/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(Q){for(var e=[],n=0,D=Q.length;n<D;n++)e[n]=oe[Q[n]];return e};define(oe[136],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=n,e.findLastIdx=D,e.findLastMonotonous=I,e.findLastIdxMonotonous=O,e.findFirstMonotonous=C,e.findFirstIdxMonotonousOrArrLen=P,e.findFirstIdxMonotonous=h,e.findFirstMaxBy=v,e.findLastMaxBy=y,e.findFirstMinBy=E,e.findMaxIdxBy=g,e.mapFindFirst=m;function n(b,w,p){const d=D(b,w);if(d!==-1)return b[d]}function D(b,w,p=b.length-1){for(let d=p;d>=0;d--){const c=b[d];if(w(c))return d}return-1}function I(b,w){const p=O(b,w);return p===-1?void 0:b[p]}function O(b,w,p=0,d=b.length){let c=p,f=d;for(;c<f;){const a=Math.floor((c+f)/2);w(b[a])?c=a+1:f=a}return c-1}function C(b,w){const p=P(b,w);return p===b.length?void 0:b[p]}function P(b,w,p=0,d=b.length){let c=p,f=d;for(;c<f;){const a=Math.floor((c+f)/2);w(b[a])?f=a:c=a+1}return c}function h(b,w,p=0,d=b.length){const c=P(b,w,p,d);return c===b.length?-1:c}class l{static{this.assertInvariants=!1}constructor(w){this._array=w,this._findLastMonotonousLastIdx=0}findLastMonotonous(w){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const d of this._array)if(this._prevFindLastPredicate(d)&&!w(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=w}const p=O(this._array,w,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=p+1,p===-1?void 0:this._array[p]}}e.MonotonousArray=l;function v(b,w){if(b.length===0)return;let p=b[0];for(let d=1;d<b.length;d++){const c=b[d];w(c,p)>0&&(p=c)}return p}function y(b,w){if(b.length===0)return;let p=b[0];for(let d=1;d<b.length;d++){const c=b[d];w(c,p)>=0&&(p=c)}return p}function E(b,w){return v(b,(p,d)=>-w(p,d))}function g(b,w){if(b.length===0)return-1;let p=0;for(let d=1;d<b.length;d++){const c=b[d];w(c,b[p])>0&&(p=d)}return p}function m(b,w){for(const p of b){const d=w(p);if(d!==void 0)return d}}}),define(oe[137],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=n,e.diffSets=D,e.diffMaps=I,e.intersection=O;function n(C,P){const h=Object.create(null);for(const l of C){const v=P(l);let y=h[v];y||(y=h[v]=[]),y.push(l)}return h}function D(C,P){const h=[],l=[];for(const v of C)P.has(v)||h.push(v);for(const v of P)C.has(v)||l.push(v);return{removed:h,added:l}}function I(C,P){const h=[],l=[];for(const[v,y]of C)P.has(v)||h.push(y);for(const[v,y]of P)C.has(v)||l.push(y);return{removed:h,added:l}}function O(C,P){const h=new Set;for(const l of P)C.has(l)&&h.add(l);return h}}),define(oe[138],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function n(P,h){const l=Math.pow(10,h);return Math.round(P*l)/l}class D{constructor(h,l,v,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.RGBA=D;class I{constructor(h,l,v,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.l=n(Math.max(Math.min(1,v),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,v=h.g/255,y=h.b/255,E=h.a,g=Math.max(l,v,y),m=Math.min(l,v,y);let b=0,w=0;const p=(m+g)/2,d=g-m;if(d>0){switch(w=Math.min(p<=.5?d/(2*p):d/(2-2*p),1),g){case l:b=(v-y)/d+(v<y?6:0);break;case v:b=(y-l)/d+2;break;case y:b=(l-v)/d+4;break}b*=60,b=Math.round(b)}return new I(b,w,p,E)}static _hue2rgb(h,l,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?h+(l-h)*6*v:v<1/2?l:v<2/3?h+(l-h)*(2/3-v)*6:h}static toRGBA(h){const l=h.h/360,{s:v,l:y,a:E}=h;let g,m,b;if(v===0)g=m=b=y;else{const w=y<.5?y*(1+v):y+v-y*v,p=2*y-w;g=I._hue2rgb(p,w,l+1/3),m=I._hue2rgb(p,w,l),b=I._hue2rgb(p,w,l-1/3)}return new D(Math.round(g*255),Math.round(m*255),Math.round(b*255),E)}}e.HSLA=I;class O{constructor(h,l,v,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.v=n(Math.max(Math.min(1,v),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,v=h.g/255,y=h.b/255,E=Math.max(l,v,y),g=Math.min(l,v,y),m=E-g,b=E===0?0:m/E;let w;return m===0?w=0:E===l?w=((v-y)/m%6+6)%6:E===v?w=(y-l)/m+2:w=(l-v)/m+4,new O(Math.round(w*60),b,E,h.a)}static toRGBA(h){const{h:l,s:v,v:y,a:E}=h,g=y*v,m=g*(1-Math.abs(l/60%2-1)),b=y-g;let[w,p,d]=[0,0,0];return l<60?(w=g,p=m):l<120?(w=m,p=g):l<180?(p=g,d=m):l<240?(p=m,d=g):l<300?(w=m,d=g):l<=360&&(w=g,d=m),w=Math.round((w+b)*255),p=Math.round((p+b)*255),d=Math.round((d+b)*255),new D(w,p,d,E)}}e.HSVA=O;class C{static fromHex(h){return C.Format.CSS.parseHex(h)||C.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this._hsla?this._hsla:I.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof D)this.rgba=h;else if(h instanceof I)this._hsla=h,this.rgba=I.toRGBA(h);else if(h instanceof O)this._hsva=h,this.rgba=O.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&D.equals(this.rgba,h.rgba)&&I.equals(this.hsla,h.hsla)&&O.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=C._relativeLuminanceForComponent(this.rgba.r),l=C._relativeLuminanceForComponent(this.rgba.g),v=C._relativeLuminanceForComponent(this.rgba.b),y=.2126*h+.7152*l+.0722*v;return n(y,4)}static _relativeLuminanceForComponent(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),v=h.getRelativeLuminance();return l>v?(l+.05)/(v+.05):(v+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),v=h.getRelativeLuminance();return l>v}isDarkerThan(h){const l=this.getRelativeLuminance(),v=h.getRelativeLuminance();return l<v}lighten(h){return new C(new I(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new C(new I(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:v,b:y,a:E}=this.rgba;return new C(new D(l,v,y,E*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,v=this.rgba.a,y=l.a,E=v+y*(1-v);if(E<1e-6)return C.transparent;const g=this.rgba.r*v/E+l.r*y*(1-v)/E,m=this.rgba.g*v/E+l.g*y*(1-v)/E,b=this.rgba.b*v/E+l.b*y*(1-v)/E;return new C(new D(g,m,b,E))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:v,b:y,a:E}=this.rgba;return new C(new D(h.rgba.r-E*(h.rgba.r-l),h.rgba.g-E*(h.rgba.g-v),h.rgba.b-E*(h.rgba.b-y),1))}flatten(...h){const l=h.reduceRight((v,y)=>C._flatten(y,v));return C._flatten(this,l)}static _flatten(h,l){const v=1-h.rgba.a;return new C(new D(v*l.rgba.r+h.rgba.a*h.rgba.r,v*l.rgba.g+h.rgba.a*h.rgba.g,v*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this._toString||(this._toString=C.Format.CSS.format(this)),this._toString}static getLighterColor(h,l,v){if(h.isLighterThan(l))return h;v=v||.5;const y=h.getRelativeLuminance(),E=l.getRelativeLuminance();return v=v*(E-y)/E,h.lighten(v)}static getDarkerColor(h,l,v){if(h.isDarkerThan(l))return h;v=v||.5;const y=h.getRelativeLuminance(),E=l.getRelativeLuminance();return v=v*(y-E)/y,h.darken(v)}static{this.white=new C(new D(255,255,255,1))}static{this.black=new C(new D(0,0,0,1))}static{this.red=new C(new D(255,0,0,1))}static{this.blue=new C(new D(0,0,255,1))}static{this.green=new C(new D(0,255,0,1))}static{this.cyan=new C(new D(0,255,255,1))}static{this.lightgrey=new C(new D(211,211,211,1))}static{this.transparent=new C(new D(0,0,0,0))}}e.Color=C,function(P){let h;(function(l){let v;(function(y){function E(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:P.Format.CSS.formatRGBA(t)}y.formatRGB=E;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=g;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(t)}y.formatHSL=m;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=b;function w(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function p(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}y.formatHex=p;function d(t,o=!1){return o&&t.rgba.a===1?P.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}y.formatHexA=d;function c(t){return t.isOpaque()?P.Format.CSS.formatHex(t):P.Format.CSS.formatRGBA(t)}y.format=c;function f(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),r=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new P(new D(s,i,r,1))}if(o===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),r=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new P(new D(s,i,r,u/255))}if(o===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),r=a(t.charCodeAt(3));return new P(new D(16*s+s,16*i+i,16*r+r))}if(o===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),r=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new P(new D(16*s+s,16*i+i,16*r+r,(16*u+u)/255))}return null}y.parseHex=f;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=l.CSS||(l.CSS={}))})(h=P.Format||(P.Format={}))}(C||(e.Color=C={}))}),define(oe[51],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=D,e.debounce=I,e.throttle=O;function n(C){return(P,h,l)=>{let v=null,y=null;if(typeof l.value=="function"?(v="value",y=l.value):typeof l.get=="function"&&(v="get",y=l.get),!y)throw new Error("not supported");l[v]=C(y,h)}}function D(C,P,h){let l=null,v=null;if(typeof h.value=="function"?(l="value",v=h.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",v=h.get),!v)throw new Error("not supported");const y=`$memoize$${P}`;h[l]=function(...E){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,E)}),this[y]}}function I(C,P,h){return n((l,v)=>{const y=`$debounce$${v}`,E=`$debounce$result$${v}`;return function(...g){this[E]||(this[E]=h?h():void 0),clearTimeout(this[y]),P&&(this[E]=P(this[E],...g),g=[this[E]]),this[y]=setTimeout(()=>{l.apply(this,g),this[E]=h?h():void 0},C)}})}function O(C,P,h){return n((l,v)=>{const y=`$throttle$timer$${v}`,E=`$throttle$result$${v}`,g=`$throttle$lastRun$${v}`,m=`$throttle$pending$${v}`;return function(...b){if(this[E]||(this[E]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[E]=P(this[E],...b)),this[m])return;const w=this[g]+C;w<=Date.now()?(this[g]=Date.now(),l.apply(this,[this[E]]),this[E]=h?h():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[g]=Date.now(),l.apply(this,[this[E]]),this[E]=h?h():void 0},w-Date.now()))}})}}),define(oe[15],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=D,e.isSigPipeError=I,e.onUnexpectedError=O,e.onUnexpectedExternalError=C,e.transformErrorForSerialization=P,e.isCancellationError=l,e.canceled=y,e.illegalArgument=E,e.illegalState=g,e.getErrorMessage=b;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(o=>{o(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=n,e.errorHandler=new n;function D(a){e.errorHandler.setUnexpectedErrorHandler(a)}function I(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(a){l(a)||e.errorHandler.onUnexpectedError(a)}function C(a){l(a)||e.errorHandler.onUnexpectedExternalError(a)}function P(a){if(a instanceof Error){const{name:t,message:o}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:s,noTelemetry:c.isErrorNoTelemetry(a)}}return a}const h="Canceled";function l(a){return a instanceof v?!0:a instanceof Error&&a.name===h&&a.message===h}class v extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=v;function y(){const a=new Error(h);return a.name=a.message,a}function E(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=m;function b(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=w;class p extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=p;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const o=new c;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class f extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.BugIndicatingError=f}),define(oe[22],ae([0,1,15,136]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=I,e.tail2=O,e.equals=C,e.removeFastWithoutKeepingOrder=P,e.binarySearch=h,e.binarySearch2=l,e.quickSelect=v,e.groupBy=y,e.groupAdjacentBy=E,e.forEachAdjacent=g,e.forEachWithNeighbors=m,e.sortedDiff=b,e.delta=w,e.top=p,e.topAsync=d,e.coalesce=f,e.coalesceInPlace=a,e.move=t,e.isFalsyOrEmpty=o,e.isNonEmptyArray=s,e.distinct=i,e.uniqueFilter=r,e.firstOrDefault=u,e.lastOrDefault=S,e.commonPrefixLength=k,e.flatten=M,e.range=L,e.index=R,e.insert=A,e.remove=F,e.arrayInsert=_,e.shuffle=z,e.pushToStart=j,e.pushToEnd=ce,e.pushMany=te,e.mapArrayOrNot=ue,e.asArray=X,e.getRandomElement=Y,e.insertInto=B,e.splice=T,e.compareBy=U,e.tieBreakComparators=le,e.reverseOrder=W;function I(G,q=0){return G[G.length-(1+q)]}function O(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}function C(G,q,H=($,se)=>$===se){if(G===q)return!0;if(!G||!q||G.length!==q.length)return!1;for(let $=0,se=G.length;$<se;$++)if(!H(G[$],q[$]))return!1;return!0}function P(G,q){const H=G.length-1;q<H&&(G[q]=G[H]),G.pop()}function h(G,q,H){return l(G.length,$=>H(G[$],q))}function l(G,q){let H=0,$=G-1;for(;H<=$;){const se=(H+$)/2|0,ee=q(se);if(ee<0)H=se+1;else if(ee>0)$=se-1;else return se}return-(H+1)}function v(G,q,H){if(G=G|0,G>=q.length)throw new TypeError("invalid index");const $=q[Math.floor(q.length*Math.random())],se=[],ee=[],de=[];for(const pe of q){const be=H(pe,$);be<0?se.push(pe):be>0?ee.push(pe):de.push(pe)}return G<se.length?v(G,se,H):G<se.length+de.length?de[0]:v(G-(se.length+de.length),ee,H)}function y(G,q){const H=[];let $;for(const se of G.slice(0).sort(q))!$||q($[0],se)!==0?($=[se],H.push($)):$.push(se);return H}function*E(G,q){let H,$;for(const se of G)$!==void 0&&q($,se)?H.push(se):(H&&(yield H),H=[se]),$=se;H&&(yield H)}function g(G,q){for(let H=0;H<=G.length;H++)q(H===0?void 0:G[H-1],H===G.length?void 0:G[H])}function m(G,q){for(let H=0;H<G.length;H++)q(H===0?void 0:G[H-1],G[H],H+1===G.length?void 0:G[H+1])}function b(G,q,H){const $=[];function se(pe,be,Ee){if(be===0&&Ee.length===0)return;const De=$[$.length-1];De&&De.start+De.deleteCount===pe?(De.deleteCount+=be,De.toInsert.push(...Ee)):$.push({start:pe,deleteCount:be,toInsert:Ee})}let ee=0,de=0;for(;;){if(ee===G.length){se(ee,0,q.slice(de));break}if(de===q.length){se(ee,G.length-ee,[]);break}const pe=G[ee],be=q[de],Ee=H(pe,be);Ee===0?(ee+=1,de+=1):Ee<0?(se(ee,1,[]),ee+=1):Ee>0&&(se(ee,0,[be]),de+=1)}return $}function w(G,q,H){const $=b(G,q,H),se=[],ee=[];for(const de of $)se.push(...G.slice(de.start,de.start+de.deleteCount)),ee.push(...de.toInsert);return{removed:se,added:ee}}function p(G,q,H){if(H===0)return[];const $=G.slice(0,H).sort(q);return c(G,q,$,H,G.length),$}function d(G,q,H,$,se){return H===0?Promise.resolve([]):new Promise((ee,de)=>{(async()=>{const pe=G.length,be=G.slice(0,H).sort(q);for(let Ee=H,De=Math.min(H+$,pe);Ee<pe;Ee=De,De=Math.min(De+$,pe)){if(Ee>H&&await new Promise(_e=>setTimeout(_e)),se&&se.isCancellationRequested)throw new n.CancellationError;c(G,q,be,Ee,De)}return be})().then(ee,de)})}function c(G,q,H,$,se){for(const ee=H.length;$<se;$++){const de=G[$];if(q(de,H[ee-1])<0){H.pop();const pe=(0,D.findFirstIdxMonotonousOrArrLen)(H,be=>q(de,be)<0);H.splice(pe,0,de)}}}function f(G){return G.filter(q=>!!q)}function a(G){let q=0;for(let H=0;H<G.length;H++)G[H]&&(G[q]=G[H],q+=1);G.length=q}function t(G,q,H){G.splice(H,0,G.splice(q,1)[0])}function o(G){return!Array.isArray(G)||G.length===0}function s(G){return Array.isArray(G)&&G.length>0}function i(G,q=H=>H){const H=new Set;return G.filter($=>{const se=q($);return H.has(se)?!1:(H.add(se),!0)})}function r(G){const q=new Set;return H=>{const $=G(H);return q.has($)?!1:(q.add($),!0)}}function u(G,q){return G.length>0?G[0]:q}function S(G,q){return G.length>0?G[G.length-1]:q}function k(G,q,H=($,se)=>$===se){let $=0;for(let se=0,ee=Math.min(G.length,q.length);se<ee&&H(G[se],q[se]);se++)$++;return $}function M(G){return[].concat(...G)}function L(G,q){let H=typeof q=="number"?G:0;typeof q=="number"?H=G:(H=0,q=G);const $=[];if(H<=q)for(let se=H;se<q;se++)$.push(se);else for(let se=H;se>q;se--)$.push(se);return $}function R(G,q,H){return G.reduce(($,se)=>($[q(se)]=H?H(se):se,$),Object.create(null))}function A(G,q){return G.push(q),()=>F(G,q)}function F(G,q){const H=G.indexOf(q);if(H>-1)return G.splice(H,1),q}function _(G,q,H){const $=G.slice(0,q),se=G.slice(q);return $.concat(H,se)}function z(G,q){let H;if(typeof q=="number"){let $=q;H=()=>{const se=Math.sin($++)*179426549;return se-Math.floor(se)}}else H=Math.random;for(let $=G.length-1;$>0;$-=1){const se=Math.floor(H()*($+1)),ee=G[$];G[$]=G[se],G[se]=ee}}function j(G,q){const H=G.indexOf(q);H>-1&&(G.splice(H,1),G.unshift(q))}function ce(G,q){const H=G.indexOf(q);H>-1&&(G.splice(H,1),G.push(q))}function te(G,q){for(const H of q)G.push(H)}function ue(G,q){return Array.isArray(G)?G.map(q):q(G)}function X(G){return Array.isArray(G)?G:[G]}function Y(G){return G[Math.floor(Math.random()*G.length)]}function B(G,q,H){const $=x(G,q),se=G.length,ee=H.length;G.length=se+ee;for(let de=se-1;de>=$;de--)G[de+ee]=G[de];for(let de=0;de<ee;de++)G[de+$]=H[de]}function T(G,q,H,$){const se=x(G,q);let ee=G.splice(se,H);return ee===void 0&&(ee=[]),B(G,se,$),ee}function x(G,q){return q<0?Math.max(q+G.length,0):Math.min(q,G.length)}var V;(function(G){function q(ee){return ee<0}G.isLessThan=q;function H(ee){return ee<=0}G.isLessThanOrEqual=H;function $(ee){return ee>0}G.isGreaterThan=$;function se(ee){return ee===0}G.isNeitherLessOrGreaterThan=se,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function U(G,q){return(H,$)=>q(G(H),G($))}function le(...G){return(q,H)=>{for(const $ of G){const se=$(q,H);if(!V.isNeitherLessOrGreaterThan(se))return se}return V.neitherLessOrGreaterThan}}const he=(G,q)=>G-q;e.numberComparator=he;const K=(G,q)=>(0,e.numberComparator)(G?1:0,q?1:0);e.booleanComparator=K;function W(G){return(q,H)=>-G(q,H)}class N{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let H=this.firstIdx;for(;H<this.items.length&&q(this.items[H]);)H++;const $=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,$}takeFromEndWhile(q){let H=this.lastIdx;for(;H>=0&&q(this.items[H]);)H--;const $=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}removeLast(){const q=this.items[this.lastIdx];return this.lastIdx--,q}takeCount(q){const H=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,H}}e.ArrayQueue=N;class Z{static{this.empty=new Z(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(H=>(q(H),!0))}toArray(){const q=[];return this.iterate(H=>(q.push(H),!0)),q}filter(q){return new Z(H=>this.iterate($=>q($)?H($):!0))}map(q){return new Z(H=>this.iterate($=>H(q($))))}some(q){let H=!1;return this.iterate($=>(H=q($),!H)),H}findFirst(q){let H;return this.iterate($=>q($)?(H=$,!1):!0),H}findLast(q){let H;return this.iterate($=>(q($)&&(H=$),!0)),H}findLastMaxBy(q){let H,$=!0;return this.iterate(se=>(($||V.isGreaterThan(q(se,H)))&&($=!1,H=se),!0)),H}}e.CallbackIterable=Z;class re{constructor(q){this._indexMap=q}static createSortPermutation(q,H){const $=Array.from(q.keys()).sort((se,ee)=>H(q[se],q[ee]));return new re($)}apply(q){return q.map((H,$)=>q[this._indexMap[$]])}inverse(){const q=this._indexMap.slice();for(let H=0;H<this._indexMap.length;H++)q[this._indexMap[H]]=H;return new re(q)}}e.Permutation=re}),define(oe[139],ae([0,1,15]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.assertNever=I,e.assert=O,e.softAssert=C,e.assertFn=P,e.checkAdjacentItems=h;function D(l,v){if(!l)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}function I(l,v="Unreachable"){throw new Error(v)}function O(l){if(!l)throw new n.BugIndicatingError("Assertion Failed")}function C(l){l||(0,n.onUnexpectedError)(new n.BugIndicatingError("Soft Assertion Failed"))}function P(l){if(!l()){debugger;l(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed"))}}function h(l,v){let y=0;for(;y<l.length-1;){const E=l[y],g=l[y+1];if(!v(E,g))return!1;y++}return!0}}),define(oe[86],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=n;function n(D,I){const O=this;let C=!1,P;return function(){if(C)return P;if(C=!0,I)try{P=D.apply(O,arguments)}finally{I()}else P=D.apply(O,arguments);return P}}}),define(oe[71],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(D){function I(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}D.is=I;const O=Object.freeze([]);function C(){return O}D.empty=C;function*P(t){yield t}D.single=P;function h(t){return I(t)?t:P(t)}D.wrap=h;function l(t){return t||O}D.from=l;function*v(t){for(let o=t.length-1;o>=0;o--)yield t[o]}D.reverse=v;function y(t){return!t||t[Symbol.iterator]().next().done===!0}D.isEmpty=y;function E(t){return t[Symbol.iterator]().next().value}D.first=E;function g(t,o){for(const s of t)if(o(s))return!0;return!1}D.some=g;function m(t,o){for(const s of t)if(o(s))return s}D.find=m;function*b(t,o){for(const s of t)o(s)&&(yield s)}D.filter=b;function*w(t,o){let s=0;for(const i of t)yield o(i,s++)}D.map=w;function*p(...t){for(const o of t)yield*o}D.concat=p;function d(t,o,s){let i=s;for(const r of t)i=o(i,r);return i}D.reduce=d;function*c(t,o,s=t.length){for(o<0&&(o+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);o<s;o++)yield t[o]}D.slice=c;function f(t,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,t];const i=t[Symbol.iterator]();for(let r=0;r<o;r++){const u=i.next();if(u.done)return[s,D.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return i}}]}D.consume=f;async function a(t){const o=[];for await(const s of t)o.push(s);return Promise.resolve(o)}D.asyncToArray=a})(n||(e.Iterable=n={}))}),define(oe[42],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=C,e.getLocation=y,e.parse=E,e.parseTree=g,e.findNodeAtLocation=m,e.getNodePath=b,e.getNodeValue=w,e.contains=p,e.findNodeAtOffset=d,e.visit=c,e.stripComments=f,e.getNodeType=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function C(t,o=!1){let s=0;const i=t.length;let r="",u=0,S=16,k=0;function M(j){let ce=0,te=0;for(;ce<j;){const ue=t.charCodeAt(s);if(ue>=48&&ue<=57)te=te*16+ue-48;else if(ue>=65&&ue<=70)te=te*16+ue-65+10;else if(ue>=97&&ue<=102)te=te*16+ue-97+10;else break;s++,ce++}return ce<j&&(te=-1),te}function L(j){s=j,r="",u=0,S=16,k=0}function R(){const j=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&l(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&l(t.charCodeAt(s)))for(s++;s<t.length&&l(t.charCodeAt(s));)s++;else return k=3,t.substring(j,s);let ce=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&l(t.charCodeAt(s))){for(s++;s<t.length&&l(t.charCodeAt(s));)s++;ce=s}else k=3;return t.substring(j,ce)}function A(){let j="",ce=s;for(;;){if(s>=i){j+=t.substring(ce,s),k=2;break}const te=t.charCodeAt(s);if(te===34){j+=t.substring(ce,s),s++;break}if(te===92){if(j+=t.substring(ce,s),s++,s>=i){k=2;break}switch(t.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const X=M(4);X>=0?j+=String.fromCharCode(X):k=4;break}default:k=5}ce=s;continue}if(te>=0&&te<=31)if(h(te)){j+=t.substring(ce,s),k=2;break}else k=6;s++}return j}function F(){if(r="",k=0,u=s,s>=i)return u=i,S=17;let j=t.charCodeAt(s);if(P(j)){do s++,r+=String.fromCharCode(j),j=t.charCodeAt(s);while(P(j));return S=15}if(h(j))return s++,r+=String.fromCharCode(j),j===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),S=14;switch(j){case 123:return s++,S=1;case 125:return s++,S=2;case 91:return s++,S=3;case 93:return s++,S=4;case 58:return s++,S=6;case 44:return s++,S=5;case 34:return s++,r=A(),S=10;case 47:{const ce=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!h(t.charCodeAt(s));)s++;return r=t.substring(ce,s),S=12}if(t.charCodeAt(s+1)===42){s+=2;const te=i-1;let ue=!1;for(;s<te;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ue=!0;break}s++}return ue||(s++,k=1),r=t.substring(ce,s),S=13}return r+=String.fromCharCode(j),s++,S=16}case 45:if(r+=String.fromCharCode(j),s++,s===i||!l(t.charCodeAt(s)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=R(),S=11;default:for(;s<i&&_(j);)s++,j=t.charCodeAt(s);if(u!==s){switch(r=t.substring(u,s),r){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return r+=String.fromCharCode(j),s++,S=16}}function _(j){if(P(j)||h(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:L,getPosition:()=>s,scan:o?z:F,getToken:()=>S,getTokenValue:()=>r,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>k}}function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var v;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(v||(v={}));function y(t,o){const s=[],i=new Object;let r;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(M,L,R,A){u.value=M,u.offset=L,u.length=R,u.type=A,u.colonOffset=void 0,r=u}try{c(t,{onObjectBegin:(M,L)=>{if(o<=M)throw i;r=void 0,S=o>M,s.push("")},onObjectProperty:(M,L,R)=>{if(o<L||(k(M,L,R,"property"),s[s.length-1]=M,o<=L+R))throw i},onObjectEnd:(M,L)=>{if(o<=M)throw i;r=void 0,s.pop()},onArrayBegin:(M,L)=>{if(o<=M)throw i;r=void 0,s.push(0)},onArrayEnd:(M,L)=>{if(o<=M)throw i;r=void 0,s.pop()},onLiteralValue:(M,L,R)=>{if(o<L||(k(M,L,R,a(M)),o<=L+R))throw i},onSeparator:(M,L,R)=>{if(o<=L)throw i;if(M===":"&&r&&r.type==="property")r.colonOffset=L,S=!1,r=void 0;else if(M===","){const A=s[s.length-1];typeof A=="number"?s[s.length-1]=A+1:(S=!0,s[s.length-1]=""),r=void 0}}})}catch(M){if(M!==i)throw M}return{path:s,previousNode:r,isAtPropertyKey:S,matches:M=>{let L=0;for(let R=0;L<M.length&&R<s.length;R++)if(M[L]===s[R]||M[L]==="*")L++;else if(M[L]!=="**")return!1;return L===M.length}}}function E(t,o=[],s=O.DEFAULT){let i=null,r=[];const u=[];function S(M){Array.isArray(r)?r.push(M):i!==null&&(r[i]=M)}return c(t,{onObjectBegin:()=>{const M={};S(M),u.push(r),r=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const M=[];S(M),u.push(r),r=M,i=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:S,onError:(M,L,R)=>{o.push({error:M,offset:L,length:R})}},s),r[0]}function g(t,o=[],s=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(M){i.type==="property"&&(i.length=M-i.offset,i=i.parent)}function u(M){return i.children.push(M),M}c(t,{onObjectBegin:M=>{i=u({type:"object",offset:M,length:-1,parent:i,children:[]})},onObjectProperty:(M,L,R)=>{i=u({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:M,offset:L,length:R,parent:i})},onObjectEnd:(M,L)=>{i.length=M+L-i.offset,i=i.parent,r(M+L)},onArrayBegin:(M,L)=>{i=u({type:"array",offset:M,length:-1,parent:i,children:[]})},onArrayEnd:(M,L)=>{i.length=M+L-i.offset,i=i.parent,r(M+L)},onLiteralValue:(M,L,R)=>{u({type:a(M),offset:L,length:R,parent:i,value:M}),r(L+R)},onSeparator:(M,L,R)=>{i.type==="property"&&(M===":"?i.colonOffset=L:M===","&&r(L))},onError:(M,L,R)=>{o.push({error:M,offset:L,length:R})}},s);const k=i.children[0];return k&&delete k.parent,k}function m(t,o){if(!t)return;let s=t;for(const i of o)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}function b(t){if(!t.parent||!t.parent.children)return[];const o=b(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const o=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(o[s.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}function d(t,o,s=!1){if(p(t,o,s)){const i=t.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=o;r++){const u=d(i[r],o,s);if(u)return u}return t}}function c(t,o,s=O.DEFAULT){const i=C(t,!1);function r(U){return U?()=>U(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(U){return U?le=>U(le,i.getTokenOffset(),i.getTokenLength()):()=>!0}const S=r(o.onObjectBegin),k=u(o.onObjectProperty),M=r(o.onObjectEnd),L=r(o.onArrayBegin),R=r(o.onArrayEnd),A=u(o.onLiteralValue),F=u(o.onSeparator),_=r(o.onComment),z=u(o.onError),j=s&&s.disallowComments,ce=s&&s.allowTrailingComma;function te(){for(;;){const U=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:j||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(U){case 12:case 13:j?ue(10):_();break;case 16:ue(1);break;case 15:case 14:break;default:return U}}}function ue(U,le=[],he=[]){if(z(U),le.length+he.length>0){let K=i.getToken();for(;K!==17;){if(le.indexOf(K)!==-1){te();break}else if(he.indexOf(K)!==-1)break;K=te()}}}function X(U){const le=i.getTokenValue();return U?A(le):k(le),te(),!0}function Y(){switch(i.getToken()){case 11:{let U=0;try{U=JSON.parse(i.getTokenValue()),typeof U!="number"&&(ue(2),U=0)}catch{ue(2)}A(U);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return te(),!0}function B(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(X(!1),i.getToken()===6?(F(":"),te(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function T(){S(),te();let U=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(U||ue(4,[],[]),F(","),te(),i.getToken()===2&&ce)break}else U&&ue(6,[],[]);B()||ue(4,[],[2,5]),U=!0}return M(),i.getToken()!==2?ue(7,[2],[]):te(),!0}function x(){L(),te();let U=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(U||ue(4,[],[]),F(","),te(),i.getToken()===4&&ce)break}else U&&ue(6,[],[]);V()||ue(4,[],[4,5]),U=!0}return R(),i.getToken()!==4?ue(8,[4],[]):te(),!0}function V(){switch(i.getToken()){case 3:return x();case 1:return T();case 10:return X(!0);default:return Y()}}return te(),i.getToken()===17?s.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}function f(t,o){const s=C(t),i=[];let r,u=0,S;do switch(S=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:u!==S&&i.push(t.substring(u,S)),o!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,o)),u=s.getPosition();break}while(r!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[140],ae([0,1,42]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=D,e.toFormattedString=I,e.getEOL=P,e.isEOL=h;function D(l,v,y){let E,g,m,b,w;if(v){for(b=v.offset,w=b+v.length,m=b;m>0&&!h(l,m-1);)m--;let S=w;for(;S<l.length&&!h(l,S);)S++;g=l.substring(m,S),E=C(g,y)}else g=l,E=0,m=0,b=0,w=l.length;const p=P(y,l);let d=!1,c=0,f;y.insertSpaces?f=O(" ",y.tabSize||4):f="	";const a=(0,n.createScanner)(g,!1);let t=!1;function o(){return p+O(f,E+c)}function s(){let S=a.scan();for(d=!1;S===15||S===14;)d=d||S===14,S=a.scan();return t=S===16||a.getTokenError()!==0,S}const i=[];function r(S,k,M){!t&&k<w&&M>b&&l.substring(k,M)!==S&&i.push({offset:k,length:M-k,content:S})}let u=s();if(u!==17){const S=a.getTokenOffset()+m,k=O(f,E);r(k,m,S)}for(;u!==17;){let S=a.getTokenOffset()+a.getTokenLength()+m,k=s(),M="";for(;!d&&(k===12||k===13);){const R=a.getTokenOffset()+m;r(" ",S,R),S=a.getTokenOffset()+a.getTokenLength()+m,M=k===12?o():"",k=s()}if(k===2)u!==1&&(c--,M=o());else if(k===4)u!==3&&(c--,M=o());else{switch(u){case 3:case 1:c++,M=o();break;case 5:case 12:M=o();break;case 13:d?M=o():M=" ";break;case 6:M=" ";break;case 10:if(k===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?M=" ":k!==5&&k!==17&&(t=!0);break;case 16:t=!0;break}d&&(k===12||k===13)&&(M=o())}const L=a.getTokenOffset()+m;r(M,S,L),u=k}return i}function I(l,v){const y=JSON.stringify(l,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?y.replace(/\r\n|\r|\n/g,v.eol):y}function O(l,v){let y="";for(let E=0;E<v;E++)y+=l;return y}function C(l,v){let y=0,E=0;const g=v.tabSize||4;for(;y<l.length;){const m=l.charAt(y);if(m===" ")E++;else if(m==="	")E+=g;else break;y++}return Math.floor(E/g)}function P(l,v){for(let y=0;y<v.length;y++){const E=v.charAt(y);if(E==="\r")return y+1<v.length&&v.charAt(y+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return l&&l.eol||`
`}function h(l,v){return`\r
`.indexOf(l.charAt(v))!==-1}}),define(oe[103],ae([0,1,42,140]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=I,e.setProperty=O,e.withFormatting=C,e.applyEdit=P,e.applyEdits=h;function I(l,v,y){return O(l,v,void 0,y)}function O(l,v,y,E,g){const m=v.slice(),b=[],w=(0,n.parseTree)(l,b);let p,d;for(;m.length>0&&(d=m.pop(),p=(0,n.findNodeAtLocation)(w,m),p===void 0&&y!==void 0);)typeof d=="string"?y={[d]:y}:y=[y];if(p)if(p.type==="object"&&typeof d=="string"&&Array.isArray(p.children)){const c=(0,n.findNodeAtLocation)(p,[d]);if(c!==void 0)if(y===void 0){if(!c.parent)throw new Error("Malformed AST");const f=p.children.indexOf(c.parent);let a,t=c.parent.offset+c.parent.length;if(f>0){const o=p.children[f-1];a=o.offset+o.length}else a=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return C(l,{offset:a,length:t-a,content:""},E)}else return C(l,{offset:c.offset,length:c.length,content:JSON.stringify(y)},E);else{if(y===void 0)return[];const f=`${JSON.stringify(d)}: ${JSON.stringify(y)}`,a=g?g(p.children.map(o=>o.children[0].value)):p.children.length;let t;if(a>0){const o=p.children[a-1];t={offset:o.offset+o.length,length:0,content:","+f}}else p.children.length===0?t={offset:p.offset+1,length:0,content:f}:t={offset:p.offset+1,length:0,content:f+","};return C(l,t,E)}}else if(p.type==="array"&&typeof d=="number"&&Array.isArray(p.children))if(y!==void 0){const c=`${JSON.stringify(y)}`;let f;if(p.children.length===0||d===0)f={offset:p.offset+1,length:0,content:p.children.length===0?c:c+","};else{const a=d===-1||d>p.children.length?p.children.length:d,t=p.children[a-1];f={offset:t.offset+t.length,length:0,content:","+c}}return C(l,f,E)}else{const c=d,f=p.children[c];let a;if(p.children.length===1)a={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===c){const t=p.children[c-1],o=t.offset+t.length,s=p.offset+p.length;a={offset:o,length:s-2-o,content:""}}else a={offset:f.offset,length:p.children[c+1].offset-f.offset,content:""};return C(l,a,E)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${p.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return C(l,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},E)}}function C(l,v,y){let E=P(l,v),g=v.offset,m=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;g>0&&!(0,D.isEOL)(E,g-1);)g--;for(;m<E.length&&!(0,D.isEOL)(E,m);)m++}const b=(0,D.format)(E,{offset:g,length:m-g},y);for(let p=b.length-1;p>=0;p--){const d=b[p];E=P(E,d),g=Math.min(g,d.offset),m=Math.max(m,d.offset+d.length),m+=d.content.length-d.length}const w=l.length-(E.length-m)-g;return[{offset:g,length:w,content:E.substring(g,m)}]}function P(l,v){return l.substring(0,v.offset)+v.content+l.substring(v.offset+v.length)}function h(l,v){const y=v.slice(0).sort((g,m)=>{const b=g.offset-m.offset;return b===0?g.length-m.length:b});let E=l.length;for(let g=y.length-1;g>=0;g--){const m=y[g];if(m.offset+m.length<=E)l=P(l,m);else throw new Error("Overlapping edit");E=m.offset}return l}}),define(oe[62],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class n{constructor(I){this.executor=I,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=n}),define(oe[104],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class n{static{this.Undefined=new n(void 0)}constructor(O){this.element=O,this.next=n.Undefined,this.prev=n.Undefined}}class D{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){let O=this._first;for(;O!==n.Undefined;){const C=O.next;O.prev=n.Undefined,O.next=n.Undefined,O=C}this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,C){const P=new n(O);if(this._first===n.Undefined)this._first=P,this._last=P;else if(C){const l=this._last;this._last=P,P.prev=l,l.next=P}else{const l=this._first;this._first=P,P.next=l,l.prev=P}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(P))}}shift(){if(this._first!==n.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==n.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==n.Undefined&&O.next!==n.Undefined){const C=O.prev;C.next=O.next,O.next.prev=C}else O.prev===n.Undefined&&O.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):O.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):O.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==n.Undefined;)yield O.element,O=O.next}}e.LinkedList=D}),define(oe[32],ae([0,1]),function(Q,e){"use strict";var n,D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=O,e.mapToString=C,e.setToString=P,e.mapsStrictEqualIgnoreOrder=d;function O(c,f,a){let t=c.get(f);return t===void 0&&(t=a,c.set(f,t)),t}function C(c){const f=[];return c.forEach((a,t)=>{f.push(`${t} => ${a}`)}),`Map(${c.size}) {${f.join(", ")}}`}function P(c){const f=[];return c.forEach(a=>{f.push(a)}),`Set(${c.size}) {${f.join(", ")}}`}class h{constructor(f,a){this.uri=f,this.value=a}}function l(c){return Array.isArray(c)}class v{static{this.defaultToKey=f=>f.toString()}constructor(f,a){if(this[n]="ResourceMap",f instanceof v)this.map=new Map(f.map),this.toKey=a??v.defaultToKey;else if(l(f)){this.map=new Map,this.toKey=a??v.defaultToKey;for(const[t,o]of f)this.set(t,o)}else this.map=new Map,this.toKey=f??v.defaultToKey}set(f,a){return this.map.set(this.toKey(f),new h(f,a)),this}get(f){return this.map.get(this.toKey(f))?.value}has(f){return this.map.has(this.toKey(f))}get size(){return this.map.size}clear(){this.map.clear()}delete(f){return this.map.delete(this.toKey(f))}forEach(f,a){typeof a<"u"&&(f=f.bind(a));for(const[t,o]of this.map)f(o.value,o.uri,this)}*values(){for(const f of this.map.values())yield f.value}*keys(){for(const f of this.map.values())yield f.uri}*entries(){for(const f of this.map.values())yield[f.uri,f.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.map)yield[f.uri,f.value]}}e.ResourceMap=v;class y{constructor(f,a){this[D]="ResourceSet",!f||typeof f=="function"?this._map=new v(f):(this._map=new v(a),f.forEach(this.add,this))}get size(){return this._map.size}add(f){return this._map.set(f,f),this}clear(){this._map.clear()}delete(f){return this._map.delete(f)}forEach(f,a){this._map.forEach((t,o)=>f.call(a,o,o,this))}has(f){return this._map.has(f)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var E;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class g{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(f){return this._map.has(f)}get(f,a=0){const t=this._map.get(f);if(t)return a!==0&&this.touch(t,a),t.value}set(f,a,t=0){let o=this._map.get(f);if(o)o.value=a,t!==0&&this.touch(o,t);else{switch(o={key:f,value:a,next:void 0,previous:void 0},t){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(f,o),this._size++}return this}delete(f){return!!this.remove(f)}remove(f){const a=this._map.get(f);if(a)return this._map.delete(f),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const f=this._head;return this._map.delete(f.key),this.removeItem(f),this._size--,f.value}forEach(f,a){const t=this._state;let o=this._head;for(;o;){if(a?f.bind(a)(o.value,o.key,this):f(o.value,o.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const f=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(f._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}values(){const f=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(f._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}entries(){const f=this,a=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(f._state!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return o}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(f){if(f>=this.size)return;if(f===0){this.clear();return}let a=this._head,t=this.size;for(;a&&t>f;)this._map.delete(a.key),a=a.next,t--;this._head=a,this._size=t,a&&(a.previous=void 0),this._state++}addItemFirst(f){if(!this._head&&!this._tail)this._tail=f;else if(this._head)f.next=this._head,this._head.previous=f;else throw new Error("Invalid list");this._head=f,this._state++}addItemLast(f){if(!this._head&&!this._tail)this._head=f;else if(this._tail)f.previous=this._tail,this._tail.next=f;else throw new Error("Invalid list");this._tail=f,this._state++}removeItem(f){if(f===this._head&&f===this._tail)this._head=void 0,this._tail=void 0;else if(f===this._head){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this._head=f.next}else if(f===this._tail){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this._tail=f.previous}else{const a=f.next,t=f.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}f.next=void 0,f.previous=void 0,this._state++}touch(f,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(f===this._head)return;const t=f.next,o=f.previous;f===this._tail?(o.next=void 0,this._tail=o):(t.previous=o,o.next=t),f.previous=void 0,f.next=this._head,this._head.previous=f,this._head=f,this._state++}else if(a===2){if(f===this._tail)return;const t=f.next,o=f.previous;f===this._head?(t.previous=void 0,this._head=t):(t.previous=o,o.next=t),f.next=void 0,f.previous=this._tail,this._tail.next=f,this._tail=f,this._state++}}}toJSON(){const f=[];return this.forEach((a,t)=>{f.push([t,a])}),f}fromJSON(f){this.clear();for(const[a,t]of f)this.set(a,t)}}e.LinkedMap=g;class m extends g{constructor(f,a=1){super(),this._limit=f,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(f){this._limit=f,this.checkTrim()}get ratio(){return this._ratio}set ratio(f){this._ratio=Math.min(Math.max(0,f),1),this.checkTrim()}get(f,a=2){return super.get(f,a)}peek(f){return super.get(f,0)}set(f,a){return super.set(f,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class b{constructor(){this.map=new Map}add(f){return this.map.set(f,(this.map.get(f)||0)+1),this}delete(f){let a=this.map.get(f)||0;return a===0?!1:(a--,a===0?this.map.delete(f):this.map.set(f,a),!0)}has(f){return this.map.has(f)}}e.CounterSet=b;class w{constructor(f){if(this._m1=new Map,this._m2=new Map,f)for(const[a,t]of f)this.set(a,t)}clear(){this._m1.clear(),this._m2.clear()}set(f,a){this._m1.set(f,a),this._m2.set(a,f)}get(f){return this._m1.get(f)}getKey(f){return this._m2.get(f)}delete(f){const a=this._m1.get(f);return a===void 0?!1:(this._m1.delete(f),this._m2.delete(a),!0)}forEach(f,a){this._m1.forEach((t,o)=>{f.call(a,t,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=w;class p{constructor(){this.map=new Map}add(f,a){let t=this.map.get(f);t||(t=new Set,this.map.set(f,t)),t.add(a)}delete(f,a){const t=this.map.get(f);t&&(t.delete(a),t.size===0&&this.map.delete(f))}forEach(f,a){const t=this.map.get(f);t&&t.forEach(a)}get(f){const a=this.map.get(f);return a||new Set}}e.SetMap=p;function d(c,f){if(c===f)return!0;if(c.size!==f.size)return!1;for(const[a,t]of c)if(!f.has(a)||f.get(a)!==t)return!1;for(const[a]of f)if(!c.has(a))return!1;return!0}}),define(oe[2],ae([0,1,22,137,32,86,71]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=v,e.trackDisposable=y,e.markAsDisposed=E,e.markAsSingleton=b,e.isDisposable=w,e.dispose=p,e.disposeIfDisposable=d,e.combinedDisposable=c,e.toDisposable=f,e.disposeOnReturn=M;const P=!1;let h=null;class l{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(A){let F=this.livingDisposables.get(A);return F||(F={parent:null,source:null,isSingleton:!1,value:A,idx:l.idx++},this.livingDisposables.set(A,F)),F}trackDisposable(A){const F=this.getDisposableData(A);F.source||(F.source=new Error().stack)}setParent(A,F){const _=this.getDisposableData(A);_.parent=F}markAsDisposed(A){this.livingDisposables.delete(A)}markAsSingleton(A){this.getDisposableData(A).isSingleton=!0}getRootParent(A,F){const _=F.get(A);if(_)return _;const z=A.parent?this.getRootParent(this.getDisposableData(A.parent),F):A;return F.set(A,z),z}getTrackedDisposables(){const A=new Map;return[...this.livingDisposables.entries()].filter(([,_])=>_.source!==null&&!this.getRootParent(_,A).isSingleton).flatMap(([_])=>_)}computeLeakingDisposables(A=10,F){let _;if(F)_=F;else{const ue=new Map,X=[...this.livingDisposables.values()].filter(B=>B.source!==null&&!this.getRootParent(B,ue).isSingleton);if(X.length===0)return;const Y=new Set(X.map(B=>B.value));if(_=X.filter(B=>!(B.parent&&Y.has(B.parent))),_.length===0)throw new Error("There are cyclic diposable chains!")}if(!_)return;function z(ue){function X(B,T){for(;B.length>0&&T.some(x=>typeof x=="string"?x===B[0]:B[0].match(x));)B.shift()}const Y=ue.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return X(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const j=new I.SetMap;for(const ue of _){const X=z(ue);for(let Y=0;Y<=X.length;Y++)j.add(X.slice(0,Y).join(`
`),ue)}_.sort((0,n.compareBy)(ue=>ue.idx,n.numberComparator));let ce="",te=0;for(const ue of _.slice(0,A)){te++;const X=z(ue),Y=[];for(let B=0;B<X.length;B++){let T=X[B];T=`(shared with ${j.get(X.slice(0,B+1).join(`
`)).size}/${_.length} leaks) at ${T}`;const V=j.get(X.slice(0,B).join(`
`)),U=(0,D.groupBy)([...V].map(le=>z(le)[B]),le=>le);delete U[X[B]];for(const[le,he]of Object.entries(U))Y.unshift(`    - stacktraces of ${he.length} other leaks continue with ${le}`);Y.unshift(T)}ce+=`


==================== Leaking disposable ${te}/${_.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return _.length>A&&(ce+=`


... and ${_.length-A} more leaking disposables

`),{leaks:_,details:ce}}}e.DisposableTracker=l;function v(R){h=R}if(P){const R="__is_disposable_tracked__";v(new class{trackDisposable(A){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[R]||console.log(F)},3e3)}setParent(A,F){if(A&&A!==t.None)try{A[R]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[R]=!0}catch{}}markAsSingleton(A){}})}function y(R){return h?.trackDisposable(R),R}function E(R){h?.markAsDisposed(R)}function g(R,A){h?.setParent(R,A)}function m(R,A){if(h)for(const F of R)h.setParent(F,A)}function b(R){return h?.markAsSingleton(R),R}function w(R){return typeof R.dispose=="function"&&R.dispose.length===0}function p(R){if(C.Iterable.is(R)){const A=[];for(const F of R)if(F)try{F.dispose()}catch(_){A.push(_)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function d(R){for(const A of R)w(A)&&A.dispose();return[]}function c(...R){const A=f(()=>p(R));return m(R,A),A}function f(R){const A=y({dispose:(0,O.createSingleCallFunction)(()=>{E(A),R()})});return A}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{p(this._toDispose)}finally{this._toDispose.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return g(A,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(A),A.dispose()}}deleteAndLeak(A){A&&this._toDispose.has(A)&&(this._toDispose.delete(A),g(A,null))}}e.DisposableStore=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,y(this),g(this._store,this)}dispose(){E(this),this._store.dispose()}_register(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(A)}}e.Disposable=t;class o{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(A){this._isDisposed||A===this._value||(this._value?.dispose(),A&&g(A,this),this._value=A)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const A=this._value;return this._value=void 0,A&&g(A,null),A}}e.MutableDisposable=o;class s{constructor(A){this._disposable=new o,this._isDisposed=!1,this._disposable.value=A}get value(){return this._disposable.value}set value(A){this._isDisposed||A===this._disposable.value||(this._disposable.value=A)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=s;class i{constructor(A){this._disposable=A,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=i;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(A){let F=A;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,E(this))},this}}e.SafeDisposable=r;class u{constructor(){this.references=new Map}acquire(A,...F){let _=this.references.get(A);_||(_={counter:0,object:this.createReferencedObject(A,...F)},this.references.set(A,_));const{object:z}=_,j=(0,O.createSingleCallFunction)(()=>{--_.counter===0&&(this.destroyReferencedObject(A,_.object),this.references.delete(A))});return _.counter++,{object:z,dispose:j}}}e.ReferenceCollection=u;class S{constructor(A){this.referenceCollection=A}async acquire(A,...F){const _=this.referenceCollection.acquire(A,...F);try{return{object:await _.object,dispose:()=>_.dispose()}}catch(z){throw _.dispose(),z}}}e.AsyncReferenceCollection=S;class k{constructor(A){this.object=A}dispose(){}}e.ImmortalReference=k;function M(R){const A=new a;try{R(A)}finally{A.dispose()}}class L{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){E(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{p(this._store.values())}finally{this._store.clear()}}has(A){return this._store.has(A)}get size(){return this._store.size}get(A){return this._store.get(A)}set(A,F,_=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||this._store.get(A)?.dispose(),this._store.set(A,F)}deleteAndDispose(A){this._store.get(A)?.dispose(),this._store.delete(A)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=L}),define(oe[72],ae([0,1,32]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=I,e.normalizeNFD=C;const D=new n.LRUCache(1e4);function I(l){return h(l,"NFC",D)}const O=new n.LRUCache(1e4);function C(l){return h(l,"NFD",O)}const P=/[^\u0000-\u0080]/;function h(l,v,y){if(!l)return l;const E=y.get(l);if(E)return E;let g;return P.test(l)?g=l.normalize(v):g=l,y.set(l,g),g}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(v){return C(v).replace(l,"")}}()}),define(oe[141],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=n,e.rot=D;function n(P,h,l){return Math.min(Math.max(P,h),l)}function D(P,h){return(h+P%h)%h}class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class O{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=O;class C{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const l=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=l,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function Q(I){const O=[];typeof I=="number"&&O.push("code/timeOrigin",I);function C(h){O.push(h,Date.now())}function P(){const h=[];for(let l=0;l<O.length;l+=2)h.push({name:O[l],startTime:O[l+1]});return h}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))O.push({name:C.name,startTime:Math.round(I+C.startTime)});return O}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function n(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=n(D))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var D in n)(typeof exports=="object"?exports:Q)[D]=n[D]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function n(D){if(e[D])return e[D].exports;var I=e[D]={i:D,l:!1,exports:{}};return Q[D].call(I.exports,I,I.exports,n),I.l=!0,I.exports}return n.m=Q,n.c=e,n.d=function(D,I,O){n.o(D,I)||Object.defineProperty(D,I,{enumerable:!0,get:O})},n.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},n.t=function(D,I){if(1&I&&(D=n(D)),8&I||4&I&&typeof D=="object"&&D&&D.__esModule)return D;var O=Object.create(null);if(n.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:D}),2&I&&typeof D!="string")for(var C in D)n.d(O,C,function(P){return D[P]}.bind(null,C));return O},n.n=function(D){var I=D&&D.__esModule?function(){return D.default}:function(){return D};return n.d(I,"a",I),I},n.o=function(D,I){return Object.prototype.hasOwnProperty.call(D,I)},n.p="",n(n.s=0)}([function(Q,e,n){(function(D){var I;e=Q.exports=he,I=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],h=e.src=[],l=0,v=l++;h[v]="0|[1-9]\\d*";var y=l++;h[y]="[0-9]+";var E=l++;h[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=l++;h[g]="("+h[v]+")\\.("+h[v]+")\\.("+h[v]+")";var m=l++;h[m]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var b=l++;h[b]="(?:"+h[v]+"|"+h[E]+")";var w=l++;h[w]="(?:"+h[y]+"|"+h[E]+")";var p=l++;h[p]="(?:-("+h[b]+"(?:\\."+h[b]+")*))";var d=l++;h[d]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var c=l++;h[c]="[0-9A-Za-z-]+";var f=l++;h[f]="(?:\\+("+h[c]+"(?:\\."+h[c]+")*))";var a=l++,t="v?"+h[g]+h[p]+"?"+h[f]+"?";h[a]="^"+t+"$";var o="[v=\\s]*"+h[m]+h[d]+"?"+h[f]+"?",s=l++;h[s]="^"+o+"$";var i=l++;h[i]="((?:<|>)?=?)";var r=l++;h[r]=h[y]+"|x|X|\\*";var u=l++;h[u]=h[v]+"|x|X|\\*";var S=l++;h[S]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[p]+")?"+h[f]+"?)?)?";var k=l++;h[k]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[d]+")?"+h[f]+"?)?)?";var M=l++;h[M]="^"+h[i]+"\\s*"+h[S]+"$";var L=l++;h[L]="^"+h[i]+"\\s*"+h[k]+"$";var R=l++;h[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=l++;h[A]="(?:~>?)";var F=l++;h[F]="(\\s*)"+h[A]+"\\s+",P[F]=new RegExp(h[F],"g");var _=l++;h[_]="^"+h[A]+h[S]+"$";var z=l++;h[z]="^"+h[A]+h[k]+"$";var j=l++;h[j]="(?:\\^)";var ce=l++;h[ce]="(\\s*)"+h[j]+"\\s+",P[ce]=new RegExp(h[ce],"g");var te=l++;h[te]="^"+h[j]+h[S]+"$";var ue=l++;h[ue]="^"+h[j]+h[k]+"$";var X=l++;h[X]="^"+h[i]+"\\s*("+o+")$|^$";var Y=l++;h[Y]="^"+h[i]+"\\s*("+t+")$|^$";var B=l++;h[B]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[S]+")",P[B]=new RegExp(h[B],"g");var T=l++;h[T]="^\\s*("+h[S]+")\\s+-\\s+("+h[S]+")\\s*$";var x=l++;h[x]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var V=l++;h[V]="(<|>)?=?\\s*\\*";for(var U=0;U<35;U++)I(U,h[U]),P[U]||(P[U]=new RegExp(h[U]));function le(J,fe){if(J instanceof he)return J;if(typeof J!="string"||J.length>O||!(fe?P[s]:P[a]).test(J))return null;try{return new he(J,fe)}catch{return null}}function he(J,fe){if(J instanceof he){if(J.loose===fe)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof he))return new he(J,fe);I("SemVer",J,fe),this.loose=fe;var me=J.trim().match(fe?P[s]:P[a]);if(!me)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ae=+Ce;if(Ae>=0&&Ae<C)return Ae}return Ce}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=le,e.valid=function(J,fe){var me=le(J,fe);return me?me.version:null},e.clean=function(J,fe){var me=le(J.trim().replace(/^[=v]+/,""),fe);return me?me.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(J){return I("SemVer.compare",this.version,this.loose,J),J instanceof he||(J=new he(J,this.loose)),this.compareMain(J)||this.comparePre(J)},he.prototype.compareMain=function(J){return J instanceof he||(J=new he(J,this.loose)),W(this.major,J.major)||W(this.minor,J.minor)||W(this.patch,J.patch)},he.prototype.comparePre=function(J){if(J instanceof he||(J=new he(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var fe=0;do{var me=this.prerelease[fe],Ce=J.prerelease[fe];if(I("prerelease compare",fe,me,Ce),me===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(me===void 0)return-1;if(me!==Ce)return W(me,Ce)}while(++fe)},he.prototype.inc=function(J,fe){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,fe,me,Ce){typeof me=="string"&&(Ce=me,me=void 0);try{return new he(J,me).inc(fe,Ce).version}catch{return null}},e.diff=function(J,fe){if(G(J,fe))return null;var me=le(J),Ce=le(fe);if(me.prerelease.length||Ce.prerelease.length){for(var Ae in me)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&me[Ae]!==Ce[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in me)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&me[Ae]!==Ce[Ae])return Ae},e.compareIdentifiers=W;var K=/^[0-9]+$/;function W(J,fe){var me=K.test(J),Ce=K.test(fe);return me&&Ce&&(J=+J,fe=+fe),me&&!Ce?-1:Ce&&!me?1:J<fe?-1:J>fe?1:0}function N(J,fe,me){return new he(J,me).compare(new he(fe,me))}function Z(J,fe,me){return N(J,fe,me)>0}function re(J,fe,me){return N(J,fe,me)<0}function G(J,fe,me){return N(J,fe,me)===0}function q(J,fe,me){return N(J,fe,me)!==0}function H(J,fe,me){return N(J,fe,me)>=0}function $(J,fe,me){return N(J,fe,me)<=0}function se(J,fe,me,Ce){var Ae;switch(fe){case"===":typeof J=="object"&&(J=J.version),typeof me=="object"&&(me=me.version),Ae=J===me;break;case"!==":typeof J=="object"&&(J=J.version),typeof me=="object"&&(me=me.version),Ae=J!==me;break;case"":case"=":case"==":Ae=G(J,me,Ce);break;case"!=":Ae=q(J,me,Ce);break;case">":Ae=Z(J,me,Ce);break;case">=":Ae=H(J,me,Ce);break;case"<":Ae=re(J,me,Ce);break;case"<=":Ae=$(J,me,Ce);break;default:throw new TypeError("Invalid operator: "+fe)}return Ae}function ee(J,fe){if(J instanceof ee){if(J.loose===fe)return J;J=J.value}if(!(this instanceof ee))return new ee(J,fe);I("comparator",J,fe),this.loose=fe,this.parse(J),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(J,fe){return W(fe,J)},e.major=function(J,fe){return new he(J,fe).major},e.minor=function(J,fe){return new he(J,fe).minor},e.patch=function(J,fe){return new he(J,fe).patch},e.compare=N,e.compareLoose=function(J,fe){return N(J,fe,!0)},e.rcompare=function(J,fe,me){return N(fe,J,me)},e.sort=function(J,fe){return J.sort(function(me,Ce){return e.compare(me,Ce,fe)})},e.rsort=function(J,fe){return J.sort(function(me,Ce){return e.rcompare(me,Ce,fe)})},e.gt=Z,e.lt=re,e.eq=G,e.neq=q,e.gte=H,e.lte=$,e.cmp=se,e.Comparator=ee;var de={};function pe(J,fe){if(J instanceof pe)return J.loose===fe?J:new pe(J.raw,fe);if(J instanceof ee)return new pe(J.value,fe);if(!(this instanceof pe))return new pe(J,fe);if(this.loose=fe,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function be(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ee(J,fe,me,Ce,Ae,ze,Oe,Te,qe,je,Ke,xe,ie){return((fe=be(me)?"":be(Ce)?">="+me+".0.0":be(Ae)?">="+me+"."+Ce+".0":">="+fe)+" "+(Te=be(qe)?"":be(je)?"<"+(+qe+1)+".0.0":be(Ke)?"<"+qe+"."+(+je+1)+".0":xe?"<="+qe+"."+je+"."+Ke+"-"+xe:"<="+Te)).trim()}function De(J,fe){for(var me=0;me<J.length;me++)if(!J[me].test(fe))return!1;if(fe.prerelease.length){for(me=0;me<J.length;me++)if(I(J[me].semver),J[me].semver!==de&&J[me].semver.prerelease.length>0){var Ce=J[me].semver;if(Ce.major===fe.major&&Ce.minor===fe.minor&&Ce.patch===fe.patch)return!0}return!1}return!0}function _e(J,fe,me){try{fe=new pe(fe,me)}catch{return!1}return fe.test(J)}function ye(J,fe,me,Ce){var Ae,ze,Oe,Te,qe;switch(J=new he(J,Ce),fe=new pe(fe,Ce),me){case">":Ae=Z,ze=$,Oe=re,Te=">",qe=">=";break;case"<":Ae=re,ze=H,Oe=Z,Te="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_e(J,fe,Ce))return!1;for(var je=0;je<fe.set.length;++je){var Ke=fe.set[je],xe=null,ie=null;if(Ke.forEach(function(ge){ge.semver===de&&(ge=new ee(">=0.0.0")),xe=xe||ge,ie=ie||ge,Ae(ge.semver,xe.semver,Ce)?xe=ge:Oe(ge.semver,ie.semver,Ce)&&(ie=ge)}),xe.operator===Te||xe.operator===qe||(!ie.operator||ie.operator===Te)&&ze(J,ie.semver)||ie.operator===qe&&Oe(J,ie.semver))return!1}return!0}ee.prototype.parse=function(J){var fe=this.loose?P[X]:P[Y],me=J.match(fe);if(!me)throw new TypeError("Invalid comparator: "+J);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new he(me[2],this.loose):this.semver=de},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(J){return I("Comparator.test",J,this.loose),this.semver===de||(typeof J=="string"&&(J=new he(J,this.loose)),se(J,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(J,fe){if(!(J instanceof ee))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(J.value,fe),_e(this.value,me,fe);if(J.operator==="")return me=new pe(this.value,fe),_e(J.semver,me,fe);var Ce=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),ze=this.semver.version===J.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Te=se(this.semver,"<",J.semver,fe)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),qe=se(this.semver,">",J.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Ce||Ae||ze&&Oe||Te||qe},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(J){var fe=this.loose;J=J.trim(),I("range",J,fe);var me=fe?P[x]:P[T];J=J.replace(me,Ee),I("hyphen replace",J),J=J.replace(P[B],"$1$2$3"),I("comparator trim",J,P[B]),J=(J=(J=J.replace(P[F],"$1~")).replace(P[ce],"$1^")).split(/\s+/).join(" ");var Ce=fe?P[X]:P[Y],Ae=J.split(" ").map(function(ze){return function(Oe,Te){return I("comp",Oe),Oe=function(qe,je){return qe.trim().split(/\s+/).map(function(Ke){return function(xe,ie){I("caret",xe,ie);var ge=ie?P[ue]:P[te];return xe.replace(ge,function(ve,Se,Ie,We,Ue){var Ge;return I("caret",xe,ve,Se,Ie,We,Ue),be(Se)?Ge="":be(Ie)?Ge=">="+Se+".0.0 <"+(+Se+1)+".0.0":be(We)?Ge=Se==="0"?">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+".0 <"+(+Se+1)+".0.0":Ue?(I("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=Se==="0"?Ie==="0"?">="+Se+"."+Ie+"."+We+Ue+" <"+Se+"."+Ie+"."+(+We+1):">="+Se+"."+Ie+"."+We+Ue+" <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+"."+We+Ue+" <"+(+Se+1)+".0.0"):(I("no pr"),Ge=Se==="0"?Ie==="0"?">="+Se+"."+Ie+"."+We+" <"+Se+"."+Ie+"."+(+We+1):">="+Se+"."+Ie+"."+We+" <"+Se+"."+(+Ie+1)+".0":">="+Se+"."+Ie+"."+We+" <"+(+Se+1)+".0.0"),I("caret return",Ge),Ge})}(Ke,je)}).join(" ")}(Oe,Te),I("caret",Oe),Oe=function(qe,je){return qe.trim().split(/\s+/).map(function(Ke){return function(xe,ie){var ge=ie?P[z]:P[_];return xe.replace(ge,function(ve,Se,Ie,We,Ue){var Ge;return I("tilde",xe,ve,Se,Ie,We,Ue),be(Se)?Ge="":be(Ie)?Ge=">="+Se+".0.0 <"+(+Se+1)+".0.0":be(We)?Ge=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0":Ue?(I("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ge=">="+Se+"."+Ie+"."+We+Ue+" <"+Se+"."+(+Ie+1)+".0"):Ge=">="+Se+"."+Ie+"."+We+" <"+Se+"."+(+Ie+1)+".0",I("tilde return",Ge),Ge})}(Ke,je)}).join(" ")}(Oe,Te),I("tildes",Oe),Oe=function(qe,je){return I("replaceXRanges",qe,je),qe.split(/\s+/).map(function(Ke){return function(xe,ie){xe=xe.trim();var ge=ie?P[L]:P[M];return xe.replace(ge,function(ve,Se,Ie,We,Ue,Ge){I("xRange",xe,ve,Se,Ie,We,Ue,Ge);var Je=be(Ie),Xe=Je||be(We),Ye=Xe||be(Ue);return Se==="="&&Ye&&(Se=""),Je?ve=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Ye?(Xe&&(We=0),Ye&&(Ue=0),Se===">"?(Se=">=",Xe?(Ie=+Ie+1,We=0,Ue=0):Ye&&(We=+We+1,Ue=0)):Se==="<="&&(Se="<",Xe?Ie=+Ie+1:We=+We+1),ve=Se+Ie+"."+We+"."+Ue):Xe?ve=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ye&&(ve=">="+Ie+"."+We+".0 <"+Ie+"."+(+We+1)+".0"),I("xRange return",ve),ve})}(Ke,je)}).join(" ")}(Oe,Te),I("xrange",Oe),Oe=function(qe,je){return I("replaceStars",qe,je),qe.trim().replace(P[V],"")}(Oe,Te),I("stars",Oe),Oe}(ze,fe)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(ze){return!!ze.match(Ce)})),Ae=Ae.map(function(ze){return new ee(ze,fe)})},pe.prototype.intersects=function(J,fe){if(!(J instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ce){return J.set.some(function(Ae){return Ae.every(function(ze){return Ce.intersects(ze,fe)})})})})},e.toComparators=function(J,fe){return new pe(J,fe).set.map(function(me){return me.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new he(J,this.loose));for(var fe=0;fe<this.set.length;fe++)if(De(this.set[fe],J))return!0;return!1},e.satisfies=_e,e.maxSatisfying=function(J,fe,me){var Ce=null,Ae=null;try{var ze=new pe(fe,me)}catch{return null}return J.forEach(function(Oe){ze.test(Oe)&&(Ce&&Ae.compare(Oe)!==-1||(Ae=new he(Ce=Oe,me)))}),Ce},e.minSatisfying=function(J,fe,me){var Ce=null,Ae=null;try{var ze=new pe(fe,me)}catch{return null}return J.forEach(function(Oe){ze.test(Oe)&&(Ce&&Ae.compare(Oe)!==1||(Ae=new he(Ce=Oe,me)))}),Ce},e.validRange=function(J,fe){try{return new pe(J,fe).range||"*"}catch{return null}},e.ltr=function(J,fe,me){return ye(J,fe,"<",me)},e.gtr=function(J,fe,me){return ye(J,fe,">",me)},e.outside=ye,e.prerelease=function(J,fe){var me=le(J,fe);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(J,fe,me){return J=new pe(J,me),fe=new pe(fe,me),J.intersects(fe)},e.coerce=function(J){if(J instanceof he)return J;if(typeof J!="string")return null;var fe=J.match(P[R]);return fe==null?null:le((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(Q,e){var n,D,I=Q.exports={};function O(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(w){if(n===setTimeout)return setTimeout(w,0);if((n===O||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:O}catch{n=O}try{D=typeof clearTimeout=="function"?clearTimeout:C}catch{D=C}})();var h,l=[],v=!1,y=-1;function E(){v&&h&&(v=!1,h.length?l=h.concat(l):y=-1,l.length&&g())}function g(){if(!v){var w=P(E);v=!0;for(var p=l.length;p;){for(h=l,l=[];++y<p;)h&&h[y].run();y=-1,p=l.length}h=null,v=!1,function(d){if(D===clearTimeout)return clearTimeout(d);if((D===C||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(d);try{D(d)}catch{try{return D.call(null,d)}catch{return D.call(this,d)}}}(w)}}function m(w,p){this.fun=w,this.array=p}function b(){}I.nextTick=function(w){var p=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)p[d-1]=arguments[d];l.push(new m(w,p)),l.length!==1||v||P(g)},m.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=b,I.addListener=b,I.once=b,I.off=b,I.removeListener=b,I.removeAllListeners=b,I.emit=b,I.prependListener=b,I.prependOnceListener=b,I.listeners=function(w){return[]},I.binding=function(w){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(w){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(oe[142],ae([0,1]),function(Q,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(P,h,l){this.level=P,this.key=h,this.value=l,this.forward=[]}}const I=void 0;class O{constructor(P,h=2**16){this.comparator=P,this[n]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(h)|0),this._header=new D(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,I,I),this._size=0}has(P){return!!O._search(this,P,this.comparator)}get(P){return O._search(this,P,this.comparator)?.value}set(P,h){return O._insert(this,P,h,this.comparator)&&(this._size+=1),this}delete(P){const h=O._delete(this,P,this.comparator);return h&&(this._size-=1),h}forEach(P,h){let l=this._header.forward[0];for(;l;)P.call(h,l.value,l.key,this),l=l.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",h=this._header.forward[0];for(;h;)P+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return P}static _search(P,h,l){let v=P._header;for(let y=P._level-1;y>=0;y--)for(;v.forward[y]&&l(v.forward[y].key,h)<0;)v=v.forward[y];if(v=v.forward[0],v&&l(v.key,h)===0)return v}static _insert(P,h,l,v){const y=[];let E=P._header;for(let g=P._level-1;g>=0;g--){for(;E.forward[g]&&v(E.forward[g].key,h)<0;)E=E.forward[g];y[g]=E}if(E=E.forward[0],E&&v(E.key,h)===0)return E.value=l,!1;{const g=O._randomLevel(P);if(g>P._level){for(let m=P._level;m<g;m++)y[m]=P._header;P._level=g}E=new D(g,h,l);for(let m=0;m<g;m++)E.forward[m]=y[m].forward[m],y[m].forward[m]=E;return!0}}static _randomLevel(P,h=.5){let l=1;for(;Math.random()<h&&l<P._maxLevel;)l+=1;return l}static _delete(P,h,l){const v=[];let y=P._header;for(let E=P._level-1;E>=0;E--){for(;y.forward[E]&&l(y.forward[E].key,h)<0;)y=y.forward[E];v[E]=y}if(y=y.forward[0],!y||l(y.key,h)!==0)return!1;for(let E=0;E<P._level&&v[E].forward[E]===y;E++)v[E].forward[E]=y.forward[E];for(;P._level>0&&P._header.forward[P._level-1]===I;)P._level-=1;return!0}}e.SkipList=O}),define(oe[73],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(O){return new D(O)}constructor(O){this._now=n&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=D}),define(oe[3],ae([0,1,15,86,2,104,73]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=g;const P=!1,h=!1,l=!1;var v;(function(R){R.None=()=>I.Disposable.None;function A(ee){if(l){const{onDidAddListener:de}=ee,pe=b.create();let be=0;ee.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),de?.()}}}function F(ee,de){return T(ee,()=>{},0,void 0,!0,void 0,de)}R.defer=F;function _(ee){return(de,pe=null,be)=>{let Ee=!1,De;return De=ee(_e=>{if(!Ee)return De?De.dispose():Ee=!0,de.call(pe,_e)},null,be),Ee&&De.dispose(),De}}R.once=_;function z(ee,de,pe){return Y((be,Ee=null,De)=>ee(_e=>be.call(Ee,de(_e)),null,De),pe)}R.map=z;function j(ee,de,pe){return Y((be,Ee=null,De)=>ee(_e=>{de(_e),be.call(Ee,_e)},null,De),pe)}R.forEach=j;function ce(ee,de,pe){return Y((be,Ee=null,De)=>ee(_e=>de(_e)&&be.call(Ee,_e),null,De),pe)}R.filter=ce;function te(ee){return ee}R.signal=te;function ue(...ee){return(de,pe=null,be)=>{const Ee=(0,I.combinedDisposable)(...ee.map(De=>De(_e=>de.call(pe,_e))));return B(Ee,be)}}R.any=ue;function X(ee,de,pe,be){let Ee=pe;return z(ee,De=>(Ee=de(Ee,De),Ee),be)}R.reduce=X;function Y(ee,de){let pe;const be={onWillAddFirstListener(){pe=ee(Ee.fire,Ee)},onDidRemoveLastListener(){pe?.dispose()}};de||A(be);const Ee=new a(be);return de?.add(Ee),Ee.event}function B(ee,de){return de instanceof Array?de.push(ee):de&&de.add(ee),ee}function T(ee,de,pe=100,be=!1,Ee=!1,De,_e){let ye,J,fe,me=0,Ce;const Ae={leakWarningThreshold:De,onWillAddFirstListener(){ye=ee(Oe=>{me++,J=de(J,Oe),be&&!fe&&(ze.fire(J),J=void 0),Ce=()=>{const Te=J;J=void 0,fe=void 0,(!be||me>1)&&ze.fire(Te),me=0},typeof pe=="number"?(clearTimeout(fe),fe=setTimeout(Ce,pe)):fe===void 0&&(fe=0,queueMicrotask(Ce))})},onWillRemoveListener(){Ee&&me>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,ye.dispose()}};_e||A(Ae);const ze=new a(Ae);return _e?.add(ze),ze.event}R.debounce=T;function x(ee,de=0,pe){return R.debounce(ee,(be,Ee)=>be?(be.push(Ee),be):[Ee],de,void 0,!0,void 0,pe)}R.accumulate=x;function V(ee,de=(be,Ee)=>be===Ee,pe){let be=!0,Ee;return ce(ee,De=>{const _e=be||!de(De,Ee);return be=!1,Ee=De,_e},pe)}R.latch=V;function U(ee,de,pe){return[R.filter(ee,de,pe),R.filter(ee,be=>!de(be),pe)]}R.split=U;function le(ee,de=!1,pe=[],be){let Ee=pe.slice(),De=ee(J=>{Ee?Ee.push(J):ye.fire(J)});be&&be.add(De);const _e=()=>{Ee?.forEach(J=>ye.fire(J)),Ee=null},ye=new a({onWillAddFirstListener(){De||(De=ee(J=>ye.fire(J)),be&&be.add(De))},onDidAddFirstListener(){Ee&&(de?setTimeout(_e):_e())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return be&&be.add(ye),ye.event}R.buffer=le;function he(ee,de){return(be,Ee,De)=>{const _e=de(new W);return ee(function(ye){const J=_e.evaluate(ye);J!==K&&be.call(Ee,J)},void 0,De)}}R.chain=he;const K=Symbol("HaltChainable");class W{constructor(){this.steps=[]}map(de){return this.steps.push(de),this}forEach(de){return this.steps.push(pe=>(de(pe),pe)),this}filter(de){return this.steps.push(pe=>de(pe)?pe:K),this}reduce(de,pe){let be=pe;return this.steps.push(Ee=>(be=de(be,Ee),be)),this}latch(de=(pe,be)=>pe===be){let pe=!0,be;return this.steps.push(Ee=>{const De=pe||!de(Ee,be);return pe=!1,be=Ee,De?Ee:K}),this}evaluate(de){for(const pe of this.steps)if(de=pe(de),de===K)break;return de}}function N(ee,de,pe=be=>be){const be=(...ye)=>_e.fire(pe(...ye)),Ee=()=>ee.on(de,be),De=()=>ee.removeListener(de,be),_e=new a({onWillAddFirstListener:Ee,onDidRemoveLastListener:De});return _e.event}R.fromNodeEventEmitter=N;function Z(ee,de,pe=be=>be){const be=(...ye)=>_e.fire(pe(...ye)),Ee=()=>ee.addEventListener(de,be),De=()=>ee.removeEventListener(de,be),_e=new a({onWillAddFirstListener:Ee,onDidRemoveLastListener:De});return _e.event}R.fromDOMEventEmitter=Z;function re(ee){return new Promise(de=>_(ee)(de))}R.toPromise=re;function G(ee){const de=new a;return ee.then(pe=>{de.fire(pe)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}R.fromPromise=G;function q(ee,de,pe){return de(pe),ee(be=>de(be))}R.runAndSubscribe=q;class H{constructor(de,pe){this._observable=de,this._counter=0,this._hasChanged=!1;const be={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};pe||A(be),this.emitter=new a(be),pe&&pe.add(this.emitter)}beginUpdate(de){this._counter++}handlePossibleChange(de){}handleChange(de,pe){this._hasChanged=!0}endUpdate(de){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function $(ee,de){return new H(ee,de).emitter.event}R.fromObservable=$;function se(ee){return(de,pe,be)=>{let Ee=0,De=!1;const _e={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(ee.reportChanges(),De&&(De=!1,de.call(pe)))},handlePossibleChange(){},handleChange(){De=!0}};ee.addObserver(_e),ee.reportChanges();const ye={dispose(){ee.removeObserver(_e)}};return be instanceof I.DisposableStore?be.add(ye):Array.isArray(be)&&be.push(ye),ye}}R.fromObservableLight=se})(v||(e.Event=v={}));class y{static{this.all=new Set}static{this._idPool=0}constructor(A){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${A}_${y._idPool++}`,y.all.add(this)}start(A){this._stopWatch=new C.StopWatch,this.listenerCount=A}stop(){if(this._stopWatch){const A=this._stopWatch.elapsed();this.durations.push(A),this.elapsedOverall+=A,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=y;let E=-1;function g(R){const A=E;return E=R,{dispose(){E=A}}}class m{constructor(A,F=Math.random().toString(18).slice(2,5)){this.threshold=A,this.name=F,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(A,F){const _=this.threshold;if(_<=0||F<_)return;this._stacks||(this._stacks=new Map);const z=this._stacks.get(A.value)||0;if(this._stacks.set(A.value,z+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=_*.5;let j,ce=0;for(const[te,ue]of this._stacks)(!j||ce<ue)&&(j=te,ce=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${ce}):`),console.warn(j)}return()=>{const j=this._stacks.get(A.value)||0;this._stacks.set(A.value,j-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(A){this.value=A}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class p{constructor(A){this.value=A,this.id=w++}}const d=2,c=(R,A)=>{if(R instanceof p)A(R);else for(let F=0;F<R.length;F++){const _=R[F];_&&A(_)}},f=P?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class a{constructor(A){this._size=0,this._options=A,this._leakageMon=E>0||this._options?.leakWarningThreshold?new m(this._options?.leakWarningThreshold??E):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(h){const A=this._listeners;queueMicrotask(()=>{c(A,F=>F.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(A,F,_)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;if(this._disposed)return I.Disposable.None;F&&(A=A.bind(F));const z=new p(A);let j,ce;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(z.stack=b.create(),j=this._leakageMon.check(z.stack,this._size+1)),h&&(z.stack=ce??b.create()),this._listeners?this._listeners instanceof p?(this._deliveryQueue??=new o,this._listeners=[this._listeners,z]):this._listeners.push(z):(this._options?.onWillAddFirstListener?.(this),this._listeners=z,this._options?.onDidAddFirstListener?.(this)),this._size++;const te=(0,I.toDisposable)(()=>{f?.unregister(te),j?.(),this._removeListener(z)});if(_ instanceof I.DisposableStore?_.add(te):Array.isArray(_)&&_.push(te),f){const ue=new Error().stack.split(`
`).slice(2).join(`
`).trim();f.register(te,ue,te)}return te},this._event}_removeListener(A){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const F=this._listeners,_=F.indexOf(A);if(_===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,F[_]=void 0;const z=this._deliveryQueue.current===this;if(this._size*d<=F.length){let j=0;for(let ce=0;ce<F.length;ce++)F[ce]?F[j++]=F[ce]:z&&(this._deliveryQueue.end--,j<this._deliveryQueue.i&&this._deliveryQueue.i--);F.length=j}}_deliver(A,F){if(!A)return;const _=this._options?.onListenerError||n.onUnexpectedError;if(!_){A.value(F);return}try{A.value(F)}catch(z){_(z)}}_deliverQueue(A){const F=A.current._listeners;for(;A.i<A.end;)this._deliver(F[A.i++],A.value);A.reset()}fire(A){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof p)this._deliver(this._listeners,A);else{const F=this._deliveryQueue;F.enqueue(this,A,this._listeners.length),this._deliverQueue(F)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=a;const t=()=>new o;e.createEventDeliveryQueue=t;class o{constructor(){this.i=-1,this.end=0}enqueue(A,F,_){this.i=0,this.end=_,this.current=A,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(A,F,_){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),c(this._listeners,z=>this._asyncDeliveryQueue.push([z.value,A]));this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[z,j]=this._asyncDeliveryQueue.shift(),ce=[],te={...j,token:F,waitUntil:ue=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");_&&(ue=_(ue,z)),ce.push(ue)}};try{z(te)}catch(ue){(0,n.onUnexpectedError)(ue);continue}Object.freeze(ce),await Promise.allSettled(ce).then(ue=>{for(const X of ue)X.status==="rejected"&&(0,n.onUnexpectedError)(X.reason)})}}}e.AsyncEmitter=s;class i extends a{get isPaused(){return this._isPaused!==0}constructor(A){super(A),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=A?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const A=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(A))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(A){this._size&&(this._isPaused!==0?this._eventQueue.push(A):super.fire(A))}}e.PauseableEmitter=i;class r extends i{constructor(A){super(A),this._delay=A.delay??100}fire(A){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(A)}}e.DebounceEmitter=r;class u extends a{constructor(A){super(A),this._queuedEvents=[],this._mergeFn=A?.merge}fire(A){this.hasListeners()&&(this._queuedEvents.push(A),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(F=>super.fire(F)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(A){const F={event:A,listener:null};this.events.push(F),this.hasListeners&&this.hook(F);const _=()=>{this.hasListeners&&this.unhook(F);const z=this.events.indexOf(F);this.events.splice(z,1)};return(0,I.toDisposable)((0,D.createSingleCallFunction)(_))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(A=>this.hook(A))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(A=>this.unhook(A))}hook(A){A.listener=A.event(F=>this.emitter.fire(F))}unhook(A){A.listener?.dispose(),A.listener=null}dispose(){this.emitter.dispose();for(const A of this.events)A.listener?.dispose();this.events=[]}}e.EventMultiplexer=S;class k{constructor(A,F,_,z){this._store=new I.DisposableStore;const j=this._store.add(new S),ce=this._store.add(new I.DisposableMap);function te(ue){ce.set(ue,j.add(z(ue)))}for(const ue of A)te(ue);this._store.add(F(ue=>{te(ue)})),this._store.add(_(ue=>{ce.deleteAndDispose(ue)})),this.event=j.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=k;class M{constructor(){this.buffers=[]}wrapEvent(A){return(F,_,z)=>A(j=>{const ce=this.buffers[this.buffers.length-1];ce?ce.push(()=>F.call(_,j)):F.call(_,j)},void 0,z)}bufferEvents(A){const F=[];this.buffers.push(F);const _=A();return this.buffers.pop(),F.forEach(z=>z()),_}}e.EventBufferer=M;class L{constructor(){this.listening=!1,this.inputEvent=v.None,this.inputEventListener=I.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(A){this.inputEvent=A,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=A(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=L}),define(oe[23],ae([0,1,3]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(P,h){const l=setTimeout(P.bind(h),0);return{dispose(){clearTimeout(l)}}});var I;(function(P){function h(l){return l===P.None||l===P.Cancelled||l instanceof O?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}P.isCancellationToken=h,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(I||(e.CancellationToken=I={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=I.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(oe[143],ae([0,1,23]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class D{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new n.CancellationTokenSource,h=this.task(P.token);return this.result={promise:h,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=D;class I{constructor(P,h=JSON.stringify){this.fn=P,this._computeKey=h,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const h=this._computeKey(P);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=I;class O{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const h=this.fn(P);return this._map.set(P,h),h}}e.CachedFunction=O}),define(oe[63],ae([0,1,15,2]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=I,e.isReadableStream=O,e.isReadableBufferedStream=C,e.newWriteableStream=P,e.consumeReadable=l,e.peekReadable=v,e.consumeStream=y,e.listenStream=E,e.peekStream=g,e.toStream=m,e.emptyStream=b,e.toReadable=w,e.transform=p,e.prefixedReadable=d,e.prefixedStream=c;function I(f){const a=f;return a?typeof a.read=="function":!1}function O(f){const a=f;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function C(f){const a=f;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function P(f,a){return new h(f,a)}class h{constructor(a,t){this.reducer=a,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a<"u"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(t=>t(a))}emitError(a){this.listeners.error.length===0?(0,n.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(t=>t(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,t){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(a,t){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,a){const t=[];let o;for(;(o=f.read())!==null;)t.push(o);return a(t)}function v(f,a,t){const o=[];let s;for(;(s=f.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return f.read()}}}function y(f,a){return new Promise((t,o)=>{const s=[];E(f,{onData:i=>{a&&s.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function E(f,a,t){f.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),f.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),f.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function g(f,a){return new Promise((t,o)=>{const s=new D.DisposableStore,i=[],r=k=>{if(i.push(k),i.length>a)return s.dispose(),f.pause(),t({stream:f,buffer:i,ended:!1})},u=k=>(s.dispose(),o(k)),S=()=>(s.dispose(),t({stream:f,buffer:i,ended:!0}));s.add((0,D.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),s.add((0,D.toDisposable)(()=>f.removeListener("end",S))),f.on("end",S),s.add((0,D.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}function m(f,a){const t=P(a);return t.end(f),t}function b(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}function w(f){let a=!1;return{read:()=>a?null:(a=!0,f)}}function p(f,a,t){const o=P(t);return E(f,{onData:s=>o.write(a.data(s)),onError:s=>o.error(a.error?a.error(s):s),onEnd:()=>o.end()}),o}function d(f,a,t){let o=!1;return{read:()=>{const s=a.read();return o?s:(o=!0,s!==null?t([f,s]):f)}}}function c(f,a,t){let o=!1;const s=P(t);return E(a,{onData:i=>o?s.write(i):(o=!0,s.write(t([f,i]))),onError:i=>s.error(i),onEnd:()=>{o||(o=!0,s.write(f)),s.end()}}),s}}),define(oe[17],ae([0,1,62,63]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=v,e.writeUInt16LE=y,e.readUInt32BE=E,e.writeUInt32BE=g,e.readUInt32LE=m,e.writeUInt32LE=b,e.readUInt8=w,e.writeUInt8=p,e.readableToBuffer=d,e.bufferToReadable=c,e.streamToBuffer=f,e.bufferedStreamToBuffer=a,e.bufferToStream=t,e.streamToBufferReadableStream=o,e.newWriteableBufferStream=s,e.prefixedBufferReadable=i,e.prefixedBufferStream=r,e.decodeBase64=u,e.encodeBase64=M;const I=typeof Buffer<"u",O=new n.Lazy(()=>new Uint8Array(256));let C,P;class h{static alloc(R){return I?new h(Buffer.allocUnsafe(R)):new h(new Uint8Array(R))}static wrap(R){return I&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new h(R)}static fromString(R,A){return!(A?.dontUseNodeBuffer||!1)&&I?new h(Buffer.from(R)):(C||(C=new TextEncoder),new h(C.encode(R)))}static fromByteArray(R){const A=h.alloc(R.length);for(let F=0,_=R.length;F<_;F++)A.buffer[F]=R[F];return A}static concat(R,A){if(typeof A>"u"){A=0;for(let z=0,j=R.length;z<j;z++)A+=R[z].byteLength}const F=h.alloc(A);let _=0;for(let z=0,j=R.length;z<j;z++){const ce=R[z];F.set(ce,_),_+=ce.byteLength}return F}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=h.alloc(this.byteLength);return R.set(this),R}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(R,A){return new h(this.buffer.subarray(R,A))}set(R,A){if(R instanceof h)this.buffer.set(R.buffer,A);else if(R instanceof Uint8Array)this.buffer.set(R,A);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),A);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return E(this.buffer,R)}writeUInt32BE(R,A){g(this.buffer,R,A)}readUInt32LE(R){return m(this.buffer,R)}writeUInt32LE(R,A){b(this.buffer,R,A)}readUInt8(R){return w(this.buffer,R)}writeUInt8(R,A){p(this.buffer,R,A)}indexOf(R,A=0){return l(this.buffer,R instanceof h?R.buffer:R,A)}}e.VSBuffer=h;function l(L,R,A=0){const F=R.byteLength,_=L.byteLength;if(F===0)return 0;if(F===1)return L.indexOf(R[0]);if(F>_-A)return-1;const z=O.value;z.fill(R.length);for(let ue=0;ue<R.length;ue++)z[R[ue]]=R.length-ue-1;let j=A+R.length-1,ce=j,te=-1;for(;j<_;)if(L[j]===R[ce]){if(ce===0){te=j;break}j--,ce--}else j+=Math.max(R.length-ce,z[L[j]]),ce=R.length-1;return te}function v(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0}function y(L,R,A){L[A+0]=R&255,R=R>>>8,L[A+1]=R&255}function E(L,R){return L[R]*2**24+L[R+1]*2**16+L[R+2]*2**8+L[R+3]}function g(L,R,A){L[A+3]=R,R=R>>>8,L[A+2]=R,R=R>>>8,L[A+1]=R,R=R>>>8,L[A]=R}function m(L,R){return L[R+0]<<0>>>0|L[R+1]<<8>>>0|L[R+2]<<16>>>0|L[R+3]<<24>>>0}function b(L,R,A){L[A+0]=R&255,R=R>>>8,L[A+1]=R&255,R=R>>>8,L[A+2]=R&255,R=R>>>8,L[A+3]=R&255}function w(L,R){return L[R]}function p(L,R,A){L[A]=R}function d(L){return D.consumeReadable(L,R=>h.concat(R))}function c(L){return D.toReadable(L)}function f(L){return D.consumeStream(L,R=>h.concat(R))}async function a(L){return L.ended?h.concat(L.buffer):h.concat([...L.buffer,await f(L.stream)])}function t(L){return D.toStream(L,R=>h.concat(R))}function o(L){return D.transform(L,{data:R=>typeof R=="string"?h.fromString(R):h.wrap(R)},R=>h.concat(R))}function s(L){return D.newWriteableStream(R=>h.concat(R),L)}function i(L,R){return D.prefixedReadable(L,R,A=>h.concat(A))}function r(L,R){return D.prefixedStream(L,R,A=>h.concat(A))}function u(L){let R=0,A=0,F=0;const _=new Uint8Array(Math.floor(L.length/4*3)),z=ce=>{switch(A){case 3:_[F++]=R|ce,A=0;break;case 2:_[F++]=R|ce>>>2,R=ce<<6,A=3;break;case 1:_[F++]=R|ce>>>4,R=ce<<4,A=2;break;default:R=ce<<2,A=1}};for(let ce=0;ce<L.length;ce++){const te=L.charCodeAt(ce);if(te>=65&&te<=90)z(te-65);else if(te>=97&&te<=122)z(te-97+26);else if(te>=48&&te<=57)z(te-48+52);else if(te===43||te===45)z(62);else if(te===47||te===95)z(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ce]}`)}}const j=F;for(;A>0;)z(0);return h.wrap(_).slice(0,j)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:L},R=!0,A=!1){const F=A?k:S;let _="";const z=L.byteLength%3;let j=0;for(;j<L.byteLength-z;j+=3){const ce=L[j+0],te=L[j+1],ue=L[j+2];_+=F[ce>>>2],_+=F[(ce<<4|te>>>4)&63],_+=F[(te<<2|ue>>>6)&63],_+=F[ue&63]}if(z===1){const ce=L[j+0];_+=F[ce>>>2],_+=F[ce<<4&63],R&&(_+="==")}else if(z===2){const ce=L[j+0],te=L[j+1];_+=F[ce>>>2],_+=F[(ce<<4|te>>>4)&63],_+=F[te<<2&63],R&&(_+="=")}return _}}),define(oe[25],ae([0,1,143,62]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=I,e.format=C,e.format2=h,e.htmlAttributeEncodeValue=l,e.escape=v,e.escapeRegExpCharacters=y,e.count=E,e.truncate=g,e.truncateMiddle=m,e.trim=b,e.ltrim=w,e.rtrim=p,e.convertSimple2RegExpPattern=d,e.stripWildcards=c,e.createRegExp=f,e.regExpLeadsToEndlessLoop=a,e.splitLines=t,e.splitLinesIncludeSeparators=o,e.firstNonWhitespaceIndex=s,e.getLeadingWhitespace=i,e.lastNonWhitespaceIndex=r,e.replaceAsync=u,e.compare=S,e.compareSubstring=k,e.compareIgnoreCase=M,e.compareSubstringIgnoreCase=L,e.isAsciiDigit=R,e.isLowerAsciiLetter=A,e.isUpperAsciiLetter=F,e.equalsIgnoreCase=_,e.startsWithIgnoreCase=z,e.commonPrefixLength=j,e.commonSuffixLength=ce,e.isHighSurrogate=te,e.isLowSurrogate=ue,e.computeCodePoint=X,e.getNextCodePoint=Y,e.nextCharLength=V,e.prevCharLength=U,e.getCharContainingOffset=le,e.charCount=he,e.containsRTL=N,e.isBasicASCII=re,e.containsUnusualLineTerminators=G,e.isFullWidthCharacter=q,e.isEmojiImprecise=H,e.lcut=$,e.forAnsiStringParts=ee,e.removeAnsiEscapeCodes=de,e.startsWithUTF8BOM=pe,e.stripUTF8BOM=be,e.fuzzyContains=Ee,e.containsUppercaseCharacter=De,e.uppercaseFirstLetter=_e,e.getNLines=ye,e.singleLetterHash=J,e.getGraphemeBreakType=fe,e.getLeftDeleteOffset=Oe;function I(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}const O=/{(\d+)}/g;function C(ie,...ge){return ge.length===0?ie:ie.replace(O,function(ve,Se){const Ie=parseInt(Se,10);return isNaN(Ie)||Ie<0||Ie>=ge.length?ve:ge[Ie]})}const P=/{([^}]+)}/g;function h(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(P,(ve,Se)=>ge[Se]??ve)}function l(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function v(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function E(ie,ge){let ve=0;const Se=ge.charCodeAt(0);for(let Ie=ie.length-1;Ie>=0;Ie--)ie.charCodeAt(Ie)===Se&&ve++;return ve}function g(ie,ge,ve="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${ve}`}function m(ie,ge,ve="\u2026"){if(ie.length<=ge)return ie;const Se=Math.ceil(ge/2)-ve.length/2,Ie=Math.floor(ge/2)-ve.length/2;return`${ie.substr(0,Se)}${ve}${ie.substr(ie.length-Ie)}`}function b(ie,ge=" "){const ve=w(ie,ge);return p(ve,ge)}function w(ie,ge){if(!ie||!ge)return ie;const ve=ge.length;if(ve===0||ie.length===0)return ie;let Se=0;for(;ie.indexOf(ge,Se)===Se;)Se=Se+ve;return ie.substring(Se)}function p(ie,ge){if(!ie||!ge)return ie;const ve=ge.length,Se=ie.length;if(ve===0||Se===0)return ie;let Ie=Se,We=-1;for(;We=ie.lastIndexOf(ge,Ie-1),!(We===-1||We+ve!==Ie);){if(We===0)return"";Ie=We}return ie.substring(0,Ie)}function d(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function c(ie){return ie.replace(/\*/g,"")}function f(ie,ge,ve={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=y(ie)),ve.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Se="";return ve.global&&(Se+="g"),ve.matchCase||(Se+="i"),ve.multiline&&(Se+="m"),ve.unicode&&(Se+="u"),new RegExp(ie,Se)}function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}function t(ie){return ie.split(/\r\n|\r|\n/)}function o(ie){const ge=[],ve=ie.split(/(\r\n|\r|\n)/);for(let Se=0;Se<Math.ceil(ve.length/2);Se++)ge.push(ve[2*Se]+(ve[2*Se+1]??""));return ge}function s(ie){for(let ge=0,ve=ie.length;ge<ve;ge++){const Se=ie.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}function i(ie,ge=0,ve=ie.length){for(let Se=ge;Se<ve;Se++){const Ie=ie.charCodeAt(Se);if(Ie!==32&&Ie!==9)return ie.substring(ge,Se)}return ie.substring(ge,ve)}function r(ie,ge=ie.length-1){for(let ve=ge;ve>=0;ve--){const Se=ie.charCodeAt(ve);if(Se!==32&&Se!==9)return ve}return-1}function u(ie,ge,ve){const Se=[];let Ie=0;for(const We of ie.matchAll(ge)){if(Se.push(ie.slice(Ie,We.index)),We.index===void 0)throw new Error("match.index should be defined");Ie=We.index+We[0].length,Se.push(ve(We[0],...We.slice(1),We.index,ie,We.groups))}return Se.push(ie.slice(Ie)),Promise.all(Se).then(We=>We.join(""))}function S(ie,ge){return ie<ge?-1:ie>ge?1:0}function k(ie,ge,ve=0,Se=ie.length,Ie=0,We=ge.length){for(;ve<Se&&Ie<We;ve++,Ie++){const Je=ie.charCodeAt(ve),Xe=ge.charCodeAt(Ie);if(Je<Xe)return-1;if(Je>Xe)return 1}const Ue=Se-ve,Ge=We-Ie;return Ue<Ge?-1:Ue>Ge?1:0}function M(ie,ge){return L(ie,ge,0,ie.length,0,ge.length)}function L(ie,ge,ve=0,Se=ie.length,Ie=0,We=ge.length){for(;ve<Se&&Ie<We;ve++,Ie++){let Je=ie.charCodeAt(ve),Xe=ge.charCodeAt(Ie);if(Je===Xe)continue;if(Je>=128||Xe>=128)return k(ie.toLowerCase(),ge.toLowerCase(),ve,Se,Ie,We);A(Je)&&(Je-=32),A(Xe)&&(Xe-=32);const Ye=Je-Xe;if(Ye!==0)return Ye}const Ue=Se-ve,Ge=We-Ie;return Ue<Ge?-1:Ue>Ge?1:0}function R(ie){return ie>=48&&ie<=57}function A(ie){return ie>=97&&ie<=122}function F(ie){return ie>=65&&ie<=90}function _(ie,ge){return ie.length===ge.length&&L(ie,ge)===0}function z(ie,ge){const ve=ge.length;return ge.length>ie.length?!1:L(ie,ge,0,ve)===0}function j(ie,ge){const ve=Math.min(ie.length,ge.length);let Se;for(Se=0;Se<ve;Se++)if(ie.charCodeAt(Se)!==ge.charCodeAt(Se))return Se;return ve}function ce(ie,ge){const ve=Math.min(ie.length,ge.length);let Se;const Ie=ie.length-1,We=ge.length-1;for(Se=0;Se<ve;Se++)if(ie.charCodeAt(Ie-Se)!==ge.charCodeAt(We-Se))return Se;return ve}function te(ie){return 55296<=ie&&ie<=56319}function ue(ie){return 56320<=ie&&ie<=57343}function X(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}function Y(ie,ge,ve){const Se=ie.charCodeAt(ve);if(te(Se)&&ve+1<ge){const Ie=ie.charCodeAt(ve+1);if(ue(Ie))return X(Se,Ie)}return Se}function B(ie,ge){const ve=ie.charCodeAt(ge-1);if(ue(ve)&&ge>1){const Se=ie.charCodeAt(ge-2);if(te(Se))return X(Se,ve)}return ve}class T{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=B(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Y(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=T;class x{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new T(ge,ve)}nextGraphemeLength(){const ge=Ae.getInstance(),ve=this._iterator,Se=ve.offset;let Ie=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const We=ve.offset,Ue=ge.getGraphemeBreakType(ve.nextCodePoint());if(me(Ie,Ue)){ve.setOffset(We);break}Ie=Ue}return ve.offset-Se}prevGraphemeLength(){const ge=Ae.getInstance(),ve=this._iterator,Se=ve.offset;let Ie=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const We=ve.offset,Ue=ge.getGraphemeBreakType(ve.prevCodePoint());if(me(Ue,Ie)){ve.setOffset(We);break}Ie=Ue}return Se-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function V(ie,ge){return new x(ie,ge).nextGraphemeLength()}function U(ie,ge){return new x(ie,ge).prevGraphemeLength()}function le(ie,ge){ge>0&&ue(ie.charCodeAt(ge))&&ge--;const ve=ge+V(ie,ge);return[ve-U(ie,ve),ve]}function he(ie){const ge=new x(ie);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}let K;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ie){return K||(K=W()),K.test(ie)}const Z=/^[\t\n\r\x20-\x7E]*$/;function re(ie){return Z.test(ie)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}function q(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}function H(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}function $(ie,ge,ve=""){const Se=ie.trimStart();if(Se.length<ge)return Se;const Ie=/\b/g;let We=0;for(;Ie.test(Se)&&!(Se.length-Ie.lastIndex<ge);)We=Ie.lastIndex,Ie.lastIndex+=1;return We===0?Se:ve+Se.substring(We).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ee(ie){let ge=0;for(const ve of ie.matchAll(se))ge!==ve.index&&(yield{isCode:!1,str:ie.substring(ge,ve.index)}),yield{isCode:!0,str:ve[0]},ge=ve.index+ve[0].length;ge!==ie.length&&(yield{isCode:!1,str:ie.substring(ge)})}function de(ie){return ie&&(ie=ie.replace(se,"")),ie}e.UTF8_BOM_CHARACTER="\uFEFF";function pe(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}function be(ie){return pe(ie)?ie.substr(1):ie}function Ee(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const ve=ge.length,Se=ie.toLowerCase();let Ie=0,We=-1;for(;Ie<ve;){const Ue=Se.indexOf(ge[Ie],We+1);if(Ue<0)return!1;We=Ue,Ie++}return!0}function De(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}function _e(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}function ye(ie,ge=1){if(ge===0)return"";let ve=-1;do ve=ie.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?ie:(ie[ve-1]==="\r"&&ve--,ie.substr(0,ve))}function J(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}function fe(ie){return Ae.getInstance().getGraphemeBreakType(ie)}function me(ie,ge){return ie===0?ge!==5&&ge!==7:ie===2&&ge===3?!1:ie===4||ie===2||ie===3||ge===4||ge===2||ge===3?!0:!(ie===8&&(ge===8||ge===9||ge===11||ge===12)||(ie===11||ie===9)&&(ge===9||ge===10)||(ie===12||ie===10)&&ge===10||ge===5||ge===13||ge===7||ie===1||ie===13&&ge===14||ie===6&&ge===6)}var Ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Ae{static{this._INSTANCE=null}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const ve=this._data,Se=ve.length/3;let Ie=1;for(;Ie<=Se;)if(ge<ve[3*Ie])Ie=2*Ie;else if(ge>ve[3*Ie+1])Ie=2*Ie+1;else return ve[3*Ie+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(ie,ge){if(ie===0)return 0;const ve=Te(ie,ge);if(ve!==void 0)return ve;const Se=new T(ge,ie);return Se.prevCodePoint(),Se.offset}function Te(ie,ge){const ve=new T(ge,ie);let Se=ve.prevCodePoint();for(;qe(Se)||Se===65039||Se===8419;){if(ve.offset===0)return;Se=ve.prevCodePoint()}if(!H(Se))return;let Ie=ve.offset;return Ie>0&&ve.prevCodePoint()===8205&&(Ie=ve.offset),Ie}function qe(ie){return 127995<=ie&&ie<=127999}var je;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class Ke{static{this.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new n.LRUCachedFunction(ge=>{function ve(Ye){const rt=new Map;for(let it=0;it<Ye.length;it+=2)rt.set(Ye[it],Ye[it+1]);return rt}function Se(Ye,rt){const it=new Map(Ye);for(const[ot,at]of rt)it.set(ot,at);return it}function Ie(Ye,rt){if(!Ye)return rt;const it=new Map;for(const[ot,at]of Ye)rt.has(ot)&&it.set(ot,at);return it}const We=this.ambiguousCharacterData.value;let Ue=ge.filter(Ye=>!Ye.startsWith("_")&&Ye in We);Ue.length===0&&(Ue=["_default"]);let Ge;for(const Ye of Ue){const rt=ve(We[Ye]);Ge=Ie(Ge,rt)}const Je=ve(We._common),Xe=Se(Je,Ge);return new Ke(Xe)})}static getInstance(ge){return Ke.cache.get(Array.from(ge))}static{this._locales=new D.Lazy(()=>Object.keys(Ke.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ke._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ke;class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(ge){return xe.getData().has(ge)}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe}),define(oe[46],ae([0,1,25]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=D,e.doHash=I,e.numberHash=O,e.stringHash=P,e.toHexString=b;function D(p){return I(p,0)}function I(p,d){switch(typeof p){case"object":return p===null?O(349,d):Array.isArray(p)?h(p,d):l(p,d);case"string":return P(p,d);case"boolean":return C(p,d);case"number":return O(p,d);case"undefined":return O(937,d);default:return O(617,d)}}function O(p,d){return(d<<5)-d+p|0}function C(p,d){return O(p?433:863,d)}function P(p,d){d=O(149417,d);for(let c=0,f=p.length;c<f;c++)d=O(p.charCodeAt(c),d);return d}function h(p,d){return d=O(104579,d),p.reduce((c,f)=>I(f,c),d)}function l(p,d){return d=O(181387,d),Object.keys(p).sort().reduce((c,f)=>(c=P(f,c),I(p[f],c)),d)}class v{constructor(){this._value=0}get value(){return this._value}hash(d){return this._value=I(d,this._value),this._value}}e.Hasher=v;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(p,d,c=32){const f=c-d,a=~((1<<f)-1);return(p<<d|(a&p)>>>f)>>>0}function g(p,d=0,c=p.byteLength,f=0){for(let a=0;a<c;a++)p[d+a]=f}function m(p,d,c="0"){for(;p.length<d;)p=c+p;return p}function b(p,d=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(c=>c.toString(16).padStart(2,"0")).join(""):m((p>>>0).toString(16),d/4)}class w{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(d){const c=d.length;if(c===0)return;const f=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,o,s;for(t!==0?(o=t,s=-1,t=0):(o=d.charCodeAt(0),s=0);;){let i=o;if(n.isHighSurrogate(o))if(s+1<c){const r=d.charCodeAt(s+1);n.isLowSurrogate(r)?(s++,i=n.computeCodePoint(o,r)):i=65533}else{t=o;break}else n.isLowSurrogate(o)&&(i=65533);if(a=this._push(f,a,i),s++,s<c)o=d.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(d,c,f){return f<128?d[c++]=f:f<2048?(d[c++]=192|(f&1984)>>>6,d[c++]=128|(f&63)>>>0):f<65536?(d[c++]=224|(f&61440)>>>12,d[c++]=128|(f&4032)>>>6,d[c++]=128|(f&63)>>>0):(d[c++]=240|(f&1835008)>>>18,d[c++]=128|(f&258048)>>>12,d[c++]=128|(f&4032)>>>6,d[c++]=128|(f&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const d=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(d/4294967296),!1),this._buffDV.setUint32(60,d%4294967296,!1),this._step()}_step(){const d=w._bigBlock32,c=this._buffDV;for(let S=0;S<64;S+=4)d.setUint32(S,c.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)d.setUint32(S,E(d.getUint32(S-12,!1)^d.getUint32(S-32,!1)^d.getUint32(S-56,!1)^d.getUint32(S-64,!1),1),!1);let f=this._h0,a=this._h1,t=this._h2,o=this._h3,s=this._h4,i,r,u;for(let S=0;S<80;S++)S<20?(i=a&t|~a&o,r=1518500249):S<40?(i=a^t^o,r=1859775393):S<60?(i=a&t|a&o|t&o,r=2400959708):(i=a^t^o,r=3395469782),u=E(f,5)+i+s+r+d.getUint32(S*4,!1)&4294967295,s=o,o=t,t=E(a,30),a=f,f=u;this._h0=this._h0+f&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=w}),define(oe[74],ae([0,1,25]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(D||(D={})),function(I){const O="error",C="warning",P="warn",h="info",l="ignore";function v(E){return E?n.equalsIgnoreCase(O,E)?I.Error:n.equalsIgnoreCase(C,E)||n.equalsIgnoreCase(P,E)?I.Warning:n.equalsIgnoreCase(h,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=v;function y(E){switch(E){case I.Error:return O;case I.Warning:return C;case I.Info:return h;default:return l}}I.toString=y}(D||(D={})),e.default=D}),define(oe[144],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[59],ae([0,1,22,25]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this._value="",this._pos=0}reset(g){return this._value=g,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(g){const m=g.charCodeAt(0),b=this._value.charCodeAt(this._pos);return m-b}value(){return this._value[this._pos]}}e.StringIterator=I;class O{constructor(g=!0){this._caseSensitive=g}reset(g){return this._value=g,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let g=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(g)this._from++;else break;else g=!1;return this}cmp(g){return this._caseSensitive?(0,D.compareSubstring)(g,this._value,0,g.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(g,this._value,0,g.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class C{constructor(g=!0,m=!0){this._splitOnBackslash=g,this._caseSensitive=m}reset(g){this._from=0,this._to=0,this._value=g,this._valueLen=g.length;for(let m=g.length-1;m>=0;m--,this._valueLen--){const b=this._value.charCodeAt(m);if(!(b===47||this._splitOnBackslash&&b===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let g=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(g)this._from++;else break;else g=!1}return this}cmp(g){return this._caseSensitive?(0,D.compareSubstring)(g,this._value,0,g.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(g,this._value,0,g.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=C;var P;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(g,m){this._ignorePathCasing=g,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(g){return this._value=g,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new C(!1,!this._ignorePathCasing(g)),this._pathIterator.reset(g.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(g)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(g){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(g,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(g,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(g);if(this._states[this._stateIdx]===4)return(0,D.compare)(g,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(g,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(v||(v={}));class y{static forUris(g=()=>!1,m=()=>!1){return new y(new h(g,m))}static forPaths(g=!1){return new y(new C(void 0,!g))}static forStrings(){return new y(new I)}static forConfigKeys(){return new y(new O)}constructor(g){this._iter=g}clear(){this._root=void 0}fill(g,m){if(m){const b=m.slice(0);(0,n.shuffle)(b);for(const w of b)this.set(w,g)}else{const b=g.slice(0);(0,n.shuffle)(b);for(const w of b)this.set(w[0],w[1])}}set(g,m){const b=this._iter.reset(g);let w;this._root||(this._root=new l,this._root.segment=b.value());const p=[];for(w=this._root;;){const c=b.cmp(w.segment);if(c>0)w.left||(w.left=new l,w.left.segment=b.value()),p.push([-1,w]),w=w.left;else if(c<0)w.right||(w.right=new l,w.right.segment=b.value()),p.push([1,w]),w=w.right;else if(b.hasNext())b.next(),w.mid||(w.mid=new l,w.mid.segment=b.value()),p.push([0,w]),w=w.mid;else break}const d=w.value;w.value=m,w.key=g;for(let c=p.length-1;c>=0;c--){const f=p[c][1];f.updateHeight();const a=f.balanceFactor();if(a<-1||a>1){const t=p[c][0],o=p[c+1][0];if(t===1&&o===1)p[c][1]=f.rotateLeft();else if(t===-1&&o===-1)p[c][1]=f.rotateRight();else if(t===1&&o===-1)f.right=p[c+1][1]=p[c+1][1].rotateRight(),p[c][1]=f.rotateLeft();else if(t===-1&&o===1)f.left=p[c+1][1]=p[c+1][1].rotateLeft(),p[c][1]=f.rotateRight();else throw new Error;if(c>0)switch(p[c-1][0]){case-1:p[c-1][1].left=p[c][1];break;case 1:p[c-1][1].right=p[c][1];break;case 0:p[c-1][1].mid=p[c][1];break}else this._root=p[0][1]}}return d}get(g){return this._getNode(g)?.value}_getNode(g){const m=this._iter.reset(g);let b=this._root;for(;b;){const w=m.cmp(b.segment);if(w>0)b=b.left;else if(w<0)b=b.right;else if(m.hasNext())m.next(),b=b.mid;else break}return b}has(g){const m=this._getNode(g);return!(m?.value===void 0&&m?.mid===void 0)}delete(g){return this._delete(g,!1)}deleteSuperstr(g){return this._delete(g,!0)}_delete(g,m){const b=this._iter.reset(g),w=[];let p=this._root;for(;p;){const d=b.cmp(p.segment);if(d>0)w.push([-1,p]),p=p.left;else if(d<0)w.push([1,p]),p=p.right;else if(b.hasNext())b.next(),w.push([0,p]),p=p.mid;else break}if(p){if(m?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const d=this._min(p.right);if(d.key){const{key:c,value:f,segment:a}=d;this._delete(d.key,!1),p.key=c,p.value=f,p.segment=a}}else{const d=p.left??p.right;if(w.length>0){const[c,f]=w[w.length-1];switch(c){case-1:f.left=d;break;case 0:f.mid=d;break;case 1:f.right=d;break}}else this._root=d}for(let d=w.length-1;d>=0;d--){const c=w[d][1];c.updateHeight();const f=c.balanceFactor();if(f>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),w[d][1]=c.rotateLeft()):f<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),w[d][1]=c.rotateRight()),d>0)switch(w[d-1][0]){case-1:w[d-1][1].left=w[d][1];break;case 1:w[d-1][1].right=w[d][1];break;case 0:w[d-1][1].mid=w[d][1];break}else this._root=w[0][1]}}}_min(g){for(;g.left;)g=g.left;return g}findSubstr(g){const m=this._iter.reset(g);let b=this._root,w;for(;b;){const p=m.cmp(b.segment);if(p>0)b=b.left;else if(p<0)b=b.right;else if(m.hasNext())m.next(),w=b.value||w,b=b.mid;else break}return b&&b.value||w}findSuperstr(g){return this._findSuperstrOrElement(g,!1)}_findSuperstrOrElement(g,m){const b=this._iter.reset(g);let w=this._root;for(;w;){const p=b.cmp(w.segment);if(p>0)w=w.left;else if(p<0)w=w.right;else if(b.hasNext())b.next(),w=w.mid;else return w.mid?this._entries(w.mid):m?w.value:void 0}}hasElementOrSubtree(g){return this._findSuperstrOrElement(g,!0)!==void 0}forEach(g){for(const[m,b]of this)g(b,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(g){const m=[];return this._dfsEntries(g,m),m[Symbol.iterator]()}_dfsEntries(g,m){g&&(g.left&&this._dfsEntries(g.left,m),g.value&&m.push([g.key,g.value]),g.mid&&this._dfsEntries(g.mid,m),g.right&&this._dfsEntries(g.right,m))}_isBalanced(){const g=m=>{if(!m)return!0;const b=m.balanceFactor();return b<-1||b>1?!1:g(m.left)&&g(m.right)};return g(this._root)}}e.TernarySearchTree=y}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=n,e.isStringArray=D,e.isObject=I,e.isTypedArray=O,e.isNumber=C,e.isIterable=P,e.isBoolean=h,e.isUndefined=l,e.isDefined=v,e.isUndefinedOrNull=y,e.assertType=E,e.assertIsDefined=g,e.assertAllDefined=m,e.isEmptyObject=w,e.isFunction=p,e.areFunctions=d,e.validateConstraints=c,e.validateConstraint=f;function n(a){return typeof a=="string"}function D(a){return Array.isArray(a)&&a.every(t=>n(t))}function I(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function O(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function C(a){return typeof a=="number"&&!isNaN(a)}function P(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function v(a){return!y(a)}function y(a){return l(a)||a===null}function E(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function g(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function m(...a){const t=[];for(let o=0;o<a.length;o++){const s=a[o];if(y(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}const b=Object.prototype.hasOwnProperty;function w(a){if(!I(a))return!1;for(const t in a)if(b.call(a,t))return!1;return!0}function p(a){return typeof a=="function"}function d(...a){return a.length>0&&a.every(p)}function c(a,t){const o=Math.min(a.length,t.length);for(let s=0;s<o;s++)f(a[s],t[s])}function f(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(p(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[105],ae([0,1,12]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=I,e.getCodiconFontCharacters=O;const D=Object.create(null);function I(C,P){if((0,n.isString)(P)){const h=D[P];if(h===void 0)throw new Error(`${C} references an unknown codicon: ${P}`);P=h}return D[C]=P,{id:C}}function O(){return D}}),define(oe[145],ae([0,1,105]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,n.register)("add",6e4),plus:(0,n.register)("plus",6e4),gistNew:(0,n.register)("gist-new",6e4),repoCreate:(0,n.register)("repo-create",6e4),lightbulb:(0,n.register)("lightbulb",60001),lightBulb:(0,n.register)("light-bulb",60001),repo:(0,n.register)("repo",60002),repoDelete:(0,n.register)("repo-delete",60002),gistFork:(0,n.register)("gist-fork",60003),repoForked:(0,n.register)("repo-forked",60003),gitPullRequest:(0,n.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.register)("git-pull-request-abandoned",60004),recordKeys:(0,n.register)("record-keys",60005),keyboard:(0,n.register)("keyboard",60005),tag:(0,n.register)("tag",60006),gitPullRequestLabel:(0,n.register)("git-pull-request-label",60006),tagAdd:(0,n.register)("tag-add",60006),tagRemove:(0,n.register)("tag-remove",60006),person:(0,n.register)("person",60007),personFollow:(0,n.register)("person-follow",60007),personOutline:(0,n.register)("person-outline",60007),personFilled:(0,n.register)("person-filled",60007),gitBranch:(0,n.register)("git-branch",60008),gitBranchCreate:(0,n.register)("git-branch-create",60008),gitBranchDelete:(0,n.register)("git-branch-delete",60008),sourceControl:(0,n.register)("source-control",60008),mirror:(0,n.register)("mirror",60009),mirrorPublic:(0,n.register)("mirror-public",60009),star:(0,n.register)("star",60010),starAdd:(0,n.register)("star-add",60010),starDelete:(0,n.register)("star-delete",60010),starEmpty:(0,n.register)("star-empty",60010),comment:(0,n.register)("comment",60011),commentAdd:(0,n.register)("comment-add",60011),alert:(0,n.register)("alert",60012),warning:(0,n.register)("warning",60012),search:(0,n.register)("search",60013),searchSave:(0,n.register)("search-save",60013),logOut:(0,n.register)("log-out",60014),signOut:(0,n.register)("sign-out",60014),logIn:(0,n.register)("log-in",60015),signIn:(0,n.register)("sign-in",60015),eye:(0,n.register)("eye",60016),eyeUnwatch:(0,n.register)("eye-unwatch",60016),eyeWatch:(0,n.register)("eye-watch",60016),circleFilled:(0,n.register)("circle-filled",60017),primitiveDot:(0,n.register)("primitive-dot",60017),closeDirty:(0,n.register)("close-dirty",60017),debugBreakpoint:(0,n.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.register)("debug-breakpoint-disabled",60017),debugHint:(0,n.register)("debug-hint",60017),terminalDecorationSuccess:(0,n.register)("terminal-decoration-success",60017),primitiveSquare:(0,n.register)("primitive-square",60018),edit:(0,n.register)("edit",60019),pencil:(0,n.register)("pencil",60019),info:(0,n.register)("info",60020),issueOpened:(0,n.register)("issue-opened",60020),gistPrivate:(0,n.register)("gist-private",60021),gitForkPrivate:(0,n.register)("git-fork-private",60021),lock:(0,n.register)("lock",60021),mirrorPrivate:(0,n.register)("mirror-private",60021),close:(0,n.register)("close",60022),removeClose:(0,n.register)("remove-close",60022),x:(0,n.register)("x",60022),repoSync:(0,n.register)("repo-sync",60023),sync:(0,n.register)("sync",60023),clone:(0,n.register)("clone",60024),desktopDownload:(0,n.register)("desktop-download",60024),beaker:(0,n.register)("beaker",60025),microscope:(0,n.register)("microscope",60025),vm:(0,n.register)("vm",60026),deviceDesktop:(0,n.register)("device-desktop",60026),file:(0,n.register)("file",60027),fileText:(0,n.register)("file-text",60027),more:(0,n.register)("more",60028),ellipsis:(0,n.register)("ellipsis",60028),kebabHorizontal:(0,n.register)("kebab-horizontal",60028),mailReply:(0,n.register)("mail-reply",60029),reply:(0,n.register)("reply",60029),organization:(0,n.register)("organization",60030),organizationFilled:(0,n.register)("organization-filled",60030),organizationOutline:(0,n.register)("organization-outline",60030),newFile:(0,n.register)("new-file",60031),fileAdd:(0,n.register)("file-add",60031),newFolder:(0,n.register)("new-folder",60032),fileDirectoryCreate:(0,n.register)("file-directory-create",60032),trash:(0,n.register)("trash",60033),trashcan:(0,n.register)("trashcan",60033),history:(0,n.register)("history",60034),clock:(0,n.register)("clock",60034),folder:(0,n.register)("folder",60035),fileDirectory:(0,n.register)("file-directory",60035),symbolFolder:(0,n.register)("symbol-folder",60035),logoGithub:(0,n.register)("logo-github",60036),markGithub:(0,n.register)("mark-github",60036),github:(0,n.register)("github",60036),terminal:(0,n.register)("terminal",60037),console:(0,n.register)("console",60037),repl:(0,n.register)("repl",60037),zap:(0,n.register)("zap",60038),symbolEvent:(0,n.register)("symbol-event",60038),error:(0,n.register)("error",60039),stop:(0,n.register)("stop",60039),variable:(0,n.register)("variable",60040),symbolVariable:(0,n.register)("symbol-variable",60040),array:(0,n.register)("array",60042),symbolArray:(0,n.register)("symbol-array",60042),symbolModule:(0,n.register)("symbol-module",60043),symbolPackage:(0,n.register)("symbol-package",60043),symbolNamespace:(0,n.register)("symbol-namespace",60043),symbolObject:(0,n.register)("symbol-object",60043),symbolMethod:(0,n.register)("symbol-method",60044),symbolFunction:(0,n.register)("symbol-function",60044),symbolConstructor:(0,n.register)("symbol-constructor",60044),symbolBoolean:(0,n.register)("symbol-boolean",60047),symbolNull:(0,n.register)("symbol-null",60047),symbolNumeric:(0,n.register)("symbol-numeric",60048),symbolNumber:(0,n.register)("symbol-number",60048),symbolStructure:(0,n.register)("symbol-structure",60049),symbolStruct:(0,n.register)("symbol-struct",60049),symbolParameter:(0,n.register)("symbol-parameter",60050),symbolTypeParameter:(0,n.register)("symbol-type-parameter",60050),symbolKey:(0,n.register)("symbol-key",60051),symbolText:(0,n.register)("symbol-text",60051),symbolReference:(0,n.register)("symbol-reference",60052),goToFile:(0,n.register)("go-to-file",60052),symbolEnum:(0,n.register)("symbol-enum",60053),symbolValue:(0,n.register)("symbol-value",60053),symbolRuler:(0,n.register)("symbol-ruler",60054),symbolUnit:(0,n.register)("symbol-unit",60054),activateBreakpoints:(0,n.register)("activate-breakpoints",60055),archive:(0,n.register)("archive",60056),arrowBoth:(0,n.register)("arrow-both",60057),arrowDown:(0,n.register)("arrow-down",60058),arrowLeft:(0,n.register)("arrow-left",60059),arrowRight:(0,n.register)("arrow-right",60060),arrowSmallDown:(0,n.register)("arrow-small-down",60061),arrowSmallLeft:(0,n.register)("arrow-small-left",60062),arrowSmallRight:(0,n.register)("arrow-small-right",60063),arrowSmallUp:(0,n.register)("arrow-small-up",60064),arrowUp:(0,n.register)("arrow-up",60065),bell:(0,n.register)("bell",60066),bold:(0,n.register)("bold",60067),book:(0,n.register)("book",60068),bookmark:(0,n.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.register)("briefcase",60076),broadcast:(0,n.register)("broadcast",60077),browser:(0,n.register)("browser",60078),bug:(0,n.register)("bug",60079),calendar:(0,n.register)("calendar",60080),caseSensitive:(0,n.register)("case-sensitive",60081),check:(0,n.register)("check",60082),checklist:(0,n.register)("checklist",60083),chevronDown:(0,n.register)("chevron-down",60084),chevronLeft:(0,n.register)("chevron-left",60085),chevronRight:(0,n.register)("chevron-right",60086),chevronUp:(0,n.register)("chevron-up",60087),chromeClose:(0,n.register)("chrome-close",60088),chromeMaximize:(0,n.register)("chrome-maximize",60089),chromeMinimize:(0,n.register)("chrome-minimize",60090),chromeRestore:(0,n.register)("chrome-restore",60091),circleOutline:(0,n.register)("circle-outline",60092),circle:(0,n.register)("circle",60092),debugBreakpointUnverified:(0,n.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.register)("terminal-decoration-incomplete",60092),circleSlash:(0,n.register)("circle-slash",60093),circuitBoard:(0,n.register)("circuit-board",60094),clearAll:(0,n.register)("clear-all",60095),clippy:(0,n.register)("clippy",60096),closeAll:(0,n.register)("close-all",60097),cloudDownload:(0,n.register)("cloud-download",60098),cloudUpload:(0,n.register)("cloud-upload",60099),code:(0,n.register)("code",60100),collapseAll:(0,n.register)("collapse-all",60101),colorMode:(0,n.register)("color-mode",60102),commentDiscussion:(0,n.register)("comment-discussion",60103),creditCard:(0,n.register)("credit-card",60105),dash:(0,n.register)("dash",60108),dashboard:(0,n.register)("dashboard",60109),database:(0,n.register)("database",60110),debugContinue:(0,n.register)("debug-continue",60111),debugDisconnect:(0,n.register)("debug-disconnect",60112),debugPause:(0,n.register)("debug-pause",60113),debugRestart:(0,n.register)("debug-restart",60114),debugStart:(0,n.register)("debug-start",60115),debugStepInto:(0,n.register)("debug-step-into",60116),debugStepOut:(0,n.register)("debug-step-out",60117),debugStepOver:(0,n.register)("debug-step-over",60118),debugStop:(0,n.register)("debug-stop",60119),debug:(0,n.register)("debug",60120),deviceCameraVideo:(0,n.register)("device-camera-video",60121),deviceCamera:(0,n.register)("device-camera",60122),deviceMobile:(0,n.register)("device-mobile",60123),diffAdded:(0,n.register)("diff-added",60124),diffIgnored:(0,n.register)("diff-ignored",60125),diffModified:(0,n.register)("diff-modified",60126),diffRemoved:(0,n.register)("diff-removed",60127),diffRenamed:(0,n.register)("diff-renamed",60128),diff:(0,n.register)("diff",60129),diffSidebyside:(0,n.register)("diff-sidebyside",60129),discard:(0,n.register)("discard",60130),editorLayout:(0,n.register)("editor-layout",60131),emptyWindow:(0,n.register)("empty-window",60132),exclude:(0,n.register)("exclude",60133),extensions:(0,n.register)("extensions",60134),eyeClosed:(0,n.register)("eye-closed",60135),fileBinary:(0,n.register)("file-binary",60136),fileCode:(0,n.register)("file-code",60137),fileMedia:(0,n.register)("file-media",60138),filePdf:(0,n.register)("file-pdf",60139),fileSubmodule:(0,n.register)("file-submodule",60140),fileSymlinkDirectory:(0,n.register)("file-symlink-directory",60141),fileSymlinkFile:(0,n.register)("file-symlink-file",60142),fileZip:(0,n.register)("file-zip",60143),files:(0,n.register)("files",60144),filter:(0,n.register)("filter",60145),flame:(0,n.register)("flame",60146),foldDown:(0,n.register)("fold-down",60147),foldUp:(0,n.register)("fold-up",60148),fold:(0,n.register)("fold",60149),folderActive:(0,n.register)("folder-active",60150),folderOpened:(0,n.register)("folder-opened",60151),gear:(0,n.register)("gear",60152),gift:(0,n.register)("gift",60153),gistSecret:(0,n.register)("gist-secret",60154),gist:(0,n.register)("gist",60155),gitCommit:(0,n.register)("git-commit",60156),gitCompare:(0,n.register)("git-compare",60157),compareChanges:(0,n.register)("compare-changes",60157),gitMerge:(0,n.register)("git-merge",60158),githubAction:(0,n.register)("github-action",60159),githubAlt:(0,n.register)("github-alt",60160),globe:(0,n.register)("globe",60161),grabber:(0,n.register)("grabber",60162),graph:(0,n.register)("graph",60163),gripper:(0,n.register)("gripper",60164),heart:(0,n.register)("heart",60165),home:(0,n.register)("home",60166),horizontalRule:(0,n.register)("horizontal-rule",60167),hubot:(0,n.register)("hubot",60168),inbox:(0,n.register)("inbox",60169),issueReopened:(0,n.register)("issue-reopened",60171),issues:(0,n.register)("issues",60172),italic:(0,n.register)("italic",60173),jersey:(0,n.register)("jersey",60174),json:(0,n.register)("json",60175),kebabVertical:(0,n.register)("kebab-vertical",60176),key:(0,n.register)("key",60177),law:(0,n.register)("law",60178),lightbulbAutofix:(0,n.register)("lightbulb-autofix",60179),linkExternal:(0,n.register)("link-external",60180),link:(0,n.register)("link",60181),listOrdered:(0,n.register)("list-ordered",60182),listUnordered:(0,n.register)("list-unordered",60183),liveShare:(0,n.register)("live-share",60184),loading:(0,n.register)("loading",60185),location:(0,n.register)("location",60186),mailRead:(0,n.register)("mail-read",60187),mail:(0,n.register)("mail",60188),markdown:(0,n.register)("markdown",60189),megaphone:(0,n.register)("megaphone",60190),mention:(0,n.register)("mention",60191),milestone:(0,n.register)("milestone",60192),gitPullRequestMilestone:(0,n.register)("git-pull-request-milestone",60192),mortarBoard:(0,n.register)("mortar-board",60193),move:(0,n.register)("move",60194),multipleWindows:(0,n.register)("multiple-windows",60195),mute:(0,n.register)("mute",60196),noNewline:(0,n.register)("no-newline",60197),note:(0,n.register)("note",60198),octoface:(0,n.register)("octoface",60199),openPreview:(0,n.register)("open-preview",60200),package:(0,n.register)("package",60201),paintcan:(0,n.register)("paintcan",60202),pin:(0,n.register)("pin",60203),play:(0,n.register)("play",60204),run:(0,n.register)("run",60204),plug:(0,n.register)("plug",60205),preserveCase:(0,n.register)("preserve-case",60206),preview:(0,n.register)("preview",60207),project:(0,n.register)("project",60208),pulse:(0,n.register)("pulse",60209),question:(0,n.register)("question",60210),quote:(0,n.register)("quote",60211),radioTower:(0,n.register)("radio-tower",60212),reactions:(0,n.register)("reactions",60213),references:(0,n.register)("references",60214),refresh:(0,n.register)("refresh",60215),regex:(0,n.register)("regex",60216),remoteExplorer:(0,n.register)("remote-explorer",60217),remote:(0,n.register)("remote",60218),remove:(0,n.register)("remove",60219),replaceAll:(0,n.register)("replace-all",60220),replace:(0,n.register)("replace",60221),repoClone:(0,n.register)("repo-clone",60222),repoForcePush:(0,n.register)("repo-force-push",60223),repoPull:(0,n.register)("repo-pull",60224),repoPush:(0,n.register)("repo-push",60225),report:(0,n.register)("report",60226),requestChanges:(0,n.register)("request-changes",60227),rocket:(0,n.register)("rocket",60228),rootFolderOpened:(0,n.register)("root-folder-opened",60229),rootFolder:(0,n.register)("root-folder",60230),rss:(0,n.register)("rss",60231),ruby:(0,n.register)("ruby",60232),saveAll:(0,n.register)("save-all",60233),saveAs:(0,n.register)("save-as",60234),save:(0,n.register)("save",60235),screenFull:(0,n.register)("screen-full",60236),screenNormal:(0,n.register)("screen-normal",60237),searchStop:(0,n.register)("search-stop",60238),server:(0,n.register)("server",60240),settingsGear:(0,n.register)("settings-gear",60241),settings:(0,n.register)("settings",60242),shield:(0,n.register)("shield",60243),smiley:(0,n.register)("smiley",60244),sortPrecedence:(0,n.register)("sort-precedence",60245),splitHorizontal:(0,n.register)("split-horizontal",60246),splitVertical:(0,n.register)("split-vertical",60247),squirrel:(0,n.register)("squirrel",60248),starFull:(0,n.register)("star-full",60249),starHalf:(0,n.register)("star-half",60250),symbolClass:(0,n.register)("symbol-class",60251),symbolColor:(0,n.register)("symbol-color",60252),symbolConstant:(0,n.register)("symbol-constant",60253),symbolEnumMember:(0,n.register)("symbol-enum-member",60254),symbolField:(0,n.register)("symbol-field",60255),symbolFile:(0,n.register)("symbol-file",60256),symbolInterface:(0,n.register)("symbol-interface",60257),symbolKeyword:(0,n.register)("symbol-keyword",60258),symbolMisc:(0,n.register)("symbol-misc",60259),symbolOperator:(0,n.register)("symbol-operator",60260),symbolProperty:(0,n.register)("symbol-property",60261),wrench:(0,n.register)("wrench",60261),wrenchSubaction:(0,n.register)("wrench-subaction",60261),symbolSnippet:(0,n.register)("symbol-snippet",60262),tasklist:(0,n.register)("tasklist",60263),telescope:(0,n.register)("telescope",60264),textSize:(0,n.register)("text-size",60265),threeBars:(0,n.register)("three-bars",60266),thumbsdown:(0,n.register)("thumbsdown",60267),thumbsup:(0,n.register)("thumbsup",60268),tools:(0,n.register)("tools",60269),triangleDown:(0,n.register)("triangle-down",60270),triangleLeft:(0,n.register)("triangle-left",60271),triangleRight:(0,n.register)("triangle-right",60272),triangleUp:(0,n.register)("triangle-up",60273),twitter:(0,n.register)("twitter",60274),unfold:(0,n.register)("unfold",60275),unlock:(0,n.register)("unlock",60276),unmute:(0,n.register)("unmute",60277),unverified:(0,n.register)("unverified",60278),verified:(0,n.register)("verified",60279),versions:(0,n.register)("versions",60280),vmActive:(0,n.register)("vm-active",60281),vmOutline:(0,n.register)("vm-outline",60282),vmRunning:(0,n.register)("vm-running",60283),watch:(0,n.register)("watch",60284),whitespace:(0,n.register)("whitespace",60285),wholeWord:(0,n.register)("whole-word",60286),window:(0,n.register)("window",60287),wordWrap:(0,n.register)("word-wrap",60288),zoomIn:(0,n.register)("zoom-in",60289),zoomOut:(0,n.register)("zoom-out",60290),listFilter:(0,n.register)("list-filter",60291),listFlat:(0,n.register)("list-flat",60292),listSelection:(0,n.register)("list-selection",60293),selection:(0,n.register)("selection",60293),listTree:(0,n.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.register)("debug-stackframe-active",60297),circleSmallFilled:(0,n.register)("circle-small-filled",60298),debugStackframeDot:(0,n.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.register)("terminal-decoration-mark",60298),debugStackframe:(0,n.register)("debug-stackframe",60299),debugStackframeFocused:(0,n.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.register)("debug-breakpoint-unsupported",60300),symbolString:(0,n.register)("symbol-string",60301),debugReverseContinue:(0,n.register)("debug-reverse-continue",60302),debugStepBack:(0,n.register)("debug-step-back",60303),debugRestartFrame:(0,n.register)("debug-restart-frame",60304),debugAlt:(0,n.register)("debug-alt",60305),callIncoming:(0,n.register)("call-incoming",60306),callOutgoing:(0,n.register)("call-outgoing",60307),menu:(0,n.register)("menu",60308),expandAll:(0,n.register)("expand-all",60309),feedback:(0,n.register)("feedback",60310),gitPullRequestReviewer:(0,n.register)("git-pull-request-reviewer",60310),groupByRefType:(0,n.register)("group-by-ref-type",60311),ungroupByRefType:(0,n.register)("ungroup-by-ref-type",60312),account:(0,n.register)("account",60313),gitPullRequestAssignee:(0,n.register)("git-pull-request-assignee",60313),bellDot:(0,n.register)("bell-dot",60314),debugConsole:(0,n.register)("debug-console",60315),library:(0,n.register)("library",60316),output:(0,n.register)("output",60317),runAll:(0,n.register)("run-all",60318),syncIgnored:(0,n.register)("sync-ignored",60319),pinned:(0,n.register)("pinned",60320),githubInverted:(0,n.register)("github-inverted",60321),serverProcess:(0,n.register)("server-process",60322),serverEnvironment:(0,n.register)("server-environment",60323),pass:(0,n.register)("pass",60324),issueClosed:(0,n.register)("issue-closed",60324),stopCircle:(0,n.register)("stop-circle",60325),playCircle:(0,n.register)("play-circle",60326),record:(0,n.register)("record",60327),debugAltSmall:(0,n.register)("debug-alt-small",60328),vmConnect:(0,n.register)("vm-connect",60329),cloud:(0,n.register)("cloud",60330),merge:(0,n.register)("merge",60331),export:(0,n.register)("export",60332),graphLeft:(0,n.register)("graph-left",60333),magnet:(0,n.register)("magnet",60334),notebook:(0,n.register)("notebook",60335),redo:(0,n.register)("redo",60336),checkAll:(0,n.register)("check-all",60337),pinnedDirty:(0,n.register)("pinned-dirty",60338),passFilled:(0,n.register)("pass-filled",60339),circleLargeFilled:(0,n.register)("circle-large-filled",60340),circleLarge:(0,n.register)("circle-large",60341),circleLargeOutline:(0,n.register)("circle-large-outline",60341),combine:(0,n.register)("combine",60342),gather:(0,n.register)("gather",60342),table:(0,n.register)("table",60343),variableGroup:(0,n.register)("variable-group",60344),typeHierarchy:(0,n.register)("type-hierarchy",60345),typeHierarchySub:(0,n.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.register)("git-pull-request-create",60348),runAbove:(0,n.register)("run-above",60349),runBelow:(0,n.register)("run-below",60350),notebookTemplate:(0,n.register)("notebook-template",60351),debugRerun:(0,n.register)("debug-rerun",60352),workspaceTrusted:(0,n.register)("workspace-trusted",60353),workspaceUntrusted:(0,n.register)("workspace-untrusted",60354),workspaceUnknown:(0,n.register)("workspace-unknown",60355),terminalCmd:(0,n.register)("terminal-cmd",60356),terminalDebian:(0,n.register)("terminal-debian",60357),terminalLinux:(0,n.register)("terminal-linux",60358),terminalPowershell:(0,n.register)("terminal-powershell",60359),terminalTmux:(0,n.register)("terminal-tmux",60360),terminalUbuntu:(0,n.register)("terminal-ubuntu",60361),terminalBash:(0,n.register)("terminal-bash",60362),arrowSwap:(0,n.register)("arrow-swap",60363),copy:(0,n.register)("copy",60364),personAdd:(0,n.register)("person-add",60365),filterFilled:(0,n.register)("filter-filled",60366),wand:(0,n.register)("wand",60367),debugLineByLine:(0,n.register)("debug-line-by-line",60368),inspect:(0,n.register)("inspect",60369),layers:(0,n.register)("layers",60370),layersDot:(0,n.register)("layers-dot",60371),layersActive:(0,n.register)("layers-active",60372),compass:(0,n.register)("compass",60373),compassDot:(0,n.register)("compass-dot",60374),compassActive:(0,n.register)("compass-active",60375),azure:(0,n.register)("azure",60376),issueDraft:(0,n.register)("issue-draft",60377),gitPullRequestClosed:(0,n.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.register)("git-pull-request-draft",60379),debugAll:(0,n.register)("debug-all",60380),debugCoverage:(0,n.register)("debug-coverage",60381),runErrors:(0,n.register)("run-errors",60382),folderLibrary:(0,n.register)("folder-library",60383),debugContinueSmall:(0,n.register)("debug-continue-small",60384),beakerStop:(0,n.register)("beaker-stop",60385),graphLine:(0,n.register)("graph-line",60386),graphScatter:(0,n.register)("graph-scatter",60387),pieChart:(0,n.register)("pie-chart",60388),bracket:(0,n.register)("bracket",60175),bracketDot:(0,n.register)("bracket-dot",60389),bracketError:(0,n.register)("bracket-error",60390),lockSmall:(0,n.register)("lock-small",60391),azureDevops:(0,n.register)("azure-devops",60392),verifiedFilled:(0,n.register)("verified-filled",60393),newline:(0,n.register)("newline",60394),layout:(0,n.register)("layout",60395),layoutActivitybarLeft:(0,n.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.register)("layout-panel-left",60398),layoutPanelCenter:(0,n.register)("layout-panel-center",60399),layoutPanelJustify:(0,n.register)("layout-panel-justify",60400),layoutPanelRight:(0,n.register)("layout-panel-right",60401),layoutPanel:(0,n.register)("layout-panel",60402),layoutSidebarLeft:(0,n.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.register)("layout-sidebar-right",60404),layoutStatusbar:(0,n.register)("layout-statusbar",60405),layoutMenubar:(0,n.register)("layout-menubar",60406),layoutCentered:(0,n.register)("layout-centered",60407),target:(0,n.register)("target",60408),indent:(0,n.register)("indent",60409),recordSmall:(0,n.register)("record-small",60410),errorSmall:(0,n.register)("error-small",60411),terminalDecorationError:(0,n.register)("terminal-decoration-error",60411),arrowCircleDown:(0,n.register)("arrow-circle-down",60412),arrowCircleLeft:(0,n.register)("arrow-circle-left",60413),arrowCircleRight:(0,n.register)("arrow-circle-right",60414),arrowCircleUp:(0,n.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.register)("layout-sidebar-left-off",60418),blank:(0,n.register)("blank",60419),heartFilled:(0,n.register)("heart-filled",60420),map:(0,n.register)("map",60421),mapHorizontal:(0,n.register)("map-horizontal",60421),foldHorizontal:(0,n.register)("fold-horizontal",60421),mapFilled:(0,n.register)("map-filled",60422),mapHorizontalFilled:(0,n.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.register)("fold-horizontal-filled",60422),circleSmall:(0,n.register)("circle-small",60423),bellSlash:(0,n.register)("bell-slash",60424),bellSlashDot:(0,n.register)("bell-slash-dot",60425),commentUnresolved:(0,n.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.register)("search-fuzzy",60429),commentDraft:(0,n.register)("comment-draft",60430),send:(0,n.register)("send",60431),sparkle:(0,n.register)("sparkle",60432),insert:(0,n.register)("insert",60433),mic:(0,n.register)("mic",60434),thumbsdownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsupFilled:(0,n.register)("thumbsup-filled",60436),coffee:(0,n.register)("coffee",60437),snake:(0,n.register)("snake",60438),game:(0,n.register)("game",60439),vr:(0,n.register)("vr",60440),chip:(0,n.register)("chip",60441),piano:(0,n.register)("piano",60442),music:(0,n.register)("music",60443),micFilled:(0,n.register)("mic-filled",60444),repoFetch:(0,n.register)("repo-fetch",60445),copilot:(0,n.register)("copilot",60446),lightbulbSparkle:(0,n.register)("lightbulb-sparkle",60447),robot:(0,n.register)("robot",60448),sparkleFilled:(0,n.register)("sparkle-filled",60449),diffSingle:(0,n.register)("diff-single",60450),diffMultiple:(0,n.register)("diff-multiple",60451),surroundWith:(0,n.register)("surround-with",60452),share:(0,n.register)("share",60453),gitStash:(0,n.register)("git-stash",60454),gitStashApply:(0,n.register)("git-stash-apply",60455),gitStashPop:(0,n.register)("git-stash-pop",60456),vscode:(0,n.register)("vscode",60457),vscodeInsiders:(0,n.register)("vscode-insiders",60458),codeOss:(0,n.register)("code-oss",60459),runCoverage:(0,n.register)("run-coverage",60460),runAllCoverage:(0,n.register)("run-all-coverage",60461),coverage:(0,n.register)("coverage",60462),githubProject:(0,n.register)("github-project",60463),mapVertical:(0,n.register)("map-vertical",60464),foldVertical:(0,n.register)("fold-vertical",60464),mapVerticalFilled:(0,n.register)("map-vertical-filled",60465),foldVerticalFilled:(0,n.register)("fold-vertical-filled",60465)}}),define(oe[75],ae([0,1,105,145]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=I;function I(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,n.register)("dialog-error","error"),dialogWarning:(0,n.register)("dialog-warning","warning"),dialogInfo:(0,n.register)("dialog-info","info"),dialogClose:(0,n.register)("dialog-close","close"),treeItemExpanded:(0,n.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.register)("tree-filter-clear","close"),treeItemLoading:(0,n.register)("tree-item-loading","loading"),menuSelection:(0,n.register)("menu-selection","check"),menuSubmenu:(0,n.register)("menu-submenu","chevron-right"),menuBarMore:(0,n.register)("menubar-more","more"),scrollbarButtonLeft:(0,n.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.register)("toolbar-more","more"),quickInputBack:(0,n.register)("quick-input-back","arrow-left"),dropDownButton:(0,n.register)("drop-down-button",60084),symbolCustomColor:(0,n.register)("symbol-customcolor",60252),exportIcon:(0,n.register)("export",60332),workspaceUnspecified:(0,n.register)("workspace-unspecified",60355),newLine:(0,n.register)("newline",60394),thumbsDownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.register)("thumbsup-filled",60436),gitFetch:(0,n.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.register)("debug-breakpoint-pending",60377)},e.Codicon={...D.codiconsLibrary,...e.codiconsDerived}}),define(oe[35],ae([0,1,12]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=D,e.deepFreeze=I,e.cloneAndChange=C,e.mixin=h,e.equals=l,e.safeStringify=v,e.distinct=y,e.getCaseInsensitive=E,e.filter=g,e.getAllPropertyNames=m,e.getAllMethodNames=b,e.createProxyObject=w;function D(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([c,f])=>{d[c]=f&&typeof f=="object"?D(f):f}),d}function I(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const c=d.shift();Object.freeze(c);for(const f in c)if(O.call(c,f)){const a=c[f];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.isTypedArray)(a)&&d.push(a)}}return p}const O=Object.prototype.hasOwnProperty;function C(p,d){return P(p,d,new Set)}function P(p,d,c){if((0,n.isUndefinedOrNull)(p))return p;const f=d(p);if(typeof f<"u")return f;if(Array.isArray(p)){const a=[];for(const t of p)a.push(P(t,d,c));return a}if((0,n.isObject)(p)){if(c.has(p))throw new Error("Cannot clone recursive data-structure");c.add(p);const a={};for(const t in p)O.call(p,t)&&(a[t]=P(p[t],d,c));return c.delete(p),a}return p}function h(p,d,c=!0){return(0,n.isObject)(p)?((0,n.isObject)(d)&&Object.keys(d).forEach(f=>{f in p?c&&((0,n.isObject)(p[f])&&(0,n.isObject)(d[f])?h(p[f],d[f],c):p[f]=d[f]):p[f]=d[f]}),p):d}function l(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let c,f;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(c=0;c<p.length;c++)if(!l(p[c],d[c]))return!1}else{const a=[];for(f in p)a.push(f);a.sort();const t=[];for(f in d)t.push(f);if(t.sort(),!l(a,t))return!1;for(c=0;c<a.length;c++)if(!l(p[a[c]],d[a[c]]))return!1}return!0}function v(p){const d=new Set;return JSON.stringify(p,(c,f)=>{if((0,n.isObject)(f)||Array.isArray(f)){if(d.has(f))return"[Circular]";d.add(f)}return f})}function y(p,d){const c=Object.create(null);return!p||!d||Object.keys(d).forEach(a=>{const t=p[a],o=d[a];l(t,o)||(c[a]=o)}),c}function E(p,d){const c=d.toLowerCase(),f=Object.keys(p).find(a=>a.toLowerCase()===c);return f?p[f]:p[d]}function g(p,d){const c=Object.create(null);for(const[f,a]of Object.entries(p))d(f,a)&&(c[f]=a);return c}function m(p){let d=[];for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}function b(p){const d=[];for(const c of m(p))typeof p[c]=="function"&&d.push(c);return d}function w(p,d){const c=a=>function(){const t=Array.prototype.slice.call(arguments,0);return d(a,t)},f={};for(const a of p)f[a]=c(a);return f}}),define(oe[106],ae([0,1,75]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=I;var D;(function(C){function P(h){return h&&typeof h=="object"&&typeof h.id=="string"}C.isThemeColor=P})(D||(e.ThemeColor=D={}));function I(C){return{id:C}}var O;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function h(d){const c=P.exec(d.id);if(!c)return h(n.Codicon.error);const[,f,a]=c,t=["codicon","codicon-"+f];return a&&t.push("codicon-modifier-"+a.substring(1)),t}C.asClassNameArray=h;function l(d){return h(d).join(" ")}C.asClassName=l;function v(d){return"."+h(d).join(".")}C.asCSSSelector=v;function y(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||D.isThemeColor(d.color))}C.isThemeIcon=y;const E=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function g(d){const c=E.exec(d);if(!c)return;const[,f]=c;return{id:f}}C.fromString=g;function m(d){return{id:d}}C.fromId=m;function b(d,c){let f=d.id;const a=f.lastIndexOf("~");return a!==-1&&(f=f.substring(0,a)),c&&(f=`${f}~${c}`),{id:f}}C.modify=b;function w(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}C.getModifier=w;function p(d,c){return d.id===c.id&&d.color?.id===c.color?.id}C.isEqual=p})(O||(e.ThemeIcon=O={}))}),define(oe[33],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=D;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(I){return n.test(I)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const O=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){I(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let h=0,l="";return l+=C[O[h++]],l+=C[O[h++]],l+=C[O[h++]],l+=C[O[h++]],l+="-",l+=C[O[h++]],l+=C[O[h++]],l+="-",l+=C[O[h++]],l+=C[O[h++]],l+="-",l+=C[O[h++]],l+=C[O[h++]],l+="-",l+=C[O[h++]],l+=C[O[h++]],l+=C[O[h++]],l+=C[O[h++]],l+=C[O[h++]],l+=C[O[h++]],l}}()}),define(oe[146],ae([0,1,87,43,86]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=O;async function O(C,P){if(await new Promise((v,y)=>{const E=D.createReadStream(C),g=n.createHash("sha256");E.pipe(g);const m=(0,I.createSingleCallFunction)((b,w)=>{E.removeAllListeners(),g.removeAllListeners(),b?y(b):v(w)});E.once("error",m),E.once("end",m),g.once("error",m),g.once("data",b=>m(void 0,b.toString("hex")))})!==P)throw new Error("Hash mismatch")}}),define(oe[147],ae([0,1,26]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=O;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(C){const P=C.replace(/\-/g,":").toLowerCase();return!D.has(P)}function O(){const C=(0,n.networkInterfaces)();for(const P in C){const h=C[P];if(h){for(const{mac:l}of h)if(I(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[107],ae([0,1,88]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=D,e.findFreePortFaster=O;function D(P,h,l,v=1){let y=!1;return new Promise(E=>{const g=setTimeout(()=>{if(!y)return y=!0,E(0)},l);I(P,h,v,m=>{if(!y)return y=!0,clearTimeout(g),E(m)})})}function I(P,h,l,v){if(h===0)return v(0);const y=new n.Socket;y.once("connect",()=>(C(y),I(P+l,h-1,l,v))),y.once("data",()=>{}),y.once("error",E=>(C(y),E.code!=="ECONNREFUSED"?I(P+l,h-1,l,v):v(P))),y.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(P,h,l,v="127.0.0.1"){let y=!1,E,g=1;const m=n.createServer({pauseOnConnect:!0});function b(w,p){y||(y=!0,m.removeAllListeners(),m.close(),E&&clearTimeout(E),p(w))}return new Promise(w=>{E=setTimeout(()=>{b(0,w)},l),m.on("listening",()=>{b(P,w)}),m.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&g<h?(P++,g++,m.listen(P,v)):b(0,w)}),m.on("close",()=>{b(0,w)}),m.listen(P,v)})}function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(h){console.error(h)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function n(h){const l=new Set;if(Array.isArray(h))for(const v of h)typeof v=="string"&&l.add(v);return Array.from(l)}function D(){const h=e();return h?Array.from(h):[]}function I(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const v of n(h))I(v)}function O(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let v;for(const y of l){if(h.indexOf(y)!==0)continue;const g=h.indexOf("\\",y.length);if(g===-1)continue;const m=h.substring(y.length,g);if(m){v=m;break}}return v}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:D,addUNCHostToAllowlist:I,getUNCHost:O,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[148],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(oe[149],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class n{constructor(I,O){this.sender=I,this.onMessage=O}send(I){try{this.sender.send("vscode:message",I.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=n}),define(oe[150],ae([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[151],ae([0,1,150]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=l,e.getDurationString=v,e.toLocalISOString=y;const D=60,I=D*60,O=I*24,C=O*7,P=O*30,h=O*365;function l(E,g,m,b){typeof E!="number"&&(E=E.getTime());const w=Math.round((new Date().getTime()-E)/1e3);if(w<-30)return(0,n.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!b&&w<30)return(0,n.localize)(1,null);let p;return w<D?(p=w,g?p===1?m?(0,n.localize)(2,null,p):(0,n.localize)(3,null,p):m?(0,n.localize)(4,null,p):(0,n.localize)(5,null,p):p===1?m?(0,n.localize)(6,null,p):(0,n.localize)(7,null,p):m?(0,n.localize)(8,null,p):(0,n.localize)(9,null,p)):w<I?(p=Math.floor(w/D),g?p===1?m?(0,n.localize)(10,null,p):(0,n.localize)(11,null,p):m?(0,n.localize)(12,null,p):(0,n.localize)(13,null,p):p===1?m?(0,n.localize)(14,null,p):(0,n.localize)(15,null,p):m?(0,n.localize)(16,null,p):(0,n.localize)(17,null,p)):w<O?(p=Math.floor(w/I),g?p===1?m?(0,n.localize)(18,null,p):(0,n.localize)(19,null,p):m?(0,n.localize)(20,null,p):(0,n.localize)(21,null,p):p===1?m?(0,n.localize)(22,null,p):(0,n.localize)(23,null,p):m?(0,n.localize)(24,null,p):(0,n.localize)(25,null,p)):w<C?(p=Math.floor(w/O),g?p===1?(0,n.localize)(26,null,p):(0,n.localize)(27,null,p):p===1?(0,n.localize)(28,null,p):(0,n.localize)(29,null,p)):w<P?(p=Math.floor(w/C),g?p===1?m?(0,n.localize)(30,null,p):(0,n.localize)(31,null,p):m?(0,n.localize)(32,null,p):(0,n.localize)(33,null,p):p===1?m?(0,n.localize)(34,null,p):(0,n.localize)(35,null,p):m?(0,n.localize)(36,null,p):(0,n.localize)(37,null,p)):w<h?(p=Math.floor(w/P),g?p===1?m?(0,n.localize)(38,null,p):(0,n.localize)(39,null,p):m?(0,n.localize)(40,null,p):(0,n.localize)(41,null,p):p===1?m?(0,n.localize)(42,null,p):(0,n.localize)(43,null,p):m?(0,n.localize)(44,null,p):(0,n.localize)(45,null,p)):(p=Math.floor(w/h),g?p===1?m?(0,n.localize)(46,null,p):(0,n.localize)(47,null,p):m?(0,n.localize)(48,null,p):(0,n.localize)(49,null,p):p===1?m?(0,n.localize)(50,null,p):(0,n.localize)(51,null,p):m?(0,n.localize)(52,null,p):(0,n.localize)(53,null,p))}function v(E,g){const m=Math.abs(E/1e3);return m<1?g?(0,n.localize)(54,null,E):(0,n.localize)(55,null,E):m<D?g?(0,n.localize)(56,null,Math.round(E)/1e3):(0,n.localize)(57,null,Math.round(E)/1e3):m<I?g?(0,n.localize)(58,null,Math.round(E/(1e3*D))):(0,n.localize)(59,null,Math.round(E/(1e3*D))):m<O?g?(0,n.localize)(60,null,Math.round(E/(1e3*I))):(0,n.localize)(61,null,Math.round(E/(1e3*I))):(0,n.localize)(62,null,Math.round(E/(1e3*O)))}function y(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[152],ae([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[47],ae([0,1,22,12,152]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=h,e.isErrorWithActions=l,e.createErrorWithActions=v;function O(y,E){return E&&(y.stack||y.stacktrace)?I.localize(0,null,P(y),C(y.stack)||C(y.stacktrace)):P(y)}function C(y){return Array.isArray(y)?y.join(`
`):y}function P(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?I.localize(1,null,y.message):y.message||I.localize(2,null)}function h(y=null,E=!1){if(!y)return I.localize(3,null);if(Array.isArray(y)){const g=n.coalesce(y),m=h(g[0],E);return g.length>1?I.localize(4,null,m,g.length):m}if(D.isString(y))return y;if(y.detail){const g=y.detail;if(g.error)return O(g.error,E);if(g.exception)return O(g.exception,E)}return y.stack?O(y,E):y.message?y.message:I.localize(5,null)}function l(y){const E=y;return E instanceof Error&&Array.isArray(E.actions)}function v(y,E){let g;return typeof y=="string"?g=new Error(y):g=y,g.actions=E,g}}),define(oe[153],ae([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[154],ae([0,1,153]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=D;function D(I){switch(I){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(oe[155],ae([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,155]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=o,e.isLittleEndian=k,e.isBigSurOrNewer=M,e.LANGUAGE_DEFAULT="en";let D=!1,I=!1,O=!1,C=!1,P=!1,h=!1,l=!1,v=!1,y=!1,E=!1,g,m=e.LANGUAGE_DEFAULT,b=e.LANGUAGE_DEFAULT,w,p;const d=globalThis;let c;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?c=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(c=process);const f=typeof c?.versions?.electron=="string",a=f&&c?.type==="renderer";if(typeof c=="object"){D=c.platform==="win32",I=c.platform==="darwin",O=c.platform==="linux",C=O&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,l=f,y=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const L=c.env.VSCODE_NLS_CONFIG;if(L)try{const R=JSON.parse(L),A=R.availableLanguages["*"];g=R.locale,b=R.osLocale,m=A||e.LANGUAGE_DEFAULT,w=R._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!a?(p=navigator.userAgent,D=p.indexOf("Windows")>=0,I=p.indexOf("Macintosh")>=0,v=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=p.indexOf("Linux")>=0,E=p?.indexOf("Mobi")>=0,h=!0,g=n.getConfiguredDefaultLocale(n.localize(0,null))||e.LANGUAGE_DEFAULT,m=g,b=navigator.language):console.error("Unable to resolve platform.");var t;(function(L){L[L.Web=0]="Web",L[L.Mac=1]="Mac",L[L.Linux=2]="Linux",L[L.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(L){switch(L){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;I?s=1:D?s=3:O&&(s=2),e.isWindows=D,e.isMacintosh=I,e.isLinux=O,e.isLinuxSnap=C,e.isNative=P,e.isElectron=l,e.isWeb=h,e.isWebWorker=h&&typeof d.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?d.origin:void 0,e.isIOS=v,e.isMobile=E,e.isCI=y,e.platform=s,e.userAgent=p,e.language=m;var i;(function(L){function R(){return e.language}L.value=R;function A(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}L.isDefaultVariant=A;function F(){return e.language==="en"}L.isDefault=F})(i||(e.Language=i={})),e.locale=g,e.platformLocale=b,e.translationsConfigFile=w,e.setTimeout0IsFaster=typeof d.postMessage=="function"&&!d.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const L=[];d.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let F=0,_=L.length;F<_;F++){const z=L[F];if(z.id===A.data.vscodeScheduleAsyncWork){L.splice(F,1),z.callback();return}}});let R=0;return A=>{const F=++R;L.push({id:F,callback:A}),d.postMessage({vscodeScheduleAsyncWork:F},"*")}}return L=>setTimeout(L)})();var r;(function(L){L[L.Windows=1]="Windows",L[L.Macintosh=2]="Macintosh",L[L.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=I||v?2:D?1:3;let u=!0,S=!1;function k(){if(!S){S=!0;const L=new Uint8Array(2);L[0]=1,L[1]=2,u=new Uint16Array(L.buffer)[0]===513}return u}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function M(L){return parseFloat(L)>=20}}),define(oe[36],ae([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let D;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.process<"u"){const O=I.process;D={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.arch=D.arch}),define(oe[9],ae([0,1,36]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,I=97,O=90,C=122,P=46,h=47,l=92,v=58,y=63;class E extends Error{constructor(o,s,i){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const u=o.indexOf(".")!==-1?"property":"argument";let S=`The "${o}" ${u} ${r} of type ${s}`;S+=`. Received type ${typeof i}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,o){if(t===null||typeof t!="object")throw new E(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new E(o,"string",t)}const b=n.platform==="win32";function w(t){return t===h||t===l}function p(t){return t===h}function d(t){return t>=D&&t<=O||t>=I&&t<=C}function c(t,o,s,i){let r="",u=0,S=-1,k=0,M=0;for(let L=0;L<=t.length;++L){if(L<t.length)M=t.charCodeAt(L);else{if(i(M))break;M=h}if(i(M)){if(!(S===L-1||k===1))if(k===2){if(r.length<2||u!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const R=r.lastIndexOf(s);R===-1?(r="",u=0):(r=r.slice(0,R),u=r.length-1-r.lastIndexOf(s)),S=L,k=0;continue}else if(r.length!==0){r="",u=0,S=L,k=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",u=2)}else r.length>0?r+=`${s}${t.slice(S+1,L)}`:r=t.slice(S+1,L),u=L-S-1;S=L,k=0}else M===P&&k!==-1?++k:k=-1}return r}function f(t,o){g(o,"pathObject");const s=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let o="",s="",i=!1;for(let r=t.length-1;r>=-1;r--){let u;if(r>=0){if(u=t[r],m(u,"path"),u.length===0)continue}else o.length===0?u=n.cwd():(u=n.env[`=${o}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==o.toLowerCase()&&u.charCodeAt(2)===l)&&(u=`${o}\\`));const S=u.length;let k=0,M="",L=!1;const R=u.charCodeAt(0);if(S===1)w(R)&&(k=1,L=!0);else if(w(R))if(L=!0,w(u.charCodeAt(1))){let A=2,F=A;for(;A<S&&!w(u.charCodeAt(A));)A++;if(A<S&&A!==F){const _=u.slice(F,A);for(F=A;A<S&&w(u.charCodeAt(A));)A++;if(A<S&&A!==F){for(F=A;A<S&&!w(u.charCodeAt(A));)A++;(A===S||A!==F)&&(M=`\\\\${_}\\${u.slice(F,A)}`,k=A)}}}else k=1;else d(R)&&u.charCodeAt(1)===v&&(M=u.slice(0,2),k=2,S>2&&w(u.charCodeAt(2))&&(L=!0,k=3));if(M.length>0)if(o.length>0){if(M.toLowerCase()!==o.toLowerCase())continue}else o=M;if(i){if(o.length>0)break}else if(s=`${u.slice(k)}\\${s}`,i=L,L&&o.length>0)break}return s=c(s,!i,"\\",w),i?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let s=0,i,r=!1;const u=t.charCodeAt(0);if(o===1)return p(u)?"\\":t;if(w(u))if(r=!0,w(t.charCodeAt(1))){let k=2,M=k;for(;k<o&&!w(t.charCodeAt(k));)k++;if(k<o&&k!==M){const L=t.slice(M,k);for(M=k;k<o&&w(t.charCodeAt(k));)k++;if(k<o&&k!==M){for(M=k;k<o&&!w(t.charCodeAt(k));)k++;if(k===o)return`\\\\${L}\\${t.slice(M)}\\`;k!==M&&(i=`\\\\${L}\\${t.slice(M,k)}`,s=k)}}}else s=1;else d(u)&&t.charCodeAt(1)===v&&(i=t.slice(0,2),s=2,o>2&&w(t.charCodeAt(2))&&(r=!0,s=3));let S=s<o?c(t.slice(s),!r,"\\",w):"";return S.length===0&&!r&&(S="."),S.length>0&&w(t.charCodeAt(o-1))&&(S+="\\"),i===void 0?r?`\\${S}`:S:r?`${i}\\${S}`:`${i}${S}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return w(s)||o>2&&d(s)&&t.charCodeAt(1)===v&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let u=0;u<t.length;++u){const S=t[u];m(S,"path"),S.length>0&&(o===void 0?o=s=S:o+=`\\${S}`)}if(o===void 0)return".";let i=!0,r=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++r;const u=s.length;u>1&&w(s.charCodeAt(1))&&(++r,u>2&&(w(s.charCodeAt(2))?++r:i=!1))}if(i){for(;r<o.length&&w(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const s=e.win32.resolve(t),i=e.win32.resolve(o);if(s===i||(t=s.toLowerCase(),o=i.toLowerCase(),t===o))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===l;)r++;let u=t.length;for(;u-1>r&&t.charCodeAt(u-1)===l;)u--;const S=u-r;let k=0;for(;k<o.length&&o.charCodeAt(k)===l;)k++;let M=o.length;for(;M-1>k&&o.charCodeAt(M-1)===l;)M--;const L=M-k,R=S<L?S:L;let A=-1,F=0;for(;F<R;F++){const z=t.charCodeAt(r+F);if(z!==o.charCodeAt(k+F))break;z===l&&(A=F)}if(F!==R){if(A===-1)return i}else{if(L>R){if(o.charCodeAt(k+F)===l)return i.slice(k+F+1);if(F===2)return i.slice(k+F)}S>R&&(t.charCodeAt(r+F)===l?A=F:F===2&&(A=3)),A===-1&&(A=0)}let _="";for(F=r+A+1;F<=u;++F)(F===u||t.charCodeAt(F)===l)&&(_+=_.length===0?"..":"\\..");return k+=A,_.length>0?`${_}${i.slice(k,M)}`:(i.charCodeAt(k)===l&&++k,i.slice(k,M))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.win32.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const s=o.charCodeAt(2);if(s!==y&&s!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===v&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let s=-1,i=0;const r=t.charCodeAt(0);if(o===1)return w(r)?t:".";if(w(r)){if(s=i=1,w(t.charCodeAt(1))){let k=2,M=k;for(;k<o&&!w(t.charCodeAt(k));)k++;if(k<o&&k!==M){for(M=k;k<o&&w(t.charCodeAt(k));)k++;if(k<o&&k!==M){for(M=k;k<o&&!w(t.charCodeAt(k));)k++;if(k===o)return t;k!==M&&(s=i=k+1)}}}}else d(r)&&t.charCodeAt(1)===v&&(s=o>2&&w(t.charCodeAt(2))?3:2,i=s);let u=-1,S=!0;for(let k=o-1;k>=i;--k)if(w(t.charCodeAt(k))){if(!S){u=k;break}}else S=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let s=0,i=-1,r=!0,u;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===v&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let S=o.length-1,k=-1;for(u=t.length-1;u>=s;--u){const M=t.charCodeAt(u);if(w(M)){if(!r){s=u+1;break}}else k===-1&&(r=!1,k=u+1),S>=0&&(M===o.charCodeAt(S)?--S===-1&&(i=u):(S=-1,i=k))}return s===i?i=k:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=s;--u)if(w(t.charCodeAt(u))){if(!r){s=u+1;break}}else i===-1&&(r=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){m(t,"path");let o=0,s=-1,i=0,r=-1,u=!0,S=0;t.length>=2&&t.charCodeAt(1)===v&&d(t.charCodeAt(0))&&(o=i=2);for(let k=t.length-1;k>=o;--k){const M=t.charCodeAt(k);if(w(M)){if(!u){i=k+1;break}continue}r===-1&&(u=!1,r=k+1),M===P?s===-1?s=k:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||r===-1||S===0||S===1&&s===r-1&&s===i+1?"":t.slice(s,r)},format:f.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let i=0,r=t.charCodeAt(0);if(s===1)return w(r)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(w(r)){if(i=1,w(t.charCodeAt(1))){let A=2,F=A;for(;A<s&&!w(t.charCodeAt(A));)A++;if(A<s&&A!==F){for(F=A;A<s&&w(t.charCodeAt(A));)A++;if(A<s&&A!==F){for(F=A;A<s&&!w(t.charCodeAt(A));)A++;A===s?i=A:A!==F&&(i=A+1)}}}}else if(d(r)&&t.charCodeAt(1)===v){if(s<=2)return o.root=o.dir=t,o;if(i=2,w(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let u=-1,S=i,k=-1,M=!0,L=t.length-1,R=0;for(;L>=i;--L){if(r=t.charCodeAt(L),w(r)){if(!M){S=L+1;break}continue}k===-1&&(M=!1,k=L+1),r===P?u===-1?u=L:R!==1&&(R=1):u!==-1&&(R=-1)}return k!==-1&&(u===-1||R===0||R===1&&u===k-1&&u===S+1?o.base=o.name=t.slice(S,k):(o.name=t.slice(S,u),o.base=t.slice(S,k),o.ext=t.slice(u,k))),S>0&&S!==i?o.dir=t.slice(0,S-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(b){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.posix={resolve(...t){let o="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const r=i>=0?t[i]:a();m(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===h)}return o=c(o,!s,"/",p),s?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=c(t,!o,"/",p),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const i=t[s];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.posix.resolve(t),o=e.posix.resolve(o),t===o))return"";const s=1,i=t.length,r=i-s,u=1,S=o.length-u,k=r<S?r:S;let M=-1,L=0;for(;L<k;L++){const A=t.charCodeAt(s+L);if(A!==o.charCodeAt(u+L))break;A===h&&(M=L)}if(L===k)if(S>k){if(o.charCodeAt(u+L)===h)return o.slice(u+L+1);if(L===0)return o.slice(u+L)}else r>k&&(t.charCodeAt(s+L)===h?M=L:L===0&&(M=0));let R="";for(L=s+M+1;L<=i;++L)(L===i||t.charCodeAt(L)===h)&&(R+=R.length===0?"..":"/..");return`${R}${o.slice(u+M)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let s=-1,i=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===h){if(!i){s=r;break}}else i=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let s=0,i=-1,r=!0,u;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let S=o.length-1,k=-1;for(u=t.length-1;u>=0;--u){const M=t.charCodeAt(u);if(M===h){if(!r){s=u+1;break}}else k===-1&&(r=!1,k=u+1),S>=0&&(M===o.charCodeAt(S)?--S===-1&&(i=u):(S=-1,i=k))}return s===i?i=k:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!r){s=u+1;break}}else i===-1&&(r=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){m(t,"path");let o=-1,s=0,i=-1,r=!0,u=0;for(let S=t.length-1;S>=0;--S){const k=t.charCodeAt(S);if(k===h){if(!r){s=S+1;break}continue}i===-1&&(r=!1,i=S+1),k===P?o===-1?o=S:u!==1&&(u=1):o!==-1&&(u=-1)}return o===-1||i===-1||u===0||u===1&&o===i-1&&o===s+1?"":t.slice(o,i)},format:f.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===h;let i;s?(o.root="/",i=1):i=0;let r=-1,u=0,S=-1,k=!0,M=t.length-1,L=0;for(;M>=i;--M){const R=t.charCodeAt(M);if(R===h){if(!k){u=M+1;break}continue}S===-1&&(k=!1,S=M+1),R===P?r===-1?r=M:L!==1&&(L=1):r!==-1&&(L=-1)}if(S!==-1){const R=u===0&&s?1:u;r===-1||L===0||L===1&&r===S-1&&r===u+1?o.base=o.name=t.slice(R,S):(o.name=t.slice(R,r),o.base=t.slice(R,S),o.ext=t.slice(r,S))}return u>0?o.dir=t.slice(0,u-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(oe[31],ae([0,1,9,4,25,12]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=C,e.toSlashes=P,e.toPosixPath=h,e.getRoot=l,e.isUNC=v,e.isValidBasename=m,e.isEqual=b,e.isEqualOrParent=w,e.isWindowsDriveLetter=p,e.sanitizeFilePath=d,e.isRootOrDriveLetter=c,e.hasDriveLetter=f,e.getDriveLetter=a,e.indexOfPath=t,e.parseLineAndColumnAware=o,e.randomPath=r;function C(u){return u===47||u===92}function P(u){return u.replace(/[\\/]/g,n.posix.sep)}function h(u){return u.indexOf("/")===-1&&(u=P(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function l(u,S=n.posix.sep){if(!u)return"";const k=u.length,M=u.charCodeAt(0);if(C(M)){if(C(u.charCodeAt(1))&&!C(u.charCodeAt(2))){let R=3;const A=R;for(;R<k&&!C(u.charCodeAt(R));R++);if(A!==R&&!C(u.charCodeAt(R+1))){for(R+=1;R<k;R++)if(C(u.charCodeAt(R)))return u.slice(0,R+1).replace(/[\\/]/g,S)}}return S}else if(p(M)&&u.charCodeAt(1)===58)return C(u.charCodeAt(2))?u.slice(0,2)+S:u.slice(0,2);let L=u.indexOf("://");if(L!==-1){for(L+=3;L<k;L++)if(C(u.charCodeAt(L)))return u.slice(0,L+1)}return""}function v(u){if(!D.isWindows||!u||u.length<5)return!1;let S=u.charCodeAt(0);if(S!==92||(S=u.charCodeAt(1),S!==92))return!1;let k=2;const M=k;for(;k<u.length&&(S=u.charCodeAt(k),S!==92);k++);return!(M===k||(S=u.charCodeAt(k+1),isNaN(S)||S===92))}const y=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(u,S=D.isWindows){const k=S?y:E;return!(!u||u.length===0||/^\s+$/.test(u)||(k.lastIndex=0,k.test(u))||S&&g.test(u)||u==="."||u===".."||S&&u[u.length-1]==="."||S&&u.length!==u.trim().length||u.length>255)}function b(u,S,k){const M=u===S;return!k||M?M:!u||!S?!1:(0,I.equalsIgnoreCase)(u,S)}function w(u,S,k,M=n.sep){if(u===S)return!0;if(!u||!S||S.length>u.length)return!1;if(k){if(!(0,I.startsWithIgnoreCase)(u,S))return!1;if(S.length===u.length)return!0;let R=S.length;return S.charAt(S.length-1)===M&&R--,u.charAt(R)===M}return S.charAt(S.length-1)!==M&&(S+=M),u.indexOf(S)===0}function p(u){return u>=65&&u<=90||u>=97&&u<=122}function d(u,S){return D.isWindows&&u.endsWith(":")&&(u+=n.sep),(0,n.isAbsolute)(u)||(u=(0,n.join)(S,u)),u=(0,n.normalize)(u),D.isWindows?(u=(0,I.rtrim)(u,n.sep),u.endsWith(":")&&(u+=n.sep)):(u=(0,I.rtrim)(u,n.sep),u||(u=n.sep)),u}function c(u){const S=(0,n.normalize)(u);return D.isWindows?u.length>3?!1:f(S)&&(u.length===2||S.charCodeAt(2)===92):S===n.posix.sep}function f(u,S=D.isWindows){return S?p(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function a(u,S=D.isWindows){return f(u,S)?u[0]:void 0}function t(u,S,k){return S.length>u.length?-1:u===S?0:(k&&(u=u.toLowerCase(),S=S.toLowerCase()),u.indexOf(S))}function o(u){const S=u.split(":");let k,M,L;for(const R of S){const A=Number(R);(0,O.isNumber)(A)?M===void 0?M=A:L===void 0&&(L=A):k=k?[k,R].join(":"):R}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:M!==void 0?M:void 0,column:L!==void 0?L:M!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(u,S,k=8){let M="";for(let R=0;R<k;R++){let A;R===0&&D.isWindows&&!S&&(k===3||k===4)?A=i:A=s,M+=A.charAt(Math.floor(Math.random()*A.length))}let L;return S?L=`${S}-${M}`:L=M,u?(0,n.join)(u,L):L}}),define(oe[76],ae([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=O,e.removeDangerousEnvVariables=C;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function O(P,...h){const l=h.reduce((E,g)=>(E[g]=!0,E),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(E=>!l[E]).forEach(E=>{for(let g=0;g<v.length;g++)if(E.search(v[g])!==-1){delete P[E];break}})}function C(P){P&&(delete P.DEBUG,n.isMacintosh&&delete P.DYLD_LIBRARY_PATH,n.isLinux&&delete P.LD_PRELOAD)}}),define(oe[7],ae([0,1,9,4]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=m,e.uriToFsPath=f;const I=/^\w[\w\d+.-]*$/,O=/^\//,C=/^\/\//;function P(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!I.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!O.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,r){return!i&&!r?"file":i}function l(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==y&&(r=y+r):r=y;break}return r}const v="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,u,S,k,M,L=!1){typeof r=="object"?(this.scheme=r.scheme||v,this.authority=r.authority||v,this.path=r.path||v,this.query=r.query||v,this.fragment=r.fragment||v):(this.scheme=h(r,L),this.authority=u||v,this.path=l(this.scheme,S||v),this.query=k||v,this.fragment=M||v,P(this,L))}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:u,authority:S,path:k,query:M,fragment:L}=r;return u===void 0?u=this.scheme:u===null&&(u=v),S===void 0?S=this.authority:S===null&&(S=v),k===void 0?k=this.path:k===null&&(k=v),M===void 0?M=this.query:M===null&&(M=v),L===void 0?L=this.fragment:L===null&&(L=v),u===this.scheme&&S===this.authority&&k===this.path&&M===this.query&&L===this.fragment?this:new w(u,S,k,M,L)}static parse(r,u=!1){const S=E.exec(r);return S?new w(S[2]||v,s(S[4]||v),s(S[5]||v),s(S[7]||v),s(S[9]||v),u):new w(v,v,v,v,v)}static file(r){let u=v;if(D.isWindows&&(r=r.replace(/\\/g,y)),r[0]===y&&r[1]===y){const S=r.indexOf(y,2);S===-1?(u=r.substring(2),r=y):(u=r.substring(2,S),r=r.substring(S)||y)}return new w("file",u,r,v,v)}static from(r,u){return new w(r.scheme,r.authority,r.path,r.query,r.fragment,u)}static joinPath(r,...u){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return D.isWindows&&r.scheme==="file"?S=g.file(n.win32.join(f(r,!0),...u)).path:S=n.posix.join(r.path,...u),r.with({path:S})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const u=new w(r);return u._formatted=r.external??null,u._fsPath=r._sep===b?r.fsPath??null:null,u}}else return r}}e.URI=g;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const b=D.isWindows?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=b),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const p={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(i,r,u){let S,k=-1;for(let M=0;M<i.length;M++){const L=i.charCodeAt(M);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||r&&L===47||u&&L===91||u&&L===93||u&&L===58)k!==-1&&(S+=encodeURIComponent(i.substring(k,M)),k=-1),S!==void 0&&(S+=i.charAt(M));else{S===void 0&&(S=i.substr(0,M));const R=p[L];R!==void 0?(k!==-1&&(S+=encodeURIComponent(i.substring(k,M)),k=-1),S+=R):k===-1&&(k=M)}}return k!==-1&&(S+=encodeURIComponent(i.substring(k))),S!==void 0?S:i}function c(i){let r;for(let u=0;u<i.length;u++){const S=i.charCodeAt(u);S===35||S===63?(r===void 0&&(r=i.substr(0,u)),r+=p[S]):r!==void 0&&(r+=i[u])}return r!==void 0?r:i}function f(i,r){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,D.isWindows&&(u=u.replace(/\//g,"\\")),u}function a(i,r){const u=r?c:d;let S="",{scheme:k,authority:M,path:L,query:R,fragment:A}=i;if(k&&(S+=k,S+=":"),(M||k==="file")&&(S+=y,S+=y),M){let F=M.indexOf("@");if(F!==-1){const _=M.substr(0,F);M=M.substr(F+1),F=_.lastIndexOf(":"),F===-1?S+=u(_,!1,!1):(S+=u(_.substr(0,F),!1,!1),S+=":",S+=u(_.substr(F+1),!1,!0)),S+="@"}M=M.toLowerCase(),F=M.lastIndexOf(":"),F===-1?S+=u(M,!1,!0):(S+=u(M.substr(0,F),!1,!0),S+=M.substr(F))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const F=L.charCodeAt(1);F>=65&&F<=90&&(L=`/${String.fromCharCode(F+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const F=L.charCodeAt(0);F>=65&&F<=90&&(L=`${String.fromCharCode(F+32)}:${L.substr(2)}`)}S+=u(L,!0,!1)}return R&&(S+="?",S+=u(R,!1,!1)),A&&(S+="#",S+=r?A:d(A,!1,!1)),S}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(o)?i.replace(o,r=>t(r)):i}}),define(oe[156],ae([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=D,e.parse=I,e.getFirstFrame=O,e.log=P;function D(l){const v=l;return v&&typeof v.type=="string"&&typeof v.severity=="string"}function I(l){const v=[];let y;try{const E=JSON.parse(l.arguments),g=E[E.length-1];g&&g.__$stack&&(E.pop(),y=g.__$stack),v.push(...E)}catch{v.push("Unable to log remote console arguments",l.arguments)}return{args:v,stack:y}}function O(l){if(typeof l!="string")return O(I(l).stack);const v=l;if(v){const y=C(v),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:n.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}function C(l){if(!l)return l;const v=l.indexOf(`
`);return v===-1?l:l.substring(0,v)}function P(l,v){const{args:y,stack:E}=I(l),g=typeof y[0]=="string"&&y.length===1;let m=C(E);m&&(m=`(${m.trim()})`);let b=[];if(typeof y[0]=="string"?m&&g?b=[`%c[${v}] %c${y[0]} %c${m}`,h("blue"),h(""),h("grey")]:b=[`%c[${v}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:b=[`%c[${v}]%`,h("blue"),...y],m&&!g&&b.push(m),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,b)}function h(l){return`color: ${l}`}}),define(oe[77],ae([0,1,17,7]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=I,e.parse=O,e.revive=P;function I(h){return JSON.stringify(h,C)}function O(h){let l=JSON.parse(h);return l=P(l),l}function C(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function P(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let v=0;v<h.length;++v)h[v]=P(h[v],l+1);else for(const v in h)Object.hasOwnProperty.call(h,v)&&(h[v]=P(h[v],l+1))}return h}}),define(oe[13],ae([0,1,15,4,25,7,9]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=h,e.matchesSomeScheme=l,e.getServerRootPath=y;var P;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(P||(e.Schemas=P={}));function h(m,b){return O.URI.isUri(m)?(0,I.equalsIgnoreCase)(m.scheme,b):(0,I.startsWithIgnoreCase)(m,b+":")}function l(m,...b){return b.some(w=>h(m,w))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class v{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b,w){this._serverRootPath=y(b,w)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return C.posix.join(this._serverRootPath,P.vscodeRemoteResource)}set(b,w,p){this._hosts[b]=w,this._ports[b]=p}setConnectionToken(b,w){this._connectionTokens[b]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)try{return this._delegate(b)}catch(a){return n.onUnexpectedError(a),b}const w=b.authority;let p=this._hosts[w];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const d=this._ports[w],c=this._connectionTokens[w];let f=`path=${encodeURIComponent(b.path)}`;return typeof c=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(c)}`),O.URI.from({scheme:D.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${p}:${d}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new v;function y(m,b){return C.posix.join(b??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class E{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(b){const w=this.toUri(b,Q);return this.uriToBrowserUri(w)}uriToBrowserUri(b){return b.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===P.file&&(D.isNative||D.webWorkerOrigin===`${P.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?b.with({scheme:P.vscodeFileResource,authority:b.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(b){const w=this.toUri(b,Q);return this.uriToFileUri(w)}uriToFileUri(b){return b.scheme===P.vscodeFileResource?b.with({scheme:P.file,authority:b.authority!==E.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(b,w){return O.URI.isUri(b)?b:O.URI.parse(w.toUrl(b))}}e.FileAccess=new E;var g;(function(m){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(b.get("3"));const w="vscode-coi";function p(c){let f;typeof c=="string"?f=new URL(c).searchParams:c instanceof URL?f=c.searchParams:O.URI.isUri(c)&&(f=new URL(c.toString(!0)).searchParams);const a=f?.get(w);if(a)return b.get(a)}m.getHeadersFromQuery=p;function d(c,f,a){if(!globalThis.crossOriginIsolated)return;const t=f&&a?"3":a?"2":"1";c instanceof URLSearchParams?c.set(w,t):c[w]=t}m.addSearchParam=d})(g||(e.COI=g={}))}),define(oe[19],ae([0,1,31,13,9,4,25,7]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=h,e.distinctParents=v,e.toLocalResource=E;function h(g){return(0,P.uriToFsPath)(g,!0)}class l{constructor(m){this._ignorePathCasing=m}compare(m,b,w=!1){return m===b?0:(0,C.compare)(this.getComparisonKey(m,w),this.getComparisonKey(b,w))}isEqual(m,b,w=!1){return m===b?!0:!m||!b?!1:this.getComparisonKey(m,w)===this.getComparisonKey(b,w)}getComparisonKey(m,b=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,b,w=!1){if(m.scheme===b.scheme){if(m.scheme===D.Schemas.file)return n.isEqualOrParent(h(m),h(b),this._ignorePathCasing(m))&&m.query===b.query&&(w||m.fragment===b.fragment);if((0,e.isEqualAuthority)(m.authority,b.authority))return n.isEqualOrParent(m.path,b.path,this._ignorePathCasing(m),"/")&&m.query===b.query&&(w||m.fragment===b.fragment)}return!1}joinPath(m,...b){return P.URI.joinPath(m,...b)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return I.posix.basename(m.path)}extname(m){return I.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let b;return m.scheme===D.Schemas.file?b=P.URI.file(I.dirname(h(m))).path:(b=I.posix.dirname(m.path),m.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),b="/")),m.with({path:b})}normalizePath(m){if(!m.path.length)return m;let b;return m.scheme===D.Schemas.file?b=P.URI.file(I.normalize(h(m))).path:b=I.posix.normalize(m.path),m.with({path:b})}relativePath(m,b){if(m.scheme!==b.scheme||!(0,e.isEqualAuthority)(m.authority,b.authority))return;if(m.scheme===D.Schemas.file){const d=I.relative(h(m),h(b));return O.isWindows?n.toSlashes(d):d}let w=m.path||"/";const p=b.path||"/";if(this._ignorePathCasing(m)){let d=0;for(const c=Math.min(w.length,p.length);d<c&&!(w.charCodeAt(d)!==p.charCodeAt(d)&&w.charAt(d).toLowerCase()!==p.charAt(d).toLowerCase());d++);w=p.substr(0,d)+w.substr(d)}return I.posix.relative(w,p)}resolvePath(m,b){if(m.scheme===D.Schemas.file){const w=P.URI.file(I.resolve(h(m),b));return m.with({authority:w.authority,path:w.path})}return b=n.toPosixPath(b),m.with({path:I.posix.resolve(m.path,b)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,b){return m===b||m!==void 0&&b!==void 0&&(0,C.equalsIgnoreCase)(m,b)}hasTrailingPathSeparator(m,b=I.sep){if(m.scheme===D.Schemas.file){const w=h(m);return w.length>n.getRoot(w).length&&w[w.length-1]===b}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,b=I.sep){return(0,e.hasTrailingPathSeparator)(m,b)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,b=I.sep){let w=!1;if(m.scheme===D.Schemas.file){const p=h(m);w=p!==void 0&&p.length===n.getRoot(p).length&&p[p.length-1]===b}else{b="/";const p=m.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(m,b)?m.with({path:m.path+"/"}):m}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(g=>g.scheme===D.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new l(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(g,m){const b=[];for(let w=0;w<g.length;w++){const p=m(g[w]);g.some((d,c)=>c===w?!1:(0,e.isEqualOrParent)(p,m(d)))||b.push(g[w])}return b}var y;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function m(b){const w=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(c=>{const[f,a]=c.split(":");f&&a&&w.set(f,a)});const d=b.path.substring(0,b.path.indexOf(";"));return d&&w.set(g.META_DATA_MIME,d),w}g.parseMetaData=m})(y||(e.DataUri=y={}));function E(g,m,b){if(m){let w=g.path;return w&&w[0]!==I.posix.sep&&(w=I.posix.sep+w),g.with({scheme:b,authority:m,path:w})}return g.with({scheme:b})}}),define(oe[8],ae([0,1,23,15,3,2,19,4,144,62]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=v,e.createCancelablePromise=y,e.raceCancellation=E,e.raceCancellationError=g,e.raceCancellablePromises=m,e.raceTimeout=b,e.asPromise=w,e.promiseWithResolvers=p,e.timeout=u,e.disposableTimeout=S,e.sequence=k,e.first=M,e.firstParallel=L,e.retry=T,e.createCancelableAsyncIterable=G;function v(H){return!!H&&typeof H.then=="function"}function y(H){const $=new n.CancellationTokenSource,se=H($.token),ee=new Promise((de,pe)=>{const be=$.token.onCancellationRequested(()=>{be.dispose(),pe(new D.CancellationError)});Promise.resolve(se).then(Ee=>{be.dispose(),$.dispose(),de(Ee)},Ee=>{be.dispose(),$.dispose(),pe(Ee)})});return new class{cancel(){$.cancel(),$.dispose()}then(de,pe){return ee.then(de,pe)}catch(de){return this.then(void 0,de)}finally(de){return ee.finally(de)}}}function E(H,$,se){return new Promise((ee,de)=>{const pe=$.onCancellationRequested(()=>{pe.dispose(),ee(se)});H.then(ee,de).finally(()=>pe.dispose())})}function g(H,$){return new Promise((se,ee)=>{const de=$.onCancellationRequested(()=>{de.dispose(),ee(new D.CancellationError)});H.then(se,ee).finally(()=>de.dispose())})}async function m(H){let $=-1;const se=H.map((ee,de)=>ee.then(pe=>($=de,pe)));try{return await Promise.race(se)}finally{H.forEach((ee,de)=>{de!==$&&ee.cancel()})}}function b(H,$,se){let ee;const de=setTimeout(()=>{ee?.(void 0),se?.()},$);return Promise.race([H.finally(()=>clearTimeout(de)),new Promise(pe=>ee=pe)])}function w(H){return new Promise(($,se)=>{const ee=H();v(ee)?ee.then($,se):$(ee)})}function p(){let H,$;return{promise:new Promise((ee,de)=>{H=ee,$=de}),resolve:H,reject:$}}class d{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const se=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ee=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ee};this.queuedPromise=new Promise(ee=>{this.activePromise.then(se,se).then(ee)})}return new Promise((se,ee)=>{this.queuedPromise.then(se,ee)})}return this.activePromise=$(),new Promise((se,ee)=>{this.activePromise.then(de=>{this.activePromise=null,se(de)},de=>{this.activePromise=null,ee(de)})})}dispose(){this.isDisposed=!0}}e.Throttler=d;class c{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=c;class f{constructor(){this.promiseMap=new Map}queue($,se){const de=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.promiseMap.get($)===de&&this.promiseMap.delete($)});return this.promiseMap.set($,de),de}}e.SequencerByKey=f;const a=(H,$)=>{let se=!0;const ee=setTimeout(()=>{se=!1,$()},H);return{isTriggered:()=>se,dispose:()=>{clearTimeout(ee),se=!1}}},t=H=>{let $=!0;return queueMicrotask(()=>{$&&($=!1,H())}),{isTriggered:()=>$,dispose:()=>{$=!1}}};class o{constructor($){this.defaultDelay=$,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,se=this.defaultDelay){this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((de,pe)=>{this.doResolve=de,this.doReject=pe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const de=this.task;return this.task=null,de()}}));const ee=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=se===h.MicrotaskDelay?t(ee):a(se,ee),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class s{constructor($){this.delayer=new o($),this.throttler=new d}trigger($,se){return this.delayer.trigger(()=>this.throttler.queue($),se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=s;class i{constructor(){this._isOpen=!1,this._promise=new Promise(($,se)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class r extends i{constructor($){super(),this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function u(H,$){return $?new Promise((se,ee)=>{const de=setTimeout(()=>{pe.dispose(),se()},H),pe=$.onCancellationRequested(()=>{clearTimeout(de),pe.dispose(),ee(new D.CancellationError)})}):y(se=>u(H,se))}function S(H,$=0,se){const ee=setTimeout(()=>{H(),se&&de.dispose()},$),de=(0,O.toDisposable)(()=>{clearTimeout(ee),se?.deleteAndLeak(de)});return se?.add(de),de}function k(H){const $=[];let se=0;const ee=H.length;function de(){return se<ee?H[se++]():null}function pe(be){be!=null&&$.push(be);const Ee=de();return Ee?Ee.then(pe):Promise.resolve($)}return Promise.resolve(null).then(pe)}function M(H,$=ee=>!!ee,se=null){let ee=0;const de=H.length,pe=()=>{if(ee>=de)return Promise.resolve(se);const be=H[ee++];return Promise.resolve(be()).then(De=>$(De)?Promise.resolve(De):pe())};return pe()}function L(H,$=ee=>!!ee,se=null){if(H.length===0)return Promise.resolve(se);let ee=H.length;const de=()=>{ee=-1;for(const pe of H)pe.cancel?.()};return new Promise((pe,be)=>{for(const Ee of H)Ee.then(De=>{--ee>=0&&$(De)?(de(),pe(De)):ee===0&&pe(se)}).catch(De=>{--ee>=0&&(de(),be(De))})})}class R{constructor($){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new I.Emitter}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue($){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((se,ee)=>{this.outstandingPromises.push({factory:$,c:se,e:ee}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const se=$.factory();se.then($.c,$.e),se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=R;class A extends R{constructor(){super(1)}}e.Queue=A;class F{constructor(){this.sequentializer=new x,this.tasks=0}queue($){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,$())):this.sequentializer.run(this.tasks++,$())}}e.LimitedQueue=F;class _{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const $=new le;return this.drainers.add($),$.p}isDrained(){for(const[,$]of this.queues)if($.size>0)return!1;return!0}queueSize($,se=C.extUri){const ee=se.getComparisonKey($);return this.queues.get(ee)?.size??0}queueFor($,se,ee=C.extUri){const de=ee.getComparisonKey($);let pe=this.queues.get(de);if(!pe){pe=new A;const be=this.drainListenerCount++,Ee=I.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.queues.delete(de),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(be),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(be,Ee),this.queues.set(de,pe)}return pe.queue(se)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const $ of this.drainers)$.complete();this.drainers.clear()}dispose(){for(const[,$]of this.queues)$.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=_;class z{constructor($,se){this._token=-1,typeof $=="function"&&typeof se=="number"&&this.setIfNotSet($,se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},se)}setIfNotSet($,se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},se))}}e.TimeoutTimer=z;class j{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet($,se,ee=globalThis){this.cancel();const de=ee.setInterval(()=>{$()},se);this.disposable=(0,O.toDisposable)(()=>{ee.clearInterval(de),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=j;class ce{constructor($,se){this.timeoutToken=-1,this.runner=$,this.timeout=se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=ce;class te{constructor($,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=te;class ue extends ce{constructor($,se){super($,se),this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner?.($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ue;class X extends O.Disposable{constructor($,se){super(),this.options=$,this.handler=se,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.options.maxBufferedWork)return!1}else if(this.pending+$.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const se of $)this.pendingWork.push(se);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ce(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(H,$)=>{(0,P.setTimeout0)(()=>{if(se)return;const ee=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e._runWhenIdle=(H,$,se)=>{const ee=H.requestIdleCallback($,typeof se=="number"?{timeout:se}:void 0);let de=!1;return{dispose(){de||(de=!0,H.cancelIdleCallback(ee))}}},e.runWhenGlobalIdle=H=>(0,e._runWhenIdle)(globalThis,H)}();class Y{constructor($,se){this._didRun=!1,this._executor=()=>{try{this._value=se()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)($,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=Y;class B extends Y{constructor($){super(globalThis,$)}}e.GlobalIdleValue=B;async function T(H,$,se){let ee;for(let de=0;de<se;de++)try{return await H()}catch(pe){ee=pe,await u($)}throw ee}class x{isRunning($){return typeof $=="number"?this._running?.taskId===$:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run($,se,ee){return this._running={taskId:$,cancel:()=>ee?.(),promise:se},se.then(()=>this.doneRunning($),()=>this.doneRunning($)),se}doneRunning($){this._running&&$===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const $=this._queued;this._queued=void 0,$.run().then($.promiseResolve,$.promiseReject)}}queue($){if(this._queued)this._queued.run=$;else{const{promise:se,resolve:ee,reject:de}=p();this._queued={run:$,promise:se,promiseResolve:ee,promiseReject:de}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=x;class V{constructor($,se=()=>Date.now()){this.interval=$,this.nowFn=se,this.lastIncrementTime=0,this.value=0}increment(){const $=this.nowFn();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=V;var U;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(U||(U={}));class le{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise(($,se)=>{this.completeCallback=$,this.errorCallback=se})}complete($){return new Promise(se=>{this.completeCallback($),this.outcome={outcome:0,value:$},se()})}error($){return new Promise(se=>{this.errorCallback($),this.outcome={outcome:1,value:$},se()})}cancel(){return this.error(new D.CancellationError)}}e.DeferredPromise=le;var he;(function(H){async function $(ee){let de;const pe=await Promise.all(ee.map(be=>be.then(Ee=>Ee,Ee=>{de||(de=Ee)})));if(typeof de<"u")throw de;return pe}H.settled=$;function se(ee){return new Promise(async(de,pe)=>{try{await ee(de,pe)}catch(be){pe(be)}})}H.withAsyncBody=se})(he||(e.Promises=he={}));class K{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor($){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=$.then(se=>(this._value=se,this._isResolved=!0,se),se=>{throw this._error=se,this._isResolved=!0,se})}requireValue(){if(!this._isResolved)throw new D.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=K;class W{constructor($){this._compute=$,this._promise=new l.Lazy(()=>new K(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=W;var N;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(N||(N={}));class Z{static fromArray($){return new Z(se=>{se.emitMany($)})}static fromPromise($){return new Z(async se=>{se.emitMany(await $)})}static fromPromises($){return new Z(async se=>{await Promise.all($.map(async ee=>se.emitOne(await ee)))})}static merge($){return new Z(async se=>{await Promise.all($.map(async ee=>{for await(const de of ee)se.emitOne(de)}))})}static{this.EMPTY=Z.fromArray([])}constructor($){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const se={emitOne:ee=>this.emitOne(ee),emitMany:ee=>this.emitMany(ee),reject:ee=>this.reject(ee)};try{await Promise.resolve($(se)),this.resolve()}catch(ee){this.reject(ee)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}[Symbol.asyncIterator](){let $=0;return{next:async()=>{do{if(this._state===2)throw this._error;if($<this._results.length)return{done:!1,value:this._results[$++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map($,se){return new Z(async ee=>{for await(const de of $)ee.emitOne(se(de))})}map($){return Z.map(this,$)}static filter($,se){return new Z(async ee=>{for await(const de of $)se(de)&&ee.emitOne(de)})}filter($){return Z.filter(this,$)}static coalesce($){return Z.filter($,se=>!!se)}coalesce(){return Z.coalesce(this)}static async toPromise($){const se=[];for await(const ee of $)se.push(ee);return se}toPromise(){return Z.toPromise(this)}emitOne($){this._state===0&&(this._results.push($),this._onStateChanged.fire())}emitMany($){this._state===0&&(this._results=this._results.concat($),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject($){this._state===0&&(this._state=2,this._error=$,this._onStateChanged.fire())}}e.AsyncIterableObject=Z;class re extends Z{constructor($,se){super(se),this._source=$}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=re;function G(H){const $=new n.CancellationTokenSource,se=H($.token);return new re($,async ee=>{const de=$.token.onCancellationRequested(()=>{de.dispose(),$.dispose(),ee.reject(new D.CancellationError)});try{for await(const pe of se){if($.token.isCancellationRequested)return;ee.emitOne(pe)}de.dispose(),$.dispose()}catch(pe){de.dispose(),$.dispose(),ee.reject(pe)}})}class q{constructor(){this._deferred=new le,this._asyncIterable=new Z(ee=>{if($){ee.reject($);return}return se&&ee.emitMany(se),this._errorFn=de=>ee.reject(de),this._emitFn=de=>ee.emitOne(de),this._deferred.p});let $,se;this._emitFn=ee=>{se||(se=[]),se.push(ee)},this._errorFn=ee=>{$||($=ee)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject($){this._errorFn($),this._deferred.complete()}emitOne($){this._emitFn($)}}e.AsyncIterableSource=q}),define(oe[108],ae([0,1,22,8,31,32,9,4,25]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=l,e.splitGlobAware=m,e.match=A,e.parse=F,e.isRelativePattern=_,e.getBasenameTerms=z,e.getPathTerms=j,e.patternsEquals=X;function l(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const v="[/\\\\]",y="[^/\\\\]",E=/\//g;function g(Y,B){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${v}|${y}+${v}${B?`|${v}${y}+`:""})*?`}}function m(Y,B){if(!Y)return[];const T=[];let x=!1,V=!1,U="";for(const le of Y){switch(le){case B:if(!x&&!V){T.push(U),U="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":V=!0;break;case"]":V=!1;break}U+=le}return U&&T.push(U),T}function b(Y){if(!Y)return"";let B="";const T=m(Y,e.GLOB_SPLIT);if(T.every(x=>x===e.GLOBSTAR))B=".*";else{let x=!1;T.forEach((V,U)=>{if(V===e.GLOBSTAR){if(x)return;B+=g(2,U===T.length-1)}else{let le=!1,he="",K=!1,W="";for(const N of V){if(N!=="}"&&le){he+=N;continue}if(K&&(N!=="]"||!W)){let Z;N==="-"?Z=N:(N==="^"||N==="!")&&!W?Z="^":N===e.GLOB_SPLIT?Z="":Z=(0,h.escapeRegExpCharacters)(N),W+=Z;continue}switch(N){case"{":le=!0;continue;case"[":K=!0;continue;case"}":{const re=`(?:${m(he,",").map(G=>b(G)).join("|")})`;B+=re,le=!1,he="";break}case"]":{B+="["+W+"]",K=!1,W="";break}case"?":B+=y;continue;case"*":B+=g(1);continue;default:B+=(0,h.escapeRegExpCharacters)(N)}}U<T.length-1&&(T[U+1]!==e.GLOBSTAR||U+2<T.length)&&(B+=v)}x=V===e.GLOBSTAR})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),o=function(){return!1},s=function(){return null};function i(Y,B){if(!Y)return s;let T;typeof Y!="string"?T=Y.pattern:T=Y,T=T.trim();const x=`${T}_${!!B.trimForExclusions}`;let V=t.get(x);if(V)return r(V,Y);let U;return w.test(T)?V=S(T.substr(4),T):(U=p.exec(u(T,B)))?V=k(U[1],T):(B.trimForExclusions?c:d).test(T)?V=M(T,B):(U=f.exec(u(T,B)))?V=L(U[1].substr(1),T,!0):(U=a.exec(u(T,B)))?V=L(U[1],T,!1):V=R(T),t.set(x,V),r(V,Y)}function r(Y,B){if(typeof B=="string")return Y;const T=function(x,V){return(0,I.isEqualOrParent)(x,B.base,!P.isLinux)?Y((0,h.ltrim)(x.substr(B.base.length),C.sep),V):null};return T.allBasenames=Y.allBasenames,T.allPaths=Y.allPaths,T.basenames=Y.basenames,T.patterns=Y.patterns,T}function u(Y,B){return B.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function S(Y,B){return function(T,x){return typeof T=="string"&&T.endsWith(Y)?B:null}}function k(Y,B){const T=`/${Y}`,x=`\\${Y}`,V=function(le,he){return typeof le!="string"?null:he?he===Y?B:null:le===Y||le.endsWith(T)||le.endsWith(x)?B:null},U=[Y];return V.basenames=U,V.patterns=[B],V.allBasenames=U,V}function M(Y,B){const T=ue(Y.slice(1,-1).split(",").map(he=>i(he,B)).filter(he=>he!==s),Y),x=T.length;if(!x)return s;if(x===1)return T[0];const V=function(he,K){for(let W=0,N=T.length;W<N;W++)if(T[W](he,K))return Y;return null},U=T.find(he=>!!he.allBasenames);U&&(V.allBasenames=U.allBasenames);const le=T.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return le.length&&(V.allPaths=le),V}function L(Y,B,T){const x=C.sep===C.posix.sep,V=x?Y:Y.replace(E,C.sep),U=C.sep+V,le=C.posix.sep+Y;let he;return T?he=function(K,W){return typeof K=="string"&&(K===V||K.endsWith(U)||!x&&(K===Y||K.endsWith(le)))?B:null}:he=function(K,W){return typeof K=="string"&&(K===V||!x&&K===Y)?B:null},he.allPaths=[(T?"*/":"./")+Y],he}function R(Y){try{const B=new RegExp(`^${b(Y)}$`);return function(T){return B.lastIndex=0,typeof T=="string"&&B.test(T)?Y:null}}catch{return s}}function A(Y,B,T){return!Y||typeof B!="string"?!1:F(Y)(B,void 0,T)}function F(Y,B={}){if(!Y)return o;if(typeof Y=="string"||_(Y)){const T=i(Y,B);if(T===s)return o;const x=function(V,U){return!!T(V,U)};return T.allBasenames&&(x.allBasenames=T.allBasenames),T.allPaths&&(x.allPaths=T.allPaths),x}return ce(Y,B)}function _(Y){const B=Y;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function z(Y){return Y.allBasenames||[]}function j(Y){return Y.allPaths||[]}function ce(Y,B){const T=ue(Object.getOwnPropertyNames(Y).map(he=>te(he,Y[he],B)).filter(he=>he!==s)),x=T.length;if(!x)return s;if(!T.some(he=>!!he.requiresSiblings)){if(x===1)return T[0];const he=function(N,Z){let re;for(let G=0,q=T.length;G<q;G++){const H=T[G](N,Z);if(typeof H=="string")return H;(0,D.isThenable)(H)&&(re||(re=[]),re.push(H))}return re?(async()=>{for(const G of re){const q=await G;if(typeof q=="string")return q}return null})():null},K=T.find(N=>!!N.allBasenames);K&&(he.allBasenames=K.allBasenames);const W=T.reduce((N,Z)=>Z.allPaths?N.concat(Z.allPaths):N,[]);return W.length&&(he.allPaths=W),he}const V=function(he,K,W){let N,Z;for(let re=0,G=T.length;re<G;re++){const q=T[re];q.requiresSiblings&&W&&(K||(K=(0,C.basename)(he)),N||(N=K.substr(0,K.length-(0,C.extname)(he).length)));const H=q(he,K,N,W);if(typeof H=="string")return H;(0,D.isThenable)(H)&&(Z||(Z=[]),Z.push(H))}return Z?(async()=>{for(const re of Z){const G=await re;if(typeof G=="string")return G}return null})():null},U=T.find(he=>!!he.allBasenames);U&&(V.allBasenames=U.allBasenames);const le=T.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return le.length&&(V.allPaths=le),V}function te(Y,B,T){if(B===!1)return s;const x=i(Y,T);if(x===s)return s;if(typeof B=="boolean")return x;if(B){const V=B.when;if(typeof V=="string"){const U=(le,he,K,W)=>{if(!W||!x(le,he))return null;const N=V.replace("$(basename)",()=>K),Z=W(N);return(0,D.isThenable)(Z)?Z.then(re=>re?Y:null):Z?Y:null};return U.requiresSiblings=!0,U}}return x}function ue(Y,B){const T=Y.filter(he=>!!he.basenames);if(T.length<2)return Y;const x=T.reduce((he,K)=>{const W=K.basenames;return W?he.concat(W):he},[]);let V;if(B){V=[];for(let he=0,K=x.length;he<K;he++)V.push(B)}else V=T.reduce((he,K)=>{const W=K.patterns;return W?he.concat(W):he},[]);const U=function(he,K){if(typeof he!="string")return null;if(!K){let N;for(N=he.length;N>0;N--){const Z=he.charCodeAt(N-1);if(Z===47||Z===92)break}K=he.substr(N)}const W=x.indexOf(K);return W!==-1?V[W]:null};U.basenames=x,U.patterns=V,U.allBasenames=x;const le=Y.filter(he=>!he.basenames);return le.push(U),le}function X(Y,B){return(0,n.equals)(Y,B,(T,x)=>typeof T=="string"&&typeof x=="string"?T===x:typeof T!="string"&&typeof x!="string"?T.base===x.base&&T.pattern===x.pattern:!1)}}),define(oe[48],ae([0,1,22,31,9,4,19,25]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=h,e.normalizeDriveLetter=v,e.tildify=E,e.untildify=g,e.shorten=p,e.template=c,e.mnemonicMenuLabel=f,e.mnemonicButtonLabel=a,e.unmnemonicLabel=t,e.splitRecentLabel=o;function h(i,r){const{os:u,tildify:S,relative:k}=r;if(k){const R=l(i,k,u);if(typeof R=="string")return R}let M=i.fsPath;if(u===1&&!O.isWindows?M=M.replace(/\//g,"\\"):u!==1&&O.isWindows&&(M=M.replace(/\\/g,"/")),u!==1&&S?.userHome){const R=S.userHome.fsPath;let A;i.scheme!==S.userHome.scheme&&i.path[0]===I.posix.sep&&i.path[1]!==I.posix.sep?A=S.userHome.with({path:i.path}).fsPath:A=M,M=E(A,R,u)}return(u===1?I.win32:I.posix).normalize(v(M,u===1))}function l(i,r,u){const S=u===1?I.win32:I.posix,k=u===3?C.extUri:C.extUriIgnorePathCase,M=r.getWorkspace(),L=(0,n.firstOrDefault)(M.folders);if(!L)return;i.scheme!==L.uri.scheme&&i.path[0]===I.posix.sep&&i.path[1]!==I.posix.sep&&(i=L.uri.with({path:i.path}));const R=r.getWorkspaceFolder(i);if(!R)return;let A;if(k.isEqual(R.uri,i)?A="":A=k.relativePath(R.uri,i)??"",A&&(A=S.normalize(A)),M.folders.length>1&&!r.noPrefix){const F=R.name?R.name:k.basenameOrAuthority(R.uri);A=A?`${F} \u2022 ${A}`:F}return A}function v(i,r=O.isWindows){return(0,D.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function E(i,r,u=O.OS){if(u===1||!i||!r)return i;let S=y.original===r?y.normalized:void 0;S||(S=r,O.isWindows&&(S=(0,D.toSlashes)(S)),S=`${(0,P.rtrim)(S,I.posix.sep)}${I.posix.sep}`,y={original:r,normalized:S});let k=i;return O.isWindows&&(k=(0,D.toSlashes)(k)),(u===3?k.startsWith(S):(0,P.startsWithIgnoreCase)(k,S))?`~/${k.substr(S.length)}`:i}function g(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}const m="\u2026",b="\\\\",w="~";function p(i,r=I.sep){const u=new Array(i.length);let S=!1;for(let k=0;k<i.length;k++){const M=i[k];if(M===""){u[k]=`.${r}`;continue}if(!M){u[k]=M;continue}S=!0;let L="",R=M;R.indexOf(b)===0?(L=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(r)===0?(L=R.substr(0,R.indexOf(r)+r.length),R=R.substr(R.indexOf(r)+r.length)):R.indexOf(w)===0&&(L=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length));const A=R.split(r);for(let F=1;S&&F<=A.length;F++)for(let _=A.length-F;S&&_>=0;_--){S=!1;let z=A.slice(_,_+F).join(r);for(let j=0;!S&&j<i.length;j++)if(j!==k&&i[j]&&i[j].indexOf(z)>-1){const ce=_+F===A.length,te=_>0&&i[j].indexOf(r)>-1?r+z:z,ue=i[j].endsWith(te);S=!ce||ue}if(!S){let j="";(A[0].endsWith(":")||L!=="")&&(_===1&&(_=0,F++,z=A[0]+r+z),_>0&&(j=A[0]+r),j=L+j),_>0&&(j=j+m+r),j=j+z,_+F<A.length&&(j=j+r+m),u[k]=j}}S&&(u[k]=M)}return u}var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function c(i,r=Object.create(null)){const u=[];let S=!1,k="";for(const M of i)if(M==="$"||S&&M==="{")k&&u.push({value:k,type:d.TEXT}),k="",S=!0;else if(M==="}"&&S){const L=r[k];if(typeof L=="string")L.length&&u.push({value:L,type:d.VARIABLE});else if(L){const R=u[u.length-1];(!R||R.type!==d.SEPARATOR)&&u.push({value:L.label,type:d.SEPARATOR})}k="",S=!1}else k+=M;return k&&!S&&u.push({value:k,type:d.TEXT}),u.filter((M,L)=>{if(M.type===d.SEPARATOR){const R=u[L-1],A=u[L+1];return[R,A].every(F=>F&&(F.type===d.VARIABLE||F.type===d.TEXT)&&F.value.length>0)}return!0}).map(M=>M.value).join("")}function f(i,r){return O.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,r){return O.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):O.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const r=i.lastIndexOf(" [",i.length-2);if(r!==-1){const u=s(i.substring(0,r)),S=i.substring(r);return{name:u.name+S,parentPath:u.parentPath}}}return s(i)}function s(i){const r=i.indexOf("/")!==-1?I.posix:I.win32,u=r.basename(i),S=r.dirname(i);return u.length?{name:u,parentPath:S}:{name:S,parentPath:""}}}),define(oe[157],ae([0,1,17,7]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=P,e.transformIncomingURIs=l,e.transformAndReviveIncomingURIs=v;function I(y){return y.toJSON()}class O{constructor(E){this._uriTransformer=E}transformIncoming(E){const g=this._uriTransformer.transformIncoming(E);return g===E?E:I(D.URI.from(g))}transformOutgoing(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:I(D.URI.from(g))}transformOutgoingURI(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:D.URI.from(g)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,E,g){if(!y||g>200)return null;if(typeof y=="object"){if(y instanceof D.URI)return E.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const b=C(y[m],E,g+1);b!==null&&(y[m]=b)}}return null}function P(y,E){const g=C(y,E,0);return g===null?y:g}function h(y,E,g,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return g?D.URI.revive(E.transformIncoming(y)):E.transformIncoming(y);if(y instanceof n.VSBuffer)return null;for(const b in y)if(Object.hasOwnProperty.call(y,b)){const w=h(y[b],E,g,m+1);w!==null&&(y[b]=w)}}return null}function l(y,E){const g=h(y,E,!1,0);return g===null?y:g}function v(y,E){const g=h(y,E,!0,0);return g===null?y:g}}),define(oe[89],ae([0,1,26,59,33,147,4]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=h,e.getSqmMachineId=y,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,g=0;const m=(0,n.networkInterfaces)();for(const b in m){const w=m[b];if(w)for(const{mac:p,internal:d}of w)d||(g+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(E+=1))}this._value=g>0?E/g:0}return this._value}};let P;async function h(E){return P||(P=(async()=>await l(E)||I.generateUuid())()),P}async function l(E){try{const g=await new Promise((b,w)=>{Q(["crypto"],b,w)}),m=(0,O.getMac)();return g.createHash("sha256").update(m,"utf8").digest("hex")}catch(g){E(g);return}}const v="Software\\Microsoft\\SQMClient";async function y(E){if(C.isWindows){const g=await new Promise((m,b)=>{Q(["@vscode/windows-registry"],m,b)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",v,"MachineId")||""}catch(m){return E(m),""}}return""}}),define(oe[21],ae([0,1,43,26,158,8,31,72,9,4,19,7]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=c,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=k;var E;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function g(te,ue=E.UNLINK,X){if((0,C.isRootOrDriveLetter)(te))throw new Error("rimraf - will refuse to recursively delete root");return ue===E.UNLINK?b(te):m(te,X)}async function m(te,ue=(0,C.randomPath)((0,D.tmpdir)())){try{try{await n.promises.rename(te,ue)}catch(X){return X.code==="ENOENT"?void 0:b(te)}b(ue).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function b(te){return(0,I.promisify)(n.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function w(te){if((0,C.isRootOrDriveLetter)(te))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function p(te,ue){return f(await(ue?d(te):(0,I.promisify)(n.readdir)(te)))}async function d(te){try{return await(0,I.promisify)(n.readdir)(te,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],X=await p(te);for(const Y of X){let B=!1,T=!1,x=!1;try{const V=await e.Promises.lstat((0,h.join)(te,Y));B=V.isFile(),T=V.isDirectory(),x=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ue.push({name:Y,isFile:()=>B,isDirectory:()=>T,isSymbolicLink:()=>x})}return ue}function c(te){return f(n.readdirSync(te))}function f(te){return te.map(ue=>typeof ue=="string"?l.isMacintosh?(0,P.normalizeNFC)(ue):ue:(ue.name=l.isMacintosh?(0,P.normalizeNFC)(ue.name):ue.name,ue))}async function a(te){const ue=await p(te),X=[];for(const Y of ue)await o.existsDirectory((0,h.join)(te,Y))&&X.push(Y);return X}function t(te,ue=1e3){return new Promise(X=>{let Y=!1;const B=setInterval(()=>{Y||(Y=!0,n.access(te,T=>{Y=!1,T&&(clearInterval(B),X(void 0))}))},ue)})}var o;(function(te){async function ue(B){let T;try{if(T=await e.Promises.lstat(B),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(l.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw V}throw x}}te.stat=ue;async function X(B){try{const{stat:T,symbolicLink:x}=await te.stat(B);return T.isFile()&&x?.dangling!==!0}catch{}return!1}te.existsFile=X;async function Y(B){try{const{stat:T,symbolicLink:x}=await te.stat(B);return T.isDirectory()&&x?.dangling!==!0}catch{}return!1}te.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const s=new O.ResourceQueue;function i(te,ue,X){return s.queueFor(y.URI.file(te),()=>{const Y=M(X);return new Promise((B,T)=>S(te,ue,Y,x=>x?T(x):B()))},v.extUriBiasedIgnorePathCase)}let r=!0;function u(te){r=te}function S(te,ue,X,Y){if(!r)return n.writeFile(te,ue,{mode:X.mode,flag:X.flag},Y);n.open(te,X.flag,X.mode,(B,T)=>{if(B)return Y(B);n.writeFile(T,ue,x=>{if(x)return n.close(T,()=>Y(x));n.fdatasync(T,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),u(!1)),n.close(T,U=>Y(U))))})})}function k(te,ue,X){const Y=M(X);if(!r)return n.writeFileSync(te,ue,{mode:Y.mode,flag:Y.flag});const B=n.openSync(te,Y.flag,Y.mode);try{n.writeFileSync(B,ue);try{n.fdatasyncSync(B)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),u(!1)}}finally{n.closeSync(B)}}function M(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function L(te,ue,X=6e4){if(te!==ue)try{l.isWindows&&typeof X=="number"?await R(te,ue,Date.now(),X):await(0,I.promisify)(n.rename)(te,ue)}catch(Y){if(te.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||te.endsWith("."))await A(te,ue,{preserveSymlinks:!1}),await g(te,E.MOVE);else throw Y}}async function R(te,ue,X,Y,B=0){try{return await(0,I.promisify)(n.rename)(te,ue)}catch(T){if(T.code!=="EACCES"&&T.code!=="EPERM"&&T.code!=="EBUSY")throw T;if(Date.now()-X>=Y)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${T}`),T;if(B===0){let x=!1;try{const{stat:V}=await o.stat(ue);V.isFile()||(x=!0)}catch{}if(x)throw T}return await(0,O.timeout)(Math.min(100,B*10)),R(te,ue,X,Y,B+1)}}async function A(te,ue,X){return _(te,ue,{root:{source:te,target:ue},options:X,handledSourcePaths:new Set})}const F=511;async function _(te,ue,X){if(X.handledSourcePaths.has(te))return;X.handledSourcePaths.add(te);const{stat:Y,symbolicLink:B}=await o.stat(te);if(B){if(X.options.preserveSymlinks)try{return await ce(te,ue,X)}catch{}if(B.dangling)return}return Y.isDirectory()?z(te,ue,Y.mode&F,X):j(te,ue,Y.mode&F)}async function z(te,ue,X,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:X});const B=await p(te);for(const T of B)await _((0,h.join)(te,T),(0,h.join)(ue,T),Y)}async function j(te,ue,X){await e.Promises.copyFile(te,ue),await e.Promises.chmod(ue,X)}async function ce(te,ue,X){let Y=await e.Promises.readlink(te);(0,C.isEqualOrParent)(Y,X.root.source,!l.isLinux)&&(Y=(0,h.join)(X.root.target,Y.substr(X.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,I.promisify)(n.access)}get stat(){return(0,I.promisify)(n.stat)}get lstat(){return(0,I.promisify)(n.lstat)}get utimes(){return(0,I.promisify)(n.utimes)}get read(){return(te,ue,X,Y,B)=>new Promise((T,x)=>{n.read(te,ue,X,Y,B,(V,U,le)=>V?x(V):T({bytesRead:U,buffer:le}))})}get readFile(){return(0,I.promisify)(n.readFile)}get write(){return(te,ue,X,Y,B)=>new Promise((T,x)=>{n.write(te,ue,X,Y,B,(V,U,le)=>V?x(V):T({bytesWritten:U,buffer:le}))})}get appendFile(){return(0,I.promisify)(n.appendFile)}get fdatasync(){return(0,I.promisify)(n.fdatasync)}get truncate(){return(0,I.promisify)(n.truncate)}get copyFile(){return(0,I.promisify)(n.copyFile)}get open(){return(0,I.promisify)(n.open)}get close(){return(0,I.promisify)(n.close)}get symlink(){return(0,I.promisify)(n.symlink)}get readlink(){return(0,I.promisify)(n.readlink)}get chmod(){return(0,I.promisify)(n.chmod)}get mkdir(){return(0,I.promisify)(n.mkdir)}get unlink(){return(0,I.promisify)(n.unlink)}get rmdir(){return(0,I.promisify)(n.rmdir)}get realpath(){return(0,I.promisify)(n.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return g}get rename(){return L}get copy(){return A}}}),define(oe[109],ae([0,1,43,9,4,25,21]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=P,e.realcase=h,e.realpath=l,e.realpathSync=v;function P(E){if(I.isLinux)return E;const g=(0,D.dirname)(E);if(E===g)return E;const m=((0,D.basename)(E)||E).toLowerCase();try{const w=(0,C.readdirSync)(g).filter(p=>p.toLowerCase()===m);if(w.length===1){const p=P(g);if(p)return(0,D.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(m);if(p>=0){const d=P(g);if(d)return(0,D.join)(d,w[p])}}}catch{}return null}async function h(E,g){if(I.isLinux)return E;const m=(0,D.dirname)(E);if(E===m)return E;const b=((0,D.basename)(E)||E).toLowerCase();try{if(g?.isCancellationRequested)return null;const p=(await C.Promises.readdir(m)).filter(d=>d.toLowerCase()===b);if(p.length===1){const d=await h(m,g);if(d)return(0,D.join)(d,p[0])}else if(p.length>1){const d=p.indexOf(b);if(d>=0){const c=await h(m,g);if(c)return(0,D.join)(c,p[d])}}}catch{}return null}async function l(E){try{return await C.Promises.realpath(E)}catch{const m=y(E);return await C.Promises.access(m,n.constants.R_OK),m}}function v(E){try{return n.realpathSync(E)}catch{const m=y(E);return n.accessSync(m,n.constants.R_OK),m}}function y(E){return(0,O.rtrim)((0,D.normalize)(E),D.sep)}}),define(oe[110],ae([0,1,26,9,21]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=d,e.getFirstAvailablePowerShellInstallation=c;const O=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:f=!1}={}){return f?l===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:f=!1,findPreview:a=!1}={}){const t=E({useAlternateBitness:f});if(!t)return null;const o=D.join(t,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(o))return null;let s=-1,i=null;for(const S of await I.Promises.readdir(o)){let k=-1;if(a){const L=S.indexOf("-");if(L<0)continue;const R=S.substring(0,L);if(!O.test(R)||S.substring(L+1)!=="preview")continue;k=parseInt(R,10)}else{if(!O.test(S))continue;k=parseInt(S,10)}if(k<=s)continue;const M=D.join(o,S,"pwsh.exe");await I.SymlinkSupport.existsFile(M)&&(i=M,s=k)}if(!i)return null;const r=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new y(i,`PowerShell${u}${r}`,!0)}async function m({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const a=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const s of await I.Promises.readdir(a))if(t.test(s)){const i=D.join(a,s,"pwsh.exe");return new y(i,o)}return null}function b(){const f=D.join(n.homedir(),".dotnet","tools","pwsh.exe");return new y(f,".NET Core PowerShell Global Tool")}function w(){const f=D.join(process.env.windir,l===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(f,"Windows PowerShell",!0)}async function*p(){let f=await g();f&&(yield f),f=await g({useAlternateBitness:!0}),f&&(yield f),f=await m(),f&&(yield f),f=b(),f&&(yield f),f=await g({findPreview:!0}),f&&(yield f),f=await m({findPreview:!0}),f&&(yield f),f=await g({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*d(){for await(const f of p())await f.exists()&&(yield f)}async function c(){for await(const f of d())return f;return null}}),define(oe[90],ae([0,1,9,4,36,76,12,21]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=h,e.createQueuedSender=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function h(y=I.env){return y.comspec||"cmd.exe"}function l(y){let E=[],g=!1;const m=function(b){if(g){E.push(b);return}(!y.send(b,p=>{if(p&&console.error(p),g=!1,E.length>0){const d=E.slice(0);E=[],d.forEach(c=>m(c))}})||D.isWindows)&&(g=!0)};return{send:m}}var v;(function(y){async function E(g,m,b){if(n.isAbsolute(g))return g;if(m===void 0&&(m=I.cwd()),n.dirname(g)!=="."||(b===void 0&&C.isString(I.env.PATH)&&(b=I.env.PATH.split(n.delimiter)),b===void 0||b.length===0))return n.join(m,g);async function p(d){if(await P.Promises.exists(d)){let c;try{c=await P.Promises.stat(d)}catch(f){f.message.startsWith("EACCES")&&(c=await P.Promises.lstat(d))}return c?!c.isDirectory():!1}return!1}for(const d of b){let c;if(n.isAbsolute(d)?c=n.join(d,g):c=n.join(m,d,g),await p(c))return c;let f=c+".com";if(await p(f)||(f=c+".exe",await p(f)))return f}return n.join(m,g)}y.findExecutable=E})(v||(e.win32=v={}))}),define(oe[111],ae([0,1,49,13]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=I;function I(C){return new Promise((P,h)=>{let l;const v=new Map;function y(g,m,b,w,p){const d=v.get(m);if(g===C||d){const c={name:E(b),cmd:b,pid:g,ppid:m,load:w,mem:p};v.set(g,c),g===C&&(l=c),d&&(d.children||(d.children=[]),d.children.push(c),d.children.length>1&&(d.children=d.children.sort((f,a)=>f.pid-a.pid)))}}function E(g){const m=/--utility-sub-type=network/i,b=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,p=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(b.exec(g))return"electron-crash-reporter";if(w.exec(g))return"winpty-agent";if(p.exec(g))return"conpty-agent";let c=d.exec(g);if(c&&c.length===2)return c[1]==="renderer"?"window":c[1]==="utility"?m.exec(g)?"utility-network-service":"utility-process":c[1]==="extensionHost"?"extension-host":c[1];const f=/[a-zA-Z-]+\.js/g;let a="";do c=f.exec(g),c&&(a+=c+" ");while(c);return a&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${a})`:g}if(process.platform==="win32"){const g=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,b)=>{Q(["@vscode/windows-process-tree"],m,b)}).then(m=>{m.getProcessList(C,b=>{if(!b){h(new Error(`Root process ${C} not found`));return}m.getProcessCpuUsage(b,w=>{const p=new Map;w.forEach(d=>{const c=g(d.commandLine||"");p.set(d.pid,{name:E(c),cmd:c,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),l=p.get(C),l?(p.forEach(d=>{const c=p.get(d.ppid);c&&(c.children||(c.children=[]),c.children.push(d))}),p.forEach(d=>{d.children&&(d.children=d.children.sort((c,f)=>c.pid-f.pid))}),P(l)):h(new Error(`Root process ${C} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let g=function(){let m=[l];const b=[];for(;m.length;){const p=m.shift();p&&(b.push(p.pid),p.children&&(m=m.concat(p.children)))}let w=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+b.join(" "),(0,n.exec)(w,{},(p,d,c)=>{if(p||c)h(p||new Error(c.toString()));else{const f=d.toString().split(`
`);for(let a=0;a<b.length;a++){const t=v.get(b[a]);t.load=parseFloat(f[a])}if(!l){h(new Error(`Root process ${C} not found`));return}P(l)}})};(0,n.exec)("which ps",{},(m,b,w)=>{if(m||w)if(process.platform!=="linux")h(m||new Error(w.toString()));else{const p=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(p,{},(d,c,f)=>{d||f?h(d||new Error(f.toString())):(O(c,y),g())})}else{const p=b.toString().trim();(0,n.exec)(`${p} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,f,a)=>{c||a&&!a.includes("screen size is bogus")?h(c||new Error(a.toString())):(O(f,y),process.platform==="linux"?g():l?P(l):h(new Error(`Root process ${C} not found`)))})}})}})}function O(C,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=C.toString().split(`
`);for(const v of l){const y=h.exec(v.trim());y&&y.length===6&&P(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(oe[112],ae([0,1,26,4,110,90]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=C;async function C(y,E){return y===1?D.isWindows?v():O.getWindowsShell(E):h(y,E)}let P=null;function h(y,E){if(D.isLinux&&y===2||D.isMacintosh&&y===3)return"/bin/bash";if(!P){let g;if(D.isWindows)g="/bin/bash";else{if(g=E.SHELL,!g)try{g=(0,n.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let l=null;async function v(){return l||(l=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),l}});var Pe=this&&this.__decorate||function(Q,e,n,D){var I=arguments.length,O=I<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,n):D,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Q,e,n,D);else for(var P=Q.length-1;P>=0;P--)(C=Q[P])&&(O=(I<3?C(O):I>3?C(e,n,O):C(e,n))||O);return I>3&&O&&Object.defineProperty(e,n,O),O};define(oe[44],ae([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=u,e.deserialize=S,e.getDelayedChannel=F,e.getNextTickChannel=_;var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function m(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(b||(b={}));function w(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(p||(p={}));function d(B){let T=0;for(let x=0;;x+=7){const V=B.read(1);if(T|=(V.buffer[0]&127)<<x,!(V.buffer[0]&128))return T}}const c=s(0);function f(B,T){if(T===0){B.write(c);return}let x=0;for(let U=T;U!==0;U=U>>>7)x++;const V=I.VSBuffer.alloc(x);for(let U=0;T!==0;U++)V.buffer[U]=T&127,T=T>>>7,T>0&&(V.buffer[U]|=128);B.write(V)}class a{constructor(T){this.buffer=T,this.pos=0}read(T){const x=this.buffer.slice(this.pos,this.pos+T);return this.pos+=x.byteLength,x}}e.BufferReader=a;class t{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}e.BufferWriter=t;var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(o||(o={}));function s(B){const T=I.VSBuffer.alloc(1);return T.writeUInt8(B,0),T}const i={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function u(B,T){if(typeof T>"u")B.write(i.Undefined);else if(typeof T=="string"){const x=I.VSBuffer.fromString(T);B.write(i.String),f(B,x.byteLength),B.write(x)}else if(r&&Buffer.isBuffer(T)){const x=I.VSBuffer.wrap(T);B.write(i.Buffer),f(B,x.byteLength),B.write(x)}else if(T instanceof I.VSBuffer)B.write(i.VSBuffer),f(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(i.Array),f(B,T.length);for(const x of T)u(B,x)}else if(typeof T=="number"&&(T|0)===T)B.write(i.Uint),f(B,T);else{const x=I.VSBuffer.fromString(JSON.stringify(T));B.write(i.Object),f(B,x.byteLength),B.write(x)}}function S(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(d(B)).toString();case o.Buffer:return B.read(d(B)).buffer;case o.VSBuffer:return B.read(d(B));case o.Array:{const x=d(B),V=[];for(let U=0;U<x;U++)V.push(S(B));return V}case o.Object:return JSON.parse(B.read(d(B)).toString());case o.Int:return d(B)}}class k{constructor(T,x,V=null,U=1e3){this.protocol=T,this.ctx=x,this.logger=V,this.timeoutDelay=U,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(T,x){this.channels.set(T,x),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const x=this.send([T.type]);this.logger?.logOutgoing(x,0,1,w(T.type));return}case 201:case 202:case 204:case 203:{const x=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(x,T.id,1,w(T.type),T.data);return}}}send(T,x=void 0){const V=new t;return u(V,T),u(V,x),this.sendBuffer(V.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const x=new a(T),V=S(x),U=S(x),le=V[0];switch(le){case 100:return this.logger?.logIncoming(T.byteLength,V[1],1,`${m(le)}: ${V[2]}.${V[3]}`,U),this.onPromise({type:le,id:V[1],channelName:V[2],name:V[3],arg:U});case 102:return this.logger?.logIncoming(T.byteLength,V[1],1,`${m(le)}: ${V[2]}.${V[3]}`,U),this.onEventListen({type:le,id:V[1],channelName:V[2],name:V[3],arg:U});case 101:return this.logger?.logIncoming(T.byteLength,V[1],1,`${m(le)}`),this.disposeActiveRequest({type:le,id:V[1]});case 103:return this.logger?.logIncoming(T.byteLength,V[1],1,`${m(le)}`),this.disposeActiveRequest({type:le,id:V[1]})}}onPromise(T){const x=this.channels.get(T.channelName);if(!x){this.collectPendingRequest(T);return}const V=new O.CancellationTokenSource;let U;try{U=x.call(this.ctx,T.name,T.arg,V.token)}catch(K){U=Promise.reject(K)}const le=T.id;U.then(K=>{this.sendResponse({id:le,data:K,type:201})},K=>{K instanceof Error?this.sendResponse({id:le,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:le,data:K,type:203})}).finally(()=>{he.dispose(),this.activeRequests.delete(T.id)});const he=(0,l.toDisposable)(()=>V.cancel());this.activeRequests.set(T.id,he)}onEventListen(T){const x=this.channels.get(T.channelName);if(!x){this.collectPendingRequest(T);return}const V=T.id,le=x.listen(this.ctx,T.name,T.arg)(he=>this.sendResponse({id:V,data:he,type:204}));this.activeRequests.set(T.id,le)}disposeActiveRequest(T){const x=this.activeRequests.get(T.id);x&&(x.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let x=this.pendingRequests.get(T.channelName);x||(x=[],this.pendingRequests.set(T.channelName,x));const V=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:T,timeoutTimer:V})}flushPendingRequests(T){const x=this.pendingRequests.get(T);if(x){for(const V of x)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=k;var M;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class L{constructor(T,x=null){this.protocol=T,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=x}getChannel(T){const x=this;return{call(V,U,le){return x.isDisposed?Promise.reject(new P.CancellationError):x.requestPromise(T,V,U,le)},listen(V,U){return x.isDisposed?h.Event.None:x.requestEvent(T,V,U)}}}requestPromise(T,x,V,U=O.CancellationToken.None){const le=this.lastRequestId++,K={id:le,type:100,channelName:T,name:x,arg:V};if(U.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise((Z,re)=>{if(U.isCancellationRequested)return re(new P.CancellationError);const G=()=>{const se=ee=>{switch(ee.type){case 201:this.handlers.delete(le),Z(ee.data);break;case 202:{this.handlers.delete(le);const de=new Error(ee.data.message);de.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,de.name=ee.data.name,re(de);break}case 203:this.handlers.delete(le),re(ee.data);break}};this.handlers.set(le,se),this.sendRequest(K)};let q=null;this.state===p.Idle?G():(q=(0,D.createCancelablePromise)(se=>this.whenInitialized()),q.then(()=>{q=null,G()}));const H=()=>{q?(q.cancel(),q=null):this.sendRequest({id:le,type:101}),re(new P.CancellationError)},$=U.onCancellationRequested(H);W=(0,l.combinedDisposable)((0,l.toDisposable)(H),$),this.activeRequests.add(W)}).finally(()=>{W.dispose(),this.activeRequests.delete(W)})}requestEvent(T,x,V){const U=this.lastRequestId++,he={id:U,type:102,channelName:T,name:x,arg:V};let K=null;const W=new h.Emitter({onWillAddFirstListener:()=>{K=(0,D.createCancelablePromise)(Z=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(W),this.sendRequest(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(W),this.sendRequest({id:U,type:103}))}}),N=Z=>W.fire(Z.data);return this.handlers.set(U,N),W.event}sendRequest(T){switch(T.type){case 100:case 102:{const x=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(x,T.id,0,`${m(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const x=this.send([T.type,T.id]);this.logger?.logOutgoing(x,T.id,0,m(T.type));return}}}send(T,x=void 0){const V=new t;return u(V,T),u(V,x),this.sendBuffer(V.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const x=new a(T),V=S(x),U=S(x),le=V[0];switch(le){case 200:return this.logger?.logIncoming(T.byteLength,0,0,w(le)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,V[1],0,w(le),U),this.onResponse({type:V[0],id:V[1],data:U})}}onResponse(T){if(T.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,l.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=L,Pe([C.memoize],L.prototype,"onDidInitializePromise",null);class R{get connections(){const T=[];return this._connections.forEach(x=>T.push(x)),T}constructor(T,x,V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new l.DisposableStore,this.disposables.add(T(({protocol:U,onDidClientDisconnect:le})=>{const he=h.Event.once(U.onMessage);this.disposables.add(he(K=>{const W=new a(K),N=S(W),Z=new k(U,N,x,V),re=new L(U,x);this.channels.forEach((q,H)=>Z.registerChannel(H,q));const G={channelServer:Z,channelClient:re,ctx:N};this._connections.add(G),this._onDidAddConnection.fire(G),this.disposables.add(le(()=>{Z.dispose(),re.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)}))}))}))}getChannel(T,x){const V=this;return{call(U,le,he){let K;if((0,E.isFunction)(x)){const N=(0,n.getRandomElement)(V.connections.filter(x));K=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,x))}else K=x.routeCall(V,U,le);const W=K.then(N=>N.channelClient.getChannel(T));return F(W).call(U,le,he)},listen(U,le){if((0,E.isFunction)(x))return V.getMulticastEvent(T,x,U,le);const he=x.routeEvent(V,U,le).then(K=>K.channelClient.getChannel(T));return F(he).listen(U,le)}}}getMulticastEvent(T,x,V,U){const le=this;let he;const K=new h.Emitter({onWillAddFirstListener:()=>{he=new l.DisposableStore;const W=new h.EventMultiplexer,N=new Map,Z=G=>{const H=G.channelClient.getChannel(T).listen(V,U),$=W.add(H);N.set(G,$)},re=G=>{const q=N.get(G);q&&(q.dispose(),N.delete(G))};le.connections.filter(x).forEach(Z),h.Event.filter(le.onDidAddConnection,x)(Z,void 0,he),le.onDidRemoveConnection(re,void 0,he),W.event(K.fire,K,he),he.add(W)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(T,x){this.channels.set(T,x);for(const V of this._connections)V.channelServer.registerChannel(T,x)}dispose(){this.disposables.dispose();for(const T of this._connections)T.channelClient.dispose(),T.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class A{constructor(T,x,V=null){const U=new t;u(U,x),T.send(U.buffer),this.channelClient=new L(T,V),this.channelServer=new k(T,x,V)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,x){this.channelServer.registerChannel(T,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function F(B){return{call(T,x,V){return B.then(U=>U.call(T,x,V))},listen(T,x){const V=new h.Relay;return B.then(U=>V.input=U.listen(T,x)),V.event}}}function _(B){let T=!1;return{call(x,V,U){return T?B.call(x,V,U):(0,D.timeout)(0).then(()=>T=!0).then(()=>B.call(x,V,U))},listen(x,V){if(T)return B.listen(x,V);const U=new h.Relay;return(0,D.timeout)(0).then(()=>T=!0).then(()=>U.input=B.listen(x,V)),U.event}}}class z{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const x of T.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await h.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=z;var j;(function(B){function T(le,he,K){const W=le,N=K&&K.disableMarshalling,Z=new Map;for(const re in W)V(re)&&Z.set(re,h.Event.buffer(W[re],!0,void 0,he));return new class{listen(re,G,q){const H=Z.get(G);if(H)return H;const $=W[G];if(typeof $=="function"){if(U(G))return $.call(W,q);if(V(G))return Z.set(G,h.Event.buffer(W[G],!0,void 0,he)),Z.get(G)}throw new P.ErrorNoTelemetry(`Event not found: ${G}`)}call(re,G,q){const H=W[G];if(typeof H=="function"){if(!N&&Array.isArray(q))for(let se=0;se<q.length;se++)q[se]=(0,v.revive)(q[se]);let $=H.apply(W,q);return $ instanceof Promise||($=Promise.resolve($)),$}throw new P.ErrorNoTelemetry(`Method not found: ${G}`)}}}B.fromService=T;function x(le,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(W,N){if(typeof N=="string")return he?.properties?.has(N)?he.properties.get(N):U(N)?function(Z){return le.listen(N,Z)}:V(N)?le.listen(N):async function(...Z){let re;he&&!(0,E.isUndefinedOrNull)(he.context)?re=[he.context,...Z]:re=Z;const G=await le.call(N,re);return K?G:(0,v.revive)(G)};throw new P.ErrorNoTelemetry(`Property not found: ${String(N)}`)}})}B.toService=x;function V(le){return le[0]==="o"&&le[1]==="n"&&y.isUpperAsciiLetter(le.charCodeAt(2))}function U(le){return/^onDynamic/.test(le)&&y.isUpperAsciiLetter(le.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function ue(B){return Array.isArray(B)?B.map(te):te(B)}function X(B,T,x,V,U,le,he){he=ue(he);const K=ce[U],W=K[V%K.length];let N=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(le)?(N=N.concat(he),N.push(")")):N.push(he),console.log.apply(console,N)}class Y{constructor(T,x){this._outgoingPrefix=T,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,x,V,U,le){this._totalOutgoing+=T,X(this._outgoingPrefix,this._totalOutgoing,T,x,V,U,le)}logIncoming(T,x,V,U,le){this._totalIncoming+=T,X(this._incomingPrefix,this._totalIncoming,T,x,V,U,le)}}e.IPCLogger=Y}),define(oe[159],ae([0,1,17,3,44]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class O{constructor(h){this.port=h,this.onMessage=D.Event.fromDOMEventEmitter(this.port,"message",l=>l.data?n.VSBuffer.wrap(l.data):n.VSBuffer.alloc(0)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=O;class C extends I.IPCClient{constructor(h,l){const v=new O(h);super(v,l),this.protocol=v}dispose(){this.protocol.disconnect(),super.dispose()}}e.Client=C}),define(oe[113],ae([0,1,17,3,2,44]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let u=0;function S(M,L){if(!r.has(M)){const R=String(++u);r.set(M,R)}return r.get(M)}function k(M,L,R,A){if(!i.enableDiagnostics)return;const F=S(M,L);if(A instanceof n.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const _=n.VSBuffer.alloc(A.byteLength);_.set(A),i.records.push({timestamp:Date.now(),id:F,label:L,type:R,buff:_})}else i.records.push({timestamp:Date.now(),id:F,label:L,type:R,data:A})}i.traceSocketEvent=k})(P||(e.SocketDiagnostics=P={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function v(){return l||(l=n.VSBuffer.alloc(0)),l}class y{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,u){if(r===0)return v();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const L=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=r),L}if(this._chunks[0].byteLength>r){const L=this._chunks[0].slice(0,r);return u&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),L}const S=n.VSBuffer.alloc(r);let k=0,M=0;for(;r>0;){const L=this._chunks[M];if(L.byteLength>r){const R=L.slice(0,r);S.set(R,k),k+=r,u&&(this._chunks[M]=L.slice(r),this._totalLength-=r),r-=r}else S.set(L,k),k+=L.byteLength,u?(this._chunks.shift(),this._totalLength-=L.byteLength):M++,r-=L.byteLength}return S}}e.ChunkStream=y;var E;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(E||(E={}));function g(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class b{constructor(r,u,S,k){this.type=r,this.id=u,this.ack=S,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends I.Disposable{constructor(r){super(),this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:g(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const S=this._state.messageType,k=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new b(S,k,M,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.VSBuffer.alloc(13);u.writeUInt8(r.type,0),u.writeUInt32BE(r.id,1),u.writeUInt32BE(r.ack,5),u.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:g(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(u,r.data)}_bufferAdd(r,u){const S=this._totalLength===0;return this._data.push(r,u),this._totalLength+=r.byteLength+u.byteLength,S}_bufferTake(){const r=n.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,u){this._bufferAdd(r,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class d extends I.Disposable{constructor(r){super(),this._onMessage=new D.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new b(1,0,0,r))}}e.Protocol=d;class c extends O.IPCClient{static fromSocket(r,u){return new c(new d(r),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(r,u,S=null){super(r,u,S),this.protocol=r}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new D.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class a{constructor(r){this.data=r,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let r=0,u=this._first;for(;u;)u=u.next,r++;return r}peek(){return this._first?this._first.data:null}toArray(){const r=[];let u=0,S=this._first;for(;S;)r[u++]=S.data,S=S.next;return r}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const u=new a(r);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const r=Date.now();for(let u=0;u<o._HISTORY_LENGTH;u++)this.lastRuns[u]=r-1e3*u;setInterval(()=>{for(let u=o._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const r=Date.now(),u=(1+o._HISTORY_LENGTH)*1e3;let S=0;for(let k=0;k<o._HISTORY_LENGTH;k++)r-this.lastRuns[k]<=u&&S++;return 1-S/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(r){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=r.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=r.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new I.DisposableStore,this._socket=r.socket,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.add(this._socket.onClose(u=>this._onSocketClose.fire(u))),r.initialChunk&&this._socketReader.acceptChunk(r.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new b(5,0,0,v());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new b(7,0,0,v());this._socketWriter.write(r)}sendResume(){const r=new b(8,0,0,v());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,u){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new I.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=this._socketDisposables.add(new p(this._socket)),this._socketReader=this._socketDisposables.add(new w(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.add(this._socket.onClose(S=>this._onSocketClose.fire(S))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,v());this._socketWriter.write(r);const u=this._outgoingUnackMsg.toArray();for(let S=0,k=u.length;S<k;S++)this._socketWriter.write(u[S]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new b(6,0,0,v())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let S=0,k=u.length;S<k;S++)this._socketWriter.write(u[S]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const S=new b(1,u,this._incomingAckId,r);this._outgoingUnackMsg.push(S),this._isReconnecting||(this._socketWriter.write(S),this._recvAckCheck())}sendControl(r){const u=new b(2,0,0,r);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),u=Date.now()-r.writtenTime,S=Date.now()-this._socketReader.lastReadTime,k=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&S>=2e4&&k>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:S});return}const M=Math.max(2e4-u,2e4-S,2e4-k,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new b(3,0,this._incomingAckId,v());this._socketWriter.write(r)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const r=new b(9,0,this._incomingAckId,v());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(oe[37],ae([0,1,14,15,13]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class O{constructor(){this.mapListenerToWrapper=new WeakMap}on(P,h){const l=(v,...y)=>{this.validateEvent(P,v)&&h(v,...y)};return this.mapListenerToWrapper.set(h,l),n.ipcMain.on(P,l),this}once(P,h){return n.ipcMain.once(P,(l,...v)=>{this.validateEvent(P,l)&&h(l,...v)}),this}handle(P,h){return n.ipcMain.handle(P,(l,...v)=>this.validateEvent(P,l)?h(l,...v):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return n.ipcMain.removeHandler(P),this}removeListener(P,h){const l=this.mapListenerToWrapper.get(h);return l&&(n.ipcMain.removeListener(P,l),this.mapListenerToWrapper.delete(h)),this}validateEvent(P,h){if(!P||!P.startsWith("vscode:"))return(0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const l=h.senderFrame,v=l.url;if(!v||v==="about:blank")return!0;let y="unknown";try{y=new URL(v).host}catch{return(0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${v}'.`),!1}return y!==I.VSCODE_AUTHORITY?((0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${y}'.`),!1):l.parent!==null?((0,D.onUnexpectedError)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new O}),define(oe[160],ae([0,1,14,37,148]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=O;function O(){D.validatedIpcMain.on(I.CONTEXT_MENU_CHANNEL,(P,h,l,v,y)=>{const E=C(P,v,l);E.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{E&&P.sender.send(I.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}function C(P,h,l){const v=new n.Menu;return l.forEach(y=>{let E;y.type==="separator"?E=new n.MenuItem({type:y.type}):Array.isArray(y.submenu)?E=new n.MenuItem({submenu:C(P,h,y.submenu),label:y.label}):E=new n.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(g,m,b)=>P.sender.send(h,y.id,b)}),v.append(E)}),v}}),define(oe[161],ae([0,1,37,17,3,2,44,149]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(v,y){const E=I.Event.fromNodeEventEmitter(n.validatedIpcMain,y,(m,b)=>({event:m,message:b})),g=I.Event.filter(E,({event:m})=>m.sender.id===v);return I.Event.map(g,({message:m})=>m&&D.VSBuffer.wrap(m))}class l extends C.IPCServer{static{this.Clients=new Map}static getOnDidClientConnect(){const y=I.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:hello",({sender:E})=>E);return I.Event.map(y,E=>{const g=E.id;l.Clients.get(g)?.dispose();const b=new I.Emitter;l.Clients.set(g,(0,O.toDisposable)(()=>b.fire()));const w=h(g,"vscode:message"),p=I.Event.any(I.Event.signal(h(g,"vscode:disconnect")),b.event);return{protocol:new P.Protocol(E,w),onDidClientDisconnect:p}})}constructor(){super(l.getOnDidClientConnect())}}e.Server=l}),define(oe[114],ae([0,1,37,3,33,159]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=void 0,e.connect=P;class C extends O.Client{constructor(l,v){super({addEventListener:(y,E)=>l.addListener(y,E),removeEventListener:(y,E)=>l.removeListener(y,E),postMessage:y=>l.postMessage(y),start:()=>l.start(),close:()=>l.close()},v)}}e.Client=C;async function P(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,I.generateUuid)();h.webContents.send("vscode:createMessageChannel",l);const v=D.Event.fromNodeEventEmitter(n.validatedIpcMain,"vscode:createMessageChannelResult",(E,g)=>({nonce:g,port:E.ports[0]})),{port:y}=await D.Event.toPromise(D.Event.once(D.Event.filter(v,E=>E.nonce===l)));return y}}),define(oe[162],ae([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends g.ChannelServer{constructor(p){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",d=>I.VSBuffer.wrap(Buffer.from(d,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=m;class b{constructor(p,d){this.modulePath=p,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new D.Delayer(c),this.child=null,this._client=null}getChannel(p){const d=this;return{call(c,f,a){return d.requestPromise(p,c,f,a)},listen(c,f){return d.requestEvent(p,c,f)}}}requestPromise(p,d,c,f=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(p),t=(0,D.createCancelablePromise)(i=>a.call(d,c,i)),o=f.onCancellationRequested(()=>t.cancel()),s=(0,l.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{o.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,d,c){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let f;const a=new h.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(p).listen(d,c)(a.fire,a),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,E.removeDangerousEnvVariables)(d.env),this.child=(0,n.fork)(this.modulePath,p,d);const c=new h.Emitter,a=h.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,C.isRemoteConsoleLog)(u)){(0,C.log)(u,`IPC Library: ${this.options.serverName}`);return}c.fire(I.VSBuffer.wrap(Buffer.from(u,"base64")))}),t=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,o=u=>this.child&&this.child.connected&&t.send(u.buffer.toString("base64")),s=c.event,i={send:o,onMessage:s};this._client=new g.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,S)=>{process.removeListener("exit",r),a.dispose(),this.activeRequests.forEach(k=>(0,l.dispose)(k)),this.activeRequests.clear(),u!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:S})})}return this._client}getCachedChannel(p){let d=this.channels.get(p);return d||(d=this.client.getChannel(p),this.channels.set(p,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(oe[115],ae([0,1,8,3,2,77,12]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=h;var P;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function h(E){const g=E;return g?.changed instanceof Map||g?.deleted instanceof Set}var l;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(l||(e.StorageState=l={}));class v extends I.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(g,m=Object.create(null)){super(),this.database=g,this.options=m,this._onDidChangeStorage=this._register(new D.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=this._register(new n.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){this._onDidChangeStorage.pause();try{g.changed?.forEach((m,b)=>this.acceptExternal(b,m)),g.deleted?.forEach(m=>this.acceptExternal(m,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(g,m){if(this.state===l.Closed)return;let b=!1;(0,C.isUndefinedOrNull)(m)?b=this.cache.delete(g):this.cache.get(g)!==m&&(this.cache.set(g,m),b=!0),b&&this._onDidChangeStorage.fire({key:g,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,m){const b=this.cache.get(g);return(0,C.isUndefinedOrNull)(b)?m:b}getBoolean(g,m){const b=this.get(g);return(0,C.isUndefinedOrNull)(b)?m:b==="true"}getNumber(g,m){const b=this.get(g);return(0,C.isUndefinedOrNull)(b)?m:parseInt(b,10)}getObject(g,m){const b=this.get(g);return(0,C.isUndefinedOrNull)(b)?m:(0,O.parse)(b)}async set(g,m,b=!1){if(this.state===l.Closed)return;if((0,C.isUndefinedOrNull)(m))return this.delete(g,b);const w=(0,C.isObject)(m)||Array.isArray(m)?(0,O.stringify)(m):String(m);if(this.cache.get(g)!==w)return this.cache.set(g,w),this.pendingInserts.set(g,w),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire({key:g,external:b}),this.doFlush()}async delete(g,m=!1){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire({key:g,external:m}),this.doFlush()}async optimize(){if(this.state!==l.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(this.hasPending)return this.doFlush(g)}async doFlush(g){return this.options.hint===P.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}isInMemory(){return this.options.hint===P.STORAGE_IN_MEMORY}}e.Storage=v;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert?.forEach((m,b)=>this.items.set(b,m)),g.delete?.forEach(m=>this.items.delete(m))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=y}),define(oe[163],ae([0,1,8,3,32,9,21]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return D.Event.None}static{this.BUSY_OPEN_TIMEOUT=2e3}static{this.MAX_HOST_PARAMETERS=256}constructor(v,y=Object.create(null)){this.path=v,this.options=y,this.name=(0,O.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}async getItems(){const v=await this.whenConnected,y=new Map;return(await this.all(v,"SELECT * FROM ItemTable")).forEach(g=>y.set(g.key,g.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${y.size} rows`),y}async updateItems(v){const y=await this.whenConnected;return this.doUpdateItems(y,v)}doUpdateItems(v,y){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${y.insert?(0,I.mapToString)(y.insert):"0"}), delete(${y.delete?(0,I.setToString)(y.delete):"0"})`),this.transaction(v,()=>{const E=y.insert,g=y.delete;if(E&&E.size>0){const m=[];m.push([]);let b=0;E.forEach((w,p)=>{let d=m[b];d.length>P.MAX_HOST_PARAMETERS&&(b++,d=[],m.push(d)),d.push(p,w)}),m.forEach(w=>{this.prepare(v,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,p=>p.run(w),()=>{const p=[];let d=0;return E.forEach((c,f)=>{p.push(f),d+=c.length}),`Keys: ${p.join(", ")} Length: ${d}`})})}if(g&&g.size){const m=[];m.push([]);let b=0;g.forEach(w=>{let p=m[b];p.length>P.MAX_HOST_PARAMETERS&&(b++,p=[],m.push(p)),p.push(w)}),m.forEach(w=>{this.prepare(v,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,p=>p.run(w),()=>{const p=[];return g.forEach(d=>{p.push(d)}),`Keys: ${p.join(", ")}`})})}})}async optimize(){this.logger.trace(`[storage ${this.name}] vacuum()`);const v=await this.whenConnected;return this.exec(v,"VACUUM")}async close(v){this.logger.trace(`[storage ${this.name}] close()`);const y=await this.whenConnected;return this.doClose(y,v)}doClose(v,y){return new Promise((E,g)=>{v.db.close(m=>(m&&this.handleSQLiteError(v,`[storage ${this.name}] close(): ${m}`),this.path===P.IN_MEMORY_PATH?E():!v.isErroneous&&!v.isInMemory?this.backup().then(E,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),E())):typeof y=="function"?C.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const w=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:y()}).then(()=>w(),p=>(w(),Promise.reject(p)))})).then(E,g):g(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const v=this.toBackupPath(this.path);return C.Promises.copy(this.path,v,{preserveSymlinks:!1})}toBackupPath(v){return`${v}.backup`}async checkIntegrity(v){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${v})`);const y=await this.whenConnected,E=await this.get(y,v?"PRAGMA integrity_check":"PRAGMA quick_check"),g=v?E.integrity_check:E.quick_check;return y.isErroneous?`${g} (last error: ${y.lastError})`:y.isInMemory?`${g} (in-memory!)`:g}async connect(v,y=!0){this.logger.trace(`[storage ${this.name}] open(${v}, retryOnBusy: ${y})`);try{return await this.doConnect(v)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&y)return await(0,n.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(v,!1);try{await C.Promises.unlink(v);try{await C.Promises.rename(this.toBackupPath(v),v,!1)}catch{}return await this.doConnect(v)}catch(g){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${g}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(v,y){v.isErroneous=!0,v.lastError=y,this.logger.error(y)}doConnect(v){return new Promise((y,E)=>{new Promise((g,m)=>{Q(["@vscode/sqlite3"],g,m)}).then(g=>{const m={db:new(this.logger.isTracing?g.verbose().Database:g.Database)(v,b=>b?m.db&&b.code!=="SQLITE_CANTOPEN"?m.db.close(()=>E(b)):E(b):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(m),w=>m.db.close(()=>E(w)))),isInMemory:v===P.IN_MEMORY_PATH};m.db.on("error",b=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&m.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},E)})}exec(v,y){return new Promise((E,g)=>{v.db.exec(y,m=>m?(this.handleSQLiteError(v,`[storage ${this.name}] exec(): ${m}`),g(m)):E())})}get(v,y){return new Promise((E,g)=>{v.db.get(y,(m,b)=>m?(this.handleSQLiteError(v,`[storage ${this.name}] get(): ${m}`),g(m)):E(b))})}all(v,y){return new Promise((E,g)=>{v.db.all(y,(m,b)=>m?(this.handleSQLiteError(v,`[storage ${this.name}] all(): ${m}`),g(m)):E(b))})}transaction(v,y){return new Promise((E,g)=>{v.db.serialize(()=>{v.db.run("BEGIN TRANSACTION"),y(),v.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(v,`[storage ${this.name}] transaction(): ${m}`),g(m)):E())})})}prepare(v,y,E,g){const m=v.db.prepare(y),b=w=>{this.handleSQLiteError(v,`[storage ${this.name}] prepare(): ${w} (${y}). Details: ${g()}`)};m.on("error",b),E(m),m.finalize(w=>{w&&b(w),m.removeListener("error",b)})}}e.SQLiteStorageDatabase=P;class h{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor(v){v&&typeof v.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=v.logTrace),v&&typeof v.logError=="function"&&(this.logError=v.logError)}get isTracing(){return!!this.logTrace}trace(v){this.logTrace?.(v)}error(v){this.logError?.(v)}}}),define(oe[164],ae([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(oe[165],ae([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[166],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[167],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(oe[168],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[169],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[170],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[171],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[172],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[173],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[174],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[175],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[176],ae([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[177],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[178],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[179],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[180],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[181],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[182],ae([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[183],ae([11,10]),function(Q,e){return Q.create("vs/platform/log/common/log",e)}),define(oe[184],ae([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[185],ae([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[186],ae([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[187],ae([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[188],ae([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[189],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[190],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[191],ae([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[192],ae([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[193],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[194],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[195],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[196],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[197],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[198],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isFolderBackupInfo=n,e.isWorkspaceBackupInfo=D;function n(I){return I&&I.hasOwnProperty("folderUri")}function D(I){return I&&I.hasOwnProperty("workspace")}}),define(oe[199],ae([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=D,e.deserializeWorkspaceInfos=I,e.deserializeFolderInfos=O;function D(C){return typeof C?.backupFolder=="string"}function I(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return P}function O(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return P}}),define(oe[200],ae([0,1,15,167]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var I;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(I||(e.TokenType=I={}));function O(...l){switch(l.length){case 1:return(0,D.localize)(0,null,l[0]);case 2:return(0,D.localize)(1,null,l[0],l[1]);case 3:return(0,D.localize)(2,null,l[0],l[1],l[2]);default:return}}const C=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(v){return this._input=v,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const y=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:y})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const y=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:y})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(v){return this._isAtEnd()||this._input.charCodeAt(this._current)!==v?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(v){this._tokens.push({type:v,offset:this._start})}_error(v){const y=this._start,E=this._input.substring(this._start,this._current),g={type:19,offset:this._start,lexeme:E};this._errors.push({offset:y,lexeme:E,additionalInfo:v}),this._tokens.push(g)}_string(){this.stringRe.lastIndex=this._start;const v=this.stringRe.exec(this._input);if(v){this._current=this._start+v[0].length;const y=this._input.substring(this._start,this._current),E=h._keywords.get(y);E?this._addToken(E):this._tokens.push({type:17,lexeme:y,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(C);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let v=this._current,y=!1,E=!1;for(;;){if(v>=this._input.length){this._current=v,this._error(P);return}const m=this._input.charCodeAt(v);if(y)y=!1;else if(m===47&&!E){v++;break}else m===91?E=!0:m===92?y=!0:m===93&&(E=!1);v++}for(;v<this._input.length&&h._regexFlags.has(this._input.charCodeAt(v));)v++;this._current=v;const g=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:g,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(oe[201],ae([0,1,3,2]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class I{constructor(){this._onCloseEmitter=new n.Emitter,this._onReloadEmitter=new n.Emitter,this._onTerminateEmitter=new n.Emitter,this._onAttachEmitter=new n.Emitter}static{this.ChannelName="extensionhostdebugservice"}call(P,h,l){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(P,h,l){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=I;class O extends D.Disposable{constructor(P){super(),this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,h,l){this.channel.call("attach",[P,h,l])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,h){this.channel.call("terminate",[P,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,h){return this.channel.call("openExtensionDevelopmentHostWindow",[P,h])}}e.ExtensionHostDebugChannelClient=O}),define(oe[202],ae([0,1,151,51,13,9,36,19,7]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=v,e.parseDebugParams=y,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,O.dirname)(I.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,n.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",g)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(h.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=C.env.VSCODE_PORTABLE;return g?h.URI.file((0,O.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,O.resolve)(g):(0,O.normalize)((0,O.join)(I.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?h.URI.file((0,O.resolve)(g)):h.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,O.resolve)(g);const m=C.env.VSCODE_EXTENSIONS;if(m)return m;const b=C.env.VSCODE_PORTABLE;return b?(0,O.join)(b,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(m=>/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,O.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,O.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const m of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);b&&b[1]&&b[2]&&g.push([b[1],b[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=C.env.VSCODE_PORTABLE;return g?h.URI.file((0,O.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this._args}constructor(g,m,b){this._args=g,this.paths=m,this.productService=b,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,Pe([D.memoize],l.prototype,"appRoot",null),Pe([D.memoize],l.prototype,"userHome",null),Pe([D.memoize],l.prototype,"userDataPath",null),Pe([D.memoize],l.prototype,"appSettingsHome",null),Pe([D.memoize],l.prototype,"tmpDir",null),Pe([D.memoize],l.prototype,"cacheHome",null),Pe([D.memoize],l.prototype,"stateResource",null),Pe([D.memoize],l.prototype,"userRoamingDataHome",null),Pe([D.memoize],l.prototype,"userDataSyncHome",null),Pe([D.memoize],l.prototype,"sync",null),Pe([D.memoize],l.prototype,"machineSettingsResource",null),Pe([D.memoize],l.prototype,"workspaceStorageHome",null),Pe([D.memoize],l.prototype,"localHistoryHome",null),Pe([D.memoize],l.prototype,"keyboardLayoutResource",null),Pe([D.memoize],l.prototype,"argvResource",null),Pe([D.memoize],l.prototype,"isExtensionDevelopment",null),Pe([D.memoize],l.prototype,"untitledWorkspacesHome",null),Pe([D.memoize],l.prototype,"builtinExtensionsPath",null),Pe([D.memoize],l.prototype,"extensionsPath",null),Pe([D.memoize],l.prototype,"extensionDevelopmentLocationURI",null),Pe([D.memoize],l.prototype,"extensionDevelopmentKind",null),Pe([D.memoize],l.prototype,"extensionTestsLocationURI",null),Pe([D.memoize],l.prototype,"debugExtensionHost",null),Pe([D.memoize],l.prototype,"logLevel",null),Pe([D.memoize],l.prototype,"extensionLogLevel",null),Pe([D.memoize],l.prototype,"serviceMachineIdResource",null),Pe([D.memoize],l.prototype,"disableTelemetry",null),Pe([D.memoize],l.prototype,"disableWorkspaceTrust",null),Pe([D.memoize],l.prototype,"useInMemorySecretStorage",null),Pe([D.memoize],l.prototype,"policyFile",null);function v(E,g){return y(E["inspect-extensions"],E["inspect-brk-extensions"],5870,g,E.debugId,E.extensionEnvironment)}function y(E,g,m,b,w,p){const c=Number(g||E)||(b?null:m),f=c?!!g:!1;let a;if(p)try{a=JSON.parse(p)}catch{}return{port:c,break:f,debugId:w,env:a}}}),define(oe[116],ae([0,1,313,4,170]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=P,e.formatOptions=l,e.buildHelpMessage=g,e.buildVersionMessage=m;const O={o:(0,I.localize)(0,null),e:(0,I.localize)(1,null),t:(0,I.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,I.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,I.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,I.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,I.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,I.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,I.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,I.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,I.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,I.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,I.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,I.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,I.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,I.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,I.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,I.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,I.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,I.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,I.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,I.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,I.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,I.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,I.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,I.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,I.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,I.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,I.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,I.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,I.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,I.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,I.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,I.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,I.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,I.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(b,w,p=C){const d=b.find(u=>u.length>0&&u[0]!=="-"),c={},f=["_"],a=[],t={};let o;for(const u in w){const S=w[u];S.type==="subcommand"?u===d&&(o=S):(S.alias&&(c[u]=S.alias),S.type==="string"||S.type==="string[]"?(f.push(u),S.deprecates&&f.push(...S.deprecates)):S.type==="boolean"&&(a.push(u),S.deprecates&&a.push(...S.deprecates)),S.global&&(t[u]=S))}if(o&&d){const u=t;for(const L in o.options)u[L]=o.options[L];const S=b.filter(L=>L!==d),k=p.getSubcommandReporter?p.getSubcommandReporter(d):void 0,M=P(S,u,k);return{[d]:M,_:[]}}const s=n(b,{string:f,boolean:a,alias:c}),i={},r=s;i._=s._.map(u=>String(u)).filter(u=>u.length>0),delete r._;for(const u in w){const S=w[u];if(S.type==="subcommand")continue;S.alias&&delete r[S.alias];let k=r[u];if(S.deprecates)for(const M of S.deprecates)r.hasOwnProperty(M)&&(k||(k=r[M],k&&p.onDeprecatedOption(M,S.deprecationMessage||(0,I.localize)(38,null,u))),delete r[M]);if(typeof k<"u"){if(S.type==="string[]"){if(Array.isArray(k)||(k=[k]),!S.allowEmptyValue){const M=k.filter(L=>L.length>0);M.length!==k.length&&(p.onEmptyValue(u),k=M.length>0?M:void 0)}}else S.type==="string"&&(Array.isArray(k)?(k=k.pop(),p.onMultipleValues(u,k)):!k&&!S.allowEmptyValue&&(p.onEmptyValue(u),k=void 0));i[u]=k,S.deprecationMessage&&p.onDeprecatedOption(u,S.deprecationMessage)}delete r[u]}for(const u in r)p.onUnknownOption(u);return i}function h(b,w){let p="";return w.args&&(Array.isArray(w.args)?p=` <${w.args.join("> <")}>`:p=` <${w.args}>`),w.alias?`-${w.alias} --${b}${p}`:`--${b}${p}`}function l(b,w){const p=[];for(const d in b){const c=b[d],f=h(d,c);p.push([f,c.description])}return v(p,w)}function v(b,w){const d=b.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-d<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=w-d-1,f=[];for(const a of b){const t=a[0],o=E(a[1],c),s=y(d-t.length-2);f.push("  "+t+s+o[0]);for(let i=1;i<o.length;i++)f.push(y(d)+o[i])}return f}function y(b){return" ".repeat(b)}function E(b,w){const p=[];for(;b.length;){const d=b.length<w?b.length:b.lastIndexOf(" ",w),c=b.slice(0,d).trim();b=b.slice(d),p.push(c)}return p}function g(b,w,p,d,c){const f=process.stdout.isTTY&&process.stdout.columns||80,a=c?.noInputFiles!==!0?`[${(0,I.localize)(39,null)}...]`:"",t=[`${b} ${p}`];t.push(""),t.push(`${(0,I.localize)(40,null)}: ${w} [${(0,I.localize)(41,null)}]${a}`),t.push(""),c?.noPipe!==!0&&(D.isWindows?t.push((0,I.localize)(42,null,w)):t.push((0,I.localize)(43,null,w)),t.push(""));const o={},s=[];for(const i in d){const r=d[i];if(r.type==="subcommand")r.description&&s.push({command:i,description:r.description});else if(r.description&&r.cat){let u=o[r.cat];u||(o[r.cat]=u={}),u[i]=r}}for(const i in o){const r=i,u=o[r];u&&(t.push(O[r]),t.push(...l(u,f)),t.push(""))}return s.length&&(t.push((0,I.localize)(44,null)),t.push(...v(s.map(i=>[i.command,i.description]),f)),t.push("")),t.join(`
`)}function m(b,w){return`${b||(0,I.localize)(45,null)}
${w||(0,I.localize)(46,null)}
${process.arch}`}}),define(oe[203],ae([0,1,88,201,116]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class O extends D.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.windowsMainService=P}call(P,h,l){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(l[0],l[1]):super.call(P,h,l)}async openExtensionDevelopmentHostWindow(P,h){const l=(0,I.parseArgs)(P,I.OPTIONS);l.debugRenderer=h;const v=l.extensionDevelopmentPath;if(!v)return{success:!1};const[y]=await this.windowsMainService.openExtensionDevelopmentHostWindow(v,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const E=y.win;if(!E)return{success:!0};const g=E.webContents.debugger;let m=g.isAttached()?1/0:0;const b=(0,n.createServer)(w=>{m++===0&&g.attach();let p=!1;const d=a=>{p||w.write(JSON.stringify(a)+"\0")},c=(a,t,o,s)=>d({method:t,params:o,sessionId:s});E.on("close",()=>{g.removeListener("message",c),w.end(),p=!0}),g.addListener("message",c);let f=Buffer.alloc(0);w.on("data",a=>{f=Buffer.concat([f,a]);for(let t=f.indexOf(0);t!==-1;t=f.indexOf(0)){let o;try{const s=f.slice(0,t).toString("utf8");f=f.slice(t+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}g.sendCommand(o.method,o.params,o.sessionId).then(s=>d({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>d({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{p=!0,--m===0&&g.detach()})});return await new Promise(w=>b.listen(0,w)),E.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=O}),define(oe[64],ae([0,1,314,171,116]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseMainProcessArgv=P,e.parseCLIProcessArgv=h,e.addArg=l,e.isLaunchedFromCli=v;function O(y,E){const g=(c,f)=>{console.warn((0,D.localize)(0,null,c,f))},m=c=>{console.warn((0,D.localize)(1,null,c))},b=(c,f)=>{console.warn((0,D.localize)(2,null,c,f))},w=c=>({onUnknownOption:f=>{I.NATIVE_CLI_COMMANDS.includes(c)||console.warn((0,D.localize)(3,null,f,c))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:b,getSubcommandReporter:I.NATIVE_CLI_COMMANDS.includes(c)?w:void 0}),p={onUnknownOption:c=>{console.warn((0,D.localize)(4,null,c))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:b,getSubcommandReporter:w},d=(0,I.parseArgs)(y,I.OPTIONS,E?p:void 0);return d.goto&&d._.forEach(c=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,D.localize)(5,null))),d}function C(y){const E=y.findIndex(g=>!/^-/.test(g));if(E>-1)return[...y.slice(0,E),...y.slice(E+1)]}function P(y){let[,...E]=y;process.env.VSCODE_DEV&&(E=C(E)||[]);const g=!v(process.env);return O(E,g)}function h(y){let[,,...E]=y;return process.env.VSCODE_DEV&&(E=C(E)||[]),O(E,!0)}function l(y,...E){const g=y.indexOf("--");return g===-1?y.push(...E):y.splice(g,0,...E),y}function v(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function Q(e,n,D){function I(C,P){const h=O(C,P),l=[h];return e.isAbsolute(h)||l.unshift(D),e.resolve(...l)}function O(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,P);const v=C["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(y,"AppData","Roaming")}break;case"darwin":l=e.join(n.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,P)}return{getUserDataPath:I}}if(typeof define=="function")define(oe[204],ae([117,26,36]),function(e,n,D){return Q(e,n,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=Q(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[91],ae([0,1,26,202,204]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=C,e.parseSharedProcessDebugPort=P;class O extends D.AbstractNativeEnvironmentService{constructor(l,v){super(l,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,I.getUserDataPath)(l,v.nameShort)},v)}}e.NativeEnvironmentService=O;function C(h,l){return(0,D.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}function P(h,l){return(0,D.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}}),define(oe[205],ae([0,1,43,26,31]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=O;function O(C){const P=(0,I.randomPath)((0,D.tmpdir)());try{return(0,n.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(h){C&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(oe[206],ae([0,1,12,173]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=I;function I(C,P,h,l){try{O(C,P,h,l)}catch(v){C.error(v?.message??v)}return P}function O(C,P,h,l){const v=(y,E,g)=>{const m=y[E];if((0,n.isString)(m)){const b=m,w=b.length;if(w>1&&b[0]==="%"&&b[w-1]==="%"){const p=b.substr(1,w-2);let d=h[p];d===void 0&&l&&(d=l[p]);const c=typeof d=="string"?d:d?.message,f=l?.[p],a=typeof f=="string"?f:f?.message;if(!c){a||C.warn(`[${P.name}]: ${(0,D.localize)(0,null,p)}`);return}if(g&&(E==="title"||E==="category")&&a&&a!==c){const t={value:c,original:a};y[E]=t}else y[E]=c}}else if((0,n.isObject)(m))for(const b in m)m.hasOwnProperty(b)&&(b==="commands"?v(m,b,!0):v(m,b,g));else if(Array.isArray(m))for(let b=0;b<m.length;b++)v(m,b,g)};for(const y in P)P.hasOwnProperty(y)&&v(P,y)}}),define(oe[207],ae([0,1,19,74,175,208]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=h,e.parseVersion=l,e.normalizeVersion=v,e.isValidVersion=y,e.validateExtensionManifest=E,e.isValidExtensionVersion=g,e.isEngineValid=m;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function h(p){return p=p.trim(),p==="*"||C.test(p)}function l(p){if(!h(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=p.match(C);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function v(p){if(!p)return null;const d=p.majorBase,c=p.majorMustEqual,f=p.minorBase;let a=p.minorMustEqual;const t=p.patchBase;let o=p.patchMustEqual;p.hasCaret&&(d===0||(a=!1),o=!1);let s=0;if(p.preRelease){const i=P.exec(p.preRelease);if(i){const[,r,u,S]=i;s=Date.UTC(Number(r),Number(u)-1,Number(S))}}return{majorBase:d,majorMustEqual:c,minorBase:f,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:p.hasGreaterEquals,notBefore:s}}function y(p,d,c){let f;typeof p=="string"?f=v(l(p)):f=p;let a;d instanceof Date?a=d.getTime():typeof d=="string"&&(a=new Date(d).getTime());let t;if(typeof c=="string"?t=v(l(c)):t=c,!f||!t)return!1;const o=f.majorBase,s=f.minorBase,i=f.patchBase;let r=t.majorBase,u=t.minorBase,S=t.patchBase;const k=t.notBefore;let M=t.majorMustEqual,L=t.minorMustEqual,R=t.patchMustEqual;return t.isMinimum?o>r?!0:o<r?!1:s>u?!0:s<u||a&&a<k?!1:i>=S:(o===1&&r===0&&(!M||!L||!R)&&(r=1,u=0,S=0,M=!0,L=!1,R=!1),o<r?!1:o>r?!M:s<u?!1:s>u?!L:i<S?!1:i>S?!R:!(a&&a<k))}function E(p,d,c,f,a){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([D.default.Error,I.localize(0,null)]),t;if(typeof f.name!="string")return t.push([D.default.Error,I.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([D.default.Error,I.localize(2,null,"version")]),t;if(!f.engines)return t.push([D.default.Error,I.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([D.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!w(f.extensionDependencies))return t.push([D.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!w(f.activationEvents))return t.push([D.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([D.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([D.default.Warning,I.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([D.default.Error,I.localize(9,null,"main")]),t;{const i=(0,n.joinPath)(c,f.main);(0,n.isEqualOrParent)(i,c)||t.push([D.default.Warning,I.localize(10,null,i.path,c.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([D.default.Error,I.localize(11,null,"browser")]),t;{const i=(0,n.joinPath)(c,f.browser);(0,n.isEqualOrParent)(i,c)||t.push([D.default.Warning,I.localize(12,null,i.path,c.path)])}}if(!O.valid(f.version))return t.push([D.default.Error,I.localize(13,null)]),t;const o=[];if(!g(p,d,f,a,o))for(const i of o)t.push([D.default.Error,i]);return t}function g(p,d,c,f,a){return f||typeof c.main>"u"&&typeof c.browser>"u"?!0:b(p,d,c.engines.vscode,a)}function m(p,d,c){return p==="*"||b(d,c,p)}function b(p,d,c,f=[]){const a=v(l(c));if(!a)return f.push(I.localize(14,null,c)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return f.push(I.localize(15,null,c)),!1}else if(!a.majorMustEqual)return f.push(I.localize(16,null,c)),!1;return y(p,d,a)?!0:(f.push(I.localize(17,null,p,c)),!1)}function w(p){if(!Array.isArray(p))return!1;for(let d=0,c=p.length;d<c;d++)if(typeof p[d]!="string")return!1;return!0}}),define(oe[209],ae([0,1,17,33]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=I;async function I(O,C,P){let h=P&&P.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const v=(await C.readFile(O.serviceMachineIdResource)).value.toString();h=(0,D.isUUID)(v)?v:null}catch{h=null}if(!h){h=(0,D.generateUuid)();try{await C.writeFile(O.serviceMachineIdResource,n.VSBuffer.fromString(h))}catch{}}return P?.store("storage.serviceMachineId",h,-1,1),h}}),define(oe[78],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(I,O=[],C=!1){this.ctor=I,this.staticArguments=O,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=n}),define(oe[210],ae([0,1,78]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=C;const D=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function O(P,h,l){h instanceof n.SyncDescriptor||(h=new n.SyncDescriptor(h,[],!!l)),D.push([P,h])}function C(){return D}}),define(oe[211],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(O,C){this.key=O,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class D{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const C of this._nodes.values())C.outgoing.size===0&&O.push(C);return O}insertEdge(O,C){const P=this.lookupOrInsertNode(O),h=this.lookupOrInsertNode(C);P.outgoing.set(h.key,h),h.incoming.set(P.key,P)}removeNode(O){const C=this._hashFn(O);this._nodes.delete(C);for(const P of this._nodes.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(O){const C=this._hashFn(O);let P=this._nodes.get(C);return P||(P=new n(C,O),this._nodes.set(C,P)),P}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[C,P]of this._nodes)O.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,C]of this._nodes){const P=new Set([O]),h=this._findCycle(C,P);if(h)return h}}_findCycle(O,C){for(const[P,h]of O.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const l=this._findCycle(h,C);if(l)return l;C.delete(P)}}}e.Graph=D}),define(oe[6],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=I,e.refineServiceDecorator=O;var n;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(n||(e._util=n={})),e.IInstantiationService=I("instantiationService");function D(C,P,h){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:C,index:h}):(P[n.DI_DEPENDENCIES]=[{id:C,index:h}],P[n.DI_TARGET]=P)}function I(C){if(n.serviceIds.has(C))return n.serviceIds.get(C);const P=function(h,l,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,h,v)};return P.toString=()=>C,n.serviceIds.set(C,P),P}function O(C){return C}}),define(oe[79],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuxiliaryWindowsMainService=void 0,e.IAuxiliaryWindowsMainService=(0,n.createDecorator)("auxiliaryWindowsMainService")}),define(oe[65],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,n.createDecorator)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=C,e.ConfigurationTargetToString=h,e.isConfigured=l,e.toValuesTree=v,e.addToValueTree=y,e.removeFromValueTree=E,e.getConfigurationValue=m,e.merge=b,e.getLanguageTagSettingPlainKey=w,e.IConfigurationService=(0,I.createDecorator)("configurationService");function O(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof D.URI)}function C(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof D.URI)}var P;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function h(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function l(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function v(p,d){const c=Object.create(null);for(const f in p)y(c,f,p[f],d);return c}function y(p,d,c,f){const a=d.split("."),t=a.pop();let o=p;for(let s=0;s<a.length;s++){const i=a[s];let r=o[i];switch(typeof r){case"undefined":r=o[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}o=r}if(typeof o=="object"&&o!==null)try{o[t]=c}catch{f(`Ignoring ${d} as ${a.join(".")} is ${JSON.stringify(o)}`)}else f(`Ignoring ${d} as ${a.join(".")} is ${JSON.stringify(o)}`)}function E(p,d){const c=d.split(".");g(p,c)}function g(p,d){const c=d.shift();if(d.length===0){delete p[c];return}if(Object.keys(p).indexOf(c)!==-1){const f=p[c];typeof f=="object"&&!Array.isArray(f)&&(g(f,d),Object.keys(f).length===0&&delete p[c])}}function m(p,d,c){function f(o,s){let i=o;for(const r of s){if(typeof i!="object"||i===null)return;i=i[r]}return i}const a=d.split("."),t=f(p,a);return typeof t>"u"?c:t}function b(p,d,c){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in p?n.isObject(p[f])&&n.isObject(d[f])?b(p[f],d[f],c):c&&(p[f]=d[f]):p[f]=d[f])})}function w(p){return p.replace(/[\[\]]/g,"")}}),define(oe[118],ae([0,1,4,25,200,6,166,15]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=l,e.validateWhenClauses=o,e.expressionsAreEqualWithConstantSubstitution=s,e.implies=U;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.isMacintosh),h.set("isLinux",n.isLinux),h.set("isWindows",n.isWindows),h.set("isWeb",n.isWeb),h.set("isMacNative",n.isMacintosh&&!n.isWeb),h.set("isEdge",n.isEdge),h.set("isFirefox",n.isFirefox),h.set("isChrome",n.isChrome),h.set("isSafari",n.isSafari);function l(K,W){if(h.get(K)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(K,W)}const v=Object.prototype.hasOwnProperty;var y;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const E={regexParsingWithErrorRecovery:!0},g=(0,C.localize)(0,null),m=(0,C.localize)(1,null),b=(0,C.localize)(2,null),w=(0,C.localize)(3,null),p=(0,C.localize)(4,null),d=(0,C.localize)(5,null),c=(0,C.localize)(6,null),f=(0,C.localize)(7,null);class a{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(W=E){this._config=W,this._scanner=new I.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(W){if(W===""){this._parsingErrors.push({message:g,offset:0,lexeme:"",additionalInfo:m});return}this._tokens=this._scanner.reset(W).scan(),this._current=0,this._parsingErrors=[];try{const N=this._expr();if(!this._isAtEnd()){const Z=this._peek(),re=Z.type===17?d:void 0;throw this._parsingErrors.push({message:p,offset:Z.offset,lexeme:I.Scanner.getLexeme(Z),additionalInfo:re}),a._parseError}return N}catch(N){if(N!==a._parseError)throw N;return}}_expr(){return this._or()}_or(){const W=[this._and()];for(;this._matchOne(16);){const N=this._and();W.push(N)}return W.length===1?W[0]:t.or(...W)}_and(){const W=[this._term()];for(;this._matchOne(15);){const N=this._term();W.push(N)}return W.length===1?W[0]:t.and(...W)}_term(){if(this._matchOne(2)){const W=this._peek();switch(W.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),u.INSTANCE;case 0:{this._advance();const N=this._expr();return this._consume(1,w),N?.negate()}case 17:return this._advance(),A.create(W.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",W)}}return this._primary()}_primary(){const W=this._peek();switch(W.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const N=this._expr();return this._consume(1,w),N}case 17:{const N=W.lexeme;if(this._advance(),this._matchOne(9)){const re=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),re.type!==10)throw this._errExpectedButGot("REGEX",re);const G=re.lexeme,q=G.lastIndexOf("/"),H=q===G.length-1?void 0:this._removeFlagsGY(G.substring(q+1));let $;try{$=new RegExp(G.substring(1,q),H)}catch{throw this._errExpectedButGot("REGEX",re)}return te.create(N,$)}switch(re.type){case 10:case 19:{const G=[re.lexeme];this._advance();let q=this._peek(),H=0;for(let pe=0;pe<re.lexeme.length;pe++)re.lexeme.charCodeAt(pe)===40?H++:re.lexeme.charCodeAt(pe)===41&&H--;for(;!this._isAtEnd()&&q.type!==15&&q.type!==16;){switch(q.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let pe=0;pe<q.lexeme.length;pe++)q.lexeme.charCodeAt(pe)===40?H++:re.lexeme.charCodeAt(pe)===41&&H--}if(H<0)break;G.push(I.Scanner.getLexeme(q)),this._advance(),q=this._peek()}const $=G.join(""),se=$.lastIndexOf("/"),ee=se===$.length-1?void 0:this._removeFlagsGY($.substring(se+1));let de;try{de=new RegExp($.substring(1,se),ee)}catch{throw this._errExpectedButGot("REGEX",re)}return t.regex(N,de)}case 18:{const G=re.lexeme;this._advance();let q=null;if(!(0,D.isFalsyOrWhitespace)(G)){const H=G.indexOf("/"),$=G.lastIndexOf("/");if(H!==$&&H>=0){const se=G.slice(H+1,$),ee=G[$+1]==="i"?"i":"";try{q=new RegExp(se,ee)}catch{throw this._errExpectedButGot("REGEX",re)}}}if(q===null)throw this._errExpectedButGot("REGEX",re);return te.create(N,q)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,b);const re=this._value();return t.notIn(N,re)}switch(this._peek().type){case 3:{this._advance();const re=this._value();if(this._previous().type===18)return t.equals(N,re);switch(re){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,re)}}case 4:{this._advance();const re=this._value();if(this._previous().type===18)return t.notEquals(N,re);switch(re){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,re)}}case 5:return this._advance(),j.create(N,this._value());case 6:return this._advance(),ce.create(N,this._value());case 7:return this._advance(),_.create(N,this._value());case 8:return this._advance(),z.create(N,this._value());case 13:return this._advance(),t.in(N,this._value());default:return t.has(N)}}case 20:throw this._parsingErrors.push({message:c,offset:W.offset,lexeme:"",additionalInfo:f}),a._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const W=this._peek();switch(W.type){case 17:case 18:return this._advance(),W.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(W){return W.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(W){return this._check(W)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(W,N){if(this._check(W))return this._advance();throw this._errExpectedButGot(N,this._peek())}_errExpectedButGot(W,N,Z){const re=(0,C.localize)(8,null,W,I.Scanner.getLexeme(N)),G=N.offset,q=I.Scanner.getLexeme(N);return this._parsingErrors.push({message:re,offset:G,lexeme:q,additionalInfo:Z}),a._parseError}_check(W){return this._peek().type===W}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=a;class t{static false(){return r.INSTANCE}static true(){return u.INSTANCE}static has(W){return S.create(W)}static equals(W,N){return k.create(W,N)}static notEquals(W,N){return R.create(W,N)}static regex(W,N){return te.create(W,N)}static in(W,N){return M.create(W,N)}static notIn(W,N){return L.create(W,N)}static not(W){return A.create(W)}static and(...W){return Y.create(W,null,!0)}static or(...W){return B.create(W,null,!0)}static greater(W,N){return _.create(W,N)}static greaterEquals(W,N){return z.create(W,N)}static smaller(W,N){return j.create(W,N)}static smallerEquals(W,N){return ce.create(W,N)}static{this._parser=new a({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this._parser.parse(W)}}e.ContextKeyExpr=t;function o(K){const W=new a({regexParsingWithErrorRecovery:!1});return K.map(N=>(W.parse(N),W.lexingErrors.length>0?W.lexingErrors.map(Z=>({errorMessage:Z.additionalInfo?(0,C.localize)(9,null,Z.additionalInfo):(0,C.localize)(10,null),offset:Z.offset,length:Z.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Z=>({errorMessage:Z.additionalInfo?`${Z.message}. ${Z.additionalInfo}`:Z.message,offset:Z.offset,length:Z.lexeme.length})):[]))}function s(K,W){const N=K?K.substituteConstants():void 0,Z=W?W.substituteConstants():void 0;return!N&&!Z?!0:!N||!Z?!1:N.equals(Z)}function i(K,W){return K.cmp(W)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=r;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=u;class S{static create(W,N=null){const Z=h.get(W);return typeof Z=="boolean"?Z?u.INSTANCE:r.INSTANCE:new S(W,N)}constructor(W,N){this.key=W,this.negated=N,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:x(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=h.get(this.key);return typeof W=="boolean"?W?u.INSTANCE:r.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.negated||(this.negated=A.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=S;class k{static create(W,N,Z=null){if(typeof N=="boolean")return N?S.create(W,Z):A.create(W,Z);const re=h.get(W);return typeof re=="boolean"?N===(re?"true":"false")?u.INSTANCE:r.INSTANCE:new k(W,N,Z)}constructor(W,N,Z){this.key=W,this.value=N,this.negated=Z,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=h.get(this.key);if(typeof W=="boolean"){const N=W?"true":"false";return this.value===N?u.INSTANCE:r.INSTANCE}return this}evaluate(W){return W.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(W){return W.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=k;class M{static create(W,N){return new M(W,N)}constructor(W,N){this.key=W,this.valueKey=N,this.type=10,this.negated=null}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.valueKey,W.key,W.valueKey)}equals(W){return W.type===this.type?this.key===W.key&&this.valueKey===W.valueKey:!1}substituteConstants(){return this}evaluate(W){const N=W.getValue(this.valueKey),Z=W.getValue(this.key);return Array.isArray(N)?N.includes(Z):typeof Z=="string"&&typeof N=="object"&&N!==null?v.call(N,Z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(W){return W.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=L.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=M;class L{static create(W,N){return new L(W,N)}constructor(W,N){this.key=W,this.valueKey=N,this.type=11,this._negated=M.create(W,N)}cmp(W){return W.type!==this.type?this.type-W.type:this._negated.cmp(W._negated)}equals(W){return W.type===this.type?this._negated.equals(W._negated):!1}substituteConstants(){return this}evaluate(W){return!this._negated.evaluate(W)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(W){return W.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=L;class R{static create(W,N,Z=null){if(typeof N=="boolean")return N?A.create(W,Z):S.create(W,Z);const re=h.get(W);return typeof re=="boolean"?N===(re?"true":"false")?r.INSTANCE:u.INSTANCE:new R(W,N,Z)}constructor(W,N,Z){this.key=W,this.value=N,this.negated=Z,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){const W=h.get(this.key);if(typeof W=="boolean"){const N=W?"true":"false";return this.value===N?r.INSTANCE:u.INSTANCE}return this}evaluate(W){return W.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(W){return W.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class A{static create(W,N=null){const Z=h.get(W);return typeof Z=="boolean"?Z?r.INSTANCE:u.INSTANCE:new A(W,N)}constructor(W,N){this.key=W,this.negated=N,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:x(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=h.get(this.key);return typeof W=="boolean"?W?r.INSTANCE:u.INSTANCE:this}evaluate(W){return!W.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(W){return W.mapNot(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=A;function F(K,W){if(typeof K=="string"){const N=parseFloat(K);isNaN(N)||(K=N)}return typeof K=="string"||typeof K=="number"?W(K):r.INSTANCE}class _{static create(W,N,Z=null){return F(N,re=>new _(W,re,Z))}constructor(W,N,Z){this.key=W,this.value=N,this.negated=Z,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ce.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=_;class z{static create(W,N,Z=null){return F(N,re=>new z(W,re,Z))}constructor(W,N,Z){this.key=W,this.value=N,this.negated=Z,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(W){return W.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=j.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=z;class j{static create(W,N,Z=null){return F(N,re=>new j(W,re,Z))}constructor(W,N,Z){this.key=W,this.value=N,this.negated=Z,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=j;class ce{static create(W,N,Z=null){return F(N,re=>new ce(W,re,Z))}constructor(W,N,Z){this.key=W,this.value=N,this.negated=Z,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:V(this.key,this.value,W.key,W.value)}equals(W){return W.type===this.type?this.key===W.key&&this.value===W.value:!1}substituteConstants(){return this}evaluate(W){return typeof this.value=="string"?!1:parseFloat(W.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(W){return W.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ce;class te{static create(W,N){return new te(W,N)}constructor(W,N){this.key=W,this.regexp=N,this.type=7,this.negated=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.key<W.key)return-1;if(this.key>W.key)return 1;const N=this.regexp?this.regexp.source:"",Z=W.regexp?W.regexp.source:"";return N<Z?-1:N>Z?1:0}equals(W){if(W.type===this.type){const N=this.regexp?this.regexp.source:"",Z=W.regexp?W.regexp.source:"";return this.key===W.key&&N===Z}return!1}substituteConstants(){return this}evaluate(W){const N=W.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const W=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${W}`}keys(){return[this.key]}map(W){return W.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ue.create(this)),this.negated}}e.ContextKeyRegexExpr=te;class ue{static create(W){return new ue(W)}constructor(W){this._actual=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this._actual.cmp(W._actual)}equals(W){return W.type===this.type?this._actual.equals(W._actual):!1}substituteConstants(){return this}evaluate(W){return!this._actual.evaluate(W)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(W){return new ue(this._actual.map(W))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ue;function X(K){let W=null;for(let N=0,Z=K.length;N<Z;N++){const re=K[N].substituteConstants();if(K[N]!==re&&W===null){W=[];for(let G=0;G<N;G++)W[G]=K[G]}W!==null&&(W[N]=re)}return W===null?K:W}class Y{static create(W,N,Z){return Y._normalizeArr(W,N,Z)}constructor(W,N){this.expr=W,this.negated=N,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let N=0,Z=this.expr.length;N<Z;N++){const re=i(this.expr[N],W.expr[N]);if(re!==0)return re}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let N=0,Z=this.expr.length;N<Z;N++)if(!this.expr[N].equals(W.expr[N]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:Y.create(W,this.negated,!1)}evaluate(W){for(let N=0,Z=this.expr.length;N<Z;N++)if(!this.expr[N].evaluate(W))return!1;return!0}static _normalizeArr(W,N,Z){const re=[];let G=!1;for(const q of W)if(q){if(q.type===1){G=!0;continue}if(q.type===0)return r.INSTANCE;if(q.type===6){re.push(...q.expr);continue}re.push(q)}if(re.length===0&&G)return u.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(i);for(let q=1;q<re.length;q++)re[q-1].equals(re[q])&&(re.splice(q,1),q--);if(re.length===1)return re[0];for(;re.length>1;){const q=re[re.length-1];if(q.type!==9)break;re.pop();const H=re.pop(),$=re.length===0,se=B.create(q.expr.map(ee=>Y.create([ee,H],null,Z)),null,$);se&&(re.push(se),re.sort(i))}if(re.length===1)return re[0];if(Z){for(let q=0;q<re.length;q++)for(let H=q+1;H<re.length;H++)if(re[q].negate().equals(re[H]))return r.INSTANCE;if(re.length===1)return re[0]}return new Y(re,N)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const N of this.expr)W.push(...N.keys());return W}map(W){return new Y(this.expr.map(N=>N.map(W)),null)}negate(){if(!this.negated){const W=[];for(const N of this.expr)W.push(N.negate());this.negated=B.create(W,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class B{static create(W,N,Z){return B._normalizeArr(W,N,Z)}constructor(W,N){this.expr=W,this.negated=N,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let N=0,Z=this.expr.length;N<Z;N++){const re=i(this.expr[N],W.expr[N]);if(re!==0)return re}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let N=0,Z=this.expr.length;N<Z;N++)if(!this.expr[N].equals(W.expr[N]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:B.create(W,this.negated,!1)}evaluate(W){for(let N=0,Z=this.expr.length;N<Z;N++)if(this.expr[N].evaluate(W))return!0;return!1}static _normalizeArr(W,N,Z){let re=[],G=!1;if(W){for(let q=0,H=W.length;q<H;q++){const $=W[q];if($){if($.type===0){G=!0;continue}if($.type===1)return u.INSTANCE;if($.type===9){re=re.concat($.expr);continue}re.push($)}}if(re.length===0&&G)return r.INSTANCE;re.sort(i)}if(re.length!==0){if(re.length===1)return re[0];for(let q=1;q<re.length;q++)re[q-1].equals(re[q])&&(re.splice(q,1),q--);if(re.length===1)return re[0];if(Z){for(let q=0;q<re.length;q++)for(let H=q+1;H<re.length;H++)if(re[q].negate().equals(re[H]))return u.INSTANCE;if(re.length===1)return re[0]}return new B(re,N)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const N of this.expr)W.push(...N.keys());return W}map(W){return new B(this.expr.map(N=>N.map(W)),null)}negate(){if(!this.negated){const W=[];for(const N of this.expr)W.push(N.negate());for(;W.length>1;){const N=W.shift(),Z=W.shift(),re=[];for(const G of he(N))for(const q of he(Z))re.push(Y.create([G,q],null,!1));W.unshift(B.create(re,null,!1))}this.negated=B.create(W,this,!0)}return this.negated}}e.ContextKeyOrExpr=B;class T extends S{static{this._info=[]}static all(){return T._info.values()}constructor(W,N,Z){super(W,null),this._defaultValue=N,typeof Z=="object"?T._info.push({...Z,key:W}):Z!==!0&&T._info.push({key:W,description:Z,type:N!=null?typeof N:void 0})}bindTo(W){return W.createKey(this.key,this._defaultValue)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return k.create(this.key,W)}notEqualsTo(W){return R.create(this.key,W)}}e.RawContextKey=T,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function x(K,W){return K<W?-1:K>W?1:0}function V(K,W,N,Z){return K<N?-1:K>N?1:W<Z?-1:W>Z?1:0}function U(K,W){if(K.type===0||W.type===1)return!0;if(K.type===9)return W.type===9?le(K.expr,W.expr):!1;if(W.type===9){for(const N of W.expr)if(U(K,N))return!0;return!1}if(K.type===6){if(W.type===6)return le(W.expr,K.expr);for(const N of K.expr)if(U(N,W))return!0;return!1}return K.equals(W)}function le(K,W){let N=0,Z=0;for(;N<K.length&&Z<W.length;){const re=K[N].cmp(W[Z]);if(re<0)return!1;re===0&&N++,Z++}return N===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(oe[92],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=D,e.ID="diagnosticsService",e.IDiagnosticsService=(0,n.createDecorator)(e.ID);function D(O){return!!O.hostName&&!!O.errorMessage}class I{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=I}),define(oe[119],ae([0,1,19,74,168,6,48,4,35]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=g,e.massageMessageBoxOptions=m,e.IDialogService=(0,O.createDecorator)("dialogService");var l;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(l||(l={}));class v{getConfirmationButtons(w){return this.getButtons(w,l.Confirmation)}getPromptButtons(w){return this.getButtons(w,l.Prompt)}getInputButtons(w){return this.getButtons(w,l.Input)}getButtons(w,p){const d=[];switch(p){case l.Confirmation:{const c=w;c.primaryButton?d.push(c.primaryButton):d.push((0,I.localize)(0,null)),c.cancelButton?d.push(c.cancelButton):d.push((0,I.localize)(1,null));break}case l.Prompt:{const c=w;Array.isArray(c.buttons)&&c.buttons.length>0&&d.push(...c.buttons.map(f=>f.label)),c.cancelButton&&(c.cancelButton===!0?d.push((0,I.localize)(2,null)):typeof c.cancelButton=="string"?d.push(c.cancelButton):c.cancelButton.label?d.push(c.cancelButton.label):d.push((0,I.localize)(3,null))),d.length===0&&d.push((0,I.localize)(4,null));break}case l.Input:{const c=w;c.primaryButton?d.push(c.primaryButton):d.push((0,I.localize)(5,null)),c.cancelButton?d.push(c.cancelButton):d.push((0,I.localize)(6,null));break}}return d}getDialogType(w){if(typeof w=="string")return w;if(typeof w=="number")return w===D.default.Info?"info":w===D.default.Error?"error":w===D.default.Warning?"warning":"none"}getPromptResult(w,p,d){const c=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&c.push(w.cancelButton);let f=c[p]?.run({checkboxChecked:d});return f instanceof Promise||(f=Promise.resolve(f)),{result:f,checkboxChecked:d}}}e.AbstractDialogHandler=v,e.IFileDialogService=(0,O.createDecorator)("fileDialogService");var y;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const E=10;function g(b){const w=[];return w.push(...b.slice(0,E).map(p=>typeof p=="string"?p:(0,n.basename)(p))),b.length>E&&(b.length-E===1?w.push((0,I.localize)(7,null)):w.push((0,I.localize)(8,null,b.length-E))),w.push(""),w.join(`
`)}function m(b,w){const p=(0,h.deepClone)(b);let d=(p.buttons??[]).map(t=>(0,C.mnemonicButtonLabel)(t)),c=(b.buttons||[]).map((t,o)=>o),f=0,a=p.cancelId??d.length-1;if(d.length>1){const t=typeof a=="number"?d[a]:void 0;if(P.isLinux||P.isMacintosh){if(typeof t=="string"&&d.length>1&&a!==1){d.splice(a,1),d.splice(1,0,t);const o=c[a];c.splice(a,1),c.splice(1,0,o),a=1}P.isLinux&&d.length>1&&(d=d.reverse(),c=c.reverse(),f=d.length-1,typeof t=="string"&&(a=f-1))}else if(P.isWindows&&typeof t=="string"&&d.length>1&&a!==d.length-1){d.splice(a,1),d.push(t);const o=c[a];c.splice(a,1),c.push(o),a=d.length-1}}return p.buttons=d,p.defaultId=f,p.cancelId=a,p.noLink=!0,p.title=p.title||w.nameLong,{options:p,buttonIndeces:c}}}),define(oe[120],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.IEncryptionMainService=e.IEncryptionService=void 0,e.isKwallet=O,e.isGnome=C,e.IEncryptionService=(0,n.createDecorator)("encryptionService"),e.IEncryptionMainService=(0,n.createDecorator)("encryptionMainService");var D;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(D||(e.PasswordStoreCLIOption=D={}));var I;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(I||(e.KnownStorageProvider=I={}));function O(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}}),define(oe[38],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[121],ae([0,1,172,6]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=I,e.toTargetPlatform=O,e.getTargetPlatform=C,e.isNotWebExtensionInWebTargetPlatform=P,e.isTargetPlatformCompatible=h,e.isIExtensionIdentifier=l,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function C(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":f==="ppc64le"?"linux-ppc64le":f==="riscv64"?"linux-riscv64":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(c,f){return f==="web"&&!c.includes("web")}function h(c,f,a){return P(f,a)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===a}function l(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var v;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var y;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var E;(function(c){c.Install="install",c.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var g;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Unknown="Unknown",c.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var b;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class w extends Error{constructor(f,a){super(f),this.code=a,this.name=a}}e.ExtensionManagementError=w;var p;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed"})(p||(e.ExtensionGalleryErrorCode=p={}));class d extends Error{constructor(f,a){super(f),this.code=a,this.name=a}}e.ExtensionGalleryError=d,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,n.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,n.localize2)(1,"Preferences")}),define(oe[212],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,n.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(oe[213],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,n.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(oe[214],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=void 0,e.IExternalTerminalMainService=(0,n.createDecorator)("externalTerminal")}),define(oe[215],ae([0,1,49,51,13,9,4,76,21,90,176,213]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=v.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends g{static{this.CMD="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,l.getWindowsShell(),t)}spawnTerminal(a,t,o,s){const i=t.windowsExec||m.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const r=O.basename(i,".exe").toLowerCase();if(r==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),r==="wt"&&u.push("-d ."),new Promise((S,k)=>{const M=p(process),L=a.spawn(o,u,{cwd:s,env:M,detached:!0});L.on("error",k),L.on("exit",()=>S())})}async runInTerminal(a,t,o,s,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),u=await m.getWtExePath();return new Promise((S,k)=>{const M=`"${t} - ${E}"`,L=`"${o.join('" "')}" & pause`,R=Object.assign({},p(process),s);Object.keys(R).filter(j=>R[j]===null).forEach(j=>delete R[j]);const A={cwd:t,env:R,windowsVerbatimArguments:!0};let F,_;O.basename(r,".exe")==="wt"?(F=r,_=["-d",".",m.CMD,"/c",L]):u?(F=u,_=["-d",".",r,"/c",L]):(F=m.CMD,_=["/c","start",M,"/wait",r,"/c",`"${L}"`]),n.spawn(F,_,A).on("error",j=>{k(d(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const a=await l.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.WindowsExternalTerminalService=m,Pe([D.memoize],m,"getWtExePath",null);class b extends g{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,s,i){const r=i.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((u,S)=>{if(r===y.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const k=r===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",a||E,"-w",t];for(const F of o)L.push("-a"),L.push(F);if(s){const F=Object.assign({},p(process),s);for(const _ in F){const z=F[_];z===null?(L.push("-u"),L.push(_)):(L.push("-e"),L.push(`${_}=${z}`))}}let R="";const A=n.spawn(b.OSASCRIPT,L);A.on("error",F=>{S(d(F))}),A.stderr.on("data",F=>{R+=F.toString()}),A.on("exit",F=>{if(F===0)u(void 0);else if(R){const _=R.split(`
`,1);S(new Error(_[0]))}else S(new Error(v.localize(1,null,k,F)))})}else S(new Error(v.localize(2,null,r)))})}spawnTerminal(a,t,o){const s=t.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const u=["-a",s];o&&u.push(o);const S=p(process),k=a.spawn("/usr/bin/open",u,{cwd:o,env:S});k.on("error",r),k.on("exit",()=>i())})}}e.MacExternalTerminalService=b;class w extends g{static{this.WAIT_MESSAGE=v.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,s,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,S)=>{const k=[];r.then(M=>{M.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const L=`${c(o)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;k.push(`''${L}''`);const R=Object.assign({},p(process),s);Object.keys(R).filter(z=>R[z]===null).forEach(z=>delete R[z]);const A={cwd:t,env:R};let F="";const _=n.spawn(M,k,A);_.on("error",z=>{S(d(z))}),_.stderr.on("data",z=>{F+=z.toString()}),_.on("exit",z=>{if(z===0)u(void 0);else if(F){const j=F.split(`
`,1);S(new Error(j[0]))}else S(new Error(v.localize(4,null,M,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,t,o){const s=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{s.then(u=>{const S=p(process),k=a.spawn(u,[],{cwd:o,env:S});k.on("error",r),k.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w;function p(f){const a={...f.env};return(0,P.sanitizeProcessEnvironment)(a),a}function d(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(v.localize(5,null,f.path)):f}function c(f){let a="";for(const t of f)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(oe[16],ae([0,1,59,9,25,12,7,178,6,4,13,62]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=E,e.isFileSystemWatcher=b,e.hasReadWriteCapability=p,e.hasFileFolderCopyCapability=d,e.hasFileCloneCapability=c,e.hasOpenReadWriteCloseCapability=f,e.hasFileReadStreamCapability=a,e.hasFileAtomicReadCapability=t,e.hasFileAtomicWriteCapability=o,e.hasFileAtomicDeleteCapability=s,e.hasReadonlyCapability=i,e.createFileSystemProviderError=S,e.ensureFileSystemProviderError=k,e.markAsFileSystemProviderError=M,e.toFileSystemProviderErrorCode=L,e.toFileOperationResult=R,e.isParent=j,e.etag=B,e.whenProviderRegistered=T,e.getLargeFileConfirmationLimit=V,e.IFileService=(0,h.createDecorator)("fileService");function E(U){return U.create===!0}var g;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var m;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function b(U){const le=U;return!!le&&typeof le.onDidChange=="function"}var w;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function p(U){return!!(U.capabilities&2)}function d(U){return!!(U.capabilities&8)}function c(U){return!!(U.capabilities&131072)}function f(U){return!!(U.capabilities&4)}function a(U){return!!(U.capabilities&16)}function t(U){return p(U)?!!(U.capabilities&16384):!1}function o(U){return p(U)?!!(U.capabilities&32768):!1}function s(U){return!!(U.capabilities&65536)}function i(U){return!!(U.capabilities&2048)}var r;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class u extends Error{static create(le,he){const K=new u(le.toString(),he);return M(K,he),K}constructor(le,he){super(le),this.code=he}}e.FileSystemProviderError=u;function S(U,le){return u.create(U,le)}function k(U){return U||S((0,P.localize)(0,null),r.Unknown)}function M(U,le){return U.name=le?`${le} (FileSystemError)`:"FileSystemError",U}function L(U){if(!U)return r.Unknown;if(U instanceof u)return U.code;const le=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!le)return r.Unknown;switch(le[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function R(U){if(U instanceof ce)return U.fileOperationResult;switch(L(U)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}var A;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class F{constructor(le,he,K){this.resource=le,this.operation=he,this.target=K}isOperation(le){return this.operation===le}}e.FileOperationEvent=F;var _;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(_||(e.FileChangeType=_={}));class z{static{this.MIXED_CORRELATION=null}constructor(le,he){this.ignorePathCasing=he,this.correlationId=void 0,this.added=new y.Lazy(()=>{const K=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.updated=new y.Lazy(()=>{const K=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.deleted=new y.Lazy(()=>{const K=n.TernarySearchTree.forUris(()=>this.ignorePathCasing);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of le){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.correlationId!==z.MIXED_CORRELATION&&(typeof K.cId=="number"?this.correlationId===void 0?this.correlationId=K.cId:this.correlationId!==K.cId&&(this.correlationId=z.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=z.MIXED_CORRELATION))}}contains(le,...he){return this.doContains(le,{includeChildren:!1},...he)}affects(le,...he){return this.doContains(le,{includeChildren:!0},...he)}doContains(le,he,...K){if(!le)return!1;const W=K.length>0;return!!((!W||K.includes(1))&&(this.added.value.get(le)||he.includeChildren&&this.added.value.findSuperstr(le))||(!W||K.includes(0))&&(this.updated.value.get(le)||he.includeChildren&&this.updated.value.findSuperstr(le))||(!W||K.includes(2))&&(this.deleted.value.findSubstr(le)||he.includeChildren&&this.deleted.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.correlationId===le}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=z;function j(U,le,he){return!U||!le||U===le||le.length>U.length?!1:(le.charAt(le.length-1)!==D.sep&&(le+=D.sep),he?(0,I.startsWithIgnoreCase)(U,le):U.indexOf(le)===0)}class ce extends Error{constructor(le,he,K){super(le),this.fileOperationResult=he,this.options=K}}e.FileOperationError=ce;class te extends ce{constructor(le,he,K,W){super(le,he,W),this.fileOperationResult=he,this.size=K}}e.TooLargeFileOperationError=te;class ue extends ce{constructor(le,he,K){super(le,2,K),this.stat=he}}e.NotModifiedSinceFileOperationError=ue;var X;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Y;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.ETAG_DISABLED="";function B(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}async function T(U,le){if(!le.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(he=>{const K=le.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===U.scheme&&W.added&&(K.dispose(),he())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(le){return(0,O.isNumber)(le)||(le=0),le<x.KB?(0,P.localize)(1,null,le.toFixed(0)):le<x.MB?(0,P.localize)(2,null,(le/x.KB).toFixed(2)):le<x.GB?(0,P.localize)(3,null,(le/x.MB).toFixed(2)):le<x.TB?(0,P.localize)(4,null,(le/x.GB).toFixed(2)):(0,P.localize)(5,null,(le/x.TB).toFixed(2))}}e.ByteSize=x;function V(U){const le=typeof U=="string"||U?.scheme===v.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===v.Schemas.file?1024*x.MB:le?10*x.MB:l.isWeb?50*x.MB:1024*x.MB}}),define(oe[122],ae([0,1,17,15,179,16]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=C;async function C(v,y,E,g,m,b){let w;try{await P(v,y,E,g,m,b)}catch(p){w=p}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&E.error(w),E.end()}}async function P(v,y,E,g,m,b){h(b);const w=await v.open(y,{create:!1});try{h(b);let p=0,d=0,c=m&&typeof m.length=="number"?m.length:void 0,f=n.VSBuffer.alloc(Math.min(m.bufferSize,typeof c=="number"?c:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do d=await v.read(w,a,f.buffer,t,f.byteLength-t),a+=d,t+=d,p+=d,typeof c=="number"&&(c-=d),t===f.byteLength&&(await E.write(g(f)),f=n.VSBuffer.alloc(Math.min(m.bufferSize,typeof c=="number"?c:m.bufferSize)),t=0);while(d>0&&(typeof c!="number"||c>0)&&h(b)&&l(p,m));if(t>0){let o=t;typeof c=="number"&&(o=Math.min(t,c)),E.write(g(f.slice(0,o)))}}catch(p){throw(0,O.ensureFileSystemProviderError)(p)}finally{await v.close(w)}}function h(v){if(v.isCancellationRequested)throw(0,D.canceled)();return!0}function l(v,y){if(typeof y?.limits?.size=="number"&&v>y.limits.size)throw(0,O.createFileSystemProviderError)((0,I.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[60],ae([0,1,108,2,9,4,7,16]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=h,e.isRecursiveWatchRequest=l,e.reviveFileChanges=g,e.coalesceEvents=m,e.normalizeWatcherPattern=b,e.parseWatcherPatterns=w;function h(d){return typeof d.correlationId=="number"}function l(d){return d.recursive===!0}class v extends D.Disposable{static{this.MAX_RESTARTS=5}constructor(c,f,a,t){super(),this.onFileChanges=c,this.onLogMessage=f,this.verboseLogging=a,this.options=t,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new D.DisposableStore;this.watcherDisposables.value=c,this.watcher=this.createWatcher(c),this.watcher.setVerboseLogging(this.verboseLogging),c.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),c.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),c.add(this.watcher.onDidError(f=>this.onError(f)))}onError(c){this.options.restartOnError?this.restartCounter<v.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`):this.error(c)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.watcher?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.watcher?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${c}`})}trace(c){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${c}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=v;class y extends v{constructor(c,f,a){super(c,f,a,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class E extends v{constructor(c,f,a){super(c,f,a,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function g(d){return d.map(c=>({type:c.type,resource:C.URI.revive(c.resource),cId:c.cId}))}function m(d){const c=new p;for(const f of d)c.processEvent(f);return c.coalesce()}function b(d,c){return typeof c=="string"&&!c.startsWith(n.GLOBSTAR)&&!(0,I.isAbsolute)(c)?{base:d,pattern:c}:c}function w(d,c){const f=[];for(const a of c)f.push((0,n.parse)(b(d,a)));return f}class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return O.isLinux?c.resource.fsPath:c.resource.fsPath.toLowerCase()}processEvent(c){const f=this.mapPathToChange.get(this.toKey(c));let a=!1;if(f){const t=f.type,o=c.type;f.resource.fsPath!==c.resource.fsPath&&(c.type===2||c.type===1)?a=!0:t===1&&o===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(f)):t===2&&o===1?f.type=0:t===1&&o===0||(f.type=o)}else a=!0;a&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],f=[];return Array.from(this.coalesced).filter(a=>a.type!==2?(c.push(a),!1):!0).sort((a,t)=>a.resource.fsPath.length-t.resource.fsPath.length).filter(a=>f.some(t=>(0,P.isParent)(a.resource.fsPath,t,!O.isLinux))?!1:(f.push(a.resource.fsPath),!0)).concat(c)}}}),define(oe[216],ae([0,1,17,47,15,3,2,63,33,16,60]),function(Q,e,n,D,I,O,C,P,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends C.Disposable{constructor(g,m){super(),this.channel=g,this.extraCapabilities=m,this.onDidChangeCapabilities=O.Event.None,this._onDidChange=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,h.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(g){return this.channel.call("stat",[g])}readdir(g){return this.channel.call("readdir",[g])}async readFile(g,m){const{buffer:b}=await this.channel.call("readFile",[g,m]);return b}readFileStream(g,m,b){const w=(0,P.newWriteableStream)(d=>n.VSBuffer.concat(d.map(c=>n.VSBuffer.wrap(c))).buffer),p=new C.DisposableStore;return p.add(this.channel.listen("readFileStream",[g,m])(d=>{if(d instanceof n.VSBuffer)w.write(d.buffer);else{if(d==="end")w.end();else{let c;if(d instanceof Error)c=d;else{const f=d;c=(0,l.createFileSystemProviderError)(f.message??(0,D.toErrorMessage)(f),f.code??l.FileSystemProviderErrorCode.Unknown)}w.error(c),w.end()}p.dispose()}})),p.add(b.onCancellationRequested(()=>{w.error((0,I.canceled)()),w.end(),p.dispose()})),w}writeFile(g,m,b){return this.channel.call("writeFile",[g,n.VSBuffer.wrap(m),b])}open(g,m){return this.channel.call("open",[g,m])}close(g){return this.channel.call("close",[g])}async read(g,m,b,w,p){const[d,c]=await this.channel.call("read",[g,m,p]);return b.set(d.buffer.slice(0,c),w),c}write(g,m,b,w,p){return this.channel.call("write",[g,m,n.VSBuffer.wrap(b),w,p])}mkdir(g){return this.channel.call("mkdir",[g])}delete(g,m){return this.channel.call("delete",[g,m])}rename(g,m,b){return this.channel.call("rename",[g,m,b])}copy(g,m,b){return this.channel.call("copy",[g,m,b])}cloneFile(g,m){return this.channel.call("cloneFile",[g,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(g=>{if(Array.isArray(g)){const m=g;this._onDidChange.fire((0,v.reviveFileChanges)(m))}else{const m=g;this._onDidWatchError.fire(m)}}))}watch(g,m){const b=(0,h.generateUuid)();return this.channel.call("watch",[this.sessionId,b,g,m]),(0,C.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=y}),define(oe[217],ae([0,1,43,2,60,3,7]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class P extends D.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new O.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new O.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new D.DisposableMap),this.suspendedWatchRequestPollingInterval=5007,this._register(this.onDidWatchFail(l=>this.handleDidWatchFail(l)))}handleDidWatchFail(l){this.isCorrelated(l)&&this.suspendWatchRequest(l)}isCorrelated(l){return(0,I.isWatchRequestWithCorrelation)(l)}async watch(l){this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const v of l)this.isCorrelated(v)?this.allCorrelatedWatchRequests.set(v.correlationId,v):this.allNonCorrelatedWatchRequests.add(v);for(const[v]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(v)||this.suspendedWatchRequests.deleteAndDispose(v);return this.updateWatchers()}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(l=>!this.suspendedWatchRequests.has(l.correlationId))])}suspendWatchRequest(l){if(this.suspendedWatchRequests.has(l.correlationId))return;const v=new D.DisposableStore;this.suspendedWatchRequests.set(l.correlationId,v),this.monitorSuspendedWatchRequest(l,v),this.updateWatchers()}resumeWatchRequest(l){this.suspendedWatchRequests.deleteAndDispose(l.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(l,v){const y=C.URI.file(l.path),E=this;let g=!1;const m=(b,w)=>{if(v.isDisposed)return;const p=this.isPathNotFound(b),d=this.isPathNotFound(w),c=g;if(g=p,!p&&(d||c)){this.trace(`fs.watchFile() detected ${l.path} exists again, resuming watcher (correlationId: ${l.correlationId})`);const f={resource:y,type:1,cId:l.correlationId};E._onDidChangeFile.fire([f]),this.traceEvent(f,l),this.resumeWatchRequest(l)}};this.trace(`starting fs.watchFile() on ${l.path} (correlationId: ${l.correlationId})`);try{(0,n.watchFile)(l.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},m)}catch(b){this.warn(`fs.watchFile() failed with error ${b} on path ${l.path} (correlationId: ${l.correlationId})`)}v.add((0,D.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${l.path} (correlationId: ${l.correlationId})`);try{(0,n.unwatchFile)(l.path,m)}catch(b){this.warn(`fs.unwatchFile() failed with error ${b} on path ${l.path} (correlationId: ${l.correlationId})`)}}))}isPathNotFound(l){return l.ctimeMs===0&&l.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll()}traceEvent(l,v){const y=` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`;this.trace(typeof v.correlationId=="number"?`${y} (correlationId: ${v.correlationId})`:y)}requestToString(l){return`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`}}e.BaseWatcher=P}),define(oe[218],ae([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=w;class b extends C.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(d,c,f,a,t){super(),this.request=d,this.onDidFilesChange=c,this.onDidWatchFail=f,this.onLogMessage=a,this.verboseLogging=t,this.throttledFileChangesEmitter=this._register(new D.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.onDidFilesChange(o))),this.fileChangesAggregator=this._register(new D.RunOnceWorker(o=>this.handleFileChanges(o),b.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new I.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const c=await g.Promises.stat(d);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(d,c.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${d})`),this.onDidWatchFail?.()}}async normalizePath(d){let c=d.path;try{c=await g.Promises.realpath(d.path),d.path===c&&(c=await(0,E.realcase)(d.path,this.cts.token)??d.path),d.path!==c&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${c})`)}catch{}return c}async doWatch(d,c){if(l.isMacintosh&&(0,O.isEqualOrParent)(d,"/Volumes/",!0))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const f=new I.CancellationTokenSource(this.cts.token),a=new C.DisposableStore;try{const t=y.URI.file(this.request.path),o=(0,h.basename)(d),s=(0,n.watch)(d);a.add((0,C.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${d}'`);const i=new Set;if(c)try{for(const u of await g.Promises.readdir(d))i.add(u)}catch(u){this.error(u)}const r=new Map;a.add((0,C.toDisposable)(()=>{for(const[,u]of r)u.dispose();r.clear()})),s.on("error",(u,S)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${u}, ${S})`),this.onDidWatchFail?.()}),s.on("change",(u,S)=>{if(f.token.isCancellationRequested)return;this.trace(`[raw] ["${u}"] ${S}`);let k="";if(S&&(k=S.toString(),l.isMacintosh&&(k=(0,P.normalizeNFC)(k))),!(!k||u!=="change"&&u!=="rename"))if(c)if(u==="rename"){r.get(k)?.dispose();const M=setTimeout(async()=>{if(r.delete(k),k===o&&!await g.Promises.exists(d)){this.onWatchedPathDeleted(t);return}const L=await this.existsChildStrictCase((0,h.join)(d,k));if(f.token.isCancellationRequested)return;let R;L?i.has(k)?R=0:(R=1,i.add(k)):(i.delete(k),R=2),this.onFileChange({resource:(0,v.joinPath)(t,k),type:R,cId:this.request.correlationId})},b.FILE_DELETE_HANDLER_DELAY);r.set(k,(0,C.toDisposable)(()=>clearTimeout(M)))}else{let M;i.has(k)?M=0:(M=1,i.add(k)),this.onFileChange({resource:(0,v.joinPath)(t,k),type:M,cId:this.request.correlationId})}else if(u==="rename"||k!==o){const M=setTimeout(async()=>{const L=await g.Promises.exists(d);f.token.isCancellationRequested||(L?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),a.add(await this.doWatch(d,!1))):this.onWatchedPathDeleted(t))},b.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,C.toDisposable)(()=>clearTimeout(M)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){f.token.isCancellationRequested||this.error(`Failed to watch ${d} for changes using fs.watch() (${t.toString()})`),this.onDidWatchFail?.()}return(0,C.toDisposable)(()=>{f.dispose(!0),a.dispose()})}onWatchedPathDeleted(d){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:d,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.onDidWatchFail?.()}onFileChange(d,c=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!c&&this.excludes.some(f=>f(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${d.resource.fsPath}`):!c&&this.includes&&this.includes.length>0&&!this.includes.some(f=>f(d.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${d.resource.fsPath}`):this.fileChangesAggregator.work(d))}handleFileChanges(d){const c=(0,m.coalesceEvents)(d);if(c.length>0){if(this.verboseLogging)for(const a of c)this.trace(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.throttledFileChangesEmitter.work(c)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(d){if(l.isLinux)return g.Promises.exists(d);try{const c=(0,h.basename)(d);return(await g.Promises.readdir((0,h.dirname)(d))).some(a=>a===c)}catch(c){return this.trace(c),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=b;async function w(p,d,c,f,a=512){const t=await g.Promises.open(p,"r"),o=Buffer.allocUnsafe(a),s=new I.CancellationTokenSource(f);let i,r=!1;const u={path:p,excludes:[],recursive:!1},S=new b(u,k=>{(async()=>{for(const{type:M}of k)if(M===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:L}=await g.Promises.read(t,o,0,a,null);if(!L||s.token.isCancellationRequested)break;d(o.slice(0,L))}}catch(L){i=new Error(L),s.dispose(!0)}finally{r=!1}}})()});return await S.ready,c(),new Promise((k,M)=>{s.token.onCancellationRequested(async()=>{S.dispose();try{await g.Promises.close(t)}catch(L){i=new Error(L)}i?M(i):k()})})}}),define(oe[219],ae([0,1,3,108,217,4,218,31]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class h extends I.BaseWatcher{constructor(){super(...arguments),this.onDidError=n.Event.None,this.watchers=new Set,this.verboseLogging=!1}async doWatch(v){v=this.removeDuplicateRequests(v);const y=[],E=new Set(Array.from(this.watchers));for(const g of v){const m=this.findWatcher(g);m&&(0,D.patternsEquals)(m.request.excludes,g.excludes)&&(0,D.patternsEquals)(m.request.includes,g.includes)?E.delete(m):y.push(g)}y.length&&this.trace(`Request to start watching: ${y.map(g=>this.requestToString(g)).join(",")}`),E.size&&this.trace(`Request to stop watching: ${Array.from(E).map(g=>this.requestToString(g.request)).join(",")}`);for(const g of E)this.stopWatching(g);for(const g of y)this.startWatching(g)}findWatcher(v){for(const y of this.watchers)if(typeof v.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===v.correlationId)return y}else if((0,P.isEqual)(y.request.path,v.path,!O.isLinux))return y}startWatching(v){const y=new C.NodeJSFileWatcherLibrary(v,g=>this._onDidChangeFile.fire(g),()=>this._onDidWatchFail.fire(v),g=>this._onDidLogMessage.fire(g),this.verboseLogging),E={request:v,instance:y};this.watchers.add(E)}async stop(){await super.stop();for(const v of this.watchers)this.stopWatching(v)}stopWatching(v){this.trace("stopping file watcher",v),this.watchers.delete(v),v.instance.dispose()}removeDuplicateRequests(v){const y=new Map;for(const E of v){const g=O.isLinux?E.path:E.path.toLowerCase();let m=y.get(E.correlationId);m||(m=new Map,y.set(E.correlationId,m)),m.has(g)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(E)}`),m.set(g,E)}return Array.from(y.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(v){this.verboseLogging=v;for(const y of this.watchers)y.instance.setVerboseLogging(v)}trace(v,y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v,y)})}warn(v){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(v)})}toMessage(v,y){return y?`[File Watcher (node.js)] ${v} (${this.requestToString(y.request)})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=h}),define(oe[220],ae([0,1,60,219]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends n.AbstractNonRecursiveWatcherClient{constructor(C,P,h){super(C,P,h),this.init()}createWatcher(C){return C.add(new D.NodeJSWatcher)}}e.NodeJSWatcherClient=I}),define(oe[221],ae([0,1,13,44,162,60]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends O.AbstractUniversalWatcherClient{constructor(h,l,v){super(h,l,v),this.init()}createWatcher(h){const l=h.add(new I.Client(n.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:v,signal:y})=>this.onError(`terminated by itself with code ${v}, signal: ${y}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(oe[93],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...I){this._entries=new Map;for(const[O,C]of I)this.set(O,C)}set(I,O){const C=this._entries.get(I);return this._entries.set(I,O),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=n}),define(oe[222],ae([0,1,8,15,2,78,211,6,93,104]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const v=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class E{constructor(w=new h.ServiceCollection,p=!1,d,c=v){this._services=w,this._strict=p,this._parent=d,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=c?d?._globalGraph??new C.Graph(f=>f):void 0}createChild(w){return new E(w,this._strict,this,this._enableTracing)}invokeFunction(w,...p){const d=m.traceInvocation(this._enableTracing,w);let c=!1;try{return w({get:a=>{if(c)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(a,d);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...p)}finally{c=!0,d.stop()}}createInstance(w,...p){let d,c;return w instanceof O.SyncDescriptor?(d=m.traceCreation(this._enableTracing,w.ctor),c=this._createInstance(w.ctor,w.staticArguments.concat(p),d)):(d=m.traceCreation(this._enableTracing,w),c=this._createInstance(w,p,d)),d.stop(),c}_createInstance(w,p=[],d){const c=P._util.getServiceDependencies(w).sort((t,o)=>t.index-o.index),f=[];for(const t of c){const o=this._getOrCreateServiceInstance(t.id,d);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(o)}const a=c.length>0?c[0].index:p.length;if(p.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${p.length} static arguments`);const t=a-p.length;t>0?p=p.concat(new Array(t)):p=p.slice(0,a)}return Reflect.construct(w,p.concat(f))}_setServiceInstance(w,p){if(this._services.get(w)instanceof O.SyncDescriptor)this._services.set(w,p);else if(this._parent)this._parent._setServiceInstance(w,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){const p=this._services.get(w);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):p}_getOrCreateServiceInstance(w,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(w));const d=this._getServiceInstanceOrDescriptor(w);return d instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,d,p.branch(w,!0)):(p.branch(w,!1),d)}_safeCreateAndCacheServiceInstance(w,p,d){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,p,d)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,p,d){const c=new C.Graph(t=>t.id.toString());let f=0;const a=[{id:w,desc:p,_trace:d}];for(;a.length;){const t=a.pop();if(c.lookupOrInsertNode(t),f++>1e3)throw new y(c);for(const o of P._util.getServiceDependencies(t.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(o.id);if(s||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof O.SyncDescriptor){const i={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};c.insertEdge(t,i),a.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new y(c);break}for(const{data:o}of t){if(this._getServiceInstanceOrDescriptor(o.id)instanceof O.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}c.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,p,d=[],c,f){if(this._services.get(w)instanceof O.SyncDescriptor)return this._createServiceInstance(w,p,d,c,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,p,d,c,f);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(w,p,d=[],c,f){if(c){const a=new E(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(w);const t=new Map,o=new n.GlobalIdleValue(()=>{const s=a._createInstance(p,d,f);for(const[i,r]of t){const u=s[i];if(typeof u=="function")for(const S of r)S.disposable=u.apply(s,S.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let S=t.get(i);return S||(S=new l.LinkedList,t.set(i,S)),(M,L,R)=>{if(o.isInitialized)return o.value[i](M,L,R);{const A={listener:[M,L,R],disposable:void 0},F=S.push(A);return(0,I.toDisposable)(()=>{F(),A.disposable?.dispose()})}}}if(i in s)return s[i];const r=o.value;let u=r[i];return typeof u!="function"||(u=u.bind(r),s[i]=u),u},set(s,i,r){return o.value[i]=r,!0},getPrototypeOf(s){return p.prototype}})}else return this._createInstance(p,d,f)}_throwIfStrict(w,p){if(p&&console.warn(w),this._strict)throw new Error(w)}}e.InstantiationService=E;var g;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(g||(g={}));class m{static{this.all=new Set}static{this._None=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,p){return w?new m(2,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(w,p){return w?new m(1,p.name):m._None}static{this._totals=0}constructor(w,p){this.type=w,this.name=p,this._start=Date.now(),this._dep=[]}branch(w,p){const d=new m(3,w.toString());return this._dep.push([w,p,d]),d}stop(){const w=Date.now()-this._start;m._totals+=w;let p=!1;function d(f,a){const t=[],o=new Array(f+1).join("	");for(const[s,i,r]of a._dep)if(i&&r){p=!0,t.push(`${o}CREATES -> ${s}`);const u=d(f+1,r);u&&t.push(u)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(w>2||p)&&m.all.add(c.join(`
`))}}e.Trace=m}),define(oe[223],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueSource=e.IssueType=void 0;var D;(function(O){O[O.Bug=0]="Bug",O[O.PerformanceIssue=1]="PerformanceIssue",O[O.FeatureRequest=2]="FeatureRequest"})(D||(e.IssueType=D={}));var I;(function(O){O.VSCode="vscode",O.Extension="extension",O.Marketplace="marketplace"})(I||(e.IssueSource=I={})),e.IIssueMainService=(0,n.createDecorator)("issueService")}),define(oe[5],ae([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=b,e.log=p,e.getLogLevel=S,e.LogLevelToString=k,e.LogLevelToLocalizedString=M,e.parseLogLevel=L,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function m(){return new Date().toISOString()}function b(R){return(0,v.isNumber)(R)}var w;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function p(R,A,F){switch(A){case w.Trace:R.trace(F);break;case w.Debug:R.debug(F);break;case w.Info:R.info(F);break;case w.Warning:R.warn(F);break;case w.Error:R.error(F);break;case w.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function d(R,A=!1){let F="";for(let _=0;_<R.length;_++){let z=R[_];if(z instanceof Error&&(z=(0,D.toErrorMessage)(z,A)),typeof z=="object")try{z=JSON.stringify(z)}catch{}F+=(_>0?" ":"")+z}return F}class c extends C.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(A){this.level!==A&&(this.level=A,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(A){return this.level!==w.Off&&this.level<=A}}e.AbstractLogger=c;class f extends c{constructor(A){super(),this.logAlways=A}checkLogLevel(A){return this.logAlways||super.checkLogLevel(A)}trace(A,...F){this.checkLogLevel(w.Trace)&&this.log(w.Trace,d([A,...F],!0))}debug(A,...F){this.checkLogLevel(w.Debug)&&this.log(w.Debug,d([A,...F]))}info(A,...F){this.checkLogLevel(w.Info)&&this.log(w.Info,d([A,...F]))}warn(A,...F){this.checkLogLevel(w.Warning)&&this.log(w.Warning,d([A,...F]))}error(A,...F){if(this.checkLogLevel(w.Error))if(A instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=A.stack,this.log(w.Error,d(_))}else this.log(w.Error,d([A,...F]))}flush(){}}e.AbstractMessageLogger=f;class a extends c{constructor(A=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(A),this.useColors=!h.isWindows}trace(A,...F){this.checkLogLevel(w.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...F):console.log(`[main ${m()}]`,A,...F))}debug(A,...F){this.checkLogLevel(w.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...F):console.log(`[main ${m()}]`,A,...F))}info(A,...F){this.checkLogLevel(w.Info)&&(this.useColors?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,A,...F):console.log(`[main ${m()}]`,A,...F))}warn(A,...F){this.checkLogLevel(w.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,A,...F):console.warn(`[main ${m()}]`,A,...F))}error(A,...F){this.checkLogLevel(w.Error)&&(this.useColors?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,A,...F):console.error(`[main ${m()}]`,A,...F))}flush(){}}e.ConsoleMainLogger=a;class t extends c{constructor(A=e.DEFAULT_LOG_LEVEL,F=!0){super(),this.useColors=F,this.setLevel(A)}trace(A,...F){this.checkLogLevel(w.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",A,...F):console.log(A,...F))}debug(A,...F){this.checkLogLevel(w.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",A,...F):console.log(A,...F))}info(A,...F){this.checkLogLevel(w.Info)&&(this.useColors?console.log("%c INFO","color: #33f",A,...F):console.log(A,...F))}warn(A,...F){this.checkLogLevel(w.Warning)&&(this.useColors?console.log("%c WARN","color: #993",A,...F):console.log(A,...F))}error(A,...F){this.checkLogLevel(w.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",A,...F):console.error(A,...F))}flush(){}}e.ConsoleLogger=t;class o extends c{constructor(A,F=e.DEFAULT_LOG_LEVEL){super(),this.adapter=A,this.setLevel(F)}trace(A,...F){this.checkLogLevel(w.Trace)&&this.adapter.log(w.Trace,[this.extractMessage(A),...F])}debug(A,...F){this.checkLogLevel(w.Debug)&&this.adapter.log(w.Debug,[this.extractMessage(A),...F])}info(A,...F){this.checkLogLevel(w.Info)&&this.adapter.log(w.Info,[this.extractMessage(A),...F])}warn(A,...F){this.checkLogLevel(w.Warning)&&this.adapter.log(w.Warning,[this.extractMessage(A),...F])}error(A,...F){this.checkLogLevel(w.Error)&&this.adapter.log(w.Error,[this.extractMessage(A),...F])}extractMessage(A){return typeof A=="string"?A:(0,D.toErrorMessage)(A,this.checkLogLevel(w.Trace))}flush(){}}e.AdapterLogger=o;class s extends c{constructor(A){super(),this.loggers=A,A.length&&this.setLevel(A[0].getLevel())}setLevel(A){for(const F of this.loggers)F.setLevel(A);super.setLevel(A)}trace(A,...F){for(const _ of this.loggers)_.trace(A,...F)}debug(A,...F){for(const _ of this.loggers)_.debug(A,...F)}info(A,...F){for(const _ of this.loggers)_.info(A,...F)}warn(A,...F){for(const _ of this.loggers)_.warn(A,...F)}error(A,...F){for(const _ of this.loggers)_.error(A,...F)}flush(){for(const A of this.loggers)A.flush()}dispose(){for(const A of this.loggers)A.dispose();super.dispose()}}e.MultiplexLogger=s;class i extends C.Disposable{constructor(A,F,_){if(super(),this.logLevel=A,this.logsHome=F,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new I.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,_)for(const z of _)this._loggers.set(z.resource,{logger:void 0,info:z})}getLoggerEntry(A){return(0,v.isString)(A)?[...this._loggers.values()].find(F=>F.info.id===A):this._loggers.get(A)}getLogger(A){return this.getLoggerEntry(A)?.logger}createLogger(A,F){const _=this.toResource(A),z=(0,v.isString)(A)?A:F?.id??(0,O.hash)(_.toString()).toString(16);let j=this._loggers.get(_)?.logger;const ce=F?.logLevel==="always"?w.Trace:F?.logLevel;j||(j=this.doCreateLogger(_,ce??this.getLogLevel(_)??this.logLevel,{...F,id:z}));const te={logger:j,info:{resource:_,id:z,logLevel:ce,name:F?.name,hidden:F?.hidden,extensionId:F?.extensionId,when:F?.when}};return this.registerLogger(te.info),this._loggers.set(_,te),j}toResource(A){return(0,v.isString)(A)?(0,l.joinPath)(this.logsHome,`${A}.log`):A}setLogLevel(A,F){if(y.URI.isUri(A)){const _=A,z=F,j=this._loggers.get(_);j&&z!==j.info.logLevel&&(j.info.logLevel=z===this.logLevel?void 0:z,j.logger?.setLevel(z),this._loggers.set(j.info.resource,j),this._onDidChangeLogLevel.fire([_,z]))}else{this.logLevel=A;for(const[_,z]of this._loggers.entries())this._loggers.get(_)?.info.logLevel===void 0&&z.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(A,F){const _=this.getLoggerEntry(A);_&&F!==!_.info.hidden&&(_.info.hidden=!F,this._loggers.set(_.info.resource,_),this._onDidChangeVisibility.fire([_.info.resource,F]))}getLogLevel(A){let F;return A&&(F=this._loggers.get(A)?.info.logLevel),F??this.logLevel}registerLogger(A){const F=this._loggers.get(A.resource);F?F.info.hidden!==A.hidden&&this.setVisibility(A.resource,!A.hidden):(this._loggers.set(A.resource,{info:A,logger:void 0}),this._onDidChangeLoggers.fire({added:[A],removed:[]}))}deregisterLogger(A){const F=this._loggers.get(A);F&&(F.logger&&F.logger.dispose(),this._loggers.delete(A),this._onDidChangeLoggers.fire({added:[],removed:[F.info]}))}*getRegisteredLoggers(){for(const A of this._loggers.values())yield A.info}getRegisteredLogger(A){return this._loggers.get(A)?.info}dispose(){this._loggers.forEach(A=>A.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=i;class r{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(A){}getLevel(){return w.Info}trace(A,...F){}debug(A,...F){}info(A,...F){}warn(A,...F){}error(A,...F){}critical(A,...F){}dispose(){}flush(){}}e.NullLogger=r;class u extends r{}e.NullLogService=u;function S(R){if(R.verbose)return w.Trace;if(typeof R.logLevel=="string"){const A=L(R.logLevel.toLowerCase());if(A!==void 0)return A}return e.DEFAULT_LOG_LEVEL}function k(R){switch(R){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function M(R){switch(R){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function L(R){switch(R){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.CONTEXT_LOG_LEVEL=new E.RawContextKey("logLevel",k(w.Info))});var ne=this&&this.__param||function(Q,e){return function(n,D){e(n,D,Q)}};define(oe[224],ae([0,1,14,4,5]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;const O=n.safeStorage;let C=class{constructor(h){this.logService=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.logService.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(O.encryptString(h));return this.logService.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.logService.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const v=Buffer.from(l.data);this.logService.trace("[EncryptionMainService] Decrypting value.");const y=O.decryptString(v);return this.logService.trace("[EncryptionMainService] Decrypted value."),y}catch(v){throw this.logService.error(v),v}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(D.isWindows)return Promise.resolve("dpapi");if(D.isMacintosh)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const h=O.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.logService.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(D.isWindows)throw new Error("Setting plain text encryption is not supported on Windows.");if(D.isMacintosh)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.EncryptionMainService=C,e.EncryptionMainService=C=Pe([ne(0,I.ILogService)],C)}),define(oe[225],ae([0,1,22,8,15,3,2,9,60,5]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class v extends C.Disposable{constructor(E,g){super(),this.logService=E,this.options=g,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(E,g){return g.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(E,g):this.watchNonRecursive(E,g)}watchUniversal(E,g){const m={path:this.toFilePath(E),excludes:g.excludes,includes:g.includes,recursive:g.recursive,correlationId:g.correlationId},b=(0,n.insert)(this.universalPathsToWatch,m);return this.refreshUniversalWatchers(),(0,C.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(E=>(0,I.onUnexpectedError)(E))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(g=>this._onDidChangeFile.fire((0,h.reviveFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)})));const E=this.options?.watcher?.recursive?.usePolling;if(E===!0)for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const g of this.universalPathsToWatch)(0,h.isRecursiveWatchRequest)(g)&&E.includes(g.path)&&(g.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(E,g){const m={path:this.toFilePath(E),excludes:g.excludes,includes:g.includes,recursive:!1,correlationId:g.correlationId},b=(0,n.insert)(this.nonRecursivePathsToWatch,m);return this.refreshNonRecursiveWatchers(),(0,C.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(E=>(0,I.onUnexpectedError)(E))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(E=>this._onDidChangeFile.fire((0,h.reviveFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===l.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===l.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(E){E.type==="error"&&this._onDidWatchError.fire(E.message),this.logService[E.type](E.message)}toFilePath(E){return(0,P.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=v}),define(oe[226],ae([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends l.Disposable{static{f=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new C.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new C.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new C.Emitter),this._onDidUncorrelatedFilesChange=this._register(new C.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${o}`);const i=new l.DisposableStore;return this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s}),i.add(s.onDidChangeFile(r=>{const u=new w.FileChangesEvent(r,!this.isPathCaseSensitive(s));this.internalOnDidFilesChange.fire(u),u.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(u)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),i.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){s.push(i)}}),!this.provider.has(o)&&await D.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return h.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new w.FileOperationError((0,b.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const i=new c.ErrorNoTelemetry;throw i.message=(0,b.localize)(1,null,o.toString()),i}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s)||(0,w.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(i){throw(0,w.toFileSystemProviderErrorCode)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,b.localize)(2,null,this.resourceForError(o)),1):(0,w.ensureFileSystemProviderError)(i)}}async doResolveFile(o,s){const i=await this.withProvider(o),r=this.isPathCaseSensitive(i),u=s?.resolveTo,S=s?.resolveSingleChildDescendants,k=s?.resolveMetadata,M=await i.stat(o);let L;return this.toFileStat(i,o,M,void 0,!!k,(R,A)=>(L||(L=v.TernarySearchTree.forUris(()=>!r),L.set(o,!0),u&&L.fill(!0,u)),L.get(R.resource)||L.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&S?A===1:!1))}async toFileStat(o,s,i,r,u,S){const{providerExtUri:k}=this.getExtUri(o),M={resource:s,name:k.basename(s),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(M.isDirectory&&S(M,r)){try{const L=await o.readdir(s),R=await D.Promises.settled(L.map(async([A,F])=>{try{const _=k.joinPath(s,A),z=u?await o.stat(_):{type:F};return await this.toFileStat(o,_,z,L.length,u,S)}catch(_){return this.logService.trace(_),null}}));M.children=(0,n.coalesce)(R)}catch(L){this.logService.trace(L),M.children=[]}return M}return M}async resolveAll(o){return D.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.withProvider(o),i=await s.stat(o);return this.toFileStat(s,o,i,void 0,!0,()=>!1)}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(i){return i}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new w.FileOperationError((0,b.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=I.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const r=await this.writeFile(o,s);return this._onDidRunOperation.fire(new w.FileOperationEvent(o,0,r)),r}async writeFile(o,s,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:u}=this.getExtUri(r);let S=i;if((0,w.hasFileAtomicWriteCapability)(r)&&!S?.atomic){const k=r.enforceAtomicWriteFile?.(o);k&&(S={...i,atomic:k})}try{await this.validateWriteFile(r,o,S)||await this.mkdirp(r,u.dirname(o));let M;if((0,w.hasReadWriteCapability)(r)&&!(s instanceof I.VSBuffer))if((0,m.isReadableStream)(s)){const L=await(0,m.peekStream)(s,3);L.ended?M=I.VSBuffer.concat(L.buffer):M=L}else M=(0,m.peekReadable)(s,L=>I.VSBuffer.concat(L),3);else M=s;!(0,w.hasOpenReadWriteCloseCapability)(r)||(0,w.hasReadWriteCapability)(r)&&M instanceof I.VSBuffer||(0,w.hasReadWriteCapability)(r)&&(0,w.hasFileAtomicWriteCapability)(r)&&S?.atomic?await this.doWriteUnbuffered(r,o,S,M):await this.doWriteBuffered(r,o,S,M instanceof I.VSBuffer?(0,I.bufferToReadable)(M):M),this._onDidRunOperation.fire(new w.FileOperationEvent(o,4))}catch(k){throw new w.FileOperationError((0,b.localize)(4,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(k).toString()),(0,w.toFileOperationResult)(k),S)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,i){const r=!!i?.unlock;if(r&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(s)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.resourceForError(s)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.resourceForError(s)));if(r)throw new Error((0,b.localize)(8,null,this.resourceForError(s)))}let S;try{S=await o.stat(s)}catch{return}if(S.type&w.FileType.Directory)throw new w.FileOperationError((0,b.localize)(9,null,this.resourceForError(s)),0,i);if(this.throwIfFileIsReadonly(s,S),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.ETAG_DISABLED&&typeof S.mtime=="number"&&typeof S.size=="number"&&i.mtime<S.mtime&&i.etag!==(0,w.etag)({mtime:i.mtime,size:S.size}))throw new w.FileOperationError((0,b.localize)(10,null),3,i);return S}async readFile(o,s,i){const r=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(r,o,s,i):this.doReadFile(r,o,s,i)}async doReadFileAtomic(o,s,i,r){return new Promise((u,S)=>{this.writeQueue.queueFor(s,async()=>{try{const k=await this.doReadFile(o,s,i,r);u(k)}catch(k){S(k)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,s,i,r){const u=await this.doReadFileStream(o,s,{...i,preferUnbuffered:!0},r);return{...u,value:await(0,I.streamToBuffer)(u.value)}}async readFileStream(o,s,i){const r=await this.withReadProvider(o);return this.doReadFileStream(r,o,s,i)}async doReadFileStream(o,s,i,r){const u=new O.CancellationTokenSource(r);let S=i;(0,w.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(s)&&(S={...i,atomic:!0});const k=this.validateReadFile(s,S).then(L=>L,L=>{throw u.dispose(!0),L});let M;try{return typeof S?.etag=="string"&&S.etag!==w.ETAG_DISABLED&&await k,S?.atomic&&(0,w.hasFileAtomicReadCapability)(o)||!((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasFileReadStreamCapability)(o))||(0,w.hasReadWriteCapability)(o)&&S?.preferUnbuffered?M=this.readFileUnbuffered(o,s,S):(0,w.hasFileReadStreamCapability)(o)?M=this.readFileStreamed(o,s,u.token,S):M=this.readFileBuffered(o,s,u.token,S),M.on("end",()=>u.dispose()),M.on("error",()=>u.dispose()),{...await k,value:M}}catch(L){throw M&&await(0,m.consumeStream)(M),this.restoreReadError(L,s,S)}}restoreReadError(o,s,i){const r=(0,b.localize)(11,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(o).toString());return o instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(r,o.stat,i):o instanceof w.TooLargeFileOperationError?new w.TooLargeFileOperationError(r,o.fileOperationResult,o.size,o.options):new w.FileOperationError(r,(0,w.toFileOperationResult)(o),i)}readFileStreamed(o,s,i,r=Object.create(null)){const u=o.readFileStream(s,r,i);return(0,m.transform)(u,{data:S=>S instanceof I.VSBuffer?S:I.VSBuffer.wrap(S),error:S=>this.restoreReadError(S,s,r)},S=>I.VSBuffer.concat(S))}readFileBuffered(o,s,i,r=Object.create(null)){const u=(0,I.newWriteableBufferStream)();return(0,p.readFileIntoStream)(o,s,u,S=>S,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:S=>this.restoreReadError(S,s,r)},i),u}readFileUnbuffered(o,s,i){const r=(0,m.newWriteableStream)(u=>I.VSBuffer.concat(u));return(async()=>{try{let u;i?.atomic&&(0,w.hasFileAtomicReadCapability)(o)?u=await o.readFile(s,{atomic:!0}):u=await o.readFile(s),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.validateReadFileLimits(s,u.byteLength,i),r.end(I.VSBuffer.wrap(u))}catch(u){r.error(u),r.end()}})(),r}async validateReadFile(o,s){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.FileOperationError((0,b.localize)(12,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&s.etag===i.etag)throw new w.NotModifiedSinceFileOperationError((0,b.localize)(13,null),i,s);return this.validateReadFileLimits(o,i.size,s),i}validateReadFileLimits(o,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new w.TooLargeFileOperationError((0,b.localize)(14,null,this.resourceForError(o)),7,s,i)}async canMove(o,s,i){return this.doCanMoveCopy(o,s,"move",i)}async canCopy(o,s,i){return this.doCanMoveCopy(o,s,"copy",i)}async doCanMoveCopy(o,s,i,r){if(o.toString()!==s.toString())try{const u=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),S=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(u,o,S,s,i,r)}catch(u){return u}return!0}async move(o,s,i){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(r,o,u,s,"move",!!i),k=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,S==="move"?2:3,k)),k}async copy(o,s,i){const r=await this.withReadProvider(o),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),S=await this.doMoveCopy(r,o,u,s,"copy",!!i),k=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,S==="copy"?3:2,k)),k}async doMoveCopy(o,s,i,r,u,S){if(s.toString()===r.toString())return u;const{exists:k,isSameResourceWithDifferentPathCase:M}=await this.doValidateMoveCopy(o,s,i,r,u,S);if(k&&!M&&S&&await this.del(r,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(r)),u==="copy"){if(o===i&&(0,w.hasFileFolderCopyCapability)(o))await o.copy(s,r,{overwrite:S});else{const L=await this.resolve(s);L.isDirectory?await this.doCopyFolder(o,L,i,r):await this.doCopyFile(o,s,i,r)}return u}else return o===i?(await o.rename(s,r,{overwrite:S}),u):(await this.doMoveCopy(o,s,i,r,"copy",S),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,i,r){if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,s,i,r);if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,s,i,r);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,s,i,r);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,s,i,r)}async doCopyFolder(o,s,i,r){await i.mkdir(r),Array.isArray(s.children)&&await D.Promises.settled(s.children.map(async u=>{const S=this.getExtUri(i).providerExtUri.joinPath(r,u.name);return u.isDirectory?this.doCopyFolder(o,await this.resolve(u.resource),i,S):this.doCopyFile(o,u.resource,i,S)}))}async doValidateMoveCopy(o,s,i,r,u,S){let k=!1;if(o===i){const{providerExtUri:L,isPathCaseSensitive:R}=this.getExtUri(o);if(R||(k=L.isEqual(s,r)),k&&u==="copy")throw new Error((0,b.localize)(15,null,this.resourceForError(s),this.resourceForError(r)));if(!k&&L.isEqualOrParent(r,s))throw new Error((0,b.localize)(16,null,this.resourceForError(s),this.resourceForError(r)))}const M=await this.exists(r);if(M&&!k){if(!S)throw new w.FileOperationError((0,b.localize)(17,null,this.resourceForError(s),this.resourceForError(r)),4);if(o===i){const{providerExtUri:L}=this.getExtUri(o);if(L.isEqualOrParent(s,r))throw new Error((0,b.localize)(18,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:M,isSameResourceWithDifferentPathCase:k}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,0,i)),i}async mkdirp(o,s){const i=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(s,r.dirname(s));)try{if(!((await o.stat(s)).type&w.FileType.Directory))throw new Error((0,b.localize)(19,null,this.resourceForError(s)));break}catch(u){if((0,w.toFileSystemProviderErrorCode)(u)!==w.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(r.basename(s)),s=r.dirname(s)}for(let u=i.length-1;u>=0;u--){s=r.joinPath(s,i[u]);try{await o.mkdir(s)}catch(S){if((0,w.toFileSystemProviderErrorCode)(S)!==w.FileSystemProviderErrorCode.FileExists)throw S}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(i){return i}return!0}async doValidateDelete(o,s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),r=!!s?.useTrash;if(r&&!(i.capabilities&4096))throw new Error((0,b.localize)(20,null,this.resourceForError(o)));const u=s?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,b.localize)(21,null,this.resourceForError(o)));if(r&&u)throw new Error((0,b.localize)(22,null,this.resourceForError(o)));let S;try{S=await i.stat(o)}catch{}if(S)this.throwIfFileIsReadonly(o,S);else throw new w.FileOperationError((0,b.localize)(23,null,this.resourceForError(o)),1);if(!!!s?.recursive){const M=await this.resolve(o);if(M.isDirectory&&Array.isArray(M.children)&&M.children.length>0)throw new Error((0,b.localize)(24,null,this.resourceForError(o)))}return i}async del(o,s){const i=await this.doValidateDelete(o,s);let r=s;if((0,w.hasFileAtomicDeleteCapability)(i)&&!r?.atomic){const M=i.enforceAtomicDelete?.(o);M&&(r={...s,atomic:M})}const u=!!r?.useTrash,S=!!r?.recursive,k=r?.atomic??!1;await i.delete(o,{recursive:S,useTrash:u,atomic:k}),this._onDidRunOperation.fire(new w.FileOperationEvent(o,1))}async cloneFile(o,s){const i=await this.withProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(!(i===r&&this.getExtUri(i).providerExtUri.isEqual(o,s)))return i===r&&(0,w.hasFileCloneCapability)(i)?i.cloneFile(o,s):(await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(s)),i===r&&(0,w.hasFileFolderCopyCapability)(i)?this.writeQueue.queueFor(o,()=>i.copy(o,s,{overwrite:!0}),this.getExtUri(i).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(i,o,r,s),this.getExtUri(i).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:f.WATCHER_CORRELATION_IDS++})}watch(o,s={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let r=!1,u=()=>{r=!0};i.add((0,l.toDisposable)(()=>u())),(async()=>{try{const k=await this.doWatch(o,s);r?(0,l.dispose)(k):u=()=>(0,l.dispose)(k)}catch(k){this.logService.error(k)}})();const S=s.correlationId;if(typeof S=="number"){const k=i.add(new C.Emitter);return i.add(this.internalOnDidFilesChange.event(L=>{L.correlates(S)&&k.fire(L)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async doWatch(o,s){const i=await this.withProvider(o),r=(0,P.hash)([this.getExtUri(i).providerExtUri.getComparisonKey(o),s]);let u=this.activeWatchers.get(r);return u||(u={count:0,disposable:i.watch(o,s)},this.activeWatchers.set(r,u)),u.count+=1,(0,l.toDisposable)(()=>{u&&(u.count--,u.count===0&&((0,l.dispose)(u.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,i,r){return this.writeQueue.queueFor(s,async()=>{const u=await o.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,u,r):await this.doWriteReadableBufferedQueued(o,u,r)}catch(S){throw(0,w.ensureFileSystemProviderError)(S)}finally{await o.close(u)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,s,i){let r=0,u;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const S=I.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,s,S,S.byteLength,r,0),r+=S.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((S,k)=>{(0,m.listenStream)(u,{onData:async M=>{u.pause();try{await this.doWriteBuffer(o,s,M,M.byteLength,r,0)}catch(L){return k(L)}r+=M.byteLength,setTimeout(()=>u.resume())},onError:M=>k(M),onEnd:()=>S()})})}async doWriteReadableBufferedQueued(o,s,i){let r=0,u;for(;(u=i.read())!==null;)await this.doWriteBuffer(o,s,u,u.byteLength,r,0),r+=u.byteLength}async doWriteBuffer(o,s,i,r,u,S){let k=0;for(;k<r;){const M=await o.write(s,u+k,i.buffer,S+k,r-k);k+=M}}async doWriteUnbuffered(o,s,i,r){return this.writeQueue.queueFor(s,()=>this.doWriteUnbufferedQueued(o,s,i,r),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,s,i,r){let u;r instanceof I.VSBuffer?u=r:(0,m.isReadableStream)(r)?u=await(0,I.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?u=await(0,I.bufferedStreamToBuffer)(r):u=(0,I.readableToBuffer)(r),await o.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async doPipeBuffered(o,s,i,r){return this.writeQueue.queueFor(r,()=>this.doPipeBufferedQueued(o,s,i,r),this.getExtUri(i).providerExtUri)}async doPipeBufferedQueued(o,s,i,r){let u,S;try{u=await o.open(s,{create:!1}),S=await i.open(r,{create:!0,unlock:!1});const k=I.VSBuffer.alloc(this.BUFFER_SIZE);let M=0,L=0,R=0;do R=await o.read(u,M,k.buffer,L,k.byteLength-L),await this.doWriteBuffer(i,S,k,R,M,L),M+=R,L+=R,L===k.byteLength&&(L=0);while(R>0)}catch(k){throw(0,w.ensureFileSystemProviderError)(k)}finally{await D.Promises.settled([typeof u=="number"?o.close(u):Promise.resolve(),typeof S=="number"?i.close(S):Promise.resolve()])}}async doPipeUnbuffered(o,s,i,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedQueued(o,s,i,r),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedQueued(o,s,i,r){return i.writeFile(r,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,s,i,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedToBufferedQueued(o,s,i,r),this.getExtUri(i).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,s,i,r){const u=await i.open(r,{create:!0,unlock:!1});try{const S=await o.readFile(s);await this.doWriteBuffer(i,u,I.VSBuffer.wrap(S),S.byteLength,0,0)}catch(S){throw(0,w.ensureFileSystemProviderError)(S)}finally{await i.close(u)}}async doPipeBufferedToUnbuffered(o,s,i,r){const u=await(0,I.streamToBuffer)(this.readFileBuffered(o,s,O.CancellationToken.None));await this.doWriteUnbuffered(i,r,void 0,u)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new w.FileOperationError((0,b.localize)(25,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,b.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=a,e.FileService=a=f=Pe([ne(0,d.ILogService)],a)}),define(oe[94],ae([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(o)}`)}})();class t extends d.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new O.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await m.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.toFileSystemProviderError(i)}}async statIgnoreError(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await m.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async u=>{try{let S;u.isSymbolicLink()?S=(await this.stat((0,E.joinPath)(s,u.name))).type:S=this.toType(u),r.push([u.name,S])}catch(S){this.logService.trace(S)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=w.FileType.Unknown:s.isFile()?r=w.FileType.File:s.isDirectory()?r=w.FileType.Directory:r=w.FileType.Unknown,i&&(r|=w.FileType.SymbolicLink),r}async createResourceLock(s){const i=this.toFilePath(s);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(s);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const u=new I.Barrier;return this.resourceLocks.set(s,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const u=this.toFilePath(s);return await m.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{r?.dispose()}}traceLock(s){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(s)}readFileStream(s,i,r){const u=(0,g.newWriteableStream)(S=>C.VSBuffer.concat(S.map(k=>C.VSBuffer.wrap(k))).buffer);return(0,p.readFileIntoStream)(this,s,u,S=>S.buffer,{...i,bufferSize:256*1024},r),u}async writeFile(s,i,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(s)?this.doWriteFileAtomic(s,(0,E.joinPath)((0,E.dirname)(s),`${(0,E.basename)(s)}${r.atomic.postfix}`),i,r):this.doWriteFile(s,i,r)}async canWriteFileAtomic(s){try{const i=this.toFilePath(s),{symbolicLink:r}=await m.SymlinkSupport.stat(i);if(r)return!1}catch{}return!0}async doWriteFileAtomic(s,i,r,u){const S=new l.DisposableStore;try{S.add(await this.createResourceLock(s)),S.add(await this.createResourceLock(i)),await this.doWriteFile(i,r,u,!0);try{await this.rename(i,s,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{S.dispose()}}async doWriteFile(s,i,r,u){let S;try{const k=this.toFilePath(s);if(!r.create||!r.overwrite){if(await m.Promises.exists(k)){if(!r.overwrite)throw(0,w.createFileSystemProviderError)((0,b.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,w.createFileSystemProviderError)((0,b.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:r.unlock},u),await this.write(S,0,i,0,i.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(s,k)}finally{typeof S=="number"&&await this.close(S)}}static{this.canFlush=!0}static configureFlushOnWrite(s){t.canFlush=s}async open(s,i,r){const u=this.toFilePath(s);let S;(0,w.isFileOpenForWriteOptions)(i)&&!r&&(S=await this.createResourceLock(s));let k;try{if((0,w.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:L}=await m.SymlinkSupport.stat(u);L.mode&128||await m.Promises.chmod(u,L.mode|128)}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}let M;if((0,w.isFileOpenForWriteOptions)(i)){if(y.isWindows)try{await m.Promises.truncate(u,0),M="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}M||(M="w")}else M="r";k=await m.Promises.open(u,M)}catch(M){throw S?.dispose(),(0,w.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,M):this.toFileSystemProviderError(M)}if(this.mapHandleToPos.set(k,0),(0,w.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(k,s),S){const M=this.mapHandleToLock.get(k);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${u})`),this.mapHandleToLock.set(k,S),M&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${u})`),M.dispose())}return k}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&t.canFlush)try{await m.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.logService.error(r)}return await m.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,r,u,S){const k=this.normalizePos(s,i);let M=null;try{M=(await m.Promises.read(s,r,u,S,k)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(s,k,M)}return M}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const u=this.mapHandleToPos.get(s);typeof u=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,u+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,u,S){return(0,I.retry)(()=>this.doWrite(s,i,r,u,S),100,3)}async doWrite(s,i,r,u,S){const k=this.normalizePos(s,i);let M=null;try{M=(await m.Promises.write(s,r,u,S,k)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),L)}finally{this.updatePos(s,k,M)}return M}async mkdir(s){try{await m.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,v.join)((0,v.dirname)(r),`${(0,v.basename)(r)}${i.atomic.postfix}`)),await m.Promises.rm(r,m.RimRafMode.MOVE,u)}else try{await m.Promises.unlink(r)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let S=!1;try{const{stat:k,symbolicLink:M}=await m.SymlinkSupport.stat(r);S=k.isDirectory()&&!M}catch{}if(S)await m.Promises.rmdir(r);else throw u}else throw u}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const u=this.toFilePath(s),S=this.toFilePath(i);if(u!==S)try{await this.validateMoveCopy(s,i,"move",r.overwrite),await m.Promises.rename(u,S)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,b.localize)(2,null,(0,v.basename)(u),(0,v.basename)((0,v.dirname)(S)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(s,i,r){const u=this.toFilePath(s),S=this.toFilePath(i);if(u!==S)try{await this.validateMoveCopy(s,i,"copy",r.overwrite),await m.Promises.copy(u,S,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,b.localize)(3,null,(0,v.basename)(u),(0,v.basename)((0,v.dirname)(S)),k.toString()))),this.toFileSystemProviderError(k)}}async validateMoveCopy(s,i,r,u){const S=this.toFilePath(s),k=this.toFilePath(i);let M=!1;if(!!(this.capabilities&1024)||(M=(0,h.isEqual)(S,k,!0)),M){if(r==="copy")throw(0,w.createFileSystemProviderError)((0,b.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const R=await this.statIgnoreError(s);if(!R)throw(0,w.createFileSystemProviderError)((0,b.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const A=await this.statIgnoreError(i);if(A){if(!u)throw(0,w.createFileSystemProviderError)((0,b.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);R.type&w.FileType.File&&A.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.doCloneFile(s,i,!1)}async doCloneFile(s,i,r){const u=this.toFilePath(s),S=this.toFilePath(i),k=!!(this.capabilities&1024);if((0,h.isEqual)(u,S,!k))return;const M=new l.DisposableStore;try{M.add(await this.createResourceLock(s)),M.add(await this.createResourceLock(i)),r&&await m.Promises.mkdir((0,v.dirname)(S),{recursive:!0}),await m.Promises.copyFile(u,S)}catch(L){if(L.code==="ENOENT"&&!r)return this.doCloneFile(s,i,!0);throw this.toFileSystemProviderError(L)}finally{M.dispose()}}createUniversalWatcher(s,i,r){return new f.UniversalWatcherClient(u=>s(u),u=>i(u),r)}createNonRecursiveWatcher(s,i,r){return new a.NodeJSWatcherClient(u=>s(u),u=>i(u),r)}toFileSystemProviderError(s){if(s instanceof w.FileSystemProviderError)return s;let i=s,r;switch(s.code){case"ENOENT":r=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=w.FileSystemProviderErrorCode.Unknown;break;default:r=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.toFilePath(s));u.mode&128||(r=(0,w.createFileSystemProviderError)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return r}}e.DiskFileSystemProvider=t}),define(oe[227],ae([0,1,3,94,2,17,63,23]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends I.Disposable{constructor(y,E){super(),this.provider=y,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(y,E,g){const m=this.getUriTransformer(y);switch(E){case"stat":return this.stat(m,g[0]);case"readdir":return this.readdir(m,g[0]);case"open":return this.open(m,g[0],g[1]);case"close":return this.close(g[0]);case"read":return this.read(g[0],g[1],g[2]);case"readFile":return this.readFile(m,g[0],g[1]);case"write":return this.write(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.writeFile(m,g[0],g[1],g[2]);case"rename":return this.rename(m,g[0],g[1],g[2]);case"copy":return this.copy(m,g[0],g[1],g[2]);case"cloneFile":return this.cloneFile(m,g[0],g[1]);case"mkdir":return this.mkdir(m,g[0]);case"delete":return this.delete(m,g[0],g[1]);case"watch":return this.watch(m,g[0],g[1],g[2],g[3]);case"unwatch":return this.unwatch(g[0],g[1])}throw new Error(`IPC Command ${E} not found`)}listen(y,E,g){const m=this.getUriTransformer(y);switch(E){case"fileChange":return this.onFileChange(m,g[0]);case"readFileStream":return this.onReadFileStream(m,g[0],g[1])}throw new Error(`Unknown event ${E}`)}stat(y,E){const g=this.transformIncoming(y,E,!0);return this.provider.stat(g)}readdir(y,E){const g=this.transformIncoming(y,E);return this.provider.readdir(g)}async readFile(y,E,g){const m=this.transformIncoming(y,E,!0),b=await this.provider.readFile(m,g);return O.VSBuffer.wrap(b)}onReadFileStream(y,E,g){const m=this.transformIncoming(y,E,!0),b=new P.CancellationTokenSource,w=new n.Emitter({onDidRemoveLastListener:()=>{b.cancel()}}),p=this.provider.readFileStream(m,g,b.token);return(0,C.listenStream)(p,{onData:d=>w.fire(O.VSBuffer.wrap(d)),onError:d=>w.fire(d),onEnd:()=>{w.fire("end"),w.dispose(),b.dispose()}}),w.event}writeFile(y,E,g,m){const b=this.transformIncoming(y,E);return this.provider.writeFile(b,g.buffer,m)}open(y,E,g){const m=this.transformIncoming(y,E,!0);return this.provider.open(m,g)}close(y){return this.provider.close(y)}async read(y,E,g){const m=O.VSBuffer.alloc(g),w=await this.provider.read(y,E,m.buffer,0,g);return[m,w]}write(y,E,g,m,b){return this.provider.write(y,E,g.buffer,m,b)}mkdir(y,E){const g=this.transformIncoming(y,E);return this.provider.mkdir(g)}delete(y,E,g){const m=this.transformIncoming(y,E);return this.provider.delete(m,g)}rename(y,E,g,m){const b=this.transformIncoming(y,E),w=this.transformIncoming(y,g);return this.provider.rename(b,w,m)}copy(y,E,g,m){const b=this.transformIncoming(y,E),w=this.transformIncoming(y,g);return this.provider.copy(b,w,m)}cloneFile(y,E,g){const m=this.transformIncoming(y,E),b=this.transformIncoming(y,g);return this.provider.cloneFile(m,b)}onFileChange(y,E){const g=new n.Emitter({onWillAddFirstListener:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(y,g))},onDidRemoveLastListener:()=>{(0,I.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return g.event}async watch(y,E,g,m,b){const w=this.sessionToWatcher.get(E);if(w){const p=this.transformIncoming(y,m),d=w.watch(g,p,b);this.watchRequests.set(E+g,d)}}async unwatch(y,E){const g=y+E,m=this.watchRequests.get(g);m&&((0,I.dispose)(m),this.watchRequests.delete(g))}dispose(){super.dispose();for(const[,y]of this.watchRequests)y.dispose();this.watchRequests.clear();for(const[,y]of this.sessionToWatcher)y.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class l extends I.Disposable{constructor(y,E,g,m){super(),this.uriTransformer=y,this.logService=g,this.environmentService=m,this.watcherRequests=new Map,this.fileWatcher=this._register(new D.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(E)}registerListeners(y){const E=this._register(new n.Emitter);this._register(E.event(g=>{y.fire(g.map(m=>({resource:this.uriTransformer.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this._register(this.fileWatcher.onDidChangeFile(g=>E.fire(g))),this._register(this.fileWatcher.onDidWatchError(g=>y.fire(g)))}getRecursiveWatcherOptions(y){}getExtraExcludes(y){}watch(y,E,g){const m=this.getExtraExcludes(this.environmentService);return Array.isArray(m)&&(g.excludes=[...g.excludes,...m]),this.watcherRequests.set(y,this.fileWatcher.watch(E,g)),(0,I.toDisposable)(()=>{(0,I.dispose)(this.watcherRequests.get(y)),this.watcherRequests.delete(y)})}dispose(){for(const[,y]of this.watcherRequests)y.dispose();this.watcherRequests.clear(),super.dispose()}}e.AbstractSessionFileWatcher=l}),define(oe[228],ae([0,1,14,180,4,7,16,9,227,157,47]),function(Q,e,n,D,I,O,C,P,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends h.AbstractDiskFileSystemProviderChannel{constructor(m,b,w){super(m,b),this.environmentService=w}getUriTransformer(m){return l.DefaultURITransformer}transformIncoming(m,b){return O.URI.revive(b)}async delete(m,b,w){if(!w.useTrash)return super.delete(m,b,w);const p=this.transformIncoming(m,b),d=(0,P.normalize)(p.fsPath);try{await n.shell.trashItem(d)}catch(c){throw(0,C.createFileSystemProviderError)(I.isWindows?(0,D.localize)(0,null,(0,P.basename)(d),(0,v.toErrorMessage)(c)):(0,D.localize)(1,null,(0,P.basename)(d),(0,v.toErrorMessage)(c)),C.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(m,b){return new E(m,b,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=y;class E extends h.AbstractSessionFileWatcher{watch(m,b,w){if(w.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(m,b,w)}}}),define(oe[229],ae([0,1,5]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class D extends n.AbstractMessageLogger{constructor(O=n.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(O),this._register(this.onDidChangeLogLevel(C=>{this._logger?.setLevel(C)}))}set logger(O){this._logger=O;for(const{level:C,message:P}of this.buffer)(0,n.log)(O,C,P);this.buffer=[]}log(O,C){this._logger?(0,n.log)(this._logger,O,C):this.getLevel()<=O&&this.buffer.push({level:O,message:C})}dispose(){this._logger?.dispose(),super.dispose()}flush(){this._logger?.flush()}}e.BufferLogger=D}),define(oe[230],ae([0,1,7,3,5,2]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class C extends I.AbstractLoggerService{constructor(y,E,g,m,b){super(E,g,m),this.windowId=y,this.channel=b,this._register(b.listen("onDidChangeLogLevel",y)(w=>{(0,I.isLogLevel)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this._register(b.listen("onDidChangeVisibility",y)(([w,p])=>super.setVisibility(n.URI.revive(w),p))),this._register(b.listen("onDidChangeLoggers",y)(({added:w,removed:p})=>{for(const d of w)super.registerLogger({...d,resource:n.URI.revive(d.resource)});for(const d of p)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new I.AdapterLogger({log:(y,E)=>{this.channel.call("consoleLog",[y,E])}})}registerLogger(y){super.registerLogger(y),this.channel.call("registerLogger",[y,this.windowId])}deregisterLogger(y){super.deregisterLogger(y),this.channel.call("deregisterLogger",[y,this.windowId])}setLogLevel(y,E){super.setLogLevel(y,E),this.channel.call("setLogLevel",[y,E])}setVisibility(y,E){super.setVisibility(y,E),this.channel.call("setVisibility",[this.toResource(y),E])}doCreateLogger(y,E,g){return new P(this.channel,y,E,g,this.windowId)}static setLogLevel(y,E,g){return y.call("setLogLevel",[E,g])}}e.LoggerChannelClient=C;class P extends I.AbstractMessageLogger{constructor(y,E,g,m,b){super(m?.logLevel==="always"),this.channel=y,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[E,m,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,E){const g=[[y,E]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(y){this.channel.call("log",[this.file,y])}}class h{constructor(y,E){this.loggerService=y,this.getUriTransformer=E}listen(y,E){const g=this.getUriTransformer(y);switch(E){case"onDidChangeLoggers":return D.Event.map(this.loggerService.onDidChangeLoggers,m=>({added:[...m.added].map(b=>this.transformLogger(b,g)),removed:[...m.removed].map(b=>this.transformLogger(b,g))}));case"onDidChangeVisibility":return D.Event.map(this.loggerService.onDidChangeVisibility,m=>[g.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return D.Event.map(this.loggerService.onDidChangeLogLevel,m=>(0,I.isLogLevel)(m)?m:[g.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${E}`)}async call(y,E,g){const m=this.getUriTransformer(y);switch(E){case"setLogLevel":return(0,I.isLogLevel)(g[0])?this.loggerService.setLogLevel(g[0]):this.loggerService.setLogLevel(n.URI.revive(m.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(b=>this.transformLogger(b,m)))}throw new Error(`Call not found: ${E}`)}transformLogger(y,E){return{...y,resource:E.transformOutgoingURI(y.resource)}}}e.LoggerChannel=h;class l extends O.Disposable{constructor(y,E){super(),E.call("setLogLevel",[y.getLogLevel()]),this._register(y.onDidChangeLogLevel(g=>E.call("setLogLevel",[g]))),E.call("getRegisteredLoggers").then(g=>{for(const m of g)y.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this._register(E.listen("onDidChangeVisibility")(([g,m])=>y.setVisibility(n.URI.revive(g),m))),this._register(E.listen("onDidChangeLoggers")(({added:g,removed:m})=>{for(const b of g)y.registerLogger({...b,resource:n.URI.revive(b.resource)});for(const b of m)y.deregisterLogger(b.resource)}))}}e.RemoteLoggerChannelClient=l}),define(oe[231],ae([0,1,2,5]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends n.Disposable{constructor(C,P=[]){super(),this.logger=new D.MultiplexLogger([C,...P]),this._register(C.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(C){this.logger.setLevel(C)}getLevel(){return this.logger.getLevel()}trace(C,...P){this.logger.trace(C,...P)}debug(C,...P){this.logger.debug(C,...P)}info(C,...P){this.logger.info(C,...P)}warn(C,...P){this.logger.warn(C,...P)}error(C,...P){this.logger.error(C,...P)}flush(){this.logger.flush()}}e.LogService=I}),define(oe[232],ae([0,1,32,7,5]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class O{constructor(P){this.loggerService=P,this.loggers=new n.ResourceMap}listen(P,h,l){switch(h){case"onDidChangeLoggers":return l?this.loggerService.getOnDidChangeLoggersEvent(l):this.loggerService.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.loggerService.getOnDidChangeLogLevelEvent(l):this.loggerService.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.loggerService.getOnDidChangeVisibilityEvent(l):this.loggerService.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(P,h,l){switch(h){case"createLogger":this.createLogger(D.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.log(D.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1]);case"setLogLevel":return(0,I.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(D.URI.revive(l[0]),l[1]);case"setVisibility":return this.loggerService.setVisibility(D.URI.revive(l[0]),l[1]);case"registerLogger":return this.loggerService.registerLogger({...l[0],resource:D.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.loggerService.deregisterLogger(D.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}createLogger(P,h,l){this.loggers.set(P,this.loggerService.createLogger(P,h,l))}consoleLog(P,h){let l=console.log;switch(P){case I.LogLevel.Error:l=console.error;break;case I.LogLevel.Warning:l=console.warn;break;case I.LogLevel.Info:l=console.info;break}l.call(console,...h)}log(P,h){const l=this.loggers.get(P);if(!l)throw new Error("Create the logger before logging");for(const[v,y]of h)(0,I.log)(l,v,y)}}e.LoggerChannel=O}),define(oe[233],ae([0,1,16,5]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(I||(I={}));async function O(l,v,y,E,g){try{const m=await new Promise((w,p)=>{Q(["@vscode/spdlog"],w,p)});m.setFlushOn(I.Trace);const b=await m.createAsyncRotatingLogger(l,v,y,E);return g?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(m){console.error(m)}return null}function C(l,v,y){switch(v){case D.LogLevel.Trace:l.trace(y);break;case D.LogLevel.Debug:l.debug(y);break;case D.LogLevel.Info:l.info(y);break;case D.LogLevel.Warning:l.warn(y);break;case D.LogLevel.Error:l.error(y);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function P(l,v){switch(v){case D.LogLevel.Trace:l.setLevel(I.Trace);break;case D.LogLevel.Debug:l.setLevel(I.Debug);break;case D.LogLevel.Info:l.setLevel(I.Info);break;case D.LogLevel.Warning:l.setLevel(I.Warning);break;case D.LogLevel.Error:l.setLevel(I.Error);break;case D.LogLevel.Off:l.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class h extends D.AbstractMessageLogger{constructor(v,y,E,g,m){super(),this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(v,y,E,g),this._register(this.onDidChangeLogLevel(b=>{this._logger&&P(this._logger,b)}))}async _createSpdLogLogger(v,y,E,g){const m=E?6:1,b=30/m*n.ByteSize.MB,w=await O(v,y,b,m,g);if(w){this._logger=w,P(this._logger,this.getLevel());for(const{level:p,message:d}of this.buffer)C(this._logger,p,d);this.buffer=[]}}log(v,y){this._logger?C(this._logger,v,y):this.getLevel()<=v&&this.buffer.push({level:v,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(oe[234],ae([0,1,33,5,233]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class O extends D.AbstractLoggerService{doCreateLogger(P,h,l){return new I.SpdLogLogger((0,n.generateUuid)(),P.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.LoggerService=O}),define(oe[67],ae([0,1,32,3,6,5,234]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,I.refineServiceDecorator)(O.ILoggerService);class P extends C.LoggerService{constructor(){super(...arguments),this.loggerResourcesByWindow=new n.ResourceMap}createLogger(l,v,y){y!==void 0&&this.loggerResourcesByWindow.set(this.toResource(l),y);try{return super.createLogger(l,v)}catch(E){throw this.loggerResourcesByWindow.delete(this.toResource(l)),E}}registerLogger(l,v){v!==void 0&&this.loggerResourcesByWindow.set(l.resource,v),super.registerLogger(l)}deregisterLogger(l){this.loggerResourcesByWindow.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const v=[];for(const y of super.getRegisteredLoggers())l===this.loggerResourcesByWindow.get(y.resource)&&v.push(y);return v}getOnDidChangeLogLevelEvent(l){return D.Event.filter(this.onDidChangeLogLevel,v=>(0,O.isLogLevel)(v)||this.isInterestedLoggerResource(v[0],l))}getOnDidChangeVisibilityEvent(l){return D.Event.filter(this.onDidChangeVisibility,([v])=>this.isInterestedLoggerResource(v,l))}getOnDidChangeLoggersEvent(l){return D.Event.filter(D.Event.map(this.onDidChangeLoggers,v=>({added:[...v.added].filter(E=>this.isInterestedLoggerResource(E.resource,l)),removed:[...v.removed].filter(E=>this.isInterestedLoggerResource(E.resource,l))})),v=>v.added.length>0||v.removed.length>0)}deregisterLoggers(l){for(const[v,y]of this.loggerResourcesByWindow)y===l&&this.deregisterLogger(v)}isInterestedLoggerResource(l,v){const y=this.loggerResourcesByWindow.get(l);return y===void 0||y===v}dispose(){super.dispose(),this.loggerResourcesByWindow.clear()}}e.LoggerMainService=P}),define(oe[235],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemSubmenu=n,e.isMenubarMenuItemSeparator=D,e.isMenubarMenuItemRecentAction=I,e.isMenubarMenuItemAction=O;function n(C){return C.submenu!==void 0}function D(C){return C.id==="vscode.menubar.separator"}function I(C){return C.uri!==void 0}function O(C){return!n(C)&&!D(C)&&!I(C)}}),define(oe[39],ae([0,1,3,71,2,6]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class C extends I.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(l){const v=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...l,...this.policyDefinitions},v!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(l),D.Iterable.reduce(this.policies.entries(),(y,[E,g])=>({...y,[E]:g}),{})}getPolicyValue(l){return this.policies.get(l)}serialize(){return D.Iterable.reduce(Object.entries(this.policyDefinitions),(l,[v,y])=>({...l,[v]:{definition:y,value:this.policies.get(v)}}),{})}}e.AbstractPolicyService=C;class P{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(oe[236],ae([0,1,8,3,71,12,16,5,39]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(y,E){const g=[];for(const m of new Set(I.Iterable.concat(y.keys(),E.keys())))y.get(m)!==E.get(m)&&g.push(m);return g}let v=class extends h.AbstractPolicyService{constructor(E,g,m){super(),this.file=E,this.fileService=g,this.logService=m,this.throttledDelayer=this._register(new n.ThrottledDelayer(500));const b=D.Event.filter(g.onDidFilesChange,w=>w.affects(E));this._register(g.watch(E)),this._register(b(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const E=new Map;try{const g=await this.fileService.readFile(this.file),m=JSON.parse(g.value.toString());if(!(0,O.isObject)(m))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(m))this.policyDefinitions[b]&&E.set(b,m[b])}catch(g){g.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",g)}return E}async refresh(){const E=await this.read(),g=l(this.policies,E);this.policies=E,g.length>0&&this._onDidChange.fire(g)}};e.FilePolicyService=v,e.FilePolicyService=v=Pe([ne(1,C.IFileService),ne(2,P.ILogService)],v)}),define(oe[237],ae([0,1,3,2,39]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(h){this.service=h,this.disposables=new D.DisposableStore}listen(h,l){switch(l){case"onDidChange":return n.Event.map(this.service.onDidChange,v=>v.reduce((y,E)=>({...y,[E]:this.service.getPolicyValue(E)??null}),{}),this.disposables)}throw new Error(`Event not found: ${l}`)}call(h,l,v){switch(l){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(v)}throw new Error(`Call not found: ${l}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=O;class C extends I.AbstractPolicyService{constructor(h,l){super(),this.channel=l;for(const v in h){const{definition:y,value:E}=h[v];this.policyDefinitions[v]=y,E!==void 0&&this.policies.set(v,E)}this.channel.listen("onDidChange")(v=>{for(const y in v){const E=v[y];E===null?this.policies.delete(y):this.policies.set(y,E)}this._onDidChange.fire(Object.keys(v))})}async _updatePolicyDefinitions(h){const l=await this.channel.call("updatePolicyDefinitions",h);for(const v in l)this.policies.set(v,l[v])}}e.PolicyChannelClient=C}),define(oe[238],ae([0,1,39,8,2,5]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let C=class extends n.AbstractPolicyService{constructor(h,l){super(),this.logService=h,this.productName=l,this.throttler=new D.Throttler,this.watcher=this._register(new I.MutableDisposable)}async _updatePolicyDefinitions(h){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:l}=await new Promise((v,y)=>{Q(["@vscode/policy-watcher"],v,y)});await this.throttler.queue(()=>new Promise((v,y)=>{try{this.watcher.value=l(this.productName,h,E=>{this._onDidPolicyChange(E),v()})}catch(E){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",E),y(E)}}))}_onDidPolicyChange(h){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const l in h){const v=h[l];v===void 0?this.policies.delete(l):this.policies.set(l,v)}this._onDidChange.fire(Object.keys(h))}};e.NativePolicyService=C,e.NativePolicyService=C=Pe([ne(0,O.ILogService)],C)}),define(oe[80],ae([0,1,36]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const I=globalThis.vscode;if(typeof I<"u"&&typeof I.context<"u"){const O=I.context.configuration();if(O)D=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){D=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:O,searchUrl:C,itemUrl:P,controlUrl:h}=D.extensionsGallery||{};Object.assign(D,{extensionsGallery:{serviceUrl:n.env.VSCODE_GALLERY_SERVICE_URL||O,searchUrl:n.env.VSCODE_GALLERY_SEARCH_URL||C,itemUrl:n.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:n.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const l=(...y)=>y.reduce((E,g)=>(Object.keys(g).forEach(m=>{Array.isArray(E[m])&&Array.isArray(g[m])?E[m]=g[m]:typeof E[m]=="object"&&typeof g[m]=="object"?E[m]=l(E[m],g[m]):E[m]=g[m]}),E),{}),v=globalThis._VSCODE_USER_PRODUCT_JSON||{};D=l(D,v)}catch{}if(n.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const l=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:l.version,release:l.release})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[27],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[239],ae([0,1,8,5]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let I=class{constructor(C,P,h){this._window=C,this._sessionId=P,this._logService=h}async inspect(C){await this._connect();const P=this._window.webContents.debugger;await P.sendCommand("Profiler.start"),this._logService.warn("[perf] profiling STARTED",this._sessionId),await(0,n.timeout)(C);const h=await P.sendCommand("Profiler.stop");return this._logService.warn("[perf] profiling DONE",this._sessionId),await this._disconnect(),h.profile}async _connect(){const C=this._window.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async _disconnect(){const C=this._window.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.WindowProfiler=I,e.WindowProfiler=I=Pe([ne(2,D.ILogService)],I)}),define(oe[81],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,n.createDecorator)("protocolMainService")}),define(oe[45],ae([0,1,139,12]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,P){n.ok(D.isString(C)),n.ok(D.isObject(P)),n.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,P)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(oe[240],ae([0,1,3,45]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class O{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,l){this.schemasById[I(h)]=l,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new O;D.Registry.add(e.Extensions.JSONContribution,C)}),define(oe[52],ae([0,1,22,3,12,165,18,240,45]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=b,e.keyFromOverrideIdentifiers=w,e.getDefaultValue=p,e.validateProperty=c,e.getScopes=f;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var v;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v||(e.ConfigurationScope=v={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=h.Registry.as(P.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.doRegisterConfigurations(t,o,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.doDeregisterConfigurations(t,o),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.doDeregisterConfigurations(o,s),this.doRegisterConfigurations(t,!1,s),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.doRegisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,o){const s=[];for(const{overrides:i,source:r}of t)for(const u in i)if(o.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const S=this.configurationDefaultsOverrides.get(u),k=S?.valuesSources??new Map;if(r)for(const A of Object.keys(i[u]))k.set(A,r);const M={...S?.value||{},...i[u]};this.configurationDefaultsOverrides.set(u,{source:r,value:M,valuesSources:k});const L=(0,C.getLanguageTagSettingPlainKey)(u),R={type:"object",default:M,description:O.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:I.isString(r)?void 0:r,defaultValueSource:r};s.push(...b(u)),this.configurationProperties[u]=R,this.defaultLanguageConfigurationOverridesNode.properties[u]=R}else{this.configurationDefaultsOverrides.set(u,{value:i[u],source:r});const S=this.configurationProperties[u];S&&(this.updatePropertyDefaultValue(u,S),this.updateSchema(u,S))}this.doRegisterOverrideIdentifiers(s)}deregisterDefaultConfigurations(t){const o=new Set;this.doDeregisterDefaultConfigurations(t,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,o){for(const{overrides:s,source:i}of t)for(const r in s){const u=this.configurationDefaultsOverrides.get(r),S=I.isString(i)?i:i?.id,k=I.isString(u?.source)?u?.source:u?.source?.id;if(S===k)if(o.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const M=this.configurationProperties[r];M&&(this.updatePropertyDefaultValue(r,M),this.updateSchema(r,M))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,s),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const o of t)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,o,s){t.forEach(i=>{this.validateAndRegisterProperties(i,o,i.extensionInfo,i.restrictedProperties,void 0,s),this.configurationContributors.push(i),this.registerJSONConfiguration(i)})}doDeregisterConfigurations(t,o){const s=i=>{if(i.properties)for(const r in i.properties){o.add(r);const u=this.configurationProperties[r];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>s(r))};for(const i of t){s(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(t,o=!0,s,i,r=3,u){r=I.isUndefinedOrNull(t.scope)?r:t.scope;const S=t.properties;if(S)for(const M in S){const L=S[M];if(o&&c(M,L)){delete S[M];continue}if(L.source=s,L.defaultDefaultValue=S[M].default,this.updatePropertyDefaultValue(M,L),e.OVERRIDE_PROPERTY_REGEX.test(M)?L.scope=void 0:(L.scope=I.isUndefinedOrNull(L.scope)?r:L.scope,L.restricted=I.isUndefinedOrNull(L.restricted)?!!i?.includes(M):L.restricted),S[M].hasOwnProperty("included")&&!S[M].included){this.excludedConfigurationProperties[M]=S[M],delete S[M];continue}else this.configurationProperties[M]=S[M],S[M].policy?.name&&this.policyConfigurations.set(S[M].policy.name,M);!S[M].deprecationMessage&&S[M].markdownDeprecationMessage&&(S[M].deprecationMessage=S[M].markdownDeprecationMessage),u.add(M)}const k=t.allOf;if(k)for(const M of k)this.validateAndRegisterProperties(M,o,s,i,r,u)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const o=s=>{const i=s.properties;if(i)for(const u in i)this.updateSchema(u,i[u]);s.allOf?.forEach(o)};o(t)}updateSchema(t,o){switch(e.allSettings.properties[t]=o,o.scope){case 1:e.applicationSettings.properties[t]=o;break;case 2:e.machineSettings.properties[t]=o;break;case 6:e.machineOverridableSettings.properties[t]=o;break;case 3:e.windowSettings.properties[t]=o;break;case 4:e.resourceSettings.properties[t]=o;break;case 5:e.resourceSettings.properties[t]=o,this.resourceLanguageSettingsSchema.properties[t]=o;break}}removeFromSchema(t,o){switch(delete e.allSettings.properties[t],o.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const o=`[${t}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}registerOverridePropertyPatternKey(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,o){const s=this.configurationDefaultsOverrides.get(t);let i=s?.value,r=s?.source;I.isUndefined(i)&&(i=o.defaultDefaultValue,r=void 0),I.isUndefined(i)&&(i=p(o.type)),o.default=i,o.defaultValueSource=r}}const g="\\[([^\\]]+)\\]",m=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(a){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=m.exec(a);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=m.exec(a)}}return(0,n.distinct)(t)}function w(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function p(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new E;h.Registry.add(e.Extensions.Configuration,d);function c(a,t){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?O.localize(7,null,a):d.getConfigurationProperties()[a]!==void 0?O.localize(8,null,a):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,a,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function f(){const a=[],t=d.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(oe[123],ae([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=c;function g(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class m{constructor(s={},i=[],r=[],u){this._contents=s,this._keys=i,this._overrides=r,this.raw=u,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof m)return i;const r=new b("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=s.reduce((i,r)=>r===i?r:i.merge(r),s[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,v.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const r=this;return{get value(){return g(r.rawConfiguration.getValue(s))},get override(){return i?g(r.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return g(i?r.rawConfiguration.override(i).getValue(s):r.rawConfiguration.getValue(s))},get overrides(){const u=[];for(const{contents:S,identifiers:k,keys:M}of r.rawConfiguration.overrides){const L=new m(S,M).getValue(s);L!==void 0&&u.push({identifiers:k,value:L})}return u.length?g(u):void 0}}}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,v.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return n.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return n.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=P.deepClone(this.contents),r=P.deepClone(this.overrides),u=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const k of s)if(S.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.mergeContents(i,k.contents);for(const M of k.overrides){const[L]=r.filter(R=>n.equals(R.identifiers,M.identifiers));L?(this.mergeContents(L.contents,M.contents),L.keys.push(...M.keys),L.keys=n.distinct(L.keys)):r.push(P.deepClone(M))}for(const M of k.keys)u.indexOf(M)===-1&&u.push(M)}return new m(i,u,r,S.every(k=>k instanceof m)?void 0:S)}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const u of n.distinct([...Object.keys(this.contents),...Object.keys(i)])){let S=this.contents[u];const k=i[u];k&&(typeof S=="object"&&typeof k=="object"?(S=P.deepClone(S),this.mergeContents(S,k)):S=k),r[u]=S}return new m(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&h.isObject(s[r])&&h.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=P.deepClone(i[r])}}getContentsForOverrideIdentifer(s){let i=null,r=null;const u=S=>{S&&(r?this.mergeContents(r,S):r=P.deepClone(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===s?i=S.contents:S.identifiers.includes(s)&&u(S.contents);return u(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.updateValue(s,i,!0)}setValue(s,i){this.updateValue(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,v.removeFromValueTree)(this.contents,s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>n.equals(r.identifiers,(0,y.overrideIdentifiersFromKey)(s))),1))}updateValue(s,i,r){(0,v.addToValueTree)(this.contents,s,i,u=>console.error(u)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),y.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,v.toValuesTree)(this.contents[s],u=>console.error(u))})}}e.ConfigurationModel=m;class b{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!h.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:u,overrides:S,restricted:k,hasExcludedProperties:M}=this.doParseRaw(s,i);this._configurationModel=new m(r,u,S,M?[s]:void 0),this._restrictedConfigurations=k||[]}doParseContent(s){let i={},r=null,u=[];const S=[],k=[];function M(R){Array.isArray(u)?u.push(R):r!==null&&(u[r]=R)}const L={onObjectBegin:()=>{const R={};M(R),S.push(u),u=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{u=S.pop()},onArrayBegin:()=>{const R=[];M(R),S.push(u),u=R,r=null},onArrayEnd:()=>{u=S.pop()},onLiteralValue:M,onError:(R,A,F)=>{k.push({error:R,offset:A,length:F})}};if(s)try{I.visit(s,L),i=u[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(s,i){const r=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),u=this.filter(s,r,!0,i);s=u.raw;const S=(0,v.toValuesTree)(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),k=Object.keys(s),M=this.toOverrides(s,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:S,keys:k,overrides:M,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}filter(s,i,r,u){let S=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:S};const k={},M=[];for(const L in s)if(y.OVERRIDE_PROPERTY_REGEX.test(L)&&r){const R=this.filter(s[L],i,!1,u);k[L]=R.raw,S=S||R.hasExcludedProperties,M.push(...R.restricted)}else{const R=i[L],A=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&M.push(L),!u.exclude?.includes(L)&&(u.include?.includes(L)||(A===void 0||u.scopes===void 0||u.scopes.includes(A))&&!(u.skipRestricted&&R?.restricted))?k[L]=s[L]:S=!0}return{raw:k,restricted:M,hasExcludedProperties:S}}toOverrides(s,i){const r=[];for(const u of Object.keys(s))if(y.OVERRIDE_PROPERTY_REGEX.test(u)){const S={};for(const k in s[u])S[k]=s[u][k];r.push({identifiers:(0,y.overrideIdentifiersFromKey)(u),keys:Object.keys(S),contents:(0,v.toValuesTree)(S,i)})}return r}}e.ConfigurationModelParser=b;class w extends O.Disposable{constructor(s,i,r,u){super(),this.userSettingsResource=s,this.parseOptions=i,this.fileService=u,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&r.isEqual(S.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(s){return s&&(this.parseOptions=s),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class p{constructor(s,i,r,u,S,k,M,L,R,A,F,_,z){this.key=s,this.overrides=i,this._value=r,this.overrideIdentifiers=u,this.defaultConfiguration=S,this.policyConfiguration=k,this.applicationConfiguration=M,this.userConfiguration=L,this.localUserConfiguration=R,this.remoteUserConfiguration=A,this.workspaceConfiguration=F,this.folderConfigurationModel=_,this.memoryConfigurationModel=z}get value(){return g(this._value)}toInspectValue(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class d{constructor(s,i,r,u,S=new m,k=new m,M=new C.ResourceMap,L=new m,R=new C.ResourceMap){this._defaultConfiguration=s,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=u,this._remoteUserConfiguration=S,this._workspaceConfiguration=k,this._folderConfigurations=M,this._memoryConfiguration=L,this._memoryConfigurationByResource=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidatedConfigurationModel(s,i,r).getValue(s)}updateValue(s,i,r={}){let u;r.resource?(u=this._memoryConfigurationByResource.get(r.resource),u||(u=new m,this._memoryConfigurationByResource.set(r.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(s):u.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const u=this.getConsolidatedConfigurationModel(s,i,r),S=this.getFolderConfigurationModelForResource(i.resource,r),k=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,M=new Set;for(const L of u.overrides)for(const R of L.identifiers)u.getOverrideValue(s,R)!==void 0&&M.add(R);return new p(s,i,u.getValue(s),M.size?[...M]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,S||void 0,k)}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateApplicationConfiguration(s){this._applicationConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:u,updated:S,removed:k}=a(this._defaultConfiguration,s);i=[...u,...S,...k]}for(const u of i)for(const S of(0,y.overrideIdentifiersFromKey)(u)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(S),M=s.getKeysForOverrideIdentifier(S),L=[...M.filter(R=>k.indexOf(R)===-1),...k.filter(R=>M.indexOf(R)===-1),...k.filter(R=>!P.equals(this._defaultConfiguration.override(S).getValue(R),s.override(S).getValue(R)))];r.push([S,L])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:r,removed:u}=a(this._policyConfiguration,s),S=[...i,...r,...u];return S.length&&this.updatePolicyConfiguration(s),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:r,removed:u,overrides:S}=a(this.applicationConfiguration,s),k=[...i,...r,...u];return k.length&&this.updateApplicationConfiguration(s),{keys:k,overrides:S}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:u,overrides:S}=a(this.localUserConfiguration,s),k=[...i,...r,...u];return k.length&&this.updateLocalUserConfiguration(s),{keys:k,overrides:S}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:u,overrides:S}=a(this.remoteUserConfiguration,s),k=[...i,...r,...u];return k.length&&this.updateRemoteUserConfiguration(s),{keys:k,overrides:S}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:u,overrides:S}=a(this.workspaceConfiguration,s),k=[...i,...r,...u];return k.length&&this.updateWorkspaceConfiguration(s),{keys:k,overrides:S}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:u,updated:S,removed:k,overrides:M}=a(r,i),L=[...u,...S,...k];return(L.length||!r)&&this.updateFolderConfiguration(s,i),{keys:L,overrides:M}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:u,removed:S,overrides:k}=a(i,void 0);return{keys:[...r,...u,...S],overrides:k}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,r){let u=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(u=u.merge(this._policyConfiguration)),u}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const u=i.getFolder(s);u&&(r=this.getFolderConsolidatedConfiguration(u.uri)||r);const S=this._memoryConfigurationByResource.get(s);S&&(r=r.merge(S))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(s);u?(i=r.merge(u),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:u,keys:S}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:u,keys:S}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this._workspaceConfiguration.keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(u=>i.add(u))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.policy),u=this.parseConfigurationModel(s.application),S=this.parseConfigurationModel(s.user),k=this.parseConfigurationModel(s.workspace),M=s.folders.reduce((L,R)=>(L.set(l.URI.revive(R[0]),this.parseConfigurationModel(R[1])),L),new C.ResourceMap);return new d(i,r,u,S,new m,k,M,new m,new C.ResourceMap)}static parseConfigurationModel(s){return new m(s.contents,s.keys,s.overrides)}}e.Configuration=d;function c(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,i=new Map;for(const u of o)u.keys.forEach(S=>s.add(S)),u.overrides.forEach(([S,k])=>{const M=(0,C.getOrSet)(i,S,new Set);k.forEach(L=>M.add(L))});const r=[];return i.forEach((u,S)=>r.push([S,[...u.values()]])),{keys:[...s.values()],overrides:r}}class f{constructor(s,i,r,u){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=u,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const S of s.keys)this.affectedKeys.add(S);for(const[,S]of s.overrides)for(const k of S)this.affectedKeys.add(k);this._affectsConfigStr=this._marker;for(const S of this.affectedKeys)this._affectsConfigStr+=S+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){const r=this._marker+s,u=this._affectsConfigStr.indexOf(r);if(u<0)return!1;const S=u+r.length;if(S>=this._affectsConfigStr.length)return!1;const k=this._affectsConfigStr.charCodeAt(S);if(k!==this._markerCode1&&k!==this._markerCode2)return!1;if(i){const M=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,L=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!P.equals(M,L)}return!0}}e.ConfigurationChangeEvent=f;function a(o,s){const{added:i,removed:r,updated:u}=t(s?.rawConfiguration,o?.rawConfiguration),S=[],k=o?.getAllOverrideIdentifiers()||[],M=s?.getAllOverrideIdentifiers()||[];if(s){const L=M.filter(R=>!k.includes(R));for(const R of L)S.push([R,s.getKeysForOverrideIdentifier(R)])}if(o){const L=k.filter(R=>!M.includes(R));for(const R of L)S.push([R,o.getKeysForOverrideIdentifier(R)])}if(s&&o){for(const L of k)if(M.includes(L)){const R=t({contents:o.getOverrideValue(void 0,L)||{},keys:o.getKeysForOverrideIdentifier(L)},{contents:s.getOverrideValue(void 0,L)||{},keys:s.getKeysForOverrideIdentifier(L)});S.push([L,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:r,updated:u,overrides:S}}function t(o,s){const i=o?s?o.keys.filter(S=>s.keys.indexOf(S)===-1):[...o.keys]:[],r=s?o?s.keys.filter(S=>o.keys.indexOf(S)===-1):[...s.keys]:[],u=[];if(o&&s){for(const S of s.keys)if(o.keys.indexOf(S)!==-1){const k=(0,v.getConfigurationValue)(s.contents,S),M=(0,v.getConfigurationValue)(o.contents,S);P.equals(k,M)||u.push(S)}}return{added:i,removed:r,updated:u}}}),define(oe[241],ae([0,1,22,3,2,35,12,123,52,5,39,45]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class E extends I.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(y.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:p})=>this.onDidUpdateConfiguration(Array.from(w),p))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(w,p){this.updateConfigurationModel(w,y.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:w})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new P.ConfigurationModel;const w=y.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(w),w)}updateConfigurationModel(w,p){const d=this.getConfigurationDefaultOverrides();for(const c of w){const f=d[c],a=p[c];f!==void 0?this._configurationModel.addValue(c,f):a?this._configurationModel.addValue(c,a.default):this._configurationModel.removeValue(c)}}}e.DefaultConfiguration=E;class g{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let m=class extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(w,p,d){super(),this.defaultConfiguration=w,this.policyService=p,this.logService=d,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(w=>this.onDidChangePolicies(w))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:w})=>this.update(await this.updatePolicyDefinitions(w),!0))),this._configurationModel}async updatePolicyDefinitions(w){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",w);const p={},d=[],c=y.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const f of w){const a=c[f];if(!a){d.push(f);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.logService.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}d.push(f),p[a.policy.name]={type:a.type}}}return(0,C.isEmptyObject)(p)||await this.policyService.updatePolicyDefinitions(p),d}onDidChangePolicies(w){this.logService.trace("PolicyConfiguration#onDidChangePolicies",w);const p=y.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),d=(0,n.coalesce)(w.map(c=>p.get(c)));this.update(d,!0)}update(w,p){this.logService.trace("PolicyConfiguration#update",w);const d=y.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),c=[],f=this._configurationModel.isEmpty();for(const a of w){const t=d[a]?.policy?.name;if(t){const o=this.policyService.getPolicyValue(t);(f?o!==void 0:!(0,O.equals)(this._configurationModel.getValue(a),o))&&c.push([a,o])}else this._configurationModel.getValue(a)!==void 0&&c.push([a,void 0])}if(c.length){this.logService.trace("PolicyConfiguration#changed",c);const a=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of a.keys)this._configurationModel.setValue(t,a.getValue(t));for(const[t,o]of c)o===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,o);p&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=m,e.PolicyConfiguration=m=Pe([ne(1,v.IPolicyService),ne(2,l.ILogService)],m)}),define(oe[242],ae([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,241,39]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends h.Disposable{constructor(f,a,t,o){super(),this.settingsResource=f,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new b.DefaultConfiguration),this.policyConfiguration=t instanceof w.NullPolicyService?new b.NullPolicyConfiguration:this._register(new b.PolicyConfiguration(this.defaultConfiguration,t,o)),this.userConfiguration=this._register(new g.UserSettings(this.settingsResource,{},y.extUriBiasedIgnorePathCase,a)),this.configuration=new g.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new g.ConfigurationModel,new g.ConfigurationModel),this.configurationEditing=new d(f,a,this),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:i})=>this.onDidDefaultConfigurationChange(s,i))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[f,a,t]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new g.Configuration(f,a,new g.ConfigurationModel,t)}getConfigurationData(){return this.configuration.toData()}getValue(f,a){const t=typeof f=="string"?f:void 0,o=(0,E.isConfigurationOverrides)(f)?f:(0,E.isConfigurationOverrides)(a)?a:{};return this.configuration.getValue(t,o,void 0)}async updateValue(f,a,t,o,s){const i=(0,E.isConfigurationUpdateOverrides)(t)?t:(0,E.isConfigurationOverrides)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,r=i?o:t;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${f} to target ${r}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.distinct)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const u=this.inspect(f,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,l.equals)(a,u.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const k=i.overrideIdentifiers.sort(),M=this.configuration.localUserConfiguration.overrides.find(L=>(0,n.equals)([...L.identifiers].sort(),k));M&&(i.overrideIdentifiers=M.identifiers)}const S=i?.overrideIdentifiers?.length?[(0,m.keyFromOverrideIdentifiers)(i.overrideIdentifiers),f]:[f];await this.configurationEditing.write(S,a),await this.reloadConfiguration()}inspect(f,a={}){return this.configuration.inspect(f,a,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const a=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(t,a,2)}onDidDefaultConfigurationChange(f,a){const t=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(f,a);this.trigger(o,t,7)}onDidPolicyConfigurationChange(f){const a=this.configuration.toData(),t=this.configuration.compareAndUpdatePolicyConfiguration(f);this.trigger(t,a,7)}trigger(f,a,t){const o=new g.ConfigurationChangeEvent(f,{data:a},this.configuration);o.source=t,this._onDidChangeConfiguration.fire(o)}}e.ConfigurationService=p;class d{constructor(f,a,t){this.settingsResource=f,this.fileService=a,this.configurationService=t,this.queue=new D.Queue}write(f,a){return this.queue.queue(()=>this.doWriteConfiguration(f,a))}async doWriteConfiguration(f,a){let t;try{t=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,C.parse)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(t,f,a);t=(0,P.applyEdits)(t,s),await this.fileService.writeFile(this.settingsResource,I.VSBuffer.fromString(t))}getEdits(f,a,t){const{tabSize:o,insertSpaces:s,eol:i}=this.formattingOptions;if(!a.length){const r=JSON.stringify(t,null,s?" ".repeat(o):"	");return[{content:r,length:r.length,offset:0}]}return(0,P.setProperty)(f,a,t,{tabSize:o,insertSpaces:s,eol:i})}get formattingOptions(){if(!this._formattingOptions){let f=v.OS===3||v.OS===2?`
`:`\r
`;const a=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(f=a),this._formattingOptions={eol:f,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(oe[243],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeRemoteResourceRouter=e.NODE_REMOTE_RESOURCE_CHANNEL_NAME=e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME=void 0,e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME="request",e.NODE_REMOTE_RESOURCE_CHANNEL_NAME="remoteResourceHandler";class n{async routeCall(I,O,C){if(O!==e.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME)throw new Error(`Call not found: ${O}`);const P=C[0];if(P?.authority){const h=I.connections.find(l=>l.ctx===P.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(I,O){throw new Error(`Event not found: ${O}`)}}e.NodeRemoteResourceRouter=n}),define(oe[244],ae([0,1,15,6]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=l,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var I;(function(v){v[v.WebSocket=0]="WebSocket",v[v.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class C{constructor(y,E){this.host=y,this.port=E,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=C;var P;(function(v){v.Unknown="Unknown",v.NotAvailable="NotAvailable",v.TemporarilyNotAvailable="TemporarilyNotAvailable",v.NoResolverFound="NoResolverFound",v.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class h extends n.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof h&&y._code===P.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof h&&y._code===P.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof h&&y._code===P.NoResolverFound}static isInvalidAuthority(y){return y instanceof h&&y._code===P.InvalidAuthority}static isHandled(y){return y instanceof h&&y.isHandled}constructor(y,E=P.Unknown,g){super(y),this._message=y,this._code=E,this._detail=g,this.isHandled=E===P.NotAvailable&&g===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function l(v){const y=v.indexOf("+");return y===-1?v:v.substring(0,y)}}),define(oe[245],ae([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=k,e.connectRemoteAgentExtensionHost=M,e.connectRemoteAgentTunnel=R;const m=30*1e3;var b;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function w(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p(K){const W=new I.CancellationTokenSource;return setTimeout(()=>W.cancel(),K),W.token}function d(K,W){if(K.isCancellationRequested||W.isCancellationRequested)return I.CancellationToken.Cancelled;const N=new I.CancellationTokenSource;return K.onCancellationRequested(()=>N.cancel()),W.onCancellationRequested(()=>N.cancel()),N.token}class c{get didTimeout(){return this._state==="timedout"}constructor(W){this._state="pending",this._disposables=new P.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,n.promiseWithResolvers)(),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function f(K,W){const N=new c(W);return N.registerDisposable(K.onControlMessage(Z=>{const re=JSON.parse(Z.toString()),G=T(re);G?N.reject(G):N.resolve(re)})),N.promise}function a(K,W,N,Z,re,G,q,H){const $=new c(H),se=v.StopWatch.create(!1);return K.info(`Creating a socket (${q})...`),l.mark(`code/willCreateSocket/${G}`),W.connect(N,Z,re,q).then(ee=>{$.didTimeout?(l.mark(`code/didCreateSocketError/${G}`),K.info(`Creating a socket (${q}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(l.mark(`code/didCreateSocketOK/${G}`),K.info(`Creating a socket (${q}) was successful after ${se.elapsed()} ms.`),$.resolve(ee))},ee=>{l.mark(`code/didCreateSocketError/${G}`),K.info(`Creating a socket (${q}) returned an error after ${se.elapsed()} ms.`),K.error(ee),$.reject(ee)}),$.promise}function t(K,W){const N=new c(W);return K.then(Z=>{N.didTimeout||N.resolve(Z)},Z=>{N.didTimeout||N.reject(Z)}),N.promise}async function o(K,W,N,Z){const re=le(K,W);K.logService.trace(`${re} 1/6. invoking socketFactory.connect().`);let G;try{G=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,h.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,w(W),`renderer-${w(W)}-${K.reconnectionToken}`,Z)}catch(ee){throw K.logService.error(`${re} socketFactory.connect() failed or timed out. Error:`),K.logService.error(ee),ee}K.logService.trace(`${re} 2/6. socketFactory.connect() was successful.`);let q,H;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(G,null),q=K.reconnectionProtocol,H=!1):(q=new E.PersistentProtocol({socket:G}),H=!0),K.logService.trace(`${re} 3/6. sending AuthRequest control message.`);const $=await t(K.signService.createNewMessage((0,y.generateUuid)()),Z),se={type:"auth",auth:K.connectionToken||"00000000000000000000",data:$.data};q.sendControl(D.VSBuffer.fromString(JSON.stringify(se)));try{const ee=await f(q,d(Z,p(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(K.logService.trace(`${re} 4/6. received SignRequest control message.`),!await t(K.signService.validate($,ee.signedData),Z)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const pe=await t(K.signService.sign(ee.data),Z),be={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:W};return N&&(be.args=N),K.logService.trace(`${re} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(D.VSBuffer.fromString(JSON.stringify(be))),{protocol:q,ownsProtocol:H}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(K.logService.error(`${re} the handshake timed out. Error:`),K.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${re} received error control message when negotiating connection. Error:`),K.logService.error(ee)),H&&B(q),ee}}async function s(K,W,N,Z){const re=Date.now(),G=le(K,W),{protocol:q,ownsProtocol:H}=await o(K,W,N,Z),$=new c(Z);return $.registerDisposable(q.onControlMessage(se=>{const ee=JSON.parse(se.toString()),de=T(ee);de?(K.logService.error(`${G} received error control message when negotiating connection. Error:`),K.logService.error(de),H&&B(q),$.reject(de)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${he(re)}!`),$.resolve({protocol:q,firstMessage:ee}))})),$.promise}async function i(K,W){const{protocol:N}=await s(K,1,void 0,W);return{protocol:N}}async function r(K,W,N){const{protocol:Z,firstMessage:re}=await s(K,2,W,N),G=re&&re.debugPort;return{protocol:Z,debugPort:G}}async function u(K,W,N){const Z=Date.now(),re=le(K,3),{protocol:G}=await o(K,3,W,N);return K.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${he(Z)}!`),G}async function S(K,W,N){const{connectTo:Z,connectionToken:re}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:Z,connectionToken:re,reconnectionToken:W,reconnectionProtocol:N,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function k(K,W,N){return L(K,async Z=>{const{protocol:re}=await i(Z,I.CancellationToken.None);return new X(K,W,N,Z.reconnectionToken,re)})}async function M(K,W){return L(K,async N=>{const{protocol:Z,debugPort:re}=await r(N,W,I.CancellationToken.None);return new Y(K,W,N.reconnectionToken,Z,re)})}async function L(K,W){for(let Z=1;;Z++)try{const re=(0,y.generateUuid)(),G=await S(K,re,null);return await W(G)}catch(re){if(Z<5)K.logService.error(`[remote-connection][attempt ${Z}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(re);else throw K.logService.error(`[remote-connection][attempt ${Z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(re),ue.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(re)),re}}async function R(K,W,N){const Z=await S(K,(0,y.generateUuid)(),null);return await u(Z,{host:W,port:N},I.CancellationToken.None)}function A(K){return(0,n.createCancelablePromise)(W=>new Promise((N,Z)=>{const re=setTimeout(N,K*1e3);W.onCancellationRequested(()=>{clearTimeout(re),N()})}))}var F;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class _{constructor(W,N){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=_;class z{constructor(W,N,Z,re){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.durationSeconds=Z,this.cancellableTimer=re,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=z;class j{constructor(W,N,Z){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=Z,this.type=2}}e.ReconnectionRunningEvent=j;class ce{constructor(W,N,Z){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=Z,this.type=4}}e.ConnectionGainEvent=ce;class te{constructor(W,N,Z,re){this.reconnectionToken=W,this.millisSinceLastIncomingData=N,this.attempt=Z,this.handled=re,this.type=3}}e.ReconnectionPermanentFailureEvent=te;class ue extends P.Disposable{static triggerPermanentFailure(W,N,Z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=N,this._permanentFailureHandled=Z,this._instances.forEach(re=>re._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(W=>W._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(W=>W._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||ue._permanentFailure}constructor(W,N,Z,re,G){super(),this._connectionType=W,this._options=N,this.reconnectionToken=Z,this.protocol=re,this._reconnectionFailureIsFatal=G,this._onDidStateChange=this._register(new C.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new ce(this.reconnectionToken,0,0)),this._register(re.onSocketClose(q=>{const H=U(this._connectionType,this.reconnectionToken,!0);q?q.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${q.hadError}).`),q.error&&this._options.logService.error(q.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${q.wasClean}, code: ${q.code}, reason: ${q.reason}).`),q.event&&this._options.logService.error(q.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(re.onSocketTimeout(q=>{const H=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} received socket timeout event (unacknowledgedMsgCount: ${q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${q.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),ue._instances.push(this),this._register((0,P.toDisposable)(()=>{const q=ue._instances.indexOf(this);q>=0&&ue._instances.splice(q,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ue._permanentFailureMillisSinceLastIncomingData,ue._permanentFailureAttempt,ue._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const W=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let Z=-1;do{Z++;const re=Z<N.length?N[Z]:N[N.length-1];try{if(re>0){const q=A(re);this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re,q)),this._options.logService.info(`${W} waiting for ${re} seconds before reconnecting...`);try{await q}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1)),this._options.logService.info(`${W} resolving connection...`);const G=await S(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${G.connectTo}...`),await this._reconnect(G,p(m)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(Z>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,O.isCancellationError)(G)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof g.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,g.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Z+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(W,N,Z){this._reconnectionFailureIsFatal?ue.triggerPermanentFailure(W,N,Z):this._gotoPermanentFailure(W,N,Z)}_gotoPermanentFailure(W,N,Z){this._onDidStateChange.fire(new te(this.reconnectionToken,W,N,Z)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ue;class X extends ue{constructor(W,N,Z,re,G){super(1,W,re,G,!0),this.client=this._register(new E.Client(G,{remoteAuthority:N,clientId:Z},W.ipcLogger))}async _reconnect(W,N){await i(W,N)}}e.ManagementPersistentConnection=X;class Y extends ue{constructor(W,N,Z,re,G){super(2,W,Z,re,!1),this._startArguments=N,this.debugPort=G}async _reconnect(W,N){await r(W,this._startArguments,N)}}e.ExtensionHostPersistentConnection=Y;function B(K){try{K.acceptDisconnect();const W=K.getSocket();K.dispose(),W.dispose()}catch(W){(0,O.onUnexpectedError)(W)}}function T(K){if(K&&K.type==="error"){const W=new Error(`Connection error: ${K.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function x(K,W){for(;K.length<W;)K+=" ";return K}function V(K,W){return`[remote-connection][${x(w(K),13)}][${W.substr(0,5)}\u2026]`}function U(K,W,N){return`${V(K,W)}[${N?"reconnect":"initial"}]`}function le(K,W){return`${U(W,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(oe[68],ae([0,1,13]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=D,e.getRemoteName=I,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=C;function D(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function I(h){if(!h)return;const l=h.indexOf("+");return l<0?h:h.substr(0,l)}function O(h){const{host:l,port:v}=P(h);if(typeof v>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:v}}function C(h,l){let{host:v,port:y}=P(h);return typeof y>"u"&&(y=l),{host:v,port:y}}function P(h){const l=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const v=h.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(oe[124],ae([0,1,25,6,68]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=y,e.isLanguagePackExtension=E,e.isAuthenticationProviderExtension=g,e.isResolverExtension=m,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var C;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.LINUX_PPC64LE="linux-ppc64le",b.LINUX_RISCV64="linux-riscv64",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,p){if(typeof w>"u"||w===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof w=="string"||typeof p=="string"){const d=typeof w=="string"?w:w.value,c=typeof p=="string"?p:p.value;return n.equalsIgnoreCase(d,c)}return w._lower===p._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=h;class l{get size(){return this._set.size}constructor(w){if(this._set=new Set,w)for(const p of w)this.add(p)}add(w){this._set.add(h.toKey(w))}delete(w){return this._set.delete(h.toKey(w))}has(w){return this._set.has(h.toKey(w))}}e.ExtensionIdentifierSet=l;class v{constructor(){this._map=new Map}clear(){this._map.clear()}delete(w){this._map.delete(h.toKey(w))}get(w){return this._map.get(h.toKey(w))}has(w){return this._map.has(h.toKey(w))}set(w,p){this._map.set(h.toKey(w),p)}values(){return this._map.values()}forEach(w){this._map.forEach(w)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=v;function y(b){return E(b)}function E(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function g(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function m(b,w){if(w){const p=`onResolveRemoteAuthority:${(0,I.getRemoteName)(w)}`;return!!b.activationEvents?.includes(p)}return!1}e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[246],ae([0,1,2,6]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,D.createDecorator)("remoteSocketFactoryService");class I{constructor(){this.factories={}}register(C,P){return this.factories[C]??=[],this.factories[C].push(P),(0,n.toDisposable)(()=>{const h=this.factories[C]?.indexOf(P);typeof h=="number"&&h>=0&&this.factories[C]?.splice(h,1)})}getSocketFactory(C){return(this.factories[C.type]||[]).find(h=>h.supports(C))}connect(C,P,h,l){const v=this.getSocketFactory(C);if(!v)throw new Error(`No socket factory found for ${C}`);return v.connect(C,P,h,l)}}e.RemoteSocketFactoryService=I}),define(oe[247],ae([0,1,26,49,21,117]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=P;let C;async function P(g=!1){return(C===void 0||g)&&(C=h()),C}async function h(){const g=l();if(g===void 0)return!1;if(g>=22e3){const m=y();if(m)return new Promise(b=>{D.execFile(m,["--status"],w=>b(!w))})}else{const m=E();if(m)try{if((await I.Promises.stat(m)).isFile())return!0}catch{}}return!1}function l(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(g)return parseInt(g[3])}function v(g){const m=process.env.SystemRoot;if(m){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(m,b?"Sysnative":"System32",g)}}function y(){return v("wsl.exe")}function E(){return v("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,15,2,186,52,6,5,45]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=E,e.hasNoContent=g,e.asText=m,e.asTextOrError=b,e.asJson=w,e.updateProxyConfigurationsScope=p,e.IRequestService=(0,P.createDecorator)("requestService");class v{constructor(a){this.original=a}toJSON(){if(!this.headers){const a=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.original[t];this.headers=a}return this.headers}}class y extends I.Disposable{constructor(a){super(),this.counter=0,this.logger=a.createLogger("network",{name:(0,O.localize)(0,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async logAndRequest(a,t,o){const s=`${a} #${++this.counter}: ${t.url}`;this.logger.trace(`${s} - begin`,t.type,new v(t.headers??{}));try{const i=await o();return this.logger.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.logger.error(`${s} - error`,t.type,(0,D.getErrorMessage)(i)),i}}}e.AbstractRequestService=y;function E(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}function g(f){return f.res.statusCode===204}async function m(f){return g(f)?null:(await(0,n.streamToBuffer)(f.stream)).toString()}async function b(f){if(!E(f))throw new Error("Server returned "+f.res.statusCode);return m(f)}async function w(f){if(!E(f))throw new Error("Server returned "+f.res.statusCode);if(g(f))return null;const t=(await(0,n.streamToBuffer)(f.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function p(f){c(f)}let d;function c(f){const a=l.Registry.as(C.Extensions.Configuration),t=d;d={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[d],remove:t?[t]:[]})}c(1)}),define(oe[248],ae([0,1,17,23]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class I{constructor(P){this.service=P}listen(P,h){throw new Error("Invalid listen")}call(P,h,l,v=D.CancellationToken.None){switch(h){case"request":return this.service.request(l[0],v).then(async({res:y,stream:E})=>{const g=await(0,n.streamToBuffer)(E);return[{statusCode:y.statusCode,headers:y.headers},g]});case"resolveProxy":return this.service.resolveProxy(l[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=I;class O{constructor(P){this.channel=P}async request(P,h){const[l,v]=await this.channel.call("request",[P],h);return{res:l,stream:(0,n.bufferToStream)(v)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=O}),define(oe[249],ae([0,1,250,12]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=O;function I(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function O(C,P,h={}){const l=(0,n.parse)(C),v=h.proxyUrl||I(l,P);if(!v)return null;const y=(0,n.parse)(v);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,D.isBoolean)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((g,m)=>{Q(["http-proxy-agent"],g,m)})).HttpProxyAgent(v,E):new(await new Promise((g,m)=>{Q(["https-proxy-agent"],g,m)})).HttpsProxyAgent(v,E)}}),define(oe[251],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[95],ae([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=b;let m;async function b(p,d,c,f){return c["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(f)&&!c["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(f)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=E.Promises.withAsyncBody(async(a,t)=>{const o=new O.CancellationTokenSource;let s=1e4;const i=p.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,g.clamp)(i,1,120)*1e3);const r=setTimeout(()=>{o.dispose(!0),t(new Error((0,I.localize)(0,null)))},s);try{a(await w(d,o.token))}catch(u){!(0,P.isCancellationError)(u)&&!o.token.isCancellationRequested?t(new Error((0,I.localize)(1,null,(0,C.toErrorMessage)(u)))):a({})}finally{clearTimeout(r),o.dispose()}})),m)}async function w(p,d){const c=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",c);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",f);const a=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};p.trace("getUnixShellEnvironment#env",o);const s=await(0,v.getSystemShell)(h.OS,o);return p.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(d.isCancellationRequested)return r(new P.CancellationError);const u=(0,D.basename)(s);let S,k;const M="";/^pwsh(-preview)?$/.test(u)?(S=`& '${process.execPath}' ${M} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,k=["-Login","-Command"]):u==="nu"?(S=`^'${process.execPath}' ${M} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,k=["-i","-l","-c"]):u==="xonsh"?(S=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,k=["-i","-l","-c"]):(S=`'${process.execPath}' ${M} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?k=["-ic"]:k=["-i","-l","-c"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),S);const L=(0,n.spawn)(s,[...k,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(L.kill(),r(new P.CancellationError))),L.on("error",F=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(F)),r(F)});const R=[];L.stdout.on("data",F=>R.push(F));const A=[];L.stderr.on("data",F=>A.push(F)),L.on("close",(F,_)=>{const z=Buffer.concat(R).toString("utf8");p.trace("getUnixShellEnvironment#raw",z);const j=Buffer.concat(A).toString("utf8");if(j.trim()&&p.trace("getUnixShellEnvironment#stderr",j),F||_)return r(new Error((0,I.localize)(2,null,F,_)));const ce=t.exec(z),te=ce?ce[1]:"{}";try{const ue=JSON.parse(te);c?ue.ELECTRON_RUN_AS_NODE=c:delete ue.ELECTRON_RUN_AS_NODE,f?ue.ELECTRON_NO_ATTACH_CONSOLE=f:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){p.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(ue)),r(ue)}})})}}),define(oe[252],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class n{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(I){try{const O=await this.getValidator();if(O){const C=String(n._nextId++);return this.validators.set(C,O),{id:C,data:O.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,O){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(O)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(I){try{return await this.signValue(I)}catch{}return I}}e.AbstractSignService=n}),define(oe[96],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,n.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[253],ae([0,1,252]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D extends n.AbstractSignService{getValidator(){return this.vsda().then(O=>new O.validator)}signValue(O){return this.vsda().then(C=>new C.signer().sign(O))}vsda(){return new Promise((O,C)=>Q(["vsda"],O,C))}}e.SignService=D}),define(oe[34],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,n.createDecorator)("stateReadService"),e.IStateService=(0,n.createDecorator)("stateService")}),define(oe[125],ae([0,1,8,17,2,12,38,16,5]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var l;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class v extends I.Disposable{constructor(m,b,w,p){super(),this.storagePath=m,this.saveStrategy=b,this.logService=w,this.fileService=p,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new n.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}}getItem(m,b){const w=this.storage[m];return(0,O.isUndefinedOrNull)(w)?b:w}setItem(m,b){this.setItems([{key:m,data:b}])}setItems(m){let b=!1;for(const{key:w,data:p}of m)this.storage[w]!==p&&((0,O.isUndefinedOrNull)(p)?(0,O.isUndefined)(this.storage[w])||(this.storage[w]=void 0,b=!0):(this.storage[w]=p,b=!0));b&&this.save()}removeItem(m){(0,O.isUndefined)(this.storage[m])||(this.storage[m]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const m=JSON.stringify(this.storage,null,4);if(m!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(m),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=m}catch(b){this.logService.error(b)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=v;let y=class extends I.Disposable{constructor(m,b,w,p){super(),this.fileStorage=this._register(new v(b.stateResource,m,w,p))}async init(){await this.fileStorage.init()}getItem(m,b){return this.fileStorage.getItem(m,b)}};e.StateReadonlyService=y,e.StateReadonlyService=y=Pe([ne(1,C.IEnvironmentService),ne(2,h.ILogService),ne(3,P.IFileService)],y);class E extends y{setItem(m,b){this.fileStorage.setItem(m,b)}setItems(m){this.fileStorage.setItems(m)}removeItem(m){this.fileStorage.removeItem(m)}close(){return this.fileStorage.close()}}e.StateService=E}),define(oe[126],ae([0,1,4,36,33]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=C,e.verifyMicrosoftInternalDomain=P;function O(h){if(n.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function C(h,l,v,y,E,g,m,b,w){const p=Object.create(null);p["common.machineId"]=g,p["common.sqmId"]=m,p.sessionID=(0,I.generateUuid)()+Date.now(),p.commitHash=y,p.version=E,p["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,n.PlatformToString)(n.platform),p["common.nodePlatform"]=D.platform,p["common.nodeArch"]=v,p["common.product"]=w||"desktop",b&&(p["common.msftInternal"]=b);let d=0;const c=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),n.isLinuxSnap&&(p["common.snap"]="true");const f=O(l);return f&&(p["common.platformDetail"]=f),p}function P(h){const l=D.env.USERDNSDOMAIN;if(!l)return!1;const v=l.toLowerCase();return h.some(y=>v===y)}}),define(oe[28],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var I;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(oe[254],ae([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=p,e.getMachineInfo=c,e.collectLaunchConfigs=f;const w=new Map;async function p(t,o){const s=`${t}::${o.join(":")}`,i=w.get(s);if(i)return i;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,S=new Map,k=2e4;function M(R,A,F,_){const z=A.substring(R.length+1);return D.Promises.withAsyncBody(async j=>{let ce;try{ce=await v.Promises.readdir(A,{withFileTypes:!0})}catch{j();return}if(_.count>=k){_.count+=ce.length,_.maxReached=!0,j();return}let te=ce.length;if(te===0){j();return}let ue=ce;_.count+ce.length>k&&(_.maxReached=!0,te=k-_.count,ue=ce.slice(0,te)),_.count+=ce.length;for(const X of ue)if(X.isDirectory()){if(F.includes(X.name)||await M(R,(0,C.join)(A,X.name),F,_),--te===0){j();return}}else{const Y=X.name.lastIndexOf(".");if(Y>=0){const B=X.name.substring(Y+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of r)B.relativePathPattern?.test(z)!==!1&&B.filePattern.test(X.name)&&S.set(B.tag,(S.get(B.tag)??0)+1);if(--te===0){j();return}}})}const L=D.Promises.withAsyncBody(async R=>{const A={count:0,maxReached:!1};await M(t,t,o,A);const F=await f(t);R({configFiles:d(S),fileTypes:d(u),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:F})});return w.set(s,L),L}function d(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function c(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(n.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function f(t){try{const o=new Map,s=(0,C.join)(t,".vscode","launch.json"),i=await v.Promises.readFile(s),r=[],u=(0,I.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,I.getNodeType)(u)==="object"&&u.configurations)for(const S of u.configurations){const k=S.type;k&&(o.has(k)?o.set(k,o.get(k)+1):o.set(k,1))}return d(o)}catch{return[]}}let a=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(n.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||s.push(`Load (avg):       ${n.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,y.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async i=>{let[r,u]=i,S=this.formatProcessList(o,r);return s.forEach(k=>{if((0,E.isRemoteDiagnosticError)(k))S+=`
${k.errorMessage}`,u+=`
${k.errorMessage}`;else if(S+=`

Remote: ${k.hostName}`,k.processes&&(S+=`
${this.formatProcessList(o,k.processes)}`),k.workspaceMetadata){u+=`
|  Remote: ${k.hostName}`;for(const M of Object.keys(k.workspaceMetadata)){const L=k.workspaceMetadata[M];let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),u+=`|    Folder (${M}): ${R}`,u+=this.formatWorkspaceStats(L)}}}),{processInfo:S,workspaceInfo:u}})}async getSystemInfo(o,s){const{memory:i,vmHint:r,os:u,cpus:S}=c(),k={os:u,memory:i,cpus:S,vmHint:r,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return P.isWindows||(k.load=`${n.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(o,s){const i=[];return(0,y.listProcesses)(o.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(o)),i.push(""),i.push(this.formatProcessList(o,r)),o.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(o))),s.forEach(u=>{if((0,E.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(o,u.processes)),u.workspaceMetadata)for(const S of Object.keys(u.workspaceMetadata)){const k=u.workspaceMetadata[S];let M=`${k.fileCount} files`;k.maxFilesReached&&(M=`more than ${M}`),i.push(`Folder (${S}): ${M}`),i.push(this.formatWorkspaceStats(k))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(o){const s=[];let r=0;const u=(L,R)=>{const A=` ${L}(${R})`;r+A.length>60?(s.push(S),S="|                 ",r=S.length):r+=A.length,S+=A};let S="|      File types:";const k=10,M=o.fileTypes.length>k?k:o.fileTypes.length;for(let L=0;L<M;L++){const R=o.fileTypes[L];u(R.name,R.count)}if(s.push(S),o.configFiles.length>=0&&(S="|      Conf files:",r=0,o.configFiles.forEach(L=>{u(L.name,L.count)}),s.push(S)),o.launchConfigFiles.length>0){let L="|      Launch Configs:";o.launchConfigFiles.forEach(R=>{const A=R.count>1?` ${R.name}(${R.count})`:` ${R.name}`;L+=A}),s.push(L)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${o[i]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],i=[];return o.windows.forEach(r=>{r.folderURIs.length===0||r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(u=>{const S=h.URI.revive(u);if(S.scheme===O.Schemas.file){const k=S.fsPath;i.push(p(k,["node_modules",".git"]).then(M=>{let L=`${M.fileCount} files`;M.maxFilesReached&&(L=`more than ${L}`),s.push(`|    Folder (${(0,C.basename)(k)}): ${L}`),s.push(this.formatWorkspaceStats(M))}).catch(M=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${M.toString()})`)}))}else s.push(`|    Folder (${S.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(o,s){const i=new Map;o.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),o.pidToNames.forEach(({pid:u,name:S})=>i.set(u,S));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(o,s,i,r,u){const S=u===0;let k;S?k=r.pid===o?`${this.productService.applicationName} main`:"remote agent":s.has(r.pid)?k=s.get(r.pid):k=`${"  ".repeat(u)} ${r.name}`;const M=process.platform==="win32"?r.mem:n.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(M/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(r.children)&&r.children.forEach(L=>this.formatProcessItem(o,s,i,L,u+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:i}of o.folders){const r=h.URI.revive(i);if(r.scheme!==O.Schemas.file)continue;const u=r.fsPath;try{(await p(u,["node_modules",".git"])).fileTypes.forEach(k=>s.add(k.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const i=h.URI.revive(s);if(i.scheme!==O.Schemas.file)continue;const r=i.fsPath;try{const u=await p(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),u.fileTypes.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),u.launchConfigFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})}),u.configFiles.forEach(S=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:S.name,count:S.count})})}catch{}}}};e.DiagnosticsService=a,e.DiagnosticsService=a=Pe([ne(0,b.ITelemetryService),ne(1,m.IProductService)],a)}),define(oe[255],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class n{constructor(O){this.appenders=O}listen(O,C){throw new Error(`Event not found: ${C}`)}call(O,C,{eventName:P,data:h}){return this.appenders.forEach(l=>l.log(P,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=n;class D{constructor(O){this.channel=O}log(O,C){return this.channel.call("log",{eventName:O,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(oe[54],ae([0,1,35,12,68,126,28]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=v,e.isLoggingOnly=y,e.getTelemetryLevel=E,e.validateTelemetryData=g,e.cleanRemoteAuthority=b,e.isInternalTelemetry=p,e.getPiiPathsFromEnvironment=d,e.cleanData=a;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=P;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class l{async publicLog(o,s,i){}async publicLogError(o,s,i){}}e.NullEndpointTelemetryService=l,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function E(t){const o=t.getValue(C.TELEMETRY_SETTING_ID),s=t.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function g(t){const o={},s={},i={};w(t,i);for(let r in i){r=r.length>150?r.substr(r.length-149):r;const u=i[r];typeof u=="number"?s[r]=u:typeof u=="boolean"?s[r]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${u.length}`),o[r]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(o[r]=u)}return{properties:o,measurements:s}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(t){if(!t)return"none";const o=(0,I.getRemoteName)(t);return m.has(o)?o:"other"}function w(t,o,s=0,i){if(t)for(const r of Object.getOwnPropertyNames(t)){const u=t[r],S=i?i+r:r;Array.isArray(u)?o[S]=(0,n.safeStringify)(u):u instanceof Date?o[S]=u.toISOString():(0,D.isObject)(u)?s<2?w(u,o,s+1,S+"."):o[S]=(0,n.safeStringify)(u):o[S]=u}}function p(t,o){const s=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(s)||i}function d(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function c(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const k of o)for(;;){const M=k.exec(t);if(!M)break;i.push([M.index,k.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(s="";;){const k=u.exec(t);if(!k)break;const M=i.some(([L,R])=>k.index<R&&L<u.lastIndex);!r.test(k[0])&&!M&&(s+=t.substring(S,k.index)+"<REDACTED: user-file-path>",S=u.lastIndex)}return S<t.length&&(s+=t.substr(S)),s}function f(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of o)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,o){return(0,n.cloneAndChange)(t,s=>{if(s instanceof P||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=c(i,o);for(const r of o)i=i.replace(r,"");return i=f(i),i}})}}),define(oe[127],ae([0,1,25,121,124,4,7,15,36,54]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=v,e.getIdAndVersion=m,e.getExtensionId=b,e.adoptToGalleryExtensionId=w,e.getGalleryExtensionId=p,e.groupByExtension=d,e.getLocalExtensionTelemetryData=c,e.getGalleryExtensionTelemetryData=f,e.getExtensionDependencies=a,e.computeTargetPlatform=o;function v(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,n.compareIgnoreCase)(s.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(i){const r=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,r,u)}static parse(i){const r=y.exec(i);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,u="undefined"){this.version=r,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?v(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(s){const i=g.exec(s);return i&&i[1]?[w(i[1]),i[2]]:[w(s),void 0]}function b(s,i){return`${s}.${i}`}function w(s){return s.toLowerCase()}function p(s,i){return w(b(s??I.UNDEFINED_PUBLISHER,i))}function d(s,i){const r=[],u=S=>{for(const k of r)if(k.some(M=>v(i(M),i(S))))return k;return null};for(const S of s){const k=u(S);k?k.push(S):r.push([S])}return r}function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function f(s){return{id:new l.TelemetryTrustedValue(s.identifier.id),name:new l.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function a(s,i){const r=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const S=u.shift();if(S&&r.every(k=>!v(k.identifier,{id:S}))){const k=s.filter(M=>v(M.identifier,{id:S}));k.length===1&&(r.push(k[0]),u.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function t(s,i){if(!O.isLinux)return!1;let r;try{r=(await s.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(S))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,i){const r=await t(s,i),u=(0,D.getTargetPlatform)(r?"alpine":O.platform,h.arch);return i.debug("ComputeTargetPlatform:",u),u}}),define(oe[256],ae([0,1,209,54]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=I;async function I(O,C,P,h,l,v,y){const E={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${C.nameShort})`};if((0,D.supportsTelemetry)(C,P)&&(0,D.getTelemetryLevel)(h)===3){const g=await(0,n.getServiceMachineId)(P,l,v);E["X-Market-User-Id"]=g,E["VSCode-SessionId"]=y.machineId||g}return E}}),define(oe[257],ae([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(p,d,c){this._configurationService=d,this._productService=c,this._experimentProperties={},this._disposables=new n.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(f=>{(f.affectsConfiguration(E.TELEMETRY_SETTING_ID)||f.affectsConfiguration(E.TELEMETRY_OLD_SETTING_ID)||f.affectsConfiguration(E.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(p,d){this._experimentProperties[p]=d}_updateTelemetryLevel(){let p=(0,g.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const c=d.usage?3:d.error?2:0;p=Math.min(p,c)}this._telemetryLevel=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(p,d,c){this._telemetryLevel<d||(c=(0,D.mixin)(c,this._experimentProperties),c=(0,g.cleanData)(c,this._cleanupPatterns),c=(0,D.mixin)(c,this._commonProperties),this._appenders.forEach(f=>f.log(p,c)))}publicLog(p,d){this._log(p,3,d)}publicLog2(p,d){this.publicLog(p,d)}publicLogError(p,d){this._sendErrorTelemetry&&this._log(p,2,d)}publicLogError2(p,d){this.publicLogError(p,d)}};e.TelemetryService=m,e.TelemetryService=m=Pe([ne(1,P.IConfigurationService),ne(2,v.IProductService)],m);function b(){const w=(0,C.localize)(0,null,l.default.nameLong),p=l.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=I.isWeb?"":(0,C.localize)(3,null),c=(0,C.localize)(4,null),f=(0,C.localize)(5,null),a=(0,C.localize)(6,null),t=(0,C.localize)(7,null),o=`
|       | ${c} | ${f} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,C.localize)(8,null);return`
${w} ${p} ${d}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:b(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,C.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,C.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[258],ae([0,1,4,89,28]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=O,e.resolveSqmId=C;async function O(P,h){let l=P.getItem(I.machineIdKey);return(typeof l!="string"||n.isMacintosh&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,D.getMachineId)(h.error.bind(h))),l}async function C(P,h){let l=P.getItem(I.sqmIdKey);return typeof l!="string"&&(l=await(0,D.getSqmMachineId)(h.error.bind(h))),l}}),define(oe[259],ae([0,1,28,258]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=I,e.resolveSqmId=O;async function I(C,P){const h=await(0,D.resolveMachineId)(C,P);return C.setItem(n.machineIdKey,h),h}async function O(C,P){const h=await(0,D.resolveSqmId)(C,P);return C.setItem(n.sqmIdKey,h),h}}),define(oe[128],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[260],ae([0,1,4,128]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const I=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor(v){this.collections=v,this.map=new Map,this.descriptionMap=new Map,v.forEach((y,E)=>{this.populateDescriptionMap(y,E);const g=y.map.entries();let m=g.next();for(;!m.done;){const b=m.value[1],w=m.value[0];let p=this.map.get(w);if(p||(p=[],this.map.set(w,p)),p.length>0&&p[0].type===D.EnvironmentVariableMutatorType.Replace){m=g.next();continue}const d={extensionIdentifier:E,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};d.scope||delete d.scope,p.unshift(d),m=g.next()}})}async applyToProcessEnvironment(v,y,E){let g;n.isWindows&&(g={},Object.keys(v).forEach(m=>g[m.toLowerCase()]=m));for(const[m,b]of this.getVariableMap(y)){const w=n.isWindows&&g[m.toLowerCase()]||m;for(const p of b){const d=E?await E(p.value):p.value;if(p.options?.applyAtProcessCreation??!0)switch(p.type){case D.EnvironmentVariableMutatorType.Append:v[w]=(v[w]||"")+d;break;case D.EnvironmentVariableMutatorType.Prepend:v[w]=d+(v[w]||"");break;case D.EnvironmentVariableMutatorType.Replace:v[w]=d;break}if(p.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${I.get(p.type)}`;v[c]=(v[c]?v[c]+":":"")+m+"="+this._encodeColons(d)}}}}_encodeColons(v){return v.replaceAll(":","\\x3a")}diff(v,y){const E=new Map,g=new Map,m=new Map;if(v.getVariableMap(y).forEach((b,w)=>{const p=this.getVariableMap(y).get(w),d=P(b,p);d&&E.set(w,d)}),this.getVariableMap(y).forEach((b,w)=>{const p=v.getVariableMap(y).get(w),d=P(b,p);d&&m.set(w,d)}),this.getVariableMap(y).forEach((b,w)=>{const p=v.getVariableMap(y).get(w),d=h(b,p);d&&g.set(w,d)}),!(E.size===0&&g.size===0&&m.size===0))return{added:E,changed:g,removed:m}}getVariableMap(v){const y=new Map;for(const E of this.map.values()){const g=E.filter(m=>C(m,v));g.length>0&&y.set(g[0].variable,g)}return y}getDescriptionMap(v){const y=new Map;for(const E of this.descriptionMap.values()){const g=E.filter(m=>C(m,v,!0));for(const m of g)y.set(m.extensionIdentifier,m.description)}return y}populateDescriptionMap(v,y){if(!v.descriptionMap)return;const E=v.descriptionMap.entries();let g=E.next();for(;!g.done;){const m=g.value[1],b=g.value[0];let w=this.descriptionMap.get(b);w||(w=[],this.descriptionMap.set(b,w));const p={extensionIdentifier:y,scope:m.scope,description:m.description};p.scope||delete p.scope,w.push(p),g=E.next()}}}e.MergedEnvironmentVariableCollection=O;function C(l,v,y=!1){return l.scope?!!(l.scope.workspaceFolder&&v?.workspaceFolder&&l.scope.workspaceFolder.index===v.workspaceFolder.index):y?v===l.scope:!0}function P(l,v){if(!v)return l;const y=new Set;v.forEach(g=>y.add(g.extensionIdentifier));const E=[];return l.forEach(g=>{y.has(g.extensionIdentifier)||E.push(g)}),E.length===0?void 0:E}function h(l,v){if(!v)return;const y=new Map;v.forEach(g=>y.set(g.extensionIdentifier,g));const E=[];return l.forEach(g=>{const m=y.get(g.extensionIdentifier);m&&(g.type!==m.type||g.value!==m.value||g.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&E.push(m)}),E.length===0?void 0:E}}),define(oe[261],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=n,e.serializeEnvironmentDescriptionMap=D,e.deserializeEnvironmentVariableCollection=I,e.deserializeEnvironmentDescriptionMap=O,e.serializeEnvironmentVariableCollections=C,e.deserializeEnvironmentVariableCollections=P;function n(h){return[...h.entries()]}function D(h){return h?[...h.entries()]:[]}function I(h){return new Map(h)}function O(h){return new Map(h??[])}function C(h){return Array.from(h.entries()).map(l=>[l[0],n(l[1].map),D(l[1].descriptionMap)])}function P(h){return new Map(h.map(l=>[l[0],{map:I(l[1]),descriptionMap:O(l[2])}]))}}),define(oe[262],ae([0,1,8,23,3,2,5]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends O.Disposable{constructor(l,v){super(),this._logService=v,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new I.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=l===void 0?15e3:l,this._register((0,O.toDisposable)(()=>{for(const y of this._pendingRequestDisposables.values())(0,O.dispose)(y)}))}createRequest(l){return new Promise((v,y)=>{const E=++this._lastRequestId;this._pendingRequests.set(E,v),this._onCreateRequest.fire({requestId:E,...l});const g=new D.CancellationTokenSource;(0,n.timeout)(this._timeout,g.token).then(()=>y(`Request ${E} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(E,[(0,O.toDisposable)(()=>g.cancel())])})}acceptReply(l,v){const y=this._pendingRequests.get(l);y?(this._pendingRequests.delete(l),(0,O.dispose)(this._pendingRequestDisposables.get(l)||[]),this._pendingRequestDisposables.delete(l),y(v)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.RequestStore=P,e.RequestStore=P=Pe([ne(1,C.ILogService)],P)}),define(oe[129],ae([0,1,6,118,45]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new D.RawContextKey("terminalTabFocusMode",!1,!0);var O;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var C;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(P||(e.PosixShellType=P={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var v;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(v||(e.TerminalIpcChannels=v={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.IPtyService=(0,n.createDecorator)("ptyService");var E;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var g;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var b;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var p;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var d;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var c;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class f{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const o=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this._backends.set(o,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}I.Registry.add(e.TerminalExtensions.Backend,new f),e.ILocalPtyService=(0,n.createDecorator)("localPtyService"),e.ITerminalLogService=(0,n.createDecorator)("terminalLogService")}),define(oe[263],ae([0,1,75,7,190,106]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=C,e.terminalProfileArgsMatch=l,e.terminalIconsEqual=v,e.isUriComponents=y;function C(E,g){const m=[{name:null,description:(0,I.localize)(0,null)}];return m.push(...E.map(b=>({name:b.profileName,description:P(b)}))),g&&m.push(...g.map(b=>({name:b.title,description:h(b)}))),{values:m.map(b=>b.name),markdownDescriptions:m.map(b=>b.description)}}function P(E){let g=`$(${O.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:n.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?g+=`
- args: "${E.args}"`:g+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(g+=`
- overrideName: ${E.overrideName}`),E.color&&(g+=`
- color: ${E.color}`),E.env&&(g+=`
- env: ${JSON.stringify(E.env)}`),g}function h(E){return`$(${O.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:n.Codicon.terminal.id}) ${E.title}
- extensionIdentifier: ${E.extensionIdentifier}`}function l(E,g){if(!E&&!g)return!0;if(typeof E=="string"&&typeof g=="string")return E===g;if(Array.isArray(E)&&Array.isArray(g)){if(E.length!==g.length)return!1;for(let m=0;m<E.length;m++)if(E[m]!==g[m])return!1;return!0}return!1}function v(E,g){if(!E&&!g)return!0;if(!E||!g)return!1;if(O.ThemeIcon.isThemeIcon(E)&&O.ThemeIcon.isThemeIcon(g))return E.id===g.id&&E.color===g.color;if(typeof E=="object"&&"light"in E&&"dark"in E&&typeof g=="object"&&"light"in g&&"dark"in g){const m=E,b=g;if((D.URI.isUri(m.light)||y(m.light))&&(D.URI.isUri(m.dark)||y(m.dark))&&(D.URI.isUri(b.light)||y(b.light))&&(D.URI.isUri(b.dark)||y(b.dark)))return m.light.path===b.light.path&&m.dark.path===b.dark.path}if(D.URI.isUri(E)&&D.URI.isUri(g)||y(E)||y(g)){const m=E,b=g;return m.path===b.path&&m.scheme===b.scheme}return!1}function y(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}}),define(oe[264],ae([0,1,75,4,189,52,45,263]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.terminalIconSchema=e.terminalColorSchema=void 0,e.registerTerminalPlatformConfiguration=g,e.registerTerminalDefaultProfileConfiguration=b,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,n.getAllCodicons)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.getAllCodicons)(),w=>`$(${w.id})`)};const h={args:{description:(0,I.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,I.localize)(1,null),type:"boolean"},icon:{description:(0,I.localize)(2,null),...e.terminalIconSchema},color:{description:(0,I.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,I.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},v={type:"object",required:["path"],properties:{path:{description:(0,I.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function y(w){const p=w===2?"linux":w===1?"osx":"windows";return(0,I.localize)(7,null,(0,D.PlatformToString)(w),'```json\n"terminal.integrated.profile.'+p+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const E={id:"terminal",order:100,title:(0,I.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,I.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,I.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,I.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,I.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(13,null),type:"string"},id:{description:(0,I.localize)(14,null),type:"string"},title:{description:(0,I.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(16,null),type:"string"},id:{description:(0,I.localize)(17,null),type:"string"},title:{description:(0,I.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,I.localize)(19,null),type:"string"},id:{description:(0,I.localize)(20,null),type:"string"},title:{description:(0,I.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,I.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,I.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,I.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,I.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,I.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){C.Registry.as(O.Extensions.Configuration).registerConfiguration(E),b()}let m;function b(w,p){const d=C.Registry.as(O.Extensions.Configuration);let c;w&&(c=(0,P.createProfileSchemaEnums)(w?.profiles,p));const f=m;m={id:"terminal",order:100,title:(0,I.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,I.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?c?.values:void 0,markdownEnumDescriptions:w?.os===3?c?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,I.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?c?.values:void 0,markdownEnumDescriptions:w?.os===2?c?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,I.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?c?.values:void 0,markdownEnumDescriptions:w?.os===1?c?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[m],remove:f?[f]:[]})}}),define(oe[265],ae([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=m,e.findExecutable=b,e.getShellIntegrationInjection=w;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let r=0;return i&&i.length===4&&(r=parseInt(i[3])),r}async function b(i,r,u,S=P.env,k=v.Promises.exists){if(O.isAbsolute(i))return await k(i)?i:void 0;if(r===void 0&&(r=P.cwd()),O.dirname(i)!=="."){const A=O.join(r,i);return await k(A)?A:void 0}const L=(0,I.getCaseInsensitive)(S,"PATH");if(u===void 0&&(0,l.isString)(L)&&(u=L.split(O.delimiter)),u===void 0||u.length===0){const A=O.join(r,i);return await k(A)?A:void 0}for(const A of u){let F;if(O.isAbsolute(A)?F=O.join(A,i):F=O.join(r,A,i),await k(F))return F;if(C.isWindows){let _=F+".com";if(await k(_)||(_=F+".exe",await k(_)))return _}}const R=O.join(r,i);return await k(R)?R:void 0}function w(i,r,u,S,k){const M=C.isWindows&&(!r.windowsEnableConpty||m()<18309);if(!r.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.ignoreShellIntegration||M)return;const L=i.args,R=P.platform==="win32"?O.basename(i.executable).toLowerCase():O.basename(i.executable),A=O.dirname(D.FileAccess.asFileUri("").fsPath);let F;const _={VSCODE_INJECTION:"1"};if(r.shellIntegration.nonce&&(_.VSCODE_NONCE=r.shellIntegration.nonce),C.isWindows){if(R==="pwsh.exe"||R==="powershell.exe")return!L||o(L)?F=c.get(d.WindowsPwsh):t(L)&&(F=c.get(d.WindowsPwshLogin)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],A,""),r.shellIntegration.suggestEnabled&&(_.VSCODE_SUGGEST="1"),{newArgs:F,envMixin:_}):void 0;S.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(R){case"bash":return!L||L.length===0?F=c.get(d.Bash):s(L)&&(_.VSCODE_SHELL_LOGIN="1",p(r,_),F=c.get(d.Bash)),F?(F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],A),{newArgs:F,envMixin:_}):void 0;case"fish":{const z=u?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",j=O.join(A,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return _.XDG_DATA_DIRS=`${z}:${j}`,p(r,_),{newArgs:void 0,envMixin:_}}case"pwsh":return!L||o(L)?F=c.get(d.Pwsh):t(L)&&(F=c.get(d.PwshLogin)),F?(r.shellIntegration.suggestEnabled&&(_.VSCODE_SUGGEST="1"),F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],A,""),{newArgs:F,envMixin:_}):void 0;case"zsh":{if(!L||L.length===0?F=c.get(d.Zsh):s(L)?(F=c.get(d.ZshLogin),p(r,_)):(L===c.get(d.Zsh)||L===c.get(d.ZshLogin))&&(F=L),!F)return;F=[...F],F[F.length-1]=(0,h.format)(F[F.length-1],A);let z;try{z=n.userInfo().username}catch{z="unknown"}const j=O.join(n.tmpdir(),`${z}-${k.applicationName}-zsh`);_.ZDOTDIR=j;const ce=u?.ZDOTDIR??n.homedir()??"~";_.USER_ZDOTDIR=ce;const te=[];return te.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(j,".zshrc")}),te.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(j,".zprofile")}),te.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(j,".zshenv")}),te.push({source:O.join(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(j,".zlogin")}),{newArgs:F,envMixin:_,filesToCopy:te}}}S.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}function p(i,r){if(C.isMacintosh&&i.environmentVariableCollections){const u=(0,E.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),k=new g.MergedEnvironmentVariableCollection(u).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),M=[];if(k)for(const L of k)L.type===y.EnvironmentVariableMutatorType.Prepend&&M.push(L.value);M.length>0&&(r.VSCODE_PATH_PREFIX=M.join(""))}}var d;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(d||(d={}));const c=new Map;c.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(d.Zsh,["-i"]),c.set(d.ZshLogin,["-il"]),c.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?f.includes(i.toLowerCase()):i.length===1&&f.includes(i[0].toLowerCase())||i.length===2&&(f.includes(i[0].toLowerCase())||f.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function s(i){return i==="string"&&f.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&f.includes(i[0].toLowerCase())}}),define(oe[266],ae([0,1,49,75,9,4,12,21,110,265,117]),function(Q,e,n,D,I,O,C,P,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=m;var y;(function(u){u.UnixShellsPath="/etc/shells"})(y||(y={}));let E,g=!0;function m(u,S,k,M,L=process.env,R,A,F,_){return R=R||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},O.isWindows?b(k,R,L,A,M.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:M.getValue("terminal.integrated.profiles.windows"),typeof S=="string"?S:M.getValue("terminal.integrated.defaultProfile.windows"),_,F):s(R,A,k,u&&typeof u=="object"?{...u}:M.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof S=="string"?S:M.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,F,L)}async function b(u,S,k,M,L,R,A,F,_){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),j=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ce=!1;(0,l.getWindowsBuildNumber)()>=16299&&(ce=!0),await c(F);const te=new Map;if(u){te.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${j}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${j}\\cmd.exe`,icon:D.Codicon.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:D.Codicon.terminalBash,isAutoDetected:!0});const X=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${j}\\cmd.exe`,args:["/K",X],requiresPath:process.env.CMDER_ROOT?X:{path:X,isUnsafe:!0},isAutoDetected:!0})}i(R,te);const ue=await w(te.entries(),A,S,k,M,_);if(u&&L)try{const X=await t(`${j}\\${ce?"wsl":"bash"}.exe`,A);for(const Y of X)(!R||!(Y.profileName in R))&&ue.push(Y)}catch{g&&(M?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return ue}async function w(u,S,k,M=process.env,L,R){const A=[];for(const[F,_]of u)A.push(p(F,_,S,k,M,L,R));return(await Promise.all(A)).filter(F=>!!F)}async function p(u,S,k,M,L=process.env,R,A){if(S===null)return;let F,_,z;if("source"in S&&!("path"in S)){const ue=E?.get(S.source);if(!ue)return;F=ue.paths,_=S.args||ue.args,S.icon?z=d(S.icon):ue.icon&&(z=ue.icon)}else F=Array.isArray(S.path)?S.path:[S.path],_=O.isWindows||Array.isArray(S.args)?S.args:void 0,z=d(S.icon);let j;if(A){const ue=F.map(Y=>typeof Y=="string"?Y:Y.path),X=await A(ue);j=new Array(F.length);for(let Y=0;Y<F.length;Y++)typeof F[Y]=="string"?j[Y]=X[Y]:j[Y]={path:X[Y],isUnsafe:!0}}else j=F.slice();let ce;if(S.requiresPath){let ue;if((0,C.isString)(S.requiresPath)?ue=S.requiresPath:(ue=S.requiresPath.path,S.requiresPath.isUnsafe&&(ce=ue)),!await M.existsFile(ue))return}const te=await r(u,k,j,M,L,_,S.env,S.overrideName,S.isAutoDetected,ce);if(!te){R?.debug("Terminal profile not validated",u,F);return}return te.isAutoDetected=S.isAutoDetected,te.icon=z,te.color=S.color,te}function d(u){return typeof u=="string"?{id:u}:u}async function c(u){if(E&&!u)return;const[S,k]=await Promise.all([f(),u||a()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:S,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:k,icon:D.Codicon.terminalPowershell})}async function f(){const u=new Set,S=await(0,l.findExecutable)("git.exe");if(S){const L=(0,v.dirname)(S);u.add((0,v.resolve)(L,"../.."))}function k(L,R){R&&L.add(R)}k(u,process.env.ProgramW6432),k(u,process.env.ProgramFiles),k(u,process.env["ProgramFiles(X86)"]),k(u,`${process.env.LocalAppData}\\Program`);const M=[];for(const L of u)M.push(`${L}\\Git\\bin\\bash.exe`,`${L}\\Git\\usr\\bin\\bash.exe`,`${L}\\usr\\bin\\bash.exe`);return M.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),M.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),M}async function a(){const u=[];for await(const S of(0,h.enumeratePowerShellInstallations)())u.push(S.exePath);return u}async function t(u,S){const k=[],M=await new Promise((A,F)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,z)=>{if(_)return F("Problem occurred when getting wsl distros");A(z)})});if(!M)return[];const L=new RegExp(/[\r?\n]/),R=M.split(L).filter(A=>A.trim().length>0&&A!=="");for(const A of R){if(A===""||A.startsWith("docker-desktop"))continue;const F=`${A} (WSL)`,_={profileName:F,path:u,args:["-d",`${A}`],isDefault:F===S,icon:o(A),isAutoDetected:!1};k.push(_)}return k}function o(u){return u.includes("Ubuntu")?D.Codicon.terminalUbuntu:u.includes("Debian")?D.Codicon.terminalDebian:D.Codicon.terminalLinux}async function s(u,S,k,M,L,R,A,F){const _=new Map;if(k&&await u.existsFile("/etc/shells")){const z=(await u.readFile("/etc/shells")).toString(),j=(R||z.split(`
`)).map(te=>{const ue=te.indexOf("#");return ue===-1?te:te.substring(0,ue)}).filter(te=>te.trim().length>0),ce=new Map;for(const te of j){let ue=(0,I.basename)(te),X=ce.get(ue)||0;X++,X>1&&(ue=`${ue} (${X})`),ce.set(ue,X),_.set(ue,{path:te,isAutoDetected:!0})}}return i(M,_),await w(_.entries(),L,u,F,S,A)}function i(u,S){if(u)for(const[k,M]of Object.entries(u))M===null||typeof M!="object"||!("path"in M)&&!("source"in M)?S.delete(k):(M.icon=M.icon||S.get(k)?.icon,S.set(k,M))}async function r(u,S,k,M,L,R,A,F,_,z){if(k.length===0)return Promise.resolve(void 0);const j=k.shift();if(j==="")return r(u,S,k,M,L,R,A,F,_);const ce=typeof j!="string"&&j.isUnsafe,te=typeof j=="string"?j:j.path,ue={profileName:u,path:te,args:R,env:A,overrideName:F,isAutoDetected:_,isDefault:u===S,isUnsafePath:ce,requiresUnsafePath:z};if((0,I.basename)(te)===te){const Y=L.PATH?L.PATH.split(I.delimiter):void 0,B=await(0,l.findExecutable)(te,void 0,Y,void 0,M.existsFile);return B?(ue.path=B,ue.isFromPath=!0,ue):r(u,S,k,M,L,R)}return await M.existsFile((0,I.normalize)(te))?ue:r(u,S,k,M,L,R,A,F,_)}}),define(oe[267],ae([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let p=class extends D.Disposable{get _connection(){return this._ensurePtyHost(),this.__connection}get _proxy(){return this._ensurePtyHost(),this.__proxy}get _optionalProxy(){return this.__proxy}_ensurePtyHost(){this.__connection||this._startPtyHost()}constructor(c,f,a,t){super(),this._ptyHostStarter=c,this._configurationService=f,this._logService=a,this._loggerService=t,this._wasQuitRequested=!1,this._restartCount=0,this._isResponsive=!0,this._onPtyHostExit=this._register(new n.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new n.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new n.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new n.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new n.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new n.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new n.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new n.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new n.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new n.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new n.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new n.Emitter),this.onProcessExit=this._onProcessExit.event,(0,E.registerTerminalPlatformConfiguration)(),this._register(this._ptyHostStarter),this._register((0,D.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),this._ptyHostStarter.onRequestConnection&&n.Event.once(this._ptyHostStarter.onRequestConnection)(()=>this._ensurePtyHost()),this._ptyHostStarter.onWillShutdown?.(()=>this._wasQuitRequested=!0)}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._optionalProxy?.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(I.isWindows)return process.env;try{return await(0,l.getResolvedShellEnv)(this._configurationService,this._logService,{_:[]},process.env)}catch(c){return this._logService.error("ptyHost was unable to resolve shell environment",c),{}}}_startPtyHost(){const c=this._ptyHostStarter.start(),f=c.client;this._logService.getLevel()===P.LogLevel.Trace&&this._logService.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(f.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(!0),this._register(c.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),!this._wasQuitRequested&&!this._store.isDisposed&&(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=O.ProxyChannel.toService(f.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(o=>this._onProcessData.fire(o))),this._register(t.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(t.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(t.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(t.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(t.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(t.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),this._register(new h.RemoteLoggerChannelClient(this._loggerService,f.getChannel(y.TerminalIpcChannels.Logger))),this.__connection=c,this.__proxy=t,this._onPtyHostStart.fire(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()})),this._refreshIgnoreProcessNames(),[c,t]}async createProcess(c,f,a,t,o,s,i,r,u,S,k){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),L=await this._proxy.createProcess(c,f,a,t,o,s,i,r,u,S,k);return clearTimeout(M),L}updateTitle(c,f,a){return this._proxy.updateTitle(c,f,a)}updateIcon(c,f,a,t){return this._proxy.updateIcon(c,f,a,t)}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c,f){return this._proxy.detachFromProcess(c,f)}shutdownAll(){return this._proxy.shutdownAll()}listProcesses(){return this._proxy.listProcesses()}async getPerformanceMarks(){return this._optionalProxy?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this._optionalProxy?.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,f){return this._proxy.shutdown(c,f)}input(c,f){return this._proxy.input(c,f)}processBinary(c,f){return this._proxy.processBinary(c,f)}resize(c,f,a){return this._proxy.resize(c,f,a)}clearBuffer(c){return this._proxy.clearBuffer(c)}acknowledgeDataEvent(c,f){return this._proxy.acknowledgeDataEvent(c,f)}setUnicodeVersion(c,f){return this._proxy.setUnicodeVersion(c,f)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}async getLatency(){const c=new b.StopWatch,f=await this._proxy.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...f]}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}installAutoReply(c,f){return this._proxy.installAutoReply(c,f)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(c){return this._proxy.uninstallAutoReply(c)}getDefaultSystemShell(c){return this._optionalProxy?.getDefaultSystemShell(c)??(0,m.getSystemShell)(c??I.OS,process.env)}async getProfiles(c,f,a,t=!1){const o=await this._resolveShellEnv();return(0,g.detectAvailableProfiles)(f,a,t,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,c))}async getEnvironment(){return this.__proxy?this._proxy.getEnvironment():{...process.env}}getWslPath(c,f){return this._proxy.getWslPath(c,f)}getRevivedPtyNewId(c,f){return this._proxy.getRevivedPtyNewId(c,f)}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this._optionalProxy?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,f){return this._proxy.requestDetachInstance(c,f)}async acceptDetachInstanceReply(c,f){return this._proxy.acceptDetachInstanceReply(c,f)}async freePortKillProcess(c){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(c)}async serializeTerminalState(c){return this._proxy.serializeTerminalState(c)}async reviveTerminalProcesses(c,f,a){return this._proxy.reviveTerminalProcesses(c,f,a)}async refreshProperty(c,f){return this._proxy.refreshProperty(c,f)}async updateProperty(c,f,a){return this._proxy.updateProperty(c,f,a)}async restartPtyHost(){this._disposePtyHost(),this._isResponsive=!0,this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll(),this._connection.store.dispose()}_handleHeartbeat(c){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),c?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(c,f){return this._resolveVariablesRequestStore.createRequest({workspaceId:c,originalText:f})}async acceptPtyHostResolvedVariables(c,f){this._resolveVariablesRequestStore.acceptReply(c,f)}};e.PtyHostService=p,e.PtyHostService=p=Pe([ne(1,C.IConfigurationService),ne(2,P.ILogService),ne(3,P.ILoggerService)],p)}),define(oe[69],ae([0,1,14,3,2,4,18,6,34]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",v="#1E1E1E",y="#000000",E="#FFFFFF",g="theme",m="themeBackground",b="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let w=class extends I.Disposable{constructor(d,c){super(),this.stateService=d,this.configurationService=c,this._onDidChangeColorScheme=this._register(new D.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._register(this.configurationService.onDidChangeConfiguration(f=>{f.affectsConfiguration("window.systemColorTheme")&&this.updateSystemColorTheme()})),this.updateSystemColorTheme(),this._register(D.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this._onDidChangeColorScheme.fire(this.getColorScheme())))}updateSystemColorTheme(){switch(this.configurationService.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.getBaseTheme()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(O.isWindows){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.isMacintosh){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.isLinux&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return d.dark?y:E;let c=this.stateService.getItem(m,null);if(!c)switch(this.getBaseTheme()){case"vs":c=l;break;case"hc-black":c=y;break;case"hc-light":c=E;break;default:c=v}return O.isMacintosh&&c.toUpperCase()===v&&(c="#171717"),c}getBaseTheme(){switch(this.stateService.getItem(g,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(d,c){this.stateService.setItems([{key:g,data:c.baseTheme},{key:m,data:c.colorInfo.background},{key:b,data:c}]),typeof d=="number"&&this.updateBackgroundColor(d,c),this.updateSystemColorTheme()}updateBackgroundColor(d,c){for(const f of n.BrowserWindow.getAllWindows())if(f.id===d){f.setBackgroundColor(c.colorInfo.background);break}}getWindowSplash(){return this.stateService.getItem(b)}};e.ThemeMainService=w,e.ThemeMainService=w=Pe([ne(0,h.IStateService),ne(1,C.IConfigurationService)],w)}),define(oe[130],ae([0,1,3,7,18,6,5]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=l,e.extractLocalHostUriMetaDataForPortMapping=y,e.extractQueryLocalHostUriMetaDataForPortMapping=E,e.isLocalhost=g,e.isAllInterfaces=m,e.isPortPrivileged=b,e.ITunnelService=(0,O.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,O.createDecorator)("sharedTunnelsService");var P;(function(d){d.Http="http",d.Https="https"})(P||(e.TunnelProtocol=P={}));var h;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(h||(e.TunnelPrivacyId=h={}));function l(d){return!!d.forwardPort}var v;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function y(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(c)return{address:c[1],port:+c[2]}}function E(d){if(d.scheme!=="http"&&d.scheme!=="https"||!d.query)return;const c=d.query.split("&");for(const f of c){const a=f.split("=")[1];if(/^https?:/.exec(a)){const t=y(D.URI.parse(a));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}function b(d,c,f,a){if(f===1)return!1;if(f===2&&m(c)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return d<1024}class w{constructor(c,f,a){this.remoteAddress=c,this.localAddress=f,this._dispose=a,this._onDispose=new n.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=w;let p=class{constructor(c,f){this.logService=c,this.configurationService=f,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this._tunnelProvider=c,c?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions,this._canChangeProtocol=c.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],f=Array.from(this._tunnels.values());for(const a of f){const t=Array.from(a.values());for(const o of t){const s=await o.value;s&&typeof s!="string"&&c.push(s)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:f}of c.values())await f.then(a=>typeof a!="string"?a?.dispose():void 0);c.clear()}this._tunnels.clear()}setEnvironmentTunnel(c,f,a,t,o){this.addTunnelToMap(c,f,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:f,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,f){(m(c)||g(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const a=this.getTunnelFromMap(c,f);if(a)return++a.refcount,a.value}openTunnel(c,f,a,t,o,s=!1,i,r){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${a} on local port ${o}.`);const u=this._tunnelProvider??c;if(!u)return;if(f||(f="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(a)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.retainOrCreateTunnel(u,f,a,t,o,s,i,r);return S?S.then(k=>{if(k){if(typeof k=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(f,a),k}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(f,a);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const M=this.makeTunnel(k);return(k.tunnelRemoteHost!==f||k.tunnelRemotePort!==a)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&k.privacy!==i&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(M),M}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const f=this._tunnels.get(c.tunnelRemoteHost);if(f){const a=f.get(c.tunnelRemotePort);a&&(a.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,a))}}}}async tryDisposeTunnel(c,f,a){if(a.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${f}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(f),t}}async closeTunnel(c,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${f} `);const a=this._tunnels.get(c);if(a&&a.has(f)){const t=a.get(f);t.refcount=0,await this.tryDisposeTunnel(c,f,t)}}addTunnelToMap(c,f,a){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(f,{refcount:1,value:a})}async removeEmptyOrErrorTunnelFromMap(c,f){const a=this._tunnels.get(c);if(a){const t=a.get(f),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete(f),a.size===0&&this._tunnels.delete(c)}}getTunnelFromMap(c,f){const a=[c];g(c)?(a.push(...e.LOCALHOST_ADDRESSES),a.push(...e.ALL_INTERFACES_ADDRESSES)):m(c)&&a.push(...e.ALL_INTERFACES_ADDRESSES);const t=a.map(o=>this._tunnels.get(o));for(const o of t){const s=o?.get(f);if(s)return s}}canTunnel(c){return!!y(c)}createWithProvider(c,f,a,t,o,s,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${a} on local port ${t}.`);const r=a;this._factoryInProgress.add(r);const u=t===void 0?a:t,S={elevationRequired:o?this.isPortPrivileged(u):!1},k={remoteAddress:{host:f,port:a},localAddressPort:t,privacy:s,public:s?s!==h.Private:void 0,protocol:i},M=c.forwardPort(k,S);return M?(this.addTunnelToMap(f,a,M),M.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),M}};e.AbstractTunnelService=p,e.AbstractTunnelService=p=Pe([ne(0,C.ILogService),ne(1,I.IConfigurationService)],p)}),define(oe[50],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.DisablementReason=e.UpdateType=e.StateType=void 0;var D;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(D||(e.StateType=D={}));var I;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap",C[C.WindowsInstaller=3]="WindowsInstaller"})(I||(e.UpdateType=I={}));var O;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.State={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:{type:"downloading"},Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,n.createDecorator)("updateService")}),define(oe[268],ae([0,1,4,191,52,45]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.Registry.as(I.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:n.isWindows&&!n.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[269],ae([0,1,3,50]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class I{constructor(P){this.service=P}listen(P,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(P,h,l){switch(h){case"checkForUpdates":return this.service.checkForUpdates(l);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=I;class O{get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}constructor(P){this.channel=P,this._onStateChange=new n.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(P){return this.channel.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=O}),define(oe[40],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,n.createDecorator)("IUriIdentityService")}),define(oe[270],ae([0,1,40,210,16,19,142,3,2]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{static{this._clock=0}constructor(E){this.uri=E,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let v=class{constructor(E){this._fileService=E,this._dispooables=new h.DisposableStore,this._limit=2**16;const g=new Map,m=b=>{let w=g.get(b.scheme);return w===void 0&&(w=E.hasProvider(b)&&!this._fileService.hasCapability(b,1024),g.set(b.scheme,w)),w};this._dispooables.add(P.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(b=>{g.delete(b.scheme)})),this.extUri=new O.ExtUri(m),this._canonicalUris=new C.SkipList((b,w)=>this.extUri.compare(b,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(E){this._fileService.hasProvider(E)&&(E=(0,O.normalizePath)(E));const g=this._canonicalUris.get(E);return g?g.touch().uri.with({fragment:E.fragment}):(this._canonicalUris.set(E,new l(E)),this._checkTrim(),E)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const E=[...this._canonicalUris.entries()].sort((m,b)=>m[1].time<b[1].time?1:m[1].time>b[1].time?-1:0);l._clock=0,this._canonicalUris.clear();const g=this._limit*.5;for(let m=0;m<g;m++)this._canonicalUris.set(E[m][0],E[m][1].touch())}};e.UriIdentityService=v,e.UriIdentityService=v=Pe([ne(0,I.IFileService)],v),(0,D.registerSingleton)(n.IUriIdentityService,v,1)}),define(oe[131],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,n.createDecorator)("urlService")}),define(oe[271],ae([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(P){this.handler=P}listen(P,h){throw new Error(`Event not found: ${h}`)}call(P,h,l){switch(h){case"handleURL":return this.handler.handleURL(n.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=D;class I{constructor(P){this.channel=P}handleURL(P,h){return this.channel.call("handleURL",[P.toJSON(),h])}}e.URLHandlerChannelClient=I;class O{constructor(P,h){this.next=P,this.logService=h}async routeCall(P,h,l,v){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const y=n.URI.revive(l[0]);if(this.logService.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const E=/\bwindowId=(\d+)/.exec(y.query);if(E){const g=E[1];this.logService.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,y.toString(!0));const m=new RegExp(`window:${g}`),b=P.connections.find(w=>(this.logService.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),m.test(w.ctx)));if(b)return this.logService.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),b;this.logService.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.logService.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.logService.trace("URLHandlerRouter#routeCall() without URI argument");return this.next.routeCall(P,h,l,v)}routeEvent(P,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=O}),define(oe[272],ae([0,1,8,2,7,27]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends D.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(l,v){const y=[...this.handlers.values()];return(0,n.first)(y.map(E=>()=>E.handleURL(l,v)),void 0,!1).then(E=>E||!1)}registerHandler(l){return this.handlers.add(l),(0,D.toDisposable)(()=>this.handlers.delete(l))}}e.AbstractURLService=C;let P=class extends C{constructor(l){super(),this.productService=l}create(l){let{authority:v,path:y,query:E,fragment:g}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return v&&y&&y.indexOf("/")!==0&&(y=`/${y}`),I.URI.from({scheme:this.productService.urlProtocol,authority:v,path:y,query:E,fragment:g})}};e.NativeURLService=P,e.NativeURLService=P=Pe([ne(0,O.IProductService)],P)}),define(oe[273],ae([0,1,14,8,3,2,4,7]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h extends O.Disposable{constructor(v,y,E,g,m,b){if(super(),this.urlService=y,this.logService=b,this.uris=[],this.retryCount=0,v&&(b.trace("ElectronURLListener initialUrisToHandle:",v.map(d=>d.originalUrl)),this.uris=v),C.isWindows){const d=g.isBuilt?[]:[`"${g.appRoot}"`];d.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,d)}const w=I.Event.map(I.Event.fromNodeEventEmitter(n.app,"open-url",(d,c)=>({event:d,url:c})),({event:d,url:c})=>(d.preventDefault(),c));this._register(w(d=>{const c=this.uriFromRawUrl(d);c&&this.urlService.open(c,{originalUrl:d})})),E.getWindows().filter(d=>d.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.flush()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this._register(I.Event.once(E.onDidSignalReadyWindow)(()=>this.flush())))}uriFromRawUrl(v){try{return P.URI.parse(v)}catch{return}}async flush(){if(this.retryCount++>10){this.logService.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.logService.trace("ElectronURLListener#flush(): flushing URLs");const v=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.originalUrl})?this.logService.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.logService.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),v.push(y));v.length!==0&&(this.uris=v,(0,D.disposableTimeout)(()=>this.flush(),500,this._store))}}e.ElectronURLListener=h}),define(oe[274],ae([0,1,3,2,16,59,32]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends D.Disposable{constructor(l,v,y,E,g,m){super(),this.fileSystemScheme=l,this.fileSystemProvider=v,this.userDataScheme=y,this.userDataProfilesService=E,this.uriIdentityService=g,this.logService=m,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new C.ResourceSet(b=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(b))),this.updateAtomicReadWritesResources(),this._register(E.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(b=>this.handleFileChanges(b)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const l of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(l.settingsResource),this.atomicReadWriteResources.add(l.keybindingsResource),this.atomicReadWriteResources.add(l.tasksResource),this.atomicReadWriteResources.add(l.extensionsResource)}open(l,v){return this.fileSystemProvider.open(this.toFileSystemResource(l),v)}close(l){return this.fileSystemProvider.close(l)}read(l,v,y,E,g){return this.fileSystemProvider.read(l,v,y,E,g)}write(l,v,y,E,g){return this.fileSystemProvider.write(l,v,y,E,g)}watch(l,v){this.watchResources.set(l,l);const y=this.fileSystemProvider.watch(this.toFileSystemResource(l),v);return(0,D.toDisposable)(()=>{this.watchResources.delete(l),y.dispose()})}stat(l){return this.fileSystemProvider.stat(this.toFileSystemResource(l))}mkdir(l){return this.fileSystemProvider.mkdir(this.toFileSystemResource(l))}rename(l,v,y){return this.fileSystemProvider.rename(this.toFileSystemResource(l),this.toFileSystemResource(v),y)}readFile(l,v){return this.fileSystemProvider.readFile(this.toFileSystemResource(l),v)}readFileStream(l,v,y){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(l),v,y)}readdir(l){return this.fileSystemProvider.readdir(this.toFileSystemResource(l))}enforceAtomicReadFile(l){return this.atomicReadWriteResources.has(l)}writeFile(l,v,y){return this.fileSystemProvider.writeFile(this.toFileSystemResource(l),v,y)}enforceAtomicWriteFile(l){return this.atomicReadWriteResources.has(l)?{postfix:".vsctmp"}:!1}delete(l,v){return this.fileSystemProvider.delete(this.toFileSystemResource(l),v)}copy(l,v,y){if((0,I.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(l),this.toFileSystemResource(v),y);throw new Error("copy not supported")}cloneFile(l,v){if((0,I.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(l),this.toFileSystemResource(v));throw new Error("clone not supported")}handleFileChanges(l){const v=[];for(const y of l){if(y.resource.scheme!==this.fileSystemScheme)continue;const E=this.toUserDataResource(y.resource);this.watchResources.findSubstr(E)&&v.push({resource:E,type:y.type,cId:y.cId})}v.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(v))}toFileSystemResource(l){return l.with({scheme:this.fileSystemScheme})}toUserDataResource(l){return l.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(oe[275],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(oe[276],ae([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,n.createDecorator)("webviewManagerService")}),define(oe[277],ae([0,1,14,2,13,7]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends D.Disposable{static{this.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.handleWebviewRequest.bind(this);n.protocol.registerFileProtocol(I.Schemas.vscodeWebview,h)}handleWebviewRequest(h,l){try{const v=O.URI.parse(h.url),y=C.validWebviewFilePaths.get(v.path);if(typeof y=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${y}`,g=I.FileAccess.asFileUri(E);return l({path:g.fsPath,headers:{...I.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=C}),define(oe[55],ae([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.WindowMinimumSize=void 0,e.isOpenedAuxiliaryWindow=D,e.isWorkspaceToOpen=I,e.isFolderToOpen=O,e.isFileToOpen=C,e.getMenuBarVisibility=P,e.hasCustomTitlebar=y,e.hasNativeTitlebar=E,e.getTitleBarStyle=g,e.useWindowControlsOverlay=m,e.useNativeFullScreen=b,e.zoomLevelToZoomFactor=w,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(p){return typeof p.parentId=="number"}function I(p){return!!p.workspaceUri}function O(p){return!!p.folderUri}function C(p){return!!p.fileUri}function P(p){const d=E(p),c=p.getValue("window.menuBarVisibility");return c==="default"||d&&c==="compact"||n.isMacintosh&&n.isNative?"classic":c}var h;(function(p){p.TITLE_BAR_STYLE="window.titleBarStyle",p.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var l;(function(p){p.NATIVE="native",p.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var v;(function(p){p.AUTO="auto",p.WINDOWED="windowed",p.NEVER="never"})(v||(e.CustomTitleBarVisibility=v={}));function y(p,d){return!0}function E(p,d){return d||(d=g(p)),d==="native"}function g(p){if(n.isWeb)return"custom";const d=p.getValue("window");if(d){if(n.isMacintosh&&d.nativeTabs===!0||n.isMacintosh&&d.nativeFullScreen===!1)return"native";const a=d.titleBarStyle;if(a==="native"||a==="custom")return a}return n.isLinux?"native":"custom"}function m(p){return!(!n.isWindows||n.isWeb||E(p))}function b(p){const d=p.getValue("window");return!d||typeof d.nativeFullScreen!="boolean"||d.nativeTabs?!0:d.nativeFullScreen!==!1}function w(p=0){return Math.pow(1.2,p)}}),define(oe[82],ae([0,1,14]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultAuxWindowState=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var D;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(D||(e.LoadReason=D={}));var I;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(I||(e.UnloadReason=I={}));const O=function(l=1){return{width:1024,height:768,mode:l}};e.defaultWindowState=O;const C=function(){const y=n.screen.getPrimaryDisplay().workArea,E=Math.max(y.x+y.width/2-800/2,0),g=Math.max(y.y+y.height/2-600/2,0);return{x:E,y:g,width:800,height:600,mode:1}};e.defaultAuxWindowState=C;var P;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(P||(e.WindowMode=P={}));var h;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(oe[278],ae([0,1,8,3,2]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends I.Disposable{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:h,getActiveWindowId:l}){super(),this.disposables=this._register(new I.DisposableStore),D.Event.latch(D.Event.any(P,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,n.createCancelablePromise)(()=>l()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=O}),define(oe[30],ae([0,1,195,9,59,19,7,6,13]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=l,e.isEmptyWorkspaceIdentifier=v,e.toWorkspaceIdentifier=y,e.isWorkspaceIdentifier=E,e.reviveIdentifier=g,e.isWorkspace=b,e.isWorkspaceFolder=w,e.toWorkspaceFolder=c,e.isUntitledWorkspace=f,e.isTemporaryWorkspace=a,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=o,e.hasWorkspaceFileExtension=s,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function l(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.uri)}function v(i){return typeof i?.id=="string"&&!l(i)&&!E(i)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function y(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function E(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.configPath)}function g(i){const r=i;if(r?.uri)return{id:r.id,uri:C.URI.revive(r.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:C.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function b(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function w(i){const r=i;return!!(r&&typeof r=="object"&&C.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class p{constructor(r,u,S,k,M){this._id=r,this._transient=S,this._configuration=k,this._ignorePathCasing=M,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=u}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class d{constructor(r,u){this.raw=u,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,O.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function c(i){return new d({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(i,r){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}function a(i){let r;return C.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===h.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function o(i,r){return!f(i,r)&&!a(i)}function s(i){return(typeof i=="string"?(0,D.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}}),define(oe[56],ae([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let w=class{constructor(d,c){this.logService=d,this.productService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(d,c){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},c)}pickFolder(d,c){return this.doPick({...d,pickFolders:!0,title:(0,v.localize)(1,null)},c)}pickFile(d,c){return this.doPick({...d,pickFiles:!0,title:(0,v.localize)(2,null)},c)}pickWorkspace(d,c){const f=(0,v.localize)(3,null),a=(0,O.mnemonicButtonLabel)((0,v.localize)(4,null)),t=b.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:f,filters:t,buttonLabel:a},c)}async doPick(d,c){const f={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(f.properties=void 0,d.pickFiles&&d.pickFolders&&(f.properties=["multiSelections","openDirectory","openFile","createDirectory"])),f.properties||(f.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&f.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(f,(c||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}getWindowDialogQueue(d){if(d){let c=this.windowDialogQueues.get(d.id);return c||(c=new D.Queue,this.windowDialogQueues.set(d.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(d,c){return this.getWindowDialogQueue(c).queue(async()=>{const{options:f,buttonIndeces:a}=(0,y.massageMessageBoxOptions)(d,this.productService);let t;return c?t=await n.dialog.showMessageBox(c,f):t=await n.dialog.showMessageBox(f),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(d,c){const f=this.acquireFileDialogLock(d,c);if(!f)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(c).queue(async()=>{let a;return c?a=await n.dialog.showSaveDialog(c,d):a=await n.dialog.showSaveDialog(d),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,C.dispose)(f)}}normalizePath(d){return d&&h.isMacintosh&&(d=(0,P.normalizeNFC)(d)),d}normalizePaths(d){return d.map(c=>this.normalizePath(c))}async showOpenDialog(d,c){d.defaultPath&&(await l.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const f=this.acquireFileDialogLock(d,c);if(!f)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(c).queue(async()=>{let a;return c?a=await n.dialog.showOpenDialog(c,d):a=await n.dialog.showOpenDialog(d),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,C.dispose)(f)}}acquireFileDialogLock(d,c){if(!c)return C.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let f=this.windowFileDialogLocks.get(c.id);f||(f=new Set,this.windowFileDialogLocks.set(c.id,f));const a=(0,I.hash)(d);if(!f.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),f.add(a),(0,C.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),f?.delete(a),f?.size===0&&this.windowFileDialogLocks.delete(c.id)})}};e.DialogMainService=w,e.DialogMainService=w=Pe([ne(0,g.ILogService),ne(1,m.IProductService)],w)}),define(oe[279],ae([0,1,3,2,77,30]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends D.Disposable{static{this.STORAGE_CHANGE_DEBOUNCE_TIME=100}constructor(h,l){super(),this.logService=h,this.storageMainService=l,this.onDidChangeApplicationStorageEmitter=this._register(new n.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(l.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(h,l){this._register(n.Event.debounce(h.onDidChangeStorage,(v,y)=>(v?v.push(y):v=[y],v),C.STORAGE_CHANGE_DEBOUNCE_TIME)(v=>{v.length&&l.fire(this.serializeStorageChangeEvents(v,h))}))}serializeStorageChangeEvents(h,l){const v=new Map,y=new Set;return h.forEach(E=>{const g=l.get(E.key);typeof g=="string"?v.set(E.key,g):y.add(E.key)}),{changed:Array.from(v.entries()),deleted:Array.from(y.values())}}listen(h,l,v){switch(l){case"onDidChangeStorage":{const y=v.profile?(0,I.revive)(v.profile):void 0;if(!y)return this.onDidChangeApplicationStorageEmitter.event;let E=this.mapProfileToOnDidChangeProfileStorageEmitter.get(y.id);return E||(E=this._register(new n.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(y),E),this.mapProfileToOnDidChangeProfileStorageEmitter.set(y.id,E)),E.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,v){const y=v.profile?(0,I.revive)(v.profile):void 0,E=(0,O.reviveIdentifier)(v.workspace),g=await this.withStorageInitialized(y,E);switch(l){case"getItems":return Array.from(g.items.entries());case"updateItems":{const m=v;if(m.insert)for(const[b,w]of m.insert)g.set(b,w);m.delete?.forEach(b=>g.delete(b));break}case"optimize":return g.optimize();case"isUsed":{const m=v.payload;if(typeof m=="string")return this.storageMainService.isUsed(m)}default:throw new Error(`Call not found: ${l}`)}}async withStorageInitialized(h,l){let v;l?v=this.storageMainService.workspaceStorage(l):h?v=this.storageMainService.profileStorage(h):v=this.storageMainService.applicationStorage;try{await v.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${y}`)}return v}}e.StorageDatabaseChannel=C}),define(oe[41],ae([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=f,e.reviveProfile=a,e.toUserDataProfile=t;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function f(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&C.URI.isUri(r.location)&&C.URI.isUri(r.globalStorageHome)&&C.URI.isUri(r.settingsResource)&&C.URI.isUri(r.keybindingsResource)&&C.URI.isUri(r.tasksResource)&&C.URI.isUri(r.snippetsHome)&&C.URI.isUri(r.extensionsResource))}e.IUserDataProfilesService=(0,v.createDecorator)("IUserDataProfilesService");function a(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:C.URI.revive(i.location).with({scheme:r}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:C.URI.revive(i.extensionsResource).with({scheme:r}),cacheHome:C.URI.revive(i.cacheHome).with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,r,u,S,k,M){return{id:i,name:r,location:u,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:M&&k?.useDefaultFlags?.globalState?M.globalStorageHome:(0,O.joinPath)(u,"globalStorage"),settingsResource:M&&k?.useDefaultFlags?.settings?M.settingsResource:(0,O.joinPath)(u,"settings.json"),keybindingsResource:M&&k?.useDefaultFlags?.keybindings?M.keybindingsResource:(0,O.joinPath)(u,"keybindings.json"),tasksResource:M&&k?.useDefaultFlags?.tasks?M.tasksResource:(0,O.joinPath)(u,"tasks.json"),snippetsHome:M&&k?.useDefaultFlags?.snippets?M.snippetsHome:(0,O.joinPath)(u,"snippets"),extensionsResource:M&&k?.useDefaultFlags?.extensions?M.extensionsResource:(0,O.joinPath)(u,"extensions.json"),cacheHome:(0,O.joinPath)(S,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}let o=class extends I.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,u,S,k){super(),this.environmentService=r,this.fileService=u,this.uriIdentityService=S,this.logService=k,this.enabled=!0,this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new D.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new D.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new D.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),u=[r];if(this.enabled)try{for(const M of this.getStoredProfiles()){if(!M.name||!(0,d.isString)(M.name)||!M.location){this.logService.warn("Skipping the invalid stored profile",M.location||M.name);continue}u.push(t((0,O.basename)(M.location),M.name,M.location,this.profilesCacheHome,{shortName:M.shortName,icon:M.icon,useDefaultFlags:M.useDefaultFlags},r))}}catch(M){this.logService.error(M)}const S=new g.ResourceMap,k=new Map;if(u.length)try{const M=this.getStoredProfileAssociations();if(M.workspaces)for(const[L,R]of Object.entries(M.workspaces)){const A=C.URI.parse(L),F=u.find(_=>_.id===R);F&&S.set(A,F)}if(M.emptyWindows)for(const[L,R]of Object.entries(M.emptyWindows)){const A=u.find(F=>F.id===R);A&&k.set(L,A)}}catch(M){this.logService.error(M)}this._profilesObject={profiles:u,workspaces:S,emptyWindows:k}}return this._profilesObject}createDefaultProfile(){const r=t("__default__profile__",(0,P.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const u="Temp",S=new RegExp(`${(0,p.escapeRegExpCharacters)(u)}\\s(\\d+)`);let k=0;for(const L of this.profiles){const R=S.exec(L.name),A=R?parseInt(R[1]):0;k=A>k?A:k}const M=`${u} ${k+1}`;return this.createProfile((0,n.hash)((0,w.generateUuid)()).toString(16),M,{transient:!0},r)}async createNamedProfile(r,u,S){return this.createProfile((0,n.hash)((0,w.generateUuid)()).toString(16),r,u,S)}async createProfile(r,u,S,k){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const M=await this.doCreateProfile(r,u,S);return k&&await this.setProfileForWorkspace(k,M),M}async doCreateProfile(r,u,S){if(!(0,d.isString)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.profileCreationPromises.get(u);return k||(k=(async()=>{try{const M=this.profiles.find(A=>A.name===u||A.id===r);if(M)return M;const L=t(r,u,(0,O.joinPath)(this.profilesHome,r),this.profilesCacheHome,S,this.defaultProfile);await this.fileService.createFolder(L.location);const R=[];return this._onWillCreateProfile.fire({profile:L,join(A){R.push(A)}}),await b.Promises.settled(R),this.updateProfiles([L],[],[]),L}finally{this.profileCreationPromises.delete(u)}})(),this.profileCreationPromises.set(u,k)),k}async updateProfile(r,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(k=>k.id===r.id);if(!S)throw new Error(`Profile '${r.name}' does not exist`);return S=t(S.id,u.name??S.name,S.location,this.profilesCacheHome,{shortName:u.shortName??S.shortName,icon:u.icon===null?void 0:u.icon??S.icon,transient:u.transient??S.isTransient,useDefaultFlags:u.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[S]),S}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(k=>k.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);const S=[];this._onWillRemoveProfile.fire({profile:u,join(k){S.push(k)}});try{await Promise.allSettled(S)}catch(k){this.logService.error(k)}for(const k of[...this.profilesObject.emptyWindows.keys()])u.id===this.profilesObject.emptyWindows.get(k)?.id&&this.profilesObject.emptyWindows.delete(k);for(const k of[...this.profilesObject.workspaces.keys()])u.id===this.profilesObject.workspaces.get(k)?.id&&this.profilesObject.workspaces.delete(k);this.updateStoredProfileAssociations(),this.updateProfiles([],[u],[]);try{await this.fileService.del(u.cacheHome,{recursive:!0})}catch(k){(0,l.toFileOperationResult)(k)!==1&&this.logService.error(k)}}async setProfileForWorkspace(r,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(k=>k.id===u.id);if(!S)throw new Error(`Profile '${u.name}' does not exist`);this.updateWorkspaceAssociation(r,S)}unsetWorkspace(r,u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,u)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(u=>u.isDirectory&&this.profiles.every(S=>!this.uriIdentityService.extUri.isEqual(S.location,u.resource))).map(u=>this.fileService.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(u=>!this.isProfileAssociatedToWorkspace(u));await Promise.allSettled(r.map(u=>this.removeProfile(u)))}getProfileForWorkspace(r){const u=this.getWorkspace(r);return C.URI.isUri(u)?this.transientProfilesObject.workspaces.get(u)??this.profilesObject.workspaces.get(u):this.transientProfilesObject.emptyWindows.get(u)??this.profilesObject.emptyWindows.get(u)}getWorkspace(r){return(0,E.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,E.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,r.location))||[...this.profilesObject.workspaces.values()].some(u=>this.uriIdentityService.extUri.isEqual(u.location,r.location)))}updateProfiles(r,u,S){const k=[...this.profiles,...r],M=[];this.transientProfilesObject.profiles=[];for(let L of k)L.isDefault||u.some(R=>L.id===R.id)||(L=S.find(R=>L.id===R.id)??L,L.isTransient?this.transientProfilesObject.profiles.push(L):M.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags}));this.saveStoredProfiles(M),this._profilesObject=void 0,this.triggerProfilesChanges(r,u,S)}triggerProfilesChanges(r,u,S){this._onDidChangeProfiles.fire({added:r,removed:u,updated:S,all:this.profiles})}updateWorkspaceAssociation(r,u,S){S=u?.isTransient?!0:S,S||this.updateWorkspaceAssociation(r,void 0,!0);const k=this.getWorkspace(r),M=S?this.transientProfilesObject:this.profilesObject;C.URI.isUri(k)?(M.workspaces.delete(k),u&&M.workspaces.set(k,u)):(M.emptyWindows.delete(k),u&&M.emptyWindows.set(k,u)),S||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[S,k]of this.profilesObject.workspaces.entries())r[S.toString()]=k.id;const u={};for(const[S,k]of this.profilesObject.emptyWindows.entries())u[S.toString()]=k.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:u}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const u={},S=this.createDefaultProfile();if(r.workspaces)for(const[M,L]of Object.entries(r.workspaces)){const R=C.URI.parse(L);u[M]=this.uriIdentityService.extUri.isEqual(R,S.location)?S.id:this.uriIdentityService.extUri.basename(R)}const k={};if(r.emptyWindows)for(const[M,L]of Object.entries(r.emptyWindows)){const R=C.URI.parse(L);k[M]=this.uriIdentityService.extUri.isEqual(R,S.location)?S.id:this.uriIdentityService.extUri.basename(R)}return{workspaces:u,emptyWindows:k}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=Pe([ne(0,h.IEnvironmentService),ne(1,l.IFileService),ne(2,m.IUriIdentityService),ne(3,y.ILogService)],o);class s extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=s}),define(oe[83],ae([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class c extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=c,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let f=class extends I.Disposable{constructor(s,i,r,u,S,k){super(),this.extensionsLocation=s,this.fileService=i,this.userDataProfilesService=r,this.uriIdentityService=u,this.telemetryService=S,this.logService=k,this._onAddExtensions=this._register(new O.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new O.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new O.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new O.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new C.ResourceMap}scanProfileExtensions(s,i){return this.withProfileExtensions(s,void 0,i)}async addExtensionsToProfile(s,i,r){const u=[],S=[];try{return await this.withProfileExtensions(i,k=>{const M=[];if(r)M.push(...k);else for(const L of k)s.some(([R])=>(0,l.areSameExtensions)(R.identifier,L.identifier)&&R.manifest.version!==L.version)?u.push(L):M.push(L);for(const[L,R]of s){const A=M.findIndex(_=>(0,l.areSameExtensions)(_.identifier,L.identifier)&&_.version===L.manifest.version),F={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:R};A===-1?(S.push(F),M.push(F)):M.splice(A,1,F)}return S.length&&this._onAddExtensions.fire({extensions:S,profileLocation:i}),u.length&&this._onRemoveExtensions.fire({extensions:u,profileLocation:i}),M}),S.length&&this._onDidAddExtensions.fire({extensions:S,profileLocation:i}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,profileLocation:i}),S}catch(k){throw S.length&&this._onDidAddExtensions.fire({extensions:S,error:k,profileLocation:i}),u.length&&this._onDidRemoveExtensions.fire({extensions:u,error:k,profileLocation:i}),k}}async updateMetadata(s,i){const r=[];return await this.withProfileExtensions(i,u=>{const S=[];for(const k of u){const M=s.find(([L])=>(0,l.areSameExtensions)(L.identifier,k.identifier)&&L.manifest.version===k.version);M&&(k.metadata={...k.metadata,...M[1]},r.push(k)),S.push(k)}return S}),r}async removeExtensionFromProfile(s,i){const r=[];try{await this.withProfileExtensions(i,u=>{const S=[];for(const k of u)(0,l.areSameExtensions)(k.identifier,s.identifier)?r.push(k):S.push(k);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:i}),S}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:i})}catch(u){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:u,profileLocation:i}),u}}async withProfileExtensions(s,i,r){return this.getResourceAccessQueue(s).queue(async()=>{let u=[],S;try{const k=await this.fileService.readFile(s);S=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,v.toFileOperationResult)(k)!==1)throw k;if(this.uriIdentityService.extUri.isEqual(s,this.userDataProfilesService.defaultProfile.extensionsResource)&&(S=await this.migrateFromOldDefaultProfileExtensionsLocation()),!S&&r?.bailOutWhenFileNotFound)throw new c((0,w.getErrorMessage)(k),"ERROR_PROFILE_NOT_FOUND")}if(S){Array.isArray(S)||this.reportAndThrowInvalidConentError(s);let k=!1;for(const M of S){a(M)||this.reportAndThrowInvalidConentError(s);let L;if((0,b.isString)(M.relativeLocation)&&M.relativeLocation)L=this.resolveExtensionLocation(M.relativeLocation);else if((0,b.isString)(M.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${M.location}`);continue}else{L=P.URI.revive(M.location);const R=this.toRelativePath(L);R&&(k=!0,M.relativeLocation=R)}(0,b.isUndefined)(M.metadata?.hasPreReleaseVersion)&&M.metadata?.preRelease&&(k=!0,M.metadata.hasPreReleaseVersion=!0),u.push({identifier:M.identifier,location:L,version:M.version,metadata:M.metadata})}k&&await this.fileService.writeFile(s,D.VSBuffer.fromString(JSON.stringify(S)))}if(i){u=i(u);const k=u.map(M=>({identifier:M.identifier,version:M.version,location:M.location.toJSON(),relativeLocation:this.toRelativePath(M.location),metadata:M.metadata}));await this.fileService.writeFile(s,D.VSBuffer.fromString(JSON.stringify(k)))}return u})}reportAndThrowInvalidConentError(s){const i=new c(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}toRelativePath(s){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(s),this.extensionsLocation)?this.uriIdentityService.extUri.basename(s):void 0}resolveExtensionLocation(s){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,s)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const s=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),i=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(s)).value.toString()}catch(S){if((0,v.toFileOperationResult)(S)===1)return;throw S}this.logService.info("Migrating extensions from old default profile location",s.toString());let u;try{const S=JSON.parse(r);Array.isArray(S)&&S.every(k=>a(k))?u=S:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",S)}catch(S){this.logService.error(S)}if(u)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(S){if((0,v.toFileOperationResult)(S)===3)this.logService.info("Migration from old default profile location to new location is done by another window",s.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw S}try{await this.fileService.del(s)}catch(S){(0,v.toFileOperationResult)(S)!==1&&this.logService.error(S)}try{await this.fileService.del(i)}catch(S){(0,v.toFileOperationResult)(S)!==1&&this.logService.error(S)}return u})()),this._migrationPromise}getResourceAccessQueue(s){let i=this.resourcesAccessQueueMap.get(s);return i||(i=new n.Queue,this.resourcesAccessQueueMap.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=f,e.AbstractExtensionsProfileScannerService=f=Pe([ne(1,v.IFileService),ne(2,g.IUserDataProfilesService),ne(3,m.IUriIdentityService),ne(4,p.ITelemetryService),ne(5,E.ILogService)],f);function a(o){return(0,b.isObject)(o)&&(0,h.isIExtensionIdentifier)(o.identifier)&&(t(o.location)||(0,b.isString)(o.location)&&o.location)&&((0,b.isUndefined)(o.relativeLocation)||(0,b.isString)(o.relativeLocation))&&o.version&&(0,b.isString)(o.version)}function t(o){return o?(0,b.isString)(o.path)&&(0,b.isString)(o.scheme):!1}}),define(oe[132],ae([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r,u,S,k,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=ce;var A;(function(ue){function X(Y,B){if(Y===B)return!0;const T=Object.keys(Y),x=new Set;for(const V of Object.keys(B))x.add(V);if(T.length!==x.size)return!1;for(const V of T){if(Y[V]!==B[V])return!1;x.delete(V)}return x.size===0}ue.equals=X})(A||(e.Translations=A={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let F=class extends l.Disposable{constructor(X,Y,B,T,x,V,U,le,he,K,W,N){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=Y,this.extensionsControlLocation=B,this.currentProfile=T,this.userDataProfilesService=x,this.extensionsProfileScannerService=V,this.fileService=U,this.logService=le,this.environmentService=he,this.productService=K,this.uriIdentityService=W,this.instantiationService=N,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(j,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(z,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(X,Y,B){const[T,x]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(Y)]),V=B?await this.scanExtensionsUnderDevelopment(X,[...T,...x]):[];return this.dedupExtensions(T,x,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const Y=[];Y.push(this.scanDefaultSystemExtensions(!!X.useCache,X.language)),Y.push(this.scanDevSystemExtensions(X.language,!!X.checkControlFile));const[B,T]=await Promise.all(Y);return this.applyScanOptions([...B,...T],0,X,!1)}async scanUserExtensions(X){const Y=X.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",Y);const B=this.uriIdentityService.extUri.isEqual(X.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.createExtensionScannerInput(Y,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,B,X.productVersion??this.getProductVersion()),x=X.useCache&&!T.devMode&&T.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let V;try{V=await x.scanExtensions(T)}catch(U){if(U instanceof k.ExtensionsProfileScanningError&&U.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),V=await x.scanExtensions(T);else throw U}return V=await this.applyScanOptions(V,1,X,!0),this.logService.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(X,Y){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(T=>T.scheme===v.Schemas.file).map(async T=>{const x=await this.createExtensionScannerInput(T,!1,1,!0,X.language,!1,void 0,X.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(x)).map(U=>(U.type=Y.find(le=>(0,f.areSameExtensions)(le.identifier,U.identifier))?.type??U.type,this.extensionsScanner.validate(U,x)))}))).flat();return this.applyScanOptions(B,"development",X,!0)}return[]}async scanExistingExtension(X,Y,B){const T=await this.createExtensionScannerInput(X,!1,Y,!0,B.language,!0,void 0,B.productVersion??this.getProductVersion()),x=await this.extensionsScanner.scanExtension(T);return!x||!B.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(X,Y,B){const T=await this.createExtensionScannerInput(X,!1,Y,!0,B.language,!0,void 0,B.productVersion??this.getProductVersion()),x=await this.extensionsScanner.scanOneOrMultipleExtensions(T);return this.applyScanOptions(x,Y,B,!0)}async scanMultipleExtensions(X,Y,B){const T=[];return await Promise.all(X.map(async x=>{const V=await this.scanOneOrMultipleExtensions(x,Y,B);T.push(...V)})),this.applyScanOptions(T,Y,B,!0)}async scanMetadata(X){const Y=(0,g.joinPath)(X,"package.json"),B=(await this.fileService.readFile(Y)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(X,Y){const B=(0,g.joinPath)(X,"package.json"),T=(await this.fileService.readFile(B)).value.toString(),x=JSON.parse(T);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,x.__metadata={...x.__metadata,...Y},await this.fileService.writeFile((0,g.joinPath)(X,"package.json"),O.VSBuffer.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof k.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw X}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.extensionsProfileScannerService.addExtensionsToProfile(X.map(Y=>[Y,Y.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(Y){(0,o.toFileOperationResult)(Y)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(Y))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.logService.error(X)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(X,Y,B,T){return B.includeAllVersions||(X=this.dedupExtensions(Y===0?X:void 0,Y===1?X:void 0,Y==="development"?X:void 0,await this.getTargetPlatform(),T)),B.includeInvalid||(X=X.filter(x=>x.isValid)),X.sort((x,V)=>{const U=y.basename(x.location.fsPath),le=y.basename(V.location.fsPath);return U<le?-1:U>le?1:0})}dedupExtensions(X,Y,B,T,x){const V=(le,he,K)=>{if(le.isValid&&!he.isValid)return!1;if(le.isValid===he.isValid){if(x&&m.gt(le.manifest.version,he.manifest.version))return this.logService.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${le.location.path} with version ${le.manifest.version}`),!1;if(m.eq(le.manifest.version,he.manifest.version)){if(le.type===0)return this.logService.debug(`Skipping extension ${he.location.path} in favour of system extension ${le.location.path} with same version`),!1;if(le.targetPlatform===T)return this.logService.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.logService.warn(`Overwriting user extension ${le.location.path} with ${he.location.path}.`):this.logService.debug(`Overwriting user extension ${le.location.path} with ${he.location.path}.`),!0},U=new a.ExtensionIdentifierMap;return X?.forEach(le=>{const he=U.get(le.identifier.id);(!he||V(he,le,!1))&&U.set(le.identifier.id,le)}),Y?.forEach(le=>{const he=U.get(le.identifier.id);if(!he&&X&&le.type===0){this.logService.debug(`Skipping obsolete system extension ${le.location.path}.`);return}(!he||V(he,le,!1))&&U.set(le.identifier.id,le)}),B?.forEach(le=>{const he=U.get(le.identifier.id);(!he||V(he,le,!0))&&U.set(le.identifier.id,le),U.set(le.identifier.id,le)}),[...U.values()]}async scanDefaultSystemExtensions(X,Y){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0,this.getProductVersion()),x=await(X&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",x.length),x}async scanDevSystemExtensions(X,Y){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const T=Y?await this.getBuiltInExtensionControl():{},x=[],V=p.URI.file(y.normalize(y.join(v.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const le of B){const he=T[le.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":x.push((0,g.joinPath)(V,le.name));break;default:x.push(p.URI.file(he));break}}const U=await Promise.all(x.map(async le=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(le,!1,0,!0,X,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",U.length),(0,n.coalesce)(U)}async getBuiltInExtensionControl(){try{const X=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(X.value.toString())}catch{return{}}}async createExtensionScannerInput(X,Y,B,T,x,V,U,le){const he=await this.getTranslations(x??E.language),K=await this.getMtime(X),W=Y&&!this.uriIdentityService.extUri.isEqual(X,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=W?await this.getMtime(W):void 0;return new _(X,K,W,N,Y,U,B,T,V,le.version,le.date,this.productService.commit,!this.environmentService.isBuilt,x,he)}async getMtime(X){try{const Y=await this.fileService.stat(X);if(typeof Y.mtime=="number")return Y.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=F,e.AbstractExtensionsScannerService=F=Pe([ne(4,M.IUserDataProfilesService),ne(5,k.IExtensionsProfileScannerService),ne(6,o.IFileService),ne(7,i.ILogService),ne(8,c.IEnvironmentService),ne(9,r.IProductService),ne(10,L.IUriIdentityService),ne(11,s.IInstantiationService)],F);class _{constructor(X,Y,B,T,x,V,U,le,he,K,W,N,Z,re,G){this.location=X,this.mtime=Y,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=T,this.profile=x,this.profileScanOptions=V,this.type=U,this.excludeObsolete=le,this.validate=he,this.productVersion=K,this.productDate=W,this.productCommit=N,this.devMode=Z,this.language=re,this.translations=G}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,Y){return(0,g.isEqual)(X.location,Y.location)&&X.mtime===Y.mtime&&(0,g.isEqual)(X.applicationExtensionslocation,Y.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&X.profile===Y.profile&&I.equals(X.profileScanOptions,Y.profileScanOptions)&&X.type===Y.type&&X.excludeObsolete===Y.excludeObsolete&&X.validate===Y.validate&&X.productVersion===Y.productVersion&&X.productDate===Y.productDate&&X.productCommit===Y.productCommit&&X.devMode===Y.devMode&&X.language===Y.language&&A.equals(X.translations,Y.translations)}}e.ExtensionScannerInput=_;let z=class extends l.Disposable{constructor(X,Y,B,T,x){super(),this.obsoleteFile=X,this.extensionsProfileScannerService=Y,this.uriIdentityService=B,this.fileService=T,this.logService=x}async scanExtensions(X){const Y=X.profile?await this.scanExtensionsFromProfile(X):await this.scanExtensionsFromLocation(X);let B={};if(X.excludeObsolete&&X.type===1)try{const T=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(T)}catch{}return(0,w.isEmptyObject)(B)?Y:Y.filter(T=>!B[f.ExtensionKey.create(T).toString()])}async scanExtensionsFromLocation(X){const Y=await this.fileService.resolve(X.location);if(!Y.children?.length)return[];const B=await Promise.all(Y.children.map(async T=>{if(!T.isDirectory||X.type===1&&(0,g.basename)(T.resource).indexOf(".")===0)return null;const x=new _(T.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(x)}));return(0,n.coalesce)(B).sort((T,x)=>T.location.path<x.location.path?-1:1)}async scanExtensionsFromProfile(X){let Y=await this.scanExtensionsFromProfileResource(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(X.location,X.applicationExtensionslocation)){Y=Y.filter(T=>!T.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(X.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,X);Y.push(...B)}return Y}async scanExtensionsFromProfileResource(X,Y,B){const T=await this.extensionsProfileScannerService.scanProfileExtensions(X,B.profileScanOptions);if(!T.length)return[];const x=await Promise.all(T.map(async V=>{if(Y(V)){const U=new _(V.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(U,V.metadata)}return null}));return(0,n.coalesce)(x)}async scanOneOrMultipleExtensions(X){try{if(await this.fileService.exists((0,g.joinPath)(X.location,"package.json"))){const Y=await this.scanExtension(X);return Y?[Y]:[]}else return await this.scanExtensions(X)}catch(Y){return this.logService.error(`Error scanning extensions at ${X.location.path}:`,(0,C.getErrorMessage)(Y)),[]}}async scanExtension(X,Y){try{let B=await this.scanExtensionManifest(X.location);if(B){B.publisher||(B.publisher=a.UNDEFINED_PUBLISHER),Y=Y??B.__metadata,delete B.__metadata;const T=(0,f.getGalleryExtensionId)(B.publisher,B.name),x=Y?.id?{id:T,uuid:Y.id}:{id:T},V=Y?.isSystem?0:X.type,U=V===0||!!Y?.isBuiltin;B=await this.translateManifest(X.location,B,_.createNlsConfiguration(X));const le={type:V,identifier:x,manifest:B,location:X.location,isBuiltin:U,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return X.validate?this.validate(le,X):le}}catch(B){X.type!==0&&this.logService.error(B)}return null}validate(X,Y){let B=!0;const T=(0,t.validateExtensionManifest)(Y.productVersion,Y.productDate,Y.location,X.manifest,X.isBuiltin);for(const[x,V]of T)x===b.default.Error&&(B=!1,this.logService.error(this.formatMessage(Y.location,V)));return X.isValid=B,X.validations=T,X}async scanExtensionManifest(X){const Y=(0,g.joinPath)(X,"package.json");let B;try{B=(await this.fileService.readFile(Y)).value.toString()}catch(x){return(0,o.toFileOperationResult)(x)!==1&&this.logService.error(this.formatMessage(X,(0,d.localize)(0,null,Y.path,x.message))),null}let T;try{T=JSON.parse(B)}catch{const V=[];(0,P.parse)(B,V);for(const U of V)this.logService.error(this.formatMessage(X,(0,d.localize)(1,null,Y.path,U.offset,U.length,(0,h.getParseErrorMessage)(U.error))));return null}return(0,P.getNodeType)(T)!=="object"?(this.logService.error(this.formatMessage(X,(0,d.localize)(2,null,Y.path))),null):T}async translateManifest(X,Y,B){const T=await this.getLocalizedMessages(X,Y,B);if(T)try{const x=[],V=await this.resolveOriginalMessageBundle(T.default,x);if(x.length>0)return x.forEach(le=>{this.logService.error(this.formatMessage(X,(0,d.localize)(3,null,T.default?.path,(0,h.getParseErrorMessage)(le.error))))}),Y;if((0,P.getNodeType)(T)!=="object")return this.logService.error(this.formatMessage(X,(0,d.localize)(4,null,T.default?.path))),Y;const U=T.values||Object.create(null);return(0,R.localizeManifest)(this.logService,Y,U,V)}catch{}return Y}async getLocalizedMessages(X,Y,B){const T=(0,g.joinPath)(X,"package.nls.json"),x=(he,K)=>{K.forEach(W=>{this.logService.error(this.formatMessage(X,(0,d.localize)(5,null,he?.path,(0,h.getParseErrorMessage)(W.error))))})},V=he=>{this.logService.error(this.formatMessage(X,(0,d.localize)(6,null,he?.path)))},U=`${Y.publisher}.${Y.name}`,le=B.translations[U];if(le)try{const he=p.URI.file(le),K=(await this.fileService.readFile(he)).value.toString(),W=[],N=(0,P.parse)(K,W);return W.length>0?(x(he,W),{values:void 0,default:T}):(0,P.getNodeType)(N)!=="object"?(V(he),{values:void 0,default:T}):{values:N.contents?N.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.fileService.exists(T))return;let K;try{K=await this.findMessageBundles(X,B)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const W=(await this.fileService.readFile(K.localized)).value.toString(),N=[],Z=(0,P.parse)(W,N);return N.length>0?(x(K.localized,N),{values:void 0,default:K.original}):(0,P.getNodeType)(Z)!=="object"?(V(K.localized),{values:void 0,default:K.original}):{values:Z,default:K.original}}catch{return{values:void 0,default:K.original}}}}async resolveOriginalMessageBundle(X,Y){if(X)try{const B=(await this.fileService.readFile(X)).value.toString();return(0,P.parse)(B,Y)}catch{}}findMessageBundles(X,Y){return new Promise((B,T)=>{const x=V=>{const U=(0,g.joinPath)(X,`package.nls.${V}.json`);this.fileService.exists(U).then(le=>{le&&B({localized:U,original:(0,g.joinPath)(X,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?B({localized:(0,g.joinPath)(X,"package.nls.json"),original:null}):(V=V.substring(0,he),x(V))})};if(Y.devMode||Y.pseudo||!Y.language)return B({localized:(0,g.joinPath)(X,"package.nls.json"),original:null});x(Y.language)})}formatMessage(X,Y){return`[${X.path}]: ${Y}`}};z=Pe([ne(1,k.IExtensionsProfileScannerService),ne(2,L.IUriIdentityService),ne(3,o.IFileService),ne(4,i.ILogService)],z);let j=class extends z{constructor(X,Y,B,T,x,V,U){super(Y,T,x,V,U),this.currentProfile=X,this.userDataProfilesService=B,this.cacheValidatorThrottler=this._register(new D.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(X){const Y=this.getCacheFile(X),B=await this.readExtensionCache(Y);if(this.input=X,B&&B.input&&_.equals(B.input,this.input))return this.logService.debug("Using cached extensions scan result",X.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(x=>(x.location=p.URI.revive(x.location),x));const T=await super.scanExtensions(X);return await this.writeExtensionCache(Y,{input:X,result:T}),T}async readExtensionCache(X){try{const Y=await this.fileService.readFile(X),B=JSON.parse(Y.value.toString());return{result:B.result,input:(0,S.revive)(B.input)}}catch(Y){this.logService.debug("Error while reading the extension cache file:",X.path,(0,C.getErrorMessage)(Y))}return null}async writeExtensionCache(X,Y){try{await this.fileService.writeFile(X,O.VSBuffer.fromString(JSON.stringify(Y)))}catch(B){this.logService.debug("Error while writing the extension cache file:",X.path,(0,C.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const X=this.getCacheFile(this.input),Y=await this.readExtensionCache(X);if(!Y)return;const B=Y.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!I.equals(T,B))try{this.logService.info("Invalidating Cache",B,T),await this.fileService.del(X),this._onDidChangeCache.fire()}catch(x){this.logService.error(x)}}getCacheFile(X){const Y=this.getProfile(X);return this.uriIdentityService.extUri.joinPath(Y.cacheHome,X.type===0?a.BUILTIN_MANIFEST_CACHE_FILE:a.USER_MANIFEST_CACHE_FILE)}getProfile(X){return X.type===0?this.userDataProfilesService.defaultProfile:X.profile?this.uriIdentityService.extUri.isEqual(X.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(Y=>this.uriIdentityService.extUri.isEqual(X.location,Y.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};j=Pe([ne(2,M.IUserDataProfilesService),ne(3,k.IExtensionsProfileScannerService),ne(4,L.IUriIdentityService),ne(5,o.IFileService),ne(6,i.ILogService)],j);function ce(ue,X){const Y=(0,f.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new a.ExtensionIdentifier(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:X,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}class te extends F{constructor(X,Y,B,T,x,V,U,le,he,K,W,N){super(X,Y,(0,g.joinPath)(B,".vscode-oss-dev","extensions","control.json"),T,x,V,U,le,he,K,W,N),this.translationsPromise=(async()=>{if(E.translationsConfigFile)try{const Z=await this.fileService.readFile(p.URI.file(E.translationsConfigFile));return JSON.parse(Z.value.toString())}catch{}return Object.create(null)})()}getTranslations(X){return this.translationsPromise}}e.NativeExtensionsScannerService=te}),define(oe[280],ae([0,1,5,41,40,28,83,16,38,7]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let v=class extends C.AbstractExtensionsProfileScannerService{constructor(E,g,m,b,w,p){super(l.URI.file(E.extensionsPath),g,m,b,w,p)}};e.ExtensionsProfileScannerService=v,e.ExtensionsProfileScannerService=v=Pe([ne(0,h.INativeEnvironmentService),ne(1,P.IFileService),ne(2,D.IUserDataProfilesService),ne(3,I.IUriIdentityService),ne(4,O.ITelemetryService),ne(5,n.ILogService)],v)}),define(oe[281],ae([0,1,7,38,83,132,16,6,5,27,40,41]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends O.NativeExtensionsScannerService{constructor(m,b,w,p,d,c,f,a){super(n.URI.file(d.builtinExtensionsPath),n.URI.file(d.extensionsPath),d.userHome,m.defaultProfile,m,b,w,p,d,c,f,a)}};e.ExtensionsScannerService=E,e.ExtensionsScannerService=E=Pe([ne(0,y.IUserDataProfilesService),ne(1,I.IExtensionsProfileScannerService),ne(2,C.IFileService),ne(3,h.ILogService),ne(4,D.INativeEnvironmentService),ne(5,l.IProductService),ne(6,v.IUriIdentityService),ne(7,P.IInstantiationService)],E)}),define(oe[282],ae([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends D.Disposable{constructor(w,p,d){super(),this.environmentService=w,this.logService=d,this.validRoots=P.TernarySearchTree.forPaths(!C.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.with({scheme:I.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(I.Schemas.vscodeFileResource,(p,d)=>this.handleResourceRequest(p,d)),w.protocol.interceptFileProtocol(I.Schemas.file,(p,d)=>this.handleFileRequest(p,d)),this._register((0,D.toDisposable)(()=>{w.protocol.unregisterProtocol(I.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(I.Schemas.file)}))}addValidFileRoot(w){const p=(0,O.normalize)(w);return this.validRoots.get(p)?D.Disposable.None:(this.validRoots.set(p,!0),(0,D.toDisposable)(()=>this.validRoots.delete(p)))}handleFileRequest(w,p){const d=h.URI.parse(w.url);return this.logService.error(`Refused to load resource ${d.fsPath} from ${I.Schemas.file}: protocol (original URL: ${w.url})`),p({error:-3})}handleResourceRequest(w,p){const d=this.requestToNormalizedFilePath(w);let c;return this.environmentService.crossOriginIsolated&&((0,O.basename)(d)==="workbench.html"||(0,O.basename)(d)==="workbench-dev.html"?c=I.COI.CoopAndCoep:c=I.COI.getHeadersFromQuery(w.url)),this.validRoots.findSubstr(d)?p({path:d,headers:c}):this.validExtensions.has((0,O.extname)(d).toLowerCase())?p({path:d}):(this.logService.error(`${I.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${I.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),p({error:-3}))}requestToNormalizedFilePath(w){const p=h.URI.parse(w.url),d=I.FileAccess.uriToFileUri(p);return(0,O.normalize)(d.fsPath)}createIPCObjectUrl(){let w;const p=h.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),d=p.toString(),c=async()=>w;return v.validatedIpcMain.handle(d,c),this.logService.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:p,update:f=>w=f,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${d}.`),v.validatedIpcMain.removeHandler(d)}}}};e.ProtocolMainService=m,e.ProtocolMainService=m=Pe([ne(0,y.INativeEnvironmentService),ne(1,g.IUserDataProfilesService),ne(2,E.ILogService)],m)}),define(oe[97],ae([0,1,8,3,2,66,12,115,6,41]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=g,e.isProfileUsingDefaultStorage=b,e.logStorage=p,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var v;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(v||(e.WillSaveStateReason=v={}));var y;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var E;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(E||(e.StorageTarget=E={}));function g(d){const c=d.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}class m extends I.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(c={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new D.PauseableEmitter),this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(c,f,a){return D.Event.filter(this._onDidChangeValue.event,t=>t.scope===c&&(f===void 0||t.key===f),a)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,f){const{key:a,external:t}=f;if(a===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:a,target:this.getKeyTargets(c)[a],external:t})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,f,a){return this.getStorage(f)?.get(c,a)}getBoolean(c,f,a){return this.getStorage(f)?.getBoolean(c,a)}getNumber(c,f,a){return this.getStorage(f)?.getNumber(c,a)}getObject(c,f,a){return this.getStorage(f)?.getObject(c,a)}storeAll(c,f){this.withPausedEmitters(()=>{for(const a of c)this.store(a.key,a.value,a.scope,a.target,f)})}store(c,f,a,t,o=!1){if((0,C.isUndefinedOrNull)(f)){this.remove(c,a,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,a,t),this.getStorage(a)?.set(c,f,o)})}remove(c,f,a=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(c,f,void 0),this.getStorage(f)?.delete(c,a)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,f){const a=[],t=this.getKeyTargets(c);for(const o of Object.keys(t))t[o]===f&&a.push(o);return a}updateKeyTarget(c,f,a,t=!1){const o=this.getKeyTargets(f);typeof a=="number"?o[c]!==a&&(o[c]=a,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(o),t)):typeof o[c]=="number"&&(delete o[c],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(o),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const f=this.getStorage(c);return f?g(f):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=v.NONE){this._onWillSaveState.fire({reason:c});const f=this.getStorage(-1),a=this.getStorage(0),t=this.getStorage(1);switch(c){case v.NONE:await n.Promises.settled([f?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await n.Promises.settled([f?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,a=this.getStorage(1)?.items??new Map;return p(c,f,a,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(c){return await this.flush(),this.getStorage(c)?.optimize()}async switch(c,f){return this.emitWillSaveState(v.NONE),(0,l.isUserDataProfile)(c)?this.switchToProfile(c,f):this.switchToWorkspace(c,f)}canSwitchProfile(c,f){return!(c.id===f.id||b(f)&&b(c))}switchData(c,f,a){this.withPausedEmitters(()=>{const t=new Set;for(const[o,s]of c)t.add(o),f.get(o)!==s&&this.emitDidChangeValue(a,{key:o,external:!0});for(const[o]of f.items)t.has(o)||this.emitDidChangeValue(a,{key:o,external:!0})})}}e.AbstractStorageService=m;function b(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class w extends m{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(c){return!1}}e.InMemoryStorageService=w;async function p(d,c,f,a,t,o){const s=A=>{try{return JSON.parse(A)}catch{return A}},i=new Map,r=new Map;d.forEach((A,F)=>{i.set(F,A),r.set(F,s(A))});const u=new Map,S=new Map;c.forEach((A,F)=>{u.set(F,A),S.set(F,s(A))});const k=new Map,M=new Map;f.forEach((A,F)=>{k.set(F,A),M.set(F,s(A))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const L=[];if(i.forEach((A,F)=>{L.push({key:F,value:A})}),console.table(L),console.groupEnd(),console.log(r),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];u.forEach((F,_)=>{A.push({key:_,value:F})}),console.table(A),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${o})`);const R=[];k.forEach((A,F)=>{R.push({key:F,value:A})}),console.table(R),console.groupEnd(),console.log(M)}}),define(oe[283],ae([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class p extends O.Disposable{static{this.LOG_SLOW_CLOSE_THRESHOLD=2e3}get storage(){return this._storage}constructor(s,i){super(),this.logService=s,this.fileService=i,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new I.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=this._register(new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.initializePromise=void 0,this.whenInitPromise=new D.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=v.StorageState.None}isInMemory(){return this._storage.isInMemory()}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===v.StorageState.None)try{const s=this._register(await this.doCreate());this._storage.dispose(),this._storage=s,this._register(s.onDidChangeStorage(r=>this._onDidChangeStorage.fire(r))),await this.doInit(s);const i=s.getBoolean(g.IS_NEW_KEY);i===void 0?s.set(g.IS_NEW_KEY,!0):i&&s.set(g.IS_NEW_KEY,!1)}catch(s){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.state=v.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===E.LogLevel.Trace?s=>this.logService.trace(s):void 0,logError:s=>this.logService.error(s)}}doInit(s){return s.init()}get items(){return this._storage.items}get(s,i){return this._storage.get(s,i)}set(s,i){return this._storage.set(s,i)}delete(s){return this._storage.delete(s)}optimize(){return this._storage.optimize()}async close(){const s=new P.StopWatch(!1);await this.doClose(),s.stop(),s.elapsed()>p.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(s),this._onDidCloseStorage.fire()}async logSlowClose(s){if(this.path)try{const i=(0,n.top)(Array.from(this._storage.items.entries()).map(([u,S])=>({key:u,length:S.length})),(u,S)=>S.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),r=(await this.fileService.stat(h.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=v.StorageState.Closed,await this._storage.close()}}class d extends p{static{this.STORAGE_NAME="state.vscdb"}get path(){if(!this.options.useInMemoryStorage)return(0,C.join)(this.profile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,d.STORAGE_NAME)}constructor(s,i,r,u){super(r,u),this.profile=s,this.options=i}async doCreate(){return new v.Storage(new y.SQLiteStorageDatabase(this.path??y.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}),this.path?void 0:{hint:v.StorageHint.STORAGE_IN_MEMORY})}}class c extends d{constructor(s,i,r,u){super(s,i,r,u)}}e.ProfileStorageMain=c;class f extends d{constructor(s,i,r,u){super(i.defaultProfile,s,r,u)}async doInit(s){await super.doInit(s),this.updateTelemetryState(s)}updateTelemetryState(s){s.get(m.firstSessionDateStorageKey,void 0)===void 0&&s.set(m.firstSessionDateStorageKey,new Date().toUTCString());const r=s.get(m.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();s.set(m.lastSessionDateStorageKey,typeof r>"u"?null:r),s.set(m.currentSessionDateStorageKey,u)}}e.ApplicationStorageMain=f;class a extends p{static{this.WORKSPACE_STORAGE_NAME="state.vscdb"}static{this.WORKSPACE_META_NAME="workspace.json"}get path(){if(!this.options.useInMemoryStorage)return(0,C.join)(this.environmentService.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.workspace.id,a.WORKSPACE_STORAGE_NAME)}constructor(s,i,r,u,S){super(r,S),this.workspace=s,this.options=i,this.environmentService=u}async doCreate(){const{storageFilePath:s,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new v.Storage(new y.SQLiteStorageDatabase(s,{logging:this.createLoggingOptions()}),{hint:this.options.useInMemoryStorage?v.StorageHint.STORAGE_IN_MEMORY:i?v.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:y.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,C.join)(this.environmentService.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.workspace.id),i=(0,C.join)(s,a.WORKSPACE_STORAGE_NAME);return await l.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(s,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(s),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(s){let i;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const r=(0,C.join)(s,a.WORKSPACE_META_NAME);await l.Promises.exists(r)||await l.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=a;class t extends p{get path(){}async doCreate(){return new v.Storage(new v.InMemoryStorageDatabase,{hint:v.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=t}),define(oe[284],ae([0,1,3,2,97]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class O extends D.Disposable{constructor(P,h,l){super(),this.storageMainService=P,this.userDataProfilesService=h,this.logService=l;const v=this._register(new D.MutableDisposable);this._onDidChange=this._register(new n.Emitter({onWillAddFirstListener:()=>v.value=this.registerStorageChangeListeners(),onDidRemoveLastListener:()=>v.value=void 0}))}registerStorageChangeListeners(){this.logService.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new D.DisposableStore;return P.add(n.Event.debounce(this.storageMainService.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.onDidChangeApplicationStorage(h))),P.add(n.Event.debounce(this.storageMainService.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let v=h.get(l.profile.id);return v||h.set(l.profile.id,v={profile:l.profile,keys:[],storage:l.storage}),v.keys.push(l.key),h},100)(h=>this.onDidChangeProfileStorage(h))),P}onDidChangeApplicationStorage(P){const h=P.includes(I.TARGET_KEY)?[this.userDataProfilesService.defaultProfile]:[],l=[];if(P=P.filter(v=>v!==I.TARGET_KEY),P.length){const v=(0,I.loadKeyTargets)(this.storageMainService.applicationStorage.storage);l.push({profile:this.userDataProfilesService.defaultProfile,changes:P.map(y=>({key:y,scope:0,target:v[y]}))})}this.triggerEvents(h,l)}onDidChangeProfileStorage(P){const h=[],l=new Map;for(const[v,y]of P.entries()){y.keys.includes(I.TARGET_KEY)&&h.push(y.profile);const E=y.keys.filter(g=>g!==I.TARGET_KEY);if(E.length){const g=(0,I.loadKeyTargets)(y.storage.storage);l.set(v,{profile:y.profile,changes:E.map(m=>({key:m,scope:0,target:g[m]}))})}}this.triggerEvents(h,[...l.values()])}triggerEvents(P,h){(P.length||h.length)&&this._onDidChange.fire({valueChanges:h,targetChanges:P})}listen(P,h,l){switch(h){case"onDidChange":return this._onDidChange.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(P,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=O}),define(oe[285],ae([0,1,7,38,16,5,34,40,41,12,125]),function(Q,e,n,D,I,O,C,P,h,l,v){"use strict";var y,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let g=class extends h.UserDataProfilesService{static{y=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(p,d,c,f,a){super(c,f,d,a),this.stateReadonlyService=p,this.nativeEnvironmentService=c}getStoredProfiles(){return this.stateReadonlyService.getItem(y.PROFILES_KEY,[]).map(d=>({...d,location:(0,l.isString)(d.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,d.location):n.URI.revive(d.location)}))}getStoredProfileAssociations(){const p=this.stateReadonlyService.getItem(y.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(y.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?p:this.migrateStoredProfileAssociations(p)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(n.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=g,e.UserDataProfilesReadonlyService=g=y=Pe([ne(0,C.IStateReadService),ne(1,P.IUriIdentityService),ne(2,D.INativeEnvironmentService),ne(3,I.IFileService),ne(4,O.ILogService)],g);let m=E=class extends g{constructor(p,d,c,f,a){super(p,d,c,f,a),this.stateService=p}saveStoredProfiles(p){p.length?this.stateService.setItem(E.PROFILES_KEY,p.map(d=>({...d,location:this.uriIdentityService.extUri.basename(d.location)}))):this.stateService.removeItem(E.PROFILES_KEY)}getStoredProfiles(){const p=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(p),this.stateService.setItem("userDataProfilesMigration",!0)),p}saveStoredProfileAssociations(p){p.emptyWindows||p.workspaces?this.stateService.setItem(E.PROFILE_ASSOCIATIONS_KEY,p):this.stateService.removeItem(E.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const p="workspaceAndProfileInfo",d=this.stateService.getItem(p,void 0);if(d){this.stateService.removeItem(p);const f=d.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.stateService.setItem(E.PROFILE_ASSOCIATIONS_KEY,{workspaces:f})}const c=super.getStoredProfileAssociations();return this.stateService.getItem(E.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(c),this.stateService.setItem(E.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),c}};e.UserDataProfilesService=m,e.UserDataProfilesService=m=E=Pe([ne(0,C.IStateService),ne(1,P.IUriIdentityService),ne(2,D.INativeEnvironmentService),ne(3,I.IFileService),ne(4,O.ILogService)],m);let b=class extends m{constructor(p,d,c,f){super(new v.StateService(0,d,f,c),p,d,c,f)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=b,e.ServerUserDataProfilesService=b=Pe([ne(0,P.IUriIdentityService),ne(1,D.INativeEnvironmentService),ne(2,I.IFileService),ne(3,O.ILogService)],b)}),define(oe[57],ae([0,1,38,16,6,5,40,41,285,34]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,I.refineServiceDecorator)(P.IUserDataProfilesService);let v=class extends h.UserDataProfilesService{constructor(E,g,m,b,w){super(E,g,m,b,w)}getAssociatedEmptyWindows(){const E=[];for(const g of this.profilesObject.emptyWindows.keys())E.push({id:g});return E}};e.UserDataProfilesMainService=v,e.UserDataProfilesMainService=v=Pe([ne(0,l.IStateService),ne(1,C.IUriIdentityService),ne(2,n.INativeEnvironmentService),ne(3,D.IFileService),ne(4,O.ILogService)],v)}),define(oe[133],ae([0,1,19,7,30]),function(Q,e,n,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnFile=O,e.findWindowOnWorkspaceOrFolder=C,e.findWindowOnExtensionDevelopmentPath=P;async function O(h,l,v){for(const E of h){const g=E.openedWorkspace;if((0,I.isWorkspaceIdentifier)(g)){const m=await v(g);if(m){if(m.folders.some(b=>n.extUriBiasedIgnorePathCase.isEqualOrParent(l,b.uri)))return E}else if(n.extUriBiasedIgnorePathCase.isEqualOrParent(l,g.configPath))return E}}const y=h.filter(E=>(0,I.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqualOrParent(l,E.openedWorkspace.uri));if(y.length)return y.sort((E,g)=>-(E.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}function C(h,l){for(const v of h)if((0,I.isWorkspaceIdentifier)(v.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.configPath,l)||(0,I.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&n.extUriBiasedIgnorePathCase.isEqual(v.openedWorkspace.uri,l))return v}function P(h,l){const v=y=>l.some(E=>n.extUriBiasedIgnorePathCase.isEqual(D.URI.file(E),D.URI.file(y)));for(const y of h)if(y.config?.extensionDevelopmentPath?.some(E=>v(E)))return y}}),define(oe[98],ae([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkspacesService=void 0,e.isRecentWorkspace=m,e.isRecentFolder=b,e.isRecentFile=w,e.isStoredWorkspaceFolder=p,e.getStoredWorkspaceFolder=f,e.toWorkspaceFolders=t,e.rewriteWorkspaceFileForNewLocation=o,e.restoreRecentlyOpened=S,e.toStoreData=k,e.IWorkspacesService=(0,y.createDecorator)("workspacesService");function m(M){return M.hasOwnProperty("workspace")}function b(M){return M.hasOwnProperty("folderUri")}function w(M){return M.hasOwnProperty("fileUri")}function p(M){return d(M)||c(M)}function d(M){const L=M;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function c(M){const L=M;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function f(M,L,R,A,F){if(M.scheme!==A.scheme)return{name:R,uri:M.toString(!0)};let _=L?void 0:F.relativePath(A,M);if(_!==void 0)_.length===0?_=".":h.isWindows&&(_=a(_));else if(M.scheme===C.Schemas.file)_=M.fsPath,h.isWindows&&(_=a(_));else if(F.isEqualAuthority(M.authority,A.authority))_=M.path;else return{name:R,uri:M.toString(!0)};return{name:R,path:_}}function a(M){return M=(0,O.normalizeDriveLetter)(M),(0,n.isUNC)(M)||(M=(0,n.toSlashes)(M)),M}function t(M,L,R){const A=[],F=new Set,_=R.dirname(L);for(const z of M){let j;if(d(z))z.path&&(j=R.resolvePath(_,z.path));else if(c(z))try{j=v.URI.parse(z.uri),j.path[0]!==P.posix.sep&&(j=j.with({path:P.posix.sep+j.path}))}catch(ce){console.warn(ce)}if(j){const ce=R.getComparisonKey(j);if(!F.has(ce)){F.add(ce);const te=z.name||R.basenameOrAuthority(j);A.push(new g.WorkspaceFolder({uri:j,name:te,index:A.length},z))}}}return A}function o(M,L,R,A,F){const _=s(L,M),z=F.dirname(L),j=F.dirname(A),ce=[];for(const Y of _.folders){const B=d(Y)?F.resolvePath(z,Y.path):v.URI.parse(Y.uri);let T;R?T=!1:T=!d(Y)||(0,P.isAbsolute)(Y.path),ce.push(f(B,T,Y.name,j,F))}const te={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},ue=I.setProperty(M,["folders"],ce,te);let X=I.applyEdits(M,ue);return(0,l.isEqualAuthority)(_.remoteAuthority,(0,E.getRemoteAuthority)(A))&&(X=I.applyEdits(X,I.removeProperty(X,["remoteAuthority"],te))),X}function s(M,L){const R=D.parse(L);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(A=>p(A));else throw new Error(`${M} looks like an invalid workspace file.`);return R}function i(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function r(M){return typeof M.folderUri=="string"}function u(M){return typeof M.fileUri=="string"}function S(M,L){const R={workspaces:[],files:[]};if(M){const A=function(_,z){for(let j=0;j<_.length;j++)try{z(_[j],j)}catch(ce){L.warn(`Error restoring recent entry ${JSON.stringify(_[j])}: ${ce.toString()}. Skip entry.`)}},F=M;Array.isArray(F.entries)&&A(F.entries,_=>{const z=_.label,j=_.remoteAuthority;i(_)?R.workspaces.push({label:z,remoteAuthority:j,workspace:{id:_.workspace.id,configPath:v.URI.parse(_.workspace.configPath)}}):r(_)?R.workspaces.push({label:z,remoteAuthority:j,folderUri:v.URI.parse(_.folderUri)}):u(_)&&R.files.push({label:z,remoteAuthority:j,fileUri:v.URI.parse(_.fileUri)})})}return R}function k(M){const L={entries:[]};for(const R of M.workspaces)b(R)?L.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):L.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of M.files)L.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return L}}),define(oe[99],ae([0,1,87,13,4,19]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=C,e.getSingleFolderWorkspaceIdentifier=P,e.createEmptyWorkspaceIdentifier=h,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(l){function v(){let y=l.scheme===D.Schemas.file?(0,O.originalFSPath)(l):l.toString();return I.isLinux||(y=y.toLowerCase()),(0,n.createHash)("md5").update(y).digest("hex")}return{id:v(),configPath:l}}function P(l,v){function y(){if(l.scheme!==D.Schemas.file)return(0,n.createHash)("md5").update(l.toString()).digest("hex");if(!v)return;let g;return I.isLinux?g=v.ino:I.isMacintosh?g=v.birthtime.getTime():I.isWindows&&(typeof v.birthtimeMs=="number"?g=Math.floor(v.birthtimeMs):g=v.birthtime.getTime()),(0,n.createHash)("md5").update(l.fsPath).update(g?String(g):"").digest("hex")}const E=y();if(typeof E=="string")return{id:E,uri:l}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[100],ae([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=s,e.createStaticIPCHandle=i,e.serve=S,e.connect=k;class b{traceSocketEvent(L,R){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,L,R)}constructor(L,R=""){this._canWrite=!0,this.debugLabel=R,this.socket=L,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,P.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener),this._closeListener=A=>{this.traceSocketEvent("close",{hadError:A}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(L){const R=A=>{this.traceSocketEvent("read",A),L(C.VSBuffer.wrap(A))};return this.socket.on("data",R),{dispose:()=>this.socket.off("data",R)}}onClose(L){const R=A=>{L({type:0,hadError:A,error:void 0})};return this.socket.on("close",R),{dispose:()=>this.socket.off("close",R)}}onEnd(L){const R=()=>{L()};return this.socket.on("end",R),{dispose:()=>this.socket.off("end",R)}}write(L){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",L),this.socket.write(L.buffer,R=>{if(R){if(R.code==="EPIPE")return;(0,P.onUnexpectedError)(R)}})}catch(R){if(R.code==="EPIPE")return;(0,P.onUnexpectedError)(R)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((L,R)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),L();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),L()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=b;var w;(function(M){M[M.MinHeaderByteSize=2]="MinHeaderByteSize",M[M.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var p;(function(M){M[M.PeekHeader=1]="PeekHeader",M[M.ReadHeader=2]="ReadHeader",M[M.ReadBody=3]="ReadBody",M[M.Fin=4]="Fin"})(p||(p={}));class d extends l.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(L,R){this.socket.traceSocketEvent(L,R)}constructor(L,R,A,F){super(),this._onData=this._register(new h.Emitter),this._onClose=this._register(new h.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=L,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:R,inflateBytesLength:A?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new c(this,R,A,F,this._onData,(_,z)=>this._write(_,z))),this._register(this._flowManager.onError(_=>{console.error(_),(0,P.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})})),this._incomingData=new m.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(async _=>{this._flowManager.isProcessingReadQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(_)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(L){return this._onData.event(L)}onClose(L){return this._onClose.event(L)}onEnd(L){return this.socket.onEnd(L)}write(L){let R=0;for(;R<L.byteLength;)this._flowManager.writeMessage(L.slice(R,Math.min(R+262144,L.byteLength)),{compressed:!0,opcode:2}),R+=262144}_write(L,{compressed:R,opcode:A}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",L);let F=2;L.byteLength<126?F+=0:L.byteLength<2**16?F+=2:F+=8;const _=C.VSBuffer.alloc(F),z=R?64:0,j=A&15;if(_.writeUInt8(128|z|j,0),L.byteLength<126)_.writeUInt8(L.byteLength,1);else if(L.byteLength<2**16){_.writeUInt8(126,1);let ce=1;_.writeUInt8(L.byteLength>>>8&255,++ce),_.writeUInt8(L.byteLength>>>0&255,++ce)}else{_.writeUInt8(127,1);let ce=1;_.writeUInt8(0,++ce),_.writeUInt8(0,++ce),_.writeUInt8(0,++ce),_.writeUInt8(0,++ce),_.writeUInt8(L.byteLength>>>24&255,++ce),_.writeUInt8(L.byteLength>>>16&255,++ce),_.writeUInt8(L.byteLength>>>8&255,++ce),_.writeUInt8(L.byteLength>>>0&255,++ce)}this.socket.write(C.VSBuffer.concat([_,L]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(L){if(L.byteLength!==0){for(this._incomingData.acceptChunk(L);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const R=this._incomingData.peek(this._state.readLen),A=R.readUInt8(0),F=(A&128)>>>7,_=(A&64)>>>6,z=A&15,j=R.readUInt8(1),ce=(j&128)>>>7,te=j&127;this._state.state=2,this._state.readLen=2+(ce?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=!!_),this._state.firstFrameOfMessage=!!F,this._state.mask=0,this._state.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const R=this._incomingData.read(this._state.readLen),A=R.readUInt8(1),F=(A&128)>>>7;let _=A&127,z=1;_===126?_=R.readUInt8(++z)*2**8+R.readUInt8(++z):_===127&&(_=R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*0+R.readUInt8(++z)*2**24+R.readUInt8(++z)*2**16+R.readUInt8(++z)*2**8+R.readUInt8(++z));let j=0;F&&(j=R.readUInt8(++z)*2**24+R.readUInt8(++z)*2**16+R.readUInt8(++z)*2**8+R.readUInt8(++z)),this._state.state=3,this._state.readLen=_,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const R=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",R),t(R,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",R),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(R,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(R,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await h.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class c extends l.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}constructor(L,R,A,F,_,z){super(),this._tracer=L,this._onData=_,this._writeFn=z,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new h.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new h.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,R?(this._zlibInflateStream=this._register(new f(this._tracer,F,A,{windowBits:15})),this._zlibDeflateStream=this._register(new a(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(L,R){this._writeQueue.push({data:L,options:R}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:L,options:R}=this._writeQueue.shift();if(this._zlibDeflateStream&&R.compressed){const A=await this._deflateMessage(this._zlibDeflateStream,L);this._writeFn(A,R)}else this._writeFn(L,{...R,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(L,R){return new Promise((A,F)=>{L.write(R),L.flush(_=>A(_))})}acceptFrame(L,R,A){this._readQueue.push({data:L,isCompressed:R,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const L=this._readQueue.shift();if(this._zlibInflateStream&&L.isCompressed){const R=await this._inflateFrame(this._zlibInflateStream,L.data,L.isLastFrameOfMessage);this._onData.fire(R)}else this._onData.fire(L.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(L,R,A){return new Promise((F,_)=>{L.write(R),A&&L.write(C.VSBuffer.fromByteArray([0,0,255,255])),L.flush(z=>F(z))})}}class f extends l.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}constructor(L,R,A,F){super(),this._tracer=L,this._recordInflateBytes=R,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,O.createInflateRaw)(F),this._zlibInflate.on("error",_=>{this._tracer.traceSocketEvent("zlibInflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibInflate.on("data",_=>{this._tracer.traceSocketEvent("zlibInflateData",_),this._pendingInflateData.push(C.VSBuffer.wrap(_))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(L){this._recordInflateBytes&&this._recordedInflateBytes.push(L.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",L),this._zlibInflate.write(L.buffer)}flush(L){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const R=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,L(R)})}}class a extends l.Disposable{constructor(L,R){super(),this._tracer=L,this._onError=this._register(new h.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,O.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(C.VSBuffer.wrap(A))})}write(L){this._tracer.traceSocketEvent("zlibDeflateWrite",L.buffer),this._zlibDeflate.write(L.buffer)}flush(L){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let R=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,R=R.slice(0,R.byteLength-4),L(R)})}}function t(M,L){if(L===0)return;const R=M.byteLength>>>2;for(let ce=0;ce<R;ce++){const te=M.readUInt32BE(ce*4);M.writeUInt32BE(te^L,ce*4)}const A=R*4,F=M.byteLength-A,_=L>>>24&255,z=L>>>16&255,j=L>>>8&255;F>=1&&M.writeUInt8(M.readUInt8(A)^_,A),F>=2&&M.writeUInt8(M.readUInt8(A+1)^z,A+1),F>=3&&M.writeUInt8(M.readUInt8(A+2)^j,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function s(){const M=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${M}-sock`;const L=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,I.tmpdir)(),R=(0,v.join)(L,`vscode-ipc-${M}.sock`);return r(R),R}function i(M,L,R){const F=(0,n.createHash)("sha256").update(M).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${R}-${L}-sock`;const _=R.substr(0,4),z=L.substr(0,6);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,v.join)(e.XDG_RUNTIME_DIR,`vscode-${F}-${_}-${z}.sock`):j=(0,v.join)(M,`${_}-${z}.sock`),r(j),j}function r(M){const L=o[y.platform];typeof L=="number"&&M.length>=L&&console.warn(`WARNING: IPC handle "${M}" is longer than ${L} chars, try a shorter --user-data-dir`)}class u extends g.IPCServer{static toClientConnectionEvent(L){const R=h.Event.fromNodeEventEmitter(L,"connection");return h.Event.map(R,A=>({protocol:new m.Protocol(new b(A,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(A,"close"))}))}constructor(L){super(u.toClientConnectionEvent(L)),this.server=L}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function S(M){return new Promise((L,R)=>{const A=(0,D.createServer)();A.on("error",R),A.listen(M,()=>{A.removeListener("error",R),L(new u(A))})})}function k(M,L){return new Promise((R,A)=>{const F=(0,D.createConnection)(M,()=>{F.removeListener("error",A),R(m.Client.fromSocket(new b(F,`ipc-client${L}`),L))});F.once("error",A)})}}),define(oe[24],ae([0,1,51,9,4,100,38,91,6]),function(Q,e,n,D,I,O,C,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,h.refineServiceDecorator)(C.IEnvironmentService);class l extends P.NativeEnvironmentService{constructor(){super(...arguments),this._snapEnv={}}get cachedLanguagesPath(){return(0,D.join)(this.userDataPath,"clp")}get backupHome(){return(0,D.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,D.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(I.isLinux){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const E=y.slice(0,-17);if(this._snapEnv[E])continue;process.env[E]&&(this._snapEnv[E]=process.env[E]),process.env[y]?process.env[E]=process.env[y]:delete process.env[E]}}}restoreSnapExportedVariables(){if(I.isLinux)for(const y in this._snapEnv)process.env[y]=this._snapEnv[y],delete this._snapEnv[y]}}e.EnvironmentMainService=l,Pe([n.memoize],l.prototype,"cachedLanguagesPath",null),Pe([n.memoize],l.prototype,"backupHome",null),Pe([n.memoize],l.prototype,"mainIPCHandle",null),Pe([n.memoize],l.prototype,"mainLockfile",null),Pe([n.memoize],l.prototype,"disableUpdates",null),Pe([n.memoize],l.prototype,"crossOriginIsolated",null),Pe([n.memoize],l.prototype,"codeCachePath",null),Pe([n.memoize],l.prototype,"useCodeCache",null)}),define(oe[287],ae([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let c=class{static{d=this}static{this.backupWorkspacesMetadataStorageKey="backupWorkspaces"}constructor(a,t,o,s){this.environmentMainService=a,this.configurationService=t,this.logService=o,this.stateService=s,this.backupHome=this.environmentMainService.backupHome,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,r)=>(0,D.isEqual)(i,r,!C.isLinux)}}async initialize(){const a=this.stateService.getItem(d.backupWorkspacesMetadataStorageKey)??{workspaces:[],folders:[],emptyWindows:[]};this.emptyWindows=await this.validateEmptyWorkspaces(a.emptyWindows),this.workspaces=await this.validateWorkspaces((0,l.deserializeWorkspaceInfos)(a)),this.folders=await this.validateFolders((0,l.deserializeFolderInfos)(a)),this.storeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==g.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===g.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||g.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(a,t){this.workspaces.some(s=>a.workspace.id===s.workspace.id)||(this.workspaces.push(a),this.storeWorkspacesMetadata());const o=(0,O.join)(this.backupHome,a.workspace.id);return t?this.moveBackupFolder(o,t).then(()=>o):o}async moveBackupFolder(a,t){if(await h.Promises.exists(a)&&await this.convertToEmptyWindowBackup(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.folders.some(t=>this.backupUriComparer.isEqual(a.folderUri,t.folderUri))||(this.folders.push(a),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,this.getFolderHash(a))}registerEmptyWindowBackup(a){return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.backupFolder))||(this.emptyWindows.push(a),this.storeWorkspacesMetadata()),(0,O.join)(this.backupHome,a.backupFolder)}async validateWorkspaces(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const s of a){const i=s.workspace;if(!(0,w.isWorkspaceIdentifier)(i))return[];if(!t.has(i.id)){t.add(i.id);const r=(0,O.join)(this.backupHome,i.id);await this.doHasBackups(r)?i.configPath.scheme!==I.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?o.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateFolders(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const i=s.folderUri,r=this.backupUriComparer.getComparisonKey(i);if(!o.has(r)){o.add(r);const u=(0,O.join)(this.backupHome,this.getFolderHash(s));await this.doHasBackups(u)?i.scheme!==I.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(s):await this.convertToEmptyWindowBackup(u):await this.deleteStaleBackup(u)}}return t}async validateEmptyWorkspaces(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const r=(0,O.join)(this.backupHome,i);await this.doHasBackups(r)?t.push(s):await this.deleteStaleBackup(r)}}return t}async deleteStaleBackup(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.logService.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}prepareNewEmptyWindowBackup(){let a=(0,p.createEmptyWorkspaceIdentifier)();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a.id));)a=(0,p.createEmptyWorkspaceIdentifier)();return{backupFolder:a.id}}async convertToEmptyWindowBackup(a){const t=this.prepareNewEmptyWindowBackup(),o=(0,O.join)(this.backupHome,t.backupFolder);try{await h.Promises.rename(a,o,!1)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.workspaces)await this.hasBackups(t)&&a.push(t);for(const t of this.folders)await this.hasBackups(t)&&a.push(t);return a}hasBackups(a){let t;return(0,l.isEmptyWindowBackupInfo)(a)?t=(0,O.join)(this.backupHome,a.backupFolder):(0,b.isFolderBackupInfo)(a)?t=(0,O.join)(this.backupHome,this.getFolderHash(a)):t=(0,O.join)(this.backupHome,a.workspace.id),this.doHasBackups(t)}async doHasBackups(a){try{const t=await h.Promises.readdir(a);for(const o of t)try{if((await h.Promises.readdir((0,O.join)(a,o))).length>0)return!0}catch{}}catch{}return!1}storeWorkspacesMetadata(){const a={workspaces:this.workspaces.map(({workspace:t,remoteAuthority:o})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return o&&(s.remoteAuthority=o),s}),folders:this.folders.map(({folderUri:t,remoteAuthority:o})=>{const s={folderUri:t.toString()};return o&&(s.remoteAuthority=o),s}),emptyWindows:this.emptyWindows.map(({backupFolder:t,remoteAuthority:o})=>{const s={backupFolder:t};return o&&(s.remoteAuthority=o),s})};this.stateService.setItem(d.backupWorkspacesMetadataStorageKey,a)}getFolderHash(a){const t=a.folderUri;let o;return t.scheme===I.Schemas.file?o=C.isLinux?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.BackupMainService=c,e.BackupMainService=c=d=Pe([ne(0,y.IEnvironmentMainService),ne(1,v.IConfigurationService),ne(2,m.ILogService),ne(3,E.IStateService)],c)}),define(oe[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,v.createDecorator)("lifecycleMainService");var b;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var w;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let p=class extends C.Disposable{static{m=this}static{this.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart"}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}constructor(c,f,a){super(),this.logService=c,this.stateService=f,this.environmentMainService=a,this._onBeforeShutdown=this._register(new O.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new O.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new O.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new O.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.relaunchHandler=void 0,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}resolveRestarted(){this._wasRestarted=!!this.stateService.getItem(m.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateService.removeItem(m.QUIT_AND_RESTART_KEY)}registerListeners(){const c=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};n.app.addListener("before-quit",c);const f=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&n.app.quit()};n.app.addListener("window-all-closed",f),n.app.once("will-quit",a=>{this.trace("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.trace("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.resolvePendingQuitPromise(!1),n.app.removeListener("before-quit",c),n.app.removeListener("window-all-closed",f),this.trace("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}fireOnWillShutdown(c){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;const f=this.logService;this.trace("Lifecycle#onWillShutdown.fire()");const a=[];return this._onWillShutdown.fire({reason:c,join(t,o){f.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{f.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.pendingWillShutdownPromise=(async()=>{try{await I.Promises.settled(a)}catch(t){this.logService.error(t)}try{await this.stateService.close()}catch(t){this.logService.error(t)}})(),this.pendingWillShutdownPromise}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===c)return;this.trace(`lifecycle (main): phase changed (value: ${c})`),this._phase=c;const f=this.phaseWhen.get(this._phase);f&&(f.open(),this.phaseWhen.delete(this._phase))}async when(c){if(c<=this._phase)return;let f=this.phaseWhen.get(c);f||(f=new I.Barrier,this.phaseWhen.set(c,f)),await f.wait()}registerWindow(c){const f=new C.DisposableStore;this.windowCounter++,f.add(c.onWillLoad(t=>this._onWillLoadWindow.fire({window:c,workspace:t.workspace,reason:t.reason})));const a=(0,l.assertIsDefined)(c.win);a.on("close",t=>{const o=c.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.trace(`Lifecycle#window.on('close') - window ID ${c.id}`),t.preventDefault(),this.unload(c,1).then(s=>{if(s){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(c),c.close()})}),a.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.windowCounter--,f.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}registerAuxWindow(c){const f=(0,l.assertIsDefined)(c.win);f.on("close",a=>{this.trace(`Lifecycle#auxWindow.on('close') - window ID ${c.id}`),this._quitRequested&&(this.trace("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),f.on("closed",()=>{this.trace(`Lifecycle#auxWindow.on('closed') - window ID ${c.id}`)})}async reload(c,f){await this.unload(c,3)||c.reload(f)}unload(c,f){const a=this.mapWindowIdToPendingUnload.get(c.id);if(a)return a;const t=this.doUnload(c,f).finally(()=>{this.mapWindowIdToPendingUnload.delete(c.id)});return this.mapWindowIdToPendingUnload.set(c.id,t),t}async doUnload(c,f){if(!c.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${c.id}`);const a=this._quitRequested?2:f,t=await this.onBeforeUnloadWindowInRenderer(c,a);return t?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.handleWindowUnloadVeto(t)):(await this.onWillUnloadWindowInRenderer(c,a),!1)}handleWindowUnloadVeto(c){return c?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(c){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(c),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(c,f){return new Promise(a=>{const t=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${t}`,s=`vscode:cancel${t}`;D.validatedIpcMain.once(o,()=>{a(!1)}),D.validatedIpcMain.once(s,()=>{a(!0)}),c.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:f})})}onWillUnloadWindowInRenderer(c,f){return new Promise(a=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;D.validatedIpcMain.once(o,()=>a()),c.send("vscode:onWillUnload",{replyChannel:o,reason:f})})}quit(c){return this.doQuit(c).then(f=>{if(!f&&c)try{if(P.isWindows){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}return f})}doQuit(c){return this.trace(`Lifecycle#quit() - begin (willRestart: ${c})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(c&&this.stateService.setItem(m.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(f=>{this.pendingQuitPromiseResolve=f,this.trace("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.pendingQuitPromise)}trace(c){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(c):this.logService.trace(c)}setRelaunchHandler(c){this.relaunchHandler=c}async relaunch(c){this.trace("Lifecycle#relaunch()");const f=process.argv.slice(1);if(c?.addArgs&&f.push(...c.addArgs),c?.removeArgs)for(const o of c.removeArgs){const s=f.indexOf(o);s>=0&&f.splice(s,1)}const a=()=>{this.relaunchHandler?.handleRelaunch(c)||(this.trace("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:f}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(c){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,I.timeout)(1e3),(async()=>{for(const f of n.BrowserWindow.getAllWindows())if(f&&!f.isDestroyed()){let a;f.webContents&&!f.webContents.isDestroyed()?a=new Promise(t=>f.once("closed",t)):a=Promise.resolve(),f.destroy(),await a}})()]),n.app.exit(c)}};e.LifecycleMainService=p,e.LifecycleMainService=p=m=Pe([ne(0,y.ILogService),ne(1,E.IStateService),ne(2,g.IEnvironmentMainService)],p)}),define(oe[288],ae([0,1,4,3,2,6,20]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,O.createDecorator)("keyboardLayoutMainService");let P=class extends I.Disposable{constructor(v){super(),this._onDidChangeKeyboardLayout=this._register(new D.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((y,E)=>{Q(["native-keymap"],y,E)});this._keyboardLayoutData=h(v),n.isCI||v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=h(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};e.KeyboardLayoutMainService=P,e.KeyboardLayoutMainService=P=Pe([ne(0,C.ILifecycleMainService)],P);function h(l){const v=l.getKeyMap(),y=l.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:y}}}),define(oe[289],ae([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=w;let m=class extends y.AbstractRequestService{constructor(d,c,f,a){super(a),this.configurationService=d,this.environmentService=c,this.logService=f,this.configure(),this._register(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.configure()}))}configure(){const d=this.configurationService.getValue("http");this.proxyUrl=d?.proxy,this.strictSSL=!!d?.proxyStrictSSL,this.authorization=d?.proxyAuthorization}async request(d,c){const{proxyUrl:f,strictSSL:a}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(i){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,O.getErrorMessage)(i)))}const o={...process.env,...t},s=d.agent?d.agent:await(0,E.getProxyAgent)(d.url||"",o,{proxyUrl:f,strictSSL:a});return d.agent=s,d.strictSSL=a,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(d.isChromiumNetwork?"electron":"node",d,()=>w(d,c))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((c,f)=>{Q(["@vscode/proxy-agent"],c,f)})).loadSystemCertificates({log:this.logService})}};e.RequestService=m,e.RequestService=m=Pe([ne(0,P.IConfigurationService),ne(1,h.INativeEnvironmentService),ne(2,v.ILogService),ne(3,v.ILoggerService)],m);async function b(p){return((0,n.parse)(p.url).protocol==="https:"?await new Promise((f,a)=>{Q(["https"],f,a)}):await new Promise((f,a)=>{Q(["http"],f,a)})).request}async function w(p,d){return D.Promises.withAsyncBody(async(c,f)=>{const a=(0,n.parse)(p.url),t=p.getRawRequest?p.getRawRequest(p):await b(p),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,C.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(o.auth=p.user+":"+p.password);const s=t(o,i=>{const r=(0,C.isNumber)(p.followRedirects)?p.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)w({...p,url:i.headers.location,followRedirects:r-1},d).then(c,f);else{let u=i;!p.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,g.createGunzip)())),c({res:i,stream:(0,I.streamToBufferReadableStream)(u)})}});s.on("error",f),p.timeout&&s.setTimeout(p.timeout),p.isChromiumNetwork&&s.removeHeader("Content-Length"),p.data&&typeof p.data=="string"&&s.write(p.data),s.end(),d.onCancellationRequested(()=>{s.abort(),f(new O.CancellationError)})})}}),define(oe[290],ae([0,1,14,289]),function(Q,e,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function I(C){return n.net.request}class O extends D.RequestService{request(P,h){return super.request({...P||{},getRawRequest:I,isChromiumNetwork:!0},h)}}e.RequestMainService=O}),define(oe[84],ae([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,P.createDecorator)("storageMainService");let w=class extends I.Disposable{constructor(c,f,a,t,o,s){super(),this.logService=c,this.environmentService=f,this.userDataProfilesService=a,this.lifecycleMainService=t,this.fileService=o,this.uriIdentityService=s,this.shutdownReason=void 0,this._onDidChangeProfileStorage=this._register(new D.Emitter),this.onDidChangeProfileStorage=this._onDidChangeProfileStorage.event,this.applicationStorage=this._register(this.createApplicationStorage()),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(c=>{c.window.profile&&this.profileStorage(c.window.profile).init(),c.workspace&&this.workspaceStorage(c.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(c=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=c.reason,c.join("applicationStorage",this.applicationStorage.close());for(const[,f]of this.mapProfileToStorage)c.join("profileStorage",f.close());for(const[,f]of this.mapWorkspaceToStorage)c.join("workspaceStorage",f.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(c=>{c.join((async()=>{await this.fileService.exists(c.profile.globalStorageHome)||await this.fileService.createFolder(c.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(c=>{const f=this.mapProfileToStorage.get(c.profile.id);f&&c.join(f.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const c=new y.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return this._register(D.Event.once(c.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")})),c}profileStorage(c){if((0,v.isProfileUsingDefaultStorage)(c))return this.applicationStorage;let f=this.mapProfileToStorage.get(c.id);if(!f){this.logService.trace(`StorageMainService: creating profile storage (${c.name})`),f=this._register(this.createProfileStorage(c)),this.mapProfileToStorage.set(c.id,f);const a=this._register(f.onDidChangeStorage(t=>this._onDidChangeProfileStorage.fire({...t,storage:f,profile:c})));this._register(D.Event.once(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${c.name})`),this.mapProfileToStorage.delete(c.id),a.dispose()}))}return f}createProfileStorage(c){return this.shutdownReason===2?new y.InMemoryStorageMain(this.logService,this.fileService):new y.ProfileStorageMain(c,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(c){let f=this.mapWorkspaceToStorage.get(c.id);return f||(this.logService.trace(`StorageMainService: creating workspace storage (${c.id})`),f=this._register(this.createWorkspaceStorage(c)),this.mapWorkspaceToStorage.set(c.id,f),this._register(D.Event.once(f.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${c.id})`),this.mapWorkspaceToStorage.delete(c.id)}))),f}createWorkspaceStorage(c){return this.shutdownReason===2?new y.InMemoryStorageMain(this.logService,this.fileService):new y.WorkspaceStorageMain(c,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}isUsed(c){const f=n.URI.file(c);for(const a of[this.applicationStorage,...this.mapProfileToStorage.values(),...this.mapWorkspaceToStorage.values()])if(a.path&&this.uriIdentityService.extUri.isEqualOrParent(n.URI.file(a.path),f))return!0;return!1}};e.StorageMainService=w,e.StorageMainService=w=Pe([ne(0,l.ILogService),ne(1,O.IEnvironmentService),ne(2,g.IUserDataProfilesMainService),ne(3,h.ILifecycleMainService),ne(4,C.IFileService),ne(5,m.IUriIdentityService)],w),e.IApplicationStorageMainService=(0,P.createDecorator)("applicationStorageMainService");let p=class extends v.AbstractStorageService{constructor(c,f){super(),this.userDataProfilesService=c,this.storageMainService=f,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(c){if(c===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(c){if(c===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=p,e.ApplicationStorageMainService=p=Pe([ne(0,E.IUserDataProfilesService),ne(1,e.IStorageMainService)],p)}),define(oe[291],ae([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function p(t,o,s,i,r){let u;for(let S=3;S&&(u?.dispose(),u=await new d(t,o,s,i,r).waitForReady(),!(r&&I.BROWSER_RESTRICTED_PORTS[r]||!I.BROWSER_RESTRICTED_PORTS[u.tunnelLocalPort]));S--);return u}class d extends P.Disposable{constructor(o,s,i,r,u){super(),this.defaultTunnelHost=s,this.suggestedLocalPort=u,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=n.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=S=>this._onConnection(S),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(s=>{s()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,s=(0,b.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let i=await(0,I.findFreePortFaster)(o,2,1e3,s),r=null;return this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address(),r||(i=0,this._server.listen(i,this.defaultTunnelHost),await this._barrier.wait(),r=this._server.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async _onConnection(o){o.pause();const s=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,E.connectRemoteAgentTunnel)(this._options,s,this.tunnelRemotePort),r=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&o.write(u.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),r.end()}),o.on("close",()=>r.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),r instanceof O.NodeSocket?r.socket.destroy():r.end()}),r instanceof O.NodeSocket?this._mirrorNodeSocket(o,r):this._mirrorGenericSocket(o,r),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),r.end()})}_mirrorGenericSocket(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(i=>o.write(i.buffer)),o.on("data",i=>s.write(w.VSBuffer.wrap(i))),o.resume()}_mirrorNodeSocket(o,s){const i=s.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.NodeRemoteTunnel=d;let c=class extends b.AbstractTunnelService{constructor(o,s,i,r,u){super(s,u),this.remoteSocketFactoryService=o,this.signService=i,this.productService=r}isPortPrivileged(o){return(0,b.isPortPrivileged)(o,this.defaultTunnelHost,h.OS,D.release())}retainOrCreateTunnel(o,s,i,r,u,S,k,M){const L=this.getTunnelFromMap(s,i);if(L)return++L.refcount,L.value;if((0,b.isTunnelProvider)(o))return this.createWithProvider(o,s,i,u,S,k,M);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${u}.`);const R={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},A=p(R,r,s,i,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(s,i,A),A}}};e.BaseTunnelService=c,e.BaseTunnelService=c=Pe([ne(0,g.IRemoteSocketFactoryService),ne(1,v.ILogService),ne(2,m.ISignService),ne(3,y.IProductService),ne(4,l.IConfigurationService)],c);let f=class extends c{constructor(o,s,i,r,u){super(o,s,i,r,u)}};e.TunnelService=f,e.TunnelService=f=Pe([ne(0,g.IRemoteSocketFactoryService),ne(1,v.ILogService),ne(2,m.ISignService),ne(3,y.IProductService),ne(4,l.IConfigurationService)],f);let a=class extends P.Disposable{constructor(o,s,i,r,u){super(),this.remoteSocketFactoryService=o,this.logService=s,this.productService=i,this.signService=r,this.configurationService=u,this._tunnelServices=new Map}async openTunnel(o,s,i,r,u,S,k,M,L){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${r} on local port ${S}.`),!this._tunnelServices.has(o)){const R=new f(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(R),this._tunnelServices.set(o,R),R.onTunnelClosed(async()=>{(await R.tunnels).length===0&&(R.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(s,i,r,u,S,k,M,L)}};e.SharedTunnelsService=a,e.SharedTunnelsService=a=Pe([ne(0,g.IRemoteSocketFactoryService),ne(1,v.ILogService),ne(2,y.IProductService),ne(3,m.ISignService),ne(4,l.IConfigurationService)],a)}),define(oe[101],ae([0,1,8,23,3,18,24,20,5,27,53,50]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=void 0,e.createUpdateURL=E;function E(m,b,w){return`${w.updateUrl}/api/update/${m}/${b}/${w.commit}`}let g=class{get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}constructor(b,w,p,d,c,f){this.lifecycleMainService=b,this.configurationService=w,this.environmentMainService=p,this.requestService=d,this.logService=c,this.productService=f,this._state=y.State.Uninitialized,this._onStateChange=new I.Emitter,this.onStateChange=this._onStateChange.event,b.when(3).finally(()=>this.initialize())}async initialize(){if(!this.environmentMainService.isBuilt){this.setState(y.State.Disabled(0));return}if(this.environmentMainService.disableUpdates){this.setState(y.State.Disabled(1)),this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.setState(y.State.Disabled(3)),this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.configurationService.getValue("update.mode"),w=this.getProductQuality(b);if(!w){this.setState(y.State.Disabled(2)),this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.setState(y.State.Disabled(4)),this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.configurationService.getValue("_update.prss")){const p=new URL(this.url);p.searchParams.set("prss","true"),this.url=p.toString()}if(this.setState(y.State.Idle(this.getUpdateType())),b==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getProductQuality(b){return b==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(b=60*60*1e3){return(0,n.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(b){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.url)return;if(this.configurationService.getValue("update.mode")==="none")return!1;try{return(await this.requestService.request({url:this.url},D.CancellationToken.None)).res.statusCode===204}catch(w){this.logService.error("update#isLatestVersion(): failed to check for updates"),this.logService.error(w);return}}async _applySpecificUpdate(b){}getUpdateType(){return 1}doQuitAndInstall(){}};e.AbstractUpdateService=g,e.AbstractUpdateService=g=Pe([ne(0,P.ILifecycleMainService),ne(1,O.IConfigurationService),ne(2,C.IEnvironmentMainService),ne(3,v.IRequestService),ne(4,h.ILogService),ne(5,l.IProductService)],g)}),define(oe[292],ae([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends b.AbstractUpdateService{get onRawError(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"error",(d,c)=>c)}get onRawUpdateNotAvailable(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get onRawUpdateDownloaded(){return I.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(d,c,f,a)=>({version:f,productVersion:f,timestamp:a}))}constructor(d,c,f,a,t,o,s){super(d,c,a,t,o,s),this.telemetryService=f,this.disposables=new C.DisposableStore,d.setRelaunchHandler(this)}handleRelaunch(d){return d?.addArgs||d?.removeArgs||this.state.type!=="ready"?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(d){this.telemetryService.publicLog2("update:error",{messageHash:String((0,O.hash)(String(d)))}),this.logService.error("UpdateService error:",d);const c=this.state.type==="checking for updates"&&this.state.explicit?d:void 0;this.setState(m.State.Idle(1,c))}buildUpdateFeedUrl(d){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const f=(0,b.createUpdateURL)(c,d,this.productService);try{n.autoUpdater.setFeedURL({url:f})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return f}doCheckForUpdates(d){this.setState(m.State.CheckingForUpdates(d)),n.autoUpdater.checkForUpdates()}onUpdateAvailable(){this.state.type==="checking for updates"&&this.setState(m.State.Downloading)}onUpdateDownloaded(d){this.state.type==="downloading"&&(this.setState(m.State.Downloaded(d)),this.telemetryService.publicLog2("update:downloaded",{version:d.version}),this.setState(m.State.Ready(d)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(m.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};e.DarwinUpdateService=w,Pe([D.memoize],w.prototype,"onRawError",null),Pe([D.memoize],w.prototype,"onRawUpdateNotAvailable",null),Pe([D.memoize],w.prototype,"onRawUpdateAvailable",null),Pe([D.memoize],w.prototype,"onRawUpdateDownloaded",null),e.DarwinUpdateService=w=Pe([ne(0,l.ILifecycleMainService),ne(1,P.IConfigurationService),ne(2,g.ITelemetryService),ne(3,h.IEnvironmentMainService),ne(4,E.IRequestService),ne(5,v.ILogService),ne(6,y.IProductService)],w)}),define(oe[293],ae([0,1,49,43,8,3,9,24,20,5,28,50]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}constructor(b,w,p){if(this.lifecycleMainService=b,this.logService=p,this._state=y.State.Uninitialized,this._onStateChange=new O.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,d=>this.logService.error(d))}scheduleCheckForUpdates(b=60*60*1e3){return(0,I.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(b){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(b){}};E=Pe([ne(0,h.ILifecycleMainService),ne(1,P.IEnvironmentMainService),ne(2,l.ILogService)],E);let g=class extends E{constructor(b,w,p,d,c,f){super(p,d,c),this.snap=b,this.snapRevision=w,this.telemetryService=f;const a=(0,D.watch)(C.dirname(this.snap)),t=O.Event.fromNodeEventEmitter(a,"change",(r,u)=>u),o=O.Event.filter(t,r=>r==="current"),i=O.Event.debounce(o,(r,u)=>u,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{i.dispose(),a.close()})}doCheckForUpdates(){this.setState(y.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(b=>{b?this.setState(y.State.Ready({version:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const b=await new Promise((p,d)=>(0,D.realpath)(`${C.dirname(this.snap)}/current`,(c,f)=>c?d(c):p(f))),w=C.basename(b);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,b=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=g,e.SnapUpdateService=g=Pe([ne(2,h.ILifecycleMainService),ne(3,P.IEnvironmentMainService),ne(4,l.ILogService),ne(5,v.ITelemetryService)],g)}),define(oe[29],ae([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.IWindowsMainService=void 0,e.defaultBrowserWindowOptions=m,e.getLastFocused=b,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var g;(function(p){p[p.CLI=0]="CLI",p[p.DOCK=1]="DOCK",p[p.MENU=2]="MENU",p[p.DIALOG=3]="DIALOG",p[p.DESKTOP=4]="DESKTOP",p[p.API=5]="API"})(g||(e.OpenContext=g={}));function m(p,d,c){const f=p.get(P.IThemeMainService),a=p.get(h.IProductService),t=p.get(l.IConfigurationService),o=p.get(v.IEnvironmentMainService),s=t.getValue("window"),i={backgroundColor:f.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,title:a.nameLong,...c,x:d.x,y:d.y,width:d.width,height:d.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.zoomLevelToZoomFactor)(d.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...c?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(D.isLinux?i.icon=(0,y.join)(o.appRoot,"resources/linux/code.png"):D.isWindows&&!o.isBuilt&&(i.icon=(0,y.join)(o.appRoot,"resources/win32/code_150x150.png")),D.isMacintosh&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),D.isMacintosh&&!(0,C.useNativeFullScreen)(t)&&(i.fullscreenable=!1),D.isMacintosh&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,C.hasNativeTitlebar)(t)&&(i.titleBarStyle="hidden",D.isMacintosh||(i.frame=!1),(0,C.useWindowControlsOverlay)(t))){const S=f.getWindowSplash()?.colorInfo.titleBarBackground??f.getBackgroundColor(),k=E.Color.fromHex(S).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:S,symbolColor:k}}return i}function b(p){let d,c=Number.MIN_VALUE;for(const f of p)f.lastFocusTime>c&&(c=f.lastFocusTime,d=f);return d}var w;(function(p){function d(f,a,t=n.screen.getAllDisplays()){if(f.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){f.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){f.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=c(t[0]);if(f.trace("window#validateWindowState: single monitor working area",i),i){let r=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};r(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),r()}return a}if(a.display&&a.mode===3){const i=t.find(r=>r.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){f.trace("window#validateWindowState: restoring fullscreen to previous display");const r=(0,O.defaultWindowState)(3);return r.x=i.bounds.x,r.y=i.bounds.y,r}}let o,s;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=c(o),f.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){f.error("window#validateWindowState: error finding display for window state",i)}if(o&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;f.trace("window#validateWindowState: state is outside of the multi-monitor working area")}p.validateWindowState=d;function c(f){if(f.workArea.width>0&&f.workArea.height>0)return f.workArea;if(f.bounds.width>0&&f.bounds.height>0)return f.bounds}})(w||(e.WindowStateValidator=w={}))}),define(oe[294],ae([0,1,14,23,3,46,2,33,120,5,84,29]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var E;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(E||(E={}));let g=class extends C.Disposable{constructor(b,w,p,d){super(),this.logService=b,this.windowsMainService=w,this.encryptionMainService=p,this.applicationStorageMainService=d,this.PROXY_CREDENTIALS_SERVICE_KEY="proxy-credentials://",this.pendingProxyResolve=void 0,this.state=E.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=I.Event.fromNodeEventEmitter(n.app,"login",(w,p,d,c,f)=>({event:w,webContents:p,req:d,authInfo:c,callback:f}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:w,req:p,callback:d}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===E.LoginDialogShown&&p.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let c;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{c=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(c?.username,c?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(b);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const w=String((0,O.hash)({scheme:b.scheme,host:b.host,port:b.port}));let p,d;try{const t=this.applicationStorageMainService.get(this.PROXY_CREDENTIALS_SERVICE_KEY+w,-1);if(t){const o=JSON.parse(await this.encryptionMainService.decrypt(t));p=o.username,d=o.password}}catch(t){this.logService.error(t)}if(this.state!==E.StoredCredentialsUsed&&typeof p=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=E.StoredCredentialsUsed,{username:p,password:d};const c=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!c){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const f={authInfo:b,username:this.sessionCredentials?.username??p,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,f),this.state=E.LoginDialogShown;const a=await new Promise(t=>{const o=async(s,i,r)=>{if(i===f.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",o),r){const u={username:r.username,password:r.password};try{if(r.remember){const S=await this.encryptionMainService.encrypt(JSON.stringify(u));this.applicationStorageMainService.store(this.PROXY_CREDENTIALS_SERVICE_KEY+w,S,-1,1)}else this.applicationStorageMainService.remove(this.PROXY_CREDENTIALS_SERVICE_KEY+w,-1)}catch(S){this.logService.error(S)}t({username:u.username,password:u.password})}else t(void 0)};c.win?.webContents.on("ipc-message",o)});return this.sessionCredentials=a,a}};e.ProxyAuthHandler=g,e.ProxyAuthHandler=g=Pe([ne(0,l.ILogService),ne(1,y.IWindowsMainService),ne(2,h.IEncryptionMainService),ne(3,v.IApplicationStorageMainService)],g)}),define(oe[295],ae([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let g=class{constructor(b,w,p,d){this.logService=b,this.windowsMainService=w,this.urlService=p,this.configurationService=d}async start(b,w){this.logService.trace("Received data from other instance: ",b,w),I.isMacintosh&&n.app.focus({steal:!0});const p=this.parseOpenUrl(b);if(p.length){let d=Promise.resolve();if(this.windowsMainService.getWindowCount()===0){const c=(0,D.firstOrDefault)(await this.windowsMainService.openEmptyWindow({context:4}));c&&(d=c.ready())}d.then(()=>{for(const{uri:c,originalUrl:f}of p)this.urlService.open(c,{originalUrl:f})})}else return this.startOpenWindow(b,w)}parseOpenUrl(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,D.coalesce)(b._urls.map(w=>{try{return{uri:O.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async startOpenWindow(b,w){const p=(0,h.isLaunchedFromCli)(w)?0:4;let d=[];const c=b.wait&&b.waitMarkerFilePath?O.URI.file(b.waitMarkerFilePath):void 0,f=b.remote||void 0,a={context:p,cli:b,userEnv:b["preserve-env"]||p===0?w:void 0,waitMarkerFileURI:c,remoteAuthority:f,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.windowsMainService.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,a);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!I.isMacintosh}if(t)d=await this.windowsMainService.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,a),d=[o]):d=await this.windowsMainService.open({...a,forceEmpty:!0})}}else d=await this.windowsMainService.open({...a,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(c&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,C.whenDeleted)(c.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=g,e.LaunchMainService=g=Pe([ne(0,v.ILogService),ne(1,E.IWindowsMainService),ne(2,y.IURLService),ne(3,P.IConfigurationService)],g)}),define(oe[296],ae([0,1,2,20,57,30,8,29]),function(Q,e,n,D,I,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=class extends n.Disposable{constructor(v,y,E){super(),this.userDataProfilesService=y,this.windowsMainService=E,this._register(v.onWillLoadWindow(g=>{g.reason===2&&this.unsetProfileForWorkspace(g.window)})),this._register(v.onBeforeCloseWindow(g=>this.unsetProfileForWorkspace(g))),this._register(new C.RunOnceScheduler(()=>this.cleanUpEmptyWindowAssociations(),30*1e3)).schedule()}async unsetProfileForWorkspace(v){const y=this.getWorkspace(v),E=this.userDataProfilesService.getProfileForWorkspace(y);E?.isTransient&&(this.userDataProfilesService.unsetWorkspace(y,E.isTransient),E.isTransient&&await this.userDataProfilesService.cleanUpTransientProfiles())}getWorkspace(v){return v.openedWorkspace??(0,O.toWorkspaceIdentifier)(v.backupPath,v.isExtensionDevelopmentHost)}cleanUpEmptyWindowAssociations(){const v=this.userDataProfilesService.getAssociatedEmptyWindows();if(v.length===0)return;const y=this.windowsMainService.getWindows().map(E=>this.getWorkspace(E));for(const E of v)y.some(g=>g.id===E.id)||this.userDataProfilesService.unsetWorkspace(E,!1)}};e.UserDataProfilesHandler=h,e.UserDataProfilesHandler=h=Pe([ne(0,D.ILifecycleMainService),ne(1,I.IUserDataProfilesMainService),ne(2,P.IWindowsMainService)],h)}),define(oe[61],ae([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function d(a){return typeof a.responseWindowId=="number"}let c=class extends D.Disposable{static{p=this}static{this.ID_COUNTER=0}static{this.all=new Map}static getAll(){return Array.from(p.all.values())}constructor(t,o,s){super(),this.logService=t,this.telemetryService=o,this.lifecycleMainService=s,this.id=String(++p.ID_COUNTER),this._onStdout=this._register(new I.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new I.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new I.Emitter),this.onMessage=this._onMessage.event,this._onSpawn=this._register(new I.Emitter),this.onSpawn=this._onSpawn.event,this._onExit=this._register(new I.Emitter),this.onExit=this._onExit.event,this._onCrash=this._register(new I.Emitter),this.onCrash=this._onCrash.event,this.process=void 0,this.processPid=void 0,this.configuration=void 0}log(t,o){let s;switch(this.configuration?.correlationId?s=`[UtilityProcess id: ${this.configuration?.correlationId}, type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.configuration?.type}, pid: ${this.processPid??"<none>"}]: ${t}`,o){case v.default.Error:this.logService.error(s);break;case v.default.Warning:this.logService.warn(s);break;case v.default.Info:this.logService.trace(s);break}}validateCanStart(){return this.process?(this.log("Cannot start utility process because it is already running...",v.default.Error),!1):!0}start(t){const o=this.doStart(t);return o&&t.payload&&this.postMessage(t.payload)&&this.log("payload sent via postMessage()",v.default.Info),o}doStart(t){if(!this.validateCanStart())return!1;this.configuration=t;const o=`${this.configuration.type}-${this.id}`,s=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,i=this.configuration.args??[],r=this.configuration.execArgv??[],u=this.configuration.allowLoadingUnsignedLibraries,S=this.configuration.forceAllocationsToV8Sandbox,k="pipe",M=this.createEnv(t);return this.log("creating new...",v.default.Info),this.process=n.utilityProcess.fork(s,i,{serviceName:o,env:M,execArgv:r,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:S,stdio:k}),this.registerListeners(this.process,this.configuration,o),!0}createEnv(t){const o=t.env?{...t.env}:{...(0,m.deepClone)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.isWindows&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,g.removeDangerousEnvVariables)(o);for(const s of Object.keys(o))o[s]=String(o[s]);return o}registerListeners(t,o,s){if(t.stdout){const i=new C.StringDecoder("utf-8");this._register(I.Event.fromNodeEventEmitter(t.stdout,"data")(r=>this._onStdout.fire(typeof r=="string"?r:i.write(r))))}if(t.stderr){const i=new C.StringDecoder("utf-8");this._register(I.Event.fromNodeEventEmitter(t.stderr,"data")(r=>this._onStderr.fire(typeof r=="string"?r:i.write(r))))}this._register(I.Event.fromNodeEventEmitter(t,"message")(i=>this._onMessage.fire(i))),this._register(I.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.processPid=t.pid,typeof t.pid=="number"&&p.all.set(t.pid,{pid:t.pid,name:d(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.log("successfully created",v.default.Info),this._onSpawn.fire(t.pid)})),this._register(I.Event.fromNodeEventEmitter(t,"exit")(i=>{this.log(`received exit event with code ${i}`,v.default.Info),this._onExit.fire({pid:this.processPid,code:i,signal:"unknown"}),this.onDidExitOrCrashOrKill()})),this._register(I.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,r)=>({event:i,details:r}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.log(`crashed with code ${i.exitCode} and reason '${i.reason}'`,v.default.Error),this.telemetryService.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this._onCrash.fire({pid:this.processPid,code:i.exitCode,reason:i.reason}),this.onDidExitOrCrashOrKill())}))}once(t,o){const s=this._register(this._onMessage.event(i=>{i===t&&(s.dispose(),o())}))}postMessage(t,o){return this.process?(this.process.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),o}enableInspectPort(){if(!this.process||typeof this.processPid!="number")return!1;this.log("enabling inspect port",v.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.processPid),!0):!1}kill(){if(!this.process)return;this.log("attempting to kill the process...",v.default.Info),this.process.kill()?(this.log("successfully killed the process",v.default.Info),this.onDidExitOrCrashOrKill()):this.log("unable to kill the process",v.default.Warning)}onDidExitOrCrashOrKill(){typeof this.processPid=="number"&&p.all.delete(this.processPid),this.process=void 0}async waitForExit(t){this.process&&(this.log("waiting to exit...",v.default.Info),await Promise.race([I.Event.toPromise(this.onExit),(0,P.timeout)(t)]),this.process&&(this.log(`did not exit within ${t}ms, will kill it now...`,v.default.Info),this.kill()))}};e.UtilityProcess=c,e.UtilityProcess=c=p=Pe([ne(0,O.ILogService),ne(1,y.ITelemetryService),ne(2,E.ILifecycleMainService)],c);let f=class extends c{constructor(t,o,s,i){super(t,s,i),this.windowsMainService=o}start(t){const o=this.windowsMainService.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.log("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error),!0;if(!super.doStart(t))return!1;this.registerWindowListeners(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}registerWindowListeners(t,o){o.windowLifecycleBound&&(this._register(I.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this._register(I.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=f,e.WindowUtilityProcess=f=Pe([ne(0,O.ILogService),ne(1,l.IWindowsMainService),ne(2,y.ITelemetryService),ne(3,E.ILifecycleMainService)],f)}),define(oe[297],ae([0,1,15,3,5,20,8,61,29,28]),function(Q,e,n,D,I,O,C,P,h,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let y=class{static{v=this}static{this._lastId=0}constructor(g,m,b,w){this._logService=g,this._lifecycleMainService=m,this._windowsMainService=b,this._telemetryService=w,this._extHosts=new Map,this._shutdown=!1,this._lifecycleMainService.onWillShutdown(p=>{this._shutdown=!0,p.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}_getExtHost(g){const m=this._extHosts.get(g);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(g){return this._getExtHost(g).onStdout}onDynamicStderr(g){return this._getExtHost(g).onStderr}onDynamicMessage(g){return this._getExtHost(g).onMessage}onDynamicExit(g){return this._getExtHost(g).onExit}async createExtensionHost(){if(this._shutdown)throw(0,n.canceled)();const g=String(++v._lastId),m=new P.WindowUtilityProcess(this._logService,this._windowsMainService,this._telemetryService,this._lifecycleMainService);return this._extHosts.set(g,m),m.onExit(({pid:b,code:w,signal:p})=>{this._logService.info(`Extension host with pid ${b} exited with code: ${w}, signal: ${p}.`),setTimeout(()=>{m.dispose(),this._extHosts.delete(g)}),setTimeout(()=>{try{process.kill(b,0),this._logService.error(`Extension host with pid ${b} still exists, forcefully killing it...`),process.kill(b)}catch{}},1e3)}),{id:g}}async start(g,m){if(this._shutdown)throw(0,n.canceled)();const b=this._getExtHost(g);return b.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:g}),{pid:await D.Event.toPromise(b.onSpawn)}}async enableInspectPort(g){if(this._shutdown)throw(0,n.canceled)();const m=this._extHosts.get(g);return m?m.enableInspectPort():!1}async kill(g){if(this._shutdown)throw(0,n.canceled)();const m=this._extHosts.get(g);m&&m.kill()}async _killAllNow(){for(const[,g]of this._extHosts)g.kill()}async _waitForAllExit(g){const m=[];for(const[,b]of this._extHosts)m.push(b.waitForExit(g));return C.Promises.settled(m).then(()=>{})}};e.ExtensionHostStarter=y,e.ExtensionHostStarter=y=v=Pe([ne(0,I.ILogService),ne(1,O.ILifecycleMainService),ne(2,h.IWindowsMainService),ne(3,l.ITelemetryService)],y)}),define(oe[298],ae([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=class extends I.Disposable{constructor(d,c,f,a,t,o,s,i){super(),this.machineId=d,this.sqmId=c,this.environmentMainService=f,this.userDataProfilesService=a,this.lifecycleMainService=t,this.logService=o,this.loggerMainService=s,this.policyService=i,this.firstWindowConnectionBarrier=new D.Barrier,this.utilityProcess=void 0,this.utilityProcessLogListener=void 0,this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){n.validatedIpcMain.on(b.SharedProcessChannelConnection.request,(d,c)=>this.onWindowConnection(d,c,b.SharedProcessChannelConnection.response)),n.validatedIpcMain.on(b.SharedProcessRawConnection.request,(d,c)=>this.onWindowConnection(d,c,b.SharedProcessRawConnection.response)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(d,c,f){this.logService.trace(`[SharedProcess] onWindowConnection for: ${f}`),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect(f);if(d.sender.isDestroyed())return a.close();d.sender.postMessage(f,c,[a])}onWillShutdown(){this.logService.trace("[SharedProcess] onWillShutdown"),this.utilityProcess?.postMessage(b.SharedProcessLifecycle.exit),this.utilityProcess=void 0}whenReady(){return this._whenReady||(this._whenReady=(async()=>{await this.whenIpcReady;const d=new D.DeferredPromise;this.utilityProcess?.once(b.SharedProcessLifecycle.initDone,()=>d.complete()),await d.p,this.utilityProcessLogListener?.dispose(),this.logService.trace("[SharedProcess] Overall ready")})()),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createUtilityProcess();const d=new D.DeferredPromise;this.utilityProcess?.once(b.SharedProcessLifecycle.ipcReady,()=>d.complete()),await d.p,this.logService.trace("[SharedProcess] IPC ready")})()),this._whenIpcReady}createUtilityProcess(){this.utilityProcess=this._register(new y.UtilityProcess(this.logService,E.NullTelemetryService,this.lifecycleMainService)),this.utilityProcessLogListener=this.utilityProcess.onMessage(f=>{typeof f.warning=="string"?this.logService.warn(f.warning):typeof f.error=="string"&&this.logService.error(f.error)});const d=(0,g.parseSharedProcessDebugPort)(this.environmentMainService.args,this.environmentMainService.isBuilt);let c;d.port&&(c=["--nolazy"],d.break?c.push(`--inspect-brk=${d.port}`):c.push(`--inspect=${d.port}`)),this.utilityProcess.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.createSharedProcessConfiguration(),execArgv:c})}createSharedProcessConfiguration(){return{machineId:this.machineId,sqmId:this.sqmId,codeCachePath:this.environmentMainService.codeCachePath,profiles:{home:this.userDataProfilesService.profilesHome,all:this.userDataProfilesService.profiles},args:this.environmentMainService.args,logLevel:this.loggerMainService.getLogLevel(),loggers:this.loggerMainService.getRegisteredLoggers(),policiesData:this.policyService.serialize()}}async connect(d){return await this.whenIpcReady,(0,m.assertIsDefined)(this.utilityProcess).connect(d)}};e.SharedProcess=w,e.SharedProcess=w=Pe([ne(2,O.IEnvironmentMainService),ne(3,h.IUserDataProfilesService),ne(4,C.ILifecycleMainService),ne(5,P.ILogService),ne(6,v.ILoggerMainService),ne(7,l.IPolicyService)],w)}),define(oe[299],ae([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronPtyHostStarter=void 0;let b=class extends v.Disposable{constructor(p,d,c,f,a){super(),this._reconnectConstants=p,this._configurationService=d,this._environmentMainService=c,this._lifecycleMainService=f,this._logService=a,this.utilityProcess=void 0,this._onRequestConnection=new y.Emitter,this.onRequestConnection=this._onRequestConnection.event,this._onWillShutdown=new y.Emitter,this.onWillShutdown=this._onWillShutdown.event,this._lifecycleMainService.onWillShutdown(()=>this._onWillShutdown.fire()),l.validatedIpcMain.on("vscode:createPtyHostMessageChannel",(t,o)=>this._onWindowConnection(t,o)),this._register((0,v.toDisposable)(()=>{l.validatedIpcMain.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.utilityProcess=new P.UtilityProcess(this._logService,C.NullTelemetryService,this._lifecycleMainService);const p=(0,D.parsePtyHostDebugPort)(this._environmentMainService.args,this._environmentMainService.isBuilt),d=p.port?["--nolazy",`--inspect${p.break?"-brk":""}=${p.port}`]:void 0;this.utilityProcess.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this._environmentMainService.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this._createPtyHostConfiguration()});const c=this.utilityProcess.connect(),f=new h.Client(c,"ptyHost"),a=new v.DisposableStore;return a.add(f),a.add((0,v.toDisposable)(()=>{this.utilityProcess?.kill(),this.utilityProcess?.dispose(),this.utilityProcess=void 0})),{client:f,store:a,onDidProcessExit:this.utilityProcess.onExit}}_createPtyHostConfiguration(){this._environmentMainService.unsetSnapExportedVariables();const p={...(0,E.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this._reconnectConstants.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this._reconnectConstants.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this._reconnectConstants.scrollback)},d=this._configurationService.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&(p.VSCODE_LATENCY=String(d));const c=this._configurationService.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(p.VSCODE_STARTUP_DELAY=String(c)),this._environmentMainService.restoreSnapExportedVariables(),p}_onWindowConnection(p,d){this._onRequestConnection.fire();const c=this.utilityProcess.connect();if(p.sender.isDestroyed()){c.close();return}p.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[c])}};e.ElectronPtyHostStarter=b,e.ElectronPtyHostStarter=b=Pe([ne(1,g.IConfigurationService),ne(2,n.IEnvironmentMainService),ne(3,I.ILifecycleMainService),ne(4,O.ILogService)],b)}),define(oe[300],ae([0,1,2,6,5,29,61,28,46,3,8,20]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,D.createDecorator)("utilityProcessWorker");let E=class extends n.Disposable{constructor(b,w,p,d){super(),this.logService=b,this.windowsMainService=w,this.telemetryService=p,this.lifecycleMainService=d,this.workers=new Map}async createWorker(b){const w=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.logService.trace(`[UtilityProcessWorker]: createWorker(${w})`);const p=this.hash(b);this.workers.has(p)&&(this.logService.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(b));const d=new g(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService,b);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.workers.set(p,d);const c=new v.DeferredPromise;return l.Event.once(d.onDidTerminate)(f=>{f.code===0?this.logService.trace(`[UtilityProcessWorker]: terminated normally with code ${f.code}, signal: ${f.signal}`):this.logService.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${f.code}, signal: ${f.signal}`),this.workers.delete(p),c.complete({reason:f})}),c.p}hash(b){return(0,h.hash)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const w=this.hash(b),p=this.workers.get(w);p&&(this.logService.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),p.kill(),this.workers.delete(w))}};e.UtilityProcessWorkerMainService=E,e.UtilityProcessWorkerMainService=E=Pe([ne(0,I.ILogService),ne(1,O.IWindowsMainService),ne(2,P.ITelemetryService),ne(3,y.ILifecycleMainService)],E);let g=class extends n.Disposable{constructor(b,w,p,d,c){super(),this.logService=b,this.windowsMainService=w,this.telemetryService=p,this.lifecycleMainService=d,this.configuration=c,this._onDidTerminate=this._register(new l.Emitter),this.onDidTerminate=this._onDidTerminate.event,this.utilityProcess=new C.WindowUtilityProcess(this.logService,this.windowsMainService,this.telemetryService,this.lifecycleMainService),this.registerListeners()}registerListeners(){this._register(this.utilityProcess.onExit(b=>this._onDidTerminate.fire({code:b.code,signal:b.signal}))),this._register(this.utilityProcess.onCrash(b=>this._onDidTerminate.fire({code:b.code,signal:"ECRASH"})))}spawn(){const w=this.windowsMainService.getWindowById(this.configuration.reply.windowId)?.win?.webContents.getOSProcessId();return this.utilityProcess.start({type:this.configuration.process.type,entryPoint:this.configuration.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.configuration.reply.windowId}`,responseWindowId:this.configuration.reply.windowId,responseChannel:this.configuration.reply.channel,responseNonce:this.configuration.reply.nonce})}kill(){this.utilityProcess.kill()}};g=Pe([ne(0,I.ILogService),ne(1,O.IWindowsMainService),ne(2,P.ITelemetryService),ne(3,y.ILifecycleMainService)],g)}),define(oe[301],ae([0,1,14,3,2,277,29]),function(Q,e,n,D,I,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends I.Disposable{constructor(l){super(),this.windowsMainService=l,this._onFoundInFrame=this._register(new D.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new O.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,v){let y;if(typeof l.windowId=="number"){const{windowId:E}=l,g=this.windowsMainService.getWindowById(E);if(!g?.win)throw new Error(`Invalid windowId: ${E}`);y=g.win.webContents}else{const{webContentsId:E}=l;if(y=n.webContents.fromId(E),!y)throw new Error(`Invalid webContentsId: ${E}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(v)}async findInFrame(l,v,y,E){const m=this.getFrameByName(l,v);if(typeof m.findInFrame=="function"){m.findInFrame(y,{findNext:E.findNext,forward:E.forward});const b=(w,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),m.removeListener("found-in-frame",b))};m.on("found-in-frame",b)}}async stopFindInFrame(l,v,y){const g=this.getFrameByName(l,v);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(l,v){const y=this.windowsMainService.getWindowById(l.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${l}`);const E=y.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===v);if(!E)throw new Error(`Unknown frame: ${v}`);return E}};e.WebviewMainService=P,e.WebviewMainService=P=Pe([ne(0,C.IWindowsMainService)],P)}),define(oe[302],ae([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsStateHandler=void 0,e.restoreWindowsState=w,e.getWindowsStateStoreData=d;let b=class extends D.Disposable{static{m=this}static{this.windowsStateStorageKey="windowsState"}get state(){return this._state}constructor(a,t,o,s,i){super(),this.windowsMainService=a,this.stateService=t,this.lifecycleMainService=o,this.logService=s,this.configurationService=i,this._state=w(this.stateService.getItem(m.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}registerListeners(){n.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(a=>this.onBeforeCloseWindow(a)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(a=>this.onBeforeCloseWindow(a))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.toWindowState(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?I.isMacintosh&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.toWindowState(i);return r.uiState.mode===3&&(a.has(r.uiState.display)?I.isMacintosh&&r.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):a.add(r.uiState.display)),r}));const s=d(t);this.stateService.setItem(m.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(a){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this._state.openedWindows.forEach(o=>{const s=(0,g.isWorkspaceIdentifier)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,g.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)&&o.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(o.folderUri,a.openedWorkspace.uri);(s||i)&&(o.uiState=t.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=t)}toWindowState(a){return{windowId:a.id,workspace:(0,g.isWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.doGetNewWindowState(a),o=this.configurationService.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):s=!!(this.lifecycleMainService.wasRestarted||o?.restoreFullscreen),s||(t.mode=1)}return t}doGetNewWindowState(a){const t=this.windowsMainService.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const S=a.workspace;if((0,g.isWorkspaceIdentifier)(S)){const M=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===S.id).map(L=>L.uiState);if(M.length)return M[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(S)){const M=this.state.openedWindows.filter(L=>L.folderUri&&O.extUriBiasedIgnorePathCase.isEqual(L.folderUri,S.uri)).map(L=>L.uiState);if(M.length)return M[0]}else if(a.backupPath){const M=this.state.openedWindows.filter(L=>L.backupPath===a.backupPath).map(L=>L.uiState);if(M.length)return M[0]}const k=this.lastClosedState||this.state.lastActiveWindow;if(!t&&k)return k.uiState}let o;const s=n.screen.getAllDisplays();if(s.length===1)o=s[0];else{if(I.isMacintosh){const S=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(S)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||s[0])}let i=(0,E.defaultWindowState)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const r=this.configurationService.getValue("window");let u=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&t){const S=t.serializeWindowState();S.mode===3?i.mode=3:i={...S,zoomLevel:void 0},u=i.mode!==3&&r.newWindowDimensions==="offset"}}return u&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(a){if(this.windowsMainService.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.WindowsStateHandler=b,e.WindowsStateHandler=b=m=Pe([ne(0,y.IWindowsMainService),ne(1,v.IStateService),ne(2,h.ILifecycleMainService),ne(3,l.ILogService),ne(4,P.IConfigurationService)],b);function w(f){const a={openedWindows:[]},t=f||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=p(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=p(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>p(o))),a}function p(f){const a={uiState:f.uiState};return f.backupPath&&(a.backupPath=f.backupPath),f.remoteAuthority&&(a.remoteAuthority=f.remoteAuthority),f.folder&&(a.folderUri=C.URI.parse(f.folder)),f.workspaceIdentifier&&(a.workspace={id:f.workspaceIdentifier.id,configPath:C.URI.parse(f.workspaceIdentifier.configURIPath)}),a}function d(f){return{lastActiveWindow:f.lastActiveWindow&&c(f.lastActiveWindow),lastPluginDevelopmentHostWindow:f.lastPluginDevelopmentHostWindow&&c(f.lastPluginDevelopmentHostWindow),openedWindows:f.openedWindows.map(a=>c(a))}}function c(f){return{workspaceIdentifier:f.workspace&&{id:f.workspace.id,configURIPath:f.workspace.configPath.toString()},folder:f.folderUri&&f.folderUri.toString(),backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.uiState}}}),define(oe[58],ae([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let a=class extends O.Disposable{constructor(o,s,i,r,u){super(),this.environmentMainService=o,this.logService=s,this.userDataProfilesMainService=i,this.backupMainService=r,this.dialogMainService=u,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this.untitledWorkspaces=[]}async initialize(){this.untitledWorkspaces=[];try{const o=(await l.Promises.readdir(this.untitledWorkspacesHome.with({scheme:C.Schemas.file}).fsPath)).map(s=>(0,h.joinPath)(this.untitledWorkspacesHome,s,d.UNTITLED_WORKSPACE_NAME));for(const s of o){const i=(0,f.getWorkspaceIdentifier)(s),r=await this.resolveLocalWorkspace(s);r?this.untitledWorkspaces.push({workspace:i,remoteAuthority:r.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${o}).`)}}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,s=>l.Promises.readFile(s,"utf8"))}doResolveLocalWorkspace(o,s){if(this.isWorkspacePath(o)&&o.scheme===C.Schemas.file)try{const i=s(o.fsPath);return i instanceof Promise?i.then(r=>this.doResolveWorkspace(o,r),r=>{}):this.doResolveWorkspace(o,i)}catch{return}}isWorkspacePath(o){return(0,d.isUntitledWorkspace)(o,this.environmentMainService)||(0,d.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,s){try{const i=this.doParseStoredWorkspace(o,s),r=(0,f.getWorkspaceIdentifier)(o);return{id:r.id,configPath:r.configPath,folders:(0,c.toWorkspaceFolders)(i.folders,r.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.logService.warn(i.toString())}}doParseStoredWorkspace(o,s){const i=(0,I.parse)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(r=>(0,c.isStoredWorkspaceFolder)(r));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,s){const{workspace:i,storedWorkspace:r}=this.newUntitledWorkspace(o,s),u=i.configPath.fsPath;return await l.Promises.mkdir((0,P.dirname)(u),{recursive:!0}),await l.Promises.writeFile(u,JSON.stringify(r,null,"	")),this.untitledWorkspaces.push({workspace:i,remoteAuthority:s}),i}newUntitledWorkspace(o=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),r=(0,h.joinPath)(this.untitledWorkspacesHome,i),u=(0,h.joinPath)(r,d.UNTITLED_WORKSPACE_NAME),S=[];for(const k of o)S.push((0,c.getStoredWorkspaceFolder)(k.uri,!0,k.name,r,h.extUriBiasedIgnorePathCase));return{workspace:(0,f.getWorkspaceIdentifier)(u),storedWorkspace:{folders:S,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,f.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,d.isUntitledWorkspace)(o.configPath,this.environmentMainService)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.doDeleteUntitledWorkspace(o),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(o),this._onDidDeleteUntitledWorkspace.fire(o))}async doDeleteUntitledWorkspace(o){const s=(0,h.originalFSPath)(o.configPath);try{await l.Promises.rm((0,P.dirname)(s));const i=(0,P.join)(this.environmentMainService.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,P.join)(i,"obsolete"),""),this.untitledWorkspaces=this.untitledWorkspaces.filter(r=>r.workspace.id!==o.id)}catch(i){this.logService.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.untitledWorkspaces}async enterWorkspace(o,s,i){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,s,i))return;const u=await this.doEnterWorkspace(o,(0,f.getWorkspaceIdentifier)(i));if(u)return this._onDidEnterWorkspace.fire({window:o,workspace:u.workspace}),u}async isValidTargetWorkspacePath(o,s,i){return i?(0,d.isWorkspaceIdentifier)(o.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,i)?!1:(0,p.findWindowOnWorkspaceOrFolder)(s,i)?(await this.dialogMainService.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,h.basename)(i)),detail:(0,v.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async doEnterWorkspace(o,s){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.backupMainService.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,d.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=i,{workspace:s,backupPath:i}}};e.WorkspacesManagementMainService=a,e.WorkspacesManagementMainService=a=Pe([ne(0,g.IEnvironmentMainService),ne(1,b.ILogService),ne(2,w.IUserDataProfilesMainService),ne(3,y.IBackupMainService),ne(4,E.IDialogMainService)],a)}),define(oe[134],ae([0,1,14,37,23,6,29,30,58,12,5,61]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,O.createDecorator)(e.ID);let E=class{constructor(m,b,w){this.windowsMainService=m,this.workspacesManagementMainService=b,this.logService=w}async getRemoteDiagnostics(m){const b=this.windowsMainService.getWindows();return(await Promise.all(b.map(async p=>{const d=p.remoteAuthority;if(!d)return;const c=`vscode:getDiagnosticInfoResponse${p.id}`,f={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.getFolderURIs(p):void 0};return new Promise(a=>{p.sendWhenReady("vscode:getDiagnosticInfo",I.CancellationToken.None,{replyChannel:c,args:f}),D.validatedIpcMain.once(c,(t,o)=>{o||a({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),a(o)}),setTimeout(()=>{a({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter(p=>!!p)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const m=[];for(const w of n.BrowserWindow.getAllWindows()){const p=this.windowsMainService.getWindowById(w.id);p?m.push(await this.codeWindowToInfo(p)):m.push(this.browserWindowToInfo(w))}const b=[];for(const{pid:w,name:p}of y.UtilityProcess.getAll())b.push({pid:w,name:p});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:b,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async codeWindowToInfo(m){const b=await this.getFolderURIs(m),w=(0,l.assertIsDefined)(m.win);return this.browserWindowToInfo(w,b,m.remoteAuthority)}browserWindowToInfo(m,b=[],w){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:b,remoteAuthority:w}}async getFolderURIs(m){const b=[],w=m.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(w))b.push(w.uri);else if((0,P.isWorkspaceIdentifier)(w)){const p=await this.workspacesManagementMainService.resolveLocalWorkspace(w.configPath);p&&p.folders.forEach(c=>{b.push(c.uri)})}return b}};e.DiagnosticsMainService=E,e.DiagnosticsMainService=E=Pe([ne(0,C.IWindowsMainService),ne(1,h.IWorkspacesManagementMainService),ne(2,v.ILogService)],E)}),define(oe[70],ae([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r,u,S,k,M,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,f.createDecorator)("nativeHostMainService");let A=class extends h.Disposable{constructor(_,z,j,ce,te,ue,X,Y,B){super(),this.windowsMainService=_,this.auxiliaryWindowsMainService=z,this.dialogMainService=j,this.lifecycleMainService=ce,this.environmentMainService=te,this.logService=ue,this.productService=X,this.themeMainService=Y,this.workspacesManagementMainService=B,this.onDidOpenMainWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,T=>T.id),this.onDidTriggerWindowSystemContextMenu=P.Event.any(P.Event.filter(P.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:T,x,y:V})=>({windowId:T.id,x,y:V})),({windowId:T})=>!!this.windowsMainService.getWindowById(T)),P.Event.filter(P.Event.map(this.auxiliaryWindowsMainService.onDidTriggerSystemContextMenu,({window:T,x,y:V})=>({windowId:T.id,x,y:V})),({windowId:T})=>!!this.auxiliaryWindowsMainService.getWindowById(T))),this.onDidMaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.windowsMainService.onDidMaximizeWindow,T=>T.id),T=>!!this.windowsMainService.getWindowById(T)),P.Event.filter(P.Event.map(this.auxiliaryWindowsMainService.onDidMaximizeWindow,T=>T.id),T=>!!this.auxiliaryWindowsMainService.getWindowById(T))),this.onDidUnmaximizeWindow=P.Event.any(P.Event.filter(P.Event.map(this.windowsMainService.onDidUnmaximizeWindow,T=>T.id),T=>!!this.windowsMainService.getWindowById(T)),P.Event.filter(P.Event.map(this.auxiliaryWindowsMainService.onDidUnmaximizeWindow,T=>T.id),T=>!!this.auxiliaryWindowsMainService.getWindowById(T))),this.onDidChangeWindowFullScreen=P.Event.any(P.Event.map(this.windowsMainService.onDidChangeFullScreen,T=>({windowId:T.window.id,fullscreen:T.fullscreen})),P.Event.map(this.auxiliaryWindowsMainService.onDidChangeFullScreen,T=>({windowId:T.window.id,fullscreen:T.fullscreen}))),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(T,x)=>x.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),T=>!!T),T=>T.id),P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(T,x)=>x.id),T=>!!this.windowsMainService.getWindowById(T))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(T,x)=>x.id),T=>!!this.auxiliaryWindowsMainService.getWindowById(T))),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.filter(P.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(T,x)=>x.id),T=>!!this.auxiliaryWindowsMainService.getWindowById(T))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(T,x,V)=>V),T=>!(Array.isArray(T)&&T.length===1&&T[0]==="workArea")),P.Event.fromNodeEventEmitter(D.screen,"display-added"),P.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(_,z){const j=this.windowsMainService.getWindows().map(te=>({id:te.id,workspace:te.openedWorkspace??(0,r.toWorkspaceIdentifier)(te.backupPath,te.isExtensionDevelopmentHost),title:te.win?.getTitle()??"",filename:te.getRepresentedFilename(),dirty:te.isDocumentEdited()})),ce=[];return z.includeAuxiliaryWindows&&ce.push(...this.auxiliaryWindowsMainService.getWindows().map(te=>({id:te.id,parentId:te.parentId,title:te.win?.getTitle()??"",filename:te.getRepresentedFilename()}))),[...j,...ce]}async getWindowCount(_){return this.windowsMainService.getWindowCount()}async getActiveWindowId(_){const z=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(z)return z.id}openWindow(_,z,j){return Array.isArray(z)?this.doOpenWindow(_,z,j):this.doOpenEmptyWindow(_,z)}async doOpenWindow(_,z,j=Object.create(null)){z.length>0&&await this.windowsMainService.open({context:5,contextWindowId:_,urisToOpen:z,cli:this.environmentMainService.args,forceNewWindow:j.forceNewWindow,forceReuseWindow:j.forceReuseWindow,preferNewWindow:j.preferNewWindow,diffMode:j.diffMode,mergeMode:j.mergeMode,addMode:j.addMode,gotoLineMode:j.gotoLineMode,noRecentEntry:j.noRecentEntry,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:j.remoteAuthority||void 0,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile})}async doOpenEmptyWindow(_,z){await this.windowsMainService.openEmptyWindow({context:5,contextWindowId:_},z)}async toggleFullScreen(_,z){this.windowById(z?.targetWindowId,_)?.toggleFullScreen()}async handleTitleDoubleClick(_,z){this.windowById(z?.targetWindowId,_)?.handleTitleDoubleClick()}async getCursorScreenPoint(_){const z=D.screen.getCursorScreenPoint(),j=D.screen.getDisplayNearestPoint(z);return{point:z,display:j.bounds}}async isMaximized(_,z){return this.windowById(z?.targetWindowId,_)?.win?.isMaximized()??!1}async maximizeWindow(_,z){this.windowById(z?.targetWindowId,_)?.win?.maximize()}async unmaximizeWindow(_,z){this.windowById(z?.targetWindowId,_)?.win?.unmaximize()}async minimizeWindow(_,z){this.windowById(z?.targetWindowId,_)?.win?.minimize()}async moveWindowTop(_,z){this.windowById(z?.targetWindowId,_)?.win?.moveTop()}async positionWindow(_,z,j){const ce=this.windowById(j?.targetWindowId,_);if(ce?.win){if(ce.win.isFullScreen()){const te=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(ce.win,"leave-full-screen")));ce.win.setFullScreen(!1),await te}ce.win.setBounds(z)}}async updateWindowControls(_,z){this.windowById(z?.targetWindowId,_)?.updateWindowControls(z)}async focusWindow(_,z){this.windowById(z?.targetWindowId,_)?.focus({force:z?.force??!1})}async setMinimumSize(_,z,j){const ce=this.codeWindowById(_);if(ce?.win){const[te,ue]=ce.win.getSize(),[X,Y]=ce.win.getMinimumSize(),[B,T]=[z??X,j??Y],[x,V]=[Math.max(te,B),Math.max(ue,T)];(X!==B||Y!==T)&&ce.win.setMinimumSize(B,T),(te!==x||ue!==V)&&ce.win.setSize(x,V)}}async saveWindowSplash(_,z){this.themeMainService.saveWindowSplash(_,z)}async installShellCommand(_){const{source:z,target:j}=await this.getShellCommandLink();try{const{symbolicLink:ce}=await b.SymlinkSupport.stat(z);if(ce&&!ce.dangling){const te=await(0,g.realpath)(z);if(j===te)return}await b.Promises.unlink(z)}catch(ce){if(ce.code!=="ENOENT")throw ce}try{await b.Promises.symlink(j,z)}catch(ce){if(ce.code!=="EACCES"&&ce.code!=="ENOENT")throw ce;const{response:te}=await this.showMessageBox(_,{type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,p.localize)(1,null),(0,p.localize)(2,null)]});if(te===1)throw new R.CancellationError;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${j}' '${z}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(ue)}catch{throw new Error((0,p.localize)(3,null,z))}}}async uninstallShellCommand(_){const{source:z}=await this.getShellCommandLink();try{await b.Promises.unlink(z)}catch(j){switch(j.code){case"EACCES":{const{response:ce}=await this.showMessageBox(_,{type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,p.localize)(5,null),(0,p.localize)(6,null)]});if(ce===1)throw new R.CancellationError;try{const te=`osascript -e "do shell script \\"rm '${z}'\\" with administrator privileges"`;await(0,O.promisify)(n.exec)(te)}catch{throw new Error((0,p.localize)(7,null,z))}break}case"ENOENT":break;default:throw j}}}async getShellCommandLink(){const _=(0,v.resolve)(this.environmentMainService.appRoot,"bin",this.productService.applicationName),z=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(_))throw new Error((0,p.localize)(8,null,_));return{source:z,target:_}}async showMessageBox(_,z){const j=this.windowById(z?.targetWindowId,_);return this.dialogMainService.showMessageBox(z,j?.win??void 0)}async showSaveDialog(_,z){const j=this.windowById(z?.targetWindowId,_);return this.dialogMainService.showSaveDialog(z,j?.win??void 0)}async showOpenDialog(_,z){const j=this.windowById(z?.targetWindowId,_);return this.dialogMainService.showOpenDialog(z,j?.win??void 0)}async pickFileFolderAndOpen(_,z){const j=await this.dialogMainService.pickFileFolder(z);j&&await this.doOpenPicked(await Promise.all(j.map(async ce=>await b.SymlinkSupport.existsDirectory(ce)?{folderUri:E.URI.file(ce)}:{fileUri:E.URI.file(ce)})),z,_)}async pickFolderAndOpen(_,z){const j=await this.dialogMainService.pickFolder(z);j&&await this.doOpenPicked(j.map(ce=>({folderUri:E.URI.file(ce)})),z,_)}async pickFileAndOpen(_,z){const j=await this.dialogMainService.pickFile(z);j&&await this.doOpenPicked(j.map(ce=>({fileUri:E.URI.file(ce)})),z,_)}async pickWorkspaceAndOpen(_,z){const j=await this.dialogMainService.pickWorkspace(z);j&&await this.doOpenPicked(j.map(ce=>({workspaceUri:E.URI.file(ce)})),z,_)}async doOpenPicked(_,z,j){await this.windowsMainService.open({context:3,contextWindowId:j,cli:this.environmentMainService.args,urisToOpen:_,forceNewWindow:z.forceNewWindow})}async showItemInFolder(_,z){D.shell.showItemInFolder(z)}async setRepresentedFilename(_,z,j){this.windowById(j?.targetWindowId,_)?.setRepresentedFilename(z)}async setDocumentEdited(_,z,j){this.windowById(j?.targetWindowId,_)?.setDocumentEdited(z)}async openExternal(_,z){return this.environmentMainService.unsetSnapExportedVariables(),D.shell.openExternal(z),this.environmentMainService.restoreSnapExportedVariables(),!0}moveItemToTrash(_,z){return D.shell.trashItem(z)}async isAdmin(){let _;return y.isWindows?_=(await new Promise((z,j)=>{Q(["native-is-elevated"],z,j)}))():_=process.getuid?.()===0,_}async writeElevated(_,z,j,ce){const te=await new Promise((ue,X)=>{Q(["@vscode/sudo-prompt"],ue,X)});return new Promise((ue,X)=>{const Y=[`"${this.cliPath}"`];ce?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${z.fsPath}"`,`"${j.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};te.exec(Y.join(" "),B,(T,x,V)=>{x&&this.logService.trace(`[sudo-prompt] received stdout: ${x}`),V&&this.logService.trace(`[sudo-prompt] received stderr: ${V}`),T?X(T):ue(void 0)})})}async isRunningUnderARM64Translation(){return y.isLinux||y.isWindows?!1:D.app.runningUnderARM64Translation}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,v.join)((0,v.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,v.join)(this.environmentMainService.appRoot,"bin",`${this.productService.applicationName}`):(0,v.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,I.totalmem)(),freemem:(0,I.freemem)(),loadavg:(0,I.loadavg)()}}async getOSProperties(){return{arch:(0,I.arch)(),platform:(0,I.platform)(),release:(0,I.release)(),type:(0,I.type)(),cpus:(0,I.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,k.hasWSLFeatureInstalled)()}async killProcess(_,z,j){process.kill(z,j)}async readClipboardText(_,z){return D.clipboard.readText(z)}async writeClipboardText(_,z,j){return D.clipboard.writeText(z,j)}async readClipboardFindText(_){return D.clipboard.readFindText()}async writeClipboardFindText(_,z){return D.clipboard.writeFindText(z)}async writeClipboardBuffer(_,z,j,ce){return D.clipboard.writeBuffer(z,Buffer.from(j.buffer),ce)}async readClipboardBuffer(_,z){return S.VSBuffer.wrap(D.clipboard.readBuffer(z))}async hasClipboard(_,z,j){return D.clipboard.has(z,j)}async newWindowTab(){await this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(_,z){this.codeWindowById(_)?.updateTouchBar(z)}async notifyReady(_){this.codeWindowById(_)?.setReady()}async relaunch(_,z){return this.lifecycleMainService.relaunch(z)}async reload(_,z){const j=this.codeWindowById(_);if(j){if((0,r.isWorkspaceIdentifier)(j.openedWorkspace)){const ce=j.openedWorkspace.configPath;if(ce.scheme===l.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ce))?.transient)return this.openWindow(j.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(j,z?.disableExtensions!==void 0?{_:[],"disable-extensions":z.disableExtensions}:void 0)}}async closeWindow(_,z){return this.windowById(z?.targetWindowId,_)?.win?.close()}async quit(_){const z=this.windowsMainService.getLastActiveWindow();z?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&z.win?z.win.close():this.lifecycleMainService.quit()}async exit(_,z){await this.lifecycleMainService.kill(z)}async resolveProxy(_,z){return this.codeWindowById(_)?.win?.webContents?.session?.resolveProxy(z)}async loadCertificates(_){return(await new Promise((j,ce)=>{Q(["@vscode/proxy-agent"],j,ce)})).loadSystemCertificates({log:this.logService})}findFreePort(_,z,j,ce,te=1){return(0,w.findFreePort)(z,j,ce,te)}async openDevTools(_,z){this.windowById(z?.targetWindowId,_)?.win?.webContents.openDevTools(z?.mode?{mode:z.mode,activate:z.activate}:void 0)}async toggleDevTools(_,z){this.windowById(z?.targetWindowId,_)?.win?.webContents.toggleDevTools()}async profileRenderer(_,z,j){const ce=this.codeWindowById(_);if(!ce||!ce.win)throw new Error;return await new M.WindowProfiler(ce.win,z,this.logService).inspect(j)}async windowsGetStringRegKey(_,z,j,ce){if(!y.isWindows)return;const te=await new Promise((ue,X)=>{Q(["@vscode/windows-registry"],ue,X)});try{return te.GetStringRegKey(z,j,ce)}catch{return}}windowById(_,z){return this.codeWindowById(_)??this.auxiliaryWindowById(_)??this.codeWindowById(z)}codeWindowById(_){if(typeof _=="number")return this.windowsMainService.getWindowById(_)}auxiliaryWindowById(_){if(typeof _=="number")return this.auxiliaryWindowsMainService.getWindowById(_)}};e.NativeHostMainService=A,Pe([C.memoize],A.prototype,"cliPath",null),e.NativeHostMainService=A=Pe([ne(0,i.IWindowsMainService),ne(1,L.IAuxiliaryWindowsMainService),ne(2,d.IDialogMainService),ne(3,a.ILifecycleMainService),ne(4,c.IEnvironmentMainService),ne(5,t.ILogService),ne(6,o.IProductService),ne(7,s.IThemeMainService),ne(8,u.IWorkspacesManagementMainService)],A)}),define(oe[303],ae([0,1,14,26,8,23,31,2,13,4,7,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const S="issue.processExplorerWindowState";let k=class{static{u=this}static{this.DEFAULT_BACKGROUND_COLOR="#1E1E1E"}constructor(R,A,F,_,z,j,ce,te,ue,X,Y){this.userEnv=R,this.environmentMainService=A,this.logService=F,this.diagnosticsService=_,this.diagnosticsMainService=z,this.dialogMainService=j,this.nativeHostMainService=ce,this.protocolMainService=te,this.productService=ue,this.stateService=X,this.windowsMainService=Y,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){E.validatedIpcMain.on("vscode:listProcesses",async R=>{const A=[];try{A.push({name:(0,g.localize)(0,null),rootProcess:await(0,y.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(_=>{(0,m.isRemoteDiagnosticError)(_)?A.push({name:_.hostName,rootProcess:_}):_.processes&&A.push({name:_.hostName,rootProcess:_.processes})})}catch(F){this.logService.error(`Listing processes failed: ${F}`)}this.safeSend(R,"vscode:listProcessesResponse",A)}),E.validatedIpcMain.on("vscode:workbenchCommand",(R,A)=>{const{id:F,from:_,args:z}=A;let j;switch(_){case"processExplorer":j=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${_}`)}j?.webContents.send("vscode:runAction",{id:F,from:_,args:z})}),E.validatedIpcMain.on("vscode:closeProcessExplorer",R=>{this.processExplorerWindow?.close()}),E.validatedIpcMain.on("vscode:pidToNameRequest",async R=>{const A=await this.diagnosticsMainService.getMainDiagnostics(),F=[];for(const _ of A.windows)F.push([_.pid,`window [${_.id}] (${_.title})`]);for(const{pid:_,name:z}of s.UtilityProcess.getAll())F.push([_,z]);this.safeSend(R,"vscode:pidToNameResponse",F)})}async openReporter(R){if(this.issueReporterWindow)this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow);else if(this.issueReporterParentWindow=n.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow){const A=new P.DisposableStore,F=A.add(this.protocolMainService.createIPCObjectUrl()),_=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(_,F,{backgroundColor:R.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:R.zoomLevel,alwaysOnTop:!1},"issue-reporter"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:R,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:f.default}),this.issueReporterWindow.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,A.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,A.dispose())})}}async openProcessExplorer(R){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=n.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const A=new P.DisposableStore,F=A.add(this.protocolMainService.createIPCObjectUrl()),_=this.stateService.getItem(S,void 0),z=M(_)?_:this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(z,F,{backgroundColor:R.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:R.zoomLevel,alwaysOnTop:!0},"process-explorer"),F.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:R,product:f.default}),this.processExplorerWindow.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,A.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,A.dispose())});const j=()=>{if(!this.processExplorerWindow)return;const ce=this.processExplorerWindow.getSize(),te=this.processExplorerWindow.getPosition();if(!ce||!te)return;const ue={width:ce[0],height:ce[1],x:te[0],y:te[1]};this.stateService.setItem(S,ue)};this.processExplorerWindow.on("moved",j),this.processExplorerWindow.on("resized",j)}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}async stopTracing(){if(!this.environmentMainService.args.trace)return;const R=await n.contentTracing.stopRecording(`${(0,C.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);await this.dialogMainService.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,R),buttons:[(0,g.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.nativeHostMainService.showItemInFolder(void 0,R)}async getSystemStatus(){const[R,A]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(R,A)}async $getSystemInfo(){const[R,A]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.diagnosticsService.getSystemInfo(R,A)}async $getPerformanceInfo(){try{const[R,A]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(R,A)}catch(R){throw this.logService.warn("issueService#getPerformanceInfo ",R.message),R}}async $reloadWithExtensionsDisabled(){if(this.issueReporterParentWindow)try{await this.nativeHostMainService.reload(this.issueReporterParentWindow.id,{disableExtensions:!0})}catch(R){this.logService.error(R)}}async $showConfirmCloseDialog(){if(this.issueReporterWindow){const{response:R}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.issueReporterWindow);R===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}}async $showClipboardDialog(){if(this.issueReporterWindow){const{response:R}=await this.dialogMainService.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.issueReporterWindow);return R===0}return!1}issueReporterWindowCheck(){if(!this.issueReporterParentWindow)throw new Error("Issue reporter window not available");const R=this.windowsMainService.getWindowById(this.issueReporterParentWindow.id);if(!R)throw new Error("Window not found");return R}async $getIssueReporterUri(R){const A=this.issueReporterWindowCheck(),F=`vscode:triggerIssueUriRequestHandlerResponse${A.id}`;return I.Promises.withAsyncBody(async(_,z)=>{const j=new O.CancellationTokenSource;A.sendWhenReady("vscode:triggerIssueUriRequestHandler",j.token,{replyChannel:F,extensionId:R}),E.validatedIpcMain.once(F,(ce,te)=>{_(v.URI.parse(te))});try{await(0,I.timeout)(5e3),j.cancel(),z(new Error("Timed out waiting for issue reporter URI"))}finally{E.validatedIpcMain.removeHandler(F)}})}async $getIssueReporterData(R){const A=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataProviderResponse${A.id}`;return I.Promises.withAsyncBody(async _=>{const z=new O.CancellationTokenSource;A.sendWhenReady("vscode:triggerIssueDataProvider",z.token,{replyChannel:F,extensionId:R}),E.validatedIpcMain.once(F,(j,ce)=>{_(ce)});try{await(0,I.timeout)(5e3),z.cancel(),_("Error: Extension timed out waiting for issue reporter data")}finally{E.validatedIpcMain.removeHandler(F)}})}async $getIssueReporterTemplate(R){const A=this.issueReporterWindowCheck(),F=`vscode:triggerIssueDataTemplateResponse${A.id}`;return I.Promises.withAsyncBody(async _=>{const z=new O.CancellationTokenSource;A.sendWhenReady("vscode:triggerIssueDataTemplate",z.token,{replyChannel:F,extensionId:R}),E.validatedIpcMain.once(F,(j,ce)=>{_(ce)});try{await(0,I.timeout)(5e3),z.cancel(),_("Error: Extension timed out waiting for issue reporter template")}finally{E.validatedIpcMain.removeHandler(F)}})}async $getReporterStatus(R,A){const F=[!1,!1],_=this.issueReporterWindowCheck(),z="vscode:triggerReporterStatus",j=new O.CancellationTokenSource;return _.sendWhenReady(z,j.token,{replyChannel:z,extensionId:R,extensionName:A}),await(0,I.raceTimeout)(new Promise(te=>E.validatedIpcMain.once("vscode:triggerReporterStatusResponse",(ue,X)=>te(X))),2e3,()=>{this.logService.error("Error: Extension timed out waiting for reporter status"),j.cancel()})??F}async $sendReporterMenu(R,A){const F=this.issueReporterWindowCheck(),_="vscode:triggerReporterMenu",z=new O.CancellationTokenSource;return F.sendWhenReady(_,z.token,{replyChannel:_,extensionId:R,extensionName:A}),await(0,I.raceTimeout)(new Promise(ce=>E.validatedIpcMain.once(`vscode:triggerReporterMenuResponse:${R}`,(te,ue)=>ce(ue))),5e3,()=>{this.logService.error(`Error: Extension ${R} timed out waiting for menu response`),z.cancel()})}async $closeReporter(){this.issueReporterWindow?.close()}async closeProcessExplorer(){this.processExplorerWindow?.close()}focusWindow(R){R.isMinimized()&&R.restore(),R.focus()}safeSend(R,A,...F){R.sender.isDestroyed()||R.sender.send(A,...F)}createBrowserWindow(R,A,F,_){const z=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:R.width,height:R.height,minWidth:300,minHeight:200,x:R.x,y:R.y,title:F.title,backgroundColor:F.backgroundColor||u.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${A.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.zoomLevelToZoomFactor)(F.zoomLevel),sandbox:!0},alwaysOnTop:F.alwaysOnTop,experimentalDarkMode:!0});return z.setMenuBarVisibility(!1),z}getWindowPosition(R,A,F){let _;const z=n.screen.getAllDisplays();if(z.length===1)_=z[0];else{if(l.isMacintosh){const te=n.screen.getCursorScreenPoint();_=n.screen.getDisplayNearestPoint(te)}!_&&R&&(_=n.screen.getDisplayMatching(R.getBounds())),_||(_=n.screen.getPrimaryDisplay()||z[0])}const j=_.bounds,ce={width:A,height:F,x:j.x+j.width/2-A/2,y:j.y+j.height/2-F/2};return j.width>0&&j.height>0&&(ce.x<j.x&&(ce.x=j.x),ce.y<j.y&&(ce.y=j.y),ce.x>j.x+j.width&&(ce.x=j.x),ce.y>j.y+j.height&&(ce.y=j.y),ce.width>j.width&&(ce.width=j.width),ce.height>j.height&&(ce.height=j.height)),ce}};e.IssueMainService=k,e.IssueMainService=k=u=Pe([ne(1,p.IEnvironmentMainService),ne(2,d.ILogService),ne(3,m.IDiagnosticsService),ne(4,b.IDiagnosticsMainService),ne(5,w.IDialogMainService),ne(6,c.INativeHostMainService),ne(7,t.IProtocolMainService),ne(8,a.IProductService),ne(9,o.IStateService),ne(10,r.IWindowsMainService)],k);function M(L){return typeof L!="object"||L===null?!1:"x"in L&&"y"in L&&"width"in L&&"height"in L}}),define(oe[304],ae([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let g=class extends E.AbstractUpdateService{constructor(b,w,p,d,c,f,a,t){super(b,w,d,c,f,t),this.telemetryService=p,this.nativeHostMainService=a}buildUpdateFeedUrl(b){return(0,E.createUpdateURL)(`linux-${process.arch}`,b,this.productService)}doCheckForUpdates(b){this.url&&(this.setState(y.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},n.CancellationToken.None).then(l.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w);const p=b?w.message||w:void 0;this.setState(y.State.Idle(1,p))}))}async doDownloadUpdate(b){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(y.State.Idle(1))}};e.LinuxUpdateService=g,e.LinuxUpdateService=g=Pe([ne(0,O.ILifecycleMainService),ne(1,D.IConfigurationService),ne(2,v.ITelemetryService),ne(3,I.IEnvironmentMainService),ne(4,l.IRequestService),ne(5,C.ILogService),ne(6,P.INativeHostMainService),ne(7,h.IProductService)],g)}),define(oe[305],ae([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(S,k=1e3){for(;!S();)await(0,O.timeout)(k)}let i;function r(){return typeof i>"u"&&(D.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?i=0:l.basename(l.normalize(l.join(process.execPath,"..","..")))==="Program Files"?i=3:i=1),i}let u=class extends o.AbstractUpdateService{get cachePath(){const k=l.join((0,I.tmpdir)(),`${this.productService.applicationName}-${this.productService.quality}-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(k,{recursive:!0}).then(()=>k)}constructor(k,M,L,R,A,F,_,z,j){super(k,M,R,A,F,j),this.telemetryService=L,this.fileService=_,this.nativeHostMainService=z,k.setRelaunchHandler(this)}handleRelaunch(k){return k?.addArgs||k?.removeArgs||this.state.type!=="ready"||!this.availableUpdate?!1:(this.logService.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.doQuitAndInstall(),!0)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.setState(t.State.Disabled(5)),this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.initialize()}buildUpdateFeedUrl(k){let M=`win32-${process.arch}`;switch(r()){case 1:M+="-archive";break;case 3:M+="-msi";break;default:this.productService.target==="user"?M+="-user":M+="-system"}return(0,o.createUpdateURL)(M,k,this.productService)}doCheckForUpdates(k){this.url&&(this.setState(t.State.CheckingForUpdates(k)),this.requestService.request({url:this.url},C.CancellationToken.None).then(f.asJson).then(M=>{const L=r();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!k}),this.setState(t.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(t.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(t.State.Downloading),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(R=>E.Promises.exists(R).then(A=>{if(A)return Promise.resolve(R);const F=`${R}.tmp`;return this.requestService.request({url:M.url},C.CancellationToken.None).then(_=>this.fileService.writeFile(v.URI.file(F),_.stream)).then(M.sha256hash?()=>(0,y.checksum)(F,M.sha256hash):()=>{}).then(()=>E.Promises.rename(F,R,!1)).then(()=>R)})).then(R=>{this.availableUpdate={packagePath:R},this.setState(t.State.Downloaded(M)),this.configurationService.getValue("update.enableWindowsBackgroundUpdates")?this.productService.target==="user"&&this.doApplyUpdate():this.setState(t.State.Ready(M))})))}).then(void 0,M=>{this.telemetryService.publicLog2("update:error",{messageHash:String((0,h.hash)(String(M)))}),this.logService.error(M);const L=k?M.message||M:void 0;this.setState(t.State.Idle(r(),L))}))}async doDownloadUpdate(k){k.update.url&&this.nativeHostMainService.openExternal(void 0,k.update.url),this.setState(t.State.Idle(r()))}async getUpdatePackagePath(k){const M=await this.cachePath;return l.join(M,`CodeSetup-${this.productService.quality}-${k}.exe`)}async cleanup(k=null){const M=k?F=>!new RegExp(`${this.productService.quality}-${k}\\.exe$`).test(F):()=>!0,L=await this.cachePath,A=(await E.Promises.readdir(L)).filter(M).map(async F=>{try{await E.Promises.unlink(l.join(L,F))}catch{}});await Promise.all(A)}async doApplyUpdate(){if(this.state.type!=="downloaded"||!this.availableUpdate)return Promise.resolve(void 0);const k=this.state.update;this.setState(t.State.Updating(k));const M=await this.cachePath;this.availableUpdate.updateFilePath=l.join(M,`CodeSetup-${this.productService.quality}-${k.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,n.spawn)(this.availableUpdate.packagePath,["/verysilent","/log",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(t.State.Idle(r()))});const R=`${this.productService.win32MutexName}-ready`,A=await new Promise((F,_)=>{Q(["@vscode/windows-mutex"],F,_)});s(()=>A.isActive(R)).then(()=>this.setState(t.State.Ready(k)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.availableUpdate.updateFilePath?D.unlinkSync(this.availableUpdate.updateFilePath):r()==3?(0,n.spawn)("msiexec.exe",["/i",this.availableUpdate.packagePath],{detached:!0,stdio:["ignore","ignore","ignore"]}):(0,n.spawn)(this.availableUpdate.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(k){if(this.state.type!=="idle")return;const M=r()==0&&this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.setState(t.State.Downloading),this.availableUpdate={packagePath:k},this.setState(t.State.Downloaded(L)),M?this.productService.target==="user"&&this.doApplyUpdate():this.setState(t.State.Ready(L))}};e.Win32UpdateService=u,Pe([P.memoize],u.prototype,"cachePath",null),e.Win32UpdateService=u=Pe([ne(0,w.ILifecycleMainService),ne(1,g.IConfigurationService),ne(2,a.ITelemetryService),ne(3,m.IEnvironmentMainService),ne(4,f.IRequestService),ne(5,p.ILogService),ne(6,b.IFileService),ne(7,d.INativeHostMainService),ne(8,c.IProductService)],u)}),define(oe[135],ae([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r,u,S,k,M,L,R,A,F,_,z,j,ce,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=e.BaseWindow=void 0;var ue;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(ue||(ue={}));class X extends P.Disposable{get lastFocusTime(){return this._lastFocusTime}get win(){return this._win}setWin(T){this._win=T,this._register(C.Event.fromNodeEventEmitter(T,"maximize")(()=>this._onDidMaximize.fire())),this._register(C.Event.fromNodeEventEmitter(T,"unmaximize")(()=>this._onDidUnmaximize.fire())),this._register(C.Event.fromNodeEventEmitter(T,"closed")(()=>{this._onDidClose.fire(),this.dispose()})),this._register(C.Event.fromNodeEventEmitter(T,"focus")(()=>{this._lastFocusTime=Date.now()})),this._register(C.Event.fromNodeEventEmitter(this._win,"enter-full-screen")(()=>this._onDidEnterFullScreen.fire())),this._register(C.Event.fromNodeEventEmitter(this._win,"leave-full-screen")(()=>this._onDidLeaveFullScreen.fire()));const x=!(0,k.hasNativeTitlebar)(this.configurationService);if(v.isMacintosh&&x&&T.setSheetOffset((0,v.isBigSurOrNewer)((0,g.release)())?28:22),x&&(v.isWindows&&(0,k.useWindowControlsOverlay)(this.configurationService)||v.isMacintosh)){const V=this.stateService.getItem(X.windowControlHeightStateStorageKey);V&&this.updateWindowControls({height:V})}v.isWindows&&x&&T.hookWindowMessage(278,()=>{const[U,le]=T.getPosition(),he=n.screen.getCursorScreenPoint(),K=he.x-U,W=he.y-le;return!(K>30&&W>=0&&W<=Math.max(T.getBounds().height*.15,35))||(T.setEnabled(!1),T.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:K,y:W})),0}),this.environmentMainService.args["open-devtools"]===!0&&T.webContents.openDevTools(),v.isMacintosh&&(this._register(this.onDidEnterFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})),this._register(this.onDidLeaveFullScreen(()=>{this.joinNativeFullScreenTransition?.complete(!0)})))}constructor(T,x,V,U){super(),this.configurationService=T,this.stateService=x,this.environmentMainService=V,this.logService=U,this._onDidClose=this._register(new C.Emitter),this.onDidClose=this._onDidClose.event,this._onDidMaximize=this._register(new C.Emitter),this.onDidMaximize=this._onDidMaximize.event,this._onDidUnmaximize=this._register(new C.Emitter),this.onDidUnmaximize=this._onDidUnmaximize.event,this._onDidTriggerSystemContextMenu=this._register(new C.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidEnterFullScreen=this._register(new C.Emitter),this.onDidEnterFullScreen=this._onDidEnterFullScreen.event,this._onDidLeaveFullScreen=this._register(new C.Emitter),this.onDidLeaveFullScreen=this._onDidLeaveFullScreen.event,this._lastFocusTime=Date.now(),this._win=null,this.hasWindowControlOverlay=(0,k.useWindowControlsOverlay)(this.configurationService),this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0}setRepresentedFilename(T){v.isMacintosh?this.win?.setRepresentedFilename(T):this.representedFilename=T}getRepresentedFilename(){return v.isMacintosh?this.win?.getRepresentedFilename():this.representedFilename}setDocumentEdited(T){v.isMacintosh&&this.win?.setDocumentEdited(T),this.documentEdited=T}isDocumentEdited(){return v.isMacintosh?!!this.win?.isDocumentEdited():!!this.documentEdited}focus(T){v.isMacintosh&&T?.force&&n.app.focus({steal:!0});const x=this.win;x&&(x.isMinimized()&&x.restore(),x.focus())}handleTitleDoubleClick(){const T=this.win;if(T)if(v.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":T.minimize();break;case"None":break;case"Maximize":default:T.isMaximized()?T.unmaximize():T.maximize()}else T.isMaximized()?T.unmaximize():T.maximize()}static{this.windowControlHeightStateStorageKey="windowControlHeight"}updateWindowControls(T){const x=this.win;if(x){if(T.height&&this.stateService.setItem(Y.windowControlHeightStateStorageKey,T.height),v.isWindows&&this.hasWindowControlOverlay)x.setTitleBarOverlay({color:T.backgroundColor?.trim()===""?void 0:T.backgroundColor,symbolColor:T.foregroundColor?.trim()===""?void 0:T.foregroundColor,height:T.height?T.height-1:void 0});else if(v.isMacintosh&&T.height!==void 0){const V=(T.height-15)/2;V?x.setWindowButtonPosition({x:V,y:V}):x.setWindowButtonPosition(null)}}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen,!1)}setFullScreen(T,x){(0,k.useNativeFullScreen)(this.configurationService)?this.setNativeFullScreen(T,x):this.setSimpleFullScreen(T)}get isFullScreen(){if(v.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean")return this.transientIsNativeFullScreen;const T=this.win,x=T?.isFullScreen(),V=T?.isSimpleFullScreen();return!!(x||V)}setNativeFullScreen(T,x){const V=this.win;V?.isSimpleFullScreen()&&V?.setSimpleFullScreen(!1),this.doSetNativeFullScreen(T,x)}doSetNativeFullScreen(T,x){if(v.isMacintosh){this.transientIsNativeFullScreen=T;const U=this.joinNativeFullScreenTransition=new D.DeferredPromise;(async()=>{const le=await Promise.race([U.p,(0,D.timeout)(1e4).then(()=>!1)]);this.joinNativeFullScreenTransition===U&&(this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,!le&&T&&x&&this.win&&!this.win.isFullScreen()&&(this.logService.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this._onDidLeaveFullScreen.fire()))})()}this.win?.setFullScreen(T)}setSimpleFullScreen(T){const x=this.win;x?.isFullScreen()&&this.doSetNativeFullScreen(!1,!1),x?.setSimpleFullScreen(T),x?.webContents.focus()}dispose(){super.dispose(),this._win=null}}e.BaseWindow=X;let Y=class extends X{get id(){return this._id}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){if(!this.config)return;const T=this.userDataProfilesService.profiles.find(x=>x.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&T?T:this.userDataProfilesService.getProfileForWorkspace(this.config.workspace??(0,L.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.userDataProfilesService.defaultProfile}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}constructor(T,x,V,U,le,he,K,W,N,Z,re,G,q,H,$,se,ee,de,pe,be,Ee){super(Z,be,U,x),this.loggerMainService=V,this.policyService=le,this.userDataProfilesService=he,this.fileService=K,this.applicationStorageMainService=W,this.storageMainService=N,this.themeMainService=re,this.workspacesManagementMainService=G,this.backupMainService=q,this.telemetryService=H,this.dialogMainService=$,this.lifecycleMainService=se,this.productService=ee,this.protocolMainService=de,this.windowsMainService=pe,this._onWillLoad=this._register(new C.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new C.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidDestroy=this._register(new C.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.customZoomLevel=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[De,_e]=this.restoreWindowState(T.state);this.windowState=De,this.logService.trace("window#ctor: using window state",De);const ye=this.windowState.mode===0||this.windowState.mode===3,J=Ee.invokeFunction(M.defaultBrowserWindowOptions,this.windowState,{show:!ye,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(J),(0,l.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.setWin(this._win);const fe=this.configurationService.getValue("window"),me=v.isMacintosh&&fe?.nativeTabs===!0;(v.isMacintosh||v.isWindows)&&_e&&(!me||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Ce=>typeof Ce=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ye&&((0,l.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0,!0),this._win.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.whenReadyCallbacks.push(T)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(T=>{function x(){V.dispose(),U.dispose(),T()}const V=this.onDidClose(()=>x()),U=this.onWillLoad(()=>x())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(x,V)=>this.onWindowError(2,{...V})),this._win.webContents.on("did-fail-load",(x,V,U)=>this.onWindowError(3,{reason:U,exitCode:V})),this._win.webContents.on("will-prevent-unload",x=>{x.preventDefault()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._register(this.onDidMaximize(()=>{this._config&&(this._config.maximized=!0)})),this._register(this.onDidUnmaximize(()=>{this._config&&(this._config.maximized=!1)})),this._register(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",I.CancellationToken.None)})),this._register(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",I.CancellationToken.None)})),this._register(this.configurationService.onDidChangeConfiguration(x=>this.onConfigurationUpdated(x))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(x=>this.onDidDeleteUntitledWorkspace(x)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(x,V)=>{const U=await this.getMarketplaceHeaders();V({cancel:!1,requestHeaders:Object.assign(x.requestHeaders,U)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,s.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(T,x){switch(T){case 2:this.logService.error(`CodeWindow: renderer process gone (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:T,reason:x?.reason,code:x?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){await this.destroyWindow(!1,!1),this.lifecycleMainService.quit();return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:U}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,E.localize)(0,null),(0,E.localize)(1,null),(0,E.localize)(2,null)],message:(0,E.localize)(3,null),detail:(0,E.localize)(4,null),checkboxLabel:this._config?.workspace?(0,E.localize)(5,null):void 0},this._win);if(V!==2){const le=V===0;await this.destroyWindow(le,U)}}else if(T===2){let V;x?V=(0,E.localize)(7,null,x.reason,x.exitCode??"<unknown>"):V=(0,E.localize)(6,null);const{response:U,checkboxChecked:le}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[this._config?.workspace?(0,E.localize)(8,null):(0,E.localize)(9,null),(0,E.localize)(10,null)],message:V,detail:this._config?.workspace?(0,E.localize)(11,null):(0,E.localize)(12,null),checkboxLabel:this._config?.workspace?(0,E.localize)(13,null):void 0},this._win),he=U===0;await this.destroyWindow(he,le)}break}}async destroyWindow(T,x){const V=this._config?.workspace;if(x&&V)try{const U=this.storageMainService.workspaceStorage(V);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.logService.error(U)}this._onDidDestroy.fire();try{if(T&&this._config){let U,le;(0,L.isSingleFolderWorkspaceIdentifier)(V)?U={folderUri:V.uri}:(0,L.isWorkspaceIdentifier)(V)?U={workspaceUri:V.configPath}:le=!0,(0,ce.firstOrDefault)(await this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:le,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this._win?.destroy()}}onDidDeleteUntitledWorkspace(T){this._config?.workspace?.id===T.id&&(this._config.workspace=void 0)}onConfigurationUpdated(T){if(!T||T.affectsConfiguration("window.menuBarVisibility")){const x=this.getMenuBarVisibility();x!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=x,this.setMenuBarVisibility(x))}if(!T||T.affectsConfiguration("http.proxy")){let x=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;x?.endsWith("/")&&(x=x.substr(0,x.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((x||"").indexOf("@")===-1&&(x!==this.currentHttpProxy||V!==this.currentNoProxy)){this.currentHttpProxy=x,this.currentNoProxy=V;const U=x||"",le=V?`${V},<local>`:"<local>";this.logService.trace(`Setting proxy to '${U}', bypassing '${le}'`),this._win.webContents.session.setProxy({proxyRules:U,proxyBypassRules:le,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:U,proxyBypassRules:le,pacScript:""})}}}addTabbedWindow(T){v.isMacintosh&&T.win&&this._win.addTabbedWindow(T.win)}load(T,x=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!x.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),x.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(T,x),this.readyState===0?this._config=T:this.pendingLoadConfig=T,this.readyState=1,this._win.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.environmentMainService.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new D.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:T.workspace,reason:x.isReload?3:V?2:1})}updateConfiguration(T,x){const V=(this._config??this.pendingLoadConfig)?.userEnv;if(V){const U=(0,d.isLaunchedFromCli)(V)&&!(0,d.isLaunchedFromCli)(T.userEnv),le=this.isExtensionDevelopmentHost;(U||le)&&(T.userEnv={...V,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),x.disableExtensions!==void 0&&(T["disable-extensions"]=x.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this._win.isMaximized(),T.partsSplash=this.themeMainService.getWindowSplash(),T.zoomLevel=this.getZoomLevel(),T.isCustomZoomLevel=typeof this.customZoomLevel=="number",T.isCustomZoomLevel&&T.partsSplash&&(T.partsSplash.zoomLevel=T.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),T.perfMarks=(0,l.getMarks)(),this.configObjectUrl.update(T)}async reload(T){const x=Object.assign({},this._config);x.workspace=await this.validateWorkspaceBeforeReload(x),delete x.filesToOpenOrCreate,delete x.filesToDiff,delete x.filesToMerge,delete x.filesToWait,this.isExtensionDevelopmentHost&&T&&(x.verbose=T.verbose,x.debugId=T.debugId,x.extensionEnvironment=T.extensionEnvironment,x["inspect-extensions"]=T["inspect-extensions"],x["inspect-brk-extensions"]=T["inspect-brk-extensions"],x["extensions-dir"]=T["extensions-dir"]),x.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),x.isInitialStartup=!1,x.policiesData=this.policyService.serialize(),x.continueOn=this.environmentMainService.continueOn,x.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile,home:this.userDataProfilesService.profilesHome},x.logLevel=this.loggerMainService.getLogLevel(),x.loggers={window:this.loggerMainService.getRegisteredLoggers(this.id),global:this.loggerMainService.getRegisteredLoggers()},this.load(x,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async validateWorkspaceBeforeReload(T){if((0,L.isWorkspaceIdentifier)(T.workspace)){const x=T.workspace.configPath;if(x.scheme===h.Schemas.file&&!await this.fileService.exists(x))return}else if((0,L.isSingleFolderWorkspaceIdentifier)(T.workspace)){const x=T.workspace.uri;if(x.scheme===h.Schemas.file&&!await this.fileService.exists(x))return}return T.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let V;try{V=n.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,A.defaultWindowState)();return{mode:3,display:V?V.id:void 0,width:this.windowState.width||U.width,height:this.windowState.height||U.height,x:this.windowState.x||0,y:this.windowState.y||0,zoomLevel:this.customZoomLevel}}const T=Object.create(null);let x;if(!v.isMacintosh&&this._win.isMaximized()?x=0:x=1,x===0?T.mode=0:T.mode=1,x===1||x===0){let V;x===1?V=this.getBounds():V=this._win.getNormalBounds(),T.x=V.x,T.y=V.y,T.width=V.width,T.height=V.height}return T.zoomLevel=this.customZoomLevel,T}restoreWindowState(T){(0,l.mark)("code/willRestoreCodeWindowState");let x=!1;if(T){this.customZoomLevel=T.zoomLevel;try{const V=n.screen.getAllDisplays();x=V.length>1,T=M.WindowStateValidator.validateWindowState(this.logService,T,V)}catch(V){this.logService.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[T||(0,A.defaultWindowState)(),x]}getBounds(){const[T,x]=this._win.getPosition(),[V,U]=this._win.getSize();return{x:T,y:x,width:V,height:U}}setFullScreen(T,x){super.setFullScreen(T,x),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",I.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}getMenuBarVisibility(){let T=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}setMenuBarVisibility(T,x=!0){v.isMacintosh||(T==="toggle"&&x&&this.send("vscode:showInfoMessage",(0,E.localize)(14,null)),T==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(T)}):this.doSetMenuBarVisibility(T))}doSetMenuBarVisibility(T){const x=this.isFullScreen;switch(T){case"classic":this._win.setMenuBarVisibility(!x),this._win.autoHideMenuBar=x;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}notifyZoomLevel(T){this.customZoomLevel=T}getZoomLevel(){return typeof this.customZoomLevel=="number"?this.customZoomLevel:this.configurationService.getValue("window")?.zoomLevel}close(){this._win?.close()}sendWhenReady(T,x,...V){this.isReady?this.send(T,...V):this.ready().then(()=>{x.isCancellationRequested||this.send(T,...V)})}send(T,...x){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this._win.webContents.send(T,...x)}catch(V){this.logService.warn(`Error sending IPC message to channel '${T}' of window ${this._id}: ${(0,O.toErrorMessage)(V)}`)}}}updateTouchBar(T){v.isMacintosh&&this.touchBarGroups.forEach((x,V)=>{const U=T[V];x.segments=this.createTouchBarGroupSegments(U)})}createTouchBar(){if(v.isMacintosh){for(let T=0;T<10;T++){const x=this.createTouchBarGroup();this.touchBarGroups.push(x)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(T=[]){const x=this.createTouchBarGroupSegments(T),V=new n.TouchBar.TouchBarSegmentedControl({segments:x,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",I.CancellationToken.None,{id:V.segments[U].id,from:"touchbar"})}});return V}createTouchBarGroupSegments(T=[]){return T.map(V=>{let U;V.icon&&!u.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===h.Schemas.file&&(U=n.nativeImage.createFromPath(y.URI.revive(V.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let le;return typeof V.title=="string"?le=V.title:le=V.title.value,{id:V.id,label:U?void 0:le,icon:U}})}dispose(){super.dispose(),this.loggerMainService.deregisterLoggers(this.id)}};e.CodeWindow=Y,e.CodeWindow=Y=Pe([ne(1,a.ILogService),ne(2,j.ILoggerMainService),ne(3,p.IEnvironmentMainService),ne(4,F.IPolicyService),ne(5,z.IUserDataProfilesMainService),ne(6,c.IFileService),ne(7,i.IApplicationStorageMainService),ne(8,i.IStorageMainService),ne(9,b.IConfigurationService),ne(10,S.IThemeMainService),ne(11,R.IWorkspacesManagementMainService),ne(12,m.IBackupMainService),ne(13,r.ITelemetryService),ne(14,w.IDialogMainService),ne(15,f.ILifecycleMainService),ne(16,t.IProductService),ne(17,o.IProtocolMainService),ne(18,M.IWindowsMainService),ne(19,_.IStateService),ne(20,te.IInstantiationService)],Y)}),define(oe[306],ae([0,1,14,4,18,24,20,5,34,55,135]),function(Q,e,n,D,I,O,C,P,h,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindow=void 0;let y=class extends v.BaseWindow{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(g,m,b,w,p,d){super(w,p,m,b),this.contents=g,this.lifecycleMainService=d,this.id=this.contents.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this._win||this._store.isDisposed||this.contents.isDestroyed())return;const g=n.BrowserWindow.fromWebContents(this.contents);g&&(this.logService.trace("[aux window] Claimed browser window instance"),this.setWin(g),g.setMenu(null),(D.isWindows||D.isLinux)&&(0,l.hasNativeTitlebar)(this.configurationService)&&g.setAutoHideMenuBar(!0),this.lifecycleMainService.registerAuxWindow(this))}};e.AuxiliaryWindow=y,e.AuxiliaryWindow=y=Pe([ne(1,O.IEnvironmentMainService),ne(2,P.ILogService),ne(3,I.IConfigurationService),ne(4,h.IStateService),ne(5,C.ILifecycleMainService)],y)}),define(oe[307],ae([0,1,14,3,2,13,37,306,6,5,82,29]),function(Q,e,n,D,I,O,C,P,h,l,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AuxiliaryWindowsMainService=void 0;let E=class extends I.Disposable{constructor(m,b){super(),this.instantiationService=m,this.logService=b,this._onDidMaximizeWindow=this._register(new D.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new D.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new D.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.registerListeners()}registerListeners(){n.app.on("browser-window-created",(m,b)=>{const w=this.getWindowById(b.id);w&&(this.logService.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),C.validatedIpcMain.handle("vscode:registerAuxiliaryWindow",async(m,b)=>{const w=this.getWindowById(m.sender.id);return w&&(this.logService.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=b),m.sender.id})}createWindow(m){return this.instantiationService.invokeFunction(y.defaultBrowserWindowOptions,this.validateWindowState(m),{webPreferences:{preload:O.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}validateWindowState(m){const b={},w=m.features.split(",");for(const d of w){const[c,f]=d.split("=");switch(c){case"width":b.width=parseInt(f,10);break;case"height":b.height=parseInt(f,10);break;case"left":b.x=parseInt(f,10);break;case"top":b.y=parseInt(f,10);break}}const p=y.WindowStateValidator.validateWindowState(this.logService,b)??(0,v.defaultAuxWindowState)();return this.logService.trace("[aux window] using window state",p),p}registerWindow(m){const b=new I.DisposableStore,w=this.instantiationService.createInstance(P.AuxiliaryWindow,m);this.windows.set(w.id,w),b.add((0,I.toDisposable)(()=>this.windows.delete(w.id))),b.add(w.onDidMaximize(()=>this._onDidMaximizeWindow.fire(w))),b.add(w.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire(w))),b.add(w.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:w,fullscreen:!0}))),b.add(w.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:w,fullscreen:!1}))),b.add(w.onDidTriggerSystemContextMenu(({x:p,y:d})=>this._onDidTriggerSystemContextMenu.fire({window:w,x:p,y:d}))),D.Event.once(w.onDidClose)(()=>b.dispose())}getWindowById(m){return this.windows.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,y.getLastFocused)(Array.from(this.windows.values()))}getWindows(){return Array.from(this.windows.values())}};e.AuxiliaryWindowsMainService=E,e.AuxiliaryWindowsMainService=E=Pe([ne(0,h.IInstantiationService),ne(1,l.ILogService)],E)}),define(oe[85],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,m.createDecorator)("workspacesHistoryMainService");let s=class extends P.Disposable{static{o=this}static{this.MAX_TOTAL_RECENT_ENTRIES=500}static{this.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList"}constructor(r,u,S,k,M){super(),this.logService=r,this.workspacesManagementMainService=u,this.lifecycleMainService=S,this.applicationStorageMainService=k,this.dialogMainService=M,this._onDidChangeRecentlyOpened=this._register(new O.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new I.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){let u=[],S=[];for(const M of r)if((0,d.isRecentWorkspace)(M))!this.workspacesManagementMainService.isUntitledWorkspace(M.workspace)&&!this.containsWorkspace(u,M.workspace)&&u.push(M);else if((0,d.isRecentFolder)(M))this.containsFolder(u,M.folderUri)||u.push(M);else{const L=this.containsFile(S,M.fileUri),R=M.fileUri.scheme===h.Schemas.file&&o.COMMON_FILES_FILTER.indexOf((0,v.basename)(M.fileUri))>=0;!L&&!R&&(S.push(M),l.isWindows&&M.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(M.fileUri.fsPath))}const k=await this.mergeEntriesFromStorage({workspaces:u,files:S});u=k.workspaces,S=k.files,u.length>o.MAX_TOTAL_RECENT_ENTRIES&&(u.length=o.MAX_TOTAL_RECENT_ENTRIES),S.length>o.MAX_TOTAL_RECENT_ENTRIES&&(S.length=o.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:u,files:S}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const u=L=>{const R=this.location(L);for(const A of r)if(v.extUriBiasedIgnorePathCase.isEqual(A,R))return!1;return!0},S=await this.getRecentlyOpened(),k=S.workspaces.filter(u),M=S.files.filter(u);(k.length!==S.workspaces.length||M.length!==S.files.length)&&(await this.saveRecentlyOpened({files:M,workspaces:k}),this._onDidChangeRecentlyOpened.fire(),l.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(r){if(r?.confirm){const{response:u}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null)],message:(0,g.localize)(2,null),detail:(0,g.localize)(3,null),cancelId:1});if(u!==0)return}await this.saveRecentlyOpened({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){return this.mergeEntriesFromStorage()}async mergeEntriesFromStorage(r){const u=new a.ResourceMap(M=>v.extUriBiasedIgnorePathCase.getComparisonKey(M));if(r?.workspaces)for(const M of r.workspaces)u.set(this.location(M),M);const S=new a.ResourceMap(M=>v.extUriBiasedIgnorePathCase.getComparisonKey(M));if(r?.files)for(const M of r.files)S.set(this.location(M),M);const k=await this.getRecentlyOpenedFromStorage();for(const M of k.workspaces){const L=u.get(this.location(M));L?L.label=L.label??M.label:u.set(this.location(M),M)}for(const M of k.files){const L=S.get(this.location(M));L?L.label=L.label??M.label:S.set(this.location(M),M)}return{workspaces:[...u.values()],files:[...S.values()]}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const u=this.applicationStorageMainService.get(o.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof u=="string")try{r=JSON.parse(u)}catch(S){this.logService.error("Unexpected error parsing opened paths list",S)}return(0,d.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(o.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(r)),-1,1)}location(r){return(0,d.isRecentFolder)(r)?r.folderUri:(0,d.isRecentFile)(r)?r.fileUri:r.workspace.configPath}containsWorkspace(r,u){return!!r.find(S=>(0,d.isRecentWorkspace)(S)&&S.workspace.id===u.id)}containsFolder(r,u){return!!r.find(S=>(0,d.isRecentFolder)(S)&&v.extUriBiasedIgnorePathCase.isEqual(S.folderUri,u))}containsFile(r,u){return!!r.find(S=>v.extUriBiasedIgnorePathCase.isEqual(S.fileUri,u))}static{this.MAX_MACOS_DOCK_RECENT_WORKSPACES=7}static{this.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10}static{this.MAX_WINDOWS_JUMP_LIST_ENTRIES=7}static{this.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"]}async handleWindowsJumpList(){l.isWindows&&(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!l.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(4,null),description:(0,g.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const M of n.app.getJumpListSettings().removedItems){const L=M.args;if(L){const R=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(L);R&&u.push(y.URI.parse(R[2]))}}await this.removeRecentlyOpened(u);let S=!1;const k=(0,D.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,o.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(M=>{const L=(0,d.isRecentWorkspace)(M)?M.workspace:M.folderUri,{title:R,description:A}=this.getWindowsJumpListLabel(L,M.label);let F;return y.URI.isUri(L)?F=`--folder-uri "${L.toString()}"`:(S=!0,F=`--file-uri "${L.configPath.toString()}"`),{type:"task",title:R.substr(0,255),description:A.substr(0,255),program:process.execPath,args:F,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&r.push({type:"custom",name:S?(0,g.localize)(6,null):(0,g.localize)(7,null),items:k})}r.push({type:"recent"});try{const u=n.app.setJumpList(r);u&&u!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.logService.warn("updateWindowsJumpList#setJumpList",u)}}getWindowsJumpListLabel(r,u){if(u)return{title:(0,C.splitRecentLabel)(u).name,description:u};if(y.URI.isUri(r))return{title:(0,v.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,g.localize)(8,null),description:""};let S=(0,v.basename)(r.configPath);return S.endsWith(c.WORKSPACE_EXTENSION)&&(S=S.substr(0,S.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(9,null,S),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,C.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!l.isMacintosh)return;n.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),u=[];let S=0;for(let M=0;M<r.workspaces.length&&S<o.MAX_MACOS_DOCK_RECENT_WORKSPACES;M++){const L=this.location(r.workspaces[M]);if(L.scheme===h.Schemas.file){const R=(0,v.originalFSPath)(L);await E.Promises.exists(R)&&(u.push(R),S++)}}const k=[];for(let M=0;M<r.files.length&&S<o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;M++){const L=this.location(r.files[M]);if(L.scheme===h.Schemas.file){const R=(0,v.originalFSPath)(L);if(o.COMMON_FILES_FILTER.includes((0,v.basename)(L))||u.includes(R))continue;await E.Promises.exists(R)&&(k.push(R),S++)}}k.reverse().forEach(M=>n.app.addRecentDocument(M)),u.reverse().forEach(M=>n.app.addRecentDocument(M))}};e.WorkspacesHistoryMainService=s,e.WorkspacesHistoryMainService=s=o=Pe([ne(0,w.ILogService),ne(1,f.IWorkspacesManagementMainService),ne(2,b.ILifecycleMainService),ne(3,p.IApplicationStorageMainService),ne(4,t.IDialogMainService)],s)}),define(oe[308],ae([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let i=class{static{o=this}static{this.lastKnownMenubarStorageKey="lastKnownMenubarData"}constructor(S,k,M,L,R,A,F,_,z,j,ce,te){this.updateService=S,this.configurationService=k,this.windowsMainService=M,this.environmentMainService=L,this.telemetryService=R,this.workspacesHistoryMainService=A,this.stateService=F,this.lifecycleMainService=_,this.logService=z,this.nativeHostMainService=j,this.productService=ce,this.auxiliaryWindowsMainService=te,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new D.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new D.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(C.isMacintosh||(0,f.hasNativeTitlebar)(k))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveMainWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const S=this.stateService.getItem(o.lastKnownMenubarStorageKey);S&&(S.menus&&(this.menubarMenus=S.menus),S.keybindings&&(this.keybindings=S.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,F,_)=>{this.runActionInRenderer({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id})},this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,F,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,F,_)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(A,F,_)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,F,_)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened({confirm:!0});const S=this.productService.youTubeUrl;S&&(this.fallbackMenuHandlers["workbench.action.openYouTubeUrl"]=()=>this.openUrl(S,"openYouTubeUrl"));const k=this.productService.requestFeatureUrl;k&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(k,"openUserVoiceUrl"));const M=this.productService.reportIssueUrl;M&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(M,"openReportIssues"));const L=this.productService.licenseUrl;L&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(C.language){const A=L.indexOf("?")>0?"&":"?";this.openUrl(`${L}${A}lang=${C.language}`,"openLicenseUrl")}else this.openUrl(L,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&L&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(S=>this.onDidChangeWindowsCount(S)),this.nativeHostMainService.onDidBlurMainWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusMainWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const S=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof S!="boolean"?!0:S}get currentEnableNativeTabs(){if(!C.isMacintosh)return!1;const S=this.configurationService.getValue("window.nativeTabs");return typeof S!="boolean"?!1:S}updateMenu(S,k){this.menubarMenus=S.menus,this.keybindings=S.keybindings,this.stateService.setItem(o.lastKnownMenubarStorageKey,S),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(S){C.isMacintosh&&(S.oldCount===0&&S.newCount>0||S.oldCount>0&&S.newCount===0)&&(this.closedLastWindow=S.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){if(!C.isMacintosh)return;const S=n.BrowserWindow.getFocusedWindow();this.noActiveMainWindow=!S||!!this.auxiliaryWindowsMainService.getWindowById(S.id),this.scheduleUpdateMenu()}install(){const S=n.Menu.getApplicationMenu();if(S&&this.oldMenus.push(S),Object.keys(this.menubarMenus).length===0){this.doSetApplicationMenu(C.isMacintosh?new n.Menu:null);return}const k=new n.Menu;let M;if(C.isMacintosh){const R=new n.Menu;M=new n.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),k.append(M)}if(C.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new n.Menu;R.append(new n.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),n.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:R});this.setMenuById(R,"File"),k.append(A)}if(this.shouldDrawMenu("Edit")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),k.append(A)}if(this.shouldDrawMenu("Selection")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),k.append(A)}if(this.shouldDrawMenu("View")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:R});this.setMenuById(R,"View"),k.append(A)}if(this.shouldDrawMenu("Go")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),k.append(A)}if(this.shouldDrawMenu("Run")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),k.append(A)}if(this.shouldDrawMenu("Terminal")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),k.append(A)}let L;if(this.shouldDrawMenu("Window")){const R=new n.Menu;L=new n.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(L&&k.append(L),this.shouldDrawMenu("Help")){const R=new n.Menu,A=new n.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),k.append(A)}k.items&&k.items.length>0?this.doSetApplicationMenu(k):this.doSetApplicationMenu(null),this.menuGC.schedule()}doSetApplicationMenu(S){if(n.Menu.setApplicationMenu(S),S)for(const k of this.auxiliaryWindowsMainService.getWindows())k.win?.setMenu(null)}setMacApplicationMenu(S){const k=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),M=this.getUpdateMenuItems();let L;if(this.shouldDrawMenu("Preferences")){const te=new n.Menu;this.setMenuById(te,"Preferences"),L=new n.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:te})}const R=new n.Menu,A=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:R}),F=new n.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),_=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),j=new n.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:async(te,ue,X)=>{const Y=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.confirmBeforeQuit(X)&&this.nativeHostMainService.quit(void 0)}})),ce=[k];ce.push(...M),L&&ce.push(r(),L),ce.push(r(),A,r(),F,_,z,r(),j),ce.forEach(te=>S.append(te))}async confirmBeforeQuit(S){if(this.windowsMainService.getWindowCount()===0)return!0;const k=this.configurationService.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.isKeyboardEvent(S)){const{response:M}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return M===0}return!0}shouldDrawMenu(S){if(!C.isMacintosh&&!(0,f.hasNativeTitlebar)(this.configurationService))return!1;switch(S){case"File":case"Help":if(C.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus&&!!this.menubarMenus[S];case"Window":if(C.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[S]}}setMenu(S,k){k.forEach(M=>{if((0,m.isMenubarMenuItemSeparator)(M))S.append(r());else if((0,m.isMenubarMenuItemSubmenu)(M)){const L=new n.Menu,R=new n.MenuItem({label:this.mnemonicLabel(M.label),submenu:L});this.setMenu(L,M.submenu.items),S.append(R)}else(0,m.isMenubarMenuItemRecentAction)(M)?S.append(this.createOpenRecentMenuItem(M)):(0,m.isMenubarMenuItemAction)(M)&&(M.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(S),C.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveMainWindow?this.fallbackMenuHandlers[M.id]?S.append(new n.MenuItem(this.likeAction(M.id,{label:this.mnemonicLabel(M.label),click:this.fallbackMenuHandlers[M.id]}))):S.append(this.createMenuItem(M.label,M.id,!1,M.checked)):S.append(this.createMenuItem(M.label,M.id,M.enabled!==!1,!!M.checked)):S.append(this.createMenuItem(M.label,M.id,M.enabled!==!1,!!M.checked)))})}setMenuById(S,k){this.menubarMenus&&this.menubarMenus[k]&&this.setMenu(S,this.menubarMenus[k].items)}insertCheckForUpdatesItems(S){const k=this.getUpdateMenuItems();k.length&&(k.forEach(M=>S.append(M)),S.append(r()))}createOpenRecentMenuItem(S){const k=P.URI.revive(S.uri),M=S.id,L=M==="openRecentFile"?{fileUri:k}:M==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new n.MenuItem(this.likeAction(M,{label:S.label,click:async(R,A,F)=>{const _=this.isOptionClick(F);(await this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[L],forceNewWindow:_,gotoLineMode:!1,remoteAuthority:S.remoteAuthority})).length>0||await this.workspacesHistoryMainService.removeRecentlyOpened([k])}},!1))}isOptionClick(S){return!!(S&&(!C.isMacintosh&&(S.ctrlKey||S.shiftKey)||C.isMacintosh&&(S.metaKey||S.altKey)))}isKeyboardEvent(S){return!!(S.triggeredByAccelerator||S.altKey||S.ctrlKey||S.metaKey||S.shiftKey)}createRoleMenuItem(S,k,M){const L={label:this.mnemonicLabel(S),role:M,enabled:!0};return new n.MenuItem(this.withKeybinding(k,L))}setMacWindowMenu(S){const k=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),M=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),L=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(h.localize(23,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(r()),A.push(this.createMenuItem(h.localize(24,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,M,r(),R,...A,r(),L].forEach(F=>S.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"idle":return[new n.MenuItem({label:this.mnemonicLabel(h.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.mnemonicLabel(h.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return C.isMacintosh?[]:[new n.MenuItem({label:this.mnemonicLabel(h.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.mnemonicLabel(h.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})];default:return[]}}createMenuItem(S,k,M,L){const R=this.mnemonicLabel(S),A=typeof k=="function"?k:(ce,te,ue)=>{const X=ce?ce.userSettingsLabel:null;let Y=k;Array.isArray(k)&&(Y=this.isOptionClick(ue)?k[1]:k[0]),X&&ue.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:X}):this.runActionInRenderer({type:"commandId",commandId:Y})},F=typeof M=="boolean"?M:this.windowsMainService.getWindowCount()>0,_=typeof L=="boolean"?L:!1,z={label:R,click:A,enabled:F};_&&(z.type="checkbox",z.checked=_);let j;return typeof k=="string"?j=k:Array.isArray(k)&&(j=k[0]),C.isMacintosh&&(j==="editor.action.clipboardCutAction"?z.role="cut":j==="editor.action.clipboardCopyAction"?z.role="copy":j==="editor.action.clipboardPasteAction"&&(z.role="paste"),j==="undo"?z.click=this.makeContextAwareClickHandler(A,{inDevTools:ce=>ce.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):j==="redo"?z.click=this.makeContextAwareClickHandler(A,{inDevTools:ce=>ce.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):j==="editor.action.selectAll"&&(z.click=this.makeContextAwareClickHandler(A,{inDevTools:ce=>ce.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.withKeybinding(j,z))}makeContextAwareClickHandler(S,k){return(M,L,R)=>{const A=n.BrowserWindow.getFocusedWindow();if(!A)return k.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return k.inDevTools(A.webContents.devToolsWebContents);S(M,L||A,R)}}runActionInRenderer(S){let k=n.BrowserWindow.getFocusedWindow();if(k){const L=this.auxiliaryWindowsMainService.getWindowById(k.id);L&&(k=this.windowsMainService.getWindowById(L.parentId)?.win??null)}if(!k){const L=this.windowsMainService.getLastActiveWindow();L?.win?.isMinimized()&&(k=L.win)}const M=k?this.windowsMainService.getWindowById(k.id):void 0;if(M){if(this.logService.trace("menubar#runActionInRenderer",S),C.isMacintosh&&!this.environmentMainService.isBuilt&&!M.isReady&&(S.type==="commandId"&&S.commandId==="workbench.action.toggleDevTools"||S.type!=="commandId"&&S.userSettingsLabel==="alt+cmd+i"))return!1;if(S.type==="commandId"){const L={id:S.commandId,from:"menu"};M.sendWhenReady("vscode:runAction",I.CancellationToken.None,L)}else{const L={userSettingsLabel:S.userSettingsLabel};M.sendWhenReady("vscode:runKeybinding",I.CancellationToken.None,L)}return!0}else return this.logService.trace("menubar#runActionInRenderer: no active window found",S),!1}withKeybinding(S,k){const M=typeof S=="string"?this.keybindings[S]:void 0;if(M?.label){if(M.isNative!==!1)k.accelerator=M.label,k.userSettingsLabel=M.userSettingsLabel;else if(typeof k.label=="string"){const L=k.label.indexOf("[");L>=0?k.label=`${k.label.substr(0,L)} [${M.label}]`:k.label=`${k.label} [${M.label}]`}}else k.accelerator=void 0;return k}likeAction(S,k,M=!k.accelerator){M&&(k=this.withKeybinding(S,k));const L=k.click;return k.click=(R,A,F)=>{this.reportMenuActionTelemetry(S),L?.(R,A,F)},k}openUrl(S,k){this.nativeHostMainService.openExternal(void 0,S),this.reportMenuActionTelemetry(k)}reportMenuActionTelemetry(S){this.telemetryService.publicLog2("workbenchActionExecuted",{id:S,from:s})}mnemonicLabel(S){return(0,O.mnemonicMenuLabel)(S,!this.currentEnableMenuBarMnemonics)}};e.Menubar=i,e.Menubar=i=o=Pe([ne(0,c.IUpdateService),ne(1,v.IConfigurationService),ne(2,a.IWindowsMainService),ne(3,y.IEnvironmentMainService),ne(4,d.ITelemetryService),ne(5,t.IWorkspacesHistoryMainService),ne(6,p.IStateService),ne(7,E.ILifecycleMainService),ne(8,g.ILogService),ne(9,b.INativeHostMainService),ne(10,w.IProductService),ne(11,l.IAuxiliaryWindowsMainService)],i);function r(){return new n.MenuItem({type:"separator"})}}),define(oe[309],ae([0,1,6,20,5,308]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,n.createDecorator)("menubarMainService");let C=class{constructor(h,l,v){this.instantiationService=h,this.lifecycleMainService=l,this.logService=v,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(O.Menubar)}async updateMenubar(h,l){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(l,h)}};e.MenubarMainService=C,e.MenubarMainService=C=Pe([ne(0,n.IInstantiationService),ne(1,D.ILifecycleMainService),ne(2,I.ILogService)],C)}),define(oe[310],ae([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r,u,S,k,M,L,R,A,F,_,z,j,ce,te,ue,X,Y,B,T,x,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U(K){return(0,ce.isWorkspaceIdentifier)(K?.workspace)}function le(K){return(0,ce.isSingleFolderWorkspaceIdentifier)(K?.workspace)}let he=class extends y.Disposable{constructor(W,N,Z,re,G,q,H,$,se,ee,de,pe,be,Ee,De,_e,ye,J,fe,me){super(),this.machineId=W,this.sqmId=N,this.initialUserEnv=Z,this.logService=re,this.loggerService=G,this.stateService=q,this.policyService=H,this.environmentMainService=$,this.userDataProfilesMainService=se,this.lifecycleMainService=ee,this.backupMainService=de,this.configurationService=pe,this.workspacesHistoryMainService=be,this.workspacesManagementMainService=Ee,this.instantiationService=De,this.dialogMainService=_e,this.fileService=ye,this.protocolMainService=J,this.themeMainService=fe,this.auxiliaryWindowsMainService=me,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidMaximizeWindow=this._register(new h.Emitter),this.onDidMaximizeWindow=this._onDidMaximizeWindow.event,this._onDidUnmaximizeWindow=this._register(new h.Emitter),this.onDidUnmaximizeWindow=this._onDidUnmaximizeWindow.event,this._onDidChangeFullScreen=this._register(new h.Emitter),this.onDidChangeFullScreen=this._onDidChangeFullScreen.event,this._onDidTriggerSystemContextMenu=this._register(new h.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windows=new Map,this.windowsStateHandler=this._register(new j.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(W=>this._onDidSignalReadyWindow.fire(W.window))),this._register(this.onDidSignalReadyWindow(W=>{if(W.config?.extensionDevelopmentPath||W.config?.extensionTestsPath){const N=new y.DisposableStore;if(N.add(h.Event.any(W.onDidClose,W.onDidDestroy)(()=>N.dispose())),W.config.extensionDevelopmentPath)for(const Z of W.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(Z));W.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(W.config.extensionTestsPath))}}))}openEmptyWindow(W,N){const Z=this.environmentMainService.args,re=N?.remoteAuthority||void 0,G=!0,q=N?.forceReuseWindow,H=!q;return this.open({...W,cli:Z,forceEmpty:G,forceNewWindow:H,forceReuseWindow:q,remoteAuthority:re})}openExistingWindow(W,N){W.focus(),this.handleWaitMarkerFile(N,[W])}async open(W){this.logService.trace("windowsManager#open"),W.addMode&&(W.initialStartup||!this.getLastActiveWindow())&&(W.addMode=!1);const N=[],Z=[],re=[],G=[],q=[];let H,$=0;const se=await this.getPathsToOpen(W);this.logService.trace("windowsManager#open pathsToOpen",se);for(const Ee of se)le(Ee)?W.addMode?N.push(Ee):Z.push(Ee):U(Ee)?re.push(Ee):Ee.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ee.remoteAuthority}),H.filesToOpenOrCreate.push(Ee)):Ee.backupPath?q.push({backupFolder:(0,g.basename)(Ee.backupPath),remoteAuthority:Ee.remoteAuthority}):$++;W.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),W.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&W.waitMarkerFileURI&&(H.filesToWait={paths:(0,C.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:W.waitMarkerFileURI}),W.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspaces()),re.push(...G),q.push(...this.backupMainService.getEmptyWindowBackups())):q.length=0;const{windows:ee,filesOpenedInWindow:de}=await this.doOpen(W,re,Z,q,$,H,N);if(this.logService.trace(`windowsManager#open used window count ${ee.length} (workspacesToOpen: ${re.length}, foldersToOpen: ${Z.length}, emptyToRestore: ${q.length}, emptyToOpen: ${$})`),ee.length>1)if(de)de.focus();else{const Ee=this.windowsStateHandler.state.lastActiveWindow&&!W.forceEmpty&&!W.cli._.length&&!W.cli["file-uri"]&&!W.cli["folder-uri"]&&!(W.urisToOpen&&W.urisToOpen.length);let De=!0,_e=!0;if(Ee){const ye=ee.filter(J=>this.windowsStateHandler.state.lastActiveWindow&&J.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),De=!1,_e=!1)}if(De)for(let ye=ee.length-1;ye>=0;ye--){const J=ee[ye];if(!(J.openedWorkspace&&G.some(fe=>J.openedWorkspace&&fe.workspace.id===J.openedWorkspace.id)||J.backupPath&&q.some(fe=>J.backupPath&&fe.backupFolder===(0,g.basename)(J.backupPath)))){J.focus(),_e=!1;break}}_e&&ee[ee.length-1].focus()}const pe=H&&H.filesToDiff.length>0,be=H&&H.filesToMerge.length>0;if(!ee.some(Ee=>Ee.isExtensionDevelopmentHost)&&!pe&&!be&&!W.noRecentEntry){const Ee=[];for(const De of se)U(De)&&!De.transient?Ee.push({label:De.label,workspace:De.workspace,remoteAuthority:De.remoteAuthority}):le(De)?Ee.push({label:De.label,folderUri:De.workspace.uri,remoteAuthority:De.remoteAuthority}):De.fileUri&&Ee.push({label:De.label,fileUri:De.fileUri,remoteAuthority:De.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Ee)}return this.handleWaitMarkerFile(W,ee),ee}handleWaitMarkerFile(W,N){const Z=W.waitMarkerFileURI;W.context===0&&Z&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(Z)}catch{}})()}async doOpen(W,N,Z,re,G,q,H){const $=[];let se;function ee(ye,J){$.push(ye),J&&(se=ye,q=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:pe}=this.shouldOpenNewWindow(W);if(!W.initialStartup&&H.length>0){const ye=H[0].remoteAuthority,J=this.getLastActiveWindowForAuthority(ye);J&&ee(this.doAddFoldersToExistingWindow(J,H.map(fe=>fe.workspace.uri)))}const be=Z.length+N.length+re.length;if(q&&be===0){const ye=q.filesToOpenOrCreate[0]||q.filesToDiff[0]||q.filesToMerge[3],J=this.getWindows().filter(me=>q&&(0,p.isEqualAuthority)(me.remoteAuthority,q.remoteAuthority));let fe;ye?.fileUri&&!pe&&((W.context===4||W.context===0||W.context===1)&&(fe=await(0,z.findWindowOnFile)(J,ye.fileUri,async me=>me.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspace(me.configPath):void 0)),fe||(fe=this.doGetLastActiveWindow(J))),fe?(0,ce.isWorkspaceIdentifier)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ce.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)?Z.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):ee(this.doOpenFilesInExistingWindow(W,fe,q),!0):ee(await this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:W.forceNewTabbedWindow,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile}),!0)}const Ee=(0,C.distinct)(N,ye=>ye.workspace.id);if(Ee.length>0){const ye=(0,C.coalesce)(Ee.map(J=>(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),J.workspace.configPath)));if(ye.length>0){const J=ye[0],fe=(0,p.isEqualAuthority)(q?.remoteAuthority,J.remoteAuthority)?q:void 0;ee(this.doOpenFilesInExistingWindow(W,J,fe),!!fe),de=!0}for(const J of Ee){if(ye.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===J.workspace.id))continue;const fe=J.remoteAuthority,me=(0,p.isEqualAuthority)(q?.remoteAuthority,fe)?q:void 0;ee(await this.doOpenFolderOrWorkspace(W,J,de,me),!!me),de=!0}}const De=(0,C.distinct)(Z,ye=>p.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(De.length>0){const ye=(0,C.coalesce)(De.map(J=>(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),J.workspace.uri)));if(ye.length>0){const J=ye[0],fe=(0,p.isEqualAuthority)(q?.remoteAuthority,J.remoteAuthority)?q:void 0;ee(this.doOpenFilesInExistingWindow(W,J,fe),!!fe),de=!0}for(const J of De){if(ye.some(Ce=>(0,ce.isSingleFolderWorkspaceIdentifier)(Ce.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Ce.openedWorkspace.uri,J.workspace.uri)))continue;const fe=J.remoteAuthority,me=(0,p.isEqualAuthority)(q?.remoteAuthority,fe)?q:void 0;ee(await this.doOpenFolderOrWorkspace(W,J,de,me),!!me),de=!0}}const _e=(0,C.distinct)(re,ye=>ye.backupFolder);if(_e.length>0)for(const ye of _e){const J=ye.remoteAuthority,fe=(0,p.isEqualAuthority)(q?.remoteAuthority,J)?q:void 0;ee(await this.doOpenEmpty(W,!0,J,fe,ye),!!fe),de=!0}if($.length===0||q){q&&!G&&G++;const ye=q?q.remoteAuthority:W.remoteAuthority;for(let J=0;J<G;J++)ee(await this.doOpenEmpty(W,de,ye,q),!!q),de=!0}return{windows:(0,C.distinct)($),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(W,N,Z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:Z}),this.focusMainOrChildWindow(N);const re={filesToOpenOrCreate:Z?.filesToOpenOrCreate,filesToDiff:Z?.filesToDiff,filesToMerge:Z?.filesToMerge,filesToWait:Z?.filesToWait,termProgram:W?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",P.CancellationToken.None,re),N}focusMainOrChildWindow(W){let N=W;const Z=n.BrowserWindow.getFocusedWindow();if(Z&&Z.id!==W.id){const re=this.auxiliaryWindowsMainService.getWindowById(Z.id);re&&re.parentId===W.id&&(N=re)}N.focus()}doAddFoldersToExistingWindow(W,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),W.focus();const Z={foldersToAdd:N};return W.sendWhenReady("vscode:addFolders",P.CancellationToken.None,Z),W}doOpenEmpty(W,N,Z,re,G){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!G,remoteAuthority:Z,filesToOpen:re,forceNewWindow:N});let q;return!N&&typeof W.contextWindowId=="number"&&(q=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:Z,forceNewWindow:N,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:re,windowToUse:q,emptyWindowBackupInfo:G,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}doOpenFolderOrWorkspace(W,N,Z,re,G){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:re}),!Z&&!G&&typeof W.contextWindowId=="number"&&(G=this.getWindowById(W.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:W.userEnv,cli:W.cli,initialStartup:W.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:Z,forceNewTabbedWindow:W.forceNewTabbedWindow,filesToOpen:re,windowToUse:G,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile})}async getPathsToOpen(W){let N,Z=!1,re=!1;if(W.urisToOpen&&W.urisToOpen.length>0?(N=await this.doExtractPathsFromAPI(W),Z=!0):W.forceEmpty?N=[Object.create(null)]:W.cli._.length||W.cli["folder-uri"]||W.cli["file-uri"]?(N=await this.doExtractPathsFromCLI(W.cli),N.length===0&&N.push(Object.create(null)),Z=!0):(N=await this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),re=!0),!W.addMode&&Z){const G=N.filter(q=>le(q));if(G.length>1){const q=G[0].remoteAuthority;if(G.every(H=>(0,p.isEqualAuthority)(H.remoteAuthority,q))){const H=await this.workspacesManagementMainService.createUntitledWorkspace(G.map($=>({uri:$.workspace.uri})));N.push({workspace:H,remoteAuthority:q}),N=N.filter($=>!le($))}}}if(W.initialStartup&&!re&&this.configurationService.getValue("window")?.restoreWindows==="preserve"){const G=await this.doGetPathsFromLastSession();N.unshift(...G.filter(q=>U(q)||le(q)||q.backupPath))}return N}async doExtractPathsFromAPI(W){const N={gotoLineMode:W.gotoLineMode,remoteAuthority:W.remoteAuthority},Z=await Promise.all((0,C.coalesce)(W.urisToOpen||[]).map(async re=>{const G=await this.resolveOpenable(re,N);if(G)return G.label=re.label,G;const q=this.resourceFromOpenable(re);this.dialogMainService.showMessageBox({type:"info",buttons:[(0,f.localize)(0,null)],message:q.scheme===E.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:q.scheme===E.Schemas.file?(0,f.localize)(3,null,(0,v.getPathLabel)(q,{os:b.OS,tildify:this.environmentMainService})):(0,f.localize)(4,null,q.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.coalesce)(Z)}async doExtractPathsFromCLI(W){const N=[],Z={ignoreFileNotFound:!0,gotoLineMode:W.goto,remoteAuthority:W.remote||void 0,forceOpenWorkspaceAsFile:W.diff&&W._.length===2||W.merge&&W._.length===4},re=W["folder-uri"];if(re){const H=await Promise.all(re.map($=>{const se=this.cliArgToUri($);if(se)return this.resolveOpenable({folderUri:se},Z)}));N.push(...(0,C.coalesce)(H))}const G=W["file-uri"];if(G){const H=await Promise.all(G.map($=>{const se=this.cliArgToUri($);if(se)return this.resolveOpenable((0,ce.hasWorkspaceFileExtension)($)?{workspaceUri:se}:{fileUri:se},Z)}));N.push(...(0,C.coalesce)(H))}const q=await Promise.all(W._.map(H=>Z.remoteAuthority?this.doResolveRemotePath(H,Z):this.doResolveFilePath(H,Z)));return N.push(...(0,C.coalesce)(q)),N}cliArgToUri(W){try{const N=c.URI.parse(W);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${W}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.logService.error(`Invalid URI input string: ${W}, ${N.message}`)}}async doGetPathsFromLastSession(){const W=this.getRestoreWindowsSetting();switch(W){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];W!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const Z=await Promise.all(N.map(async re=>{if(re.workspace){const G=await this.resolveOpenable({workspaceUri:re.workspace.configPath},{remoteAuthority:re.remoteAuthority,rejectTransientWorkspaces:!0});if(U(G))return G}else if(re.folderUri){const G=await this.resolveOpenable({folderUri:re.folderUri},{remoteAuthority:re.remoteAuthority});if(le(G))return G}else if(W!=="folders"&&re.backupPath)return{backupPath:re.backupPath,remoteAuthority:re.remoteAuthority}}));return(0,C.coalesce)(Z)}}}getRestoreWindowsSetting(){let W;return this.lifecycleMainService.wasRestarted?W="all":(W=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(W)||(W="all")),W}async resolveOpenable(W,N=Object.create(null)){const Z=this.resourceFromOpenable(W);return Z.scheme===E.Schemas.file?((0,A.isFileToOpen)(W)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(Z.fsPath,N)):this.doResolveRemoteOpenable(W,N)}doResolveRemoteOpenable(W,N){let Z=this.resourceFromOpenable(W);const re=(0,L.getRemoteAuthority)(Z)||N.remoteAuthority;if(Z=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(Z)),(0,A.isFileToOpen)(W)){if(N.gotoLineMode){const{path:G,line:q,column:H}=(0,l.parseLineAndColumnAware)(Z.path);return{fileUri:Z.with({path:G}),options:{selection:q?{startLineNumber:q,startColumn:H||1}:void 0},remoteAuthority:re}}return{fileUri:Z,remoteAuthority:re}}else if((0,A.isWorkspaceToOpen)(W))return{workspace:(0,te.getWorkspaceIdentifier)(Z),remoteAuthority:re};return{workspace:(0,te.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:re}}resourceFromOpenable(W){return(0,A.isWorkspaceToOpen)(W)?W.workspaceUri:(0,A.isFolderToOpen)(W)?W.folderUri:W.fileUri}async doResolveFilePath(W,N,Z){let re,G;N.gotoLineMode&&({path:W,line:re,column:G}=(0,l.parseLineAndColumnAware)(W)),W=(0,l.sanitizeFilePath)((0,g.normalize)(W),(0,w.cwd)());try{const q=await D.Promises.stat(W);if(q.isFile()){if(!N.forceOpenWorkspaceAsFile){const H=await this.workspacesManagementMainService.resolveLocalWorkspace(c.URI.file(W));if(H)return H.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:H.id,configPath:H.configPath},type:i.FileType.File,exists:!0,remoteAuthority:H.remoteAuthority,transient:H.transient}}return{fileUri:c.URI.file(W),type:i.FileType.File,exists:!0,options:{selection:re?{startLineNumber:re,startColumn:G||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,te.getSingleFolderWorkspaceIdentifier)(c.URI.file(W),q),type:i.FileType.Directory,exists:!0};if(!b.isWindows&&W==="/dev/null")return{fileUri:c.URI.file(W),type:i.FileType.File,exists:!0}}}catch(q){if(q.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!Z)return this.onUNCHostNotAllowed(W,N);const H=c.URI.file(W);if(this.workspacesHistoryMainService.removeRecentlyOpened([H]),N.ignoreFileNotFound)return{fileUri:H,type:i.FileType.File,exists:!1}}}async onUNCHostNotAllowed(W,N){const Z=c.URI.file(W),{response:re,checkboxChecked:G}=await this.dialogMainService.showMessageBox({type:"warning",buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null),(0,f.localize)(7,null)],message:(0,f.localize)(8,null,Z.authority),detail:(0,f.localize)(9,null,(0,v.getPathLabel)(Z,{os:b.OS,tildify:this.environmentMainService})),checkboxLabel:(0,f.localize)(10,null,Z.authority),cancelId:1});if(re===0){if((0,I.addUNCHostToAllowlist)(Z.authority),G){const q={channel:"vscode:configureAllowedUNCHost",args:Z.authority};this.sendToFocused(q.channel,q.args),this.sendToOpeningWindow(q.channel,q.args)}return this.doResolveFilePath(W,N,!0)}if(re===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.onUNCHostNotAllowed(W,N)}doResolveRemotePath(W,N){const Z=W.charCodeAt(0),re=N.remoteAuthority;let G,q;N.gotoLineMode&&({path:W,line:G,column:q}=(0,l.parseLineAndColumnAware)(W)),Z!==47&&((0,l.isWindowsDriveLetter)(Z)&&W.charCodeAt(W.charCodeAt(1))===58&&(W=(0,l.toSlashes)(W)),W=`/${W}`);const H=c.URI.from({scheme:E.Schemas.vscodeRemote,authority:re,path:W});if(W.charCodeAt(W.length-1)!==47){if((0,ce.hasWorkspaceFileExtension)(W))return N.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:G?{startLineNumber:G,startColumn:q||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,te.getWorkspaceIdentifier)(H),remoteAuthority:re};if(N.gotoLineMode||g.posix.basename(W).indexOf(".")!==-1)return{fileUri:H,options:{selection:G?{startLineNumber:G,startColumn:q||1}:void 0},remoteAuthority:re}}return{workspace:(0,te.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:re}}shouldOpenNewWindow(W){const N=this.configurationService.getValue("window"),Z=N?.openFoldersInNewWindow||"default",re=N?.openFilesInNewWindow||"off";let G=(W.preferNewWindow||W.forceNewWindow)&&!W.forceReuseWindow;!W.forceNewWindow&&!W.forceReuseWindow&&(Z==="on"||Z==="off")&&(G=Z==="on");let q=!1;return W.forceNewWindow||W.forceReuseWindow?q=!!W.forceNewWindow&&!W.forceReuseWindow:(b.isMacintosh?W.context===1&&(q=!0):W.context!==3&&W.context!==2&&!(W.userEnv&&W.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!W.cli.extensionDevelopmentPath&&(re==="on"||re==="off")&&(q=re==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:q}}async openExtensionDevelopmentHostWindow(W,N){const Z=(0,z.findWindowOnExtensionDevelopmentPath)(this.getWindows(),W);if(Z)return this.lifecycleMainService.reload(Z,N.cli),Z.focus(),[Z];let re=N.cli["folder-uri"]||[],G=N.cli["file-uri"]||[],q=N.cli._;if(!q.length&&!re.length&&!G.length&&!N.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ee=se?.workspace??se?.folderUri;ee&&(c.URI.isUri(ee)?ee.scheme===E.Schemas.file?q=[ee.fsPath]:re=[ee.toString()]:ee.configPath.scheme===E.Schemas.file?q=[(0,p.originalFSPath)(ee.configPath)]:G=[ee.configPath.toString()])}let H=N.remoteAuthority;for(const se of W)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=c.URI.parse(se),de=(0,L.getRemoteAuthority)(ee);de&&(H?(0,p.isEqualAuthority)(de,H)||this.logService.error("more than one extension development path authority"):H=de)}q=q.filter(se=>{const ee=c.URI.file(se);return(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:(0,p.isEqualAuthority)((0,L.getRemoteAuthority)(ee),H)}),re=re.filter(se=>{const ee=this.cliArgToUri(se);return ee&&(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,p.isEqualAuthority)((0,L.getRemoteAuthority)(ee),H):!1}),G=G.filter(se=>{const ee=this.cliArgToUri(se);return ee&&(0,z.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,p.isEqualAuthority)((0,L.getRemoteAuthority)(ee),H):!1}),N.cli._=q,N.cli["folder-uri"]=re,N.cli["file-uri"]=G;const $={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!q.length&&!re.length&&!G.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:H,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open($)}async openInBrowserWindow(W){const N=this.configurationService.getValue("window"),Z=this.getLastActiveWindow(),re=Z?.profile??this.userDataProfilesMainService.defaultProfile;let G;!W.forceNewWindow&&!W.forceNewTabbedWindow&&(G=W.windowToUse||Z,G&&G.focus());const q={...this.environmentMainService.args,...W.cli,machineId:this.machineId,sqmId:this.sqmId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:W.emptyWindowBackupInfo?(0,g.join)(this.environmentMainService.backupHome,W.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.userDataProfilesMainService.profilesHome,all:this.userDataProfilesMainService.profiles,profile:re},homeDir:this.environmentMainService.userHome.with({scheme:E.Schemas.file}).fsPath,tmpDir:this.environmentMainService.tmpDir.with({scheme:E.Schemas.file}).fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:W.remoteAuthority,workspace:W.workspace,userEnv:{...this.initialUserEnv,...W.userEnv},filesToOpenOrCreate:W.filesToOpen?.filesToOpenOrCreate,filesToDiff:W.filesToOpen?.filesToDiff,filesToMerge:W.filesToOpen?.filesToMerge,filesToWait:W.filesToOpen?.filesToWait,logLevel:this.loggerService.getLogLevel(),loggers:{window:[],global:this.loggerService.getRegisteredLoggers()},logsPath:this.environmentMainService.logsHome.with({scheme:E.Schemas.file}).fsPath,product:k.default,isInitialStartup:W.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),continueOn:this.environmentMainService.continueOn};if(G){const H=G.config;!q.extensionDevelopmentPath&&H?.extensionDevelopmentPath&&(q.extensionDevelopmentPath=H.extensionDevelopmentPath,q.extensionDevelopmentKind=H.extensionDevelopmentKind,q["enable-proposed-api"]=H["enable-proposed-api"],q.verbose=H.verbose,q["inspect-extensions"]=H["inspect-extensions"],q["inspect-brk-extensions"]=H["inspect-brk-extensions"],q.debugId=H.debugId,q.extensionEnvironment=H.extensionEnvironment,q["extensions-dir"]=H["extensions-dir"],q["disable-extensions"]=H["disable-extensions"]),q.loggers={global:q.loggers.global,window:H?.loggers.window??q.loggers.window}}else{const H=this.windowsStateHandler.getNewWindowState(q);(0,m.mark)("code/willCreateCodeWindow");const $=G=this.instantiationService.createInstance(F.CodeWindow,{state:H,extensionDevelopmentPath:q.extensionDevelopmentPath,isExtensionTestHost:!!q.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),W.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow($),this.windows.set($.id,$),this._onDidOpenWindow.fire($),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const se=new y.DisposableStore;se.add($.onDidSignalReady(()=>this._onDidSignalReadyWindow.fire($))),se.add(h.Event.once($.onDidClose)(()=>this.onWindowClosed($,se))),se.add(h.Event.once($.onDidDestroy)(()=>this.onWindowDestroyed($))),se.add($.onDidMaximize(()=>this._onDidMaximizeWindow.fire($))),se.add($.onDidUnmaximize(()=>this._onDidUnmaximizeWindow.fire($))),se.add($.onDidEnterFullScreen(()=>this._onDidChangeFullScreen.fire({window:$,fullscreen:!0}))),se.add($.onDidLeaveFullScreen(()=>this._onDidChangeFullScreen.fire({window:$,fullscreen:!1}))),se.add($.onDidTriggerSystemContextMenu(({x:de,y:pe})=>this._onDidTriggerSystemContextMenu.fire({window:$,x:de,y:pe})));const ee=(0,d.assertIsDefined)($.win?.webContents);ee.removeAllListeners("devtools-reload-page"),ee.on("devtools-reload-page",()=>this.lifecycleMainService.reload($)),this.lifecycleMainService.registerWindow($)}return q.windowId=G.id,G.isReady?this.lifecycleMainService.unload(G,4).then(async H=>{H||await this.doOpenInBrowserWindow(G,q,W,re)}):await this.doOpenInBrowserWindow(G,q,W,re),G}async doOpenInBrowserWindow(W,N,Z,re){if(N.extensionDevelopmentPath||((0,ce.isWorkspaceIdentifier)(N.workspace)?N.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ce.isSingleFolderWorkspaceIdentifier)(N.workspace)?N.backupPath=this.backupMainService.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.backupMainService.registerEmptyWindowBackup({backupFolder:Z.emptyWindowBackupInfo?.backupFolder??(0,te.createEmptyWorkspaceIdentifier)().id,remoteAuthority:N.remoteAuthority})),this.userDataProfilesMainService.isEnabled()){const G=N.workspace??(0,ce.toWorkspaceIdentifier)(N.backupPath,!1),q=this.resolveProfileForBrowserWindow(Z,G,re),H=q instanceof Promise?await q:q;N.profiles.profile=H,N.extensionDevelopmentPath||await this.userDataProfilesMainService.setProfileForWorkspace(G,H)}W.load(N)}resolveProfileForBrowserWindow(W,N,Z){return W.forceProfile?this.userDataProfilesMainService.profiles.find(re=>re.name===W.forceProfile)??this.userDataProfilesMainService.createNamedProfile(W.forceProfile):W.forceTempProfile?this.userDataProfilesMainService.createTransientProfile():this.userDataProfilesMainService.getProfileForWorkspace(N)??Z}onWindowClosed(W,N){this.windows.delete(W.id),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}onWindowDestroyed(W){this.windows.delete(W.id),this._onDidDestroyWindow.fire(W)}getFocusedWindow(){const W=n.BrowserWindow.getFocusedWindow();if(W)return this.getWindowById(W.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(W){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,p.isEqualAuthority)(N.remoteAuthority,W)))}doGetLastActiveWindow(W){return(0,_.getLastFocused)(W)}sendToFocused(W,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(W,P.CancellationToken.None,...N)}sendToOpeningWindow(W,...N){this._register(h.Event.once(this.onDidSignalReadyWindow)(Z=>{Z.sendWhenReady(W,P.CancellationToken.None,...N)}))}sendToAll(W,N,Z){for(const re of this.getWindows())Z&&Z.indexOf(re.id)>=0||re.sendWhenReady(W,P.CancellationToken.None,N)}getWindows(){return Array.from(this.windows.values())}getWindowCount(){return this.windows.size}getWindowById(W){return this.windows.get(W)}getWindowByWebContents(W){const N=n.BrowserWindow.fromWebContents(W);if(N)return this.getWindowById(N.id)}};e.WindowsMainService=he,e.WindowsMainService=he=Pe([ne(3,S.ILogService),ne(4,x.ILoggerMainService),ne(5,R.IStateService),ne(6,B.IPolicyService),ne(7,s.IEnvironmentMainService),ne(8,T.IUserDataProfilesMainService),ne(9,u.ILifecycleMainService),ne(10,a.IBackupMainService),ne(11,t.IConfigurationService),ne(12,ue.IWorkspacesHistoryMainService),ne(13,X.IWorkspacesManagementMainService),ne(14,r.IInstantiationService),ne(15,o.IDialogMainService),ne(16,i.IFileService),ne(17,M.IProtocolMainService),ne(18,Y.IThemeMainService),ne(19,V.IAuxiliaryWindowsMainService)],he)}),define(oe[311],ae([0,1,65,29,85,58]),function(Q,e,n,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(h,l,v,y){this.workspacesManagementMainService=h,this.windowsMainService=l,this.workspacesHistoryMainService=v,this.backupMainService=y,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const v=this.windowsMainService.getWindowById(h);if(v)return this.workspacesManagementMainService.enterWorkspace(v,this.windowsMainService.getWindows(),l)}createUntitledWorkspace(h,l,v){return this.workspacesManagementMainService.createUntitledWorkspace(l,v)}deleteUntitledWorkspace(h,l){return this.workspacesManagementMainService.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.workspacesManagementMainService.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(h,l){return this.workspacesHistoryMainService.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.workspacesHistoryMainService.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};e.WorkspacesMainService=C,e.WorkspacesMainService=C=Pe([ne(0,O.IWorkspacesManagementMainService),ne(1,D.IWindowsMainService),ne(2,I.IWorkspacesHistoryMainService),ne(3,n.IBackupMainService)],C)}),define(oe[312],ae([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r,u,S,k,M,L,R,A,F,_,z,j,ce,te,ue,X,Y,B,T,x,V,U,le,he,K,W,N,Z,re,G,q,H,$,se,ee,de,pe,be,Ee,De,_e,ye,J,fe,me,Ce,Ae,ze,Oe,Te,qe,je,Ke,xe,ie,ge,ve,Se,Ie,We,Ue,Ge,Je,Xe,Ye,rt,it,ot,at,bt,Et,Pt,It,Ct,lt,gt,kt,Dt,Mt,ct,Rt,mt,ut,Lt,At,ht,Wt,pt,Ot,vt){"use strict";var dt;Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ft=class extends g.Disposable{static{dt=this}static{this.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(ke,Me,Le,we,Re,Be,$e,Ve,Fe,Ne,He,Qe){super(),this.mainProcessNodeIpcServer=ke,this.userEnv=Me,this.mainInstantiationService=Le,this.logService=we,this.loggerService=Re,this.environmentMainService=Be,this.lifecycleMainService=$e,this.configurationService=Ve,this.stateService=Fe,this.fileService=Ne,this.productService=He,this.userDataProfilesMainService=Qe,this.configureSession(),this.registerListeners()}configureSession(){const ke=Fe=>Fe?.startsWith(`${m.Schemas.vscodeWebview}://`),Me=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,Ne,He,Qe)=>ke(Qe.requestingUrl)?He(Me.has(Ne)):He(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,Ne,He,Qe)=>ke(Qe.requestingUrl)?Me.has(Ne):!1);const Le=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Fe=>{for(let Ne=Fe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Re=Fe=>Fe.resourceType==="xhr"||we(Fe.frame),Be=Fe=>{const Ne=Fe.frame;if(!Ne||!this.windowsMainService)return!1;const He=n.BrowserWindow.getAllWindows();for(const Qe of He)if(Ne.processId===Qe.webContents.mainFrame.processId)return!0;return!1},$e=(Fe,Ne)=>{if(Fe.path!=="/index.html")return!0;const He=Ne.frame;if(!He||!this.windowsMainService)return!1;for(const Qe of this.windowsMainService.getWindows())if(Qe.win&&He.processId===Qe.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,Ne)=>{const He=d.URI.parse(Fe.url);return He.scheme===m.Schemas.vscodeWebview&&!$e(He,Fe)?(this.logService.error("Blocked vscode-webview request",Fe.url),Ne({cancel:!0})):He.scheme===m.Schemas.vscodeFileResource&&!Be(Fe)?(this.logService.error("Blocked vscode-file request",Fe.url),Ne({cancel:!0})):He.path.endsWith(".svg")&&!Le.has(He.scheme)?Ne({cancel:!Re(Fe)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,Ne)=>{const He=Fe.responseHeaders,Qe=He["content-type"]||He["Content-Type"];if(Qe&&Array.isArray(Qe)){const Ze=d.URI.parse(Fe.url);if(Ze.path.endsWith(".svg")&&Le.has(Ze.scheme))return He["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:He});if(!Ze.path.endsWith(m.Schemas.vscodeRemoteResource)&&Qe.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!Re(Fe)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,Ne)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const He=Fe.responseHeaders??Object.create(null);if(He["Access-Control-Allow-Origin"]===void 0)return He["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:He})}return Ne({cancel:!1})});const Ve=n.session.defaultSession;typeof Ve.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ve.setCodeCachePath((0,b.join)(this.environmentMainService.codeCachePath,"chrome")),w.isWindows&&(this.configurationService.getValue("security.restrictUNCAccess")===!1?(0,D.disableUNCAccessRestrictions)():(0,D.addUNCHostToAllowlist)(this.configurationService.getValue("security.allowedUNCHosts")))}registerListeners(){(0,h.setUnexpectedErrorHandler)(Le=>this.onUnexpectedError(Le)),process.on("uncaughtException",Le=>{(0,h.isSigPipeError)(Le)||(0,h.onUnexpectedError)(Le)}),process.on("unhandledRejection",Le=>(0,h.onUnexpectedError)(Le)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,f.registerContextMenuListener)(),n.app.on("accessibility-support-changed",(Le,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),n.app.on("activate",async(Le,we)=>{this.logService.trace("app#activate"),we||await this.windowsMainService?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Le,we)=>{we?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.VSCODE_AUTHORITY}/`)&&(this.logService.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.auxiliaryWindowsMainService?.registerWindow(we)),we.on("will-navigate",Re=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),we.setWindowOpenHandler(Re=>Re.url==="about:blank"?(this.logService.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.auxiliaryWindowsMainService?.createWindow(Re)}):(this.logService.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Re.url}}`),this.nativeHostMainService?.openExternal(void 0,Re.url),{action:"deny"}))});let ke=[],Me;n.app.on("open-file",(Le,we)=>{we=(0,vt.normalizeNFC)(we),this.logService.trace("app#open-file: ",we),Le.preventDefault(),ke.push((0,We.hasWorkspaceFileExtension)(we)?{workspaceUri:d.URI.file(we)}:{fileUri:d.URI.file(we)}),Me!==void 0&&(clearTimeout(Me),Me=void 0),Me=setTimeout(async()=>{await this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ke,gotoLineMode:!1,preferNewWindow:!0}),ke=[],Me=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.windowsMainService?.openEmptyWindow({context:4})}),I.validatedIpcMain.handle("vscode:fetchShellEnv",Le=>{const we=this.windowsMainService?.getWindowByWebContents(Le.sender);let Re,Be;return we?.config?(Re=we.config,Be={...process.env,...we.config.userEnv}):(Re=this.environmentMainService.args,Be=process.env),this.resolveShellEnvironment(Re,Be,!1)}),I.validatedIpcMain.handle("vscode:writeNlsFile",(Le,we,Re)=>{const Be=this.validateNlsPath([we]);if(!Be||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Be,C.VSBuffer.fromString(Re))}),I.validatedIpcMain.handle("vscode:readNlsFile",async(Le,...we)=>{const Re=this.validateNlsPath(we);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Re)).value.toString()}),I.validatedIpcMain.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),I.validatedIpcMain.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),I.validatedIpcMain.on("vscode:reloadWindow",Le=>Le.sender.reload()),I.validatedIpcMain.handle("vscode:notifyZoomLevel",async(Le,we)=>{const Re=this.windowsMainService?.getWindowById(Le.sender.id);Re&&Re.notifyZoomLevel(we)})}validateNlsPath(ke){let Me;for(const Le of ke)typeof Le=="string"&&(typeof Me!="string"?Me=Le:Me=(0,b.join)(Me,Le));if(!(typeof Me!="string"||!(0,b.isAbsolute)(Me)||!(0,l.isEqualOrParent)(Me,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return d.URI.file(Me)}onUnexpectedError(ke){if(ke){const Me={message:`[uncaught exception in main]: ${ke.message}`,stack:ke.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${ke}`),ke.stack&&this.logService.error(ke.stack)}async startup(){this.logService.debug("Starting VSCodium"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ke=this.productService.win32AppUserModelId;w.isWindows&&ke&&n.app.setAppUserModelId(ke);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.logService.error(Ne)}const Me=new t.Server;this.lifecycleMainService.onWillShutdown(Ne=>{Ne.reason===2&&Me.dispose()}),this.logService.trace("Resolving machine identifier...");const[Le,we]=await Promise.all([(0,gt.resolveMachineId)(this.stateService,this.logService),(0,gt.resolveSqmId)(this.stateService,this.logService)]);this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcessReady:Re,sharedProcessClient:Be}=this.setupSharedProcess(Le,we),$e=await this.initServices(Le,we,Re);this._register($e.createInstance(s.ProxyAuthHandler)),this._register($e.createInstance(It.UserDataProfilesHandler)),$e.invokeFunction(Ne=>this.initChannels(Ne,Me,Be));const Ve=await $e.invokeFunction(Ne=>this.setupProtocolUrlHandlers(Ne,Me));this.setupManagedRemoteResourceUrlHandler(Me),this.lifecycleMainService.phase=2,await $e.invokeFunction(Ne=>this.openFirstWindow(Ne,Ve)),this.lifecycleMainService.phase=3,this.afterWindowOpen(),this._register(new lt.RunOnceScheduler(()=>{this._register((0,lt.runWhenGlobalIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}async setupProtocolUrlHandlers(ke,Me){const Le=this.windowsMainService=ke.get(ve.IWindowsMainService),we=ke.get(Te.IURLService),Re=this.nativeHostMainService=ke.get(q.INativeHostMainService),Be=ke.get(R.IDialogMainService),$e=this;we.registerHandler({async handleURL(Ze,nt){return $e.handleProtocolUrl(Le,Be,we,Ze,nt)}});const Ve=this._register(new Ie.ActiveWindowManager({onDidOpenMainWindow:Re.onDidOpenMainWindow,onDidFocusMainWindow:Re.onDidFocusMainWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Fe=new a.StaticRouter(Ze=>Ve.getActiveClientId().then(nt=>Ze===nt)),Ne=new qe.URLHandlerRouter(Fe,this.logService),He=Me.getChannel("urlHandler",Ne);we.registerHandler(new qe.URLHandlerChannelClient(He));const Qe=await this.resolveInitialProtocolUrls(Le,Be);return this._register(new Ke.ElectronURLListener(Qe?.urls,we,Le,this.environmentMainService,this.productService,this.logService)),Qe}setupManagedRemoteResourceUrlHandler(ke){const Me=()=>({statusCode:404,data:"Not found"}),Le=new Wt.Lazy(()=>ke.getChannel(ht.NODE_REMOTE_RESOURCE_CHANNEL_NAME,new ht.NodeRemoteResourceRouter));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(we,Re)=>{const Be=d.URI.parse(we.url);if(!Be.authority.startsWith("window:"))return Re(Me());Le.value.call(ht.NODE_REMOTE_RESOURCE_IPC_METHOD_NAME,[Be]).then($e=>Re({...$e,data:Buffer.from($e.body,"base64")}),$e=>{this.logService.warn("error dispatching remote resource call",$e),Re({statusCode:500,data:String($e)})})})}async resolveInitialProtocolUrls(ke,Me){const Le=this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[];Le.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Le);const we=global.getOpenUrls()||[];if(we.length>0&&this.logService.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Le.length+we.length===0)return;const Re=[...Le,...we].map(Ve=>{try{return{uri:d.URI.parse(Ve),originalUrl:Ve}}catch{this.logService.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ve);return}}),Be=[],$e=[];for(const Ve of Re){if(!Ve)continue;const Fe=this.getWindowOpenableFromProtocolUrl(Ve.uri);if(Fe)if(await this.shouldBlockOpenable(Fe,ke,Me)){this.logService.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ve.uri.toString(!0));continue}else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ve.uri.toString(!0),Fe),Be.push(Fe);else this.logService.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ve.uri.toString(!0)),$e.push(Ve)}return{urls:$e,openables:Be}}async shouldBlockOpenable(ke,Me,Le){let we,Re;if((0,ge.isWorkspaceToOpen)(ke)?(we=ke.workspaceUri,Re=(0,i.localize)(0,null,we.scheme===m.Schemas.file?(0,E.getPathLabel)(we,{os:w.OS,tildify:this.environmentMainService}):we.toString(!0),this.productService.nameShort)):(0,ge.isFolderToOpen)(ke)?(we=ke.folderUri,Re=(0,i.localize)(1,null,we.scheme===m.Schemas.file?(0,E.getPathLabel)(we,{os:w.OS,tildify:this.environmentMainService}):we.toString(!0),this.productService.nameShort)):(we=ke.fileUri,Re=(0,i.localize)(2,null,we.scheme===m.Schemas.file?(0,E.getPathLabel)(we,{os:w.OS,tildify:this.environmentMainService}):we.toString(!0),this.productService.nameShort)),we.scheme!==m.Schemas.file&&we.scheme!==m.Schemas.vscodeRemote||this.configurationService.getValue(dt.SECURITY_PROTOCOL_HANDLING_CONFIRMATION_SETTING_KEY[we.scheme])===!1)return!1;const{response:$e,checkboxChecked:Ve}=await Le.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Re,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if($e!==0)return!0;if(Ve){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===m.Schemas.file?"local":"remote"};Me.sendToFocused(Fe.channel,Fe.args),Me.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}getWindowOpenableFromProtocolUrl(ke){if(ke.path){if(ke.authority===m.Schemas.file){const Me=d.URI.file(ke.fsPath);return(0,We.hasWorkspaceFileExtension)(Me)?{workspaceUri:Me}:{fileUri:Me}}else if(ke.authority===m.Schemas.vscodeRemote){const Me=ke.path.indexOf(b.posix.sep,1);if(Me!==-1){const Le=ke.path.substring(1,Me),we=ke.path.substring(Me);let Re=ke.query;const Be=new URLSearchParams(ke.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Re=Be.toString());const $e=d.URI.from({scheme:m.Schemas.vscodeRemote,authority:Le,path:we,query:Re,fragment:ke.fragment});return(0,We.hasWorkspaceFileExtension)(we)?{workspaceUri:$e}:/:[\d]+$/.test(we)?{fileUri:$e}:{folderUri:$e}}}}}async handleProtocolUrl(ke,Me,Le,we,Re){this.logService.trace("app#handleProtocolUrl():",we.toString(!0),Re),we.scheme===this.productService.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:d.URI.parse(we.query).path,query:""}));let Be=!1;const $e=new URLSearchParams(we.query);$e.get("windowId")==="_blank"?(this.logService.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),$e.delete("windowId"),we=we.with({query:$e.toString()}),Be=!0):w.isMacintosh&&ke.getWindowCount()===0&&(this.logService.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Be=!0);const Ve=$e.get("continueOn");Ve!==null&&(this.logService.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),$e.delete("continueOn"),we=we.with({query:$e.toString()}),this.environmentMainService.continueOn=Ve??void 0);const Fe=this.getWindowOpenableFromProtocolUrl(we);return Fe?await this.shouldBlockOpenable(Fe,ke,Me)?(this.logService.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.logService.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,we.toString(!0)),(0,mt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},urisToOpen:[Fe],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.logService.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,mt.firstOrDefault)(await ke.open({context:5,cli:{...this.environmentMainService.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,$.getRemoteAuthority)(we)}))?.ready(),Le.open(we,Re)):(this.logService.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Re),!1)}setupSharedProcess(ke,Me){const Le=this._register(this.mainInstantiationService.createInstance(se.SharedProcess,ke,Me)),we=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Be=await Le.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new o.Client(Be,"main")})();return{sharedProcessReady:(async()=>(await Le.whenReady(),we))(),sharedProcessClient:we}}async initServices(ke,Me,Le){const we=new le.ServiceCollection;switch(process.platform){case"win32":we.set(fe.IUpdateService,new V.SyncDescriptor(Oe.Win32UpdateService));break;case"linux":w.isLinuxSnap?we.set(fe.IUpdateService,new V.SyncDescriptor(ze.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.IUpdateService,new V.SyncDescriptor(Ae.LinuxUpdateService));break;case"darwin":we.set(fe.IUpdateService,new V.SyncDescriptor(Ce.DarwinUpdateService));break}we.set(ve.IWindowsMainService,new V.SyncDescriptor(Se.WindowsMainService,[ke,Me,this.userEnv],!1)),we.set(pt.IAuxiliaryWindowsMainService,new V.SyncDescriptor(Ot.AuxiliaryWindowsMainService,void 0,!1));const Re=new R.DialogMainService(this.logService,this.productService);we.set(R.IDialogMainService,Re),we.set(N.ILaunchMainService,new V.SyncDescriptor(N.LaunchMainService,void 0,!1)),we.set(L.IDiagnosticsMainService,new V.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),we.set(M.IDiagnosticsService,a.ProxyChannel.toService((0,a.getDelayedChannel)(Le.then(Ne=>Ne.getChannel("diagnostics"))))),we.set(he.IIssueMainService,new V.SyncDescriptor(K.IssueMainService,[this.userEnv])),we.set(A.IEncryptionMainService,new V.SyncDescriptor(F.EncryptionMainService)),we.set(W.IKeyboardLayoutMainService,new V.SyncDescriptor(W.KeyboardLayoutMainService)),we.set(q.INativeHostMainService,new V.SyncDescriptor(q.NativeHostMainService,void 0,!1)),we.set(xe.IWebviewManagerService,new V.SyncDescriptor(ie.WebviewMainService)),we.set(G.IMenubarMainService,new V.SyncDescriptor(G.MenubarMainService)),we.set(ce.IExtensionHostStarter,new V.SyncDescriptor(te.ExtensionHostStarter)),we.set(be.IStorageMainService,new V.SyncDescriptor(be.StorageMainService)),we.set(be.IApplicationStorageMainService,new V.SyncDescriptor(be.ApplicationStorageMainService));const Be=new Lt.ElectronPtyHostStarter({graceTime:6e4,shortGraceTime:6e3,scrollback:this.configurationService.getValue("terminal.integrated.persistentSessionScrollback")??100},this.configurationService,this.environmentMainService,this.lifecycleMainService,this.logService),$e=new At.PtyHostService(Be,this.configurationService,this.logService,this.loggerService);we.set(ut.ILocalPtyService,$e),w.isWindows?we.set(ue.IExternalTerminalMainService,new V.SyncDescriptor(X.WindowsExternalTerminalService)):w.isMacintosh?we.set(ue.IExternalTerminalMainService,new V.SyncDescriptor(X.MacExternalTerminalService)):w.isLinux&&we.set(ue.IExternalTerminalMainService,new V.SyncDescriptor(X.LinuxExternalTerminalService));const Ve=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.stateService);we.set(r.IBackupMainService,Ve);const Fe=new Xe.WorkspacesManagementMainService(this.environmentMainService,this.logService,this.userDataProfilesMainService,Ve,Re);if(we.set(Xe.IWorkspacesManagementMainService,Fe),we.set(Ue.IWorkspacesService,new V.SyncDescriptor(Je.WorkspacesMainService,void 0,!1)),we.set(Ge.IWorkspacesHistoryMainService,new V.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),we.set(Te.IURLService,new V.SyncDescriptor(je.NativeURLService,void 0,!1)),(0,J.supportsTelemetry)(this.productService,this.environmentMainService)){const Ne=(0,J.isInternalTelemetry)(this.productService,this.configurationService),He=(0,a.getDelayedChannel)(Le.then(st=>st.getChannel("telemetryAppender"))),Qe=new _e.TelemetryAppenderClient(He),Ze=(0,Ee.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,this.productService.commit,this.productService.version,ke,Me,Ne),nt=(0,J.getPiiPathsFromEnvironment)(this.environmentMainService),et={appenders:[Qe],commonProperties:Ze,piiPaths:nt,sendErrorTelemetry:!0};we.set(De.ITelemetryService,new V.SyncDescriptor(ye.TelemetryService,[et],!1))}else we.set(De.ITelemetryService,J.NullTelemetryService);return we.set(bt.IExtensionsProfileScannerService,new V.SyncDescriptor(kt.ExtensionsProfileScannerService,void 0,!0)),we.set(Et.IExtensionsScannerService,new V.SyncDescriptor(Pt.ExtensionsScannerService,void 0,!0)),we.set(ct.IUtilityProcessWorkerMainService,new V.SyncDescriptor(ct.UtilityProcessWorkerMainService,void 0,!0)),await lt.Promises.settled([Ve.initialize(),Fe.initialize()]),this.mainInstantiationService.createChild(we)}initChannels(ke,Me,Le){const we=this._register(new g.DisposableStore),Re=a.ProxyChannel.fromService(ke.get(N.ILaunchMainService),we,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Re);const Be=a.ProxyChannel.fromService(ke.get(L.IDiagnosticsMainService),we,{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Be);const $e=new rt.PolicyChannel(ke.get(Ye.IPolicyService));Me.registerChannel("policy",$e),Le.then(tt=>tt.registerChannel("policy",$e));const Ve=this.fileService.getProvider(m.Schemas.file);(0,p.assertType)(Ve instanceof x.DiskFileSystemProvider);const Fe=new T.DiskFileSystemProviderChannel(Ve,this.logService,this.environmentMainService);Me.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe),Le.then(tt=>tt.registerChannel(Y.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Fe));const Ne=a.ProxyChannel.fromService(ke.get(it.IUserDataProfilesMainService),we);Me.registerChannel("userDataProfiles",Ne),Le.then(tt=>tt.registerChannel("userDataProfiles",Ne));const He=new ot.RequestChannel(ke.get(at.IRequestService));Le.then(tt=>tt.registerChannel("request",He));const Qe=new me.UpdateChannel(ke.get(fe.IUpdateService));Me.registerChannel("update",Qe);const Ze=a.ProxyChannel.fromService(ke.get(he.IIssueMainService),we);Me.registerChannel("issue",Ze);const nt=a.ProxyChannel.fromService(ke.get(A.IEncryptionMainService),we);Me.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(ke.get(ee.ISignService),we);Me.registerChannel("sign",et);const st=a.ProxyChannel.fromService(ke.get(W.IKeyboardLayoutMainService),we);Me.registerChannel("keyboardLayout",st),this.nativeHostMainService=ke.get(q.INativeHostMainService);const wt=a.ProxyChannel.fromService(this.nativeHostMainService,we);Me.registerChannel("nativeHost",wt),Le.then(tt=>tt.registerChannel("nativeHost",wt));const Tt=a.ProxyChannel.fromService(ke.get(Ue.IWorkspacesService),we);Me.registerChannel("workspaces",Tt);const Ft=a.ProxyChannel.fromService(ke.get(G.IMenubarMainService),we);Me.registerChannel("menubar",Ft);const _t=a.ProxyChannel.fromService(ke.get(Te.IURLService),we);Me.registerChannel("url",_t);const Nt=a.ProxyChannel.fromService(ke.get(xe.IWebviewManagerService),we);Me.registerChannel("webview",Nt);const St=this._register(new pe.StorageDatabaseChannel(this.logService,ke.get(be.IStorageMainService)));Me.registerChannel("storage",St),Le.then(tt=>tt.registerChannel("storage",St));const xt=this._register(new Ct.ProfileStorageChangesListenerChannel(ke.get(be.IStorageMainService),ke.get(it.IUserDataProfilesMainService),this.logService));Le.then(tt=>tt.registerChannel("profileStorageListener",xt));const Ut=a.ProxyChannel.fromService(ke.get(ut.ILocalPtyService),we);Me.registerChannel(ut.TerminalIpcChannels.LocalPty,Ut);const Bt=a.ProxyChannel.fromService(ke.get(ue.IExternalTerminalMainService),we);Me.registerChannel("externalTerminal",Bt);const yt=new Dt.LoggerChannel(ke.get(Mt.ILoggerMainService));Me.registerChannel("logger",yt),Le.then(tt=>tt.registerChannel("logger",yt));const zt=new k.ElectronExtensionHostDebugBroadcastChannel(ke.get(ve.IWindowsMainService));Me.registerChannel("extensionhostdebugservice",zt);const $t=a.ProxyChannel.fromService(ke.get(ce.IExtensionHostStarter),we);Me.registerChannel(ce.ipcExtensionHostStarterChannelName,$t);const qt=a.ProxyChannel.fromService(ke.get(ct.IUtilityProcessWorkerMainService),we);Me.registerChannel(Rt.ipcUtilityProcessWorkerChannelName,qt)}async openFirstWindow(ke,Me){const Le=this.windowsMainService=ke.get(ve.IWindowsMainService);this.auxiliaryWindowsMainService=ke.get(pt.IAuxiliaryWindowsMainService);const we=(0,z.isLaunchedFromCli)(process.env)?0:4,Re=this.environmentMainService.args;if(Me){if(Me.openables.length>0)return Le.open({context:we,cli:Re,urisToOpen:Me.openables,gotoLineMode:!0,initialStartup:!0});if(Me.urls.length>0)for(const et of Me.urls){const st=new URLSearchParams(et.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:st.toString()}),Le.open({context:we,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,$e=Re._.length,Ve=!!Re["folder-uri"],Fe=!!Re["file-uri"],Ne=Re["skip-add-to-recently-opened"]===!0,He=Re.wait&&Re.waitMarkerFilePath?d.URI.file(Re.waitMarkerFilePath):void 0,Qe=Re.remote||void 0,Ze=Re.profile,nt=Re["profile-temp"];if(!$e&&!Ve&&!Fe){if(Re["new-window"]||Ze||nt)return Le.open({context:we,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:He,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:nt});if(Be.length)return Le.open({context:1,cli:Re,urisToOpen:Be.map(et=>(et=(0,vt.normalizeNFC)(et),(0,We.hasWorkspaceFileExtension)(et)?{workspaceUri:d.URI.file(et)}:{fileUri:d.URI.file(et)})),noRecentEntry:Ne,waitMarkerFileURI:He,initialStartup:!0})}return Le.open({context:we,cli:Re,forceNewWindow:Re["new-window"]||!$e&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Ne,waitMarkerFileURI:He,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Qe,forceProfile:Ze,forceTempProfile:nt})}afterWindowOpen(){this.installMutex(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(ke,Me)=>{Me({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement(),w.isMacintosh&&n.app.runningUnderARM64Translation&&this.windowsMainService?.sendToFocused("vscode:showTranslatedBuildWarning")}async installMutex(){const ke=this.productService.win32MutexName;if(w.isWindows&&ke)try{const Me=await new Promise((we,Re)=>{Q(["@vscode/windows-mutex"],we,Re)}),Le=new Me.Mutex(ke);v.Event.once(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(ke,Me,Le){try{return await(0,j.getResolvedShellEnv)(this.configurationService,this.logService,ke,Me)}catch(we){const Re=(0,P.toErrorMessage)(we);Le?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Re):this.logService.error(Re)}return{}}async updateCrashReporterEnablement(){try{const Me=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Le=JSON.parse((0,y.stripComments)(Me)),Re=(0,J.getTelemetryLevel)(this.configurationService)>=1;if(Le["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],$e=Me.substring(0,Me.length-2).concat(`,
`,Be.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString($e))}else{const Be=Me.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);Be!==Me&&await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(Be))}}catch(ke){this.logService.error(ke)}}};e.CodeApplication=ft,e.CodeApplication=ft=dt=Pe([ne(2,U.IInstantiationService),ne(3,re.ILogService),ne(4,re.ILoggerService),ne(5,_.IEnvironmentMainService),ne(6,Z.ILifecycleMainService),ne(7,S.IConfigurationService),ne(8,de.IStateService),ne(9,B.IFileService),ne(10,H.IProductService),ne(11,it.IUserDataProfilesMainService)],ft)}),define(oe[317],ae([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(Q,e,n,D,I,O,C,P,h,l,v,y,E,g,m,b,w,p,d,c,f,a,t,o,s,i,r,u,S,k,M,L,R,A,F,_,z,j,ce,te,ue,X,Y,B,T,x,V,U,le,he,K,W,N,Z,re,G,q,H,$,se,ee,de,pe,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.startup()}catch(ye){console.error(ye.message),n.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(Te=>console.error(Te));const[ye,J,fe,me,Ce,Ae,ze,Oe]=this.createServices();try{try{await this.initServices(fe,Oe,me,Ce,ze)}catch(Te){throw this.handleStartupDataDirError(fe,ze,Te),Te}await ye.invokeFunction(async Te=>{const qe=Te.get(j.ILogService),je=Te.get(_.ILifecycleMainService),Ke=Te.get(k.IFileService),xe=Te.get(j.ILoggerService),ie=await this.claimInstance(qe,fe,je,ye,ze,!0);return d.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(ge=>{qe.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Ae.logger=xe.createLogger("main",{name:(0,t.localize)(0,null)}),v.Event.once(je.onWillShutdown)(ge=>{Ke.dispose(),me.dispose(),ge.join("instanceLockfile",d.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),ye.createInstance(a.CodeApplication,ie,J).startup()})}catch(Te){ye.invokeFunction(this.quit,Te)}}createServices(){const ye=new F.ServiceCollection,J=new G.DisposableStore;process.once("exit",()=>J.dispose());const fe={_serviceBrand:void 0,...ce.default};ye.set(te.IProductService,fe);const me=new r.EnvironmentMainService(this.resolveArgs(),fe),Ce=this.patchEnvironment(me);ye.set(r.IEnvironmentMainService,me);const Ae=new $.LoggerMainService((0,j.getLogLevel)(me),me.logsHome);ye.set($.ILoggerMainService,Ae);const ze=new z.BufferLogger(Ae.getLogLevel()),Oe=J.add(new se.LogService(ze,[new j.ConsoleMainLogger(Ae.getLogLevel())]));ye.set(j.ILogService,Oe);const Te=new M.FileService(Oe);ye.set(k.IFileService,Te);const qe=new L.DiskFileSystemProvider(Oe);Te.registerProvider(E.Schemas.file,qe);const je=new H.UriIdentityService(Te);ye.set(q.IUriIdentityService,je);const Ke=new de.StateService(1,me,Oe,Te);ye.set(le.IStateReadService,Ke),ye.set(le.IStateService,Ke);const xe=new W.UserDataProfilesMainService(Ke,je,me,Te,Oe);ye.set(W.IUserDataProfilesMainService,xe),Te.registerProvider(E.Schemas.vscodeUserData,new pe.FileUserDataProvider(E.Schemas.file,qe,E.Schemas.vscodeUserData,xe,je,Oe));const ie=b.isWindows&&fe.win32RegValueName?J.add(new Z.NativePolicyService(Oe,fe.win32RegValueName)):me.policyFile?J.add(new re.FilePolicyService(me.policyFile,Te,Oe)):new N.NullPolicyService;ye.set(N.IPolicyService,ie);const ge=new s.ConfigurationService(xe.defaultProfile.settingsResource,Te,ie,Oe);return ye.set(o.IConfigurationService,ge),ye.set(_.ILifecycleMainService,new R.SyncDescriptor(_.LifecycleMainService,void 0,!1)),ye.set(T.IRequestService,new R.SyncDescriptor(x.RequestMainService,void 0,!0)),ye.set(K.IThemeMainService,new R.SyncDescriptor(K.ThemeMainService)),ye.set(V.ISignService,new R.SyncDescriptor(U.SignService,void 0,!1)),ye.set(Y.ITunnelService,new R.SyncDescriptor(B.TunnelService)),ye.set(ue.IProtocolMainService,new X.ProtocolMainService(me,xe,Oe)),[new A.InstantiationService(ye,!0),Ce,me,ge,Ke,ze,fe,xe]}patchEnvironment(ye){const J={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const me=process.env[fe];typeof me=="string"&&(J[fe]=me)}),Object.assign(process.env,J),J}async initServices(ye,J,fe,me,Ce){await C.Promises.settled([Promise.all([this.allowWindowsUNCPath(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:E.Schemas.file}).fsPath,J.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:E.Schemas.file}).fsPath,ye.backupHome].map(Ae=>Ae?d.Promises.mkdir(Ae,{recursive:!0}):void 0)),me.init(),fe.initialize()]),J.init()}allowWindowsUNCPath(ye){if(b.isWindows){const J=(0,be.getUNCHost)(ye);J&&(0,be.addUNCHostToAllowlist)(J)}return ye}async claimInstance(ye,J,fe,me,Ce,Ae){let ze;try{(0,m.mark)("code/willStartMainServer"),ze=await(0,f.serve)(J.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),v.Event.once(fe.onWillShutdown)(()=>ze.dispose())}catch(Oe){if(Oe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(J,Ce,Oe),Oe;let Te;try{Te=await(0,f.connect)(J.mainIPCHandle,"main")}catch(xe){if(!Ae||b.isWindows||xe.code!=="ECONNREFUSED")throw xe.code==="EPERM"&&this.showStartupWarningDialog((0,t.localize)(1,null,Ce.nameShort),(0,t.localize)(2,null),Ce),xe;try{(0,D.unlinkSync)(J.mainIPCHandle)}catch(ie){throw ye.warn("Could not delete obsolete instance handle",ie),ie}return this.claimInstance(ye,J,fe,me,Ce,!1)}if(J.extensionTestsLocationURI&&!J.debugExtensionHost.break){const xe=`Running extension tests from the command line is currently only supported if no other instance of ${Ce.nameShort} is running.`;throw ye.error(xe),Te.dispose(),new Error(xe)}let qe;!J.args.wait&&!J.args.status&&(qe=setTimeout(()=>{this.showStartupWarningDialog((0,t.localize)(3,null,Ce.nameShort),(0,t.localize)(4,null),Ce)},1e4));const je=c.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),Ke=c.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(J.args.status)return me.invokeFunction(async()=>{const xe=new i.DiagnosticsService(he.NullTelemetryService,Ce),ie=await Ke.getMainDiagnostics(),ge=await Ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ve=await xe.getDiagnostics(ie,ge);throw console.log(ve),new h.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(je,ye),ye.trace("Sending env to running instance..."),await je.start(J.args,process.env),Te.dispose(),qe&&clearTimeout(qe),new h.ExpectedError("Sent env to running instance. Terminating...")}if(J.args.status)throw console.log((0,t.localize)(5,null,Ce.nameShort)),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ze}handleStartupDataDirError(ye,J,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const me=(0,O.coalesce)([ye.userDataPath,ye.extensionsPath,f.XDG_RUNTIME_DIR]).map(Ce=>(0,y.getPathLabel)(I.URI.file(Ce),{os:b.OS,tildify:ye}));this.showStartupWarningDialog((0,t.localize)(6,null),(0,t.localize)(7,null,(0,P.toErrorMessage)(fe),me.join(`
`)),J)}}showStartupWarningDialog(ye,J,fe){n.dialog.showMessageBoxSync((0,ee.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:J},fe).options)}async windowsAllowSetForegroundWindow(ye,J){if(b.isWindows){const fe=await ye.getMainProcessId();J.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((me,Ce)=>{Q(["windows-foreground-love"],me,Ce)})).allowSetForegroundWindow(fe)}catch(me){J.error(me)}}}quit(ye,J){const fe=ye.get(j.ILogService),me=ye.get(_.ILifecycleMainService);let Ce=0;J&&(J.isExpected?J.message&&fe.trace(J.message):(Ce=1,J.stack?fe.error(J.stack):fe.error(`Startup error: ${J.toString()}`))),me.kill(Ce)}resolveArgs(){const ye=this.validatePaths((0,u.parseMainProcessArgv)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const J=(0,S.createWaitMarkerFileSync)(ye.verbose);J&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",J),ye.waitMarkerFilePath=J)}return ye}validatePaths(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const J=this.doValidatePaths(ye._,ye.goto);ye._=J}return ye}doValidatePaths(ye,J){const fe=(0,w.cwd)(),me=ye.map(ze=>{let Oe=String(ze),Te;J&&(Te=(0,l.parseLineAndColumnAware)(Oe),Oe=Te.path),Oe&&(Oe=this.preparePath(fe,Oe));const qe=(0,l.sanitizeFilePath)(Oe,fe),je=(0,g.basename)(qe);return je&&!(0,l.isValidBasename)(je)?null:J&&Te?(Te.path=qe,this.toPath(Te)):qe}),Ce=b.isWindows||b.isMacintosh,Ae=(0,O.distinct)(me,ze=>ze&&Ce?ze.toLowerCase():ze||"");return(0,O.coalesce)(Ae)}preparePath(ye,J){return b.isWindows&&(J=(0,p.rtrim)(J,'"')),J=(0,p.trim)((0,p.trim)(J," "),"	"),b.isWindows&&(J=(0,g.resolve)(ye,J),J=(0,p.rtrim)(J,".")),J}toPath(ye){const J=[ye.path];return typeof ye.line=="number"&&J.push(String(ye.line)),typeof ye.column=="number"&&J.push(String(ye.column)),J.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/code/electron-main/main.js.map
