/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/errors","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/base/common/extpath","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],se=function(K){for(var e=[],O=0,L=K.length;O<L;O++)e[O]=ne[K[O]];return e};define(ne[71],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class O{static get(){const C=new Map,x=new Map,k=new Map,I=new Map;function u(m,S){m.has(S.detail)||m.set(S.detail,-S.timestamp)}function a(m,S){const D=m.get(S.detail);D&&(D>=0||m.set(S.detail,D+S.timestamp))}let y=[];typeof K=="function"&&typeof K.getStats=="function"&&(y=K.getStats().slice(0).sort((m,S)=>m.timestamp-S.timestamp));for(const m of y)switch(m.type){case 10:u(C,m);break;case 11:case 12:a(C,m);break;case 21:u(x,m);break;case 22:a(x,m);break;case 33:u(k,m);break;case 34:a(k,m);break;case 31:u(I,m);break;case 32:a(I,m);break}let w=0;k.forEach(m=>w+=m);function d(m){const S=[];return m.forEach((D,p)=>S.push([p,D])),S}return{amdLoad:d(C),amdInvoke:d(x),nodeRequire:d(k),nodeEval:d(I),nodeRequireTotal:w}}static toMarkdownTable(C,x){let k="";const I=[];return C.forEach((u,a)=>{I[a]=u.length}),x.forEach(u=>{u.forEach((a,y)=>{typeof a>"u"&&(a=u[y]="-");const w=a.toString().length;I[y]=Math.max(w,I[y])})}),C.forEach((u,a)=>{k+=`| ${u+" ".repeat(I[a]-u.toString().length)} `}),k+=`|
`,C.forEach((u,a)=>{k+=`| ${"-".repeat(I[a])} `}),k+=`|
`,x.forEach(u=>{u.forEach((a,y)=>{typeof a<"u"&&(k+=`| ${a+" ".repeat(I[y]-a.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=O}),define(ne[54],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=L,e.debounce=C,e.throttle=x;function O(k){return(I,u,a)=>{let y=null,w=null;if(typeof a.value=="function"?(y="value",w=a.value):typeof a.get=="function"&&(y="get",w=a.get),!w)throw new Error("not supported");a[y]=k(w,u)}}function L(k,I,u){let a=null,y=null;if(typeof u.value=="function"?(a="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",y=u.get),!y)throw new Error("not supported");const w=`$memoize$${I}`;u[a]=function(...d){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[w]}}function C(k,I,u){return O((a,y)=>{const w=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...m){this[d]||(this[d]=u?u():void 0),clearTimeout(this[w]),I&&(this[d]=I(this[d],...m),m=[this[d]]),this[w]=setTimeout(()=>{a.apply(this,m),this[d]=u?u():void 0},k)}})}function x(k,I,u){return O((a,y)=>{const w=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,S=`$throttle$pending$${y}`;return function(...D){if(this[d]||(this[d]=u?u():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...D)),this[S])return;const p=this[m]+k;p<=Date.now()?(this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[S]=!0,this[w]=setTimeout(()=>{this[S]=!1,this[m]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},p-Date.now()))}})}}),define(ne[72],se([0,1,8]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.assertNever=C,e.assert=x,e.softAssert=k,e.assertFn=I,e.checkAdjacentItems=u;function L(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function C(a,y="Unreachable"){throw new Error(y)}function x(a){if(!a)throw new O.BugIndicatingError("Assertion Failed")}function k(a){a||(0,O.onUnexpectedError)(new O.BugIndicatingError("Soft Assertion Failed"))}function I(a){if(!a()){debugger;a(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}function u(a,y){let w=0;for(;w<a.length-1;){const d=a[w],m=a[w+1];if(!y(d,m))return!1;w++}return!0}}),define(ne[38],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=w,e.parse=d,e.parseTree=m,e.findNodeAtLocation=S,e.getNodePath=D,e.getNodeValue=p,e.contains=l,e.findNodeAtOffset=E,e.visit=v,e.stripComments=f,e.getNodeType=g;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var x;(function(i){i.DEFAULT={allowTrailingComma:!0}})(x||(e.ParseOptions=x={}));function k(i,s=!1){let t=0;const n=i.length;let r="",o=0,c=16,b=0;function R(ie){let ue=0,fe=0;for(;ue<ie;){const le=i.charCodeAt(t);if(le>=48&&le<=57)fe=fe*16+le-48;else if(le>=65&&le<=70)fe=fe*16+le-65+10;else if(le>=97&&le<=102)fe=fe*16+le-97+10;else break;t++,ue++}return ue<ie&&(fe=-1),fe}function T(ie){t=ie,r="",o=0,c=16,b=0}function N(){const ie=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return b=3,i.substring(ie,t);let ue=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;ue=t}else b=3;return i.substring(ie,ue)}function F(){let ie="",ue=t;for(;;){if(t>=n){ie+=i.substring(ue,t),b=2;break}const fe=i.charCodeAt(t);if(fe===34){ie+=i.substring(ue,t),t++;break}if(fe===92){if(ie+=i.substring(ue,t),t++,t>=n){b=2;break}switch(i.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const j=R(4);j>=0?ie+=String.fromCharCode(j):b=4;break}default:b=5}ue=t;continue}if(fe>=0&&fe<=31)if(u(fe)){ie+=i.substring(ue,t),b=2;break}else b=6;t++}return ie}function z(){if(r="",b=0,o=t,t>=n)return o=n,c=17;let ie=i.charCodeAt(t);if(I(ie)){do t++,r+=String.fromCharCode(ie),ie=i.charCodeAt(t);while(I(ie));return c=15}if(u(ie))return t++,r+=String.fromCharCode(ie),ie===13&&i.charCodeAt(t)===10&&(t++,r+=`
`),c=14;switch(ie){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,r=F(),c=10;case 47:{const ue=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return r=i.substring(ue,t),c=12}if(i.charCodeAt(t+1)===42){t+=2;const fe=n-1;let le=!1;for(;t<fe;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,le=!0;break}t++}return le||(t++,b=1),r=i.substring(ue,t),c=13}return r+=String.fromCharCode(ie),t++,c=16}case 45:if(r+=String.fromCharCode(ie),t++,t===n||!a(i.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),c=11;default:for(;t<n&&H(ie);)t++,ie=i.charCodeAt(t);if(o!==t){switch(r=i.substring(o,t),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode(ie),t++,c=16}}function H(ie){if(I(ie)||u(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ie;do ie=z();while(ie>=12&&ie<=15);return ie}return{setPosition:T,getPosition:()=>t,scan:s?re:z,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>b}}function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function w(i,s){const t=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function b(R,T,N,F){o.value=R,o.offset=T,o.length=N,o.type=F,o.colonOffset=void 0,r=o}try{v(i,{onObjectBegin:(R,T)=>{if(s<=R)throw n;r=void 0,c=s>R,t.push("")},onObjectProperty:(R,T,N)=>{if(s<T||(b(R,T,N,"property"),t[t.length-1]=R,s<=T+N))throw n},onObjectEnd:(R,T)=>{if(s<=R)throw n;r=void 0,t.pop()},onArrayBegin:(R,T)=>{if(s<=R)throw n;r=void 0,t.push(0)},onArrayEnd:(R,T)=>{if(s<=R)throw n;r=void 0,t.pop()},onLiteralValue:(R,T,N)=>{if(s<T||(b(R,T,N,g(R)),s<=T+N))throw n},onSeparator:(R,T,N)=>{if(s<=T)throw n;if(R===":"&&r&&r.type==="property")r.colonOffset=T,c=!1,r=void 0;else if(R===","){const F=t[t.length-1];typeof F=="number"?t[t.length-1]=F+1:(c=!0,t[t.length-1]=""),r=void 0}}})}catch(R){if(R!==n)throw R}return{path:t,previousNode:r,isAtPropertyKey:c,matches:R=>{let T=0;for(let N=0;T<R.length&&N<t.length;N++)if(R[T]===t[N]||R[T]==="*")T++;else if(R[T]!=="**")return!1;return T===R.length}}}function d(i,s=[],t=x.DEFAULT){let n=null,r=[];const o=[];function c(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}return v(i,{onObjectBegin:()=>{const R={};c(R),o.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const R=[];c(R),o.push(r),r=R,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:c,onError:(R,T,N)=>{s.push({error:R,offset:T,length:N})}},t),r[0]}function m(i,s=[],t=x.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(R){n.type==="property"&&(n.length=R-n.offset,n=n.parent)}function o(R){return n.children.push(R),R}v(i,{onObjectBegin:R=>{n=o({type:"object",offset:R,length:-1,parent:n,children:[]})},onObjectProperty:(R,T,N)=>{n=o({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:R,offset:T,length:N,parent:n})},onObjectEnd:(R,T)=>{n.length=R+T-n.offset,n=n.parent,r(R+T)},onArrayBegin:(R,T)=>{n=o({type:"array",offset:R,length:-1,parent:n,children:[]})},onArrayEnd:(R,T)=>{n.length=R+T-n.offset,n=n.parent,r(R+T)},onLiteralValue:(R,T,N)=>{o({type:g(R),offset:T,length:N,parent:n,value:R}),r(T+N)},onSeparator:(R,T,N)=>{n.type==="property"&&(R===":"?n.colonOffset=T:R===","&&r(T))},onError:(R,T,N)=>{s.push({error:R,offset:T,length:N})}},t);const b=n.children[0];return b&&delete b.parent,b}function S(i,s){if(!i)return;let t=i;for(const n of s)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}function D(i){if(!i.parent||!i.parent.children)return[];const s=D(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const s=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(s[t.children[0].value]=p(n))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function l(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}function E(i,s,t=!1){if(l(i,s,t)){const n=i.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=E(n[r],s,t);if(o)return o}return i}}function v(i,s,t=x.DEFAULT){const n=k(i,!1);function r(J){return J?()=>J(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(J){return J?Z=>J(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=r(s.onObjectBegin),b=o(s.onObjectProperty),R=r(s.onObjectEnd),T=r(s.onArrayBegin),N=r(s.onArrayEnd),F=o(s.onLiteralValue),z=o(s.onSeparator),H=r(s.onComment),re=o(s.onError),ie=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function fe(){for(;;){const J=n.scan();switch(n.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:ie||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(J){case 12:case 13:ie?le(10):H();break;case 16:le(1);break;case 15:case 14:break;default:return J}}}function le(J,Z=[],M=[]){if(re(J),Z.length+M.length>0){let _=n.getToken();for(;_!==17;){if(Z.indexOf(_)!==-1){fe();break}else if(M.indexOf(_)!==-1)break;_=fe()}}}function j(J){const Z=n.getTokenValue();return J?F(Z):b(Z),fe(),!0}function X(){switch(n.getToken()){case 11:{let J=0;try{J=JSON.parse(n.getTokenValue()),typeof J!="number"&&(le(2),J=0)}catch{le(2)}F(J);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return fe(),!0}function W(){return n.getToken()!==10?(le(3,[],[2,5]),!1):(j(!1),n.getToken()===6?(z(":"),fe(),Y()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function V(){c(),fe();let J=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(J||le(4,[],[]),z(","),fe(),n.getToken()===2&&ue)break}else J&&le(6,[],[]);W()||le(4,[],[2,5]),J=!0}return R(),n.getToken()!==2?le(7,[2],[]):fe(),!0}function q(){T(),fe();let J=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(J||le(4,[],[]),z(","),fe(),n.getToken()===4&&ue)break}else J&&le(6,[],[]);Y()||le(4,[],[4,5]),J=!0}return N(),n.getToken()!==4?le(8,[4],[]):fe(),!0}function Y(){switch(n.getToken()){case 3:return q();case 1:return V();case 10:return j(!0);default:return X()}}return fe(),n.getToken()===17?t.allowEmptyContent?!0:(le(4,[],[]),!1):Y()?(n.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}function f(i,s){const t=k(i),n=[];let r,o=0,c;do switch(c=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:o!==c&&n.push(i.substring(o,c)),s!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,s)),o=t.getPosition();break}while(r!==17);return n.join("")}function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[73],se([0,1,38]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=L,e.toFormattedString=C,e.getEOL=I,e.isEOL=u;function L(a,y,w){let d,m,S,D,p;if(y){for(D=y.offset,p=D+y.length,S=D;S>0&&!u(a,S-1);)S--;let c=p;for(;c<a.length&&!u(a,c);)c++;m=a.substring(S,c),d=k(m,w)}else m=a,d=0,S=0,D=0,p=a.length;const l=I(w,a);let E=!1,v=0,f;w.insertSpaces?f=x(" ",w.tabSize||4):f="	";const g=(0,O.createScanner)(m,!1);let i=!1;function s(){return l+x(f,d+v)}function t(){let c=g.scan();for(E=!1;c===15||c===14;)E=E||c===14,c=g.scan();return i=c===16||g.getTokenError()!==0,c}const n=[];function r(c,b,R){!i&&b<p&&R>D&&a.substring(b,R)!==c&&n.push({offset:b,length:R-b,content:c})}let o=t();if(o!==17){const c=g.getTokenOffset()+S,b=x(f,d);r(b,S,c)}for(;o!==17;){let c=g.getTokenOffset()+g.getTokenLength()+S,b=t(),R="";for(;!E&&(b===12||b===13);){const N=g.getTokenOffset()+S;r(" ",c,N),c=g.getTokenOffset()+g.getTokenLength()+S,R=b===12?s():"",b=t()}if(b===2)o!==1&&(v--,R=s());else if(b===4)o!==3&&(v--,R=s());else{switch(o){case 3:case 1:v++,R=s();break;case 5:case 12:R=s();break;case 13:E?R=s():R=" ";break;case 6:R=" ";break;case 10:if(b===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?R=" ":b!==5&&b!==17&&(i=!0);break;case 16:i=!0;break}E&&(b===12||b===13)&&(R=s())}const T=g.getTokenOffset()+S;r(R,c,T),o=b}return n}function C(a,y){const w=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?w.replace(/\r\n|\r|\n/g,y.eol):w}function x(a,y){let w="";for(let d=0;d<y;d++)w+=a;return w}function k(a,y){let w=0,d=0;const m=y.tabSize||4;for(;w<a.length;){const S=a.charAt(w);if(S===" ")d++;else if(S==="	")d+=m;else break;w++}return Math.floor(d/m)}function I(a,y){for(let w=0;w<y.length;w++){const d=y.charAt(w);if(d==="\r")return w+1<y.length&&y.charAt(w+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function u(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}}),define(ne[74],se([0,1,38,73]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=C,e.setProperty=x,e.withFormatting=k,e.applyEdit=I,e.applyEdits=u;function C(a,y,w){return x(a,y,void 0,w)}function x(a,y,w,d,m){const S=y.slice(),D=[],p=(0,O.parseTree)(a,D);let l,E;for(;S.length>0&&(E=S.pop(),l=(0,O.findNodeAtLocation)(p,S),l===void 0&&w!==void 0);)typeof E=="string"?w={[E]:w}:w=[w];if(l)if(l.type==="object"&&typeof E=="string"&&Array.isArray(l.children)){const v=(0,O.findNodeAtLocation)(l,[E]);if(v!==void 0)if(w===void 0){if(!v.parent)throw new Error("Malformed AST");const f=l.children.indexOf(v.parent);let g,i=v.parent.offset+v.parent.length;if(f>0){const s=l.children[f-1];g=s.offset+s.length}else g=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return k(a,{offset:g,length:i-g,content:""},d)}else return k(a,{offset:v.offset,length:v.length,content:JSON.stringify(w)},d);else{if(w===void 0)return[];const f=`${JSON.stringify(E)}: ${JSON.stringify(w)}`,g=m?m(l.children.map(s=>s.children[0].value)):l.children.length;let i;if(g>0){const s=l.children[g-1];i={offset:s.offset+s.length,length:0,content:","+f}}else l.children.length===0?i={offset:l.offset+1,length:0,content:f}:i={offset:l.offset+1,length:0,content:f+","};return k(a,i,d)}}else if(l.type==="array"&&typeof E=="number"&&Array.isArray(l.children))if(w!==void 0){const v=`${JSON.stringify(w)}`;let f;if(l.children.length===0||E===0)f={offset:l.offset+1,length:0,content:l.children.length===0?v:v+","};else{const g=E===-1||E>l.children.length?l.children.length:E,i=l.children[g-1];f={offset:i.offset+i.length,length:0,content:","+v}}return k(a,f,d)}else{const v=E,f=l.children[v];let g;if(l.children.length===1)g={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===v){const i=l.children[v-1],s=i.offset+i.length,t=l.offset+l.length;g={offset:s,length:t-2-s,content:""}}else g={offset:f.offset,length:l.children[v+1].offset-f.offset,content:""};return k(a,g,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${l.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return k(a,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(w)},d)}}function k(a,y,w){let d=I(a,y),m=y.offset,S=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,L.isEOL)(d,m-1);)m--;for(;S<d.length&&!(0,L.isEOL)(d,S);)S++}const D=(0,L.format)(d,{offset:m,length:S-m},w);for(let l=D.length-1;l>=0;l--){const E=D[l];d=I(d,E),m=Math.min(m,E.offset),S=Math.max(S,E.offset+E.length),S+=E.content.length-E.length}const p=a.length-(d.length-S)-m;return[{offset:m,length:p,content:d.substring(m,S)}]}function I(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}function u(a,y){const w=y.slice(0).sort((m,S)=>{const D=m.offset-S.offset;return D===0?m.length-S.length:D});let d=a.length;for(let m=w.length-1;m>=0;m--){const S=w[m];if(S.offset+S.length<=d)a=I(a,S);else throw new Error("Overlapping edit");d=S.offset}return a}}),define(ne[75],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=O,e.rot=L;function O(I,u,a){return Math.min(Math.max(I,u),a)}function L(I,u){return(u+I%u)%u}class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class x{constructor(){this._n=1,this._val=0}update(u){return this._val=this._val+(u-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=x;class k{constructor(u){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(u),this._values.fill(0,0,u)}update(u){const a=this._values[this._index];return this._values[this._index]=u,this._index=(this._index+1)%this._values.length,this._sum-=a,this._sum+=u,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=k}),function(){function K(C){const x=[];typeof C=="number"&&x.push("code/timeOrigin",C);function k(u){x.push(u,Date.now())}function I(){const u=[];for(let a=0;a<x.length;a+=2)u.push({name:x[a],startTime:x[a+1]});return u}return{mark:k,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const x=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const k of performance.getEntriesByType("mark"))x.push({name:k.name,startTime:Math.round(C+k.startTime)});return x}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function O(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=O(L))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var L in O)(typeof exports=="object"?exports:K)[L]=O[L]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function O(L){if(e[L])return e[L].exports;var C=e[L]={i:L,l:!1,exports:{}};return K[L].call(C.exports,C,C.exports,O),C.l=!0,C.exports}return O.m=K,O.c=e,O.d=function(L,C,x){O.o(L,C)||Object.defineProperty(L,C,{enumerable:!0,get:x})},O.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},O.t=function(L,C){if(1&C&&(L=O(L)),8&C||4&C&&typeof L=="object"&&L&&L.__esModule)return L;var x=Object.create(null);if(O.r(x),Object.defineProperty(x,"default",{enumerable:!0,value:L}),2&C&&typeof L!="string")for(var k in L)O.d(x,k,function(I){return L[I]}.bind(null,k));return x},O.n=function(L){var C=L&&L.__esModule?function(){return L.default}:function(){return L};return O.d(C,"a",C),C},O.o=function(L,C){return Object.prototype.hasOwnProperty.call(L,C)},O.p="",O(O.s=0)}([function(K,e,O){(function(L){var C;e=K.exports=M,C=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var $=Array.prototype.slice.call(arguments,0);$.unshift("SEMVER"),console.log.apply(console,$)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var x=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],u=e.src=[],a=0,y=a++;u[y]="0|[1-9]\\d*";var w=a++;u[w]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=a++;u[m]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var S=a++;u[S]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var D=a++;u[D]="(?:"+u[y]+"|"+u[d]+")";var p=a++;u[p]="(?:"+u[w]+"|"+u[d]+")";var l=a++;u[l]="(?:-("+u[D]+"(?:\\."+u[D]+")*))";var E=a++;u[E]="(?:-?("+u[p]+"(?:\\."+u[p]+")*))";var v=a++;u[v]="[0-9A-Za-z-]+";var f=a++;u[f]="(?:\\+("+u[v]+"(?:\\."+u[v]+")*))";var g=a++,i="v?"+u[m]+u[l]+"?"+u[f]+"?";u[g]="^"+i+"$";var s="[v=\\s]*"+u[S]+u[E]+"?"+u[f]+"?",t=a++;u[t]="^"+s+"$";var n=a++;u[n]="((?:<|>)?=?)";var r=a++;u[r]=u[w]+"|x|X|\\*";var o=a++;u[o]=u[y]+"|x|X|\\*";var c=a++;u[c]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[l]+")?"+u[f]+"?)?)?";var b=a++;u[b]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[E]+")?"+u[f]+"?)?)?";var R=a++;u[R]="^"+u[n]+"\\s*"+u[c]+"$";var T=a++;u[T]="^"+u[n]+"\\s*"+u[b]+"$";var N=a++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=a++;u[F]="(?:~>?)";var z=a++;u[z]="(\\s*)"+u[F]+"\\s+",I[z]=new RegExp(u[z],"g");var H=a++;u[H]="^"+u[F]+u[c]+"$";var re=a++;u[re]="^"+u[F]+u[b]+"$";var ie=a++;u[ie]="(?:\\^)";var ue=a++;u[ue]="(\\s*)"+u[ie]+"\\s+",I[ue]=new RegExp(u[ue],"g");var fe=a++;u[fe]="^"+u[ie]+u[c]+"$";var le=a++;u[le]="^"+u[ie]+u[b]+"$";var j=a++;u[j]="^"+u[n]+"\\s*("+s+")$|^$";var X=a++;u[X]="^"+u[n]+"\\s*("+i+")$|^$";var W=a++;u[W]="(\\s*)"+u[n]+"\\s*("+s+"|"+u[c]+")",I[W]=new RegExp(u[W],"g");var V=a++;u[V]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var q=a++;u[q]="^\\s*("+u[b]+")\\s+-\\s+("+u[b]+")\\s*$";var Y=a++;u[Y]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)C(J,u[J]),I[J]||(I[J]=new RegExp(u[J]));function Z($,Q){if($ instanceof M)return $;if(typeof $!="string"||$.length>x||!(Q?I[t]:I[g]).test($))return null;try{return new M($,Q)}catch{return null}}function M($,Q){if($ instanceof M){if($.loose===Q)return $;$=$.version}else if(typeof $!="string")throw new TypeError("Invalid Version: "+$);if($.length>x)throw new TypeError("version is longer than "+x+" characters");if(!(this instanceof M))return new M($,Q);C("SemVer",$,Q),this.loose=Q;var ee=$.trim().match(Q?I[t]:I[g]);if(!ee)throw new TypeError("Invalid Version: "+$);if(this.raw=$,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var we=+ge;if(we>=0&&we<k)return we}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Z,e.valid=function($,Q){var ee=Z($,Q);return ee?ee.version:null},e.clean=function($,Q){var ee=Z($.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function($){return C("SemVer.compare",this.version,this.loose,$),$ instanceof M||($=new M($,this.loose)),this.compareMain($)||this.comparePre($)},M.prototype.compareMain=function($){return $ instanceof M||($=new M($,this.loose)),h(this.major,$.major)||h(this.minor,$.minor)||h(this.patch,$.patch)},M.prototype.comparePre=function($){if($ instanceof M||($=new M($,this.loose)),this.prerelease.length&&!$.prerelease.length)return-1;if(!this.prerelease.length&&$.prerelease.length)return 1;if(!this.prerelease.length&&!$.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],ge=$.prerelease[Q];if(C("prerelease compare",Q,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return h(ee,ge)}while(++Q)},M.prototype.inc=function($,Q){switch($){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+$)}return this.format(),this.raw=this.version,this},e.inc=function($,Q,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new M($,ee).inc(Q,ge).version}catch{return null}},e.diff=function($,Q){if(G($,Q))return null;var ee=Z($),ge=Z(Q);if(ee.prerelease.length||ge.prerelease.length){for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ge[we])return"pre"+we;return"prerelease"}for(var we in ee)if((we==="major"||we==="minor"||we==="patch")&&ee[we]!==ge[we])return we},e.compareIdentifiers=h;var _=/^[0-9]+$/;function h($,Q){var ee=_.test($),ge=_.test(Q);return ee&&ge&&($=+$,Q=+Q),ee&&!ge?-1:ge&&!ee?1:$<Q?-1:$>Q?1:0}function P($,Q,ee){return new M($,ee).compare(new M(Q,ee))}function A($,Q,ee){return P($,Q,ee)>0}function U($,Q,ee){return P($,Q,ee)<0}function G($,Q,ee){return P($,Q,ee)===0}function B($,Q,ee){return P($,Q,ee)!==0}function te($,Q,ee){return P($,Q,ee)>=0}function ae($,Q,ee){return P($,Q,ee)<=0}function ce($,Q,ee,ge){var we;switch(Q){case"===":typeof $=="object"&&($=$.version),typeof ee=="object"&&(ee=ee.version),we=$===ee;break;case"!==":typeof $=="object"&&($=$.version),typeof ee=="object"&&(ee=ee.version),we=$!==ee;break;case"":case"=":case"==":we=G($,ee,ge);break;case"!=":we=B($,ee,ge);break;case">":we=A($,ee,ge);break;case">=":we=te($,ee,ge);break;case"<":we=U($,ee,ge);break;case"<=":we=ae($,ee,ge);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function me($,Q){if($ instanceof me){if($.loose===Q)return $;$=$.value}if(!(this instanceof me))return new me($,Q);C("comparator",$,Q),this.loose=Q,this.parse($),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function($,Q){return h(Q,$)},e.major=function($,Q){return new M($,Q).major},e.minor=function($,Q){return new M($,Q).minor},e.patch=function($,Q){return new M($,Q).patch},e.compare=P,e.compareLoose=function($,Q){return P($,Q,!0)},e.rcompare=function($,Q,ee){return P(Q,$,ee)},e.sort=function($,Q){return $.sort(function(ee,ge){return e.compare(ee,ge,Q)})},e.rsort=function($,Q){return $.sort(function(ee,ge){return e.rcompare(ee,ge,Q)})},e.gt=A,e.lt=U,e.eq=G,e.neq=B,e.gte=te,e.lte=ae,e.cmp=ce,e.Comparator=me;var ye={};function he($,Q){if($ instanceof he)return $.loose===Q?$:new he($.raw,Q);if($ instanceof me)return new he($.value,Q);if(!(this instanceof he))return new he($,Q);if(this.loose=Q,this.raw=$,this.set=$.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$);this.format()}function pe($){return!$||$.toLowerCase()==="x"||$==="*"}function de($,Q,ee,ge,we,Oe,be,Te,Re,xe,_e,Le,Ae){return((Q=pe(ee)?"":pe(ge)?">="+ee+".0.0":pe(we)?">="+ee+"."+ge+".0":">="+Q)+" "+(Te=pe(Re)?"":pe(xe)?"<"+(+Re+1)+".0.0":pe(_e)?"<"+Re+"."+(+xe+1)+".0":Le?"<="+Re+"."+xe+"."+_e+"-"+Le:"<="+Te)).trim()}function Se($,Q){for(var ee=0;ee<$.length;ee++)if(!$[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<$.length;ee++)if(C($[ee].semver),$[ee].semver!==ye&&$[ee].semver.prerelease.length>0){var ge=$[ee].semver;if(ge.major===Q.major&&ge.minor===Q.minor&&ge.patch===Q.patch)return!0}return!1}return!0}function Pe($,Q,ee){try{Q=new he(Q,ee)}catch{return!1}return Q.test($)}function Ce($,Q,ee,ge){var we,Oe,be,Te,Re;switch($=new M($,ge),Q=new he(Q,ge),ee){case">":we=A,Oe=ae,be=U,Te=">",Re=">=";break;case"<":we=U,Oe=te,be=A,Te="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe($,Q,ge))return!1;for(var xe=0;xe<Q.set.length;++xe){var _e=Q.set[xe],Le=null,Ae=null;if(_e.forEach(function(Ne){Ne.semver===ye&&(Ne=new me(">=0.0.0")),Le=Le||Ne,Ae=Ae||Ne,we(Ne.semver,Le.semver,ge)?Le=Ne:be(Ne.semver,Ae.semver,ge)&&(Ae=Ne)}),Le.operator===Te||Le.operator===Re||(!Ae.operator||Ae.operator===Te)&&Oe($,Ae.semver)||Ae.operator===Re&&be($,Ae.semver))return!1}return!0}me.prototype.parse=function($){var Q=this.loose?I[j]:I[X],ee=$.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+$);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new M(ee[2],this.loose):this.semver=ye},me.prototype.toString=function(){return this.value},me.prototype.test=function($){return C("Comparator.test",$,this.loose),this.semver===ye||(typeof $=="string"&&($=new M($,this.loose)),ce($,this.operator,this.semver,this.loose))},me.prototype.intersects=function($,Q){if(!($ instanceof me))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new he($.value,Q),Pe(this.value,ee,Q);if($.operator==="")return ee=new he(this.value,Q),Pe($.semver,ee,Q);var ge=!(this.operator!==">="&&this.operator!==">"||$.operator!==">="&&$.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||$.operator!=="<="&&$.operator!=="<"),Oe=this.semver.version===$.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||$.operator!==">="&&$.operator!=="<="),Te=ce(this.semver,"<",$.semver,Q)&&(this.operator===">="||this.operator===">")&&($.operator==="<="||$.operator==="<"),Re=ce(this.semver,">",$.semver,Q)&&(this.operator==="<="||this.operator==="<")&&($.operator===">="||$.operator===">");return ge||we||Oe&&be||Te||Re},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function($){return $.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function($){var Q=this.loose;$=$.trim(),C("range",$,Q);var ee=Q?I[q]:I[V];$=$.replace(ee,de),C("hyphen replace",$),$=$.replace(I[W],"$1$2$3"),C("comparator trim",$,I[W]),$=($=($=$.replace(I[z],"$1~")).replace(I[ue],"$1^")).split(/\s+/).join(" ");var ge=Q?I[j]:I[X],we=$.split(" ").map(function(Oe){return function(be,Te){return C("comp",be),be=function(Re,xe){return Re.trim().split(/\s+/).map(function(_e){return function(Le,Ae){C("caret",Le,Ae);var Ne=Ae?I[le]:I[fe];return Le.replace(Ne,function(Me,Ee,Ie,De,ke){var Fe;return C("caret",Le,Me,Ee,Ie,De,ke),pe(Ee)?Fe="":pe(Ie)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":pe(De)?Fe=Ee==="0"?">="+Ee+"."+Ie+".0 <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+".0 <"+(+Ee+1)+".0.0":ke?(C("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=Ee==="0"?Ie==="0"?">="+Ee+"."+Ie+"."+De+ke+" <"+Ee+"."+Ie+"."+(+De+1):">="+Ee+"."+Ie+"."+De+ke+" <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+"."+De+ke+" <"+(+Ee+1)+".0.0"):(C("no pr"),Fe=Ee==="0"?Ie==="0"?">="+Ee+"."+Ie+"."+De+" <"+Ee+"."+Ie+"."+(+De+1):">="+Ee+"."+Ie+"."+De+" <"+Ee+"."+(+Ie+1)+".0":">="+Ee+"."+Ie+"."+De+" <"+(+Ee+1)+".0.0"),C("caret return",Fe),Fe})}(_e,xe)}).join(" ")}(be,Te),C("caret",be),be=function(Re,xe){return Re.trim().split(/\s+/).map(function(_e){return function(Le,Ae){var Ne=Ae?I[re]:I[H];return Le.replace(Ne,function(Me,Ee,Ie,De,ke){var Fe;return C("tilde",Le,Me,Ee,Ie,De,ke),pe(Ee)?Fe="":pe(Ie)?Fe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":pe(De)?Fe=">="+Ee+"."+Ie+".0 <"+Ee+"."+(+Ie+1)+".0":ke?(C("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Fe=">="+Ee+"."+Ie+"."+De+ke+" <"+Ee+"."+(+Ie+1)+".0"):Fe=">="+Ee+"."+Ie+"."+De+" <"+Ee+"."+(+Ie+1)+".0",C("tilde return",Fe),Fe})}(_e,xe)}).join(" ")}(be,Te),C("tildes",be),be=function(Re,xe){return C("replaceXRanges",Re,xe),Re.split(/\s+/).map(function(_e){return function(Le,Ae){Le=Le.trim();var Ne=Ae?I[T]:I[R];return Le.replace(Ne,function(Me,Ee,Ie,De,ke,Fe){C("xRange",Le,Me,Ee,Ie,De,ke,Fe);var We=pe(Ie),Ue=We||pe(De),Ve=Ue||pe(ke);return Ee==="="&&Ve&&(Ee=""),We?Me=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Ue&&(De=0),Ve&&(ke=0),Ee===">"?(Ee=">=",Ue?(Ie=+Ie+1,De=0,ke=0):Ve&&(De=+De+1,ke=0)):Ee==="<="&&(Ee="<",Ue?Ie=+Ie+1:De=+De+1),Me=Ee+Ie+"."+De+"."+ke):Ue?Me=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ve&&(Me=">="+Ie+"."+De+".0 <"+Ie+"."+(+De+1)+".0"),C("xRange return",Me),Me})}(_e,xe)}).join(" ")}(be,Te),C("xrange",be),be=function(Re,xe){return C("replaceStars",Re,xe),Re.trim().replace(I[Y],"")}(be,Te),C("stars",be),be}(Oe,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Oe){return!!Oe.match(ge)})),we=we.map(function(Oe){return new me(Oe,Q)})},he.prototype.intersects=function($,Q){if(!($ instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return $.set.some(function(we){return we.every(function(Oe){return ge.intersects(Oe,Q)})})})})},e.toComparators=function($,Q){return new he($,Q).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},he.prototype.test=function($){if(!$)return!1;typeof $=="string"&&($=new M($,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Se(this.set[Q],$))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function($,Q,ee){var ge=null,we=null;try{var Oe=new he(Q,ee)}catch{return null}return $.forEach(function(be){Oe.test(be)&&(ge&&we.compare(be)!==-1||(we=new M(ge=be,ee)))}),ge},e.minSatisfying=function($,Q,ee){var ge=null,we=null;try{var Oe=new he(Q,ee)}catch{return null}return $.forEach(function(be){Oe.test(be)&&(ge&&we.compare(be)!==1||(we=new M(ge=be,ee)))}),ge},e.validRange=function($,Q){try{return new he($,Q).range||"*"}catch{return null}},e.ltr=function($,Q,ee){return Ce($,Q,"<",ee)},e.gtr=function($,Q,ee){return Ce($,Q,">",ee)},e.outside=Ce,e.prerelease=function($,Q){var ee=Z($,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function($,Q,ee){return $=new he($,ee),Q=new he(Q,ee),$.intersects(Q)},e.coerce=function($){if($ instanceof M)return $;if(typeof $!="string")return null;var Q=$.match(I[N]);return Q==null?null:Z((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,O(1))},function(K,e){var O,L,C=K.exports={};function x(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function I(p){if(O===setTimeout)return setTimeout(p,0);if((O===x||!O)&&setTimeout)return O=setTimeout,setTimeout(p,0);try{return O(p,0)}catch{try{return O.call(null,p,0)}catch{return O.call(this,p,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:x}catch{O=x}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch{L=k}})();var u,a=[],y=!1,w=-1;function d(){y&&u&&(y=!1,u.length?a=u.concat(a):w=-1,a.length&&m())}function m(){if(!y){var p=I(d);y=!0;for(var l=a.length;l;){for(u=a,a=[];++w<l;)u&&u[w].run();w=-1,l=a.length}u=null,y=!1,function(E){if(L===clearTimeout)return clearTimeout(E);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(E);try{L(E)}catch{try{return L.call(null,E)}catch{return L.call(this,E)}}}(p)}}function S(p,l){this.fun=p,this.array=l}function D(){}C.nextTick=function(p){var l=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)l[E-1]=arguments[E];a.push(new S(p,l)),a.length!==1||y||I(m)},S.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=D,C.addListener=D,C.once=D,C.off=D,C.removeListener=D,C.removeAllListeners=D,C.emit=D,C.prependListener=D,C.prependOnceListener=D,C.listeners=function(p){return[]},C.binding=function(p){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(p){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ne[76],se([0,1]),function(K,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(I,u,a){this.level=I,this.key=u,this.value=a,this.forward=[]}}const C=void 0;class x{constructor(I,u=2**16){this.comparator=I,this[O]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new L(this._maxLevel,C,C)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,C,C),this._size=0}has(I){return!!x._search(this,I,this.comparator)}get(I){return x._search(this,I,this.comparator)?.value}set(I,u){return x._insert(this,I,u,this.comparator)&&(this._size+=1),this}delete(I){const u=x._delete(this,I,this.comparator);return u&&(this._size-=1),u}forEach(I,u){let a=this._header.forward[0];for(;a;)I.call(u,a.value,a.key,this),a=a.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",u=this._header.forward[0];for(;u;)I+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return I}static _search(I,u,a){let y=I._header;for(let w=I._level-1;w>=0;w--)for(;y.forward[w]&&a(y.forward[w].key,u)<0;)y=y.forward[w];if(y=y.forward[0],y&&a(y.key,u)===0)return y}static _insert(I,u,a,y){const w=[];let d=I._header;for(let m=I._level-1;m>=0;m--){for(;d.forward[m]&&y(d.forward[m].key,u)<0;)d=d.forward[m];w[m]=d}if(d=d.forward[0],d&&y(d.key,u)===0)return d.value=a,!1;{const m=x._randomLevel(I);if(m>I._level){for(let S=I._level;S<m;S++)w[S]=I._header;I._level=m}d=new L(m,u,a);for(let S=0;S<m;S++)d.forward[S]=w[S].forward[S],w[S].forward[S]=d;return!0}}static _randomLevel(I,u=.5){let a=1;for(;Math.random()<u&&a<I._maxLevel;)a+=1;return a}static _delete(I,u,a){const y=[];let w=I._header;for(let d=I._level-1;d>=0;d--){for(;w.forward[d]&&a(w.forward[d].key,u)<0;)w=w.forward[d];y[d]=w}if(w=w.forward[0],!w||a(w.key,u)!==0)return!1;for(let d=0;d<I._level&&y[d].forward[d]===w;d++)y[d].forward[d]=w.forward[d];for(;I._level>0&&I._header.forward[I._level-1]===C;)I._level-=1;return!0}}e.SkipList=x}),define(ne[46],se([0,1,8,2]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=C,e.isReadableStream=x,e.isReadableBufferedStream=k,e.newWriteableStream=I,e.consumeReadable=a,e.peekReadable=y,e.consumeStream=w,e.listenStream=d,e.peekStream=m,e.toStream=S,e.emptyStream=D,e.toReadable=p,e.transform=l,e.prefixedReadable=E,e.prefixedStream=v;function C(f){const g=f;return g?typeof g.read=="function":!1}function x(f){const g=f;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}function k(f){const g=f;return g?x(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function I(f,g){return new u(f,g)}class u{constructor(g,i){this.reducer=g,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(i=>i(g))}emitError(g){this.listeners.error.length===0?(0,O.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(i=>i(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,i){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(g,i){if(this.state.destroyed)return;let s;switch(g){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function a(f,g){const i=[];let s;for(;(s=f.read())!==null;)i.push(s);return g(i)}function y(f,g,i){const s=[];let t;for(;(t=f.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return f.read()}}}function w(f,g){return new Promise((i,s)=>{const t=[];d(f,{onData:n=>{g&&t.push(n)},onError:n=>{g?s(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}function d(f,g,i){f.on("error",s=>{i?.isCancellationRequested||g.onError(s)}),f.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),f.on("data",s=>{i?.isCancellationRequested||g.onData(s)})}function m(f,g){return new Promise((i,s)=>{const t=new L.DisposableStore,n=[],r=b=>{if(n.push(b),n.length>g)return t.dispose(),f.pause(),i({stream:f,buffer:n,ended:!1})},o=b=>(t.dispose(),s(b)),c=()=>(t.dispose(),i({stream:f,buffer:n,ended:!0}));t.add((0,L.toDisposable)(()=>f.removeListener("error",o))),f.on("error",o),t.add((0,L.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),t.add((0,L.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}function S(f,g){const i=I(g);return i.end(f),i}function D(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}function p(f){let g=!1;return{read:()=>g?null:(g=!0,f)}}function l(f,g,i){const s=I(i);return d(f,{onData:t=>s.write(g.data(t)),onError:t=>s.error(g.error?g.error(t):t),onEnd:()=>s.end()}),s}function E(f,g,i){let s=!1;return{read:()=>{const t=g.read();return s?t:(s=!0,t!==null?i([f,t]):f)}}}function v(f,g,i){let s=!1;const t=I(i);return d(g,{onData:n=>s?t.write(n):(s=!0,t.write(i([f,n]))),onError:n=>t.error(n),onEnd:()=>{s||(s=!0,t.write(f)),t.end()}}),t}}),define(ne[14],se([0,1,169,46]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=a,e.readUInt16LE=y,e.writeUInt16LE=w,e.readUInt32BE=d,e.writeUInt32BE=m,e.readUInt32LE=S,e.writeUInt32LE=D,e.readUInt8=p,e.writeUInt8=l,e.readableToBuffer=E,e.bufferToReadable=v,e.streamToBuffer=f,e.bufferedStreamToBuffer=g,e.bufferToStream=i,e.streamToBufferReadableStream=s,e.newWriteableBufferStream=t,e.prefixedBufferReadable=n,e.prefixedBufferStream=r,e.decodeBase64=o,e.encodeBase64=R;const C=typeof Buffer<"u",x=new O.Lazy(()=>new Uint8Array(256));let k,I;class u{static alloc(N){return C?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return C&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,F){return!(F?.dontUseNodeBuffer||!1)&&C?new u(Buffer.from(N)):(k||(k=new TextEncoder),new u(k.encode(N)))}static fromByteArray(N){const F=u.alloc(N.length);for(let z=0,H=N.length;z<H;z++)F.buffer[z]=N[z];return F}static concat(N,F){if(typeof F>"u"){F=0;for(let re=0,ie=N.length;re<ie;re++)F+=N[re].byteLength}const z=u.alloc(F);let H=0;for(let re=0,ie=N.length;re<ie;re++){const ue=N[re];z.set(ue,H),H+=ue.byteLength}return z}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return C?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(N,F){return new u(this.buffer.subarray(N,F))}set(N,F){if(N instanceof u)this.buffer.set(N.buffer,F);else if(N instanceof Uint8Array)this.buffer.set(N,F);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),F);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return d(this.buffer,N)}writeUInt32BE(N,F){m(this.buffer,N,F)}readUInt32LE(N){return S(this.buffer,N)}writeUInt32LE(N,F){D(this.buffer,N,F)}readUInt8(N){return p(this.buffer,N)}writeUInt8(N,F){l(this.buffer,N,F)}indexOf(N,F=0){return a(this.buffer,N instanceof u?N.buffer:N,F)}}e.VSBuffer=u;function a(T,N,F=0){const z=N.byteLength,H=T.byteLength;if(z===0)return 0;if(z===1)return T.indexOf(N[0]);if(z>H-F)return-1;const re=x.value;re.fill(N.length);for(let le=0;le<N.length;le++)re[N[le]]=N.length-le-1;let ie=F+N.length-1,ue=ie,fe=-1;for(;ie<H;)if(T[ie]===N[ue]){if(ue===0){fe=ie;break}ie--,ue--}else ie+=Math.max(N.length-ue,re[T[ie]]),ue=N.length-1;return fe}function y(T,N){return T[N+0]<<0>>>0|T[N+1]<<8>>>0}function w(T,N,F){T[F+0]=N&255,N=N>>>8,T[F+1]=N&255}function d(T,N){return T[N]*2**24+T[N+1]*2**16+T[N+2]*2**8+T[N+3]}function m(T,N,F){T[F+3]=N,N=N>>>8,T[F+2]=N,N=N>>>8,T[F+1]=N,N=N>>>8,T[F]=N}function S(T,N){return T[N+0]<<0>>>0|T[N+1]<<8>>>0|T[N+2]<<16>>>0|T[N+3]<<24>>>0}function D(T,N,F){T[F+0]=N&255,N=N>>>8,T[F+1]=N&255,N=N>>>8,T[F+2]=N&255,N=N>>>8,T[F+3]=N&255}function p(T,N){return T[N]}function l(T,N,F){T[F]=N}function E(T){return L.consumeReadable(T,N=>u.concat(N))}function v(T){return L.toReadable(T)}function f(T){return L.consumeStream(T,N=>u.concat(N))}async function g(T){return T.ended?u.concat(T.buffer):u.concat([...T.buffer,await f(T.stream)])}function i(T){return L.toStream(T,N=>u.concat(N))}function s(T){return L.transform(T,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}function t(T){return L.newWriteableStream(N=>u.concat(N),T)}function n(T,N){return L.prefixedReadable(T,N,F=>u.concat(F))}function r(T,N){return L.prefixedStream(T,N,F=>u.concat(F))}function o(T){let N=0,F=0,z=0;const H=new Uint8Array(Math.floor(T.length/4*3)),re=ue=>{switch(F){case 3:H[z++]=N|ue,F=0;break;case 2:H[z++]=N|ue>>>2,N=ue<<6,F=3;break;case 1:H[z++]=N|ue>>>4,N=ue<<4,F=2;break;default:N=ue<<2,F=1}};for(let ue=0;ue<T.length;ue++){const fe=T.charCodeAt(ue);if(fe>=65&&fe<=90)re(fe-65);else if(fe>=97&&fe<=122)re(fe-97+26);else if(fe>=48&&fe<=57)re(fe-48+52);else if(fe===43||fe===45)re(62);else if(fe===47||fe===95)re(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ue]}`)}}const ie=z;for(;F>0;)re(0);return u.wrap(H).slice(0,ie)}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:T},N=!0,F=!1){const z=F?b:c;let H="";const re=T.byteLength%3;let ie=0;for(;ie<T.byteLength-re;ie+=3){const ue=T[ie+0],fe=T[ie+1],le=T[ie+2];H+=z[ue>>>2],H+=z[(ue<<4|fe>>>4)&63],H+=z[(fe<<2|le>>>6)&63],H+=z[le&63]}if(re===1){const ue=T[ie+0];H+=z[ue>>>2],H+=z[ue<<4&63],N&&(H+="==")}else if(re===2){const ue=T[ie+0],fe=T[ie+1];H+=z[ue>>>2],H+=z[(ue<<4|fe>>>4)&63],H+=z[fe<<2&63],N&&(H+="=")}return H}}),define(ne[43],se([0,1,30]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=L,e.doHash=C,e.numberHash=x,e.stringHash=I,e.toHexString=D;function L(l){return C(l,0)}function C(l,E){switch(typeof l){case"object":return l===null?x(349,E):Array.isArray(l)?u(l,E):a(l,E);case"string":return I(l,E);case"boolean":return k(l,E);case"number":return x(l,E);case"undefined":return x(937,E);default:return x(617,E)}}function x(l,E){return(E<<5)-E+l|0}function k(l,E){return x(l?433:863,E)}function I(l,E){E=x(149417,E);for(let v=0,f=l.length;v<f;v++)E=x(l.charCodeAt(v),E);return E}function u(l,E){return E=x(104579,E),l.reduce((v,f)=>C(f,v),E)}function a(l,E){return E=x(181387,E),Object.keys(l).sort().reduce((v,f)=>(v=I(f,v),C(l[f],v)),E)}class y{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=C(E,this._value),this._value}}e.Hasher=y;var w;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function d(l,E,v=32){const f=v-E,g=~((1<<f)-1);return(l<<E|(g&l)>>>f)>>>0}function m(l,E=0,v=l.byteLength,f=0){for(let g=0;g<v;g++)l[E+g]=f}function S(l,E,v="0"){for(;l.length<E;)l=v+l;return l}function D(l,E=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(v=>v.toString(16).padStart(2,"0")).join(""):S((l>>>0).toString(16),E/4)}class p{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const v=E.length;if(v===0)return;const f=this._buff;let g=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=E.charCodeAt(0),t=0);;){let n=s;if(O.isHighSurrogate(s))if(t+1<v){const r=E.charCodeAt(t+1);O.isLowSurrogate(r)?(t++,n=O.computeCodePoint(s,r)):n=65533}else{i=s;break}else O.isLowSurrogate(s)&&(n=65533);if(g=this._push(f,g,n),t++,t<v)s=E.charCodeAt(t);else break}this._buffLen=g,this._leftoverHighSurrogate=i}_push(E,v,f){return f<128?E[v++]=f:f<2048?(E[v++]=192|(f&1984)>>>6,E[v++]=128|(f&63)>>>0):f<65536?(E[v++]=224|(f&61440)>>>12,E[v++]=128|(f&4032)>>>6,E[v++]=128|(f&63)>>>0):(E[v++]=240|(f&1835008)>>>18,E[v++]=128|(f&258048)>>>12,E[v++]=128|(f&4032)>>>6,E[v++]=128|(f&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,E[0]=E[64],E[1]=E[65],E[2]=E[66]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),D(this._h0)+D(this._h1)+D(this._h2)+D(this._h3)+D(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,v=this._buffDV;for(let c=0;c<64;c+=4)E.setUint32(c,v.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)E.setUint32(c,d(E.getUint32(c-12,!1)^E.getUint32(c-32,!1)^E.getUint32(c-56,!1)^E.getUint32(c-64,!1),1),!1);let f=this._h0,g=this._h1,i=this._h2,s=this._h3,t=this._h4,n,r,o;for(let c=0;c<80;c++)c<20?(n=g&i|~g&s,r=1518500249):c<40?(n=g^i^s,r=1859775393):c<60?(n=g&i|g&s|i&s,r=2400959708):(n=g^i^s,r=3395469782),o=d(f,5)+n+t+r+E.getUint32(c*4,!1)&4294967295,t=s,s=i,i=d(g,30),g=f,f=o;this._h0=this._h0+f&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=p}),define(ne[55],se([0,1,30]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(L||(L={})),function(C){const x="error",k="warning",I="warn",u="info",a="ignore";function y(d){return d?O.equalsIgnoreCase(x,d)?C.Error:O.equalsIgnoreCase(k,d)||O.equalsIgnoreCase(I,d)?C.Warning:O.equalsIgnoreCase(u,d)?C.Info:C.Ignore:C.Ignore}C.fromValue=y;function w(d){switch(d){case C.Error:return x;case C.Warning:return k;case C.Info:return u;default:return a}}C.toString=w}(L||(L={})),e.default=L}),define(ne[27],se([0,1,3]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=L,e.deepFreeze=C,e.cloneAndChange=k,e.mixin=u,e.equals=a,e.safeStringify=y,e.distinct=w,e.getCaseInsensitive=d,e.filter=m,e.getAllPropertyNames=S,e.getAllMethodNames=D,e.createProxyObject=p;function L(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const E=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([v,f])=>{E[v]=f&&typeof f=="object"?L(f):f}),E}function C(l){if(!l||typeof l!="object")return l;const E=[l];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const f in v)if(x.call(v,f)){const g=v[f];typeof g=="object"&&!Object.isFrozen(g)&&!(0,O.isTypedArray)(g)&&E.push(g)}}return l}const x=Object.prototype.hasOwnProperty;function k(l,E){return I(l,E,new Set)}function I(l,E,v){if((0,O.isUndefinedOrNull)(l))return l;const f=E(l);if(typeof f<"u")return f;if(Array.isArray(l)){const g=[];for(const i of l)g.push(I(i,E,v));return g}if((0,O.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const g={};for(const i in l)x.call(l,i)&&(g[i]=I(l[i],E,v));return v.delete(l),g}return l}function u(l,E,v=!0){return(0,O.isObject)(l)?((0,O.isObject)(E)&&Object.keys(E).forEach(f=>{f in l?v&&((0,O.isObject)(l[f])&&(0,O.isObject)(E[f])?u(l[f],E[f],v):l[f]=E[f]):l[f]=E[f]}),l):E}function a(l,E){if(l===E)return!0;if(l==null||E===null||E===void 0||typeof l!=typeof E||typeof l!="object"||Array.isArray(l)!==Array.isArray(E))return!1;let v,f;if(Array.isArray(l)){if(l.length!==E.length)return!1;for(v=0;v<l.length;v++)if(!a(l[v],E[v]))return!1}else{const g=[];for(f in l)g.push(f);g.sort();const i=[];for(f in E)i.push(f);if(i.sort(),!a(g,i))return!1;for(v=0;v<g.length;v++)if(!a(l[g[v]],E[g[v]]))return!1}return!0}function y(l){const E=new Set;return JSON.stringify(l,(v,f)=>{if((0,O.isObject)(f)||Array.isArray(f)){if(E.has(f))return"[Circular]";E.add(f)}return f})}function w(l,E){const v=Object.create(null);return!l||!E||Object.keys(E).forEach(g=>{const i=l[g],s=E[g];a(i,s)||(v[g]=s)}),v}function d(l,E){const v=E.toLowerCase(),f=Object.keys(l).find(g=>g.toLowerCase()===v);return f?l[f]:l[E]}function m(l,E){const v=Object.create(null);for(const[f,g]of Object.entries(l))E(f,g)&&(v[f]=g);return v}function S(l){let E=[];for(;Object.prototype!==l;)E=E.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return E}function D(l){const E=[];for(const v of S(l))typeof l[v]=="function"&&E.push(v);return E}function p(l,E){const v=g=>function(){const i=Array.prototype.slice.call(arguments,0);return E(g,i)},f={};for(const g of l)f[g]=v(g);return f}}),define(ne[28],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=L;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(C){return O.test(C)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(I){for(let u=0;u<I.length;u++)I[u]=Math.floor(Math.random()*256);return I};const x=new Uint8Array(16),k=[];for(let I=0;I<256;I++)k.push(I.toString(16).padStart(2,"0"));return function(){C(x),x[6]=x[6]&15|64,x[8]=x[8]&63|128;let u=0,a="";return a+=k[x[u++]],a+=k[x[u++]],a+=k[x[u++]],a+=k[x[u++]],a+="-",a+=k[x[u++]],a+=k[x[u++]],a+="-",a+=k[x[u++]],a+=k[x[u++]],a+="-",a+=k[x[u++]],a+=k[x[u++]],a+="-",a+=k[x[u++]],a+=k[x[u++]],a+=k[x[u++]],a+=k[x[u++]],a+=k[x[u++]],a+=k[x[u++]],a}}()}),define(ne[77],se([0,1,33]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=x;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(k){const I=k.replace(/\-/g,":").toLowerCase();return!L.has(I)}function x(){const k=(0,O.networkInterfaces)();for(const I in k){const u=k[I];if(u){for(const{mac:a}of u)if(C(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[78],se([7,4]),function(K,e){return K.create("vs/base/common/date",e)}),define(ne[79],se([0,1,78]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=a,e.getDurationString=y,e.toLocalISOString=w;const L=60,C=L*60,x=C*24,k=x*7,I=x*30,u=x*365;function a(d,m,S,D){typeof d!="number"&&(d=d.getTime());const p=Math.round((new Date().getTime()-d)/1e3);if(p<-30)return(0,O.localize)(0,null,a(new Date().getTime()+p*1e3,!1));if(!D&&p<30)return(0,O.localize)(1,null);let l;return p<L?(l=p,m?l===1?S?(0,O.localize)(2,null,l):(0,O.localize)(3,null,l):S?(0,O.localize)(4,null,l):(0,O.localize)(5,null,l):l===1?S?(0,O.localize)(6,null,l):(0,O.localize)(7,null,l):S?(0,O.localize)(8,null,l):(0,O.localize)(9,null,l)):p<C?(l=Math.floor(p/L),m?l===1?S?(0,O.localize)(10,null,l):(0,O.localize)(11,null,l):S?(0,O.localize)(12,null,l):(0,O.localize)(13,null,l):l===1?S?(0,O.localize)(14,null,l):(0,O.localize)(15,null,l):S?(0,O.localize)(16,null,l):(0,O.localize)(17,null,l)):p<x?(l=Math.floor(p/C),m?l===1?S?(0,O.localize)(18,null,l):(0,O.localize)(19,null,l):S?(0,O.localize)(20,null,l):(0,O.localize)(21,null,l):l===1?S?(0,O.localize)(22,null,l):(0,O.localize)(23,null,l):S?(0,O.localize)(24,null,l):(0,O.localize)(25,null,l)):p<k?(l=Math.floor(p/x),m?l===1?(0,O.localize)(26,null,l):(0,O.localize)(27,null,l):l===1?(0,O.localize)(28,null,l):(0,O.localize)(29,null,l)):p<I?(l=Math.floor(p/k),m?l===1?S?(0,O.localize)(30,null,l):(0,O.localize)(31,null,l):S?(0,O.localize)(32,null,l):(0,O.localize)(33,null,l):l===1?S?(0,O.localize)(34,null,l):(0,O.localize)(35,null,l):S?(0,O.localize)(36,null,l):(0,O.localize)(37,null,l)):p<u?(l=Math.floor(p/I),m?l===1?S?(0,O.localize)(38,null,l):(0,O.localize)(39,null,l):S?(0,O.localize)(40,null,l):(0,O.localize)(41,null,l):l===1?S?(0,O.localize)(42,null,l):(0,O.localize)(43,null,l):S?(0,O.localize)(44,null,l):(0,O.localize)(45,null,l)):(l=Math.floor(p/u),m?l===1?S?(0,O.localize)(46,null,l):(0,O.localize)(47,null,l):S?(0,O.localize)(48,null,l):(0,O.localize)(49,null,l):l===1?S?(0,O.localize)(50,null,l):(0,O.localize)(51,null,l):S?(0,O.localize)(52,null,l):(0,O.localize)(53,null,l))}function y(d,m){const S=Math.abs(d/1e3);return S<1?m?(0,O.localize)(54,null,d):(0,O.localize)(55,null,d):S<L?m?(0,O.localize)(56,null,Math.round(d)/1e3):(0,O.localize)(57,null,Math.round(d)/1e3):S<C?m?(0,O.localize)(58,null,Math.round(d/(1e3*L))):(0,O.localize)(59,null,Math.round(d/(1e3*L))):S<x?m?(0,O.localize)(60,null,Math.round(d/(1e3*C))):(0,O.localize)(61,null,Math.round(d/(1e3*C))):(0,O.localize)(62,null,Math.round(d/(1e3*x)))}function w(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[80],se([7,4]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ne[34],se([0,1,19,3,80]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=u,e.isErrorWithActions=a,e.createErrorWithActions=y;function x(w,d){return d&&(w.stack||w.stacktrace)?C.localize(0,null,I(w),k(w.stack)||k(w.stacktrace)):I(w)}function k(w){return Array.isArray(w)?w.join(`
`):w}function I(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?C.localize(1,null,w.message):w.message||C.localize(2,null)}function u(w=null,d=!1){if(!w)return C.localize(3,null);if(Array.isArray(w)){const m=O.coalesce(w),S=u(m[0],d);return m.length>1?C.localize(4,null,S,m.length):S}if(L.isString(w))return w;if(w.detail){const m=w.detail;if(m.error)return x(m.error,d);if(m.exception)return x(m.exception,d)}return w.stack?x(w,d):w.message?w.message:C.localize(5,null)}function a(w){const d=w;return d instanceof Error&&Array.isArray(d.actions)}function y(w,d){let m;return typeof w=="string"?m=new Error(w):m=w,m.actions=d,m}}),define(ne[81],se([7,4]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(ne[82],se([0,1,81]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=L;function L(C){switch(C){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}}),define(ne[56],se([0,1,12]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=x,e.removeDangerousEnvVariables=k;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var C;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function x(I,...u){const a=u.reduce((d,m)=>(d[m]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(d=>!a[d]).forEach(d=>{for(let m=0;m<y.length;m++)if(d.search(y[m])!==-1){delete I[d];break}})}function k(I){I&&(delete I.DEBUG,O.isMacintosh&&delete I.DYLD_LIBRARY_PATH,O.isLinux&&delete I.LD_PRELOAD)}}),define(ne[83],se([0,1,11]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=L,e.parse=C,e.getFirstFrame=x,e.log=I;function L(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function C(a){const y=[];let w;try{const d=JSON.parse(a.arguments),m=d[d.length-1];m&&m.__$stack&&(d.pop(),w=m.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:w}}function x(a){if(typeof a!="string")return x(C(a).stack);const y=a;if(y){const w=k(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function k(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function I(a,y){const{args:w,stack:d}=C(a),m=typeof w[0]=="string"&&w.length===1;let S=k(d);S&&(S=`(${S.trim()})`);let D=[];if(typeof w[0]=="string"?S&&m?D=[`%c[${y}] %c${w[0]} %c${S}`,u("blue"),u(""),u("grey")]:D=[`%c[${y}] %c${w[0]}`,u("blue"),u(""),...w.slice(1)]:D=[`%c[${y}]%`,u("blue"),...w],S&&!m&&D.push(S),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,D)}function u(a){return`color: ${a}`}}),define(ne[47],se([0,1,14,11]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=C,e.parse=x,e.revive=I;function C(u){return JSON.stringify(u,k)}function x(u){let a=JSON.parse(u);return a=I(a),a}function k(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function I(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return L.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof O.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=I(u[y],a+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=I(u[y],a+1))}return u}}),define(ne[84],se([0,1,71,15,12,11]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=y;class k{constructor(d,m,S){this.id=d,this.dependencies=m,this.callback=S}}class I{static{this.INSTANCE=new I}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(d,m,S)=>{typeof d!="string"&&(S=m,m=d,d=null),(typeof m!="object"||!Array.isArray(m))&&(S=m,m=null),this._defineCalls.push(new k(d,m,S))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this._initialize();const m=await(this._isWebWorker?this._workerLoadScript(d):this._isRenderer?this._rendererLoadScript(d):this._nodeJSLoadScript(d));if(!m)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}_rendererLoadScript(d){return new Promise((m,S)=>{const D=document.createElement("script");D.setAttribute("async","async"),D.setAttribute("type","text/javascript");const p=()=>{D.removeEventListener("load",l),D.removeEventListener("error",E)},l=v=>{p(),m(this._defineCalls.pop())},E=v=>{p(),S(v)};D.addEventListener("load",l),D.addEventListener("error",E),this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),D.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(D)})}_workerLoadScript(d){return new Promise((m,S)=>{try{this._amdPolicy&&(d=this._amdPolicy.createScriptURL(d)),importScripts(d),m(this._defineCalls.pop())}catch(D){S(D)}})}async _nodeJSLoadScript(d){try{const m=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,D=globalThis._VSCODE_NODE_MODULES.module,p=x.URI.parse(d).fsPath,l=m.readFileSync(p).toString(),E=D.wrap(l.replace(/^#!.*/,""));return new S.Script(E).runInThisContext().apply(),this._defineCalls.pop()}catch(m){throw m}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(w,d,m){if(O.isESM){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[w]&&(w=a[w]);const S=`${w}/${d}`;if(u.has(S))return u.get(S);let D;if(/^\w[\w\d+.-]*:\/\//.test(S))D=S;else{const v=`${m&&!C.isWeb?L.nodeModulesAsarPath:L.nodeModulesPath}/${S}`;D=L.FileAccess.asBrowserUri(v).toString(!0)}const p=I.INSTANCE.load(D);return u.set(S,p),p}else return await new Promise((S,D)=>{K([w],S,D)})}}),define(ne[85],se([0,1,33,48,28,77,12]),function(K,e,O,L,C,x,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=u,e.getSqmMachineId=w,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(d){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(d)}value(){if(this._value===void 0){let d=0,m=0;const S=(0,O.networkInterfaces)();for(const D in S){const p=S[D];if(p)for(const{mac:l,internal:E}of p)E||(m+=1,this._isVirtualMachineMacAddress(l.toUpperCase())&&(d+=1))}this._value=m>0?d/m:0}return this._value}};let I;async function u(d){return I||(I=(async()=>await a(d)||C.generateUuid())()),I}async function a(d){try{const m=await new Promise((D,p)=>{K(["crypto"],D,p)}),S=(0,x.getMac)();return m.createHash("sha256").update(S,"utf8").digest("hex")}catch(m){d(m);return}}const y="Software\\Microsoft\\SQMClient";async function w(d){if(k.isWindows){const m=await new Promise((S,D)=>{K(["@vscode/windows-registry"],S,D)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(S){return d(S),""}}return""}}),define(ne[86],se([0,1,33,16,25]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=E,e.getFirstAvailablePowerShellInstallation=v;const x=/^\d+$/,k=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var u;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class w{constructor(g,i,s){this.exePath=g,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await C.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:f=!1}={}){return f?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:f=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:f});if(!i)return null;const s=L.join(i,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(s))return null;let t=-1,n=null;for(const c of await C.Promises.readdir(s)){let b=-1;if(g){const T=c.indexOf("-");if(T<0)continue;const N=c.substring(0,T);if(!x.test(N)||c.substring(T+1)!=="preview")continue;b=parseInt(N,10)}else{if(!x.test(c))continue;b=parseInt(c,10)}if(b<=t)continue;const R=L.join(s,c,"pwsh.exe");await C.SymlinkSupport.existsFile(R)&&(n=R,t=b)}if(!n)return null;const r=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new w(n,`PowerShell${o}${r}`,!0)}async function S({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const g=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const t of await C.Promises.readdir(g))if(i.test(t)){const n=L.join(g,t,"pwsh.exe");return new w(n,s)}return null}function D(){const f=L.join(O.homedir(),".dotnet","tools","pwsh.exe");return new w(f,".NET Core PowerShell Global Tool")}function p(){const f=L.join(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(f,"Windows PowerShell",!0)}async function*l(){let f=await m();f&&(yield f),f=await m({useAlternateBitness:!0}),f&&(yield f),f=await S(),f&&(yield f),f=D(),f&&(yield f),f=await m({findPreview:!0}),f&&(yield f),f=await S({findPreview:!0}),f&&(yield f),f=await m({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=p(),f&&(yield f)}async function*E(){for await(const f of l())await f.exists()&&(yield f)}async function v(){for await(const f of E())return f;return null}}),define(ne[57],se([0,1,16,12,35,56,3,25]),function(K,e,O,L,C,x,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=u,e.createQueuedSender=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return x.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return x.TerminateResponseCode}});function u(w=C.env){return w.comspec||"cmd.exe"}function a(w){let d=[],m=!1;const S=function(D){if(m){d.push(D);return}(!w.send(D,l=>{if(l&&console.error(l),m=!1,d.length>0){const E=d.slice(0);d=[],E.forEach(v=>S(v))}})||L.isWindows)&&(m=!0)};return{send:S}}var y;(function(w){async function d(m,S,D){if(O.isAbsolute(m))return m;if(S===void 0&&(S=C.cwd()),O.dirname(m)!=="."||(D===void 0&&k.isString(C.env.PATH)&&(D=C.env.PATH.split(O.delimiter)),D===void 0||D.length===0))return O.join(S,m);async function l(E){if(await I.Promises.exists(E)){let v;try{v=await I.Promises.stat(E)}catch(f){f.message.startsWith("EACCES")&&(v=await I.Promises.lstat(E))}return v?!v.isDirectory():!1}return!1}for(const E of D){let v;if(O.isAbsolute(E)?v=O.join(E,m):v=O.join(S,E,m),await l(v))return v;let f=v+".com";if(await l(f)||(f=v+".exe",await l(f)))return f}return O.join(S,m)}w.findExecutable=d})(y||(e.win32=y={}))}),define(ne[87],se([0,1,33,12,86,57]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=k;async function k(w,d){return w===1?L.isWindows?y():x.getWindowsShell(d):u(w,d)}let I=null;function u(w,d){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!I){let m;if(L.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,O.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}I=m}return I}let a=null;async function y(){return a||(a=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),a}});var ve=this&&this.__decorate||function(K,e,O,L){var C=arguments.length,x=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,O):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")x=Reflect.decorate(K,e,O,L);else for(var I=K.length-1;I>=0;I--)(k=K[I])&&(x=(C<3?k(x):C>3?k(e,O,x):k(e,O))||x);return C>3&&x&&Object.defineProperty(e,O,x),x};define(ne[58],se([0,1,19,9,14,20,54,8,5,2,47,30,3]),function(K,e,O,L,C,x,k,I,u,a,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=c,e.getDelayedChannel=z,e.getNextTickChannel=H;var m;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(m||(m={}));function S(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var D;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(D||(D={}));function p(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(l||(l={}));function E(W){let V=0;for(let q=0;;q+=7){const Y=W.read(1);if(V|=(Y.buffer[0]&127)<<q,!(Y.buffer[0]&128))return V}}const v=t(0);function f(W,V){if(V===0){W.write(v);return}let q=0;for(let J=V;J!==0;J=J>>>7)q++;const Y=C.VSBuffer.alloc(q);for(let J=0;V!==0;J++)Y.buffer[J]=V&127,V=V>>>7,V>0&&(Y.buffer[J]|=128);W.write(Y)}class g{constructor(V){this.buffer=V,this.pos=0}read(V){const q=this.buffer.slice(this.pos,this.pos+V);return this.pos+=q.byteLength,q}}e.BufferReader=g;class i{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}e.BufferWriter=i;var s;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(s||(s={}));function t(W){const V=C.VSBuffer.alloc(1);return V.writeUInt8(W,0),V}const n={Undefined:t(s.Undefined),String:t(s.String),Buffer:t(s.Buffer),VSBuffer:t(s.VSBuffer),Array:t(s.Array),Object:t(s.Object),Uint:t(s.Int)},r=typeof Buffer<"u";function o(W,V){if(typeof V>"u")W.write(n.Undefined);else if(typeof V=="string"){const q=C.VSBuffer.fromString(V);W.write(n.String),f(W,q.byteLength),W.write(q)}else if(r&&Buffer.isBuffer(V)){const q=C.VSBuffer.wrap(V);W.write(n.Buffer),f(W,q.byteLength),W.write(q)}else if(V instanceof C.VSBuffer)W.write(n.VSBuffer),f(W,V.byteLength),W.write(V);else if(Array.isArray(V)){W.write(n.Array),f(W,V.length);for(const q of V)o(W,q)}else if(typeof V=="number"&&(V|0)===V)W.write(n.Uint),f(W,V);else{const q=C.VSBuffer.fromString(JSON.stringify(V));W.write(n.Object),f(W,q.byteLength),W.write(q)}}function c(W){switch(W.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return W.read(E(W)).toString();case s.Buffer:return W.read(E(W)).buffer;case s.VSBuffer:return W.read(E(W));case s.Array:{const q=E(W),Y=[];for(let J=0;J<q;J++)Y.push(c(W));return Y}case s.Object:return JSON.parse(W.read(E(W)).toString());case s.Int:return E(W)}}class b{constructor(V,q,Y=null,J=1e3){this.protocol=V,this.ctx=q,this.logger=Y,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(V,q){this.channels.set(V,q),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const q=this.send([V.type]);this.logger?.logOutgoing(q,0,1,p(V.type));return}case 201:case 202:case 204:case 203:{const q=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(q,V.id,1,p(V.type),V.data);return}}}send(V,q=void 0){const Y=new i;return o(Y,V),o(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const q=new g(V),Y=c(q),J=c(q),Z=Y[0];switch(Z){case 100:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${S(Z)}: ${Y[2]}.${Y[3]}`,J),this.onPromise({type:Z,id:Y[1],channelName:Y[2],name:Y[3],arg:J});case 102:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${S(Z)}: ${Y[2]}.${Y[3]}`,J),this.onEventListen({type:Z,id:Y[1],channelName:Y[2],name:Y[3],arg:J});case 101:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${S(Z)}`),this.disposeActiveRequest({type:Z,id:Y[1]});case 103:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${S(Z)}`),this.disposeActiveRequest({type:Z,id:Y[1]})}}onPromise(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=new x.CancellationTokenSource;let J;try{J=q.call(this.ctx,V.name,V.arg,Y.token)}catch(_){J=Promise.reject(_)}const Z=V.id;J.then(_=>{this.sendResponse({id:Z,data:_,type:201})},_=>{_ instanceof Error?this.sendResponse({id:Z,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:Z,data:_,type:203})}).finally(()=>{M.dispose(),this.activeRequests.delete(V.id)});const M=(0,a.toDisposable)(()=>Y.cancel());this.activeRequests.set(V.id,M)}onEventListen(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=V.id,Z=q.listen(this.ctx,V.name,V.arg)(M=>this.sendResponse({id:Y,data:M,type:204}));this.activeRequests.set(V.id,Z)}disposeActiveRequest(V){const q=this.activeRequests.get(V.id);q&&(q.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let q=this.pendingRequests.get(V.channelName);q||(q=[],this.pendingRequests.set(V.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:V,timeoutTimer:Y})}flushPendingRequests(V){const q=this.pendingRequests.get(V);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=b;var R;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class T{constructor(V,q=null){this.protocol=V,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=q}getChannel(V){const q=this;return{call(Y,J,Z){return q.isDisposed?Promise.reject(new I.CancellationError):q.requestPromise(V,Y,J,Z)},listen(Y,J){return q.isDisposed?u.Event.None:q.requestEvent(V,Y,J)}}}requestPromise(V,q,Y,J=x.CancellationToken.None){const Z=this.lastRequestId++,_={id:Z,type:100,channelName:V,name:q,arg:Y};if(J.isCancellationRequested)return Promise.reject(new I.CancellationError);let h;return new Promise((A,U)=>{if(J.isCancellationRequested)return U(new I.CancellationError);const G=()=>{const ce=me=>{switch(me.type){case 201:this.handlers.delete(Z),A(me.data);break;case 202:{this.handlers.delete(Z);const ye=new Error(me.data.message);ye.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,ye.name=me.data.name,U(ye);break}case 203:this.handlers.delete(Z),U(me.data);break}};this.handlers.set(Z,ce),this.sendRequest(_)};let B=null;this.state===l.Idle?G():(B=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),B.then(()=>{B=null,G()}));const te=()=>{B?(B.cancel(),B=null):this.sendRequest({id:Z,type:101}),U(new I.CancellationError)},ae=J.onCancellationRequested(te);h=(0,a.combinedDisposable)((0,a.toDisposable)(te),ae),this.activeRequests.add(h)}).finally(()=>{h.dispose(),this.activeRequests.delete(h)})}requestEvent(V,q,Y){const J=this.lastRequestId++,M={id:J,type:102,channelName:V,name:q,arg:Y};let _=null;const h=new u.Emitter({onWillAddFirstListener:()=>{_=(0,L.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(h),this.sendRequest(M)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(h),this.sendRequest({id:J,type:103}))}}),P=A=>h.fire(A.data);return this.handlers.set(J,P),h.event}sendRequest(V){switch(V.type){case 100:case 102:{const q=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(q,V.id,0,`${S(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const q=this.send([V.type,V.id]);this.logger?.logOutgoing(q,V.id,0,S(V.type));return}}}send(V,q=void 0){const Y=new i;return o(Y,V),o(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const q=new g(V),Y=c(q),J=c(q),Z=Y[0];switch(Z){case 200:return this.logger?.logIncoming(V.byteLength,0,0,p(Z)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,Y[1],0,p(Z),J),this.onResponse({type:Y[0],id:Y[1],data:J})}}onResponse(V){if(V.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,a.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=T,ve([k.memoize],T.prototype,"onDidInitializePromise",null);class N{get connections(){const V=[];return this._connections.forEach(q=>V.push(q)),V}constructor(V,q,Y){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new a.DisposableStore,this.disposables.add(V(({protocol:J,onDidClientDisconnect:Z})=>{const M=u.Event.once(J.onMessage);this.disposables.add(M(_=>{const h=new g(_),P=c(h),A=new b(J,P,q,Y),U=new T(J,q);this.channels.forEach((B,te)=>A.registerChannel(te,B));const G={channelServer:A,channelClient:U,ctx:P};this._connections.add(G),this._onDidAddConnection.fire(G),this.disposables.add(Z(()=>{A.dispose(),U.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)}))}))}))}getChannel(V,q){const Y=this;return{call(J,Z,M){let _;if((0,d.isFunction)(q)){const P=(0,O.getRandomElement)(Y.connections.filter(q));_=P?Promise.resolve(P):u.Event.toPromise(u.Event.filter(Y.onDidAddConnection,q))}else _=q.routeCall(Y,J,Z);const h=_.then(P=>P.channelClient.getChannel(V));return z(h).call(J,Z,M)},listen(J,Z){if((0,d.isFunction)(q))return Y.getMulticastEvent(V,q,J,Z);const M=q.routeEvent(Y,J,Z).then(_=>_.channelClient.getChannel(V));return z(M).listen(J,Z)}}}getMulticastEvent(V,q,Y,J){const Z=this;let M;const _=new u.Emitter({onWillAddFirstListener:()=>{M=new a.DisposableStore;const h=new u.EventMultiplexer,P=new Map,A=G=>{const te=G.channelClient.getChannel(V).listen(Y,J),ae=h.add(te);P.set(G,ae)},U=G=>{const B=P.get(G);B&&(B.dispose(),P.delete(G))};Z.connections.filter(q).forEach(A),u.Event.filter(Z.onDidAddConnection,q)(A,void 0,M),Z.onDidRemoveConnection(U,void 0,M),h.event(_.fire,_,M),M.add(h)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return _.event}registerChannel(V,q){this.channels.set(V,q);for(const Y of this._connections)Y.channelServer.registerChannel(V,q)}dispose(){this.disposables.dispose();for(const V of this._connections)V.channelClient.dispose(),V.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=N;class F{constructor(V,q,Y=null){const J=new i;o(J,q),V.send(J.buffer),this.channelClient=new T(V,Y),this.channelServer=new b(V,q,Y)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,q){this.channelServer.registerChannel(V,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function z(W){return{call(V,q,Y){return W.then(J=>J.call(V,q,Y))},listen(V,q){const Y=new u.Relay;return W.then(J=>Y.input=J.listen(V,q)),Y.event}}}function H(W){let V=!1;return{call(q,Y,J){return V?W.call(q,Y,J):(0,L.timeout)(0).then(()=>V=!0).then(()=>W.call(q,Y,J))},listen(q,Y){if(V)return W.listen(q,Y);const J=new u.Relay;return(0,L.timeout)(0).then(()=>V=!0).then(()=>J.input=W.listen(q,Y)),J.event}}}class re{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const q of V.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await u.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=re;var ie;(function(W){function V(Z,M,_){const h=Z,P=_&&_.disableMarshalling,A=new Map;for(const U in h)Y(U)&&A.set(U,u.Event.buffer(h[U],!0,void 0,M));return new class{listen(U,G,B){const te=A.get(G);if(te)return te;const ae=h[G];if(typeof ae=="function"){if(J(G))return ae.call(h,B);if(Y(G))return A.set(G,u.Event.buffer(h[G],!0,void 0,M)),A.get(G)}throw new I.ErrorNoTelemetry(`Event not found: ${G}`)}call(U,G,B){const te=h[G];if(typeof te=="function"){if(!P&&Array.isArray(B))for(let ce=0;ce<B.length;ce++)B[ce]=(0,y.revive)(B[ce]);let ae=te.apply(h,B);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new I.ErrorNoTelemetry(`Method not found: ${G}`)}}}W.fromService=V;function q(Z,M){const _=M&&M.disableMarshalling;return new Proxy({},{get(h,P){if(typeof P=="string")return M?.properties?.has(P)?M.properties.get(P):J(P)?function(A){return Z.listen(P,A)}:Y(P)?Z.listen(P):async function(...A){let U;M&&!(0,d.isUndefinedOrNull)(M.context)?U=[M.context,...A]:U=A;const G=await Z.call(P,U);return _?G:(0,y.revive)(G)};throw new I.ErrorNoTelemetry(`Property not found: ${String(P)}`)}})}W.toService=q;function Y(Z){return Z[0]==="o"&&Z[1]==="n"&&w.isUpperAsciiLetter(Z.charCodeAt(2))}function J(Z){return/^onDynamic/.test(Z)&&w.isUpperAsciiLetter(Z.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const V=W.toString();if(V!=="[object Object]")return V}return W}function le(W){return Array.isArray(W)?W.map(fe):fe(W)}function j(W,V,q,Y,J,Z,M){M=le(M);const _=ue[J],h=_[Y%_.length];let P=[`%c[${W}]%c[${String(V).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(Z)?(P=P.concat(M),P.push(")")):P.push(M),console.log.apply(console,P)}class X{constructor(V,q){this._outgoingPrefix=V,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,q,Y,J,Z){this._totalOutgoing+=V,j(this._outgoingPrefix,this._totalOutgoing,V,q,Y,J,Z)}logIncoming(V,q,Y,J,Z){this._totalIncoming+=V,j(this._incomingPrefix,this._totalIncoming,V,q,Y,J,Z)}}e.IPCLogger=X}),define(ne[88],se([0,1,59,9,14,20,83,8,5,2,27,57,56,58]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends m.ChannelServer{constructor(l){super({send:E=>{try{process.send?.(E.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",E=>C.VSBuffer.wrap(Buffer.from(E,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=S;class D{constructor(l,E){this.modulePath=l,this.options=E,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=E&&E.timeout?E.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(l){const E=this;return{call(v,f,g){return E.requestPromise(l,v,f,g)},listen(v,f){return E.requestEvent(l,v,f)}}}requestPromise(l,E,v,f=x.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const g=this.getCachedChannel(l),i=(0,L.createCancelablePromise)(n=>g.call(E,v,n)),s=f.onCancellationRequested(()=>i.cancel()),t=(0,a.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(l,E,v){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let f;const g=new u.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(l).listen(E,v)(g.fire,g),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return g.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],E=Object.create(null);E.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(E.env={...E.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(E.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(E.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(E.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),E.execArgv===void 0&&(E.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,d.removeDangerousEnvVariables)(E.env),this.child=(0,O.fork)(this.modulePath,l,E);const v=new u.Emitter,g=u.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}v.fire(C.VSBuffer.wrap(Buffer.from(o,"base64")))}),i=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&i.send(o.buffer.toString("base64")),t=v.event,n={send:s,onMessage:t};this._client=new m.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",r),g.dispose(),this.activeRequests.forEach(b=>(0,a.dispose)(b)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(l){let E=this.channels.get(l);return E||(E=this.client.getChannel(l),this.channels.set(l,E)),E}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=D}),define(ne[89],se([0,1,9,5,2,47,3]),function(K,e,O,L,C,x,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=u;var I;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function u(d){const m=d;return m?.changed instanceof Map||m?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends C.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(m,S=Object.create(null)){super(),this.database=m,this.options=S,this._onDidChangeStorage=this._register(new L.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new O.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){this._onDidChangeStorage.pause();try{m.changed?.forEach((S,D)=>this.acceptExternal(D,S)),m.deleted?.forEach(S=>this.acceptExternal(S,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(m,S){if(this.state===a.Closed)return;let D=!1;(0,k.isUndefinedOrNull)(S)?D=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),D=!0),D&&this._onDidChangeStorage.fire({key:m,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const D=this.cache.get(m);return(0,k.isUndefinedOrNull)(D)?S:D}getBoolean(m,S){const D=this.get(m);return(0,k.isUndefinedOrNull)(D)?S:D==="true"}getNumber(m,S){const D=this.get(m);return(0,k.isUndefinedOrNull)(D)?S:parseInt(D,10)}getObject(m,S){const D=this.get(m);return(0,k.isUndefinedOrNull)(D)?S:(0,x.parse)(D)}async set(m,S,D=!1){if(this.state===a.Closed)return;if((0,k.isUndefinedOrNull)(S))return this.delete(m,D);const p=(0,k.isObject)(S)||Array.isArray(S)?(0,x.stringify)(S):String(S);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire({key:m,external:D}),this.doFlush()}async delete(m,S=!1){if(!(this.state===a.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire({key:m,external:S}),this.doFlush()}async optimize(){if(this.state!==a.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(this.hasPending)return this.doFlush(m)}async doFlush(m){return this.options.hint===I.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}isInMemory(){return this.options.hint===I.STORAGE_IN_MEMORY}}e.Storage=y;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((S,D)=>this.items.set(D,S)),m.delete?.forEach(S=>this.items.delete(S))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(ne[90],se([7,4]),function(K,e){return K.create("vs/base/node/zip",e)}),define(ne[49],se([0,1,60,9,16,3,25,90]),function(K,e,O,L,C,x,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=p,e.extract=l,e.buffer=v,e.CorruptZipMessage="end of central directory record signature not found";const u=new RegExp(e.CorruptZipMessage);class a extends Error{constructor(g,i){let s=i.message;switch(g){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=g,this.cause=i}}e.ExtractError=a;function y(f){const g=f.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,s)=>i+s,g&61440)}function w(f){if(f instanceof a)return f;let g;return u.test(f.message)&&(g="CorruptZip"),new a(g,f)}function d(f,g,i,s,t,n){const r=C.dirname(g),o=C.join(s,r);if(!o.startsWith(s))return Promise.reject(new Error(I.localize(0,null,g)));const c=C.join(s,g);let b;return n.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(k.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,T)=>{if(!n.isCancellationRequested)try{b=(0,O.createWriteStream)(c,{mode:i}),b.once("close",()=>R()),b.once("error",T),f.once("error",T),f.pipe(b)}catch(N){T(N)}}))}function m(f,g,i,s){let t=(0,L.createCancelablePromise)(()=>Promise.resolve()),n=0;const r=s.onCancellationRequested(()=>{t.cancel(),f.close()});return new Promise((o,c)=>{const b=new L.Sequencer,R=T=>{T.isCancellationRequested||(n++,f.readEntry())};f.once("error",c),f.once("close",()=>t.then(()=>{s.isCancellationRequested||f.entryCount===n?o():c(new a("Incomplete",new Error(I.localize(1,null,n,f.entryCount))))},c)),f.readEntry(),f.on("entry",T=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(T.fileName)){R(s);return}const N=T.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const H=C.join(g,N);t=(0,L.createCancelablePromise)(re=>k.Promises.mkdir(H,{recursive:!0}).then(()=>R(re)).then(void 0,c));return}const F=D(f,T),z=y(T);t=(0,L.createCancelablePromise)(H=>b.queue(()=>F.then(re=>d(re,N,z,g,i,H).then(()=>R(H)))).then(null,c))})}).finally(()=>r.dispose())}async function S(f,g=!1){const{open:i}=await new Promise((s,t)=>{K(["yauzl"],s,t)});return new Promise((s,t)=>{i(f,g?{lazyEntries:!0}:void 0,(n,r)=>{n?t(w(n)):s((0,x.assertIsDefined)(r))})})}function D(f,g){return new Promise((i,s)=>{f.openReadStream(g,(t,n)=>{t?s(w(t)):i((0,x.assertIsDefined)(n))})})}async function p(f,g){const{ZipFile:i}=await new Promise((s,t)=>{K(["yazl"],s,t)});return new Promise((s,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,O.createWriteStream)(f);n.outputStream.pipe(r),n.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>s(f))})}function l(f,g,i={},s){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=S(f,!0);return i.overwrite&&(n=n.then(r=>k.Promises.rm(g).then(()=>r))),n.then(r=>m(r,g,{sourcePathRegex:t},s))}function E(f,g){return S(f).then(i=>new Promise((s,t)=>{i.on("entry",n=>{n.fileName===g&&D(i,n).then(r=>s(r),r=>t(r))}),i.once("close",()=>t(new Error(I.localize(2,null,g))))}))}function v(f,g){return E(f,g).then(i=>new Promise((s,t)=>{const n=[];i.once("error",t),i.on("data",r=>n.push(r)),i.on("end",()=>s(Buffer.concat(n)))}))}}),define(ne[91],se([7,4]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[92],se([7,4]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[93],se([7,4]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(ne[94],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[95],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[96],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[97],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[98],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[99],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[100],se([7,4]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[101],se([7,4]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[102],se([7,4]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(ne[103],se([7,4]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(ne[104],se([7,4]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[105],se([7,4]),function(K,e){return K.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[106],se([7,4]),function(K,e){return K.create("vs/platform/log/common/log",e)}),define(ne[107],se([7,4]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(ne[108],se([7,4]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(ne[109],se([7,4]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[110],se([7,4]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[111],se([7,4]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(ne[112],se([0,1,8,93]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(C||(e.TokenType=C={}));function x(...a){switch(a.length){case 1:return(0,L.localize)(0,null,a[0]);case 2:return(0,L.localize)(1,null,a[0],a[1]);case 3:return(0,L.localize)(2,null,a[0],a[1],a[2]);default:return}}const k=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class u{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,O.illegalState)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(y){return this._input=y,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const w=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:w})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const w=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:w})}else this._match(126)?this._addToken(9):this._error(x("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(x("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(x("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(y){return this._isAtEnd()||this._input.charCodeAt(this._current)!==y?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(y){this._tokens.push({type:y,offset:this._start})}_error(y){const w=this._start,d=this._input.substring(this._start,this._current),m={type:19,offset:this._start,lexeme:d};this._errors.push({offset:w,lexeme:d,additionalInfo:y}),this._tokens.push(m)}_string(){this.stringRe.lastIndex=this._start;const y=this.stringRe.exec(this._input);if(y){this._current=this._start+y[0].length;const w=this._input.substring(this._start,this._current),d=u._keywords.get(w);d?this._addToken(d):this._tokens.push({type:17,lexeme:w,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(k);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let y=this._current,w=!1,d=!1;for(;;){if(y>=this._input.length){this._current=y,this._error(I);return}const S=this._input.charCodeAt(y);if(w)w=!1;else if(S===47&&!d){y++;break}else S===91?d=!0:S===92?w=!0:S===93&&(d=!1);y++}for(;y<this._input.length&&u._regexFlags.has(this._input.charCodeAt(y));)y++;this._current=y;const m=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:m,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=u}),define(ne[113],se([0,1,79,54,15,16,35,17,11]),function(K,e,O,L,C,x,k,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=y,e.parseDebugParams=w,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,x.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,x.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,x.join)(this.userDataPath,"logs",m)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(u.URI.file((0,x.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=k.env.VSCODE_PORTABLE;return m?u.URI.file((0,x.join)(m,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,x.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,x.resolve)(m):(0,x.normalize)((0,x.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?u.URI.file((0,x.resolve)(m)):u.URI.file((0,x.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,x.resolve)(m);const S=k.env.VSCODE_EXTENSIONS;if(S)return S;const D=k.env.VSCODE_PORTABLE;return D?(0,x.join)(D,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(S=>/^[^:/?#]+?:\/\//.test(S)?u.URI.parse(S):u.URI.file((0,x.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,x.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(m))}get extensionLogLevel(){const m=[];for(const S of this.args.log||[]){const D=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);D&&D[1]&&D[2]&&m.push([D[1],D[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=k.env.VSCODE_PORTABLE;return m?u.URI.file((0,x.join)(m,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this._args}constructor(m,S,D){this._args=m,this.paths=S,this.productService=D,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=a,ve([L.memoize],a.prototype,"appRoot",null),ve([L.memoize],a.prototype,"userHome",null),ve([L.memoize],a.prototype,"userDataPath",null),ve([L.memoize],a.prototype,"appSettingsHome",null),ve([L.memoize],a.prototype,"tmpDir",null),ve([L.memoize],a.prototype,"cacheHome",null),ve([L.memoize],a.prototype,"stateResource",null),ve([L.memoize],a.prototype,"userRoamingDataHome",null),ve([L.memoize],a.prototype,"userDataSyncHome",null),ve([L.memoize],a.prototype,"sync",null),ve([L.memoize],a.prototype,"machineSettingsResource",null),ve([L.memoize],a.prototype,"workspaceStorageHome",null),ve([L.memoize],a.prototype,"localHistoryHome",null),ve([L.memoize],a.prototype,"keyboardLayoutResource",null),ve([L.memoize],a.prototype,"argvResource",null),ve([L.memoize],a.prototype,"isExtensionDevelopment",null),ve([L.memoize],a.prototype,"untitledWorkspacesHome",null),ve([L.memoize],a.prototype,"builtinExtensionsPath",null),ve([L.memoize],a.prototype,"extensionsPath",null),ve([L.memoize],a.prototype,"extensionDevelopmentLocationURI",null),ve([L.memoize],a.prototype,"extensionDevelopmentKind",null),ve([L.memoize],a.prototype,"extensionTestsLocationURI",null),ve([L.memoize],a.prototype,"debugExtensionHost",null),ve([L.memoize],a.prototype,"logLevel",null),ve([L.memoize],a.prototype,"extensionLogLevel",null),ve([L.memoize],a.prototype,"serviceMachineIdResource",null),ve([L.memoize],a.prototype,"disableTelemetry",null),ve([L.memoize],a.prototype,"disableWorkspaceTrust",null),ve([L.memoize],a.prototype,"useInMemorySecretStorage",null),ve([L.memoize],a.prototype,"policyFile",null);function y(d,m){return w(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}function w(d,m,S,D,p,l){const v=Number(m||d)||(D?null:S),f=v?!!m:!1;let g;if(l)try{g=JSON.parse(l)}catch{}return{port:v,break:f,debugId:p,env:g}}}),function(){"use strict";function K(e,O,L){function C(k,I){const u=x(k,I),a=[u];return e.isAbsolute(u)||a.unshift(L),e.resolve(...a)}function x(k,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,I);const y=k["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(O.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,I)}return{getUserDataPath:C}}if(typeof define=="function")define(ne[114],se([170,33,35]),function(e,O,L){return K(e,O,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=K(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[115],se([0,1,33,113,114]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=I;class x extends L.AbstractNativeEnvironmentService{constructor(a,y){super(a,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,C.getUserDataPath)(a,y.nameShort)},y)}}e.NativeEnvironmentService=x;function k(u,a){return(0,L.parseDebugParams)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function I(u,a){return(0,L.parseDebugParams)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(ne[116],se([0,1,3,97]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=C;function C(k,I,u,a){try{x(k,I,u,a)}catch(y){k.error(y?.message??y)}return I}function x(k,I,u,a){const y=(w,d,m)=>{const S=w[d];if((0,O.isString)(S)){const D=S,p=D.length;if(p>1&&D[0]==="%"&&D[p-1]==="%"){const l=D.substr(1,p-2);let E=u[l];E===void 0&&a&&(E=a[l]);const v=typeof E=="string"?E:E?.message,f=a?.[l],g=typeof f=="string"?f:f?.message;if(!v){g||k.warn(`[${I.name}]: ${(0,L.localize)(0,null,l)}`);return}if(m&&(d==="title"||d==="category")&&g&&g!==v){const i={value:v,original:g};w[d]=i}else w[d]=v}}else if((0,O.isObject)(S))for(const D in S)S.hasOwnProperty(D)&&(D==="commands"?y(S,D,!0):y(S,D,m));else if(Array.isArray(S))for(let D=0;D<S.length;D++)y(S,D,m)};for(const w in I)I.hasOwnProperty(w)&&y(I,w)}}),define(ne[117],se([0,1,49,100]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=C;function C(x){return(0,O.buffer)(x,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}}),define(ne[50],se([0,1,17,55,101,44]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=u,e.parseVersion=a,e.normalizeVersion=y,e.isValidVersion=w,e.validateExtensionManifest=d,e.isValidExtensionVersion=m,e.isEngineValid=S;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function u(l){return l=l.trim(),l==="*"||k.test(l)}function a(l){if(!u(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const E=l.match(k);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}function y(l){if(!l)return null;const E=l.majorBase,v=l.majorMustEqual,f=l.minorBase;let g=l.minorMustEqual;const i=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(E===0||(g=!1),s=!1);let t=0;if(l.preRelease){const n=I.exec(l.preRelease);if(n){const[,r,o,c]=n;t=Date.UTC(Number(r),Number(o)-1,Number(c))}}return{majorBase:E,majorMustEqual:v,minorBase:f,minorMustEqual:g,patchBase:i,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:t}}function w(l,E,v){let f;typeof l=="string"?f=y(a(l)):f=l;let g;E instanceof Date?g=E.getTime():typeof E=="string"&&(g=new Date(E).getTime());let i;if(typeof v=="string"?i=y(a(v)):i=v,!f||!i)return!1;const s=f.majorBase,t=f.minorBase,n=f.patchBase;let r=i.majorBase,o=i.minorBase,c=i.patchBase;const b=i.notBefore;let R=i.majorMustEqual,T=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?s>r?!0:s<r?!1:t>o?!0:t<o||g&&g<b?!1:n>=c:(s===1&&r===0&&(!R||!T||!N)&&(r=1,o=0,c=0,R=!0,T=!1,N=!1),s<r?!1:s>r?!R:t<o?!1:t>o?!T:n<c?!1:n>c?!N:!(g&&g<b))}function d(l,E,v,f,g){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([L.default.Error,C.localize(0,null)]),i;if(typeof f.name!="string")return i.push([L.default.Error,C.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([L.default.Error,C.localize(2,null,"version")]),i;if(!f.engines)return i.push([L.default.Error,C.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([L.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!p(f.extensionDependencies))return i.push([L.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!p(f.activationEvents))return i.push([L.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([L.default.Error,C.localize(7,null,"activationEvents","main","browser")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([L.default.Warning,C.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([L.default.Error,C.localize(9,null,"main")]),i;{const n=(0,O.joinPath)(v,f.main);(0,O.isEqualOrParent)(n,v)||i.push([L.default.Warning,C.localize(10,null,n.path,v.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([L.default.Error,C.localize(11,null,"browser")]),i;{const n=(0,O.joinPath)(v,f.browser);(0,O.isEqualOrParent)(n,v)||i.push([L.default.Warning,C.localize(12,null,n.path,v.path)])}}if(!x.valid(f.version))return i.push([L.default.Error,C.localize(13,null)]),i;const s=[];if(!m(l,E,f,g,s))for(const n of s)i.push([L.default.Error,n]);return i}function m(l,E,v,f,g){return f||typeof v.main>"u"&&typeof v.browser>"u"?!0:D(l,E,v.engines.vscode,g)}function S(l,E,v){return l==="*"||D(E,v,l)}function D(l,E,v,f=[]){const g=y(a(v));if(!g)return f.push(C.localize(14,null,v)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return f.push(C.localize(15,null,v)),!1}else if(!g.majorMustEqual)return f.push(C.localize(16,null,v)),!1;return w(l,E,g)?!0:(f.push(C.localize(17,null,l,v)),!1)}function p(l){if(!Array.isArray(l))return!1;for(let E=0,v=l.length;E<v;E++)if(typeof l[E]!="string")return!1;return!0}}),define(ne[118],se([0,1,14,28]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=C;async function C(x,k,I){let u=I&&I.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const y=(await k.readFile(x.serviceMachineIdResource)).value.toString();u=(0,L.isUUID)(y)?y:null}catch{u=null}if(!u){u=(0,L.generateUuid)();try{await k.writeFile(x.serviceMachineIdResource,O.VSBuffer.fromString(u))}catch{}}return I?.store("storage.serviceMachineId",u,-1,1),u}}),define(ne[51],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(C,x=[],k=!1){this.ctor=C,this.staticArguments=x,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=O}),define(ne[119],se([0,1,51]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=x,e.getSingletonServiceDescriptors=k;const L=[];var C;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function x(I,u,a){u instanceof O.SyncDescriptor||(u=new O.SyncDescriptor(u,[],!!a)),L.push([I,u])}function k(){return L}}),define(ne[120],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(x,k){this.key=x,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class L{constructor(x){this._hashFn=x,this._nodes=new Map}roots(){const x=[];for(const k of this._nodes.values())k.outgoing.size===0&&x.push(k);return x}insertEdge(x,k){const I=this.lookupOrInsertNode(x),u=this.lookupOrInsertNode(k);I.outgoing.set(u.key,u),u.incoming.set(I.key,I)}removeNode(x){const k=this._hashFn(x);this._nodes.delete(k);for(const I of this._nodes.values())I.outgoing.delete(k),I.incoming.delete(k)}lookupOrInsertNode(x){const k=this._hashFn(x);let I=this._nodes.get(k);return I||(I=new O(k,x),this._nodes.set(k,I)),I}lookup(x){return this._nodes.get(this._hashFn(x))}isEmpty(){return this._nodes.size===0}toString(){const x=[];for(const[k,I]of this._nodes)x.push(`${k}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return x.join(`
`)}findCycleSlow(){for(const[x,k]of this._nodes){const I=new Set([x]),u=this._findCycle(k,I);if(u)return u}}_findCycle(x,k){for(const[I,u]of x.outgoing){if(k.has(I))return[...k,I].join(" -> ");k.add(I);const a=this._findCycle(u,k);if(a)return a;k.delete(I)}}}e.Graph=L}),define(ne[29],se([0,1,3,11,10]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=x,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=u,e.isConfigured=a,e.toValuesTree=y,e.addToValueTree=w,e.removeFromValueTree=d,e.getConfigurationValue=S,e.merge=D,e.getLanguageTagSettingPlainKey=p,e.IConfigurationService=(0,C.createDecorator)("configurationService");function x(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof L.URI)}function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof L.URI)}var I;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function u(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function y(l,E){const v=Object.create(null);for(const f in l)w(v,f,l[f],E);return v}function w(l,E,v,f){const g=E.split("."),i=g.pop();let s=l;for(let t=0;t<g.length;t++){const n=g[t];let r=s[n];switch(typeof r){case"undefined":r=s[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${E} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[i]=v}catch{f(`Ignoring ${E} as ${g.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${E} as ${g.join(".")} is ${JSON.stringify(s)}`)}function d(l,E){const v=E.split(".");m(l,v)}function m(l,E){const v=E.shift();if(E.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const f=l[v];typeof f=="object"&&!Array.isArray(f)&&(m(f,E),Object.keys(f).length===0&&delete l[v])}}function S(l,E,v){function f(s,t){let n=s;for(const r of t){if(typeof n!="object"||n===null)return;n=n[r]}return n}const g=E.split("."),i=f(l,g);return typeof i>"u"?v:i}function D(l,E,v){Object.keys(E).forEach(f=>{f!=="__proto__"&&(f in l?O.isObject(l[f])&&O.isObject(E[f])?D(l[f],E[f],v):v&&(l[f]=E[f]):l[f]=E[f])})}function p(l){return l.replace(/[\[\]]/g,"")}}),define(ne[121],se([0,1,12,30,112,10,92,8]),function(K,e,O,L,C,x,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=a,e.validateWhenClauses=s,e.expressionsAreEqualWithConstantSubstitution=t,e.implies=J;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",O.isMacintosh),u.set("isLinux",O.isLinux),u.set("isWindows",O.isWindows),u.set("isWeb",O.isWeb),u.set("isMacNative",O.isMacintosh&&!O.isWeb),u.set("isEdge",O.isEdge),u.set("isFirefox",O.isFirefox),u.set("isChrome",O.isChrome),u.set("isSafari",O.isSafari);function a(_,h){if(u.get(_)!==void 0)throw(0,I.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(_,h)}const y=Object.prototype.hasOwnProperty;var w;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const d={regexParsingWithErrorRecovery:!0},m=(0,k.localize)(0,null),S=(0,k.localize)(1,null),D=(0,k.localize)(2,null),p=(0,k.localize)(3,null),l=(0,k.localize)(4,null),E=(0,k.localize)(5,null),v=(0,k.localize)(6,null),f=(0,k.localize)(7,null);class g{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(h=d){this._config=h,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(h){if(h===""){this._parsingErrors.push({message:m,offset:0,lexeme:"",additionalInfo:S});return}this._tokens=this._scanner.reset(h).scan(),this._current=0,this._parsingErrors=[];try{const P=this._expr();if(!this._isAtEnd()){const A=this._peek(),U=A.type===17?E:void 0;throw this._parsingErrors.push({message:l,offset:A.offset,lexeme:C.Scanner.getLexeme(A),additionalInfo:U}),g._parseError}return P}catch(P){if(P!==g._parseError)throw P;return}}_expr(){return this._or()}_or(){const h=[this._and()];for(;this._matchOne(16);){const P=this._and();h.push(P)}return h.length===1?h[0]:i.or(...h)}_and(){const h=[this._term()];for(;this._matchOne(15);){const P=this._term();h.push(P)}return h.length===1?h[0]:i.and(...h)}_term(){if(this._matchOne(2)){const h=this._peek();switch(h.type){case 11:return this._advance(),r.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const P=this._expr();return this._consume(1,p),P?.negate()}case 17:return this._advance(),F.create(h.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",h)}}return this._primary()}_primary(){const h=this._peek();switch(h.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const P=this._expr();return this._consume(1,p),P}case 17:{const P=h.lexeme;if(this._advance(),this._matchOne(9)){const U=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),U.type!==10)throw this._errExpectedButGot("REGEX",U);const G=U.lexeme,B=G.lastIndexOf("/"),te=B===G.length-1?void 0:this._removeFlagsGY(G.substring(B+1));let ae;try{ae=new RegExp(G.substring(1,B),te)}catch{throw this._errExpectedButGot("REGEX",U)}return fe.create(P,ae)}switch(U.type){case 10:case 19:{const G=[U.lexeme];this._advance();let B=this._peek(),te=0;for(let he=0;he<U.lexeme.length;he++)U.lexeme.charCodeAt(he)===40?te++:U.lexeme.charCodeAt(he)===41&&te--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let he=0;he<B.lexeme.length;he++)B.lexeme.charCodeAt(he)===40?te++:U.lexeme.charCodeAt(he)===41&&te--}if(te<0)break;G.push(C.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const ae=G.join(""),ce=ae.lastIndexOf("/"),me=ce===ae.length-1?void 0:this._removeFlagsGY(ae.substring(ce+1));let ye;try{ye=new RegExp(ae.substring(1,ce),me)}catch{throw this._errExpectedButGot("REGEX",U)}return i.regex(P,ye)}case 18:{const G=U.lexeme;this._advance();let B=null;if(!(0,L.isFalsyOrWhitespace)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const ce=G.slice(te+1,ae),me=G[ae+1]==="i"?"i":"";try{B=new RegExp(ce,me)}catch{throw this._errExpectedButGot("REGEX",U)}}}if(B===null)throw this._errExpectedButGot("REGEX",U);return fe.create(P,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,D);const U=this._value();return i.notIn(P,U)}switch(this._peek().type){case 3:{this._advance();const U=this._value();if(this._previous().type===18)return i.equals(P,U);switch(U){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,U)}}case 4:{this._advance();const U=this._value();if(this._previous().type===18)return i.notEquals(P,U);switch(U){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,U)}}case 5:return this._advance(),ie.create(P,this._value());case 6:return this._advance(),ue.create(P,this._value());case 7:return this._advance(),H.create(P,this._value());case 8:return this._advance(),re.create(P,this._value());case 13:return this._advance(),i.in(P,this._value());default:return i.has(P)}}case 20:throw this._parsingErrors.push({message:v,offset:h.offset,lexeme:"",additionalInfo:f}),g._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const h=this._peek();switch(h.type){case 17:case 18:return this._advance(),h.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(h){return h.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(h){return this._check(h)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(h,P){if(this._check(h))return this._advance();throw this._errExpectedButGot(P,this._peek())}_errExpectedButGot(h,P,A){const U=(0,k.localize)(8,null,h,C.Scanner.getLexeme(P)),G=P.offset,B=C.Scanner.getLexeme(P);return this._parsingErrors.push({message:U,offset:G,lexeme:B,additionalInfo:A}),g._parseError}_check(h){return this._peek().type===h}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=g;class i{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(h){return c.create(h)}static equals(h,P){return b.create(h,P)}static notEquals(h,P){return N.create(h,P)}static regex(h,P){return fe.create(h,P)}static in(h,P){return R.create(h,P)}static notIn(h,P){return T.create(h,P)}static not(h){return F.create(h)}static and(...h){return X.create(h,null,!0)}static or(...h){return W.create(h,null,!0)}static greater(h,P){return H.create(h,P)}static greaterEquals(h,P){return re.create(h,P)}static smaller(h,P){return ie.create(h,P)}static smallerEquals(h,P){return ue.create(h,P)}static{this._parser=new g({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this._parser.parse(h)}}e.ContextKeyExpr=i;function s(_){const h=new g({regexParsingWithErrorRecovery:!1});return _.map(P=>(h.parse(P),h.lexingErrors.length>0?h.lexingErrors.map(A=>({errorMessage:A.additionalInfo?(0,k.localize)(9,null,A.additionalInfo):(0,k.localize)(10,null),offset:A.offset,length:A.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(A=>({errorMessage:A.additionalInfo?`${A.message}. ${A.additionalInfo}`:A.message,offset:A.offset,length:A.lexeme.length})):[]))}function t(_,h){const P=_?_.substituteConstants():void 0,A=h?h.substituteConstants():void 0;return!P&&!A?!0:!P||!A?!1:P.equals(A)}function n(_,h){return _.cmp(h)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=r;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=o;class c{static create(h,P=null){const A=u.get(h);return typeof A=="boolean"?A?o.INSTANCE:r.INSTANCE:new c(h,P)}constructor(h,P){this.key=h,this.negated=P,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:q(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=u.get(this.key);return typeof h=="boolean"?h?o.INSTANCE:r.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.negated||(this.negated=F.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=c;class b{static create(h,P,A=null){if(typeof P=="boolean")return P?c.create(h,A):F.create(h,A);const U=u.get(h);return typeof U=="boolean"?P===(U?"true":"false")?o.INSTANCE:r.INSTANCE:new b(h,P,A)}constructor(h,P,A){this.key=h,this.value=P,this.negated=A,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=u.get(this.key);if(typeof h=="boolean"){const P=h?"true":"false";return this.value===P?o.INSTANCE:r.INSTANCE}return this}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class R{static create(h,P){return new R(h,P)}constructor(h,P){this.key=h,this.valueKey=P,this.type=10,this.negated=null}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}substituteConstants(){return this}evaluate(h){const P=h.getValue(this.valueKey),A=h.getValue(this.key);return Array.isArray(P)?P.includes(A):typeof A=="string"&&typeof P=="object"&&P!==null?y.call(P,A):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=R;class T{static create(h,P){return new T(h,P)}constructor(h,P){this.key=h,this.valueKey=P,this.type=11,this._negated=R.create(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:this._negated.cmp(h._negated)}equals(h){return h.type===this.type?this._negated.equals(h._negated):!1}substituteConstants(){return this}evaluate(h){return!this._negated.evaluate(h)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(h){return h.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=T;class N{static create(h,P,A=null){if(typeof P=="boolean")return P?F.create(h,A):c.create(h,A);const U=u.get(h);return typeof U=="boolean"?P===(U?"true":"false")?r.INSTANCE:o.INSTANCE:new N(h,P,A)}constructor(h,P,A){this.key=h,this.value=P,this.negated=A,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){const h=u.get(this.key);if(typeof h=="boolean"){const P=h?"true":"false";return this.value===P?r.INSTANCE:o.INSTANCE}return this}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=N;class F{static create(h,P=null){const A=u.get(h);return typeof A=="boolean"?A?r.INSTANCE:o.INSTANCE:new F(h,P)}constructor(h,P){this.key=h,this.negated=P,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:q(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=u.get(this.key);return typeof h=="boolean"?h?r.INSTANCE:o.INSTANCE:this}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=F;function z(_,h){if(typeof _=="string"){const P=parseFloat(_);isNaN(P)||(_=P)}return typeof _=="string"||typeof _=="number"?h(_):r.INSTANCE}class H{static create(h,P,A=null){return z(P,U=>new H(h,U,A))}constructor(h,P,A){this.key=h,this.value=P,this.negated=A,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=ue.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class re{static create(h,P,A=null){return z(P,U=>new re(h,U,A))}constructor(h,P,A){this.key=h,this.value=P,this.negated=A,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=ie.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=re;class ie{static create(h,P,A=null){return z(P,U=>new ie(h,U,A))}constructor(h,P,A){this.key=h,this.value=P,this.negated=A,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=ie;class ue{static create(h,P,A=null){return z(P,U=>new ue(h,U,A))}constructor(h,P,A){this.key=h,this.value=P,this.negated=A,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:Y(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}substituteConstants(){return this}evaluate(h){return typeof this.value=="string"?!1:parseFloat(h.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=ue;class fe{static create(h,P){return new fe(h,P)}constructor(h,P){this.key=h,this.regexp=P,this.type=7,this.negated=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const P=this.regexp?this.regexp.source:"",A=h.regexp?h.regexp.source:"";return P<A?-1:P>A?1:0}equals(h){if(h.type===this.type){const P=this.regexp?this.regexp.source:"",A=h.regexp?h.regexp.source:"";return this.key===h.key&&P===A}return!1}substituteConstants(){return this}evaluate(h){const P=h.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=le.create(this)),this.negated}}e.ContextKeyRegexExpr=fe;class le{static create(h){return new le(h)}constructor(h){this._actual=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}substituteConstants(){return this}evaluate(h){return!this._actual.evaluate(h)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(h){return new le(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=le;function j(_){let h=null;for(let P=0,A=_.length;P<A;P++){const U=_[P].substituteConstants();if(_[P]!==U&&h===null){h=[];for(let G=0;G<P;G++)h[G]=_[G]}h!==null&&(h[P]=U)}return h===null?_:h}class X{static create(h,P,A){return X._normalizeArr(h,P,A)}constructor(h,P){this.expr=h,this.negated=P,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,A=this.expr.length;P<A;P++){const U=n(this.expr[P],h.expr[P]);if(U!==0)return U}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,A=this.expr.length;P<A;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}substituteConstants(){const h=j(this.expr);return h===this.expr?this:X.create(h,this.negated,!1)}evaluate(h){for(let P=0,A=this.expr.length;P<A;P++)if(!this.expr[P].evaluate(h))return!1;return!0}static _normalizeArr(h,P,A){const U=[];let G=!1;for(const B of h)if(B){if(B.type===1){G=!0;continue}if(B.type===0)return r.INSTANCE;if(B.type===6){U.push(...B.expr);continue}U.push(B)}if(U.length===0&&G)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];for(;U.length>1;){const B=U[U.length-1];if(B.type!==9)break;U.pop();const te=U.pop(),ae=U.length===0,ce=W.create(B.expr.map(me=>X.create([me,te],null,A)),null,ae);ce&&(U.push(ce),U.sort(n))}if(U.length===1)return U[0];if(A){for(let B=0;B<U.length;B++)for(let te=B+1;te<U.length;te++)if(U[B].negate().equals(U[te]))return r.INSTANCE;if(U.length===1)return U[0]}return new X(U,P)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const P of this.expr)h.push(...P.keys());return h}map(h){return new X(this.expr.map(P=>P.map(h)),null)}negate(){if(!this.negated){const h=[];for(const P of this.expr)h.push(P.negate());this.negated=W.create(h,this,!0)}return this.negated}}e.ContextKeyAndExpr=X;class W{static create(h,P,A){return W._normalizeArr(h,P,A)}constructor(h,P){this.expr=h,this.negated=P,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,A=this.expr.length;P<A;P++){const U=n(this.expr[P],h.expr[P]);if(U!==0)return U}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,A=this.expr.length;P<A;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}substituteConstants(){const h=j(this.expr);return h===this.expr?this:W.create(h,this.negated,!1)}evaluate(h){for(let P=0,A=this.expr.length;P<A;P++)if(this.expr[P].evaluate(h))return!0;return!1}static _normalizeArr(h,P,A){let U=[],G=!1;if(h){for(let B=0,te=h.length;B<te;B++){const ae=h[B];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&G)return r.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let B=1;B<U.length;B++)U[B-1].equals(U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0];if(A){for(let B=0;B<U.length;B++)for(let te=B+1;te<U.length;te++)if(U[B].negate().equals(U[te]))return o.INSTANCE;if(U.length===1)return U[0]}return new W(U,P)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const P of this.expr)h.push(...P.keys());return h}map(h){return new W(this.expr.map(P=>P.map(h)),null)}negate(){if(!this.negated){const h=[];for(const P of this.expr)h.push(P.negate());for(;h.length>1;){const P=h.shift(),A=h.shift(),U=[];for(const G of M(P))for(const B of M(A))U.push(X.create([G,B],null,!1));h.unshift(W.create(U,null,!1))}this.negated=W.create(h,this,!0)}return this.negated}}e.ContextKeyOrExpr=W;class V extends c{static{this._info=[]}static all(){return V._info.values()}constructor(h,P,A){super(h,null),this._defaultValue=P,typeof A=="object"?V._info.push({...A,key:h}):A!==!0&&V._info.push({key:h,description:A,type:P!=null?typeof P:void 0})}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return b.create(this.key,h)}notEqualsTo(h){return N.create(this.key,h)}}e.RawContextKey=V,e.IContextKeyService=(0,x.createDecorator)("contextKeyService");function q(_,h){return _<h?-1:_>h?1:0}function Y(_,h,P,A){return _<P?-1:_>P?1:h<A?-1:h>A?1:0}function J(_,h){if(_.type===0||h.type===1)return!0;if(_.type===9)return h.type===9?Z(_.expr,h.expr):!1;if(h.type===9){for(const P of h.expr)if(J(_,P))return!0;return!1}if(_.type===6){if(h.type===6)return Z(h.expr,_.expr);for(const P of _.expr)if(J(P,h))return!0;return!1}return _.equals(h)}function Z(_,h){let P=0,A=0;for(;P<_.length&&A<h.length;){const U=_[P].cmp(h[A]);if(U<0)return!1;U===0&&P++,A++}return P===_.length}function M(_){return _.type===9?_.expr:[_]}}),define(ne[61],se([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(ne[18],se([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[21],se([0,1,95,10]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=C,e.toTargetPlatform=x,e.getTargetPlatform=k,e.isNotWebExtensionInWebTargetPlatform=I,e.isTargetPlatformCompatible=u,e.isIExtensionIdentifier=a,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function C(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function x(v){switch(v){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function k(v,f){switch(v){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":f==="ppc64le"?"linux-ppc64le":f==="riscv64"?"linux-riscv64":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function I(v,f){return f==="web"&&!v.includes("web")}function u(v,f,g){return I(f,g)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===g}function a(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}var y;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var w;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var d;(function(v){v.Install="install",v.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var m;(function(v){v[v.None=1]="None",v[v.Install=2]="Install",v[v.Update=3]="Update",v[v.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var S;(function(v){v.Unsupported="Unsupported",v.Deprecated="Deprecated",v.Malicious="Malicious",v.Incompatible="Incompatible",v.IncompatibleTargetPlatform="IncompatibleTargetPlatform",v.ReleaseVersionNotFound="ReleaseVersionNotFound",v.Invalid="Invalid",v.Download="Download",v.DownloadSignature="DownloadSignature",v.UpdateMetadata="UpdateMetadata",v.Extract="Extract",v.Scanning="Scanning",v.Delete="Delete",v.Rename="Rename",v.CorruptZip="CorruptZip",v.IncompleteZip="IncompleteZip",v.Signature="Signature",v.NotAllowed="NotAllowed",v.Gallery="Gallery",v.Unknown="Unknown",v.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var D;(function(v){v.UnknownError="UnknownError",v.PackageIsInvalidZip="PackageIsInvalidZip",v.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(D||(e.ExtensionSignaturetErrorCode=D={}));class p extends Error{constructor(f,g){super(f),this.code=g,this.name=g}}e.ExtensionManagementError=p;var l;(function(v){v.Timeout="Timeout",v.Cancelled="Cancelled",v.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class E extends Error{constructor(f,g){super(f),this.code=g,this.name=g}}e.ExtensionGalleryError=E,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,O.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,O.localize2)(1,"Preferences")}),define(ne[62],se([0,1,14,8,103,13]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(y,w,d,m,S,D){let p;try{await I(y,w,d,m,S,D)}catch(l){p=l}finally{p&&S.errorTransformer&&(p=S.errorTransformer(p)),typeof p<"u"&&d.error(p),d.end()}}async function I(y,w,d,m,S,D){u(D);const p=await y.open(w,{create:!1});try{u(D);let l=0,E=0,v=S&&typeof S.length=="number"?S.length:void 0,f=O.VSBuffer.alloc(Math.min(S.bufferSize,typeof v=="number"?v:S.bufferSize)),g=S&&typeof S.position=="number"?S.position:0,i=0;do E=await y.read(p,g,f.buffer,i,f.byteLength-i),g+=E,i+=E,l+=E,typeof v=="number"&&(v-=E),i===f.byteLength&&(await d.write(m(f)),f=O.VSBuffer.alloc(Math.min(S.bufferSize,typeof v=="number"?v:S.bufferSize)),i=0);while(E>0&&(typeof v!="number"||v>0)&&u(D)&&a(l,S));if(i>0){let s=i;typeof v=="number"&&(s=Math.min(i,v)),d.write(m(f.slice(0,s)))}}catch(l){throw(0,x.ensureFileSystemProviderError)(l)}finally{await y.close(p)}}function u(y){if(y.isCancellationRequested)throw(0,L.canceled)();return!0}function a(y,w){if(typeof w?.limits?.size=="number"&&y>w.limits.size)throw(0,x.createFileSystemProviderError)((0,C.localize)(0,null),x.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[122],se([0,1,60,2,52,5,11]),function(K,e,O,L,C,x,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class I extends L.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new x.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new x.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new x.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new L.DisposableMap),this.suspendedWatchRequestPollingInterval=5007,this._register(this.onDidWatchFail(a=>this.handleDidWatchFail(a)))}handleDidWatchFail(a){this.isCorrelated(a)&&this.suspendWatchRequest(a)}isCorrelated(a){return(0,C.isWatchRequestWithCorrelation)(a)}async watch(a){this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const y of a)this.isCorrelated(y)?this.allCorrelatedWatchRequests.set(y.correlationId,y):this.allNonCorrelatedWatchRequests.add(y);for(const[y]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(y)||this.suspendedWatchRequests.deleteAndDispose(y);return this.updateWatchers()}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(a=>!this.suspendedWatchRequests.has(a.correlationId))])}suspendWatchRequest(a){if(this.suspendedWatchRequests.has(a.correlationId))return;const y=new L.DisposableStore;this.suspendedWatchRequests.set(a.correlationId,y),this.monitorSuspendedWatchRequest(a,y),this.updateWatchers()}resumeWatchRequest(a){this.suspendedWatchRequests.deleteAndDispose(a.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(a,y){const w=k.URI.file(a.path),d=this;let m=!1;const S=(D,p)=>{if(y.isDisposed)return;const l=this.isPathNotFound(D),E=this.isPathNotFound(p),v=m;if(m=l,!l&&(E||v)){this.trace(`fs.watchFile() detected ${a.path} exists again, resuming watcher (correlationId: ${a.correlationId})`);const f={resource:w,type:1,cId:a.correlationId};d._onDidChangeFile.fire([f]),this.traceEvent(f,a),this.resumeWatchRequest(a)}};this.trace(`starting fs.watchFile() on ${a.path} (correlationId: ${a.correlationId})`);try{(0,O.watchFile)(a.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},S)}catch(D){this.warn(`fs.watchFile() failed with error ${D} on path ${a.path} (correlationId: ${a.correlationId})`)}y.add((0,L.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${a.path} (correlationId: ${a.correlationId})`);try{(0,O.unwatchFile)(a.path,S)}catch(D){this.warn(`fs.unwatchFile() failed with error ${D} on path ${a.path} (correlationId: ${a.correlationId})`)}}))}isPathNotFound(a){return a.ctimeMs===0&&a.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll()}traceEvent(a,y){const w=` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`;this.trace(typeof y.correlationId=="number"?`${w} (correlationId: ${y.correlationId})`:w)}requestToString(a){return`${a.path} (excludes: ${a.excludes.length>0?a.excludes:"<none>"}, includes: ${a.includes&&a.includes.length>0?JSON.stringify(a.includes):"<all>"}, correlationId: ${typeof a.correlationId=="number"?a.correlationId:"<none>"})`}}e.BaseWatcher=I}),define(ne[123],se([0,1,5,171,122,12,172,124]),function(K,e,O,L,C,x,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class u extends C.BaseWatcher{constructor(){super(...arguments),this.onDidError=O.Event.None,this.watchers=new Set,this.verboseLogging=!1}async doWatch(y){y=this.removeDuplicateRequests(y);const w=[],d=new Set(Array.from(this.watchers));for(const m of y){const S=this.findWatcher(m);S&&(0,L.patternsEquals)(S.request.excludes,m.excludes)&&(0,L.patternsEquals)(S.request.includes,m.includes)?d.delete(S):w.push(m)}w.length&&this.trace(`Request to start watching: ${w.map(m=>this.requestToString(m)).join(",")}`),d.size&&this.trace(`Request to stop watching: ${Array.from(d).map(m=>this.requestToString(m.request)).join(",")}`);for(const m of d)this.stopWatching(m);for(const m of w)this.startWatching(m)}findWatcher(y){for(const w of this.watchers)if(typeof y.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===y.correlationId)return w}else if((0,I.isEqual)(w.request.path,y.path,!x.isLinux))return w}startWatching(y){const w=new k.NodeJSFileWatcherLibrary(y,m=>this._onDidChangeFile.fire(m),()=>this._onDidWatchFail.fire(y),m=>this._onDidLogMessage.fire(m),this.verboseLogging),d={request:y,instance:w};this.watchers.add(d)}async stop(){await super.stop();for(const y of this.watchers)this.stopWatching(y)}stopWatching(y){this.trace("stopping file watcher",y),this.watchers.delete(y),y.instance.dispose()}removeDuplicateRequests(y){const w=new Map;for(const d of y){const m=x.isLinux?d.path:d.path.toLowerCase();let S=w.get(d.correlationId);S||(S=new Map,w.set(d.correlationId,S)),S.has(m)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(d)}`),S.set(m,d)}return Array.from(w.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(y){this.verboseLogging=y;for(const w of this.watchers)w.instance.setVerboseLogging(y)}trace(y,w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y,w)})}warn(y){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(y)})}toMessage(y,w){return w?`[File Watcher (node.js)] ${y} (${this.requestToString(w.request)})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=u}),define(ne[125],se([0,1,52,123]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends O.AbstractNonRecursiveWatcherClient{constructor(k,I,u){super(k,I,u),this.init()}createWatcher(k){return k.add(new L.NodeJSWatcher)}}e.NodeJSWatcherClient=C}),define(ne[126],se([0,1,15,58,88,52]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends x.AbstractUniversalWatcherClient{constructor(u,a,y){super(u,a,y),this.init()}createWatcher(u){const a=u.add(new C.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:y,signal:w})=>this.onError(`terminated by itself with code ${y}, signal: ${w}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(a.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ne[63],se([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...C){this._entries=new Map;for(const[x,k]of C)this.set(x,k)}set(C,x){const k=this._entries.get(C);return this._entries.set(C,x),k}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=O}),define(ne[127],se([0,1,9,8,2,51,120,10,63,173]),function(K,e,O,L,C,x,k,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class w extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class d{constructor(p=new u.ServiceCollection,l=!1,E,v=y){this._services=p,this._strict=l,this._parent=E,this._enableTracing=v,this._activeInstantiations=new Set,this._services.set(I.IInstantiationService,this),this._globalGraph=v?E?._globalGraph??new k.Graph(f=>f):void 0}createChild(p){return new d(p,this._strict,this,this._enableTracing)}invokeFunction(p,...l){const E=S.traceInvocation(this._enableTracing,p);let v=!1;try{return p({get:g=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(g,E);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...l)}finally{v=!0,E.stop()}}createInstance(p,...l){let E,v;return p instanceof x.SyncDescriptor?(E=S.traceCreation(this._enableTracing,p.ctor),v=this._createInstance(p.ctor,p.staticArguments.concat(l),E)):(E=S.traceCreation(this._enableTracing,p),v=this._createInstance(p,l,E)),E.stop(),v}_createInstance(p,l=[],E){const v=I._util.getServiceDependencies(p).sort((i,s)=>i.index-s.index),f=[];for(const i of v){const s=this._getOrCreateServiceInstance(i.id,E);s||this._throwIfStrict(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(s)}const g=v.length>0?v[0].index:l.length;if(l.length!==g){console.trace(`[createInstance] First service dependency of ${p.name} at position ${g+1} conflicts with ${l.length} static arguments`);const i=g-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,g)}return Reflect.construct(p,l.concat(f))}_setServiceInstance(p,l){if(this._services.get(p)instanceof x.SyncDescriptor)this._services.set(p,l);else if(this._parent)this._parent._setServiceInstance(p,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){const l=this._services.get(p);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):l}_getOrCreateServiceInstance(p,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(p));const E=this._getServiceInstanceOrDescriptor(p);return E instanceof x.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,E,l.branch(p,!0)):(l.branch(p,!1),E)}_safeCreateAndCacheServiceInstance(p,l,E){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,l,E)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,l,E){const v=new k.Graph(i=>i.id.toString());let f=0;const g=[{id:p,desc:l,_trace:E}];for(;g.length;){const i=g.pop();if(v.lookupOrInsertNode(i),f++>1e3)throw new w(v);for(const s of I._util.getServiceDependencies(i.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${p} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),t instanceof x.SyncDescriptor){const n={id:s.id,desc:t,_trace:i._trace.branch(s.id,!0)};v.insertEdge(i,n),g.push(n)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:s}of i){if(this._getServiceInstanceOrDescriptor(s.id)instanceof x.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}v.removeNode(s)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,l,E=[],v,f){if(this._services.get(p)instanceof x.SyncDescriptor)return this._createServiceInstance(p,l,E,v,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,l,E,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(p,l,E=[],v,f){if(v){const g=new d(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(p);const i=new Map,s=new O.GlobalIdleValue(()=>{const t=g._createInstance(l,E,f);for(const[n,r]of i){const o=t[n];if(typeof o=="function")for(const c of r)c.disposable=o.apply(t,c.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let c=i.get(n);return c||(c=new a.LinkedList,i.set(n,c)),(R,T,N)=>{if(s.isInitialized)return s.value[n](R,T,N);{const F={listener:[R,T,N],disposable:void 0},z=c.push(F);return(0,C.toDisposable)(()=>{z(),F.disposable?.dispose()})}}}if(n in t)return t[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),t[n]=o),o},set(t,n,r){return s.value[n]=r,!0},getPrototypeOf(t){return l.prototype}})}else return this._createInstance(l,E,f)}_throwIfStrict(p,l){if(l&&console.warn(p),this._strict)throw new Error(p)}}e.InstantiationService=d;var m;(function(D){D[D.None=0]="None",D[D.Creation=1]="Creation",D[D.Invocation=2]="Invocation",D[D.Branch=3]="Branch"})(m||(m={}));class S{static{this.all=new Set}static{this._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,l){return p?new S(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(p,l){return p?new S(1,l.name):S._None}static{this._totals=0}constructor(p,l){this.type=p,this.name=l,this._start=Date.now(),this._dep=[]}branch(p,l){const E=new S(3,p.toString());return this._dep.push([p,l,E]),E}stop(){const p=Date.now()-this._start;S._totals+=p;let l=!1;function E(f,g){const i=[],s=new Array(f+1).join("	");for(const[t,n,r]of g._dep)if(n&&r){l=!0,i.push(`${s}CREATES -> ${t}`);const o=E(f+1,r);o&&i.push(o)}else i.push(`${s}uses -> ${t}`);return i.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(p>2||l)&&S.all.add(v.join(`
`))}}e.Trace=S});var oe=this&&this.__param||function(K,e){return function(O,L){e(O,L,K)}};define(ne[64],se([0,1,20,2,12,105,21,10]),function(K,e,O,L,C,x,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=u;function u(y){return y.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let a=class extends L.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new O.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let d;try{d=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const S=d.firstPage.filter(D=>D.properties.localizedLanguages?.length&&D.tags.some(p=>p.startsWith("lp-"))).map(D=>{const p=D.properties.localizedLanguages?.[0],l=u(D);return{...this.createQuickPickItem(l,p,D),extensionId:D.identifier.id,galleryExtension:D}});return S.push(this.createQuickPickItem("en","English")),S}createQuickPickItem(w,d,m){const S=d??w;let D;if(S!==w&&(D=`(${w})`),w.toLowerCase()===C.language.toLowerCase()&&(D??="",D+=(0,x.localize)(0,null)),m?.installCount){D??="";const p=m.installCount;let l;p>1e6?l=`${Math.floor(p/1e5)/10}M`:p>1e3?l=`${Math.floor(p/1e3)}K`:l=String(p),D+=` $(cloud-download) ${l}`}return{id:w,label:S,description:D}}};e.LanguagePackBaseService=a,e.LanguagePackBaseService=a=ve([oe(0,k.IExtensionGalleryService)],a)}),define(ne[6],se([0,1,106,34,5,43,2,31,12,17,3,11,121,10]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=D,e.log=l,e.getLogLevel=c,e.LogLevelToString=b,e.LogLevelToLocalizedString=R,e.parseLogLevel=T,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function S(){return new Date().toISOString()}function D(N){return(0,y.isNumber)(N)}var p;(function(N){N[N.Off=0]="Off",N[N.Trace=1]="Trace",N[N.Debug=2]="Debug",N[N.Info=3]="Info",N[N.Warning=4]="Warning",N[N.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function l(N,F,z){switch(F){case p.Trace:N.trace(z);break;case p.Debug:N.debug(z);break;case p.Info:N.info(z);break;case p.Warning:N.warn(z);break;case p.Error:N.error(z);break;case p.Off:break;default:throw new Error(`Invalid log level ${F}`)}}function E(N,F=!1){let z="";for(let H=0;H<N.length;H++){let re=N[H];if(re instanceof Error&&(re=(0,L.toErrorMessage)(re,F)),typeof re=="object")try{re=JSON.stringify(re)}catch{}z+=(H>0?" ":"")+re}return z}class v extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(F){this.level!==F&&(this.level=F,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(F){return this.level!==p.Off&&this.level<=F}}e.AbstractLogger=v;class f extends v{constructor(F){super(),this.logAlways=F}checkLogLevel(F){return this.logAlways||super.checkLogLevel(F)}trace(F,...z){this.checkLogLevel(p.Trace)&&this.log(p.Trace,E([F,...z],!0))}debug(F,...z){this.checkLogLevel(p.Debug)&&this.log(p.Debug,E([F,...z]))}info(F,...z){this.checkLogLevel(p.Info)&&this.log(p.Info,E([F,...z]))}warn(F,...z){this.checkLogLevel(p.Warning)&&this.log(p.Warning,E([F,...z]))}error(F,...z){if(this.checkLogLevel(p.Error))if(F instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=F.stack,this.log(p.Error,E(H))}else this.log(p.Error,E([F,...z]))}flush(){}}e.AbstractMessageLogger=f;class g extends v{constructor(F=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(F),this.useColors=!u.isWindows}trace(F,...z){this.checkLogLevel(p.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,F,...z):console.log(`[main ${S()}]`,F,...z))}debug(F,...z){this.checkLogLevel(p.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,F,...z):console.log(`[main ${S()}]`,F,...z))}info(F,...z){this.checkLogLevel(p.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,F,...z):console.log(`[main ${S()}]`,F,...z))}warn(F,...z){this.checkLogLevel(p.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,F,...z):console.warn(`[main ${S()}]`,F,...z))}error(F,...z){this.checkLogLevel(p.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,F,...z):console.error(`[main ${S()}]`,F,...z))}flush(){}}e.ConsoleMainLogger=g;class i extends v{constructor(F=e.DEFAULT_LOG_LEVEL,z=!0){super(),this.useColors=z,this.setLevel(F)}trace(F,...z){this.checkLogLevel(p.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",F,...z):console.log(F,...z))}debug(F,...z){this.checkLogLevel(p.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",F,...z):console.log(F,...z))}info(F,...z){this.checkLogLevel(p.Info)&&(this.useColors?console.log("%c INFO","color: #33f",F,...z):console.log(F,...z))}warn(F,...z){this.checkLogLevel(p.Warning)&&(this.useColors?console.log("%c WARN","color: #993",F,...z):console.log(F,...z))}error(F,...z){this.checkLogLevel(p.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",F,...z):console.error(F,...z))}flush(){}}e.ConsoleLogger=i;class s extends v{constructor(F,z=e.DEFAULT_LOG_LEVEL){super(),this.adapter=F,this.setLevel(z)}trace(F,...z){this.checkLogLevel(p.Trace)&&this.adapter.log(p.Trace,[this.extractMessage(F),...z])}debug(F,...z){this.checkLogLevel(p.Debug)&&this.adapter.log(p.Debug,[this.extractMessage(F),...z])}info(F,...z){this.checkLogLevel(p.Info)&&this.adapter.log(p.Info,[this.extractMessage(F),...z])}warn(F,...z){this.checkLogLevel(p.Warning)&&this.adapter.log(p.Warning,[this.extractMessage(F),...z])}error(F,...z){this.checkLogLevel(p.Error)&&this.adapter.log(p.Error,[this.extractMessage(F),...z])}extractMessage(F){return typeof F=="string"?F:(0,L.toErrorMessage)(F,this.checkLogLevel(p.Trace))}flush(){}}e.AdapterLogger=s;class t extends v{constructor(F){super(),this.loggers=F,F.length&&this.setLevel(F[0].getLevel())}setLevel(F){for(const z of this.loggers)z.setLevel(F);super.setLevel(F)}trace(F,...z){for(const H of this.loggers)H.trace(F,...z)}debug(F,...z){for(const H of this.loggers)H.debug(F,...z)}info(F,...z){for(const H of this.loggers)H.info(F,...z)}warn(F,...z){for(const H of this.loggers)H.warn(F,...z)}error(F,...z){for(const H of this.loggers)H.error(F,...z)}flush(){for(const F of this.loggers)F.flush()}dispose(){for(const F of this.loggers)F.dispose();super.dispose()}}e.MultiplexLogger=t;class n extends k.Disposable{constructor(F,z,H){if(super(),this.logLevel=F,this.logsHome=z,this._loggers=new I.ResourceMap,this._onDidChangeLoggers=this._register(new C.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,H)for(const re of H)this._loggers.set(re.resource,{logger:void 0,info:re})}getLoggerEntry(F){return(0,y.isString)(F)?[...this._loggers.values()].find(z=>z.info.id===F):this._loggers.get(F)}getLogger(F){return this.getLoggerEntry(F)?.logger}createLogger(F,z){const H=this.toResource(F),re=(0,y.isString)(F)?F:z?.id??(0,x.hash)(H.toString()).toString(16);let ie=this._loggers.get(H)?.logger;const ue=z?.logLevel==="always"?p.Trace:z?.logLevel;ie||(ie=this.doCreateLogger(H,ue??this.getLogLevel(H)??this.logLevel,{...z,id:re}));const fe={logger:ie,info:{resource:H,id:re,logLevel:ue,name:z?.name,hidden:z?.hidden,extensionId:z?.extensionId,when:z?.when}};return this.registerLogger(fe.info),this._loggers.set(H,fe),ie}toResource(F){return(0,y.isString)(F)?(0,a.joinPath)(this.logsHome,`${F}.log`):F}setLogLevel(F,z){if(w.URI.isUri(F)){const H=F,re=z,ie=this._loggers.get(H);ie&&re!==ie.info.logLevel&&(ie.info.logLevel=re===this.logLevel?void 0:re,ie.logger?.setLevel(re),this._loggers.set(ie.info.resource,ie),this._onDidChangeLogLevel.fire([H,re]))}else{this.logLevel=F;for(const[H,re]of this._loggers.entries())this._loggers.get(H)?.info.logLevel===void 0&&re.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(F,z){const H=this.getLoggerEntry(F);H&&z!==!H.info.hidden&&(H.info.hidden=!z,this._loggers.set(H.info.resource,H),this._onDidChangeVisibility.fire([H.info.resource,z]))}getLogLevel(F){let z;return F&&(z=this._loggers.get(F)?.info.logLevel),z??this.logLevel}registerLogger(F){const z=this._loggers.get(F.resource);z?z.info.hidden!==F.hidden&&this.setVisibility(F.resource,!F.hidden):(this._loggers.set(F.resource,{info:F,logger:void 0}),this._onDidChangeLoggers.fire({added:[F],removed:[]}))}deregisterLogger(F){const z=this._loggers.get(F);z&&(z.logger&&z.logger.dispose(),this._loggers.delete(F),this._onDidChangeLoggers.fire({added:[],removed:[z.info]}))}*getRegisteredLoggers(){for(const F of this._loggers.values())yield F.info}getRegisteredLogger(F){return this._loggers.get(F)?.info}dispose(){this._loggers.forEach(F=>F.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=n;class r{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(F){}getLevel(){return p.Info}trace(F,...z){}debug(F,...z){}info(F,...z){}warn(F,...z){}error(F,...z){}critical(F,...z){}dispose(){}flush(){}}e.NullLogger=r;class o extends r{}e.NullLogService=o;function c(N){if(N.verbose)return p.Trace;if(typeof N.logLevel=="string"){const F=T(N.logLevel.toLowerCase());if(F!==void 0)return F}return e.DEFAULT_LOG_LEVEL}function b(N){switch(N){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function R(N){switch(N){case p.Trace:return{original:"Trace",value:O.localize(0,null)};case p.Debug:return{original:"Debug",value:O.localize(1,null)};case p.Info:return{original:"Info",value:O.localize(2,null)};case p.Warning:return{original:"Warning",value:O.localize(3,null)};case p.Error:return{original:"Error",value:O.localize(4,null)};case p.Off:return{original:"Off",value:O.localize(5,null)}}}function T(N){switch(N){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.CONTEXT_LOG_LEVEL=new d.RawContextKey("logLevel",b(p.Info))}),define(ne[128],se([0,1,19,9,8,5,2,16,52,6]),function(K,e,O,L,C,x,k,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends k.Disposable{constructor(d,m){super(),this.logService=d,this.options=m,this._onDidChangeFile=this._register(new x.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new x.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new L.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(d,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,m):this.watchNonRecursive(d,m)}watchUniversal(d,m){const S={path:this.toFilePath(d),excludes:m.excludes,includes:m.includes,recursive:m.recursive,correlationId:m.correlationId},D=(0,O.insert)(this.universalPathsToWatch,S);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{D(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,C.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const m of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const m of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(m)&&d.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,m){const S={path:this.toFilePath(d),excludes:m.excludes,includes:m.includes,recursive:!1,correlationId:m.correlationId},D=(0,O.insert)(this.nonRecursivePathsToWatch,S);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{D(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,C.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,u.reviveFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===a.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,I.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(ne[129],se([0,1,19,9,14,20,5,43,65,2,48,15,130,17,46,102,13,62,6,8]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends a.Disposable{static{f=this}constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${s}`);const n=new a.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(r=>{const o=new p.FileChangesEvent(r,!this.isPathCaseSensitive(t));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,a.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,a.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await L.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,m.isAbsolutePath)(s))throw new p.FileOperationError((0,D.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new v.ErrorNoTelemetry;throw n.message=(0,D.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t)||(0,p.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,p.hasOpenReadWriteCloseCapability)(t)||(0,p.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,p.toFileSystemProviderErrorCode)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,D.localize)(2,null,this.resourceForError(s)),1):(0,p.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),r=this.isPathCaseSensitive(n),o=t?.resolveTo,c=t?.resolveSingleChildDescendants,b=t?.resolveMetadata,R=await n.stat(s);let T;return this.toFileStat(n,s,R,void 0,!!b,(N,F)=>(T||(T=y.TernarySearchTree.forUris(()=>!r),T.set(s,!0),o&&T.fill(!0,o)),T.get(N.resource)||T.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&c?F===1:!1))}async toFileStat(s,t,n,r,o,c){const{providerExtUri:b}=this.getExtUri(s),R={resource:t,name:b.basename(t),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&p.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((n.permissions??0)&p.FilePermission.Locked),etag:(0,p.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(R.isDirectory&&c(R,r)){try{const T=await s.readdir(t),N=await L.Promises.settled(T.map(async([F,z])=>{try{const H=b.joinPath(t,F),re=o?await s.stat(H):{type:z};return await this.toFileStat(s,H,re,T.length,o,c)}catch(H){return this.logService.trace(H),null}}));R.children=(0,O.coalesce)(N)}catch(T){this.logService.trace(T),R.children=[]}return R}return R}async resolveAll(s){return L.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new p.FileOperationError((0,D.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=C.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const r=await this.writeFile(s,t);return this._onDidRunOperation.fire(new p.FileOperationEvent(s,0,r)),r}async writeFile(s,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:o}=this.getExtUri(r);let c=n;if((0,p.hasFileAtomicWriteCapability)(r)&&!c?.atomic){const b=r.enforceAtomicWriteFile?.(s);b&&(c={...n,atomic:b})}try{await this.validateWriteFile(r,s,c)||await this.mkdirp(r,o.dirname(s));let R;if((0,p.hasReadWriteCapability)(r)&&!(t instanceof C.VSBuffer))if((0,S.isReadableStream)(t)){const T=await(0,S.peekStream)(t,3);T.ended?R=C.VSBuffer.concat(T.buffer):R=T}else R=(0,S.peekReadable)(t,T=>C.VSBuffer.concat(T),3);else R=t;!(0,p.hasOpenReadWriteCloseCapability)(r)||(0,p.hasReadWriteCapability)(r)&&R instanceof C.VSBuffer||(0,p.hasReadWriteCapability)(r)&&(0,p.hasFileAtomicWriteCapability)(r)&&c?.atomic?await this.doWriteUnbuffered(r,s,c,R):await this.doWriteBuffered(r,s,c,R instanceof C.VSBuffer?(0,C.bufferToReadable)(R):R),this._onDidRunOperation.fire(new p.FileOperationEvent(s,4))}catch(b){throw new p.FileOperationError((0,D.localize)(4,null,this.resourceForError(s),(0,p.ensureFileSystemProviderError)(b).toString()),(0,p.toFileOperationResult)(b),c)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){const r=!!n?.unlock;if(r&&!(s.capabilities&8192))throw new Error((0,D.localize)(5,null,this.resourceForError(t)));if(!!n?.atomic){if(!(s.capabilities&32768))throw new Error((0,D.localize)(6,null,this.resourceForError(t)));if(!(s.capabilities&2))throw new Error((0,D.localize)(7,null,this.resourceForError(t)));if(r)throw new Error((0,D.localize)(8,null,this.resourceForError(t)))}let c;try{c=await s.stat(t)}catch{return}if(c.type&p.FileType.Directory)throw new p.FileOperationError((0,D.localize)(9,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,c),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.ETAG_DISABLED&&typeof c.mtime=="number"&&typeof c.size=="number"&&n.mtime<c.mtime&&n.etag!==(0,p.etag)({mtime:n.mtime,size:c.size}))throw new p.FileOperationError((0,D.localize)(10,null),3,n);return c}async readFile(s,t,n){const r=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(r,s,t,n):this.doReadFile(r,s,t,n)}async doReadFileAtomic(s,t,n,r){return new Promise((o,c)=>{this.writeQueue.queueFor(t,async()=>{try{const b=await this.doReadFile(s,t,n,r);o(b)}catch(b){c(b)}},this.getExtUri(s).providerExtUri)})}async doReadFile(s,t,n,r){const o=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},r);return{...o,value:await(0,C.streamToBuffer)(o.value)}}async readFileStream(s,t,n){const r=await this.withReadProvider(s);return this.doReadFileStream(r,s,t,n)}async doReadFileStream(s,t,n,r){const o=new x.CancellationTokenSource(r);let c=n;(0,p.hasFileAtomicReadCapability)(s)&&s.enforceAtomicReadFile?.(t)&&(c={...n,atomic:!0});const b=this.validateReadFile(t,c).then(T=>T,T=>{throw o.dispose(!0),T});let R;try{return typeof c?.etag=="string"&&c.etag!==p.ETAG_DISABLED&&await b,c?.atomic&&(0,p.hasFileAtomicReadCapability)(s)||!((0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasFileReadStreamCapability)(s))||(0,p.hasReadWriteCapability)(s)&&c?.preferUnbuffered?R=this.readFileUnbuffered(s,t,c):(0,p.hasFileReadStreamCapability)(s)?R=this.readFileStreamed(s,t,o.token,c):R=this.readFileBuffered(s,t,o.token,c),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await b,value:R}}catch(T){throw R&&await(0,S.consumeStream)(R),this.restoreReadError(T,t,c)}}restoreReadError(s,t,n){const r=(0,D.localize)(11,null,this.resourceForError(t),(0,p.ensureFileSystemProviderError)(s).toString());return s instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(r,s.stat,n):s instanceof p.TooLargeFileOperationError?new p.TooLargeFileOperationError(r,s.fileOperationResult,s.size,s.options):new p.FileOperationError(r,(0,p.toFileOperationResult)(s),n)}readFileStreamed(s,t,n,r=Object.create(null)){const o=s.readFileStream(t,r,n);return(0,S.transform)(o,{data:c=>c instanceof C.VSBuffer?c:C.VSBuffer.wrap(c),error:c=>this.restoreReadError(c,t,r)},c=>C.VSBuffer.concat(c))}readFileBuffered(s,t,n,r=Object.create(null)){const o=(0,C.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,o,c=>c,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>this.restoreReadError(c,t,r)},n),o}readFileUnbuffered(s,t,n){const r=(0,S.newWriteableStream)(o=>C.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,p.hasFileAtomicReadCapability)(s)?o=await s.readFile(t,{atomic:!0}):o=await s.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.validateReadFileLimits(t,o.byteLength,n),r.end(C.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new p.FileOperationError((0,D.localize)(12,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&t.etag===n.etag)throw new p.NotModifiedSinceFileOperationError((0,D.localize)(13,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new p.TooLargeFileOperationError((0,D.localize)(14,null,this.resourceForError(s)),7,t,n)}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,r){if(s.toString()!==t.toString())try{const o=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(o,s,c,t,n,r)}catch(o){return o}return!0}async move(s,t,n){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(r,s,o,t,"move",!!n),b=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,c==="move"?2:3,b)),b}async copy(s,t,n){const r=await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(r,s,o,t,"copy",!!n),b=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,c==="copy"?3:2,b)),b}async doMoveCopy(s,t,n,r,o,c){if(t.toString()===r.toString())return o;const{exists:b,isSameResourceWithDifferentPathCase:R}=await this.doValidateMoveCopy(s,t,n,r,o,c);if(b&&!R&&c&&await this.del(r,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(r)),o==="copy"){if(s===n&&(0,p.hasFileFolderCopyCapability)(s))await s.copy(t,r,{overwrite:c});else{const T=await this.resolve(t);T.isDirectory?await this.doCopyFolder(s,T,n,r):await this.doCopyFile(s,t,n,r)}return o}else return s===n?(await s.rename(t,r,{overwrite:c}),o):(await this.doMoveCopy(s,t,n,r,"copy",c),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,r){if((0,p.hasOpenReadWriteCloseCapability)(s)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,r);if((0,p.hasOpenReadWriteCloseCapability)(s)&&(0,p.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,r);if((0,p.hasReadWriteCapability)(s)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,r);if((0,p.hasReadWriteCapability)(s)&&(0,p.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,r)}async doCopyFolder(s,t,n,r){await n.mkdir(r),Array.isArray(t.children)&&await L.Promises.settled(t.children.map(async o=>{const c=this.getExtUri(n).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(s,await this.resolve(o.resource),n,c):this.doCopyFile(s,o.resource,n,c)}))}async doValidateMoveCopy(s,t,n,r,o,c){let b=!1;if(s===n){const{providerExtUri:T,isPathCaseSensitive:N}=this.getExtUri(s);if(N||(b=T.isEqual(t,r)),b&&o==="copy")throw new Error((0,D.localize)(15,null,this.resourceForError(t),this.resourceForError(r)));if(!b&&T.isEqualOrParent(r,t))throw new Error((0,D.localize)(16,null,this.resourceForError(t),this.resourceForError(r)))}const R=await this.exists(r);if(R&&!b){if(!c)throw new p.FileOperationError((0,D.localize)(17,null,this.resourceForError(t),this.resourceForError(r)),4);if(s===n){const{providerExtUri:T}=this.getExtUri(s);if(T.isEqualOrParent(t,r))throw new Error((0,D.localize)(18,null,this.resourceForError(t),this.resourceForError(r)))}}return{exists:R,isSameResourceWithDifferentPathCase:b}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(t,r.dirname(t));)try{if(!((await s.stat(t)).type&p.FileType.Directory))throw new Error((0,D.localize)(19,null,this.resourceForError(t)));break}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(t)),t=r.dirname(t)}for(let o=n.length-1;o>=0;o--){t=r.joinPath(t,n[o]);try{await s.mkdir(t)}catch(c){if((0,p.toFileSystemProviderErrorCode)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s),r=!!t?.useTrash;if(r&&!(n.capabilities&4096))throw new Error((0,D.localize)(20,null,this.resourceForError(s)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,D.localize)(21,null,this.resourceForError(s)));if(r&&o)throw new Error((0,D.localize)(22,null,this.resourceForError(s)));let c;try{c=await n.stat(s)}catch{}if(c)this.throwIfFileIsReadonly(s,c);else throw new p.FileOperationError((0,D.localize)(23,null,this.resourceForError(s)),1);if(!!!t?.recursive){const R=await this.resolve(s);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,D.localize)(24,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t);let r=t;if((0,p.hasFileAtomicDeleteCapability)(n)&&!r?.atomic){const R=n.enforceAtomicDelete?.(s);R&&(r={...t,atomic:R})}const o=!!r?.useTrash,c=!!r?.recursive,b=r?.atomic??!1;await n.delete(s,{recursive:c,useTrash:o,atomic:b}),this._onDidRunOperation.fire(new p.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(!(n===r&&this.getExtUri(n).providerExtUri.isEqual(s,t)))return n===r&&(0,p.hasFileCloneCapability)(n)?n.cloneFile(s,t):(await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),n===r&&(0,p.hasFileFolderCopyCapability)(n)?this.writeQueue.queueFor(s,()=>n.copy(s,t,{overwrite:!0}),this.getExtUri(n).providerExtUri):this.writeQueue.queueFor(s,()=>this.doCopyFile(n,s,r,t),this.getExtUri(n).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(s,t){return this.watch(s,{...t,correlationId:f.WATCHER_CORRELATION_IDS++})}watch(s,t={recursive:!1,excludes:[]}){const n=new a.DisposableStore;let r=!1,o=()=>{r=!0};n.add((0,a.toDisposable)(()=>o())),(async()=>{try{const b=await this.doWatch(s,t);r?(0,a.dispose)(b):o=()=>(0,a.dispose)(b)}catch(b){this.logService.error(b)}})();const c=t.correlationId;if(typeof c=="number"){const b=n.add(new k.Emitter);return n.add(this.internalOnDidFilesChange.event(T=>{T.correlates(c)&&b.fire(T)})),{onDidChange:b.event,dispose:()=>n.dispose()}}return n}async doWatch(s,t){const n=await this.withProvider(s),r=(0,I.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let o=this.activeWatchers.get(r);return o||(o={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(r,o)),o.count+=1,(0,a.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,a.dispose)(o.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,a.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,r){return this.writeQueue.queueFor(t,async()=>{const o=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,S.isReadableStream)(r)||(0,S.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,o,r):await this.doWriteReadableBufferedQueued(s,o,r)}catch(c){throw(0,p.ensureFileSystemProviderError)(c)}finally{await s.close(o)}},this.getExtUri(s).providerExtUri)}async doWriteStreamBufferedQueued(s,t,n){let r=0,o;if((0,S.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=C.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,c,c.byteLength,r,0),r+=c.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((c,b)=>{(0,S.listenStream)(o,{onData:async R=>{o.pause();try{await this.doWriteBuffer(s,t,R,R.byteLength,r,0)}catch(T){return b(T)}r+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>b(R),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(s,t,n){let r=0,o;for(;(o=n.read())!==null;)await this.doWriteBuffer(s,t,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(s,t,n,r,o,c){let b=0;for(;b<r;){const R=await s.write(t,o+b,n.buffer,c+b,r-b);b+=R}}async doWriteUnbuffered(s,t,n,r){return this.writeQueue.queueFor(t,()=>this.doWriteUnbufferedQueued(s,t,n,r),this.getExtUri(s).providerExtUri)}async doWriteUnbufferedQueued(s,t,n,r){let o;r instanceof C.VSBuffer?o=r:(0,S.isReadableStream)(r)?o=await(0,C.streamToBuffer)(r):(0,S.isReadableBufferedStream)(r)?o=await(0,C.bufferedStreamToBuffer)(r):o=(0,C.readableToBuffer)(r),await s.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async doPipeBuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeBufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeBufferedQueued(s,t,n,r){let o,c;try{o=await s.open(t,{create:!1}),c=await n.open(r,{create:!0,unlock:!1});const b=C.VSBuffer.alloc(this.BUFFER_SIZE);let R=0,T=0,N=0;do N=await s.read(o,R,b.buffer,T,b.byteLength-T),await this.doWriteBuffer(n,c,b,N,R,T),R+=N,T+=N,T===b.byteLength&&(T=0);while(N>0)}catch(b){throw(0,p.ensureFileSystemProviderError)(b)}finally{await L.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedQueued(s,t,n,r){return n.writeFile(r,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(s,t,n,r){return this.writeQueue.queueFor(r,()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,r),this.getExtUri(n).providerExtUri)}async doPipeUnbufferedToBufferedQueued(s,t,n,r){const o=await n.open(r,{create:!0,unlock:!1});try{const c=await s.readFile(t);await this.doWriteBuffer(n,o,C.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,p.ensureFileSystemProviderError)(c)}finally{await n.close(o)}}async doPipeBufferedToUnbuffered(s,t,n,r){const o=await(0,C.streamToBuffer)(this.readFileBuffered(s,t,x.CancellationToken.None));await this.doWriteUnbuffered(n,r,void 0,o)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new p.FileOperationError((0,D.localize)(25,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,D.localize)(26,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};e.FileService=g,e.FileService=g=f=ve([oe(0,E.ILogService)],g)}),define(ne[131],se([0,1,60,174,9,31,14,5,124,2,16,12,17,46,25,104,13,62,128,34,126,125]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(s)}`)}})();class i extends E.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new x.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:r}=await S.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:p.FilePermission.Locked}}catch(n){throw this.toFileSystemProviderError(n)}}async statIgnoreError(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await S.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,d.joinPath)(t,o.name))).type:c=this.toType(o),r.push([o.name,c])}catch(c){this.logService.trace(c)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let r;return n?.dangling?r=p.FileType.Unknown:t.isFile()?r=p.FileType.File:t.isDirectory()?r=p.FileType.Directory:r=p.FileType.Unknown,n&&(r|=p.FileType.SymbolicLink),r}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new C.Barrier;return this.resourceLocks.set(t,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let r;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),r=await this.createResourceLock(t));const o=this.toFilePath(t);return await S.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,r){const o=(0,m.newWriteableStream)(c=>k.VSBuffer.concat(c.map(b=>k.VSBuffer.wrap(b))).buffer);return(0,l.readFileIntoStream)(this,t,o,c=>c.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(t,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.canWriteFileAtomic(t)?this.doWriteFileAtomic(t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${r.atomic.postfix}`),n,r):this.doWriteFile(t,n,r)}async canWriteFileAtomic(t){try{const n=this.toFilePath(t),{symbolicLink:r}=await S.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async doWriteFileAtomic(t,n,r,o){const c=new a.DisposableStore;try{c.add(await this.createResourceLock(t)),c.add(await this.createResourceLock(n)),await this.doWriteFile(n,r,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(b){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{c.dispose()}}async doWriteFile(t,n,r,o){let c;try{const b=this.toFilePath(t);if(!r.create||!r.overwrite){if(await S.Promises.exists(b)){if(!r.overwrite)throw(0,p.createFileSystemProviderError)((0,D.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,p.createFileSystemProviderError)((0,D.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:r.unlock},o),await this.write(c,0,n,0,n.byteLength)}catch(b){throw await this.toFileSystemProviderWriteError(t,b)}finally{typeof c=="number"&&await this.close(c)}}static{this.canFlush=!0}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n,r){const o=this.toFilePath(t);let c;(0,p.isFileOpenForWriteOptions)(n)&&!r&&(c=await this.createResourceLock(t));let b;try{if((0,p.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:T}=await S.SymlinkSupport.stat(o);T.mode&128||await S.Promises.chmod(o,T.mode|128)}catch(T){T.code!=="ENOENT"&&this.logService.trace(T)}let R;if((0,p.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await S.Promises.truncate(o,0),R="r+"}catch(T){T.code!=="ENOENT"&&this.logService.trace(T)}R||(R="w")}else R="r";b=await S.Promises.open(o,R)}catch(R){throw c?.dispose(),(0,p.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,R):this.toFileSystemProviderError(R)}if(this.mapHandleToPos.set(b,0),(0,p.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(b,t),c){const R=this.mapHandleToLock.get(b);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${o})`),this.mapHandleToLock.set(b,c),R&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${o})`),R.dispose())}return b}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await S.Promises.fdatasync(t)}catch(r){i.configureFlushOnWrite(!1),this.logService.error(r)}return await S.Promises.close(t)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,r,o,c){const b=this.normalizePos(t,n);let R=null;try{R=(await S.Promises.read(t,r,o,c,b)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(t,b,R)}return R}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,r){const o=this.mapHandleToPos.get(t);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(t,o+r):this.mapHandleToPos.delete(t)))}async write(t,n,r,o,c){return(0,C.retry)(()=>this.doWrite(t,n,r,o,c),100,3)}async doWrite(t,n,r,o,c){const b=this.normalizePos(t,n);let R=null;try{R=(await S.Promises.write(t,r,o,c,b)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),T)}finally{this.updatePos(t,b,R)}return R}async mkdir(t){try{await S.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const r=this.toFilePath(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.join)((0,y.dirname)(r),`${(0,y.basename)(r)}${n.atomic.postfix}`)),await S.Promises.rm(r,S.RimRafMode.MOVE,o)}else try{await S.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:b,symbolicLink:R}=await S.SymlinkSupport.stat(r);c=b.isDirectory()&&!R}catch{}if(c)await S.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.toFileSystemProviderError(r)}}async rename(t,n,r){const o=this.toFilePath(t),c=this.toFilePath(n);if(o!==c)try{await this.validateMoveCopy(t,n,"move",r.overwrite),await S.Promises.rename(o,c)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,D.localize)(2,null,(0,y.basename)(o),(0,y.basename)((0,y.dirname)(c)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(t,n,r){const o=this.toFilePath(t),c=this.toFilePath(n);if(o!==c)try{await this.validateMoveCopy(t,n,"copy",r.overwrite),await S.Promises.copy(o,c,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,D.localize)(3,null,(0,y.basename)(o),(0,y.basename)((0,y.dirname)(c)),b.toString()))),this.toFileSystemProviderError(b)}}async validateMoveCopy(t,n,r,o){const c=this.toFilePath(t),b=this.toFilePath(n);let R=!1;if(!!(this.capabilities&1024)||(R=(0,u.isEqual)(c,b,!0)),R){if(r==="copy")throw(0,p.createFileSystemProviderError)((0,D.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const N=await this.statIgnoreError(t);if(!N)throw(0,p.createFileSystemProviderError)((0,D.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const F=await this.statIgnoreError(n);if(F){if(!o)throw(0,p.createFileSystemProviderError)((0,D.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);N.type&p.FileType.File&&F.type&p.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,r){const o=this.toFilePath(t),c=this.toFilePath(n),b=!!(this.capabilities&1024);if((0,u.isEqual)(o,c,!b))return;const R=new a.DisposableStore;try{R.add(await this.createResourceLock(t)),R.add(await this.createResourceLock(n)),r&&await S.Promises.mkdir((0,y.dirname)(c),{recursive:!0}),await S.Promises.copyFile(o,c)}catch(T){if(T.code==="ENOENT"&&!r)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(T)}finally{R.dispose()}}createUniversalWatcher(t,n,r){return new f.UniversalWatcherClient(o=>t(o),o=>n(o),r)}createNonRecursiveWatcher(t,n,r){return new g.NodeJSWatcherClient(o=>t(o),o=>n(o),r)}toFileSystemProviderError(t){if(t instanceof p.FileSystemProviderError)return t;let n=t,r;switch(t.code){case"ENOENT":r=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=p.FileSystemProviderErrorCode.Unknown;break;default:r=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(t,n){let r=this.toFileSystemProviderError(n);if(t&&r.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await S.SymlinkSupport.stat(this.toFilePath(t));o.mode&128||(r=(0,p.createFileSystemProviderError)(n,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=i}),define(ne[132],se([0,1,2,6]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends O.Disposable{constructor(k,I=[]){super(),this.logger=new L.MultiplexLogger([k,...I]),this._register(k.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...I){this.logger.trace(k,...I)}debug(k,...I){this.logger.debug(k,...I)}info(k,...I){this.logger.info(k,...I)}warn(k,...I){this.logger.warn(k,...I)}error(k,...I){this.logger.error(k,...I)}flush(){this.logger.flush()}}e.LogService=C}),define(ne[133],se([0,1,13,6]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(C||(C={}));async function x(a,y,w,d,m){try{const S=await new Promise((p,l)=>{K(["@vscode/spdlog"],p,l)});S.setFlushOn(C.Trace);const D=await S.createAsyncRotatingLogger(a,y,w,d);return m?D.clearFormatters():D.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),D}catch(S){console.error(S)}return null}function k(a,y,w){switch(y){case L.LogLevel.Trace:a.trace(w);break;case L.LogLevel.Debug:a.debug(w);break;case L.LogLevel.Info:a.info(w);break;case L.LogLevel.Warning:a.warn(w);break;case L.LogLevel.Error:a.error(w);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function I(a,y){switch(y){case L.LogLevel.Trace:a.setLevel(C.Trace);break;case L.LogLevel.Debug:a.setLevel(C.Debug);break;case L.LogLevel.Info:a.setLevel(C.Info);break;case L.LogLevel.Warning:a.setLevel(C.Warning);break;case L.LogLevel.Error:a.setLevel(C.Error);break;case L.LogLevel.Off:a.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class u extends L.AbstractMessageLogger{constructor(y,w,d,m,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(y,w,d,m),this._register(this.onDidChangeLogLevel(D=>{this._logger&&I(this._logger,D)}))}async _createSpdLogLogger(y,w,d,m){const S=d?6:1,D=30/S*O.ByteSize.MB,p=await x(y,w,D,S,m);if(p){this._logger=p,I(this._logger,this.getLevel());for(const{level:l,message:E}of this.buffer)k(this._logger,l,E);this.buffer=[]}}log(y,w){this._logger?k(this._logger,y,w):this.getLevel()<=y&&this.buffer.push({level:y,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=u}),define(ne[134],se([0,1,28,6,133]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class x extends L.AbstractLoggerService{doCreateLogger(I,u,a){return new C.SpdLogLogger((0,O.generateUuid)(),I.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.LoggerService=x}),define(ne[39],se([0,1,5,65,2,10]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,x.createDecorator)("policy");class k extends C.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(a){const y=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...a,...this.policyDefinitions},y!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(a),L.Iterable.reduce(this.policies.entries(),(w,[d,m])=>({...w,[d]:m}),{})}getPolicyValue(a){return this.policies.get(a)}serialize(){return L.Iterable.reduce(Object.entries(this.policyDefinitions),(a,[y,w])=>({...a,[y]:{definition:w,value:this.policies.get(y)}}),{})}}e.AbstractPolicyService=k;class I{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ne[135],se([0,1,9,5,65,3,13,6,39]),function(K,e,O,L,C,x,k,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function a(w,d){const m=[];for(const S of new Set(C.Iterable.concat(w.keys(),d.keys())))w.get(S)!==d.get(S)&&m.push(S);return m}let y=class extends u.AbstractPolicyService{constructor(d,m,S){super(),this.file=d,this.fileService=m,this.logService=S,this.throttledDelayer=this._register(new O.ThrottledDelayer(500));const D=L.Event.filter(m.onDidFilesChange,p=>p.affects(d));this._register(m.watch(d)),this._register(D(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async _updatePolicyDefinitions(){await this.refresh()}async read(){const d=new Map;try{const m=await this.fileService.readFile(this.file),S=JSON.parse(m.value.toString());if(!(0,x.isObject)(S))throw new Error("Policy file isn't a JSON object");for(const D of Object.keys(S))this.policyDefinitions[D]&&d.set(D,S[D])}catch(m){m.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",m)}return d}async refresh(){const d=await this.read(),m=a(this.policies,d);this.policies=d,m.length>0&&this._onDidChange.fire(m)}};e.FilePolicyService=y,e.FilePolicyService=y=ve([oe(1,k.IFileService),oe(2,I.ILogService)],y)}),define(ne[136],se([0,1,39,9,2,6]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends O.AbstractPolicyService{constructor(u,a){super(),this.logService=u,this.productName=a,this.throttler=new L.Throttler,this.watcher=this._register(new C.MutableDisposable)}async _updatePolicyDefinitions(u){this.logService.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((y,w)=>{K(["@vscode/policy-watcher"],y,w)});await this.throttler.queue(()=>new Promise((y,w)=>{try{this.watcher.value=a(this.productName,u,d=>{this._onDidPolicyChange(d),y()})}catch(d){this.logService.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),w(d)}}))}_onDidPolicyChange(u){this.logService.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const y=u[a];y===void 0?this.policies.delete(a):this.policies.set(a,y)}this._onDidChange.fire(Object.keys(u))}};e.NativePolicyService=k,e.NativePolicyService=k=ve([oe(0,x.ILogService)],k)}),define(ne[32],se([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[36],se([0,1,72,3]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(k,I){O.ok(L.isString(k)),O.ok(L.isObject(I)),O.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,I)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new C}),define(ne[137],se([0,1,5,36]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class x{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,a){this.schemasById[C(u)]=a,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new x;L.Registry.add(e.Extensions.JSONContribution,k)}),define(ne[40],se([0,1,19,5,3,91,29,137,36]),function(K,e,O,L,C,x,k,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=D,e.keyFromOverrideIdentifiers=p,e.getDefaultValue=l,e.validateProperty=v,e.getScopes=f;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=u.Registry.as(I.Extensions.JSONContribution);class d{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:x.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=new Set;this.doRegisterConfigurations(i,s,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=new Set;this.doDeregisterConfigurations(i,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=new Set;this.doDeregisterConfigurations(s,t),this.doRegisterConfigurations(i,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}registerDefaultConfigurations(i){const s=new Set;this.doRegisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,s){const t=[];for(const{overrides:n,source:r}of i)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.configurationDefaultsOverrides.get(o),b=c?.valuesSources??new Map;if(r)for(const F of Object.keys(n[o]))b.set(F,r);const R={...c?.value||{},...n[o]};this.configurationDefaultsOverrides.set(o,{source:r,value:R,valuesSources:b});const T=(0,k.getLanguageTagSettingPlainKey)(o),N={type:"object",default:R,description:x.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:C.isString(r)?void 0:r,defaultValueSource:r};t.push(...D(o)),this.configurationProperties[o]=N,this.defaultLanguageConfigurationOverridesNode.properties[o]=N}else{this.configurationDefaultsOverrides.set(o,{value:n[o],source:r});const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.doRegisterOverrideIdentifiers(t)}deregisterDefaultConfigurations(i){const s=new Set;this.doDeregisterDefaultConfigurations(i,s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,s){for(const{overrides:t,source:n}of i)for(const r in t){const o=this.configurationDefaultsOverrides.get(r),c=C.isString(n)?n:n?.id,b=C.isString(o?.source)?o?.source:o?.source?.id;if(c===b)if(s.add(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const R=this.configurationProperties[r];R&&(this.updatePropertyDefaultValue(r,R),this.updateSchema(r,R))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let s=!1;const t=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,t),s=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,t),s=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,t),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s,t){i.forEach(n=>{this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties,void 0,t),this.configurationContributors.push(n),this.registerJSONConfiguration(n)})}doDeregisterConfigurations(i,s){const t=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.configurationProperties[r];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,n.properties[r])}n.allOf?.forEach(r=>t(r))};for(const n of i){t(n);const r=this.configurationContributors.indexOf(n);r!==-1&&this.configurationContributors.splice(r,1)}}validateAndRegisterProperties(i,s=!0,t,n,r=3,o){r=C.isUndefinedOrNull(i.scope)?r:i.scope;const c=i.properties;if(c)for(const R in c){const T=c[R];if(s&&v(R,T)){delete c[R];continue}if(T.source=t,T.defaultDefaultValue=c[R].default,this.updatePropertyDefaultValue(R,T),e.OVERRIDE_PROPERTY_REGEX.test(R)?T.scope=void 0:(T.scope=C.isUndefinedOrNull(T.scope)?r:T.scope,T.restricted=C.isUndefinedOrNull(T.restricted)?!!n?.includes(R):T.restricted),c[R].hasOwnProperty("included")&&!c[R].included){this.excludedConfigurationProperties[R]=c[R],delete c[R];continue}else this.configurationProperties[R]=c[R],c[R].policy?.name&&this.policyConfigurations.set(c[R].policy.name,R);!c[R].deprecationMessage&&c[R].markdownDeprecationMessage&&(c[R].deprecationMessage=c[R].markdownDeprecationMessage),o.add(R)}const b=i.allOf;if(b)for(const R of b)this.validateAndRegisterProperties(R,s,t,n,r,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const n=t.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:x.localize(2,null),errorMessage:x.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}}registerOverridePropertyPatternKey(){const i={type:"object",description:x.localize(4,null),errorMessage:x.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,r=t?.source;C.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),C.isUndefined(n)&&(n=l(s.type)),s.default=n,s.defaultValueSource=r}}const m="\\[([^\\]]+)\\]",S=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function D(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=S.exec(g);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=S.exec(g)}}return(0,O.distinct)(i)}function p(g){return g.reduce((i,s)=>`${i}[${s}]`,"")}function l(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const E=new d;u.Registry.add(e.Extensions.Configuration,E);function v(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?x.localize(7,null,g):E.getConfigurationProperties()[g]!==void 0?x.localize(8,null,g):i.policy?.name&&E.getPolicyConfigurations().get(i.policy?.name)!==void 0?x.localize(9,null,g,i.policy?.name,E.getPolicyConfigurations().get(i.policy?.name)):null:x.localize(6,null)}function f(){const g=[],i=E.getConfigurationProperties();for(const s of Object.keys(i))g.push([s,i[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(ne[66],se([0,1,19,5,38,2,31,27,3,11,29,40,36]),function(K,e,O,L,C,x,k,I,u,a,y,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=v;function m(s){return Object.isFrozen(s)?s:I.deepFreeze(s)}class S{constructor(t={},n=[],r=[],o){this._contents=t,this._keys=n,this._overrides=r,this.raw=o,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof S)return n;const r=new D("");return r.parseRaw(n),r.configurationModel});this._rawConfiguration=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const r=this;return{get value(){return m(r.rawConfiguration.getValue(t))},get override(){return n?m(r.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return m(n?r.rawConfiguration.override(n).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:c,identifiers:b,keys:R}of r.rawConfiguration.overrides){const T=new S(c,R).getValue(t);T!==void 0&&o.push({identifiers:b,value:T})}return o.length?m(o):void 0}}}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,y.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return O.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return O.distinct(t)}override(t){let n=this.overrideConfigurations.get(t);return n||(n=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,n)),n}merge(...t){const n=I.deepClone(this.contents),r=I.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const b of t)if(c.push(...b.raw?.length?b.raw:[b]),!b.isEmpty()){this.mergeContents(n,b.contents);for(const R of b.overrides){const[T]=r.filter(N=>O.equals(N.identifiers,R.identifiers));T?(this.mergeContents(T.contents,R.contents),T.keys.push(...R.keys),T.keys=O.distinct(T.keys)):r.push(I.deepClone(R))}for(const R of b.keys)o.indexOf(R)===-1&&o.push(R)}return new S(n,o,r,c.every(b=>b instanceof S)?void 0:c)}createOverrideConfigurationModel(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[o];const b=n[o];b&&(typeof c=="object"&&typeof b=="object"?(c=I.deepClone(c),this.mergeContents(c,b)):c=b),r[o]=c}return new S(r,this.keys,this.overrides)}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&u.isObject(t[r])&&u.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=I.deepClone(n[r])}}getContentsForOverrideIdentifer(t){let n=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=I.deepClone(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===t?n=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.updateValue(t,n,!0)}setValue(t,n){this.updateValue(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}updateValue(t,n,r){(0,y.addToValueTree)(this.contents,t,n,o=>console.error(o)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,y.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=S;class D{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!u.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:o,overrides:c,restricted:b,hasExcludedProperties:R}=this.doParseRaw(t,n);this._configurationModel=new S(r,o,c,R?[t]:void 0),this._restrictedConfigurations=b||[]}doParseContent(t){let n={},r=null,o=[];const c=[],b=[];function R(N){Array.isArray(o)?o.push(N):r!==null&&(o[r]=N)}const T={onObjectBegin:()=>{const N={};R(N),c.push(o),o=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const N=[];R(N),c.push(o),o=N,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:R,onError:(N,F,z)=>{b.push({error:N,offset:F,length:z})}};if(t)try{C.visit(t,T),n=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(t,n){const r=d.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,n);t=o.raw;const c=(0,y.toValuesTree)(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),b=Object.keys(t),R=this.toOverrides(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:c,keys:b,overrides:R,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(t,n,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:c};const b={},R=[];for(const T in t)if(w.OVERRIDE_PROPERTY_REGEX.test(T)&&r){const N=this.filter(t[T],n,!1,o);b[T]=N.raw,c=c||N.hasExcludedProperties,R.push(...N.restricted)}else{const N=n[T],F=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&R.push(T),!o.exclude?.includes(T)&&(o.include?.includes(T)||(F===void 0||o.scopes===void 0||o.scopes.includes(F))&&!(o.skipRestricted&&N?.restricted))?b[T]=t[T]:c=!0}return{raw:b,restricted:R,hasExcludedProperties:c}}toOverrides(t,n){const r=[];for(const o of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const b in t[o])c[b]=t[o][b];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,y.toValuesTree)(c,n)})}return r}}e.ConfigurationModelParser=D;class p extends x.Disposable{constructor(t,n,r,o){super(),this.userSettingsResource=t,this.parseOptions=n,this.fileService=o,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new D(this.userSettingsResource.toString()),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.any(L.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),L.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(t){return t&&(this.parseOptions=t),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class l{constructor(t,n,r,o,c,b,R,T,N,F,z,H,re){this.key=t,this.overrides=n,this._value=r,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=b,this.applicationConfiguration=R,this.userConfiguration=T,this.localUserConfiguration=N,this.remoteUserConfiguration=F,this.workspaceConfiguration=z,this.folderConfigurationModel=H,this.memoryConfigurationModel=re}get value(){return m(this._value)}toInspectValue(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class E{constructor(t,n,r,o,c=new S,b=new S,R=new k.ResourceMap,T=new S,N=new k.ResourceMap){this._defaultConfiguration=t,this._policyConfiguration=n,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=b,this._folderConfigurations=R,this._memoryConfiguration=T,this._memoryConfigurationByResource=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidatedConfigurationModel(t,n,r).getValue(t)}updateValue(t,n,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new S,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(t):o.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const o=this.getConsolidatedConfigurationModel(t,n,r),c=this.getFolderConfigurationModelForResource(n.resource,r),b=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,R=new Set;for(const T of o.overrides)for(const N of T.identifiers)o.getOverrideValue(t,N)!==void 0&&R.add(N);return new l(t,n,o.getValue(t),R.size?[...R]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this._workspaceConfiguration:void 0,c||void 0,b)}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:o,updated:c,removed:b}=g(this._defaultConfiguration,t);n=[...o,...c,...b]}for(const o of n)for(const c of(0,w.overrideIdentifiersFromKey)(o)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(c),R=t.getKeysForOverrideIdentifier(c),T=[...R.filter(N=>b.indexOf(N)===-1),...b.filter(N=>R.indexOf(N)===-1),...b.filter(N=>!I.equals(this._defaultConfiguration.override(c).getValue(N),t.override(c).getValue(N)))];r.push([c,T])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:o}=g(this._policyConfiguration,t),c=[...n,...r,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.applicationConfiguration,t),b=[...n,...r,...o];return b.length&&this.updateApplicationConfiguration(t),{keys:b,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.localUserConfiguration,t),b=[...n,...r,...o];return b.length&&this.updateLocalUserConfiguration(t),{keys:b,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.remoteUserConfiguration,t),b=[...n,...r,...o];return b.length&&this.updateRemoteUserConfiguration(t),{keys:b,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:o,overrides:c}=g(this.workspaceConfiguration,t),b=[...n,...r,...o];return b.length&&this.updateWorkspaceConfiguration(t),{keys:b,overrides:c}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:o,updated:c,removed:b,overrides:R}=g(r,n),T=[...o,...c,...b];return(T.length||!r)&&this.updateFolderConfiguration(t,n),{keys:T,overrides:R}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:c,overrides:b}=g(n,void 0);return{keys:[...r,...o,...c],overrides:b}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,n,r){let o=this.getConsolidatedConfigurationModelForResource(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const o=n.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(t);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(n=r.merge(o),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this._workspaceConfiguration.keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.policy),o=this.parseConfigurationModel(t.application),c=this.parseConfigurationModel(t.user),b=this.parseConfigurationModel(t.workspace),R=t.folders.reduce((T,N)=>(T.set(a.URI.revive(N[0]),this.parseConfigurationModel(N[1])),T),new k.ResourceMap);return new E(n,r,o,c,new S,b,R,new S,new k.ResourceMap)}static parseConfigurationModel(t){return new S(t.contents,t.keys,t.overrides)}}e.Configuration=E;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const o of s)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,b])=>{const R=(0,k.getOrSet)(n,c,new Set);b.forEach(T=>R.add(T))});const r=[];return n.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...t.values()],overrides:r}}class f{constructor(t,n,r,o){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=o,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const b of c)this.affectedKeys.add(b);this._affectsConfigStr=this._marker;for(const c of this.affectedKeys)this._affectsConfigStr+=c+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){const r=this._marker+t,o=this._affectsConfigStr.indexOf(r);if(o<0)return!1;const c=o+r.length;if(c>=this._affectsConfigStr.length)return!1;const b=this._affectsConfigStr.charCodeAt(c);if(b!==this._markerCode1&&b!==this._markerCode2)return!1;if(n){const R=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.previous?.workspace):void 0,T=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!I.equals(R,T)}return!0}}e.ConfigurationChangeEvent=f;function g(s,t){const{added:n,removed:r,updated:o}=i(t?.rawConfiguration,s?.rawConfiguration),c=[],b=s?.getAllOverrideIdentifiers()||[],R=t?.getAllOverrideIdentifiers()||[];if(t){const T=R.filter(N=>!b.includes(N));for(const N of T)c.push([N,t.getKeysForOverrideIdentifier(N)])}if(s){const T=b.filter(N=>!R.includes(N));for(const N of T)c.push([N,s.getKeysForOverrideIdentifier(N)])}if(t&&s){for(const T of b)if(R.includes(T)){const N=i({contents:s.getOverrideValue(void 0,T)||{},keys:s.getKeysForOverrideIdentifier(T)},{contents:t.getOverrideValue(void 0,T)||{},keys:t.getKeysForOverrideIdentifier(T)});c.push([T,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:r,updated:o,overrides:c}}function i(s,t){const n=s?t?s.keys.filter(c=>t.keys.indexOf(c)===-1):[...s.keys]:[],r=t?s?t.keys.filter(c=>s.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(s&&t){for(const c of t.keys)if(s.keys.indexOf(c)!==-1){const b=(0,y.getConfigurationValue)(t.contents,c),R=(0,y.getConfigurationValue)(s.contents,c);I.equals(b,R)||o.push(c)}}return{added:n,removed:r,updated:o}}}),define(ne[138],se([0,1,19,5,2,27,3,66,40,6,39,36]),function(K,e,O,L,C,x,k,I,u,a,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends C.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:l})=>this.onDidUpdateConfiguration(Array.from(p),l))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(p,l){this.updateConfigurationModel(p,w.Registry.as(u.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new I.ConfigurationModel;const p=w.Registry.as(u.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(p),p)}updateConfigurationModel(p,l){const E=this.getConfigurationDefaultOverrides();for(const v of p){const f=E[v],g=l[v];f!==void 0?this._configurationModel.addValue(v,f):g?this._configurationModel.addValue(v,g.default):this._configurationModel.removeValue(v)}}}e.DefaultConfiguration=d;class m{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let S=class extends C.Disposable{get configurationModel(){return this._configurationModel}constructor(p,l,E){super(),this.defaultConfiguration=p,this.policyService=l,this.logService=E,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.updatePolicyDefinitions(p),!0))),this._configurationModel}async updatePolicyDefinitions(p){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",p);const l={},E=[],v=w.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const f of p){const g=v[f];if(!g){E.push(f);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.logService.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}E.push(f),l[g.policy.name]={type:g.type}}}return(0,k.isEmptyObject)(l)||await this.policyService.updatePolicyDefinitions(l),E}onDidChangePolicies(p){this.logService.trace("PolicyConfiguration#onDidChangePolicies",p);const l=w.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),E=(0,O.coalesce)(p.map(v=>l.get(v)));this.update(E,!0)}update(p,l){this.logService.trace("PolicyConfiguration#update",p);const E=w.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),v=[],f=this._configurationModel.isEmpty();for(const g of p){const i=E[g]?.policy?.name;if(i){const s=this.policyService.getPolicyValue(i);(f?s!==void 0:!(0,x.equals)(this._configurationModel.getValue(g),s))&&v.push([g,s])}else this._configurationModel.getValue(g)!==void 0&&v.push([g,void 0])}if(v.length){this.logService.trace("PolicyConfiguration#changed",v);const g=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const i of g.keys)this._configurationModel.setValue(i,g.getValue(i));for(const[i,s]of v)s===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,s);l&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=S,e.PolicyConfiguration=S=ve([oe(1,y.IPolicyService),oe(2,a.ILogService)],S)}),define(ne[139],se([0,1,19,9,14,5,38,74,2,27,12,17,29,66,40,138,39]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class l extends u.Disposable{constructor(f,g,i,s){super(),this.settingsResource=f,this._onDidChangeConfiguration=this._register(new x.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new D.DefaultConfiguration),this.policyConfiguration=i instanceof p.NullPolicyService?new D.NullPolicyConfiguration:this._register(new D.PolicyConfiguration(this.defaultConfiguration,i,s)),this.userConfiguration=this._register(new m.UserSettings(this.settingsResource,{},w.extUriBiasedIgnorePathCase,g)),this.configuration=new m.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new m.ConfigurationModel,new m.ConfigurationModel),this.configurationEditing=new E(f,g,this),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:t,properties:n})=>this.onDidDefaultConfigurationChange(t,n))),this._register(this.policyConfiguration.onDidChangeConfiguration(t=>this.onDidPolicyConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[f,g,i]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new m.Configuration(f,g,new m.ConfigurationModel,i)}getConfigurationData(){return this.configuration.toData()}getValue(f,g){const i=typeof f=="string"?f:void 0,s=(0,d.isConfigurationOverrides)(f)?f:(0,d.isConfigurationOverrides)(g)?g:{};return this.configuration.getValue(i,s,void 0)}async updateValue(f,g,i,s,t){const n=(0,d.isConfigurationUpdateOverrides)(i)?i:(0,d.isConfigurationOverrides)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,r=n?s:i;if(r!==void 0&&r!==3&&r!==2)throw new Error(`Unable to write ${f} to target ${r}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,O.distinct)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(f,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,a.equals)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const b=n.overrideIdentifiers.sort(),R=this.configuration.localUserConfiguration.overrides.find(T=>(0,O.equals)([...T.identifiers].sort(),b));R&&(n.overrideIdentifiers=R.identifiers)}const c=n?.overrideIdentifiers?.length?[(0,S.keyFromOverrideIdentifiers)(n.overrideIdentifiers),f]:[f];await this.configurationEditing.write(c,g),await this.reloadConfiguration()}inspect(f,g={}){return this.configuration.inspect(f,g,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const g=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(i,g,2)}onDidDefaultConfigurationChange(f,g){const i=this.configuration.toData(),s=this.configuration.compareAndUpdateDefaultConfiguration(f,g);this.trigger(s,i,7)}onDidPolicyConfigurationChange(f){const g=this.configuration.toData(),i=this.configuration.compareAndUpdatePolicyConfiguration(f);this.trigger(i,g,7)}trigger(f,g,i){const s=new m.ConfigurationChangeEvent(f,{data:g},this.configuration);s.source=i,this._onDidChangeConfiguration.fire(s)}}e.ConfigurationService=l;class E{constructor(f,g,i){this.settingsResource=f,this.fileService=g,this.configurationService=i,this.queue=new L.Queue}write(f,g){return this.queue.queue(()=>this.doWriteConfiguration(f,g))}async doWriteConfiguration(f,g){let i;try{i=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const s=[];if((0,k.parse)(i,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.getEdits(i,f,g);i=(0,I.applyEdits)(i,t),await this.fileService.writeFile(this.settingsResource,C.VSBuffer.fromString(i))}getEdits(f,g,i){const{tabSize:s,insertSpaces:t,eol:n}=this.formattingOptions;if(!g.length){const r=JSON.stringify(i,null,t?" ".repeat(s):"	");return[{content:r,length:r.length,offset:0}]}return(0,I.setProperty)(f,g,i,{tabSize:s,insertSpaces:t,eol:n})}get formattingOptions(){if(!this._formattingOptions){let f=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(f=g),this._formattingOptions={eol:f,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ne[67],se([0,1,15]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=L,e.getRemoteName=C,e.parseAuthorityWithPort=x,e.parseAuthorityWithOptionalPort=k;function L(u){return u.scheme===O.Schemas.vscodeRemote?u.authority:void 0}function C(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function x(u){const{host:a,port:y}=I(u);if(typeof y>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:y}}function k(u,a){let{host:y,port:w}=I(u);return typeof w>"u"&&(w=a),{host:y,port:w}}function I(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const w=u.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:u,port:void 0}}}),define(ne[37],se([0,1,30,10,67]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=x,e.isApplicationScopedExtension=w,e.isLanguagePackExtension=d,e.isAuthenticationProviderExtension=m,e.isResolverExtension=S,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function x(D){if(typeof D=="object"&&D!==null&&D.supported!==!0)return D.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var k;(function(D){D[D.System=0]="System",D[D.User=1]="User"})(k||(e.ExtensionType=k={}));var I;(function(D){D.WIN32_X64="win32-x64",D.WIN32_ARM64="win32-arm64",D.LINUX_X64="linux-x64",D.LINUX_ARM64="linux-arm64",D.LINUX_ARMHF="linux-armhf",D.LINUX_PPC64LE="linux-ppc64le",D.LINUX_RISCV64="linux-riscv64",D.ALPINE_X64="alpine-x64",D.ALPINE_ARM64="alpine-arm64",D.DARWIN_X64="darwin-x64",D.DARWIN_ARM64="darwin-arm64",D.WEB="web",D.UNIVERSAL="universal",D.UNKNOWN="unknown",D.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class u{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,l){if(typeof p>"u"||p===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof p=="string"||typeof l=="string"){const E=typeof p=="string"?p:p.value,v=typeof l=="string"?l:l.value;return O.equalsIgnoreCase(E,v)}return p._lower===l._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=u;class a{get size(){return this._set.size}constructor(p){if(this._set=new Set,p)for(const l of p)this.add(l)}add(p){this._set.add(u.toKey(p))}delete(p){return this._set.delete(u.toKey(p))}has(p){return this._set.has(u.toKey(p))}}e.ExtensionIdentifierSet=a;class y{constructor(){this._map=new Map}clear(){this._map.clear()}delete(p){this._map.delete(u.toKey(p))}get(p){return this._map.get(u.toKey(p))}has(p){return this._map.has(u.toKey(p))}set(p,l){this._map.set(u.toKey(p),l)}values(){return this._map.values()}forEach(p){this._map.forEach(p)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=y;function w(D){return d(D)}function d(D){return D.contributes&&D.contributes.localizations?D.contributes.localizations.length>0:!1}function m(D){return D.contributes&&D.contributes.authentication?D.contributes.authentication.length>0:!1}function S(D,p){if(p){const l=`onResolveRemoteAuthority:${(0,C.getRemoteName)(p)}`;return!!D.activationEvents?.includes(l)}return!1}e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[140],se([0,1,2,37,13]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class x extends O.Disposable{constructor(I,u,a,y,w){super(),this.userDataProfilesService=I,this.fileService=u,this.uriIdentityService=a,this.logService=w,this._register(y.onDidInstallExtensions(d=>this.onDidInstallExtensions(d))),this._register(y.onDidUninstallExtension(d=>this.onDidUnInstallExtension(d)))}onDidInstallExtensions(I){for(const u of I)u.local&&this.invalidate(u.profileLocation)}onDidUnInstallExtension(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const u of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(u.extensionsResource,I)&&await this.deleteUserCacheFile(u);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(I){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(I.cacheHome,L.USER_MANIFEST_CACHE_FILE))}catch(u){(0,C.toFileOperationResult)(u)!==1&&this.logService.error(u)}}}e.ExtensionsManifestCache=x}),define(ne[45],se([0,1,14,8,2,107,40,10,6,36]),function(K,e,O,L,C,x,k,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=d,e.hasNoContent=m,e.asText=S,e.asTextOrError=D,e.asJson=p,e.updateProxyConfigurationsScope=l,e.IRequestService=(0,I.createDecorator)("requestService");class y{constructor(g){this.original=g}toJSON(){if(!this.headers){const g=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.original[i];this.headers=g}return this.headers}}class w extends C.Disposable{constructor(g){super(),this.counter=0,this.logger=g.createLogger("network",{name:(0,x.localize)(0,null),when:u.CONTEXT_LOG_LEVEL.isEqualTo((0,u.LogLevelToString)(u.LogLevel.Trace)).serialize()})}async logAndRequest(g,i,s){const t=`${g} #${++this.counter}: ${i.url}`;this.logger.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await s();return this.logger.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.logger.error(`${t} - error`,i.type,(0,L.getErrorMessage)(n)),n}}}e.AbstractRequestService=w;function d(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}function m(f){return f.res.statusCode===204}async function S(f){return m(f)?null:(await(0,O.streamToBuffer)(f.stream)).toString()}async function D(f){if(!d(f))throw new Error("Server returned "+f.res.statusCode);return S(f)}async function p(f){if(!d(f))throw new Error("Server returned "+f.res.statusCode);if(m(f))return null;const i=(await(0,O.streamToBuffer)(f.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}function l(f){v(f)}let E;function v(f){const g=a.Registry.as(k.Extensions.Configuration),i=E;E={id:"http",order:15,title:(0,x.localize)(1,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,x.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,x.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,x.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,x.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,x.localize)(6,null),(0,x.localize)(7,null),(0,x.localize)(8,null),(0,x.localize)(9,null)],default:"override",description:(0,x.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,x.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,x.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[E],remove:i?[i]:[]})}v(1)}),define(ne[141],se([0,1,20,15,13,45]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(u,a){this.requestService=u,this.fileService=a}async download(u,a,y=O.CancellationToken.None){if(u.scheme===L.Schemas.file||u.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(u,a);return}const w={type:"GET",url:u.toString(!0)},d=await this.requestService.request(w,y);if(d.res.statusCode===200)await this.fileService.writeFile(a,d.stream);else{const m=await(0,x.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${m}`)}}};e.DownloadService=k,e.DownloadService=k=ve([oe(0,x.IRequestService),oe(1,C.IFileService)],k)}),define(ne[142],se([0,1,143,3]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=x;function C(k,I){return k.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:k.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function x(k,I,u={}){const a=(0,O.parse)(k),y=u.proxyUrl||C(a,I);if(!y)return null;const w=(0,O.parse)(y);if(!/^https?:$/.test(w.protocol||""))return null;const d={host:w.hostname||"",port:(w.port?+w.port:0)||(w.protocol==="https"?443:80),auth:w.auth,rejectUnauthorized:(0,L.isBoolean)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((m,S)=>{K(["http-proxy-agent"],m,S)})).HttpProxyAgent(y,d):new(await new Promise((m,S)=>{K(["https-proxy-agent"],m,S)})).HttpsProxyAgent(y,d)}}),define(ne[144],se([0,1,59,16,108,20,34,8,12,28,87,175,9,75]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=D;let S;async function D(l,E,v,f){return v["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(f)&&!v["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(f)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=d.Promises.withAsyncBody(async(g,i)=>{const s=new x.CancellationTokenSource;let t=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,m.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),i(new Error((0,C.localize)(0,null)))},t);try{g(await p(E,s.token))}catch(o){!(0,I.isCancellationError)(o)&&!s.token.isCancellationRequested?i(new Error((0,C.localize)(1,null,(0,k.toErrorMessage)(o)))):g({})}finally{clearTimeout(r),s.dispose()}})),S)}async function p(l,E){const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",f);const g=(0,a.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",s);const t=await(0,y.getSystemShell)(u.OS,s);return l.trace("getUnixShellEnvironment#shell",t),new Promise((n,r)=>{if(E.isCancellationRequested)return r(new I.CancellationError);const o=(0,L.basename)(t);let c,b;const R="";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${R} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,b=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${R} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,b=["-i","-l","-c"]):o==="xonsh"?(c=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,b=["-i","-l","-c"]):(c=`'${process.execPath}' ${R} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?b=["-ic"]:b=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),c);const T=(0,O.spawn)(t,[...b,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});E.onCancellationRequested(()=>(T.kill(),r(new I.CancellationError))),T.on("error",z=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(z)),r(z)});const N=[];T.stdout.on("data",z=>N.push(z));const F=[];T.stderr.on("data",z=>F.push(z)),T.on("close",(z,H)=>{const re=Buffer.concat(N).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const ie=Buffer.concat(F).toString("utf8");if(ie.trim()&&l.trace("getUnixShellEnvironment#stderr",ie),z||H)return r(new Error((0,C.localize)(2,null,z,H)));const ue=i.exec(re),fe=ue?ue[1]:"{}";try{const le=JSON.parse(fe);v?le.ELECTRON_RUN_AS_NODE=v:delete le.ELECTRON_RUN_AS_NODE,f?le.ELECTRON_NO_ATTACH_CONSOLE=f:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",le),n(le)}catch(le){l.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(le)),r(le)}})})}}),define(ne[145],se([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,O.createDecorator)("stateReadService"),e.IStateService=(0,O.createDecorator)("stateService")}),define(ne[68],se([0,1,9,14,2,3,18,13,6]),function(K,e,O,L,C,x,k,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var a;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends C.Disposable{constructor(S,D,p,l){super(),this.storagePath=S,this.saveStrategy=D,this.logService=p,this.fileService=l,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=this._register(new O.ThrottledDelayer(this.saveStrategy===0?0:100)),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,D){const p=this.storage[S];return(0,x.isUndefinedOrNull)(p)?D:p}setItem(S,D){this.setItems([{key:S,data:D}])}setItems(S){let D=!1;for(const{key:p,data:l}of S)this.storage[p]!==l&&((0,x.isUndefinedOrNull)(l)?(0,x.isUndefined)(this.storage[p])||(this.storage[p]=void 0,D=!0):(this.storage[p]=l,D=!0));D&&this.save()}removeItem(S){(0,x.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(S),{atomic:{postfix:".vsctmp"}}),this.lastSavedStorageContents=S}catch(D){this.logService.error(D)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let w=class extends C.Disposable{constructor(S,D,p,l){super(),this.fileStorage=this._register(new y(D.stateResource,S,p,l))}async init(){await this.fileStorage.init()}getItem(S,D){return this.fileStorage.getItem(S,D)}};e.StateReadonlyService=w,e.StateReadonlyService=w=ve([oe(1,k.IEnvironmentService),oe(2,u.ILogService),oe(3,I.IFileService)],w);class d extends w{setItem(S,D){this.fileStorage.setItem(S,D)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}}e.StateService=d}),define(ne[69],se([0,1,12,35,28]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=I;function x(u){if(O.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function k(u,a,y,w,d,m,S,D,p){const l=Object.create(null);l["common.machineId"]=m,l["common.sqmId"]=S,l.sessionID=(0,C.generateUuid)()+Date.now(),l.commitHash=w,l.version=d,l["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,O.PlatformToString)(O.platform),l["common.nodePlatform"]=L.platform,l["common.nodeArch"]=y,l["common.product"]=p||"desktop",D&&(l["common.msftInternal"]=D);let E=0;const v=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),O.isLinuxSnap&&(l["common.snap"]="true");const f=x(a);return f&&(l["common.platformDetail"]=f),l}function I(u){const a=L.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return u.some(w=>y===w)}}),define(ne[22],se([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(x){x[x.NONE=0]="NONE",x[x.CRASH=1]="CRASH",x[x.ERROR=2]="ERROR",x[x.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var C;(function(x){x.OFF="off",x.CRASH="crash",x.ERROR="error",x.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(ne[70],se([0,1,8,10,6,22]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");let k=class{constructor(u,a){this.logService=u,this.telemetryService=a}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((u,a)=>K(["@vscode/vsce-sign"],async y=>u(y),a))),this.moduleLoadingPromise}async verify(u,a,y){let w;try{w=await this.vsceSign()}catch(D){return this.logService.error("Could not load vsce-sign module",(0,O.getErrorMessage)(D)),!1}const d=new Date().getTime();let m,S;try{return m=await w.verify(u,a,y),m}catch(D){throw S=D,D}finally{const D=new Date().getTime()-d;this.telemetryService.publicLog2("extensionsignature:verification",{duration:D,verified:m,error:S?S.code??"unknown":void 0})}}};e.ExtensionSignatureVerificationService=k,e.ExtensionSignatureVerificationService=k=ve([oe(0,C.ILogService),oe(1,x.ITelemetryService)],k)}),define(ne[41],se([0,1,27,3,67,69,22]),function(K,e,O,L,C,x,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=y,e.isLoggingOnly=w,e.getTelemetryLevel=d,e.validateTelemetryData=m,e.cleanRemoteAuthority=D,e.isInternalTelemetry=l,e.getPiiPathsFromEnvironment=E,e.cleanData=g;class I{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=I;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class a{async publicLog(s,t,n){}async publicLogError(s,t,n){}}e.NullEndpointTelemetryService=a,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}function w(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const s=i.getValue(k.TELEMETRY_SETTING_ID),t=i.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(i){const s={},t={},n={};p(i,n);for(let r in n){r=r.length>150?r.substr(r.length-149):r;const o=n[r];typeof o=="number"?t[r]=o:typeof o=="boolean"?t[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),s[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[r]=o)}return{properties:s,measurements:t}}const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function D(i){if(!i)return"none";const s=(0,C.getRemoteName)(i);return S.has(s)?s:"other"}function p(i,s,t=0,n){if(i)for(const r of Object.getOwnPropertyNames(i)){const o=i[r],c=n?n+r:r;Array.isArray(o)?s[c]=(0,O.safeStringify)(o):o instanceof Date?s[c]=o.toISOString():(0,L.isObject)(o)?t<2?p(o,s,t+1,c+"."):s[c]=(0,O.safeStringify)(o):s[c]=o}}function l(i,s){const t=i.msftInternalDomains||[],n=s.getValue("telemetry.internalTesting");return(0,x.verifyMicrosoftInternalDomain)(t)||n}function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function v(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const b of s)for(;;){const R=b.exec(i);if(!R)break;n.push([R.index,b.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(t="";;){const b=o.exec(i);if(!b)break;const R=n.some(([T,N])=>b.index<N&&T<o.lastIndex);!r.test(b[0])&&!R&&(t+=i.substring(c,b.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<i.length&&(t+=i.substr(c)),t}function f(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of s)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,s){return(0,O.cloneAndChange)(i,t=>{if(t instanceof I||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=v(n,s);for(const r of s)n=n.replace(r,"");return n=f(n),n}})}}),define(ne[26],se([0,1,30,21,37,12,11,8,35,41]),function(K,e,O,L,C,x,k,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=y,e.getIdAndVersion=S,e.getExtensionId=D,e.adoptToGalleryExtensionId=p,e.getGalleryExtensionId=l,e.groupByExtension=E,e.getLocalExtensionTelemetryData=v,e.getGalleryExtensionTelemetryData=f,e.getExtensionDependencies=g,e.computeTargetPlatform=s;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,O.compareIgnoreCase)(t.id,n.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,o)}static parse(n){const r=w.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(t){const n=m.exec(t);return n&&n[1]?[p(n[1]),n[2]]:[p(t),void 0]}function D(t,n){return`${t}.${n}`}function p(t){return t.toLowerCase()}function l(t,n){return p(D(t??C.UNDEFINED_PUBLISHER,n))}function E(t,n){const r=[],o=c=>{for(const b of r)if(b.some(R=>y(n(R),n(c))))return b;return null};for(const c of t){const b=o(c);b?b.push(c):r.push([c])}return r}function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function f(t){return{id:new a.TelemetryTrustedValue(t.identifier.id),name:new a.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function g(t,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(b=>!y(b.identifier,{id:c}))){const b=t.filter(R=>y(R.identifier,{id:c}));b.length===1&&(r.push(b[0]),o.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function i(t,n){if(!x.isLinux)return!1;let r;try{r=(await t.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await t.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(t,n){const r=await i(t,n),o=(0,L.getTargetPlatform)(r?"alpine":x.platform,u.arch);return n.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],se([0,1,20,8,15,17,44,11,96,21,26,37]),function(K,e,O,L,C,x,k,I,u,a,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=D=>(0,u.localize)(0,null,D),m=(0,u.localize)(1,null,"ms-dotnettools.csharp");let S=class{constructor(p,l,E){this.logger=p,this.extensionManagementService=l,this.extensionGalleryService=E}get location(){}async listExtensions(p,l,E){let v=await this.extensionManagementService.getInstalled(1,E);const f=w.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(l&&l!==""){if(f.indexOf(l.toLowerCase())<0){this.logger.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.logger.info("Possible Categories: "),f.forEach(i=>{this.logger.info(i)});return}this.location&&this.logger.info((0,u.localize)(2,null,this.location)),v=v.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let g;for(const i of v)g!==i.identifier.id&&(g=i.identifier.id,this.logger.info(p?`${g}@${i.manifest.version}`:g))}async installExtensions(p,l,E,v){const f=[];try{p.length&&this.logger.info(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const g=[],i=[],s=(n,r,o)=>{i.push({id:n,version:r!=="prerelease"?r:void 0,installOptions:{...E,isBuiltin:o,installPreReleaseVersion:r==="prerelease"||E.installPreReleaseVersion}})};for(const n of p)if(n instanceof I.URI)g.push({vsix:n,installOptions:E});else{const[r,o]=(0,y.getIdAndVersion)(n);s(r,o,!1)}for(const n of l)if(n instanceof I.URI)g.push({vsix:n,installOptions:{...E,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,o]=(0,y.getIdAndVersion)(n);s(r,o,!0)}const t=await this.extensionManagementService.getInstalled(1,E.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:r})=>{try{await this.installVSIX(n,r,v,t)}catch(o){this.logger.error(o),f.push(n.toString())}})),i.length){const n=await this.installGalleryExtensions(i,t,v);f.push(...n)}}catch(g){throw this.logger.error((0,u.localize)(5,null,(0,L.getErrorMessage)(g))),g}if(f.length)throw new Error((0,u.localize)(6,null,f.join(", ")))}async updateExtensions(p){const l=await this.extensionManagementService.getInstalled(1,p),E=[];for(const i of l)i.identifier.uuid&&E.push({...i.identifier,preRelease:i.preRelease});this.logger.trace((0,u.localize)(7,null,E.length));const v=await this.extensionGalleryService.getExtensions(E,{compatible:!0},O.CancellationToken.None),f=[];for(const i of v)for(const s of l)(0,y.areSameExtensions)(s.identifier,i.identifier)&&(0,k.gt)(i.version,s.manifest.version)&&f.push({extension:i,options:{operation:3,installPreReleaseVersion:s.isPreReleaseVersion}});if(!f.length){this.logger.info((0,u.localize)(8,null));return}this.logger.info((0,u.localize)(9,null,f.map(i=>i.extension.identifier.id).join(", ")));const g=await this.extensionManagementService.installGalleryExtensions(f);for(const i of g)i.error?this.logger.error((0,u.localize)(10,null,i.identifier.id,(0,L.getErrorMessage)(i.error))):this.logger.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async installGalleryExtensions(p,l,E){if(p=p.filter(({id:i,version:s})=>{const t=l.find(n=>(0,y.areSameExtensions)(n.identifier,{id:i}));if(t){if(!E&&(!s||s==="prerelease"&&t.preRelease))return this.logger.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(s&&t.manifest.version===s)return this.logger.info((0,u.localize)(13,null,`${i}@${s}`)),!1}return!0}),!p.length)return[];const v=[],f=[],g=await this.getGalleryExtensions(p);if(await Promise.all(p.map(async({id:i,version:s,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.logger.error(`${d(s?`${i}@${s}`:i)}
${m}`),v.push(i);return}try{const o=await this.extensionGalleryService.getManifest(n,O.CancellationToken.None);if(o&&!this.validateExtensionKind(o))return}catch(o){this.logger.error(o.message||o.stack||o),v.push(i);return}const r=l.find(o=>(0,y.areSameExtensions)(o.identifier,n.identifier));if(r){if(n.version===r.manifest.version){this.logger.info((0,u.localize)(14,null,s?`${i}@${s}`:i));return}this.logger.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.logger.info(s?(0,u.localize)(16,null,i,s):(0,u.localize)(17,null,i)):this.logger.info(s?(0,u.localize)(18,null,i,s):(0,u.localize)(19,null,i)),f.push({extension:n,options:{...t,installGivenVersion:!!s}})})),f.length){const i=await this.extensionManagementService.installGalleryExtensions(f);for(const s of i)s.error?(this.logger.error((0,u.localize)(20,null,s.identifier.id,(0,L.getErrorMessage)(s.error))),v.push(s.identifier.id)):this.logger.info((0,u.localize)(21,null,s.identifier.id,s.local?.manifest.version))}return v}async installVSIX(p,l,E,v){const f=await this.extensionManagementService.getManifest(p);if(!f)throw new Error("Invalid vsix");if(await this.validateVSIX(f,E,l.profileLocation,v))try{await this.extensionManagementService.install(p,l),this.logger.info((0,u.localize)(22,null,(0,x.basename)(p)))}catch(i){if((0,L.isCancellationError)(i))this.logger.info((0,u.localize)(23,null,(0,x.basename)(p)));else throw i}}async getGalleryExtensions(p){const l=new Map,E=p.some(g=>g.installOptions.installPreReleaseVersion),v=await this.extensionManagementService.getTargetPlatform(),f=[];for(const g of p)a.EXTENSION_IDENTIFIER_REGEX.test(g.id)&&f.push({...g,preRelease:E});if(f.length){const g=await this.extensionGalleryService.getExtensions(f,{targetPlatform:v},O.CancellationToken.None);for(const i of g)l.set(i.identifier.id.toLowerCase(),i)}return l}validateExtensionKind(p){return!0}async validateVSIX(p,l,E,v){if(!l){const f={id:(0,y.getGalleryExtensionId)(p.publisher,p.name)},g=v.find(i=>(0,y.areSameExtensions)(f,i.identifier)&&(0,k.gt)(i.manifest.version,p.version));if(g)return this.logger.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,p.version)),!1}return this.validateExtensionKind(p)}async uninstallExtensions(p,l,E){const v=async g=>{if(g instanceof I.URI){const i=await this.extensionManagementService.getManifest(g);return(0,y.getExtensionId)(i.publisher,i.name)}return g},f=[];for(const g of p){const i=await v(g),t=(await this.extensionManagementService.getInstalled(void 0,E)).filter(n=>(0,y.areSameExtensions)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.notInstalled(i)}
${m}`);if(t.some(n=>n.type===0)){this.logger.info((0,u.localize)(25,null,i));return}if(!l&&t.some(n=>n.isBuiltin)){this.logger.info((0,u.localize)(26,null,i));return}this.logger.info((0,u.localize)(27,null,i));for(const n of t)await this.extensionManagementService.uninstall(n,{profileLocation:E}),f.push(n);this.location?this.logger.info((0,u.localize)(28,null,i,this.location)):this.logger.info((0,u.localize)(29,null,i))}}async locateExtension(p){const l=await this.extensionManagementService.getInstalled();p.forEach(E=>{l.forEach(v=>{if(v.identifier.id===E&&v.location.scheme===C.Schemas.file){this.logger.info(v.location.fsPath);return}})})}notInstalled(p){return this.location?(0,u.localize)(30,null,p,this.location):(0,u.localize)(31,null,p)}};e.ExtensionManagementCLI=S,e.ExtensionManagementCLI=S=ve([oe(1,a.IExtensionManagementService),oe(2,a.IExtensionGalleryService)],S)}),define(ne[147],se([0,1,9,8,2,15,17,44,3,28,25,49,29,18,21,26,70,13,6]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends C.Disposable{static{v=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(i,s,t,n,r,o){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=n,this.extensionSignatureVerificationService=r,this.logService=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,s,t){await this.cleanUpPromise;const n=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,n,o=>this.extensionGalleryService.download(i,o,s))}catch(o){throw new S.ExtensionManagementError(o.message,S.ExtensionManagementErrorCode.Download)}let r=!1;if(t&&this.shouldVerifySignature(i)){const o=await this.downloadSignatureArchive(i);try{r=await this.extensionSignatureVerificationService.verify(n.fsPath,o.fsPath,this.logService.getLevel()===E.LogLevel.Trace)}catch(c){const b=c;if(r=b.code,b.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${b.output}`),r===S.ExtensionSignaturetErrorCode.PackageIsInvalidZip||r===S.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(R){this.logService.error(R)}throw new S.ExtensionManagementError(w.CorruptZipMessage,S.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(c){this.logService.error(c)}}}return r===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):r===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${r}': ${i.identifier.id}`),{location:n,verificationStatus:r}}shouldVerifySignature(i){if(!i.isSigned)return this.logService.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.configurationService.getValue("extensions.verifySignature");return(0,u.isBoolean)(s)?s:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const s=(0,k.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${v.SignatureArchiveExtension}`);try{await this.downloadFile(i,s,t=>this.extensionGalleryService.downloadSignatureArchive(i,t))}catch(t){throw new S.ExtensionManagementError(t.message,S.ExtensionManagementErrorCode.DownloadSignature)}return s}async downloadFile(i,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==x.Schemas.file){await t(s);return}const n=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,a.generateUuid)()}`);await this.fileService.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,s.fsPath,2*60*1e3)}catch(r){try{await this.fileService.del(n)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],t=[],n=[];for(const c of i.children)if(c.name.endsWith(v.SignatureArchiveExtension))n.push(c.resource);else{const b=D.ExtensionKey.parse(c.name);b&&t.push([b,c])}const r=(0,D.groupByExtension)(t,([c])=>c),o=[];for(const c of r)c.sort((b,R)=>I.rcompare(b[0].version,R[0].version)),s.push(...c.slice(1).map(b=>b[1].resource)),o.push(c[0][1]);o.sort((c,b)=>c.mtime-b.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(c=>c.resource)),s.push(...n),await O.Promises.settled(s.map(c=>(this.logService.trace("Deleting from cache",c.path),this.fileService.del(c))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?D.ExtensionKey.create(i).toString().toLowerCase():(0,a.generateUuid)()}};e.ExtensionsDownloader=f,e.ExtensionsDownloader=f=v=ve([oe(0,m.INativeEnvironmentService),oe(1,l.IFileService),oe(2,S.IExtensionGalleryService),oe(3,d.IConfigurationService),oe(4,p.IExtensionSignatureVerificationService),oe(5,E.ILogService)],f)}),define(ne[148],se([0,1,5,2,31,26,37]),function(K,e,O,L,C,x,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class I extends L.Disposable{constructor(a,y,w,d,m,S,D){super(),this.extensionManagementService=a,this.extensionsScannerService=y,this.userDataProfilesService=w,this.extensionsProfileScannerService=d,this.uriIdentityService=m,this.fileService=S,this.logService=D,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new L.DisposableMap),this.initialize().then(null,p=>D.error(p))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(a=>this.onDidChangeProfiles(a.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(a=>this.onAddExtensions(a))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(a=>this.onDidAddExtensions(a))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(a=>this.onRemoveExtensions(a))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(a=>this.onDidRemoveExtensions(a))),this._register(this.fileService.onDidFilesChange(a=>this.onDidFilesChange(a)))}async onDidChangeProfiles(a){try{a.length&&await Promise.all(a.map(y=>(this.extensionsProfileWatchDisposables.set(y.id,(0,L.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(y.extensionsResource)),this.fileService.watch(y.extensionsResource))),this.populateExtensionsFromProfile(y.extensionsResource))))}catch(y){throw this.logService.error(y),y}}async onAddExtensions(a){for(const y of a.extensions)this.addExtensionWithKey(this.getKey(y.identifier,y.version),a.profileLocation)}async onDidAddExtensions(a){for(const y of a.extensions){const w=this.getKey(y.identifier,y.version);a.error?this.removeExtensionWithKey(w,a.profileLocation):this.addExtensionWithKey(w,a.profileLocation)}}async onRemoveExtensions(a){for(const y of a.extensions)this.removeExtensionWithKey(this.getKey(y.identifier,y.version),a.profileLocation)}async onDidRemoveExtensions(a){const y=[],w=[];for(const d of a.extensions){const m=this.getKey(d.identifier,d.version);a.error?this.addExtensionWithKey(m,a.profileLocation):(this.removeExtensionWithKey(m,a.profileLocation),this.allExtensions.has(m)||(this.logService.debug("Extension is removed from all profiles",d.identifier.id,d.version),w.push(this.extensionManagementService.scanInstalledExtensionAtLocation(d.location).then(S=>{S?y.push(S):this.logService.info("Extension not found at the location",d.location.toString())},S=>this.logService.error(S)))))}try{await Promise.all(w),y.length&&await this.uninstallExtensionsNotInProfiles(y)}catch(d){this.logService.error(d)}}onDidFilesChange(a){for(const y of this.userDataProfilesService.profiles)a.contains(y.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(y.extensionsResource)}async onDidExtensionsProfileChange(a){const y=[],w=[],d=await this.extensionsProfileScannerService.scanProfileExtensions(a),m=new Set,S=new Set;for(const[D,p]of this.allExtensions)p.has(a)&&S.add(D);for(const D of d){const p=this.getKey(D.identifier,D.version);m.add(p),S.has(p)||(y.push(D.identifier),this.addExtensionWithKey(p,a))}for(const D of S)if(!m.has(D)){const p=this.fromKey(D);p&&(w.push(p.identifier),this.removeExtensionWithKey(D,a))}(y.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:w.length?{extensions:w,profileLocation:a}:void 0})}async populateExtensionsFromProfile(a){const y=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const w of y)this.addExtensionWithKey(this.getKey(w.identifier,w.version),a)}async uninstallExtensionsNotInProfiles(a){a||(a=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(w=>!this.allExtensions.has(this.getKey(w.identifier,w.manifest.version)))),a.length&&await this.extensionManagementService.markAsUninstalled(...a)}addExtensionWithKey(a,y){let w=this.allExtensions.get(a);w||this.allExtensions.set(a,w=new C.ResourceSet(d=>this.uriIdentityService.extUri.getComparisonKey(d))),w.add(y)}removeExtensionWithKey(a,y){const w=this.allExtensions.get(a);w&&w.delete(y),w?.size||this.allExtensions.delete(a)}getKey(a,y){return`${k.ExtensionIdentifier.toKey(a.id)}@${y}`}fromKey(a){const[y,w]=(0,x.getIdAndVersion)(a);return w?{identifier:{id:y},version:w}:void 0}}e.ExtensionsWatcher=I}),define(ne[149],se([0,1,118,41]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=C;async function C(x,k,I,u,a,y,w){const d={"X-Market-Client-Id":`VSCode ${x}`,"User-Agent":`VSCode ${x} (${k.nameShort})`};if((0,L.supportsTelemetry)(k,I)&&(0,L.getTelemetryLevel)(u)===3){const m=await(0,O.getServiceMachineId)(I,a,y);d["X-Market-User-Id"]=m,d["VSCode-SessionId"]=w.machineId||m}return d}}),define(ne[150],se([0,1,176,19,9,2,15,16,25,18,21,26,6,64,11]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let D=class extends m.LanguagePackBaseService{constructor(v,f,g,i){super(g),this.extensionManagementService=v,this.logService=i,this.cache=this._register(new p(f,i)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getBuiltInExtensionTranslationsUri(v,f){const i=(await this.cache.getLanguagePacks())[f];if(!i){this.logService.warn(`No language pack found for ${f}`);return}const s=i.translations[v];return s?S.URI.file(s):void 0}async getInstalledLanguages(){const v=await this.cache.getLanguagePacks(),f=Object.keys(v).map(g=>{const i=v[g];return{...this.createQuickPickItem(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return f.push(this.createQuickPickItem("en","English")),f.sort((g,i)=>g.label.localeCompare(i.label)),f}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const f=await this.cache.getLanguagePacks();Object.keys(f).some(g=>f[g]&&f[g].extensions.some(i=>(0,w.areSameExtensions)(i.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(f);return!(0,L.equals)(Object.keys(v),Object.keys(g))}};e.NativeLanguagePackService=D,e.NativeLanguagePackService=D=ve([oe(0,y.IExtensionManagementService),oe(1,a.INativeEnvironmentService),oe(2,y.IExtensionGalleryService),oe(3,d.ILogService)],D);let p=class extends x.Disposable{constructor(v,f){super(),this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(f=>{Object.keys(f).forEach(g=>delete f[g]),this.createLanguagePacksFromExtensions(f,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...f){for(const g of f)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,g);Object.keys(v).forEach(g=>this.updateHash(v[g]))}createLanguagePacksFromExtension(v,f){const g=f.identifier,i=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const s of i)if(f.location.scheme===k.Schemas.file&&l(s)){let t=v[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},v[s.languageId]=t);const n=t.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,g))[0];n?n.version=f.manifest.version:t.extensions.push({extensionIdentifier:g,version:f.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,I.join)(f.location.fsPath,r.path)}}updateHash(v){if(v){const f=(0,O.createHash)("md5");for(const g of v.extensions)f.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);v.hash=f.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(f=v(g),g)).then(g=>{for(const s of Object.keys(g))g[s]||delete g[s];this.languagePacks=g,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),u.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>f,g=>this.logService.error(g))})}};p=ve([oe(0,a.INativeEnvironmentService),oe(1,d.ILogService)],p);function l(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const v of E.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}}),define(ne[151],se([0,1,84,8,27,41]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://0.0.0.0/OneCollector/1.0",I="https://0.0.0.0/ping";async function u(y,w,d){const m=await(0,O.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),S=await(0,O.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),D=new m.AppInsightsCore,p=new S.PostChannel,l={instrumentationKey:y,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(d){l.extensionConfig={};const E={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};l.extensionConfig[p.identifier]=E}return D.initialize(l,[]),D.addTelemetryInitializer(E=>{E.ext=E.ext??{},E.ext.web=E.ext.web??{},E.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',w&&(E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),D}class a{constructor(w,d,m,S,D){this._isInternalTelemetry=w,this._eventPrefix=d,this._defaultData=m,this._xhrOverride=D,this.endPointUrl=k,this.endPointHealthUrl=I,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(w){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{w(d)},d=>{(0,L.onUnexpectedError)(d),console.error(d)})}}log(w,d){if(!this._aiCoreOrKey)return;d=(0,C.mixin)(d,this._defaultData),d=(0,x.validateTelemetryData)(d);const m=this._eventPrefix+"/"+w;try{this._withAIClient(S=>{S.pluginVersionString=d?.properties.version??"Unknown",S.track({name:m,baseData:{name:m,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=a}),define(ne[152],se([0,1,2,27,12,30,109,29,40,153,32,36,22,41]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,E,v){this._configurationService=E,this._productService=v,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,x.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,x.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(f=>{(f.affectsConfiguration(d.TELEMETRY_SETTING_ID)||f.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||f.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(l,E){this._experimentProperties[l]=E}_updateTelemetryLevel(){let l=(0,m.getTelemetryLevel)(this._configurationService);const E=this._productService.enabledTelemetryLevels;if(E){this._sendErrorTelemetry=this.sendErrorTelemetry?E.error:!1;const v=E.usage?3:E.error?2:0;l=Math.min(l,v)}this._telemetryLevel=l}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(l,E,v){this._telemetryLevel<E||(v=(0,L.mixin)(v,this._experimentProperties),v=(0,m.cleanData)(v,this._cleanupPatterns),v=(0,L.mixin)(v,this._commonProperties),this._appenders.forEach(f=>f.log(l,v)))}publicLog(l,E){this._log(l,3,E)}publicLog2(l,E){this.publicLog(l,E)}publicLogError(l,E){this._sendErrorTelemetry&&this._log(l,2,E)}publicLogError2(l,E){this.publicLogError(l,E)}};e.TelemetryService=S,e.TelemetryService=S=ve([oe(1,I.IConfigurationService),oe(2,y.IProductService)],S);function D(){const p=(0,k.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),E=C.isWeb?"":(0,k.localize)(3,null),v=(0,k.localize)(4,null),f=(0,k.localize)(5,null),g=(0,k.localize)(6,null),i=(0,k.localize)(7,null),s=`
|       | ${v} | ${f} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,k.localize)(8,null);return`
${p} ${l} ${E}

&nbsp;

${i}
${s}

&nbsp;

${t}
`}w.Registry.as(u.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:D(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(u.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,k.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,k.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],se([0,1,14,20,177,151]),function(K,e,O,L,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function k(y,w){const d=await w.request(y,L.CancellationToken.None),m=(await(0,O.streamToBuffer)(d.stream)).toString(),S=d.res.statusCode??200;return{headers:d.res.headers,statusCode:S,responseData:m}}async function I(y){const w={method:y.type,headers:y.headers};return new Promise((m,S)=>{const D=C.request(y.url??"",w,p=>{p.on("data",function(l){m({headers:p.headers,statusCode:p.statusCode??200,responseData:l.toString()})}),p.on("error",function(l){S(l)})});D.write(y.data,p=>{p&&S(p)}),D.end()})}async function u(y,w,d){const m=typeof w.data=="string"?w.data:new TextDecoder().decode(w.data),S={type:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data).toString()},url:w.urlString,data:m};try{const D=y?await k(S,y):await I(S);d(D.statusCode,D.headers,D.responseData)}catch{d(0,{})}}class a extends x.AbstractOneDataSystemAppender{constructor(w,d,m,S,D){const p={sendPOST:(l,E)=>{u(w,l,E)}};super(d,m,S,D,p)}}e.OneDataSystemAppender=a}),define(ne[155],se([0,1,16,25]),function(K,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=C;async function C(x,k){const I=Object.create(null),u=(y,w)=>{const d=JSON.parse(y);I[w]=d};if(k){const y=[],w=await L.Promises.readdir(k);for(const m of w)try{(await L.Promises.stat((0,O.join)(k,m))).isDirectory()&&y.push(m)}catch{}const d=[];for(const m of y)(await L.Promises.readdir((0,O.join)(k,m))).filter(D=>D==="telemetry.json").length===1&&d.push(m);for(const m of d){const S=(await L.Promises.readFile((0,O.join)(k,m,"telemetry.json"))).toString();u(S,m)}}let a=(await L.Promises.readFile((0,O.join)(x,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await L.Promises.readFile((0,O.join)(x,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(I,null,4)}}),define(ne[156],se([0,1,12,85,22]),function(K,e,O,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=x,e.resolveSqmId=k;async function x(I,u){let a=I.getItem(C.machineIdKey);return(typeof a!="string"||O.isMacintosh&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,L.getMachineId)(u.error.bind(u))),a}async function k(I,u){let a=I.getItem(C.sqmIdKey);return typeof a!="string"&&(a=await(0,L.getSqmMachineId)(u.error.bind(u))),a}}),define(ne[23],se([0,1,10]),function(K,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(ne[157],se([0,1,23,119,13,17,76,5,2]),function(K,e,O,L,C,x,k,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this._fileService=d,this._dispooables=new u.DisposableStore,this._limit=2**16;const m=new Map,S=D=>{let p=m.get(D.scheme);return p===void 0&&(p=d.hasProvider(D)&&!this._fileService.hasCapability(D,1024),m.set(D.scheme,p)),p};this._dispooables.add(I.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(D=>{m.delete(D.scheme)})),this.extUri=new x.ExtUri(S),this._canonicalUris=new k.SkipList((D,p)=>this.extUri.compare(D,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,x.normalizePath)(d));const m=this._canonicalUris.get(d);return m?m.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new a(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((S,D)=>S[1].time<D[1].time?1:S[1].time>D[1].time?-1:0);a._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let S=0;S<m;S++)this._canonicalUris.set(d[S][0],d[S][1].touch())}};e.UriIdentityService=y,e.UriIdentityService=y=ve([oe(0,C.IFileService)],y),(0,L.registerSingleton)(O.IUriIdentityService,y,1)}),define(ne[158],se([0,1,5,2,13,48,31]),function(K,e,O,L,C,x,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends L.Disposable{constructor(a,y,w,d,m,S){super(),this.fileSystemScheme=a,this.fileSystemProvider=y,this.userDataScheme=w,this.userDataProfilesService=d,this.uriIdentityService=m,this.logService=S,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=x.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new k.ResourceSet(D=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(D))),this.updateAtomicReadWritesResources(),this._register(d.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(D=>this.handleFileChanges(D)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const a of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(a.settingsResource),this.atomicReadWriteResources.add(a.keybindingsResource),this.atomicReadWriteResources.add(a.tasksResource),this.atomicReadWriteResources.add(a.extensionsResource)}open(a,y){return this.fileSystemProvider.open(this.toFileSystemResource(a),y)}close(a){return this.fileSystemProvider.close(a)}read(a,y,w,d,m){return this.fileSystemProvider.read(a,y,w,d,m)}write(a,y,w,d,m){return this.fileSystemProvider.write(a,y,w,d,m)}watch(a,y){this.watchResources.set(a,a);const w=this.fileSystemProvider.watch(this.toFileSystemResource(a),y);return(0,L.toDisposable)(()=>{this.watchResources.delete(a),w.dispose()})}stat(a){return this.fileSystemProvider.stat(this.toFileSystemResource(a))}mkdir(a){return this.fileSystemProvider.mkdir(this.toFileSystemResource(a))}rename(a,y,w){return this.fileSystemProvider.rename(this.toFileSystemResource(a),this.toFileSystemResource(y),w)}readFile(a,y){return this.fileSystemProvider.readFile(this.toFileSystemResource(a),y)}readFileStream(a,y,w){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(a),y,w)}readdir(a){return this.fileSystemProvider.readdir(this.toFileSystemResource(a))}enforceAtomicReadFile(a){return this.atomicReadWriteResources.has(a)}writeFile(a,y,w){return this.fileSystemProvider.writeFile(this.toFileSystemResource(a),y,w)}enforceAtomicWriteFile(a){return this.atomicReadWriteResources.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.fileSystemProvider.delete(this.toFileSystemResource(a),y)}copy(a,y,w){if((0,C.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(a),this.toFileSystemResource(y),w);throw new Error("copy not supported")}cloneFile(a,y){if((0,C.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(a),this.toFileSystemResource(y));throw new Error("clone not supported")}handleFileChanges(a){const y=[];for(const w of a){if(w.resource.scheme!==this.fileSystemScheme)continue;const d=this.toUserDataResource(w.resource);this.watchResources.findSubstr(d)&&y.push({resource:d,type:w.type,cId:w.cId})}y.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(y))}toFileSystemResource(a){return a.with({scheme:this.fileSystemScheme})}toUserDataResource(a){return a.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(ne[159],se([0,1,111,16,48,17,11,10,15]),function(K,e,O,L,C,x,k,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=a,e.isEmptyWorkspaceIdentifier=y,e.toWorkspaceIdentifier=w,e.isWorkspaceIdentifier=d,e.reviveIdentifier=m,e.isWorkspace=D,e.isWorkspaceFolder=p,e.toWorkspaceFolder=v,e.isUntitledWorkspace=f,e.isTemporaryWorkspace=g,e.isStandaloneEditorWorkspace=i,e.isSavedWorkspace=s,e.hasWorkspaceFileExtension=t,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function a(n){const r=n;return typeof r?.id=="string"&&k.URI.isUri(r.uri)}function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const r=n;return typeof r?.id=="string"&&k.URI.isUri(r.configPath)}function m(n){const r=n;if(r?.uri)return{id:r.id,uri:k.URI.revive(r.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var S;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function D(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function p(n){const r=n;return!!(r&&typeof r=="object"&&k.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class l{constructor(r,o,c,b,R){this._id=r,this._transient=c,this._configuration=b,this._ignorePathCasing=R,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class E{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,x.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function v(n){return new E({uri:n,index:0,name:(0,x.basenameOrAuthority)(n)},{uri:n.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(n,r){return x.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}function g(n){let r;return k.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===u.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function s(n,r){return!f(n,r)&&!g(n)}function t(n){return(typeof n=="string"?(0,L.extname)(n):(0,x.extname)(n))===e.WORKSPACE_SUFFIX}}),define(ne[24],se([0,1,43,5,2,17,11,110,18,13,10,6,159,31,23,9,28,30,3]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=f,e.reviveProfile=g,e.toUserDataProfile=i;var v;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function f(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&k.URI.isUri(r.location)&&k.URI.isUri(r.globalStorageHome)&&k.URI.isUri(r.settingsResource)&&k.URI.isUri(r.keybindingsResource)&&k.URI.isUri(r.tasksResource)&&k.URI.isUri(r.snippetsHome)&&k.URI.isUri(r.extensionsResource))}e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function g(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:k.URI.revive(n.location).with({scheme:r}),globalStorageHome:k.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:k.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:k.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:k.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:k.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:k.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:k.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,r,o,c,b,R){return{id:n,name:r,location:o,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:R&&b?.useDefaultFlags?.globalState?R.globalStorageHome:(0,x.joinPath)(o,"globalStorage"),settingsResource:R&&b?.useDefaultFlags?.settings?R.settingsResource:(0,x.joinPath)(o,"settings.json"),keybindingsResource:R&&b?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,x.joinPath)(o,"keybindings.json"),tasksResource:R&&b?.useDefaultFlags?.tasks?R.tasksResource:(0,x.joinPath)(o,"tasks.json"),snippetsHome:R&&b?.useDefaultFlags?.snippets?R.snippetsHome:(0,x.joinPath)(o,"snippets"),extensionsResource:R&&b?.useDefaultFlags?.extensions?R.extensionsResource:(0,x.joinPath)(o,"extensions.json"),cacheHome:(0,x.joinPath)(c,n),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let s=class extends C.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,c,b){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=c,this.logService=b,this.enabled=!0,this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new L.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new L.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new L.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,x.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,x.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.createDefaultProfile(),o=[r];if(this.enabled)try{for(const R of this.getStoredProfiles()){if(!R.name||!(0,E.isString)(R.name)||!R.location){this.logService.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(i((0,x.basename)(R.location),R.name,R.location,this.profilesCacheHome,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},r))}}catch(R){this.logService.error(R)}const c=new m.ResourceMap,b=new Map;if(o.length)try{const R=this.getStoredProfileAssociations();if(R.workspaces)for(const[T,N]of Object.entries(R.workspaces)){const F=k.URI.parse(T),z=o.find(H=>H.id===N);z&&c.set(F,z)}if(R.emptyWindows)for(const[T,N]of Object.entries(R.emptyWindows)){const F=o.find(z=>z.id===N);F&&b.set(T,F)}}catch(R){this.logService.error(R)}this._profilesObject={profiles:o,workspaces:c,emptyWindows:b}}return this._profilesObject}createDefaultProfile(){const r=i("__default__profile__",(0,I.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...r,extensionsResource:this.getDefaultProfileExtensionsLocation()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let b=0;for(const T of this.profiles){const N=c.exec(T.name),F=N?parseInt(N[1]):0;b=F>b?F:b}const R=`${o} ${b+1}`;return this.createProfile((0,O.hash)((0,p.generateUuid)()).toString(16),R,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,O.hash)((0,p.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,b){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const R=await this.doCreateProfile(r,o,c);return b&&await this.setProfileForWorkspace(b,R),R}async doCreateProfile(r,o,c){if(!(0,E.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.profileCreationPromises.get(o);return b||(b=(async()=>{try{const R=this.profiles.find(F=>F.name===o||F.id===r);if(R)return R;const T=i(r,o,(0,x.joinPath)(this.profilesHome,r),this.profilesCacheHome,c,this.defaultProfile);await this.fileService.createFolder(T.location);const N=[];return this._onWillCreateProfile.fire({profile:T,join(F){N.push(F)}}),await D.Promises.settled(N),this.updateProfiles([T],[],[]),T}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,b)),b}async updateProfile(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(b=>b.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=i(c.id,o.name??c.name,c.location,this.profilesCacheHome,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(b=>b.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(b){c.push(b)}});try{await Promise.allSettled(c)}catch(b){this.logService.error(b)}for(const b of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(b)?.id&&this.profilesObject.emptyWindows.delete(b);for(const b of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(b)?.id&&this.profilesObject.workspaces.delete(b);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(b){(0,a.toFileOperationResult)(b)!==1&&this.logService.error(b)}}async setProfileForWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(b=>b.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return k.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(r){return(0,d.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,d.isWorkspaceIdentifier)(r)?r.configPath:r.id}isProfileAssociatedToWorkspace(r){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,c){const b=[...this.profiles,...r],R=[];this.transientProfilesObject.profiles=[];for(let T of b)T.isDefault||o.some(N=>T.id===N.id)||(T=c.find(N=>T.id===N.id)??T,T.isTransient?this.transientProfilesObject.profiles.push(T):R.push({location:T.location,name:T.name,shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags}));this.saveStoredProfiles(R),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,c)}triggerProfilesChanges(r,o,c){this._onDidChangeProfiles.fire({added:r,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const b=this.getWorkspace(r),R=c?this.transientProfilesObject:this.profilesObject;k.URI.isUri(b)?(R.workspaces.delete(b),o&&R.workspaces.set(b,o)):(R.emptyWindows.delete(b),o&&R.emptyWindows.set(b,o)),c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,b]of this.profilesObject.workspaces.entries())r[c.toString()]=b.id;const o={};for(const[c,b]of this.profilesObject.emptyWindows.entries())o[c.toString()]=b.id;this.saveStoredProfileAssociations({workspaces:r,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(r){const o={},c=this.createDefaultProfile();if(r.workspaces)for(const[R,T]of Object.entries(r.workspaces)){const N=k.URI.parse(T);o[R]=this.uriIdentityService.extUri.isEqual(N,c.location)?c.id:this.uriIdentityService.extUri.basename(N)}const b={};if(r.emptyWindows)for(const[R,T]of Object.entries(r.emptyWindows)){const N=k.URI.parse(T);b[R]=this.uriIdentityService.extUri.isEqual(N,c.location)?c.id:this.uriIdentityService.extUri.basename(N)}return{workspaces:o,emptyWindows:b}}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=s,e.UserDataProfilesService=s=ve([oe(0,u.IEnvironmentService),oe(1,a.IFileService),oe(2,S.IUriIdentityService),oe(3,w.ILogService)],s);class t extends s{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=t}),define(ne[160],se([0,1,19,9,20,8,5,2,12,3,11,94,21,26,37,6,32,22,23,24]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.joinErrors=g,e.toExtensionManagementError=i;let f=class extends I.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(r,o,c,b,R,T){super(),this.galleryService=r,this.telemetryService=o,this.uriIdentityService=c,this.logService=b,this.productService=R,this.userDataProfilesService=T,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:N})=>N.cancel()),this.uninstallingExtensions.forEach(N=>N.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(c=>(0,d.isTargetPlatformCompatible)(c,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{const b=(await this.installGalleryExtensions([{extension:r,options:o}])).find(({identifier:R})=>(0,m.areSameExtensions)(R,r.identifier));if(b?.local)return b?.local;throw b?.error?b.error:new d.ExtensionManagementError(`Unknown error while installing extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(c){throw i(c)}}async installGalleryExtensions(r){if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(w.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],c=[];await Promise.allSettled(r.map(async({extension:b,options:R})=>{try{const T=await this.checkAndGetCompatibleVersion(b,!!R?.installGivenVersion,!!R?.installPreReleaseVersion,R.productVersion??{version:this.productService.version,date:this.productService.date});c.push({...T,options:R})}catch(T){o.push({identifier:b.identifier,operation:2,source:b,error:T})}})),c.length&&o.push(...await this.installExtensions(c));for(const b of o)b.error&&(this.logService.error("Failed to install extension.",b.identifier.id),this.logService.error(b.error),b.source&&!y.URI.isUri(b.source)&&s(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(b.source),error:b.error}));return o}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.uninstallExtension(r,o)}async toggleAppliationScope(r,o){if((0,S.isApplicationScopedExtension)(r.manifest)||r.isBuiltin)return r;if(r.isApplicationScoped){let c=await this.updateMetadata(r,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)||(c=await this.copyExtension(r,this.userDataProfilesService.defaultProfile.extensionsResource,o));for(const b of this.userDataProfilesService.profiles){const R=(await this.getInstalled(1,b.extensionsResource)).find(T=>(0,m.areSameExtensions)(T.identifier,r.identifier));R?this._onDidUpdateExtensionMetadata.fire(R):this._onDidUninstallExtension.fire({identifier:r.identifier,profileLocation:b.extensionsResource})}return c}else{const c=this.uriIdentityService.extUri.isEqual(o,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(r,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(r,o,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtensions(r){const o=[],c=new Map,b=[],R=[],T=(F,z)=>`${m.ExtensionKey.create(F).toString()}-${z.toString()}`,N=(F,z,H)=>{const re=this.createInstallExtensionTask(F,z,H),ie=y.URI.isUri(z)?z.path:`${z.identifier.id.toLowerCase()}-${H.profileLocation.toString()}`;c.set(ie,{task:re,manifest:F}),this._onInstallExtension.fire({identifier:re.identifier,source:z,profileLocation:H.profileLocation}),this.logService.info("Installing extension:",re.identifier.id),y.URI.isUri(z)||this.installingExtensions.set(T(z,H.profileLocation),{task:re,waitingTasks:[]})};try{for(const{manifest:F,extension:z,options:H}of r){const re=H.isApplicationScoped||H.isBuiltin||(0,S.isApplicationScopedExtension)(F),ie={...H,installOnlyNewlyAddedFromExtensionPack:H.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(z),isApplicationScoped:re,profileLocation:re?this.userDataProfilesService.defaultProfile.extensionsResource:H.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:H.productVersion??{version:this.productService.version,date:this.productService.date}},ue=y.URI.isUri(z)?void 0:this.installingExtensions.get(T(z,ie.profileLocation));ue?(this.logService.info("Extension is already requested to install",ue.task.identifier.id),b.push(ue.task.waitUntilTaskIsFinished())):N(F,z,ie)}await Promise.all([...c.values()].map(async({task:F,manifest:z})=>{if(F.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const H=await this.getAllDepsAndPackExtensions(F.identifier,z,!!F.options.installOnlyNewlyAddedFromExtensionPack,!!F.options.installPreReleaseVersion,F.options.profileLocation,F.options.productVersion),re=await this.getInstalled(void 0,F.options.profileLocation,F.options.productVersion),ie={...F.options,donotIncludePackAndDependencies:!0,context:{...F.options.context,[d.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:ue,manifest:fe}of(0,O.distinct)(H,({gallery:le})=>le.identifier.id)){if(c.has(`${ue.identifier.id.toLowerCase()}-${ie.profileLocation.toString()}`))continue;const le=this.installingExtensions.get(T(ue,ie.profileLocation));if(le){if(this.canWaitForTask(F,le.task)){const j=le.task.identifier;this.logService.info("Waiting for already requested installing extension",j.id,F.identifier.id),le.waitingTasks.push(F),b.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,X=>X.some(W=>(0,m.areSameExtensions)(W.identifier,j)))).then(X=>{if(this.logService.info("Finished waiting for already requested installing extension",j.id,F.identifier.id),!X.find(V=>(0,m.areSameExtensions)(V.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else re.some(({identifier:j})=>(0,m.areSameExtensions)(j,ue.identifier))||N(fe,ue,ie)}}catch(H){if(y.URI.isUri(F.source))(0,O.isNonEmptyArray)(z.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",F.identifier.id,H.message),(0,O.isNonEmptyArray)(z.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",F.identifier.id,H.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),H}})),await this.joinAllSettled([...c.values()].map(async({task:F})=>{const z=new Date().getTime();try{const H=await F.run();if(await this.joinAllSettled(this.participants.map(re=>re.postInstall(H,F.source,F.options,C.CancellationToken.None))),!y.URI.isUri(F.source)){const re=F.operation===3,ie=re?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(s(this.telemetryService,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(F.source),verificationStatus:F.verificationStatus,duration:new Date().getTime()-z,durationSinceUpdate:ie}),u.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(H.manifest.publisher,H.manifest.name,H.manifest.version,"install")}catch{}}R.push({local:H,identifier:F.identifier,operation:F.operation,source:F.source,context:F.options.context,profileLocation:F.profileLocation,applicationScoped:H.isApplicationScoped})}catch(H){throw this.logService.error("Error while installing the extension",F.identifier.id,(0,x.getErrorMessage)(H)),H}})),b.length&&await this.joinAllSettled(b);for(const F of R)this.logService.info("Extension installed successfully:",F.identifier.id),o.push(F);return o}catch(F){R.length&&(this.logService.info("Rollback: Uninstalling installed extensions",(0,x.getErrorMessage)(F)),await Promise.allSettled(R.map(async({local:z,profileLocation:H})=>{try{await this.createUninstallExtensionTask(z,{versionOnly:!0,profileLocation:H}).run(),this.logService.info("Rollback: Uninstalled extension",z.identifier.id)}catch(re){this.logService.warn("Rollback: Error while uninstalling extension",z.identifier.id,(0,x.getErrorMessage)(re))}})));for(const{task:z}of c.values())z.cancel(),o.push({identifier:z.identifier,operation:2,source:z.source,context:z.options.context,profileLocation:z.profileLocation,error:F});throw F}finally{for(const{task:F}of c.values())F.source&&!y.URI.isUri(F.source)&&this.installingExtensions.delete(T(F.source,F.profileLocation));o.length&&this._onDidInstallExtensions.fire(o)}}canWaitForTask(r,o){for(const[,{task:c,waitingTasks:b}]of this.installingExtensions.entries())if(c===r&&(b.includes(o)||b.some(R=>this.canWaitForTask(R,o)))||c===o&&b[0]&&!this.canWaitForTask(r,b[0]))return!1;return!0}async joinAllSettled(r){const o=[],c=[],b=await Promise.allSettled(r);for(const R of b)R.status==="fulfilled"?o.push(R.value):c.push(R.reason);if(c.length)throw g(c);return o}async getAllDepsAndPackExtensions(r,o,c,b,R,T){if(!this.galleryService.isEnabled())return[];const N=await this.getInstalled(void 0,R,T),F=[],z=[],H=async(re,ie)=>{F.push(re);const ue=ie.extensionDependencies||[],fe=[...ue];if(ie.extensionPack){const le=c?N.find(j=>(0,m.areSameExtensions)(j.identifier,re)):void 0;for(const j of ie.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(X=>(0,m.areSameExtensions)({id:X},{id:j}))||fe.every(X=>!(0,m.areSameExtensions)({id:X},{id:j}))&&fe.push(j)}if(fe.length){const le=fe.filter(j=>F.every(X=>!(0,m.areSameExtensions)(X,{id:j})));if(le.length){const j=await this.galleryService.getExtensions(le.map(X=>({id:X,preRelease:b})),C.CancellationToken.None);for(const X of j){if(F.find(q=>(0,m.areSameExtensions)(q,X.identifier)))continue;const W=ue.some(q=>(0,m.areSameExtensions)({id:q},X.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(X,!1,b,T)}catch(q){if(W)throw q;this.logService.info("Skipping the packed extension as it cannot be installed",X.identifier.id,(0,x.getErrorMessage)(q));continue}z.push({gallery:V.extension,manifest:V.manifest}),await H(V.extension.identifier,V.manifest)}}}};return await H(r,o),z}async checkAndGetCompatibleVersion(r,o,c,b){let R;const T=await this.getExtensionsControlManifest();if(T.malicious.some(z=>(0,m.areSameExtensions)(r.identifier,z)))throw new d.ExtensionManagementError(w.localize(1,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);const N=T.deprecated[r.identifier.id.toLowerCase()];if(N?.extension?.autoMigrate){if(this.logService.info(`The '${r.identifier.id}' extension is deprecated, fetching the compatible '${N.extension.id}' extension instead.`),R=(await this.galleryService.getExtensions([{id:N.extension.id,preRelease:N.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:b},C.CancellationToken.None))[0],!R)throw new d.ExtensionManagementError(w.localize(2,null,r.identifier.id,N.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(r)){const z=await this.getTargetPlatform();throw new d.ExtensionManagementError(w.localize(3,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(z)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.getCompatibleVersion(r,o,c,b),!R)throw!c&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],C.CancellationToken.None))[0]?new d.ExtensionManagementError(w.localize(4,null,r.displayName??r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(w.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",R.identifier.id);const F=await this.galleryService.getManifest(R,C.CancellationToken.None);if(F===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${R.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(F.version!==R.version)throw new d.ExtensionManagementError(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:F}}async getCompatibleVersion(r,o,c,b){const R=await this.getTargetPlatform();let T=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==c&&(T=(await this.galleryService.getExtensions([{...r.identifier,preRelease:c}],{targetPlatform:R,compatible:!0,productVersion:b},C.CancellationToken.None))[0]||null),!T&&await this.galleryService.isExtensionCompatible(r,c,R,b)&&(T=r),T||(o?T=(await this.galleryService.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:R,compatible:!0,productVersion:b},C.CancellationToken.None))[0]||null:T=await this.galleryService.getCompatibleExtension(r,c,R,b)),T}async uninstallExtension(r,o){const c={...o,profileLocation:r.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:o.profileLocation??this.getCurrentExtensionsManifestLocation()},b=H=>`${H.id.toLowerCase()}${c.versionOnly?`-${r.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,R=this.uninstallingExtensions.get(b(r.identifier));if(R)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),R.waitUntilTaskIsFinished();const T=H=>{const re=this.createUninstallExtensionTask(H,c);return this.uninstallingExtensions.set(b(re.extension.identifier),re),c.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,c.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${H.identifier.id}@${H.manifest.version}`),this._onUninstallExtension.fire({identifier:H.identifier,profileLocation:c.profileLocation,applicationScoped:H.isApplicationScoped}),re},N=(H,re)=>{re?c.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${H.identifier.id}@${H.manifest.version}`,c.profileLocation.toString(),re.message):this.logService.error("Failed to uninstall extension:",`${H.identifier.id}@${H.manifest.version}`,re.message):c.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${H.identifier.id}@${H.manifest.version}`,c.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${H.identifier.id}@${H.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(H),error:re}),this._onDidUninstallExtension.fire({identifier:H.identifier,error:re?.code,profileLocation:c.profileLocation,applicationScoped:H.isApplicationScoped})},F=[],z=[];try{F.push(T(r));const H=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${r.identifier.id}@${r.manifest.version}`);else{const re=this.getAllPackExtensionsToUninstall(r,H);for(const ie of re)this.uninstallingExtensions.has(b(ie.identifier))?this.logService.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(T(ie))}c.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${r.identifier.id}@${r.manifest.version}`):this.checkForDependents(F.map(re=>re.extension),H,r),await this.joinAllSettled(F.map(async re=>{try{if(await re.run(),await this.joinAllSettled(this.participants.map(ie=>ie.postUninstall(re.extension,c,C.CancellationToken.None))),re.extension.identifier.uuid)try{await this.galleryService.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}N(re.extension)}catch(ie){const ue=ie instanceof d.ExtensionManagementError?ie:new d.ExtensionManagementError((0,x.getErrorMessage)(ie),d.ExtensionManagementErrorCode.Internal);throw N(re.extension,ue),ue}finally{z.push(re)}}))}catch(H){const re=H instanceof d.ExtensionManagementError?H:new d.ExtensionManagementError((0,x.getErrorMessage)(H),d.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}z.includes(ie)||N(ie.extension,re)}throw re}finally{for(const H of F)this.uninstallingExtensions.delete(b(H.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",H.extension.identifier.id)}}checkForDependents(r,o,c){for(const b of r){const R=this.getDependents(b,o);if(R.length){const T=R.filter(N=>!r.some(F=>(0,m.areSameExtensions)(F.identifier,N.identifier)));if(T.length)throw new Error(this.getDependentsErrorMessage(b,T,c))}}}getDependentsErrorMessage(r,o,c){return c===r?o.length===1?w.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?w.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):w.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?w.localize(9,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?w.localize(10,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):w.localize(11,null,c.manifest.displayName||c.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,c=[]){if(c.indexOf(r)!==-1)return[];c.push(r);const b=r.manifest.extensionPack?r.manifest.extensionPack:[];if(b.length){const R=o.filter(N=>!N.isBuiltin&&b.some(F=>(0,m.areSameExtensions)({id:F},N.identifier))),T=[];for(const N of R)T.push(...this.getAllPackExtensionsToUninstall(N,o,c));return[...R,...T]}return[]}getDependents(r,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(b=>(0,m.areSameExtensions)({id:b},r.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(r){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,x.getErrorMessage)(r)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=f,e.AbstractExtensionManagementService=f=ve([oe(0,d.IExtensionGalleryService),oe(1,l.ITelemetryService),oe(2,E.IUriIdentityService),oe(3,D.ILogService),oe(4,p.IProductService),oe(5,v.IUserDataProfilesService)],f);function g(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}function i(n){if(n instanceof d.ExtensionManagementError)return n;if(n instanceof d.ExtensionGalleryError){const o=new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const r=new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function s(n,r,{extensionData:o,verificationStatus:c,duration:b,error:R,durationSinceUpdate:T}){let N,F;(0,a.isDefined)(c)&&(c===!0?c="Verified":(c===!1||(N=d.ExtensionManagementErrorCode.Signature,F=c),c="Unverified")),R&&(R instanceof d.ExtensionManagementError||R instanceof d.ExtensionGalleryError?(N=R.code,R.code===d.ExtensionManagementErrorCode.Signature&&(F=R.message)):N=d.ExtensionManagementErrorCode.Internal),n.publicLog(r,{...o,verificationStatus:c,success:!R,duration:b,errorcode:N,errorcodeDetail:F,durationSinceUpdate:T})}class t{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>new Promise((o,c)=>{const b=r.onCancellationRequested(()=>{b.dispose(),c(new x.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(ne[42],se([0,1,9,14,2,5,31,11,21,26,13,10,6,24,23,3,8,22]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var E;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(E||(e.ExtensionsProfileScanningErrorCode=E={}));class v extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let f=class extends C.Disposable{constructor(t,n,r,o,c,b){super(),this.extensionsLocation=t,this.fileService=n,this.userDataProfilesService=r,this.uriIdentityService=o,this.telemetryService=c,this.logService=b,this._onAddExtensions=this._register(new x.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new x.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new x.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new x.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(t,n){return this.withProfileExtensions(t,void 0,n)}async addExtensionsToProfile(t,n,r){const o=[],c=[];try{return await this.withProfileExtensions(n,b=>{const R=[];if(r)R.push(...b);else for(const T of b)t.some(([N])=>(0,a.areSameExtensions)(N.identifier,T.identifier)&&N.manifest.version!==T.version)?o.push(T):R.push(T);for(const[T,N]of t){const F=R.findIndex(H=>(0,a.areSameExtensions)(H.identifier,T.identifier)&&H.version===T.manifest.version),z={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:N};F===-1?(c.push(z),R.push(z)):R.splice(F,1,z)}return c.length&&this._onAddExtensions.fire({extensions:c,profileLocation:n}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:n}),R}),c.length&&this._onDidAddExtensions.fire({extensions:c,profileLocation:n}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:n}),c}catch(b){throw c.length&&this._onDidAddExtensions.fire({extensions:c,error:b,profileLocation:n}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:b,profileLocation:n}),b}}async updateMetadata(t,n){const r=[];return await this.withProfileExtensions(n,o=>{const c=[];for(const b of o){const R=t.find(([T])=>(0,a.areSameExtensions)(T.identifier,b.identifier)&&T.manifest.version===b.version);R&&(b.metadata={...b.metadata,...R[1]},r.push(b)),c.push(b)}return c}),r}async removeExtensionFromProfile(t,n){const r=[];try{await this.withProfileExtensions(n,o=>{const c=[];for(const b of o)(0,a.areSameExtensions)(b.identifier,t.identifier)?r.push(b):c.push(b);return r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:n}),c}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:n})}catch(o){throw r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:o,profileLocation:n}),o}}async withProfileExtensions(t,n,r){return this.getResourceAccessQueue(t).queue(async()=>{let o=[],c;try{const b=await this.fileService.readFile(t);c=JSON.parse(b.value.toString().trim()||"[]")}catch(b){if((0,y.toFileOperationResult)(b)!==1)throw b;if(this.uriIdentityService.extUri.isEqual(t,this.userDataProfilesService.defaultProfile.extensionsResource)&&(c=await this.migrateFromOldDefaultProfileExtensionsLocation()),!c&&r?.bailOutWhenFileNotFound)throw new v((0,p.getErrorMessage)(b),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.reportAndThrowInvalidConentError(t);let b=!1;for(const R of c){g(R)||this.reportAndThrowInvalidConentError(t);let T;if((0,D.isString)(R.relativeLocation)&&R.relativeLocation)T=this.resolveExtensionLocation(R.relativeLocation);else if((0,D.isString)(R.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{T=I.URI.revive(R.location);const N=this.toRelativePath(T);N&&(b=!0,R.relativeLocation=N)}(0,D.isUndefined)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(b=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:T,version:R.version,metadata:R.metadata})}b&&await this.fileService.writeFile(t,L.VSBuffer.fromString(JSON.stringify(c)))}if(n){o=n(o);const b=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.toRelativePath(R.location),metadata:R.metadata}));await this.fileService.writeFile(t,L.VSBuffer.fromString(JSON.stringify(b)))}return o})}reportAndThrowInvalidConentError(t){const n=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}toRelativePath(t){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(t),this.extensionsLocation)?this.uriIdentityService.extUri.basename(t):void 0}resolveExtensionLocation(t){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,t)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const t=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),n=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let r;try{r=(await this.fileService.readFile(t)).value.toString()}catch(c){if((0,y.toFileOperationResult)(c)===1)return;throw c}this.logService.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(r);Array.isArray(c)&&c.every(b=>g(b))?o=c:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.logService.error(c)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(c){if((0,y.toFileOperationResult)(c)===3)this.logService.info("Migration from old default profile location to new location is done by another window",t.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw c}try{await this.fileService.del(t)}catch(c){(0,y.toFileOperationResult)(c)!==1&&this.logService.error(c)}try{await this.fileService.del(n)}catch(c){(0,y.toFileOperationResult)(c)!==1&&this.logService.error(c)}return o})()),this._migrationPromise}getResourceAccessQueue(t){let n=this.resourcesAccessQueueMap.get(t);return n||(n=new O.Queue,this.resourcesAccessQueueMap.set(t,n)),n}};e.AbstractExtensionsProfileScannerService=f,e.AbstractExtensionsProfileScannerService=f=ve([oe(1,y.IFileService),oe(2,m.IUserDataProfilesService),oe(3,S.IUriIdentityService),oe(4,l.ITelemetryService),oe(5,d.ILogService)],f);function g(s){return(0,D.isObject)(s)&&(0,u.isIExtensionIdentifier)(s.identifier)&&(i(s.location)||(0,D.isString)(s.location)&&s.location)&&((0,D.isUndefined)(s.relativeLocation)||(0,D.isString)(s.relativeLocation))&&s.version&&(0,D.isString)(s.version)}function i(s){return s?(0,D.isString)(s.path)&&(0,D.isString)(s.scheme):!1}}),define(ne[53],se([0,1,19,9,27,14,8,38,82,2,15,16,12,17,44,55,3,11,98,18,26,37,50,13,10,6,32,5,47,42,24,23,116]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v,f,g,i,s,t,n,r,o,c,b,R,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=ue;var F;(function(le){function j(X,W){if(X===W)return!0;const V=Object.keys(X),q=new Set;for(const Y of Object.keys(W))q.add(Y);if(V.length!==q.size)return!1;for(const Y of V){if(X[Y]!==W[Y])return!1;q.delete(Y)}return q.size===0}le.equals=j})(F||(e.Translations=F={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let z=class extends a.Disposable{constructor(j,X,W,V,q,Y,J,Z,M,_,h,P){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=X,this.extensionsControlLocation=W,this.currentProfile=V,this.userDataProfilesService=q,this.extensionsProfileScannerService=Y,this.fileService=J,this.logService=Z,this.environmentService=M,this.productService=_,this.uriIdentityService=h,this.instantiationService=P,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ie,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(re,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,X,W){const[V,q]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(X)]),Y=W?await this.scanExtensionsUnderDevelopment(j,[...V,...q]):[];return this.dedupExtensions(V,q,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const X=[];X.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),X.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[W,V]=await Promise.all(X);return this.applyScanOptions([...W,...V],0,j,!1)}async scanUserExtensions(j){const X=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",X);const W=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.createExtensionScannerInput(X,!!j.profileLocation,1,!j.includeUninstalled,j.language,!0,W,j.productVersion??this.getProductVersion()),q=j.useCache&&!V.devMode&&V.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let Y;try{Y=await q.scanExtensions(V)}catch(J){if(J instanceof b.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),Y=await q.scanExtensions(V);else throw J}return Y=await this.applyScanOptions(Y,1,j,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(j,X){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const W=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(V=>V.scheme===y.Schemas.file).map(async V=>{const q=await this.createExtensionScannerInput(V,!1,1,!0,j.language,!1,void 0,j.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(q)).map(J=>(J.type=X.find(Z=>(0,f.areSameExtensions)(Z.identifier,J.identifier))?.type??J.type,this.extensionsScanner.validate(J,q)))}))).flat();return this.applyScanOptions(W,"development",j,!0)}return[]}async scanExistingExtension(j,X,W){const V=await this.createExtensionScannerInput(j,!1,X,!0,W.language,!0,void 0,W.productVersion??this.getProductVersion()),q=await this.extensionsScanner.scanExtension(V);return!q||!W.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(j,X,W){const V=await this.createExtensionScannerInput(j,!1,X,!0,W.language,!0,void 0,W.productVersion??this.getProductVersion()),q=await this.extensionsScanner.scanOneOrMultipleExtensions(V);return this.applyScanOptions(q,X,W,!0)}async scanMultipleExtensions(j,X,W){const V=[];return await Promise.all(j.map(async q=>{const Y=await this.scanOneOrMultipleExtensions(q,X,W);V.push(...Y)})),this.applyScanOptions(V,X,W,!0)}async scanMetadata(j){const X=(0,m.joinPath)(j,"package.json"),W=(await this.fileService.readFile(X)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(j,X){const W=(0,m.joinPath)(j,"package.json"),V=(await this.fileService.readFile(W)).value.toString(),q=JSON.parse(V);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,q.__metadata={...q.__metadata,...X},await this.fileService.writeFile((0,m.joinPath)(j,"package.json"),x.VSBuffer.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof b.ExtensionsProfileScanningError&&j.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(X=>[X,X.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,x.VSBuffer.fromString(JSON.stringify([])))}catch(X){(0,s.toFileOperationResult)(X)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(X))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,X,W,V){return W.includeAllVersions||(j=this.dedupExtensions(X===0?j:void 0,X===1?j:void 0,X==="development"?j:void 0,await this.getTargetPlatform(),V)),W.includeInvalid||(j=j.filter(q=>q.isValid)),j.sort((q,Y)=>{const J=w.basename(q.location.fsPath),Z=w.basename(Y.location.fsPath);return J<Z?-1:J>Z?1:0})}dedupExtensions(j,X,W,V,q){const Y=(Z,M,_)=>{if(Z.isValid&&!M.isValid)return!1;if(Z.isValid===M.isValid){if(q&&S.gt(Z.manifest.version,M.manifest.version))return this.logService.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${Z.location.path} with version ${Z.manifest.version}`),!1;if(S.eq(Z.manifest.version,M.manifest.version)){if(Z.type===0)return this.logService.debug(`Skipping extension ${M.location.path} in favour of system extension ${Z.location.path} with same version`),!1;if(Z.targetPlatform===V)return this.logService.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return _?this.logService.warn(`Overwriting user extension ${Z.location.path} with ${M.location.path}.`):this.logService.debug(`Overwriting user extension ${Z.location.path} with ${M.location.path}.`),!0},J=new g.ExtensionIdentifierMap;return j?.forEach(Z=>{const M=J.get(Z.identifier.id);(!M||Y(M,Z,!1))&&J.set(Z.identifier.id,Z)}),X?.forEach(Z=>{const M=J.get(Z.identifier.id);if(!M&&j&&Z.type===0){this.logService.debug(`Skipping obsolete system extension ${Z.location.path}.`);return}(!M||Y(M,Z,!1))&&J.set(Z.identifier.id,Z)}),W?.forEach(Z=>{const M=J.get(Z.identifier.id);(!M||Y(M,Z,!0))&&J.set(Z.identifier.id,Z),J.set(Z.identifier.id,Z)}),[...J.values()]}async scanDefaultSystemExtensions(j,X){this.logService.trace("Started scanning system extensions");const W=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0,this.getProductVersion()),q=await(j&&!W.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return this.logService.trace("Scanned system extensions:",q.length),q}async scanDevSystemExtensions(j,X){const W=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!W?.length)return[];this.logService.trace("Started scanning dev system extensions");const V=X?await this.getBuiltInExtensionControl():{},q=[],Y=l.URI.file(w.normalize(w.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Z of W){const M=V[Z.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":q.push((0,m.joinPath)(Y,Z.name));break;default:q.push(l.URI.file(M));break}}const J=await Promise.all(q.map(async Z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(Z,!1,0,!0,j,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",J.length),(0,O.coalesce)(J)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,X,W,V,q,Y,J,Z){const M=await this.getTranslations(q??d.language),_=await this.getMtime(j),h=X&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,P=h?await this.getMtime(h):void 0;return new H(j,_,h,P,X,J,W,V,Y,Z.version,Z.date,this.productService.commit,!this.environmentService.isBuilt,q,M)}async getMtime(j){try{const X=await this.fileService.stat(j);if(typeof X.mtime=="number")return X.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=z,e.AbstractExtensionsScannerService=z=ve([oe(4,R.IUserDataProfilesService),oe(5,b.IExtensionsProfileScannerService),oe(6,s.IFileService),oe(7,n.ILogService),oe(8,v.IEnvironmentService),oe(9,r.IProductService),oe(10,T.IUriIdentityService),oe(11,t.IInstantiationService)],z);class H{constructor(j,X,W,V,q,Y,J,Z,M,_,h,P,A,U,G){this.location=j,this.mtime=X,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=V,this.profile=q,this.profileScanOptions=Y,this.type=J,this.excludeObsolete=Z,this.validate=M,this.productVersion=_,this.productDate=h,this.productCommit=P,this.devMode=A,this.language=U,this.translations=G}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,X){return(0,m.isEqual)(j.location,X.location)&&j.mtime===X.mtime&&(0,m.isEqual)(j.applicationExtensionslocation,X.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&j.profile===X.profile&&C.equals(j.profileScanOptions,X.profileScanOptions)&&j.type===X.type&&j.excludeObsolete===X.excludeObsolete&&j.validate===X.validate&&j.productVersion===X.productVersion&&j.productDate===X.productDate&&j.productCommit===X.productCommit&&j.devMode===X.devMode&&j.language===X.language&&F.equals(j.translations,X.translations)}}e.ExtensionScannerInput=H;let re=class extends a.Disposable{constructor(j,X,W,V,q){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=X,this.uriIdentityService=W,this.fileService=V,this.logService=q}async scanExtensions(j){const X=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let W={};if(j.excludeObsolete&&j.type===1)try{const V=(await this.fileService.readFile(this.obsoleteFile)).value.toString();W=JSON.parse(V)}catch{}return(0,p.isEmptyObject)(W)?X:X.filter(V=>!W[f.ExtensionKey.create(V).toString()])}async scanExtensionsFromLocation(j){const X=await this.fileService.resolve(j.location);if(!X.children?.length)return[];const W=await Promise.all(X.children.map(async V=>{if(!V.isDirectory||j.type===1&&(0,m.basename)(V.resource).indexOf(".")===0)return null;const q=new H(V.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(q)}));return(0,O.coalesce)(W).sort((V,q)=>V.location.path<q.location.path?-1:1)}async scanExtensionsFromProfile(j){let X=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){X=X.filter(V=>!V.metadata?.isApplicationScoped);const W=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,j);X.push(...W)}return X}async scanExtensionsFromProfileResource(j,X,W){const V=await this.extensionsProfileScannerService.scanProfileExtensions(j,W.profileScanOptions);if(!V.length)return[];const q=await Promise.all(V.map(async Y=>{if(X(Y)){const J=new H(Y.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(J,Y.metadata)}return null}));return(0,O.coalesce)(q)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,m.joinPath)(j.location,"package.json"))){const X=await this.scanExtension(j);return X?[X]:[]}else return await this.scanExtensions(j)}catch(X){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,k.getErrorMessage)(X)),[]}}async scanExtension(j,X){try{let W=await this.scanExtensionManifest(j.location);if(W){W.publisher||(W.publisher=g.UNDEFINED_PUBLISHER),X=X??W.__metadata,delete W.__metadata;const V=(0,f.getGalleryExtensionId)(W.publisher,W.name),q=X?.id?{id:V,uuid:X.id}:{id:V},Y=X?.isSystem?0:j.type,J=Y===0||!!X?.isBuiltin;W=await this.translateManifest(j.location,W,H.createNlsConfiguration(j));const Z={type:Y,identifier:q,manifest:W,location:j.location,isBuiltin:J,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return j.validate?this.validate(Z,j):Z}}catch(W){j.type!==0&&this.logService.error(W)}return null}validate(j,X){let W=!0;const V=(0,i.validateExtensionManifest)(X.productVersion,X.productDate,X.location,j.manifest,j.isBuiltin);for(const[q,Y]of V)q===D.default.Error&&(W=!1,this.logService.error(this.formatMessage(X.location,Y)));return j.isValid=W,j.validations=V,j}async scanExtensionManifest(j){const X=(0,m.joinPath)(j,"package.json");let W;try{W=(await this.fileService.readFile(X)).value.toString()}catch(q){return(0,s.toFileOperationResult)(q)!==1&&this.logService.error(this.formatMessage(j,(0,E.localize)(0,null,X.path,q.message))),null}let V;try{V=JSON.parse(W)}catch{const Y=[];(0,I.parse)(W,Y);for(const J of Y)this.logService.error(this.formatMessage(j,(0,E.localize)(1,null,X.path,J.offset,J.length,(0,u.getParseErrorMessage)(J.error))));return null}return(0,I.getNodeType)(V)!=="object"?(this.logService.error(this.formatMessage(j,(0,E.localize)(2,null,X.path))),null):V}async translateManifest(j,X,W){const V=await this.getLocalizedMessages(j,X,W);if(V)try{const q=[],Y=await this.resolveOriginalMessageBundle(V.default,q);if(q.length>0)return q.forEach(Z=>{this.logService.error(this.formatMessage(j,(0,E.localize)(3,null,V.default?.path,(0,u.getParseErrorMessage)(Z.error))))}),X;if((0,I.getNodeType)(V)!=="object")return this.logService.error(this.formatMessage(j,(0,E.localize)(4,null,V.default?.path))),X;const J=V.values||Object.create(null);return(0,N.localizeManifest)(this.logService,X,J,Y)}catch{}return X}async getLocalizedMessages(j,X,W){const V=(0,m.joinPath)(j,"package.nls.json"),q=(M,_)=>{_.forEach(h=>{this.logService.error(this.formatMessage(j,(0,E.localize)(5,null,M?.path,(0,u.getParseErrorMessage)(h.error))))})},Y=M=>{this.logService.error(this.formatMessage(j,(0,E.localize)(6,null,M?.path)))},J=`${X.publisher}.${X.name}`,Z=W.translations[J];if(Z)try{const M=l.URI.file(Z),_=(await this.fileService.readFile(M)).value.toString(),h=[],P=(0,I.parse)(_,h);return h.length>0?(q(M,h),{values:void 0,default:V}):(0,I.getNodeType)(P)!=="object"?(Y(M),{values:void 0,default:V}):{values:P.contents?P.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.fileService.exists(V))return;let _;try{_=await this.findMessageBundles(j,W)}catch{return}if(!_.localized)return{values:void 0,default:_.original};try{const h=(await this.fileService.readFile(_.localized)).value.toString(),P=[],A=(0,I.parse)(h,P);return P.length>0?(q(_.localized,P),{values:void 0,default:_.original}):(0,I.getNodeType)(A)!=="object"?(Y(_.localized),{values:void 0,default:_.original}):{values:A,default:_.original}}catch{return{values:void 0,default:_.original}}}}async resolveOriginalMessageBundle(j,X){if(j)try{const W=(await this.fileService.readFile(j)).value.toString();return(0,I.parse)(W,X)}catch{}}findMessageBundles(j,X){return new Promise((W,V)=>{const q=Y=>{const J=(0,m.joinPath)(j,`package.nls.${Y}.json`);this.fileService.exists(J).then(Z=>{Z&&W({localized:J,original:(0,m.joinPath)(j,"package.nls.json")});const M=Y.lastIndexOf("-");M===-1?W({localized:(0,m.joinPath)(j,"package.nls.json"),original:null}):(Y=Y.substring(0,M),q(Y))})};if(X.devMode||X.pseudo||!X.language)return W({localized:(0,m.joinPath)(j,"package.nls.json"),original:null});q(X.language)})}formatMessage(j,X){return`[${j.path}]: ${X}`}};re=ve([oe(1,b.IExtensionsProfileScannerService),oe(2,T.IUriIdentityService),oe(3,s.IFileService),oe(4,n.ILogService)],re);let ie=class extends re{constructor(j,X,W,V,q,Y,J){super(X,V,q,Y,J),this.currentProfile=j,this.userDataProfilesService=W,this.cacheValidatorThrottler=this._register(new L.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const X=this.getCacheFile(j),W=await this.readExtensionCache(X);if(this.input=j,W&&W.input&&H.equals(W.input,this.input))return this.logService.debug("Using cached extensions scan result",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(q=>(q.location=l.URI.revive(q.location),q));const V=await super.scanExtensions(j);return await this.writeExtensionCache(X,{input:j,result:V}),V}async readExtensionCache(j){try{const X=await this.fileService.readFile(j),W=JSON.parse(X.value.toString());return{result:W.result,input:(0,c.revive)(W.input)}}catch(X){this.logService.debug("Error while reading the extension cache file:",j.path,(0,k.getErrorMessage)(X))}return null}async writeExtensionCache(j,X){try{await this.fileService.writeFile(j,x.VSBuffer.fromString(JSON.stringify(X)))}catch(W){this.logService.debug("Error while writing the extension cache file:",j.path,(0,k.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),X=await this.readExtensionCache(j);if(!X)return;const W=X.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!C.equals(V,W))try{this.logService.info("Invalidating Cache",W,V),await this.fileService.del(j),this._onDidChangeCache.fire()}catch(q){this.logService.error(q)}}getCacheFile(j){const X=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(X.cacheHome,j.type===0?g.BUILTIN_MANIFEST_CACHE_FILE:g.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===0?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(X=>this.uriIdentityService.extUri.isEqual(j.location,X.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};ie=ve([oe(2,R.IUserDataProfilesService),oe(3,b.IExtensionsProfileScannerService),oe(4,T.IUriIdentityService),oe(5,s.IFileService),oe(6,n.ILogService)],ie);function ue(le,j){const X=(0,f.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:X,identifier:new g.ExtensionIdentifier(X),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:j,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}class fe extends z{constructor(j,X,W,V,q,Y,J,Z,M,_,h,P){super(j,X,(0,m.joinPath)(W,".vscode-oss-dev","extensions","control.json"),V,q,Y,J,Z,M,_,h,P),this.translationsPromise=(async()=>{if(d.translationsConfigFile)try{const A=await this.fileService.readFile(l.URI.file(d.translationsConfigFile));return JSON.parse(A.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=fe}),define(ne[161],se([0,1,59,9,34,5,2,15,16,25,6,24]),function(K,e,O,L,C,x,k,I,u,a,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(S,D){super(),this.userDataProfilesService=S,this.logService=D,this.processesLimiter=new L.Limiter(5)}async postUninstall(S){const D=this.parseScript(S,"uninstall");D&&(this.logService.info(S.identifier.id,S.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(D.script,"uninstall",D.args,!0,S),this.logService.info("Finished running post uninstall script",S.identifier.id,S.manifest.version)}catch(p){this.logService.error("Failed to run post uninstall script",S.identifier.id,S.manifest.version),this.logService.error(p)}}));try{await a.Promises.rm(this.getExtensionStoragePath(S))}catch(p){this.logService.error("Error while removing extension storage path",S.identifier.id),this.logService.error(p)}}parseScript(S,D){const p=`vscode:${D}`;if(S.location.scheme===I.Schemas.file&&S.manifest&&S.manifest.scripts&&typeof S.manifest.scripts[p]=="string"){const l=S.manifest.scripts[p].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(S.identifier.id,S.manifest.version,`${p} should be a node script`),null):{script:(0,u.join)(S.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(S,D,p,l,E){return new Promise((v,f)=>{const g=this.start(S,D,p,E);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?f(t):v(void 0)};g.on("error",t=>{s((0,C.toErrorMessage)(t)||"Unknown")}),g.on("exit",(t,n)=>{s(t?`post-${D} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,g.kill(),f("timed out")},5e3))})}start(S,D,p,l){const E={silent:!0,execArgv:void 0},v=(0,O.fork)(S,[`--type=extension-post-${D}`,...p],E);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const f=x.Event.fromNodeEventEmitter(v.stdout,"data"),g=x.Event.fromNodeEventEmitter(v.stderr,"data");f(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${D}`,t)),g(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${D}`,t));const i=x.Event.any(x.Event.map(f,t=>({data:`%c${t}`,format:[""]})),x.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return x.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}getExtensionStoragePath(S){return(0,u.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,S.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=d,e.ExtensionsLifecycle=d=ve([oe(0,w.IUserDataProfilesService),oe(1,y.ILogService)],d)}),define(ne[162],se([0,1,9,14,20,34,8,5,43,2,31,15,16,17,44,3,11,28,25,49,99,61,18,160,21,26,42,53,147,161,117,140,148,50,13,10,6,32,22,23,24]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v,f,g,i,s,t,n,r,o,c,b,R,T,N,F,z,H,re,ie,ue,fe,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,H.refineServiceDecorator)(t.IExtensionManagementService);const j=".vsctmp";let X=class extends s.AbstractExtensionManagementService{constructor(M,_,h,P,A,U,G,B,te,ae,ce,me){super(M,_,ce,h,ae,me),this.extensionsScannerService=A,this.extensionsProfileScannerService=U,this.downloadService=G,this.fileService=te,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new y.ResourceSet;const ye=this._register(B.createInstance(b.ExtensionsLifecycle));this.extensionsScanner=this._register(B.createInstance(W,pe=>ye.postUninstall(pe))),this.manifestCache=this._register(new T.ExtensionsManifestCache(me,te,ce,this,this.logService)),this.extensionsDownloader=this._register(B.createInstance(c.ExtensionsDownloader));const he=this._register(new N.ExtensionsWatcher(this,this.extensionsScannerService,me,U,ce,te,h));this._register(he.onDidChangeExtensionsByAnotherSource(pe=>this.onDidChangeExtensionsFromAnotherSource(pe))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,n.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const _=await this.collectFiles(M),h=await(0,v.zip)((0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)()).fsPath,_);return p.URI.file(h)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:_,cleanup:h}=await this.downloadVsix(M),P=d.resolve(_.fsPath);try{return await(0,R.getManifest)(P)}finally{await h()}}getInstalled(M,_=this.userDataProfilesService.defaultProfile.extensionsResource,h={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(M??null,_,h)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.extensionsScanner.scanUserExtensionAtLocation(M)}async install(M,_={}){this.logService.trace("ExtensionManagementService#install",M.toString());const{location:h,cleanup:P}=await this.downloadVsix(M);try{const A=await(0,R.getManifest)(d.resolve(h.fsPath)),U=(0,n.getGalleryExtensionId)(A.publisher,A.name);if(A.engines&&A.engines.vscode&&!(0,F.isEngineValid)(A.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,U,this.productService.version));const B=(await this.installExtensions([{manifest:A,extension:h,options:_}])).find(({identifier:te})=>(0,n.areSameExtensions)(te,{id:U}));if(B?.local)return B.local;throw B?.error?B.error:(0,s.toExtensionManagementError)(new Error(`Unknown error while installing extension ${U}`))}finally{await P()}}async installFromLocation(M,_){this.logService.trace("ExtensionManagementService#installFromLocation",M.toString());const h=await this.extensionsScanner.scanUserExtensionAtLocation(M);if(!h||!h.manifest.name||!h.manifest.version)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.addExtensionsToProfile([[h,{source:"resource"}]],_),this.logService.info("Successfully installed extension",h.identifier.id,_.toString()),h}async installExtensionsFromProfile(M,_,h){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",M,_.toString(),h.toString());const P=(await this.getInstalled(1,_)).filter(A=>M.some(U=>(0,n.areSameExtensions)(U,A.identifier)));if(P.length){const A=await Promise.all(P.map(U=>this.extensionsScanner.scanMetadata(U,_)));await this.addExtensionsToProfile(P.map((U,G)=>[U,A[G]]),h),this.logService.info("Successfully installed extensions",P.map(U=>U.identifier.id),h.toString())}return P}async updateMetadata(M,_,h=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),_.isPreReleaseVersion&&(_.preRelease=!0,_.hasPreReleaseVersion=!0),_.isMachineScoped===!1&&(_.isMachineScoped=void 0),_.isBuiltin===!1&&(_.isBuiltin=void 0),_.pinned===!1&&(_.pinned=void 0),M=await this.extensionsScanner.updateMetadata(M,_,h),this.manifestCache.invalidate(h),this._onDidUpdateExtensionMetadata.fire(M),M}async reinstallFromGallery(M){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.galleryService.isEnabled())throw new Error(f.localize(1,null));const _=await this.getTargetPlatform(),[h]=await this.galleryService.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:_,compatible:!0},C.CancellationToken.None);if(!h)throw new Error(f.localize(2,null));await this.extensionsScanner.setUninstalled(M);try{await this.extensionsScanner.removeUninstalledExtension(M)}catch(P){throw new Error(f.localize(3,null,(0,x.toErrorMessage)(P)))}return this.installFromGallery(h)}copyExtension(M,_,h,P){return this.extensionsScanner.copyExtension(M,_,h,P)}copyExtensions(M,_){return this.extensionsScanner.copyExtensions(M,_,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...M){return this.extensionsScanner.setUninstalled(...M)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(M){this.logService.error(M)}}async download(M,_,h){const{location:P}=await this.extensionsDownloader.download(M,_,!h);return P}async downloadVsix(M){if(M.scheme===w.Schemas.file)return{location:M,async cleanup(){}};this.logService.trace("Downloading extension from",M.toString());const _=(0,m.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,l.generateUuid)());return await this.downloadService.download(M,_),this.logService.info("Downloaded extension to",_.toString()),{location:_,cleanup:async()=>{try{await this.fileService.del(_)}catch(P){this.logService.error(P)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(M,_,h){if(p.URI.isUri(_))return new Y(M,_,h,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const P=n.ExtensionKey.create(_).toString();let A=this.installGalleryExtensionsTasks.get(P);return A||(this.installGalleryExtensionsTasks.set(P,A=new q(M,_,h,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService,this.telemetryService)),A.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(P))),A}createUninstallExtensionTask(M,_){return new J(M,_.profileLocation,this.extensionsProfileScannerService)}async collectFiles(M){const _=async P=>{let A=await E.Promises.readdir(P);A=A.map(B=>d.join(P,B));const U=await Promise.all(A.map(B=>E.Promises.stat(B)));let G=Promise.resolve([]);return U.forEach((B,te)=>{const ae=A[te];B.isFile()&&(G=G.then(ce=>[...ce,ae])),B.isDirectory()&&(G=G.then(ce=>_(ae).then(me=>[...ce,...me])))}),G};return(await _(M.location.fsPath)).map(P=>({path:`extension/${d.relative(M.location.fsPath,P)}`,localPath:P}))}async onDidChangeExtensionsFromAnotherSource({added:M,removed:_}){if(_){const h=M&&this.uriIdentityService.extUri.isEqual(_.profileLocation,M.profileLocation)?_.extensions.filter(P=>M.extensions.every(A=>!(0,n.areSameExtensions)(A,P))):_.extensions;for(const P of h)this.logService.info("Extensions removed from another source",P.id,_.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:P,profileLocation:_.profileLocation})}if(M){const P=(await this.getInstalled(1,M.profileLocation)).filter(A=>M.extensions.some(U=>(0,n.areSameExtensions)(U,A.identifier)));this._onDidInstallExtensions.fire(P.map(A=>(this.logService.info("Extensions added from another source",A.identifier.id,M.profileLocation.toString()),{identifier:A.identifier,local:A,profileLocation:M.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(_=>this.knownDirectories.add(_)));const M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const _ of M.children??[])_.isDirectory&&this.knownDirectories.add(_.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(_=>this.onDidFilesChange(_)))}async onDidFilesChange(M){if(!M.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const _=[];for(const h of M.rawAdded){if(this.knownDirectories.has(h)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(h,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(h).startsWith(".")||!(await this.fileService.stat(h)).isDirectory)continue;const P=await this.extensionsScanner.scanUserExtensionAtLocation(h);P&&P.installedTimestamp===void 0&&(this.knownDirectories.add(h),_.push(P))}_.length&&(await this.addExtensionsToProfile(_.map(h=>[h,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",_.map(h=>h.identifier.id)))}async addExtensionsToProfile(M,_){const h=M.map(P=>P[0]);await this.setInstalled(h),await this.extensionsProfileScannerService.addExtensionsToProfile(M,_),this._onDidInstallExtensions.fire(h.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:_})))}async setInstalled(M){const _=await this.extensionsScanner.getUninstalledExtensions();for(const h of M){const P=n.ExtensionKey.create(h);_[P.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",P.id),await this.extensionsScanner.setInstalled(P),this.logService.info("Removed the extension from uninstalled list:",P.id))}}};e.ExtensionManagementService=X,e.ExtensionManagementService=X=ve([oe(0,t.IExtensionGalleryService),oe(1,ue.ITelemetryService),oe(2,re.ILogService),oe(3,i.INativeEnvironmentService),oe(4,o.IExtensionsScannerService),oe(5,r.IExtensionsProfileScannerService),oe(6,g.IDownloadService),oe(7,H.IInstantiationService),oe(8,z.IFileService),oe(9,ie.IProductService),oe(10,fe.IUriIdentityService),oe(11,le.IUserDataProfilesService)],X);let W=class extends a.Disposable{constructor(M,_,h,P,A,U){super(),this.beforeRemovingExtension=M,this.fileService=_,this.extensionsScannerService=h,this.extensionsProfileScannerService=P,this.uriIdentityService=A,this.logService=U,this._onExtract=this._register(new I.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,m.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(M,_,h){const P={includeInvalid:!0,profileLocation:_,productVersion:h};let A=[];return M===null||M===0?A.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},P,!1)):M===1&&A.push(...await this.extensionsScannerService.scanUserExtensions(P)),A=M!==null?A.filter(U=>U.type===M):A,Promise.all(A.map(U=>this.toLocalExtension(U)))}async scanAllUserExtensions(M){const _=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(_.map(h=>this.toLocalExtension(h)))}async scanUserExtensionAtLocation(M){try{const _=await this.extensionsScannerService.scanExistingExtension(M,1,{includeInvalid:!0});if(_)return await this.toLocalExtension(_)}catch(_){this.logService.error(_)}return null}async extractUserExtension(M,_,h,P,A){const U=M.toString(),G=p.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,l.generateUuid)()}`)),B=p.URI.file(d.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U));let te=await this.fileService.exists(B);if(te&&P){try{await this.deleteExtensionFromLocation(M.id,B,"removeExisting")}catch{throw new t.ExtensionManagementError(f.localize(4,null,B.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.extensionsScannerService.updateMetadata(B,h);else try{try{this.logService.trace(`Started extracting the extension from ${_} to ${B.fsPath}`),await(0,v.extract)(_,G.fsPath,{sourcePath:"extension",overwrite:!0},A),this.logService.info(`Extracted extension to ${B}:`,M.id)}catch(ae){let ce=t.ExtensionManagementErrorCode.Extract;throw ae instanceof v.ExtractError&&(ae.type==="CorruptZip"?ce=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(ce=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(ae.message,ce)}await this.extensionsScannerService.updateMetadata(G,h);try{this.logService.trace(`Started renaming the extension from ${G.fsPath} to ${B.fsPath}`),await this.rename(G.fsPath,B.fsPath),this.logService.info("Renamed to",B.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(ae)}. Deleted from extracted location`,G),ae}this._onExtract.fire(B)}catch(ae){try{await this.fileService.del(G,{recursive:!0})}catch{}throw ae}return this.scanLocalExtension(B,1)}async scanMetadata(M,_){return _?(await this.getScannedExtension(M,_))?.metadata:this.extensionsScannerService.scanMetadata(M.location)}async getScannedExtension(M,_){return(await this.extensionsProfileScannerService.scanProfileExtensions(_)).find(P=>(0,n.areSameExtensions)(P.identifier,M.identifier))}async updateMetadata(M,_,h){return h?await this.extensionsProfileScannerService.updateMetadata([[M,_]],h):await this.extensionsScannerService.updateMetadata(M.location,_),this.scanLocalExtension(M.location,M.type,h)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...M){const _=M.map(h=>n.ExtensionKey.create(h));await this.withUninstalledExtensions(h=>_.forEach(P=>{h[P.toString()]=!0,this.logService.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(M){await this.withUninstalledExtensions(_=>delete _[M.toString()])}async removeExtension(M,_){if(this.uriIdentityService.extUri.isEqualOrParent(M.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(M.identifier.id,M.location,_)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.withUninstalledExtensions(_=>delete _[n.ExtensionKey.create(M).toString()])}async copyExtension(M,_,h,P){const A=await this.getScannedExtension(M,_),U=await this.getScannedExtension(M,h);if(P={...A?.metadata,...P},U)if(this.uriIdentityService.extUri.isEqual(U.location,M.location))await this.extensionsProfileScannerService.updateMetadata([[M,{...U.metadata,...P}]],h);else{const G=await this.scanLocalExtension(U.location,M.type,h);await this.extensionsProfileScannerService.removeExtensionFromProfile(G,h),await this.extensionsProfileScannerService.addExtensionsToProfile([[M,{...U.metadata,...P}]],h)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[M,P]],h);return this.scanLocalExtension(M.location,M.type,h)}async copyExtensions(M,_,h){const P=await this.scanExtensions(1,M,h),A=await Promise.all(P.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,M)]));await this.extensionsProfileScannerService.addExtensionsToProfile(A,_)}async deleteExtensionFromLocation(M,_,h){this.logService.trace(`Deleting ${h} extension from disk`,M,_.fsPath);const P=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(_),`${this.uriIdentityService.extUri.basename(_)}.${(0,u.hash)((0,l.generateUuid)()).toString(16)}${j}`);await this.rename(_.fsPath,P.fsPath),await this.fileService.del(P,{recursive:!0}),this.logService.info(`Deleted ${h} extension from disk`,M,_.fsPath)}async withUninstalledExtensions(M){return this.uninstalledFileLimiter.queue(async()=>{let _;try{_=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(P){if((0,z.toFileOperationResult)(P)!==1)throw P}let h={};if(_)try{h=JSON.parse(_)}catch{}return M&&(M(h),Object.keys(h).length?await this.fileService.writeFile(this.uninstalledResource,L.VSBuffer.fromString(JSON.stringify(h))):await this.fileService.del(this.uninstalledResource)),h})}async rename(M,_){try{await E.Promises.rename(M,_,2*60*1e3)}catch(h){throw new t.ExtensionManagementError(h.message||f.localize(5,null,M,_),h.code||t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(M,_,h){if(h){const A=(await this.extensionsScannerService.scanUserExtensions({profileLocation:h})).find(U=>this.uriIdentityService.extUri.isEqual(U.location,M));if(A)return this.toLocalExtension(A)}else{const P=await this.extensionsScannerService.scanExistingExtension(M,_,{includeInvalid:!0});if(P)return this.toLocalExtension(P)}throw new Error(f.localize(6,null,M.path))}async toLocalExtension(M){const _=await this.fileService.resolve(M.location);let h,P;return _.children&&(h=_.children.find(({name:A})=>/^readme(\.txt|\.md|)$/i.test(A))?.resource,P=_.children.find(({name:A})=>/^changelog(\.txt|\.md|)$/i.test(A))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:h,changelogUrl:P,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!M.metadata?.hasPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned,isWorkspaceScoped:!1,source:M.metadata?.source??(M.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(M));const _=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),h=new Set;for(const A of _)M[n.ExtensionKey.create(A).toString()]||h.add(A.identifier.id.toLowerCase());try{const A=(0,n.groupByExtension)(_,U=>U.identifier);await O.Promises.settled(A.map(async U=>{const G=U.sort((B,te)=>S.rcompare(B.manifest.version,te.manifest.version))[0];h.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}))}catch(A){this.logService.error(A)}const P=_.filter(A=>A.metadata&&M[n.ExtensionKey.create(A).toString()]);await Promise.allSettled(P.map(A=>this.removeUninstalledExtension(A)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(_){(0,z.toFileOperationResult)(_)!==1&&this.logService.error(_);return}if(M?.children)try{await Promise.allSettled(M.children.map(async _=>{if(!(!_.isDirectory||!_.name.endsWith(j))){this.logService.trace("Deleting the temporarily deleted folder",_.resource.toString());try{await this.fileService.del(_.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",_.resource.toString())}catch(h){(0,z.toFileOperationResult)(h)!==1&&this.logService.error(h)}}}))}catch{}}};e.ExtensionsScanner=W,e.ExtensionsScanner=W=ve([oe(1,z.IFileService),oe(2,o.IExtensionsScannerService),oe(3,r.IExtensionsProfileScannerService),oe(4,fe.IUriIdentityService),oe(5,re.ILogService)],W);class V extends s.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,D.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(M,_,h,P,A,U,G,B,te){super(),this.identifier=M,this.source=_,this.options=h,this.extensionsScanner=P,this.uriIdentityService=A,this.userDataProfilesService=U,this.extensionsScannerService=G,this.extensionsProfileScannerService=B,this.logService=te,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(M){const[_,h]=await this.install(M);return this._profileLocation=_.isBuiltin||_.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[_,h]],this._profileLocation,!_.isValid),_}async extractExtension({zipPath:M,key:_,metadata:h},P,A){let U=await this.unsetIfUninstalled(_);return U?U=await this.extensionsScanner.updateMetadata(U,h):(this.logService.trace("Extracting extension...",_.id),U=await this.extensionsScanner.extractUserExtension(_,M,h,P,A),this.logService.info("Extracting extension completed.",_.id)),U}async unsetIfUninstalled(M){return await this.isUninstalled(M)?(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(P=>n.ExtensionKey.create(P).equals(M))):void 0}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.toString()]}}class q extends V{constructor(M,_,h,P,A,U,G,B,te,ae,ce){super(_.identifier,_,h,A,U,G,B,te,ae),this.gallery=_,this.extensionsDownloader=P,this.telemetryService=ce}async install(M){let _;try{_=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(A){throw new t.ExtensionManagementError(A,t.ExtensionManagementErrorCode.Scanning)}const h=_.find(A=>(0,n.areSameExtensions)(A.identifier,this.gallery.identifier));h&&(this._operation=3);const P={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||h?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||h?.isMachineScoped,isBuiltin:this.options.isBuiltin||h?.isBuiltin,isSystem:h?.type===0?!0:void 0,updated:!!h,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:h?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??h?.pinned,preRelease:(0,D.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||h?.preRelease,source:"gallery"};if(h?.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(h,P),P]}catch(A){throw new t.ExtensionManagementError((0,k.getErrorMessage)(A),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.downloadAndInstallExtension(P,M)}catch(A){if(A instanceof t.ExtensionManagementError&&(A.code===t.ExtensionManagementErrorCode.CorruptZip||A.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.logService.info("Downloaded VSIX is invalid. Trying to download and install again...",this.gallery.identifier.id);try{const U=await this.downloadAndInstallExtension(P,M);return this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!0}),U}catch(U){throw this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!1}),U}}else throw A}}async downloadAndInstallExtension(M,_){const{location:h,verificationStatus:P}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=P,this.validateManifest(h.fsPath),[await this.extractExtension({zipPath:h.fsPath,key:n.ExtensionKey.create(this.gallery),metadata:M},!1,_),M]}catch(A){try{await this.extensionsDownloader.delete(h)}catch(U){this.logService.warn("Error while deleting the downloaded file",h.toString(),(0,k.getErrorMessage)(U))}throw A}}async validateManifest(M){try{await(0,R.getManifest)(M)}catch(_){throw new t.ExtensionManagementError((0,s.joinErrors)(_).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=q;class Y extends V{constructor(M,_,h,P,A,U,G,B,te,ae){super({id:(0,n.getGalleryExtensionId)(M.publisher,M.name)},_,h,A,U,G,B,te,ae),this.manifest=M,this.location=_,this.galleryService=P}async doRun(M){const _=await super.doRun(M);return this.updateMetadata(_,M),_}async install(M){const _=new n.ExtensionKey(this.identifier,this.manifest.version),P=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,n.areSameExtensions)(this.identifier,G.identifier)),A={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned,source:"vsix"};if(P)if(this._operation=3,_.equals(new n.ExtensionKey(P.identifier,P.manifest.version)))try{await this.extensionsScanner.removeExtension(P,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&S.gt(P.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(P);else{const G=await this.unsetIfUninstalled(_);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(f.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:d.resolve(this.location.fsPath),key:_,metadata:A},!0,M),A]}async updateMetadata(M,_){try{let[h]=await this.galleryService.getExtensions([{id:M.identifier.id,version:M.manifest.version}],_);if(h||([h]=await this.galleryService.getExtensions([{id:M.identifier.id}],_)),h){const P={id:h.identifier.uuid,publisherDisplayName:h.publisherDisplayName,publisherId:h.publisherId,isPreReleaseVersion:h.properties.isPreReleaseVersion,hasPreReleaseVersion:M.hasPreReleaseVersion||h.properties.isPreReleaseVersion,preRelease:h.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(M,P,this.options.profileLocation)}}catch{}}}class J extends s.AbstractExtensionTask{constructor(M,_,h){super(),this.extension=M,this.profileLocation=_,this.extensionsProfileScannerService=h}async doRun(M){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ne[163],se([0,1,6,24,23,22,42,13,18,11]),function(K,e,O,L,C,x,k,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let y=class extends k.AbstractExtensionsProfileScannerService{constructor(d,m,S,D,p,l){super(a.URI.file(d.extensionsPath),m,S,D,p,l)}};e.ExtensionsProfileScannerService=y,e.ExtensionsProfileScannerService=y=ve([oe(0,u.INativeEnvironmentService),oe(1,I.IFileService),oe(2,L.IUserDataProfilesService),oe(3,C.IUriIdentityService),oe(4,x.ITelemetryService),oe(5,O.ILogService)],y)}),define(ne[164],se([0,1,11,18,42,53,13,10,6,32,23,24]),function(K,e,O,L,C,x,k,I,u,a,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends x.NativeExtensionsScannerService{constructor(S,D,p,l,E,v,f,g){super(O.URI.file(E.builtinExtensionsPath),O.URI.file(E.extensionsPath),E.userHome,S.defaultProfile,S,D,p,l,E,v,f,g)}};e.ExtensionsScannerService=d,e.ExtensionsScannerService=d=ve([oe(0,w.IUserDataProfilesService),oe(1,C.IExtensionsProfileScannerService),oe(2,k.IFileService),oe(3,u.ILogService),oe(4,L.INativeEnvironmentService),oe(5,a.IProductService),oe(6,y.IUriIdentityService),oe(7,I.IInstantiationService)],d)}),define(ne[165],se([0,1,9,5,2,130,3,89,10,24]),function(K,e,O,L,C,x,k,I,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=m,e.isProfileUsingDefaultStorage=D,e.logStorage=l,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,u.createDecorator)("storageService");var y;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var w;(function(E){E[E.APPLICATION=-1]="APPLICATION",E[E.PROFILE=0]="PROFILE",E[E.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var d;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function m(E){const v=E.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class S extends C.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(v={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=v,this._onDidChangeValue=this._register(new L.PauseableEmitter),this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(v,f,g){return L.Event.filter(this._onDidChangeValue.event,i=>i.scope===v&&(f===void 0||i.key===f),g)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,x.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,x.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,f){const{key:g,external:i}=f;if(g===e.TARGET_KEY){switch(v){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:v})}else this._onDidChangeValue.fire({scope:v,key:g,target:this.getKeyTargets(v)[g],external:i})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,f,g){return this.getStorage(f)?.get(v,g)}getBoolean(v,f,g){return this.getStorage(f)?.getBoolean(v,g)}getNumber(v,f,g){return this.getStorage(f)?.getNumber(v,g)}getObject(v,f,g){return this.getStorage(f)?.getObject(v,g)}storeAll(v,f){this.withPausedEmitters(()=>{for(const g of v)this.store(g.key,g.value,g.scope,g.target,f)})}store(v,f,g,i,s=!1){if((0,k.isUndefinedOrNull)(f)){this.remove(v,g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,g,i),this.getStorage(g)?.set(v,f,s)})}remove(v,f,g=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(v,f,void 0),this.getStorage(f)?.delete(v,g)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,f){const g=[],i=this.getKeyTargets(v);for(const s of Object.keys(i))i[s]===f&&g.push(s);return g}updateKeyTarget(v,f,g,i=!1){const s=this.getKeyTargets(f);typeof g=="number"?s[v]!==g&&(s[v]=g,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(s),i)):typeof s[v]=="number"&&(delete s[v],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(s),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(v){switch(v){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(v){const f=this.getStorage(v);return f?m(f):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=y.NONE){this._onWillSaveState.fire({reason:v});const f=this.getStorage(-1),g=this.getStorage(0),i=this.getStorage(1);switch(v){case y.NONE:await O.Promises.settled([f?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await O.Promises.settled([f?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return l(v,f,g,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(v){return await this.flush(),this.getStorage(v)?.optimize()}async switch(v,f){return this.emitWillSaveState(y.NONE),(0,a.isUserDataProfile)(v)?this.switchToProfile(v,f):this.switchToWorkspace(v,f)}canSwitchProfile(v,f){return!(v.id===f.id||D(f)&&D(v))}switchData(v,f,g){this.withPausedEmitters(()=>{const i=new Set;for(const[s,t]of v)i.add(s),f.get(s)!==t&&this.emitDidChangeValue(g,{key:s,external:!0});for(const[s]of f.items)i.has(s)||this.emitDidChangeValue(g,{key:s,external:!0})})}}e.AbstractStorageService=S;function D(E){return E.isDefault||!!E.useDefaultFlags?.globalState}class p extends S{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.profileStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),this._register(this.applicationStorage.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v)))}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(v){return!1}}e.InMemoryStorageService=p;async function l(E,v,f,g,i,s){const t=F=>{try{return JSON.parse(F)}catch{return F}},n=new Map,r=new Map;E.forEach((F,z)=>{n.set(z,F),r.set(z,t(F))});const o=new Map,c=new Map;v.forEach((F,z)=>{o.set(z,F),c.set(z,t(F))});const b=new Map,R=new Map;f.forEach((F,z)=>{b.set(z,F),R.set(z,t(F))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const T=[];if(n.forEach((F,z)=>{T.push({key:z,value:F})}),console.table(T),console.groupEnd(),console.log(r),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const F=[];o.forEach((z,H)=>{F.push({key:H,value:z})}),console.table(F),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${s})`);const N=[];b.forEach((F,z)=>{N.push({key:z,value:F})}),console.table(N),console.groupEnd(),console.log(R)}}),define(ne[166],se([0,1,19,20,8,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=Y;const i=x.isWeb?"web":(0,w.getTargetPlatform)(x.platform,k.arch),s="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...P){return String(P.reduce((A,U)=>A|U,0))}var r;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class T{constructor(A=R){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(A,U=this.state.pageSize){return new T({...this.state,pageNumber:A,pageSize:U})}withFilter(A,...U){const G=[...this.state.criteria,...U.length?U.map(B=>({filterType:A,value:B})):[{filterType:A}]];return new T({...this.state,criteria:G})}withSortBy(A){return new T({...this.state,sortBy:A})}withSortOrder(A){return new T({...this.state,sortOrder:A})}withFlags(...A){return new T({...this.state,flags:A.reduce((U,G)=>U|G,0)})}withAssetTypes(...A){return new T({...this.state,assetTypes:A})}withSource(A){return new T({...this.state,source:A})}get raw(){const{criteria:A,pageNumber:U,pageSize:G,sortBy:B,sortOrder:te,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:A,pageNumber:U,pageSize:G,sortBy:B,sortOrder:te}],assetTypes:ce,flags:ae}}get searchText(){const A=this.state.criteria.filter(U=>U.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function N(P,A){const U=(P||[]).filter(G=>G.statisticName===A)[0];return U?U.value:0}function F(P){const A="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(G=>G.assetType.indexOf(A)===0).reduce((G,B)=>{const te=re(P,B.assetType);return te&&G.push([B.assetType.substring(A.length),te]),G},[])}function z(P){if(P.properties){const A=P.properties.filter(B=>B.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=A.filter(B=>U.test(B.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return re(P,o.Repository)}function H(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function re(P,A){return P.files.filter(G=>G.assetType===A)[0]?{uri:`${P.assetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function ie(P,A){const U=P.properties?P.properties.filter(B=>B.key===A):[],G=U.length>0&&U[0].value;return G?G.split(",").map(B=>(0,d.adoptToGalleryExtensionId)(B)):[]}function ue(P){const A=P.properties?P.properties.filter(U=>U.key===c.Engine):[];return A.length>0&&A[0].value||""}function fe(P){const A=P.properties?P.properties.filter(U=>U.key===c.PreRelease):[];return A.length>0&&A[0].value==="true"}function le(P){const A=P.properties?P.properties.filter(G=>G.key===c.LocalizedLanguages):[],U=A.length>0&&A[0].value||"";return U?U.split(","):[]}function j(P){return P.properties?.find(A=>A.key===c.SponsorLink)?.value}function X(P){return P.properties?.find(A=>A.key===c.SupportLink)?.value}function W(P){return P.indexOf("preview")!==-1}function V(P){return P.targetPlatform?(0,w.toTargetPlatform)(P.targetPlatform):"undefined"}function q(P){const A=(0,O.distinct)(P.versions.map(V)),U=!!P.tags?.includes(w.WEB_EXTENSION_TAG),G=A.indexOf("web");return U?G===-1&&A.push("web"):G!==-1&&A.splice(G,1),A}function Y(P,A){for(let U=0;U<P.length;U++){const G=P[U];if(G.version===P[U-1]?.version){let B=U;if(V(G)===A)for(;B>0&&P[B-1].version===G.version;)B--;B!==U&&(P.splice(U,1),P.splice(B,0,G))}}return P}function J(P,A,U){P.telemetryData={index:A,querySource:U,queryActivityId:P.queryContext?.[s]}}function Z(P,A,U,G){const B=P.versions[0],te={manifest:re(A,o.Manifest),readme:re(A,o.Details),changelog:re(A,o.Changelog),license:re(A,o.License),repository:z(A),download:H(A),icon:re(A,o.Icon),signature:re(A,o.Signature),coreTranslations:F(A)};return{identifier:{id:(0,d.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:A.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:j(B),description:P.shortDescription??"",installCount:N(P.statistics,"install"),rating:N(P.statistics,"averagerating"),ratingCount:N(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:U,assets:te,properties:{dependencies:ie(A,c.Dependency),extensionPack:ie(A,c.ExtensionPack),engine:ue(A),localizedLanguages:le(A),targetPlatform:V(A),isPreReleaseVersion:fe(A)},hasPreReleaseVersion:fe(B),hasReleaseVersion:!0,preview:W(P.flags),isSigned:!!te.signature,queryContext:G,supportLink:X(B)}}let M=class{constructor(A,U,G,B,te,ae,ce,me){this.requestService=U,this.logService=G,this.environmentService=B,this.telemetryService=te,this.fileService=ae,this.productService=ce,this.configurationService=me;const ye=ce.extensionsGallery,he=ye?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=he?ye.servicePPEUrl:ye?.serviceUrl,this.extensionsGallerySearchUrl=he?void 0:ye?.searchUrl,this.extensionsControlUrl=ye?.controlUrl,this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,A,this.telemetryService)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,U,G){const B=L.CancellationToken.isCancellationToken(U)?{}:U,te=L.CancellationToken.isCancellationToken(U)?U:G,ae=[],ce=[],me=[],ye=[];let he=!0;for(const Se of A){Se.uuid?ce.push(Se.uuid):ae.push(Se.id);const Pe=!!(Se.version||Se.preRelease);me.push({id:Se.id,uuid:Se.uuid,includePreRelease:Pe}),Se.version&&ye.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!Pe}if(!ce.length&&!ae.length)return[];let pe=new T().withPage(1,A.length);ce.length&&(pe=pe.withFilter(r.ExtensionId,...ce)),ae.length&&(pe=pe.withFilter(r.ExtensionName,...ae)),(B.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,t.IncludeVersions)),B.source&&(pe=pe.withSource(B.source));const{extensions:de}=await this.queryGalleryExtensions(pe,{targetPlatform:B.targetPlatform??i,includePreRelease:me,versions:ye,compatible:!!B.compatible,productVersion:B.productVersion??{version:this.productService.version,date:this.productService.date}},te);return B.source&&de.forEach((Se,Pe)=>J(Se,Pe,B.source)),de}async getCompatibleExtension(A,U,G,B={version:this.productService.version,date:this.productService.date}){if((0,w.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(A,U,G))return A;const te=new T().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,A.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(te,{targetPlatform:G,compatible:!0,includePreRelease:U,productVersion:B},L.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(A,U,G,B={version:this.productService.version,date:this.productService.date}){if(!(0,w.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,G)||!U&&A.properties.isPreReleaseVersion)return!1;let te=A.properties.engine;if(!te){const ae=await this.getManifest(A,L.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,m.isEngineValid)(te,B.version,B.date)}async isValidVersion(A,U,G,B,te,ae,ce={version:this.productService.version,date:this.productService.date}){if(!(0,w.isTargetPlatformCompatible)(V(U),te,ae)||G!=="any"&&fe(U)!==(G==="prerelease"))return!1;if(B)try{const me=await this.getEngine(A,U);if(!(0,m.isEngineValid)(me,ce.version,ce.date))return!1}catch(me){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,C.getErrorMessage)(me)),!1}return!0}async query(A,U){let G=A.text||"";const B=A.pageSize??50;let te=new T().withPage(1,B);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,de)=>(te=te.withFilter(r.Category,de||pe),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,de)=>(te=te.withFilter(r.Tag,de||pe),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(r.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(r.SearchText,G)),te=te.withSortBy(0)):A.ids?te=te.withFilter(r.ExtensionId,...A.ids):A.names?te=te.withFilter(r.ExtensionName,...A.names):te=te.withSortBy(4),typeof A.sortBy=="number"&&(te=te.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(te=te.withSortOrder(A.sortOrder)),A.source&&(te=te.withSource(A.source));const ae=async(he,pe)=>{const{extensions:de,total:Se}=await this.queryGalleryExtensions(he,{targetPlatform:i,compatible:!1,includePreRelease:!!A.includePreRelease,productVersion:A.productVersion??{version:this.productService.version,date:this.productService.date}},pe);return de.forEach((Pe,Ce)=>J(Pe,(he.pageNumber-1)*he.pageSize+Ce,A.source)),{extensions:de,total:Se}},{extensions:ce,total:me}=await ae(te,U),ye=async(he,pe)=>{if(pe.isCancellationRequested)throw new C.CancellationError;const{extensions:de}=await ae(te.withPage(he+1),pe);return de};return{firstPage:ce,total:me,pageSize:te.pageSize,getPage:ye}}async queryGalleryExtensions(A,U,G){const B=A.flags;A.flags&t.IncludeLatestVersionOnly&&A.flags&t.IncludeVersions&&(A=A.withFlags(A.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(A.flags&t.IncludeLatestVersionOnly)&&!(A.flags&t.IncludeVersions)&&(A=A.withFlags(A.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(A=A.withFlags(A.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),A=A.withFlags(A.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:ce}=await this.queryRawGalleryExtensions(A,G);if(!(A.flags&t.IncludeLatestVersionOnly)){const pe=[];for(const de of te){const Se=await this.toGalleryExtensionWithCriteria(de,U,ce);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const ye=[],he=new Map;for(let pe=0;pe<te.length;pe++){const de=te[pe],Se={id:(0,d.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Pe=(0,I.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find($=>(0,d.areSameExtensions)($,Se))?.includePreRelease;if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(q(de),U.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(de,U,ce);!Ce||Ce.properties.isPreReleaseVersion&&(!Pe||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==U.targetPlatform&&Ce.hasPreReleaseVersion?he.set(de.extensionId,pe):ye.push([pe,Ce])}if(he.size){const pe=new g.StopWatch,de=new T().withFlags(B&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,he.size).withFilter(r.ExtensionId,...he.keys()),{extensions:Se}=await this.queryGalleryExtensions(de,U,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const Pe of Se){const Ce=he.get(Pe.identifier.uuid);ye.push([Ce,Pe])}}return{extensions:ye.sort((pe,de)=>pe[0]-de[0]).map(([,pe])=>pe),total:ae}}async toGalleryExtensionWithCriteria(A,U,G){const B={id:(0,d.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},te=U.versions?.find(ye=>(0,d.areSameExtensions)(ye,B))?.version,ae=(0,I.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ye=>(0,d.areSameExtensions)(ye,B))?.includePreRelease,ce=q(A),me=Y(A.versions,U.targetPlatform);if(U.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ce,U.targetPlatform))return null;for(let ye=0;ye<me.length;ye++){const he=me[ye];if(!(te&&he.version!==te)){if(await this.isValidVersion((0,d.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),he,ae?"any":"release",U.compatible,ce,U.targetPlatform,U.productVersion))return Z(A,he,ce,G);if(te&&he.version===te)return null}}return te||U.compatible?null:Z(A,A.versions[0],ce)}async queryRawGalleryExtensions(A,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(t.Unpublished));const G=await this.commonHeadersPromise,B=JSON.stringify(A.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},ae=new g.StopWatch;let ce,me,ye=0;try{if(ce=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&A.criteria.some(pe=>pe.filterType===r.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:B,headers:te},U),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ye};const he=await(0,l.asJson)(ce);if(he){const pe=he.results[0],de=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ye=Se&&Se.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[s]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(he){const pe=(0,C.isCancellationError)(he)?w.ExtensionGalleryErrorCode.Cancelled:(0,C.getErrorMessage)(he).startsWith("XHR timeout")?w.ExtensionGalleryErrorCode.Timeout:w.ExtensionGalleryErrorCode.Failed;throw me=new w.ExtensionGalleryError((0,C.getErrorMessage)(he),pe),me}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(B.length),duration:ae.elapsed(),success:!!ce&&(0,l.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:me?.code,count:String(ye)})}}async reportStatistic(A,U,G,B){if(!this.isEnabled())return;const te=x.isWeb?this.api(`/itemName/${A}.${U}/version/${G}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${U}/${G}/stats?statType=${B}`),ae=x.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:te,headers:me},L.CancellationToken.None)}catch{}}async download(A,U,G){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const B=(0,d.getGalleryExtensionTelemetryData)(A),te=new Date().getTime(),ae=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...B,duration:pe}),ce=G===2?"install":G===3?"update":"",me=ce?{uri:`${A.assets.download.uri}${u.URI.parse(A.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${A.assets.download.fallbackUri}${u.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:A.assets.download,ye=A.queryContext?.[s]?{[s]:A.queryContext[s]}:void 0,he=await this.getAsset(A.identifier.id,me,o.VSIX,ye?{headers:ye}:void 0);await this.fileService.writeFile(U,he.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(A,U){if(!A.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const G=await this.getAsset(A.identifier.id,A.assets.signature,o.Signature);await this.fileService.writeFile(U,G.stream)}async getReadme(A,U){if(A.assets.readme){const G=await this.getAsset(A.identifier.id,A.assets.readme,o.Details,{},U);return await(0,l.asTextOrError)(G)||""}return""}async getManifest(A,U){if(A.assets.manifest){const G=await this.getAsset(A.identifier.id,A.assets.manifest,o.Manifest,{},U),B=await(0,l.asTextOrError)(G);return B?JSON.parse(B):null}return null}async getManifestFromRawExtensionVersion(A,U,G){const B=re(U,o.Manifest);if(!B)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.getAsset(A,B,o.Manifest,{headers:te});return await(0,l.asJson)(ae)}async getCoreTranslation(A,U){const G=A.assets.coreTranslations.filter(B=>B[0]===U.toUpperCase())[0];if(G){const B=await this.getAsset(A.identifier.id,G[1],G[0]),te=await(0,l.asTextOrError)(B);return te?JSON.parse(te):null}return null}async getChangelog(A,U){if(A.assets.changelog){const G=await this.getAsset(A.identifier.id,A.assets.changelog,o.Changelog,{},U);return await(0,l.asTextOrError)(G)||""}return""}async getAllCompatibleVersions(A,U,G){let B=new T().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?B=B.withFilter(r.ExtensionId,A.identifier.uuid):B=B.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:te}=await this.queryRawGalleryExtensions(B,L.CancellationToken.None);if(!te.length)return[];const ae=q(te[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ae,G))return[];const ce=[];await Promise.all(te[0].versions.map(async he=>{try{await this.isValidVersion(A.identifier.id,he,U?"any":"release",!0,ae,G)&&ce.push(he)}catch{}}));const me=[],ye=new Set;for(const he of Y(ce,G))ye.has(he.version)||(ye.add(he.version),me.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:fe(he)}));return me}async getAsset(A,U,G,B={},te=L.CancellationToken.None){const ae=await this.commonHeadersPromise,ce={type:"GET"},me={...ae,...B.headers||{}};B={...B,...ce,headers:me};const ye=U.uri,he=U.fallbackUri,pe={...B,url:ye};try{const de=await this.requestService.request(pe,te);if(de.res.statusCode===200)return de;const Se=await(0,l.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Se}`)}catch(de){if((0,C.isCancellationError)(de))throw de;const Se=(0,C.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:A,assetType:G,message:Se});const Pe={...B,url:he};return this.requestService.request(Pe,te)}}async getEngine(A,U){let G=ue(U);if(!G){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:A,version:U.version});const B=await this.getManifestFromRawExtensionVersion(A,U,L.CancellationToken.None);if(!B)throw new Error("Manifest was not found");G=B.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(A),G=[],B={},te=[];if(U){for(const ae of U.malicious)G.push({id:ae});if(U.migrateToPreRelease)for(const[ae,ce]of Object.entries(U.migrateToPreRelease))(!ce.engine||(0,m.isEngineValid)(ce.engine,this.productService.version,this.productService.date))&&(B[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ae,ce]of Object.entries(U.deprecated))ce&&(B[ae.toLowerCase()]=(0,I.isBoolean)(ce)?{}:ce);if(U.search)for(const ae of U.search)te.push(ae)}return{malicious:G,deprecated:B,search:te}}};M=ve([oe(1,l.IRequestService),oe(2,D.ILogService),oe(3,y.IEnvironmentService),oe(4,f.ITelemetryService),oe(5,S.IFileService),oe(6,p.IProductService),oe(7,a.IConfigurationService)],M);let _=class extends M{constructor(A,U,G,B,te,ae,ce,me){super(A,U,G,B,te,ae,ce,me)}};e.ExtensionGalleryService=_,e.ExtensionGalleryService=_=ve([oe(0,v.IStorageService),oe(1,l.IRequestService),oe(2,D.ILogService),oe(3,y.IEnvironmentService),oe(4,f.ITelemetryService),oe(5,S.IFileService),oe(6,p.IProductService),oe(7,a.IConfigurationService)],_);let h=class extends M{constructor(A,U,G,B,te,ae,ce){super(void 0,A,U,G,B,te,ae,ce)}};e.ExtensionGalleryServiceWithNoStorageService=h,e.ExtensionGalleryServiceWithNoStorageService=h=ve([oe(0,l.IRequestService),oe(1,D.ILogService),oe(2,y.IEnvironmentService),oe(3,f.ITelemetryService),oe(4,S.IFileService),oe(5,p.IProductService),oe(6,a.IConfigurationService)],h)}),define(ne[167],se([0,1,11,18,13,6,145,23,24,3,68]),function(K,e,O,L,C,x,k,I,u,a,y){"use strict";var w,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=class extends u.UserDataProfilesService{static{w=this}static{this.PROFILE_ASSOCIATIONS_MIGRATION_KEY="profileAssociationsMigration"}constructor(l,E,v,f,g){super(v,f,E,g),this.stateReadonlyService=l,this.nativeEnvironmentService=v}getStoredProfiles(){return this.stateReadonlyService.getItem(w.PROFILES_KEY,[]).map(E=>({...E,location:(0,a.isString)(E.location)?this.uriIdentityService.extUri.joinPath(this.profilesHome,E.location):O.URI.revive(E.location)}))}getStoredProfileAssociations(){const l=this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_KEY,{});return this.stateReadonlyService.getItem(w.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)?l:this.migrateStoredProfileAssociations(l)}getDefaultProfileExtensionsLocation(){return this.uriIdentityService.extUri.joinPath(O.URI.file(this.nativeEnvironmentService.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.UserDataProfilesReadonlyService=m,e.UserDataProfilesReadonlyService=m=w=ve([oe(0,k.IStateReadService),oe(1,I.IUriIdentityService),oe(2,L.INativeEnvironmentService),oe(3,C.IFileService),oe(4,x.ILogService)],m);let S=d=class extends m{constructor(l,E,v,f,g){super(l,E,v,f,g),this.stateService=l}saveStoredProfiles(l){l.length?this.stateService.setItem(d.PROFILES_KEY,l.map(E=>({...E,location:this.uriIdentityService.extUri.basename(E.location)}))):this.stateService.removeItem(d.PROFILES_KEY)}getStoredProfiles(){const l=super.getStoredProfiles();return this.stateService.getItem("userDataProfilesMigration",!1)||(this.saveStoredProfiles(l),this.stateService.setItem("userDataProfilesMigration",!0)),l}saveStoredProfileAssociations(l){l.emptyWindows||l.workspaces?this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,l):this.stateService.removeItem(d.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const l="workspaceAndProfileInfo",E=this.stateService.getItem(l,void 0);if(E){this.stateService.removeItem(l);const f=E.reduce((g,{workspace:i,profile:s})=>(g[O.URI.revive(i).toString()]=O.URI.revive(s).toString(),g),{});this.stateService.setItem(d.PROFILE_ASSOCIATIONS_KEY,{workspaces:f})}const v=super.getStoredProfileAssociations();return this.stateService.getItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!1)||(this.saveStoredProfileAssociations(v),this.stateService.setItem(d.PROFILE_ASSOCIATIONS_MIGRATION_KEY,!0)),v}};e.UserDataProfilesService=S,e.UserDataProfilesService=S=d=ve([oe(0,k.IStateService),oe(1,I.IUriIdentityService),oe(2,L.INativeEnvironmentService),oe(3,C.IFileService),oe(4,x.ILogService)],S);let D=class extends S{constructor(l,E,v,f){super(new y.StateService(0,E,f,v),l,E,v,f)}async init(){return await this.stateService.init(),super.init()}};e.ServerUserDataProfilesService=D,e.ServerUserDataProfilesService=D=ve([oe(0,I.IUriIdentityService),oe(1,L.INativeEnvironmentService),oe(2,C.IFileService),oe(3,x.ILogService)],D)}),define(ne[168],se([0,1,143,9,14,8,3,29,18,144,6,45,142,179]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0,e.nodeRequest=p;let S=class extends w.AbstractRequestService{constructor(E,v,f,g){super(g),this.configurationService=E,this.environmentService=v,this.logService=f,this.configure(),this._register(E.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.configure()}))}configure(){const E=this.configurationService.getValue("http");this.proxyUrl=E?.proxy,this.strictSSL=!!E?.proxyStrictSSL,this.authorization=E?.proxyAuthorization}async request(E,v){const{proxyUrl:f,strictSSL:g}=this;let i;try{i=await(0,a.getResolvedShellEnv)(this.configurationService,this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("resolving shell environment failed",(0,x.getErrorMessage)(n)))}const s={...process.env,...i},t=E.agent?E.agent:await(0,d.getProxyAgent)(E.url||"",s,{proxyUrl:f,strictSSL:g});return E.agent=t,E.strictSSL=g,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization}),this.logAndRequest(E.isChromiumNetwork?"electron":"node",E,()=>p(E,v))}async resolveProxy(E){}async loadCertificates(){return(await new Promise((v,f)=>{K(["@vscode/proxy-agent"],v,f)})).loadSystemCertificates({log:this.logService})}};e.RequestService=S,e.RequestService=S=ve([oe(0,I.IConfigurationService),oe(1,u.INativeEnvironmentService),oe(2,y.ILogService),oe(3,y.ILoggerService)],S);async function D(l){return((0,O.parse)(l.url).protocol==="https:"?await new Promise((f,g)=>{K(["https"],f,g)}):await new Promise((f,g)=>{K(["http"],f,g)})).request}async function p(l,E){return L.Promises.withAsyncBody(async(v,f)=>{const g=(0,O.parse)(l.url),i=l.getRawRequest?l.getRawRequest(l):await D(l),s={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,k.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(s.auth=l.user+":"+l.password);const t=i(s,n=>{const r=(0,k.isNumber)(l.followRedirects)?l.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)p({...l,url:n.headers.location,followRedirects:r-1},E).then(v,f);else{let o=n;!l.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,m.createGunzip)())),v({res:n,stream:(0,C.streamToBufferReadableStream)(o)})}});t.on("error",f),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),E.onCancellationRequested(()=>{t.abort(),f(new x.CancellationError)})})}}),define(ne[180],se([0,1,33,9,34,8,2,15,16,12,35,11,25,29,139,61,141,18,115,166,21,70,146,42,53,162,164,13,129,131,51,127,63,64,150,6,135,39,136,153,32,45,168,68,69,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(K,e,O,L,C,x,k,I,u,a,y,w,d,m,S,D,p,l,E,v,f,g,i,s,t,n,r,o,c,b,R,T,N,F,z,H,re,ie,ue,fe,le,j,X,W,V,q,Y,J,Z,M,_,h,P,A,U,G,B,te,ae,ce,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=he;class ye extends k.Disposable{constructor(de){super(),this.argv=de,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[de,Se]=await this.initServices();return de.invokeFunction(async Pe=>{const Ce=Pe.get(H.ILogService),$=Pe.get(o.IFileService),Q=Pe.get(l.INativeEnvironmentService),ee=Pe.get(P.IUserDataProfilesService);Ce.info("CLI main",this.argv),this.registerErrorHandler(Ce),await this.doRun(Q,$,ee,de),await Promise.all(Se.map(ge=>{(0,L.raceTimeout)(ge.flush(),1e3)}))})}async initServices(){const de=new N.ServiceCollection,Se={_serviceBrand:void 0,...fe.default};de.set(le.IProductService,Se);const Pe=new E.NativeEnvironmentService(this.argv,Se);de.set(l.INativeEnvironmentService,Pe),await Promise.all([this.allowWindowsUNCPath(Pe.appSettingsHome.with({scheme:I.Schemas.file}).fsPath),this.allowWindowsUNCPath(Pe.extensionsPath)].map(Ee=>Ee?d.Promises.mkdir(Ee,{recursive:!0}):void 0));const Ce=new te.LoggerService((0,H.getLogLevel)(Pe),Pe.logsHome);de.set(H.ILoggerService,Ce);const $=this._register(Ce.createLogger("cli",{name:(0,ae.localize)(0,null)})),Q=[];Ce.getLogLevel()===H.LogLevel.Trace&&Q.push(new H.ConsoleLogger(Ce.getLogLevel()));const ee=this._register(new B.LogService($,Q));de.set(H.ILogService,ee);const ge=this._register(new c.FileService(ee));de.set(o.IFileService,ge);const we=this._register(new b.DiskFileSystemProvider(ee));ge.registerProvider(I.Schemas.file,we);const Oe=new h.UriIdentityService(ge);de.set(_.IUriIdentityService,Oe);const be=new W.StateReadonlyService(1,Pe,ee,ge),Te=new A.UserDataProfilesReadonlyService(be,Oe,Pe,ge,ee);de.set(P.IUserDataProfilesService,Te),ge.registerProvider(I.Schemas.vscodeUserData,new ce.FileUserDataProvider(I.Schemas.file,we,I.Schemas.vscodeUserData,Te,Oe,ee));const Re=a.isWindows&&Se.win32RegValueName?this._register(new ue.NativePolicyService(ee,Se.win32RegValueName)):Pe.policyFile?this._register(new re.FilePolicyService(Pe.policyFile,ge,ee)):new ie.NullPolicyService;de.set(ie.IPolicyService,Re);const xe=this._register(new S.ConfigurationService(Te.defaultProfile.settingsResource,ge,Re,ee));de.set(m.IConfigurationService,xe),await Promise.all([be.init(),xe.initialize()]);let _e;try{_e=await(0,U.resolveMachineId)(be,ee)}catch(Ee){Ee.code!=="ENOENT"&&ee.error(Ee)}const Le=await(0,U.resolveSqmId)(be,ee);Te.init(),de.set(_.IUriIdentityService,new h.UriIdentityService(ge));const Ae=new X.RequestService(xe,Pe,ee,Ce);de.set(j.IRequestService,Ae),de.set(D.IDownloadService,new R.SyncDescriptor(p.DownloadService,void 0,!0)),de.set(s.IExtensionsProfileScannerService,new R.SyncDescriptor(G.ExtensionsProfileScannerService,void 0,!0)),de.set(t.IExtensionsScannerService,new R.SyncDescriptor(r.ExtensionsScannerService,void 0,!0)),de.set(g.IExtensionSignatureVerificationService,new R.SyncDescriptor(g.ExtensionSignatureVerificationService,void 0,!0)),de.set(n.INativeServerExtensionManagementService,new R.SyncDescriptor(n.ExtensionManagementService,void 0,!0)),de.set(f.IExtensionGalleryService,new R.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),de.set(F.ILanguagePackService,new R.SyncDescriptor(z.NativeLanguagePackService,void 0,!1));const Ne=[],Me=(0,J.isInternalTelemetry)(Se,xe);if((0,J.supportsTelemetry)(Se,Pe)){Se.aiConfig&&Se.aiConfig.ariaKey&&Ne.push(new Z.OneDataSystemAppender(Ae,Me,"monacoworkbench",null,Se.aiConfig.ariaKey));const Ee={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(0,V.resolveCommonProperties)((0,O.release)(),(0,O.hostname)(),process.arch,Se.commit,Se.version,_e,Le,Me),piiPaths:(0,J.getPiiPathsFromEnvironment)(Pe)};de.set(q.ITelemetryService,new R.SyncDescriptor(Y.TelemetryService,[Ee],!1))}else de.set(q.ITelemetryService,J.NullTelemetryService);return[new T.InstantiationService(de),Ne]}allowWindowsUNCPath(de){if(a.isWindows){const Se=(0,me.getUNCHost)(de);Se&&(0,me.addUNCHostToAllowlist)(Se)}return de}registerErrorHandler(de){(0,x.setUnexpectedErrorHandler)(Se=>{const Pe=(0,C.toErrorMessage)(Se,!0);Pe&&de.error(`[uncaught exception in CLI]: ${Pe}`)}),process.on("uncaughtException",Se=>{(0,x.isSigPipeError)(Se)||(0,x.onUnexpectedError)(Se)}),process.on("unhandledRejection",Se=>(0,x.onUnexpectedError)(Se))}async doRun(de,Se,Pe,Ce){let $;if(de.args.profile&&($=Pe.profiles.find(ee=>ee.name===de.args.profile),!$))throw new Error(`Profile '${de.args.profile}' not found.`);const Q=($??Pe.defaultProfile).extensionsResource;if(this.argv["list-extensions"])return Ce.createInstance(i.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).listExtensions(!!this.argv["show-versions"],this.argv.category,Q);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ee={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Q};return Ce.createInstance(i.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.asExtensionIdOrVSIX(this.argv["install-builtin-extension"]||[]),ee,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return Ce.createInstance(i.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Q);if(this.argv["update-extensions"])return Ce.createInstance(i.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).updateExtensions(Q);if(this.argv["locate-extension"])return Ce.createInstance(i.ExtensionManagementCLI,new H.ConsoleLogger(H.LogLevel.Info,!1)).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(de.appRoot,de.extensionsPath))}}asExtensionIdOrVSIX(de){return de.map(Se=>/\.vsix$/i.test(Se)?w.URI.file((0,u.isAbsolute)(Se)?Se:(0,u.join)((0,y.cwd)(),Se)):Se)}}async function he(pe){const de=new ye(pe);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/code/node/cliProcessMain.js.map
