/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(se){for(var e=[],L=0,U=se.length;L<U;L++)e[L]=le[se[L]];return e};define(le[124],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class L{static get(){const O=new Map,A=new Map,_=new Map,R=new Map;function P(h,u){h.has(u.detail)||h.set(u.detail,-u.timestamp)}function f(h,u){const y=h.get(u.detail);y&&(y>=0||h.set(u.detail,y+u.timestamp))}let D=[];typeof se=="function"&&typeof se.getStats=="function"&&(D=se.getStats().slice(0).sort((h,u)=>h.timestamp-u.timestamp));for(const h of D)switch(h.type){case 10:P(O,h);break;case 11:case 12:f(O,h);break;case 21:P(A,h);break;case 22:f(A,h);break;case 33:P(_,h);break;case 34:f(_,h);break;case 31:P(R,h);break;case 32:f(R,h);break}let w=0;_.forEach(h=>w+=h);function m(h){const u=[];return h.forEach((y,v)=>u.push([v,y])),u}return{amdLoad:m(O),amdInvoke:m(A),nodeRequire:m(_),nodeEval:m(R),nodeRequireTotal:w}}static toMarkdownTable(O,A){let _="";const R=[];return O.forEach((P,f)=>{R[f]=P.length}),A.forEach(P=>{P.forEach((f,D)=>{typeof f>"u"&&(f=P[D]="-");const w=f.toString().length;R[D]=Math.max(w,R[D])})}),O.forEach((P,f)=>{_+=`| ${P+" ".repeat(R[f]-P.toString().length)} `}),_+=`|
`,O.forEach((P,f)=>{_+=`| ${"-".repeat(R[f])} `}),_+=`|
`,A.forEach(P=>{P.forEach((f,D)=>{typeof f<"u"&&(_+=`| ${f+" ".repeat(R[D]-f.toString().length)} `)}),_+=`|
`}),_}}e.LoaderStats=L}),define(le[125],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=L,e.findLastIdx=U,e.findLastMonotonous=O,e.findLastIdxMonotonous=A,e.findFirstMonotonous=_,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=P,e.findFirstMaxBy=D,e.findLastMaxBy=w,e.findFirstMinBy=m,e.findMaxIdxBy=h,e.mapFindFirst=u;function L(y,v,d){const g=U(y,v);if(g!==-1)return y[g]}function U(y,v,d=y.length-1){for(let g=d;g>=0;g--){const l=y[g];if(v(l))return g}return-1}function O(y,v){const d=A(y,v);return d===-1?void 0:y[d]}function A(y,v,d=0,g=y.length){let l=d,c=g;for(;l<c;){const S=Math.floor((l+c)/2);v(y[S])?l=S+1:c=S}return l-1}function _(y,v){const d=R(y,v);return d===y.length?void 0:y[d]}function R(y,v,d=0,g=y.length){let l=d,c=g;for(;l<c;){const S=Math.floor((l+c)/2);v(y[S])?c=S:l=S+1}return l}function P(y,v,d=0,g=y.length){const l=R(y,v,d,g);return l===y.length?-1:l}class f{static{this.assertInvariants=!1}constructor(v){this._array=v,this._findLastMonotonousLastIdx=0}findLastMonotonous(v){if(f.assertInvariants){if(this._prevFindLastPredicate){for(const g of this._array)if(this._prevFindLastPredicate(g)&&!v(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=v}const d=A(this._array,v,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=d+1,d===-1?void 0:this._array[d]}}e.MonotonousArray=f;function D(y,v){if(y.length===0)return;let d=y[0];for(let g=1;g<y.length;g++){const l=y[g];v(l,d)>0&&(d=l)}return d}function w(y,v){if(y.length===0)return;let d=y[0];for(let g=1;g<y.length;g++){const l=y[g];v(l,d)>=0&&(d=l)}return d}function m(y,v){return D(y,(d,g)=>-v(d,g))}function h(y,v){if(y.length===0)return-1;let d=0;for(let g=1;g<y.length;g++){const l=y[g];v(l,y[d])>0&&(d=g)}return d}function u(y,v){for(const d of y){const g=v(d);if(g!==void 0)return g}}}),define(le[126],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=L,e.diffSets=U,e.diffMaps=O,e.intersection=A;function L(_,R){const P=Object.create(null);for(const f of _){const D=R(f);let w=P[D];w||(w=P[D]=[]),w.push(f)}return P}function U(_,R){const P=[],f=[];for(const D of _)R.has(D)||P.push(D);for(const D of R)_.has(D)||f.push(D);return{removed:P,added:f}}function O(_,R){const P=[],f=[];for(const[D,w]of _)R.has(D)||P.push(w);for(const[D,w]of R)_.has(D)||f.push(w);return{removed:P,added:f}}function A(_,R){const P=new Set;for(const f of R)_.has(f)&&P.add(f);return P}}),define(le[84],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=U,e.debounce=O,e.throttle=A;function L(_){return(R,P,f)=>{let D=null,w=null;if(typeof f.value=="function"?(D="value",w=f.value):typeof f.get=="function"&&(D="get",w=f.get),!w)throw new Error("not supported");f[D]=_(w,P)}}function U(_,R,P){let f=null,D=null;if(typeof P.value=="function"?(f="value",D=P.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(f="get",D=P.get),!D)throw new Error("not supported");const w=`$memoize$${R}`;P[f]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,m)}),this[w]}}function O(_,R,P){return L((f,D)=>{const w=`$debounce$${D}`,m=`$debounce$result$${D}`;return function(...h){this[m]||(this[m]=P?P():void 0),clearTimeout(this[w]),R&&(this[m]=R(this[m],...h),h=[this[m]]),this[w]=setTimeout(()=>{f.apply(this,h),this[m]=P?P():void 0},_)}})}function A(_,R,P){return L((f,D)=>{const w=`$throttle$timer$${D}`,m=`$throttle$result$${D}`,h=`$throttle$lastRun$${D}`,u=`$throttle$pending$${D}`;return function(...y){if(this[m]||(this[m]=P?P():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...y)),this[u])return;const v=this[h]+_;v<=Date.now()?(this[h]=Date.now(),f.apply(this,[this[m]]),this[m]=P?P():void 0):(this[u]=!0,this[w]=setTimeout(()=>{this[u]=!1,this[h]=Date.now(),f.apply(this,[this[m]]),this[m]=P?P():void 0},v-Date.now()))}})}}),define(le[7],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=U,e.isSigPipeError=O,e.onUnexpectedError=A,e.onUnexpectedExternalError=_,e.transformErrorForSerialization=R,e.isCancellationError=f,e.canceled=w,e.illegalArgument=m,e.illegalState=h,e.getErrorMessage=y;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=L,e.errorHandler=new L;function U(S){e.errorHandler.setUnexpectedErrorHandler(S)}function O(S){if(!S||typeof S!="object")return!1;const i=S;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(S){f(S)||e.errorHandler.onUnexpectedError(S)}function _(S){f(S)||e.errorHandler.onUnexpectedExternalError(S)}function R(S){if(S instanceof Error){const{name:i,message:o}=S,n=S.stacktrace||S.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:l.isErrorNoTelemetry(S)}}return S}const P="Canceled";function f(S){return S instanceof D?!0:S instanceof Error&&S.name===P&&S.message===P}class D extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=D;function w(){const S=new Error(P);return S.name=S.message,S}function m(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}function h(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}class u extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=u;function y(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}class v extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=v;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=d;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const o=new l;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=l;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.BugIndicatingError=c}),define(le[17],ue([0,1,7,125]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=O,e.tail2=A,e.equals=_,e.removeFastWithoutKeepingOrder=R,e.binarySearch=P,e.binarySearch2=f,e.quickSelect=D,e.groupBy=w,e.groupAdjacentBy=m,e.forEachAdjacent=h,e.forEachWithNeighbors=u,e.sortedDiff=y,e.delta=v,e.top=d,e.topAsync=g,e.coalesce=c,e.coalesceInPlace=S,e.move=i,e.isFalsyOrEmpty=o,e.isNonEmptyArray=n,e.distinct=s,e.uniqueFilter=t,e.firstOrDefault=r,e.lastOrDefault=a,e.commonPrefixLength=E,e.flatten=C,e.range=b,e.index=I,e.insert=p,e.remove=k,e.arrayInsert=N,e.shuffle=F,e.pushToStart=x,e.pushToEnd=Z,e.pushMany=B,e.mapArrayOrNot=X,e.asArray=j,e.getRandomElement=G,e.insertInto=z,e.splice=q,e.compareBy=te,e.tieBreakComparators=ce,e.reverseOrder=T;function O(H,ee=0){return H[H.length-(1+ee)]}function A(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function _(H,ee,Q=(Y,ne)=>Y===ne){if(H===ee)return!0;if(!H||!ee||H.length!==ee.length)return!1;for(let Y=0,ne=H.length;Y<ne;Y++)if(!Q(H[Y],ee[Y]))return!1;return!0}function R(H,ee){const Q=H.length-1;ee<Q&&(H[ee]=H[Q]),H.pop()}function P(H,ee,Q){return f(H.length,Y=>Q(H[Y],ee))}function f(H,ee){let Q=0,Y=H-1;for(;Q<=Y;){const ne=(Q+Y)/2|0,re=ee(ne);if(re<0)Q=ne+1;else if(re>0)Y=ne-1;else return ne}return-(Q+1)}function D(H,ee,Q){if(H=H|0,H>=ee.length)throw new TypeError("invalid index");const Y=ee[Math.floor(ee.length*Math.random())],ne=[],re=[],he=[];for(const fe of ee){const me=Q(fe,Y);me<0?ne.push(fe):me>0?re.push(fe):he.push(fe)}return H<ne.length?D(H,ne,Q):H<ne.length+he.length?he[0]:D(H-(ne.length+he.length),re,Q)}function w(H,ee){const Q=[];let Y;for(const ne of H.slice(0).sort(ee))!Y||ee(Y[0],ne)!==0?(Y=[ne],Q.push(Y)):Y.push(ne);return Q}function*m(H,ee){let Q,Y;for(const ne of H)Y!==void 0&&ee(Y,ne)?Q.push(ne):(Q&&(yield Q),Q=[ne]),Y=ne;Q&&(yield Q)}function h(H,ee){for(let Q=0;Q<=H.length;Q++)ee(Q===0?void 0:H[Q-1],Q===H.length?void 0:H[Q])}function u(H,ee){for(let Q=0;Q<H.length;Q++)ee(Q===0?void 0:H[Q-1],H[Q],Q+1===H.length?void 0:H[Q+1])}function y(H,ee,Q){const Y=[];function ne(fe,me,Ee){if(me===0&&Ee.length===0)return;const Ie=Y[Y.length-1];Ie&&Ie.start+Ie.deleteCount===fe?(Ie.deleteCount+=me,Ie.toInsert.push(...Ee)):Y.push({start:fe,deleteCount:me,toInsert:Ee})}let re=0,he=0;for(;;){if(re===H.length){ne(re,0,ee.slice(he));break}if(he===ee.length){ne(re,H.length-re,[]);break}const fe=H[re],me=ee[he],Ee=Q(fe,me);Ee===0?(re+=1,he+=1):Ee<0?(ne(re,1,[]),re+=1):Ee>0&&(ne(re,0,[me]),he+=1)}return Y}function v(H,ee,Q){const Y=y(H,ee,Q),ne=[],re=[];for(const he of Y)ne.push(...H.slice(he.start,he.start+he.deleteCount)),re.push(...he.toInsert);return{removed:ne,added:re}}function d(H,ee,Q){if(Q===0)return[];const Y=H.slice(0,Q).sort(ee);return l(H,ee,Y,Q,H.length),Y}function g(H,ee,Q,Y,ne){return Q===0?Promise.resolve([]):new Promise((re,he)=>{(async()=>{const fe=H.length,me=H.slice(0,Q).sort(ee);for(let Ee=Q,Ie=Math.min(Q+Y,fe);Ee<fe;Ee=Ie,Ie=Math.min(Ie+Y,fe)){if(Ee>Q&&await new Promise(Le=>setTimeout(Le)),ne&&ne.isCancellationRequested)throw new L.CancellationError;l(H,ee,me,Ee,Ie)}return me})().then(re,he)})}function l(H,ee,Q,Y,ne){for(const re=Q.length;Y<ne;Y++){const he=H[Y];if(ee(he,Q[re-1])<0){Q.pop();const fe=(0,U.findFirstIdxMonotonousOrArrLen)(Q,me=>ee(he,me)<0);Q.splice(fe,0,he)}}}function c(H){return H.filter(ee=>!!ee)}function S(H){let ee=0;for(let Q=0;Q<H.length;Q++)H[Q]&&(H[ee]=H[Q],ee+=1);H.length=ee}function i(H,ee,Q){H.splice(Q,0,H.splice(ee,1)[0])}function o(H){return!Array.isArray(H)||H.length===0}function n(H){return Array.isArray(H)&&H.length>0}function s(H,ee=Q=>Q){const Q=new Set;return H.filter(Y=>{const ne=ee(Y);return Q.has(ne)?!1:(Q.add(ne),!0)})}function t(H){const ee=new Set;return Q=>{const Y=H(Q);return ee.has(Y)?!1:(ee.add(Y),!0)}}function r(H,ee){return H.length>0?H[0]:ee}function a(H,ee){return H.length>0?H[H.length-1]:ee}function E(H,ee,Q=(Y,ne)=>Y===ne){let Y=0;for(let ne=0,re=Math.min(H.length,ee.length);ne<re&&Q(H[ne],ee[ne]);ne++)Y++;return Y}function C(H){return[].concat(...H)}function b(H,ee){let Q=typeof ee=="number"?H:0;typeof ee=="number"?Q=H:(Q=0,ee=H);const Y=[];if(Q<=ee)for(let ne=Q;ne<ee;ne++)Y.push(ne);else for(let ne=Q;ne>ee;ne--)Y.push(ne);return Y}function I(H,ee,Q){return H.reduce((Y,ne)=>(Y[ee(ne)]=Q?Q(ne):ne,Y),Object.create(null))}function p(H,ee){return H.push(ee),()=>k(H,ee)}function k(H,ee){const Q=H.indexOf(ee);if(Q>-1)return H.splice(Q,1),ee}function N(H,ee,Q){const Y=H.slice(0,ee),ne=H.slice(ee);return Y.concat(Q,ne)}function F(H,ee){let Q;if(typeof ee=="number"){let Y=ee;Q=()=>{const ne=Math.sin(Y++)*179426549;return ne-Math.floor(ne)}}else Q=Math.random;for(let Y=H.length-1;Y>0;Y-=1){const ne=Math.floor(Q()*(Y+1)),re=H[Y];H[Y]=H[ne],H[ne]=re}}function x(H,ee){const Q=H.indexOf(ee);Q>-1&&(H.splice(Q,1),H.unshift(ee))}function Z(H,ee){const Q=H.indexOf(ee);Q>-1&&(H.splice(Q,1),H.push(ee))}function B(H,ee){for(const Q of ee)H.push(Q)}function X(H,ee){return Array.isArray(H)?H.map(ee):ee(H)}function j(H){return Array.isArray(H)?H:[H]}function G(H){return H[Math.floor(Math.random()*H.length)]}function z(H,ee,Q){const Y=ie(H,ee),ne=H.length,re=Q.length;H.length=ne+re;for(let he=ne-1;he>=Y;he--)H[he+re]=H[he];for(let he=0;he<re;he++)H[he+Y]=Q[he]}function q(H,ee,Q,Y){const ne=ie(H,ee);let re=H.splice(ne,Q);return re===void 0&&(re=[]),z(H,ne,Y),re}function ie(H,ee){return ee<0?Math.max(ee+H.length,0):Math.min(ee,H.length)}var ae;(function(H){function ee(re){return re<0}H.isLessThan=ee;function Q(re){return re<=0}H.isLessThanOrEqual=Q;function Y(re){return re>0}H.isGreaterThan=Y;function ne(re){return re===0}H.isNeitherLessOrGreaterThan=ne,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function te(H,ee){return(Q,Y)=>ee(H(Q),H(Y))}function ce(...H){return(ee,Q)=>{for(const Y of H){const ne=Y(ee,Q);if(!ae.isNeitherLessOrGreaterThan(ne))return ne}return ae.neitherLessOrGreaterThan}}const V=(H,ee)=>H-ee;e.numberComparator=V;const $=(H,ee)=>(0,e.numberComparator)(H?1:0,ee?1:0);e.booleanComparator=$;function T(H){return(ee,Q)=>-H(ee,Q)}class M{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let Q=this.firstIdx;for(;Q<this.items.length&&ee(this.items[Q]);)Q++;const Y=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,Y}takeFromEndWhile(ee){let Q=this.lastIdx;for(;Q>=0&&ee(this.items[Q]);)Q--;const Y=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,Y}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const Q=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,Q}}e.ArrayQueue=M;class W{static{this.empty=new W(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(Q=>(ee(Q),!0))}toArray(){const ee=[];return this.iterate(Q=>(ee.push(Q),!0)),ee}filter(ee){return new W(Q=>this.iterate(Y=>ee(Y)?Q(Y):!0))}map(ee){return new W(Q=>this.iterate(Y=>Q(ee(Y))))}some(ee){let Q=!1;return this.iterate(Y=>(Q=ee(Y),!Q)),Q}findFirst(ee){let Q;return this.iterate(Y=>ee(Y)?(Q=Y,!1):!0),Q}findLast(ee){let Q;return this.iterate(Y=>(ee(Y)&&(Q=Y),!0)),Q}findLastMaxBy(ee){let Q,Y=!0;return this.iterate(ne=>((Y||ae.isGreaterThan(ee(ne,Q)))&&(Y=!1,Q=ne),!0)),Q}}e.CallbackIterable=W;class J{constructor(ee){this._indexMap=ee}static createSortPermutation(ee,Q){const Y=Array.from(ee.keys()).sort((ne,re)=>Q(ee[ne],ee[re]));return new J(Y)}apply(ee){return ee.map((Q,Y)=>ee[this._indexMap[Y]])}inverse(){const ee=this._indexMap.slice();for(let Q=0;Q<this._indexMap.length;Q++)ee[this._indexMap[Q]]=Q;return new J(ee)}}e.Permutation=J}),define(le[127],ue([0,1,7]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=U,e.assertNever=O,e.assert=A,e.softAssert=_,e.assertFn=R,e.checkAdjacentItems=P;function U(f,D){if(!f)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}function O(f,D="Unreachable"){throw new Error(D)}function A(f){if(!f)throw new L.BugIndicatingError("Assertion Failed")}function _(f){f||(0,L.onUnexpectedError)(new L.BugIndicatingError("Soft Assertion Failed"))}function R(f){if(!f()){debugger;f(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}function P(f,D){let w=0;for(;w<f.length-1;){const m=f[w],h=f[w+1];if(!D(m,h))return!1;w++}return!0}}),define(le[85],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=L;function L(U,O){const A=this;let _=!1,R;return function(){if(_)return R;if(_=!0,O)try{R=U.apply(A,arguments)}finally{O()}else R=U.apply(A,arguments);return R}}}),define(le[61],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(U){function O(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}U.is=O;const A=Object.freeze([]);function _(){return A}U.empty=_;function*R(i){yield i}U.single=R;function P(i){return O(i)?i:R(i)}U.wrap=P;function f(i){return i||A}U.from=f;function*D(i){for(let o=i.length-1;o>=0;o--)yield i[o]}U.reverse=D;function w(i){return!i||i[Symbol.iterator]().next().done===!0}U.isEmpty=w;function m(i){return i[Symbol.iterator]().next().value}U.first=m;function h(i,o){for(const n of i)if(o(n))return!0;return!1}U.some=h;function u(i,o){for(const n of i)if(o(n))return n}U.find=u;function*y(i,o){for(const n of i)o(n)&&(yield n)}U.filter=y;function*v(i,o){let n=0;for(const s of i)yield o(s,n++)}U.map=v;function*d(...i){for(const o of i)yield*o}U.concat=d;function g(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}U.reduce=g;function*l(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}U.slice=l;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,U.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}U.consume=c;async function S(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}U.asyncToArray=S})(L||(e.Iterable=L={}))}),define(le[34],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=_,e.getLocation=w,e.parse=m,e.parseTree=h,e.findNodeAtLocation=u,e.getNodePath=y,e.getNodeValue=v,e.contains=d,e.findNodeAtOffset=g,e.visit=l,e.stripComments=c,e.getNodeType=S;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var U;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(U||(e.SyntaxKind=U={}));var O;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function _(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,E=0;function C(x){let Z=0,B=0;for(;Z<x;){const X=i.charCodeAt(n);if(X>=48&&X<=57)B=B*16+X-48;else if(X>=65&&X<=70)B=B*16+X-65+10;else if(X>=97&&X<=102)B=B*16+X-97+10;else break;n++,Z++}return Z<x&&(B=-1),B}function b(x){n=x,t="",r=0,a=16,E=0}function I(){const x=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&f(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&f(i.charCodeAt(n)))for(n++;n<i.length&&f(i.charCodeAt(n));)n++;else return E=3,i.substring(x,n);let Z=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&f(i.charCodeAt(n))){for(n++;n<i.length&&f(i.charCodeAt(n));)n++;Z=n}else E=3;return i.substring(x,Z)}function p(){let x="",Z=n;for(;;){if(n>=s){x+=i.substring(Z,n),E=2;break}const B=i.charCodeAt(n);if(B===34){x+=i.substring(Z,n),n++;break}if(B===92){if(x+=i.substring(Z,n),n++,n>=s){E=2;break}switch(i.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const j=C(4);j>=0?x+=String.fromCharCode(j):E=4;break}default:E=5}Z=n;continue}if(B>=0&&B<=31)if(P(B)){x+=i.substring(Z,n),E=2;break}else E=6;n++}return x}function k(){if(t="",E=0,r=n,n>=s)return r=s,a=17;let x=i.charCodeAt(n);if(R(x)){do n++,t+=String.fromCharCode(x),x=i.charCodeAt(n);while(R(x));return a=15}if(P(x))return n++,t+=String.fromCharCode(x),x===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(x){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=p(),a=10;case 47:{const Z=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(i.charCodeAt(n));)n++;return t=i.substring(Z,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const B=s-1;let X=!1;for(;n<B;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,E=1),t=i.substring(Z,n),a=13}return t+=String.fromCharCode(x),n++,a=16}case 45:if(t+=String.fromCharCode(x),n++,n===s||!f(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=I(),a=11;default:for(;n<s&&N(x);)n++,x=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(x),n++,a=16}}function N(x){if(R(x)||P(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let x;do x=k();while(x>=12&&x<=15);return x}return{setPosition:b,getPosition:()=>n,scan:o?F:k,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>E}}function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function f(i){return i>=48&&i<=57}var D;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(D||(D={}));function w(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function E(C,b,I,p){r.value=C,r.offset=b,r.length=I,r.type=p,r.colonOffset=void 0,t=r}try{l(i,{onObjectBegin:(C,b)=>{if(o<=C)throw s;t=void 0,a=o>C,n.push("")},onObjectProperty:(C,b,I)=>{if(o<b||(E(C,b,I,"property"),n[n.length-1]=C,o<=b+I))throw s},onObjectEnd:(C,b)=>{if(o<=C)throw s;t=void 0,n.pop()},onArrayBegin:(C,b)=>{if(o<=C)throw s;t=void 0,n.push(0)},onArrayEnd:(C,b)=>{if(o<=C)throw s;t=void 0,n.pop()},onLiteralValue:(C,b,I)=>{if(o<b||(E(C,b,I,S(C)),o<=b+I))throw s},onSeparator:(C,b,I)=>{if(o<=b)throw s;if(C===":"&&t&&t.type==="property")t.colonOffset=b,a=!1,t=void 0;else if(C===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(C){if(C!==s)throw C}return{path:n,previousNode:t,isAtPropertyKey:a,matches:C=>{let b=0;for(let I=0;b<C.length&&I<n.length;I++)if(C[b]===n[I]||C[b]==="*")b++;else if(C[b]!=="**")return!1;return b===C.length}}}function m(i,o=[],n=A.DEFAULT){let s=null,t=[];const r=[];function a(C){Array.isArray(t)?t.push(C):s!==null&&(t[s]=C)}return l(i,{onObjectBegin:()=>{const C={};a(C),r.push(t),t=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const C=[];a(C),r.push(t),t=C,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(C,b,I)=>{o.push({error:C,offset:b,length:I})}},n),t[0]}function h(i,o=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(C){s.type==="property"&&(s.length=C-s.offset,s=s.parent)}function r(C){return s.children.push(C),C}l(i,{onObjectBegin:C=>{s=r({type:"object",offset:C,length:-1,parent:s,children:[]})},onObjectProperty:(C,b,I)=>{s=r({type:"property",offset:b,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:C,offset:b,length:I,parent:s})},onObjectEnd:(C,b)=>{s.length=C+b-s.offset,s=s.parent,t(C+b)},onArrayBegin:(C,b)=>{s=r({type:"array",offset:C,length:-1,parent:s,children:[]})},onArrayEnd:(C,b)=>{s.length=C+b-s.offset,s=s.parent,t(C+b)},onLiteralValue:(C,b,I)=>{r({type:S(C),offset:b,length:I,parent:s,value:C}),t(b+I)},onSeparator:(C,b,I)=>{s.type==="property"&&(C===":"?s.colonOffset=b:C===","&&t(b))},onError:(C,b,I)=>{o.push({error:C,offset:b,length:I})}},n);const E=s.children[0];return E&&delete E.parent,E}function u(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function y(i){if(!i.parent||!i.parent.children)return[];const o=y(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function v(i){switch(i.type){case"array":return i.children.map(v);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=v(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function g(i,o,n=!1){if(d(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=g(s[t],o,n);if(r)return r}return i}}function l(i,o,n=A.DEFAULT){const s=_(i,!1);function t(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(te){return te?ce=>te(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),E=r(o.onObjectProperty),C=t(o.onObjectEnd),b=t(o.onArrayBegin),I=t(o.onArrayEnd),p=r(o.onLiteralValue),k=r(o.onSeparator),N=t(o.onComment),F=r(o.onError),x=n&&n.disallowComments,Z=n&&n.allowTrailingComma;function B(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:x||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(te){case 12:case 13:x?X(10):N();break;case 16:X(1);break;case 15:case 14:break;default:return te}}}function X(te,ce=[],V=[]){if(F(te),ce.length+V.length>0){let $=s.getToken();for(;$!==17;){if(ce.indexOf($)!==-1){B();break}else if(V.indexOf($)!==-1)break;$=B()}}}function j(te){const ce=s.getTokenValue();return te?p(ce):E(ce),B(),!0}function G(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(X(2),te=0)}catch{X(2)}p(te);break}case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return B(),!0}function z(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(j(!1),s.getToken()===6?(k(":"),B(),ae()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function q(){a(),B();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||X(4,[],[]),k(","),B(),s.getToken()===2&&Z)break}else te&&X(6,[],[]);z()||X(4,[],[2,5]),te=!0}return C(),s.getToken()!==2?X(7,[2],[]):B(),!0}function ie(){b(),B();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||X(4,[],[]),k(","),B(),s.getToken()===4&&Z)break}else te&&X(6,[],[]);ae()||X(4,[],[4,5]),te=!0}return I(),s.getToken()!==4?X(8,[4],[]):B(),!0}function ae(){switch(s.getToken()){case 3:return ie();case 1:return q();case 10:return j(!0);default:return G()}}return B(),s.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):ae()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}function c(i,o){const n=_(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[43],ue([0,1,34]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=U,e.toFormattedString=O,e.getEOL=R,e.isEOL=P;function U(f,D,w){let m,h,u,y,v;if(D){for(y=D.offset,v=y+D.length,u=y;u>0&&!P(f,u-1);)u--;let a=v;for(;a<f.length&&!P(f,a);)a++;h=f.substring(u,a),m=_(h,w)}else h=f,m=0,u=0,y=0,v=f.length;const d=R(w,f);let g=!1,l=0,c;w.insertSpaces?c=A(" ",w.tabSize||4):c="	";const S=(0,L.createScanner)(h,!1);let i=!1;function o(){return d+A(c,m+l)}function n(){let a=S.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=S.scan();return i=a===16||S.getTokenError()!==0,a}const s=[];function t(a,E,C){!i&&E<v&&C>y&&f.substring(E,C)!==a&&s.push({offset:E,length:C-E,content:a})}let r=n();if(r!==17){const a=S.getTokenOffset()+u,E=A(c,m);t(E,u,a)}for(;r!==17;){let a=S.getTokenOffset()+S.getTokenLength()+u,E=n(),C="";for(;!g&&(E===12||E===13);){const I=S.getTokenOffset()+u;t(" ",a,I),a=S.getTokenOffset()+S.getTokenLength()+u,C=E===12?o():"",E=n()}if(E===2)r!==1&&(l--,C=o());else if(E===4)r!==3&&(l--,C=o());else{switch(r){case 3:case 1:l++,C=o();break;case 5:case 12:C=o();break;case 13:g?C=o():C=" ";break;case 6:C=" ";break;case 10:if(E===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?C=" ":E!==5&&E!==17&&(i=!0);break;case 16:i=!0;break}g&&(E===12||E===13)&&(C=o())}const b=S.getTokenOffset()+u;t(C,a,b),r=E}return s}function O(f,D){const w=JSON.stringify(f,void 0,D.insertSpaces?D.tabSize||4:"	");return D.eol!==void 0?w.replace(/\r\n|\r|\n/g,D.eol):w}function A(f,D){let w="";for(let m=0;m<D;m++)w+=f;return w}function _(f,D){let w=0,m=0;const h=D.tabSize||4;for(;w<f.length;){const u=f.charAt(w);if(u===" ")m++;else if(u==="	")m+=h;else break;w++}return Math.floor(m/h)}function R(f,D){for(let w=0;w<D.length;w++){const m=D.charAt(w);if(m==="\r")return w+1<D.length&&D.charAt(w+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return f&&f.eol||`
`}function P(f,D){return`\r
`.indexOf(f.charAt(D))!==-1}}),define(le[62],ue([0,1,34,43]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=O,e.setProperty=A,e.withFormatting=_,e.applyEdit=R,e.applyEdits=P;function O(f,D,w){return A(f,D,void 0,w)}function A(f,D,w,m,h){const u=D.slice(),y=[],v=(0,L.parseTree)(f,y);let d,g;for(;u.length>0&&(g=u.pop(),d=(0,L.findNodeAtLocation)(v,u),d===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(d)if(d.type==="object"&&typeof g=="string"&&Array.isArray(d.children)){const l=(0,L.findNodeAtLocation)(d,[g]);if(l!==void 0)if(w===void 0){if(!l.parent)throw new Error("Malformed AST");const c=d.children.indexOf(l.parent);let S,i=l.parent.offset+l.parent.length;if(c>0){const o=d.children[c-1];S=o.offset+o.length}else S=d.offset+1,d.children.length>1&&(i=d.children[1].offset);return _(f,{offset:S,length:i-S,content:""},m)}else return _(f,{offset:l.offset,length:l.length,content:JSON.stringify(w)},m);else{if(w===void 0)return[];const c=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,S=h?h(d.children.map(o=>o.children[0].value)):d.children.length;let i;if(S>0){const o=d.children[S-1];i={offset:o.offset+o.length,length:0,content:","+c}}else d.children.length===0?i={offset:d.offset+1,length:0,content:c}:i={offset:d.offset+1,length:0,content:c+","};return _(f,i,m)}}else if(d.type==="array"&&typeof g=="number"&&Array.isArray(d.children))if(w!==void 0){const l=`${JSON.stringify(w)}`;let c;if(d.children.length===0||g===0)c={offset:d.offset+1,length:0,content:d.children.length===0?l:l+","};else{const S=g===-1||g>d.children.length?d.children.length:g,i=d.children[S-1];c={offset:i.offset+i.length,length:0,content:","+l}}return _(f,c,m)}else{const l=g,c=d.children[l];let S;if(d.children.length===1)S={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===l){const i=d.children[l-1],o=i.offset+i.length,n=d.offset+d.length;S={offset:o,length:n-2-o,content:""}}else S={offset:c.offset,length:d.children[l+1].offset-c.offset,content:""};return _(f,S,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${d.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return _(f,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(w)},m)}}function _(f,D,w){let m=R(f,D),h=D.offset,u=D.offset+D.content.length;if(D.length===0||D.content.length===0){for(;h>0&&!(0,U.isEOL)(m,h-1);)h--;for(;u<m.length&&!(0,U.isEOL)(m,u);)u++}const y=(0,U.format)(m,{offset:h,length:u-h},w);for(let d=y.length-1;d>=0;d--){const g=y[d];m=R(m,g),h=Math.min(h,g.offset),u=Math.max(u,g.offset+g.length),u+=g.content.length-g.length}const v=f.length-(m.length-u)-h;return[{offset:h,length:v,content:m.substring(h,u)}]}function R(f,D){return f.substring(0,D.offset)+D.content+f.substring(D.offset+D.length)}function P(f,D){const w=D.slice(0).sort((h,u)=>{const y=h.offset-u.offset;return y===0?h.length-u.length:y});let m=f.length;for(let h=w.length-1;h>=0;h--){const u=w[h];if(u.offset+u.length<=m)f=R(f,u);else throw new Error("Overlapping edit");m=u.offset}return f}}),define(le[53],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(O){this.executor=O,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(O){this._error=O}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=L}),define(le[86],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{static{this.Undefined=new L(void 0)}constructor(A){this.element=A,this.next=L.Undefined,this.prev=L.Undefined}}class U{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let A=this._first;for(;A!==L.Undefined;){const _=A.next;A.prev=L.Undefined,A.next=L.Undefined,A=_}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,_){const R=new L(A);if(this._first===L.Undefined)this._first=R,this._last=R;else if(_){const f=this._last;this._last=R,R.prev=f,f.next=R}else{const f=this._first;this._first=R,R.next=f,f.prev=R}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==L.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==L.Undefined&&A.next!==L.Undefined){const _=A.prev;_.next=A.next,A.next.prev=_}else A.prev===L.Undefined&&A.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):A.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):A.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==L.Undefined;)yield A.element,A=A.next}}e.LinkedList=U}),define(le[35],ue([0,1]),function(se,e){"use strict";var L,U,O;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=A,e.mapToString=_,e.setToString=R,e.mapsStrictEqualIgnoreOrder=g;function A(l,c,S){let i=l.get(c);return i===void 0&&(i=S,l.set(c,i)),i}function _(l){const c=[];return l.forEach((S,i)=>{c.push(`${i} => ${S}`)}),`Map(${l.size}) {${c.join(", ")}}`}function R(l){const c=[];return l.forEach(S=>{c.push(S)}),`Set(${l.size}) {${c.join(", ")}}`}class P{constructor(c,S){this.uri=c,this.value=S}}function f(l){return Array.isArray(l)}class D{static{this.defaultToKey=c=>c.toString()}constructor(c,S){if(this[L]="ResourceMap",c instanceof D)this.map=new Map(c.map),this.toKey=S??D.defaultToKey;else if(f(c)){this.map=new Map,this.toKey=S??D.defaultToKey;for(const[i,o]of c)this.set(i,o)}else this.map=new Map,this.toKey=c??D.defaultToKey}set(c,S){return this.map.set(this.toKey(c),new P(c,S)),this}get(c){return this.map.get(this.toKey(c))?.value}has(c){return this.map.has(this.toKey(c))}get size(){return this.map.size}clear(){this.map.clear()}delete(c){return this.map.delete(this.toKey(c))}forEach(c,S){typeof S<"u"&&(c=c.bind(S));for(const[i,o]of this.map)c(o.value,o.uri,this)}*values(){for(const c of this.map.values())yield c.value}*keys(){for(const c of this.map.values())yield c.uri}*entries(){for(const c of this.map.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.map)yield[c.uri,c.value]}}e.ResourceMap=D;class w{constructor(c,S){this[U]="ResourceSet",!c||typeof c=="function"?this._map=new D(c):(this._map=new D(S),c.forEach(this.add,this))}get size(){return this._map.size}add(c){return this._map.set(c,c),this}clear(){this._map.clear()}delete(c){return this._map.delete(c)}forEach(c,S){this._map.forEach((i,o)=>c.call(S,o,o,this))}has(c){return this._map.has(c)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=w;var m;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class h{constructor(){this[O]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(c){return this._map.has(c)}get(c,S=0){const i=this._map.get(c);if(i)return S!==0&&this.touch(i,S),i.value}set(c,S,i=0){let o=this._map.get(c);if(o)o.value=S,i!==0&&this.touch(o,i);else{switch(o={key:c,value:S,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(c,o),this._size++}return this}delete(c){return!!this.remove(c)}remove(c){const S=this._map.get(c);if(S)return this._map.delete(c),this.removeItem(S),this._size--,S.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const c=this._head;return this._map.delete(c.key),this.removeItem(c),this._size--,c.value}forEach(c,S){const i=this._state;let o=this._head;for(;o;){if(S?c.bind(S)(o.value,o.key,this):c(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,S=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==S)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,S=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==S)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,S=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(c._state!==S)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(c){if(c>=this.size)return;if(c===0){this.clear();return}let S=this._head,i=this.size;for(;S&&i>c;)this._map.delete(S.key),S=S.next,i--;this._head=S,this._size=i,S&&(S.previous=void 0),this._state++}addItemFirst(c){if(!this._head&&!this._tail)this._tail=c;else if(this._head)c.next=this._head,this._head.previous=c;else throw new Error("Invalid list");this._head=c,this._state++}addItemLast(c){if(!this._head&&!this._tail)this._head=c;else if(this._tail)c.previous=this._tail,this._tail.next=c;else throw new Error("Invalid list");this._tail=c,this._state++}removeItem(c){if(c===this._head&&c===this._tail)this._head=void 0,this._tail=void 0;else if(c===this._head){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this._head=c.next}else if(c===this._tail){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this._tail=c.previous}else{const S=c.next,i=c.previous;if(!S||!i)throw new Error("Invalid list");S.previous=i,i.next=S}c.next=void 0,c.previous=void 0,this._state++}touch(c,S){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(S!==1&&S!==2)){if(S===1){if(c===this._head)return;const i=c.next,o=c.previous;c===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this._head,this._head.previous=c,this._head=c,this._state++}else if(S===2){if(c===this._tail)return;const i=c.next,o=c.previous;c===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this._tail,this._tail.next=c,this._tail=c,this._state++}}}toJSON(){const c=[];return this.forEach((S,i)=>{c.push([i,S])}),c}fromJSON(c){this.clear();for(const[S,i]of c)this.set(S,i)}}e.LinkedMap=h;class u extends h{constructor(c,S=1){super(),this._limit=c,this._ratio=Math.min(Math.max(0,S),1)}get limit(){return this._limit}set limit(c){this._limit=c,this.checkTrim()}get ratio(){return this._ratio}set ratio(c){this._ratio=Math.min(Math.max(0,c),1),this.checkTrim()}get(c,S=2){return super.get(c,S)}peek(c){return super.get(c,0)}set(c,S){return super.set(c,S,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class y{constructor(){this.map=new Map}add(c){return this.map.set(c,(this.map.get(c)||0)+1),this}delete(c){let S=this.map.get(c)||0;return S===0?!1:(S--,S===0?this.map.delete(c):this.map.set(c,S),!0)}has(c){return this.map.has(c)}}e.CounterSet=y;class v{constructor(c){if(this._m1=new Map,this._m2=new Map,c)for(const[S,i]of c)this.set(S,i)}clear(){this._m1.clear(),this._m2.clear()}set(c,S){this._m1.set(c,S),this._m2.set(S,c)}get(c){return this._m1.get(c)}getKey(c){return this._m2.get(c)}delete(c){const S=this._m1.get(c);return S===void 0?!1:(this._m1.delete(c),this._m2.delete(S),!0)}forEach(c,S){this._m1.forEach((i,o)=>{c.call(S,i,o,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=v;class d{constructor(){this.map=new Map}add(c,S){let i=this.map.get(c);i||(i=new Set,this.map.set(c,i)),i.add(S)}delete(c,S){const i=this.map.get(c);i&&(i.delete(S),i.size===0&&this.map.delete(c))}forEach(c,S){const i=this.map.get(c);i&&i.forEach(S)}get(c){const S=this.map.get(c);return S||new Set}}e.SetMap=d;function g(l,c){if(l===c)return!0;if(l.size!==c.size)return!1;for(const[S,i]of l)if(!c.has(S)||c.get(S)!==i)return!1;for(const[S]of c)if(!l.has(S))return!1;return!0}}),define(le[2],ue([0,1,17,126,35,85,61]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=D,e.trackDisposable=w,e.markAsDisposed=m,e.markAsSingleton=y,e.isDisposable=v,e.dispose=d,e.disposeIfDisposable=g,e.combinedDisposable=l,e.toDisposable=c,e.disposeOnReturn=C;const R=!1;let P=null;class f{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(p){let k=this.livingDisposables.get(p);return k||(k={parent:null,source:null,isSingleton:!1,value:p,idx:f.idx++},this.livingDisposables.set(p,k)),k}trackDisposable(p){const k=this.getDisposableData(p);k.source||(k.source=new Error().stack)}setParent(p,k){const N=this.getDisposableData(p);N.parent=k}markAsDisposed(p){this.livingDisposables.delete(p)}markAsSingleton(p){this.getDisposableData(p).isSingleton=!0}getRootParent(p,k){const N=k.get(p);if(N)return N;const F=p.parent?this.getRootParent(this.getDisposableData(p.parent),k):p;return k.set(p,F),F}getTrackedDisposables(){const p=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,p).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(p=10,k){let N;if(k)N=k;else{const X=new Map,j=[...this.livingDisposables.values()].filter(z=>z.source!==null&&!this.getRootParent(z,X).isSingleton);if(j.length===0)return;const G=new Set(j.map(z=>z.value));if(N=j.filter(z=>!(z.parent&&G.has(z.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function F(X){function j(z,q){for(;z.length>0&&q.some(ie=>typeof ie=="string"?ie===z[0]:z[0].match(ie));)z.shift()}const G=X.source.split(`
`).map(z=>z.trim().replace("at ","")).filter(z=>z!=="");return j(G,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),G.reverse()}const x=new O.SetMap;for(const X of N){const j=F(X);for(let G=0;G<=j.length;G++)x.add(j.slice(0,G).join(`
`),X)}N.sort((0,L.compareBy)(X=>X.idx,L.numberComparator));let Z="",B=0;for(const X of N.slice(0,p)){B++;const j=F(X),G=[];for(let z=0;z<j.length;z++){let q=j[z];q=`(shared with ${x.get(j.slice(0,z+1).join(`
`)).size}/${N.length} leaks) at ${q}`;const ae=x.get(j.slice(0,z).join(`
`)),te=(0,U.groupBy)([...ae].map(ce=>F(ce)[z]),ce=>ce);delete te[j[z]];for(const[ce,V]of Object.entries(te))G.unshift(`    - stacktraces of ${V.length} other leaks continue with ${ce}`);G.unshift(q)}Z+=`


==================== Leaking disposable ${B}/${N.length}: ${X.value.constructor.name} ====================
${G.join(`
`)}
============================================================

`}return N.length>p&&(Z+=`


... and ${N.length-p} more leaking disposables

`),{leaks:N,details:Z}}}e.DisposableTracker=f;function D(I){P=I}if(R){const I="__is_disposable_tracked__";D(new class{trackDisposable(p){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[I]||console.log(k)},3e3)}setParent(p,k){if(p&&p!==i.None)try{p[I]=!0}catch{}}markAsDisposed(p){if(p&&p!==i.None)try{p[I]=!0}catch{}}markAsSingleton(p){}})}function w(I){return P?.trackDisposable(I),I}function m(I){P?.markAsDisposed(I)}function h(I,p){P?.setParent(I,p)}function u(I,p){if(P)for(const k of I)P.setParent(k,p)}function y(I){return P?.markAsSingleton(I),I}function v(I){return typeof I.dispose=="function"&&I.dispose.length===0}function d(I){if(_.Iterable.is(I)){const p=[];for(const k of I)if(k)try{k.dispose()}catch(N){p.push(N)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function g(I){for(const p of I)v(p)&&p.dispose();return[]}function l(...I){const p=c(()=>d(I));return u(I,p),p}function c(I){const p=w({dispose:(0,A.createSingleCallFunction)(()=>{m(p),I()})});return p}class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{d(this._toDispose)}finally{this._toDispose.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return h(p,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(p),p.dispose()}}deleteAndLeak(p){p&&this._toDispose.has(p)&&(this._toDispose.delete(p),h(p,null))}}e.DisposableStore=S;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new S,w(this),h(this._store,this)}dispose(){m(this),this._store.dispose()}_register(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(p)}}e.Disposable=i;class o{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(p){this._isDisposed||p===this._value||(this._value?.dispose(),p&&h(p,this),this._value=p)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const p=this._value;return this._value=void 0,p&&h(p,null),p}}e.MutableDisposable=o;class n{constructor(p){this._disposable=new o,this._isDisposed=!1,this._disposable.value=p}get value(){return this._disposable.value}set value(p){this._isDisposed||p===this._disposable.value||(this._disposable.value=p)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class s{constructor(p){this._disposable=p,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(p){let k=p;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,m(this))},this}}e.SafeDisposable=t;class r{constructor(){this.references=new Map}acquire(p,...k){let N=this.references.get(p);N||(N={counter:0,object:this.createReferencedObject(p,...k)},this.references.set(p,N));const{object:F}=N,x=(0,A.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(p,N.object),this.references.delete(p))});return N.counter++,{object:F,dispose:x}}}e.ReferenceCollection=r;class a{constructor(p){this.referenceCollection=p}async acquire(p,...k){const N=this.referenceCollection.acquire(p,...k);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(F){throw N.dispose(),F}}}e.AsyncReferenceCollection=a;class E{constructor(p){this.object=p}dispose(){}}e.ImmortalReference=E;function C(I){const p=new S;try{I(p)}finally{p.dispose()}}class b{constructor(){this._store=new Map,this._isDisposed=!1,w(this)}dispose(){m(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{d(this._store.values())}finally{this._store.clear()}}has(p){return this._store.has(p)}get size(){return this._store.size}get(p){return this._store.get(p)}set(p,k,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(p)?.dispose(),this._store.set(p,k)}deleteAndDispose(p){this._store.get(p)?.dispose(),this._store.delete(p)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=b}),define(le[87],ue([0,1,35]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=O,e.normalizeNFD=_;const U=new L.LRUCache(1e4);function O(f){return P(f,"NFC",U)}const A=new L.LRUCache(1e4);function _(f){return P(f,"NFD",A)}const R=/[^\u0000-\u0080]/;function P(f,D,w){if(!f)return f;const m=w.get(f);if(m)return m;let h;return R.test(f)?h=f.normalize(D):h=f,w.set(f,h),h}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(D){return _(D).replace(f,"")}}()}),function(){function se(O){const A=[];typeof O=="number"&&A.push("code/timeOrigin",O);function _(P){A.push(P,Date.now())}function R(){const P=[];for(let f=0;f<A.length;f+=2)P.push({name:A[f],startTime:A[f+1]});return P}return{mark:_,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const _ of performance.getEntriesByType("mark"))A.push({name:_.name,startTime:Math.round(O+_.startTime)});return A}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function L(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=L(U))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var U in L)(typeof exports=="object"?exports:se)[U]=L[U]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function L(U){if(e[U])return e[U].exports;var O=e[U]={i:U,l:!1,exports:{}};return se[U].call(O.exports,O,O.exports,L),O.l=!0,O.exports}return L.m=se,L.c=e,L.d=function(U,O,A){L.o(U,O)||Object.defineProperty(U,O,{enumerable:!0,get:A})},L.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},L.t=function(U,O){if(1&O&&(U=L(U)),8&O||4&O&&typeof U=="object"&&U&&U.__esModule)return U;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:U}),2&O&&typeof U!="string")for(var _ in U)L.d(A,_,function(R){return U[R]}.bind(null,_));return A},L.n=function(U){var O=U&&U.__esModule?function(){return U.default}:function(){return U};return L.d(O,"a",O),O},L.o=function(U,O){return Object.prototype.hasOwnProperty.call(U,O)},L.p="",L(L.s=0)}([function(se,e,L){(function(U){var O;e=se.exports=V,O=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],f=0,D=f++;P[D]="0|[1-9]\\d*";var w=f++;P[w]="[0-9]+";var m=f++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=f++;P[h]="("+P[D]+")\\.("+P[D]+")\\.("+P[D]+")";var u=f++;P[u]="("+P[w]+")\\.("+P[w]+")\\.("+P[w]+")";var y=f++;P[y]="(?:"+P[D]+"|"+P[m]+")";var v=f++;P[v]="(?:"+P[w]+"|"+P[m]+")";var d=f++;P[d]="(?:-("+P[y]+"(?:\\."+P[y]+")*))";var g=f++;P[g]="(?:-?("+P[v]+"(?:\\."+P[v]+")*))";var l=f++;P[l]="[0-9A-Za-z-]+";var c=f++;P[c]="(?:\\+("+P[l]+"(?:\\."+P[l]+")*))";var S=f++,i="v?"+P[h]+P[d]+"?"+P[c]+"?";P[S]="^"+i+"$";var o="[v=\\s]*"+P[u]+P[g]+"?"+P[c]+"?",n=f++;P[n]="^"+o+"$";var s=f++;P[s]="((?:<|>)?=?)";var t=f++;P[t]=P[w]+"|x|X|\\*";var r=f++;P[r]=P[D]+"|x|X|\\*";var a=f++;P[a]="[v=\\s]*("+P[r]+")(?:\\.("+P[r]+")(?:\\.("+P[r]+")(?:"+P[d]+")?"+P[c]+"?)?)?";var E=f++;P[E]="[v=\\s]*("+P[t]+")(?:\\.("+P[t]+")(?:\\.("+P[t]+")(?:"+P[g]+")?"+P[c]+"?)?)?";var C=f++;P[C]="^"+P[s]+"\\s*"+P[a]+"$";var b=f++;P[b]="^"+P[s]+"\\s*"+P[E]+"$";var I=f++;P[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var p=f++;P[p]="(?:~>?)";var k=f++;P[k]="(\\s*)"+P[p]+"\\s+",R[k]=new RegExp(P[k],"g");var N=f++;P[N]="^"+P[p]+P[a]+"$";var F=f++;P[F]="^"+P[p]+P[E]+"$";var x=f++;P[x]="(?:\\^)";var Z=f++;P[Z]="(\\s*)"+P[x]+"\\s+",R[Z]=new RegExp(P[Z],"g");var B=f++;P[B]="^"+P[x]+P[a]+"$";var X=f++;P[X]="^"+P[x]+P[E]+"$";var j=f++;P[j]="^"+P[s]+"\\s*("+o+")$|^$";var G=f++;P[G]="^"+P[s]+"\\s*("+i+")$|^$";var z=f++;P[z]="(\\s*)"+P[s]+"\\s*("+o+"|"+P[a]+")",R[z]=new RegExp(P[z],"g");var q=f++;P[q]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=f++;P[ie]="^\\s*("+P[E]+")\\s+-\\s+("+P[E]+")\\s*$";var ae=f++;P[ae]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)O(te,P[te]),R[te]||(R[te]=new RegExp(P[te]));function ce(de,Se){if(de instanceof V)return de;if(typeof de!="string"||de.length>A||!(Se?R[n]:R[S]).test(de))return null;try{return new V(de,Se)}catch{return null}}function V(de,Se){if(de instanceof V){if(de.loose===Se)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof V))return new V(de,Se);O("SemVer",de,Se),this.loose=Se;var ye=de.trim().match(Se?R[n]:R[S]);if(!ye)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(De){if(/^[0-9]+$/.test(De)){var Re=+De;if(Re>=0&&Re<_)return Re}return De}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ce,e.valid=function(de,Se){var ye=ce(de,Se);return ye?ye.version:null},e.clean=function(de,Se){var ye=ce(de.trim().replace(/^[=v]+/,""),Se);return ye?ye.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(de){return O("SemVer.compare",this.version,this.loose,de),de instanceof V||(de=new V(de,this.loose)),this.compareMain(de)||this.comparePre(de)},V.prototype.compareMain=function(de){return de instanceof V||(de=new V(de,this.loose)),T(this.major,de.major)||T(this.minor,de.minor)||T(this.patch,de.patch)},V.prototype.comparePre=function(de){if(de instanceof V||(de=new V(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var Se=0;do{var ye=this.prerelease[Se],De=de.prerelease[Se];if(O("prerelease compare",Se,ye,De),ye===void 0&&De===void 0)return 0;if(De===void 0)return 1;if(ye===void 0)return-1;if(ye!==De)return T(ye,De)}while(++Se)},V.prototype.inc=function(de,Se){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,Se,ye,De){typeof ye=="string"&&(De=ye,ye=void 0);try{return new V(de,ye).inc(Se,De).version}catch{return null}},e.diff=function(de,Se){if(H(de,Se))return null;var ye=ce(de),De=ce(Se);if(ye.prerelease.length||De.prerelease.length){for(var Re in ye)if((Re==="major"||Re==="minor"||Re==="patch")&&ye[Re]!==De[Re])return"pre"+Re;return"prerelease"}for(var Re in ye)if((Re==="major"||Re==="minor"||Re==="patch")&&ye[Re]!==De[Re])return Re},e.compareIdentifiers=T;var $=/^[0-9]+$/;function T(de,Se){var ye=$.test(de),De=$.test(Se);return ye&&De&&(de=+de,Se=+Se),ye&&!De?-1:De&&!ye?1:de<Se?-1:de>Se?1:0}function M(de,Se,ye){return new V(de,ye).compare(new V(Se,ye))}function W(de,Se,ye){return M(de,Se,ye)>0}function J(de,Se,ye){return M(de,Se,ye)<0}function H(de,Se,ye){return M(de,Se,ye)===0}function ee(de,Se,ye){return M(de,Se,ye)!==0}function Q(de,Se,ye){return M(de,Se,ye)>=0}function Y(de,Se,ye){return M(de,Se,ye)<=0}function ne(de,Se,ye,De){var Re;switch(Se){case"===":typeof de=="object"&&(de=de.version),typeof ye=="object"&&(ye=ye.version),Re=de===ye;break;case"!==":typeof de=="object"&&(de=de.version),typeof ye=="object"&&(ye=ye.version),Re=de!==ye;break;case"":case"=":case"==":Re=H(de,ye,De);break;case"!=":Re=ee(de,ye,De);break;case">":Re=W(de,ye,De);break;case">=":Re=Q(de,ye,De);break;case"<":Re=J(de,ye,De);break;case"<=":Re=Y(de,ye,De);break;default:throw new TypeError("Invalid operator: "+Se)}return Re}function re(de,Se){if(de instanceof re){if(de.loose===Se)return de;de=de.value}if(!(this instanceof re))return new re(de,Se);O("comparator",de,Se),this.loose=Se,this.parse(de),this.semver===he?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(de,Se){return T(Se,de)},e.major=function(de,Se){return new V(de,Se).major},e.minor=function(de,Se){return new V(de,Se).minor},e.patch=function(de,Se){return new V(de,Se).patch},e.compare=M,e.compareLoose=function(de,Se){return M(de,Se,!0)},e.rcompare=function(de,Se,ye){return M(Se,de,ye)},e.sort=function(de,Se){return de.sort(function(ye,De){return e.compare(ye,De,Se)})},e.rsort=function(de,Se){return de.sort(function(ye,De){return e.rcompare(ye,De,Se)})},e.gt=W,e.lt=J,e.eq=H,e.neq=ee,e.gte=Q,e.lte=Y,e.cmp=ne,e.Comparator=re;var he={};function fe(de,Se){if(de instanceof fe)return de.loose===Se?de:new fe(de.raw,Se);if(de instanceof re)return new fe(de.value,Se);if(!(this instanceof fe))return new fe(de,Se);if(this.loose=Se,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function me(de){return!de||de.toLowerCase()==="x"||de==="*"}function Ee(de,Se,ye,De,Re,Ne,ke,$e,Me,xe,We,Oe,oe){return((Se=me(ye)?"":me(De)?">="+ye+".0.0":me(Re)?">="+ye+"."+De+".0":">="+Se)+" "+($e=me(Me)?"":me(xe)?"<"+(+Me+1)+".0.0":me(We)?"<"+Me+"."+(+xe+1)+".0":Oe?"<="+Me+"."+xe+"."+We+"-"+Oe:"<="+$e)).trim()}function Ie(de,Se){for(var ye=0;ye<de.length;ye++)if(!de[ye].test(Se))return!1;if(Se.prerelease.length){for(ye=0;ye<de.length;ye++)if(O(de[ye].semver),de[ye].semver!==he&&de[ye].semver.prerelease.length>0){var De=de[ye].semver;if(De.major===Se.major&&De.minor===Se.minor&&De.patch===Se.patch)return!0}return!1}return!0}function Le(de,Se,ye){try{Se=new fe(Se,ye)}catch{return!1}return Se.test(de)}function Te(de,Se,ye,De){var Re,Ne,ke,$e,Me;switch(de=new V(de,De),Se=new fe(Se,De),ye){case">":Re=W,Ne=Y,ke=J,$e=">",Me=">=";break;case"<":Re=J,Ne=Q,ke=W,$e="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(de,Se,De))return!1;for(var xe=0;xe<Se.set.length;++xe){var We=Se.set[xe],Oe=null,oe=null;if(We.forEach(function(ge){ge.semver===he&&(ge=new re(">=0.0.0")),Oe=Oe||ge,oe=oe||ge,Re(ge.semver,Oe.semver,De)?Oe=ge:ke(ge.semver,oe.semver,De)&&(oe=ge)}),Oe.operator===$e||Oe.operator===Me||(!oe.operator||oe.operator===$e)&&Ne(de,oe.semver)||oe.operator===Me&&ke(de,oe.semver))return!1}return!0}re.prototype.parse=function(de){var Se=this.loose?R[j]:R[G],ye=de.match(Se);if(!ye)throw new TypeError("Invalid comparator: "+de);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new V(ye[2],this.loose):this.semver=he},re.prototype.toString=function(){return this.value},re.prototype.test=function(de){return O("Comparator.test",de,this.loose),this.semver===he||(typeof de=="string"&&(de=new V(de,this.loose)),ne(de,this.operator,this.semver,this.loose))},re.prototype.intersects=function(de,Se){if(!(de instanceof re))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new fe(de.value,Se),Le(this.value,ye,Se);if(de.operator==="")return ye=new fe(this.value,Se),Le(de.semver,ye,Se);var De=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),Ne=this.semver.version===de.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),$e=ne(this.semver,"<",de.semver,Se)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),Me=ne(this.semver,">",de.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return De||Re||Ne&&ke||$e||Me},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(de){var Se=this.loose;de=de.trim(),O("range",de,Se);var ye=Se?R[ie]:R[q];de=de.replace(ye,Ee),O("hyphen replace",de),de=de.replace(R[z],"$1$2$3"),O("comparator trim",de,R[z]),de=(de=(de=de.replace(R[k],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var De=Se?R[j]:R[G],Re=de.split(" ").map(function(Ne){return function(ke,$e){return O("comp",ke),ke=function(Me,xe){return Me.trim().split(/\s+/).map(function(We){return function(Oe,oe){O("caret",Oe,oe);var ge=oe?R[X]:R[B];return Oe.replace(ge,function(ve,pe,Ce,Pe,_e){var Ue;return O("caret",Oe,ve,pe,Ce,Pe,_e),me(pe)?Ue="":me(Ce)?Ue=">="+pe+".0.0 <"+(+pe+1)+".0.0":me(Pe)?Ue=pe==="0"?">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+".0 <"+(+pe+1)+".0.0":_e?(O("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Ue=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Pe+_e+" <"+pe+"."+Ce+"."+(+Pe+1):">="+pe+"."+Ce+"."+Pe+_e+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Pe+_e+" <"+(+pe+1)+".0.0"):(O("no pr"),Ue=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+Ce+"."+(+Pe+1):">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Pe+" <"+(+pe+1)+".0.0"),O("caret return",Ue),Ue})}(We,xe)}).join(" ")}(ke,$e),O("caret",ke),ke=function(Me,xe){return Me.trim().split(/\s+/).map(function(We){return function(Oe,oe){var ge=oe?R[F]:R[N];return Oe.replace(ge,function(ve,pe,Ce,Pe,_e){var Ue;return O("tilde",Oe,ve,pe,Ce,Pe,_e),me(pe)?Ue="":me(Ce)?Ue=">="+pe+".0.0 <"+(+pe+1)+".0.0":me(Pe)?Ue=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":_e?(O("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),Ue=">="+pe+"."+Ce+"."+Pe+_e+" <"+pe+"."+(+Ce+1)+".0"):Ue=">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+(+Ce+1)+".0",O("tilde return",Ue),Ue})}(We,xe)}).join(" ")}(ke,$e),O("tildes",ke),ke=function(Me,xe){return O("replaceXRanges",Me,xe),Me.split(/\s+/).map(function(We){return function(Oe,oe){Oe=Oe.trim();var ge=oe?R[b]:R[C];return Oe.replace(ge,function(ve,pe,Ce,Pe,_e,Ue){O("xRange",Oe,ve,pe,Ce,Pe,_e,Ue);var ze=me(Ce),qe=ze||me(Pe),Fe=qe||me(_e);return pe==="="&&Fe&&(pe=""),ze?ve=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Fe?(qe&&(Pe=0),Fe&&(_e=0),pe===">"?(pe=">=",qe?(Ce=+Ce+1,Pe=0,_e=0):Fe&&(Pe=+Pe+1,_e=0)):pe==="<="&&(pe="<",qe?Ce=+Ce+1:Pe=+Pe+1),ve=pe+Ce+"."+Pe+"."+_e):qe?ve=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Fe&&(ve=">="+Ce+"."+Pe+".0 <"+Ce+"."+(+Pe+1)+".0"),O("xRange return",ve),ve})}(We,xe)}).join(" ")}(ke,$e),O("xrange",ke),ke=function(Me,xe){return O("replaceStars",Me,xe),Me.trim().replace(R[ae],"")}(ke,$e),O("stars",ke),ke}(Ne,Se)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ne){return!!Ne.match(De)})),Re=Re.map(function(Ne){return new re(Ne,Se)})},fe.prototype.intersects=function(de,Se){if(!(de instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(De){return de.set.some(function(Re){return Re.every(function(Ne){return De.intersects(Ne,Se)})})})})},e.toComparators=function(de,Se){return new fe(de,Se).set.map(function(ye){return ye.map(function(De){return De.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new V(de,this.loose));for(var Se=0;Se<this.set.length;Se++)if(Ie(this.set[Se],de))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(de,Se,ye){var De=null,Re=null;try{var Ne=new fe(Se,ye)}catch{return null}return de.forEach(function(ke){Ne.test(ke)&&(De&&Re.compare(ke)!==-1||(Re=new V(De=ke,ye)))}),De},e.minSatisfying=function(de,Se,ye){var De=null,Re=null;try{var Ne=new fe(Se,ye)}catch{return null}return de.forEach(function(ke){Ne.test(ke)&&(De&&Re.compare(ke)!==1||(Re=new V(De=ke,ye)))}),De},e.validRange=function(de,Se){try{return new fe(de,Se).range||"*"}catch{return null}},e.ltr=function(de,Se,ye){return Te(de,Se,"<",ye)},e.gtr=function(de,Se,ye){return Te(de,Se,">",ye)},e.outside=Te,e.prerelease=function(de,Se){var ye=ce(de,Se);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(de,Se,ye){return de=new fe(de,ye),Se=new fe(Se,ye),de.intersects(Se)},e.coerce=function(de){if(de instanceof V)return de;if(typeof de!="string")return null;var Se=de.match(R[I]);return Se==null?null:ce((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,L(1))},function(se,e){var L,U,O=se.exports={};function A(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function R(v){if(L===setTimeout)return setTimeout(v,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch{try{return L.call(null,v,0)}catch{return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{U=typeof clearTimeout=="function"?clearTimeout:_}catch{U=_}})();var P,f=[],D=!1,w=-1;function m(){D&&P&&(D=!1,P.length?f=P.concat(f):w=-1,f.length&&h())}function h(){if(!D){var v=R(m);D=!0;for(var d=f.length;d;){for(P=f,f=[];++w<d;)P&&P[w].run();w=-1,d=f.length}P=null,D=!1,function(g){if(U===clearTimeout)return clearTimeout(g);if((U===_||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(g);try{U(g)}catch{try{return U.call(null,g)}catch{return U.call(this,g)}}}(v)}}function u(v,d){this.fun=v,this.array=d}function y(){}O.nextTick=function(v){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];f.push(new u(v,d)),f.length!==1||D||R(h)},u.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=y,O.addListener=y,O.once=y,O.off=y,O.removeListener=y,O.removeAllListeners=y,O.emit=y,O.prependListener=y,O.prependOnceListener=y,O.listeners=function(v){return[]},O.binding=function(v){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(v){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(le[128],ue([0,1]),function(se,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(R,P,f){this.level=R,this.key=P,this.value=f,this.forward=[]}}const O=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new U(this._maxLevel,O,O)}get size(){return this._size}clear(){this._header=new U(this._maxLevel,O,O),this._size=0}has(R){return!!A._search(this,R,this.comparator)}get(R){return A._search(this,R,this.comparator)?.value}set(R,P){return A._insert(this,R,P,this.comparator)&&(this._size+=1),this}delete(R){const P=A._delete(this,R,this.comparator);return P&&(this._size-=1),P}forEach(R,P){let f=this._header.forward[0];for(;f;)R.call(P,f.value,f.key,this),f=f.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this._header.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static _search(R,P,f){let D=R._header;for(let w=R._level-1;w>=0;w--)for(;D.forward[w]&&f(D.forward[w].key,P)<0;)D=D.forward[w];if(D=D.forward[0],D&&f(D.key,P)===0)return D}static _insert(R,P,f,D){const w=[];let m=R._header;for(let h=R._level-1;h>=0;h--){for(;m.forward[h]&&D(m.forward[h].key,P)<0;)m=m.forward[h];w[h]=m}if(m=m.forward[0],m&&D(m.key,P)===0)return m.value=f,!1;{const h=A._randomLevel(R);if(h>R._level){for(let u=R._level;u<h;u++)w[u]=R._header;R._level=h}m=new U(h,P,f);for(let u=0;u<h;u++)m.forward[u]=w[u].forward[u],w[u].forward[u]=m;return!0}}static _randomLevel(R,P=.5){let f=1;for(;Math.random()<P&&f<R._maxLevel;)f+=1;return f}static _delete(R,P,f){const D=[];let w=R._header;for(let m=R._level-1;m>=0;m--){for(;w.forward[m]&&f(w.forward[m].key,P)<0;)w=w.forward[m];D[m]=w}if(w=w.forward[0],!w||f(w.key,P)!==0)return!1;for(let m=0;m<R._level&&D[m].forward[m]===w;m++)D[m].forward[m]=w.forward[m];for(;R._level>0&&R._header.forward[R._level-1]===O;)R._level-=1;return!0}}e.SkipList=A}),define(le[63],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=globalThis.performance&&typeof globalThis.performance.now=="function";class U{static create(A){return new U(A)}constructor(A){this._now=L&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=U}),define(le[3],ue([0,1,7,85,2,86,63]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=h;const R=!1,P=!1,f=!1;var D;(function(I){I.None=()=>O.Disposable.None;function p(re){if(f){const{onDidAddListener:he}=re,fe=y.create();let me=0;re.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),he?.()}}}function k(re,he){return q(re,()=>{},0,void 0,!0,void 0,he)}I.defer=k;function N(re){return(he,fe=null,me)=>{let Ee=!1,Ie;return Ie=re(Le=>{if(!Ee)return Ie?Ie.dispose():Ee=!0,he.call(fe,Le)},null,me),Ee&&Ie.dispose(),Ie}}I.once=N;function F(re,he,fe){return G((me,Ee=null,Ie)=>re(Le=>me.call(Ee,he(Le)),null,Ie),fe)}I.map=F;function x(re,he,fe){return G((me,Ee=null,Ie)=>re(Le=>{he(Le),me.call(Ee,Le)},null,Ie),fe)}I.forEach=x;function Z(re,he,fe){return G((me,Ee=null,Ie)=>re(Le=>he(Le)&&me.call(Ee,Le),null,Ie),fe)}I.filter=Z;function B(re){return re}I.signal=B;function X(...re){return(he,fe=null,me)=>{const Ee=(0,O.combinedDisposable)(...re.map(Ie=>Ie(Le=>he.call(fe,Le))));return z(Ee,me)}}I.any=X;function j(re,he,fe,me){let Ee=fe;return F(re,Ie=>(Ee=he(Ee,Ie),Ee),me)}I.reduce=j;function G(re,he){let fe;const me={onWillAddFirstListener(){fe=re(Ee.fire,Ee)},onDidRemoveLastListener(){fe?.dispose()}};he||p(me);const Ee=new S(me);return he?.add(Ee),Ee.event}function z(re,he){return he instanceof Array?he.push(re):he&&he.add(re),re}function q(re,he,fe=100,me=!1,Ee=!1,Ie,Le){let Te,de,Se,ye=0,De;const Re={leakWarningThreshold:Ie,onWillAddFirstListener(){Te=re(ke=>{ye++,de=he(de,ke),me&&!Se&&(Ne.fire(de),de=void 0),De=()=>{const $e=de;de=void 0,Se=void 0,(!me||ye>1)&&Ne.fire($e),ye=0},typeof fe=="number"?(clearTimeout(Se),Se=setTimeout(De,fe)):Se===void 0&&(Se=0,queueMicrotask(De))})},onWillRemoveListener(){Ee&&ye>0&&De?.()},onDidRemoveLastListener(){De=void 0,Te.dispose()}};Le||p(Re);const Ne=new S(Re);return Le?.add(Ne),Ne.event}I.debounce=q;function ie(re,he=0,fe){return I.debounce(re,(me,Ee)=>me?(me.push(Ee),me):[Ee],he,void 0,!0,void 0,fe)}I.accumulate=ie;function ae(re,he=(me,Ee)=>me===Ee,fe){let me=!0,Ee;return Z(re,Ie=>{const Le=me||!he(Ie,Ee);return me=!1,Ee=Ie,Le},fe)}I.latch=ae;function te(re,he,fe){return[I.filter(re,he,fe),I.filter(re,me=>!he(me),fe)]}I.split=te;function ce(re,he=!1,fe=[],me){let Ee=fe.slice(),Ie=re(de=>{Ee?Ee.push(de):Te.fire(de)});me&&me.add(Ie);const Le=()=>{Ee?.forEach(de=>Te.fire(de)),Ee=null},Te=new S({onWillAddFirstListener(){Ie||(Ie=re(de=>Te.fire(de)),me&&me.add(Ie))},onDidAddFirstListener(){Ee&&(he?setTimeout(Le):Le())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return me&&me.add(Te),Te.event}I.buffer=ce;function V(re,he){return(me,Ee,Ie)=>{const Le=he(new T);return re(function(Te){const de=Le.evaluate(Te);de!==$&&me.call(Ee,de)},void 0,Ie)}}I.chain=V;const $=Symbol("HaltChainable");class T{constructor(){this.steps=[]}map(he){return this.steps.push(he),this}forEach(he){return this.steps.push(fe=>(he(fe),fe)),this}filter(he){return this.steps.push(fe=>he(fe)?fe:$),this}reduce(he,fe){let me=fe;return this.steps.push(Ee=>(me=he(me,Ee),me)),this}latch(he=(fe,me)=>fe===me){let fe=!0,me;return this.steps.push(Ee=>{const Ie=fe||!he(Ee,me);return fe=!1,me=Ee,Ie?Ee:$}),this}evaluate(he){for(const fe of this.steps)if(he=fe(he),he===$)break;return he}}function M(re,he,fe=me=>me){const me=(...Te)=>Le.fire(fe(...Te)),Ee=()=>re.on(he,me),Ie=()=>re.removeListener(he,me),Le=new S({onWillAddFirstListener:Ee,onDidRemoveLastListener:Ie});return Le.event}I.fromNodeEventEmitter=M;function W(re,he,fe=me=>me){const me=(...Te)=>Le.fire(fe(...Te)),Ee=()=>re.addEventListener(he,me),Ie=()=>re.removeEventListener(he,me),Le=new S({onWillAddFirstListener:Ee,onDidRemoveLastListener:Ie});return Le.event}I.fromDOMEventEmitter=W;function J(re){return new Promise(he=>N(re)(he))}I.toPromise=J;function H(re){const he=new S;return re.then(fe=>{he.fire(fe)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}I.fromPromise=H;function ee(re,he,fe){return he(fe),re(me=>he(me))}I.runAndSubscribe=ee;class Q{constructor(he,fe){this._observable=he,this._counter=0,this._hasChanged=!1;const me={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};fe||p(me),this.emitter=new S(me),fe&&fe.add(this.emitter)}beginUpdate(he){this._counter++}handlePossibleChange(he){}handleChange(he,fe){this._hasChanged=!0}endUpdate(he){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Y(re,he){return new Q(re,he).emitter.event}I.fromObservable=Y;function ne(re){return(he,fe,me)=>{let Ee=0,Ie=!1;const Le={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(re.reportChanges(),Ie&&(Ie=!1,he.call(fe)))},handlePossibleChange(){},handleChange(){Ie=!0}};re.addObserver(Le),re.reportChanges();const Te={dispose(){re.removeObserver(Le)}};return me instanceof O.DisposableStore?me.add(Te):Array.isArray(me)&&me.push(Te),Te}}I.fromObservableLight=ne})(D||(e.Event=D={}));class w{static{this.all=new Set}static{this._idPool=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${w._idPool++}`,w.all.add(this)}start(p){this._stopWatch=new _.StopWatch,this.listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=w;let m=-1;function h(I){const p=m;return m=I,{dispose(){m=p}}}class u{constructor(p,k=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=k,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(p,k){const N=this.threshold;if(N<=0||k<N)return;this._stacks||(this._stacks=new Map);const F=this._stacks.get(p.value)||0;if(this._stacks.set(p.value,F+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=N*.5;let x,Z=0;for(const[B,X]of this._stacks)(!x||Z<X)&&(x=B,Z=X);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${Z}):`),console.warn(x)}return()=>{const x=this._stacks.get(p.value)||0;this._stacks.set(p.value,x-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class d{constructor(p){this.value=p,this.id=v++}}const g=2,l=(I,p)=>{if(I instanceof d)p(I);else for(let k=0;k<I.length;k++){const N=I[k];N&&p(N)}},c=R?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class S{constructor(p){this._size=0,this._options=p,this._leakageMon=m>0||this._options?.leakWarningThreshold?new u(this._options?.leakWarningThreshold??m):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(P){const p=this._listeners;queueMicrotask(()=>{l(p,k=>k.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(p,k,N)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.Disposable.None;if(this._disposed)return O.Disposable.None;k&&(p=p.bind(k));const F=new d(p);let x,Z;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(F.stack=y.create(),x=this._leakageMon.check(F.stack,this._size+1)),P&&(F.stack=Z??y.create()),this._listeners?this._listeners instanceof d?(this._deliveryQueue??=new o,this._listeners=[this._listeners,F]):this._listeners.push(F):(this._options?.onWillAddFirstListener?.(this),this._listeners=F,this._options?.onDidAddFirstListener?.(this)),this._size++;const B=(0,O.toDisposable)(()=>{c?.unregister(B),x?.(),this._removeListener(F)});if(N instanceof O.DisposableStore?N.add(B):Array.isArray(N)&&N.push(B),c){const X=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(B,X,B)}return B},this._event}_removeListener(p){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const k=this._listeners,N=k.indexOf(p);if(N===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,k[N]=void 0;const F=this._deliveryQueue.current===this;if(this._size*g<=k.length){let x=0;for(let Z=0;Z<k.length;Z++)k[Z]?k[x++]=k[Z]:F&&(this._deliveryQueue.end--,x<this._deliveryQueue.i&&this._deliveryQueue.i--);k.length=x}}_deliver(p,k){if(!p)return;const N=this._options?.onListenerError||L.onUnexpectedError;if(!N){p.value(k);return}try{p.value(k)}catch(F){N(F)}}_deliverQueue(p){const k=p.current._listeners;for(;p.i<p.end;)this._deliver(k[p.i++],p.value);p.reset()}fire(p){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof d)this._deliver(this._listeners,p);else{const k=this._deliveryQueue;k.enqueue(this,p,this._listeners.length),this._deliverQueue(k)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=S;const i=()=>new o;e.createEventDeliveryQueue=i;class o{constructor(){this.i=-1,this.end=0}enqueue(p,k,N){this.i=0,this.end=N,this.current=p,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends S{async fireAsync(p,k,N){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),l(this._listeners,F=>this._asyncDeliveryQueue.push([F.value,p]));this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[F,x]=this._asyncDeliveryQueue.shift(),Z=[],B={...x,token:k,waitUntil:X=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");N&&(X=N(X,F)),Z.push(X)}};try{F(B)}catch(X){(0,L.onUnexpectedError)(X);continue}Object.freeze(Z),await Promise.allSettled(Z).then(X=>{for(const j of X)j.status==="rejected"&&(0,L.onUnexpectedError)(j.reason)})}}}e.AsyncEmitter=n;class s extends S{get isPaused(){return this._isPaused!==0}constructor(p){super(p),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._size&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=s;class t extends s{constructor(p){super(p),this._delay=p.delay??100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}e.DebounceEmitter=t;class r extends S{constructor(p){super(p),this._queuedEvents=[],this._mergeFn=p?.merge}fire(p){this.hasListeners()&&(this._queuedEvents.push(p),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(k=>super.fire(k)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=r;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const k={event:p,listener:null};this.events.push(k),this.hasListeners&&this.hook(k);const N=()=>{this.hasListeners&&this.unhook(k);const F=this.events.indexOf(k);this.events.splice(F,1)};return(0,O.toDisposable)((0,U.createSingleCallFunction)(N))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(k=>this.emitter.fire(k))}unhook(p){p.listener?.dispose(),p.listener=null}dispose(){this.emitter.dispose();for(const p of this.events)p.listener?.dispose();this.events=[]}}e.EventMultiplexer=a;class E{constructor(p,k,N,F){this._store=new O.DisposableStore;const x=this._store.add(new a),Z=this._store.add(new O.DisposableMap);function B(X){Z.set(X,x.add(F(X)))}for(const X of p)B(X);this._store.add(k(X=>{B(X)})),this._store.add(N(X=>{Z.deleteAndDispose(X)})),this.event=x.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=E;class C{constructor(){this.buffers=[]}wrapEvent(p){return(k,N,F)=>p(x=>{const Z=this.buffers[this.buffers.length-1];Z?Z.push(()=>k.call(N,x)):k.call(N,x)},void 0,F)}bufferEvents(p){const k=[];this.buffers.push(k);const N=p();return this.buffers.pop(),k.forEach(F=>F()),N}}e.EventBufferer=C;class b{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=O.Disposable.None,this.emitter=new S({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(le[26],ue([0,1,3]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const U=Object.freeze(function(R,P){const f=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(f)}}});var O;(function(R){function P(f){return f===R.None||f===R.Cancelled||f instanceof A?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(O||(e.CancellationToken=O={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=O.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=O.None}}e.CancellationTokenSource=_}),define(le[129],ue([0,1,26]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class U{constructor(R){this.task=R,this.result=null}get(){if(this.result)return this.result;const R=new L.CancellationTokenSource,P=this.task(R.token);return this.result={promise:P,dispose:()=>{this.result=null,R.cancel(),R.dispose()}},this.result}}e.Cache=U;class O{constructor(R,P=JSON.stringify){this.fn=R,this._computeKey=P,this.lastCache=void 0,this.lastArgKey=void 0}get(R){const P=this._computeKey(R);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(R)),this.lastCache}}e.LRUCachedFunction=O;class A{get cachedValues(){return this._map}constructor(R){this.fn=R,this._map=new Map}get(R){if(this._map.has(R))return this._map.get(R);const P=this.fn(R);return this._map.set(R,P),P}}e.CachedFunction=A}),define(le[50],ue([0,1,7,2]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=O,e.isReadableStream=A,e.isReadableBufferedStream=_,e.newWriteableStream=R,e.consumeReadable=f,e.peekReadable=D,e.consumeStream=w,e.listenStream=m,e.peekStream=h,e.toStream=u,e.emptyStream=y,e.toReadable=v,e.transform=d,e.prefixedReadable=g,e.prefixedStream=l;function O(c){const S=c;return S?typeof S.read=="function":!1}function A(c){const S=c;return S?[S.on,S.pause,S.resume,S.destroy].every(i=>typeof i=="function"):!1}function _(c){const S=c;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}function R(c,S){return new P(c,S)}class P{constructor(S,i){this.reducer=S,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(i=>i(S))}emitError(S){this.listeners.error.length===0?(0,L.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(i=>i(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,i){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(S,i){if(this.state.destroyed)return;let o;switch(S){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(c,S){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return S(i)}function D(c,S,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?S(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function w(c,S){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{S&&n.push(s)},onError:s=>{S?o(s):i(void 0)},onEnd:()=>{i(S?S(n):void 0)}})})}function m(c,S,i){c.on("error",o=>{i?.isCancellationRequested||S.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||S.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||S.onData(o)})}function h(c,S){return new Promise((i,o)=>{const n=new U.DisposableStore,s=[],t=E=>{if(s.push(E),s.length>S)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=E=>(n.dispose(),o(E)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,U.toDisposable)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,U.toDisposable)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,U.toDisposable)(()=>c.removeListener("data",t))),c.on("data",t)})}function u(c,S){const i=R(S);return i.end(c),i}function y(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}function v(c){let S=!1;return{read:()=>S?null:(S=!0,c)}}function d(c,S,i){const o=R(i);return m(c,{onData:n=>o.write(S.data(n)),onError:n=>o.error(S.error?S.error(n):n),onEnd:()=>o.end()}),o}function g(c,S,i){let o=!1;return{read:()=>{const n=S.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function l(c,S,i){let o=!1;const n=R(i);return m(S,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(le[15],ue([0,1,53,50]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=f,e.readUInt16LE=D,e.writeUInt16LE=w,e.readUInt32BE=m,e.writeUInt32BE=h,e.readUInt32LE=u,e.writeUInt32LE=y,e.readUInt8=v,e.writeUInt8=d,e.readableToBuffer=g,e.bufferToReadable=l,e.streamToBuffer=c,e.bufferedStreamToBuffer=S,e.bufferToStream=i,e.streamToBufferReadableStream=o,e.newWriteableBufferStream=n,e.prefixedBufferReadable=s,e.prefixedBufferStream=t,e.decodeBase64=r,e.encodeBase64=C;const O=typeof Buffer<"u",A=new L.Lazy(()=>new Uint8Array(256));let _,R;class P{static alloc(I){return O?new P(Buffer.allocUnsafe(I)):new P(new Uint8Array(I))}static wrap(I){return O&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new P(I)}static fromString(I,p){return!(p?.dontUseNodeBuffer||!1)&&O?new P(Buffer.from(I)):(_||(_=new TextEncoder),new P(_.encode(I)))}static fromByteArray(I){const p=P.alloc(I.length);for(let k=0,N=I.length;k<N;k++)p.buffer[k]=I[k];return p}static concat(I,p){if(typeof p>"u"){p=0;for(let F=0,x=I.length;F<x;F++)p+=I[F].byteLength}const k=P.alloc(p);let N=0;for(let F=0,x=I.length;F<x;F++){const Z=I[F];k.set(Z,N),N+=Z.byteLength}return k}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=P.alloc(this.byteLength);return I.set(this),I}toString(){return O?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(I,p){return new P(this.buffer.subarray(I,p))}set(I,p){if(I instanceof P)this.buffer.set(I.buffer,p);else if(I instanceof Uint8Array)this.buffer.set(I,p);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),p);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return m(this.buffer,I)}writeUInt32BE(I,p){h(this.buffer,I,p)}readUInt32LE(I){return u(this.buffer,I)}writeUInt32LE(I,p){y(this.buffer,I,p)}readUInt8(I){return v(this.buffer,I)}writeUInt8(I,p){d(this.buffer,I,p)}indexOf(I,p=0){return f(this.buffer,I instanceof P?I.buffer:I,p)}}e.VSBuffer=P;function f(b,I,p=0){const k=I.byteLength,N=b.byteLength;if(k===0)return 0;if(k===1)return b.indexOf(I[0]);if(k>N-p)return-1;const F=A.value;F.fill(I.length);for(let X=0;X<I.length;X++)F[I[X]]=I.length-X-1;let x=p+I.length-1,Z=x,B=-1;for(;x<N;)if(b[x]===I[Z]){if(Z===0){B=x;break}x--,Z--}else x+=Math.max(I.length-Z,F[b[x]]),Z=I.length-1;return B}function D(b,I){return b[I+0]<<0>>>0|b[I+1]<<8>>>0}function w(b,I,p){b[p+0]=I&255,I=I>>>8,b[p+1]=I&255}function m(b,I){return b[I]*2**24+b[I+1]*2**16+b[I+2]*2**8+b[I+3]}function h(b,I,p){b[p+3]=I,I=I>>>8,b[p+2]=I,I=I>>>8,b[p+1]=I,I=I>>>8,b[p]=I}function u(b,I){return b[I+0]<<0>>>0|b[I+1]<<8>>>0|b[I+2]<<16>>>0|b[I+3]<<24>>>0}function y(b,I,p){b[p+0]=I&255,I=I>>>8,b[p+1]=I&255,I=I>>>8,b[p+2]=I&255,I=I>>>8,b[p+3]=I&255}function v(b,I){return b[I]}function d(b,I,p){b[p]=I}function g(b){return U.consumeReadable(b,I=>P.concat(I))}function l(b){return U.toReadable(b)}function c(b){return U.consumeStream(b,I=>P.concat(I))}async function S(b){return b.ended?P.concat(b.buffer):P.concat([...b.buffer,await c(b.stream)])}function i(b){return U.toStream(b,I=>P.concat(I))}function o(b){return U.transform(b,{data:I=>typeof I=="string"?P.fromString(I):P.wrap(I)},I=>P.concat(I))}function n(b){return U.newWriteableStream(I=>P.concat(I),b)}function s(b,I){return U.prefixedReadable(b,I,p=>P.concat(p))}function t(b,I){return U.prefixedStream(b,I,p=>P.concat(p))}function r(b){let I=0,p=0,k=0;const N=new Uint8Array(Math.floor(b.length/4*3)),F=Z=>{switch(p){case 3:N[k++]=I|Z,p=0;break;case 2:N[k++]=I|Z>>>2,I=Z<<6,p=3;break;case 1:N[k++]=I|Z>>>4,I=Z<<4,p=2;break;default:I=Z<<2,p=1}};for(let Z=0;Z<b.length;Z++){const B=b.charCodeAt(Z);if(B>=65&&B<=90)F(B-65);else if(B>=97&&B<=122)F(B-97+26);else if(B>=48&&B<=57)F(B-48+52);else if(B===43||B===45)F(62);else if(B===47||B===95)F(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${b[Z]}`)}}const x=k;for(;p>0;)F(0);return P.wrap(N).slice(0,x)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:b},I=!0,p=!1){const k=p?E:a;let N="";const F=b.byteLength%3;let x=0;for(;x<b.byteLength-F;x+=3){const Z=b[x+0],B=b[x+1],X=b[x+2];N+=k[Z>>>2],N+=k[(Z<<4|B>>>4)&63],N+=k[(B<<2|X>>>6)&63],N+=k[X&63]}if(F===1){const Z=b[x+0];N+=k[Z>>>2],N+=k[Z<<4&63],I&&(N+="==")}else if(F===2){const Z=b[x+0],B=b[x+1];N+=k[Z>>>2],N+=k[(Z<<4|B>>>4)&63],N+=k[B<<2&63],I&&(N+="=")}return N}}),define(le[27],ue([0,1,129,53]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=O,e.format=_,e.format2=P,e.htmlAttributeEncodeValue=f,e.escape=D,e.escapeRegExpCharacters=w,e.count=m,e.truncate=h,e.truncateMiddle=u,e.trim=y,e.ltrim=v,e.rtrim=d,e.convertSimple2RegExpPattern=g,e.stripWildcards=l,e.createRegExp=c,e.regExpLeadsToEndlessLoop=S,e.splitLines=i,e.splitLinesIncludeSeparators=o,e.firstNonWhitespaceIndex=n,e.getLeadingWhitespace=s,e.lastNonWhitespaceIndex=t,e.replaceAsync=r,e.compare=a,e.compareSubstring=E,e.compareIgnoreCase=C,e.compareSubstringIgnoreCase=b,e.isAsciiDigit=I,e.isLowerAsciiLetter=p,e.isUpperAsciiLetter=k,e.equalsIgnoreCase=N,e.startsWithIgnoreCase=F,e.commonPrefixLength=x,e.commonSuffixLength=Z,e.isHighSurrogate=B,e.isLowSurrogate=X,e.computeCodePoint=j,e.getNextCodePoint=G,e.nextCharLength=ae,e.prevCharLength=te,e.getCharContainingOffset=ce,e.charCount=V,e.containsRTL=M,e.isBasicASCII=J,e.containsUnusualLineTerminators=H,e.isFullWidthCharacter=ee,e.isEmojiImprecise=Q,e.lcut=Y,e.forAnsiStringParts=re,e.removeAnsiEscapeCodes=he,e.startsWithUTF8BOM=fe,e.stripUTF8BOM=me,e.fuzzyContains=Ee,e.containsUppercaseCharacter=Ie,e.uppercaseFirstLetter=Le,e.getNLines=Te,e.singleLetterHash=de,e.getGraphemeBreakType=Se,e.getLeftDeleteOffset=ke;function O(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const A=/{(\d+)}/g;function _(oe,...ge){return ge.length===0?oe:oe.replace(A,function(ve,pe){const Ce=parseInt(pe,10);return isNaN(Ce)||Ce<0||Ce>=ge.length?ve:ge[Ce]})}const R=/{([^}]+)}/g;function P(oe,ge){return Object.keys(ge).length===0?oe:oe.replace(R,(ve,pe)=>ge[pe]??ve)}function f(oe){return oe.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function D(oe){return oe.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function w(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(oe,ge){let ve=0;const pe=ge.charCodeAt(0);for(let Ce=oe.length-1;Ce>=0;Ce--)oe.charCodeAt(Ce)===pe&&ve++;return ve}function h(oe,ge,ve="\u2026"){return oe.length<=ge?oe:`${oe.substr(0,ge)}${ve}`}function u(oe,ge,ve="\u2026"){if(oe.length<=ge)return oe;const pe=Math.ceil(ge/2)-ve.length/2,Ce=Math.floor(ge/2)-ve.length/2;return`${oe.substr(0,pe)}${ve}${oe.substr(oe.length-Ce)}`}function y(oe,ge=" "){const ve=v(oe,ge);return d(ve,ge)}function v(oe,ge){if(!oe||!ge)return oe;const ve=ge.length;if(ve===0||oe.length===0)return oe;let pe=0;for(;oe.indexOf(ge,pe)===pe;)pe=pe+ve;return oe.substring(pe)}function d(oe,ge){if(!oe||!ge)return oe;const ve=ge.length,pe=oe.length;if(ve===0||pe===0)return oe;let Ce=pe,Pe=-1;for(;Pe=oe.lastIndexOf(ge,Ce-1),!(Pe===-1||Pe+ve!==Ce);){if(Pe===0)return"";Ce=Pe}return oe.substring(0,Ce)}function g(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(oe){return oe.replace(/\*/g,"")}function c(oe,ge,ve={}){if(!oe)throw new Error("Cannot create regex from empty string");ge||(oe=w(oe)),ve.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let pe="";return ve.global&&(pe+="g"),ve.matchCase||(pe+="i"),ve.multiline&&(pe+="m"),ve.unicode&&(pe+="u"),new RegExp(oe,pe)}function S(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function i(oe){return oe.split(/\r\n|\r|\n/)}function o(oe){const ge=[],ve=oe.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(ve.length/2);pe++)ge.push(ve[2*pe]+(ve[2*pe+1]??""));return ge}function n(oe){for(let ge=0,ve=oe.length;ge<ve;ge++){const pe=oe.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}function s(oe,ge=0,ve=oe.length){for(let pe=ge;pe<ve;pe++){const Ce=oe.charCodeAt(pe);if(Ce!==32&&Ce!==9)return oe.substring(ge,pe)}return oe.substring(ge,ve)}function t(oe,ge=oe.length-1){for(let ve=ge;ve>=0;ve--){const pe=oe.charCodeAt(ve);if(pe!==32&&pe!==9)return ve}return-1}function r(oe,ge,ve){const pe=[];let Ce=0;for(const Pe of oe.matchAll(ge)){if(pe.push(oe.slice(Ce,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Ce=Pe.index+Pe[0].length,pe.push(ve(Pe[0],...Pe.slice(1),Pe.index,oe,Pe.groups))}return pe.push(oe.slice(Ce)),Promise.all(pe).then(Pe=>Pe.join(""))}function a(oe,ge){return oe<ge?-1:oe>ge?1:0}function E(oe,ge,ve=0,pe=oe.length,Ce=0,Pe=ge.length){for(;ve<pe&&Ce<Pe;ve++,Ce++){const ze=oe.charCodeAt(ve),qe=ge.charCodeAt(Ce);if(ze<qe)return-1;if(ze>qe)return 1}const _e=pe-ve,Ue=Pe-Ce;return _e<Ue?-1:_e>Ue?1:0}function C(oe,ge){return b(oe,ge,0,oe.length,0,ge.length)}function b(oe,ge,ve=0,pe=oe.length,Ce=0,Pe=ge.length){for(;ve<pe&&Ce<Pe;ve++,Ce++){let ze=oe.charCodeAt(ve),qe=ge.charCodeAt(Ce);if(ze===qe)continue;if(ze>=128||qe>=128)return E(oe.toLowerCase(),ge.toLowerCase(),ve,pe,Ce,Pe);p(ze)&&(ze-=32),p(qe)&&(qe-=32);const Fe=ze-qe;if(Fe!==0)return Fe}const _e=pe-ve,Ue=Pe-Ce;return _e<Ue?-1:_e>Ue?1:0}function I(oe){return oe>=48&&oe<=57}function p(oe){return oe>=97&&oe<=122}function k(oe){return oe>=65&&oe<=90}function N(oe,ge){return oe.length===ge.length&&b(oe,ge)===0}function F(oe,ge){const ve=ge.length;return ge.length>oe.length?!1:b(oe,ge,0,ve)===0}function x(oe,ge){const ve=Math.min(oe.length,ge.length);let pe;for(pe=0;pe<ve;pe++)if(oe.charCodeAt(pe)!==ge.charCodeAt(pe))return pe;return ve}function Z(oe,ge){const ve=Math.min(oe.length,ge.length);let pe;const Ce=oe.length-1,Pe=ge.length-1;for(pe=0;pe<ve;pe++)if(oe.charCodeAt(Ce-pe)!==ge.charCodeAt(Pe-pe))return pe;return ve}function B(oe){return 55296<=oe&&oe<=56319}function X(oe){return 56320<=oe&&oe<=57343}function j(oe,ge){return(oe-55296<<10)+(ge-56320)+65536}function G(oe,ge,ve){const pe=oe.charCodeAt(ve);if(B(pe)&&ve+1<ge){const Ce=oe.charCodeAt(ve+1);if(X(Ce))return j(pe,Ce)}return pe}function z(oe,ge){const ve=oe.charCodeAt(ge-1);if(X(ve)&&ge>1){const pe=oe.charCodeAt(ge-2);if(B(pe))return j(pe,ve)}return ve}class q{get offset(){return this._offset}constructor(ge,ve=0){this._str=ge,this._len=ge.length,this._offset=ve}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=z(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=G(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class ie{get offset(){return this._iterator.offset}constructor(ge,ve=0){this._iterator=new q(ge,ve)}nextGraphemeLength(){const ge=Re.getInstance(),ve=this._iterator,pe=ve.offset;let Ce=ge.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Pe=ve.offset,_e=ge.getGraphemeBreakType(ve.nextCodePoint());if(ye(Ce,_e)){ve.setOffset(Pe);break}Ce=_e}return ve.offset-pe}prevGraphemeLength(){const ge=Re.getInstance(),ve=this._iterator,pe=ve.offset;let Ce=ge.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Pe=ve.offset,_e=ge.getGraphemeBreakType(ve.prevCodePoint());if(ye(_e,Ce)){ve.setOffset(Pe);break}Ce=_e}return pe-ve.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function ae(oe,ge){return new ie(oe,ge).nextGraphemeLength()}function te(oe,ge){return new ie(oe,ge).prevGraphemeLength()}function ce(oe,ge){ge>0&&X(oe.charCodeAt(ge))&&ge--;const ve=ge+ae(oe,ge);return[ve-te(oe,ve),ve]}function V(oe){const ge=new ie(oe);let ve=0;for(;!ge.eol();)ve++,ge.nextGraphemeLength();return ve}let $;function T(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(oe){return $||($=T()),$.test(oe)}const W=/^[\t\n\r\x20-\x7E]*$/;function J(oe){return W.test(oe)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(oe){return e.UNUSUAL_LINE_TERMINATORS.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function Q(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function Y(oe,ge,ve=""){const pe=oe.trimStart();if(pe.length<ge)return pe;const Ce=/\b/g;let Pe=0;for(;Ce.test(pe)&&!(pe.length-Ce.lastIndex<ge);)Pe=Ce.lastIndex,Ce.lastIndex+=1;return Pe===0?pe:ve+pe.substring(Pe).trimStart()}const ne=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*re(oe){let ge=0;for(const ve of oe.matchAll(ne))ge!==ve.index&&(yield{isCode:!1,str:oe.substring(ge,ve.index)}),yield{isCode:!0,str:ve[0]},ge=ve.index+ve[0].length;ge!==oe.length&&(yield{isCode:!1,str:oe.substring(ge)})}function he(oe){return oe&&(oe=oe.replace(ne,"")),oe}e.UTF8_BOM_CHARACTER="\uFEFF";function fe(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function me(oe){return fe(oe)?oe.substr(1):oe}function Ee(oe,ge){if(!oe||!ge||oe.length<ge.length)return!1;const ve=ge.length,pe=oe.toLowerCase();let Ce=0,Pe=-1;for(;Ce<ve;){const _e=pe.indexOf(ge[Ce],Pe+1);if(_e<0)return!1;Pe=_e,Ce++}return!0}function Ie(oe,ge=!1){return oe?(ge&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Le(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function Te(oe,ge=1){if(ge===0)return"";let ve=-1;do ve=oe.indexOf(`
`,ve+1),ge--;while(ge>0&&ve>=0);return ve===-1?oe:(oe[ve-1]==="\r"&&ve--,oe.substr(0,ve))}function de(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function Se(oe){return Re.getInstance().getGraphemeBreakType(oe)}function ye(oe,ge){return oe===0?ge!==5&&ge!==7:oe===2&&ge===3?!1:oe===4||oe===2||oe===3||ge===4||ge===2||ge===3?!0:!(oe===8&&(ge===8||ge===9||ge===11||ge===12)||(oe===11||oe===9)&&(ge===9||ge===10)||(oe===12||oe===10)&&ge===10||ge===5||ge===13||ge===7||oe===1||oe===13&&ge===14||oe===6&&ge===6)}var De;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class Re{static{this._INSTANCE=null}static getInstance(){return Re._INSTANCE||(Re._INSTANCE=new Re),Re._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const ve=this._data,pe=ve.length/3;let Ce=1;for(;Ce<=pe;)if(ge<ve[3*Ce])Ce=2*Ce;else if(ge>ve[3*Ce+1])Ce=2*Ce+1;else return ve[3*Ce+2];return 0}}function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(oe,ge){if(oe===0)return 0;const ve=$e(oe,ge);if(ve!==void 0)return ve;const pe=new q(ge,oe);return pe.prevCodePoint(),pe.offset}function $e(oe,ge){const ve=new q(ge,oe);let pe=ve.prevCodePoint();for(;Me(pe)||pe===65039||pe===8419;){if(ve.offset===0)return;pe=ve.prevCodePoint()}if(!Q(pe))return;let Ce=ve.offset;return Ce>0&&ve.prevCodePoint()===8205&&(Ce=ve.offset),Ce}function Me(oe){return 127995<=oe&&oe<=127999}var xe;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.noBreakWhitespace="\xA0";class We{static{this.ambiguousCharacterData=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new L.LRUCachedFunction(ge=>{function ve(Fe){const Ke=new Map;for(let Be=0;Be<Fe.length;Be+=2)Ke.set(Fe[Be],Fe[Be+1]);return Ke}function pe(Fe,Ke){const Be=new Map(Fe);for(const[Ze,tt]of Ke)Be.set(Ze,tt);return Be}function Ce(Fe,Ke){if(!Fe)return Ke;const Be=new Map;for(const[Ze,tt]of Fe)Ke.has(Ze)&&Be.set(Ze,tt);return Be}const Pe=this.ambiguousCharacterData.value;let _e=ge.filter(Fe=>!Fe.startsWith("_")&&Fe in Pe);_e.length===0&&(_e=["_default"]);let Ue;for(const Fe of _e){const Ke=ve(Pe[Fe]);Ue=Ce(Ue,Ke)}const ze=ve(Pe._common),qe=pe(ze,Ue);return new We(qe)})}static getInstance(ge){return We.cache.get(Array.from(ge))}static{this._locales=new U.Lazy(()=>Object.keys(We.ambiguousCharacterData.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return We._locales.value}constructor(ge){this.confusableDictionary=ge}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=We;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(ge){return Oe.getData().has(ge)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe}),define(le[54],ue([0,1,27]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=U,e.doHash=O,e.numberHash=A,e.stringHash=R,e.toHexString=y;function U(d){return O(d,0)}function O(d,g){switch(typeof d){case"object":return d===null?A(349,g):Array.isArray(d)?P(d,g):f(d,g);case"string":return R(d,g);case"boolean":return _(d,g);case"number":return A(d,g);case"undefined":return A(937,g);default:return A(617,g)}}function A(d,g){return(g<<5)-g+d|0}function _(d,g){return A(d?433:863,g)}function R(d,g){g=A(149417,g);for(let l=0,c=d.length;l<c;l++)g=A(d.charCodeAt(l),g);return g}function P(d,g){return g=A(104579,g),d.reduce((l,c)=>O(c,l),g)}function f(d,g){return g=A(181387,g),Object.keys(d).sort().reduce((l,c)=>(l=R(c,l),O(d[c],l)),g)}class D{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=O(g,this._value),this._value}}e.Hasher=D;var w;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function m(d,g,l=32){const c=l-g,S=~((1<<c)-1);return(d<<g|(S&d)>>>c)>>>0}function h(d,g=0,l=d.byteLength,c=0){for(let S=0;S<l;S++)d[g+S]=c}function u(d,g,l="0"){for(;d.length<g;)d=l+d;return d}function y(d,g=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(l=>l.toString(16).padStart(2,"0")).join(""):u((d>>>0).toString(16),g/4)}class v{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const l=g.length;if(l===0)return;const c=this._buff;let S=this._buffLen,i=this._leftoverHighSurrogate,o,n;for(i!==0?(o=i,n=-1,i=0):(o=g.charCodeAt(0),n=0);;){let s=o;if(L.isHighSurrogate(o))if(n+1<l){const t=g.charCodeAt(n+1);L.isLowSurrogate(t)?(n++,s=L.computeCodePoint(o,t)):s=65533}else{i=o;break}else L.isLowSurrogate(o)&&(s=65533);if(S=this._push(c,S,s),n++,n<l)o=g.charCodeAt(n);else break}this._buffLen=S,this._leftoverHighSurrogate=i}_push(g,l,c){return c<128?g[l++]=c:c<2048?(g[l++]=192|(c&1984)>>>6,g[l++]=128|(c&63)>>>0):c<65536?(g[l++]=224|(c&61440)>>>12,g[l++]=128|(c&4032)>>>6,g[l++]=128|(c&63)>>>0):(g[l++]=240|(c&1835008)>>>18,g[l++]=128|(c&258048)>>>12,g[l++]=128|(c&4032)>>>6,g[l++]=128|(c&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=v._bigBlock32,l=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,l.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let c=this._h0,S=this._h1,i=this._h2,o=this._h3,n=this._h4,s,t,r;for(let a=0;a<80;a++)a<20?(s=S&i|~S&o,t=1518500249):a<40?(s=S^i^o,t=1859775393):a<60?(s=S&i|S&o|i&o,t=2400959708):(s=S^i^o,t=3395469782),r=m(c,5)+s+n+t+g.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(S,30),S=c,c=r;this._h0=this._h0+c&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v}),define(le[88],ue([0,1,27]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(U||(U={})),function(O){const A="error",_="warning",R="warn",P="info",f="ignore";function D(m){return m?L.equalsIgnoreCase(A,m)?O.Error:L.equalsIgnoreCase(_,m)||L.equalsIgnoreCase(R,m)?O.Warning:L.equalsIgnoreCase(P,m)?O.Info:O.Ignore:O.Ignore}O.fromValue=D;function w(m){switch(m){case O.Error:return A;case O.Warning:return _;case O.Info:return P;default:return f}}O.toString=w}(U||(U={})),e.default=U}),define(le[130],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(le[51],ue([0,1,17,27]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class O{constructor(){this._value="",this._pos=0}reset(h){return this._value=h,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(h){const u=h.charCodeAt(0),y=this._value.charCodeAt(this._pos);return u-y}value(){return this._value[this._pos]}}e.StringIterator=O;class A{constructor(h=!0){this._caseSensitive=h}reset(h){return this._value=h,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let h=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(h)this._from++;else break;else h=!1;return this}cmp(h){return this._caseSensitive?(0,U.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class _{constructor(h=!0,u=!0){this._splitOnBackslash=h,this._caseSensitive=u}reset(h){this._from=0,this._to=0,this._value=h,this._valueLen=h.length;for(let u=h.length-1;u>=0;u--,this._valueLen--){const y=this._value.charCodeAt(u);if(!(y===47||this._splitOnBackslash&&y===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let h=!0;for(;this._to<this._valueLen;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(h)this._from++;else break;else h=!1}return this}cmp(h){return this._caseSensitive?(0,U.compareSubstring)(h,this._value,0,h.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(h,this._value,0,h.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=_;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(h,u){this._ignorePathCasing=h,this._ignoreQueryAndFragment=u,this._states=[],this._stateIdx=0}reset(h){return this._value=h,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(h)),this._pathIterator.reset(h.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(h)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(h){if(this._states[this._stateIdx]===1)return(0,U.compareIgnoreCase)(h,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,U.compareIgnoreCase)(h,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(h);if(this._states[this._stateIdx]===4)return(0,U.compare)(h,this._value.query);if(this._states[this._stateIdx]===5)return(0,U.compare)(h,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(D||(D={}));class w{static forUris(h=()=>!1,u=()=>!1){return new w(new P(h,u))}static forPaths(h=!1){return new w(new _(void 0,!h))}static forStrings(){return new w(new O)}static forConfigKeys(){return new w(new A)}constructor(h){this._iter=h}clear(){this._root=void 0}fill(h,u){if(u){const y=u.slice(0);(0,L.shuffle)(y);for(const v of y)this.set(v,h)}else{const y=h.slice(0);(0,L.shuffle)(y);for(const v of y)this.set(v[0],v[1])}}set(h,u){const y=this._iter.reset(h);let v;this._root||(this._root=new f,this._root.segment=y.value());const d=[];for(v=this._root;;){const l=y.cmp(v.segment);if(l>0)v.left||(v.left=new f,v.left.segment=y.value()),d.push([-1,v]),v=v.left;else if(l<0)v.right||(v.right=new f,v.right.segment=y.value()),d.push([1,v]),v=v.right;else if(y.hasNext())y.next(),v.mid||(v.mid=new f,v.mid.segment=y.value()),d.push([0,v]),v=v.mid;else break}const g=v.value;v.value=u,v.key=h;for(let l=d.length-1;l>=0;l--){const c=d[l][1];c.updateHeight();const S=c.balanceFactor();if(S<-1||S>1){const i=d[l][0],o=d[l+1][0];if(i===1&&o===1)d[l][1]=c.rotateLeft();else if(i===-1&&o===-1)d[l][1]=c.rotateRight();else if(i===1&&o===-1)c.right=d[l+1][1]=d[l+1][1].rotateRight(),d[l][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=d[l+1][1]=d[l+1][1].rotateLeft(),d[l][1]=c.rotateRight();else throw new Error;if(l>0)switch(d[l-1][0]){case-1:d[l-1][1].left=d[l][1];break;case 1:d[l-1][1].right=d[l][1];break;case 0:d[l-1][1].mid=d[l][1];break}else this._root=d[0][1]}}return g}get(h){return this._getNode(h)?.value}_getNode(h){const u=this._iter.reset(h);let y=this._root;for(;y;){const v=u.cmp(y.segment);if(v>0)y=y.left;else if(v<0)y=y.right;else if(u.hasNext())u.next(),y=y.mid;else break}return y}has(h){const u=this._getNode(h);return!(u?.value===void 0&&u?.mid===void 0)}delete(h){return this._delete(h,!1)}deleteSuperstr(h){return this._delete(h,!0)}_delete(h,u){const y=this._iter.reset(h),v=[];let d=this._root;for(;d;){const g=y.cmp(d.segment);if(g>0)v.push([-1,d]),d=d.left;else if(g<0)v.push([1,d]),d=d.right;else if(y.hasNext())y.next(),v.push([0,d]),d=d.mid;else break}if(d){if(u?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const g=this._min(d.right);if(g.key){const{key:l,value:c,segment:S}=g;this._delete(g.key,!1),d.key=l,d.value=c,d.segment=S}}else{const g=d.left??d.right;if(v.length>0){const[l,c]=v[v.length-1];switch(l){case-1:c.left=g;break;case 0:c.mid=g;break;case 1:c.right=g;break}}else this._root=g}for(let g=v.length-1;g>=0;g--){const l=v[g][1];l.updateHeight();const c=l.balanceFactor();if(c>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),v[g][1]=l.rotateLeft()):c<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),v[g][1]=l.rotateRight()),g>0)switch(v[g-1][0]){case-1:v[g-1][1].left=v[g][1];break;case 1:v[g-1][1].right=v[g][1];break;case 0:v[g-1][1].mid=v[g][1];break}else this._root=v[0][1]}}}_min(h){for(;h.left;)h=h.left;return h}findSubstr(h){const u=this._iter.reset(h);let y=this._root,v;for(;y;){const d=u.cmp(y.segment);if(d>0)y=y.left;else if(d<0)y=y.right;else if(u.hasNext())u.next(),v=y.value||v,y=y.mid;else break}return y&&y.value||v}findSuperstr(h){return this._findSuperstrOrElement(h,!1)}_findSuperstrOrElement(h,u){const y=this._iter.reset(h);let v=this._root;for(;v;){const d=y.cmp(v.segment);if(d>0)v=v.left;else if(d<0)v=v.right;else if(y.hasNext())y.next(),v=v.mid;else return v.mid?this._entries(v.mid):u?v.value:void 0}}hasElementOrSubtree(h){return this._findSuperstrOrElement(h,!0)!==void 0}forEach(h){for(const[u,y]of this)h(y,u)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(h){const u=[];return this._dfsEntries(h,u),u[Symbol.iterator]()}_dfsEntries(h,u){h&&(h.left&&this._dfsEntries(h.left,u),h.value&&u.push([h.key,h.value]),h.mid&&this._dfsEntries(h.mid,u),h.right&&this._dfsEntries(h.right,u))}_isBalanced(){const h=u=>{if(!u)return!0;const y=u.balanceFactor();return y<-1||y>1?!1:h(u.left)&&h(u.right)};return h(this._root)}}e.TernarySearchTree=w}),define(le[13],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=L,e.isStringArray=U,e.isObject=O,e.isTypedArray=A,e.isNumber=_,e.isIterable=R,e.isBoolean=P,e.isUndefined=f,e.isDefined=D,e.isUndefinedOrNull=w,e.assertType=m,e.assertIsDefined=h,e.assertAllDefined=u,e.isEmptyObject=v,e.isFunction=d,e.areFunctions=g,e.validateConstraints=l,e.validateConstraint=c;function L(S){return typeof S=="string"}function U(S){return Array.isArray(S)&&S.every(i=>L(i))}function O(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}function A(S){const i=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof i}function _(S){return typeof S=="number"&&!isNaN(S)}function R(S){return!!S&&typeof S[Symbol.iterator]=="function"}function P(S){return S===!0||S===!1}function f(S){return typeof S>"u"}function D(S){return!w(S)}function w(S){return f(S)||S===null}function m(S,i){if(!S)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function h(S){if(w(S))throw new Error("Assertion Failed: argument is undefined or null");return S}function u(...S){const i=[];for(let o=0;o<S.length;o++){const n=S[o];if(w(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const y=Object.prototype.hasOwnProperty;function v(S){if(!O(S))return!1;for(const i in S)if(y.call(S,i))return!1;return!0}function d(S){return typeof S=="function"}function g(...S){return S.length>0&&S.every(d)}function l(S,i){const o=Math.min(S.length,i.length);for(let n=0;n<o;n++)c(S[n],i[n])}function c(S,i){if(L(i)){if(typeof S!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(S instanceof i)return}catch{}if(!w(S)&&S.constructor===i||i.length===1&&i.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],ue([0,1,13]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=U,e.deepFreeze=O,e.cloneAndChange=_,e.mixin=P,e.equals=f,e.safeStringify=D,e.distinct=w,e.getCaseInsensitive=m,e.filter=h,e.getAllPropertyNames=u,e.getAllMethodNames=y,e.createProxyObject=v;function U(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([l,c])=>{g[l]=c&&typeof c=="object"?U(c):c}),g}function O(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const l=g.shift();Object.freeze(l);for(const c in l)if(A.call(l,c)){const S=l[c];typeof S=="object"&&!Object.isFrozen(S)&&!(0,L.isTypedArray)(S)&&g.push(S)}}return d}const A=Object.prototype.hasOwnProperty;function _(d,g){return R(d,g,new Set)}function R(d,g,l){if((0,L.isUndefinedOrNull)(d))return d;const c=g(d);if(typeof c<"u")return c;if(Array.isArray(d)){const S=[];for(const i of d)S.push(R(i,g,l));return S}if((0,L.isObject)(d)){if(l.has(d))throw new Error("Cannot clone recursive data-structure");l.add(d);const S={};for(const i in d)A.call(d,i)&&(S[i]=R(d[i],g,l));return l.delete(d),S}return d}function P(d,g,l=!0){return(0,L.isObject)(d)?((0,L.isObject)(g)&&Object.keys(g).forEach(c=>{c in d?l&&((0,L.isObject)(d[c])&&(0,L.isObject)(g[c])?P(d[c],g[c],l):d[c]=g[c]):d[c]=g[c]}),d):g}function f(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let l,c;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(l=0;l<d.length;l++)if(!f(d[l],g[l]))return!1}else{const S=[];for(c in d)S.push(c);S.sort();const i=[];for(c in g)i.push(c);if(i.sort(),!f(S,i))return!1;for(l=0;l<S.length;l++)if(!f(d[S[l]],g[S[l]]))return!1}return!0}function D(d){const g=new Set;return JSON.stringify(d,(l,c)=>{if((0,L.isObject)(c)||Array.isArray(c)){if(g.has(c))return"[Circular]";g.add(c)}return c})}function w(d,g){const l=Object.create(null);return!d||!g||Object.keys(g).forEach(S=>{const i=d[S],o=g[S];f(i,o)||(l[S]=o)}),l}function m(d,g){const l=g.toLowerCase(),c=Object.keys(d).find(S=>S.toLowerCase()===l);return c?d[c]:d[g]}function h(d,g){const l=Object.create(null);for(const[c,S]of Object.entries(d))g(c,S)&&(l[c]=S);return l}function u(d){let g=[];for(;Object.prototype!==d;)g=g.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return g}function y(d){const g=[];for(const l of u(d))typeof d[l]=="function"&&g.push(l);return g}function v(d,g){const l=S=>function(){const i=Array.prototype.slice.call(arguments,0);return g(S,i)},c={};for(const S of d)c[S]=l(S);return c}}),define(le[32],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=U;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(O){return L.test(O)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),_=[];for(let R=0;R<256;R++)_.push(R.toString(16).padStart(2,"0"));return function(){O(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,f="";return f+=_[A[P++]],f+=_[A[P++]],f+=_[A[P++]],f+=_[A[P++]],f+="-",f+=_[A[P++]],f+=_[A[P++]],f+="-",f+=_[A[P++]],f+=_[A[P++]],f+="-",f+=_[A[P++]],f+=_[A[P++]],f+="-",f+=_[A[P++]],f+=_[A[P++]],f+=_[A[P++]],f+=_[A[P++]],f+=_[A[P++]],f+=_[A[P++]],f}}()}),define(le[131],ue([0,1,37]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=A;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(_){const R=_.replace(/\-/g,":").toLowerCase();return!U.has(R)}function A(){const _=(0,L.networkInterfaces)();for(const R in _){const P=_[R];if(P){for(const{mac:f}of P)if(O(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[132],ue([0,1,273,15]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class O extends L.Transform{constructor(_){if(super(),typeof _=="number")this.splitter=_,this.spitterLen=1;else{const R=Buffer.isBuffer(_)?_:Buffer.from(_);this.splitter=R.length===1?R[0]:R,this.spitterLen=R.length}}_transform(_,R,P){this.buffer?this.buffer=Buffer.concat([this.buffer,_]):this.buffer=_;let f=0;for(;f<this.buffer.length;){const D=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,f):(0,U.binaryIndexOf)(this.buffer,this.splitter,f);if(D===-1)break;this.push(this.buffer.slice(f,D+this.spitterLen)),f=D+this.spitterLen}this.buffer=f===this.buffer.length?void 0:this.buffer.slice(f),P()}_flush(_){this.buffer&&this.push(this.buffer),_()}}e.StreamSplitter=O}),define(le[133],ue([0,1,64]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=U,e.findFreePortFaster=A;function U(R,P,f,D=1){let w=!1;return new Promise(m=>{const h=setTimeout(()=>{if(!w)return w=!0,m(0)},f);O(R,P,D,u=>{if(!w)return w=!0,clearTimeout(h),m(u)})})}function O(R,P,f,D){if(P===0)return D(0);const w=new L.Socket;w.once("connect",()=>(_(w),O(R+f,P-1,f,D))),w.once("data",()=>{}),w.once("error",m=>(_(w),m.code!=="ECONNREFUSED"?O(R+f,P-1,f,D):D(R))),w.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,f,D="127.0.0.1"){let w=!1,m,h=1;const u=L.createServer({pauseOnConnect:!0});function y(v,d){w||(w=!0,u.removeAllListeners(),u.close(),m&&clearTimeout(m),d(v))}return new Promise(v=>{m=setTimeout(()=>{y(0,v)},f),u.on("listening",()=>{y(R,v)}),u.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&h<P?(R++,h++,u.listen(R,D)):y(0,v)}),u.on("close",()=>{y(0,v)}),u.listen(R,D)})}function _(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(le[134],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=L;function L(U){return!!U.parentPort}}),define(le[135],ue([11,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],ue([0,1,135]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=f,e.getDurationString=D,e.toLocalISOString=w;const U=60,O=U*60,A=O*24,_=A*7,R=A*30,P=A*365;function f(m,h,u,y){typeof m!="number"&&(m=m.getTime());const v=Math.round((new Date().getTime()-m)/1e3);if(v<-30)return(0,L.localize)(0,null,f(new Date().getTime()+v*1e3,!1));if(!y&&v<30)return(0,L.localize)(1,null);let d;return v<U?(d=v,h?d===1?u?(0,L.localize)(2,null,d):(0,L.localize)(3,null,d):u?(0,L.localize)(4,null,d):(0,L.localize)(5,null,d):d===1?u?(0,L.localize)(6,null,d):(0,L.localize)(7,null,d):u?(0,L.localize)(8,null,d):(0,L.localize)(9,null,d)):v<O?(d=Math.floor(v/U),h?d===1?u?(0,L.localize)(10,null,d):(0,L.localize)(11,null,d):u?(0,L.localize)(12,null,d):(0,L.localize)(13,null,d):d===1?u?(0,L.localize)(14,null,d):(0,L.localize)(15,null,d):u?(0,L.localize)(16,null,d):(0,L.localize)(17,null,d)):v<A?(d=Math.floor(v/O),h?d===1?u?(0,L.localize)(18,null,d):(0,L.localize)(19,null,d):u?(0,L.localize)(20,null,d):(0,L.localize)(21,null,d):d===1?u?(0,L.localize)(22,null,d):(0,L.localize)(23,null,d):u?(0,L.localize)(24,null,d):(0,L.localize)(25,null,d)):v<_?(d=Math.floor(v/A),h?d===1?(0,L.localize)(26,null,d):(0,L.localize)(27,null,d):d===1?(0,L.localize)(28,null,d):(0,L.localize)(29,null,d)):v<R?(d=Math.floor(v/_),h?d===1?u?(0,L.localize)(30,null,d):(0,L.localize)(31,null,d):u?(0,L.localize)(32,null,d):(0,L.localize)(33,null,d):d===1?u?(0,L.localize)(34,null,d):(0,L.localize)(35,null,d):u?(0,L.localize)(36,null,d):(0,L.localize)(37,null,d)):v<P?(d=Math.floor(v/R),h?d===1?u?(0,L.localize)(38,null,d):(0,L.localize)(39,null,d):u?(0,L.localize)(40,null,d):(0,L.localize)(41,null,d):d===1?u?(0,L.localize)(42,null,d):(0,L.localize)(43,null,d):u?(0,L.localize)(44,null,d):(0,L.localize)(45,null,d)):(d=Math.floor(v/P),h?d===1?u?(0,L.localize)(46,null,d):(0,L.localize)(47,null,d):u?(0,L.localize)(48,null,d):(0,L.localize)(49,null,d):d===1?u?(0,L.localize)(50,null,d):(0,L.localize)(51,null,d):u?(0,L.localize)(52,null,d):(0,L.localize)(53,null,d))}function D(m,h){const u=Math.abs(m/1e3);return u<1?h?(0,L.localize)(54,null,m):(0,L.localize)(55,null,m):u<U?h?(0,L.localize)(56,null,Math.round(m)/1e3):(0,L.localize)(57,null,Math.round(m)/1e3):u<O?h?(0,L.localize)(58,null,Math.round(m/(1e3*U))):(0,L.localize)(59,null,Math.round(m/(1e3*U))):u<A?h?(0,L.localize)(60,null,Math.round(m/(1e3*O))):(0,L.localize)(61,null,Math.round(m/(1e3*O))):(0,L.localize)(62,null,Math.round(m/(1e3*A)))}function w(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[136],ue([11,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],ue([0,1,17,13,136]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=P,e.isErrorWithActions=f,e.createErrorWithActions=D;function A(w,m){return m&&(w.stack||w.stacktrace)?O.localize(0,null,R(w),_(w.stack)||_(w.stacktrace)):R(w)}function _(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?O.localize(1,null,w.message):w.message||O.localize(2,null)}function P(w=null,m=!1){if(!w)return O.localize(3,null);if(Array.isArray(w)){const h=L.coalesce(w),u=P(h[0],m);return h.length>1?O.localize(4,null,u,h.length):u}if(U.isString(w))return w;if(w.detail){const h=w.detail;if(h.error)return A(h.error,m);if(h.exception)return A(h.exception,m)}return w.stack?A(w,m):w.message?w.message:O.localize(5,null)}function f(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}function D(w,m){let h;return typeof w=="string"?h=new Error(w):h=w,h.actions=m,h}}),define(le[137],ue([11,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],ue([0,1,137]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=U;function U(O){switch(O){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}}),define(le[139],ue([11,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],ue([0,1,139]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=o,e.isLittleEndian=E,e.isBigSurOrNewer=C,e.LANGUAGE_DEFAULT="en";let U=!1,O=!1,A=!1,_=!1,R=!1,P=!1,f=!1,D=!1,w=!1,m=!1,h,u=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT,v,d;const g=globalThis;let l;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?l=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const c=typeof l?.versions?.electron=="string",S=c&&l?.type==="renderer";if(typeof l=="object"){U=l.platform==="win32",O=l.platform==="darwin",A=l.platform==="linux",_=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,f=c,w=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,u=e.LANGUAGE_DEFAULT;const b=l.env.VSCODE_NLS_CONFIG;if(b)try{const I=JSON.parse(b),p=I.availableLanguages["*"];h=I.locale,y=I.osLocale,u=p||e.LANGUAGE_DEFAULT,v=I._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!S?(d=navigator.userAgent,U=d.indexOf("Windows")>=0,O=d.indexOf("Macintosh")>=0,D=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=d.indexOf("Linux")>=0,m=d?.indexOf("Mobi")>=0,P=!0,h=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,u=h,y=navigator.language):console.error("Unable to resolve platform.");var i;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;O?n=1:U?n=3:A&&(n=2),e.isWindows=U,e.isMacintosh=O,e.isLinux=A,e.isLinuxSnap=_,e.isNative=R,e.isElectron=f,e.isWeb=P,e.isWebWorker=P&&typeof g.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?g.origin:void 0,e.isIOS=D,e.isMobile=m,e.isCI=w,e.platform=n,e.userAgent=d,e.language=u;var s;(function(b){function I(){return e.language}b.value=I;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}b.isDefaultVariant=p;function k(){return e.language==="en"}b.isDefault=k})(s||(e.Language=s={})),e.locale=h,e.platformLocale=y,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof g.postMessage=="function"&&!g.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const b=[];g.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let k=0,N=b.length;k<N;k++){const F=b[k];if(F.id===p.data.vscodeScheduleAsyncWork){b.splice(k,1),F.callback();return}}});let I=0;return p=>{const k=++I;b.push({id:k,callback:p}),g.postMessage({vscodeScheduleAsyncWork:k},"*")}}return b=>setTimeout(b)})();var t;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=O||D?2:U?1:3;let r=!0,a=!1;function E(){if(!a){a=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,r=new Uint16Array(b.buffer)[0]===513}return r}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function C(b){return parseFloat(b)>=20}}),define(le[36],ue([0,1,5]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.process<"u"){const A=O.process;U={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(le[140],ue([0,1,36]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=_;var U;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(U||(U={}));const O="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function _(){const R=L.env[O];if(R){const f=R.split(":").map(D=>D.trim()).filter(D=>D.length>0);for(const D of f)switch(D){case"Unity":{const w=L.env.DESKTOP_SESSION;return w&&w.includes("gnome-fallback")?U.GNOME:U.UNITY}case"Deepin":return U.DEEPIN;case"GNOME":return U.GNOME;case"X-Cinnamon":return U.CINNAMON;case"KDE":{const w=L.env[A];return w==="5"?U.KDE5:w==="6"?U.KDE6:U.KDE4}case"Pantheon":return U.PANTHEON;case"XFCE":return U.XFCE;case"UKUI":return U.UKUI;case"LXQt":return U.LXQT}}const P=L.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return U.DEEPIN;case"gnome":case"mate":return U.GNOME;case"kde4":case"kde-plasma":return U.KDE4;case"kde":return A in L.env?U.KDE4:U.KDE3;case"xfce":case"xubuntu":return U.XFCE;case"ukui":return U.UKUI}return"GNOME_DESKTOP_SESSION_ID"in L.env?U.GNOME:"KDE_FULL_SESSION"in L.env?A in L.env?U.KDE4:U.KDE3:U.UNKNOWN}}),define(le[14],ue([0,1,36]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,O=97,A=90,_=122,R=46,P=47,f=92,D=58,w=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function u(i,o){if(typeof i!="string")throw new m(o,"string",i)}const y=L.platform==="win32";function v(i){return i===P||i===f}function d(i){return i===P}function g(i){return i>=U&&i<=A||i>=O&&i<=_}function l(i,o,n,s){let t="",r=0,a=-1,E=0,C=0;for(let b=0;b<=i.length;++b){if(b<i.length)C=i.charCodeAt(b);else{if(s(C))break;C=P}if(s(C)){if(!(a===b-1||E===1))if(E===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const I=t.lastIndexOf(n);I===-1?(t="",r=0):(t=t.slice(0,I),r=t.length-1-t.lastIndexOf(n)),a=b,E=0;continue}else if(t.length!==0){t="",r=0,a=b,E=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,b)}`:t=i.slice(a+1,b),r=b-a-1;a=b,E=0}else C===R&&E!==-1?++E:E=-1}return t}function c(i,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.win32={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],u(r,"path"),r.length===0)continue}else o.length===0?r=L.cwd():(r=L.env[`=${o}`]||L.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===f)&&(r=`${o}\\`));const a=r.length;let E=0,C="",b=!1;const I=r.charCodeAt(0);if(a===1)v(I)&&(E=1,b=!0);else if(v(I))if(b=!0,v(r.charCodeAt(1))){let p=2,k=p;for(;p<a&&!v(r.charCodeAt(p));)p++;if(p<a&&p!==k){const N=r.slice(k,p);for(k=p;p<a&&v(r.charCodeAt(p));)p++;if(p<a&&p!==k){for(k=p;p<a&&!v(r.charCodeAt(p));)p++;(p===a||p!==k)&&(C=`\\\\${N}\\${r.slice(k,p)}`,E=p)}}}else E=1;else g(I)&&r.charCodeAt(1)===D&&(C=r.slice(0,2),E=2,a>2&&v(r.charCodeAt(2))&&(b=!0,E=3));if(C.length>0)if(o.length>0){if(C.toLowerCase()!==o.toLowerCase())continue}else o=C;if(s){if(o.length>0)break}else if(n=`${r.slice(E)}\\${n}`,s=b,b&&o.length>0)break}return n=l(n,!s,"\\",v),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){u(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return d(r)?"\\":i;if(v(r))if(t=!0,v(i.charCodeAt(1))){let E=2,C=E;for(;E<o&&!v(i.charCodeAt(E));)E++;if(E<o&&E!==C){const b=i.slice(C,E);for(C=E;E<o&&v(i.charCodeAt(E));)E++;if(E<o&&E!==C){for(C=E;E<o&&!v(i.charCodeAt(E));)E++;if(E===o)return`\\\\${b}\\${i.slice(C)}\\`;E!==C&&(s=`\\\\${b}\\${i.slice(C,E)}`,n=E)}}}else n=1;else g(r)&&i.charCodeAt(1)===D&&(s=i.slice(0,2),n=2,o>2&&v(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?l(i.slice(n),!t,"\\",v):"";return a.length===0&&!t&&(a="."),a.length>0&&v(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){u(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return v(n)||o>2&&g(n)&&i.charCodeAt(1)===D&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];u(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&v(n.charCodeAt(0))){++t;const r=n.length;r>1&&v(n.charCodeAt(1))&&(++t,r>2&&(v(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&v(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.win32.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o)return"";const n=e.win32.resolve(i),s=e.win32.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===f;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===f;)r--;const a=r-t;let E=0;for(;E<o.length&&o.charCodeAt(E)===f;)E++;let C=o.length;for(;C-1>E&&o.charCodeAt(C-1)===f;)C--;const b=C-E,I=a<b?a:b;let p=-1,k=0;for(;k<I;k++){const F=i.charCodeAt(t+k);if(F!==o.charCodeAt(E+k))break;F===f&&(p=k)}if(k!==I){if(p===-1)return s}else{if(b>I){if(o.charCodeAt(E+k)===f)return s.slice(E+k+1);if(k===2)return s.slice(E+k)}a>I&&(i.charCodeAt(t+k)===f?p=k:k===2&&(p=3)),p===-1&&(p=0)}let N="";for(k=t+p+1;k<=r;++k)(k===r||i.charCodeAt(k)===f)&&(N+=N.length===0?"..":"\\..");return E+=p,N.length>0?`${N}${s.slice(E,C)}`:(s.charCodeAt(E)===f&&++E,s.slice(E,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===f){if(o.charCodeAt(1)===f){const n=o.charCodeAt(2);if(n!==w&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===D&&o.charCodeAt(2)===f)return`\\\\?\\${o}`;return i},dirname(i){u(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return v(t)?i:".";if(v(t)){if(n=s=1,v(i.charCodeAt(1))){let E=2,C=E;for(;E<o&&!v(i.charCodeAt(E));)E++;if(E<o&&E!==C){for(C=E;E<o&&v(i.charCodeAt(E));)E++;if(E<o&&E!==C){for(C=E;E<o&&!v(i.charCodeAt(E));)E++;if(E===o)return i;E!==C&&(n=s=E+1)}}}}else g(t)&&i.charCodeAt(1)===D&&(n=o>2&&v(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let E=o-1;E>=s;--E)if(v(i.charCodeAt(E))){if(!a){r=E;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===D&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=n;--r){const C=i.charCodeAt(r);if(v(C)){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(C===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(v(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){u(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===D&&g(i.charCodeAt(0))&&(o=s=2);for(let E=i.length-1;E>=o;--E){const C=i.charCodeAt(E);if(v(C)){if(!r){s=E+1;break}continue}t===-1&&(r=!1,t=E+1),C===R?n===-1?n=E:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return v(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(t)){if(s=1,v(i.charCodeAt(1))){let p=2,k=p;for(;p<n&&!v(i.charCodeAt(p));)p++;if(p<n&&p!==k){for(k=p;p<n&&v(i.charCodeAt(p));)p++;if(p<n&&p!==k){for(k=p;p<n&&!v(i.charCodeAt(p));)p++;p===n?s=p:p!==k&&(s=p+1)}}}}else if(g(t)&&i.charCodeAt(1)===D){if(n<=2)return o.root=o.dir=i,o;if(s=2,v(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,E=-1,C=!0,b=i.length-1,I=0;for(;b>=s;--b){if(t=i.charCodeAt(b),v(t)){if(!C){a=b+1;break}continue}E===-1&&(C=!1,E=b+1),t===R?r===-1?r=b:I!==1&&(I=1):r!==-1&&(I=-1)}return E!==-1&&(r===-1||I===0||I===1&&r===E-1&&r===a+1?o.base=o.name=i.slice(a,E):(o.name=i.slice(a,r),o.base=i.slice(a,E),o.ext=i.slice(r,E))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(y){const i=/\\/g;return()=>{const o=L.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:S();u(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===P)}return o=l(o,!n,"/",d),n?`/${o}`:o.length>0?o:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P,n=i.charCodeAt(i.length-1)===P;return i=l(i,!o,"/",d),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];u(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,E=t<a?t:a;let C=-1,b=0;for(;b<E;b++){const p=i.charCodeAt(n+b);if(p!==o.charCodeAt(r+b))break;p===P&&(C=b)}if(b===E)if(a>E){if(o.charCodeAt(r+b)===P)return o.slice(r+b+1);if(b===0)return o.slice(r+b)}else t>E&&(i.charCodeAt(n+b)===P?C=b:b===0&&(C=0));let I="";for(b=n+C+1;b<=s;++b)(b===s||i.charCodeAt(b)===P)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(r+C)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===P;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===P){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=0;--r){const C=i.charCodeAt(r);if(C===P){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(C===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===P){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){u(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const E=i.charCodeAt(a);if(E===P){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),E===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===P;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,E=!0,C=i.length-1,b=0;for(;C>=s;--C){const I=i.charCodeAt(C);if(I===P){if(!E){r=C+1;break}continue}a===-1&&(E=!1,a=C+1),I===R?t===-1?t=C:b!==1&&(b=1):t!==-1&&(b=-1)}if(a!==-1){const I=r===0&&n?1:r;t===-1||b===0||b===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(I,a):(o.name=i.slice(I,t),o.base=i.slice(I,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(le[44],ue([0,1,14,5,27,13]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=_,e.toSlashes=R,e.toPosixPath=P,e.getRoot=f,e.isUNC=D,e.isValidBasename=u,e.isEqual=y,e.isEqualOrParent=v,e.isWindowsDriveLetter=d,e.sanitizeFilePath=g,e.isRootOrDriveLetter=l,e.hasDriveLetter=c,e.getDriveLetter=S,e.indexOfPath=i,e.parseLineAndColumnAware=o,e.randomPath=t;function _(r){return r===47||r===92}function R(r){return r.replace(/[\\/]/g,L.posix.sep)}function P(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function f(r,a=L.posix.sep){if(!r)return"";const E=r.length,C=r.charCodeAt(0);if(_(C)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let I=3;const p=I;for(;I<E&&!_(r.charCodeAt(I));I++);if(p!==I&&!_(r.charCodeAt(I+1))){for(I+=1;I<E;I++)if(_(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,a)}}return a}else if(d(C)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let b=r.indexOf("://");if(b!==-1){for(b+=3;b<E;b++)if(_(r.charCodeAt(b)))return r.slice(0,b+1)}return""}function D(r){if(!U.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let E=2;const C=E;for(;E<r.length&&(a=r.charCodeAt(E),a!==92);E++);return!(C===E||(a=r.charCodeAt(E+1),isNaN(a)||a===92))}const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,a=U.isWindows){const E=a?w:m;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function y(r,a,E){const C=r===a;return!E||C?C:!r||!a?!1:(0,O.equalsIgnoreCase)(r,a)}function v(r,a,E,C=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(E){if(!(0,O.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let I=a.length;return a.charAt(a.length-1)===C&&I--,r.charAt(I)===C}return a.charAt(a.length-1)!==C&&(a+=C),r.indexOf(a)===0}function d(r){return r>=65&&r<=90||r>=97&&r<=122}function g(r,a){return U.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(a,r)),r=(0,L.normalize)(r),U.isWindows?(r=(0,O.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,O.rtrim)(r,L.sep),r||(r=L.sep)),r}function l(r){const a=(0,L.normalize)(r);return U.isWindows?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.posix.sep}function c(r,a=U.isWindows){return a?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function S(r,a=U.isWindows){return c(r,a)?r[0]:void 0}function i(r,a,E){return a.length>r.length?-1:r===a?0:(E&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let E,C,b;for(const I of a){const p=Number(I);(0,A.isNumber)(p)?C===void 0?C=p:b===void 0&&(b=p):E=E?[E,I].join(":"):I}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:C!==void 0?C:void 0,column:b!==void 0?b:C!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,E=8){let C="";for(let I=0;I<E;I++){let p;I===0&&U.isWindows&&!a&&(E===3||E===4)?p=s:p=n,C+=p.charAt(Math.floor(Math.random()*p.length))}let b;return a?b=`${a}-${C}`:b=C,r?(0,L.join)(r,b):b}}),define(le[141],ue([0,1,14]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=A,e.getMediaMime=_,e.getExtensionForMimeType=R,e.normalizeMimeType=f,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(D){const w=(0,L.extname)(D),m=U[w.toLowerCase()];return m!==void 0?m:_(D)}function _(D){const w=(0,L.extname)(D);return O[w.toLowerCase()]}function R(D){for(const w in O)if(O[w]===D)return w}const P=/^(.+)\/(.+?)(;.+)?$/;function f(D,w){const m=P.exec(D);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:D}}),define(le[89],ue([0,1,5]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=_;var U;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(U||(e.Source=U={}));var O;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function A(R,...P){const f=P.reduce((m,h)=>(m[h]=!0,m),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!f[m]).forEach(m=>{for(let h=0;h<D.length;h++)if(m.search(D[h])!==-1){delete R[m];break}})}function _(R){R&&(delete R.DEBUG,L.isMacintosh&&delete R.DYLD_LIBRARY_PATH,L.isLinux&&delete R.LD_PRELOAD)}}),define(le[8],ue([0,1,14,5]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=u,e.uriToFsPath=c;const O=/^\w[\w\d+.-]*$/,A=/^\//,_=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!O.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,t){return!s&&!t?"file":s}function f(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==w&&(t=w+t):t=w;break}return t}const D="",w="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(t){return t instanceof h?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,E,C,b=!1){typeof t=="object"?(this.scheme=t.scheme||D,this.authority=t.authority||D,this.path=t.path||D,this.query=t.query||D,this.fragment=t.fragment||D):(this.scheme=P(t,b),this.authority=r||D,this.path=f(this.scheme,a||D),this.query=E||D,this.fragment=C||D,R(this,b))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:E,query:C,fragment:b}=t;return r===void 0?r=this.scheme:r===null&&(r=D),a===void 0?a=this.authority:a===null&&(a=D),E===void 0?E=this.path:E===null&&(E=D),C===void 0?C=this.query:C===null&&(C=D),b===void 0?b=this.fragment:b===null&&(b=D),r===this.scheme&&a===this.authority&&E===this.path&&C===this.query&&b===this.fragment?this:new v(r,a,E,C,b)}static parse(t,r=!1){const a=m.exec(t);return a?new v(a[2]||D,n(a[4]||D),n(a[5]||D),n(a[7]||D),n(a[9]||D),r):new v(D,D,D,D,D)}static file(t){let r=D;if(U.isWindows&&(t=t.replace(/\\/g,w)),t[0]===w&&t[1]===w){const a=t.indexOf(w,2);a===-1?(r=t.substring(2),t=w):(r=t.substring(2,a),t=t.substring(a)||w)}return new v("file",r,t,D,D)}static from(t,r){return new v(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return U.isWindows&&t.scheme==="file"?a=h.file(L.win32.join(c(t,!0),...r)).path:a=L.posix.join(t.path,...r),t.with({path:a})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof h)return t;{const r=new v(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=h;function u(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const y=U.isWindows?1:void 0;class v extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(s,t,r){let a,E=-1;for(let C=0;C<s.length;C++){const b=s.charCodeAt(C);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||t&&b===47||r&&b===91||r&&b===93||r&&b===58)E!==-1&&(a+=encodeURIComponent(s.substring(E,C)),E=-1),a!==void 0&&(a+=s.charAt(C));else{a===void 0&&(a=s.substr(0,C));const I=d[b];I!==void 0?(E!==-1&&(a+=encodeURIComponent(s.substring(E,C)),E=-1),a+=I):E===-1&&(E=C)}}return E!==-1&&(a+=encodeURIComponent(s.substring(E))),a!==void 0?a:s}function l(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=d[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,U.isWindows&&(r=r.replace(/\//g,"\\")),r}function S(s,t){const r=t?l:g;let a="",{scheme:E,authority:C,path:b,query:I,fragment:p}=s;if(E&&(a+=E,a+=":"),(C||E==="file")&&(a+=w,a+=w),C){let k=C.indexOf("@");if(k!==-1){const N=C.substr(0,k);C=C.substr(k+1),k=N.lastIndexOf(":"),k===-1?a+=r(N,!1,!1):(a+=r(N.substr(0,k),!1,!1),a+=":",a+=r(N.substr(k+1),!1,!0)),a+="@"}C=C.toLowerCase(),k=C.lastIndexOf(":"),k===-1?a+=r(C,!1,!0):(a+=r(C.substr(0,k),!1,!0),a+=C.substr(k))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const k=b.charCodeAt(1);k>=65&&k<=90&&(b=`/${String.fromCharCode(k+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const k=b.charCodeAt(0);k>=65&&k<=90&&(b=`${String.fromCharCode(k+32)}:${b.substr(2)}`)}a+=r(b,!0,!1)}return I&&(a+="?",a+=r(I,!1,!1)),p&&(a+="#",a+=t?p:g(p,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],ue([0,1,8]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=U,e.parse=O,e.getFirstFrame=A,e.log=R;function U(f){const D=f;return D&&typeof D.type=="string"&&typeof D.severity=="string"}function O(f){const D=[];let w;try{const m=JSON.parse(f.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),w=h.__$stack),D.push(...m)}catch{D.push("Unable to log remote console arguments",f.arguments)}return{args:D,stack:w}}function A(f){if(typeof f!="string")return A(O(f).stack);const D=f;if(D){const w=_(D),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function _(f){if(!f)return f;const D=f.indexOf(`
`);return D===-1?f:f.substring(0,D)}function R(f,D){const{args:w,stack:m}=O(f),h=typeof w[0]=="string"&&w.length===1;let u=_(m);u&&(u=`(${u.trim()})`);let y=[];if(typeof w[0]=="string"?u&&h?y=[`%c[${D}] %c${w[0]} %c${u}`,P("blue"),P(""),P("grey")]:y=[`%c[${D}] %c${w[0]}`,P("blue"),P(""),...w.slice(1)]:y=[`%c[${D}]%`,P("blue"),...w],u&&!h&&y.push(u),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,y)}function P(f){return`color: ${f}`}}),define(le[66],ue([0,1,15,8]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=O,e.parse=A,e.revive=R;function O(P){return JSON.stringify(P,_)}function A(P){let f=JSON.parse(P);return f=R(f),f}function _(P,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function R(P,f=0){if(!P||f>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return U.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let D=0;D<P.length;++D)P[D]=R(P[D],f+1);else for(const D in P)Object.hasOwnProperty.call(P,D)&&(P[D]=R(P[D],f+1))}return P}}),define(le[23],ue([0,1,7,5,27,8,14]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=P,e.matchesSomeScheme=f,e.getServerRootPath=w;var R;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.codeSetting="code-setting"})(R||(e.Schemas=R={}));function P(u,y){return A.URI.isUri(u)?(0,O.equalsIgnoreCase)(u.scheme,y):(0,O.startsWithIgnoreCase)(u,y+":")}function f(u,...y){return y.some(v=>P(u,v))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}setServerRootPath(y,v){this._serverRootPath=w(y,v)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return _.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(y,v,d){this._hosts[y]=v,this._ports[y]=d}setConnectionToken(y,v){this._connectionTokens[y]=v}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(y){if(this._delegate)try{return this._delegate(y)}catch(S){return L.onUnexpectedError(S),y}const v=y.authority;let d=this._hosts[v];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const g=this._ports[v],l=this._connectionTokens[v];let c=`path=${encodeURIComponent(y.path)}`;return typeof l=="string"&&(c+=`&${e.connectionTokenQueryName}=${encodeURIComponent(l)}`),A.URI.from({scheme:U.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${d}:${g}`,path:this._remoteResourcesPath,query:c})}}e.RemoteAuthorities=new D;function w(u,y){return _.posix.join(y??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class m{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(y){const v=this.toUri(y,se);return this.uriToBrowserUri(v)}uriToBrowserUri(y){return y.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===R.file&&(U.isNative||U.webWorkerOrigin===`${R.vscodeFileResource}://${m.FALLBACK_AUTHORITY}`)?y.with({scheme:R.vscodeFileResource,authority:y.authority||m.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(y){const v=this.toUri(y,se);return this.uriToFileUri(v)}uriToFileUri(y){return y.scheme===R.vscodeFileResource?y.with({scheme:R.file,authority:y.authority!==m.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(y,v){return A.URI.isUri(y)?y:A.URI.parse(v.toUrl(y))}}e.FileAccess=new m;var h;(function(u){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(y.get("3"));const v="vscode-coi";function d(l){let c;typeof l=="string"?c=new URL(l).searchParams:l instanceof URL?c=l.searchParams:A.URI.isUri(l)&&(c=new URL(l.toString(!0)).searchParams);const S=c?.get(v);if(S)return y.get(S)}u.getHeadersFromQuery=d;function g(l,c,S){if(!globalThis.crossOriginIsolated)return;const i=c&&S?"3":S?"2":"1";l instanceof URLSearchParams?l.set(v,i):l[v]=i}u.addSearchParam=g})(h||(e.COI=h={}))}),define(le[143],ue([0,1,124,23,5,8]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=D;class _{constructor(m,h,u){this.id=m,this.dependencies=h,this.callback=u}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(m,h,u)=>{typeof m!="string"&&(u=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&(u=h,h=null),this._defineCalls.push(new _(m,h,u))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this._initialize();const h=await(this._isWebWorker?this._workerLoadScript(m):this._isRenderer?this._rendererLoadScript(m):this._nodeJSLoadScript(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}_rendererLoadScript(m){return new Promise((h,u)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const v=()=>{y.removeEventListener("load",d),y.removeEventListener("error",g)},d=l=>{v(),h(this._defineCalls.pop())},g=l=>{v(),u(l)};y.addEventListener("load",d),y.addEventListener("error",g),this._amdPolicy&&(m=this._amdPolicy.createScriptURL(m)),y.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(y)})}_workerLoadScript(m){return new Promise((h,u)=>{try{this._amdPolicy&&(m=this._amdPolicy.createScriptURL(m)),importScripts(m),h(this._defineCalls.pop())}catch(y){u(y)}})}async _nodeJSLoadScript(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,u=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,v=A.URI.parse(m).fsPath,d=h.readFileSync(v).toString(),g=y.wrap(d.replace(/^#!.*/,""));return new u.Script(g).runInThisContext().apply(),this._defineCalls.pop()}catch(h){throw h}}}const P=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function D(w,m,h){if(L.isESM){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[w]&&(w=f[w]);const u=`${w}/${m}`;if(P.has(u))return P.get(u);let y;if(/^\w[\w\d+.-]*:\/\//.test(u))y=u;else{const l=`${h&&!O.isWeb?U.nodeModulesAsarPath:U.nodeModulesPath}/${u}`;y=U.FileAccess.asBrowserUri(l).toString(!0)}const v=R.INSTANCE.load(y);return P.set(u,v),v}else return await new Promise((u,y)=>{se([w],u,y)})}}),define(le[20],ue([0,1,44,23,14,5,27,8]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=P,e.distinctParents=D,e.toLocalResource=m;function P(h){return(0,R.uriToFsPath)(h,!0)}class f{constructor(u){this._ignorePathCasing=u}compare(u,y,v=!1){return u===y?0:(0,_.compare)(this.getComparisonKey(u,v),this.getComparisonKey(y,v))}isEqual(u,y,v=!1){return u===y?!0:!u||!y?!1:this.getComparisonKey(u,v)===this.getComparisonKey(y,v)}getComparisonKey(u,y=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,y,v=!1){if(u.scheme===y.scheme){if(u.scheme===U.Schemas.file)return L.isEqualOrParent(P(u),P(y),this._ignorePathCasing(u))&&u.query===y.query&&(v||u.fragment===y.fragment);if((0,e.isEqualAuthority)(u.authority,y.authority))return L.isEqualOrParent(u.path,y.path,this._ignorePathCasing(u),"/")&&u.query===y.query&&(v||u.fragment===y.fragment)}return!1}joinPath(u,...y){return R.URI.joinPath(u,...y)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return O.posix.basename(u.path)}extname(u){return O.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let y;return u.scheme===U.Schemas.file?y=R.URI.file(O.dirname(P(u))).path:(y=O.posix.dirname(u.path),u.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),y="/")),u.with({path:y})}normalizePath(u){if(!u.path.length)return u;let y;return u.scheme===U.Schemas.file?y=R.URI.file(O.normalize(P(u))).path:y=O.posix.normalize(u.path),u.with({path:y})}relativePath(u,y){if(u.scheme!==y.scheme||!(0,e.isEqualAuthority)(u.authority,y.authority))return;if(u.scheme===U.Schemas.file){const g=O.relative(P(u),P(y));return A.isWindows?L.toSlashes(g):g}let v=u.path||"/";const d=y.path||"/";if(this._ignorePathCasing(u)){let g=0;for(const l=Math.min(v.length,d.length);g<l&&!(v.charCodeAt(g)!==d.charCodeAt(g)&&v.charAt(g).toLowerCase()!==d.charAt(g).toLowerCase());g++);v=d.substr(0,g)+v.substr(g)}return O.posix.relative(v,d)}resolvePath(u,y){if(u.scheme===U.Schemas.file){const v=R.URI.file(O.resolve(P(u),y));return u.with({authority:v.authority,path:v.path})}return y=L.toPosixPath(y),u.with({path:O.posix.resolve(u.path,y)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,y){return u===y||u!==void 0&&y!==void 0&&(0,_.equalsIgnoreCase)(u,y)}hasTrailingPathSeparator(u,y=O.sep){if(u.scheme===U.Schemas.file){const v=P(u);return v.length>L.getRoot(v).length&&v[v.length-1]===y}else{const v=u.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,y=O.sep){return(0,e.hasTrailingPathSeparator)(u,y)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,y=O.sep){let v=!1;if(u.scheme===U.Schemas.file){const d=P(u);v=d!==void 0&&d.length===L.getRoot(d).length&&d[d.length-1]===y}else{y="/";const d=u.path;v=d.length===1&&d.charCodeAt(d.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(u,y)?u.with({path:u.path+"/"}):u}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(h=>h.scheme===U.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new f(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(h,u){const y=[];for(let v=0;v<h.length;v++){const d=u(h[v]);h.some((g,l)=>l===v?!1:(0,e.isEqualOrParent)(d,u(g)))||y.push(h[v])}return y}var w;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function u(y){const v=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,S]=l.split(":");c&&S&&v.set(c,S)});const g=y.path.substring(0,y.path.indexOf(";"));return g&&v.set(h.META_DATA_MIME,g),v}h.parseMetaData=u})(w||(e.DataUri=w={}));function m(h,u,y){if(u){let v=h.path;return v&&v[0]!==O.posix.sep&&(v=O.posix.sep+v),h.with({scheme:y,authority:u,path:v})}return h.with({scheme:y})}}),define(le[6],ue([0,1,26,7,3,2,20,5,130,53]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=D,e.createCancelablePromise=w,e.raceCancellation=m,e.raceCancellationError=h,e.raceCancellablePromises=u,e.raceTimeout=y,e.asPromise=v,e.promiseWithResolvers=d,e.timeout=r,e.disposableTimeout=a,e.sequence=E,e.first=C,e.firstParallel=b,e.retry=q,e.createCancelableAsyncIterable=H;function D(Q){return!!Q&&typeof Q.then=="function"}function w(Q){const Y=new L.CancellationTokenSource,ne=Q(Y.token),re=new Promise((he,fe)=>{const me=Y.token.onCancellationRequested(()=>{me.dispose(),fe(new U.CancellationError)});Promise.resolve(ne).then(Ee=>{me.dispose(),Y.dispose(),he(Ee)},Ee=>{me.dispose(),Y.dispose(),fe(Ee)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(he,fe){return re.then(he,fe)}catch(he){return this.then(void 0,he)}finally(he){return re.finally(he)}}}function m(Q,Y,ne){return new Promise((re,he)=>{const fe=Y.onCancellationRequested(()=>{fe.dispose(),re(ne)});Q.then(re,he).finally(()=>fe.dispose())})}function h(Q,Y){return new Promise((ne,re)=>{const he=Y.onCancellationRequested(()=>{he.dispose(),re(new U.CancellationError)});Q.then(ne,re).finally(()=>he.dispose())})}async function u(Q){let Y=-1;const ne=Q.map((re,he)=>re.then(fe=>(Y=he,fe)));try{return await Promise.race(ne)}finally{Q.forEach((re,he)=>{he!==Y&&re.cancel()})}}function y(Q,Y,ne){let re;const he=setTimeout(()=>{re?.(void 0),ne?.()},Y);return Promise.race([Q.finally(()=>clearTimeout(he)),new Promise(fe=>re=fe)])}function v(Q){return new Promise((Y,ne)=>{const re=Q();D(re)?re.then(Y,ne):Y(re)})}function d(){let Q,Y;return{promise:new Promise((re,he)=>{Q=re,Y=he}),resolve:Q,reject:Y}}class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ne=()=>{if(this.queuedPromise=null,this.isDisposed)return;const re=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,re};this.queuedPromise=new Promise(re=>{this.activePromise.then(ne,ne).then(re)})}return new Promise((ne,re)=>{this.queuedPromise.then(ne,re)})}return this.activePromise=Y(),new Promise((ne,re)=>{this.activePromise.then(he=>{this.activePromise=null,ne(he)},he=>{this.activePromise=null,re(he)})})}dispose(){this.isDisposed=!0}}e.Throttler=g;class l{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=l;class c{constructor(){this.promiseMap=new Map}queue(Y,ne){const he=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.promiseMap.get(Y)===he&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,he),he}}e.SequencerByKey=c;const S=(Q,Y)=>{let ne=!0;const re=setTimeout(()=>{ne=!1,Y()},Q);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(re),ne=!1}}},i=Q=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,Q())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class o{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ne=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((he,fe)=>{this.doResolve=he,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const he=this.task;return this.task=null,he()}}));const re=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ne===P.MicrotaskDelay?i(re):S(ne,re),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new U.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=o;class n{constructor(Y){this.delayer=new o(Y),this.throttler=new g}trigger(Y,ne){return this.delayer.trigger(()=>this.throttler.queue(Y),ne)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ne)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class t extends s{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=t;function r(Q,Y){return Y?new Promise((ne,re)=>{const he=setTimeout(()=>{fe.dispose(),ne()},Q),fe=Y.onCancellationRequested(()=>{clearTimeout(he),fe.dispose(),re(new U.CancellationError)})}):w(ne=>r(Q,ne))}function a(Q,Y=0,ne){const re=setTimeout(()=>{Q(),ne&&he.dispose()},Y),he=(0,A.toDisposable)(()=>{clearTimeout(re),ne?.deleteAndLeak(he)});return ne?.add(he),he}function E(Q){const Y=[];let ne=0;const re=Q.length;function he(){return ne<re?Q[ne++]():null}function fe(me){me!=null&&Y.push(me);const Ee=he();return Ee?Ee.then(fe):Promise.resolve(Y)}return Promise.resolve(null).then(fe)}function C(Q,Y=re=>!!re,ne=null){let re=0;const he=Q.length,fe=()=>{if(re>=he)return Promise.resolve(ne);const me=Q[re++];return Promise.resolve(me()).then(Ie=>Y(Ie)?Promise.resolve(Ie):fe())};return fe()}function b(Q,Y=re=>!!re,ne=null){if(Q.length===0)return Promise.resolve(ne);let re=Q.length;const he=()=>{re=-1;for(const fe of Q)fe.cancel?.()};return new Promise((fe,me)=>{for(const Ee of Q)Ee.then(Ie=>{--re>=0&&Y(Ie)?(he(),fe(Ie)):re===0&&fe(ne)}).catch(Ie=>{--re>=0&&(he(),me(Ie))})})}class I{constructor(Y){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new O.Emitter}whenIdle(){return this.size>0?O.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ne,re)=>{this.outstandingPromises.push({factory:Y,c:ne,e:re}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ne=Y.factory();ne.then(Y.c,Y.e),ne.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=I;class p extends I{constructor(){super(1)}}e.Queue=p;class k{constructor(){this.sequentializer=new ie,this.tasks=0}queue(Y){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,Y())):this.sequentializer.run(this.tasks++,Y())}}e.LimitedQueue=k;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const Y=new ce;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueSize(Y,ne=_.extUri){const re=ne.getComparisonKey(Y);return this.queues.get(re)?.size??0}queueFor(Y,ne,re=_.extUri){const he=re.getComparisonKey(Y);let fe=this.queues.get(he);if(!fe){fe=new p;const me=this.drainListenerCount++,Ee=O.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.queues.delete(he),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(me),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(me,Ee),this.queues.set(he,fe)}return fe.queue(ne)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class F{constructor(Y,ne){this._token=-1,typeof Y=="function"&&typeof ne=="number"&&this.setIfNotSet(Y,ne)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ne){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ne)}setIfNotSet(Y,ne){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ne))}}e.TimeoutTimer=F;class x{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(Y,ne,re=globalThis){this.cancel();const he=re.setInterval(()=>{Y()},ne);this.disposable=(0,A.toDisposable)(()=>{re.clearInterval(he),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=x;class Z{constructor(Y,ne){this.timeoutToken=-1,this.runner=Y,this.timeout=ne,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Z;class B{constructor(Y,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ne,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=B;class X extends Z{constructor(Y,ne){super(Y,ne),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class j extends A.Disposable{constructor(Y,ne){super(),this.options=Y,this.handler=ne,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ne of Y)this.pendingWork.push(ne);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Z(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=j,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Q,Y)=>{(0,R.setTimeout0)(()=>{if(ne)return;const re=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e._runWhenIdle=(Q,Y,ne)=>{const re=Q.requestIdleCallback(Y,typeof ne=="number"?{timeout:ne}:void 0);let he=!1;return{dispose(){he||(he=!0,Q.cancelIdleCallback(re))}}},e.runWhenGlobalIdle=Q=>(0,e._runWhenIdle)(globalThis,Q)}();class G{constructor(Y,ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(re){this._error=re}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(Y,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=G;class z extends G{constructor(Y){super(globalThis,Y)}}e.GlobalIdleValue=z;async function q(Q,Y,ne){let re;for(let he=0;he<ne;he++)try{return await Q()}catch(fe){re=fe,await r(Y)}throw re}class ie{isRunning(Y){return typeof Y=="number"?this._running?.taskId===Y:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(Y,ne,re){return this._running={taskId:Y,cancel:()=>re?.(),promise:ne},ne.then(()=>this.doneRunning(Y),()=>this.doneRunning(Y)),ne}doneRunning(Y){this._running&&Y===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const Y=this._queued;this._queued=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this._queued)this._queued.run=Y;else{const{promise:ne,resolve:re,reject:he}=d();this._queued={run:Y,promise:ne,promiseResolve:re,promiseReject:he}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ie;class ae{constructor(Y,ne=()=>Date.now()){this.interval=Y,this.nowFn=ne,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=ae;var te;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(te||(te={}));class ce{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((Y,ne)=>{this.completeCallback=Y,this.errorCallback=ne})}complete(Y){return new Promise(ne=>{this.completeCallback(Y),this.outcome={outcome:0,value:Y},ne()})}error(Y){return new Promise(ne=>{this.errorCallback(Y),this.outcome={outcome:1,value:Y},ne()})}cancel(){return this.error(new U.CancellationError)}}e.DeferredPromise=ce;var V;(function(Q){async function Y(re){let he;const fe=await Promise.all(re.map(me=>me.then(Ee=>Ee,Ee=>{he||(he=Ee)})));if(typeof he<"u")throw he;return fe}Q.settled=Y;function ne(re){return new Promise(async(he,fe)=>{try{await re(he,fe)}catch(me){fe(me)}})}Q.withAsyncBody=ne})(V||(e.Promises=V={}));class ${get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(Y){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=Y.then(ne=>(this._value=ne,this._isResolved=!0,ne),ne=>{throw this._error=ne,this._isResolved=!0,ne})}requireValue(){if(!this._isResolved)throw new U.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=$;class T{constructor(Y){this._compute=Y,this._promise=new f.Lazy(()=>new $(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=T;var M;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(M||(M={}));class W{static fromArray(Y){return new W(ne=>{ne.emitMany(Y)})}static fromPromise(Y){return new W(async ne=>{ne.emitMany(await Y)})}static fromPromises(Y){return new W(async ne=>{await Promise.all(Y.map(async re=>ne.emitOne(await re)))})}static merge(Y){return new W(async ne=>{await Promise.all(Y.map(async re=>{for await(const he of re)ne.emitOne(he)}))})}static{this.EMPTY=W.fromArray([])}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new O.Emitter,queueMicrotask(async()=>{const ne={emitOne:re=>this.emitOne(re),emitMany:re=>this.emitMany(re),reject:re=>this.reject(re)};try{await Promise.resolve(Y(ne)),this.resolve()}catch(re){this.reject(re)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await O.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ne){return new W(async re=>{for await(const he of Y)re.emitOne(ne(he))})}map(Y){return W.map(this,Y)}static filter(Y,ne){return new W(async re=>{for await(const he of Y)ne(he)&&re.emitOne(he)})}filter(Y){return W.filter(this,Y)}static coalesce(Y){return W.filter(Y,ne=>!!ne)}coalesce(){return W.coalesce(this)}static async toPromise(Y){const ne=[];for await(const re of Y)ne.push(re);return ne}toPromise(){return W.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=W;class J extends W{constructor(Y,ne){super(ne),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=J;function H(Q){const Y=new L.CancellationTokenSource,ne=Q(Y.token);return new J(Y,async re=>{const he=Y.token.onCancellationRequested(()=>{he.dispose(),Y.dispose(),re.reject(new U.CancellationError)});try{for await(const fe of ne){if(Y.token.isCancellationRequested)return;re.emitOne(fe)}he.dispose(),Y.dispose()}catch(fe){he.dispose(),Y.dispose(),re.reject(fe)}})}class ee{constructor(){this._deferred=new ce,this._asyncIterable=new W(re=>{if(Y){re.reject(Y);return}return ne&&re.emitMany(ne),this._errorFn=he=>re.reject(he),this._emitFn=he=>re.emitOne(he),this._deferred.p});let Y,ne;this._emitFn=re=>{ne||(ne=[]),ne.push(re)},this._errorFn=re=>{Y||(Y=re)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(Y){this._errorFn(Y),this._deferred.complete()}emitOne(Y){this._emitFn(Y)}}e.AsyncIterableSource=ee}),define(le[90],ue([0,1,17,6,44,35,14,5,27]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=f,e.splitGlobAware=u,e.match=p,e.parse=k,e.isRelativePattern=N,e.getBasenameTerms=F,e.getPathTerms=x,e.patternsEquals=j;function f(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",w="[^/\\\\]",m=/\//g;function h(G,z){switch(G){case 0:return"";case 1:return`${w}*?`;default:return`(?:${D}|${w}+${D}${z?`|${D}${w}+`:""})*?`}}function u(G,z){if(!G)return[];const q=[];let ie=!1,ae=!1,te="";for(const ce of G){switch(ce){case z:if(!ie&&!ae){q.push(te),te="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}te+=ce}return te&&q.push(te),q}function y(G){if(!G)return"";let z="";const q=u(G,e.GLOB_SPLIT);if(q.every(ie=>ie===e.GLOBSTAR))z=".*";else{let ie=!1;q.forEach((ae,te)=>{if(ae===e.GLOBSTAR){if(ie)return;z+=h(2,te===q.length-1)}else{let ce=!1,V="",$=!1,T="";for(const M of ae){if(M!=="}"&&ce){V+=M;continue}if($&&(M!=="]"||!T)){let W;M==="-"?W=M:(M==="^"||M==="!")&&!T?W="^":M===e.GLOB_SPLIT?W="":W=(0,P.escapeRegExpCharacters)(M),T+=W;continue}switch(M){case"{":ce=!0;continue;case"[":$=!0;continue;case"}":{const J=`(?:${u(V,",").map(H=>y(H)).join("|")})`;z+=J,ce=!1,V="";break}case"]":{z+="["+T+"]",$=!1,T="";break}case"?":z+=w;continue;case"*":z+=h(1);continue;default:z+=(0,P.escapeRegExpCharacters)(M)}}te<q.length-1&&(q[te+1]!==e.GLOBSTAR||te+2<q.length)&&(z+=D)}ie=ae===e.GLOBSTAR})}return z}const v=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.LRUCache(1e4),o=function(){return!1},n=function(){return null};function s(G,z){if(!G)return n;let q;typeof G!="string"?q=G.pattern:q=G,q=q.trim();const ie=`${q}_${!!z.trimForExclusions}`;let ae=i.get(ie);if(ae)return t(ae,G);let te;return v.test(q)?ae=a(q.substr(4),q):(te=d.exec(r(q,z)))?ae=E(te[1],q):(z.trimForExclusions?l:g).test(q)?ae=C(q,z):(te=c.exec(r(q,z)))?ae=b(te[1].substr(1),q,!0):(te=S.exec(r(q,z)))?ae=b(te[1],q,!1):ae=I(q),i.set(ie,ae),t(ae,G)}function t(G,z){if(typeof z=="string")return G;const q=function(ie,ae){return(0,O.isEqualOrParent)(ie,z.base,!R.isLinux)?G((0,P.ltrim)(ie.substr(z.base.length),_.sep),ae):null};return q.allBasenames=G.allBasenames,q.allPaths=G.allPaths,q.basenames=G.basenames,q.patterns=G.patterns,q}function r(G,z){return z.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function a(G,z){return function(q,ie){return typeof q=="string"&&q.endsWith(G)?z:null}}function E(G,z){const q=`/${G}`,ie=`\\${G}`,ae=function(ce,V){return typeof ce!="string"?null:V?V===G?z:null:ce===G||ce.endsWith(q)||ce.endsWith(ie)?z:null},te=[G];return ae.basenames=te,ae.patterns=[z],ae.allBasenames=te,ae}function C(G,z){const q=X(G.slice(1,-1).split(",").map(V=>s(V,z)).filter(V=>V!==n),G),ie=q.length;if(!ie)return n;if(ie===1)return q[0];const ae=function(V,$){for(let T=0,M=q.length;T<M;T++)if(q[T](V,$))return G;return null},te=q.find(V=>!!V.allBasenames);te&&(ae.allBasenames=te.allBasenames);const ce=q.reduce((V,$)=>$.allPaths?V.concat($.allPaths):V,[]);return ce.length&&(ae.allPaths=ce),ae}function b(G,z,q){const ie=_.sep===_.posix.sep,ae=ie?G:G.replace(m,_.sep),te=_.sep+ae,ce=_.posix.sep+G;let V;return q?V=function($,T){return typeof $=="string"&&($===ae||$.endsWith(te)||!ie&&($===G||$.endsWith(ce)))?z:null}:V=function($,T){return typeof $=="string"&&($===ae||!ie&&$===G)?z:null},V.allPaths=[(q?"*/":"./")+G],V}function I(G){try{const z=new RegExp(`^${y(G)}$`);return function(q){return z.lastIndex=0,typeof q=="string"&&z.test(q)?G:null}}catch{return n}}function p(G,z,q){return!G||typeof z!="string"?!1:k(G)(z,void 0,q)}function k(G,z={}){if(!G)return o;if(typeof G=="string"||N(G)){const q=s(G,z);if(q===n)return o;const ie=function(ae,te){return!!q(ae,te)};return q.allBasenames&&(ie.allBasenames=q.allBasenames),q.allPaths&&(ie.allPaths=q.allPaths),ie}return Z(G,z)}function N(G){const z=G;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function F(G){return G.allBasenames||[]}function x(G){return G.allPaths||[]}function Z(G,z){const q=X(Object.getOwnPropertyNames(G).map(V=>B(V,G[V],z)).filter(V=>V!==n)),ie=q.length;if(!ie)return n;if(!q.some(V=>!!V.requiresSiblings)){if(ie===1)return q[0];const V=function(M,W){let J;for(let H=0,ee=q.length;H<ee;H++){const Q=q[H](M,W);if(typeof Q=="string")return Q;(0,U.isThenable)(Q)&&(J||(J=[]),J.push(Q))}return J?(async()=>{for(const H of J){const ee=await H;if(typeof ee=="string")return ee}return null})():null},$=q.find(M=>!!M.allBasenames);$&&(V.allBasenames=$.allBasenames);const T=q.reduce((M,W)=>W.allPaths?M.concat(W.allPaths):M,[]);return T.length&&(V.allPaths=T),V}const ae=function(V,$,T){let M,W;for(let J=0,H=q.length;J<H;J++){const ee=q[J];ee.requiresSiblings&&T&&($||($=(0,_.basename)(V)),M||(M=$.substr(0,$.length-(0,_.extname)(V).length)));const Q=ee(V,$,M,T);if(typeof Q=="string")return Q;(0,U.isThenable)(Q)&&(W||(W=[]),W.push(Q))}return W?(async()=>{for(const J of W){const H=await J;if(typeof H=="string")return H}return null})():null},te=q.find(V=>!!V.allBasenames);te&&(ae.allBasenames=te.allBasenames);const ce=q.reduce((V,$)=>$.allPaths?V.concat($.allPaths):V,[]);return ce.length&&(ae.allPaths=ce),ae}function B(G,z,q){if(z===!1)return n;const ie=s(G,q);if(ie===n)return n;if(typeof z=="boolean")return ie;if(z){const ae=z.when;if(typeof ae=="string"){const te=(ce,V,$,T)=>{if(!T||!ie(ce,V))return null;const M=ae.replace("$(basename)",()=>$),W=T(M);return(0,U.isThenable)(W)?W.then(J=>J?G:null):W?G:null};return te.requiresSiblings=!0,te}}return ie}function X(G,z){const q=G.filter(V=>!!V.basenames);if(q.length<2)return G;const ie=q.reduce((V,$)=>{const T=$.basenames;return T?V.concat(T):V},[]);let ae;if(z){ae=[];for(let V=0,$=ie.length;V<$;V++)ae.push(z)}else ae=q.reduce((V,$)=>{const T=$.patterns;return T?V.concat(T):V},[]);const te=function(V,$){if(typeof V!="string")return null;if(!$){let M;for(M=V.length;M>0;M--){const W=V.charCodeAt(M-1);if(W===47||W===92)break}$=V.substr(M)}const T=ie.indexOf($);return T!==-1?ae[T]:null};te.basenames=ie,te.patterns=ae,te.allBasenames=ie;const ce=G.filter(V=>!V.basenames);return ce.push(te),ce}function j(G,z){return(0,L.equals)(G,z,(q,ie)=>typeof q=="string"&&typeof ie=="string"?q===ie:typeof q!="string"&&typeof ie!="string"?q.base===ie.base&&q.pattern===ie.pattern:!1)}}),define(le[91],ue([0,1,15,8]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=R,e.transformIncomingURIs=f,e.transformAndReviveIncomingURIs=D;function O(w){return w.toJSON()}class A{constructor(m){this._uriTransformer=m}transformIncoming(m){const h=this._uriTransformer.transformIncoming(m);return h===m?m:O(U.URI.from(h))}transformOutgoing(m){const h=this._uriTransformer.transformOutgoing(m);return h===m?m:O(U.URI.from(h))}transformOutgoingURI(m){const h=this._uriTransformer.transformOutgoing(m);return h===m?m:U.URI.from(h)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function _(w,m,h){if(!w||h>200)return null;if(typeof w=="object"){if(w instanceof U.URI)return m.transformOutgoing(w);for(const u in w)if(Object.hasOwnProperty.call(w,u)){const y=_(w[u],m,h+1);y!==null&&(w[u]=y)}}return null}function R(w,m){const h=_(w,m,0);return h===null?w:h}function P(w,m,h,u){if(!w||u>200)return null;if(typeof w=="object"){if(w.$mid===1)return h?U.URI.revive(m.transformIncoming(w)):m.transformIncoming(w);if(w instanceof L.VSBuffer)return null;for(const y in w)if(Object.hasOwnProperty.call(w,y)){const v=P(w[y],m,h,u+1);v!==null&&(w[y]=v)}}return null}function f(w,m){const h=P(w,m,!1,0);return h===null?w:h}function D(w,m){const h=P(w,m,!0,0);return h===null?w:h}}),define(le[144],ue([0,1,37,51,32,131,5]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=P,e.getSqmMachineId=w,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(m){return this._virtualMachineOUIs||(this._virtualMachineOUIs=U.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(m)}value(){if(this._value===void 0){let m=0,h=0;const u=(0,L.networkInterfaces)();for(const y in u){const v=u[y];if(v)for(const{mac:d,internal:g}of v)g||(h+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(m+=1))}this._value=h>0?m/h:0}return this._value}};let R;async function P(m){return R||(R=(async()=>await f(m)||O.generateUuid())()),R}async function f(m){try{const h=await new Promise((y,v)=>{se(["crypto"],y,v)}),u=(0,A.getMac)();return h.createHash("sha256").update(u,"utf8").digest("hex")}catch(h){m(h);return}}const D="Software\\Microsoft\\SQMClient";async function w(m){if(_.isWindows){const h=await new Promise((u,y)=>{se(["@vscode/windows-registry"],u,y)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",D,"MachineId")||""}catch(u){return m(u),""}}return""}}),define(le[145],ue([0,1,40,146,14,36]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDisplayProtocol=D,e.getCodeDisplayProtocol=w;const _="XDG_SESSION_TYPE",R="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var f;(function(m){m.Wayland="wayland",m.XWayland="xwayland",m.X11="x11",m.Unknown="unknown"})(f||(f={}));async function D(m){const h=A.env[_];if(h)return h==="wayland"||h==="x11"?h:"unknown";if(A.env[R]){const y=A.env[P];if(y){const v=(0,O.join)(y,"wayland-0");try{return await(0,U.access)(v,L.constants.R_OK),"wayland"}catch(d){return m(d),"unknown"}}else return"unknown"}else return"x11"}function w(m,h){if(h)switch(h){case"auto":return m;case"x11":return m==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return m==="wayland"?"xwayland":"x11"}}),define(le[147],ue([0,1,40,146,274,5]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=_;async function _(R){if(A.isMacintosh||A.isWindows)return;let P;for(const f of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,U.open)(f,L.constants.R_OK);break}catch{}if(!P){R("Unable to retrieve release information from known identifier paths.");return}try{const f=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),D={id:"unknown"};for await(const w of(0,O.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!w.includes("="))continue;const m=w.split("=")[0].toUpperCase().trim();if(f.has(m)){const h=w.split("=")[1].replace(/"/g,"").toLowerCase().trim();m==="ID"||m==="DISTRIB_ID"?D.id=h:m==="ID_LIKE"?D.id_like=h:(m==="VERSION_ID"||m==="DISTRIB_RELEASE")&&(D.version_id=h)}}return D}catch(f){R(f)}}}),define(le[31],ue([0,1,40,37,275,6,44,87,14,5,20,8]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=l,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=E;var m;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function h(B,X=m.UNLINK,j){if((0,_.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return X===m.UNLINK?y(B):u(B,j)}async function u(B,X=(0,_.randomPath)((0,U.tmpdir)())){try{try{await L.promises.rename(B,X)}catch(j){return j.code==="ENOENT"?void 0:y(B)}y(X).catch(j=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function y(B){return(0,O.promisify)(L.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function v(B){if((0,_.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}async function d(B,X){return c(await(X?g(B):(0,O.promisify)(L.readdir)(B)))}async function g(B){try{return await(0,O.promisify)(L.readdir)(B,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const X=[],j=await d(B);for(const G of j){let z=!1,q=!1,ie=!1;try{const ae=await e.Promises.lstat((0,P.join)(B,G));z=ae.isFile(),q=ae.isDirectory(),ie=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}X.push({name:G,isFile:()=>z,isDirectory:()=>q,isSymbolicLink:()=>ie})}return X}function l(B){return c(L.readdirSync(B))}function c(B){return B.map(X=>typeof X=="string"?f.isMacintosh?(0,R.normalizeNFC)(X):X:(X.name=f.isMacintosh?(0,R.normalizeNFC)(X.name):X.name,X))}async function S(B){const X=await d(B),j=[];for(const G of X)await o.existsDirectory((0,P.join)(B,G))&&j.push(G);return j}function i(B,X=1e3){return new Promise(j=>{let G=!1;const z=setInterval(()=>{G||(G=!0,L.access(B,q=>{G=!1,q&&(clearInterval(z),j(void 0))}))},X)})}var o;(function(B){async function X(z){let q;try{if(q=await e.Promises.lstat(z),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(f.isWindows&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ae}throw ie}}B.stat=X;async function j(z){try{const{stat:q,symbolicLink:ie}=await B.stat(z);return q.isFile()&&ie?.dangling!==!0}catch{}return!1}B.existsFile=j;async function G(z){try{const{stat:q,symbolicLink:ie}=await B.stat(z);return q.isDirectory()&&ie?.dangling!==!0}catch{}return!1}B.existsDirectory=G})(o||(e.SymlinkSupport=o={}));const n=new A.ResourceQueue;function s(B,X,j){return n.queueFor(w.URI.file(B),()=>{const G=C(j);return new Promise((z,q)=>a(B,X,G,ie=>ie?q(ie):z()))},D.extUriBiasedIgnorePathCase)}let t=!0;function r(B){t=B}function a(B,X,j,G){if(!t)return L.writeFile(B,X,{mode:j.mode,flag:j.flag},G);L.open(B,j.flag,j.mode,(z,q)=>{if(z)return G(z);L.writeFile(q,X,ie=>{if(ie)return L.close(q,()=>G(ie));L.fdatasync(q,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),r(!1)),L.close(q,te=>G(te))))})})}function E(B,X,j){const G=C(j);if(!t)return L.writeFileSync(B,X,{mode:G.mode,flag:G.flag});const z=L.openSync(B,G.flag,G.mode);try{L.writeFileSync(z,X);try{L.fdatasyncSync(z)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{L.closeSync(z)}}function C(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function b(B,X,j=6e4){if(B!==X)try{f.isWindows&&typeof j=="number"?await I(B,X,Date.now(),j):await(0,O.promisify)(L.rename)(B,X)}catch(G){if(B.toLowerCase()!==X.toLowerCase()&&G.code==="EXDEV"||B.endsWith("."))await p(B,X,{preserveSymlinks:!1}),await h(B,m.MOVE);else throw G}}async function I(B,X,j,G,z=0){try{return await(0,O.promisify)(L.rename)(B,X)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-j>=G)throw console.error(`[node.js fs] rename failed after ${z} retries with error: ${q}`),q;if(z===0){let ie=!1;try{const{stat:ae}=await o.stat(X);ae.isFile()||(ie=!0)}catch{}if(ie)throw q}return await(0,A.timeout)(Math.min(100,z*10)),I(B,X,j,G,z+1)}}async function p(B,X,j){return N(B,X,{root:{source:B,target:X},options:j,handledSourcePaths:new Set})}const k=511;async function N(B,X,j){if(j.handledSourcePaths.has(B))return;j.handledSourcePaths.add(B);const{stat:G,symbolicLink:z}=await o.stat(B);if(z){if(j.options.preserveSymlinks)try{return await Z(B,X,j)}catch{}if(z.dangling)return}return G.isDirectory()?F(B,X,G.mode&k,j):x(B,X,G.mode&k)}async function F(B,X,j,G){await e.Promises.mkdir(X,{recursive:!0,mode:j});const z=await d(B);for(const q of z)await N((0,P.join)(B,q),(0,P.join)(X,q),G)}async function x(B,X,j){await e.Promises.copyFile(B,X),await e.Promises.chmod(X,j)}async function Z(B,X,j){let G=await e.Promises.readlink(B);(0,_.isEqualOrParent)(G,j.root.source,!f.isLinux)&&(G=(0,P.join)(j.root.target,G.substr(j.root.source.length+1))),await e.Promises.symlink(G,X)}e.Promises=new class{get access(){return(0,O.promisify)(L.access)}get stat(){return(0,O.promisify)(L.stat)}get lstat(){return(0,O.promisify)(L.lstat)}get utimes(){return(0,O.promisify)(L.utimes)}get read(){return(B,X,j,G,z)=>new Promise((q,ie)=>{L.read(B,X,j,G,z,(ae,te,ce)=>ae?ie(ae):q({bytesRead:te,buffer:ce}))})}get readFile(){return(0,O.promisify)(L.readFile)}get write(){return(B,X,j,G,z)=>new Promise((q,ie)=>{L.write(B,X,j,G,z,(ae,te,ce)=>ae?ie(ae):q({bytesWritten:te,buffer:ce}))})}get appendFile(){return(0,O.promisify)(L.appendFile)}get fdatasync(){return(0,O.promisify)(L.fdatasync)}get truncate(){return(0,O.promisify)(L.truncate)}get copyFile(){return(0,O.promisify)(L.copyFile)}get open(){return(0,O.promisify)(L.open)}get close(){return(0,O.promisify)(L.close)}get symlink(){return(0,O.promisify)(L.symlink)}get readlink(){return(0,O.promisify)(L.readlink)}get chmod(){return(0,O.promisify)(L.chmod)}get mkdir(){return(0,O.promisify)(L.mkdir)}get unlink(){return(0,O.promisify)(L.unlink)}get rmdir(){return(0,O.promisify)(L.rmdir)}get realpath(){return(0,O.promisify)(L.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return S}get writeFile(){return s}get rm(){return h}get rename(){return b}get copy(){return p}}}),define(le[148],ue([0,1,40,14,5,27,31]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=P,e.realpath=f,e.realpathSync=D;function R(m){if(O.isLinux)return m;const h=(0,U.dirname)(m);if(m===h)return m;const u=((0,U.basename)(m)||m).toLowerCase();try{const v=(0,_.readdirSync)(h).filter(d=>d.toLowerCase()===u);if(v.length===1){const d=R(h);if(d)return(0,U.join)(d,v[0])}else if(v.length>1){const d=v.indexOf(u);if(d>=0){const g=R(h);if(g)return(0,U.join)(g,v[d])}}}catch{}return null}async function P(m,h){if(O.isLinux)return m;const u=(0,U.dirname)(m);if(m===u)return m;const y=((0,U.basename)(m)||m).toLowerCase();try{if(h?.isCancellationRequested)return null;const d=(await _.Promises.readdir(u)).filter(g=>g.toLowerCase()===y);if(d.length===1){const g=await P(u,h);if(g)return(0,U.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(y);if(g>=0){const l=await P(u,h);if(l)return(0,U.join)(l,d[g])}}}catch{}return null}async function f(m){try{return await _.Promises.realpath(m)}catch{const u=w(m);return await _.Promises.access(u,L.constants.R_OK),u}}function D(m){try{return L.realpathSync(m)}catch{const u=w(m);return L.accessSync(u,L.constants.R_OK),u}}function w(m){return(0,A.rtrim)((0,U.normalize)(m),U.sep)}}),define(le[149],ue([0,1,14,5,36,89,13,31]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=P,e.createQueuedSender=f,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(w=O.env){return w.comspec||"cmd.exe"}function f(w){let m=[],h=!1;const u=function(y){if(h){m.push(y);return}(!w.send(y,d=>{if(d&&console.error(d),h=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(l=>u(l))}})||U.isWindows)&&(h=!0)};return{send:u}}var D;(function(w){async function m(h,u,y){if(L.isAbsolute(h))return h;if(u===void 0&&(u=O.cwd()),L.dirname(h)!=="."||(y===void 0&&_.isString(O.env.PATH)&&(y=O.env.PATH.split(L.delimiter)),y===void 0||y.length===0))return L.join(u,h);async function d(g){if(await R.Promises.exists(g)){let l;try{l=await R.Promises.stat(g)}catch(c){c.message.startsWith("EACCES")&&(l=await R.Promises.lstat(g))}return l?!l.isDirectory():!1}return!1}for(const g of y){let l;if(L.isAbsolute(g)?l=L.join(g,h):l=L.join(u,g,h),await d(l))return l;let c=l+".com";if(await d(c)||(c=l+".exe",await d(c)))return c}return L.join(u,h)}w.findExecutable=m})(D||(e.win32=D={}))}),define(le[150],ue([0,1,67,23]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=O;function O(_){return new Promise((R,P)=>{let f;const D=new Map;function w(h,u,y,v,d){const g=D.get(u);if(h===_||g){const l={name:m(y),cmd:y,pid:h,ppid:u,load:v,mem:d};D.set(h,l),h===_&&(f=l),g&&(g.children||(g.children=[]),g.children.push(l),g.children.length>1&&(g.children=g.children.sort((c,S)=>c.pid-S.pid)))}}function m(h){const u=/--utility-sub-type=network/i,y=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(y.exec(h))return"electron-crash-reporter";if(v.exec(h))return"winpty-agent";if(d.exec(h))return"conpty-agent";let l=g.exec(h);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?u.exec(h)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const c=/[a-zA-Z-]+\.js/g;let S="";do l=c.exec(h),l&&(S+=l+" ");while(l);return S&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${S})`:h}if(process.platform==="win32"){const h=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,y)=>{se(["@vscode/windows-process-tree"],u,y)}).then(u=>{u.getProcessList(_,y=>{if(!y){P(new Error(`Root process ${_} not found`));return}u.getProcessCpuUsage(y,v=>{const d=new Map;v.forEach(g=>{const l=h(g.commandLine||"");d.set(g.pid,{name:m(l),cmd:l,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),f=d.get(_),f?(d.forEach(g=>{const l=d.get(g.ppid);l&&(l.children||(l.children=[]),l.children.push(g))}),d.forEach(g=>{g.children&&(g.children=g.children.sort((l,c)=>l.pid-c.pid))}),R(f)):P(new Error(`Root process ${_} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let h=function(){let u=[f];const y=[];for(;u.length;){const d=u.shift();d&&(y.push(d.pid),d.children&&(u=u.concat(d.children)))}let v=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+y.join(" "),(0,L.exec)(v,{},(d,g,l)=>{if(d||l)P(d||new Error(l.toString()));else{const c=g.toString().split(`
`);for(let S=0;S<y.length;S++){const i=D.get(y[S]);i.load=parseFloat(c[S])}if(!f){P(new Error(`Root process ${_} not found`));return}R(f)}})};(0,L.exec)("which ps",{},(u,y,v)=>{if(u||v)if(process.platform!=="linux")P(u||new Error(v.toString()));else{const d=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(d,{},(g,l,c)=>{g||c?P(g||new Error(c.toString())):(A(l,w),h())})}else{const d=y.toString().trim();(0,L.exec)(`${d} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,S)=>{l||S&&!S.includes("screen size is bogus")?P(l||new Error(S.toString())):(A(c,w),process.platform==="linux"?h():f?R(f):P(new Error(`Root process ${_} not found`)))})}})}})}function A(_,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=_.toString().split(`
`);for(const D of f){const w=P.exec(D.trim());w&&w.length===6&&R(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}});var we=this&&this.__decorate||function(se,e,L,U){var O=arguments.length,A=O<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,L):U,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,L,U);else for(var R=se.length-1;R>=0;R--)(_=se[R])&&(A=(O<3?_(A):O>3?_(e,L,A):_(e,L))||A);return O>3&&A&&Object.defineProperty(e,L,A),A};define(le[41],ue([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(se,e,L,U,O,A,_,R,P,f,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=r,e.deserialize=a,e.getDelayedChannel=k,e.getNextTickChannel=N;var h;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(h||(h={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(y||(y={}));function v(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(d||(d={}));function g(z){let q=0;for(let ie=0;;ie+=7){const ae=z.read(1);if(q|=(ae.buffer[0]&127)<<ie,!(ae.buffer[0]&128))return q}}const l=n(0);function c(z,q){if(q===0){z.write(l);return}let ie=0;for(let te=q;te!==0;te=te>>>7)ie++;const ae=O.VSBuffer.alloc(ie);for(let te=0;q!==0;te++)ae.buffer[te]=q&127,q=q>>>7,q>0&&(ae.buffer[te]|=128);z.write(ae)}class S{constructor(q){this.buffer=q,this.pos=0}read(q){const ie=this.buffer.slice(this.pos,this.pos+q);return this.pos+=ie.byteLength,ie}}e.BufferReader=S;class i{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=i;var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(o||(o={}));function n(z){const q=O.VSBuffer.alloc(1);return q.writeUInt8(z,0),q}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(z,q){if(typeof q>"u")z.write(s.Undefined);else if(typeof q=="string"){const ie=O.VSBuffer.fromString(q);z.write(s.String),c(z,ie.byteLength),z.write(ie)}else if(t&&Buffer.isBuffer(q)){const ie=O.VSBuffer.wrap(q);z.write(s.Buffer),c(z,ie.byteLength),z.write(ie)}else if(q instanceof O.VSBuffer)z.write(s.VSBuffer),c(z,q.byteLength),z.write(q);else if(Array.isArray(q)){z.write(s.Array),c(z,q.length);for(const ie of q)r(z,ie)}else if(typeof q=="number"&&(q|0)===q)z.write(s.Uint),c(z,q);else{const ie=O.VSBuffer.fromString(JSON.stringify(q));z.write(s.Object),c(z,ie.byteLength),z.write(ie)}}function a(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(g(z)).toString();case o.Buffer:return z.read(g(z)).buffer;case o.VSBuffer:return z.read(g(z));case o.Array:{const ie=g(z),ae=[];for(let te=0;te<ie;te++)ae.push(a(z));return ae}case o.Object:return JSON.parse(z.read(g(z)).toString());case o.Int:return g(z)}}class E{constructor(q,ie,ae=null,te=1e3){this.protocol=q,this.ctx=ie,this.logger=ae,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(q,ie){this.channels.set(q,ie),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const ie=this.send([q.type]);this.logger?.logOutgoing(ie,0,1,v(q.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(ie,q.id,1,v(q.type),q.data);return}}}send(q,ie=void 0){const ae=new i;return r(ae,q),r(ae,ie),this.sendBuffer(ae.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const ie=new S(q),ae=a(ie),te=a(ie),ce=ae[0];switch(ce){case 100:return this.logger?.logIncoming(q.byteLength,ae[1],1,`${u(ce)}: ${ae[2]}.${ae[3]}`,te),this.onPromise({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:te});case 102:return this.logger?.logIncoming(q.byteLength,ae[1],1,`${u(ce)}: ${ae[2]}.${ae[3]}`,te),this.onEventListen({type:ce,id:ae[1],channelName:ae[2],name:ae[3],arg:te});case 101:return this.logger?.logIncoming(q.byteLength,ae[1],1,`${u(ce)}`),this.disposeActiveRequest({type:ce,id:ae[1]});case 103:return this.logger?.logIncoming(q.byteLength,ae[1],1,`${u(ce)}`),this.disposeActiveRequest({type:ce,id:ae[1]})}}onPromise(q){const ie=this.channels.get(q.channelName);if(!ie){this.collectPendingRequest(q);return}const ae=new A.CancellationTokenSource;let te;try{te=ie.call(this.ctx,q.name,q.arg,ae.token)}catch($){te=Promise.reject($)}const ce=q.id;te.then($=>{this.sendResponse({id:ce,data:$,type:201})},$=>{$ instanceof Error?this.sendResponse({id:ce,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:ce,data:$,type:203})}).finally(()=>{V.dispose(),this.activeRequests.delete(q.id)});const V=(0,f.toDisposable)(()=>ae.cancel());this.activeRequests.set(q.id,V)}onEventListen(q){const ie=this.channels.get(q.channelName);if(!ie){this.collectPendingRequest(q);return}const ae=q.id,ce=ie.listen(this.ctx,q.name,q.arg)(V=>this.sendResponse({id:ae,data:V,type:204}));this.activeRequests.set(q.id,ce)}disposeActiveRequest(q){const ie=this.activeRequests.get(q.id);ie&&(ie.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let ie=this.pendingRequests.get(q.channelName);ie||(ie=[],this.pendingRequests.set(q.channelName,ie));const ae=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:q,timeoutTimer:ae})}flushPendingRequests(q){const ie=this.pendingRequests.get(q);if(ie){for(const ae of ie)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=E;var C;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class b{constructor(q,ie=null){this.protocol=q,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=ie}getChannel(q){const ie=this;return{call(ae,te,ce){return ie.isDisposed?Promise.reject(new R.CancellationError):ie.requestPromise(q,ae,te,ce)},listen(ae,te){return ie.isDisposed?P.Event.None:ie.requestEvent(q,ae,te)}}}requestPromise(q,ie,ae,te=A.CancellationToken.None){const ce=this.lastRequestId++,$={id:ce,type:100,channelName:q,name:ie,arg:ae};if(te.isCancellationRequested)return Promise.reject(new R.CancellationError);let T;return new Promise((W,J)=>{if(te.isCancellationRequested)return J(new R.CancellationError);const H=()=>{const ne=re=>{switch(re.type){case 201:this.handlers.delete(ce),W(re.data);break;case 202:{this.handlers.delete(ce);const he=new Error(re.data.message);he.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,he.name=re.data.name,J(he);break}case 203:this.handlers.delete(ce),J(re.data);break}};this.handlers.set(ce,ne),this.sendRequest($)};let ee=null;this.state===d.Idle?H():(ee=(0,U.createCancelablePromise)(ne=>this.whenInitialized()),ee.then(()=>{ee=null,H()}));const Q=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:ce,type:101}),J(new R.CancellationError)},Y=te.onCancellationRequested(Q);T=(0,f.combinedDisposable)((0,f.toDisposable)(Q),Y),this.activeRequests.add(T)}).finally(()=>{T.dispose(),this.activeRequests.delete(T)})}requestEvent(q,ie,ae){const te=this.lastRequestId++,V={id:te,type:102,channelName:q,name:ie,arg:ae};let $=null;const T=new P.Emitter({onWillAddFirstListener:()=>{$=(0,U.createCancelablePromise)(W=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(T),this.sendRequest(V)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(T),this.sendRequest({id:te,type:103}))}}),M=W=>T.fire(W.data);return this.handlers.set(te,M),T.event}sendRequest(q){switch(q.type){case 100:case 102:{const ie=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(ie,q.id,0,`${u(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const ie=this.send([q.type,q.id]);this.logger?.logOutgoing(ie,q.id,0,u(q.type));return}}}send(q,ie=void 0){const ae=new i;return r(ae,q),r(ae,ie),this.sendBuffer(ae.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const ie=new S(q),ae=a(ie),te=a(ie),ce=ae[0];switch(ce){case 200:return this.logger?.logIncoming(q.byteLength,0,0,v(ce)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,ae[1],0,v(ce),te),this.onResponse({type:ae[0],id:ae[1],data:te})}}onResponse(q){if(q.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=b,we([_.memoize],b.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this._connections.forEach(ie=>q.push(ie)),q}constructor(q,ie,ae){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new f.DisposableStore,this.disposables.add(q(({protocol:te,onDidClientDisconnect:ce})=>{const V=P.Event.once(te.onMessage);this.disposables.add(V($=>{const T=new S($),M=a(T),W=new E(te,M,ie,ae),J=new b(te,ie);this.channels.forEach((ee,Q)=>W.registerChannel(Q,ee));const H={channelServer:W,channelClient:J,ctx:M};this._connections.add(H),this._onDidAddConnection.fire(H),this.disposables.add(ce(()=>{W.dispose(),J.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)}))}))}))}getChannel(q,ie){const ae=this;return{call(te,ce,V){let $;if((0,m.isFunction)(ie)){const M=(0,L.getRandomElement)(ae.connections.filter(ie));$=M?Promise.resolve(M):P.Event.toPromise(P.Event.filter(ae.onDidAddConnection,ie))}else $=ie.routeCall(ae,te,ce);const T=$.then(M=>M.channelClient.getChannel(q));return k(T).call(te,ce,V)},listen(te,ce){if((0,m.isFunction)(ie))return ae.getMulticastEvent(q,ie,te,ce);const V=ie.routeEvent(ae,te,ce).then($=>$.channelClient.getChannel(q));return k(V).listen(te,ce)}}}getMulticastEvent(q,ie,ae,te){const ce=this;let V;const $=new P.Emitter({onWillAddFirstListener:()=>{V=new f.DisposableStore;const T=new P.EventMultiplexer,M=new Map,W=H=>{const Q=H.channelClient.getChannel(q).listen(ae,te),Y=T.add(Q);M.set(H,Y)},J=H=>{const ee=M.get(H);ee&&(ee.dispose(),M.delete(H))};ce.connections.filter(ie).forEach(W),P.Event.filter(ce.onDidAddConnection,ie)(W,void 0,V),ce.onDidRemoveConnection(J,void 0,V),T.event($.fire,$,V),V.add(T)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return $.event}registerChannel(q,ie){this.channels.set(q,ie);for(const ae of this._connections)ae.channelServer.registerChannel(q,ie)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class p{constructor(q,ie,ae=null){const te=new i;r(te,ie),q.send(te.buffer),this.channelClient=new b(q,ae),this.channelServer=new E(q,ie,ae)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,ie){this.channelServer.registerChannel(q,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=p;function k(z){return{call(q,ie,ae){return z.then(te=>te.call(q,ie,ae))},listen(q,ie){const ae=new P.Relay;return z.then(te=>ae.input=te.listen(q,ie)),ae.event}}}function N(z){let q=!1;return{call(ie,ae,te){return q?z.call(ie,ae,te):(0,U.timeout)(0).then(()=>q=!0).then(()=>z.call(ie,ae,te))},listen(ie,ae){if(q)return z.listen(ie,ae);const te=new P.Relay;return(0,U.timeout)(0).then(()=>q=!0).then(()=>te.input=z.listen(ie,ae)),te.event}}}class F{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const ie of q.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=F;var x;(function(z){function q(ce,V,$){const T=ce,M=$&&$.disableMarshalling,W=new Map;for(const J in T)ae(J)&&W.set(J,P.Event.buffer(T[J],!0,void 0,V));return new class{listen(J,H,ee){const Q=W.get(H);if(Q)return Q;const Y=T[H];if(typeof Y=="function"){if(te(H))return Y.call(T,ee);if(ae(H))return W.set(H,P.Event.buffer(T[H],!0,void 0,V)),W.get(H)}throw new R.ErrorNoTelemetry(`Event not found: ${H}`)}call(J,H,ee){const Q=T[H];if(typeof Q=="function"){if(!M&&Array.isArray(ee))for(let ne=0;ne<ee.length;ne++)ee[ne]=(0,D.revive)(ee[ne]);let Y=Q.apply(T,ee);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new R.ErrorNoTelemetry(`Method not found: ${H}`)}}}z.fromService=q;function ie(ce,V){const $=V&&V.disableMarshalling;return new Proxy({},{get(T,M){if(typeof M=="string")return V?.properties?.has(M)?V.properties.get(M):te(M)?function(W){return ce.listen(M,W)}:ae(M)?ce.listen(M):async function(...W){let J;V&&!(0,m.isUndefinedOrNull)(V.context)?J=[V.context,...W]:J=W;const H=await ce.call(M,J);return $?H:(0,D.revive)(H)};throw new R.ErrorNoTelemetry(`Property not found: ${String(M)}`)}})}z.toService=ie;function ae(ce){return ce[0]==="o"&&ce[1]==="n"&&w.isUpperAsciiLetter(ce.charCodeAt(2))}function te(ce){return/^onDynamic/.test(ce)&&w.isUpperAsciiLetter(ce.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const q=z.toString();if(q!=="[object Object]")return q}return z}function X(z){return Array.isArray(z)?z.map(B):B(z)}function j(z,q,ie,ae,te,ce,V){V=X(V);const $=Z[te],T=$[ae%$.length];let M=[`%c[${z}]%c[${String(q).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(ce)?(M=M.concat(V),M.push(")")):M.push(V),console.log.apply(console,M)}class G{constructor(q,ie){this._outgoingPrefix=q,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,ie,ae,te,ce){this._totalOutgoing+=q,j(this._outgoingPrefix,this._totalOutgoing,q,ie,ae,te,ce)}logIncoming(q,ie,ae,te,ce){this._totalIncoming+=q,j(this._incomingPrefix,this._totalIncoming,q,ie,ae,te,ce)}}e.IPCLogger=G}),define(le[68],ue([0,1,15,3,2,41]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(_||(e.SocketDiagnosticsEventType=_={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(C,b){if(!t.has(C)){const I=String(++r);t.set(C,I)}return t.get(C)}function E(C,b,I,p){if(!s.enableDiagnostics)return;const k=a(C,b);if(p instanceof L.VSBuffer||p instanceof Uint8Array||p instanceof ArrayBuffer||ArrayBuffer.isView(p)){const N=L.VSBuffer.alloc(p.byteLength);N.set(p),s.records.push({timestamp:Date.now(),id:k,label:b,type:I,buff:N})}else s.records.push({timestamp:Date.now(),id:k,label:b,type:I,data:p})}s.traceSocketEvent=E})(R||(e.SocketDiagnostics=R={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let f=null;function D(){return f||(f=L.VSBuffer.alloc(0)),f}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,r){if(t===0)return D();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const b=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=t),b}if(this._chunks[0].byteLength>t){const b=this._chunks[0].slice(0,t);return r&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),b}const a=L.VSBuffer.alloc(t);let E=0,C=0;for(;t>0;){const b=this._chunks[C];if(b.byteLength>t){const I=b.slice(0,t);a.set(I,E),E+=t,r&&(this._chunks[C]=b.slice(t),this._totalLength-=t),t-=t}else a.set(b,E),E+=b.byteLength,r?(this._chunks.shift(),this._totalLength-=b.byteLength):C++,t-=b.byteLength}return a}}e.ChunkStream=w;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(u||(e.ProtocolConstants=u={}));class y{constructor(t,r,a,E){this.type=t,this.id=r,this.ack=a,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends O.Disposable{constructor(t){super(),this._onMessage=this._register(new U.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:h(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,E=this._state.id,C=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new y(a,E,C,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(t){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=L.VSBuffer.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:h(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",t.data),this._writeSoon(r,t.data)}_bufferAdd(t,r){const a=this._totalLength===0;return this._data.push(t,r),this._totalLength+=t.byteLength+r.byteLength,a}_bufferTake(){const t=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,r){this._bufferAdd(t,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const t=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this._socket.write(t)}}class g extends O.Disposable{constructor(t){super(),this._onMessage=new U.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new U.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new y(1,0,0,t))}}e.Protocol=g;class l extends A.IPCClient{static fromSocket(t,r){return new l(new g(t),r)}get onDidDispose(){return this.protocol.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.protocol=t}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=l;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new U.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class S{constructor(t){this.data=t,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let t=0,r=this._first;for(;r;)r=r.next,t++;return t}peek(){return this._first?this._first.data:null}toArray(){const t=[];let r=0,a=this._first;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const r=new S(t);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class o{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const t=Date.now();for(let r=0;r<o._HISTORY_LENGTH;r++)this.lastRuns[r]=t-1e3*r;setInterval(()=>{for(let r=o._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}load(){const t=Date.now(),r=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let E=0;E<o._HISTORY_LENGTH;E++)t-this.lastRuns[E]<=r&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(t){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t.loadEstimator??o.getInstance(),this._shouldSendKeepAlive=t.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new O.DisposableStore,this._socket=t.socket,this._socketWriter=this._socketDisposables.add(new d(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.add(this._socket.onClose(r=>this._onSocketClose.fire(r))),t.initialChunk&&this._socketReader.acceptChunk(t.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new y(5,0,0,D());this._socketWriter.write(t),this._socketWriter.flush()}sendPause(){const t=new y(7,0,0,D());this._socketWriter.write(t)}sendResume(){const t=new y(8,0,0,D());this._socketWriter.write(t)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,r){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new O.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=t,this._socketWriter=this._socketDisposables.add(new d(this._socket)),this._socketReader=this._socketDisposables.add(new v(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const t=new y(3,0,this._incomingAckId,D());this._socketWriter.write(t);const r=this._outgoingUnackMsg.toArray();for(let a=0,E=r.length;a<E;a++)this._socketWriter.write(r[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new y(6,0,0,D())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data);break}case 2:{this._onControlMessage.fire(t.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let a=0,E=r.length;a<E;a++)this._socketWriter.write(r[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new y(1,r,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const r=new y(2,0,0,t);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this._socketReader.lastReadTime,E=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&a>=2e4&&E>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const C=Math.max(2e4-r,2e4-a,2e4-E,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},C)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new y(3,0,this._incomingAckId,D());this._socketWriter.write(t)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const t=new y(9,0,this._incomingAckId,D());this._socketWriter.write(t)}}e.PersistentProtocol=n}),define(le[92],ue([0,1,67,6,15,26,142,7,3,2,30,149,89,41]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends h.ChannelServer{constructor(d){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>O.VSBuffer.wrap(Buffer.from(g,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=u;class y{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new U.Delayer(l),this.child=null,this._client=null}getChannel(d){const g=this;return{call(l,c,S){return g.requestPromise(d,l,c,S)},listen(l,c){return g.requestEvent(d,l,c)}}}requestPromise(d,g,l,c=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(d),i=(0,U.createCancelablePromise)(s=>S.call(g,l,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,f.toDisposable)(()=>i.cancel());return this.activeRequests.add(n),i.finally(()=>{o.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(d,g,l){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let c;const S=new P.Emitter({onWillAddFirstListener:()=>{c=this.getCachedChannel(d).listen(g,l)(S.fire,S),this.activeRequests.add(c)},onDidRemoveLastListener:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,L.fork)(this.modulePath,d,g);const l=new P.Emitter,S=P.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,_.isRemoteConsoleLog)(r)){(0,_.log)(r,`IPC Library: ${this.options.serverName}`);return}l.fire(O.VSBuffer.wrap(Buffer.from(r,"base64")))}),i=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,o=r=>this.child&&this.child.connected&&i.send(r.buffer.toString("base64")),n=l.event,s={send:o,onMessage:n};this._client=new h.ChannelClient(s);const t=()=>this.disposeClient();process.once("exit",t),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",t),S.dispose(),this.activeRequests.forEach(E=>(0,f.dispose)(E)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(le[151],ue([0,1,134,15,41,3,13,17]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=D;class P{constructor(m){this.port=m,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",h=>h.data?U.VSBuffer.wrap(h.data):U.VSBuffer.alloc(0)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}class f extends O.IPCServer{static getOnDidClientConnect(m){(0,_.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const h=new A.Emitter;return process.parentPort.on("message",u=>{if(m?.handledClientConnection(u))return;const y=(0,R.firstOrDefault)(u.ports);y&&h.fire(y)}),A.Event.map(h.event,u=>({protocol:new P(u),onDidClientDisconnect:A.Event.fromNodeEventEmitter(u,"close")}))}constructor(m){super(f.getOnDidClientConnect(m))}}e.Server=f;function D(w,m,h){const u=y=>{y.data===m&&(w.removeListener("message",u),h())};w.on("message",u)}}),define(le[69],ue([0,1,6,3,2,66,13]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=P;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function P(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}var f;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(f||(e.StorageState=f={}));class D extends O.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(h,u=Object.create(null)){super(),this.database=h,this.options=u,this._onDidChangeStorage=this._register(new U.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=this._register(new L.ThrottledDelayer(D.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){this._onDidChangeStorage.pause();try{h.changed?.forEach((u,y)=>this.acceptExternal(y,u)),h.deleted?.forEach(u=>this.acceptExternal(u,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(h,u){if(this.state===f.Closed)return;let y=!1;(0,_.isUndefinedOrNull)(u)?y=this.cache.delete(h):this.cache.get(h)!==u&&(this.cache.set(h,u),y=!0),y&&this._onDidChangeStorage.fire({key:h,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,u){const y=this.cache.get(h);return(0,_.isUndefinedOrNull)(y)?u:y}getBoolean(h,u){const y=this.get(h);return(0,_.isUndefinedOrNull)(y)?u:y==="true"}getNumber(h,u){const y=this.get(h);return(0,_.isUndefinedOrNull)(y)?u:parseInt(y,10)}getObject(h,u){const y=this.get(h);return(0,_.isUndefinedOrNull)(y)?u:(0,A.parse)(y)}async set(h,u,y=!1){if(this.state===f.Closed)return;if((0,_.isUndefinedOrNull)(u))return this.delete(h,y);const v=(0,_.isObject)(u)||Array.isArray(u)?(0,A.stringify)(u):String(u);if(this.cache.get(h)!==v)return this.cache.set(h,v),this.pendingInserts.set(h,v),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire({key:h,external:y}),this.doFlush()}async delete(h,u=!1){if(!(this.state===f.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire({key:h,external:u}),this.doFlush()}async optimize(){if(this.state!==f.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(this.hasPending)return this.doFlush(h)}async doFlush(h){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=D;class w{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((u,y)=>this.items.set(y,u)),h.delete?.forEach(u=>this.items.delete(u))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=w}),define(le[152],ue([11,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],ue([0,1,40,6,14,13,31,152]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=v,e.extract=d,e.buffer=l,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class f extends Error{constructor(S,i){let o=i.message;switch(S){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=S,this.cause=i}}e.ExtractError=f;function D(c){const S=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>S&i).reduce((i,o)=>i+o,S&61440)}function w(c){if(c instanceof f)return c;let S;return P.test(c.message)&&(S="CorruptZip"),new f(S,c)}function m(c,S,i,o,n,s){const t=O.dirname(S),r=O.join(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,S)));const a=O.join(o,S);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(_.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((C,b)=>{if(!s.isCancellationRequested)try{E=(0,L.createWriteStream)(a,{mode:i}),E.once("close",()=>C()),E.once("error",b),c.once("error",b),c.pipe(E)}catch(I){b(I)}}))}function h(c,S,i,o){let n=(0,U.createCancelablePromise)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const E=new U.Sequencer,C=b=>{b.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new f("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",b=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(b.fileName)){C(o);return}const I=b.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(I)){const N=O.join(S,I);n=(0,U.createCancelablePromise)(F=>_.Promises.mkdir(N,{recursive:!0}).then(()=>C(F)).then(void 0,a));return}const p=y(c,b),k=D(b);n=(0,U.createCancelablePromise)(N=>E.queue(()=>p.then(F=>m(F,I,k,S,i,N).then(()=>C(N)))).then(null,a))})}).finally(()=>t.dispose())}async function u(c,S=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,S?{lazyEntries:!0}:void 0,(s,t)=>{s?n(w(s)):o((0,A.assertIsDefined)(t))})})}function y(c,S){return new Promise((i,o)=>{c.openReadStream(S,(n,s)=>{n?o(w(n)):i((0,A.assertIsDefined)(s))})})}async function v(c,S){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;S.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,L.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function d(c,S,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=u(c,!0);return i.overwrite&&(s=s.then(t=>_.Promises.rm(S).then(()=>t))),s.then(t=>h(t,S,{sourcePathRegex:n},o))}function g(c,S){return u(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===S&&y(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,S))))}))}function l(c,S){return g(c,S).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(le[153],ue([11,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[154],ue([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[155],ue([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[156],ue([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[157],ue([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[158],ue([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[159],ue([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[160],ue([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[161],ue([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[162],ue([11,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[163],ue([11,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[164],ue([11,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[165],ue([11,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[166],ue([11,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[167],ue([11,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[168],ue([11,10]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[169],ue([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[170],ue([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[171],ue([11,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[172],ue([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[173],ue([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[174],ue([11,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[175],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[176],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[177],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[178],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[179],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[180],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[181],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[182],ue([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[183],ue([11,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[184],ue([0,1,7,155]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...f){switch(f.length){case 1:return(0,U.localize)(0,null,f[0]);case 2:return(0,U.localize)(1,null,f[0],f[1]);case 3:return(0,U.localize)(2,null,f[0],f[1],f[2]);default:return}}const _=(0,U.localize)(3,null),R=(0,U.localize)(4,null);class P{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return D.isTripleEq?"===":"==";case 4:return D.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(D){return this._input=D,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const w=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:w})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const w=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:w})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(D){return this._isAtEnd()||this._input.charCodeAt(this._current)!==D?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(D){this._tokens.push({type:D,offset:this._start})}_error(D){const w=this._start,m=this._input.substring(this._start,this._current),h={type:19,offset:this._start,lexeme:m};this._errors.push({offset:w,lexeme:m,additionalInfo:D}),this._tokens.push(h)}_string(){this.stringRe.lastIndex=this._start;const D=this.stringRe.exec(this._input);if(D){this._current=this._start+D[0].length;const w=this._input.substring(this._start,this._current),m=P._keywords.get(w);m?this._addToken(m):this._tokens.push({type:17,lexeme:w,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(_);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let D=this._current,w=!1,m=!1;for(;;){if(D>=this._input.length){this._current=D,this._error(R);return}const u=this._input.charCodeAt(D);if(w)w=!1;else if(u===47&&!m){D++;break}else u===91?m=!0:u===92?w=!0:u===93&&(m=!1);D++}for(;D<this._input.length&&P._regexFlags.has(this._input.charCodeAt(D));)D++;this._current=D;const h=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:h,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=P}),define(le[185],ue([0,1,65,84,23,14,36,20,8]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=D,e.parseDebugParams=w,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class f{get appRoot(){return(0,A.dirname)(O.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=_.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(O.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,A.resolve)(h)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const u=_.env.VSCODE_EXTENSIONS;if(u)return u;const y=_.env.VSCODE_PORTABLE;return y?(0,A.join)(y,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(u=>/^[^:/?#]+?:\/\//.test(u)?P.URI.parse(u):P.URI.file((0,A.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!_.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const u of this.args.log||[]){const y=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(u);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=_.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this._args}constructor(h,u,y){this._args=h,this.paths=u,this.productService=y,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=f,we([U.memoize],f.prototype,"appRoot",null),we([U.memoize],f.prototype,"userHome",null),we([U.memoize],f.prototype,"userDataPath",null),we([U.memoize],f.prototype,"appSettingsHome",null),we([U.memoize],f.prototype,"tmpDir",null),we([U.memoize],f.prototype,"cacheHome",null),we([U.memoize],f.prototype,"stateResource",null),we([U.memoize],f.prototype,"userRoamingDataHome",null),we([U.memoize],f.prototype,"userDataSyncHome",null),we([U.memoize],f.prototype,"sync",null),we([U.memoize],f.prototype,"machineSettingsResource",null),we([U.memoize],f.prototype,"workspaceStorageHome",null),we([U.memoize],f.prototype,"localHistoryHome",null),we([U.memoize],f.prototype,"keyboardLayoutResource",null),we([U.memoize],f.prototype,"argvResource",null),we([U.memoize],f.prototype,"isExtensionDevelopment",null),we([U.memoize],f.prototype,"untitledWorkspacesHome",null),we([U.memoize],f.prototype,"builtinExtensionsPath",null),we([U.memoize],f.prototype,"extensionsPath",null),we([U.memoize],f.prototype,"extensionDevelopmentLocationURI",null),we([U.memoize],f.prototype,"extensionDevelopmentKind",null),we([U.memoize],f.prototype,"extensionTestsLocationURI",null),we([U.memoize],f.prototype,"debugExtensionHost",null),we([U.memoize],f.prototype,"logLevel",null),we([U.memoize],f.prototype,"extensionLogLevel",null),we([U.memoize],f.prototype,"serviceMachineIdResource",null),we([U.memoize],f.prototype,"disableTelemetry",null),we([U.memoize],f.prototype,"disableWorkspaceTrust",null),we([U.memoize],f.prototype,"useInMemorySecretStorage",null),we([U.memoize],f.prototype,"policyFile",null);function D(m,h){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}function w(m,h,u,y,v,d){const l=Number(h||m)||(y?null:u),c=l?!!h:!1;let S;if(d)try{S=JSON.parse(d)}catch{}return{port:l,break:c,debugId:v,env:S}}}),function(){"use strict";function se(e,L,U){function O(_,R){const P=A(_,R),f=[P];return e.isAbsolute(P)||f.unshift(U),e.resolve(...f)}function A(_,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,R);const D=_["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(w,"AppData","Roaming")}break;case"darwin":f=e.join(L.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,R)}return{getUserDataPath:O}}if(typeof define=="function")define(le[186],ue([276,37,36]),function(e,L,U){return se(e,L,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=se(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[187],ue([0,1,37,185,186]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=_,e.parseSharedProcessDebugPort=R;class A extends U.AbstractNativeEnvironmentService{constructor(f,D){super(f,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,O.getUserDataPath)(f,D.nameShort)},D)}}e.NativeEnvironmentService=A;function _(P,f){return(0,U.parseDebugParams)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,f,P.extensionEnvironment)}function R(P,f){return(0,U.parseDebugParams)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,f,P.extensionEnvironment)}}),define(le[188],ue([0,1,13,158]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=O;function O(_,R,P,f){try{A(_,R,P,f)}catch(D){_.error(D?.message??D)}return R}function A(_,R,P,f){const D=(w,m,h)=>{const u=w[m];if((0,L.isString)(u)){const y=u,v=y.length;if(v>1&&y[0]==="%"&&y[v-1]==="%"){const d=y.substr(1,v-2);let g=P[d];g===void 0&&f&&(g=f[d]);const l=typeof g=="string"?g:g?.message,c=f?.[d],S=typeof c=="string"?c:c?.message;if(!l){S||_.warn(`[${R.name}]: ${(0,U.localize)(0,null,d)}`);return}if(h&&(m==="title"||m==="category")&&S&&S!==l){const i={value:l,original:S};w[m]=i}else w[m]=l}}else if((0,L.isObject)(u))for(const y in u)u.hasOwnProperty(y)&&(y==="commands"?D(u,y,!0):D(u,y,h));else if(Array.isArray(u))for(let y=0;y<u.length;y++)D(u,y,h)};for(const w in R)R.hasOwnProperty(w)&&D(R,w)}}),define(le[189],ue([0,1,70,161]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=O;function O(A){return(0,L.buffer)(A,"extension/package.json").then(_=>{try{return JSON.parse(_.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}}),define(le[190],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.channel.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class U{constructor(A){this.service=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,R){switch(_){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${_}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(le[71],ue([0,1,20,88,162,55]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=P,e.parseVersion=f,e.normalizeVersion=D,e.isValidVersion=w,e.validateExtensionManifest=m,e.isValidExtensionVersion=h,e.isEngineValid=u;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(d){return d=d.trim(),d==="*"||_.test(d)}function f(d){if(!P(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=d.match(_);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function D(d){if(!d)return null;const g=d.majorBase,l=d.majorMustEqual,c=d.minorBase;let S=d.minorMustEqual;const i=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(g===0||(S=!1),o=!1);let n=0;if(d.preRelease){const s=R.exec(d.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:g,majorMustEqual:l,minorBase:c,minorMustEqual:S,patchBase:i,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:n}}function w(d,g,l){let c;typeof d=="string"?c=D(f(d)):c=d;let S;g instanceof Date?S=g.getTime():typeof g=="string"&&(S=new Date(g).getTime());let i;if(typeof l=="string"?i=D(f(l)):i=l,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const E=i.notBefore;let C=i.majorMustEqual,b=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||S&&S<E?!1:s>=a:(o===1&&t===0&&(!C||!b||!I)&&(t=1,r=0,a=0,C=!0,b=!1,I=!1),o<t?!1:o>t?!C:n<r?!1:n>r?!b:s<a?!1:s>a?!I:!(S&&S<E))}function m(d,g,l,c,S){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([U.default.Error,O.localize(0,null)]),i;if(typeof c.name!="string")return i.push([U.default.Error,O.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([U.default.Error,O.localize(2,null,"version")]),i;if(!c.engines)return i.push([U.default.Error,O.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([U.default.Error,O.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!v(c.extensionDependencies))return i.push([U.default.Error,O.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!v(c.activationEvents))return i.push([U.default.Error,O.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([U.default.Error,O.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([U.default.Warning,O.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([U.default.Error,O.localize(9,null,"main")]),i;{const s=(0,L.joinPath)(l,c.main);(0,L.isEqualOrParent)(s,l)||i.push([U.default.Warning,O.localize(10,null,s.path,l.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([U.default.Error,O.localize(11,null,"browser")]),i;{const s=(0,L.joinPath)(l,c.browser);(0,L.isEqualOrParent)(s,l)||i.push([U.default.Warning,O.localize(12,null,s.path,l.path)])}}if(!A.valid(c.version))return i.push([U.default.Error,O.localize(13,null)]),i;const o=[];if(!h(d,g,c,S,o))for(const s of o)i.push([U.default.Error,s]);return i}function h(d,g,l,c,S){return c||typeof l.main>"u"&&typeof l.browser>"u"?!0:y(d,g,l.engines.vscode,S)}function u(d,g,l){return d==="*"||y(g,l,d)}function y(d,g,l,c=[]){const S=D(f(l));if(!S)return c.push(O.localize(14,null,l)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return c.push(O.localize(15,null,l)),!1}else if(!S.majorMustEqual)return c.push(O.localize(16,null,l)),!1;return w(d,g,S)?!0:(c.push(O.localize(17,null,d,l)),!1)}function v(d){if(!Array.isArray(d))return!1;for(let g=0,l=d.length;g<l;g++)if(typeof d[g]!="string")return!1;return!0}}),define(le[45],ue([0,1,15,32]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=O;async function O(A,_,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const D=(await _.readFile(A.serviceMachineIdResource)).value.toString();P=(0,U.isUUID)(D)?D:null}catch{P=null}if(!P){P=(0,U.generateUuid)();try{await _.writeFile(A.serviceMachineIdResource,L.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}}),define(le[72],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(O,A=[],_=!1){this.ctor=O,this.staticArguments=A,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=L}),define(le[191],ue([0,1,72]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=A,e.getSingletonServiceDescriptors=_;const U=[];var O;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function A(R,P,f){P instanceof L.SyncDescriptor||(P=new L.SyncDescriptor(P,[],!!f)),U.push([R,P])}function _(){return U}}),define(le[192],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(A,_){this.key=A,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class U{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(const _ of this._nodes.values())_.outgoing.size===0&&A.push(_);return A}insertEdge(A,_){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(_);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const _=this._hashFn(A);this._nodes.delete(_);for(const R of this._nodes.values())R.outgoing.delete(_),R.incoming.delete(_)}lookupOrInsertNode(A){const _=this._hashFn(A);let R=this._nodes.get(_);return R||(R=new L(_,A),this._nodes.set(_,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){const A=[];for(const[_,R]of this._nodes)A.push(`${_}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,_]of this._nodes){const R=new Set([A]),P=this._findCycle(_,R);if(P)return P}}_findCycle(A,_){for(const[R,P]of A.outgoing){if(_.has(R))return[..._,R].join(" -> ");_.add(R);const f=this._findCycle(P,_);if(f)return f;_.delete(R)}}}e.Graph=U}),define(le[4],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=O,e.refineServiceDecorator=A;var L;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=R})(L||(e._util=L={})),e.IInstantiationService=O("instantiationService");function U(_,R,P){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:_,index:P}):(R[L.DI_DEPENDENCIES]=[{id:_,index:P}],R[L.DI_TARGET]=R)}function O(_){if(L.serviceIds.has(_))return L.serviceIds.get(_);const R=function(P,f,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(R,P,D)};return R.toString=()=>_,L.serviceIds.set(_,R),R}function A(_){return _}}),define(le[193],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(le[21],ue([0,1,13,8,4]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=A,e.isConfigurationUpdateOverrides=_,e.ConfigurationTargetToString=P,e.isConfigured=f,e.toValuesTree=D,e.addToValueTree=w,e.removeFromValueTree=m,e.getConfigurationValue=u,e.merge=y,e.getLanguageTagSettingPlainKey=v,e.IConfigurationService=(0,O.createDecorator)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof U.URI)}function _(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof U.URI)}var R;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function P(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function f(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function D(d,g){const l=Object.create(null);for(const c in d)w(l,c,d[c],g);return l}function w(d,g,l,c){const S=g.split("."),i=S.pop();let o=d;for(let n=0;n<S.length;n++){const s=S[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${g} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=l}catch{c(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(o)}`)}function m(d,g){const l=g.split(".");h(d,l)}function h(d,g){const l=g.shift();if(g.length===0){delete d[l];return}if(Object.keys(d).indexOf(l)!==-1){const c=d[l];typeof c=="object"&&!Array.isArray(c)&&(h(c,g),Object.keys(c).length===0&&delete d[l])}}function u(d,g,l){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const S=g.split("."),i=c(d,S);return typeof i>"u"?l:i}function y(d,g,l){Object.keys(g).forEach(c=>{c!=="__proto__"&&(c in d?L.isObject(d[c])&&L.isObject(g[c])?y(d[c],g[c],l):l&&(d[c]=g[c]):d[c]=g[c])})}function v(d){return d.replace(/[\[\]]/g,"")}}),define(le[93],ue([0,1,5,27,184,4,154,7]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=f,e.validateWhenClauses=o,e.expressionsAreEqualWithConstantSubstitution=n,e.implies=te;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",L.isMacintosh),P.set("isLinux",L.isLinux),P.set("isWindows",L.isWindows),P.set("isWeb",L.isWeb),P.set("isMacNative",L.isMacintosh&&!L.isWeb),P.set("isEdge",L.isEdge),P.set("isFirefox",L.isFirefox),P.set("isChrome",L.isChrome),P.set("isSafari",L.isSafari);function f($,T){if(P.get($)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set($,T)}const D=Object.prototype.hasOwnProperty;var w;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const m={regexParsingWithErrorRecovery:!0},h=(0,_.localize)(0,null),u=(0,_.localize)(1,null),y=(0,_.localize)(2,null),v=(0,_.localize)(3,null),d=(0,_.localize)(4,null),g=(0,_.localize)(5,null),l=(0,_.localize)(6,null),c=(0,_.localize)(7,null);class S{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(T=m){this._config=T,this._scanner=new O.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(T){if(T===""){this._parsingErrors.push({message:h,offset:0,lexeme:"",additionalInfo:u});return}this._tokens=this._scanner.reset(T).scan(),this._current=0,this._parsingErrors=[];try{const M=this._expr();if(!this._isAtEnd()){const W=this._peek(),J=W.type===17?g:void 0;throw this._parsingErrors.push({message:d,offset:W.offset,lexeme:O.Scanner.getLexeme(W),additionalInfo:J}),S._parseError}return M}catch(M){if(M!==S._parseError)throw M;return}}_expr(){return this._or()}_or(){const T=[this._and()];for(;this._matchOne(16);){const M=this._and();T.push(M)}return T.length===1?T[0]:i.or(...T)}_and(){const T=[this._term()];for(;this._matchOne(15);){const M=this._term();T.push(M)}return T.length===1?T[0]:i.and(...T)}_term(){if(this._matchOne(2)){const T=this._peek();switch(T.type){case 11:return this._advance(),t.INSTANCE;case 12:return this._advance(),r.INSTANCE;case 0:{this._advance();const M=this._expr();return this._consume(1,v),M?.negate()}case 17:return this._advance(),p.create(T.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",T)}}return this._primary()}_primary(){const T=this._peek();switch(T.type){case 11:return this._advance(),i.true();case 12:return this._advance(),i.false();case 0:{this._advance();const M=this._expr();return this._consume(1,v),M}case 17:{const M=T.lexeme;if(this._advance(),this._matchOne(9)){const J=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),J.type!==10)throw this._errExpectedButGot("REGEX",J);const H=J.lexeme,ee=H.lastIndexOf("/"),Q=ee===H.length-1?void 0:this._removeFlagsGY(H.substring(ee+1));let Y;try{Y=new RegExp(H.substring(1,ee),Q)}catch{throw this._errExpectedButGot("REGEX",J)}return B.create(M,Y)}switch(J.type){case 10:case 19:{const H=[J.lexeme];this._advance();let ee=this._peek(),Q=0;for(let fe=0;fe<J.lexeme.length;fe++)J.lexeme.charCodeAt(fe)===40?Q++:J.lexeme.charCodeAt(fe)===41&&Q--;for(;!this._isAtEnd()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:Q++;break;case 1:Q--;break;case 10:case 18:for(let fe=0;fe<ee.lexeme.length;fe++)ee.lexeme.charCodeAt(fe)===40?Q++:J.lexeme.charCodeAt(fe)===41&&Q--}if(Q<0)break;H.push(O.Scanner.getLexeme(ee)),this._advance(),ee=this._peek()}const Y=H.join(""),ne=Y.lastIndexOf("/"),re=ne===Y.length-1?void 0:this._removeFlagsGY(Y.substring(ne+1));let he;try{he=new RegExp(Y.substring(1,ne),re)}catch{throw this._errExpectedButGot("REGEX",J)}return i.regex(M,he)}case 18:{const H=J.lexeme;this._advance();let ee=null;if(!(0,U.isFalsyOrWhitespace)(H)){const Q=H.indexOf("/"),Y=H.lastIndexOf("/");if(Q!==Y&&Q>=0){const ne=H.slice(Q+1,Y),re=H[Y+1]==="i"?"i":"";try{ee=new RegExp(ne,re)}catch{throw this._errExpectedButGot("REGEX",J)}}}if(ee===null)throw this._errExpectedButGot("REGEX",J);return B.create(M,ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,y);const J=this._value();return i.notIn(M,J)}switch(this._peek().type){case 3:{this._advance();const J=this._value();if(this._previous().type===18)return i.equals(M,J);switch(J){case"true":return i.has(M);case"false":return i.not(M);default:return i.equals(M,J)}}case 4:{this._advance();const J=this._value();if(this._previous().type===18)return i.notEquals(M,J);switch(J){case"true":return i.not(M);case"false":return i.has(M);default:return i.notEquals(M,J)}}case 5:return this._advance(),x.create(M,this._value());case 6:return this._advance(),Z.create(M,this._value());case 7:return this._advance(),N.create(M,this._value());case 8:return this._advance(),F.create(M,this._value());case 13:return this._advance(),i.in(M,this._value());default:return i.has(M)}}case 20:throw this._parsingErrors.push({message:l,offset:T.offset,lexeme:"",additionalInfo:c}),S._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const T=this._peek();switch(T.type){case 17:case 18:return this._advance(),T.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(T){return T.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(T){return this._check(T)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(T,M){if(this._check(T))return this._advance();throw this._errExpectedButGot(M,this._peek())}_errExpectedButGot(T,M,W){const J=(0,_.localize)(8,null,T,O.Scanner.getLexeme(M)),H=M.offset,ee=O.Scanner.getLexeme(M);return this._parsingErrors.push({message:J,offset:H,lexeme:ee,additionalInfo:W}),S._parseError}_check(T){return this._peek().type===T}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=S;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(T){return a.create(T)}static equals(T,M){return E.create(T,M)}static notEquals(T,M){return I.create(T,M)}static regex(T,M){return B.create(T,M)}static in(T,M){return C.create(T,M)}static notIn(T,M){return b.create(T,M)}static not(T){return p.create(T)}static and(...T){return G.create(T,null,!0)}static or(...T){return z.create(T,null,!0)}static greater(T,M){return N.create(T,M)}static greaterEquals(T,M){return F.create(T,M)}static smaller(T,M){return x.create(T,M)}static smallerEquals(T,M){return Z.create(T,M)}static{this._parser=new S({regexParsingWithErrorRecovery:!1})}static deserialize(T){return T==null?void 0:this._parser.parse(T)}}e.ContextKeyExpr=i;function o($){const T=new S({regexParsingWithErrorRecovery:!1});return $.map(M=>(T.parse(M),T.lexingErrors.length>0?T.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,_.localize)(9,null,W.additionalInfo):(0,_.localize)(10,null),offset:W.offset,length:W.lexeme.length})):T.parsingErrors.length>0?T.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}function n($,T){const M=$?$.substituteConstants():void 0,W=T?T.substituteConstants():void 0;return!M&&!W?!0:!M||!W?!1:M.equals(W)}function s($,T){return $.cmp(T)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return t.INSTANCE}}e.ContextKeyTrueExpr=r;class a{static create(T,M=null){const W=P.get(T);return typeof W=="boolean"?W?r.INSTANCE:t.INSTANCE:new a(T,M)}constructor(T,M){this.key=T,this.negated=M,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:ie(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=P.get(this.key);return typeof T=="boolean"?T?r.INSTANCE:t.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class E{static create(T,M,W=null){if(typeof M=="boolean")return M?a.create(T,W):p.create(T,W);const J=P.get(T);return typeof J=="boolean"?M===(J?"true":"false")?r.INSTANCE:t.INSTANCE:new E(T,M,W)}constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=P.get(this.key);if(typeof T=="boolean"){const M=T?"true":"false";return this.value===M?r.INSTANCE:t.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class C{static create(T,M){return new C(T,M)}constructor(T,M){this.key=T,this.valueKey=M,this.type=10,this.negated=null}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const M=T.getValue(this.valueKey),W=T.getValue(this.key);return Array.isArray(M)?M.includes(W):typeof W=="string"&&typeof M=="object"&&M!==null?D.call(M,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=C;class b{static create(T,M){return new b(T,M)}constructor(T,M){this.key=T,this.valueKey=M,this.type=11,this._negated=C.create(T,M)}cmp(T){return T.type!==this.type?this.type-T.type:this._negated.cmp(T._negated)}equals(T){return T.type===this.type?this._negated.equals(T._negated):!1}substituteConstants(){return this}evaluate(T){return!this._negated.evaluate(T)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(T){return T.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class I{static create(T,M,W=null){if(typeof M=="boolean")return M?p.create(T,W):a.create(T,W);const J=P.get(T);return typeof J=="boolean"?M===(J?"true":"false")?t.INSTANCE:r.INSTANCE:new I(T,M,W)}constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=P.get(this.key);if(typeof T=="boolean"){const M=T?"true":"false";return this.value===M?t.INSTANCE:r.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class p{static create(T,M=null){const W=P.get(T);return typeof W=="boolean"?W?t.INSTANCE:r.INSTANCE:new p(T,M)}constructor(T,M){this.key=T,this.negated=M,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:ie(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=P.get(this.key);return typeof T=="boolean"?T?t.INSTANCE:r.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function k($,T){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?T($):t.INSTANCE}class N{static create(T,M,W=null){return k(M,J=>new N(T,J,W))}constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=Z.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class F{static create(T,M,W=null){return k(M,J=>new F(T,J,W))}constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class x{static create(T,M,W=null){return k(M,J=>new x(T,J,W))}constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class Z{static create(T,M,W=null){return k(M,J=>new Z(T,J,W))}constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:ae(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=Z;class B{static create(T,M){return new B(T,M)}constructor(T,M){this.key=T,this.regexp=M,this.type=7,this.negated=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const M=this.regexp?this.regexp.source:"",W=T.regexp?T.regexp.source:"";return M<W?-1:M>W?1:0}equals(T){if(T.type===this.type){const M=this.regexp?this.regexp.source:"",W=T.regexp?T.regexp.source:"";return this.key===T.key&&M===W}return!1}substituteConstants(){return this}evaluate(T){const M=T.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=X.create(this)),this.negated}}e.ContextKeyRegexExpr=B;class X{static create(T){return new X(T)}constructor(T){this._actual=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(T){return new X(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=X;function j($){let T=null;for(let M=0,W=$.length;M<W;M++){const J=$[M].substituteConstants();if($[M]!==J&&T===null){T=[];for(let H=0;H<M;H++)T[H]=$[H]}T!==null&&(T[M]=J)}return T===null?$:T}class G{static create(T,M,W){return G._normalizeArr(T,M,W)}constructor(T,M){this.expr=T,this.negated=M,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const J=s(this.expr[M],T.expr[M]);if(J!==0)return J}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(T.expr[M]))return!1;return!0}return!1}substituteConstants(){const T=j(this.expr);return T===this.expr?this:G.create(T,this.negated,!1)}evaluate(T){for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].evaluate(T))return!1;return!0}static _normalizeArr(T,M,W){const J=[];let H=!1;for(const ee of T)if(ee){if(ee.type===1){H=!0;continue}if(ee.type===0)return t.INSTANCE;if(ee.type===6){J.push(...ee.expr);continue}J.push(ee)}if(J.length===0&&H)return r.INSTANCE;if(J.length!==0){if(J.length===1)return J[0];J.sort(s);for(let ee=1;ee<J.length;ee++)J[ee-1].equals(J[ee])&&(J.splice(ee,1),ee--);if(J.length===1)return J[0];for(;J.length>1;){const ee=J[J.length-1];if(ee.type!==9)break;J.pop();const Q=J.pop(),Y=J.length===0,ne=z.create(ee.expr.map(re=>G.create([re,Q],null,W)),null,Y);ne&&(J.push(ne),J.sort(s))}if(J.length===1)return J[0];if(W){for(let ee=0;ee<J.length;ee++)for(let Q=ee+1;Q<J.length;Q++)if(J[ee].negate().equals(J[Q]))return t.INSTANCE;if(J.length===1)return J[0]}return new G(J,M)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const M of this.expr)T.push(...M.keys());return T}map(T){return new G(this.expr.map(M=>M.map(T)),null)}negate(){if(!this.negated){const T=[];for(const M of this.expr)T.push(M.negate());this.negated=z.create(T,this,!0)}return this.negated}}e.ContextKeyAndExpr=G;class z{static create(T,M,W){return z._normalizeArr(T,M,W)}constructor(T,M){this.expr=T,this.negated=M,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const J=s(this.expr[M],T.expr[M]);if(J!==0)return J}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(T.expr[M]))return!1;return!0}return!1}substituteConstants(){const T=j(this.expr);return T===this.expr?this:z.create(T,this.negated,!1)}evaluate(T){for(let M=0,W=this.expr.length;M<W;M++)if(this.expr[M].evaluate(T))return!0;return!1}static _normalizeArr(T,M,W){let J=[],H=!1;if(T){for(let ee=0,Q=T.length;ee<Q;ee++){const Y=T[ee];if(Y){if(Y.type===0){H=!0;continue}if(Y.type===1)return r.INSTANCE;if(Y.type===9){J=J.concat(Y.expr);continue}J.push(Y)}}if(J.length===0&&H)return t.INSTANCE;J.sort(s)}if(J.length!==0){if(J.length===1)return J[0];for(let ee=1;ee<J.length;ee++)J[ee-1].equals(J[ee])&&(J.splice(ee,1),ee--);if(J.length===1)return J[0];if(W){for(let ee=0;ee<J.length;ee++)for(let Q=ee+1;Q<J.length;Q++)if(J[ee].negate().equals(J[Q]))return r.INSTANCE;if(J.length===1)return J[0]}return new z(J,M)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const M of this.expr)T.push(...M.keys());return T}map(T){return new z(this.expr.map(M=>M.map(T)),null)}negate(){if(!this.negated){const T=[];for(const M of this.expr)T.push(M.negate());for(;T.length>1;){const M=T.shift(),W=T.shift(),J=[];for(const H of V(M))for(const ee of V(W))J.push(G.create([H,ee],null,!1));T.unshift(z.create(J,null,!1))}this.negated=z.create(T,this,!0)}return this.negated}}e.ContextKeyOrExpr=z;class q extends a{static{this._info=[]}static all(){return q._info.values()}constructor(T,M,W){super(T,null),this._defaultValue=M,typeof W=="object"?q._info.push({...W,key:T}):W!==!0&&q._info.push({key:T,description:W,type:M!=null?typeof M:void 0})}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return E.create(this.key,T)}notEqualsTo(T){return I.create(this.key,T)}}e.RawContextKey=q,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function ie($,T){return $<T?-1:$>T?1:0}function ae($,T,M,W){return $<M?-1:$>M?1:T<W?-1:T>W?1:0}function te($,T){if($.type===0||T.type===1)return!0;if($.type===9)return T.type===9?ce($.expr,T.expr):!1;if(T.type===9){for(const M of T.expr)if(te($,M))return!0;return!1}if($.type===6){if(T.type===6)return ce(T.expr,$.expr);for(const M of $.expr)if(te(M,T))return!0;return!1}return $.equals(T)}function ce($,T){let M=0,W=0;for(;M<$.length&&W<T.length;){const J=$[M].cmp(T[W]);if(J<0)return!1;J===0&&M++,W++}return M===$.length}function V($){return $.type===9?$.expr:[$]}}),define(le[94],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=U,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function U(A){return!!A.hostName&&!!A.errorMessage}class O{async getPerformanceInfo(_,R){return{}}async getSystemInfo(_,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,R){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}e.NullDiagnosticsService=O}),define(le[95],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(le[16],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(le[29],ue([0,1,157,4]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=O,e.toTargetPlatform=A,e.getTargetPlatform=_,e.isNotWebExtensionInWebTargetPlatform=R,e.isTargetPlatformCompatible=P,e.isIExtensionIdentifier=f,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function O(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function _(l,c){switch(l){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":c==="ppc64le"?"linux-ppc64le":c==="riscv64"?"linux-riscv64":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(l,c){return c==="web"&&!l.includes("web")}function P(l,c,S){return R(c,S)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===S}function f(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var u;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));var y;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class v extends Error{constructor(c,S){super(c),this.code=S,this.name=S}}e.ExtensionManagementError=v;var d;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})(d||(e.ExtensionGalleryErrorCode=d={}));class g extends Error{constructor(c,S){super(c),this.code=S,this.name=S}}e.ExtensionGalleryError=g,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,L.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,L.localize2)(1,"Preferences")}),define(le[194],ue([0,1,3,2,30,8,91,29]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(v,d){return v?A.URI.revive(d?d.transformIncoming(v):v):void 0}function f(v,d){return d?d.transformOutgoingURI(v):v}function D(v,d){d=d||_.DefaultURITransformer;const g=v.manifest;return{...(0,_.transformAndReviveIncomingURIs)({...v,manifest:void 0},d),manifest:g}}function w(v,d){return v?.profileLocation?(0,_.transformAndReviveIncomingURIs)(v,d??_.DefaultURITransformer):v}function m(v,d){return d?(0,O.cloneAndChange)(v,g=>g instanceof A.URI?d.transformOutgoingURI(g):void 0):v}class h{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=L.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(d.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(d.onDidUpdateExtensionMetadata,!0)}listen(d,g){const l=this.getUriTransformer(d);switch(g){case"onInstallExtension":return L.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?f(c.profileLocation,l):c.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,c=>c.map(S=>({...S,local:S.local?m(S.local,l):S.local,profileLocation:S.profileLocation?f(S.profileLocation,l):S.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?f(c.profileLocation,l):c.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?f(c.profileLocation,l):c.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,l))}throw new Error("Invalid listen")}async call(d,g,l){const c=this.getUriTransformer(d);switch(g){case"zip":{const S=D(l[0],c),i=await this.service.zip(S);return f(i,c)}case"unzip":return this.service.unzip(P(l[0],c));case"install":return this.service.install(P(l[0],c),w(l[1],c));case"installFromLocation":return this.service.installFromLocation(P(l[0],c),P(l[1],c));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(l[0],P(l[1],c),P(l[2],c));case"getManifest":return this.service.getManifest(P(l[0],c));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(l[0]);case"installFromGallery":return this.service.installFromGallery(l[0],w(l[1],c));case"installGalleryExtensions":{const S=l[0];return this.service.installGalleryExtensions(S.map(({extension:i,options:o})=>({extension:i,options:w(o,c)??{}})))}case"uninstall":return this.service.uninstall(D(l[0],c),w(l[1],c));case"reinstallFromGallery":return this.service.reinstallFromGallery(D(l[0],c));case"getInstalled":return(await this.service.getInstalled(l[0],P(l[1],c),l[2])).map(i=>m(i,c));case"toggleAppliationScope":{const S=await this.service.toggleAppliationScope(D(l[0],c),P(l[1],c));return m(S,c)}case"copyExtensions":return this.service.copyExtensions(P(l[0],c),P(l[1],c));case"updateMetadata":{const S=await this.service.updateMetadata(D(l[0],c),l[1],P(l[2],c));return m(S,c)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(l[0],l[1],l[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=h;class u extends U.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(d){super(),this.channel=d,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this._onDidUpdateExtensionMetadata=this._register(new L.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this.fireEvent(this._onInstallExtension,{...g,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this.fireEvent(this._onDidInstallExtensions,g.map(l=>({...l,local:l.local?D(l.local,null):l.local,source:this.isUriComponents(l.source)?A.URI.revive(l.source):l.source,profileLocation:A.URI.revive(l.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this.fireEvent(this._onUninstallExtension,{...g,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this.fireEvent(this._onDidUninstallExtension,{...g,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(g=>this._onDidUpdateExtensionMetadata.fire(D(g,null))))}fireEvent(d,g){d.fire(g)}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(l=>(0,R.isTargetPlatformCompatible)(l,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>A.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(l=>D(l,null))}installFromLocation(d,g){return Promise.resolve(this.channel.call("installFromLocation",[d,g])).then(l=>D(l,null))}async installExtensionsFromProfile(d,g,l){return(await this.channel.call("installExtensionsFromProfile",[d,g,l])).map(S=>D(S,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(l=>D(l,null))}async installGalleryExtensions(d){return(await this.channel.call("installGalleryExtensions",[d])).map(l=>({...l,local:l.local?D(l.local,null):l.local,source:this.isUriComponents(l.source)?A.URI.revive(l.source):l.source,profileLocation:A.URI.revive(l.profileLocation)}))}uninstall(d,g){if(d.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d])).then(g=>D(g,null))}getInstalled(d=null,g,l){return Promise.resolve(this.channel.call("getInstalled",[d,g,l])).then(c=>c.map(S=>D(S,null)))}updateMetadata(d,g,l){return Promise.resolve(this.channel.call("updateMetadata",[d,g,l])).then(c=>D(c,null))}toggleAppliationScope(d,g){return this.channel.call("toggleAppliationScope",[d,g]).then(l=>D(l,null))}copyExtensions(d,g){return this.channel.call("copyExtensions",[d,g])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(d,g,l){const c=await this.channel.call("download",[d,g,l]);return A.URI.revive(c)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=u;class y{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,l){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(le[96],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.RecommendationSourceToString=O;var U;(function(_){_[_.FILE=1]="FILE",_[_.WORKSPACE=2]="WORKSPACE",_[_.EXE=3]="EXE"})(U||(e.RecommendationSource=U={}));function O(_){switch(_){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var A;(function(_){_.Ignored="ignored",_.Cancelled="cancelled",_.TooMany="toomany",_.IncompatibleWindow="incompatibleWindow",_.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(le[12],ue([0,1,51,14,27,13,8,164,4,5,23,53]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=m,e.isFileSystemWatcher=y,e.hasReadWriteCapability=d,e.hasFileFolderCopyCapability=g,e.hasFileCloneCapability=l,e.hasOpenReadWriteCloseCapability=c,e.hasFileReadStreamCapability=S,e.hasFileAtomicReadCapability=i,e.hasFileAtomicWriteCapability=o,e.hasFileAtomicDeleteCapability=n,e.hasReadonlyCapability=s,e.createFileSystemProviderError=a,e.ensureFileSystemProviderError=E,e.markAsFileSystemProviderError=C,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=I,e.isParent=x,e.etag=z,e.whenProviderRegistered=q,e.getLargeFileConfirmationLimit=ae,e.IFileService=(0,P.createDecorator)("fileService");function m(te){return te.create===!0}var h;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var u;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(u||(e.FilePermission=u={}));function y(te){const ce=te;return!!ce&&typeof ce.onDidChange=="function"}var v;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function d(te){return!!(te.capabilities&2)}function g(te){return!!(te.capabilities&8)}function l(te){return!!(te.capabilities&131072)}function c(te){return!!(te.capabilities&4)}function S(te){return!!(te.capabilities&16)}function i(te){return d(te)?!!(te.capabilities&16384):!1}function o(te){return d(te)?!!(te.capabilities&32768):!1}function n(te){return!!(te.capabilities&65536)}function s(te){return!!(te.capabilities&2048)}var t;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ce,V){const $=new r(ce.toString(),V);return C($,V),$}constructor(ce,V){super(ce),this.code=V}}e.FileSystemProviderError=r;function a(te,ce){return r.create(te,ce)}function E(te){return te||a((0,R.localize)(0,null),t.Unknown)}function C(te,ce){return te.name=ce?`${ce} (FileSystemError)`:"FileSystemError",te}function b(te){if(!te)return t.Unknown;if(te instanceof r)return te.code;const ce=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ce)return t.Unknown;switch(ce[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function I(te){if(te instanceof Z)return te.fileOperationResult;switch(b(te)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var p;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(p||(e.FileOperation=p={}));class k{constructor(ce,V,$){this.resource=ce,this.operation=V,this.target=$}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=k;var N;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class F{static{this.MIXED_CORRELATION=null}constructor(ce,V){this.ignorePathCasing=V,this.correlationId=void 0,this.added=new w.Lazy(()=>{const $=L.TernarySearchTree.forUris(()=>this.ignorePathCasing);return $.fill(this.rawAdded.map(T=>[T,!0])),$}),this.updated=new w.Lazy(()=>{const $=L.TernarySearchTree.forUris(()=>this.ignorePathCasing);return $.fill(this.rawUpdated.map(T=>[T,!0])),$}),this.deleted=new w.Lazy(()=>{const $=L.TernarySearchTree.forUris(()=>this.ignorePathCasing);return $.fill(this.rawDeleted.map(T=>[T,!0])),$}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const $ of ce){switch($.type){case 1:this.rawAdded.push($.resource);break;case 0:this.rawUpdated.push($.resource);break;case 2:this.rawDeleted.push($.resource);break}this.correlationId!==F.MIXED_CORRELATION&&(typeof $.cId=="number"?this.correlationId===void 0?this.correlationId=$.cId:this.correlationId!==$.cId&&(this.correlationId=F.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=F.MIXED_CORRELATION))}}contains(ce,...V){return this.doContains(ce,{includeChildren:!1},...V)}affects(ce,...V){return this.doContains(ce,{includeChildren:!0},...V)}doContains(ce,V,...$){if(!ce)return!1;const T=$.length>0;return!!((!T||$.includes(1))&&(this.added.value.get(ce)||V.includeChildren&&this.added.value.findSuperstr(ce))||(!T||$.includes(0))&&(this.updated.value.get(ce)||V.includeChildren&&this.updated.value.findSuperstr(ce))||(!T||$.includes(2))&&(this.deleted.value.findSubstr(ce)||V.includeChildren&&this.deleted.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.correlationId===ce}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=F;function x(te,ce,V){return!te||!ce||te===ce||ce.length>te.length?!1:(ce.charAt(ce.length-1)!==U.sep&&(ce+=U.sep),V?(0,O.startsWithIgnoreCase)(te,ce):te.indexOf(ce)===0)}class Z extends Error{constructor(ce,V,$){super(ce),this.fileOperationResult=V,this.options=$}}e.FileOperationError=Z;class B extends Z{constructor(ce,V,$,T){super(ce,V,T),this.fileOperationResult=V,this.size=$}}e.TooLargeFileOperationError=B;class X extends Z{constructor(ce,V,$){super(ce,2,$),this.stat=V}}e.NotModifiedSinceFileOperationError=X;var j;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(j||(e.FileOperationResult=j={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var G;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(G||(e.FileKind=G={})),e.ETAG_DISABLED="";function z(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function q(te,ce){if(!ce.hasProvider(_.URI.from({scheme:te.scheme})))return new Promise(V=>{const $=ce.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===te.scheme&&T.added&&($.dispose(),V())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ce){return(0,A.isNumber)(ce)||(ce=0),ce<ie.KB?(0,R.localize)(1,null,ce.toFixed(0)):ce<ie.MB?(0,R.localize)(2,null,(ce/ie.KB).toFixed(2)):ce<ie.GB?(0,R.localize)(3,null,(ce/ie.MB).toFixed(2)):ce<ie.TB?(0,R.localize)(4,null,(ce/ie.GB).toFixed(2)):(0,R.localize)(5,null,(ce/ie.TB).toFixed(2))}}e.ByteSize=ie;function ae(te){const ce=typeof te=="string"||te?.scheme===D.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===D.Schemas.file?1024*ie.MB:ce?10*ie.MB:f.isWeb?50*ie.MB:1024*ie.MB}});var K=this&&this.__param||function(se,e){return function(L,U){e(L,U,se)}};define(le[195],ue([0,1,73,50,12]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const P=(await this.fileService.readFileStream(R)).value;return new Promise((f,D)=>{const w=(0,L.createHash)("sha256");(0,U.listenStream)(P,{onData:m=>w.update(m.buffer),onError:m=>D(m),onEnd:()=>f(w.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=A,e.ChecksumService=A=we([K(0,O.IFileService)],A)}),define(le[97],ue([0,1,15,7,165,12]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=_;async function _(D,w,m,h,u,y){let v;try{await R(D,w,m,h,u,y)}catch(d){v=d}finally{v&&u.errorTransformer&&(v=u.errorTransformer(v)),typeof v<"u"&&m.error(v),m.end()}}async function R(D,w,m,h,u,y){P(y);const v=await D.open(w,{create:!1});try{P(y);let d=0,g=0,l=u&&typeof u.length=="number"?u.length:void 0,c=L.VSBuffer.alloc(Math.min(u.bufferSize,typeof l=="number"?l:u.bufferSize)),S=u&&typeof u.position=="number"?u.position:0,i=0;do g=await D.read(v,S,c.buffer,i,c.byteLength-i),S+=g,i+=g,d+=g,typeof l=="number"&&(l-=g),i===c.byteLength&&(await m.write(h(c)),c=L.VSBuffer.alloc(Math.min(u.bufferSize,typeof l=="number"?l:u.bufferSize)),i=0);while(g>0&&(typeof l!="number"||l>0)&&P(y)&&f(d,u));if(i>0){let o=i;typeof l=="number"&&(o=Math.min(i,l)),m.write(h(c.slice(0,o)))}}catch(d){throw(0,A.ensureFileSystemProviderError)(d)}finally{await D.close(v)}}function P(D){if(D.isCancellationRequested)throw(0,U.canceled)();return!0}function f(D,w){if(typeof w?.limits?.size=="number"&&D>w.limits.size)throw(0,A.createFileSystemProviderError)((0,O.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[46],ue([0,1,90,2,14,5,8,12]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=P,e.isRecursiveWatchRequest=f,e.reviveFileChanges=h,e.coalesceEvents=u,e.normalizeWatcherPattern=y,e.parseWatcherPatterns=v;function P(g){return typeof g.correlationId=="number"}function f(g){return g.recursive===!0}class D extends U.Disposable{static{this.MAX_RESTARTS=5}constructor(l,c,S,i){super(),this.onFileChanges=l,this.onLogMessage=c,this.verboseLogging=S,this.options=i,this.watcherDisposables=this._register(new U.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const l=new U.DisposableStore;this.watcherDisposables.value=l,this.watcher=this.createWatcher(l),this.watcher.setVerboseLogging(this.verboseLogging),l.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),l.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),l.add(this.watcher.onDidError(c=>this.onError(c)))}onError(l){this.options.restartOnError?this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${l}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${l}`):this.error(l)}restart(l){this.restartCounter++,this.init(),this.watch(l)}async watch(l){this.requests=l,await this.watcher?.watch(l)}async setVerboseLogging(l){this.verboseLogging=l,await this.watcher?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${l}`})}trace(l){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${l}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=D;class w extends D{constructor(l,c,S){super(l,c,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=w;class m extends D{constructor(l,c,S){super(l,c,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function h(g){return g.map(l=>({type:l.type,resource:_.URI.revive(l.resource),cId:l.cId}))}function u(g){const l=new d;for(const c of g)l.processEvent(c);return l.coalesce()}function y(g,l){return typeof l=="string"&&!l.startsWith(L.GLOBSTAR)&&!(0,O.isAbsolute)(l)?{base:g,pattern:l}:l}function v(g,l){const c=[];for(const S of l)c.push((0,L.parse)(y(g,S)));return c}class d{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(l){return A.isLinux?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const c=this.mapPathToChange.get(this.toKey(l));let S=!1;if(c){const i=c.type,o=l.type;c.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?S=!0:i===1&&o===2?(this.mapPathToChange.delete(this.toKey(l)),this.coalesced.delete(c)):i===2&&o===1?c.type=0:i===1&&o===0||(c.type=o)}else S=!0;S&&(this.coalesced.add(l),this.mapPathToChange.set(this.toKey(l),l))}coalesce(){const l=[],c=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(l.push(S),!1):!0).sort((S,i)=>S.resource.fsPath.length-i.resource.fsPath.length).filter(S=>c.some(i=>(0,R.isParent)(S.resource.fsPath,i,!A.isLinux))?!1:(c.push(S.resource.fsPath),!0)).concat(l)}}}),define(le[196],ue([0,1,15,38,7,3,2,50,32,12,46]),function(se,e,L,U,O,A,_,R,P,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends _.Disposable{constructor(h,u){super(),this.channel=h,this.extraCapabilities=u,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(h){return this.channel.call("stat",[h])}readdir(h){return this.channel.call("readdir",[h])}async readFile(h,u){const{buffer:y}=await this.channel.call("readFile",[h,u]);return y}readFileStream(h,u,y){const v=(0,R.newWriteableStream)(g=>L.VSBuffer.concat(g.map(l=>L.VSBuffer.wrap(l))).buffer),d=new _.DisposableStore;return d.add(this.channel.listen("readFileStream",[h,u])(g=>{if(g instanceof L.VSBuffer)v.write(g.buffer);else{if(g==="end")v.end();else{let l;if(g instanceof Error)l=g;else{const c=g;l=(0,f.createFileSystemProviderError)(c.message??(0,U.toErrorMessage)(c),c.code??f.FileSystemProviderErrorCode.Unknown)}v.error(l),v.end()}d.dispose()}})),d.add(y.onCancellationRequested(()=>{v.error((0,O.canceled)()),v.end(),d.dispose()})),v}writeFile(h,u,y){return this.channel.call("writeFile",[h,L.VSBuffer.wrap(u),y])}open(h,u){return this.channel.call("open",[h,u])}close(h){return this.channel.call("close",[h])}async read(h,u,y,v,d){const[g,l]=await this.channel.call("read",[h,u,d]);return y.set(g.buffer.slice(0,l),v),l}write(h,u,y,v,d){return this.channel.call("write",[h,u,L.VSBuffer.wrap(y),v,d])}mkdir(h){return this.channel.call("mkdir",[h])}delete(h,u){return this.channel.call("delete",[h,u])}rename(h,u,y){return this.channel.call("rename",[h,u,y])}copy(h,u,y){return this.channel.call("copy",[h,u,y])}cloneFile(h,u){return this.channel.call("cloneFile",[h,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(h=>{if(Array.isArray(h)){const u=h;this._onDidChange.fire((0,D.reviveFileChanges)(u))}else{const u=h;this._onDidWatchError.fire(u)}}))}watch(h,u){const y=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,y,h,u]),(0,_.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=w}),define(le[197],ue([0,1,40,2,46,3,8]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class R extends U.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new A.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new A.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new U.DisposableMap),this.suspendedWatchRequestPollingInterval=5007,this._register(this.onDidWatchFail(f=>this.handleDidWatchFail(f)))}handleDidWatchFail(f){this.isCorrelated(f)&&this.suspendWatchRequest(f)}isCorrelated(f){return(0,O.isWatchRequestWithCorrelation)(f)}async watch(f){this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const D of f)this.isCorrelated(D)?this.allCorrelatedWatchRequests.set(D.correlationId,D):this.allNonCorrelatedWatchRequests.add(D);for(const[D]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(D)||this.suspendedWatchRequests.deleteAndDispose(D);return this.updateWatchers()}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(f=>!this.suspendedWatchRequests.has(f.correlationId))])}suspendWatchRequest(f){if(this.suspendedWatchRequests.has(f.correlationId))return;const D=new U.DisposableStore;this.suspendedWatchRequests.set(f.correlationId,D),this.monitorSuspendedWatchRequest(f,D),this.updateWatchers()}resumeWatchRequest(f){this.suspendedWatchRequests.deleteAndDispose(f.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(f,D){const w=_.URI.file(f.path),m=this;let h=!1;const u=(y,v)=>{if(D.isDisposed)return;const d=this.isPathNotFound(y),g=this.isPathNotFound(v),l=h;if(h=d,!d&&(g||l)){this.trace(`fs.watchFile() detected ${f.path} exists again, resuming watcher (correlationId: ${f.correlationId})`);const c={resource:w,type:1,cId:f.correlationId};m._onDidChangeFile.fire([c]),this.traceEvent(c,f),this.resumeWatchRequest(f)}};this.trace(`starting fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,L.watchFile)(f.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},u)}catch(y){this.warn(`fs.watchFile() failed with error ${y} on path ${f.path} (correlationId: ${f.correlationId})`)}D.add((0,U.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${f.path} (correlationId: ${f.correlationId})`);try{(0,L.unwatchFile)(f.path,u)}catch(y){this.warn(`fs.unwatchFile() failed with error ${y} on path ${f.path} (correlationId: ${f.correlationId})`)}}))}isPathNotFound(f){return f.ctimeMs===0&&f.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll()}traceEvent(f,D){const w=` >> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`;this.trace(typeof D.correlationId=="number"?`${w} (correlationId: ${D.correlationId})`:w)}requestToString(f){return`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`}}e.BaseWatcher=R}),define(le[198],ue([0,1,40,6,26,44,2,87,14,5,20,8,148,31,46]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=v;class y extends _.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(g,l,c,S,i){super(),this.request=g,this.onDidFilesChange=l,this.onDidWatchFail=c,this.onLogMessage=S,this.verboseLogging=i,this.throttledFileChangesEmitter=this._register(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.onDidFilesChange(o))),this.fileChangesAggregator=this._register(new U.RunOnceWorker(o=>this.handleFileChanges(o),y.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,u.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,u.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new O.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const l=await h.Promises.stat(g);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(g,l.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${g})`),this.onDidWatchFail?.()}}async normalizePath(g){let l=g.path;try{l=await h.Promises.realpath(g.path),g.path===l&&(l=await(0,m.realcase)(g.path,this.cts.token)??g.path),g.path!==l&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${l})`)}catch{}return l}async doWatch(g,l){if(f.isMacintosh&&(0,A.isEqualOrParent)(g,"/Volumes/",!0))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const c=new O.CancellationTokenSource(this.cts.token),S=new _.DisposableStore;try{const i=w.URI.file(this.request.path),o=(0,P.basename)(g),n=(0,L.watch)(g);S.add((0,_.toDisposable)(()=>{n.removeAllListeners(),n.close()})),this.trace(`Started watching: '${g}'`);const s=new Set;if(l)try{for(const r of await h.Promises.readdir(g))s.add(r)}catch(r){this.error(r)}const t=new Map;S.add((0,_.toDisposable)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${r}, ${a})`),this.onDidWatchFail?.()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${r}"] ${a}`);let E="";if(a&&(E=a.toString(),f.isMacintosh&&(E=(0,R.normalizeNFC)(E))),!(!E||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){t.get(E)?.dispose();const C=setTimeout(async()=>{if(t.delete(E),E===o&&!await h.Promises.exists(g)){this.onWatchedPathDeleted(i);return}const b=await this.existsChildStrictCase((0,P.join)(g,E));if(c.token.isCancellationRequested)return;let I;b?s.has(E)?I=0:(I=1,s.add(E)):(s.delete(E),I=2),this.onFileChange({resource:(0,D.joinPath)(i,E),type:I,cId:this.request.correlationId})},y.FILE_DELETE_HANDLER_DELAY);t.set(E,(0,_.toDisposable)(()=>clearTimeout(C)))}else{let C;s.has(E)?C=0:(C=1,s.add(E)),this.onFileChange({resource:(0,D.joinPath)(i,E),type:C,cId:this.request.correlationId})}else if(r==="rename"||E!==o){const C=setTimeout(async()=>{const b=await h.Promises.exists(g);c.token.isCancellationRequested||(b?(this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0),S.add(await this.doWatch(g,!1))):this.onWatchedPathDeleted(i))},y.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,_.toDisposable)(()=>clearTimeout(C)))}else this.onFileChange({resource:i,type:0,cId:this.request.correlationId},!0)})}catch(i){c.token.isCancellationRequested||this.error(`Failed to watch ${g} for changes using fs.watch() (${i.toString()})`),this.onDidWatchFail?.()}return(0,_.toDisposable)(()=>{c.dispose(!0),S.dispose()})}onWatchedPathDeleted(g){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:g,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.onDidWatchFail?.()}onFileChange(g,l=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!l&&this.excludes.some(c=>c(g.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${g.resource.fsPath}`):!l&&this.includes&&this.includes.length>0&&!this.includes.some(c=>c(g.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${g.resource.fsPath}`):this.fileChangesAggregator.work(g))}handleFileChanges(g){const l=(0,u.coalesceEvents)(g);if(l.length>0){if(this.verboseLogging)for(const S of l)this.trace(` >> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`);this.throttledFileChangesEmitter.work(l)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(g){if(f.isLinux)return h.Promises.exists(g);try{const l=(0,P.basename)(g);return(await h.Promises.readdir((0,P.dirname)(g))).some(S=>S===l)}catch(l){return this.trace(l),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y;async function v(d,g,l,c,S=512){const i=await h.Promises.open(d,"r"),o=Buffer.allocUnsafe(S),n=new O.CancellationTokenSource(c);let s,t=!1;const r={path:d,excludes:[],recursive:!1},a=new y(r,E=>{(async()=>{for(const{type:C}of E)if(C===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:b}=await h.Promises.read(i,o,0,S,null);if(!b||n.token.isCancellationRequested)break;g(o.slice(0,b))}}catch(b){s=new Error(b),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,l(),new Promise((E,C)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(i)}catch(b){s=new Error(b)}s?C(s):E()})})}}),define(le[199],ue([0,1,3,90,197,5,198,44]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends O.BaseWatcher{constructor(){super(...arguments),this.onDidError=L.Event.None,this.watchers=new Set,this.verboseLogging=!1}async doWatch(D){D=this.removeDuplicateRequests(D);const w=[],m=new Set(Array.from(this.watchers));for(const h of D){const u=this.findWatcher(h);u&&(0,U.patternsEquals)(u.request.excludes,h.excludes)&&(0,U.patternsEquals)(u.request.includes,h.includes)?m.delete(u):w.push(h)}w.length&&this.trace(`Request to start watching: ${w.map(h=>this.requestToString(h)).join(",")}`),m.size&&this.trace(`Request to stop watching: ${Array.from(m).map(h=>this.requestToString(h.request)).join(",")}`);for(const h of m)this.stopWatching(h);for(const h of w)this.startWatching(h)}findWatcher(D){for(const w of this.watchers)if(typeof D.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===D.correlationId)return w}else if((0,R.isEqual)(w.request.path,D.path,!A.isLinux))return w}startWatching(D){const w=new _.NodeJSFileWatcherLibrary(D,h=>this._onDidChangeFile.fire(h),()=>this._onDidWatchFail.fire(D),h=>this._onDidLogMessage.fire(h),this.verboseLogging),m={request:D,instance:w};this.watchers.add(m)}async stop(){await super.stop();for(const D of this.watchers)this.stopWatching(D)}stopWatching(D){this.trace("stopping file watcher",D),this.watchers.delete(D),D.instance.dispose()}removeDuplicateRequests(D){const w=new Map;for(const m of D){const h=A.isLinux?m.path:m.path.toLowerCase();let u=w.get(m.correlationId);u||(u=new Map,w.set(m.correlationId,u)),u.has(h)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(m)}`),u.set(h,m)}return Array.from(w.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(D){this.verboseLogging=D;for(const w of this.watchers)w.instance.setVerboseLogging(D)}trace(D,w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(D,w)})}warn(D){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(D)})}toMessage(D,w){return w?`[File Watcher (node.js)] ${D} (${this.requestToString(w.request)})`:`[File Watcher (node.js)] ${D}`}}e.NodeJSWatcher=P}),define(le[200],ue([0,1,46,199]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class O extends L.AbstractNonRecursiveWatcherClient{constructor(_,R,P){super(_,R,P),this.init()}createWatcher(_){return _.add(new U.NodeJSWatcher)}}e.NodeJSWatcherClient=O}),define(le[201],ue([0,1,23,41,92,46]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class _ extends A.AbstractUniversalWatcherClient{constructor(P,f,D){super(P,f,D),this.init()}createWatcher(P){const f=P.add(new O.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(f.onDidProcessExit(({code:D,signal:w})=>this.onError(`terminated by itself with code ${D}, signal: ${w}`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(f.getChannel("watcher")))}}e.UniversalWatcherClient=_}),define(le[74],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...O){this._entries=new Map;for(const[A,_]of O)this.set(A,_)}set(O,A){const _=this._entries.get(O);return this._entries.set(O,A),_}has(O){return this._entries.has(O)}get(O){return this._entries.get(O)}}e.ServiceCollection=L}),define(le[202],ue([0,1,6,7,2,72,192,4,74,86]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class w extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class m{constructor(v=new P.ServiceCollection,d=!1,g,l=D){this._services=v,this._strict=d,this._parent=g,this._enableTracing=l,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=l?g?._globalGraph??new _.Graph(c=>c):void 0}createChild(v){return new m(v,this._strict,this,this._enableTracing)}invokeFunction(v,...d){const g=u.traceInvocation(this._enableTracing,v);let l=!1;try{return v({get:S=>{if(l)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(S,g);if(!i)throw new Error(`[invokeFunction] unknown service '${S}'`);return i}},...d)}finally{l=!0,g.stop()}}createInstance(v,...d){let g,l;return v instanceof A.SyncDescriptor?(g=u.traceCreation(this._enableTracing,v.ctor),l=this._createInstance(v.ctor,v.staticArguments.concat(d),g)):(g=u.traceCreation(this._enableTracing,v),l=this._createInstance(v,d,g)),g.stop(),l}_createInstance(v,d=[],g){const l=R._util.getServiceDependencies(v).sort((i,o)=>i.index-o.index),c=[];for(const i of l){const o=this._getOrCreateServiceInstance(i.id,g);o||this._throwIfStrict(`[createInstance] ${v.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const S=l.length>0?l[0].index:d.length;if(d.length!==S){console.trace(`[createInstance] First service dependency of ${v.name} at position ${S+1} conflicts with ${d.length} static arguments`);const i=S-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,S)}return Reflect.construct(v,d.concat(c))}_setServiceInstance(v,d){if(this._services.get(v)instanceof A.SyncDescriptor)this._services.set(v,d);else if(this._parent)this._parent._setServiceInstance(v,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){const d=this._services.get(v);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):d}_getOrCreateServiceInstance(v,d){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(v));const g=this._getServiceInstanceOrDescriptor(v);return g instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,g,d.branch(v,!0)):(d.branch(v,!1),g)}_safeCreateAndCacheServiceInstance(v,d,g){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,d,g)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,d,g){const l=new _.Graph(i=>i.id.toString());let c=0;const S=[{id:v,desc:d,_trace:g}];for(;S.length;){const i=S.pop();if(l.lookupOrInsertNode(i),c++>1e3)throw new w(l);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(o.id);if(n||this._throwIfStrict(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.SyncDescriptor){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};l.insertEdge(i,s),S.push(s)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new w(l);break}for(const{data:o}of i){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}l.removeNode(o)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,d,g=[],l,c){if(this._services.get(v)instanceof A.SyncDescriptor)return this._createServiceInstance(v,d,g,l,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,d,g,l,c);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(v,d,g=[],l,c){if(l){const S=new m(void 0,this._strict,this,this._enableTracing);S._globalGraphImplicitDependency=String(v);const i=new Map,o=new L.GlobalIdleValue(()=>{const n=S._createInstance(d,g,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new f.LinkedList,i.set(s,a)),(C,b,I)=>{if(o.isInitialized)return o.value[s](C,b,I);{const p={listener:[C,b,I],disposable:void 0},k=a.push(p);return(0,O.toDisposable)(()=>{k(),p.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return d.prototype}})}else return this._createInstance(d,g,c)}_throwIfStrict(v,d){if(d&&console.warn(v),this._strict)throw new Error(v)}}e.InstantiationService=m;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class u{static{this.all=new Set}static{this._None=new class extends u{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(v,d){return v?new u(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u._None}static traceCreation(v,d){return v?new u(1,d.name):u._None}static{this._totals=0}constructor(v,d){this.type=v,this.name=d,this._start=Date.now(),this._dep=[]}branch(v,d){const g=new u(3,v.toString());return this._dep.push([v,d,g]),g}stop(){const v=Date.now()-this._start;u._totals+=v;let d=!1;function g(c,S){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of S._dep)if(s&&t){d=!0,i.push(`${o}CREATES -> ${n}`);const r=g(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(v>2||d)&&u.all.add(l.join(`
`))}}e.Trace=u}),define(le[56],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class U{constructor(A,_){this.server=A,this.router=_}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,_){this.server.registerChannel(A,_)}}e.MainProcessService=U}),define(le[75],ue([0,1,26,2,5,167,29,4]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=P;function P(D){return D.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let f=class extends U.Disposable{constructor(w){super(),this.extensionGalleryService=w}async getAvailableLanguages(){const w=new L.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let m;try{m=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const u=m.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(v=>v.startsWith("lp-"))).map(y=>{const v=y.properties.localizedLanguages?.[0],d=P(y);return{...this.createQuickPickItem(d,v,y),extensionId:y.identifier.id,galleryExtension:y}});return u.push(this.createQuickPickItem("en","English")),u}createQuickPickItem(w,m,h){const u=m??w;let y;if(u!==w&&(y=`(${w})`),w.toLowerCase()===O.language.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),h?.installCount){y??="";const v=h.installCount;let d;v>1e6?d=`${Math.floor(v/1e5)/10}M`:v>1e3?d=`${Math.floor(v/1e3)}K`:d=String(v),y+=` $(cloud-download) ${d}`}return{id:w,label:u,description:y}}};e.LanguagePackBaseService=f,e.LanguagePackBaseService=f=we([K(0,_.IExtensionGalleryService)],f)}),define(le[203],ue([0,1,2,75]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let O=class extends L.Disposable{constructor(_){super(),this.localizationsService=_,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=O,e.LocalizationsUpdater=O=we([K(0,U.ILanguagePackService)],O)}),define(le[9],ue([0,1,168,38,3,54,2,35,5,20,13,8,93,4]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=y,e.log=d,e.getLogLevel=a,e.LogLevelToString=E,e.LogLevelToLocalizedString=C,e.parseLogLevel=b,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function u(){return new Date().toISOString()}function y(I){return(0,D.isNumber)(I)}var v;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function d(I,p,k){switch(p){case v.Trace:I.trace(k);break;case v.Debug:I.debug(k);break;case v.Info:I.info(k);break;case v.Warning:I.warn(k);break;case v.Error:I.error(k);break;case v.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function g(I,p=!1){let k="";for(let N=0;N<I.length;N++){let F=I[N];if(F instanceof Error&&(F=(0,U.toErrorMessage)(F,p)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(N>0?" ":"")+F}return k}class l extends _.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(p){this.level!==p&&(this.level=p,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(p){return this.level!==v.Off&&this.level<=p}}e.AbstractLogger=l;class c extends l{constructor(p){super(),this.logAlways=p}checkLogLevel(p){return this.logAlways||super.checkLogLevel(p)}trace(p,...k){this.checkLogLevel(v.Trace)&&this.log(v.Trace,g([p,...k],!0))}debug(p,...k){this.checkLogLevel(v.Debug)&&this.log(v.Debug,g([p,...k]))}info(p,...k){this.checkLogLevel(v.Info)&&this.log(v.Info,g([p,...k]))}warn(p,...k){this.checkLogLevel(v.Warning)&&this.log(v.Warning,g([p,...k]))}error(p,...k){if(this.checkLogLevel(v.Error))if(p instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=p.stack,this.log(v.Error,g(N))}else this.log(v.Error,g([p,...k]))}flush(){}}e.AbstractMessageLogger=c;class S extends l{constructor(p=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(p),this.useColors=!P.isWindows}trace(p,...k){this.checkLogLevel(v.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,p,...k):console.log(`[main ${u()}]`,p,...k))}debug(p,...k){this.checkLogLevel(v.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,p,...k):console.log(`[main ${u()}]`,p,...k))}info(p,...k){this.checkLogLevel(v.Info)&&(this.useColors?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,p,...k):console.log(`[main ${u()}]`,p,...k))}warn(p,...k){this.checkLogLevel(v.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,p,...k):console.warn(`[main ${u()}]`,p,...k))}error(p,...k){this.checkLogLevel(v.Error)&&(this.useColors?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,p,...k):console.error(`[main ${u()}]`,p,...k))}flush(){}}e.ConsoleMainLogger=S;class i extends l{constructor(p=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(p)}trace(p,...k){this.checkLogLevel(v.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",p,...k):console.log(p,...k))}debug(p,...k){this.checkLogLevel(v.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",p,...k):console.log(p,...k))}info(p,...k){this.checkLogLevel(v.Info)&&(this.useColors?console.log("%c INFO","color: #33f",p,...k):console.log(p,...k))}warn(p,...k){this.checkLogLevel(v.Warning)&&(this.useColors?console.log("%c WARN","color: #993",p,...k):console.log(p,...k))}error(p,...k){this.checkLogLevel(v.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",p,...k):console.error(p,...k))}flush(){}}e.ConsoleLogger=i;class o extends l{constructor(p,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=p,this.setLevel(k)}trace(p,...k){this.checkLogLevel(v.Trace)&&this.adapter.log(v.Trace,[this.extractMessage(p),...k])}debug(p,...k){this.checkLogLevel(v.Debug)&&this.adapter.log(v.Debug,[this.extractMessage(p),...k])}info(p,...k){this.checkLogLevel(v.Info)&&this.adapter.log(v.Info,[this.extractMessage(p),...k])}warn(p,...k){this.checkLogLevel(v.Warning)&&this.adapter.log(v.Warning,[this.extractMessage(p),...k])}error(p,...k){this.checkLogLevel(v.Error)&&this.adapter.log(v.Error,[this.extractMessage(p),...k])}extractMessage(p){return typeof p=="string"?p:(0,U.toErrorMessage)(p,this.checkLogLevel(v.Trace))}flush(){}}e.AdapterLogger=o;class n extends l{constructor(p){super(),this.loggers=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const k of this.loggers)k.setLevel(p);super.setLevel(p)}trace(p,...k){for(const N of this.loggers)N.trace(p,...k)}debug(p,...k){for(const N of this.loggers)N.debug(p,...k)}info(p,...k){for(const N of this.loggers)N.info(p,...k)}warn(p,...k){for(const N of this.loggers)N.warn(p,...k)}error(p,...k){for(const N of this.loggers)N.error(p,...k)}flush(){for(const p of this.loggers)p.flush()}dispose(){for(const p of this.loggers)p.dispose();super.dispose()}}e.MultiplexLogger=n;class s extends _.Disposable{constructor(p,k,N){if(super(),this.logLevel=p,this.logsHome=k,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new O.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new O.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,N)for(const F of N)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(p){return(0,D.isString)(p)?[...this._loggers.values()].find(k=>k.info.id===p):this._loggers.get(p)}getLogger(p){return this.getLoggerEntry(p)?.logger}createLogger(p,k){const N=this.toResource(p),F=(0,D.isString)(p)?p:k?.id??(0,A.hash)(N.toString()).toString(16);let x=this._loggers.get(N)?.logger;const Z=k?.logLevel==="always"?v.Trace:k?.logLevel;x||(x=this.doCreateLogger(N,Z??this.getLogLevel(N)??this.logLevel,{...k,id:F}));const B={logger:x,info:{resource:N,id:F,logLevel:Z,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(B.info),this._loggers.set(N,B),x}toResource(p){return(0,D.isString)(p)?(0,f.joinPath)(this.logsHome,`${p}.log`):p}setLogLevel(p,k){if(w.URI.isUri(p)){const N=p,F=k,x=this._loggers.get(N);x&&F!==x.info.logLevel&&(x.info.logLevel=F===this.logLevel?void 0:F,x.logger?.setLevel(F),this._loggers.set(x.info.resource,x),this._onDidChangeLogLevel.fire([N,F]))}else{this.logLevel=p;for(const[N,F]of this._loggers.entries())this._loggers.get(N)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(p,k){const N=this.getLoggerEntry(p);N&&k!==!N.info.hidden&&(N.info.hidden=!k,this._loggers.set(N.info.resource,N),this._onDidChangeVisibility.fire([N.info.resource,k]))}getLogLevel(p){let k;return p&&(k=this._loggers.get(p)?.info.logLevel),k??this.logLevel}registerLogger(p){const k=this._loggers.get(p.resource);k?k.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this._loggers.set(p.resource,{info:p,logger:void 0}),this._onDidChangeLoggers.fire({added:[p],removed:[]}))}deregisterLogger(p){const k=this._loggers.get(p);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(p),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const p of this._loggers.values())yield p.info}getRegisteredLogger(p){return this._loggers.get(p)?.info}dispose(){this._loggers.forEach(p=>p.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class t{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(p){}getLevel(){return v.Info}trace(p,...k){}debug(p,...k){}info(p,...k){}warn(p,...k){}error(p,...k){}critical(p,...k){}dispose(){}flush(){}}e.NullLogger=t;class r extends t{}e.NullLogService=r;function a(I){if(I.verbose)return v.Trace;if(typeof I.logLevel=="string"){const p=b(I.logLevel.toLowerCase());if(p!==void 0)return p}return e.DEFAULT_LOG_LEVEL}function E(I){switch(I){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function C(I){switch(I){case v.Trace:return{original:"Trace",value:L.localize(0,null)};case v.Debug:return{original:"Debug",value:L.localize(1,null)};case v.Info:return{original:"Info",value:L.localize(2,null)};case v.Warning:return{original:"Warning",value:L.localize(3,null)};case v.Error:return{original:"Error",value:L.localize(4,null)};case v.Off:return{original:"Off",value:L.localize(5,null)}}}function b(I){switch(I){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",E(v.Info))}),define(le[204],ue([0,1,6,7,2,23,14,20,31,16,9]),function(se,e,L,U,O,A,_,R,P,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends O.Disposable{constructor(h,u){super(),this.environmentService=h,this.logService=u,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.basename)(this.environmentService.logsHome),u=(0,R.dirname)(this.environmentService.logsHome.with({scheme:A.Schemas.file})).fsPath,d=(await P.Promises.readdir(u)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==h),g=d.slice(0,Math.max(0,d.length-9));g.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${g.join(", ")}'`),await Promise.all(g.map(l=>P.Promises.rm((0,_.join)(u,l)))))}catch(h){(0,U.onUnexpectedError)(h)}}};e.LogsDataCleaner=w,e.LogsDataCleaner=w=we([K(0,f.IEnvironmentService),K(1,D.ILogService)],w)}),define(le[205],ue([0,1,17,6,7,3,2,14,46,9]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends _.Disposable{constructor(m,h){super(),this.logService=m,this.options=h,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new U.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new U.ThrottledDelayer(0))}watch(m,h){return h.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,h):this.watchNonRecursive(m,h)}watchUniversal(m,h){const u={path:this.toFilePath(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},y=(0,L.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,_.toDisposable)(()=>{y(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,O.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(h=>this._onDidChangeFile.fire((0,P.reviveFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(h)&&m.includes(h.path)&&(h.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,h){const u={path:this.toFilePath(m),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},y=(0,L.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,_.toDisposable)(()=>{y(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,O.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,P.reviveFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,R.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(le[206],ue([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends f.Disposable{static{c=this}constructor(o){super(),this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new _.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new _.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new _.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new _.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new _.Emitter),this._onDidUncorrelatedFilesChange=this._register(new _.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new U.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new f.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new v.FileChangesEvent(t,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(r),r.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,f.dispose)(s)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(s){n.push(s)}}),!this.provider.has(o)&&await U.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const s=this.provider.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new v.FileOperationError((0,y.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const s=new l.ErrorNoTelemetry;throw s.message=(0,y.localize)(1,null,o.toString()),s}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)||(0,v.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(s){throw(0,v.toFileSystemProviderErrorCode)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,y.localize)(2,null,this.resourceForError(o)),1):(0,v.ensureFileSystemProviderError)(s)}}async doResolveFile(o,n){const s=await this.withProvider(o),t=this.isPathCaseSensitive(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,E=n?.resolveMetadata,C=await s.stat(o);let b;return this.toFileStat(s,o,C,void 0,!!E,(I,p)=>(b||(b=D.TernarySearchTree.forUris(()=>!t),b.set(o,!0),r&&b.fill(!0,r)),b.get(I.resource)||b.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&a?p===1:!1))}async toFileStat(o,n,s,t,r,a){const{providerExtUri:E}=this.getExtUri(o),C={resource:n,name:E.basename(n),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(C.isDirectory&&a(C,t)){try{const b=await o.readdir(n),I=await U.Promises.settled(b.map(async([p,k])=>{try{const N=E.joinPath(n,p),F=r?await o.stat(N):{type:k};return await this.toFileStat(o,N,F,b.length,r,a)}catch(N){return this.logService.trace(N),null}}));C.children=(0,L.coalesce)(I)}catch(b){this.logService.trace(b),C.children=[]}return C}return C}async resolveAll(o){return U.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.withProvider(o),s=await n.stat(o);return this.toFileStat(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(s){return s}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new v.FileOperationError((0,y.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=O.VSBuffer.fromString(""),s){await this.doValidateCreateFile(o,s);const t=await this.writeFile(o,n);return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,t)),t}async writeFile(o,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(t);let a=s;if((0,v.hasFileAtomicWriteCapability)(t)&&!a?.atomic){const E=t.enforceAtomicWriteFile?.(o);E&&(a={...s,atomic:E})}try{await this.validateWriteFile(t,o,a)||await this.mkdirp(t,r.dirname(o));let C;if((0,v.hasReadWriteCapability)(t)&&!(n instanceof O.VSBuffer))if((0,u.isReadableStream)(n)){const b=await(0,u.peekStream)(n,3);b.ended?C=O.VSBuffer.concat(b.buffer):C=b}else C=(0,u.peekReadable)(n,b=>O.VSBuffer.concat(b),3);else C=n;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&C instanceof O.VSBuffer||(0,v.hasReadWriteCapability)(t)&&(0,v.hasFileAtomicWriteCapability)(t)&&a?.atomic?await this.doWriteUnbuffered(t,o,a,C):await this.doWriteBuffered(t,o,a,C instanceof O.VSBuffer?(0,O.bufferToReadable)(C):C),this._onDidRunOperation.fire(new v.FileOperationEvent(o,4))}catch(E){throw new v.FileOperationError((0,y.localize)(4,null,this.resourceForError(o),(0,v.ensureFileSystemProviderError)(E).toString()),(0,v.toFileOperationResult)(E),a)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.resourceForError(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.resourceForError(n)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.resourceForError(n)));if(t)throw new Error((0,y.localize)(8,null,this.resourceForError(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&v.FileType.Directory)throw new v.FileOperationError((0,y.localize)(9,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,v.etag)({mtime:s.mtime,size:a.size}))throw new v.FileOperationError((0,y.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(t,o,n,s):this.doReadFile(t,o,n,s)}async doReadFileAtomic(o,n,s,t){return new Promise((r,a)=>{this.writeQueue.queueFor(n,async()=>{try{const E=await this.doReadFile(o,n,s,t);r(E)}catch(E){a(E)}},this.getExtUri(o).providerExtUri)})}async doReadFile(o,n,s,t){const r=await this.doReadFileStream(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,O.streamToBuffer)(r.value)}}async readFileStream(o,n,s){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,n,s)}async doReadFileStream(o,n,s,t){const r=new A.CancellationTokenSource(t);let a=s;(0,v.hasFileAtomicReadCapability)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const E=this.validateReadFile(n,a).then(b=>b,b=>{throw r.dispose(!0),b});let C;try{return typeof a?.etag=="string"&&a.etag!==v.ETAG_DISABLED&&await E,a?.atomic&&(0,v.hasFileAtomicReadCapability)(o)||!((0,v.hasOpenReadWriteCloseCapability)(o)||(0,v.hasFileReadStreamCapability)(o))||(0,v.hasReadWriteCapability)(o)&&a?.preferUnbuffered?C=this.readFileUnbuffered(o,n,a):(0,v.hasFileReadStreamCapability)(o)?C=this.readFileStreamed(o,n,r.token,a):C=this.readFileBuffered(o,n,r.token,a),C.on("end",()=>r.dispose()),C.on("error",()=>r.dispose()),{...await E,value:C}}catch(b){throw C&&await(0,u.consumeStream)(C),this.restoreReadError(b,n,a)}}restoreReadError(o,n,s){const t=(0,y.localize)(11,null,this.resourceForError(n),(0,v.ensureFileSystemProviderError)(o).toString());return o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(t,o.stat,s):o instanceof v.TooLargeFileOperationError?new v.TooLargeFileOperationError(t,o.fileOperationResult,o.size,o.options):new v.FileOperationError(t,(0,v.toFileOperationResult)(o),s)}readFileStreamed(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,u.transform)(r,{data:a=>a instanceof O.VSBuffer?a:O.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,n,t)},a=>O.VSBuffer.concat(a))}readFileBuffered(o,n,s,t=Object.create(null)){const r=(0,O.newWriteableBufferStream)();return(0,d.readFileIntoStream)(o,n,r,a=>a,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,n,t)},s),r}readFileUnbuffered(o,n,s){const t=(0,u.newWriteableStream)(r=>O.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,v.hasFileAtomicReadCapability)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(n,r.byteLength,s),t.end(O.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new v.FileOperationError((0,y.localize)(12,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&n.etag===s.etag)throw new v.NotModifiedSinceFileOperationError((0,y.localize)(13,null),s,n);return this.validateReadFileLimits(o,s.size,n),s}validateReadFileLimits(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new v.TooLargeFileOperationError((0,y.localize)(14,null,this.resourceForError(o)),7,n,s)}async canMove(o,n,s){return this.doCanMoveCopy(o,n,"move",s)}async canCopy(o,n,s){return this.doCanMoveCopy(o,n,"copy",s)}async doCanMoveCopy(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"move",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,a==="move"?2:3,E)),E}async copy(o,n,s){const t=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(t,o,r,n,"copy",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,a==="copy"?3:2,E)),E}async doMoveCopy(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:C}=await this.doValidateMoveCopy(o,n,s,t,r,a);if(E&&!C&&a&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,v.hasFileFolderCopyCapability)(o))await o.copy(n,t,{overwrite:a});else{const b=await this.resolve(n);b.isDirectory?await this.doCopyFolder(o,b,s,t):await this.doCopyFile(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.doMoveCopy(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,s,t){if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(o,n,s,t);if((0,v.hasOpenReadWriteCloseCapability)(o)&&(0,v.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(o,n,s,t);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(o,n,s,t);if((0,v.hasReadWriteCapability)(o)&&(0,v.hasReadWriteCapability)(s))return this.doPipeUnbuffered(o,n,s,t)}async doCopyFolder(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await U.Promises.settled(n.children.map(async r=>{const a=this.getExtUri(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),s,a):this.doCopyFile(o,r.resource,s,a)}))}async doValidateMoveCopy(o,n,s,t,r,a){let E=!1;if(o===s){const{providerExtUri:b,isPathCaseSensitive:I}=this.getExtUri(o);if(I||(E=b.isEqual(n,t)),E&&r==="copy")throw new Error((0,y.localize)(15,null,this.resourceForError(n),this.resourceForError(t)));if(!E&&b.isEqualOrParent(t,n))throw new Error((0,y.localize)(16,null,this.resourceForError(n),this.resourceForError(t)))}const C=await this.exists(t);if(C&&!E){if(!a)throw new v.FileOperationError((0,y.localize)(17,null,this.resourceForError(n),this.resourceForError(t)),4);if(o===s){const{providerExtUri:b}=this.getExtUri(o);if(b.isEqualOrParent(n,t))throw new Error((0,y.localize)(18,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:C,isSameResourceWithDifferentPathCase:E}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(o,0,s)),s}async mkdirp(o,n){const s=[],{providerExtUri:t}=this.getExtUri(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&v.FileType.Directory))throw new Error((0,y.localize)(19,null,this.resourceForError(n)));break}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(s){return s}return!0}async doValidateDelete(o,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,y.localize)(20,null,this.resourceForError(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,y.localize)(21,null,this.resourceForError(o)));if(t&&r)throw new Error((0,y.localize)(22,null,this.resourceForError(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.throwIfFileIsReadonly(o,a);else throw new v.FileOperationError((0,y.localize)(23,null,this.resourceForError(o)),1);if(!!!n?.recursive){const C=await this.resolve(o);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,y.localize)(24,null,this.resourceForError(o)))}return s}async del(o,n){const s=await this.doValidateDelete(o,n);let t=n;if((0,v.hasFileAtomicDeleteCapability)(s)&&!t?.atomic){const C=s.enforceAtomicDelete?.(o);C&&(t={...n,atomic:C})}const r=!!t?.useTrash,a=!!t?.recursive,E=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:E}),this._onDidRunOperation.fire(new v.FileOperationEvent(o,1))}async cloneFile(o,n){const s=await this.withProvider(o),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(s===t&&this.getExtUri(s).providerExtUri.isEqual(o,n)))return s===t&&(0,v.hasFileCloneCapability)(s)?s.cloneFile(o,n):(await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n)),s===t&&(0,v.hasFileFolderCopyCapability)(s)?this.writeQueue.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.getExtUri(s).providerExtUri):this.writeQueue.queueFor(o,()=>this.doCopyFile(s,o,t,n),this.getExtUri(s).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.WATCHER_CORRELATION_IDS++})}watch(o,n={recursive:!1,excludes:[]}){const s=new f.DisposableStore;let t=!1,r=()=>{t=!0};s.add((0,f.toDisposable)(()=>r())),(async()=>{try{const E=await this.doWatch(o,n);t?(0,f.dispose)(E):r=()=>(0,f.dispose)(E)}catch(E){this.logService.error(E)}})();const a=n.correlationId;if(typeof a=="number"){const E=s.add(new _.Emitter);return s.add(this.internalOnDidFilesChange.event(b=>{b.correlates(a)&&E.fire(b)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async doWatch(o,n){const s=await this.withProvider(o),t=(0,R.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(o),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,f.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,s,t){return this.writeQueue.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,u.isReadableStream)(t)||(0,u.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(o,r,t):await this.doWriteReadableBufferedQueued(o,r,t)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await o.close(r)}},this.getExtUri(o).providerExtUri)}async doWriteStreamBufferedQueued(o,n,s){let t=0,r;if((0,u.isReadableBufferedStream)(s)){if(s.buffer.length>0){const a=O.VSBuffer.concat(s.buffer);await this.doWriteBuffer(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,E)=>{(0,u.listenStream)(r,{onData:async C=>{r.pause();try{await this.doWriteBuffer(o,n,C,C.byteLength,t,0)}catch(b){return E(b)}t+=C.byteLength,setTimeout(()=>r.resume())},onError:C=>E(C),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(o,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(o,n,s,t,r,a){let E=0;for(;E<t;){const C=await o.write(n,r+E,s.buffer,a+E,t-E);E+=C}}async doWriteUnbuffered(o,n,s,t){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(o,n,s,t),this.getExtUri(o).providerExtUri)}async doWriteUnbufferedQueued(o,n,s,t){let r;t instanceof O.VSBuffer?r=t:(0,u.isReadableStream)(t)?r=await(0,O.streamToBuffer)(t):(0,u.isReadableBufferedStream)(t)?r=await(0,O.bufferedStreamToBuffer)(t):r=(0,O.readableToBuffer)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeBufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeBufferedQueued(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const E=O.VSBuffer.alloc(this.BUFFER_SIZE);let C=0,b=0,I=0;do I=await o.read(r,C,E.buffer,b,E.byteLength-b),await this.doWriteBuffer(s,a,E,I,C,b),C+=I,b+=I,b===E.byteLength&&(b=0);while(I>0)}catch(E){throw(0,v.ensureFileSystemProviderError)(E)}finally{await U.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeUnbufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedQueued(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(o,n,s,t){return this.writeQueue.queueFor(t,()=>this.doPipeUnbufferedToBufferedQueued(o,n,s,t),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedToBufferedQueued(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.doWriteBuffer(s,r,O.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,v.ensureFileSystemProviderError)(a)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(o,n,s,t){const r=await(0,O.streamToBuffer)(this.readFileBuffered(o,n,A.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,r)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new v.FileOperationError((0,y.localize)(25,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,y.localize)(26,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};e.FileService=S,e.FileService=S=c=we([K(0,g.ILogService)],S)}),define(le[207],ue([0,1,40,277,6,35,15,3,44,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(o)}`)}})();class i extends g.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(t=>m.extUriBiasedIgnorePathCase.getComparisonKey(t)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:t}=await u.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:v.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await u.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(n,r.name))).type:a=this.toType(r),t.push([r.name,a])}catch(a){this.logService.trace(a)}})),t}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let t;return s?.dangling?t=v.FileType.Unknown:n.isFile()?t=v.FileType.File:n.isDirectory()?t=v.FileType.Directory:t=v.FileType.Unknown,s&&(t|=v.FileType.SymbolicLink),t}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new O.Barrier;return this.resourceLocks.set(n,r),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,f.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===r&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),t=await this.createResourceLock(n));const r=this.toFilePath(n);return await u.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{t?.dispose()}}traceLock(n){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,t){const r=(0,h.newWriteableStream)(a=>_.VSBuffer.concat(a.map(E=>_.VSBuffer.wrap(E))).buffer);return(0,d.readFileIntoStream)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,m.joinPath)((0,m.dirname)(n),`${(0,m.basename)(n)}${t.atomic.postfix}`),s,t):this.doWriteFile(n,s,t)}async canWriteFileAtomic(n){try{const s=this.toFilePath(n),{symbolicLink:t}=await u.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async doWriteFileAtomic(n,s,t,r){const a=new f.DisposableStore;try{a.add(await this.createResourceLock(n)),a.add(await this.createResourceLock(s)),await this.doWriteFile(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(E){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{a.dispose()}}async doWriteFile(n,s,t,r){let a;try{const E=this.toFilePath(n);if(!t.create||!t.overwrite){if(await u.Promises.exists(E)){if(!t.overwrite)throw(0,v.createFileSystemProviderError)((0,y.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,v.createFileSystemProviderError)((0,y.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(n,E)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(n){i.canFlush=n}async open(n,s,t){const r=this.toFilePath(n);let a;(0,v.isFileOpenForWriteOptions)(s)&&!t&&(a=await this.createResourceLock(n));let E;try{if((0,v.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:b}=await u.SymlinkSupport.stat(r);b.mode&128||await u.Promises.chmod(r,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}let C;if((0,v.isFileOpenForWriteOptions)(s)){if(w.isWindows)try{await u.Promises.truncate(r,0),C="r+"}catch(b){b.code!=="ENOENT"&&this.logService.trace(b)}C||(C="w")}else C="r";E=await u.Promises.open(r,C)}catch(C){throw a?.dispose(),(0,v.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,C):this.toFileSystemProviderError(C)}if(this.mapHandleToPos.set(E,0),(0,v.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(E,n),a){const C=this.mapHandleToLock.get(E);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.mapHandleToLock.set(E,a),C&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),C.dispose())}return E}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&i.canFlush)try{await u.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.logService.error(t)}return await u.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const E=this.normalizePos(n,s);let C=null;try{C=(await u.Promises.read(n,t,r,a,E)).bytesRead}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(n,E,C)}return C}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,t){const r=this.mapHandleToPos.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.mapHandleToPos.set(n,r+t):this.mapHandleToPos.delete(n)))}async write(n,s,t,r,a){return(0,O.retry)(()=>this.doWrite(n,s,t,r,a),100,3)}async doWrite(n,s,t,r,a){const E=this.normalizePos(n,s);let C=null;try{C=(await u.Promises.write(n,t,r,a,E)).bytesWritten}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),b)}finally{this.updatePos(n,E,C)}return C}async mkdir(n){try{await u.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const t=this.toFilePath(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,D.join)((0,D.dirname)(t),`${(0,D.basename)(t)}${s.atomic.postfix}`)),await u.Promises.rm(t,u.RimRafMode.MOVE,r)}else try{await u.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:E,symbolicLink:C}=await u.SymlinkSupport.stat(t);a=E.isDirectory()&&!C}catch{}if(a)await u.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.toFileSystemProviderError(t)}}async rename(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"move",t.overwrite),await u.Promises.rename(r,a)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(2,null,(0,D.basename)(r),(0,D.basename)((0,D.dirname)(a)),E.toString()))),this.toFileSystemProviderError(E)}}async copy(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s);if(r!==a)try{await this.validateMoveCopy(n,s,"copy",t.overwrite),await u.Promises.copy(r,a,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(3,null,(0,D.basename)(r),(0,D.basename)((0,D.dirname)(a)),E.toString()))),this.toFileSystemProviderError(E)}}async validateMoveCopy(n,s,t,r){const a=this.toFilePath(n),E=this.toFilePath(s);let C=!1;if(!!(this.capabilities&1024)||(C=(0,P.isEqual)(a,E,!0)),C){if(t==="copy")throw(0,v.createFileSystemProviderError)((0,y.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const I=await this.statIgnoreError(n);if(!I)throw(0,v.createFileSystemProviderError)((0,y.localize)(5,null),v.FileSystemProviderErrorCode.FileNotFound);const p=await this.statIgnoreError(s);if(p){if(!r)throw(0,v.createFileSystemProviderError)((0,y.localize)(6,null),v.FileSystemProviderErrorCode.FileExists);I.type&v.FileType.File&&p.type&v.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,t){const r=this.toFilePath(n),a=this.toFilePath(s),E=!!(this.capabilities&1024);if((0,P.isEqual)(r,a,!E))return;const C=new f.DisposableStore;try{C.add(await this.createResourceLock(n)),C.add(await this.createResourceLock(s)),t&&await u.Promises.mkdir((0,D.dirname)(a),{recursive:!0}),await u.Promises.copyFile(r,a)}catch(b){if(b.code==="ENOENT"&&!t)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(b)}finally{C.dispose()}}createUniversalWatcher(n,s,t){return new c.UniversalWatcherClient(r=>n(r),r=>s(r),t)}createNonRecursiveWatcher(n,s,t){return new S.NodeJSWatcherClient(r=>n(r),r=>s(r),t)}toFileSystemProviderError(n){if(n instanceof v.FileSystemProviderError)return n;let s=n,t;switch(n.code){case"ENOENT":t=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=v.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=v.FileSystemProviderErrorCode.Unknown;break;default:t=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(s,t)}async toFileSystemProviderWriteError(n,s){let t=this.toFileSystemProviderError(s);if(n&&t.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await u.SymlinkSupport.stat(this.toFilePath(n));r.mode&128||(t=(0,v.createFileSystemProviderError)(s,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return t}}e.DiskFileSystemProvider=i}),define(le[99],ue([0,1,3,2,4,9]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,O.createDecorator)("sharedProcessLifecycleService");let _=class extends U.Disposable{constructor(P){super(),this.logService=P,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=_,e.SharedProcessLifecycleService=_=we([K(0,A.ILogService)],_)}),define(le[208],ue([0,1,8,3,9,2]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class _ extends O.AbstractLoggerService{constructor(w,m,h,u,y){super(m,h,u),this.windowId=w,this.channel=y,this._register(y.listen("onDidChangeLogLevel",w)(v=>{(0,O.isLogLevel)(v)?super.setLogLevel(v):super.setLogLevel(L.URI.revive(v[0]),v[1])})),this._register(y.listen("onDidChangeVisibility",w)(([v,d])=>super.setVisibility(L.URI.revive(v),d))),this._register(y.listen("onDidChangeLoggers",w)(({added:v,removed:d})=>{for(const g of v)super.registerLogger({...g,resource:L.URI.revive(g.resource)});for(const g of d)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new O.AdapterLogger({log:(w,m)=>{this.channel.call("consoleLog",[w,m])}})}registerLogger(w){super.registerLogger(w),this.channel.call("registerLogger",[w,this.windowId])}deregisterLogger(w){super.deregisterLogger(w),this.channel.call("deregisterLogger",[w,this.windowId])}setLogLevel(w,m){super.setLogLevel(w,m),this.channel.call("setLogLevel",[w,m])}setVisibility(w,m){super.setVisibility(w,m),this.channel.call("setVisibility",[this.toResource(w),m])}doCreateLogger(w,m,h){return new R(this.channel,w,m,h,this.windowId)}static setLogLevel(w,m,h){return w.call("setLogLevel",[m,h])}}e.LoggerChannelClient=_;class R extends O.AbstractMessageLogger{constructor(w,m,h,u,y){super(u?.logLevel==="always"),this.channel=w,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[m,u,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(w,m){const h=[[w,m]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(w){this.channel.call("log",[this.file,w])}}class P{constructor(w,m){this.loggerService=w,this.getUriTransformer=m}listen(w,m){const h=this.getUriTransformer(w);switch(m){case"onDidChangeLoggers":return U.Event.map(this.loggerService.onDidChangeLoggers,u=>({added:[...u.added].map(y=>this.transformLogger(y,h)),removed:[...u.removed].map(y=>this.transformLogger(y,h))}));case"onDidChangeVisibility":return U.Event.map(this.loggerService.onDidChangeVisibility,u=>[h.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return U.Event.map(this.loggerService.onDidChangeLogLevel,u=>(0,O.isLogLevel)(u)?u:[h.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${m}`)}async call(w,m,h){const u=this.getUriTransformer(w);switch(m){case"setLogLevel":return(0,O.isLogLevel)(h[0])?this.loggerService.setLogLevel(h[0]):this.loggerService.setLogLevel(L.URI.revive(u.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(y=>this.transformLogger(y,u)))}throw new Error(`Call not found: ${m}`)}transformLogger(w,m){return{...w,resource:m.transformOutgoingURI(w.resource)}}}e.LoggerChannel=P;class f extends A.Disposable{constructor(w,m){super(),m.call("setLogLevel",[w.getLogLevel()]),this._register(w.onDidChangeLogLevel(h=>m.call("setLogLevel",[h]))),m.call("getRegisteredLoggers").then(h=>{for(const u of h)w.registerLogger({...u,resource:L.URI.revive(u.resource)})}),this._register(m.listen("onDidChangeVisibility")(([h,u])=>w.setVisibility(L.URI.revive(h),u))),this._register(m.listen("onDidChangeLoggers")(({added:h,removed:u})=>{for(const y of h)w.registerLogger({...y,resource:L.URI.revive(y.resource)});for(const y of u)w.deregisterLogger(y.resource)}))}}e.RemoteLoggerChannelClient=f}),define(le[209],ue([0,1,2,9]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class O extends L.Disposable{constructor(_,R=[]){super(),this.logger=new U.MultiplexLogger([_,...R]),this._register(_.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(_){this.logger.setLevel(_)}getLevel(){return this.logger.getLevel()}trace(_,...R){this.logger.trace(_,...R)}debug(_,...R){this.logger.debug(_,...R)}info(_,...R){this.logger.info(_,...R)}warn(_,...R){this.logger.warn(_,...R)}error(_,...R){this.logger.error(_,...R)}flush(){this.logger.flush()}}e.LogService=O}),define(le[57],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(le[210],ue([0,1,41,56]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let O=class{constructor(_,R){return this.windowId=_,L.ProxyChannel.toService(R.getChannel("nativeHost"),{context:_,properties:(()=>{const P=new Map;return P.set("windowId",_),P})()})}};e.NativeHostService=O,e.NativeHostService=O=we([K(1,U.IMainProcessService)],O)}),define(le[58],ue([0,1,3,61,2,4]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class _ extends O.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(f){const D=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...f,...this.policyDefinitions},D!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(f),U.Iterable.reduce(this.policies.entries(),(w,[m,h])=>({...w,[m]:h}),{})}getPolicyValue(f){return this.policies.get(f)}serialize(){return U.Iterable.reduce(Object.entries(this.policyDefinitions),(f,[D,w])=>({...f,[D]:{definition:w,value:this.policies.get(D)}}),{})}}e.AbstractPolicyService=_;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(le[211],ue([0,1,3,2,58]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.service=P,this.disposables=new U.DisposableStore}listen(P,f){switch(f){case"onDidChange":return L.Event.map(this.service.onDidChange,D=>D.reduce((w,m)=>({...w,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${f}`)}call(P,f,D){switch(f){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(D)}throw new Error(`Call not found: ${f}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=A;class _ extends O.AbstractPolicyService{constructor(P,f){super(),this.channel=f;for(const D in P){const{definition:w,value:m}=P[D];this.policyDefinitions[D]=w,m!==void 0&&this.policies.set(D,m)}this.channel.listen("onDidChange")(D=>{for(const w in D){const m=D[w];m===null?this.policies.delete(w):this.policies.set(w,m)}this._onDidChange.fire(Object.keys(D))})}async _updatePolicyDefinitions(P){const f=await this.channel.call("updatePolicyDefinitions",P);for(const D in f)this.policies.set(D,f[D])}}e.PolicyChannelClient=_}),define(le[100],ue([0,1,36]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;const O=globalThis.vscode;if(typeof O<"u"&&typeof O.context<"u"){const A=O.context.configuration();if(A)U=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){U=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:_,itemUrl:R,controlUrl:P}=U.extensionsGallery||{};Object.assign(U,{extensionsGallery:{serviceUrl:L.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:L.env.VSCODE_GALLERY_SEARCH_URL||_,itemUrl:L.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:L.env.VSCODE_GALLERY_CONTROL_URL||P}});try{const f=(...w)=>w.reduce((m,h)=>(Object.keys(h).forEach(u=>{Array.isArray(m[u])&&Array.isArray(h[u])?m[u]=h[u]:typeof m[u]=="object"&&typeof h[u]=="object"?m[u]=f(m[u],h[u]):m[u]=h[u]}),m),{}),D=globalThis._VSCODE_USER_PRODUCT_JSON||{};U=f(U,D)}catch{}if(L.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`,serverDataFolderName:U.serverDataFolderName?`${U.serverDataFolderName}-dev`:void 0}),!U.version){const f=globalThis._VSCODE_PACKAGE_JSON;Object.assign(U,{version:f.version,release:f.release})}}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=U}),define(le[24],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(le[212],ue([0,1,6,7,2,14,31,9,24]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let f=class extends O.Disposable{constructor(w,m,h){super(),this.productService=m,this.logService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),h=(0,A.dirname)(w),u=(0,A.basename)(w),y=await _.Promises.readdir(h);await Promise.all(y.map(async v=>{if(v===u)return;const d=(0,A.join)(h,v),g=await _.Promises.stat(d);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),_.Promises.rm(d)}))}catch(m){(0,U.onUnexpectedError)(m)}}};e.CodeCacheCleaner=f,e.CodeCacheCleaner=f=we([K(1,P.IProductService),K(2,R.ILogService)],f)}),define(le[213],ue([0,1,6,7,2,14,31,16,9,24]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let D=class extends O.Disposable{constructor(m,h,u){super(),this.environmentService=m,this.logService=h,this.productService=u,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),h=JSON.parse(await _.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(h)){const l=h[g];m[`${l.hash}.${g}`]=!0}const u=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await _.Promises.exists(u))return;const v=await _.Promises.readdir(u);for(const g of v){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await _.Promises.rm((0,A.join)(u,g))}const d=Date.now();for(const g of Object.keys(m)){const l=(0,A.join)(u,g),c=await _.Promises.readdir(l);for(const S of c){if(S==="tcf.json")continue;const i=(0,A.join)(l,S),o=await _.Promises.stat(i);o.isDirectory()&&d-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(g,S)}`),await _.Promises.rm(i))}}}catch(m){(0,U.onUnexpectedError)(m)}}};e.LanguagePackCachedDataCleaner=D,e.LanguagePackCachedDataCleaner=D=we([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,f.IProductService)],D)}),define(le[214],ue([0,1,14,4]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var O;(function(A){function _(P){return!!(P.samples&&P.timeDeltas)}A.isValidProfile=_;function R(P,f="noAbsolutePaths"){for(const D of P.nodes)D.callFrame&&D.callFrame.url&&((0,L.isAbsolute)(D.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(D.callFrame.url))&&(D.callFrame.url=(0,L.join)(f,(0,L.basename)(D.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(O||(e.Utils=O={}))}),define(le[215],ue([0,1,32]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((f,D)=>{se(["v8-inspect-profiler"],f,D)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,L.generateUuid)();return this._sessions.set(P,R),P}async stopProfiling(A){const _=this._sessions.get(A);if(!_)throw new Error(`UNKNOWN session '${A}'`);const R=await _.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=U}),define(le[42],ue([0,1,127,13]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class O{constructor(){this.data=new Map}add(_,R){L.ok(U.isString(_)),L.ok(U.isObject(R)),L.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,R)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new O}),define(le[101],ue([0,1,3,42]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function O(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,f){this.schemasById[O(P)]=f,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new A;U.Registry.add(e.Extensions.JSONContribution,_)}),define(le[47],ue([0,1,17,3,13,153,21,101,42]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=y,e.keyFromOverrideIdentifiers=v,e.getDefaultValue=d,e.validateProperty=l,e.getScopes=c;var f;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D||(e.ConfigurationScope=D={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=P.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new U.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new U.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.doRegisterConfigurations(i,o,n),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.doDeregisterConfigurations(i,o),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.doDeregisterConfigurations(o,n),this.doRegisterConfigurations(i,!1,n),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.doRegisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doRegisterDefaultConfigurations(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const a=this.configurationDefaultsOverrides.get(r),E=a?.valuesSources??new Map;if(t)for(const p of Object.keys(s[r]))E.set(p,t);const C={...a?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:C,valuesSources:E});const b=(0,_.getLanguageTagSettingPlainKey)(r),I={type:"object",default:C,description:A.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:O.isString(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.configurationProperties[r]=I,this.defaultLanguageConfigurationOverridesNode.properties[r]=I}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:t});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(i){const o=new Set;this.doDeregisterDefaultConfigurations(i,o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.configurationDefaultsOverrides.get(t),a=O.isString(s)?s:s?.id,E=O.isString(r?.source)?r?.source:r?.source?.id;if(a===E)if(o.add(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const C=this.configurationProperties[t];C&&(this.updatePropertyDefaultValue(t,C),this.updateSchema(t,C))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.doDeregisterDefaultConfigurations(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.doRegisterDefaultConfigurations(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.doDeregisterConfigurations(i.removedConfigurations,n),i.addedConfigurations&&this.doRegisterConfigurations(i.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){this.doRegisterOverrideIdentifiers(i),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o,n){i.forEach(s=>{this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.configurationProperties[t];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[t],this.removeFromSchema(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.configurationContributors.indexOf(s);t!==-1&&this.configurationContributors.splice(t,1)}}validateAndRegisterProperties(i,o=!0,n,s,t=3,r){t=O.isUndefinedOrNull(i.scope)?t:i.scope;const a=i.properties;if(a)for(const C in a){const b=a[C];if(o&&l(C,b)){delete a[C];continue}if(b.source=n,b.defaultDefaultValue=a[C].default,this.updatePropertyDefaultValue(C,b),e.OVERRIDE_PROPERTY_REGEX.test(C)?b.scope=void 0:(b.scope=O.isUndefinedOrNull(b.scope)?t:b.scope,b.restricted=O.isUndefinedOrNull(b.restricted)?!!s?.includes(C):b.restricted),a[C].hasOwnProperty("included")&&!a[C].included){this.excludedConfigurationProperties[C]=a[C],delete a[C];continue}else this.configurationProperties[C]=a[C],a[C].policy?.name&&this.policyConfigurations.set(a[C].policy.name,C);!a[C].deprecationMessage&&a[C].markdownDeprecationMessage&&(a[C].deprecationMessage=a[C].markdownDeprecationMessage),r.add(C)}const E=i.allOf;if(E)for(const C of E)this.validateAndRegisterProperties(C,o,n,s,t,r)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);n.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,n),e.allSettings.properties[o]=n,e.applicationSettings.properties[o]=n,e.machineSettings.properties[o]=n,e.machineOverridableSettings.properties[o]=n,e.windowSettings.properties[o]=n,e.resourceSettings.properties[o]=n}}registerOverridePropertyPatternKey(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const n=this.configurationDefaultsOverrides.get(i);let s=n?.value,t=n?.source;O.isUndefined(s)&&(s=o.defaultDefaultValue,t=void 0),O.isUndefined(s)&&(s=d(o.type)),o.default=s,o.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",u=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(S){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let o=u.exec(S);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=u.exec(S)}}return(0,L.distinct)(i)}function v(S){return S.reduce((i,o)=>`${i}[${o}]`,"")}function d(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new m;P.Registry.add(e.Extensions.Configuration,g);function l(S,i){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?A.localize(7,null,S):g.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,S,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function c(){const S=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))S.push([o,i[o].scope]);return S.push(["launch",4]),S.push(["task",4]),S}}),define(le[76],ue([0,1,17,3,34,2,35,30,13,8,21,47,42]),function(se,e,L,U,O,A,_,R,P,f,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=l;function h(o){return Object.isFrozen(o)?o:R.deepFreeze(o)}class u{constructor(n={},s=[],t=[],r){this._contents=n,this._keys=s,this._overrides=t,this.raw=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof u)return s;const t=new y("");return t.parseRaw(s),t.configurationModel});this._rawConfiguration=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return h(t.rawConfiguration.getValue(n))},get override(){return s?h(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:E,keys:C}of t.rawConfiguration.overrides){const b=new u(a,C).getValue(n);b!==void 0&&r.push({identifiers:E,value:b})}return r.length?h(r):void 0}}}getOverrideValue(n,s){const t=this.getContentsForOverrideIdentifer(s);return t?n?(0,D.getConfigurationValue)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return L.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return L.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=R.deepClone(this.contents),t=R.deepClone(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const E of n)if(a.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.mergeContents(s,E.contents);for(const C of E.overrides){const[b]=t.filter(I=>L.equals(I.identifiers,C.identifiers));b?(this.mergeContents(b.contents,C.contents),b.keys.push(...C.keys),b.keys=L.distinct(b.keys)):t.push(R.deepClone(C))}for(const C of E.keys)r.indexOf(C)===-1&&r.push(C)}return new u(s,r,t,a.every(E=>E instanceof u)?void 0:a)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of L.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const E=s[r];E&&(typeof a=="object"&&typeof E=="object"?(a=R.deepClone(a),this.mergeContents(a,E)):a=E),t[r]=a}return new u(t,this.keys,this.overrides)}mergeContents(n,s){for(const t of Object.keys(s)){if(t in n&&P.isObject(n[t])&&P.isObject(s[t])){this.mergeContents(n[t],s[t]);continue}n[t]=R.deepClone(s[t])}}getContentsForOverrideIdentifer(n){let s=null,t=null;const r=a=>{a&&(t?this.mergeContents(t,a):t=R.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,D.removeFromValueTree)(this.contents,n),w.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>L.equals(t.identifiers,(0,w.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,t){(0,D.addToValueTree)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),w.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,D.toValuesTree)(this.contents[n],r=>console.error(r))})}}e.ConfigurationModel=u;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new u}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!P.isUndefinedOrNull(n)){const t=this.doParseContent(n);this.parseRaw(t,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:t,keys:r,overrides:a,restricted:E,hasExcludedProperties:C}=this.doParseRaw(n,s);this._configurationModel=new u(t,r,a,C?[n]:void 0),this._restrictedConfigurations=E||[]}doParseContent(n){let s={},t=null,r=[];const a=[],E=[];function C(I){Array.isArray(r)?r.push(I):t!==null&&(r[t]=I)}const b={onObjectBegin:()=>{const I={};C(I),a.push(r),r=I,t=null},onObjectProperty:I=>{t=I},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const I=[];C(I),a.push(r),r=I,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:C,onError:(I,p,k)=>{E.push({error:I,offset:p,length:k})}};if(n)try{O.visit(n,b),s=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return s}doParseRaw(n,s){const t=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,t,!0,s);n=r.raw;const a=(0,D.toValuesTree)(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),E=Object.keys(n),C=this.toOverrides(n,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:a,keys:E,overrides:C,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}filter(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const E={},C=[];for(const b in n)if(w.OVERRIDE_PROPERTY_REGEX.test(b)&&t){const I=this.filter(n[b],s,!1,r);E[b]=I.raw,a=a||I.hasExcludedProperties,C.push(...I.restricted)}else{const I=s[b],p=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&C.push(b),!r.exclude?.includes(b)&&(r.include?.includes(b)||(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&!(r.skipRestricted&&I?.restricted))?E[b]=n[b]:a=!0}return{raw:E,restricted:C,hasExcludedProperties:a}}toOverrides(n,s){const t=[];for(const r of Object.keys(n))if(w.OVERRIDE_PROPERTY_REGEX.test(r)){const a={};for(const E in n[r])a[E]=n[r][E];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(a),contents:(0,D.toValuesTree)(a,s)})}return t}}e.ConfigurationModelParser=y;class v extends A.Disposable{constructor(n,s,t,r){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=r,this._onDidChange=this._register(new U.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(U.Event.any(U.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),U.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new u}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class d{constructor(n,s,t,r,a,E,C,b,I,p,k,N,F){this.key=n,this.overrides=s,this._value=t,this.overrideIdentifiers=r,this.defaultConfiguration=a,this.policyConfiguration=E,this.applicationConfiguration=C,this.userConfiguration=b,this.localUserConfiguration=I,this.remoteUserConfiguration=p,this.workspaceConfiguration=k,this.folderConfigurationModel=N,this.memoryConfigurationModel=F}get value(){return h(this._value)}toInspectValue(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class g{constructor(n,s,t,r,a=new u,E=new u,C=new _.ResourceMap,b=new u,I=new _.ResourceMap){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=a,this._workspaceConfiguration=E,this._folderConfigurations=C,this._memoryConfiguration=b,this._memoryConfigurationByResource=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,s,t){return this.getConsolidatedConfigurationModel(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new u,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,t){const r=this.getConsolidatedConfigurationModel(n,s,t),a=this.getFolderConfigurationModelForResource(s.resource,t),E=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,C=new Set;for(const b of r.overrides)for(const I of b.identifiers)r.getOverrideValue(n,I)!==void 0&&C.add(I);return new d(n,s,r.getValue(n),C.size?[...C]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this._workspaceConfiguration:void 0,a||void 0,E)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:E}=S(this._defaultConfiguration,n);s=[...r,...a,...E]}for(const r of s)for(const a of(0,w.overrideIdentifiersFromKey)(r)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(a),C=n.getKeysForOverrideIdentifier(a),b=[...C.filter(I=>E.indexOf(I)===-1),...E.filter(I=>C.indexOf(I)===-1),...E.filter(I=>!R.equals(this._defaultConfiguration.override(a).getValue(I),n.override(a).getValue(I)))];t.push([a,b])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=S(this._policyConfiguration,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=S(this.applicationConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateApplicationConfiguration(n),{keys:E,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=S(this.localUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateLocalUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=S(this.remoteUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateRemoteUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=S(this.workspaceConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateWorkspaceConfiguration(n),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:E,overrides:C}=S(t,s),b=[...r,...a,...E];return(b.length||!t)&&this.updateFolderConfiguration(n,s),{keys:b,overrides:C}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:E}=S(s,void 0);return{keys:[...t,...r,...a],overrides:E}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const r=s.getFolder(n);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const a=this._memoryConfigurationByResource.get(n);a&&(t=t.merge(a))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(s=t.merge(r),this._foldersConsolidatedConfigurations.set(n,s)):s=t}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),t=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),a=this.parseConfigurationModel(n.user),E=this.parseConfigurationModel(n.workspace),C=n.folders.reduce((b,I)=>(b.set(f.URI.revive(I[0]),this.parseConfigurationModel(I[1])),b),new _.ResourceMap);return new g(s,t,r,a,new u,E,C,new u,new _.ResourceMap)}static parseConfigurationModel(n){return new u(n.contents,n.keys,n.overrides)}}e.Configuration=g;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,E])=>{const C=(0,_.getOrSet)(s,a,new Set);E.forEach(b=>C.add(b))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r){this.change=n,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=r,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const E of a)this.affectedKeys.add(E);this._affectsConfigStr=this._marker;for(const a of this.affectedKeys)this._affectsConfigStr+=a+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){const t=this._marker+n,r=this._affectsConfigStr.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this._affectsConfigStr.length)return!1;const E=this._affectsConfigStr.charCodeAt(a);if(E!==this._markerCode1&&E!==this._markerCode2)return!1;if(s){const C=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,b=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!R.equals(C,b)}return!0}}e.ConfigurationChangeEvent=c;function S(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],E=o?.getAllOverrideIdentifiers()||[],C=n?.getAllOverrideIdentifiers()||[];if(n){const b=C.filter(I=>!E.includes(I));for(const I of b)a.push([I,n.getKeysForOverrideIdentifier(I)])}if(o){const b=E.filter(I=>!C.includes(I));for(const I of b)a.push([I,o.getKeysForOverrideIdentifier(I)])}if(n&&o){for(const b of E)if(C.includes(b)){const I=i({contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)},{contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)});a.push([b,[...I.added,...I.removed,...I.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const E=(0,D.getConfigurationValue)(n.contents,a),C=(0,D.getConfigurationValue)(o.contents,a);R.equals(E,C)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[216],ue([0,1,17,3,2,30,13,76,47,9,58,42]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends O.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.resetConfigurationModel(),this._register(w.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.onDidUpdateConfiguration(Array.from(v),d))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(v,d){this.updateConfigurationModel(v,w.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=new R.ConfigurationModel;const v=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(v),v)}updateConfigurationModel(v,d){const g=this.getConfigurationDefaultOverrides();for(const l of v){const c=g[l],S=d[l];c!==void 0?this._configurationModel.addValue(l,c):S?this._configurationModel.addValue(l,S.default):this._configurationModel.removeValue(l)}}}e.DefaultConfiguration=m;class h{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let u=class extends O.Disposable{get configurationModel(){return this._configurationModel}constructor(v,d,g){super(),this.defaultConfiguration=v,this.policyService=d,this.logService=g,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new R.ConfigurationModel}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.updatePolicyDefinitions(v),!0))),this._configurationModel}async updatePolicyDefinitions(v){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",v);const d={},g=[],l=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const c of v){const S=l[c];if(!S){g.push(c);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.logService.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}g.push(c),d[S.policy.name]={type:S.type}}}return(0,_.isEmptyObject)(d)||await this.policyService.updatePolicyDefinitions(d),g}onDidChangePolicies(v){this.logService.trace("PolicyConfiguration#onDidChangePolicies",v);const d=w.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),g=(0,L.coalesce)(v.map(l=>d.get(l)));this.update(g,!0)}update(v,d){this.logService.trace("PolicyConfiguration#update",v);const g=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),l=[],c=this._configurationModel.isEmpty();for(const S of v){const i=g[S]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(c?o!==void 0:!(0,A.equals)(this._configurationModel.getValue(S),o))&&l.push([S,o])}else this._configurationModel.getValue(S)!==void 0&&l.push([S,void 0])}if(l.length){this.logService.trace("PolicyConfiguration#changed",l);const S=this._configurationModel;this._configurationModel=new R.ConfigurationModel;for(const i of S.keys)this._configurationModel.setValue(i,S.getValue(i));for(const[i,o]of l)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=u,e.PolicyConfiguration=u=we([K(1,D.IPolicyService),K(2,f.ILogService)],u)}),define(le[217],ue([0,1,17,6,15,3,34,62,2,30,5,20,21,76,47,216,58]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class d extends P.Disposable{constructor(c,S,i,o){super(),this.settingsResource=c,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new y.DefaultConfiguration),this.policyConfiguration=i instanceof v.NullPolicyService?new y.NullPolicyConfiguration:this._register(new y.PolicyConfiguration(this.defaultConfiguration,i,o)),this.userConfiguration=this._register(new h.UserSettings(this.settingsResource,{},w.extUriBiasedIgnorePathCase,S)),this.configuration=new h.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new h.ConfigurationModel,new h.ConfigurationModel),this.configurationEditing=new g(c,S,this),this.reloadConfigurationScheduler=this._register(new U.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:n,properties:s})=>this.onDidDefaultConfigurationChange(n,s))),this._register(this.policyConfiguration.onDidChangeConfiguration(n=>this.onDidPolicyConfigurationChange(n))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[c,S,i]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new h.Configuration(c,S,new h.ConfigurationModel,i)}getConfigurationData(){return this.configuration.toData()}getValue(c,S){const i=typeof c=="string"?c:void 0,o=(0,m.isConfigurationOverrides)(c)?c:(0,m.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(i,o,void 0)}async updateValue(c,S,i,o,n){const s=(0,m.isConfigurationUpdateOverrides)(i)?i:(0,m.isConfigurationOverrides)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,L.distinct)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,f.equals)(S,r.defaultValue)&&(S=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const E=s.overrideIdentifiers.sort(),C=this.configuration.localUserConfiguration.overrides.find(b=>(0,L.equals)([...b.identifiers].sort(),E));C&&(s.overrideIdentifiers=C.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,u.keyFromOverrideIdentifiers)(s.overrideIdentifiers),c]:[c];await this.configurationEditing.write(a,S),await this.reloadConfiguration()}inspect(c,S={}){return this.configuration.inspect(c,S,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const S=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(i,S,2)}onDidDefaultConfigurationChange(c,S){const i=this.configuration.toData(),o=this.configuration.compareAndUpdateDefaultConfiguration(c,S);this.trigger(o,i,7)}onDidPolicyConfigurationChange(c){const S=this.configuration.toData(),i=this.configuration.compareAndUpdatePolicyConfiguration(c);this.trigger(i,S,7)}trigger(c,S,i){const o=new h.ConfigurationChangeEvent(c,{data:S},this.configuration);o.source=i,this._onDidChangeConfiguration.fire(o)}}e.ConfigurationService=d;class g{constructor(c,S,i){this.settingsResource=c,this.fileService=S,this.configurationService=i,this.queue=new U.Queue}write(c,S){return this.queue.queue(()=>this.doWriteConfiguration(c,S))}async doWriteConfiguration(c,S){let i;try{i=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,_.parse)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.getEdits(i,c,S);i=(0,R.applyEdits)(i,n),await this.fileService.writeFile(this.settingsResource,O.VSBuffer.fromString(i))}getEdits(c,S,i){const{tabSize:o,insertSpaces:n,eol:s}=this.formattingOptions;if(!S.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.setProperty)(c,S,i,{tabSize:o,insertSpaces:n,eol:s})}get formattingOptions(){if(!this._formattingOptions){let c=D.OS===3||D.OS===2?`
`:`\r
`;const S=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});S&&typeof S=="string"&&S!=="auto"&&(c=S),this._formattingOptions={eol:c,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(le[218],ue([0,1,15,3,2,68]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=R;const _=(f,D,w)=>{const m=new Uint8Array(16);for(let y=0;y<16;y++)m[y]=Math.round(Math.random()*256);const h=(0,L.encodeBase64)(L.VSBuffer.wrap(m));return[`GET ws://localhost${f}?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=_,e.socketRawEndHeaderSequence=L.VSBuffer.fromString(`\r
\r
`);async function R(f,D,w,m,h){f.write(L.VSBuffer.fromString((0,e.makeRawSocketHeaders)(D,w,m)));const u=new O.DisposableStore;try{return await new Promise((y,v)=>{let d;u.add(f.onData(g=>{d?d=L.VSBuffer.concat([d,g],d.byteLength+g.byteLength):d=g;const l=d.indexOf(e.socketRawEndHeaderSequence);if(l===-1)return;y(f),f.pauseData();const c=d.slice(l+e.socketRawEndHeaderSequence.byteLength);c.byteLength&&h.onData.fire(c)})),u.add(f.onClose(g=>v(g??new Error("socket closed")))),u.add(f.onEnd(()=>v(new Error("socket ended"))))})}catch(y){throw f.dispose(),y}finally{u.dispose()}}class P extends O.Disposable{constructor(D,w){super(),this.debugLabel=D,this.pausableDataEmitter=this._register(new U.PauseableEmitter),this.onData=(...m)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...m)),this.didDisposeEmitter=this._register(new U.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(w.onData),this._register(w.onData.event(m=>this.pausableDataEmitter.fire(m))),this.onClose=this._register(w.onClose).event,this.onEnd=this._register(w.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(D,w){A.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,D,w)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=P}),define(le[219],ue([0,1,7,4]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=f,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var O;(function(D){D[D.WebSocket=0]="WebSocket",D[D.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class A{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class _{constructor(w,m){this.host=w,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=_;var R;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound",D.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class P extends L.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof P&&w._code===R.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof P&&w._code===R.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof P&&w._code===R.NoResolverFound}static isInvalidAuthority(w){return w instanceof P&&w._code===R.InvalidAuthority}static isHandled(w){return w instanceof P&&w.isHandled}constructor(w,m=R.Unknown,h){super(w),this._message=w,this._code=m,this._detail=h,this.isHandled=m===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P;function f(D){const w=D.indexOf("+");return w===-1?D:D.substring(0,w)}}),define(le[220],ue([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=E,e.connectRemoteAgentExtensionHost=C,e.connectRemoteAgentTunnel=I;const u=30*1e3;var y;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function v($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d($){const T=new O.CancellationTokenSource;return setTimeout(()=>T.cancel(),$),T.token}function g($,T){if($.isCancellationRequested||T.isCancellationRequested)return O.CancellationToken.Cancelled;const M=new O.CancellationTokenSource;return $.onCancellationRequested(()=>M.cancel()),T.onCancellationRequested(()=>M.cancel()),M.token}class l{get didTimeout(){return this._state==="timedout"}constructor(T){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,L.promiseWithResolvers)(),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function c($,T){const M=new l(T);return M.registerDisposable($.onControlMessage(W=>{const J=JSON.parse(W.toString()),H=q(J);H?M.reject(H):M.resolve(J)})),M.promise}function S($,T,M,W,J,H,ee,Q){const Y=new l(Q),ne=D.StopWatch.create(!1);return $.info(`Creating a socket (${ee})...`),f.mark(`code/willCreateSocket/${H}`),T.connect(M,W,J,ee).then(re=>{Y.didTimeout?(f.mark(`code/didCreateSocketError/${H}`),$.info(`Creating a socket (${ee}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(f.mark(`code/didCreateSocketOK/${H}`),$.info(`Creating a socket (${ee}) was successful after ${ne.elapsed()} ms.`),Y.resolve(re))},re=>{f.mark(`code/didCreateSocketError/${H}`),$.info(`Creating a socket (${ee}) returned an error after ${ne.elapsed()} ms.`),$.error(re),Y.reject(re)}),Y.promise}function i($,T){const M=new l(T);return $.then(W=>{M.didTimeout||M.resolve(W)},W=>{M.didTimeout||M.reject(W)}),M.promise}async function o($,T,M,W){const J=ce($,T);$.logService.trace(`${J} 1/6. invoking socketFactory.connect().`);let H;try{H=await S($.logService,$.remoteSocketFactoryService,$.connectTo,P.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,v(T),`renderer-${v(T)}-${$.reconnectionToken}`,W)}catch(re){throw $.logService.error(`${J} socketFactory.connect() failed or timed out. Error:`),$.logService.error(re),re}$.logService.trace(`${J} 2/6. socketFactory.connect() was successful.`);let ee,Q;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(H,null),ee=$.reconnectionProtocol,Q=!1):(ee=new m.PersistentProtocol({socket:H}),Q=!0),$.logService.trace(`${J} 3/6. sending AuthRequest control message.`);const Y=await i($.signService.createNewMessage((0,w.generateUuid)()),W),ne={type:"auth",auth:$.connectionToken||"00000000000000000000",data:Y.data};ee.sendControl(U.VSBuffer.fromString(JSON.stringify(ne)));try{const re=await c(ee,g(W,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if($.logService.trace(`${J} 4/6. received SignRequest control message.`),!await i($.signService.validate(Y,re.signedData),W)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const fe=await i($.signService.sign(re.data),W),me={type:"connectionType",commit:$.commit,signedData:fe,desiredConnectionType:T};return M&&(me.args=M),$.logService.trace(`${J} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(U.VSBuffer.fromString(JSON.stringify(me))),{protocol:ee,ownsProtocol:Q}}catch(re){throw re&&re.code==="ETIMEDOUT"&&($.logService.error(`${J} the handshake timed out. Error:`),$.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${J} received error control message when negotiating connection. Error:`),$.logService.error(re)),Q&&z(ee),re}}async function n($,T,M,W){const J=Date.now(),H=ce($,T),{protocol:ee,ownsProtocol:Q}=await o($,T,M,W),Y=new l(W);return Y.registerDisposable(ee.onControlMessage(ne=>{const re=JSON.parse(ne.toString()),he=q(re);he?($.logService.error(`${H} received error control message when negotiating connection. Error:`),$.logService.error(he),Q&&z(ee),Y.reject(he)):($.reconnectionProtocol?.endAcceptReconnection(),$.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${V(J)}!`),Y.resolve({protocol:ee,firstMessage:re}))})),Y.promise}async function s($,T){const{protocol:M}=await n($,1,void 0,T);return{protocol:M}}async function t($,T,M){const{protocol:W,firstMessage:J}=await n($,2,T,M),H=J&&J.debugPort;return{protocol:W,debugPort:H}}async function r($,T,M){const W=Date.now(),J=ce($,3),{protocol:H}=await o($,3,T,M);return $.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${V(W)}!`),H}async function a($,T,M){const{connectTo:W,connectionToken:J}=await $.addressProvider.getAddress();return{commit:$.commit,quality:$.quality,connectTo:W,connectionToken:J,reconnectionToken:T,reconnectionProtocol:M,remoteSocketFactoryService:$.remoteSocketFactoryService,signService:$.signService,logService:$.logService}}async function E($,T,M){return b($,async W=>{const{protocol:J}=await s(W,O.CancellationToken.None);return new j($,T,M,W.reconnectionToken,J)})}async function C($,T){return b($,async M=>{const{protocol:W,debugPort:J}=await t(M,T,O.CancellationToken.None);return new G($,T,M.reconnectionToken,W,J)})}async function b($,T){for(let W=1;;W++)try{const J=(0,w.generateUuid)(),H=await a($,J,null);return await T(H)}catch(J){if(W<5)$.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),$.logService.error(J);else throw $.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$.logService.error(J),X.triggerPermanentFailure(0,0,h.RemoteAuthorityResolverError.isHandled(J)),J}}async function I($,T,M){const W=await a($,(0,w.generateUuid)(),null);return await r(W,{host:T,port:M},O.CancellationToken.None)}function p($){return(0,L.createCancelablePromise)(T=>new Promise((M,W)=>{const J=setTimeout(M,$*1e3);T.onCancellationRequested(()=>{clearTimeout(J),M()})}))}var k;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(k||(e.PersistentConnectionEventType=k={}));class N{constructor(T,M){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.type=0}}e.ConnectionLostEvent=N;class F{constructor(T,M,W,J){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.durationSeconds=W,this.cancellableTimer=J,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class x{constructor(T,M,W){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=x;class Z{constructor(T,M,W){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.attempt=W,this.type=4}}e.ConnectionGainEvent=Z;class B{constructor(T,M,W,J){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.attempt=W,this.handled=J,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class X extends R.Disposable{static triggerPermanentFailure(T,M,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=M,this._permanentFailureHandled=W,this._instances.forEach(J=>J._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(T=>T._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(T=>T._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||X._permanentFailure}constructor(T,M,W,J,H){super(),this._connectionType=T,this._options=M,this.reconnectionToken=W,this.protocol=J,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new _.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new Z(this.reconnectionToken,0,0)),this._register(J.onSocketClose(ee=>{const Q=te(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${Q} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${Q} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${Q} received socket close event.`),this._beginReconnecting()})),this._register(J.onSocketTimeout(ee=>{const Q=te(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),X._instances.push(this),this._register((0,R.toDisposable)(()=>{const ee=X._instances.indexOf(this);ee>=0&&X._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const T=te(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const J=W<M.length?M[W]:M[M.length-1];try{if(J>0){const ee=p(J);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J,ee)),this._options.logService.info(`${T} waiting for ${J} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${T} resolving connection...`);const H=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${H.connectTo}...`),await this._reconnect(H,d(u)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(h.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,A.isCancellationError)(H)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof h.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,h.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(T,M,W){this._reconnectionFailureIsFatal?X.triggerPermanentFailure(T,M,W):this._gotoPermanentFailure(T,M,W)}_gotoPermanentFailure(T,M,W){this._onDidStateChange.fire(new B(this.reconnectionToken,T,M,W)),z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X;class j extends X{constructor(T,M,W,J,H){super(1,T,J,H,!0),this.client=this._register(new m.Client(H,{remoteAuthority:M,clientId:W},T.ipcLogger))}async _reconnect(T,M){await s(T,M)}}e.ManagementPersistentConnection=j;class G extends X{constructor(T,M,W,J,H){super(2,T,W,J,!1),this._startArguments=M,this.debugPort=H}async _reconnect(T,M){await t(T,this._startArguments,M)}}e.ExtensionHostPersistentConnection=G;function z($){try{$.acceptDisconnect();const T=$.getSocket();$.dispose(),T.dispose()}catch(T){(0,A.onUnexpectedError)(T)}}function q($){if($&&$.type==="error"){const T=new Error(`Connection error: ${$.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function ie($,T){for(;$.length<T;)$+=" ";return $}function ae($,T){return`[remote-connection][${ie(v($),13)}][${T.substr(0,5)}\u2026]`}function te($,T,M){return`${ae($,T)}[${M?"reconnect":"initial"}]`}function ce($,T){return`${te(T,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.connectTo}]`}function V($){return`${Date.now()-$} ms`}}),define(le[102],ue([0,1,23]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=U,e.getRemoteName=O,e.parseAuthorityWithPort=A,e.parseAuthorityWithOptionalPort=_;function U(P){return P.scheme===L.Schemas.vscodeRemote?P.authority:void 0}function O(P){if(!P)return;const f=P.indexOf("+");return f<0?P:P.substr(0,f)}function A(P){const{host:f,port:D}=R(P);if(typeof D>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:f,port:D}}function _(P,f){let{host:D,port:w}=R(P);return typeof w>"u"&&(w=f),{host:D,port:w}}function R(P){const f=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(f)return{host:f[1],port:parseInt(f[2],10)};const D=P.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const w=P.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:P,port:void 0}}}),define(le[48],ue([0,1,27,4,102]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=A,e.isApplicationScopedExtension=w,e.isLanguagePackExtension=m,e.isAuthenticationProviderExtension=h,e.isResolverExtension=u,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var _;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(_||(e.ExtensionType=_={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.LINUX_PPC64LE="linux-ppc64le",y.LINUX_RISCV64="linux-riscv64",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class P{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,d){if(typeof v>"u"||v===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof v=="string"||typeof d=="string"){const g=typeof v=="string"?v:v.value,l=typeof d=="string"?d:d.value;return L.equalsIgnoreCase(g,l)}return v._lower===d._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=P;class f{get size(){return this._set.size}constructor(v){if(this._set=new Set,v)for(const d of v)this.add(d)}add(v){this._set.add(P.toKey(v))}delete(v){return this._set.delete(P.toKey(v))}has(v){return this._set.has(P.toKey(v))}}e.ExtensionIdentifierSet=f;class D{constructor(){this._map=new Map}clear(){this._map.clear()}delete(v){this._map.delete(P.toKey(v))}get(v){return this._map.get(P.toKey(v))}has(v){return this._map.has(P.toKey(v))}set(v,d){this._map.set(P.toKey(v),d)}values(){return this._map.values()}forEach(v){this._map.forEach(v)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=D;function w(y){return m(y)}function m(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function u(y,v){if(v){const d=`onResolveRemoteAuthority:${(0,O.getRemoteName)(v)}`;return!!y.activationEvents?.includes(d)}return!1}e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(le[221],ue([0,1,2,48,12]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends L.Disposable{constructor(R,P,f,D,w){super(),this.userDataProfilesService=R,this.fileService=P,this.uriIdentityService=f,this.logService=w,this._register(D.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(D.onDidUninstallExtension(m=>this.onDidUnInstallExtension(m)))}onDidInstallExtensions(R){for(const P of R)P.local&&this.invalidate(P.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const P of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(P.extensionsResource,R)&&await this.deleteUserCacheFile(P);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,U.USER_MANIFEST_CACHE_FILE))}catch(P){(0,O.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}e.ExtensionsManifestCache=A}),define(le[103],ue([0,1,2,4]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,U.createDecorator)("remoteSocketFactoryService");class O{constructor(){this.factories={}}register(_,R){return this.factories[_]??=[],this.factories[_].push(R),(0,L.toDisposable)(()=>{const P=this.factories[_]?.indexOf(R);typeof P=="number"&&P>=0&&this.factories[_]?.splice(P,1)})}getSocketFactory(_){return(this.factories[_.type]||[]).find(P=>P.supports(_))}connect(_,R,P,f){const D=this.getSocketFactory(_);if(!D)throw new Error(`No socket factory found for ${_}`);return D.connect(_,R,P,f)}}e.RemoteSocketFactoryService=O}),define(le[222],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(le[104],ue([0,1,4,169]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var O;(function(A){A.disconnected=_=>({type:"disconnected",onTokenFailed:_}),A.connected=(_,R)=>({type:"connected",info:_,serviceInstallFailed:R}),A.connecting=_=>({type:"connecting",progress:_}),A.uninitialized={type:"uninitialized"}})(O||(e.TunnelStates=O={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(le[59],ue([0,1,15,7,2,171,47,4,9,42]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=m,e.hasNoContent=h,e.asText=u,e.asTextOrError=y,e.asJson=v,e.updateProxyConfigurationsScope=d,e.IRequestService=(0,R.createDecorator)("requestService");class D{constructor(S){this.original=S}toJSON(){if(!this.headers){const S=Object.create(null);for(const i in this.original)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?S[i]="*****":S[i]=this.original[i];this.headers=S}return this.headers}}class w extends O.Disposable{constructor(S){super(),this.counter=0,this.logger=S.createLogger("network",{name:(0,A.localize)(0,null),when:P.CONTEXT_LOG_LEVEL.isEqualTo((0,P.LogLevelToString)(P.LogLevel.Trace)).serialize()})}async logAndRequest(S,i,o){const n=`${S} #${++this.counter}: ${i.url}`;this.logger.trace(`${n} - begin`,i.type,new D(i.headers??{}));try{const s=await o();return this.logger.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${n} - error`,i.type,(0,U.getErrorMessage)(s)),s}}}e.AbstractRequestService=w;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function h(c){return c.res.statusCode===204}async function u(c){return h(c)?null:(await(0,L.streamToBuffer)(c.stream)).toString()}async function y(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return u(c)}async function v(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(h(c))return null;const i=(await(0,L.streamToBuffer)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function d(c){l(c)}let g;function l(c){const S=f.Registry.as(_.Extensions.Configuration),i=g;g={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[g],remove:i?[i]:[]})}l(1)}),define(le[223],ue([0,1,26,23,12,59]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let _=class{constructor(P,f){this.requestService=P,this.fileService=f}async download(P,f,D=L.CancellationToken.None){if(P.scheme===U.Schemas.file||P.scheme===U.Schemas.vscodeRemote){await this.fileService.copy(P,f);return}const w={type:"GET",url:P.toString(!0)},m=await this.requestService.request(w,D);if(m.res.statusCode===200)await this.fileService.writeFile(f,m.stream);else{const h=await(0,A.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.DownloadService=_,e.DownloadService=_=we([K(0,A.IRequestService),K(1,O.IFileService)],_)}),define(le[224],ue([0,1,15,26]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class O{constructor(R){this.service=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,f,D=U.CancellationToken.None){switch(P){case"request":return this.service.request(f[0],D).then(async({res:w,stream:m})=>{const h=await(0,L.streamToBuffer)(m);return[{statusCode:w.statusCode,headers:w.headers},h]});case"resolveProxy":return this.service.resolveProxy(f[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=O;class A{constructor(R){this.channel=R}async request(R,P){const[f,D]=await this.channel.call("request",[R],P);return{res:f,stream:(0,L.bufferToStream)(D)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=A}),define(le[225],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[226],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class L{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(O){try{const A=await this.getValidator();if(A){const _=String(L._nextId++);return this.validators.set(_,A),{id:_,data:A.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,A){if(!O.id)return!0;const _=this.validators.get(O.id);if(!_)return!1;this.validators.delete(O.id);try{return _.validate(A)==="ok"}catch{return!1}finally{_.dispose?.()}}async sign(O){try{return await this.signValue(O)}catch{}return O}}e.AbstractSignService=L}),define(le[105],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(le[227],ue([0,1,226]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class U extends L.AbstractSignService{getValidator(){return this.vsda().then(A=>new A.validator)}signValue(A){return this.vsda().then(_=>new _.signer().sign(A))}vsda(){return new Promise((A,_)=>se(["vsda"],A,_))}}e.SignService=U}),define(le[77],ue([0,1,3,2]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class O extends U.Disposable{constructor(w,m,h){super(),this.channel=w,this.profile=m,this.workspace=h}async getItems(){const w={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",w);return new Map(m)}updateItems(w){const m={profile:this.profile,workspace:this.workspace};return w.insert&&(m.insert=Array.from(w.insert.entries())),w.delete&&(m.delete=Array.from(w.delete.values())),this.channel.call("updateItems",m)}optimize(){const w={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",w)}}class A extends O{constructor(w,m){super(w,m,void 0),this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(w=>this.onDidChangeStorage(w)))}onDidChangeStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class _ extends A{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=_;class R extends A{constructor(w,m){super(w,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends O{constructor(w,m){super(w,void 0,m),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class f{constructor(w){this.channel=w}isUsed(w){const m={payload:w,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=f}),define(le[106],ue([0,1,5,36,32]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=_,e.verifyMicrosoftInternalDomain=R;function A(P){if(L.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function _(P,f,D,w,m,h,u,y,v){const d=Object.create(null);d["common.machineId"]=h,d["common.sqmId"]=u,d.sessionID=(0,O.generateUuid)()+Date.now(),d.commitHash=w,d.version=m,d["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,L.PlatformToString)(L.platform),d["common.nodePlatform"]=U.platform,d["common.nodeArch"]=D,d["common.product"]=v||"desktop",y&&(d["common.msftInternal"]=y);let g=0;const l=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),L.isLinuxSnap&&(d["common.snap"]="true");const c=A(f);return c&&(d["common.platformDetail"]=c),d}function R(P){const f=U.env.USERDNSDOMAIN;if(!f)return!1;const D=f.toLowerCase();return P.some(w=>D===w)}}),define(le[22],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(U||(e.TelemetryLevel=U={}));var O;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(le[228],ue([0,1,37,6,34,23,14,5,8,144,31,150,94,12,24,22]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=d,e.getMachineInfo=l,e.collectLaunchConfigs=c;const v=new Map;async function d(i,o){const n=`${i}::${o.join(":")}`,s=v.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,E=2e4;function C(I,p,k,N){const F=p.substring(I.length+1);return U.Promises.withAsyncBody(async x=>{let Z;try{Z=await D.Promises.readdir(p,{withFileTypes:!0})}catch{x();return}if(N.count>=E){N.count+=Z.length,N.maxReached=!0,x();return}let B=Z.length;if(B===0){x();return}let X=Z;N.count+Z.length>E&&(N.maxReached=!0,B=E-N.count,X=Z.slice(0,B)),N.count+=Z.length;for(const j of X)if(j.isDirectory()){if(k.includes(j.name)||await C(I,(0,_.join)(p,j.name),k,N),--B===0){x();return}}else{const G=j.name.lastIndexOf(".");if(G>=0){const z=j.name.substring(G+1);z&&r.set(z,(r.get(z)??0)+1)}for(const z of t)z.relativePathPattern?.test(F)!==!1&&z.filePattern.test(j.name)&&a.set(z.tag,(a.get(z.tag)??0)+1);if(--B===0){x();return}}})}const b=U.Promises.withAsyncBody(async I=>{const p={count:0,maxReached:!1};await C(i,i,o,p);const k=await c(i);I({configFiles:g(a),fileTypes:g(r),fileCount:p.count,maxFilesReached:p.maxReached,launchConfigFiles:k})});return v.set(n,b),b}function g(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function l(){const i={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.virtualMachineHint.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,_.join)(i,".vscode","launch.json"),s=await D.Promises.readFile(n),t=[],r=(0,O.parse)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,O.getNodeType)(r)==="object"&&r.configurations)for(const a of r.configurations){const E=a.type;E&&(o.has(E)?o.set(E,o.get(E)+1):o.set(E,1))}return g(o)}catch{return[]}}let S=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const s=L.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${L.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(f.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,w.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async s=>{let[t,r]=s,a=this.formatProcessList(o,t);return n.forEach(E=>{if((0,m.isRemoteDiagnosticError)(E))a+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(a+=`

Remote: ${E.hostName}`,E.processes&&(a+=`
${this.formatProcessList(o,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const C of Object.keys(E.workspaceMetadata)){const b=E.workspaceMetadata[C];let I=`${b.fileCount} files`;b.maxFilesReached&&(I=`more than ${I}`),r+=`|    Folder (${C}): ${I}`,r+=this.formatWorkspaceStats(b)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=l(),E={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(E.load=`${L.loadavg().map(C=>Math.round(C)).join(", ")}`),R.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(o,n){const s=[];return(0,w.listProcesses)(o.mainPID).then(async t=>(s.push(""),s.push(this.formatEnvironment(o)),s.push(""),s.push(this.formatProcessList(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(o))),n.forEach(r=>{if((0,m.isRemoteDiagnosticError)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.formatMachineInfo(r.machineInfo)),r.processes&&s.push(this.formatProcessList(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[a];let C=`${E.fileCount} files`;E.maxFilesReached&&(C=`more than ${C}`),s.push(`Folder (${a}): ${C}`),s.push(this.formatWorkspaceStats(E))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(o){const n=[];let t=0;const r=(b,I)=>{const p=` ${b}(${I})`;t+p.length>60?(n.push(a),a="|                 ",t=a.length):t+=p.length,a+=p};let a="|      File types:";const E=10,C=o.fileTypes.length>E?E:o.fileTypes.length;for(let b=0;b<C;b++){const I=o.fileTypes[b];r(I.name,I.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(b=>{r(b.name,b.count)}),n.push(a)),o.launchConfigFiles.length>0){let b="|      Launch Configs:";o.launchConfigFiles.forEach(I=>{const p=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;b+=p}),n.push(b)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=P.URI.revive(r);if(a.scheme===A.Schemas.file){const E=a.fsPath;s.push(d(E,["node_modules",".git"]).then(C=>{let b=`${C.fileCount} files`;C.maxFilesReached&&(b=`more than ${b}`),n.push(`|    Folder (${(0,_.basename)(E)}): ${b}`),n.push(this.formatWorkspaceStats(C))}).catch(C=>{n.push(`|      Error: Unable to collect workspace stats for folder ${E} (${C.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}formatProcessList(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,s,t,n,0),t.join(`
`)}formatProcessItem(o,n,s,t,r){const a=r===0;let E;a?E=t.pid===o?`${this.productService.applicationName} main`:"remote agent":n.has(t.pid)?E=n.get(t.pid):E=`${"  ".repeat(r)} ${t.name}`;const C=process.platform==="win32"?t.mem:L.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(C/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(t.children)&&t.children.forEach(b=>this.formatProcessItem(o,n,s,b,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=P.URI.revive(s);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await d(r,["node_modules",".git"])).fileTypes.forEach(E=>n.add(E.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=P.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const t=s.fsPath;try{const r=await d(t,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=S,e.DiagnosticsService=S=we([K(0,y.ITelemetryService),K(1,u.IProductService)],S)}),define(le[107],ue([0,1,7,4,9,22]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,U.createDecorator)("IExtensionSignatureVerificationService");let _=class{constructor(P,f){this.logService=P,this.telemetryService=f}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((P,f)=>se(["@vscode/vsce-sign"],async D=>P(D),f))),this.moduleLoadingPromise}async verify(P,f,D){let w;try{w=await this.vsceSign()}catch(y){return this.logService.error("Could not load vsce-sign module",(0,L.getErrorMessage)(y)),!1}const m=new Date().getTime();let h,u;try{return h=await w.verify(P,f,D),h}catch(y){throw u=y,y}finally{const y=new Date().getTime()-m;this.telemetryService.publicLog2("extensionsignature:verification",{duration:y,verified:h,error:u?u.code??"unknown":void 0})}}};e.ExtensionSignatureVerificationService=_,e.ExtensionSignatureVerificationService=_=we([K(0,O.ILogService),K(1,A.ITelemetryService)],_)}),define(le[108],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(A){this.appenders=A}listen(A,_){throw new Error(`Event not found: ${_}`)}call(A,_,{eventName:R,data:P}){return this.appenders.forEach(f=>f.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class U{constructor(A){this.channel=A}log(A,_){return this.channel.call("log",{eventName:A,data:_}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(le[49],ue([0,1,30,13,102,106,22]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=D,e.isLoggingOnly=w,e.getTelemetryLevel=m,e.validateTelemetryData=h,e.cleanRemoteAuthority=y,e.isInternalTelemetry=d,e.getPiiPathsFromEnvironment=g,e.cleanData=S;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class f{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.NullEndpointTelemetryService=f,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function w(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function m(i){const o=i.getValue(_.TELEMETRY_SETTING_ID),n=i.getValue(_.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function h(i){const o={},n={},s={};v(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(i){if(!i)return"none";const o=(0,O.getRemoteName)(i);return u.has(o)?o:"other"}function v(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,L.safeStringify)(r):r instanceof Date?o[a]=r.toISOString():(0,U.isObject)(r)?n<2?v(r,o,n+1,a+"."):o[a]=(0,L.safeStringify)(r):o[a]=r}}function d(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||s}function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function l(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const E of o)for(;;){const C=E.exec(i);if(!C)break;s.push([C.index,E.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const E=r.exec(i);if(!E)break;const C=s.some(([b,I])=>E.index<I&&b<r.lastIndex);!t.test(E[0])&&!C&&(n+=i.substring(a,E.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function S(i,o){return(0,L.cloneAndChange)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=l(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(le[33],ue([0,1,27,29,48,5,8,7,36,49]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=D,e.getIdAndVersion=u,e.getExtensionId=y,e.adoptToGalleryExtensionId=v,e.getGalleryExtensionId=d,e.groupByExtension=g,e.getLocalExtensionTelemetryData=l,e.getGalleryExtensionTelemetryData=c,e.getExtensionDependencies=S,e.computeTargetPlatform=o;function D(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,L.compareIgnoreCase)(n.id,s.id)===0}const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=w.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?D(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(n){const s=h.exec(n);return s&&s[1]?[v(s[1]),s[2]]:[v(n),void 0]}function y(n,s){return`${n}.${s}`}function v(n){return n.toLowerCase()}function d(n,s){return v(y(n??O.UNDEFINED_PUBLISHER,s))}function g(n,s){const t=[],r=a=>{for(const E of t)if(E.some(C=>D(s(C),s(a))))return E;return null};for(const a of n){const E=r(a);E?E.push(a):t.push([a])}return t}function l(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new f.TelemetryTrustedValue(n.identifier.id),name:new f.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function S(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(E=>!D(E.identifier,{id:a}))){const E=n.filter(C=>D(C.identifier,{id:a}));E.length===1&&(t.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!A.isLinux)return!1;let t;try{t=(await n.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,U.getTargetPlatform)(t?"alpine":A.platform,P.arch);return s.debug("ComputeTargetPlatform:",r),r}}),define(le[229],ue([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let u=class extends U.Disposable{constructor(l,c){super(),this.fileService=l,this.productService=c,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,S])=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(l){return this.getValidConfigBasedTips(l)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(l){const c=[];for(const[S,i]of this.allConfigBasedTips)if(!(i.configScheme&&i.configScheme!==l.scheme))try{const o=(await this.fileService.readFile((0,O.joinPath)(l,S))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.ExtensionTipsService=u,e.ExtensionTipsService=u=we([K(0,_.IFileService),K(1,R.IProductService)],u);const y="extensionTips/promptedExecutableTips",v="extensionTips/lastPromptedMediumImpExeTime";class d extends u{constructor(l,c,S,i,o,n,s,t){super(s,t),this.userHome=l,this.windowEvents=c,this.telemetryService=S,this.extensionManagementService=i,this.storageService=o,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const E=[],C=[],b=[];Object.entries(a.recommendations).forEach(([I,p])=>{p.important?a.important?E.push({extensionId:I,extensionName:p.name,isExtensionPack:!!p.isExtensionPack}):C.push({extensionId:I,extensionName:p.name,isExtensionPack:!!p.isExtensionPack}):b.push({extensionId:I,extensionName:p.name,isExtensionPack:!!p.isExtensionPack})}),E.length&&this.highImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),C.length&&this.mediumImportanceExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:C}),b.length&&this.allOtherExecutableTips.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b})}),(0,P.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...l,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),S=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(l,S),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,S)}groupImportantTipsByExe(l,c){const S=new Map;l.forEach(t=>S.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.groupByInstalled([...S.keys()],c);for(const t of i){const r=S.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=S.get(t);r&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.getPromptedExecutableTips(),s=new Map;for(const t of o){const r=S.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[l,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(S=>{switch(S){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(l);break;case"incompatibleWindow":{const i=f.Event.once(f.Event.latch(f.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(i(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const i=this._register(new U.MutableDisposable);i.value=(0,P.disposableTimeout)(()=>{i.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const l=this.getLastPromptedMediumExeTime(),c=Date.now()-l,S=7*24*60*60*1e3;if(c<S){const n=this._register(new U.MutableDisposable);n.value=(0,P.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},S-c);return}const[i,o]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(i),this.addToRecommendedExecutables(o[0].exeName,o);const s=this._register(new U.MutableDisposable);s.value=(0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},S);break}case"ignored":this.mediumImportanceTipsByExe.delete(i),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const s=f.Event.once(f.Event.latch(f.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(s(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new U.MutableDisposable);s.value=(0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(l){const c=await this.extensionManagementService.getInstalled(1),S=l.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,h.areSameExtensions)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:S,source:3,name:l[0].exeFriendlyName,searchValue:`@exe:"${l[0].exeName}"`})}getLastPromptedMediumExeTime(){let l=this.storageService.getNumber(v,-1);return l||(l=Date.now(),this.updateLastPromptedMediumExeTime(l)),l}updateLastPromptedMediumExeTime(l){this.storageService.store(v,l,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(y,-1,"{}"))}addToRecommendedExecutables(l,c){const S=this.getPromptedExecutableTips();S[l]=c.map(({extensionId:i})=>i.toLowerCase()),this.storageService.store(y,JSON.stringify(S),-1,0)}groupByInstalled(l,c){const S=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return l.forEach(n=>{o.has(n.toLowerCase())?S.push(n):i.push(n)}),{installed:S,uninstalled:i}}async getValidExecutableBasedExtensionTips(l){const c=[],S=new Map;for(const i of l.keys()){const o=l.get(i);if(!o||!(0,L.isNonEmptyArray)(o.recommendations))continue;const n=[];w.isWindows?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,D.join)("/usr/local/bin",i)),n.push((0,D.join)("/usr/bin",i)),n.push((0,D.join)(this.userHome.fsPath,i)));for(const s of n){let t=S.get(s);if(t===void 0&&(t=await this.fileService.exists(A.URI.file(s)),S.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:E,whenNotInstalled:C}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:E,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:C})}}return c}}e.AbstractNativeExtensionTipsService=d}),define(le[230],ue([0,1,26,33]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=O;async function O(A,_,R,P,f){try{const D=await A.getExtensionsControlManifest();if(!D.deprecated)return;const w=await A.getInstalled(1);for(const[m,h]of Object.entries(D.deprecated)){if(!h?.extension)continue;const{id:u,autoMigrate:y,preRelease:v}=h.extension;if(!y)continue;const d=w.find(l=>(0,U.areSameExtensions)(l.identifier,{id:m}));if(!d)continue;const g=(await _.getExtensions([{id:u,preRelease:v}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!g){f.info(`Skipping migrating '${d.identifier.id}' extension because, the comaptible target '${u}' extension is not found`);continue}try{f.info(`Migrating '${d.identifier.id}' extension to '${u}' extension...`);const l=!P.getDisabledExtensions().some(S=>(0,U.areSameExtensions)(S,d.identifier));await A.uninstall(d),f.info(`Uninstalled the unsupported extension '${d.identifier.id}'`);let c=w.find(S=>(0,U.areSameExtensions)(S.identifier,{id:u}));(!c||!c.isPreReleaseVersion&&l)&&(c=await A.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:d.isMachineScoped,operation:4}),f.info(`Installed the pre-release extension '${c.identifier.id}'`),l||(await P.disableExtension(c.identifier),f.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${d.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,U.getExtensionId)(d.manifest.publisher,d.manifest.name),(0,U.getExtensionId)(c.manifest.publisher,c.manifest.name)),f.info("Added pre-release extension to the storage migration list"))),f.info(`Migrated '${d.identifier.id}' extension to '${u}' extension.`)}catch(l){f.error(l)}}}catch(D){f.error(D)}}}),define(le[231],ue([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let c=class extends O.Disposable{static{l=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(i,o,n,s,t,r){super(),this.fileService=o,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(i,o,n){await this.cleanUpPromise;const s=(0,_.joinPath)(this.extensionsDownloadDir,this.getName(i));try{await this.downloadFile(i,s,r=>this.extensionGalleryService.download(i,r,o))}catch(r){throw new u.ExtensionManagementError(r.message,u.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.shouldVerifySignature(i)){const r=await this.downloadSignatureArchive(i);try{t=await this.extensionSignatureVerificationService.verify(s.fsPath,r.fsPath,this.logService.getLevel()===g.LogLevel.Trace)}catch(a){const E=a;if(t=E.code,E.output&&this.logService.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${E.output}`),t===u.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===u.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(C){this.logService.error(C)}throw new u.ExtensionManagementError(w.CorruptZipMessage,u.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.logService.error(a)}}}return t===!0?this.logService.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.logService.info(`Extension signature verification is not done: ${i.identifier.id}`):this.logService.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}shouldVerifySignature(i){if(!i.isSigned)return this.logService.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.configurationService.getValue("extensions.verifySignature");return(0,P.isBoolean)(o)?o:!0}async downloadSignatureArchive(i){await this.cleanUpPromise;const o=(0,_.joinPath)(this.extensionsDownloadDir,`${this.getName(i)}${l.SignatureArchiveExtension}`);try{await this.downloadFile(i,o,n=>this.extensionGalleryService.downloadSignatureArchive(i,n))}catch(n){throw new u.ExtensionManagementError(n.message,u.ExtensionManagementErrorCode.DownloadSignature)}return o}async downloadFile(i,o,n){if(await this.fileService.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const s=(0,_.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(s)||await n(s);try{await D.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.fileService.del(s)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.logService.info(`Rename failed because of ${(0,U.getErrorMessage)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.cleanUpPromise,await this.fileService.del(i)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(l.SignatureArchiveExtension))s.push(a.resource);else{const E=y.ExtensionKey.parse(a.name);E&&n.push([E,a])}const t=(0,y.groupByExtension)(n,([a])=>a),r=[];for(const a of t)a.sort((E,C)=>R.rcompare(E[0].version,C[0].version)),o.push(...a.slice(1).map(E=>E[1].resource)),r.push(a[0][1]);r.sort((a,E)=>a.mtime-E.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(a=>a.resource)),o.push(...s),await L.Promises.settled(o.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(i){this.logService.error(i)}}getName(i){return this.cache?y.ExtensionKey.create(i).toString().toLowerCase():(0,f.generateUuid)()}};e.ExtensionsDownloader=c,e.ExtensionsDownloader=c=l=we([K(0,h.INativeEnvironmentService),K(1,d.IFileService),K(2,u.IExtensionGalleryService),K(3,m.IConfigurationService),K(4,v.IExtensionSignatureVerificationService),K(5,g.ILogService)],c)}),define(le[232],ue([0,1,3,2,35,33,48]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends U.Disposable{constructor(f,D,w,m,h,u,y){super(),this.extensionManagementService=f,this.extensionsScannerService=D,this.userDataProfilesService=w,this.extensionsProfileScannerService=m,this.uriIdentityService=h,this.fileService=u,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new U.DisposableMap),this.initialize().then(null,v=>y.error(v))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(f=>this.onDidChangeProfiles(f.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(f=>this.onAddExtensions(f))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(f=>this.onDidAddExtensions(f))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(f=>this.onRemoveExtensions(f))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(f=>this.onDidRemoveExtensions(f))),this._register(this.fileService.onDidFilesChange(f=>this.onDidFilesChange(f)))}async onDidChangeProfiles(f){try{f.length&&await Promise.all(f.map(D=>(this.extensionsProfileWatchDisposables.set(D.id,(0,U.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(D.extensionsResource)),this.fileService.watch(D.extensionsResource))),this.populateExtensionsFromProfile(D.extensionsResource))))}catch(D){throw this.logService.error(D),D}}async onAddExtensions(f){for(const D of f.extensions)this.addExtensionWithKey(this.getKey(D.identifier,D.version),f.profileLocation)}async onDidAddExtensions(f){for(const D of f.extensions){const w=this.getKey(D.identifier,D.version);f.error?this.removeExtensionWithKey(w,f.profileLocation):this.addExtensionWithKey(w,f.profileLocation)}}async onRemoveExtensions(f){for(const D of f.extensions)this.removeExtensionWithKey(this.getKey(D.identifier,D.version),f.profileLocation)}async onDidRemoveExtensions(f){const D=[],w=[];for(const m of f.extensions){const h=this.getKey(m.identifier,m.version);f.error?this.addExtensionWithKey(h,f.profileLocation):(this.removeExtensionWithKey(h,f.profileLocation),this.allExtensions.has(h)||(this.logService.debug("Extension is removed from all profiles",m.identifier.id,m.version),w.push(this.extensionManagementService.scanInstalledExtensionAtLocation(m.location).then(u=>{u?D.push(u):this.logService.info("Extension not found at the location",m.location.toString())},u=>this.logService.error(u)))))}try{await Promise.all(w),D.length&&await this.uninstallExtensionsNotInProfiles(D)}catch(m){this.logService.error(m)}}onDidFilesChange(f){for(const D of this.userDataProfilesService.profiles)f.contains(D.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(D.extensionsResource)}async onDidExtensionsProfileChange(f){const D=[],w=[],m=await this.extensionsProfileScannerService.scanProfileExtensions(f),h=new Set,u=new Set;for(const[y,v]of this.allExtensions)v.has(f)&&u.add(y);for(const y of m){const v=this.getKey(y.identifier,y.version);h.add(v),u.has(v)||(D.push(y.identifier),this.addExtensionWithKey(v,f))}for(const y of u)if(!h.has(y)){const v=this.fromKey(y);v&&(w.push(v.identifier),this.removeExtensionWithKey(y,f))}(D.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:D.length?{extensions:D,profileLocation:f}:void 0,removed:w.length?{extensions:w,profileLocation:f}:void 0})}async populateExtensionsFromProfile(f){const D=await this.extensionsProfileScannerService.scanProfileExtensions(f);for(const w of D)this.addExtensionWithKey(this.getKey(w.identifier,w.version),f)}async uninstallExtensionsNotInProfiles(f){f||(f=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(w=>!this.allExtensions.has(this.getKey(w.identifier,w.manifest.version)))),f.length&&await this.extensionManagementService.markAsUninstalled(...f)}addExtensionWithKey(f,D){let w=this.allExtensions.get(f);w||this.allExtensions.set(f,w=new O.ResourceSet(m=>this.uriIdentityService.extUri.getComparisonKey(m))),w.add(D)}removeExtensionWithKey(f,D){const w=this.allExtensions.get(f);w&&w.delete(D),w?.size||this.allExtensions.delete(f)}getKey(f,D){return`${_.ExtensionIdentifier.toKey(f.id)}@${D}`}fromKey(f){const[D,w]=(0,A.getIdAndVersion)(f);return w?{identifier:{id:D},version:w}:void 0}}e.ExtensionsWatcher=R}),define(le[233],ue([0,1,45,49]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=O;async function O(A,_,R,P,f,D,w){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${_.nameShort})`};if((0,U.supportsTelemetry)(_,R)&&(0,U.getTelemetryLevel)(P)===3){const h=await(0,L.getServiceMachineId)(R,f,D);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=w.machineId||h}return m}}),define(le[234],ue([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends h.LanguagePackBaseService{constructor(l,c,S,i){super(S),this.extensionManagementService=l,this.logService=i,this.cache=this._register(new v(c,i)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getBuiltInExtensionTranslationsUri(l,c){const i=(await this.cache.getLanguagePacks())[c];if(!i){this.logService.warn(`No language pack found for ${c}`);return}const o=i.translations[l];return o?u.URI.file(o):void 0}async getInstalledLanguages(){const l=await this.cache.getLanguagePacks(),c=Object.keys(l).map(S=>{const i=l[S];return{...this.createQuickPickItem(S,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.createQuickPickItem("en","English")),c.sort((S,i)=>S.label.localeCompare(i.label)),c}async postInstallExtension(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",l.identifier.id),await this.update())}async postUninstallExtension(l){const c=await this.cache.getLanguagePacks();Object.keys(c).some(S=>c[S]&&c[S].extensions.some(i=>(0,w.areSameExtensions)(i.extensionIdentifier,l.identifier)))&&(this.logService.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(c);return!(0,U.equals)(Object.keys(l),Object.keys(S))}};e.NativeLanguagePackService=y,e.NativeLanguagePackService=y=we([K(0,D.IExtensionManagementService),K(1,f.INativeEnvironmentService),K(2,D.IExtensionGalleryService),K(3,m.ILogService)],y);let v=class extends A.Disposable{constructor(l,c){super(),this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(l.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new O.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(l){return this.withLanguagePacks(c=>{Object.keys(c).forEach(S=>delete c[S]),this.createLanguagePacksFromExtensions(c,...l)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(l,...c){for(const S of c)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(l,S);Object.keys(l).forEach(S=>this.updateHash(l[S]))}createLanguagePacksFromExtension(l,c){const S=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===_.Schemas.file&&d(o)){let n=l[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},l[o.languageId]=n);const s=n.extensions.filter(t=>(0,w.areSameExtensions)(t.extensionIdentifier,S))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:S,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.join)(c.location.fsPath,t.path)}}updateHash(l){if(l){const c=(0,L.createHash)("md5");for(const S of l.extensions)c.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);l.hash=c.digest("hex")}}withLanguagePacks(l=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(c=l(S),S)).then(S=>{for(const o of Object.keys(S))S[o]||delete S[o];this.languagePacks=S,this.initializedCache=!0;const i=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",i),P.Promises.writeFile(this.languagePacksFilePath,i)}).then(()=>c,S=>this.logService.error(S))})}};v=we([K(0,f.INativeEnvironmentService),K(1,m.ILogService)],v);function d(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const l of g.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(le[235],ue([0,1,143,7,30,49]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const _="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function P(D,w,m){const h=await(0,L.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),u=await(0,L.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new h.AppInsightsCore,v=new u.PostChannel,d={instrumentationKey:D,endpointUrl:_,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(m){d.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};d.extensionConfig[v.identifier]=g}return y.initialize(d,[]),y.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',w&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),y}class f{constructor(w,m,h,u,y){this._isInternalTelemetry=w,this._eventPrefix=m,this._defaultData=h,this._xhrOverride=y,this.endPointUrl=_,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof u=="function"?this._aiCoreOrKey=u():this._aiCoreOrKey=u,this._asyncAiCore=null}_withAIClient(w){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(m=>{w(m)},m=>{(0,U.onUnexpectedError)(m),console.error(m)})}}log(w,m){if(!this._aiCoreOrKey)return;m=(0,O.mixin)(m,this._defaultData),m=(0,A.validateTelemetryData)(m);const h=this._eventPrefix+"/"+w;try{this._withAIClient(u=>{u.pluginVersionString=m?.properties.version??"Unknown",u.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(m=>{m.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(le[109],ue([0,1,2,172,16,9,24,49]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=class extends L.Disposable{constructor(D,w,m,h,u=""){super(),this.prefix=u;const y=w.getLogger(R.telemetryLogId);if(y)this.logger=this._register(y);else{const d=(0,R.isLoggingOnly)(h,m)?" (Not Sent)":"",g=()=>(0,R.supportsTelemetry)(h,m)&&D.getLevel()===A.LogLevel.Trace;this.logger=this._register(w.createLogger(R.telemetryLogId,{name:(0,U.localize)(0,null,d),hidden:!g()})),this._register(D.onDidChangeLogLevel(()=>w.setVisibility(R.telemetryLogId,g()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(D,w){this.logger.trace(`${this.prefix}telemetry/${D}`,(0,R.validateTelemetryData)(w))}};e.TelemetryLogAppender=P,e.TelemetryLogAppender=P=we([K(0,A.ILogService),K(1,A.ILoggerService),K(2,O.IEnvironmentService),K(3,_.IProductService)],P)}),define(le[110],ue([0,1,2,30,5,27,173,21,47,100,24,42,22,49]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let u=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,g,l){this._configurationService=g,this._productService=l,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c),"gi")),c.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(c.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.TELEMETRY_SETTING_ID)||c.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||c.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(d,g){this._experimentProperties[d]=g}_updateTelemetryLevel(){let d=(0,h.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const l=g.usage?3:g.error?2:0;d=Math.min(d,l)}this._telemetryLevel=d}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(d,g,l){this._telemetryLevel<g||(l=(0,U.mixin)(l,this._experimentProperties),l=(0,h.cleanData)(l,this._cleanupPatterns),l=(0,U.mixin)(l,this._commonProperties),this._appenders.forEach(c=>c.log(d,l)))}publicLog(d,g){this._log(d,3,g)}publicLog2(d,g){this.publicLog(d,g)}publicLogError(d,g){this._sendErrorTelemetry&&this._log(d,2,g)}publicLogError2(d,g){this.publicLogError(d,g)}};e.TelemetryService=u,e.TelemetryService=u=we([K(1,R.IConfigurationService),K(2,D.IProductService)],u);function y(){const v=(0,_.localize)(0,null,f.default.nameLong),d=f.default.privacyStatementUrl?(0,_.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,_.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=O.isWeb?"":(0,_.localize)(3,null),l=(0,_.localize)(4,null),c=(0,_.localize)(5,null),S=(0,_.localize)(6,null),i=(0,_.localize)(7,null),o=`
|       | ${l} | ${c} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,_.localize)(8,null);return`
${v} ${d} ${g}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}w.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,_.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,_.localize)(10,null),(0,_.localize)(11,null),(0,_.localize)(12,null),(0,_.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,_.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,_.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,_.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,_.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[236],ue([0,1,15,26,278,235]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function _(D,w){const m=await w.request(D,U.CancellationToken.None),h=(await(0,L.streamToBuffer)(m.stream)).toString(),u=m.res.statusCode??200;return{headers:m.res.headers,statusCode:u,responseData:h}}async function R(D){const w={method:D.type,headers:D.headers};return new Promise((h,u)=>{const y=O.request(D.url??"",w,v=>{v.on("data",function(d){h({headers:v.headers,statusCode:v.statusCode??200,responseData:d.toString()})}),v.on("error",function(d){u(d)})});y.write(D.data,v=>{v&&u(v)}),y.end()})}async function P(D,w,m){const h=typeof w.data=="string"?w.data:new TextDecoder().decode(w.data),u={type:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data).toString()},url:w.urlString,data:h};try{const y=D?await _(u,D):await R(u);m(y.statusCode,y.headers,y.responseData)}catch{m(0,{})}}class f extends A.AbstractOneDataSystemAppender{constructor(w,m,h,u,y){const v={sendPOST:(d,g)=>{P(w,d,g)}};super(m,h,u,y,v)}}e.OneDataSystemAppender=f}),define(le[237],ue([0,1,23,92,21,16,9,24,22,108,109,110]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(u,y,v,d,g,l){this.configurationService=u,this.telemetryService=y,this.logService=v,this.loggerService=d,this.environmentService=g,this.productService=l,this.customTelemetryServices=new Map}getCustomTelemetryService(u){if(!this.customTelemetryServices.has(u.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.telemetryService.machineId,y["common.vscodesessionid"]=this.telemetryService.sessionId;const v=[u.id,JSON.stringify(y),u.aiKey],g=new U.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:v,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new f.TelemetryAppenderClient(g),new D.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${u.id}] `)];this.customTelemetryServices.set(u.id,new w.TelemetryService({appenders:l,sendErrorTelemetry:u.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(u.id)}publicLog(u,y,v){this.getCustomTelemetryService(u).publicLog(y,v)}publicLogError(u,y,v){this.getCustomTelemetryService(u).publicLogError(y,v)}};e.CustomEndpointTelemetryService=m,e.CustomEndpointTelemetryService=m=we([K(0,O.IConfigurationService),K(1,P.ITelemetryService),K(2,_.ILogService),K(3,_.ILoggerService),K(4,A.IEnvironmentService),K(5,R.IProductService)],m)}),define(le[78],ue([0,1,3,8,21,4,9]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=f,e.extractLocalHostUriMetaDataForPortMapping=w,e.extractQueryLocalHostUriMetaDataForPortMapping=m,e.isLocalhost=h,e.isAllInterfaces=u,e.isPortPrivileged=y,e.ITunnelService=(0,A.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,A.createDecorator)("sharedTunnelsService");var R;(function(g){g.Http="http",g.Https="https"})(R||(e.TunnelProtocol=R={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f(g){return!!g.forwardPort}var D;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(D||(e.ProvidedOnAutoForward=D={}));function w(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(l)return{address:l[1],port:+l[2]}}function m(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const l=g.query.split("&");for(const c of l){const S=c.split("=")[1];if(/^https?:/.exec(S)){const i=w(U.URI.parse(S));if(i)return i}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}function y(g,l,c,S){if(c===1)return!1;if(c===2&&u(l)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(S);if(i?.length===4&&parseInt(i[1])>=18)return!1}return g<1024}class v{constructor(l,c,S){this.remoteAddress=l,this.localAddress=c,this._dispose=S,this._onDispose=new L.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let d=class{constructor(l,c){this.logService=l,this.configurationService=c,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this._tunnelProvider=l,l?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this._canElevate=l.elevation,this._privacyOptions=l.privacyOptions,this._canChangeProtocol=l.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const l=[],c=Array.from(this._tunnels.values());for(const S of c){const i=Array.from(S.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&l.push(n)}}return l}async dispose(){for(const l of this._tunnels.values()){for(const{value:c}of l.values())await c.then(S=>typeof S!="string"?S?.dispose():void 0);l.clear()}this._tunnels.clear()}setEnvironmentTunnel(l,c,S,i,o){this.addTunnelToMap(l,c,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:c,localAddress:S,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,c){(u(l)||h(l))&&(l=e.LOCALHOST_ADDRESSES[0]);const S=this.getTunnelFromMap(l,c);if(S)return++S.refcount,S.value}openTunnel(l,c,S,i,o,n=!1,s,t){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${S} on local port ${o}.`);const r=this._tunnelProvider??l;if(!r)return;if(c||(c="localhost"),i||(i=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.retainOrCreateTunnel(r,c,S,i,o,n,s,t);return a?a.then(E=>{if(E){if(typeof E=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(c,S),E}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(c,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.makeTunnel(E);return(E.tunnelRemoteHost!==c||E.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&E.privacy!==s&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(C),C}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this._tunnels.get(l.tunnelRemoteHost);if(c){const S=c.get(l.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,S))}}}}async tryDisposeTunnel(l,c,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const i=S.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(c),i}}async closeTunnel(l,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const S=this._tunnels.get(l);if(S&&S.has(c)){const i=S.get(c);i.refcount=0,await this.tryDisposeTunnel(l,c,i)}}addTunnelToMap(l,c,S){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(c,{refcount:1,value:S})}async removeEmptyOrErrorTunnelFromMap(l,c){const S=this._tunnels.get(l);if(S){const i=S.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&S.delete(c),S.size===0&&this._tunnels.delete(l)}}getTunnelFromMap(l,c){const S=[l];h(l)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):u(l)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const i=S.map(o=>this._tunnels.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(l){return!!w(l)}createWithProvider(l,c,S,i,o,n,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${S} on local port ${i}.`);const t=S;this._factoryInProgress.add(t);const r=i===void 0?S:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},E={remoteAddress:{host:c,port:S},localAddressPort:i,privacy:n,public:n?n!==P.Private:void 0,protocol:s},C=l.forwardPort(E,a);return C?(this.addTunnelToMap(c,S,C),C.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(t)})):this._factoryInProgress.delete(t),C}};e.AbstractTunnelService=d,e.AbstractTunnelService=d=we([K(0,_.ILogService),K(1,O.IConfigurationService)],d)}),define(le[238],ue([0,1,9,78,2,7,6]),function(se,e,L,U,O,A,_){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends O.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new _.DeferredPromise),this._addressPromise.p)}setAddress(w){this._address=w,this._addressPromise&&(this._addressPromise.complete(w),this._addressPromise=null)}setTunnel(w){this._register(w)}}let f=class extends O.Disposable{static{R=this}static{this._lastId=0}constructor(w,m){super(),this._tunnelService=w,this._logService=m,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(w=>w.dispose())}async createTunnel(){return{id:String(++R._lastId)}}async startTunnel(w,m,h,u,y,v,d){const g=new P,l=await Promise.resolve(this._tunnelService.openTunnel(w,g,h,u,y,v,d));if(!l||typeof l=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${u} (remote).`),g.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(m))throw this._disposedTunnels.delete(m),g.dispose(),await l.dispose(),(0,A.canceled)();return g.setTunnel(l),this._tunnels.set(m,g),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${l.localAddress} (local) to ${h}:${u} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(w,m){const h=this._tunnels.get(w);h&&h.setAddress(m)}async destroyTunnel(w){const m=this._tunnels.get(w);if(m){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${w}.`),this._tunnels.delete(w),await m.dispose();return}this._disposedTunnels.add(w)}};e.SharedProcessTunnelService=f,e.SharedProcessTunnelService=f=R=we([K(0,U.ISharedTunnelsService),K(1,L.ILogService)],f)}),define(le[28],ue([0,1,4]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(le[239],ue([0,1,28,191,12,20,128,3,2]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class f{static{this._clock=0}constructor(m){this.uri=m,this.time=f._clock++}touch(){return this.time=f._clock++,this}}let D=class{constructor(m){this._fileService=m,this._dispooables=new P.DisposableStore,this._limit=2**16;const h=new Map,u=y=>{let v=h.get(y.scheme);return v===void 0&&(v=m.hasProvider(y)&&!this._fileService.hasCapability(y,1024),h.set(y.scheme,v)),v};this._dispooables.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new A.ExtUri(u),this._canonicalUris=new _.SkipList((y,v)=>this.extUri.compare(y,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,A.normalizePath)(m));const h=this._canonicalUris.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new f(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((u,y)=>u[1].time<y[1].time?1:u[1].time>y[1].time?-1:0);f._clock=0,this._canonicalUris.clear();const h=this._limit*.5;for(let u=0;u<h;u++)this._canonicalUris.set(m[u][0],m[u][1].touch())}};e.UriIdentityService=D,e.UriIdentityService=D=we([K(0,O.IFileService)],D),(0,U.registerSingleton)(L.IUriIdentityService,D,1)}),define(le[240],ue([0,1,3,2,12,51,35]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends U.Disposable{constructor(f,D,w,m,h,u){super(),this.fileSystemScheme=f,this.fileSystemProvider=D,this.userDataScheme=w,this.userDataProfilesService=m,this.uriIdentityService=h,this.logService=u,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new _.ResourceSet(y=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(y))),this.updateAtomicReadWritesResources(),this._register(m.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const f of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(f.settingsResource),this.atomicReadWriteResources.add(f.keybindingsResource),this.atomicReadWriteResources.add(f.tasksResource),this.atomicReadWriteResources.add(f.extensionsResource)}open(f,D){return this.fileSystemProvider.open(this.toFileSystemResource(f),D)}close(f){return this.fileSystemProvider.close(f)}read(f,D,w,m,h){return this.fileSystemProvider.read(f,D,w,m,h)}write(f,D,w,m,h){return this.fileSystemProvider.write(f,D,w,m,h)}watch(f,D){this.watchResources.set(f,f);const w=this.fileSystemProvider.watch(this.toFileSystemResource(f),D);return(0,U.toDisposable)(()=>{this.watchResources.delete(f),w.dispose()})}stat(f){return this.fileSystemProvider.stat(this.toFileSystemResource(f))}mkdir(f){return this.fileSystemProvider.mkdir(this.toFileSystemResource(f))}rename(f,D,w){return this.fileSystemProvider.rename(this.toFileSystemResource(f),this.toFileSystemResource(D),w)}readFile(f,D){return this.fileSystemProvider.readFile(this.toFileSystemResource(f),D)}readFileStream(f,D,w){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(f),D,w)}readdir(f){return this.fileSystemProvider.readdir(this.toFileSystemResource(f))}enforceAtomicReadFile(f){return this.atomicReadWriteResources.has(f)}writeFile(f,D,w){return this.fileSystemProvider.writeFile(this.toFileSystemResource(f),D,w)}enforceAtomicWriteFile(f){return this.atomicReadWriteResources.has(f)?{postfix:".vsctmp"}:!1}delete(f,D){return this.fileSystemProvider.delete(this.toFileSystemResource(f),D)}copy(f,D,w){if((0,O.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(f),this.toFileSystemResource(D),w);throw new Error("copy not supported")}cloneFile(f,D){if((0,O.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(f),this.toFileSystemResource(D));throw new Error("clone not supported")}handleFileChanges(f){const D=[];for(const w of f){if(w.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(w.resource);this.watchResources.findSubstr(m)&&D.push({resource:m,type:w.type,cId:w.cId})}D.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(D))}toFileSystemResource(f){return f.with({scheme:this.fileSystemScheme})}toUserDataResource(f){return f.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(le[79],ue([0,1,62]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=U,e.getLineStartOffset=O,e.getLineEndOffset=A;function U(_,R,P,f){const D=(0,L.setProperty)(_,R,P,f)[0];return D&&(_=_.substring(0,D.offset)+D.content+_.substring(D.offset+D.length)),_}function O(_,R,P){let f=P;for(;f>=0;){if(_.charAt(f)===R.charAt(R.length-1)&&R.length===1)return f+1;if(f--,R.length===2&&f>=0&&_.charAt(f)===R.charAt(0))return f+2}return 0}function A(_,R,P){let f=P;for(;f>=0;)if(_.charAt(f)===R.charAt(R.length-1)&&R.length===1||(f++,R.length===2&&f>=0&&_.charAt(f)===R.charAt(1)))return f;return _.length-1}}),define(le[241],ue([0,1,30,55,13]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=A;function A(h,u,y,v,d,g){const l=[],c=[],S=[];if(!u){const x=h.filter(({identifier:Z})=>d.every(B=>B.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:l,removed:c,updated:S},remote:x.length>0?{added:x,updated:[],removed:[],all:x}:null}}h=h.map(w),u=u.map(w),y=y?y.map(w):null;const i=new Map,o=x=>{x.uuid&&i.set(x.id.toLowerCase(),x.uuid)};h.forEach(({identifier:x})=>o(x)),u.forEach(({identifier:x})=>o(x)),y?.forEach(({identifier:x})=>o(x)),v?.forEach(({identifier:x})=>o(x)),g?.forEach(x=>o(x));const n=x=>{const Z=x.identifier.uuid||i.get(x.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${x.identifier.id.toLowerCase()}`},s=(x,Z)=>(x.set(n(Z),Z),x),t=h.reduce(s,new Map),r=u.reduce(s,new Map),a=u.reduce((x,Z)=>s(x,(0,L.deepClone)(Z)),new Map),E=y?y.reduce(s,new Map):null,C=v.reduce(s,new Map),b=d.reduce((x,Z)=>{const B=i.get(Z.toLowerCase());return x.add(B?`uuid:${B}`:`id:${Z.toLowerCase()}`)},new Set),I=g?g.reduce((x,{id:Z,uuid:B})=>(B=B??i.get(Z.toLowerCase()),x.add(B?`uuid:${B}`:`id:${Z.toLowerCase()}`)),new Set):null,p=_(t,r,b,!1);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const x=_(E,t,b,!1),Z=_(E,r,b,!0),B=(X,j,G,z)=>{let q,ie,ae;return j.installed?(q=z.pinned,ae=z.preRelease,q&&(ie=z.version)):(q=G.pinned,ae=G.preRelease,q&&(ie=G.version)),q===void 0&&(q=j.pinned,q&&(ie=j.version)),ae===void 0&&(ae=j.preRelease),{...z,installed:j.installed||G.installed,pinned:q,preRelease:ae,version:ie??(G.version&&(!j.installed||U.gt(G.version,j.version))?G.version:j.version),state:P(j,G,E?.get(X))}};for(const X of Z.removed.values()){const j=t.get(X);if(!j)continue;const G=(0,O.assertIsDefined)(E?.get(X)),z=I&&!I.has(X)&&G.installed;j.installed&&z?c.push(j.identifier):a.set(X,j)}for(const X of Z.added.values()){const j=(0,O.assertIsDefined)(r.get(X)),G=t.get(X);if(G){if(p.updated.has(X)){const z=B(X,G,j,j);R(G,j,!1,!1)||S.push(m(z,X)),a.set(X,z)}}else j.installed&&l.push(m(j,X))}for(const X of Z.updated.values()){const j=(0,O.assertIsDefined)(r.get(X)),G=(0,O.assertIsDefined)(E?.get(X)),z=t.get(X);if(z)if(I&&!I.has(X)&&G.installed&&z.installed&&!j.installed)c.push(z.identifier);else{const ie=B(X,z,j,j);S.push(m(ie,X)),a.set(X,ie)}else j.installed&&l.push(m(j,X))}for(const X of x.added.values())Z.added.has(X)||a.set(X,(0,O.assertIsDefined)(t.get(X)));for(const X of x.updated.values()){if(Z.removed.has(X)||Z.updated.has(X))continue;const j=(0,O.assertIsDefined)(t.get(X)),G=(0,O.assertIsDefined)(r.get(X));a.set(X,B(X,j,G,j))}for(const X of x.removed.values())Z.updated.has(X)||Z.removed.has(X)||C.has(X)||(0,O.assertIsDefined)(r.get(X)).installed&&I&&(I.has(X)||!(0,O.assertIsDefined)(E?.get(X)).installed||a.delete(X))}const k=[],N=_(r,a,new Set,!0),F=N.added.size>0||N.updated.size>0||N.removed.size>0;return F&&a.forEach((x,Z)=>k.push(m(x,Z))),{local:{added:l,removed:c,updated:S},remote:F?{added:[...N.added].map(x=>a.get(x)),updated:[...N.updated].map(x=>a.get(x)),removed:[...N.removed].map(x=>r.get(x)),all:k}:null}}function _(h,u,y,v){const d=h?[...h.keys()].filter(i=>!y.has(i)):[],g=[...u.keys()].filter(i=>!y.has(i)),l=g.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=d.filter(i=>!g.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),S=new Set;for(const i of d){if(c.has(i))continue;const o=h.get(i),n=u.get(i);(!n||!R(o,n,v,!0))&&S.add(i)}return{added:l,removed:c,updated:S}}function R(h,u,y,v){return!(h.disabled!==u.disabled||!!h.isApplicationScoped!=!!u.isApplicationScoped||v&&h.installed!==u.installed||h.installed&&u.installed&&(h.preRelease!==u.preRelease||h.pinned!==u.pinned||u.pinned&&h.version!==u.version)||!D(h.state,u.state)||y&&h.version!==u.version)}function P(h,u,y){const v=h.state,d=u.state,g=y?.state;if(!u.version||v&&U.gt(h.version,u.version))return v;if(d&&U.gt(u.version,h.version)||!v)return d;if(!d)return v;const l=(0,L.deepClone)(v),c=g?f(g,d):{added:Object.keys(d).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},S=g?f(g,v):{added:Object.keys(v).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])l[i]=d[i];for(const i of c.removed.values())S.updated.has(i)||delete l[i];return l}function f(h,u){const y=Object.keys(h),v=Object.keys(u),d=v.filter(c=>!y.includes(c)).reduce((c,S)=>(c.add(S),c),new Set),g=y.filter(c=>!v.includes(c)).reduce((c,S)=>(c.add(S),c),new Set),l=new Set;for(const c of y){if(g.has(c))continue;const S=h[c],i=u[c];(0,L.equals)(S,i)||l.add(c)}return{added:d,removed:g,updated:l}}function D(h={},u={}){const{added:y,removed:v,updated:d}=f(h,u);return y.size===0&&v.size===0&&d.size===0}function w(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function m(h,u){const y={...h,identifier:{id:h.identifier.id,uuid:u.startsWith("uuid:")?u.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete y.disabled,h.installed||delete y.installed,h.state||delete y.state,h.isApplicationScoped||delete y.isApplicationScoped,y}}),define(le[111],ue([0,1,17,21,4]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,O.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let f=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return f=f.filter(D=>D!==R&&D!==`-${R}`),P&&f.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}updateSynchronizedExtensions(R,P){let f=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(D=>D.toLowerCase());return f=f.filter(D=>D!==R&&D!==`-${R}`),P&&f.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",f.length?f:void 0,2)}getIgnoredExtensions(R){const P=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),f=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),D=[],w=[];if(Array.isArray(f))for(const m of f)m.startsWith("-")?w.push(m.substring(1)):D.push(m);return(0,L.distinct)([...P,...D].filter(m=>!w.includes(m)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.IgnoredExtensionsManagementService=A,e.IgnoredExtensionsManagementService=A=we([K(0,U.IConfigurationService)],A)}),define(le[242],ue([0,1,17,34,30,93,79]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=P;function R(c){return(0,U.parse)(c)||[]}async function P(c,S,i,o,n){const s=R(c),t=R(S),r=i?R(i):null,a=[...s,...t,...r||[]].map(B=>B.key),E=await n.resolveUserBindings(a),C=D(s,t,r,E);if(!C.hasLocalForwarded&&!C.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!C.hasLocalForwarded&&C.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};if(C.hasLocalForwarded&&!C.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const b=m(s),I=m(t),p=r?m(r):null,k=u(b,I,E),N=p?u(p,b,E):{added:[...b.keys()].reduce((B,X)=>(B.add(X),B),new Set),removed:new Set,updated:new Set},F=p?u(p,I,E):{added:[...I.keys()].reduce((B,X)=>(B.add(X),B),new Set),removed:new Set,updated:new Set},x=f(k,N,F);let Z=c;for(const B of x.removed.values())x.conflicts.has(B)||(Z=g(Z,B,o));for(const B of x.added.values()){if(x.conflicts.has(B))continue;const X=I.get(B);if(X.some(j=>j.command!==`-${B}`&&C.conflicts.has(E[j.key]))){x.conflicts.add(B);continue}Z=d(Z,X,o)}for(const B of x.updated.values()){if(x.conflicts.has(B))continue;const X=I.get(B);if(X.some(j=>j.command!==`-${B}`&&C.conflicts.has(E[j.key]))){x.conflicts.add(B);continue}Z=l(Z,B,X,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:x.conflicts.size>0}}function f(c,S,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of S.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(S.updated.has(r)?t.add(r):n.add(r));for(const r of S.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(S.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of S.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(S.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function D(c,S,i,o){const n=new Set,s=w(c,o),t=w(S,o),r=i?w(i,o):null,a=h(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const E=r?h(r,s):{added:[...s.keys()].reduce((N,F)=>(N.add(F),N),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const C=r?h(r,t):{added:[...t.keys()].reduce((N,F)=>(N.add(F),N),new Set),removed:new Set,updated:new Set};if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:b,removed:I,updated:p,conflicts:k}=f(a,E,C);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:b,removed:I,updated:p,conflicts:k}}function w(c,S){const i=new Map;for(const o of c){const n=S[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const S=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=S.get(o);n||(n=[],S.set(o,n)),n.push(i)}return S}function h(c,S){const i=[...c.keys()],o=[...S.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(C=>({...C,key:r})),E=S.get(r).map(C=>({...C,key:r}));(0,L.equals)(a,E,(C,b)=>v(C,b))||t.add(r)}return{added:n,removed:s,updated:t}}function u(c,S,i){const o=[...c.keys()],n=[...S.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const E=c.get(a).map(b=>({...b,key:i[b.key]})),C=S.get(a).map(b=>({...b,key:i[b.key]}));y(E,C)||r.add(a)}return{added:s,removed:t,updated:r}}function y(c,S){return!(!(0,L.equals)(c.filter(({command:i})=>i[0]!=="-"),S.filter(({command:i})=>i[0]!=="-"),(i,o)=>v(i,o))||!(0,L.equals)(c.filter(({command:i})=>i[0]==="-"),S.filter(({command:i})=>i[0]==="-"),(i,o)=>v(i,o)))}function v(c,S){if(c.command!==S.command||c.key!==S.key)return!1;const i=A.ContextKeyExpr.deserialize(c.when),o=A.ContextKeyExpr.deserialize(S.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!O.equals(c.args,S.args))}function d(c,S,i){for(const o of S)c=_.edit(c,[-1],o,i);return c}function g(c,S,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===S||o[n].command===`-${S}`)&&(c=_.edit(c,[n],void 0,i));return c}function l(c,S,i,o){const n=R(c),s=n.findIndex(t=>t.command===S||t.command===`-${S}`);for(let t=n.length-1;t>=0;t--)(n[t].command===S||n[t].command===`-${S}`)&&(c=_.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=_.edit(c,[s],i[t],o);return c}}),define(le[243],ue([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=L,e.areSame=O;function L(A,_,R){const P={},f={},D=new Set;if(!_)return{local:{added:P,updated:f,removed:[...D.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const w=U(A,_);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:P,updated:f,removed:[...D.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=U(R,A),h=U(R,_),u={},y={},v=new Set,d=new Set;for(const g of m.removed.values())h.updated.has(g)?P[g]=_[g]:v.add(g);for(const g of h.removed.values())d.has(g)||(m.updated.has(g)?d.add(g):D.add(g));for(const g of m.updated.values())d.has(g)||(h.updated.has(g)?w.updated.has(g)&&d.add(g):y[g]=A[g]);for(const g of h.updated.values())d.has(g)||(m.updated.has(g)?w.updated.has(g)&&d.add(g):A[g]!==void 0&&(f[g]=_[g]));for(const g of m.added.values())d.has(g)||(h.added.has(g)?w.updated.has(g)&&d.add(g):u[g]=A[g]);for(const g of h.added.values())d.has(g)||(m.added.has(g)?w.updated.has(g)&&d.add(g):P[g]=_[g]);return{local:{added:P,removed:[...D.values()],updated:f},remote:{added:u,removed:[...v.values()],updated:y},conflicts:[...d.values()]}}function U(A,_){const R=A?Object.keys(A):[],P=_?Object.keys(_):[],f=P.filter(m=>!R.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),D=R.filter(m=>!P.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),w=new Set;for(const m of R){if(D.has(m))continue;const h=A[m],u=_[m];h!==u&&w.add(m)}return{added:f,removed:D,updated:w}}function O(A,_){const{added:R,removed:P,updated:f}=U(A,_);return R.size===0&&P.size===0&&f.size===0}}),define(le[244],ue([0,1,30]),function(se,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=U;function U(A,_,R,P){const f={added:[],removed:[],updated:[]};let D={added:[],removed:[],updated:[]};if(!_){const m=A.filter(({id:h})=>!P.includes(h));return m.length?D.added=m:D=null,{local:f,remote:D}}const w=O(A,_,P);if(w.added.length>0||w.removed.length>0||w.updated.length>0){const m=O(R,A,P),h=O(R,_,P);for(const u of h.removed){const y=A.find(v=>v.id===u);y&&f.removed.push(y)}for(const u of h.added){const y=_.find(v=>v.id===u);m.added.includes(u)?w.updated.includes(u)&&f.updated.push(y):f.added.push(y)}for(const u of h.updated)f.updated.push(_.find(y=>y.id===u));for(const u of m.added)h.added.includes(u)||D.added.push(A.find(y=>y.id===u));for(const u of m.updated)h.removed.includes(u)||h.updated.includes(u)||D.updated.push(A.find(y=>y.id===u));for(const u of m.removed){const y=_.find(v=>v.id===u);y&&D.removed.push(y)}}return D.added.length===0&&D.removed.length===0&&D.updated.length===0&&(D=null),{local:f,remote:D}}function O(A,_,R){A=A?A.filter(({id:h})=>!R.includes(h)):[],_=_.filter(({id:h})=>!R.includes(h));const P=A.map(({id:h})=>h),f=_.map(({id:h})=>h),D=f.filter(h=>!P.includes(h)),w=P.filter(h=>!f.includes(h)),m=[];for(const{id:h,name:u,shortName:y,icon:v,useDefaultFlags:d}of A){if(w.includes(h))continue;const g=_.find(l=>l.id===h);(!g||g.name!==u||g.shortName!==y||g.icon!==v||!(0,L.equals)(g.useDefaultFlags,d))&&m.push(h)}return{added:D,removed:w,updated:m}}}),define(le[25],ue([0,1,17,13,179,47,29,4,101,42]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=void 0,e.getDisallowedIgnoredSettings=D,e.getDefaultIgnoredSettings=w,e.registerConfiguration=m,e.isAuthenticationProvider=h,e.getPathSegments=y,e.getLastSyncResourceUri=v,e.createSyncHeaders=d,e.getEnablementKey=s;function D(){const t=f.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function w(){const t=f.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(C=>!!t[C].ignoreSync),a=Object.keys(t).filter(C=>t[C].scope===2||t[C].scope===6),E=D();return(0,L.distinct)([...r,...a,...E])}e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=f.Registry.as(A.Extensions.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,O.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,O.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,O.localize)(2,null),items:[{type:"string",pattern:_.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,O.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,O.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=f.Registry.as(P.Extensions.JSONContribution),E=()=>{const C=D(),b=w(),I=Object.keys(A.allSettings.properties).filter(N=>!b.includes(N)),p=b.filter(N=>!C.includes(N)),k={items:{type:"string",enum:[...I,...p.map(N=>`-${N}`)]}};a.registerSchema(t,k)};return r.onDidUpdateConfiguration(()=>E())}function h(t){return t&&(0,U.isObject)(t)&&(0,U.isString)(t.id)&&Array.isArray(t.scopes)}var u;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(u||(e.SyncResource=u={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}function v(t,r,a,E){return E.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,R.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(t){const r={};return r[e.HEADER_EXECUTION_ID]=t,r}var g;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(g||(e.UserDataSyncErrorCode=g={}));class l extends Error{constructor(r,a,E,C){super(r),this.code=a,this.resource=E,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=l;class c extends l{constructor(r,a,E,C,b){super(r,E,void 0,b),this.url=a,this.serverCode=C}}e.UserDataSyncStoreError=c;class S extends l{constructor(r,a){super(r,a)}}e.UserDataAutoSyncError=S,function(t){function r(a){if(a instanceof t)return a;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(E&&E[1]){const C=E[2]==="unknown"?void 0:E[2],b=E[3]==="unknown"?void 0:E[3];return new t(a.message,E[1],C,b)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(l||(e.UserDataSyncError=l={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(le[245],ue([0,1,30,25]),function(se,e,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=O;function O(_,R,P,f,D){if(!R)return{remote:{added:Object.keys(_),removed:[],updated:[],all:Object.keys(_).length>0?_:null},local:{added:{},removed:[],updated:{}}};const w=A(_,R);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=P?A(P,R):{added:Object.keys(R).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},h=P?A(P,_):{added:Object.keys(_).reduce((g,l)=>(g.add(l),g),new Set),removed:new Set,updated:new Set},u={added:{},removed:[],updated:{}},y=L.deepClone(R),v=!P;for(const g of h.added.values())g!==U.SYNC_SERVICE_URL_TYPE&&v&&m.added.has(g)||(y[g]=_[g]);for(const g of h.updated.values())y[g]=_[g];for(const g of h.removed.values())f.unregistered.includes(g)||delete y[g];for(const g of m.added.values()){const l=R[g];if(f.machine.includes(g)){D.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(P&&h.added.has(g))continue;const c=_[g];c&&c.value===l.value||g===U.SYNC_SERVICE_URL_TYPE&&v&&h.added.has(g)||(c?u.updated[g]=l:u.added[g]=l)}for(const g of m.updated.values()){const l=R[g];if(f.machine.includes(g)){D.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const c=_[g];c&&c.value===l.value||(u.updated[g]=l)}for(const g of m.removed.values()){if(f.machine.includes(g)){D.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||u.removed.push(g)}const d=A(R,y);return{local:u,remote:{added:[...d.added],updated:[...d.updated],removed:[...d.removed],all:d.added.size===0&&d.removed.size===0&&d.updated.size===0?null:y}}}function A(_,R){const P=Object.keys(_),f=Object.keys(R),D=f.filter(h=>!P.includes(h)).reduce((h,u)=>(h.add(u),h),new Set),w=P.filter(h=>!f.includes(h)).reduce((h,u)=>(h.add(u),h),new Set),m=new Set;for(const h of P){if(w.has(h))continue;const u=_[h],y=R[h];L.equals(u,y)||m.add(h)}return{added:D,removed:w,updated:m}}}),define(le[246],ue([0,1,17,34,62,43,30,79,25]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getIgnoredSettings=f,e.removeComments=m,e.updateIgnoredSettings=h,e.merge=u,e.isEmpty=v,e.addSetting=g;function f(a,E,C){let b=[];C?b=w(C):b=D(E);const I=[],p=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const k of b)k.startsWith("-")?p.push(k.substring(1)):I.push(k);return(0,L.distinct)([...a,...I].filter(k=>!p.includes(k)))}function D(a){let E=a.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=a.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:a.getValue("settingsSync.ignoredSettings")||[]}function w(a){const E=(0,U.parse)(a);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function m(a,E){const C=(0,U.parse)(a)||{};let b="{}";for(const I of Object.keys(C)){const p=(0,O.setProperty)(b,[I],C[I],E);b=(0,O.applyEdits)(b,p)}return b}function h(a,E,C,b){if(C.length){const I=r(E),p=(0,U.parse)(E)||{},k=(0,U.parse)(a);if(!k)return a;const N=[];for(const F of C){const x=p[F],Z=k[F];x===void 0?a=R.edit(a,[F],void 0,b):Z!==void 0?a=R.edit(a,[F],x,b):N.push(i(F,I))}N.sort((F,x)=>F.startOffset-x.startOffset),N.forEach(F=>a=g(F.setting.key,E,a,b))}return a}function u(a,E,C,b,I,p){const k=h(a,E,b,p),N=C!==k,F=C!==E;if(!N&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!F)return{conflictsSettings:[],localContent:null,remoteContent:k,hasConflicts:!1};if(F&&!N)return{conflictsSettings:[],localContent:h(E,a,b,p),remoteContent:null,hasConflicts:!1};if(C===null&&v(a)){const M=y(a,E,b)?null:h(E,a,b,p);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let x=a,Z=E;const B=(0,U.parse)(a),X=(0,U.parse)(E),j=C?(0,U.parse)(C):null,G=b.reduce((M,W)=>(M.add(W),M),new Set),z=d(B,X,G),q=d(j,B,G),ie=d(j,X,G),ae=new Map,te=new Set,ce=M=>{te.add(M);const W=I.filter(({key:J})=>J===M)[0];W?(x=R.edit(x,[M],W.value,p),Z=R.edit(Z,[M],W.value,p)):ae.set(M,{key:M,localValue:B[M],remoteValue:X[M]})};for(const M of q.removed.values())ie.updated.has(M)?ce(M):Z=R.edit(Z,[M],void 0,p);for(const M of ie.removed.values())te.has(M)||(q.updated.has(M)?ce(M):x=R.edit(x,[M],void 0,p));for(const M of q.updated.values())te.has(M)||(ie.updated.has(M)?z.updated.has(M)&&ce(M):Z=R.edit(Z,[M],B[M],p));for(const M of ie.updated.values())te.has(M)||(q.updated.has(M)?z.updated.has(M)&&ce(M):x=R.edit(x,[M],X[M],p));for(const M of q.added.values())te.has(M)||(ie.added.has(M)?z.updated.has(M)&&ce(M):Z=g(M,x,Z,p));for(const M of ie.added.values())te.has(M)||(q.added.has(M)?z.updated.has(M)&&ce(M):x=g(M,Z,x,p));const V=ae.size>0||!y(x,Z,b),$=V||!y(x,a,[]),T=V||!y(Z,E,[]);return{localContent:$?x:null,remoteContent:T?Z:null,conflictsSettings:[...ae.values()],hasConflicts:V}}function y(a,E,C){if(a===E)return!0;const b=(0,U.parse)(a),I=(0,U.parse)(E),p=C.reduce((F,x)=>(F.add(x),F),new Set),k=r(a).filter(F=>!(F.setting&&p.has(F.setting.key))),N=r(E).filter(F=>!(F.setting&&p.has(F.setting.key)));if(k.length!==N.length)return!1;for(let F=0;F<k.length;F++){const x=k[F],Z=N[F];if(x.setting&&Z.setting){if(x.setting.key!==Z.setting.key||!_.equals(b[x.setting.key],I[x.setting.key]))return!1}else if(!x.setting&&!Z.setting){if(x.value!==Z.value)return!1}else return!1}return!0}function v(a){return a?r(a).length===0:!0}function d(a,E,C){const b=a?Object.keys(a).filter(F=>!C.has(F)):[],I=Object.keys(E).filter(F=>!C.has(F)),p=I.filter(F=>!b.includes(F)).reduce((F,x)=>(F.add(x),F),new Set),k=b.filter(F=>!I.includes(F)).reduce((F,x)=>(F.add(x),F),new Set),N=new Set;if(a)for(const F of b){if(k.has(F))continue;const x=a[F],Z=E[F];_.equals(x,Z)||N.add(F)}return{added:p,removed:k,updated:N}}function g(a,E,C,b){const I=(0,U.parse)(E),p=r(E),k=r(C),N=l(a,p,k);return c(C,a,I[a],N,k,b)}function l(a,E,C){const b=E.findIndex(p=>p.setting?.key===a),I=E[b-1];if(I){if(I.setting){const k=i(I.setting.key,C);if(k)return{index:C.indexOf(k),insertAfter:!0}}else{const k=o(b,E);if(k){const N=i(k.setting.key,C);if(N){const F=n(C.indexOf(N),C),x=s(E,k,E[b]);if(F){const Z=s(C,N,F),B=t(x,Z);return B?{index:C.indexOf(B),insertAfter:!0}:{index:C.indexOf(F),insertAfter:!1}}else{const Z=s(C,N,C[C.length-1]),B=t(x,Z);return B?{index:C.indexOf(B),insertAfter:!0}:{index:C.length-1,insertAfter:!0}}}}}const p=E[b+1];if(p)if(p.setting){const k=i(p.setting.key,C);if(k)return{index:C.indexOf(k),insertAfter:!1}}else{const k=n(b,E);if(k){const N=i(k.setting.key,C);if(N){const F=o(C.indexOf(N),C),x=s(E,E[b],k);if(F){const Z=s(C,F,N),B=t(x.reverse(),Z.reverse());return B?{index:C.indexOf(B),insertAfter:!1}:{index:C.indexOf(F),insertAfter:!0}}else{const Z=s(C,C[0],N),B=t(x.reverse(),Z.reverse());return B?{index:C.indexOf(B),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:C.length-1,insertAfter:!0}}function c(a,E,C,b,I,p){let k;return b.index===-1?k=(0,O.setProperty)(a,[E],C,p):k=S(a,E,C,b,I,p).map(N=>(0,O.withFormatting)(a,N,p)[0]),(0,O.applyEdits)(a,k)}function S(a,E,C,b,I,p){const k=`${JSON.stringify(E)}: ${JSON.stringify(C)}`,N=(0,A.getEOL)(p,a),F=I[b.index];if(b.insertAfter){const x=[];if(F.setting)x.push({offset:F.endOffset,length:0,content:","+k});else{const Z=n(b.index,I),B=o(b.index,I),X=B?.setting?.commaOffset;B&&X===void 0&&x.push({offset:B.endOffset,length:0,content:","});const j=X!==void 0&&X>F.endOffset;x.push({offset:j?X+1:F.endOffset,length:0,content:Z?N+k+",":N+k})}return x}else{if(F.setting)return[{offset:F.startOffset,length:0,content:k+","}];const x=(I[b.index-1]&&!I[b.index-1].setting?N:"")+k+(n(b.index,I)?",":"")+N;return[{offset:F.startOffset,length:0,content:x}]}}function i(a,E){return E.filter(C=>C.setting?.key===a)[0]}function o(a,E){for(let C=a-1;C>=0;C--)if(E[C].setting)return E[C]}function n(a,E){for(let C=a+1;C<E.length;C++)if(E[C].setting)return E[C]}function s(a,E,C){const b=a.indexOf(E),I=a.indexOf(C);return a.filter((p,k)=>b<k&&k<I)}function t(a,E){if(a.length&&E.length){let C=0;for(;C<E.length&&C<a.length;C++)if(a[C].value!==E[C].value)return E[C-1];return E[C-1]}}function r(a){const E=[];let C=-1,b,I;const p={onObjectBegin:k=>{C++},onObjectProperty:(k,N,F)=>{C===0&&(b=N,I=k)},onObjectEnd:(k,N)=>{C--,C===0&&E.push({startOffset:b,endOffset:k+N,value:a.substring(b,k+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(k,N)=>{C++},onArrayEnd:(k,N)=>{C--,C===0&&E.push({startOffset:b,endOffset:k+N,value:a.substring(b,k+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(k,N,F)=>{C===0&&E.push({startOffset:b,endOffset:N+F,value:a.substring(b,N+F),setting:{key:I,commaOffset:void 0}})},onSeparator:(k,N,F)=>{if(C===0&&k===","){let x=E.length-1;for(;x>=0&&!E[x].setting;x--);const Z=E[x];Z&&E.splice(x,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:N}})}},onComment:(k,N)=>{C===0&&E.push({startOffset:k,endOffset:k+N,value:a.substring(k,k+N)})}};return(0,U.visit)(a,p),E}}),define(le[80],ue([0,1,3,2,4,25]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,O.createDecorator)("IUserDataSyncAccountService");let _=class extends U.Disposable{get account(){return this._account}constructor(P,f){super(),this.userDataSyncStoreService=P,this.logService=f,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(D=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,D),this.updateAccount(void 0),D==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};e.UserDataSyncAccountService=_,e.UserDataSyncAccountService=_=we([K(0,A.IUserDataSyncStoreService),K(1,A.IUserDataSyncLogService)],_)}),define(le[247],ue([0,1,20,180,16,9,25]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends A.AbstractLogger{constructor(f,D){super(),this.logger=this._register(f.createLogger((0,L.joinPath)(D.logsHome,`${_.USER_DATA_SYNC_LOG_ID}.log`),{id:_.USER_DATA_SYNC_LOG_ID,name:(0,U.localize)(0,null)}))}trace(f,...D){this.logger.trace(f,...D)}debug(f,...D){this.logger.debug(f,...D)}info(f,...D){this.logger.info(f,...D)}warn(f,...D){this.logger.warn(f,...D)}error(f,...D){this.logger.error(f,...D)}flush(){this.logger.flush()}};e.UserDataSyncLogService=R,e.UserDataSyncLogService=R=we([K(0,A.ILoggerService),K(1,O.IEnvironmentService)],R)}),define(le[248],ue([0,1,6,3,2]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends O.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:P,getActiveWindowId:f}){super(),this.disposables=this._register(new O.DisposableStore),U.Event.latch(U.Event.any(R,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>f()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(le[112],ue([0,1,183,14,51,20,8,4,23]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=f,e.isEmptyWorkspaceIdentifier=D,e.toWorkspaceIdentifier=w,e.isWorkspaceIdentifier=m,e.reviveIdentifier=h,e.isWorkspace=y,e.isWorkspaceFolder=v,e.toWorkspaceFolder=l,e.isUntitledWorkspace=c,e.isTemporaryWorkspace=S,e.isStandaloneEditorWorkspace=i,e.isSavedWorkspace=o,e.hasWorkspaceFileExtension=n,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function f(s){const t=s;return typeof t?.id=="string"&&_.URI.isUri(t.uri)}function D(s){return typeof s?.id=="string"&&!f(s)&&!m(s)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,U.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function m(s){const t=s;return typeof t?.id=="string"&&_.URI.isUri(t.configPath)}function h(s){const t=s;if(t?.uri)return{id:t.id,uri:_.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var u;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(u||(e.WorkbenchState=u={}));function y(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function v(s){const t=s;return!!(t&&typeof t=="object"&&_.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class d{constructor(t,r,a,E,C){this._id=t,this._transient=a,this._configuration=E,this._ignorePathCasing=C,this._foldersMap=O.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=O.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class g{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function l(s){return new g({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(s,t){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}function S(s){let t;return _.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===P.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function o(s,t){return!c(s,t)&&!S(s)}function n(s){return(typeof s=="string"?(0,U.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}}),define(le[18],ue([0,1,54,3,2,20,8,174,16,12,4,9,112,35,28,6,32,27,13]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=c,e.reviveProfile=S,e.toUserDataProfile=i;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&_.URI.isUri(t.location)&&_.URI.isUri(t.globalStorageHome)&&_.URI.isUri(t.settingsResource)&&_.URI.isUri(t.keybindingsResource)&&_.URI.isUri(t.tasksResource)&&_.URI.isUri(t.snippetsHome)&&_.URI.isUri(t.extensionsResource))}e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function S(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:_.URI.revive(s.location).with({scheme:t}),globalStorageHome:_.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:_.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:_.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:_.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:_.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:_.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:_.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,E,C){return{id:s,name:t,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:C&&E?.useDefaultFlags?.globalState?C.globalStorageHome:(0,A.joinPath)(r,"globalStorage"),settingsResource:C&&E?.useDefaultFlags?.settings?C.settingsResource:(0,A.joinPath)(r,"settings.json"),keybindingsResource:C&&E?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,A.joinPath)(r,"keybindings.json"),tasksResource:C&&E?.useDefaultFlags?.tasks?C.tasksResource:(0,A.joinPath)(r,"tasks.json"),snippetsHome:C&&E?.useDefaultFlags?.snippets?C.snippetsHome:(0,A.joinPath)(r,"snippets"),extensionsResource:C&&E?.useDefaultFlags?.extensions?C.extensionsResource:(0,A.joinPath)(r,"extensions.json"),cacheHome:(0,A.joinPath)(a,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let o=class extends O.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(t,r,a,E){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=a,this.logService=E,this.enabled=!0,this._onDidChangeProfiles=this._register(new U.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new U.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new U.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new U.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,A.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const t=this.createDefaultProfile(),r=[t];if(this.enabled)try{for(const C of this.getStoredProfiles()){if(!C.name||!(0,g.isString)(C.name)||!C.location){this.logService.warn("Skipping the invalid stored profile",C.location||C.name);continue}r.push(i((0,A.basename)(C.location),C.name,C.location,this.profilesCacheHome,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},t))}}catch(C){this.logService.error(C)}const a=new h.ResourceMap,E=new Map;if(r.length)try{const C=this.getStoredProfileAssociations();if(C.workspaces)for(const[b,I]of Object.entries(C.workspaces)){const p=_.URI.parse(b),k=r.find(N=>N.id===I);k&&a.set(p,k)}if(C.emptyWindows)for(const[b,I]of Object.entries(C.emptyWindows)){const p=r.find(k=>k.id===I);p&&E.set(b,p)}}catch(C){this.logService.error(C)}this._profilesObject={profiles:r,workspaces:a,emptyWindows:E}}return this._profilesObject}createDefaultProfile(){const t=i("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...t,extensionsResource:this.getDefaultProfileExtensionsLocation()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,d.escapeRegExpCharacters)(r)}\\s(\\d+)`);let E=0;for(const b of this.profiles){const I=a.exec(b.name),p=I?parseInt(I[1]):0;E=p>E?p:E}const C=`${r} ${E+1}`;return this.createProfile((0,L.hash)((0,v.generateUuid)()).toString(16),C,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,L.hash)((0,v.generateUuid)()).toString(16),t,r,a)}async createProfile(t,r,a,E){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const C=await this.doCreateProfile(t,r,a);return E&&await this.setProfileForWorkspace(E,C),C}async doCreateProfile(t,r,a){if(!(0,g.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.profileCreationPromises.get(r);return E||(E=(async()=>{try{const C=this.profiles.find(p=>p.name===r||p.id===t);if(C)return C;const b=i(t,r,(0,A.joinPath)(this.profilesHome,t),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(b.location);const I=[];return this._onWillCreateProfile.fire({profile:b,join(p){I.push(p)}}),await y.Promises.settled(I),this.updateProfiles([b],[],[]),b}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,E)),E}async updateProfile(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(E=>E.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.profilesCacheHome,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(t){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:r,join(E){a.push(E)}});try{await Promise.allSettled(a)}catch(E){this.logService.error(E)}for(const E of[...this.profilesObject.emptyWindows.keys()])r.id===this.profilesObject.emptyWindows.get(E)?.id&&this.profilesObject.emptyWindows.delete(E);for(const E of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(E)?.id&&this.profilesObject.workspaces.delete(E);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{await this.fileService.del(r.cacheHome,{recursive:!0})}catch(E){(0,f.toFileOperationResult)(E)!==1&&this.logService.error(E)}}async setProfileForWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(E=>E.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,a)}unsetWorkspace(t,r){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return _.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindows.get(r)??this.profilesObject.emptyWindows.get(r)}getWorkspace(t){return(0,m.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,m.isWorkspaceIdentifier)(t)?t.configPath:t.id}isProfileAssociatedToWorkspace(t){return!!([...this.transientProfilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.emptyWindows.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,a){const E=[...this.profiles,...t],C=[];this.transientProfilesObject.profiles=[];for(let b of E)b.isDefault||r.some(I=>b.id===I.id)||(b=a.find(I=>b.id===I.id)??b,b.isTransient?this.transientProfilesObject.profiles.push(b):C.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.saveStoredProfiles(C),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,a)}triggerProfilesChanges(t,r,a){this._onDidChangeProfiles.fire({added:t,removed:r,updated:a,all:this.profiles})}updateWorkspaceAssociation(t,r,a){a=r?.isTransient?!0:a,a||this.updateWorkspaceAssociation(t,void 0,!0);const E=this.getWorkspace(t),C=a?this.transientProfilesObject:this.profilesObject;_.URI.isUri(E)?(C.workspaces.delete(E),r&&C.workspaces.set(E,r)):(C.emptyWindows.delete(E),r&&C.emptyWindows.set(E,r)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[a,E]of this.profilesObject.workspaces.entries())t[a.toString()]=E.id;const r={};for(const[a,E]of this.profilesObject.emptyWindows.entries())r[a.toString()]=E.id;this.saveStoredProfileAssociations({workspaces:t,emptyWindows:r}),this._profilesObject=void 0}migrateStoredProfileAssociations(t){const r={},a=this.createDefaultProfile();if(t.workspaces)for(const[C,b]of Object.entries(t.workspaces)){const I=_.URI.parse(b);r[C]=this.uriIdentityService.extUri.isEqual(I,a.location)?a.id:this.uriIdentityService.extUri.basename(I)}const E={};if(t.emptyWindows)for(const[C,b]of Object.entries(t.emptyWindows)){const I=_.URI.parse(b);E[C]=this.uriIdentityService.extUri.isEqual(I,a.location)?a.id:this.uriIdentityService.extUri.basename(I)}return{workspaces:r,emptyWindows:E}}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=o,e.UserDataProfilesService=o=we([K(0,P.IEnvironmentService),K(1,f.IFileService),K(2,u.IUriIdentityService),K(3,w.ILogService)],o);class n extends o{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(t){this.storedProfiles=t}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(t){this.storedProfileAssociations=t}}e.InMemoryUserDataProfilesService=n}),define(le[249],ue([0,1,6,2,18]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends U.Disposable{constructor(R){super(),this._register(new L.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=A,e.UserDataProfilesCleaner=A=we([K(0,O.IUserDataProfilesService)],A)}),define(le[250],ue([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.joinErrors=S,e.toExtensionManagementError=i;let c=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(t,r,a,E,C,b){super(),this.galleryService=t,this.telemetryService=r,this.uriIdentityService=a,this.logService=E,this.productService=C,this.userDataProfilesService=b,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this._onDidUpdateExtensionMetadata=this._register(new _.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:I})=>I.cancel()),this.uninstallingExtensions.forEach(I=>I.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.isTargetPlatformCompatible)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const E=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:C})=>(0,h.areSameExtensions)(C,t.identifier));if(E?.local)return E?.local;throw E?.error?E.error:new m.ExtensionManagementError(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.galleryService.isEnabled())throw new m.ExtensionManagementError(w.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:E,options:C})=>{try{const b=await this.checkAndGetCompatibleVersion(E,!!C?.installGivenVersion,!!C?.installPreReleaseVersion,C.productVersion??{version:this.productService.version,date:this.productService.date});a.push({...b,options:C})}catch(b){r.push({identifier:E.identifier,operation:2,source:E,error:b})}})),a.length&&r.push(...await this.installExtensions(a));for(const E of r)E.error&&(this.logService.error("Failed to install extension.",E.identifier.id),this.logService.error(E.error),E.source&&!D.URI.isUri(E.source)&&o(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(E.source),error:E.error}));return r}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async toggleAppliationScope(t,r){if((0,u.isApplicationScopedExtension)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)||(a=await this.copyExtension(t,this.userDataProfilesService.defaultProfile.extensionsResource,r));for(const E of this.userDataProfilesService.profiles){const C=(await this.getInstalled(1,E.extensionsResource)).find(b=>(0,h.areSameExtensions)(b.identifier,t.identifier));C?this._onDidUpdateExtensionMetadata.fire(C):this._onDidUninstallExtension.fire({identifier:t.identifier,profileLocation:E.extensionsResource})}return a}else{const a=this.uriIdentityService.extUri.isEqual(r,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(t,r,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtensions(t){const r=[],a=new Map,E=[],C=[],b=(p,k)=>`${h.ExtensionKey.create(p).toString()}-${k.toString()}`,I=(p,k,N)=>{const F=this.createInstallExtensionTask(p,k,N),x=D.URI.isUri(k)?k.path:`${k.identifier.id.toLowerCase()}-${N.profileLocation.toString()}`;a.set(x,{task:F,manifest:p}),this._onInstallExtension.fire({identifier:F.identifier,source:k,profileLocation:N.profileLocation}),this.logService.info("Installing extension:",F.identifier.id),D.URI.isUri(k)||this.installingExtensions.set(b(k,N.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:p,extension:k,options:N}of t){const F=N.isApplicationScoped||N.isBuiltin||(0,u.isApplicationScopedExtension)(p),x={...N,installOnlyNewlyAddedFromExtensionPack:N.installOnlyNewlyAddedFromExtensionPack??!D.URI.isUri(k),isApplicationScoped:F,profileLocation:F?this.userDataProfilesService.defaultProfile.extensionsResource:N.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:N.productVersion??{version:this.productService.version,date:this.productService.date}},Z=D.URI.isUri(k)?void 0:this.installingExtensions.get(b(k,x.profileLocation));Z?(this.logService.info("Extension is already requested to install",Z.task.identifier.id),E.push(Z.task.waitUntilTaskIsFinished())):I(p,k,x)}await Promise.all([...a.values()].map(async({task:p,manifest:k})=>{if(p.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",p.identifier.id);else try{const N=await this.getAllDepsAndPackExtensions(p.identifier,k,!!p.options.installOnlyNewlyAddedFromExtensionPack,!!p.options.installPreReleaseVersion,p.options.profileLocation,p.options.productVersion),F=await this.getInstalled(void 0,p.options.profileLocation,p.options.productVersion),x={...p.options,donotIncludePackAndDependencies:!0,context:{...p.options.context,[m.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:Z,manifest:B}of(0,L.distinct)(N,({gallery:X})=>X.identifier.id)){if(a.has(`${Z.identifier.id.toLowerCase()}-${x.profileLocation.toString()}`))continue;const X=this.installingExtensions.get(b(Z,x.profileLocation));if(X){if(this.canWaitForTask(p,X.task)){const j=X.task.identifier;this.logService.info("Waiting for already requested installing extension",j.id,p.identifier.id),X.waitingTasks.push(p),E.push(_.Event.toPromise(_.Event.filter(this.onDidInstallExtensions,G=>G.some(z=>(0,h.areSameExtensions)(z.identifier,j)))).then(G=>{if(this.logService.info("Finished waiting for already requested installing extension",j.id,p.identifier.id),!G.find(q=>(0,h.areSameExtensions)(q.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else F.some(({identifier:j})=>(0,h.areSameExtensions)(j,Z.identifier))||I(B,Z,x)}}catch(N){if(D.URI.isUri(p.source))(0,L.isNonEmptyArray)(k.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",p.identifier.id,N.message),(0,L.isNonEmptyArray)(k.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",p.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",p.identifier.id),N}})),await this.joinAllSettled([...a.values()].map(async({task:p})=>{const k=new Date().getTime();try{const N=await p.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(N,p.source,p.options,O.CancellationToken.None))),!D.URI.isUri(p.source)){const F=p.operation===3,x=F?void 0:(new Date().getTime()-p.source.lastUpdated)/1e3;if(o(this.telemetryService,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(p.source),verificationStatus:p.verificationStatus,duration:new Date().getTime()-k,durationSinceUpdate:x}),P.isWeb&&p.operation!==3)try{await this.galleryService.reportStatistic(N.manifest.publisher,N.manifest.name,N.manifest.version,"install")}catch{}}C.push({local:N,identifier:p.identifier,operation:p.operation,source:p.source,context:p.options.context,profileLocation:p.profileLocation,applicationScoped:N.isApplicationScoped})}catch(N){throw this.logService.error("Error while installing the extension",p.identifier.id,(0,A.getErrorMessage)(N)),N}})),E.length&&await this.joinAllSettled(E);for(const p of C)this.logService.info("Extension installed successfully:",p.identifier.id),r.push(p);return r}catch(p){C.length&&(this.logService.info("Rollback: Uninstalling installed extensions",(0,A.getErrorMessage)(p)),await Promise.allSettled(C.map(async({local:k,profileLocation:N})=>{try{await this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:N}).run(),this.logService.info("Rollback: Uninstalled extension",k.identifier.id)}catch(F){this.logService.warn("Rollback: Error while uninstalling extension",k.identifier.id,(0,A.getErrorMessage)(F))}})));for(const{task:k}of a.values())k.cancel(),r.push({identifier:k.identifier,operation:2,source:k.source,context:k.options.context,profileLocation:k.profileLocation,error:p});throw p}finally{for(const{task:p}of a.values())p.source&&!D.URI.isUri(p.source)&&this.installingExtensions.delete(b(p.source,p.profileLocation));r.length&&this._onDidInstallExtensions.fire(r)}}canWaitForTask(t,r){for(const[,{task:a,waitingTasks:E}]of this.installingExtensions.entries())if(a===t&&(E.includes(r)||E.some(C=>this.canWaitForTask(C,r)))||a===r&&E[0]&&!this.canWaitForTask(t,E[0]))return!1;return!0}async joinAllSettled(t){const r=[],a=[],E=await Promise.allSettled(t);for(const C of E)C.status==="fulfilled"?r.push(C.value):a.push(C.reason);if(a.length)throw S(a);return r}async getAllDepsAndPackExtensions(t,r,a,E,C,b){if(!this.galleryService.isEnabled())return[];const I=await this.getInstalled(void 0,C,b),p=[],k=[],N=async(F,x)=>{p.push(F);const Z=x.extensionDependencies||[],B=[...Z];if(x.extensionPack){const X=a?I.find(j=>(0,h.areSameExtensions)(j.identifier,F)):void 0;for(const j of x.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(G=>(0,h.areSameExtensions)({id:G},{id:j}))||B.every(G=>!(0,h.areSameExtensions)({id:G},{id:j}))&&B.push(j)}if(B.length){const X=B.filter(j=>p.every(G=>!(0,h.areSameExtensions)(G,{id:j})));if(X.length){const j=await this.galleryService.getExtensions(X.map(G=>({id:G,preRelease:E})),O.CancellationToken.None);for(const G of j){if(p.find(ie=>(0,h.areSameExtensions)(ie,G.identifier)))continue;const z=Z.some(ie=>(0,h.areSameExtensions)({id:ie},G.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(G,!1,E,b)}catch(ie){if(z)throw ie;this.logService.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,A.getErrorMessage)(ie));continue}k.push({gallery:q.extension,manifest:q.manifest}),await N(q.extension.identifier,q.manifest)}}}};return await N(t,r),k}async checkAndGetCompatibleVersion(t,r,a,E){let C;const b=await this.getExtensionsControlManifest();if(b.malicious.some(k=>(0,h.areSameExtensions)(t.identifier,k)))throw new m.ExtensionManagementError(w.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const I=b.deprecated[t.identifier.id.toLowerCase()];if(I?.extension?.autoMigrate){if(this.logService.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${I.extension.id}' extension instead.`),C=(await this.galleryService.getExtensions([{id:I.extension.id,preRelease:I.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:E},O.CancellationToken.None))[0],!C)throw new m.ExtensionManagementError(w.localize(2,null,t.identifier.id,I.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const k=await this.getTargetPlatform();throw new m.ExtensionManagementError(w.localize(3,null,t.identifier.id,this.productService.nameLong,(0,m.TargetPlatformToString)(k)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.getCompatibleVersion(t,r,a,E),!C)throw!a&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],O.CancellationToken.None))[0]?new m.ExtensionManagementError(w.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(w.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),m.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",C.identifier.id);const p=await this.galleryService.getManifest(C,O.CancellationToken.None);if(p===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${C.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(p.version!==C.version)throw new m.ExtensionManagementError(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:p}}async getCompatibleVersion(t,r,a,E){const C=await this.getTargetPlatform();let b=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(b=(await this.galleryService.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:C,compatible:!0,productVersion:E},O.CancellationToken.None))[0]||null),!b&&await this.galleryService.isExtensionCompatible(t,a,C,E)&&(b=t),b||(r?b=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:C,compatible:!0,productVersion:E},O.CancellationToken.None))[0]||null:b=await this.galleryService.getCompatibleExtension(t,a,C,E)),b}async uninstallExtension(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:r.profileLocation??this.getCurrentExtensionsManifestLocation()},E=N=>`${N.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,C=this.uninstallingExtensions.get(E(t.identifier));if(C)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),C.waitUntilTaskIsFinished();const b=N=>{const F=this.createUninstallExtensionTask(N,a);return this.uninstallingExtensions.set(E(F.extension.identifier),F),a.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this._onUninstallExtension.fire({identifier:N.identifier,profileLocation:a.profileLocation,applicationScoped:N.isApplicationScoped}),F},I=(N,F)=>{F?a.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString(),F.message):this.logService.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,F.message):a.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,a.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),o(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(N),error:F}),this._onDidUninstallExtension.fire({identifier:N.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:N.isApplicationScoped})},p=[],k=[];try{p.push(b(t));const N=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.getAllPackExtensionsToUninstall(t,N);for(const x of F)this.uninstallingExtensions.has(E(x.identifier))?this.logService.info("Extensions is already requested to uninstall",x.identifier.id):p.push(b(x))}a.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(p.map(F=>F.extension),N,t),await this.joinAllSettled(p.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(x=>x.postUninstall(F.extension,a,O.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}I(F.extension)}catch(x){const Z=x instanceof m.ExtensionManagementError?x:new m.ExtensionManagementError((0,A.getErrorMessage)(x),m.ExtensionManagementErrorCode.Internal);throw I(F.extension,Z),Z}finally{k.push(F)}}))}catch(N){const F=N instanceof m.ExtensionManagementError?N:new m.ExtensionManagementError((0,A.getErrorMessage)(N),m.ExtensionManagementErrorCode.Internal);for(const x of p){try{x.cancel()}catch{}k.includes(x)||I(x.extension,F)}throw F}finally{for(const N of p)this.uninstallingExtensions.delete(E(N.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}checkForDependents(t,r,a){for(const E of t){const C=this.getDependents(E,r);if(C.length){const b=C.filter(I=>!t.some(p=>(0,h.areSameExtensions)(p.identifier,I.identifier)));if(b.length)throw new Error(this.getDependentsErrorMessage(E,b,a))}}}getDependentsErrorMessage(t,r,a){return a===t?r.length===1?w.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?w.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):w.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?w.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?w.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):w.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const E=t.manifest.extensionPack?t.manifest.extensionPack:[];if(E.length){const C=r.filter(I=>!I.isBuiltin&&E.some(p=>(0,h.areSameExtensions)({id:p},I.identifier))),b=[];for(const I of C)b.push(...this.getAllPackExtensionsToUninstall(I,r,a));return[...C,...b]}return[]}getDependents(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(E=>(0,h.areSameExtensions)({id:E},t.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(t){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.getErrorMessage)(t)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=c,e.AbstractExtensionManagementService=c=we([K(0,m.IExtensionGalleryService),K(1,d.ITelemetryService),K(2,g.IUriIdentityService),K(3,y.ILogService),K(4,v.IProductService),K(5,l.IUserDataProfilesService)],c);function S(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof m.ExtensionManagementError)return s;if(s instanceof m.ExtensionGalleryError){const r=new m.ExtensionManagementError(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.ExtensionManagementError(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:E,error:C,durationSinceUpdate:b}){let I,p;(0,f.isDefined)(a)&&(a===!0?a="Verified":(a===!1||(I=m.ExtensionManagementErrorCode.Signature,p=a),a="Unverified")),C&&(C instanceof m.ExtensionManagementError||C instanceof m.ExtensionGalleryError?(I=C.code,C.code===m.ExtensionManagementErrorCode.Signature&&(p=C.message)):I=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!C,duration:E,errorcode:I,errorcodeDetail:p,durationSinceUpdate:b})}class n{constructor(){this.barrier=new U.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(t=>new Promise((r,a)=>{const E=t.onCancellationRequested(()=>{E.dispose(),a(new A.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(le[52],ue([0,1,6,15,2,3,35,8,29,33,12,4,9,18,28,13,7,22]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class l extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=l,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let c=class extends O.Disposable{constructor(n,s,t,r,a,E){super(),this.extensionsLocation=n,this.fileService=s,this.userDataProfilesService=t,this.uriIdentityService=r,this.telemetryService=a,this.logService=E,this._onAddExtensions=this._register(new A.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new A.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new A.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new A.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new _.ResourceMap}scanProfileExtensions(n,s){return this.withProfileExtensions(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.withProfileExtensions(s,E=>{const C=[];if(t)C.push(...E);else for(const b of E)n.some(([I])=>(0,f.areSameExtensions)(I.identifier,b.identifier)&&I.manifest.version!==b.version)?r.push(b):C.push(b);for(const[b,I]of n){const p=C.findIndex(N=>(0,f.areSameExtensions)(N.identifier,b.identifier)&&N.version===b.manifest.version),k={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:I};p===-1?(a.push(k),C.push(k)):C.splice(p,1,k)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:s}),r.length&&this._onRemoveExtensions.fire({extensions:r,profileLocation:s}),C}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:s}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,profileLocation:s}),a}catch(E){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:E,profileLocation:s}),r.length&&this._onDidRemoveExtensions.fire({extensions:r,error:E,profileLocation:s}),E}}async updateMetadata(n,s){const t=[];return await this.withProfileExtensions(s,r=>{const a=[];for(const E of r){const C=n.find(([b])=>(0,f.areSameExtensions)(b.identifier,E.identifier)&&b.manifest.version===E.version);C&&(E.metadata={...E.metadata,...C[1]},t.push(E)),a.push(E)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.withProfileExtensions(s,r=>{const a=[];for(const E of r)(0,f.areSameExtensions)(E.identifier,n.identifier)?t.push(E):a.push(E);return t.length&&this._onRemoveExtensions.fire({extensions:t,profileLocation:s}),a}),t.length&&this._onDidRemoveExtensions.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this._onDidRemoveExtensions.fire({extensions:t,error:r,profileLocation:s}),r}}async withProfileExtensions(n,s,t){return this.getResourceAccessQueue(n).queue(async()=>{let r=[],a;try{const E=await this.fileService.readFile(n);a=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,D.toFileOperationResult)(E)!==1)throw E;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&t?.bailOutWhenFileNotFound)throw new l((0,v.getErrorMessage)(E),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let E=!1;for(const C of a){S(C)||this.reportAndThrowInvalidConentError(n);let b;if((0,y.isString)(C.relativeLocation)&&C.relativeLocation)b=this.resolveExtensionLocation(C.relativeLocation);else if((0,y.isString)(C.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${C.location}`);continue}else{b=R.URI.revive(C.location);const I=this.toRelativePath(b);I&&(E=!0,C.relativeLocation=I)}(0,y.isUndefined)(C.metadata?.hasPreReleaseVersion)&&C.metadata?.preRelease&&(E=!0,C.metadata.hasPreReleaseVersion=!0),r.push({identifier:C.identifier,location:b,version:C.version,metadata:C.metadata})}E&&await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(a)))}if(s){r=s(r);const E=r.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.toRelativePath(C.location),metadata:C.metadata}));await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(E)))}return r})}reportAndThrowInvalidConentError(n){const s=new l(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let t;try{t=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,D.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(E=>S(E))?r=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(r)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,D.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,D.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(s)}catch(a){(0,D.toFileOperationResult)(a)!==1&&this.logService.error(a)}return r})()),this._migrationPromise}getResourceAccessQueue(n){let s=this.resourcesAccessQueueMap.get(n);return s||(s=new L.Queue,this.resourcesAccessQueueMap.set(n,s)),s}};e.AbstractExtensionsProfileScannerService=c,e.AbstractExtensionsProfileScannerService=c=we([K(1,D.IFileService),K(2,h.IUserDataProfilesService),K(3,u.IUriIdentityService),K(4,d.ITelemetryService),K(5,m.ILogService)],c);function S(o){return(0,y.isObject)(o)&&(0,P.isIExtensionIdentifier)(o.identifier)&&(i(o.location)||(0,y.isString)(o.location)&&o.location)&&((0,y.isUndefined)(o.relativeLocation)||(0,y.isString)(o.relativeLocation))&&o.version&&(0,y.isString)(o.version)}function i(o){return o?(0,y.isString)(o.path)&&(0,y.isString)(o.scheme):!1}}),define(le[81],ue([0,1,17,6,30,15,7,34,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i,o,n,s,t,r,a,E,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=Z;var p;(function(X){function j(G,z){if(G===z)return!0;const q=Object.keys(G),ie=new Set;for(const ae of Object.keys(z))ie.add(ae);if(q.length!==ie.size)return!1;for(const ae of q){if(G[ae]!==z[ae])return!1;ie.delete(ae)}return ie.size===0}X.equals=j})(p||(e.Translations=p={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let k=class extends f.Disposable{constructor(j,G,z,q,ie,ae,te,ce,V,$,T,M){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=G,this.extensionsControlLocation=z,this.currentProfile=q,this.userDataProfilesService=ie,this.extensionsProfileScannerService=ae,this.fileService=te,this.logService=ce,this.environmentService=V,this.productService=$,this.uriIdentityService=T,this.instantiationService=M,this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,G,z){const[q,ie]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(G)]),ae=z?await this.scanExtensionsUnderDevelopment(j,[...q,...ie]):[];return this.dedupExtensions(q,ie,ae,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const G=[];G.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),G.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[z,q]=await Promise.all(G);return this.applyScanOptions([...z,...q],0,j,!1)}async scanUserExtensions(j){const G=j.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",G);const z=this.uriIdentityService.extUri.isEqual(j.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(G,!!j.profileLocation,1,!j.includeUninstalled,j.language,!0,z,j.productVersion??this.getProductVersion()),ie=j.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let ae;try{ae=await ie.scanExtensions(q)}catch(te){if(te instanceof E.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),ae=await ie.scanExtensions(q);else throw te}return ae=await this.applyScanOptions(ae,1,j,!0),this.logService.trace("Scanned user extensions:",ae.length),ae}async scanExtensionsUnderDevelopment(j,G){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===D.Schemas.file).map(async q=>{const ie=await this.createExtensionScannerInput(q,!1,1,!0,j.language,!1,void 0,j.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(ie)).map(te=>(te.type=G.find(ce=>(0,c.areSameExtensions)(ce.identifier,te.identifier))?.type??te.type,this.extensionsScanner.validate(te,ie)))}))).flat();return this.applyScanOptions(z,"development",j,!0)}return[]}async scanExistingExtension(j,G,z){const q=await this.createExtensionScannerInput(j,!1,G,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),ie=await this.extensionsScanner.scanExtension(q);return!ie||!z.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(j,G,z){const q=await this.createExtensionScannerInput(j,!1,G,!0,z.language,!0,void 0,z.productVersion??this.getProductVersion()),ie=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(ie,G,z,!0)}async scanMultipleExtensions(j,G,z){const q=[];return await Promise.all(j.map(async ie=>{const ae=await this.scanOneOrMultipleExtensions(ie,G,z);q.push(...ae)})),this.applyScanOptions(q,G,z,!0)}async scanMetadata(j){const G=(0,h.joinPath)(j,"package.json"),z=(await this.fileService.readFile(G)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(j,G){const z=(0,h.joinPath)(j,"package.json"),q=(await this.fileService.readFile(z)).value.toString(),ie=JSON.parse(q);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,ie.__metadata={...ie.__metadata,...G},await this.fileService.writeFile((0,h.joinPath)(j,"package.json"),A.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(j){if(j instanceof E.ExtensionsProfileScanningError&&j.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw j}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});if(j.length)await this.extensionsProfileScannerService.addExtensionsToProfile(j.map(G=>[G,G.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(G){(0,o.toFileOperationResult)(G)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,_.getErrorMessage)(G))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(j){this.logService.error(j)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(j,G,z,q){return z.includeAllVersions||(j=this.dedupExtensions(G===0?j:void 0,G===1?j:void 0,G==="development"?j:void 0,await this.getTargetPlatform(),q)),z.includeInvalid||(j=j.filter(ie=>ie.isValid)),j.sort((ie,ae)=>{const te=w.basename(ie.location.fsPath),ce=w.basename(ae.location.fsPath);return te<ce?-1:te>ce?1:0})}dedupExtensions(j,G,z,q,ie){const ae=(ce,V,$)=>{if(ce.isValid&&!V.isValid)return!1;if(ce.isValid===V.isValid){if(ie&&u.gt(ce.manifest.version,V.manifest.version))return this.logService.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(u.eq(ce.manifest.version,V.manifest.version)){if(ce.type===0)return this.logService.debug(`Skipping extension ${V.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===q)return this.logService.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return $?this.logService.warn(`Overwriting user extension ${ce.location.path} with ${V.location.path}.`):this.logService.debug(`Overwriting user extension ${ce.location.path} with ${V.location.path}.`),!0},te=new S.ExtensionIdentifierMap;return j?.forEach(ce=>{const V=te.get(ce.identifier.id);(!V||ae(V,ce,!1))&&te.set(ce.identifier.id,ce)}),G?.forEach(ce=>{const V=te.get(ce.identifier.id);if(!V&&j&&ce.type===0){this.logService.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!V||ae(V,ce,!1))&&te.set(ce.identifier.id,ce)}),z?.forEach(ce=>{const V=te.get(ce.identifier.id);(!V||ae(V,ce,!0))&&te.set(ce.identifier.id,ce),te.set(ce.identifier.id,ce)}),[...te.values()]}async scanDefaultSystemExtensions(j,G){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0,this.getProductVersion()),ie=await(j&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",ie.length),ie}async scanDevSystemExtensions(j,G){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=G?await this.getBuiltInExtensionControl():{},ie=[],ae=d.URI.file(w.normalize(w.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of z){const V=q[ce.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":ie.push((0,h.joinPath)(ae,ce.name));break;default:ie.push(d.URI.file(V));break}}const te=await Promise.all(ie.map(async ce=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(ce,!1,0,!0,j,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",te.length),(0,L.coalesce)(te)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,G,z,q,ie,ae,te,ce){const V=await this.getTranslations(ie??m.language),$=await this.getMtime(j),T=G&&!this.uriIdentityService.extUri.isEqual(j,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=T?await this.getMtime(T):void 0;return new N(j,$,T,M,G,te,z,q,ae,ce.version,ce.date,this.productService.commit,!this.environmentService.isBuilt,ie,V)}async getMtime(j){try{const G=await this.fileService.stat(j);if(typeof G.mtime=="number")return G.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=k,e.AbstractExtensionsScannerService=k=we([K(4,C.IUserDataProfilesService),K(5,E.IExtensionsProfileScannerService),K(6,o.IFileService),K(7,s.ILogService),K(8,l.IEnvironmentService),K(9,t.IProductService),K(10,b.IUriIdentityService),K(11,n.IInstantiationService)],k);class N{constructor(j,G,z,q,ie,ae,te,ce,V,$,T,M,W,J,H){this.location=j,this.mtime=G,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=q,this.profile=ie,this.profileScanOptions=ae,this.type=te,this.excludeObsolete=ce,this.validate=V,this.productVersion=$,this.productDate=T,this.productCommit=M,this.devMode=W,this.language=J,this.translations=H}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,G){return(0,h.isEqual)(j.location,G.location)&&j.mtime===G.mtime&&(0,h.isEqual)(j.applicationExtensionslocation,G.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&j.profile===G.profile&&O.equals(j.profileScanOptions,G.profileScanOptions)&&j.type===G.type&&j.excludeObsolete===G.excludeObsolete&&j.validate===G.validate&&j.productVersion===G.productVersion&&j.productDate===G.productDate&&j.productCommit===G.productCommit&&j.devMode===G.devMode&&j.language===G.language&&p.equals(j.translations,G.translations)}}e.ExtensionScannerInput=N;let F=class extends f.Disposable{constructor(j,G,z,q,ie){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=G,this.uriIdentityService=z,this.fileService=q,this.logService=ie}async scanExtensions(j){const G=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let z={};if(j.excludeObsolete&&j.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(q)}catch{}return(0,v.isEmptyObject)(z)?G:G.filter(q=>!z[c.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(j){const G=await this.fileService.resolve(j.location);if(!G.children?.length)return[];const z=await Promise.all(G.children.map(async q=>{if(!q.isDirectory||j.type===1&&(0,h.basename)(q.resource).indexOf(".")===0)return null;const ie=new N(q.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(ie)}));return(0,L.coalesce)(z).sort((q,ie)=>q.location.path<ie.location.path?-1:1)}async scanExtensionsFromProfile(j){let G=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){G=G.filter(q=>!q.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,j);G.push(...z)}return G}async scanExtensionsFromProfileResource(j,G,z){const q=await this.extensionsProfileScannerService.scanProfileExtensions(j,z.profileScanOptions);if(!q.length)return[];const ie=await Promise.all(q.map(async ae=>{if(G(ae)){const te=new N(ae.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(te,ae.metadata)}return null}));return(0,L.coalesce)(ie)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,h.joinPath)(j.location,"package.json"))){const G=await this.scanExtension(j);return G?[G]:[]}else return await this.scanExtensions(j)}catch(G){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,_.getErrorMessage)(G)),[]}}async scanExtension(j,G){try{let z=await this.scanExtensionManifest(j.location);if(z){z.publisher||(z.publisher=S.UNDEFINED_PUBLISHER),G=G??z.__metadata,delete z.__metadata;const q=(0,c.getGalleryExtensionId)(z.publisher,z.name),ie=G?.id?{id:q,uuid:G.id}:{id:q},ae=G?.isSystem?0:j.type,te=ae===0||!!G?.isBuiltin;z=await this.translateManifest(j.location,z,N.createNlsConfiguration(j));const ce={type:ae,identifier:ie,manifest:z,location:j.location,isBuiltin:te,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return j.validate?this.validate(ce,j):ce}}catch(z){j.type!==0&&this.logService.error(z)}return null}validate(j,G){let z=!0;const q=(0,i.validateExtensionManifest)(G.productVersion,G.productDate,G.location,j.manifest,j.isBuiltin);for(const[ie,ae]of q)ie===y.default.Error&&(z=!1,this.logService.error(this.formatMessage(G.location,ae)));return j.isValid=z,j.validations=q,j}async scanExtensionManifest(j){const G=(0,h.joinPath)(j,"package.json");let z;try{z=(await this.fileService.readFile(G)).value.toString()}catch(ie){return(0,o.toFileOperationResult)(ie)!==1&&this.logService.error(this.formatMessage(j,(0,g.localize)(0,null,G.path,ie.message))),null}let q;try{q=JSON.parse(z)}catch{const ae=[];(0,R.parse)(z,ae);for(const te of ae)this.logService.error(this.formatMessage(j,(0,g.localize)(1,null,G.path,te.offset,te.length,(0,P.getParseErrorMessage)(te.error))));return null}return(0,R.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(j,(0,g.localize)(2,null,G.path))),null):q}async translateManifest(j,G,z){const q=await this.getLocalizedMessages(j,G,z);if(q)try{const ie=[],ae=await this.resolveOriginalMessageBundle(q.default,ie);if(ie.length>0)return ie.forEach(ce=>{this.logService.error(this.formatMessage(j,(0,g.localize)(3,null,q.default?.path,(0,P.getParseErrorMessage)(ce.error))))}),G;if((0,R.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(j,(0,g.localize)(4,null,q.default?.path))),G;const te=q.values||Object.create(null);return(0,I.localizeManifest)(this.logService,G,te,ae)}catch{}return G}async getLocalizedMessages(j,G,z){const q=(0,h.joinPath)(j,"package.nls.json"),ie=(V,$)=>{$.forEach(T=>{this.logService.error(this.formatMessage(j,(0,g.localize)(5,null,V?.path,(0,P.getParseErrorMessage)(T.error))))})},ae=V=>{this.logService.error(this.formatMessage(j,(0,g.localize)(6,null,V?.path)))},te=`${G.publisher}.${G.name}`,ce=z.translations[te];if(ce)try{const V=d.URI.file(ce),$=(await this.fileService.readFile(V)).value.toString(),T=[],M=(0,R.parse)($,T);return T.length>0?(ie(V,T),{values:void 0,default:q}):(0,R.getNodeType)(M)!=="object"?(ae(V),{values:void 0,default:q}):{values:M.contents?M.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let $;try{$=await this.findMessageBundles(j,z)}catch{return}if(!$.localized)return{values:void 0,default:$.original};try{const T=(await this.fileService.readFile($.localized)).value.toString(),M=[],W=(0,R.parse)(T,M);return M.length>0?(ie($.localized,M),{values:void 0,default:$.original}):(0,R.getNodeType)(W)!=="object"?(ae($.localized),{values:void 0,default:$.original}):{values:W,default:$.original}}catch{return{values:void 0,default:$.original}}}}async resolveOriginalMessageBundle(j,G){if(j)try{const z=(await this.fileService.readFile(j)).value.toString();return(0,R.parse)(z,G)}catch{}}findMessageBundles(j,G){return new Promise((z,q)=>{const ie=ae=>{const te=(0,h.joinPath)(j,`package.nls.${ae}.json`);this.fileService.exists(te).then(ce=>{ce&&z({localized:te,original:(0,h.joinPath)(j,"package.nls.json")});const V=ae.lastIndexOf("-");V===-1?z({localized:(0,h.joinPath)(j,"package.nls.json"),original:null}):(ae=ae.substring(0,V),ie(ae))})};if(G.devMode||G.pseudo||!G.language)return z({localized:(0,h.joinPath)(j,"package.nls.json"),original:null});ie(G.language)})}formatMessage(j,G){return`[${j.path}]: ${G}`}};F=we([K(1,E.IExtensionsProfileScannerService),K(2,b.IUriIdentityService),K(3,o.IFileService),K(4,s.ILogService)],F);let x=class extends F{constructor(j,G,z,q,ie,ae,te){super(G,q,ie,ae,te),this.currentProfile=j,this.userDataProfilesService=z,this.cacheValidatorThrottler=this._register(new U.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new r.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const G=this.getCacheFile(j),z=await this.readExtensionCache(G);if(this.input=j,z&&z.input&&N.equals(z.input,this.input))return this.logService.debug("Using cached extensions scan result",j.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(ie=>(ie.location=d.URI.revive(ie.location),ie));const q=await super.scanExtensions(j);return await this.writeExtensionCache(G,{input:j,result:q}),q}async readExtensionCache(j){try{const G=await this.fileService.readFile(j),z=JSON.parse(G.value.toString());return{result:z.result,input:(0,a.revive)(z.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",j.path,(0,_.getErrorMessage)(G))}return null}async writeExtensionCache(j,G){try{await this.fileService.writeFile(j,A.VSBuffer.fromString(JSON.stringify(G)))}catch(z){this.logService.debug("Error while writing the extension cache file:",j.path,(0,_.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const j=this.getCacheFile(this.input),G=await this.readExtensionCache(j);if(!G)return;const z=G.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!O.equals(q,z))try{this.logService.info("Invalidating Cache",z,q),await this.fileService.del(j),this._onDidChangeCache.fire()}catch(ie){this.logService.error(ie)}}getCacheFile(j){const G=this.getProfile(j);return this.uriIdentityService.extUri.joinPath(G.cacheHome,j.type===0?S.BUILTIN_MANIFEST_CACHE_FILE:S.USER_MANIFEST_CACHE_FILE)}getProfile(j){return j.type===0?this.userDataProfilesService.defaultProfile:j.profile?this.uriIdentityService.extUri.isEqual(j.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(G=>this.uriIdentityService.extUri.isEqual(j.location,G.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};x=we([K(2,C.IUserDataProfilesService),K(3,E.IExtensionsProfileScannerService),K(4,b.IUriIdentityService),K(5,o.IFileService),K(6,s.ILogService)],x);function Z(X,j){const G=(0,c.getExtensionId)(X.manifest.publisher,X.manifest.name);return{id:G,identifier:new S.ExtensionIdentifier(G),isBuiltin:X.type===0,isUserBuiltin:X.type===1&&X.isBuiltin,isUnderDevelopment:j,extensionLocation:X.location,uuid:X.identifier.uuid,targetPlatform:X.targetPlatform,...X.manifest}}class B extends k{constructor(j,G,z,q,ie,ae,te,ce,V,$,T,M){super(j,G,(0,h.joinPath)(z,".vscode-oss-dev","extensions","control.json"),q,ie,ae,te,ce,V,$,T,M),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const W=await this.fileService.readFile(d.URI.file(m.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=B}),define(le[251],ue([0,1,67,6,38,3,2,23,14,31,9,18]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends _.Disposable{constructor(u,y){super(),this.userDataProfilesService=u,this.logService=y,this.processesLimiter=new U.Limiter(5)}async postUninstall(u){const y=this.parseScript(u,"uninstall");y&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(y.script,"uninstall",y.args,!0,u),this.logService.info("Finished running post uninstall script",u.identifier.id,u.manifest.version)}catch(v){this.logService.error("Failed to run post uninstall script",u.identifier.id,u.manifest.version),this.logService.error(v)}}));try{await f.Promises.rm(this.getExtensionStoragePath(u))}catch(v){this.logService.error("Error while removing extension storage path",u.identifier.id),this.logService.error(v)}}parseScript(u,y){const v=`vscode:${y}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const d=u.manifest.scripts[v].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,P.join)(u.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(u,y,v,d,g){return new Promise((l,c)=>{const S=this.start(u,y,v,g);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):l(void 0)};S.on("error",n=>{o((0,O.toErrorMessage)(n)||"Unknown")}),S.on("exit",(n,s)=>{o(n?`post-${y} process exited with code ${n}`:void 0)}),d&&(i=setTimeout(()=>{i=null,S.kill(),c("timed out")},5e3))})}start(u,y,v,d){const g={silent:!0,execArgv:void 0},l=(0,L.fork)(u,[`--type=extension-post-${y}`,...v],g);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const c=A.Event.fromNodeEventEmitter(l.stdout,"data"),S=A.Event.fromNodeEventEmitter(l.stderr,"data");c(n=>this.logService.info(d.identifier.id,d.manifest.version,`post-${y}`,n)),S(n=>this.logService.error(d.identifier.id,d.manifest.version,`post-${y}`,n));const i=A.Event.any(A.Event.map(c,n=>({data:`%c${n}`,format:[""]})),A.Event.map(S,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(d.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}getExtensionStoragePath(u){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m,e.ExtensionsLifecycle=m=we([K(0,w.IUserDataProfilesService),K(1,D.ILogService)],m)}),define(le[113],ue([0,1,6,15,26,38,7,3,54,2,35,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i,o,n,s,t,r,a,E,C,b,I,p,k,N,F,x,Z,B,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,N.refineServiceDecorator)(n.IExtensionManagementService);const j=".vsctmp";let G=class extends o.AbstractExtensionManagementService{constructor(V,$,T,M,W,J,H,ee,Q,Y,ne,re){super(V,$,ne,T,Y,re),this.extensionsScannerService=W,this.extensionsProfileScannerService=J,this.downloadService=H,this.fileService=Q,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new D.ResourceSet;const he=this._register(ee.createInstance(E.ExtensionsLifecycle));this.extensionsScanner=this._register(ee.createInstance(z,me=>he.postUninstall(me))),this.manifestCache=this._register(new b.ExtensionsManifestCache(re,Q,ne,this,this.logService)),this.extensionsDownloader=this._register(ee.createInstance(a.ExtensionsDownloader));const fe=this._register(new I.ExtensionsWatcher(this,this.extensionsScannerService,re,J,ne,Q,T));this._register(fe.onDidChangeExtensionsByAnotherSource(me=>this.onDidChangeExtensionsFromAnotherSource(me))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(V){this.logService.trace("ExtensionManagementService#zip",V.identifier.id);const $=await this.collectFiles(V),T=await(0,l.zip)((0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,$);return v.URI.file(T)}async unzip(V){return this.logService.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:$,cleanup:T}=await this.downloadVsix(V),M=m.resolve($.fsPath);try{return await(0,C.getManifest)(M)}finally{await T()}}getInstalled(V,$=this.userDataProfilesService.defaultProfile.extensionsResource,T={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(V??null,$,T)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.extensionsScanner.scanUserExtensionAtLocation(V)}async install(V,$={}){this.logService.trace("ExtensionManagementService#install",V.toString());const{location:T,cleanup:M}=await this.downloadVsix(V);try{const W=await(0,C.getManifest)(m.resolve(T.fsPath)),J=(0,s.getGalleryExtensionId)(W.publisher,W.name);if(W.engines&&W.engines.vscode&&!(0,p.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(c.localize(0,null,J,this.productService.version));const ee=(await this.installExtensions([{manifest:W,extension:T,options:$}])).find(({identifier:Q})=>(0,s.areSameExtensions)(Q,{id:J}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,o.toExtensionManagementError)(new Error(`Unknown error while installing extension ${J}`))}finally{await M()}}async installFromLocation(V,$){this.logService.trace("ExtensionManagementService#installFromLocation",V.toString());const T=await this.extensionsScanner.scanUserExtensionAtLocation(V);if(!T||!T.manifest.name||!T.manifest.version)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.addExtensionsToProfile([[T,{source:"resource"}]],$),this.logService.info("Successfully installed extension",T.identifier.id,$.toString()),T}async installExtensionsFromProfile(V,$,T){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",V,$.toString(),T.toString());const M=(await this.getInstalled(1,$)).filter(W=>V.some(J=>(0,s.areSameExtensions)(J,W.identifier)));if(M.length){const W=await Promise.all(M.map(J=>this.extensionsScanner.scanMetadata(J,$)));await this.addExtensionsToProfile(M.map((J,H)=>[J,W[H]]),T),this.logService.info("Successfully installed extensions",M.map(J=>J.identifier.id),T.toString())}return M}async updateMetadata(V,$,T=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",V.identifier.id),$.isPreReleaseVersion&&($.preRelease=!0,$.hasPreReleaseVersion=!0),$.isMachineScoped===!1&&($.isMachineScoped=void 0),$.isBuiltin===!1&&($.isBuiltin=void 0),$.pinned===!1&&($.pinned=void 0),V=await this.extensionsScanner.updateMetadata(V,$,T),this.manifestCache.invalidate(T),this._onDidUpdateExtensionMetadata.fire(V),V}async reinstallFromGallery(V){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.galleryService.isEnabled())throw new Error(c.localize(1,null));const $=await this.getTargetPlatform(),[T]=await this.galleryService.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:$,compatible:!0},O.CancellationToken.None);if(!T)throw new Error(c.localize(2,null));await this.extensionsScanner.setUninstalled(V);try{await this.extensionsScanner.removeUninstalledExtension(V)}catch(M){throw new Error(c.localize(3,null,(0,A.toErrorMessage)(M)))}return this.installFromGallery(T)}copyExtension(V,$,T,M){return this.extensionsScanner.copyExtension(V,$,T,M)}copyExtensions(V,$){return this.extensionsScanner.copyExtensions(V,$,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...V){return this.extensionsScanner.setUninstalled(...V)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(V){this.logService.error(V)}}async download(V,$,T){const{location:M}=await this.extensionsDownloader.download(V,$,!T);return M}async downloadVsix(V){if(V.scheme===w.Schemas.file)return{location:V,async cleanup(){}};this.logService.trace("Downloading extension from",V.toString());const $=(0,h.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,d.generateUuid)());return await this.downloadService.download(V,$),this.logService.info("Downloaded extension to",$.toString()),{location:$,cleanup:async()=>{try{await this.fileService.del($)}catch(M){this.logService.error(M)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(V,$,T){if(v.URI.isUri($))return new ae(V,$,T,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const M=s.ExtensionKey.create($).toString();let W=this.installGalleryExtensionsTasks.get(M);return W||(this.installGalleryExtensionsTasks.set(M,W=new ie(V,$,T,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService,this.telemetryService)),W.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(M))),W}createUninstallExtensionTask(V,$){return new te(V,$.profileLocation,this.extensionsProfileScannerService)}async collectFiles(V){const $=async M=>{let W=await g.Promises.readdir(M);W=W.map(ee=>m.join(M,ee));const J=await Promise.all(W.map(ee=>g.Promises.stat(ee)));let H=Promise.resolve([]);return J.forEach((ee,Q)=>{const Y=W[Q];ee.isFile()&&(H=H.then(ne=>[...ne,Y])),ee.isDirectory()&&(H=H.then(ne=>$(Y).then(re=>[...ne,...re])))}),H};return(await $(V.location.fsPath)).map(M=>({path:`extension/${m.relative(V.location.fsPath,M)}`,localPath:M}))}async onDidChangeExtensionsFromAnotherSource({added:V,removed:$}){if($){const T=V&&this.uriIdentityService.extUri.isEqual($.profileLocation,V.profileLocation)?$.extensions.filter(M=>V.extensions.every(W=>!(0,s.areSameExtensions)(W,M))):$.extensions;for(const M of T)this.logService.info("Extensions removed from another source",M.id,$.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:M,profileLocation:$.profileLocation})}if(V){const M=(await this.getInstalled(1,V.profileLocation)).filter(W=>V.extensions.some(J=>(0,s.areSameExtensions)(J,W.identifier)));this._onDidInstallExtensions.fire(M.map(W=>(this.logService.info("Extensions added from another source",W.identifier.id,V.profileLocation.toString()),{identifier:W.identifier,local:W,profileLocation:V.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract($=>this.knownDirectories.add($)));const V=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const $ of V.children??[])$.isDirectory&&this.knownDirectories.add($.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange($=>this.onDidFilesChange($)))}async onDidFilesChange(V){if(!V.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const $=[];for(const T of V.rawAdded){if(this.knownDirectories.has(T)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(T),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(T,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(T).startsWith(".")||!(await this.fileService.stat(T)).isDirectory)continue;const M=await this.extensionsScanner.scanUserExtensionAtLocation(T);M&&M.installedTimestamp===void 0&&(this.knownDirectories.add(T),$.push(M))}$.length&&(await this.addExtensionsToProfile($.map(T=>[T,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",$.map(T=>T.identifier.id)))}async addExtensionsToProfile(V,$){const T=V.map(M=>M[0]);await this.setInstalled(T),await this.extensionsProfileScannerService.addExtensionsToProfile(V,$),this._onDidInstallExtensions.fire(T.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:$})))}async setInstalled(V){const $=await this.extensionsScanner.getUninstalledExtensions();for(const T of V){const M=s.ExtensionKey.create(T);$[M.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id))}}};e.ExtensionManagementService=G,e.ExtensionManagementService=G=we([K(0,n.IExtensionGalleryService),K(1,Z.ITelemetryService),K(2,F.ILogService),K(3,i.INativeEnvironmentService),K(4,r.IExtensionsScannerService),K(5,t.IExtensionsProfileScannerService),K(6,S.IDownloadService),K(7,N.IInstantiationService),K(8,k.IFileService),K(9,x.IProductService),K(10,B.IUriIdentityService),K(11,X.IUserDataProfilesService)],G);let z=class extends f.Disposable{constructor(V,$,T,M,W,J){super(),this.beforeRemovingExtension=V,this.fileService=$,this.extensionsScannerService=T,this.extensionsProfileScannerService=M,this.uriIdentityService=W,this.logService=J,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,h.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(V,$,T){const M={includeInvalid:!0,profileLocation:$,productVersion:T};let W=[];return V===null||V===0?W.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},M,!1)):V===1&&W.push(...await this.extensionsScannerService.scanUserExtensions(M)),W=V!==null?W.filter(J=>J.type===V):W,Promise.all(W.map(J=>this.toLocalExtension(J)))}async scanAllUserExtensions(V){const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all($.map(T=>this.toLocalExtension(T)))}async scanUserExtensionAtLocation(V){try{const $=await this.extensionsScannerService.scanExistingExtension(V,1,{includeInvalid:!0});if($)return await this.toLocalExtension($)}catch($){this.logService.error($)}return null}async extractUserExtension(V,$,T,M,W){const J=V.toString(),H=v.URI.file(m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`)),ee=v.URI.file(m.join(this.extensionsScannerService.userExtensionsLocation.fsPath,J));let Q=await this.fileService.exists(ee);if(Q&&M){try{await this.deleteExtensionFromLocation(V.id,ee,"removeExisting")}catch{throw new n.ExtensionManagementError(c.localize(4,null,ee.fsPath,V.id),n.ExtensionManagementErrorCode.Delete)}Q=!1}if(Q)await this.extensionsScannerService.updateMetadata(ee,T);else try{try{this.logService.trace(`Started extracting the extension from ${$} to ${ee.fsPath}`),await(0,l.extract)($,H.fsPath,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${ee}:`,V.id)}catch(Y){let ne=n.ExtensionManagementErrorCode.Extract;throw Y instanceof l.ExtractError&&(Y.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:Y.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(Y.message,ne)}await this.extensionsScannerService.updateMetadata(H,T);try{this.logService.trace(`Started renaming the extension from ${H.fsPath} to ${ee.fsPath}`),await this.rename(H.fsPath,ee.fsPath),this.logService.info("Renamed to",ee.fsPath)}catch(Y){if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(Y)}. Deleted from extracted location`,H),Y}this._onExtract.fire(ee)}catch(Y){try{await this.fileService.del(H,{recursive:!0})}catch{}throw Y}return this.scanLocalExtension(ee,1)}async scanMetadata(V,$){return $?(await this.getScannedExtension(V,$))?.metadata:this.extensionsScannerService.scanMetadata(V.location)}async getScannedExtension(V,$){return(await this.extensionsProfileScannerService.scanProfileExtensions($)).find(M=>(0,s.areSameExtensions)(M.identifier,V.identifier))}async updateMetadata(V,$,T){return T?await this.extensionsProfileScannerService.updateMetadata([[V,$]],T):await this.extensionsScannerService.updateMetadata(V.location,$),this.scanLocalExtension(V.location,V.type,T)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...V){const $=V.map(T=>s.ExtensionKey.create(T));await this.withUninstalledExtensions(T=>$.forEach(M=>{T[M.toString()]=!0,this.logService.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(V){await this.withUninstalledExtensions($=>delete $[V.toString()])}async removeExtension(V,$){if(this.uriIdentityService.extUri.isEqualOrParent(V.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(V.identifier.id,V.location,$)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.withUninstalledExtensions($=>delete $[s.ExtensionKey.create(V).toString()])}async copyExtension(V,$,T,M){const W=await this.getScannedExtension(V,$),J=await this.getScannedExtension(V,T);if(M={...W?.metadata,...M},J)if(this.uriIdentityService.extUri.isEqual(J.location,V.location))await this.extensionsProfileScannerService.updateMetadata([[V,{...J.metadata,...M}]],T);else{const H=await this.scanLocalExtension(J.location,V.type,T);await this.extensionsProfileScannerService.removeExtensionFromProfile(H,T),await this.extensionsProfileScannerService.addExtensionsToProfile([[V,{...J.metadata,...M}]],T)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[V,M]],T);return this.scanLocalExtension(V.location,V.type,T)}async copyExtensions(V,$,T){const M=await this.scanExtensions(1,V,T),W=await Promise.all(M.filter(J=>!J.isApplicationScoped).map(async J=>[J,await this.scanMetadata(J,V)]));await this.extensionsProfileScannerService.addExtensionsToProfile(W,$)}async deleteExtensionFromLocation(V,$,T){this.logService.trace(`Deleting ${T} extension from disk`,V,$.fsPath);const M=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname($),`${this.uriIdentityService.extUri.basename($)}.${(0,P.hash)((0,d.generateUuid)()).toString(16)}${j}`);await this.rename($.fsPath,M.fsPath),await this.fileService.del(M,{recursive:!0}),this.logService.info(`Deleted ${T} extension from disk`,V,$.fsPath)}async withUninstalledExtensions(V){return this.uninstalledFileLimiter.queue(async()=>{let $;try{$=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(M){if((0,k.toFileOperationResult)(M)!==1)throw M}let T={};if($)try{T=JSON.parse($)}catch{}return V&&(V(T),Object.keys(T).length?await this.fileService.writeFile(this.uninstalledResource,U.VSBuffer.fromString(JSON.stringify(T))):await this.fileService.del(this.uninstalledResource)),T})}async rename(V,$){try{await g.Promises.rename(V,$,2*60*1e3)}catch(T){throw new n.ExtensionManagementError(T.message||c.localize(5,null,V,$),T.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(V,$,T){if(T){const W=(await this.extensionsScannerService.scanUserExtensions({profileLocation:T})).find(J=>this.uriIdentityService.extUri.isEqual(J.location,V));if(W)return this.toLocalExtension(W)}else{const M=await this.extensionsScannerService.scanExistingExtension(V,$,{includeInvalid:!0});if(M)return this.toLocalExtension(M)}throw new Error(c.localize(6,null,V.path))}async toLocalExtension(V){const $=await this.fileService.resolve(V.location);let T,M;return $.children&&(T=$.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,M=$.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:T,changelogUrl:M,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!V.metadata?.hasPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned,isWorkspaceScoped:!1,source:V.metadata?.source??(V.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const V=await this.getUninstalledExtensions();if(Object.keys(V).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(V));const $=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const W of $)V[s.ExtensionKey.create(W).toString()]||T.add(W.identifier.id.toLowerCase());try{const W=(0,s.groupByExtension)($,J=>J.identifier);await L.Promises.settled(W.map(async J=>{const H=J.sort((ee,Q)=>u.rcompare(ee.manifest.version,Q.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}))}catch(W){this.logService.error(W)}const M=$.filter(W=>W.metadata&&V[s.ExtensionKey.create(W).toString()]);await Promise.allSettled(M.map(W=>this.removeUninstalledExtension(W)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let V;try{V=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch($){(0,k.toFileOperationResult)($)!==1&&this.logService.error($);return}if(V?.children)try{await Promise.allSettled(V.children.map(async $=>{if(!(!$.isDirectory||!$.name.endsWith(j))){this.logService.trace("Deleting the temporarily deleted folder",$.resource.toString());try{await this.fileService.del($.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",$.resource.toString())}catch(T){(0,k.toFileOperationResult)(T)!==1&&this.logService.error(T)}}}))}catch{}}};e.ExtensionsScanner=z,e.ExtensionsScanner=z=we([K(1,k.IFileService),K(2,r.IExtensionsScannerService),K(3,t.IExtensionsProfileScannerService),K(4,B.IUriIdentityService),K(5,F.ILogService)],z);class q extends o.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(V,$,T,M,W,J,H,ee,Q){super(),this.identifier=V,this.source=$,this.options=T,this.extensionsScanner=M,this.uriIdentityService=W,this.userDataProfilesService=J,this.extensionsScannerService=H,this.extensionsProfileScannerService=ee,this.logService=Q,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(V){const[$,T]=await this.install(V);return this._profileLocation=$.isBuiltin||$.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[$,T]],this._profileLocation,!$.isValid),$}async extractExtension({zipPath:V,key:$,metadata:T},M,W){let J=await this.unsetIfUninstalled($);return J?J=await this.extensionsScanner.updateMetadata(J,T):(this.logService.trace("Extracting extension...",$.id),J=await this.extensionsScanner.extractUserExtension($,V,T,M,W),this.logService.info("Extracting extension completed.",$.id)),J}async unsetIfUninstalled(V){return await this.isUninstalled(V)?(this.logService.trace("Removing the extension from uninstalled list:",V.id),await this.extensionsScanner.setInstalled(V),this.logService.info("Removed the extension from uninstalled list:",V.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(M=>s.ExtensionKey.create(M).equals(V))):void 0}async isUninstalled(V){return!!(await this.extensionsScanner.getUninstalledExtensions())[V.toString()]}}class ie extends q{constructor(V,$,T,M,W,J,H,ee,Q,Y,ne){super($.identifier,$,T,W,J,H,ee,Q,Y),this.gallery=$,this.extensionsDownloader=M,this.telemetryService=ne}async install(V){let $;try{$=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(W){throw new n.ExtensionManagementError(W,n.ExtensionManagementErrorCode.Scanning)}const T=$.find(W=>(0,s.areSameExtensions)(W.identifier,this.gallery.identifier));T&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:T?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned,preRelease:(0,y.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||T?.preRelease,source:"gallery"};if(T?.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(T,M),M]}catch(W){throw new n.ExtensionManagementError((0,_.getErrorMessage)(W),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.downloadAndInstallExtension(M,V)}catch(W){if(W instanceof n.ExtensionManagementError&&(W.code===n.ExtensionManagementErrorCode.CorruptZip||W.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.logService.info("Downloaded VSIX is invalid. Trying to download and install again...",this.gallery.identifier.id);try{const J=await this.downloadAndInstallExtension(M,V);return this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!0}),J}catch(J){throw this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!1}),J}}else throw W}}async downloadAndInstallExtension(V,$){const{location:T,verificationStatus:M}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=M,this.validateManifest(T.fsPath),[await this.extractExtension({zipPath:T.fsPath,key:s.ExtensionKey.create(this.gallery),metadata:V},!1,$),V]}catch(W){try{await this.extensionsDownloader.delete(T)}catch(J){this.logService.warn("Error while deleting the downloaded file",T.toString(),(0,_.getErrorMessage)(J))}throw W}}async validateManifest(V){try{await(0,C.getManifest)(V)}catch($){throw new n.ExtensionManagementError((0,o.joinErrors)($).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ie;class ae extends q{constructor(V,$,T,M,W,J,H,ee,Q,Y){super({id:(0,s.getGalleryExtensionId)(V.publisher,V.name)},$,T,W,J,H,ee,Q,Y),this.manifest=V,this.location=$,this.galleryService=M}async doRun(V){const $=await super.doRun(V);return this.updateMetadata($,V),$}async install(V){const $=new s.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(H=>(0,s.areSameExtensions)(this.identifier,H.identifier)),W={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:"vsix"};if(M)if(this._operation=3,$.equals(new s.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(c.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&u.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const H=await this.unsetIfUninstalled($);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(c.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:m.resolve(this.location.fsPath),key:$,metadata:W},!0,V),W]}async updateMetadata(V,$){try{let[T]=await this.galleryService.getExtensions([{id:V.identifier.id,version:V.manifest.version}],$);if(T||([T]=await this.galleryService.getExtensions([{id:V.identifier.id}],$)),T){const M={id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId,isPreReleaseVersion:T.properties.isPreReleaseVersion,hasPreReleaseVersion:V.hasPreReleaseVersion||T.properties.isPreReleaseVersion,preRelease:T.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(V,M,this.options.profileLocation)}}catch{}}}class te extends o.AbstractExtensionTask{constructor(V,$,T){super(),this.extension=V,this.profileLocation=$,this.extensionsProfileScannerService=T}async doRun(V){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(le[252],ue([0,1,9,18,28,22,52,12,16,8]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let D=class extends _.AbstractExtensionsProfileScannerService{constructor(m,h,u,y,v,d){super(f.URI.file(m.extensionsPath),h,u,y,v,d)}};e.ExtensionsProfileScannerService=D,e.ExtensionsProfileScannerService=D=we([K(0,P.INativeEnvironmentService),K(1,R.IFileService),K(2,U.IUserDataProfilesService),K(3,O.IUriIdentityService),K(4,A.ITelemetryService),K(5,L.ILogService)],D)}),define(le[253],ue([0,1,8,16,52,81,12,4,9,24,28,18]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends A.NativeExtensionsScannerService{constructor(u,y,v,d,g,l,c,S){super(L.URI.file(g.builtinExtensionsPath),L.URI.file(g.extensionsPath),g.userHome,u.defaultProfile,u,y,v,d,g,l,c,S)}};e.ExtensionsScannerService=m,e.ExtensionsScannerService=m=we([K(0,w.IUserDataProfilesService),K(1,O.IExtensionsProfileScannerService),K(2,_.IFileService),K(3,P.ILogService),K(4,U.INativeEnvironmentService),K(5,f.IProductService),K(6,D.IUriIdentityService),K(7,R.IInstantiationService)],m)}),define(le[19],ue([0,1,6,3,2,98,13,69,4,18]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=h,e.isProfileUsingDefaultStorage=y,e.logStorage=d,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var D;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(D||(e.WillSaveStateReason=D={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(g){const l=g.get(e.TARGET_KEY);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class u extends O.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(l={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super(),this.options=l,this._onDidChangeValue=this._register(new U.PauseableEmitter),this._onDidChangeTarget=this._register(new U.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new U.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new O.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(l,c,S){return U.Event.filter(this._onDidChangeValue.event,i=>i.scope===l&&(c===void 0||i.key===c),S)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,O.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(l,c){const{key:S,external:i}=c;if(S===e.TARGET_KEY){switch(l){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:l})}else this._onDidChangeValue.fire({scope:l,key:S,target:this.getKeyTargets(l)[S],external:i})}emitWillSaveState(l){this._onWillSaveState.fire({reason:l})}get(l,c,S){return this.getStorage(c)?.get(l,S)}getBoolean(l,c,S){return this.getStorage(c)?.getBoolean(l,S)}getNumber(l,c,S){return this.getStorage(c)?.getNumber(l,S)}getObject(l,c,S){return this.getStorage(c)?.getObject(l,S)}storeAll(l,c){this.withPausedEmitters(()=>{for(const S of l)this.store(S.key,S.value,S.scope,S.target,c)})}store(l,c,S,i,o=!1){if((0,_.isUndefinedOrNull)(c)){this.remove(l,S,o);return}this.withPausedEmitters(()=>{this.updateKeyTarget(l,S,i),this.getStorage(S)?.set(l,c,o)})}remove(l,c,S=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(l,c,void 0),this.getStorage(c)?.delete(l,S)})}withPausedEmitters(l){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{l()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(l,c){const S=[],i=this.getKeyTargets(l);for(const o of Object.keys(i))i[o]===c&&S.push(o);return S}updateKeyTarget(l,c,S,i=!1){const o=this.getKeyTargets(c);typeof S=="number"?o[l]!==S&&(o[l]=S,this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(o),i)):typeof o[l]=="number"&&(delete o[l],this.getStorage(c)?.set(e.TARGET_KEY,JSON.stringify(o),i))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(l){switch(l){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(l){const c=this.getStorage(l);return c?h(c):Object.create(null)}isNew(l){return this.getBoolean(e.IS_NEW_KEY,l)===!0}async flush(l=D.NONE){this._onWillSaveState.fire({reason:l});const c=this.getStorage(-1),S=this.getStorage(0),i=this.getStorage(1);switch(l){case D.NONE:await L.Promises.settled([c?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await L.Promises.settled([c?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(l,c,S,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(l){return await this.flush(),this.getStorage(l)?.optimize()}async switch(l,c){return this.emitWillSaveState(D.NONE),(0,f.isUserDataProfile)(l)?this.switchToProfile(l,c):this.switchToWorkspace(l,c)}canSwitchProfile(l,c){return!(l.id===c.id||y(c)&&y(l))}switchData(l,c,S){this.withPausedEmitters(()=>{const i=new Set;for(const[o,n]of l)i.add(o),c.get(o)!==n&&this.emitDidChangeValue(S,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.emitDidChangeValue(S,{key:o,external:!0})})}}e.AbstractStorageService=u;function y(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class v extends u{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(l=>this.emitDidChangeValue(1,l))),this._register(this.profileStorage.onDidChangeStorage(l=>this.emitDidChangeValue(0,l))),this._register(this.applicationStorage.onDidChangeStorage(l=>this.emitDidChangeValue(-1,l)))}getStorage(l){switch(l){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(l){return!1}}e.InMemoryStorageService=v;async function d(g,l,c,S,i,o){const n=p=>{try{return JSON.parse(p)}catch{return p}},s=new Map,t=new Map;g.forEach((p,k)=>{s.set(k,p),t.set(k,n(p))});const r=new Map,a=new Map;l.forEach((p,k)=>{r.set(k,p),a.set(k,n(p))});const E=new Map,C=new Map;c.forEach((p,k)=>{E.set(k,p),C.set(k,n(p))}),console.group(S!==i?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const b=[];if(s.forEach((p,k)=>{b.push({key:k,value:p})}),console.table(b),console.groupEnd(),console.log(t),S!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const p=[];r.forEach((k,N)=>{p.push({key:N,value:k})}),console.table(p),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const I=[];E.forEach((p,k)=>{I.push({key:k,value:p})}),console.table(I),console.groupEnd(),console.log(C)}}),define(le[114],ue([0,1,3,2,13,29,33,19]),function(se,e,L,U,O,A,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends U.Disposable{constructor(w,m){super(),this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new f(w)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"}))),this._register(m.onDidInstallExtensions(h=>h.forEach(({local:u,operation:y})=>{u&&y===4&&this._removeFromDisabledExtensions(u.identifier)})))}async enableExtension(w,m){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}async disableExtension(w,m){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const m=this.getDisabledExtensions();return m.every(h=>!(0,_.areSameExtensions)(h,w))?(m.push(w),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(w){const m=this.getDisabledExtensions();for(let h=0;h<m.length;h++){const u=m[h];if((0,_.areSameExtensions)(u,w))return m.splice(h,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(w){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,m){this.storageManger.set(w,m,0)}};e.GlobalExtensionEnablementService=P,e.GlobalExtensionEnablementService=P=we([K(0,R.IStorageService),K(1,A.IExtensionManagementService)],P);class f extends U.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(0,void 0,this._register(new U.DisposableStore))(m=>this.onDidStorageChange(m)))}get(w,m){let h;return m===0?((0,O.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,m)),h=this.storage[w]):h=this._get(w,m),JSON.parse(h)}set(w,m,h){const u=JSON.stringify(m.map(({id:v,uuid:d})=>({id:v,uuid:d})));this._get(w,h)!==u&&(h===0&&(m.length?this.storage[w]=u:delete this.storage[w]),this._set(w,m.length?u:void 0,h))}onDidStorageChange(w){if(!(0,O.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const h=this.get(w.key,w.scope);delete this.storage[w.key];const u=this.get(w.key,w.scope),y=h.filter(d=>!u.some(g=>(0,_.areSameExtensions)(d,g))),v=u.filter(d=>!h.some(g=>(0,_.areSameExtensions)(g,d)));(y.length||v.length)&&this._onDidChange.fire([...y,...v])}}_get(w,m){return this.storageService.get(w,m,"[]")}_set(w,m,h){m?this.storageService.store(w,m,h,1):this.storageService.remove(w,h)}}e.StorageManager=f}),define(le[254],ue([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=ae;const i=A.isWeb?"web":(0,w.getTargetPlatform)(A.platform,_.arch),o="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce((W,J)=>W|J,0))}var t;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class b{constructor(W=C){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(W,J=this.state.pageSize){return new b({...this.state,pageNumber:W,pageSize:J})}withFilter(W,...J){const H=[...this.state.criteria,...J.length?J.map(ee=>({filterType:W,value:ee})):[{filterType:W}]];return new b({...this.state,criteria:H})}withSortBy(W){return new b({...this.state,sortBy:W})}withSortOrder(W){return new b({...this.state,sortOrder:W})}withFlags(...W){return new b({...this.state,flags:W.reduce((J,H)=>J|H,0)})}withAssetTypes(...W){return new b({...this.state,assetTypes:W})}withSource(W){return new b({...this.state,source:W})}get raw(){const{criteria:W,pageNumber:J,pageSize:H,sortBy:ee,sortOrder:Q,flags:Y,assetTypes:ne}=this.state;return{filters:[{criteria:W,pageNumber:J,pageSize:H,sortBy:ee,sortOrder:Q}],assetTypes:ne,flags:Y}}get searchText(){const W=this.state.criteria.filter(J=>J.filterType===t.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function I(M,W){const J=(M||[]).filter(H=>H.statisticName===W)[0];return J?J.value:0}function p(M){const W="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(H=>H.assetType.indexOf(W)===0).reduce((H,ee)=>{const Q=F(M,ee.assetType);return Q&&H.push([ee.assetType.substring(W.length),Q]),H},[])}function k(M){if(M.properties){const W=M.properties.filter(ee=>ee.key===r.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=W.filter(ee=>J.test(ee.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return F(M,r.Repository)}function N(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,W){return M.files.filter(H=>H.assetType===W)[0]?{uri:`${M.assetUri}/${W}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${W}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function x(M,W){const J=M.properties?M.properties.filter(ee=>ee.key===W):[],H=J.length>0&&J[0].value;return H?H.split(",").map(ee=>(0,m.adoptToGalleryExtensionId)(ee)):[]}function Z(M){const W=M.properties?M.properties.filter(J=>J.key===a.Engine):[];return W.length>0&&W[0].value||""}function B(M){const W=M.properties?M.properties.filter(J=>J.key===a.PreRelease):[];return W.length>0&&W[0].value==="true"}function X(M){const W=M.properties?M.properties.filter(H=>H.key===a.LocalizedLanguages):[],J=W.length>0&&W[0].value||"";return J?J.split(","):[]}function j(M){return M.properties?.find(W=>W.key===a.SponsorLink)?.value}function G(M){return M.properties?.find(W=>W.key===a.SupportLink)?.value}function z(M){return M.indexOf("preview")!==-1}function q(M){return M.targetPlatform?(0,w.toTargetPlatform)(M.targetPlatform):"undefined"}function ie(M){const W=(0,L.distinct)(M.versions.map(q)),J=!!M.tags?.includes(w.WEB_EXTENSION_TAG),H=W.indexOf("web");return J?H===-1&&W.push("web"):H!==-1&&W.splice(H,1),W}function ae(M,W){for(let J=0;J<M.length;J++){const H=M[J];if(H.version===M[J-1]?.version){let ee=J;if(q(H)===W)for(;ee>0&&M[ee-1].version===H.version;)ee--;ee!==J&&(M.splice(J,1),M.splice(ee,0,H))}}return M}function te(M,W,J){M.telemetryData={index:W,querySource:J,queryActivityId:M.queryContext?.[o]}}function ce(M,W,J,H){const ee=M.versions[0],Q={manifest:F(W,r.Manifest),readme:F(W,r.Details),changelog:F(W,r.Changelog),license:F(W,r.License),repository:k(W),download:N(W),icon:F(W,r.Icon),signature:F(W,r.Signature),coreTranslations:p(W)};return{identifier:{id:(0,m.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:W.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:j(ee),description:M.shortDescription??"",installCount:I(M.statistics,"install"),rating:I(M.statistics,"averagerating"),ratingCount:I(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:J,assets:Q,properties:{dependencies:x(W,a.Dependency),extensionPack:x(W,a.ExtensionPack),engine:Z(W),localizedLanguages:X(W),targetPlatform:q(W),isPreReleaseVersion:B(W)},hasPreReleaseVersion:B(ee),hasReleaseVersion:!0,preview:z(M.flags),isSigned:!!Q.signature,queryContext:H,supportLink:G(ee)}}let V=class{constructor(W,J,H,ee,Q,Y,ne,re){this.requestService=J,this.logService=H,this.environmentService=ee,this.telemetryService=Q,this.fileService=Y,this.productService=ne,this.configurationService=re;const he=ne.extensionsGallery,fe=he?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=fe?he.servicePPEUrl:he?.serviceUrl,this.extensionsGallerySearchUrl=fe?void 0:he?.searchUrl,this.extensionsControlUrl=he?.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ne.version,ne,this.environmentService,this.configurationService,this.fileService,W,this.telemetryService)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,J,H){const ee=U.CancellationToken.isCancellationToken(J)?{}:J,Q=U.CancellationToken.isCancellationToken(J)?J:H,Y=[],ne=[],re=[],he=[];let fe=!0;for(const Ie of W){Ie.uuid?ne.push(Ie.uuid):Y.push(Ie.id);const Le=!!(Ie.version||Ie.preRelease);re.push({id:Ie.id,uuid:Ie.uuid,includePreRelease:Le}),Ie.version&&he.push({id:Ie.id,uuid:Ie.uuid,version:Ie.version}),fe=fe&&!!Ie.hasPreRelease&&!Le}if(!ne.length&&!Y.length)return[];let me=new b().withPage(1,W.length);ne.length&&(me=me.withFilter(t.ExtensionId,...ne)),Y.length&&(me=me.withFilter(t.ExtensionName,...Y)),(ee.queryAllVersions||fe)&&(me=me.withFlags(me.flags,n.IncludeVersions)),ee.source&&(me=me.withSource(ee.source));const{extensions:Ee}=await this.queryGalleryExtensions(me,{targetPlatform:ee.targetPlatform??i,includePreRelease:re,versions:he,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.productService.version,date:this.productService.date}},Q);return ee.source&&Ee.forEach((Ie,Le)=>te(Ie,Le,ee.source)),Ee}async getCompatibleExtension(W,J,H,ee={version:this.productService.version,date:this.productService.date}){if((0,w.isNotWebExtensionInWebTargetPlatform)(W.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(W,J,H))return W;const Q=new b().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,W.identifier.uuid),{extensions:Y}=await this.queryGalleryExtensions(Q,{targetPlatform:H,compatible:!0,includePreRelease:J,productVersion:ee},U.CancellationToken.None);return Y[0]||null}async isExtensionCompatible(W,J,H,ee={version:this.productService.version,date:this.productService.date}){if(!(0,w.isTargetPlatformCompatible)(W.properties.targetPlatform,W.allTargetPlatforms,H)||!J&&W.properties.isPreReleaseVersion)return!1;let Q=W.properties.engine;if(!Q){const Y=await this.getManifest(W,U.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");Q=Y.engines.vscode}return(0,h.isEngineValid)(Q,ee.version,ee.date)}async isValidVersion(W,J,H,ee,Q,Y,ne={version:this.productService.version,date:this.productService.date}){if(!(0,w.isTargetPlatformCompatible)(q(J),Q,Y)||H!=="any"&&B(J)!==(H==="prerelease"))return!1;if(ee)try{const re=await this.getEngine(W,J);if(!(0,h.isEngineValid)(re,ne.version,ne.date))return!1}catch(re){return this.logService.error(`Error while getting the engine for the version ${J.version}.`,(0,O.getErrorMessage)(re)),!1}return!0}async query(W,J){let H=W.text||"";const ee=W.pageSize??50;let Q=new b().withPage(1,ee);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,Ee)=>(Q=Q.withFilter(t.Category,Ee||me),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,Ee)=>(Q=Q.withFilter(t.Tag,Ee||me),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(t.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),Q=Q.withFilter(t.SearchText,H)),Q=Q.withSortBy(0)):W.ids?Q=Q.withFilter(t.ExtensionId,...W.ids):W.names?Q=Q.withFilter(t.ExtensionName,...W.names):Q=Q.withSortBy(4),typeof W.sortBy=="number"&&(Q=Q.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(Q=Q.withSortOrder(W.sortOrder)),W.source&&(Q=Q.withSource(W.source));const Y=async(fe,me)=>{const{extensions:Ee,total:Ie}=await this.queryGalleryExtensions(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!W.includePreRelease,productVersion:W.productVersion??{version:this.productService.version,date:this.productService.date}},me);return Ee.forEach((Le,Te)=>te(Le,(fe.pageNumber-1)*fe.pageSize+Te,W.source)),{extensions:Ee,total:Ie}},{extensions:ne,total:re}=await Y(Q,J),he=async(fe,me)=>{if(me.isCancellationRequested)throw new O.CancellationError;const{extensions:Ee}=await Y(Q.withPage(fe+1),me);return Ee};return{firstPage:ne,total:re,pageSize:Q.pageSize,getPage:he}}async queryGalleryExtensions(W,J,H){const ee=W.flags;W.flags&n.IncludeLatestVersionOnly&&W.flags&n.IncludeVersions&&(W=W.withFlags(W.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(W.flags&n.IncludeLatestVersionOnly)&&!(W.flags&n.IncludeVersions)&&(W=W.withFlags(W.flags,n.IncludeLatestVersionOnly)),J.versions?.length&&(W=W.withFlags(W.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),W=W.withFlags(W.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Q,total:Y,context:ne}=await this.queryRawGalleryExtensions(W,H);if(!(W.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of Q){const Ie=await this.toGalleryExtensionWithCriteria(Ee,J,ne);Ie&&me.push(Ie)}return{extensions:me,total:Y}}const he=[],fe=new Map;for(let me=0;me<Q.length;me++){const Ee=Q[me],Ie={id:(0,m.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Le=(0,R.isBoolean)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(de=>(0,m.areSameExtensions)(de,Ie))?.includePreRelease;if(J.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ie(Ee),J.targetPlatform))continue;const Te=await this.toGalleryExtensionWithCriteria(Ee,J,ne);!Te||Te.properties.isPreReleaseVersion&&(!Le||!Te.hasReleaseVersion)||!Te.properties.isPreReleaseVersion&&Te.properties.targetPlatform!==J.targetPlatform&&Te.hasPreReleaseVersion?fe.set(Ee.extensionId,me):he.push([me,Te])}if(fe.size){const me=new S.StopWatch,Ee=new b().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:Ie}=await this.queryGalleryExtensions(Ee,J,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Le of Ie){const Te=fe.get(Le.identifier.uuid);he.push([Te,Le])}}return{extensions:he.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:Y}}async toGalleryExtensionWithCriteria(W,J,H){const ee={id:(0,m.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},Q=J.versions?.find(he=>(0,m.areSameExtensions)(he,ee))?.version,Y=(0,R.isBoolean)(J.includePreRelease)?J.includePreRelease:!!J.includePreRelease.find(he=>(0,m.areSameExtensions)(he,ee))?.includePreRelease,ne=ie(W),re=ae(W.versions,J.targetPlatform);if(J.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ne,J.targetPlatform))return null;for(let he=0;he<re.length;he++){const fe=re[he];if(!(Q&&fe.version!==Q)){if(await this.isValidVersion((0,m.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),fe,Y?"any":"release",J.compatible,ne,J.targetPlatform,J.productVersion))return ce(W,fe,ne,H);if(Q&&fe.version===Q)return null}}return Q||J.compatible?null:ce(W,W.versions[0],ne)}async queryRawGalleryExtensions(W,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const H=await this.commonHeadersPromise,ee=JSON.stringify(W.raw),Q={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Y=new S.StopWatch;let ne,re,he=0;try{if(ne=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&W.criteria.some(me=>me.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:Q},J),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:he};const fe=await(0,d.asJson)(ne);if(fe){const me=fe.results[0],Ee=me.extensions,Ie=me.resultMetadata&&me.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return he=Ie&&Ie.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:he,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(fe){const me=(0,O.isCancellationError)(fe)?w.ExtensionGalleryErrorCode.Cancelled:(0,O.getErrorMessage)(fe).startsWith("XHR timeout")?w.ExtensionGalleryErrorCode.Timeout:w.ExtensionGalleryErrorCode.Failed;throw re=new w.ExtensionGalleryError((0,O.getErrorMessage)(fe),me),re}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(ee.length),duration:Y.elapsed(),success:!!ne&&(0,d.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:re?.code,count:String(he)})}}async reportStatistic(W,J,H,ee){if(!this.isEnabled())return;const Q=A.isWeb?this.api(`/itemName/${W}.${J}/version/${H}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${J}/${H}/stats?statType=${ee}`),Y=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:Y};try{await this.requestService.request({type:"POST",url:Q,headers:re},U.CancellationToken.None)}catch{}}async download(W,J,H){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const ee=(0,m.getGalleryExtensionTelemetryData)(W),Q=new Date().getTime(),Y=me=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:me}),ne=H===2?"install":H===3?"update":"",re=ne?{uri:`${W.assets.download.uri}${P.URI.parse(W.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${W.assets.download.fallbackUri}${P.URI.parse(W.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:W.assets.download,he=W.queryContext?.[o]?{[o]:W.queryContext[o]}:void 0,fe=await this.getAsset(W.identifier.id,re,r.VSIX,he?{headers:he}:void 0);await this.fileService.writeFile(J,fe.stream),Y(new Date().getTime()-Q)}async downloadSignatureArchive(W,J){if(!W.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",W.identifier.id);const H=await this.getAsset(W.identifier.id,W.assets.signature,r.Signature);await this.fileService.writeFile(J,H.stream)}async getReadme(W,J){if(W.assets.readme){const H=await this.getAsset(W.identifier.id,W.assets.readme,r.Details,{},J);return await(0,d.asTextOrError)(H)||""}return""}async getManifest(W,J){if(W.assets.manifest){const H=await this.getAsset(W.identifier.id,W.assets.manifest,r.Manifest,{},J),ee=await(0,d.asTextOrError)(H);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(W,J,H){const ee=F(J,r.Manifest);if(!ee)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},Y=await this.getAsset(W,ee,r.Manifest,{headers:Q});return await(0,d.asJson)(Y)}async getCoreTranslation(W,J){const H=W.assets.coreTranslations.filter(ee=>ee[0]===J.toUpperCase())[0];if(H){const ee=await this.getAsset(W.identifier.id,H[1],H[0]),Q=await(0,d.asTextOrError)(ee);return Q?JSON.parse(Q):null}return null}async getChangelog(W,J){if(W.assets.changelog){const H=await this.getAsset(W.identifier.id,W.assets.changelog,r.Changelog,{},J);return await(0,d.asTextOrError)(H)||""}return""}async getAllCompatibleVersions(W,J,H){let ee=new b().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);W.identifier.uuid?ee=ee.withFilter(t.ExtensionId,W.identifier.uuid):ee=ee.withFilter(t.ExtensionName,W.identifier.id);const{galleryExtensions:Q}=await this.queryRawGalleryExtensions(ee,U.CancellationToken.None);if(!Q.length)return[];const Y=ie(Q[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(Y,H))return[];const ne=[];await Promise.all(Q[0].versions.map(async fe=>{try{await this.isValidVersion(W.identifier.id,fe,J?"any":"release",!0,Y,H)&&ne.push(fe)}catch{}}));const re=[],he=new Set;for(const fe of ae(ne,H))he.has(fe.version)||(he.add(fe.version),re.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:B(fe)}));return re}async getAsset(W,J,H,ee={},Q=U.CancellationToken.None){const Y=await this.commonHeadersPromise,ne={type:"GET"},re={...Y,...ee.headers||{}};ee={...ee,...ne,headers:re};const he=J.uri,fe=J.fallbackUri,me={...ee,url:he};try{const Ee=await this.requestService.request(me,Q);if(Ee.res.statusCode===200)return Ee;const Ie=await(0,d.asTextOrError)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ie}`)}catch(Ee){if((0,O.isCancellationError)(Ee))throw Ee;const Ie=(0,O.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:W,assetType:H,message:Ie});const Le={...ee,url:fe};return this.requestService.request(Le,Q)}}async getEngine(W,J){let H=Z(J);if(!H){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:W,version:J.version});const ee=await this.getManifestFromRawExtensionVersion(W,J,U.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");H=ee.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},U.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,d.asJson)(W),H=[],ee={},Q=[];if(J){for(const Y of J.malicious)H.push({id:Y});if(J.migrateToPreRelease)for(const[Y,ne]of Object.entries(J.migrateToPreRelease))(!ne.engine||(0,h.isEngineValid)(ne.engine,this.productService.version,this.productService.date))&&(ee[Y.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(J.deprecated)for(const[Y,ne]of Object.entries(J.deprecated))ne&&(ee[Y.toLowerCase()]=(0,R.isBoolean)(ne)?{}:ne);if(J.search)for(const Y of J.search)Q.push(Y)}return{malicious:H,deprecated:ee,search:Q}}};V=we([K(1,d.IRequestService),K(2,y.ILogService),K(3,D.IEnvironmentService),K(4,c.ITelemetryService),K(5,u.IFileService),K(6,v.IProductService),K(7,f.IConfigurationService)],V);let $=class extends V{constructor(W,J,H,ee,Q,Y,ne,re){super(W,J,H,ee,Q,Y,ne,re)}};e.ExtensionGalleryService=$,e.ExtensionGalleryService=$=we([K(0,l.IStorageService),K(1,d.IRequestService),K(2,y.ILogService),K(3,D.IEnvironmentService),K(4,c.ITelemetryService),K(5,u.IFileService),K(6,v.IProductService),K(7,f.IConfigurationService)],$);let T=class extends V{constructor(W,J,H,ee,Q,Y,ne){super(void 0,W,J,H,ee,Q,Y,ne)}};e.ExtensionGalleryServiceWithNoStorageService=T,e.ExtensionGalleryServiceWithNoStorageService=T=we([K(0,d.IRequestService),K(1,y.ILogService),K(2,D.IEnvironmentService),K(3,c.ITelemetryService),K(4,u.IFileService),K(5,v.IProductService),K(6,f.IConfigurationService)],T)}),define(le[82],ue([0,1,4,3,2,19,33,24,17,9,13]),function(se,e,L,U,O,A,_,R,P,f,D){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends O.Disposable{static{w=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(y){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(y.id)}@${y.version}`}static fromKey(y){const v=m.exec(y);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(y,v){const d=await y.getInstalled(),g=[];for(const[l,c]of w.readAllExtensionsWithKeysForSync(v)){const S=d.find(i=>(0,_.areSameExtensions)(i.identifier,{id:l}))?.manifest.version;for(const i of c)S!==i&&g.push(w.toKey({id:l,version:i}))}for(const l of g)v.remove(l,0)}static readAllExtensionsWithKeysForSync(y){const v=new Map,d=y.keys(0,1);for(const g of d){const l=w.fromKey(g);if(l){let c=v.get(l.id.toLowerCase());c||v.set(l.id.toLowerCase(),c=[]),c.push(l.version)}}return v}constructor(y,v,d){super(),this.storageService=y,this.productService=v,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new U.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=w.readAllExtensionsWithKeysForSync(y),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new O.DisposableStore))(g=>this.onDidChangeStorageValue(g)))}onDidChangeStorageValue(y){if(this.extensionsWithKeysForSync.has(y.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=w.fromKey(y.key);if(v){if(this.storageService.get(y.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let d=this.extensionsWithKeysForSync.get(v.id.toLowerCase());d||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),d=[]),d.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(y){if((0,D.isString)(y))return y;const v=y.manifest?y.manifest.publisher:y.publisher,d=y.manifest?y.manifest.name:y.name;return(0,_.getExtensionId)(v,d)}getExtensionState(y,v){const d=this.getExtensionId(y),g=this.getExtensionStateRaw(y,v);if(g)try{return JSON.parse(g)}catch(l){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${v}): ${l}`)}}getExtensionStateRaw(y,v){const d=this.getExtensionId(y),g=this.storageService.get(d,v?0:1);return g&&g?.length>w.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${d}, global: ${v}): ${g.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),g}setExtensionState(y,v,d){const g=this.getExtensionId(y);v===void 0?this.storageService.remove(g,d?0:1):this.storageService.store(g,JSON.stringify(v),d?0:1,1)}setKeysForSync(y,v){this.storageService.store(w.toKey(y),JSON.stringify(v),0,1)}getKeysForSync(y){const v=this.productService.extensionSyncedKeys?.[y.id.toLowerCase()],d=this.storageService.get(w.toKey(y),0),g=d?JSON.parse(d):void 0;return g&&v?(0,P.distinct)([...g,...v]):g||v}addToMigrationList(y,v){if(y!==v){const d=this.migrationList.filter(g=>!g.includes(y)&&!g.includes(v));d.push([y,v]),this.migrationList=d}}getSourceExtensionToMigrate(y){const v=this.migrationList.find(([,d])=>y===d);return v?v[0]:void 0}get migrationList(){const y=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(y);if(Array.isArray(v))return v}catch{}return[]}set migrationList(y){y.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=h,e.ExtensionStorageService=h=w=we([K(0,A.IStorageService),K(1,R.IProductService),K(2,f.ILogService)],h)}),define(le[255],ue([0,1,2,29,82,230,113,9,19]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let f=class extends L.Disposable{constructor(w,m,h,u,y,v){super(),w.cleanUp(),(0,A.migrateUnsupportedExtensions)(w,m,h,u,v),O.ExtensionStorageService.removeOutdatedExtensionVersions(w,y)}};e.ExtensionsContributions=f,e.ExtensionsContributions=f=we([K(0,_.INativeServerExtensionManagementService),K(1,U.IExtensionGalleryService),K(2,O.IExtensionStorageService),K(3,U.IGlobalExtensionEnablementService),K(4,P.IStorageService),K(5,R.ILogService)],f)}),define(le[256],ue([0,1,29,12,24,16,96,57,19,22,229]),function(se,e,L,U,O,A,_,R,P,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends D.AbstractNativeExtensionTipsService{constructor(h,u,y,v,d,g,l,c){super(h.userHome,d,u,y,v,g,l,c)}};e.ExtensionTipsService=w,e.ExtensionTipsService=w=we([K(0,A.INativeEnvironmentService),K(1,f.ITelemetryService),K(2,L.IExtensionManagementService),K(3,P.IStorageService),K(4,R.INativeHostService),K(5,_.IExtensionRecommendationNotificationService),K(6,U.IFileService),K(7,O.IProductService)],w)}),define(le[257],ue([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const S=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends _.Disposable{constructor(a,E,C,b,I,p,k){super(),this.telemetryService=a,this.productService=E,this.environmentService=C,this.configurationService=p,this.storageService=k,this._onDidTokenFailedEmitter=new U.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new U.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new U.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=L.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(N,F)=>{F?this._logger.error(N):this._logger.info(N)},this._logger=this._register(b.createLogger((0,c.joinPath)(C.logsHome,`${L.LOG_ID}.log`),{id:L.LOG_ID,name:L.LOGGER_NAME})),this._startTunnelProcessDelayer=new m.Delayer(100),this._register(this._logger.onDidChangeLogLevel(N=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(N)))),this._register(I.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(p.onDidChangeConfiguration(N=>{S.some(F=>N.affectsConfiguration(F))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=L.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(a){this._tunnelStatus=a,this._onDidChangeTunnelStatusEmitter.fire(a)}setMode(a){t(this._mode,a)||(this._mode=a,this._storeMode(a),this._onDidChangeModeEmitter.fire(this._mode),a.active?(this._logger.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this._logger.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(a){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(E){this._logger.error(E)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let a;w.isMacintosh?a=this.environmentService.appRoot:a=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(a,"bin",`${this.productService.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(a){if(t(this._mode,a)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(E){this._logger.error(E)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const a=this._mode.asService;this.setMode(L.INACTIVE_TUNNEL_MODE);try{a&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(E){this._logger.error(E)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(a){this._logger.error(a)}this.setTunnelStatus(L.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let a="",E=!1;const C=(F,x)=>{x?this._logger.error(F):a+=F,!this.environmentService.isBuilt&&F.startsWith("   Compiling")&&this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(0,null)))},b=this.runCodeTunnelCommand("status",["status"],C);this._tunnelProcess=b;try{if(await b,this._tunnelProcess!==b)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(x=>x.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.setTunnelStatus(L.TunnelStates.disconnected());return}if(E=F.service_installed,this._logger.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this._mode.active){this.setTunnelStatus(L.TunnelStates.disconnected());return}}catch(F){this._logger.error(F),this.setTunnelStatus(L.TunnelStates.disconnected());return}finally{this._tunnelProcess===b&&(this._tunnelProcess=void 0)}const I=this._mode.active?this._mode.session:void 0;if(I&&I.token){const F=I.token;this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(1,null,I.accountLabel,I.providerId)));const x=(B,X)=>{B=B.replaceAll(F,"*".repeat(4)),C(B,X)},Z=this.runCodeTunnelCommand("login",["user","login","--provider",I.providerId,"--access-token",F,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],x);this._tunnelProcess=Z;try{if(await Z,this._tunnelProcess!==Z)return}catch(B){this._logger.error(B),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(I),this.setTunnelStatus(L.TunnelStates.disconnected(I));return}}const p=this._getTunnelName();p?this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(2,null,p))):this.setTunnelStatus(L.TunnelStates.connecting((0,y.localize)(3,null)));const k=["--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];p?k.push("--name",p):k.push("--random-name");let N=!1;return this._mode.active&&this._mode.asService&&!E&&(N=await this.installTunnelService(k)===!1),this.serverOrAttachTunnel(I,k,N)}async installTunnelService(a){let E;try{E=await this.runCodeTunnelCommand("serviceInstall",["service","install",...a])}catch(C){this._logger.error(C),E=1}if(E!==0){const C=(0,y.localize)(4,null);return this._logger.warn(C),this.setTunnelStatus(L.TunnelStates.connecting(C)),!1}return!0}async serverOrAttachTunnel(a,E,C){E.push("--parent-process-id",String(process.pid)),this._preventSleep()&&E.push("--no-sleep");let b=!1;const I=this.runCodeTunnelCommand("tunnel",E,(p,k)=>{k?this._logger.error(p):this._logger.info(p),p.includes("Connected to an existing tunnel process")&&(b=!0);const N=p.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(N){const F={link:N[1],domain:N[2],tunnelName:N[4],isAttached:b};this.setTunnelStatus(L.TunnelStates.connected(F,C))}else p.match(/error refreshing token/)&&(I.cancel(),this._onDidTokenFailedEmitter.fire(a),this.setTunnelStatus(L.TunnelStates.disconnected(a)))});this._tunnelProcess=I,I.finally(()=>{I===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=L.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(L.TunnelStates.disconnected()))})}runCodeTunnelCommand(a,E,C=this.defaultOnOutput){return(0,m.createCancelablePromise)(b=>new Promise((I,p)=>{b.isCancellationRequested&&I(-1);let k;const N=["ignore","pipe","pipe"];if(b.onCancellationRequested(()=>{k&&(this._logger.info(`${a} terminating(${k.pid})`),k.kill())}),!this.environmentService.isBuilt)C(`Building tunnel CLI from sources and run
`,!1),C(`${a} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),k=(0,f.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,P.join)(this.environmentService.appRoot,"cli"),stdio:N});else{C(`Running tunnel CLI
`,!1);const F=this.getTunnelCommandLocation();C(`${a} Spawning: ${F} tunnel ${E.join(" ")}
`,!1),k=(0,f.spawn)(F,["tunnel",...E],{cwd:(0,v.homedir)(),stdio:N})}k.stdout.pipe(new l.StreamSplitter(`
`)).on("data",F=>{if(k){const x=F.toString();C(x,!1)}}),k.stderr.pipe(new l.StreamSplitter(`
`)).on("data",F=>{if(k){const x=F.toString();C(x,!0)}}),k.on("exit",F=>{k&&(C(`${a} exit(${k.pid}): + ${F} `,!1),k=void 0,I(F||0))}),k.on("error",F=>{k&&(C(`${a} error(${k.pid}): + ${F} `,!0),k=void 0,p())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let a=this.configurationService.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,v.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}_restoreMode(){try{const a=this.storageService.get(i,-1),E=this.storageService.getBoolean(o,-1,!1);if(a){const C=JSON.parse(a);if(C&&(0,g.isString)(C.accountLabel)&&(0,g.isString)(C.sessionId)&&(0,g.isString)(C.providerId))return{active:!0,session:C,asService:E};this._logger.error("Problems restoring session from storage, invalid format",C)}}catch(a){this._logger.error("Problems restoring session from storage",a)}return L.INACTIVE_TUNNEL_MODE}_storeMode(a){if(a.active){const E={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.storageService.store(i,JSON.stringify(E),-1,1),this.storageService.store(o,a.asService,-1,1)}else this.storageService.remove(i,-1),this.storageService.remove(o,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=we([K(0,O.ITelemetryService),K(1,D.IProductService),K(2,A.INativeEnvironmentService),K(3,R.ILoggerService),K(4,h.ISharedProcessLifecycleService),K(5,u.IConfigurationService),K(6,d.IStorageService)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[258],ue([0,1,6,2,23,20,69,19,77,18]),function(se,e,L,U,O,A,_,R,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class D extends R.AbstractStorageService{constructor(m,h,u,y){super(),this.initialWorkspace=m,this.initialProfiles=h,this.remoteService=u,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new U.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new U.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const m=this._register(new P.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),h=this._register(new _.Storage(m));return this._register(h.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u))),h}createProfileStorage(m){this.profileStorageDisposables.clear(),this.profileStorageProfile=m;let h;if((0,R.isProfileUsingDefaultStorage)(m))h=this.applicationStorage;else{const u=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),m));h=this.profileStorageDisposables.add(new _.Storage(u))}return this.profileStorageDisposables.add(h.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),h}createWorkspaceStorage(m){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=m?.id;let h;if(m){const u=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),m));h=this.workspaceStorageDisposables.add(new _.Storage(u)),this.workspaceStorageDisposables.add(h.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return h}async doInitialize(){await L.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:O.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:O.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,A.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:O.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(m){if(!this.canSwitchProfile(this.profileStorageProfile,m))return;const h=this.profileStorage,u=h.items;h!==this.applicationStorage&&await h.close(),this.profileStorage=this.createProfileStorage(m),await this.profileStorage.init(),this.switchData(u,this.profileStorage,0)}async switchToWorkspace(m,h){const u=this.workspaceStorage,y=u?.items??new Map;await u?.close(),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1)}hasScope(m){return(0,f.isUserDataProfile)(m)?this.profileStorageProfile.id===m.id:this.workspaceStorageId===m.id}}e.RemoteStorageService=D}),define(le[259],ue([0,1,3,2,18,91]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class _{constructor(f,D){this.service=f,this.getUriTransformer=D}listen(f,D){const w=this.getUriTransformer(f);switch(D){case"onDidChangeProfiles":return L.Event.map(this.service.onDidChangeProfiles,m=>({all:m.all.map(h=>(0,A.transformOutgoingURIs)({...h},w)),added:m.added.map(h=>(0,A.transformOutgoingURIs)({...h},w)),removed:m.removed.map(h=>(0,A.transformOutgoingURIs)({...h},w)),updated:m.updated.map(h=>(0,A.transformOutgoingURIs)({...h},w))}))}throw new Error(`Invalid listen ${D}`)}async call(f,D,w){const m=this.getUriTransformer(f);switch(D){case"createProfile":{const h=await this.service.createProfile(w[0],w[1],w[2]);return(0,A.transformOutgoingURIs)({...h},m)}case"updateProfile":{let h=(0,O.reviveProfile)((0,A.transformIncomingURIs)(w[0],m),this.service.profilesHome.scheme);return h=await this.service.updateProfile(h,w[1]),(0,A.transformOutgoingURIs)({...h},m)}case"removeProfile":{const h=(0,O.reviveProfile)((0,A.transformIncomingURIs)(w[0],m),this.service.profilesHome.scheme);return this.service.removeProfile(h)}}throw new Error(`Invalid call ${D}`)}}e.RemoteUserDataProfilesServiceChannel=_;class R extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(f,D,w){super(),this.profilesHome=D,this.channel=w,this._profiles=[],this._onDidChangeProfiles=this._register(new L.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=f.map(m=>(0,O.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const h=m.added.map(v=>(0,O.reviveProfile)(v,this.profilesHome.scheme)),u=m.removed.map(v=>(0,O.reviveProfile)(v,this.profilesHome.scheme)),y=m.updated.map(v=>(0,O.reviveProfile)(v,this.profilesHome.scheme));this._profiles=m.all.map(v=>(0,O.reviveProfile)(v,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:u,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(f){this.enabled=f}isEnabled(){return this.enabled}async createNamedProfile(f,D,w){const m=await this.channel.call("createNamedProfile",[f,D,w]);return(0,O.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(f,D,w,m){const h=await this.channel.call("createProfile",[f,D,w,m]);return(0,O.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(f){const D=await this.channel.call("createTransientProfile",[f]);return(0,O.reviveProfile)(D,this.profilesHome.scheme)}async setProfileForWorkspace(f,D){await this.channel.call("setProfileForWorkspace",[f,D])}removeProfile(f){return this.channel.call("removeProfile",[f])}async updateProfile(f,D){const w=await this.channel.call("updateProfile",[f,D]);return(0,O.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(le[60],ue([0,1,2,69,4,19,3,77,18]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,O.createDecorator)("IUserDataProfileStorageService");let f=class extends L.Disposable{constructor(h){super(),this.storageService=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async u=>this.getItems(u))}async updateStorageData(h,u,y){return this.withProfileScopedStorageService(h,async v=>this.writeItems(v,u,y))}async withProfileScopedStorageService(h,u){if(this.storageService.hasScope(h))return u(this.storageService);const y=await this.createStorageDatabase(h),v=new w(y);try{await v.initialize();const d=await u(v);return await v.flush(),d}finally{v.dispose(),await this.closeAndDispose(y)}}getItems(h){const u=new Map,y=v=>{for(const d of h.keys(0,v))u.set(d,{value:h.get(d,0),target:v})};return y(0),y(1),u}writeItems(h,u,y){h.storeAll(Array.from(u.entries()).map(([v,d])=>({key:v,value:d,scope:0,target:y})),!0)}async closeAndDispose(h){try{await h.close()}finally{(0,L.isDisposable)(h)&&h.dispose()}}};e.AbstractUserDataProfileStorageService=f,e.AbstractUserDataProfileStorageService=f=we([K(0,A.IStorageService)],f);class D extends f{constructor(h,u,y,v){super(y),this.remoteService=h;const d=h.getChannel("profileStorageListener"),g=this._register(new L.MutableDisposable);this._onDidChange=this._register(new _.Emitter({onWillAddFirstListener:()=>{g.value=d.listen("onDidChange")(l=>{v.trace("profile storage changes",l),this._onDidChange.fire({targetChanges:l.targetChanges.map(c=>(0,P.reviveProfile)(c,u.profilesHome.scheme)),valueChanges:l.valueChanges.map(c=>({...c,profile:(0,P.reviveProfile)(c.profile,u.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(h){const u=this.remoteService.getChannel("storage");return(0,A.isProfileUsingDefaultStorage)(h)?new R.ApplicationStorageDatabaseClient(u):new R.ProfileStorageDatabaseClient(u,h)}}e.RemoteUserDataProfileStorageService=D;class w extends A.AbstractStorageService{constructor(h){super({flushInterval:100}),this.profileStorage=this._register(new U.Storage(h))}doInitialize(){return this.profileStorage.init()}getStorage(h){return h===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(le[260],ue([0,1,19,9,18,56,60]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends _.RemoteUserDataProfileStorageService{constructor(f,D,w,m){super(f,D,w,m)}};e.NativeUserDataProfileStorageService=R,e.NativeUserDataProfileStorageService=R=we([K(0,A.IMainProcessService),K(1,O.IUserDataProfilesService),K(2,L.IStorageService),K(3,U.ILogService)],R)}),define(le[39],ue([0,1,17,6,15,26,3,34,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0,e.isRemoteUserData=i,e.isSyncData=o,e.getSyncResourceLogLabel=n;function i(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||o(E.syncData)))}function o(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}function n(E,C){return`${(0,f.uppercaseFirstLetter)(E)}${C.isDefault?"":` (${C.name})`}`}let s=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(C,b,I,p,k,N,F,x,Z,B,X,j){super(),this.syncResource=C,this.collection=b,this.fileService=I,this.environmentService=p,this.storageService=k,this.userDataSyncStoreService=N,this.userDataSyncLocalStoreService=F,this.userDataSyncEnablementService=x,this.telemetryService=Z,this.logService=B,this.configurationService=X,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new U.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(C.syncResource,C.profile),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,...(0,c.getPathSegments)(C.profile.isDefault?void 0:C.profile.id,C.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(C.profile.isDefault?void 0:C.profile.id,C.syncResource,p,this.extUri),this.currentMachineIdPromise=(0,v.getServiceMachineId)(p,I,k)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const C=await this.syncPreviewPromise;this.syncPreviewPromise=null;const b=await this.performSync(C.remoteUserData,C.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(b)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const C=await this.getLastSyncUserData();(C?await this.hasRemoteChanged(C):!0)&&this._onDidChangeLocal.fire()}}setStatus(C){this._status!==C&&(this._status=C,this._onDidChangStatus.fire(C))}async sync(C,b={}){await this._sync(C,!0,this.getUserDataSyncConfiguration(),b)}async preview(C,b,I={}){return this._sync(C,!1,b,I)}async apply(C,b={}){try{this.syncHeaders={...b};const I=await this.doApply(C);return this.setStatus(I),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(C,b,I,p){try{if(this.syncHeaders={...p},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let k="idle";try{const N=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(C,N);return k=await this.performSync(F,N,b,I),k==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):k==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(k)}}finally{this.syncHeaders={}}}async replace(C){const b=this.parseSyncData(C);if(!b)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),p=await this.getLatestRemoteUserData(null,I),k=await this.isRemoteDataFromCurrentMachine(p),N=await this.generateSyncPreview({ref:p.ref,syncData:b},I,k,this.getUserDataSyncConfiguration(),A.CancellationToken.None),F=[];for(const x of N){const Z=await this.getAcceptResult(x,x.remoteResource,void 0,A.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(x,x.previewResource,x.remoteContent,A.CancellationToken.None);F.push([x,{...Z,remoteChange:B!==0?B:2}])}await this.applyResult(p,I,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(C){const b=await this.currentMachineIdPromise;return!!C.syncData?.machineId&&C.syncData.machineId===b}async getLatestRemoteUserData(C,b){if(b){const I=C?C[this.resource]:void 0;if(b.ref===I||I===void 0&&b.syncData===null)return b}return this.getRemoteUserData(b)}async performSync(C,b,I,p){if(C.syncData&&C.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,w.localize)(0,null,this.resource,this.version,C.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(C,b,I,p)}catch(k){if(k instanceof c.UserDataSyncError)switch(k.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(C,b,I,p);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),C=await this.getRemoteUserData(null),b=await this.getLastSyncUserData(),this.performSync(C,b,I,p)}throw k}}async doSync(C,b,I,p){try{const k=await this.isRemoteDataFromCurrentMachine(C),N=!k&&b===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,F=I&&!N;this.syncPreviewPromise||(this.syncPreviewPromise=(0,U.createCancelablePromise)(Z=>this.doGenerateSyncResourcePreview(C,b,k,F,p,Z)));let x=await this.syncPreviewPromise;if(I&&N){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of x.resourcePreviews)x=await this.accept(Z.remoteResource)||x}return this.updateConflicts(x.resourcePreviews),x.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":I?await this.doApply(!1):"syncing"}catch(k){throw this.syncPreviewPromise=null,k}}async merge(C){return await this.updateSyncResourcePreview(C,async b=>{const I=await this.getMergeResult(b,A.CancellationToken.None);await this.fileService.writeFile(b.previewResource,O.VSBuffer.fromString(I?.content||""));const p=I&&!I.hasConflicts?await this.getAcceptResult(b,b.previewResource,void 0,A.CancellationToken.None):void 0;return b.acceptResult=p,b.mergeState=I.hasConflicts?"conflict":p?"accepted":"preview",b.localChange=p?p.localChange:I.localChange,b.remoteChange=p?p.remoteChange:I.remoteChange,b}),this.syncPreviewPromise}async accept(C,b){return await this.updateSyncResourcePreview(C,async I=>{const p=await this.getAcceptResult(I,C,b,A.CancellationToken.None);return I.acceptResult=p,I.mergeState="accepted",I.localChange=p.localChange,I.remoteChange=p.remoteChange,I}),this.syncPreviewPromise}async discard(C){return await this.updateSyncResourcePreview(C,async b=>{const I=await this.getMergeResult(b,A.CancellationToken.None);return await this.fileService.writeFile(b.previewResource,O.VSBuffer.fromString(I.content||"")),b.acceptResult=void 0,b.mergeState="preview",b.localChange=I.localChange,b.remoteChange=I.remoteChange,b}),this.syncPreviewPromise}async updateSyncResourcePreview(C,b){if(!this.syncPreviewPromise)return;let I=await this.syncPreviewPromise;const p=I.resourcePreviews.findIndex(({localResource:k,remoteResource:N,previewResource:F})=>this.extUri.isEqual(k,C)||this.extUri.isEqual(N,C)||this.extUri.isEqual(F,C));p!==-1&&(this.syncPreviewPromise=(0,U.createCancelablePromise)(async k=>{const N=[...I.resourcePreviews];return N[p]=await b(N[p]),{...I,resourcePreviews:N}}),I=await this.syncPreviewPromise,this.updateConflicts(I.resourcePreviews),I.resourcePreviews.some(({mergeState:k})=>k==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(C){if(!this.syncPreviewPromise)return"idle";const b=await this.syncPreviewPromise;return b.resourcePreviews.some(({mergeState:I})=>I==="conflict")?"hasConflicts":b.resourcePreviews.some(({mergeState:I})=>I!=="accepted")?"syncing":(await this.applyResult(b.remoteUserData,b.lastSyncUserData,b.resourcePreviews.map(I=>[I,I.acceptResult]),C),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(C){const b=C.filter(({mergeState:I})=>I==="conflict");(0,L.equals)(this._conflicts,b,(I,p)=>this.extUri.isEqual(I.previewResource,p.previewResource))||(this._conflicts=b,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const C=await this.getLastSyncUserData();return!!C&&C.syncData!==null}async resolvePreviewContent(C){const b=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(b)for(const I of b.resourcePreviews){if(this.extUri.isEqual(I.acceptedResource,C))return I.acceptResult?I.acceptResult.content:null;if(this.extUri.isEqual(I.remoteResource,C))return I.remoteContent;if(this.extUri.isEqual(I.localResource,C))return I.localContent;if(this.extUri.isEqual(I.baseResource,C))return I.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(C){(0,u.toFileOperationResult)(C)!==1&&this.logService.error(C)}}async doGenerateSyncResourcePreview(C,b,I,p,k,N){const F=await this.generateSyncPreview(C,b,I,k,N),x=[];for(const Z of F){const B=Z.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)x.push({...Z,acceptedResource:B,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=p?await this.getMergeResult(Z,N):void 0;if(N.isCancellationRequested)break;await this.fileService.writeFile(Z.previewResource,O.VSBuffer.fromString(X?.content||""));const j=X&&!X.hasConflicts?await this.getAcceptResult(Z,Z.previewResource,void 0,N):void 0;x.push({...Z,acceptResult:j,mergeState:X?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:X?X.localChange:Z.localChange,remoteChange:j?j.remoteChange:X?X.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:C,lastSyncUserData:b,resourcePreviews:x,isLastSyncFromCurrentMachine:I}}async getLastSyncUserData(){let C=this.getStoredLastSyncUserDataStateContent();if(C||(C=await this.migrateLastSyncUserData()),!C)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const b=JSON.parse(C),I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!b.version&&!!I&&b.version!==I,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${b.version} is not compatible with current sync state version ${I}.`),await this.resetLocal(),null;let p,k=1;for(;p===void 0&&k++<6;)try{const N=await this.readLastSyncStoredRemoteUserData();N&&(N.ref===b.ref?p=N.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(N){if(N instanceof u.FileOperationError&&N.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(N instanceof c.UserDataSyncError)throw N;this.logService.error(N,k)}}if(p===void 0)try{const N=await this.userDataSyncStoreService.resolveResourceContent(this.resource,b.ref,this.collection,this.syncHeaders);p=N===null?null:this.parseSyncData(N),await this.writeLastSyncStoredRemoteUserData({ref:b.ref,syncData:p})}catch(N){if(N instanceof c.UserDataSyncError&&N.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw N}return p===void 0?null:{...b,syncData:p}}async updateLastSyncUserData(C,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const I=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),p={ref:C.ref,version:I,...b};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(p),-1,1),await this.writeLastSyncStoredRemoteUserData(C)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const C=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const b=C?JSON.parse(C):void 0;if(i(b))return b}catch(b){this.logService.error(b)}}async writeLastSyncStoredRemoteUserData(C){await this.fileService.writeFile(this.lastSyncResource,O.VSBuffer.fromString(JSON.stringify(C)))}async migrateLastSyncUserData(){try{const C=await this.fileService.readFile(this.lastSyncResource),b=JSON.parse(C.value.toString());await this.fileService.del(this.lastSyncResource),b.ref&&b.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...b,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:b.ref,syncData:b.content===null?null:JSON.parse(b.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,b)}catch(C){C instanceof u.FileOperationError&&C.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(C)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(C){const{ref:b,content:I}=await this.getUserData(C);let p=null;return I!==null&&(p=this.parseSyncData(I)),{ref:b,syncData:p}}parseSyncData(C){try{const b=JSON.parse(C);if(o(b))return b}catch(b){this.logService.error(b)}throw new c.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(C){const b=C?{ref:C.ref,content:C.syncData?JSON.stringify(C.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,b,this.collection,this.syncHeaders)}async updateRemoteUserData(C,b){const I=await this.currentMachineIdPromise,p={version:this.version,machineId:I,content:C};try{return b=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(p),b,this.collection,this.syncHeaders),{ref:b,syncData:p}}catch(k){throw k instanceof c.UserDataSyncError&&k.code==="TooLarge"&&(k=new c.UserDataSyncError(k.message,k.code,this.resource)),k}}async backupLocal(C){const b={version:this.version,content:C};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(b),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=s,e.AbstractSynchroniser=s=we([K(2,u.IFileService),K(3,h.IEnvironmentService),K(4,d.IStorageService),K(5,c.IUserDataSyncStoreService),K(6,c.IUserDataSyncLocalStoreService),K(7,c.IUserDataSyncEnablementService),K(8,g.ITelemetryService),K(9,c.IUserDataSyncLogService),K(10,m.IConfigurationService),K(11,l.IUriIdentityService)],s);let t=class extends s{constructor(C,b,I,p,k,N,F,x,Z,B,X,j,G){super(b,I,p,k,N,F,x,Z,B,X,j,G),this.file=C,this._register(this.fileService.watch(this.extUri.dirname(C))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(C,b,I){try{b?await this.fileService.writeFile(this.file,O.VSBuffer.fromString(C),I?void 0:b):await this.fileService.createFile(this.file,O.VSBuffer.fromString(C),{overwrite:I})}catch(p){throw p instanceof u.FileOperationError&&p.fileOperationResult===1||p instanceof u.FileOperationError&&p.fileOperationResult===3?new c.UserDataSyncError(p.message,"LocalPreconditionFailed"):p}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(C){if(!(C instanceof u.FileOperationError&&C.fileOperationResult===1))throw C}}onFileChanges(C){C.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=t,e.AbstractFileSynchroniser=t=we([K(3,u.IFileService),K(4,h.IEnvironmentService),K(5,d.IStorageService),K(6,c.IUserDataSyncStoreService),K(7,c.IUserDataSyncLocalStoreService),K(8,c.IUserDataSyncEnablementService),K(9,g.ITelemetryService),K(10,c.IUserDataSyncLogService),K(11,m.IConfigurationService),K(12,l.IUriIdentityService)],t);let r=class extends t{constructor(C,b,I,p,k,N,F,x,Z,B,X,j,G,z){super(C,b,I,p,k,N,F,x,Z,B,X,G,z),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(C,b){const I=[],p=(0,R.parse)(C,I,{allowEmptyContent:!0,allowTrailingComma:!0});return I.length>0||!(0,D.isUndefined)(p)&&b!==Array.isArray(p)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=r,e.AbstractJsonFileSynchroniser=r=we([K(3,u.IFileService),K(4,h.IEnvironmentService),K(5,d.IStorageService),K(6,c.IUserDataSyncStoreService),K(7,c.IUserDataSyncLocalStoreService),K(8,c.IUserDataSyncEnablementService),K(9,g.ITelemetryService),K(10,c.IUserDataSyncLogService),K(11,c.IUserDataSyncUtilService),K(12,m.IConfigurationService),K(13,l.IUriIdentityService)],r);let a=class{constructor(C,b,I,p,k,N,F){this.resource=C,this.userDataProfilesService=b,this.environmentService=I,this.logService=p,this.fileService=k,this.storageService=N,this.extUri=F.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(void 0,this.resource,I,this.extUri)}async initialize({ref:C,content:b}){if(!b){this.logService.info("Remote content does not exist.",this.resource);return}const I=this.parseSyncData(b);if(I)try{await this.doInitialize({ref:C,syncData:I})}catch(p){this.logService.error(p)}}parseSyncData(C){try{const b=JSON.parse(C);if(o(b))return b}catch(b){this.logService.error(b)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(C,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const I={ref:C.ref,version:void 0,...b};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(I),-1,1),await this.fileService.writeFile(this.lastSyncResource,O.VSBuffer.fromString(JSON.stringify(C)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=we([K(1,S.IUserDataProfilesService),K(2,h.IEnvironmentService),K(3,y.ILogService),K(4,u.IFileService),K(5,d.IStorageService),K(6,l.IUriIdentityService)],a)}),define(le[115],ue([0,1,6,26,7,3,43,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0,e.parseExtensions=C,e.stringify=b;async function E(N,F){const x=JSON.parse(N.content);if(N.version===1||N.version===2){const Z=(await F.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of x)N.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),N.version===2&&Z.every(X=>!(0,h.areSameExtensions)(X.identifier,B.identifier))&&(B.installed=!0)}return x}function C(N){return JSON.parse(N.content)}function b(N,F){return N.sort((x,Z)=>!x.identifier.uuid&&Z.identifier.uuid?-1:x.identifier.uuid&&!Z.identifier.uuid?1:(0,P.compare)(x.identifier.id,Z.identifier.id)),F?(0,_.toFormattedString)(N,{}):JSON.stringify(N)}let I=class extends n.AbstractSynchroniser{constructor(F,x,Z,B,X,j,G,z,q,ie,ae,te,ce,V,$,T,M){super({syncResource:"extensions",profile:F},x,B,Z,X,j,G,te,ce,ie,ae,$),this.extensionManagementService=z,this.ignoredExtensionsManagementService=q,this.instantiationService=M,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(p),this._register(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:J})=>!!J)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),A.Event.filter(T.onDidChange,W=>W.valueChanges.some(({profile:J,changes:H})=>this.syncResource.profile.id===J.id&&H.some(ee=>ee.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),V.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,x){const Z=F.syncData?await E(F.syncData,this.extensionManagementService):null,B=x?.skippedExtensions??[],X=x?.builtinExtensions??null,j=x?.syncData?await E(x.syncData,this.extensionManagementService):null,{localExtensions:G,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);Z?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:ie}=(0,s.merge)(G,Z,j,B,z,X),ae={local:q,remote:ie,content:this.getPreviewContent(G,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:ie!==null?2:0},te=this.stringify(G,!1);return[{skippedExtensions:B,builtinExtensions:X,baseResource:this.baseResource,baseContent:j?this.stringify(j,!1):te,localResource:this.localResource,localContent:te,localExtensions:G,remoteResource:this.remoteResource,remoteExtensions:Z,remoteContent:Z?this.stringify(Z,!1):null,previewResource:this.previewResource,previewResult:ae,localChange:ae.localChange,remoteChange:ae.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const x=F.syncData?await E(F.syncData,this.extensionManagementService):null,{localExtensions:Z,ignoredExtensions:B}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:X}=(0,s.merge)(Z,x,x,F.skippedExtensions||[],B,F.builtinExtensions||[]);return X!==null}getPreviewContent(F,x,Z,B){const X=[...x,...Z],j=new Set,G=z=>{j.add(z.id.toLowerCase()),z.uuid&&j.add(z.uuid)};X.forEach(({identifier:z})=>G(z)),B.forEach(G);for(const z of F)j.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&j.has(z.identifier.uuid)||X.push(z);return this.stringify(X,!1)}async getMergeResult(F,x){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,x,Z,B){if(this.extUri.isEqual(x,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(x,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(x,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${x.toString()}`)}async acceptLocal(F){const x=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.ignoredExtensionsManagementService.getIgnoredExtensions(x),B=(0,s.merge)(F.localExtensions,null,null,F.skippedExtensions,Z,F.builtinExtensions),{local:X,remote:j}=B;return{content:F.localContent,local:X,remote:j,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(F){const x=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.ignoredExtensionsManagementService.getIgnoredExtensions(x),B=F.remoteContent?JSON.parse(F.remoteContent):null;if(B!==null){const X=(0,s.merge)(F.localExtensions,B,F.localExtensions,[],Z,F.builtinExtensions),{local:j,remote:G}=X;return{content:F.remoteContent,local:j,remote:G,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:G!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(F,x,Z,B){let{skippedExtensions:X,builtinExtensions:j,localExtensions:G}=Z[0][0];const{local:z,remote:q,localChange:ie,remoteChange:ae}=Z[0][1];if(ie===0&&ae===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),ie!==0&&(await this.backupLocal(JSON.stringify(G)),X=await this.localExtensionsProvider.updateLocalExtensions(z.added,z.removed,z.updated,X,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const te=JSON.stringify(q.all);F=await this.updateRemoteUserData(te,B?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(ce=>ce.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(ce=>ce.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(ce=>ce.identifier.id))}.`:""}`)}x?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),j=this.computeBuiltinExtensions(G,j),await this.updateLastSyncUserData(F,{skippedExtensions:X,builtinExtensions:j}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${X.length?` Skipped: ${JSON.stringify(X.map(te=>te.identifier.id))}.`:""}`))}computeBuiltinExtensions(F,x){const Z=new Set,B=[];for(const X of F)Z.add(X.identifier.id.toLowerCase()),X.installed||B.push(X.identifier);if(x)for(const X of x)Z.has(X.id.toLowerCase())||B.push(X);return B}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const x=await this.resolvePreviewContent(F);return x&&this.stringify(JSON.parse(x),!0)}return null}stringify(F,x){return b(F,x)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(F.some(x=>x.installed||x.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=I,e.ExtensionsSynchroniser=I=we([K(2,D.IEnvironmentService),K(3,v.IFileService),K(4,c.IStorageService),K(5,r.IUserDataSyncStoreService),K(6,r.IUserDataSyncLocalStoreService),K(7,m.IExtensionManagementService),K(8,t.IIgnoredExtensionsManagementService),K(9,r.IUserDataSyncLogService),K(10,f.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,S.ITelemetryService),K(13,u.IExtensionStorageService),K(14,i.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,d.IInstantiationService)],I);let p=class{constructor(F,x,Z,B,X,j){this.extensionManagementService=F,this.userDataProfileStorageService=x,this.extensionGalleryService=Z,this.ignoredExtensionsManagementService=B,this.instantiationService=X,this.logService=j}async getLocalExtensions(F){const x=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),Z=this.ignoredExtensionsManagementService.getIgnoredExtensions(x);return{localExtensions:await this.withProfileScopedServices(F,async(X,j)=>{const G=X.getDisabledExtensions();return x.map(z=>{const{identifier:q,isBuiltin:ie,manifest:ae,preRelease:te,pinned:ce,isApplicationScoped:V}=z,$={identifier:q,preRelease:te,version:ae.version,pinned:!!ce};V&&!(0,y.isApplicationScopedExtension)(ae)&&($.isApplicationScoped=V),G.some(T=>(0,h.areSameExtensions)(T,q))&&($.disabled=!0),ie||($.installed=!0);try{const T=j.getKeysForSync({id:q.id,version:ae.version});if(T){const M=j.getExtensionState(z,!0)||{};$.state=Object.keys(M).reduce((W,J)=>(T.includes(J)&&(W[J]=M[J]),W),{})}}catch(T){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,O.getErrorMessage)(T))}return $})}),ignoredExtensions:Z}}async updateLocalExtensions(F,x,Z,B,X){const j=(0,n.getSyncResourceLogLabel)("extensions",X),G=[],z=new Map,q=[],ie=[],ae=await this.extensionManagementService.getInstalled(void 0,X.extensionsResource);if((F.length||Z.length)&&await this.withProfileScopedServices(X,async(V,$)=>{await L.Promises.settled([...F,...Z].map(async T=>{const M=ae.find(H=>(0,h.areSameExtensions)(H.identifier,T.identifier));if(M&&M.isBuiltin){T.state&&M.manifest.version===T.version&&this.updateExtensionState(T.state,M,M.manifest.version,$),V.getDisabledExtensions().some(ee=>(0,h.areSameExtensions)(ee,T.identifier))!==!!T.disabled&&(T.disabled?(this.logService.trace(`${j}: Disabling extension...`,T.identifier.id),await V.disableExtension(T.identifier),this.logService.info(`${j}: Disabled extension`,T.identifier.id)):(this.logService.trace(`${j}: Enabling extension...`,T.identifier.id),await V.enableExtension(T.identifier),this.logService.info(`${j}: Enabled extension`,T.identifier.id))),q.push(T.identifier);return}const W=T.pinned?T.version:void 0,J=(await this.extensionGalleryService.getExtensions([{...T.identifier,version:W,preRelease:W?void 0:T.preRelease}],U.CancellationToken.None))[0];if(T.state&&(M?M.manifest.version===T.version:J)&&this.updateExtensionState(T.state,M||J,M?.manifest.version,$),J)try{V.getDisabledExtensions().some(ee=>(0,h.areSameExtensions)(ee,T.identifier))!==!!T.disabled&&(T.disabled?(this.logService.trace(`${j}: Disabling extension...`,T.identifier.id,J.version),await V.disableExtension(J.identifier),this.logService.info(`${j}: Disabled extension`,T.identifier.id,J.version)):(this.logService.trace(`${j}: Enabling extension...`,T.identifier.id,J.version),await V.enableExtension(J.identifier),this.logService.info(`${j}: Enabled extension`,T.identifier.id,J.version))),(!M||M.preRelease!==T.preRelease||M.pinned!==T.pinned||W&&M.manifest.version!==W)&&(await this.extensionManagementService.canInstall(J)?(G.push({extension:J,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:T.pinned&&!!T.version,installPreReleaseVersion:T.preRelease,profileLocation:X.extensionsResource,isApplicationScoped:T.isApplicationScoped,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),z.set(J.identifier.id.toLowerCase(),T)):(this.logService.info(`${j}: Skipped synchronizing extension because it cannot be installed.`,J.displayName||J.identifier.id),ie.push(T)))}catch(H){ie.push(T),this.logService.error(H),this.logService.info(`${j}: Skipped synchronizing extension`,J.displayName||J.identifier.id)}else ie.push(T),this.logService.info(`${j}: Skipped synchronizing extension because the extension is not found.`,T.identifier.id)}))}),x.length){const V=ae.filter(({identifier:$,isBuiltin:T})=>!T&&x.some(M=>(0,h.areSameExtensions)($,M)));await L.Promises.settled(V.map(async $=>{this.logService.trace(`${j}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:X.extensionsResource}),this.logService.info(`${j}: Uninstalled local extension.`,$.identifier.id),q.push($.identifier)}))}const te=await this.extensionManagementService.installGalleryExtensions(G);for(const{identifier:V,local:$,error:T,source:M}of te){const W=M;if($)this.logService.info(`${j}: Installed extension.`,V.id,W.version),q.push(V);else{const J=z.get(V.id.toLowerCase());J&&(ie.push(J),this.logService.info(`${j}: Skipped synchronizing extension`,W.displayName||W.identifier.id)),T instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(T.code)?this.logService.info(`${j}: Skipped synchronizing extension because the compatible extension is not found.`,W.displayName||W.identifier.id):T&&this.logService.error(T)}}const ce=[];for(const V of B)q.some($=>(0,h.areSameExtensions)($,V.identifier))||ce.push(V);for(const V of ie)ce.some($=>(0,h.areSameExtensions)($.identifier,V.identifier))||ce.push(V);return ce}updateExtensionState(F,x,Z,B){const X=B.getExtensionState(x,!0)||{},j=Z?B.getKeysForSync({id:x.identifier.id,version:Z}):void 0;j?j.forEach(G=>{X[G]=F[G]}):Object.keys(F).forEach(G=>X[G]=F[G]),B.setExtensionState(x,X,!0)}async withProfileScopedServices(F,x){return this.userDataProfileStorageService.withProfileScopedStorageService(F,async Z=>{const B=new R.DisposableStore,X=this.instantiationService.createChild(new g.ServiceCollection([c.IStorageService,Z])),j=B.add(X.createInstance(w.GlobalExtensionEnablementService)),G=B.add(X.createInstance(u.ExtensionStorageService));try{return await x(j,G)}finally{B.dispose()}})}};e.LocalExtensionsProvider=p,e.LocalExtensionsProvider=p=we([K(0,m.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,m.IExtensionGalleryService),K(3,t.IIgnoredExtensionsManagementService),K(4,d.IInstantiationService),K(5,r.IUserDataSyncLogService)],p);let k=class extends n.AbstractInitializer{constructor(F,x,Z,B,X,j,G,z){super("extensions",B,X,j,Z,G,z),this.extensionManagementService=F,this.ignoredExtensionsManagementService=x}async parseExtensions(F){return F.syncData?await E(F.syncData,this.extensionManagementService):null}generatePreview(F,x){const Z=[],B=[],X=[];for(const j of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(j.identifier.id))continue;const G=x.find(z=>(0,h.areSameExtensions)(z.identifier,j.identifier));G?(Z.push(G),j.disabled&&X.push(j.identifier)):j.installed&&(B.push({...j.identifier,preRelease:!!j.preRelease}),j.disabled&&X.push(j.identifier))}return{installedExtensions:Z,newExtensions:B,disabledExtensions:X,remoteExtensions:F}}};e.AbstractExtensionsInitializer=k,e.AbstractExtensionsInitializer=k=we([K(0,m.IExtensionManagementService),K(1,t.IIgnoredExtensionsManagementService),K(2,v.IFileService),K(3,o.IUserDataProfilesService),K(4,D.IEnvironmentService),K(5,l.ILogService),K(6,c.IStorageService),K(7,i.IUriIdentityService)],k)}),define(le[116],ue([0,1,15,7,3,34,43,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0,e.stringify=t;const n="globalState.argv.",s=["locale"];function t(I,p){const k=I.storage?Object.keys(I.storage).sort():[],N={};return k.forEach(F=>N[F]=I.storage[F]),I.storage=N,p?(0,_.toFormattedString)(I,{}):JSON.stringify(I)}const r=1;let a=class extends d.AbstractSynchroniser{constructor(p,k,N,F,x,Z,B,X,j,G,z,q,ie,ae){super({syncResource:"globalState",profile:p},k,F,X,q,x,Z,j,G,B,z,ie),this.userDataProfileStorageService=N,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ae.createInstance(E),this._register(F.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(O.Event.any(O.Event.filter(F.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),O.Event.filter(N.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:V})=>this.syncResource.profile.id===ce.id&&V.some($=>$.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(p,k,N){const F=p.syncData?JSON.parse(p.syncData.content):null;k=k===null&&N?p:k;const x=k&&k.syncData?JSON.parse(k.syncData.content):null,Z=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=await this.getStorageKeys(x),{local:X,remote:j}=(0,l.merge)(Z.storage,F?F.storage:null,x?x.storage:null,B,this.logService),G={content:null,local:X,remote:j,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:j.all!==null?2:0},z=t(Z,!1);return[{baseResource:this.baseResource,baseContent:x?t(x,!1):z,localResource:this.localResource,localContent:z,localUserData:Z,remoteResource:this.remoteResource,remoteContent:F?t(F,!1):null,previewResource:this.previewResource,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async hasRemoteChanged(p){const k=p.syncData?JSON.parse(p.syncData.content):null;if(k===null)return!0;const N=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),F=await this.getStorageKeys(k),{remote:x}=(0,l.merge)(N.storage,k.storage,k.storage,F,this.logService);return x.all!==null}async getMergeResult(p,k){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,k,N,F){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(k,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(p.localUserData.storage),removed:[],updated:[],all:p.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(p){if(p.remoteContent!==null){const k=JSON.parse(p.remoteContent),{local:N,remote:F}=(0,l.merge)(p.localUserData.storage,k.storage,null,p.storageKeys,this.logService);return{content:p.remoteContent,local:N,remote:F,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(p,k,N,F){const{localUserData:x}=N[0][0],{local:Z,remote:B,localChange:X,remoteChange:j}=N[0][1];if(X===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),X!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(x)),await this.localGlobalStateProvider.writeLocalGlobalState(Z,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const G=JSON.stringify({storage:B.all});p=await this.updateRemoteUserData(G,F?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${B.added.length?` Added: ${B.added}.`:""}${B.updated.length?` Updated: ${B.updated}.`:""}${B.removed.length?` Removed: ${B.removed}.`:""}`)}k?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p)){const k=await this.resolvePreviewContent(p);return k&&t(JSON.parse(k),!0)}return null}async hasLocalData(){try{const{storage:p}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(p).length>1||p[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(p){const k=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),N=[],F=[];for(const[B,X]of k)X.target===0?N.push(B):X.target===1&&F.push(B);const x=[...N,...F],Z=p?.storage?Object.keys(p.storage).filter(B=>!B.startsWith(n)&&!x.includes(B)&&k.get(B)!==void 0):[];if(!R.isWeb){const B=[...c.ALL_SYNC_RESOURCES.map(X=>(0,c.getEnablementKey)(X)),c.SYNC_SERVICE_URL_TYPE];Z.push(...B),F.push(...B)}return{user:N,machine:F,unregistered:Z}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=we([K(2,i.IUserDataProfileStorageService),K(3,w.IFileService),K(4,c.IUserDataSyncStoreService),K(5,c.IUserDataSyncLocalStoreService),K(6,c.IUserDataSyncLogService),K(7,D.IEnvironmentService),K(8,c.IUserDataSyncEnablementService),K(9,y.ITelemetryService),K(10,f.IConfigurationService),K(11,u.IStorageService),K(12,v.IUriIdentityService),K(13,o.IInstantiationService)],a);let E=class{constructor(p,k,N,F){this.fileService=p,this.environmentService=k,this.userDataProfileStorageService=N,this.logService=F}async getLocalGlobalState(p){const k={};if(p.isDefault){const F=await this.getLocalArgvContent(),x=(0,A.parse)(F);for(const Z of s)x[Z]!==void 0&&(k[`${n}${Z}`]={version:1,value:x[Z]})}const N=await this.userDataProfileStorageService.readStorageData(p);for(const[F,x]of N)x.value&&x.target===0&&(k[F]={version:1,value:x.value});return{storage:k}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const p=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),p.value.toString()}catch(p){this.logService.debug((0,U.getErrorMessage)(p))}return"{}"}async writeLocalGlobalState({added:p,removed:k,updated:N},F){const x=(0,d.getSyncResourceLogLabel)("globalState",F),Z={},B=new Map,X=await this.userDataProfileStorageService.readStorageData(F),j=(G,z)=>{for(const q of G){if(q.startsWith(n)){Z[q.substring(n.length)]=z?z[q].value:void 0;continue}if(z){const ie=z[q];ie.value!==X.get(q)?.value&&B.set(q,ie.value)}else X.get(q)!==void 0&&B.set(q,void 0)}};if(j(Object.keys(p),p),j(Object.keys(N),N),j(k),Object.keys(Z).length){this.logService.trace(`${x}: Updating locale...`);const G=await this.getLocalArgvContent();let z=G;for(const q of Object.keys(Z))z=(0,g.edit)(z,[q],Z[q],{});G!==z&&(this.logService.trace(`${x}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(z)),this.logService.info(`${x}: Updated locale.`)),this.logService.info(`${x}: Updated locale`)}B.size&&(this.logService.trace(`${x}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(F,B,0),this.logService.info(`${x}: Updated global state`,[...B.keys()]))}};e.LocalGlobalStateProvider=E,e.LocalGlobalStateProvider=E=we([K(0,w.IFileService),K(1,D.IEnvironmentService),K(2,i.IUserDataProfileStorageService),K(3,c.IUserDataSyncLogService)],E);let C=class extends d.AbstractInitializer{constructor(p,k,N,F,x,Z){super("globalState",N,F,x,k,p,Z)}async doInitialize(p){const k=p.syncData?JSON.parse(p.syncData.content):null;if(!k){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},F={};for(const x of Object.keys(k.storage))x.startsWith(n)?N[x.substring(n.length)]=k.storage[x].value:this.storageService.get(x,0)===void 0&&(F[x]=k.storage[x].value);if(Object.keys(N).length){let x="{}";try{x=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const Z of Object.keys(N))x=(0,g.edit)(x,[Z],N[Z],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(x))}if(Object.keys(F).length){const x=[];for(const Z of Object.keys(F))x.push({key:Z,value:F[Z],scope:0,target:0});this.storageService.storeAll(x,!0)}}};e.GlobalStateInitializer=C,e.GlobalStateInitializer=C=we([K(0,u.IStorageService),K(1,w.IFileService),K(2,S.IUserDataProfilesService),K(3,D.IEnvironmentService),K(4,c.IUserDataSyncLogService),K(5,v.IUriIdentityService)],C);let b=class{constructor(p,k,N,F,x){this.userDataSyncStoreClient=p,this.storageService=k,this.environmentService=N,this.fileService=F,this.logService=x}getSyncStoreType(p){return this.parseGlobalState(p)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(p){const k=(0,c.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(p,k)}catch(N){if(N instanceof c.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(p,k)}throw N}}async doSync(p,k){const N=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,k),F=this.parseGlobalState(N)||{storage:{}};F.storage[c.SYNC_SERVICE_URL_TYPE]={value:p,version:r};const x=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),Z={version:r,machineId:x,content:t(F,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(Z),N.ref,void 0,k)}parseGlobalState({content:p}){if(!p)return null;const k=JSON.parse(p);if((0,d.isSyncData)(k))return k?JSON.parse(k.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=b,e.UserDataSyncStoreTypeSynchronizer=b=we([K(1,u.IStorageService),K(2,D.IEnvironmentService),K(3,w.IFileService),K(4,m.ILogService)],b)}),define(le[117],ue([0,1,17,15,3,34,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=void 0,e.getKeybindingsContentFromSyncContent=l;function l(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.isUndefined)(s.all)?null:s.all;switch(_.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends v.AbstractJsonFileSynchroniser{constructor(o,n,s,t,r,a,E,C,b,I,p,k,N){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,C,b,I,s,t,E,k,r,p,a,N),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(O.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,n,s,t){const r=o.syncData?l(o.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?o:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,E=await this.getLocalFileContent(),C=await this.getFormattingOptions();let b=null,I=!1,p=!1,k=!1;if(r){let x=E?E.value.toString():"[]";if(x=x||"[]",this.hasErrors(x,!0))throw new g.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==x||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const Z=await(0,d.merge)(x,r,a,C,this.userDataSyncUtilService);Z.hasChanges&&(b=Z.mergeContent,k=Z.hasConflicts,I=k||Z.mergeContent!==x,p=k||Z.mergeContent!==r)}}else E&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=E.value.toString(),p=!0);const N={content:k?a:b,localChange:I?E?2:1:0,remoteChange:p?2:0,hasConflicts:k},F=E?E.value.toString():null;return[{fileContent:E,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:F,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const n=this.getKeybindingsContentFromLastSyncUserData(o);if(n===null)return!0;const s=await this.getLocalFileContent(),t=s?s.value.toString():"",r=await this.getFormattingOptions(),a=await(0,d.merge)(t||"[]",n,n,r,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(o,n){return o.previewResult}async getAcceptResult(o,n,s,t){if(this.extUri.isEqual(n,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:E,remoteChange:C}=s[0][1];if(E===0&&C===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new g.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),C!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const b=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(b,t?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const n=(0,A.parse)(o.value.toString());if((0,L.isNonEmptyArray)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:l(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,_.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(g.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=c,e.KeybindingsSynchroniser=c=we([K(2,g.IUserDataSyncStoreService),K(3,g.IUserDataSyncLocalStoreService),K(4,g.IUserDataSyncLogService),K(5,f.IConfigurationService),K(6,g.IUserDataSyncEnablementService),K(7,w.IFileService),K(8,D.IEnvironmentService),K(9,m.IStorageService),K(10,g.IUserDataSyncUtilService),K(11,h.ITelemetryService),K(12,u.IUriIdentityService)],c);let S=class extends v.AbstractInitializer{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async doInitialize(o){const n=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,U.VSBuffer.fromString(n)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,A.parse)(o.value.toString());return!(0,L.isNonEmptyArray)(n)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return l(o,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=S,e.KeybindingsInitializer=S=we([K(0,w.IFileService),K(1,y.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,m.IStorageService),K(5,u.IUriIdentityService)],S)}),define(le[118],ue([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=void 0,e.parseSettingsSyncContent=g;function d(S){return S&&S.settings&&typeof S.settings=="string"&&Object.keys(S).length===1}function g(S){const i=JSON.parse(S);return d(i)?i:{settings:S}}let l=class extends u.AbstractJsonFileSynchroniser{constructor(i,o,n,s,t,r,a,E,C,b,I,p,k,N){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,I,p,E,C,b,N),this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(i,o),s=this.getSettingsSyncContent(n),t=new _.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,o,n){const s=await this.getLocalFileContent(),t=await this.getFormattingOptions(),r=this.getSettingsSyncContent(i);o=o===null&&n?i:o;const a=o?this.getSettingsSyncContent(o):null,E=await this.getIgnoredSettings();let C=null,b=!1,I=!1,p=!1;if(r){let x=s?s.value.toString().trim():"{}";x=x||"{}",this.validateContent(x),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const Z=(0,y.merge)(x,r.settings,a?a.settings:null,E,[],t);C=Z.localContent||Z.remoteContent,b=Z.localContent!==null,I=Z.remoteContent!==null,p=Z.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),C=s.value.toString().trim()||"{}",this.validateContent(C),I=!0);const k=s?s.value.toString():null,N=a?.settings??null,F={content:p?N:C,localChange:b?2:0,remoteChange:I?2:0,hasConflicts:p};return[{fileContent:s,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:k,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const o=this.getSettingsSyncContent(i);if(o===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",t=await this.getIgnoredSettings(),r=await this.getFormattingOptions();return(0,y.merge)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async getMergeResult(i,o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,y.updateIgnoredSettings)(i.previewResult.content,"{}",s,n):null}}async getAcceptResult(i,o,n,s){const t=await this.getFormattingOptions(),r=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:i.fileContent?(0,y.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,y.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,y.updateIgnoredSettings)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:E}=n[0][1];if(a===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.validateContent(r),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),t&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(t.value.toString()))),await this.updateLocalFileContent(r,t,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),E!==0){const C=await this.getFormattingOptions(),b=this.getSettingsSyncContent(i),I=await this.getIgnoredSettings(r);r=(0,y.updateIgnoredSettings)(r,b?b.settings:"{}",I,C),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(r)),s?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i)return!(0,y.isEmpty)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i)||this.extUri.isEqual(this.baseResource,i)?this.resolvePreviewContent(i):null}async resolvePreviewContent(i){let o=await super.resolvePreviewContent(i);if(o){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();o=(0,y.updateIgnoredSettings)(o,"{}",s,n)}return o}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return g(i)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const o=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(o,this.configurationService,i)}validateContent(i){if(this.hasErrors(i,!1))throw new v.UserDataSyncError((0,O.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=l,e.SettingsSynchroniser=l=we([K(2,f.IFileService),K(3,R.IEnvironmentService),K(4,D.IStorageService),K(5,v.IUserDataSyncStoreService),K(6,v.IUserDataSyncLocalStoreService),K(7,v.IUserDataSyncLogService),K(8,v.IUserDataSyncUtilService),K(9,A.IConfigurationService),K(10,v.IUserDataSyncEnablementService),K(11,w.ITelemetryService),K(12,P.IExtensionManagementService),K(13,m.IUriIdentityService)],l);let c=class extends u.AbstractInitializer{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async doInitialize(i){const o=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,L.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return g(i)}catch(o){this.logService.error(o)}return null}};e.SettingsInitializer=c,e.SettingsInitializer=c=we([K(0,f.IFileService),K(1,h.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,v.IUserDataSyncLogService),K(4,D.IStorageService),K(5,m.IUriIdentityService)],c)}),define(le[119],ue([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0,e.parseSnippets=y;function y(g){return JSON.parse(g.content)}let v=class extends m.AbstractSynchroniser{constructor(l,c,S,i,o,n,s,t,r,a,E,C){super({syncResource:"snippets",profile:l},c,i,S,o,n,s,a,E,t,r,C),this.version=1,this.snippetsFolder=l.snippetsHome,this._register(this.fileService.watch(S.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(U.Event.filter(this.fileService.onDidFilesChange,b=>b.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(l,c,S){const i=await this.getSnippetsFileContents(),o=this.toSnippetsContents(i),n=l.syncData?this.parseSnippets(l.syncData):null;c=c===null&&S?l:c;const s=c&&c.syncData?this.parseSnippets(c.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,h.merge)(o,n,s);return this.getResourcePreviews(t,i,n||{},s||{})}async hasRemoteChanged(l){const c=l.syncData?this.parseSnippets(l.syncData):null;if(c===null)return!0;const S=await this.getSnippetsFileContents(),i=this.toSnippetsContents(S),o=(0,h.merge)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(l,c){return l.previewResult}async getAcceptResult(l,c,S,i){if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:l.fileContent?l.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:l.remoteContent,localChange:l.remoteContent!==null?l.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder))return S===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:S,localChange:S===null?l.fileContent!==null?3:0:2,remoteChange:S===null?l.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(l,c,S,i){const o=S.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,i)),o.some(({remoteChange:n})=>n!==0)&&(l=await this.updateRemoteSnippets(o,l,i)),c?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(l),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.fileService.del(n)}catch{}}getResourcePreviews(l,c,S,i){const o=new Map;for(const n of Object.keys(l.local.added)){const s={content:l.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(l.local.updated)){const s={content:l.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of l.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(l.remote.added)){const s={content:l.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(l.remote.updated)){const s={content:l.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of l.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of l.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:S[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(l){return this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(l,this.syncPreviewFolder.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(l):null}async hasLocalData(){try{const l=await this.getSnippetsFileContents();if(Object.keys(l).length)return!0}catch{}return!1}async updateLocalBackup(l){const c={};for(const S of l)S.fileContent&&(c[this.extUri.basename(S.localResource)]=S.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(c)))}async updateLocalSnippets(l,c){for(const{fileContent:S,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of l)if(s!==0){const t=n?this.extUri.basename(n):this.extUri.basename(o),r=this.extUri.joinPath(this.snippetsFolder,t);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,L.VSBuffer.fromString(i.content),{overwrite:c}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,L.VSBuffer.fromString(i.content),c?void 0:S),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(l,c,S){const i=c.syncData?this.parseSnippets(c.syncData):{},o=(0,O.deepClone)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of l)if(r!==0){const a=s?this.extUri.basename(s):this.extUri.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,h.areSame)(i,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),c=await this.updateRemoteUserData(JSON.stringify(o),S?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),c}parseSnippets(l){return y(l)}toSnippetsContents(l){const c={};for(const S of Object.keys(l))c[S]=l[S].value.toString();return c}async getSnippetsFileContents(){const l={};let c;try{c=await this.fileService.resolve(this.snippetsFolder)}catch(S){if(S instanceof R.FileOperationError&&S.fileOperationResult===1)return l;throw S}for(const S of c.children||[]){const i=S.resource,o=this.extUri.extname(i);if(o===".json"||o===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,i),s=await this.fileService.readFile(i);l[n]=s}}return l}};e.SnippetsSynchroniser=v,e.SnippetsSynchroniser=v=we([K(2,_.IEnvironmentService),K(3,R.IFileService),K(4,P.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncLocalStoreService),K(7,u.IUserDataSyncLogService),K(8,A.IConfigurationService),K(9,u.IUserDataSyncEnablementService),K(10,f.ITelemetryService),K(11,D.IUriIdentityService)],v);let d=class extends m.AbstractInitializer{constructor(l,c,S,i,o,n){super("snippets",c,S,i,l,o,n)}async doInitialize(l){const c=l.syncData?JSON.parse(l.syncData.content):null;if(!c){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,i);await this.fileService.createFile(n,L.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(l)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(l){return l.fileOperationResult===1}}};e.SnippetsInitializer=d,e.SnippetsInitializer=d=we([K(0,R.IFileService),K(1,w.IUserDataProfilesService),K(2,_.IEnvironmentService),K(3,u.IUserDataSyncLogService),K(4,P.IStorageService),K(5,D.IUriIdentityService)],d)}),define(le[120],ue([0,1,15,21,16,12,19,22,28,18,39,25]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=void 0,e.getTasksContentFromSyncContent=m;function m(v,d){try{return JSON.parse(v).tasks??null}catch(g){return d.error(g),null}}let h=class extends D.AbstractFileSynchroniser{constructor(d,g,l,c,S,i,o,n,s,t,r,a){super(d.tasksResource,{syncResource:"tasks",profile:d},g,n,s,t,l,c,o,r,S,i,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(d,g,l,c){const S=d.syncData?m(d.syncData.content,this.logService):null;g=g===null&&l?d:g;const i=g?.syncData?m(g.syncData.content,this.logService):null,o=await this.getLocalFileContent();let n=null,s=!1,t=!1,r=!1;if(d.syncData){const C=o?o.value.toString():null;if(!i||i!==C||i!==S){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const b=y(C,S,i);n=b.content,r=b.hasConflicts,s=b.hasLocalChanged,t=b.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},E=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:E,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:S,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const g=d?.syncData?m(d.syncData.content,this.logService):null;if(g===null)return!0;const l=await this.getLocalFileContent(),c=l?l.value.toString():null,S=y(c,g,g);return S.hasLocalChanged||S.hasRemoteChanged}async getMergeResult(d,g){return d.previewResult}async getAcceptResult(d,g,l,c){if(this.extUri.isEqual(g,this.localResource))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:d.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return l===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:l,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(d,g,l,c){const{fileContent:S}=l[0][0],{content:i,localChange:o,remoteChange:n}=l[0][1];if(o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),S&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(S.value.toString()))),i?await this.updateLocalFileContent(i,S,c):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(i));d=await this.updateRemoteUserData(s,c?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(d){return this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)?this.resolvePreviewContent(d):null}toTasksSyncContent(d){return d?{tasks:d}:{}}};e.TasksSynchroniser=h,e.TasksSynchroniser=h=we([K(2,w.IUserDataSyncStoreService),K(3,w.IUserDataSyncLocalStoreService),K(4,w.IUserDataSyncLogService),K(5,U.IConfigurationService),K(6,w.IUserDataSyncEnablementService),K(7,A.IFileService),K(8,O.IEnvironmentService),K(9,_.IStorageService),K(10,R.ITelemetryService),K(11,P.IUriIdentityService)],h);let u=class extends D.AbstractInitializer{constructor(d,g,l,c,S,i){super("tasks",g,l,c,d,S,i),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(d){const g=d.syncData?m(d.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,L.VSBuffer.fromString(g)),await this.updateLastSyncUserData(d)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=u,e.TasksInitializer=u=we([K(0,A.IFileService),K(1,f.IUserDataProfilesService),K(2,O.IEnvironmentService),K(3,w.IUserDataSyncLogService),K(4,_.IStorageService),K(5,P.IUriIdentityService)],u);function y(v,d,g){if(v===null&&d===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===d)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const l=g!==v,c=g!==d;return!l&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:l&&!c?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!l?{content:d,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],ue([0,1,43,21,16,12,19,22,28,18,39,244,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0,e.stringifyLocalProfiles=u,e.parseUserDataProfilesManifest=y;let h=class extends D.AbstractSynchroniser{constructor(d,g,l,c,S,i,o,n,s,t,r,a,E){super({syncResource:"profiles",profile:d},g,c,S,i,o,n,r,a,s,t,E),this.userDataProfilesService=l,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(l.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const d=await this.getLastSyncUserData();return d?.syncData?y(d.syncData):null}async getRemoteSyncedProfiles(d){const g=await this.getLastSyncUserData(),l=await this.getLatestRemoteUserData(d,g);return l?.syncData?y(l.syncData):null}async generateSyncPreview(d,g,l){if(!this.userDataProfilesService.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const c=d.syncData?y(d.syncData):null,S=g?.syncData?y(g.syncData):null,i=this.getLocalUserDataProfiles(),{local:o,remote:n}=(0,w.merge)(i,c,S,[]),s={local:o,remote:n,content:S?this.stringifyRemoteProfiles(S):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=u(i,!1);return[{baseResource:this.baseResource,baseContent:S?this.stringifyRemoteProfiles(S):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.stringifyRemoteProfiles(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(d){const g=d?.syncData?y(d.syncData):null,l=this.getLocalUserDataProfiles(),{remote:c}=(0,w.merge)(l,g,g,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async getMergeResult(d,g){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,g,l,c){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(g,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(d){const g=this.getLocalUserDataProfiles(),l=(0,w.merge)(g,null,null,[]),{local:c,remote:S}=l;return{content:d.localContent,local:c,remote:S,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:S!==null?2:0}}async acceptRemote(d){const g=d.remoteContent?JSON.parse(d.remoteContent):null,l=[],c=[];for(const S of this.getLocalUserDataProfiles()){const i=g?.find(o=>o.id===S.id);i&&(l.push({id:S.id,name:S.name,collection:i.collection}),c.push(S))}if(g!==null){const S=(0,w.merge)(c,g,l,[]),{local:i,remote:o}=S;return{content:d.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:d.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(d,g,l,c){const{local:S,remote:i,localChange:o,remoteChange:n}=l[0][1];o===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const s=l[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.backupLocal(u(this.getLocalUserDataProfiles(),!1)),await Promise.all(S.removed.map(async r=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${r.name}' profile...`),await this.userDataProfilesService.removeProfile(r),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${r.name}'.`)}));const t=[];for(const r of S.added)t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${r.name}' profile...`),await this.userDataProfilesService.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${r.name}'.`)})());for(const r of S.updated){const a=this.userDataProfilesService.profiles.find(E=>E.id===r.id);a?t.push((async()=>{this.logService.trace(`${this.syncResourceLogLabel}: Updating '${r.name}' profile...`),await this.userDataProfilesService.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${r.name}'.`)})()):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const E=await this.userDataSyncStoreService.createCollection(this.syncHeaders);t.push(E),s.push({id:a.id,name:a.name,collection:E,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:E})=>a.id===E),1);for(const a of i?.updated||[]){const E=s.find(({id:C})=>a.id===C);E&&s.splice(s.indexOf(E),1,{...E,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{d=await this.updateRemoteProfiles(s,c?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of t)await this.userDataSyncStoreService.deleteCollection(E,this.syncHeaders)}throw a}for(const a of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}g?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(d,g){return this.updateRemoteUserData(this.stringifyRemoteProfiles(d),g)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(d){if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.baseResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)){const g=await this.resolvePreviewContent(d);return g&&(0,L.toFormattedString)(JSON.parse(g),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(d=>!d.isDefault&&!d.isTransient)}stringifyRemoteProfiles(d){return JSON.stringify([...d].sort((g,l)=>g.name.localeCompare(l.name)))}};e.UserDataProfilesManifestSynchroniser=h,e.UserDataProfilesManifestSynchroniser=h=we([K(2,f.IUserDataProfilesService),K(3,A.IFileService),K(4,O.IEnvironmentService),K(5,_.IStorageService),K(6,m.IUserDataSyncStoreService),K(7,m.IUserDataSyncLocalStoreService),K(8,m.IUserDataSyncLogService),K(9,U.IConfigurationService),K(10,m.IUserDataSyncEnablementService),K(11,R.ITelemetryService),K(12,P.IUriIdentityService)],h);function u(v,d){const g=[...v].sort((l,c)=>l.name.localeCompare(c.name)).map(l=>({id:l.id,name:l.name}));return d?(0,L.toFormattedString)(g,{}):JSON.stringify(g)}function y(v){return JSON.parse(v.content)}}),define(le[261],ue([0,1,3,2,5,16,19,22,25]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const f="sync.enable";let D=class extends U.Disposable{constructor(m,h,u,y){super(),this.storageService=m,this.telemetryService=h,this.environmentService=u,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(-1,void 0,this._register(new U.DisposableStore))(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(f,{enabled:m}),this.storageService.store(f,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,P.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,h){if(this.isResourceEnabled(m)!==h){const u=(0,P.getEnablementKey)(m);this.storeResourceEnablement(u,h)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,h){this.storageService.store(m,h,-1,O.isWeb?0:1)}onDidStorageChange(m){if(f===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const h=P.ALL_SYNC_RESOURCES.filter(u=>(0,P.getEnablementKey)(u)===m.key)[0];if(h){this._onDidChangeResourceEnablement.fire([h,this.isResourceEnabled(h)]);return}}};e.UserDataSyncEnablementService=D,e.UserDataSyncEnablementService=D=we([K(0,_.IStorageService),K(1,R.ITelemetryService),K(2,A.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],D)}),define(le[262],ue([0,1,6,15,65,2,20,21,16,12,18,25]),function(se,e,L,U,O,A,_,R,P,f,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let m=class extends A.Disposable{constructor(u,y,v,d,g){super(),this.environmentService=u,this.fileService=y,this.configurationService=v,this.logService=d,this.userDataProfilesService=g,this.cleanUp()}async cleanUp(){for(const y of this.userDataProfilesService.profiles)for(const v of w.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(v,y.isDefault?void 0:y.id))}catch(d){this.logService.error(d)}let u;try{u=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(y){(0,f.toFileOperationResult)(y)!==1&&this.logService.error(y);return}if(u.children){for(const y of u.children)if(y.isDirectory&&!this.userDataProfilesService.profiles.some(v=>v.id===y.name))try{this.logService.info("Deleting non existing profile from backup",y.resource.path),await this.fileService.del(y.resource,{recursive:!0})}catch(v){this.logService.error(v)}}}async getAllResourceRefs(u,y,v){const d=this.getResourceBackupHome(u,y,v);try{const g=await this.fileService.resolve(d);if(g.children)return g.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)}))}catch(g){if((0,f.toFileOperationResult)(g)!==1)throw g}return[]}async resolveResourceContent(u,y,v,d){const g=this.getResourceBackupHome(u,v,d),l=(0,_.joinPath)(g,y);try{return(await this.fileService.readFile(l)).value.toString()}catch(c){return this.logService.error(c),null}}async writeResource(u,y,v,d,g){const l=this.getResourceBackupHome(u,d,g),c=(0,_.joinPath)(l,`${(0,O.toLocalISOString)(v).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(c,U.VSBuffer.fromString(y))}catch(S){this.logService.error(S)}}getResourceBackupHome(u,y,v=this.environmentService.userDataSyncHome){return(0,_.joinPath)(v,...y?[y,u]:[u])}async cleanUpBackup(u){try{try{if(!await this.fileService.exists(u))return}catch{return}const y=await this.fileService.resolve(u);if(y.children){const v=y.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=v.filter(c=>Date.now()-this.getCreationTime(c)>d);const l=v.length-g.length;l<10&&(g=g.slice(10-l)),await L.Promises.settled(g.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(u){return new Date(parseInt(u.name.substring(0,4)),parseInt(u.name.substring(4,6))-1,parseInt(u.name.substring(6,8)),parseInt(u.name.substring(9,11)),parseInt(u.name.substring(11,13)),parseInt(u.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=m,e.UserDataSyncLocalStoreService=m=we([K(0,P.IEnvironmentService),K(1,f.IFileService),K(2,R.IConfigurationService),K(3,w.IUserDataSyncLogService),K(4,D.IUserDataProfilesService)],m)}),define(le[83],ue([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.isWebPlatform=S,e.IUserDataSyncMachinesService=(0,f.createDecorator)("IUserDataSyncMachinesService");const y="sync.currentMachineName",v="Safari",d="Chrome",g="Edge",l="Firefox",c="Android";function S(n){switch(n){case v:case d:case g:case l:case c:case(0,O.PlatformToString)(0):return!0}return!1}function i(){return O.isSafari?v:O.isChrome?d:O.isEdge?g:O.isFirefox?l:O.isAndroid?c:(0,O.PlatformToString)(O.isWeb?0:O.platform)}let o=class extends U.Disposable{static{u=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(s,t,r,a,E,C){super(),this.storageService=r,this.userDataSyncStoreService=a,this.logService=E,this.productService=C,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(s,t,r)}async getMachines(s){const t=await this.currentMachineIdPromise;return(await this.readMachinesData(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.computeCurrentMachineName(r.machines),platform:i()}),await this.writeMachinesData(r))}async removeCurrentMachine(s){const t=await this.currentMachineIdPromise,r=await this.readMachinesData(s),a=r.machines.filter(({id:E})=>E!==t);a.length!==r.machines.length&&(r.machines=a,await this.writeMachinesData(r))}async renameMachine(s,t,r){const a=await this.readMachinesData(r),E=a.machines.find(({id:C})=>C===s);if(E){E.name=t,await this.writeMachinesData(a);const C=await this.currentMachineIdPromise;s===C&&this.storageService.store(y,t,-1,1)}}async setEnablements(s){const t=await this.readMachinesData();for(const[r,a]of s){const E=t.machines.find(C=>C.id===r);E&&(E.disabled=a?void 0:!0)}await this.writeMachinesData(t)}computeCurrentMachineName(s){const t=this.storageService.get(y,-1);if(t)return t;const r=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${i()} (${this.productService.nameShort})`,a=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let E=0;for(const C of s){const b=a.exec(C.name),I=b?parseInt(b[1]):0;E=I>E?I:E}return`${r} #${E+1}`}async readMachinesData(s){this.userData=await this.readUserData(s);const t=this.parse(this.userData);if(t.version!==u.VERSION)throw new Error((0,_.localize)(0,null,this.productService.nameLong));return t}async writeMachinesData(s){const t=JSON.stringify(s),r=await this.userDataSyncStoreService.writeResource(u.RESOURCE,t,this.userData?.ref||null);this.userData={ref:r,content:t},this._onDidChange.fire()}async readUserData(s){if(this.userData){const t=s&&s.latest?s.latest[u.RESOURCE]:void 0;if(this.userData.ref===t)return this.userData;if(t===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(u.RESOURCE,this.userData)}parse(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.logService.error(t)}return{version:u.VERSION,machines:[]}}};e.UserDataSyncMachinesService=o,e.UserDataSyncMachinesService=o=u=we([K(0,R.IEnvironmentService),K(1,P.IFileService),K(2,m.IStorageService),K(3,h.IUserDataSyncStoreService),K(4,h.IUserDataSyncLogService),K(5,D.IProductService)],o)}),define(le[263],ue([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",l="sync.sessionId",c="sync.storeUrl",S="sync.productQuality";let i=class extends R.Disposable{get syncUrl(){const s=this.storageService.get(c,-1);return s?D.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(c,s.toString(),-1,1):this.storageService.remove(c,-1)}get productQuality(){return this.storageService.get(S,-1)}set productQuality(s){s?this.storageService.store(S,s,-1,1):this.storageService.remove(S,-1)}constructor(s,t,r,a,E,C,b,I,p,k){super(),this.userDataSyncStoreManagementService=t,this.userDataSyncStoreService=r,this.userDataSyncEnablementService=a,this.userDataSyncService=E,this.logService=C,this.userDataSyncAccountService=b,this.telemetryService=I,this.userDataSyncMachinesService=p,this.storageService=k,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new _.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(t.onDidChangeUserDataSyncStore(()=>{(0,f.isEqual)(this.syncUrl,t.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=t.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(b.onDidChangeAccount(()=>this.updateAutoSync())),this._register(r.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(E.onDidChangeLocal(N=>this.triggerSync([N],!1,!1))),this._register(_.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:t}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(r=>this.onDidFinishSync(r))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(t&&this.logService.info(t),this.autoSync.clear()):t&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(t))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,t,r){try{this.userDataSyncAccountService.account&&!r&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),t)this.updateEnablement(!1);else throw a}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const t=y.UserDataSyncError.toUserDataSyncError(s);t instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:t.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?P.isWeb&&t.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(t),this.successiveFailures++),this._onError.fire(t)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(s,t,r){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(t&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",r)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=i,e.UserDataAutoSyncService=i=we([K(0,m.IProductService),K(1,y.IUserDataSyncStoreManagementService),K(2,y.IUserDataSyncStoreService),K(3,y.IUserDataSyncEnablementService),K(4,y.IUserDataSyncService),K(5,y.IUserDataSyncLogService),K(6,v.IUserDataSyncAccountService),K(7,u.ITelemetryService),K(8,d.IUserDataSyncMachinesService),K(9,h.IStorageService)],i);class o extends R.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(s,t,r,a,E,C,b,I,p){super(),this.lastSyncUrl=s,this.interval=t,this.userDataSyncStoreManagementService=r,this.userDataSyncStoreService=a,this.userDataSyncService=E,this.userDataSyncMachinesService=C,this.logService=b,this.telemetryService=I,this.storageService=p,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new _.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new _.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>{this.sync(o.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(s,t){const r=(0,L.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(E){if((0,A.isCancellationError)(E))return}return this.doSync(s,t,a)});return this.syncPromise=r,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,f.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),t=this.userDataSyncStoreManagementService.userDataSyncStore;return!!t&&!!s&&(!(0,f.isEqual)(t.defaultUrl,s.defaultUrl)||!(0,f.isEqual)(t.insidersUrl,s.insidersUrl)||!(0,f.isEqual)(t.stableUrl,s.stableUrl))}async doSync(s,t,r){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(t,r)}catch(E){if(this.logService.error(E),a=E,y.UserDataSyncError.toUserDataSyncError(E).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(t,r),a=void 0}catch(C){this.logService.error(C),a=C}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(s,t){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),t.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const r=this.storageService.get(l,-1);if(r&&this.manifest&&r!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(t.isCancellationRequested)return;const E=a.find(b=>b.isCurrent);if(E?.disabled)throw new y.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");const C=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-C}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(b){throw new y.UserDataAutoSyncError((0,O.toErrorMessage)(b),b instanceof y.UserDataSyncError?b.code:"Unknown")}this.manifest&&this.manifest.session!==r&&this.storageService.store(l,this.manifest.session,-1,1),!t.isCancellationRequested&&(E||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(s){return super._register(s)}}}),define(le[264],ue([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,43,27]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{o=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(t,r,a,E,C,b,I,p,k,N){this.userDataSyncStoreService=t,this.userDataSyncLocalStoreService=r,this.logService=a,this.environmentService=C,this.storageService=b,this.fileService=I,this.userDataProfilesService=p,this.configurationService=k,this.instantiationService=N,this.extUri=E.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,c.parseUserDataProfilesManifest)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const E=this.parseSyncData(a,"profiles");return(0,c.parseUserDataProfilesManifest)(E)}}return[]}async getLocalSyncedMachines(t){const r=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(C=>({...C,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:E,ref:C})=>({created:E,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:r?.collection,ref:C,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(t,r?.collection,a)).map(({created:C,ref:b})=>({created:C,uri:this.toUri({remote:!1,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:b,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),a=r?this.userDataProfilesService.profiles.find(E=>E.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const a=this.userDataProfilesService.profiles.find(E=>E.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,a);case"keybindings":return this.getKeybindingsAssociatedResources(t,a);case"tasks":return this.getTasksAssociatedResources(t,a);case"snippets":return this.getSnippetsAssociatedResources(t,a);case"globalState":return this.getGlobalStateAssociatedResources(t,a);case"extensions":return this.getExtensionsAssociatedResources(t,a);case"profiles":return this.getProfilesAssociatedResources(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.getUserData(r.syncResource,r.ref,r.collection);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.userDataSyncLocalStoreService.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.parseSyncData(a,r.syncResource)?.machineId}return}return(0,_.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===o.NOT_EXISTING_RESOURCE)return null;if(r.ref){const a=await this.getContentFromStore(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.resolveNodeContent(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,a,E,C){if(t){const{content:b}=await this.getUserData(r,E,a);return b}return this.userDataSyncLocalStoreService.resolveResourceContent(r,E,a,C)}resolveNodeContent(t,r,a){const E=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(E,a);case"keybindings":return this.resolveKeybindingsNodeContent(E,a);case"tasks":return this.resolveTasksNodeContent(E,a);case"snippets":return this.resolveSnippetsNodeContent(E,a);case"globalState":return this.resolveGlobalStateNodeContent(E,a);case"extensions":return this.resolveExtensionsNodeContent(E,a);case"profiles":return this.resolveProfileNodeContent(E,a);case"workspaceState":return null}}async resolveLatestContent(t,r){const a=this.userDataProfilesService.profiles.find(E=>E.id===r);if(!a)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(a);case"extensions":return this.resolveLatestExtensionsContent(a);case"profiles":return this.resolveLatestProfilesContent(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"settings.json"),E=r?r.settingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:E}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,h.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"keybindings.json"),E=r?r.keybindingsResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:E}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,u.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(f.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const a=this.extUri.joinPath(t,"tasks.json"),E=r?r.tasksResource:this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:E}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,v.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const a=await this.resolveContent(t);if(a){const E=this.parseSyncData(a,"snippets");if(E){const C=(0,m.parseSnippets)(E),b=[];for(const I of Object.keys(C)){const p=this.extUri.joinPath(t,I),k=r?this.extUri.joinPath(r.snippetsHome,I):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);b.push({resource:p,comparableResource:k})}return b}}return[]}resolveSnippetsNodeContent(t,r){return(0,m.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const a=this.extUri.joinPath(t,"extensions.json"),E=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:E}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,d.stringify)((0,d.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(d.LocalExtensionsProvider).getLocalExtensions(t);return(0,d.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const a=this.extUri.joinPath(t,"globalState.json"),E=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,o.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:E}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,g.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(g.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,g.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const a=this.extUri.joinPath(t,"profiles.json"),E=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:E}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,S.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,c.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?o.REMOTE_BACKUP_AUTHORITY:o.LOCAL_BACKUP_AUTHORITY,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.trim)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.extUri.joinPath(L.URI.from({scheme:f.USER_DATA_SYNC_SCHEME,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}resolveUri(t){if(t.scheme!==f.USER_DATA_SYNC_SCHEME)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const a=t.authority===o.REMOTE_BACKUP_AUTHORITY;let E,C;const b=[];let I,p,k,N,F;for(;r.length;){const x=r.shift();x.startsWith("scheme:")?E=x.substring(7):x.startsWith("authority:")?C=x.substring(10):x.startsWith("syncResource:")?I=x.substring(13):x.startsWith("profile:")?p=x.substring(8):x.startsWith("collection:")?k=x.substring(11):x.startsWith("ref:")?N=x.substring(4):I?F=x:b.push(x)}return{remote:a,syncResource:I,profile:p,collection:k,ref:N,node:F,location:E&&C!==void 0?this.extUri.joinPath(L.URI.from({scheme:E,authority:C,query:t.query,fragment:t.fragment,path:"/"}),...b):void 0}}parseSyncData(t,r){try{const a=JSON.parse(t);if((0,w.isSyncData)(a))return a}catch(a){this.logService.error(a)}throw new f.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,a){const E=await this.userDataSyncStoreService.resolveResourceContent(t,r,a);return{ref:r,content:E}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=o=we([K(0,f.IUserDataSyncStoreService),K(1,f.IUserDataSyncLocalStoreService),K(2,f.IUserDataSyncLogService),K(3,P.IUriIdentityService),K(4,O.IEnvironmentService),K(5,R.IStorageService),K(6,A.IFileService),K(7,D.IUserDataProfilesService),K(8,y.IConfigurationService),K(9,l.IInstantiationService)],n)}),define(le[265],ue([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(I,p,k,N,F,x,Z,B,X,j,G){super(),this.fileService=I,this.userDataSyncStoreService=p,this.userDataSyncStoreManagementService=k,this.instantiationService=N,this.logService=F,this.telemetryService=x,this.storageService=Z,this.userDataSyncEnablementService=B,this.userDataProfilesService=X,this.userDataSyncResourceProviderService=j,this.userDataSyncLocalStoreService=G,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=k.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(t,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(I,p){this.checkEnablement(),this.logService.info("Sync started.");const k=new Date().getTime(),N=(0,D.generateUuid)();try{const B=(0,s.createSyncHeaders)(N);p&&(B["Cache-Control"]="no-cache"),I=await this.userDataSyncStoreService.manifest(I,B)}catch(B){const X=s.UserDataSyncError.toUserDataSyncError(B);throw C(X,N,this.userDataSyncStoreManagementService,this.telemetryService),X}const F=!1,x=this;let Z;return{manifest:I,async run(){if(F)throw new Error("Can run a task only once");Z=(0,U.createCancelablePromise)(B=>x.sync(I,!1,N,B)),await Z.finally(()=>Z=void 0),x.logService.info(`Sync done. Took ${new Date().getTime()-k}ms`),x.updateLastSyncTime()},stop(){return Z?.cancel(),x.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const I=new Date().getTime(),p=(0,D.generateUuid)(),k=(0,s.createSyncHeaders)(p);let N;try{N=await this.userDataSyncStoreService.manifest(null,k)}catch(Z){const B=s.UserDataSyncError.toUserDataSyncError(Z);throw C(B,p,this.userDataSyncStoreManagementService,this.telemetryService),B}await this.resetLocal();const F=this,x=new O.CancellationTokenSource;return{id:p,async merge(){return F.sync(N,!0,p,x.token)},async apply(){try{try{await F.applyManualSync(N,p,x.token)}catch(Z){if(s.UserDataSyncError.toUserDataSyncError(Z).code==="MethodNotFound")F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(N,p,x.token);else throw Z}}catch(Z){throw F.logService.error(Z),Z}F.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),F.updateLastSyncTime()},async stop(){x.cancel(),await F.stop(),await F.resetLocal()}}}async sync(I,p,k,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,I,p,k,N));const x=F.enabled.find(Z=>Z.resource==="profiles");if(x){const Z=await x.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(Z,I,p,k,N)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(I,p,k,N,F){for(const x of I){if(F.isCancellationRequested)return;const Z=this.userDataProfilesService.profiles.find(X=>X.id===x.id);if(!Z){this.logService.error(`Profile with id:${x.id} and name: ${x.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",x.name);const B=this.getOrCreateActiveProfileSynchronizer(Z,x);this._syncErrors.push(...await this.syncProfile(B,p,k,N,F))}for(const[x,Z]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(B=>B.id===Z[0].profile.id)||(Z[1].dispose(),this.activeProfileSynchronizers.delete(x))}async applyManualSync(I,p,k){const N=this.getActiveProfileSynchronizers();for(const X of N){if(k.isCancellationRequested)return;await X.apply(p,k)}const F=N.find(X=>X.profile.isDefault);if(!F)return;const x=F.enabled.find(X=>X.resource==="profiles");if(!x)return;const B=(await x.getRemoteSyncedProfiles(I?.latest??null)||[]).filter(X=>N.every(j=>j.profile.id!==X.id));B.length&&await this.syncRemoteProfiles(B,I,!1,p,k)}async syncProfile(I,p,k,N,F){return(await I.sync(p,k,N,F)).map(([Z,B])=>({profile:I.profile,syncResource:Z,error:B}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(I=>I.stop()))}async resolveContent(I){const p=await this.userDataSyncResourceProviderService.resolveContent(I);if(p)return p;for(const k of this.getActiveProfileSynchronizers())for(const N of k.enabled){const F=await N.resolveContent(I);if(F)return F}return null}async replace(I){this.checkEnablement();const p=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(I);if(!p)return;const k=await this.resolveContent(I.uri);k&&await this.performAction(p.profile,async N=>{if(p.syncResource===N.resource)return await N.replace(k),!0})}async accept(I,p,k,N){this.checkEnablement(),await this.performAction(I.profile,async F=>{if(I.syncResource===F.resource)return await F.accept(p,k),N&&await F.apply((0,f.isBoolean)(N)?!1:N.force,(0,s.createSyncHeaders)((0,D.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async p=>{if(p.resource!=="globalState"&&await p.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async p=>{if(await p.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(I){this.logService.error(I)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(t,-1);for(const[I]of this.activeProfileSynchronizers.values())try{await I.resetLocal()}catch(p){this.logService.error(p)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const I=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),p=I.map(x=>x.collection),k=await this.userDataSyncStoreService.getAllCollections(),N=k.filter(x=>!p.includes(x));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(x=>this.userDataSyncStoreService.deleteCollection(x))),this.logService.info("Deleted redundant collections on server"));const F=I.filter(x=>k.includes(x.collection));if(F.length!==I.length){const x=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await x.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await x.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{x.dispose()}}}async saveRemoteActivityData(I){this.checkEnablement();const p=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(I,p)}async extractActivityData(I,p){const k=(await this.fileService.readFile(I)).value.toString(),N=JSON.parse(k);if(N.resources)for(const F in N.resources)for(const x of N.resources[F])await this.userDataSyncLocalStoreService.writeResource(F,x.content,new Date(x.created*1e3),void 0,p);if(N.collections)for(const F in N.collections)for(const x in N.collections[F].resources)for(const Z of N.collections[F].resources?.[x]??[])await this.userDataSyncLocalStoreService.writeResource(x,Z.content,new Date(Z.created*1e3),F,p)}async performAction(I,p){const k=new R.DisposableStore;try{const N=this.activeProfileSynchronizers.get(I.id);if(N){const X=await this.performActionWithProfileSynchronizer(N[0],p,k);return(0,f.isUndefined)(X)?null:X}if(I.isDefault){const X=k.add(this.instantiationService.createInstance(a,I,void 0)),j=await this.performActionWithProfileSynchronizer(X,p,k);return(0,f.isUndefined)(j)?null:j}if(this.userDataProfilesService.isEnabled())return null;const F=k.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,I,void 0)),x=await this.userDataSyncStoreService.manifest(null),B=(await F.getRemoteSyncedProfiles(x?.latest??null)||[]).find(X=>X.id===I.id);if(B){const X=k.add(this.instantiationService.createInstance(a,I,B.collection)),j=await this.performActionWithProfileSynchronizer(X,p,k);return(0,f.isUndefined)(j)?null:j}return null}finally{k.dispose()}}async performActionWithProfileSynchronizer(I,p,k){const N=[...I.enabled,...I.disabled.reduce((F,x)=>(x!=="workspaceState"&&F.push(k.add(I.createSynchronizer(x))),F),[])];for(const F of N){const x=await p(F);if(!(0,f.isUndefined)(x))return x}}setStatus(I){const p=this._status;this._status!==I&&(this._status=I,this._onDidChangeStatus.fire(I),p==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const I=this.getActiveProfileSynchronizers().map(p=>p.conflicts).flat();(0,L.equals)(this._conflicts,I,(p,k)=>p.profile.id===k.profile.id&&p.syncResource===k.syncResource&&(0,L.equals)(p.conflicts,k.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=I,this._onDidChangeConflicts.fire(I))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(I,p){let k=this.activeProfileSynchronizers.get(I.id);if(k&&k[0].collection!==p?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),k[1].dispose(),k=void 0,this.activeProfileSynchronizers.delete(I.id)),!k){const N=new R.DisposableStore,F=N.add(this.instantiationService.createInstance(a,I,p?.collection));N.add(F.onDidChangeStatus(x=>this.setStatus(x))),N.add(F.onDidChangeConflicts(x=>this.updateConflicts())),N.add(F.onDidChangeLocal(x=>this._onDidChangeLocal.fire(x))),this.activeProfileSynchronizers.set(I.id,k=[F,N])}return k[0]}getActiveProfileSynchronizers(){const I=[];for(const[p]of this.activeProfileSynchronizers.values())I.push(p);return I}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,I])=>I.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=r,e.UserDataSyncService=r=we([K(0,h.IFileService),K(1,s.IUserDataSyncStoreService),K(2,s.IUserDataSyncStoreManagementService),K(3,u.IInstantiationService),K(4,s.IUserDataSyncLogService),K(5,v.ITelemetryService),K(6,y.IStorageService),K(7,s.IUserDataSyncEnablementService),K(8,d.IUserDataProfilesService),K(9,s.IUserDataSyncResourceProviderService),K(10,s.IUserDataSyncLocalStoreService)],r);let a=class extends R.Disposable{get enabled(){return this._enabled.sort((I,p)=>I[1]-p[1]).map(([I])=>I)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(I=>!this.userDataSyncEnablementService.isResourceEnabled(I))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(I,p,k,N,F,x,Z,B,X,j){super(),this.profile=I,this.collection=p,this.userDataSyncEnablementService=k,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=x,this.telemetryService=Z,this.logService=B,this.userDataProfilesService=X,this.configurationService=j,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(k.onDidChangeResourceEnablement(([G,z])=>this.onDidChangeResourceEnablement(G,z))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,G])=>G.dispose())));for(const G of s.ALL_SYNC_RESOURCES)k.isResourceEnabled(G)&&this.registerSynchronizer(G)}onDidChangeResourceEnablement(I,p){p?this.registerSynchronizer(I):this.deRegisterSynchronizer(I)}registerSynchronizer(I){if(this._enabled.some(([F])=>F.resource===I))return;if(I==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(I==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||I==="workspaceState")return;if(I!=="profiles"&&this.profile.useDefaultFlags?.[I]){this.logService.debug(`Skipping syncing ${I} in ${this.profile.name} because it is already synced by default profile`);return}const p=new R.DisposableStore,k=p.add(this.createSynchronizer(I));p.add(k.onDidChangeStatus(()=>this.updateStatus())),p.add(k.onDidChangeConflicts(()=>this.updateConflicts())),p.add(k.onDidChangeLocal(()=>this._onDidChangeLocal.fire(I)));const N=this.getOrder(I);this._enabled.push([k,N,p])}deRegisterSynchronizer(I){const p=this._enabled.findIndex(([k])=>k.resource===I);if(p!==-1){const[[k,,N]]=this._enabled.splice(p,1);N.dispose(),this.updateStatus(),Promise.allSettled([k.stop(),k.resetLocal()]).then(null,F=>this.logService.error(F))}}createSynchronizer(I){switch(I){case"settings":return this.instantiationService.createInstance(S.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(c.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(i.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(o.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(l.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(g.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(I,p,k,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const x=[],Z=(0,s.createSyncHeaders)(k),B=(this.collection?I?.collections?.[this.collection]?.latest:I?.latest)??null,X=p?await this.getUserDataSyncConfiguration(B):{};for(const j of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(j.resource))return[];try{if(p){const G=await j.preview(B,X,Z);if(G)for(const z of G.resourcePreviews)(z.localChange!==0||z.remoteChange!==0)&&z.mergeState==="preview"&&await j.merge(z.previewResource)}else await j.sync(B,Z)}catch(G){const z=s.UserDataSyncError.toUserDataSyncError(G);if(C(z,k,this.userDataSyncStoreManagementService,this.telemetryService),E(G))throw z;this.logService.error(G),this.logService.error(`${j.resource}: ${(0,A.toErrorMessage)(G)}`),x.push([j.resource,z])}}return x}finally{this.updateStatus()}}async apply(I,p){const k=(0,s.createSyncHeaders)(I);for(const N of this.enabled){if(p.isCancellationRequested)return;try{await N.apply(!1,k)}catch(F){const x=s.UserDataSyncError.toUserDataSyncError(F);if(C(x,I,this.userDataSyncStoreManagementService,this.telemetryService),E(F))throw x;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,A.toErrorMessage)(F)}`)}}}async stop(){for(const I of this.enabled)try{I.status!=="idle"&&await I.stop()}catch(p){this.logService.error(p)}}async resetLocal(){for(const I of this.enabled)try{await I.resetLocal()}catch(p){this.logService.error(`${I.resource}: ${(0,A.toErrorMessage)(p)}`),this.logService.error(p)}}async getUserDataSyncConfiguration(I){if(!this.profile.isDefault)return{};const p=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),k=this.enabled.find(N=>N instanceof S.SettingsSynchroniser);if(k){const N=await k.getRemoteUserDataSyncConfiguration(I);return{...p,...N}}return p}setStatus(I){this._status!==I&&(this._status=I,this._onDidChangeStatus.fire(I))}updateStatus(){return this.updateConflicts(),this.enabled.some(I=>I.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(I=>I.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const I=this.enabled.filter(p=>p.status==="hasConflicts").filter(p=>p.conflicts.conflicts.length>0).map(p=>p.conflicts);(0,L.equals)(this._conflicts,I,(p,k)=>p.syncResource===k.syncResource&&(0,L.equals)(p.conflicts,k.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=I,this._onDidChangeConflicts.fire(I))}getOrder(I){switch(I){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=we([K(2,s.IUserDataSyncEnablementService),K(3,u.IInstantiationService),K(4,m.IExtensionGalleryService),K(5,s.IUserDataSyncStoreManagementService),K(6,v.ITelemetryService),K(7,s.IUserDataSyncLogService),K(8,d.IUserDataProfilesService),K(9,w.IConfigurationService)],a);function E(b){if(b instanceof s.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function C(b,I,p,k){k.publicLog2("sync/error",{code:b.code,serverCode:b instanceof s.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof s.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:I,service:p.userDataSyncStore.url.toString()})}}),define(le[266],ue([0,1,3,2,8,18,25]),function(se,e,L,U,O,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function R(m,h){return{...m,profile:(0,A.reviveProfile)(m.profile,h.profilesHome.scheme)}}function P(m){return{created:m.created,uri:O.URI.revive(m.uri)}}class f{constructor(h,u,y){this.service=h,this.userDataProfilesService=u,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(h,u){switch(u){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${u}`)}async call(h,u,y){try{return await this._call(h,u,y)}catch(v){throw this.logService.error(v),v}}async _call(h,u,y){switch(u){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(O.URI.revive(y[0]));case"accept":return this.service.accept(R(y[0],this.userDataProfilesService),O.URI.revive(y[1]),y[2],y[3]);case"replace":return this.service.replace(P(y[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(O.URI.revive(y[0]));case"extractActivityData":return this.service.extractActivityData(O.URI.revive(y[0]),O.URI.revive(y[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(u.startsWith("manualSync/")){const v=u.substring(11),d=y[0],g=this.getManualSyncTask(d);switch(y=y.slice(1),v){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.manualSyncTasks.delete(this.createKey(g.id)));case"stop":return g.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(g.id)))}}throw new Error("Invalid call")}getManualSyncTask(h){const u=this.manualSyncTasks.get(this.createKey(h));if(!u)throw new Error(`Manual sync taks not found: ${h}`);return u}async createManualSyncTask(){const h=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(h.id),h),h.id}createKey(h){return`manualSyncTask-${h}`}}e.UserDataSyncServiceChannel=f;let D=class extends U.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(h,u){super(),this.userDataProfilesService=u,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,v,d){return h.call(y,v,d).then(null,g=>{throw _.UserDataSyncError.toUserDataSyncError(g)})},listen(y,v){return h.listen(y,v)}},this.channel.call("_getInitialData").then(([y,v,d])=>{this.updateStatus(y),this.updateConflicts(v),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(g=>this.updateStatus(g))),this._register(this.channel.listen("onDidChangeLastSyncTime")(g=>this.updateLastSyncTime(g)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(v=>({...v,error:_.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.channel.call("createManualSyncTask"),u=this;return new w(h,{async call(v,d,g){return u.channel.call(`manualSync/${v}`,[h,...Array.isArray(d)?d:[d]],g)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(h,u,y,v){return this.channel.call("accept",[h,u,y,v])}resolveContent(h){return this.channel.call("resolveContent",[h])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(h){return this.channel.call("replace",[h])}saveRemoteActivityData(h){return this.channel.call("getRemoteActivityData",[h])}extractActivityData(h,u){return this.channel.call("extractActivityData",[h,u])}async updateStatus(h){this._status=h,this._onDidChangeStatus.fire(h)}async updateConflicts(h){this._conflicts=h.map(u=>({syncResource:u.syncResource,profile:(0,A.reviveProfile)(u.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:u.conflicts.map(y=>({...y,baseResource:O.URI.revive(y.baseResource),localResource:O.URI.revive(y.localResource),remoteResource:O.URI.revive(y.remoteResource),previewResource:O.URI.revive(y.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(h){this._lastSyncTime!==h&&(this._lastSyncTime=h,this._onDidChangeLastSyncTime.fire(h))}};e.UserDataSyncServiceChannelClient=D,e.UserDataSyncServiceChannelClient=D=we([K(1,A.IUserDataProfilesService)],D);class w extends U.Disposable{constructor(h,u){super(),this.id=h,this.channel=u}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(le[122],ue([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const S="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends _.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(k){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,k,-1,P.isWeb?0:1)}constructor(k,N,F){super(),this.productService=k,this.configurationService=N,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const x=this._register(new _.DisposableStore);this._register(A.Event.filter(F.onDidChangeValue(-1,c.SYNC_SERVICE_URL_TYPE,x),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,x)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(k){if(k&&(k=P.isWeb&&k.web?{...k,...k.web}:k,(0,D.isString)(k.url)&&(0,D.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(N=>Array.isArray(k.authenticationProviders[N].scopes)))){const N=k,F=!!N.canSwitch,x=N.url===N.insidersUrl?"insiders":"stable",Z=(F?this.userDataSyncStoreType:void 0)||x,B=Z==="insiders"?N.insidersUrl:Z==="stable"?N.stableUrl:N.url;return{url:w.URI.parse(B),type:Z,defaultType:x,defaultUrl:w.URI.parse(N.url),stableUrl:w.URI.parse(N.stableUrl),insidersUrl:w.URI.parse(N.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(N.authenticationProviders).reduce((X,j)=>(X.push({id:j,scopes:N.authenticationProviders[j].scopes}),X),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=we([K(0,v.IProductService),K(1,h.IConfigurationService),K(2,l.IStorageService)],a);let E=class extends a{constructor(k,N,F){super(k,N,F);const x=this.storageService.get(i,-1);x&&(this.previousConfigurationSyncStore=JSON.parse(x));const Z=this.productService[S];Z?this.storageService.store(i,JSON.stringify(Z),-1,1):this.storageService.remove(i,-1)}async switch(k){k!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=k,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=E,e.UserDataSyncStoreManagementService=E=we([K(0,v.IProductService),K(1,h.IConfigurationService),K(2,l.IStorageService)],E);let C=class extends _.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(k,N,F,x,Z,B,X){super(),this.requestService=F,this.logService=x,this.storageService=X,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(k),this.commonHeadersPromise=(0,g.getServiceMachineId)(Z,B,X).then(j=>{const G={"X-Client-Name":`${N.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(G["X-Client-Commit"]=N.commit),G}),this.session=new I(t,r,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,_.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(k,N){this.authToken={token:k,type:N}}updateUserDataSyncStoreUrl(k){this.userDataSyncStoreUrl=k?(0,f.joinPath)(k,"v1"):void 0}initDonotMakeRequestsUntil(){const k=this.storageService.getNumber(o,-1);k&&Date.now()<k&&this.setDonotMakeRequestsUntil(new Date(k))}setDonotMakeRequestsUntil(k){this._donotMakeRequestsUntil?.getTime()!==k?.getTime()&&(this._donotMakeRequestsUntil=k,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(o,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(o,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,f.joinPath)(this.userDataSyncStoreUrl,"collection").toString();k={...k},k["Content-Type"]="application/json";const F=await this.request(N,{type:"GET",headers:k},[],U.CancellationToken.None);return(await(0,d.asJson)(F))?.map(({id:x})=>x)||[]}async createCollection(k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,f.joinPath)(this.userDataSyncStoreUrl,"collection").toString();k={...k},k["Content-Type"]=R.Mimes.text;const F=await this.request(N,{type:"POST",headers:k},[],U.CancellationToken.None),x=await(0,d.asTextOrError)(F);if(!x)throw new c.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);return x}async deleteCollection(k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=k?(0,f.joinPath)(this.userDataSyncStoreUrl,"collection",k).toString():(0,f.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(F,{type:"DELETE",headers:N},[],U.CancellationToken.None)}async getAllResourceRefs(k,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,N,k),x={},Z=await this.request(F.toString(),{type:"GET",headers:x},[],U.CancellationToken.None);return(await(0,d.asJson)(Z)||[]).map(({url:X,created:j})=>({ref:(0,f.relativePath)(F,F.with({path:X})),created:j*1e3}))}async resolveResourceContent(k,N,F,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Z=(0,f.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,k),N).toString();x={...x},x["Cache-Control"]="no-cache";const B=await this.request(Z,{type:"GET",headers:x},[],U.CancellationToken.None);return await(0,d.asTextOrError)(B)}async deleteResource(k,N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=N!==null?(0,f.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,k),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,k).toString(),Z={};await this.request(x,{type:"DELETE",headers:Z},[],U.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,f.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(k,{type:"DELETE",headers:N},[],U.CancellationToken.None)}async readResource(k,N,F,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const Z=(0,f.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,k),"latest").toString();x={...x},x["Cache-Control"]="no-cache",N&&(x["If-None-Match"]=N.ref);const B=await this.request(Z,{type:"GET",headers:x},[304],U.CancellationToken.None);let X=null;if(B.res.statusCode===304&&(X=N),X===null){const j=B.res.headers.etag;if(!j)throw new c.UserDataSyncStoreError("Server did not return the ref",Z,"NoRef",B.res.statusCode,B.res.headers[c.HEADER_OPERATION_ID]);const G=await(0,d.asTextOrError)(B);if(!G&&B.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",Z,"EmptyResponse",B.res.statusCode,B.res.headers[c.HEADER_OPERATION_ID]);X={ref:j,content:G}}return X}async writeResource(k,N,F,x,Z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=this.getResourceUrl(this.userDataSyncStoreUrl,x,k).toString();Z={...Z},Z["Content-Type"]=R.Mimes.text,F&&(Z["If-Match"]=F);const X=await this.request(B,{type:"POST",data:N,headers:Z},[],U.CancellationToken.None),j=X.res.headers.etag;if(!j)throw new c.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",X.res.statusCode,X.res.headers[c.HEADER_OPERATION_ID]);return j}async manifest(k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,f.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",k&&(N["If-None-Match"]=k.ref);const x=await this.request(F,{type:"GET",headers:N},[304],U.CancellationToken.None);let Z=null;if(x.res.statusCode===304&&(Z=k),!Z){const X=x.res.headers.etag;if(!X)throw new c.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",x.res.statusCode,x.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,d.asTextOrError)(x);if(!j&&x.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",F,"EmptyResponse",x.res.statusCode,x.res.headers[c.HEADER_OPERATION_ID]);j&&(Z={...JSON.parse(j),ref:X})}const B=this.storageService.get(n,-1);return B&&Z&&B!==Z.session&&this.clearSession(),Z===null&&B&&this.clearSession(),Z&&this.storageService.store(n,Z.session,-1,1),Z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,f.joinPath)(this.userDataSyncStoreUrl,"download").toString(),N={},F=await this.request(k,{type:"GET",headers:N},[],U.CancellationToken.None);if(!(0,d.isSuccess)(F))throw new c.UserDataSyncStoreError("Server returned "+F.res.statusCode,k,"EmptyResponse",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);if((0,d.hasNoContent)(F))throw new c.UserDataSyncStoreError("Empty response",k,"EmptyResponse",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);return F.stream}getResourceUrl(k,N,F){return N?(0,f.joinPath)(k,"collection",N,"resource",F):(0,f.joinPath)(k,"resource",F)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(s,-1)}async request(k,N,F,x){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",k,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of too many requests (429).`,k,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const Z=await this.commonHeadersPromise;N.headers={...N.headers||{},...Z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:k,type:N.type,headers:{...N.headers,authorization:void 0}});let B;try{B=await this.session.request(k,N,x)}catch(q){if(!(q instanceof c.UserDataSyncStoreError)){let ie="RequestFailed";const ae=(0,O.getErrorMessage)(q).toLowerCase();ae.includes("xhr timeout")?ie="RequestTimeout":ae.includes("protocol")&&ae.includes("not supported")?ie="RequestProtocolNotSupported":ae.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":ae.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,O.isCancellationError)(q)&&(ie="RequestCanceled"),q=new c.UserDataSyncStoreError(`Connection refused for the request '${k}'.`,k,ie,void 0,void 0)}throw this.logService.info("Request failed",k),q}const X=B.res.headers[c.HEADER_OPERATION_ID],j={url:k,status:B.res.statusCode,"execution-id":N.headers[c.HEADER_EXECUTION_ID],"operation-id":X},G=(0,d.isSuccess)(B)||B.res.statusCode&&F.includes(B.res.statusCode);let z="";if(G?this.logService.trace("Request succeeded",j):(z=await(0,d.asText)(B)||"",this.logService.info("Request failed",j,z)),B.res.statusCode===401||B.res.statusCode===403){if(this.authToken=void 0,B.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of Unauthorized (401).`,k,"Unauthorized",B.res.statusCode,X);if(B.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because the access is forbidden (403).`,k,"Forbidden",B.res.statusCode,X)}if(this._onTokenSucceed.fire(),B.res.statusCode===404)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because the requested resource is not found (404).`,k,"NotFound",B.res.statusCode,X);if(B.res.statusCode===405)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because the requested endpoint is not found (405). ${z}`,k,"MethodNotFound",B.res.statusCode,X);if(B.res.statusCode===409)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,k,"Conflict",B.res.statusCode,X);if(B.res.statusCode===410)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because the requested resource is not longer available (410).`,k,"Gone",B.res.statusCode,X);if(B.res.statusCode===412)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,k,"PreconditionFailed",B.res.statusCode,X);if(B.res.statusCode===413)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of too large payload (413).`,k,"TooLarge",B.res.statusCode,X);if(B.res.statusCode===426)throw new c.UserDataSyncStoreError(`${N.type} request '${k}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,k,"UpgradeRequired",B.res.statusCode,X);if(B.res.statusCode===429){const q=B.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of too many requests (429).`,k,"TooManyRequestsAndRetryAfter",B.res.statusCode,X)):new c.UserDataSyncStoreError(`${N.type} request '${k}' failed because of too many requests (429).`,k,"RemoteTooManyRequests",B.res.statusCode,X)}if(!G)throw new c.UserDataSyncStoreError("Server returned "+B.res.statusCode,k,"Unknown",B.res.statusCode,X);return B}addSessionHeaders(k){let N=this.storageService.get(s,-1);N===void 0&&(N=(0,m.generateUuid)(),this.storageService.store(s,N,-1,1)),k["X-Machine-Session-Id"]=N;const F=this.storageService.get(n,-1);F!==void 0&&(k["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=C,e.UserDataSyncStoreClient=C=we([K(1,v.IProductService),K(2,d.IRequestService),K(3,c.IUserDataSyncLogService),K(4,u.IEnvironmentService),K(5,y.IFileService),K(6,l.IStorageService)],C);let b=class extends C{constructor(k,N,F,x,Z,B,X){super(k.userDataSyncStore?.url,N,F,x,Z,B,X),this._register(k.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(k.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=b,e.UserDataSyncStoreService=b=we([K(0,c.IUserDataSyncStoreManagementService),K(1,v.IProductService),K(2,d.IRequestService),K(3,c.IUserDataSyncLogService),K(4,u.IEnvironmentService),K(5,y.IFileService),K(6,l.IStorageService)],b);class I{constructor(k,N,F,x){this.limit=k,this.interval=N,this.requestService=F,this.logService=x,this.requests=[],this.startTime=void 0}request(k,N,F){if(this.isExpired()&&this.reset(),N.url=k,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,k,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(k),this.requestService.request(N,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(le[267],ue([0,1,3,2,8,21,24,19,122]),function(se,e,L,U,O,A,_,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class f{constructor(u){this.service=u}listen(u,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${y}`)}call(u,y,v){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(v)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=f;class D extends U.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(u){super(),this.channel=u,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(y=>{this._account=y,this._register(this.channel.listen("onDidChangeAccount")(v=>{this._account=v,this._onDidChangeAccount.fire(v)}))})}updateAccount(u){return this.channel.call("updateAccount",u)}}e.UserDataSyncAccountServiceChannelClient=D;class w{constructor(u){this.service=u}listen(u,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${y}`)}call(u,y,v){switch(y){case"switch":return this.service.switch(v[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;let m=class extends P.AbstractUserDataSyncStoreManagementService{constructor(u,y,v,d){super(y,v,d),this.channel=u,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(u){return this.channel.call("switch",[u])}async getPreviousUserDataSyncStore(){const u=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(u)}revive(u){return{url:O.URI.revive(u.url),type:u.type,defaultUrl:O.URI.revive(u.defaultUrl),insidersUrl:O.URI.revive(u.insidersUrl),stableUrl:O.URI.revive(u.stableUrl),canSwitch:u.canSwitch,authenticationProviders:u.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=m,e.UserDataSyncStoreManagementServiceChannelClient=m=we([K(1,_.IProductService),K(2,A.IConfigurationService),K(3,R.IStorageService)],m)}),define(le[268],ue([0,1,3,57,24,19,22,263,25,80,83]),function(se,e,L,U,O,A,_,R,P,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends R.UserDataAutoSyncService{constructor(h,u,y,v,d,g,l,c,S,i,o){super(h,u,y,v,d,l,c,S,i,o),this._register(L.Event.debounce(L.Event.any(L.Event.map(g.onDidFocusMainWindow,()=>"windowFocus"),L.Event.map(g.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=w,e.UserDataAutoSyncService=w=we([K(0,O.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,U.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,f.IUserDataSyncAccountService),K(8,_.ITelemetryService),K(9,D.IUserDataSyncMachinesService),K(10,A.IStorageService)],w)}),define(le[269],ue([0,1,73,23,5,20]),function(se,e,L,U,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=_,e.getSingleFolderWorkspaceIdentifier=R,e.createEmptyWorkspaceIdentifier=P,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function _(f){function D(){let w=f.scheme===U.Schemas.file?(0,A.originalFSPath)(f):f.toString();return O.isLinux||(w=w.toLowerCase()),(0,L.createHash)("md5").update(w).digest("hex")}return{id:D(),configPath:f}}function R(f,D){function w(){if(f.scheme!==U.Schemas.file)return(0,L.createHash)("md5").update(f.toString()).digest("hex");if(!D)return;let h;return O.isLinux?h=D.ino:O.isMacintosh?h=D.birthtime.getTime():O.isWindows&&(typeof D.birthtimeMs=="number"?h=Math.floor(D.birthtimeMs):h=D.birthtime.getTime()),(0,L.createHash)("md5").update(f.fsPath).update(h?String(h):"").digest("hex")}const m=w();if(typeof m=="string")return{id:m,uri:f}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[270],ue([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let y=class extends O.Disposable{constructor(d,g,l,c){super(),this.environmentService=d,this.logService=g,this.nativeHostService=l,this.mainProcessService=c,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const d=this.environmentService.workspaceStorageHome.with({scheme:u.Schemas.file}).fsPath,g=await _.Promises.readdir(d),l=new f.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(g.map(async c=>{const S=(0,A.join)(d,c);c.length===w.NON_EMPTY_WORKSPACE_ID_LENGTH||c===D.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await l.isUsed(S)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await _.Promises.rm(S))}))}catch(d){(0,U.onUnexpectedError)(d)}}};e.UnusedWorkspaceStorageDataCleaner=y,e.UnusedWorkspaceStorageDataCleaner=y=we([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,m.INativeHostService),K(3,h.IMainProcessService)],y)}),define(le[123],ue([0,1,73,64,37,279,15,7,3,2,14,5,32,41,68]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=n,e.createStaticIPCHandle=s,e.serve=a,e.connect=E;class y{traceSocketEvent(b,I){u.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,I)}constructor(b,I=""){this._canWrite=!0,this.debugLabel=I,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,R.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener),this._closeListener=p=>{this.traceSocketEvent("close",{hadError:p}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(b){const I=p=>{this.traceSocketEvent("read",p),b(_.VSBuffer.wrap(p))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(b){const I=p=>{b({type:0,hadError:p,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(b){const I=()=>{b()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(b){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,R.onUnexpectedError)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,R.onUnexpectedError)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=y;var v;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(v||(v={}));var d;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(d||(d={}));class g extends f.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,I){this.socket.traceSocketEvent(b,I)}constructor(b,I,p,k){super(),this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:p?.byteLength||0,recordInflateBytes:k}),this._flowManager=this._register(new l(this,I,p,k,this._onData,(N,F)=>this._write(N,F))),this._register(this._flowManager.onError(N=>{console.error(N),(0,R.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new u.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let I=0;for(;I<b.byteLength;)this._flowManager.writeMessage(b.slice(I,Math.min(I+262144,b.byteLength)),{compressed:!0,opcode:2}),I+=262144}_write(b,{compressed:I,opcode:p}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let k=2;b.byteLength<126?k+=0:b.byteLength<2**16?k+=2:k+=8;const N=_.VSBuffer.alloc(k),F=I?64:0,x=p&15;if(N.writeUInt8(128|F|x,0),b.byteLength<126)N.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){N.writeUInt8(126,1);let Z=1;N.writeUInt8(b.byteLength>>>8&255,++Z),N.writeUInt8(b.byteLength>>>0&255,++Z)}else{N.writeUInt8(127,1);let Z=1;N.writeUInt8(0,++Z),N.writeUInt8(0,++Z),N.writeUInt8(0,++Z),N.writeUInt8(0,++Z),N.writeUInt8(b.byteLength>>>24&255,++Z),N.writeUInt8(b.byteLength>>>16&255,++Z),N.writeUInt8(b.byteLength>>>8&255,++Z),N.writeUInt8(b.byteLength>>>0&255,++Z)}this.socket.write(_.VSBuffer.concat([N,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const I=this._incomingData.peek(this._state.readLen),p=I.readUInt8(0),k=(p&128)>>>7,N=(p&64)>>>6,F=p&15,x=I.readUInt8(1),Z=(x&128)>>>7,B=x&127;this._state.state=2,this._state.readLen=2+(Z?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=k,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!k,this._state.mask=0,this._state.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const I=this._incomingData.read(this._state.readLen),p=I.readUInt8(1),k=(p&128)>>>7;let N=p&127,F=1;N===126?N=I.readUInt8(++F)*2**8+I.readUInt8(++F):N===127&&(N=I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*0+I.readUInt8(++F)*2**24+I.readUInt8(++F)*2**16+I.readUInt8(++F)*2**8+I.readUInt8(++F));let x=0;k&&(x=I.readUInt8(++F)*2**24+I.readUInt8(++F)*2**16+I.readUInt8(++F)*2**8+I.readUInt8(++F)),this._state.state=3,this._state.readLen=N,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const I=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(I,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class l extends f.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}constructor(b,I,p,k,N,F){super(),this._tracer=b,this._onData=N,this._writeFn=F,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new P.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,I?(this._zlibInflateStream=this._register(new c(this._tracer,k,p,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(b,I){this._writeQueue.push({data:b,options:I}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:b,options:I}=this._writeQueue.shift();if(this._zlibDeflateStream&&I.compressed){const p=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(p,I)}else this._writeFn(b,{...I,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,I){return new Promise((p,k)=>{b.write(I),b.flush(N=>p(N))})}acceptFrame(b,I,p){this._readQueue.push({data:b,isCompressed:I,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const I=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(I)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(b,I,p){return new Promise((k,N)=>{b.write(I),p&&b.write(_.VSBuffer.fromByteArray([0,0,255,255])),b.flush(F=>k(F))})}}class c extends f.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}constructor(b,I,p,k){super(),this._tracer=b,this._recordInflateBytes=I,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,A.createInflateRaw)(k),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(_.VSBuffer.wrap(N))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const I=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(I)})}}class S extends f.Disposable{constructor(b,I){super(),this._tracer=b,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,A.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(_.VSBuffer.wrap(p))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let I=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,I=I.slice(0,I.byteLength-4),b(I)})}}function i(C,b){if(b===0)return;const I=C.byteLength>>>2;for(let Z=0;Z<I;Z++){const B=C.readUInt32BE(Z*4);C.writeUInt32BE(B^b,Z*4)}const p=I*4,k=C.byteLength-p,N=b>>>24&255,F=b>>>16&255,x=b>>>8&255;k>=1&&C.writeUInt8(C.readUInt8(p)^N,p),k>=2&&C.writeUInt8(C.readUInt8(p+1)^F,p+1),k>=3&&C.writeUInt8(C.readUInt8(p+2)^x,p+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const C=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const b=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,O.tmpdir)(),I=(0,D.join)(b,`vscode-ipc-${C}.sock`);return t(I),I}function s(C,b,I){const k=(0,L.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${I}-${b}-sock`;const N=I.substr(0,4),F=b.substr(0,6);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${k}-${N}-${F}.sock`):x=(0,D.join)(C,`${N}-${F}.sock`),t(x),x}function t(C){const b=o[w.platform];typeof b=="number"&&C.length>=b&&console.warn(`WARNING: IPC handle "${C}" is longer than ${b} chars, try a shorter --user-data-dir`)}class r extends h.IPCServer{static toClientConnectionEvent(b){const I=P.Event.fromNodeEventEmitter(b,"connection");return P.Event.map(I,p=>({protocol:new u.Protocol(new y(p,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(p,"close"))}))}constructor(b){super(r.toClientConnectionEvent(b)),this.server=b}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(C){return new Promise((b,I)=>{const p=(0,U.createServer)();p.on("error",I),p.listen(C,()=>{p.removeListener("error",I),b(new r(p))})})}function E(C,b){return new Promise((I,p)=>{const k=(0,U.createConnection)(C,()=>{k.removeListener("error",p),I(u.Client.fromSocket(new y(k,`ipc-client${b}`),b))});k.once("error",p)})}}),define(le[271],ue([0,1,64,123,218]),function(se,e,L,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(A){return!0}connect({host:A,port:_},R,P,f){return new Promise((D,w)=>{const m=L.createConnection({host:A,port:_},()=>{m.removeListener("error",w),m.write((0,O.makeRawSocketHeaders)(R,P,f));const h=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",h),D(new U.NodeSocket(m,f)))};m.on("data",h)});m.setNoDelay(!0),m.once("error",w)})}}}),define(le[272],ue([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function d(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new g(i,o,n,s,t).waitForReady(),!(t&&O.BROWSER_RESTRICTED_PORTS[t]||!O.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));a--);return r}class g extends R.Disposable{constructor(o,n,s,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=o,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const o=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,y.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,O.findFreePortFaster)(o,2,1e3,n),t=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(o){o.pause();const n=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this._socketsDispose.delete(o.localAddress),t instanceof A.NodeSocket?t.socket.destroy():t.end()}),t instanceof A.NodeSocket?this._mirrorNodeSocket(o,t):this._mirrorGenericSocket(o,t),o.localAddress&&this._socketsDispose.set(o.localAddress,()=>{o.end(),t.end()})}_mirrorGenericSocket(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(v.VSBuffer.wrap(s))),o.resume()}_mirrorNodeSocket(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.NodeRemoteTunnel=g;let l=class extends y.AbstractTunnelService{constructor(o,n,s,t,r){super(n,r),this.remoteSocketFactoryService=o,this.signService=s,this.productService=t}isPortPrivileged(o){return(0,y.isPortPrivileged)(o,this.defaultTunnelHost,P.OS,U.release())}retainOrCreateTunnel(o,n,s,t,r,a,E,C){const b=this.getTunnelFromMap(n,s);if(b)return++b.refcount,b.value;if((0,y.isTunnelProvider)(o))return this.createWithProvider(o,n,s,r,a,E,C);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const I={commit:this.productService.commit,quality:this.productService.quality,addressProvider:o,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},p=d(I,t,n,s,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,p),p}}};e.BaseTunnelService=l,e.BaseTunnelService=l=we([K(0,h.IRemoteSocketFactoryService),K(1,D.ILogService),K(2,u.ISignService),K(3,w.IProductService),K(4,f.IConfigurationService)],l);let c=class extends l{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.TunnelService=c,e.TunnelService=c=we([K(0,h.IRemoteSocketFactoryService),K(1,D.ILogService),K(2,u.ISignService),K(3,w.IProductService),K(4,f.IConfigurationService)],c);let S=class extends R.Disposable{constructor(o,n,s,t,r){super(),this.remoteSocketFactoryService=o,this.logService=n,this.productService=s,this.signService=t,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(o,n,s,t,r,a,E,C,b){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this._tunnelServices.has(o)){const I=new c(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(I),this._tunnelServices.set(o,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this._tunnelServices.delete(o))})}return this._tunnelServices.get(o).openTunnel(n,s,t,r,a,E,C,b)}};e.SharedTunnelsService=S,e.SharedTunnelsService=S=we([K(0,h.IRemoteSocketFactoryService),K(1,D.ILogService),K(2,w.IProductService),K(3,u.ISignService),K(4,f.IConfigurationService)],S)}),define(le[280],ue([0,1,37,38,7,2,23,8,17,3,41,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(se,e,L,U,O,A,_,R,P,f,D,w,m,h,u,y,v,d,g,l,c,S,i,o,n,s,t,r,a,E,C,b,I,p,k,N,F,x,Z,B,X,j,G,z,q,ie,ae,te,ce,V,$,T,M,W,J,H,ee,Q,Y,ne,re,he,fe,me,Ee,Ie,Le,Te,de,Se,ye,De,Re,Ne,ke,$e,Me,xe,We,Oe,oe,ge,ve,pe,Ce,Pe,_e,Ue,ze,qe,Fe,Ke,Be,Ze,tt,It,bt,gt,Pt,Dt,Rt,Lt,_t,kt,Tt,At,mt,Ot,St,Ut,Nt,st,Mt,Ft,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class xt extends A.Disposable{constructor(be){super(),this.configuration=be,this.server=this._register(new w.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new f.Emitter),this.registerListeners()}registerListeners(){let be=!1;const Ae=()=>{be||(be=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,w.once)(process.parentPort,st.SharedProcessLifecycle.exit,Ae)}async init(){const be=await this.initServices();(0,Q.registerConfiguration)(),be.invokeFunction(Ae=>{const Ve=Ae.get(G.ILogService),je=Ae.get(V.ITelemetryService),Ye=Ae.get(Pe.IUserDataProfilesService);Ve.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ae),this.registerErrorHandler(Ve),this.reportProfilesInfo(je,Ye),this._register(Ye.onDidChangeProfiles(()=>this.reportProfilesInfo(je,Ye))),this.reportClientOSInfo(je,Ve)}),this._register((0,A.combinedDisposable)(be.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),be.createInstance(h.LanguagePackCachedDataCleaner),be.createInstance(v.UnusedWorkspaceStorageDataCleaner),be.createInstance(y.LogsDataCleaner),be.createInstance(u.LocalizationsUpdater),be.createInstance(tt.ExtensionsContributions),be.createInstance(Ke.UserDataProfilesCleaner)))}async initServices(){const be=new B.ServiceCollection,Ae={_serviceBrand:void 0,...q.default};be.set(ie.IProductService,Ae);const Ve=new D.StaticRouter(Ge=>Ge==="main"),je=new mt.MainProcessService(this.server,Ve);be.set(mt.IMainProcessService,je);const Ye=this.configuration.policiesData?new Ue.PolicyChannelClient(this.configuration.policiesData,je.getChannel("policy")):new ze.NullPolicyService;be.set(ze.IPolicyService,Ye);const He=new Nt.NativeEnvironmentService(this.configuration.args,Ae);be.set(s.INativeEnvironmentService,He);const et=new z.LoggerChannelClient(void 0,this.configuration.logLevel,He.logsHome,this.configuration.loggers.map(Ge=>({...Ge,resource:R.URI.revive(Ge.resource)})),je.getChannel("logger"));be.set(G.ILoggerService,et);const ot=this._register(et.createLogger("sharedprocess",{name:(0,It.localize)(0,null)})),ut=this._register(new G.ConsoleLogger(ot.getLevel())),Je=this._register(new bt.LogService(ot,[ut]));be.set(G.ILogService,Je),this.lifecycleService=this._register(new gt.SharedProcessLifecycleService(Je)),be.set(gt.ISharedProcessLifecycleService,this.lifecycleService);const Xe=this._register(new k.FileService(Je));be.set(p.IFileService,Xe);const ht=this._register(new N.DiskFileSystemProvider(Je));Xe.registerProvider(_.Schemas.file,ht);const at=new xe.UriIdentityService(Xe);be.set(Me.IUriIdentityService,at);const Qe=this._register(new qe.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),je.getChannel("userDataProfiles")));be.set(Pe.IUserDataProfilesService,Qe);const dt=this._register(new Oe.FileUserDataProvider(_.Schemas.file,this._register(new oe.DiskFileSystemProviderClient(je.getChannel(oe.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:We.isLinux})),_.Schemas.vscodeUserData,Qe,at,Je));Xe.registerProvider(_.Schemas.vscodeUserData,dt);const it=this._register(new c.ConfigurationService(Qe.defaultProfile.settingsResource,Xe,Ye,Je));be.set(l.IConfigurationService,it);const ft=new Ot.RemoteStorageService(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},je,He);be.set(te.IStorageService,ft),this._register((0,A.toDisposable)(()=>ft.flush())),await Promise.all([it.initialize(),ft.initialize()]);const yt=new Rt.RequestChannelClient(je.getChannel("request"));be.set(ae.IRequestService,yt),be.set(d.IChecksumService,new F.SyncDescriptor(g.ChecksumService,void 0,!1)),be.set(ve.IV8InspectProfilingService,new F.SyncDescriptor(ge.InspectProfilingService,void 0,!1));const Et=new kt.NativeHostService(-1,je);be.set(_t.INativeHostService,Et),be.set(o.IDownloadService,new F.SyncDescriptor(n.DownloadService,void 0,!0));const Wt=this._register(new Se.ActiveWindowManager(Et)),qt=new D.StaticRouter(Ge=>Wt.getActiveClientId().then(lt=>Ge===lt));be.set(I.IExtensionRecommendationNotificationService,new Lt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",qt)));let ct;const nt=[],wt=(0,W.isInternalTelemetry)(Ae,it);if((0,W.supportsTelemetry)(Ae,He)){const Ge=new T.TelemetryLogAppender(Je,et,He,Ae);if(nt.push(Ge),!(0,W.isLoggingOnly)(Ae,He)&&Ae.aiConfig?.ariaKey){const lt=new Fe.OneDataSystemAppender(yt,wt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>lt.flush())),nt.push(lt)}ct=new M.TelemetryService({appenders:nt,commonProperties:(0,ce.resolveCommonProperties)((0,L.release)(),(0,L.hostname)(),process.arch,Ae.commit,Ae.version,this.configuration.machineId,this.configuration.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,W.getPiiPathsFromEnvironment)(He)},it,Ae)}else{ct=W.NullTelemetryService;const Ge=W.NullAppender;nt.push(Ge)}this.server.registerChannel("telemetryAppender",new $.TelemetryAppenderChannel(nt)),be.set(V.ITelemetryService,ct);const jt=new J.CustomEndpointTelemetryService(it,ct,Je,et,He,Ae);be.set(V.ICustomEndpointTelemetryService,jt),be.set(_e.IExtensionsProfileScannerService,new F.SyncDescriptor(Dt.ExtensionsProfileScannerService,void 0,!0)),be.set(pe.IExtensionsScannerService,new F.SyncDescriptor(Ce.ExtensionsScannerService,void 0,!0)),be.set(E.IExtensionSignatureVerificationService,new F.SyncDescriptor(E.ExtensionSignatureVerificationService,void 0,!0)),be.set(b.INativeServerExtensionManagementService,new F.SyncDescriptor(b.ExtensionManagementService,void 0,!0)),be.set(a.IExtensionGalleryService,new F.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),be.set(a.IExtensionTipsService,new F.SyncDescriptor(At.ExtensionTipsService,void 0,!1)),be.set(X.ILanguagePackService,new F.SyncDescriptor(j.NativeLanguagePackService,void 0,!1)),be.set(S.IDiagnosticsService,new F.SyncDescriptor(i.DiagnosticsService,void 0,!1)),be.set(Y.IUserDataSyncAccountService,new F.SyncDescriptor(Y.UserDataSyncAccountService,void 0,!0)),be.set(Q.IUserDataSyncLogService,new F.SyncDescriptor(he.UserDataSyncLogService,void 0,!0)),be.set(Q.IUserDataSyncUtilService,D.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),be.set(a.IGlobalExtensionEnablementService,new F.SyncDescriptor(t.GlobalExtensionEnablementService,void 0,!1)),be.set(ee.IIgnoredExtensionsManagementService,new F.SyncDescriptor(ee.IgnoredExtensionsManagementService,void 0,!0)),be.set(H.IExtensionStorageService,new F.SyncDescriptor(H.ExtensionStorageService)),be.set(Q.IUserDataSyncStoreManagementService,new F.SyncDescriptor(Le.UserDataSyncStoreManagementService,void 0,!0)),be.set(Q.IUserDataSyncStoreService,new F.SyncDescriptor(Le.UserDataSyncStoreService,void 0,!0)),be.set(fe.IUserDataSyncMachinesService,new F.SyncDescriptor(fe.UserDataSyncMachinesService,void 0,!0)),be.set(Q.IUserDataSyncLocalStoreService,new F.SyncDescriptor(ne.UserDataSyncLocalStoreService,void 0,!1)),be.set(Q.IUserDataSyncEnablementService,new F.SyncDescriptor(me.UserDataSyncEnablementService,void 0,!0)),be.set(Q.IUserDataSyncService,new F.SyncDescriptor(Ee.UserDataSyncService,void 0,!1)),be.set(Te.IUserDataProfileStorageService,new F.SyncDescriptor(de.NativeUserDataProfileStorageService,void 0,!0)),be.set(Q.IUserDataSyncResourceProviderService,new F.SyncDescriptor(Ze.UserDataSyncResourceProviderService,void 0,!0)),be.set(ye.ISignService,new F.SyncDescriptor(De.SignService,void 0,!1));const Ct=new St.RemoteSocketFactoryService;return be.set(St.IRemoteSocketFactoryService,Ct),Ct.register(0,Ut.nodeSocketFactory),be.set(Re.ISharedTunnelsService,new F.SyncDescriptor(Ne.SharedTunnelsService)),be.set(ke.ISharedProcessTunnelService,new F.SyncDescriptor($e.SharedProcessTunnelService)),be.set(Be.IRemoteTunnelService,new F.SyncDescriptor(Pt.RemoteTunnelService)),new Z.InstantiationService(be)}initChannels(be){const Ae=new C.ExtensionManagementChannel(be.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ae);const Ve=D.ProxyChannel.fromService(be.get(X.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",Ve);const je=D.ProxyChannel.fromService(be.get(S.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",je);const Ye=new C.ExtensionTipsChannel(be.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ye);const He=D.ProxyChannel.fromService(be.get(d.IChecksumService),this._store);this.server.registerChannel("checksum",He);const et=D.ProxyChannel.fromService(be.get(ve.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",et);const ot=D.ProxyChannel.fromService(be.get(fe.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",ot);const ut=D.ProxyChannel.fromService(be.get(V.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",ut);const Je=new re.UserDataSyncAccountServiceChannel(be.get(Y.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new re.UserDataSyncStoreManagementServiceChannel(be.get(Q.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ht=new Ie.UserDataSyncServiceChannel(be.get(Q.IUserDataSyncService),be.get(Pe.IUserDataProfilesService),be.get(G.ILogService));this.server.registerChannel("userDataSync",ht);const at=this._register(be.get(x.IInstantiationService).createInstance(Tt.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",D.ProxyChannel.fromService(at,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",D.ProxyChannel.fromService(be.get(Q.IUserDataSyncResourceProviderService),this._store));const Qe=D.ProxyChannel.fromService(be.get(ke.ISharedProcessTunnelService),this._store);this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,Qe);const dt=D.ProxyChannel.fromService(be.get(Be.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",dt)}registerErrorHandler(be){process.on("uncaughtException",Ae=>(0,O.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,O.onUnexpectedError)(Ae)),(0,O.setUnexpectedErrorHandler)(Ae=>{const Ve=(0,U.toErrorMessage)(Ae,!0);Ve&&be.error(`[uncaught exception in sharedProcess]: ${Ve}`)})}reportProfilesInfo(be,Ae){be.publicLog2("profilesInfo",{count:Ae.profiles.length})}async reportClientOSInfo(be,Ae){if(We.isLinux){const[Ve,je]=await Promise.all([(0,Mt.getOSReleaseInfo)(Ae.error.bind(Ae)),(0,vt.getDisplayProtocol)(Ae.error.bind(Ae))]),Ye=(0,Ft.getDesktopEnvironment)(),He=(0,vt.getCodeDisplayProtocol)(je,this.configuration.args["ozone-platform"]);Ve&&be.publicLog2("clientPlatformInfo",{platformId:Ve.id,platformVersionId:Ve.version_id,platformIdLike:Ve.id_like,desktopEnvironment:Ye,displayProtocol:je,codeDisplayProtocol:He})}}handledClientConnection(be){if(be.data!==st.SharedProcessRawConnection.response)return!1;const Ae=(0,P.firstOrDefault)(be.ports);return Ae?(this.onDidWindowConnectRaw.fire(Ae),!0):!1}}async function pt(rt){try{const be=new xt(rt);process.parentPort.postMessage(st.SharedProcessLifecycle.ipcReady),await be.init(),process.parentPort.postMessage(st.SharedProcessLifecycle.initDone)}catch(be){process.parentPort.postMessage({error:be.toString()})}}const $t=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout($t),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
