/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],de=function(le){for(var e=[],y=0,k=le.length;y<k;y++)e[y]=he[le[y]];return e};define(he[40],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=y,e.findLastIdx=k,e.findLastMonotonous=C,e.findLastIdxMonotonous=I,e.findFirstMonotonous=M,e.findFirstIdxMonotonousOrArrLen=w,e.findFirstIdxMonotonous=h,e.findFirstMaxBy=S,e.findLastMaxBy=p,e.findFirstMinBy=b,e.findMaxIdxBy=u,e.mapFindFirst=l;function y(g,s,i){const o=k(g,s);if(o!==-1)return g[o]}function k(g,s,i=g.length-1){for(let o=i;o>=0;o--){const f=g[o];if(s(f))return o}return-1}function C(g,s){const i=I(g,s);return i===-1?void 0:g[i]}function I(g,s,i=0,o=g.length){let f=i,r=o;for(;f<r;){const t=Math.floor((f+r)/2);s(g[t])?f=t+1:r=t}return f-1}function M(g,s){const i=w(g,s);return i===g.length?void 0:g[i]}function w(g,s,i=0,o=g.length){let f=i,r=o;for(;f<r;){const t=Math.floor((f+r)/2);s(g[t])?r=t:f=t+1}return f}function h(g,s,i=0,o=g.length){const f=w(g,s,i,o);return f===g.length?-1:f}class c{static{this.assertInvariants=!1}constructor(s){this._array=s,this._findLastMonotonousLastIdx=0}findLastMonotonous(s){if(c.assertInvariants){if(this._prevFindLastPredicate){for(const o of this._array)if(this._prevFindLastPredicate(o)&&!s(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=s}const i=I(this._array,s,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=i+1,i===-1?void 0:this._array[i]}}e.MonotonousArray=c;function S(g,s){if(g.length===0)return;let i=g[0];for(let o=1;o<g.length;o++){const f=g[o];s(f,i)>0&&(i=f)}return i}function p(g,s){if(g.length===0)return;let i=g[0];for(let o=1;o<g.length;o++){const f=g[o];s(f,i)>=0&&(i=f)}return i}function b(g,s){return S(g,(i,o)=>-s(i,o))}function u(g,s){if(g.length===0)return-1;let i=0;for(let o=1;o<g.length;o++){const f=g[o];s(f,g[i])>0&&(i=o)}return i}function l(g,s){for(const i of g){const o=s(i);if(o!==void 0)return o}}}),define(he[41],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=y,e.diffSets=k,e.diffMaps=C,e.intersection=I;function y(M,w){const h=Object.create(null);for(const c of M){const S=w(c);let p=h[S];p||(p=h[S]=[]),p.push(c)}return h}function k(M,w){const h=[],c=[];for(const S of M)w.has(S)||h.push(S);for(const S of w)M.has(S)||c.push(S);return{removed:h,added:c}}function C(M,w){const h=[],c=[];for(const[S,p]of M)w.has(S)||h.push(p);for(const[S,p]of w)M.has(S)||c.push(p);return{removed:h,added:c}}function I(M,w){const h=new Set;for(const c of w)M.has(c)&&h.add(c);return h}}),define(he[14],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=k,e.debounce=C,e.throttle=I;function y(M){return(w,h,c)=>{let S=null,p=null;if(typeof c.value=="function"?(S="value",p=c.value):typeof c.get=="function"&&(S="get",p=c.get),!p)throw new Error("not supported");c[S]=M(p,h)}}function k(M,w,h){let c=null,S=null;if(typeof h.value=="function"?(c="value",S=h.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",S=h.get),!S)throw new Error("not supported");const p=`$memoize$${w}`;h[c]=function(...b){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,b)}),this[p]}}function C(M,w,h){return y((c,S)=>{const p=`$debounce$${S}`,b=`$debounce$result$${S}`;return function(...u){this[b]||(this[b]=h?h():void 0),clearTimeout(this[p]),w&&(this[b]=w(this[b],...u),u=[this[b]]),this[p]=setTimeout(()=>{c.apply(this,u),this[b]=h?h():void 0},M)}})}function I(M,w,h){return y((c,S)=>{const p=`$throttle$timer$${S}`,b=`$throttle$result$${S}`,u=`$throttle$lastRun$${S}`,l=`$throttle$pending$${S}`;return function(...g){if(this[b]||(this[b]=h?h():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),w&&(this[b]=w(this[b],...g)),this[l])return;const s=this[u]+M;s<=Date.now()?(this[u]=Date.now(),c.apply(this,[this[b]]),this[b]=h?h():void 0):(this[l]=!0,this[p]=setTimeout(()=>{this[l]=!1,this[u]=Date.now(),c.apply(this,[this[b]]),this[b]=h?h():void 0},s-Date.now()))}})}}),define(he[7],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=k,e.isSigPipeError=C,e.onUnexpectedError=I,e.onUnexpectedExternalError=M,e.transformErrorForSerialization=w,e.isCancellationError=c,e.canceled=p,e.illegalArgument=b,e.illegalState=u,e.getErrorMessage=g;class y{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?f.isErrorNoTelemetry(n)?new f(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(_=>{_(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=y,e.errorHandler=new y;function k(t){e.errorHandler.setUnexpectedErrorHandler(t)}function C(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function I(t){c(t)||e.errorHandler.onUnexpectedError(t)}function M(t){c(t)||e.errorHandler.onUnexpectedExternalError(t)}function w(t){if(t instanceof Error){const{name:n,message:_}=t,O=t.stacktrace||t.stack;return{$isError:!0,name:n,message:_,stack:O,noTelemetry:f.isErrorNoTelemetry(t)}}return t}const h="Canceled";function c(t){return t instanceof S?!0:t instanceof Error&&t.name===h&&t.message===h}class S extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=S;function p(){const t=new Error(h);return t.name=t.message,t}function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}class l extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=l;function g(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}class s extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=s;class i extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=i;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=o;class f extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof f)return n;const _=new f;return _.message=n.message,_.stack=n.stack,_}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class r extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.BugIndicatingError=r}),define(he[16],de([0,1,7,40]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=C,e.tail2=I,e.equals=M,e.removeFastWithoutKeepingOrder=w,e.binarySearch=h,e.binarySearch2=c,e.quickSelect=S,e.groupBy=p,e.groupAdjacentBy=b,e.forEachAdjacent=u,e.forEachWithNeighbors=l,e.sortedDiff=g,e.delta=s,e.top=i,e.topAsync=o,e.coalesce=r,e.coalesceInPlace=t,e.move=n,e.isFalsyOrEmpty=_,e.isNonEmptyArray=O,e.distinct=m,e.uniqueFilter=E,e.firstOrDefault=v,e.lastOrDefault=A,e.commonPrefixLength=W,e.flatten=Y,e.range=N,e.index=D,e.insert=a,e.remove=L,e.arrayInsert=P,e.shuffle=T,e.pushToStart=J,e.pushToEnd=re,e.pushMany=x,e.mapArrayOrNot=te,e.asArray=ce,e.getRandomElement=me,e.insertInto=G,e.splice=q,e.compareBy=$,e.tieBreakComparators=ee,e.reverseOrder=d;function C(H,j=0){return H[H.length-(1+j)]}function I(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function M(H,j,F=(R,B)=>R===B){if(H===j)return!0;if(!H||!j||H.length!==j.length)return!1;for(let R=0,B=H.length;R<B;R++)if(!F(H[R],j[R]))return!1;return!0}function w(H,j){const F=H.length-1;j<F&&(H[j]=H[F]),H.pop()}function h(H,j,F){return c(H.length,R=>F(H[R],j))}function c(H,j){let F=0,R=H-1;for(;F<=R;){const B=(F+R)/2|0,V=j(B);if(V<0)F=B+1;else if(V>0)R=B-1;else return B}return-(F+1)}function S(H,j,F){if(H=H|0,H>=j.length)throw new TypeError("invalid index");const R=j[Math.floor(j.length*Math.random())],B=[],V=[],K=[];for(const oe of j){const ue=F(oe,R);ue<0?B.push(oe):ue>0?V.push(oe):K.push(oe)}return H<B.length?S(H,B,F):H<B.length+K.length?K[0]:S(H-(B.length+K.length),V,F)}function p(H,j){const F=[];let R;for(const B of H.slice(0).sort(j))!R||j(R[0],B)!==0?(R=[B],F.push(R)):R.push(B);return F}function*b(H,j){let F,R;for(const B of H)R!==void 0&&j(R,B)?F.push(B):(F&&(yield F),F=[B]),R=B;F&&(yield F)}function u(H,j){for(let F=0;F<=H.length;F++)j(F===0?void 0:H[F-1],F===H.length?void 0:H[F])}function l(H,j){for(let F=0;F<H.length;F++)j(F===0?void 0:H[F-1],H[F],F+1===H.length?void 0:H[F+1])}function g(H,j,F){const R=[];function B(oe,ue,pe){if(ue===0&&pe.length===0)return;const ve=R[R.length-1];ve&&ve.start+ve.deleteCount===oe?(ve.deleteCount+=ue,ve.toInsert.push(...pe)):R.push({start:oe,deleteCount:ue,toInsert:pe})}let V=0,K=0;for(;;){if(V===H.length){B(V,0,j.slice(K));break}if(K===j.length){B(V,H.length-V,[]);break}const oe=H[V],ue=j[K],pe=F(oe,ue);pe===0?(V+=1,K+=1):pe<0?(B(V,1,[]),V+=1):pe>0&&(B(V,0,[ue]),K+=1)}return R}function s(H,j,F){const R=g(H,j,F),B=[],V=[];for(const K of R)B.push(...H.slice(K.start,K.start+K.deleteCount)),V.push(...K.toInsert);return{removed:B,added:V}}function i(H,j,F){if(F===0)return[];const R=H.slice(0,F).sort(j);return f(H,j,R,F,H.length),R}function o(H,j,F,R,B){return F===0?Promise.resolve([]):new Promise((V,K)=>{(async()=>{const oe=H.length,ue=H.slice(0,F).sort(j);for(let pe=F,ve=Math.min(F+R,oe);pe<oe;pe=ve,ve=Math.min(ve+R,oe)){if(pe>F&&await new Promise(Ce=>setTimeout(Ce)),B&&B.isCancellationRequested)throw new y.CancellationError;f(H,j,ue,pe,ve)}return ue})().then(V,K)})}function f(H,j,F,R,B){for(const V=F.length;R<B;R++){const K=H[R];if(j(K,F[V-1])<0){F.pop();const oe=(0,k.findFirstIdxMonotonousOrArrLen)(F,ue=>j(K,ue)<0);F.splice(oe,0,K)}}}function r(H){return H.filter(j=>!!j)}function t(H){let j=0;for(let F=0;F<H.length;F++)H[F]&&(H[j]=H[F],j+=1);H.length=j}function n(H,j,F){H.splice(F,0,H.splice(j,1)[0])}function _(H){return!Array.isArray(H)||H.length===0}function O(H){return Array.isArray(H)&&H.length>0}function m(H,j=F=>F){const F=new Set;return H.filter(R=>{const B=j(R);return F.has(B)?!1:(F.add(B),!0)})}function E(H){const j=new Set;return F=>{const R=H(F);return j.has(R)?!1:(j.add(R),!0)}}function v(H,j){return H.length>0?H[0]:j}function A(H,j){return H.length>0?H[H.length-1]:j}function W(H,j,F=(R,B)=>R===B){let R=0;for(let B=0,V=Math.min(H.length,j.length);B<V&&F(H[B],j[B]);B++)R++;return R}function Y(H){return[].concat(...H)}function N(H,j){let F=typeof j=="number"?H:0;typeof j=="number"?F=H:(F=0,j=H);const R=[];if(F<=j)for(let B=F;B<j;B++)R.push(B);else for(let B=F;B>j;B--)R.push(B);return R}function D(H,j,F){return H.reduce((R,B)=>(R[j(B)]=F?F(B):B,R),Object.create(null))}function a(H,j){return H.push(j),()=>L(H,j)}function L(H,j){const F=H.indexOf(j);if(F>-1)return H.splice(F,1),j}function P(H,j,F){const R=H.slice(0,j),B=H.slice(j);return R.concat(F,B)}function T(H,j){let F;if(typeof j=="number"){let R=j;F=()=>{const B=Math.sin(R++)*179426549;return B-Math.floor(B)}}else F=Math.random;for(let R=H.length-1;R>0;R-=1){const B=Math.floor(F()*(R+1)),V=H[R];H[R]=H[B],H[B]=V}}function J(H,j){const F=H.indexOf(j);F>-1&&(H.splice(F,1),H.unshift(j))}function re(H,j){const F=H.indexOf(j);F>-1&&(H.splice(F,1),H.push(j))}function x(H,j){for(const F of j)H.push(F)}function te(H,j){return Array.isArray(H)?H.map(j):j(H)}function ce(H){return Array.isArray(H)?H:[H]}function me(H){return H[Math.floor(Math.random()*H.length)]}function G(H,j,F){const R=Q(H,j),B=H.length,V=F.length;H.length=B+V;for(let K=B-1;K>=R;K--)H[K+V]=H[K];for(let K=0;K<V;K++)H[K+R]=F[K]}function q(H,j,F,R){const B=Q(H,j);let V=H.splice(B,F);return V===void 0&&(V=[]),G(H,B,R),V}function Q(H,j){return j<0?Math.max(j+H.length,0):Math.min(j,H.length)}var ie;(function(H){function j(V){return V<0}H.isLessThan=j;function F(V){return V<=0}H.isLessThanOrEqual=F;function R(V){return V>0}H.isGreaterThan=R;function B(V){return V===0}H.isNeitherLessOrGreaterThan=B,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function $(H,j){return(F,R)=>j(H(F),H(R))}function ee(...H){return(j,F)=>{for(const R of H){const B=R(j,F);if(!ie.isNeitherLessOrGreaterThan(B))return B}return ie.neitherLessOrGreaterThan}}const ge=(H,j)=>H-j;e.numberComparator=ge;const Z=(H,j)=>(0,e.numberComparator)(H?1:0,j?1:0);e.booleanComparator=Z;function d(H){return(j,F)=>-H(j,F)}class z{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let F=this.firstIdx;for(;F<this.items.length&&j(this.items[F]);)F++;const R=F===this.firstIdx?null:this.items.slice(this.firstIdx,F);return this.firstIdx=F,R}takeFromEndWhile(j){let F=this.lastIdx;for(;F>=0&&j(this.items[F]);)F--;const R=F===this.lastIdx?null:this.items.slice(F+1,this.lastIdx+1);return this.lastIdx=F,R}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}removeLast(){const j=this.items[this.lastIdx];return this.lastIdx--,j}takeCount(j){const F=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,F}}e.ArrayQueue=z;class ne{static{this.empty=new ne(j=>{})}constructor(j){this.iterate=j}forEach(j){this.iterate(F=>(j(F),!0))}toArray(){const j=[];return this.iterate(F=>(j.push(F),!0)),j}filter(j){return new ne(F=>this.iterate(R=>j(R)?F(R):!0))}map(j){return new ne(F=>this.iterate(R=>F(j(R))))}some(j){let F=!1;return this.iterate(R=>(F=j(R),!F)),F}findFirst(j){let F;return this.iterate(R=>j(R)?(F=R,!1):!0),F}findLast(j){let F;return this.iterate(R=>(j(R)&&(F=R),!0)),F}findLastMaxBy(j){let F,R=!0;return this.iterate(B=>((R||ie.isGreaterThan(j(B,F)))&&(R=!1,F=B),!0)),F}}e.CallbackIterable=ne;class se{constructor(j){this._indexMap=j}static createSortPermutation(j,F){const R=Array.from(j.keys()).sort((B,V)=>F(j[B],j[V]));return new se(R)}apply(j){return j.map((F,R)=>j[this._indexMap[R]])}inverse(){const j=this._indexMap.slice();for(let F=0;F<this._indexMap.length;F++)j[this._indexMap[F]]=F;return new se(j)}}e.Permutation=se}),define(he[42],de([0,1,7]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=k,e.assertNever=C,e.assert=I,e.softAssert=M,e.assertFn=w,e.checkAdjacentItems=h;function k(c,S){if(!c)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function C(c,S="Unreachable"){throw new Error(S)}function I(c){if(!c)throw new y.BugIndicatingError("Assertion Failed")}function M(c){c||(0,y.onUnexpectedError)(new y.BugIndicatingError("Soft Assertion Failed"))}function w(c){if(!c()){debugger;c(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}function h(c,S){let p=0;for(;p<c.length-1;){const b=c[p],u=c[p+1];if(!S(b,u))return!1;p++}return!0}}),define(he[29],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=y;function y(k,C){const I=this;let M=!1,w;return function(){if(M)return w;if(M=!0,C)try{w=k.apply(I,arguments)}finally{C()}else w=k.apply(I,arguments);return w}}}),define(he[43],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(k){function C(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}k.is=C;const I=Object.freeze([]);function M(){return I}k.empty=M;function*w(n){yield n}k.single=w;function h(n){return C(n)?n:w(n)}k.wrap=h;function c(n){return n||I}k.from=c;function*S(n){for(let _=n.length-1;_>=0;_--)yield n[_]}k.reverse=S;function p(n){return!n||n[Symbol.iterator]().next().done===!0}k.isEmpty=p;function b(n){return n[Symbol.iterator]().next().value}k.first=b;function u(n,_){for(const O of n)if(_(O))return!0;return!1}k.some=u;function l(n,_){for(const O of n)if(_(O))return O}k.find=l;function*g(n,_){for(const O of n)_(O)&&(yield O)}k.filter=g;function*s(n,_){let O=0;for(const m of n)yield _(m,O++)}k.map=s;function*i(...n){for(const _ of n)yield*_}k.concat=i;function o(n,_,O){let m=O;for(const E of n)m=_(m,E);return m}k.reduce=o;function*f(n,_,O=n.length){for(_<0&&(_+=n.length),O<0?O+=n.length:O>n.length&&(O=n.length);_<O;_++)yield n[_]}k.slice=f;function r(n,_=Number.POSITIVE_INFINITY){const O=[];if(_===0)return[O,n];const m=n[Symbol.iterator]();for(let E=0;E<_;E++){const v=m.next();if(v.done)return[O,k.empty()];O.push(v.value)}return[O,{[Symbol.iterator](){return m}}]}k.consume=r;async function t(n){const _=[];for await(const O of n)_.push(O);return Promise.resolve(_)}k.asyncToArray=t})(y||(e.Iterable=y={}))}),define(he[22],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(C){this.executor=C,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=y}),define(he[44],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{static{this.Undefined=new y(void 0)}constructor(I){this.element=I,this.next=y.Undefined,this.prev=y.Undefined}}class k{constructor(){this._first=y.Undefined,this._last=y.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===y.Undefined}clear(){let I=this._first;for(;I!==y.Undefined;){const M=I.next;I.prev=y.Undefined,I.next=y.Undefined,I=M}this._first=y.Undefined,this._last=y.Undefined,this._size=0}unshift(I){return this._insert(I,!1)}push(I){return this._insert(I,!0)}_insert(I,M){const w=new y(I);if(this._first===y.Undefined)this._first=w,this._last=w;else if(M){const c=this._last;this._last=w,w.prev=c,c.next=w}else{const c=this._first;this._first=w,w.next=c,c.prev=w}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(w))}}shift(){if(this._first!==y.Undefined){const I=this._first.element;return this._remove(this._first),I}}pop(){if(this._last!==y.Undefined){const I=this._last.element;return this._remove(this._last),I}}_remove(I){if(I.prev!==y.Undefined&&I.next!==y.Undefined){const M=I.prev;M.next=I.next,I.next.prev=M}else I.prev===y.Undefined&&I.next===y.Undefined?(this._first=y.Undefined,this._last=y.Undefined):I.next===y.Undefined?(this._last=this._last.prev,this._last.next=y.Undefined):I.prev===y.Undefined&&(this._first=this._first.next,this._first.prev=y.Undefined);this._size-=1}*[Symbol.iterator](){let I=this._first;for(;I!==y.Undefined;)yield I.element,I=I.next}}e.LinkedList=k}),define(he[25],de([0,1]),function(le,e){"use strict";var y,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=I,e.mapToString=M,e.setToString=w,e.mapsStrictEqualIgnoreOrder=o;function I(f,r,t){let n=f.get(r);return n===void 0&&(n=t,f.set(r,n)),n}function M(f){const r=[];return f.forEach((t,n)=>{r.push(`${n} => ${t}`)}),`Map(${f.size}) {${r.join(", ")}}`}function w(f){const r=[];return f.forEach(t=>{r.push(t)}),`Set(${f.size}) {${r.join(", ")}}`}class h{constructor(r,t){this.uri=r,this.value=t}}function c(f){return Array.isArray(f)}class S{static{this.defaultToKey=r=>r.toString()}constructor(r,t){if(this[y]="ResourceMap",r instanceof S)this.map=new Map(r.map),this.toKey=t??S.defaultToKey;else if(c(r)){this.map=new Map,this.toKey=t??S.defaultToKey;for(const[n,_]of r)this.set(n,_)}else this.map=new Map,this.toKey=r??S.defaultToKey}set(r,t){return this.map.set(this.toKey(r),new h(r,t)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,t){typeof t<"u"&&(r=r.bind(t));for(const[n,_]of this.map)r(_.value,_.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=S;class p{constructor(r,t){this[k]="ResourceSet",!r||typeof r=="function"?this._map=new S(r):(this._map=new S(t),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,t){this._map.forEach((n,_)=>r.call(t,_,_,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var b;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class u{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,t=0){const n=this._map.get(r);if(n)return t!==0&&this.touch(n,t),n.value}set(r,t,n=0){let _=this._map.get(r);if(_)_.value=t,n!==0&&this.touch(_,n);else{switch(_={key:r,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(_);break;case 1:this.addItemFirst(_);break;case 2:this.addItemLast(_);break;default:this.addItemLast(_);break}this._map.set(r,_),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const t=this._map.get(r);if(t)return this._map.delete(r),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,t){const n=this._state;let _=this._head;for(;_;){if(t?r.bind(t)(_.value,_.key,this):r(_.value,_.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const r=this,t=this._state;let n=this._head;const _={[Symbol.iterator](){return _},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const O={value:n.key,done:!1};return n=n.next,O}else return{value:void 0,done:!0}}};return _}values(){const r=this,t=this._state;let n=this._head;const _={[Symbol.iterator](){return _},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const O={value:n.value,done:!1};return n=n.next,O}else return{value:void 0,done:!0}}};return _}entries(){const r=this,t=this._state;let n=this._head;const _={[Symbol.iterator](){return _},next(){if(r._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const O={value:[n.key,n.value],done:!1};return n=n.next,O}else return{value:void 0,done:!0}}};return _}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let t=this._head,n=this.size;for(;t&&n>r;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const t=r.next,n=r.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}r.next=void 0,r.previous=void 0,this._state++}touch(r,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(r===this._head)return;const n=r.next,_=r.previous;r===this._tail?(_.next=void 0,this._tail=_):(n.previous=_,_.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(t===2){if(r===this._tail)return;const n=r.next,_=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=_,_.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((t,n)=>{r.push([n,t])}),r}fromJSON(r){this.clear();for(const[t,n]of r)this.set(t,n)}}e.LinkedMap=u;class l extends u{constructor(r,t=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,t=2){return super.get(r,t)}peek(r){return super.get(r,0)}set(r,t){return super.set(r,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class g{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let t=this.map.get(r)||0;return t===0?!1:(t--,t===0?this.map.delete(r):this.map.set(r,t),!0)}has(r){return this.map.has(r)}}e.CounterSet=g;class s{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[t,n]of r)this.set(t,n)}clear(){this._m1.clear(),this._m2.clear()}set(r,t){this._m1.set(r,t),this._m2.set(t,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const t=this._m1.get(r);return t===void 0?!1:(this._m1.delete(r),this._m2.delete(t),!0)}forEach(r,t){this._m1.forEach((n,_)=>{r.call(t,n,_,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=s;class i{constructor(){this.map=new Map}add(r,t){let n=this.map.get(r);n||(n=new Set,this.map.set(r,n)),n.add(t)}delete(r,t){const n=this.map.get(r);n&&(n.delete(t),n.size===0&&this.map.delete(r))}forEach(r,t){const n=this.map.get(r);n&&n.forEach(t)}get(r){const t=this.map.get(r);return t||new Set}}e.SetMap=i;function o(f,r){if(f===r)return!0;if(f.size!==r.size)return!1;for(const[t,n]of f)if(!r.has(t)||r.get(t)!==n)return!1;for(const[t]of r)if(!f.has(t))return!1;return!0}}),define(he[2],de([0,1,16,41,25,29,43]),function(le,e,y,k,C,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=S,e.trackDisposable=p,e.markAsDisposed=b,e.markAsSingleton=g,e.isDisposable=s,e.dispose=i,e.disposeIfDisposable=o,e.combinedDisposable=f,e.toDisposable=r,e.disposeOnReturn=Y;const w=!1;let h=null;class c{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(a){let L=this.livingDisposables.get(a);return L||(L={parent:null,source:null,isSingleton:!1,value:a,idx:c.idx++},this.livingDisposables.set(a,L)),L}trackDisposable(a){const L=this.getDisposableData(a);L.source||(L.source=new Error().stack)}setParent(a,L){const P=this.getDisposableData(a);P.parent=L}markAsDisposed(a){this.livingDisposables.delete(a)}markAsSingleton(a){this.getDisposableData(a).isSingleton=!0}getRootParent(a,L){const P=L.get(a);if(P)return P;const T=a.parent?this.getRootParent(this.getDisposableData(a.parent),L):a;return L.set(a,T),T}getTrackedDisposables(){const a=new Map;return[...this.livingDisposables.entries()].filter(([,P])=>P.source!==null&&!this.getRootParent(P,a).isSingleton).flatMap(([P])=>P)}computeLeakingDisposables(a=10,L){let P;if(L)P=L;else{const te=new Map,ce=[...this.livingDisposables.values()].filter(G=>G.source!==null&&!this.getRootParent(G,te).isSingleton);if(ce.length===0)return;const me=new Set(ce.map(G=>G.value));if(P=ce.filter(G=>!(G.parent&&me.has(G.parent))),P.length===0)throw new Error("There are cyclic diposable chains!")}if(!P)return;function T(te){function ce(G,q){for(;G.length>0&&q.some(Q=>typeof Q=="string"?Q===G[0]:G[0].match(Q));)G.shift()}const me=te.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return ce(me,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),me.reverse()}const J=new C.SetMap;for(const te of P){const ce=T(te);for(let me=0;me<=ce.length;me++)J.add(ce.slice(0,me).join(`
`),te)}P.sort((0,y.compareBy)(te=>te.idx,y.numberComparator));let re="",x=0;for(const te of P.slice(0,a)){x++;const ce=T(te),me=[];for(let G=0;G<ce.length;G++){let q=ce[G];q=`(shared with ${J.get(ce.slice(0,G+1).join(`
`)).size}/${P.length} leaks) at ${q}`;const ie=J.get(ce.slice(0,G).join(`
`)),$=(0,k.groupBy)([...ie].map(ee=>T(ee)[G]),ee=>ee);delete $[ce[G]];for(const[ee,ge]of Object.entries($))me.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${ee}`);me.unshift(q)}re+=`


==================== Leaking disposable ${x}/${P.length}: ${te.value.constructor.name} ====================
${me.join(`
`)}
============================================================

`}return P.length>a&&(re+=`


... and ${P.length-a} more leaking disposables

`),{leaks:P,details:re}}}e.DisposableTracker=c;function S(D){h=D}if(w){const D="__is_disposable_tracked__";S(new class{trackDisposable(a){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[D]||console.log(L)},3e3)}setParent(a,L){if(a&&a!==n.None)try{a[D]=!0}catch{}}markAsDisposed(a){if(a&&a!==n.None)try{a[D]=!0}catch{}}markAsSingleton(a){}})}function p(D){return h?.trackDisposable(D),D}function b(D){h?.markAsDisposed(D)}function u(D,a){h?.setParent(D,a)}function l(D,a){if(h)for(const L of D)h.setParent(L,a)}function g(D){return h?.markAsSingleton(D),D}function s(D){return typeof D.dispose=="function"&&D.dispose.length===0}function i(D){if(M.Iterable.is(D)){const a=[];for(const L of D)if(L)try{L.dispose()}catch(P){a.push(P)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function o(D){for(const a of D)s(a)&&a.dispose();return[]}function f(...D){const a=r(()=>i(D));return l(D,a),a}function r(D){const a=p({dispose:(0,I.createSingleCallFunction)(()=>{b(a),D()})});return a}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,p(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{i(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return u(a,this),this._isDisposed?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}delete(a){if(a){if(a===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(a),a.dispose()}}deleteAndLeak(a){a&&this._toDispose.has(a)&&(this._toDispose.delete(a),u(a,null))}}e.DisposableStore=t;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new t,p(this),u(this._store,this)}dispose(){b(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=n;class _{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&u(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&u(a,null),a}}e.MutableDisposable=_;class O{constructor(a){this._disposable=new _,this._isDisposed=!1,this._disposable.value=a}get value(){return this._disposable.value}set value(a){this._isDisposed||a===this._disposable.value||(this._disposable.value=a)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=O;class m{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=m;class E{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(a){let L=a;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,b(this))},this}}e.SafeDisposable=E;class v{constructor(){this.references=new Map}acquire(a,...L){let P=this.references.get(a);P||(P={counter:0,object:this.createReferencedObject(a,...L)},this.references.set(a,P));const{object:T}=P,J=(0,I.createSingleCallFunction)(()=>{--P.counter===0&&(this.destroyReferencedObject(a,P.object),this.references.delete(a))});return P.counter++,{object:T,dispose:J}}}e.ReferenceCollection=v;class A{constructor(a){this.referenceCollection=a}async acquire(a,...L){const P=this.referenceCollection.acquire(a,...L);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(T){throw P.dispose(),T}}}e.AsyncReferenceCollection=A;class W{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=W;function Y(D){const a=new t;try{D(a)}finally{a.dispose()}}class N{constructor(){this._store=new Map,this._isDisposed=!1,p(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{i(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get size(){return this._store.size}get(a){return this._store.get(a)}set(a,L,P=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this._store.get(a)?.dispose(),this._store.set(a,L)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=N}),define(he[45],de([0,1,25]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=C,e.normalizeNFD=M;const k=new y.LRUCache(1e4);function C(c){return h(c,"NFC",k)}const I=new y.LRUCache(1e4);function M(c){return h(c,"NFD",I)}const w=/[^\u0000-\u0080]/;function h(c,S,p){if(!c)return c;const b=p.get(c);if(b)return b;let u;return w.test(c)?u=c.normalize(S):u=c,p.set(c,u),u}e.removeAccents=function(){const c=/[\u0300-\u036f]/g;return function(S){return M(S).replace(c,"")}}()}),function(){function le(C){const I=[];typeof C=="number"&&I.push("code/timeOrigin",C);function M(h){I.push(h,Date.now())}function w(){const h=[];for(let c=0;c<I.length;c+=2)h.push({name:I[c],startTime:I[c+1]});return h}return{mark:M,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const M of performance.getEntriesByType("mark"))I.push({name:M.name,startTime:Math.round(C+M.startTime)});return I}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=y(k))}(),define(he[46],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class k{static create(I){return new k(I)}constructor(I){this._now=y&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=k}),define(he[4],de([0,1,7,29,2,44,46]),function(le,e,y,k,C,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=u;const w=!1,h=!1,c=!1;var S;(function(D){D.None=()=>C.Disposable.None;function a(V){if(c){const{onDidAddListener:K}=V,oe=g.create();let ue=0;V.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),oe.print()),K?.()}}}function L(V,K){return q(V,()=>{},0,void 0,!0,void 0,K)}D.defer=L;function P(V){return(K,oe=null,ue)=>{let pe=!1,ve;return ve=V(Ce=>{if(!pe)return ve?ve.dispose():pe=!0,K.call(oe,Ce)},null,ue),pe&&ve.dispose(),ve}}D.once=P;function T(V,K,oe){return me((ue,pe=null,ve)=>V(Ce=>ue.call(pe,K(Ce)),null,ve),oe)}D.map=T;function J(V,K,oe){return me((ue,pe=null,ve)=>V(Ce=>{K(Ce),ue.call(pe,Ce)},null,ve),oe)}D.forEach=J;function re(V,K,oe){return me((ue,pe=null,ve)=>V(Ce=>K(Ce)&&ue.call(pe,Ce),null,ve),oe)}D.filter=re;function x(V){return V}D.signal=x;function te(...V){return(K,oe=null,ue)=>{const pe=(0,C.combinedDisposable)(...V.map(ve=>ve(Ce=>K.call(oe,Ce))));return G(pe,ue)}}D.any=te;function ce(V,K,oe,ue){let pe=oe;return T(V,ve=>(pe=K(pe,ve),pe),ue)}D.reduce=ce;function me(V,K){let oe;const ue={onWillAddFirstListener(){oe=V(pe.fire,pe)},onDidRemoveLastListener(){oe?.dispose()}};K||a(ue);const pe=new t(ue);return K?.add(pe),pe.event}function G(V,K){return K instanceof Array?K.push(V):K&&K.add(V),V}function q(V,K,oe=100,ue=!1,pe=!1,ve,Ce){let be,Ee,Me,Te=0,Oe;const Le={leakWarningThreshold:ve,onWillAddFirstListener(){be=V(We=>{Te++,Ee=K(Ee,We),ue&&!Me&&(Ne.fire(Ee),Ee=void 0),Oe=()=>{const $e=Ee;Ee=void 0,Me=void 0,(!ue||Te>1)&&Ne.fire($e),Te=0},typeof oe=="number"?(clearTimeout(Me),Me=setTimeout(Oe,oe)):Me===void 0&&(Me=0,queueMicrotask(Oe))})},onWillRemoveListener(){pe&&Te>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};Ce||a(Le);const Ne=new t(Le);return Ce?.add(Ne),Ne.event}D.debounce=q;function Q(V,K=0,oe){return D.debounce(V,(ue,pe)=>ue?(ue.push(pe),ue):[pe],K,void 0,!0,void 0,oe)}D.accumulate=Q;function ie(V,K=(ue,pe)=>ue===pe,oe){let ue=!0,pe;return re(V,ve=>{const Ce=ue||!K(ve,pe);return ue=!1,pe=ve,Ce},oe)}D.latch=ie;function $(V,K,oe){return[D.filter(V,K,oe),D.filter(V,ue=>!K(ue),oe)]}D.split=$;function ee(V,K=!1,oe=[],ue){let pe=oe.slice(),ve=V(Ee=>{pe?pe.push(Ee):be.fire(Ee)});ue&&ue.add(ve);const Ce=()=>{pe?.forEach(Ee=>be.fire(Ee)),pe=null},be=new t({onWillAddFirstListener(){ve||(ve=V(Ee=>be.fire(Ee)),ue&&ue.add(ve))},onDidAddFirstListener(){pe&&(K?setTimeout(Ce):Ce())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return ue&&ue.add(be),be.event}D.buffer=ee;function ge(V,K){return(ue,pe,ve)=>{const Ce=K(new d);return V(function(be){const Ee=Ce.evaluate(be);Ee!==Z&&ue.call(pe,Ee)},void 0,ve)}}D.chain=ge;const Z=Symbol("HaltChainable");class d{constructor(){this.steps=[]}map(K){return this.steps.push(K),this}forEach(K){return this.steps.push(oe=>(K(oe),oe)),this}filter(K){return this.steps.push(oe=>K(oe)?oe:Z),this}reduce(K,oe){let ue=oe;return this.steps.push(pe=>(ue=K(ue,pe),ue)),this}latch(K=(oe,ue)=>oe===ue){let oe=!0,ue;return this.steps.push(pe=>{const ve=oe||!K(pe,ue);return oe=!1,ue=pe,ve?pe:Z}),this}evaluate(K){for(const oe of this.steps)if(K=oe(K),K===Z)break;return K}}function z(V,K,oe=ue=>ue){const ue=(...be)=>Ce.fire(oe(...be)),pe=()=>V.on(K,ue),ve=()=>V.removeListener(K,ue),Ce=new t({onWillAddFirstListener:pe,onDidRemoveLastListener:ve});return Ce.event}D.fromNodeEventEmitter=z;function ne(V,K,oe=ue=>ue){const ue=(...be)=>Ce.fire(oe(...be)),pe=()=>V.addEventListener(K,ue),ve=()=>V.removeEventListener(K,ue),Ce=new t({onWillAddFirstListener:pe,onDidRemoveLastListener:ve});return Ce.event}D.fromDOMEventEmitter=ne;function se(V){return new Promise(K=>P(V)(K))}D.toPromise=se;function H(V){const K=new t;return V.then(oe=>{K.fire(oe)},()=>{K.fire(void 0)}).finally(()=>{K.dispose()}),K.event}D.fromPromise=H;function j(V,K,oe){return K(oe),V(ue=>K(ue))}D.runAndSubscribe=j;class F{constructor(K,oe){this._observable=K,this._counter=0,this._hasChanged=!1;const ue={onWillAddFirstListener:()=>{K.addObserver(this)},onDidRemoveLastListener:()=>{K.removeObserver(this)}};oe||a(ue),this.emitter=new t(ue),oe&&oe.add(this.emitter)}beginUpdate(K){this._counter++}handlePossibleChange(K){}handleChange(K,oe){this._hasChanged=!0}endUpdate(K){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function R(V,K){return new F(V,K).emitter.event}D.fromObservable=R;function B(V){return(K,oe,ue)=>{let pe=0,ve=!1;const Ce={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(V.reportChanges(),ve&&(ve=!1,K.call(oe)))},handlePossibleChange(){},handleChange(){ve=!0}};V.addObserver(Ce),V.reportChanges();const be={dispose(){V.removeObserver(Ce)}};return ue instanceof C.DisposableStore?ue.add(be):Array.isArray(ue)&&ue.push(be),be}}D.fromObservableLight=B})(S||(e.Event=S={}));class p{static{this.all=new Set}static{this._idPool=0}constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${p._idPool++}`,p.all.add(this)}start(a){this._stopWatch=new M.StopWatch,this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=p;let b=-1;function u(D){const a=b;return b=D,{dispose(){b=a}}}class l{constructor(a,L=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=L,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(a,L){const P=this.threshold;if(P<=0||L<P)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let J,re=0;for(const[x,te]of this._stacks)(!J||re<te)&&(J=x,re=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${re}):`),console.warn(J)}return()=>{const J=this._stacks.get(a.value)||0;this._stacks.set(a.value,J-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class i{constructor(a){this.value=a,this.id=s++}}const o=2,f=(D,a)=>{if(D instanceof i)a(D);else for(let L=0;L<D.length;L++){const P=D[L];P&&a(P)}},r=w?new FinalizationRegistry(D=>{typeof D=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(D))}):void 0;class t{constructor(a){this._size=0,this._options=a,this._leakageMon=b>0||this._options?.leakWarningThreshold?new l(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(h){const a=this._listeners;queueMicrotask(()=>{f(a,L=>L.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(a,L,P)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.Disposable.None;if(this._disposed)return C.Disposable.None;L&&(a=a.bind(L));const T=new i(a);let J,re;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(T.stack=g.create(),J=this._leakageMon.check(T.stack,this._size+1)),h&&(T.stack=re??g.create()),this._listeners?this._listeners instanceof i?(this._deliveryQueue??=new _,this._listeners=[this._listeners,T]):this._listeners.push(T):(this._options?.onWillAddFirstListener?.(this),this._listeners=T,this._options?.onDidAddFirstListener?.(this)),this._size++;const x=(0,C.toDisposable)(()=>{r?.unregister(x),J?.(),this._removeListener(T)});if(P instanceof C.DisposableStore?P.add(x):Array.isArray(P)&&P.push(x),r){const te=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(x,te,x)}return x},this._event}_removeListener(a){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const L=this._listeners,P=L.indexOf(a);if(P===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,L[P]=void 0;const T=this._deliveryQueue.current===this;if(this._size*o<=L.length){let J=0;for(let re=0;re<L.length;re++)L[re]?L[J++]=L[re]:T&&(this._deliveryQueue.end--,J<this._deliveryQueue.i&&this._deliveryQueue.i--);L.length=J}}_deliver(a,L){if(!a)return;const P=this._options?.onListenerError||y.onUnexpectedError;if(!P){a.value(L);return}try{a.value(L)}catch(T){P(T)}}_deliverQueue(a){const L=a.current._listeners;for(;a.i<a.end;)this._deliver(L[a.i++],a.value);a.reset()}fire(a){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof i)this._deliver(this._listeners,a);else{const L=this._deliveryQueue;L.enqueue(this,a,this._listeners.length),this._deliverQueue(L)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=t;const n=()=>new _;e.createEventDeliveryQueue=n;class _{constructor(){this.i=-1,this.end=0}enqueue(a,L,P){this.i=0,this.end=P,this.current=a,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class O extends t{async fireAsync(a,L,P){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList),f(this._listeners,T=>this._asyncDeliveryQueue.push([T.value,a]));this._asyncDeliveryQueue.size>0&&!L.isCancellationRequested;){const[T,J]=this._asyncDeliveryQueue.shift(),re=[],x={...J,token:L,waitUntil:te=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");P&&(te=P(te,T)),re.push(te)}};try{T(x)}catch(te){(0,y.onUnexpectedError)(te);continue}Object.freeze(re),await Promise.allSettled(re).then(te=>{for(const ce of te)ce.status==="rejected"&&(0,y.onUnexpectedError)(ce.reason)})}}}e.AsyncEmitter=O;class m extends t{get isPaused(){return this._isPaused!==0}constructor(a){super(a),this._isPaused=0,this._eventQueue=new I.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._size&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=m;class E extends m{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=E;class v extends t{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this.hasListeners()&&(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(L=>super.fire(L)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=v;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new t({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const L={event:a,listener:null};this.events.push(L),this.hasListeners&&this.hook(L);const P=()=>{this.hasListeners&&this.unhook(L);const T=this.events.indexOf(L);this.events.splice(T,1)};return(0,C.toDisposable)((0,k.createSingleCallFunction)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(L=>this.emitter.fire(L))}unhook(a){a.listener?.dispose(),a.listener=null}dispose(){this.emitter.dispose();for(const a of this.events)a.listener?.dispose();this.events=[]}}e.EventMultiplexer=A;class W{constructor(a,L,P,T){this._store=new C.DisposableStore;const J=this._store.add(new A),re=this._store.add(new C.DisposableMap);function x(te){re.set(te,J.add(T(te)))}for(const te of a)x(te);this._store.add(L(te=>{x(te)})),this._store.add(P(te=>{re.deleteAndDispose(te)})),this.event=J.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=W;class Y{constructor(){this.buffers=[]}wrapEvent(a){return(L,P,T)=>a(J=>{const re=this.buffers[this.buffers.length-1];re?re.push(()=>L.call(P,J)):L.call(P,J)},void 0,T)}bufferEvents(a){const L=[];this.buffers.push(L);const P=a();return this.buffers.pop(),L.forEach(T=>T()),P}}e.EventBufferer=Y;class N{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=C.Disposable.None,this.emitter=new t({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=N}),define(he[17],de([0,1,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(w,h){const c=setTimeout(w.bind(h),0);return{dispose(){clearTimeout(c)}}});var C;(function(w){function h(c){return c===w.None||c===w.Cancelled||c instanceof I?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}w.isCancellationToken=h,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(C||(e.CancellationToken=C={}));class I{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new y.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new I),this._token}cancel(){this._token?this._token instanceof I&&this._token.cancel():this._token=C.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof I&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=M}),define(he[47],de([0,1,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class k{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new y.CancellationTokenSource,h=this.task(w.token);return this.result={promise:h,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}e.Cache=k;class C{constructor(w,h=JSON.stringify){this.fn=w,this._computeKey=h,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const h=this._computeKey(w);return this.lastArgKey!==h&&(this.lastArgKey=h,this.lastCache=this.fn(w)),this.lastCache}}e.LRUCachedFunction=C;class I{get cachedValues(){return this._map}constructor(w){this.fn=w,this._map=new Map}get(w){if(this._map.has(w))return this._map.get(w);const h=this.fn(w);return this._map.set(w,h),h}}e.CachedFunction=I}),define(he[48],de([0,1,7,2]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=C,e.isReadableStream=I,e.isReadableBufferedStream=M,e.newWriteableStream=w,e.consumeReadable=c,e.peekReadable=S,e.consumeStream=p,e.listenStream=b,e.peekStream=u,e.toStream=l,e.emptyStream=g,e.toReadable=s,e.transform=i,e.prefixedReadable=o,e.prefixedStream=f;function C(r){const t=r;return t?typeof t.read=="function":!1}function I(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(n=>typeof n=="function"):!1}function M(r){const t=r;return t?I(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function w(r,t){return new h(r,t)}class h{constructor(t,n){this.reducer=t,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(t){if(!this.state.destroyed){if(this.state.flowing)this.emitData(t);else if(this.buffer.data.push(t),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(t){this.state.destroyed||(this.state.flowing?this.emitError(t):this.buffer.error.push(t))}end(t){this.state.destroyed||(typeof t<"u"&&this.write(t),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(t){this.listeners.data.slice(0).forEach(n=>n(t))}emitError(t){this.listeners.error.length===0?(0,y.onUnexpectedError)(t):this.listeners.error.slice(0).forEach(n=>n(t))}emitEnd(){this.listeners.end.slice(0).forEach(t=>t())}on(t,n){if(!this.state.destroyed)switch(t){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(t,n){if(this.state.destroyed)return;let _;switch(t){case"data":_=this.listeners.data;break;case"end":_=this.listeners.end;break;case"error":_=this.listeners.error;break}if(_){const O=_.indexOf(n);O>=0&&_.splice(O,1)}}flowData(){if(this.buffer.data.length>0){const t=this.reducer(this.buffer.data);this.emitData(t),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(_=>_())}}flowErrors(){if(this.listeners.error.length>0){for(const t of this.buffer.error)this.emitError(t);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(r,t){const n=[];let _;for(;(_=r.read())!==null;)n.push(_);return t(n)}function S(r,t,n){const _=[];let O;for(;(O=r.read())!==null&&_.length<n;)_.push(O);return O===null&&_.length>0?t(_):{read:()=>{if(_.length>0)return _.shift();if(typeof O<"u"){const m=O;return O=void 0,m}return r.read()}}}function p(r,t){return new Promise((n,_)=>{const O=[];b(r,{onData:m=>{t&&O.push(m)},onError:m=>{t?_(m):n(void 0)},onEnd:()=>{n(t?t(O):void 0)}})})}function b(r,t,n){r.on("error",_=>{n?.isCancellationRequested||t.onError(_)}),r.on("end",()=>{n?.isCancellationRequested||t.onEnd()}),r.on("data",_=>{n?.isCancellationRequested||t.onData(_)})}function u(r,t){return new Promise((n,_)=>{const O=new k.DisposableStore,m=[],E=W=>{if(m.push(W),m.length>t)return O.dispose(),r.pause(),n({stream:r,buffer:m,ended:!1})},v=W=>(O.dispose(),_(W)),A=()=>(O.dispose(),n({stream:r,buffer:m,ended:!0}));O.add((0,k.toDisposable)(()=>r.removeListener("error",v))),r.on("error",v),O.add((0,k.toDisposable)(()=>r.removeListener("end",A))),r.on("end",A),O.add((0,k.toDisposable)(()=>r.removeListener("data",E))),r.on("data",E)})}function l(r,t){const n=w(t);return n.end(r),n}function g(){const r=w(()=>{throw new Error("not supported")});return r.end(),r}function s(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function i(r,t,n){const _=w(n);return b(r,{onData:O=>_.write(t.data(O)),onError:O=>_.error(t.error?t.error(O):O),onEnd:()=>_.end()}),_}function o(r,t,n){let _=!1;return{read:()=>{const O=t.read();return _?O:(_=!0,O!==null?n([r,O]):r)}}}function f(r,t,n){let _=!1;const O=w(n);return b(t,{onData:m=>_?O.write(m):(_=!0,O.write(n([r,m]))),onError:m=>O.error(m),onEnd:()=>{_||(_=!0,O.write(r)),O.end()}}),O}}),define(he[18],de([0,1,22,48]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=c,e.readUInt16LE=S,e.writeUInt16LE=p,e.readUInt32BE=b,e.writeUInt32BE=u,e.readUInt32LE=l,e.writeUInt32LE=g,e.readUInt8=s,e.writeUInt8=i,e.readableToBuffer=o,e.bufferToReadable=f,e.streamToBuffer=r,e.bufferedStreamToBuffer=t,e.bufferToStream=n,e.streamToBufferReadableStream=_,e.newWriteableBufferStream=O,e.prefixedBufferReadable=m,e.prefixedBufferStream=E,e.decodeBase64=v,e.encodeBase64=Y;const C=typeof Buffer<"u",I=new y.Lazy(()=>new Uint8Array(256));let M,w;class h{static alloc(D){return C?new h(Buffer.allocUnsafe(D)):new h(new Uint8Array(D))}static wrap(D){return C&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new h(D)}static fromString(D,a){return!(a?.dontUseNodeBuffer||!1)&&C?new h(Buffer.from(D)):(M||(M=new TextEncoder),new h(M.encode(D)))}static fromByteArray(D){const a=h.alloc(D.length);for(let L=0,P=D.length;L<P;L++)a.buffer[L]=D[L];return a}static concat(D,a){if(typeof a>"u"){a=0;for(let T=0,J=D.length;T<J;T++)a+=D[T].byteLength}const L=h.alloc(a);let P=0;for(let T=0,J=D.length;T<J;T++){const re=D[T];L.set(re,P),P+=re.byteLength}return L}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=h.alloc(this.byteLength);return D.set(this),D}toString(){return C?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(D,a){return new h(this.buffer.subarray(D,a))}set(D,a){if(D instanceof h)this.buffer.set(D.buffer,a);else if(D instanceof Uint8Array)this.buffer.set(D,a);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),a);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),a);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return b(this.buffer,D)}writeUInt32BE(D,a){u(this.buffer,D,a)}readUInt32LE(D){return l(this.buffer,D)}writeUInt32LE(D,a){g(this.buffer,D,a)}readUInt8(D){return s(this.buffer,D)}writeUInt8(D,a){i(this.buffer,D,a)}indexOf(D,a=0){return c(this.buffer,D instanceof h?D.buffer:D,a)}}e.VSBuffer=h;function c(N,D,a=0){const L=D.byteLength,P=N.byteLength;if(L===0)return 0;if(L===1)return N.indexOf(D[0]);if(L>P-a)return-1;const T=I.value;T.fill(D.length);for(let te=0;te<D.length;te++)T[D[te]]=D.length-te-1;let J=a+D.length-1,re=J,x=-1;for(;J<P;)if(N[J]===D[re]){if(re===0){x=J;break}J--,re--}else J+=Math.max(D.length-re,T[N[J]]),re=D.length-1;return x}function S(N,D){return N[D+0]<<0>>>0|N[D+1]<<8>>>0}function p(N,D,a){N[a+0]=D&255,D=D>>>8,N[a+1]=D&255}function b(N,D){return N[D]*2**24+N[D+1]*2**16+N[D+2]*2**8+N[D+3]}function u(N,D,a){N[a+3]=D,D=D>>>8,N[a+2]=D,D=D>>>8,N[a+1]=D,D=D>>>8,N[a]=D}function l(N,D){return N[D+0]<<0>>>0|N[D+1]<<8>>>0|N[D+2]<<16>>>0|N[D+3]<<24>>>0}function g(N,D,a){N[a+0]=D&255,D=D>>>8,N[a+1]=D&255,D=D>>>8,N[a+2]=D&255,D=D>>>8,N[a+3]=D&255}function s(N,D){return N[D]}function i(N,D,a){N[a]=D}function o(N){return k.consumeReadable(N,D=>h.concat(D))}function f(N){return k.toReadable(N)}function r(N){return k.consumeStream(N,D=>h.concat(D))}async function t(N){return N.ended?h.concat(N.buffer):h.concat([...N.buffer,await r(N.stream)])}function n(N){return k.toStream(N,D=>h.concat(D))}function _(N){return k.transform(N,{data:D=>typeof D=="string"?h.fromString(D):h.wrap(D)},D=>h.concat(D))}function O(N){return k.newWriteableStream(D=>h.concat(D),N)}function m(N,D){return k.prefixedReadable(N,D,a=>h.concat(a))}function E(N,D){return k.prefixedStream(N,D,a=>h.concat(a))}function v(N){let D=0,a=0,L=0;const P=new Uint8Array(Math.floor(N.length/4*3)),T=re=>{switch(a){case 3:P[L++]=D|re,a=0;break;case 2:P[L++]=D|re>>>2,D=re<<6,a=3;break;case 1:P[L++]=D|re>>>4,D=re<<4,a=2;break;default:D=re<<2,a=1}};for(let re=0;re<N.length;re++){const x=N.charCodeAt(re);if(x>=65&&x<=90)T(x-65);else if(x>=97&&x<=122)T(x-97+26);else if(x>=48&&x<=57)T(x-48+52);else if(x===43||x===45)T(62);else if(x===47||x===95)T(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${N[re]}`)}}const J=L;for(;a>0;)T(0);return h.wrap(P).slice(0,J)}const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",W="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Y({buffer:N},D=!0,a=!1){const L=a?W:A;let P="";const T=N.byteLength%3;let J=0;for(;J<N.byteLength-T;J+=3){const re=N[J+0],x=N[J+1],te=N[J+2];P+=L[re>>>2],P+=L[(re<<4|x>>>4)&63],P+=L[(x<<2|te>>>6)&63],P+=L[te&63]}if(T===1){const re=N[J+0];P+=L[re>>>2],P+=L[re<<4&63],D&&(P+="==")}else if(T===2){const re=N[J+0],x=N[J+1];P+=L[re>>>2],P+=L[(re<<4|x>>>4)&63],P+=L[x<<2&63],D&&(P+="=")}return P}}),define(he[12],de([0,1,47,22]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=C,e.format=M,e.format2=h,e.htmlAttributeEncodeValue=c,e.escape=S,e.escapeRegExpCharacters=p,e.count=b,e.truncate=u,e.truncateMiddle=l,e.trim=g,e.ltrim=s,e.rtrim=i,e.convertSimple2RegExpPattern=o,e.stripWildcards=f,e.createRegExp=r,e.regExpLeadsToEndlessLoop=t,e.splitLines=n,e.splitLinesIncludeSeparators=_,e.firstNonWhitespaceIndex=O,e.getLeadingWhitespace=m,e.lastNonWhitespaceIndex=E,e.replaceAsync=v,e.compare=A,e.compareSubstring=W,e.compareIgnoreCase=Y,e.compareSubstringIgnoreCase=N,e.isAsciiDigit=D,e.isLowerAsciiLetter=a,e.isUpperAsciiLetter=L,e.equalsIgnoreCase=P,e.startsWithIgnoreCase=T,e.commonPrefixLength=J,e.commonSuffixLength=re,e.isHighSurrogate=x,e.isLowSurrogate=te,e.computeCodePoint=ce,e.getNextCodePoint=me,e.nextCharLength=ie,e.prevCharLength=$,e.getCharContainingOffset=ee,e.charCount=ge,e.containsRTL=z,e.isBasicASCII=se,e.containsUnusualLineTerminators=H,e.isFullWidthCharacter=j,e.isEmojiImprecise=F,e.lcut=R,e.forAnsiStringParts=V,e.removeAnsiEscapeCodes=K,e.startsWithUTF8BOM=oe,e.stripUTF8BOM=ue,e.fuzzyContains=pe,e.containsUppercaseCharacter=ve,e.uppercaseFirstLetter=Ce,e.getNLines=be,e.singleLetterHash=Ee,e.getGraphemeBreakType=Me,e.getLeftDeleteOffset=We;function C(U){return!U||typeof U!="string"?!0:U.trim().length===0}const I=/{(\d+)}/g;function M(U,...X){return X.length===0?U:U.replace(I,function(ae,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=X.length?ae:X[ye]})}const w=/{([^}]+)}/g;function h(U,X){return Object.keys(X).length===0?U:U.replace(w,(ae,fe)=>X[fe]??ae)}function c(U){return U.replace(/[<>"'&]/g,X=>{switch(X){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return X})}function S(U){return U.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}function p(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(U,X){let ae=0;const fe=X.charCodeAt(0);for(let ye=U.length-1;ye>=0;ye--)U.charCodeAt(ye)===fe&&ae++;return ae}function u(U,X,ae="\u2026"){return U.length<=X?U:`${U.substr(0,X)}${ae}`}function l(U,X,ae="\u2026"){if(U.length<=X)return U;const fe=Math.ceil(X/2)-ae.length/2,ye=Math.floor(X/2)-ae.length/2;return`${U.substr(0,fe)}${ae}${U.substr(U.length-ye)}`}function g(U,X=" "){const ae=s(U,X);return i(ae,X)}function s(U,X){if(!U||!X)return U;const ae=X.length;if(ae===0||U.length===0)return U;let fe=0;for(;U.indexOf(X,fe)===fe;)fe=fe+ae;return U.substring(fe)}function i(U,X){if(!U||!X)return U;const ae=X.length,fe=U.length;if(ae===0||fe===0)return U;let ye=fe,we=-1;for(;we=U.lastIndexOf(X,ye-1),!(we===-1||we+ae!==ye);){if(we===0)return"";ye=we}return U.substring(0,ye)}function o(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(U){return U.replace(/\*/g,"")}function r(U,X,ae={}){if(!U)throw new Error("Cannot create regex from empty string");X||(U=p(U)),ae.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let fe="";return ae.global&&(fe+="g"),ae.matchCase||(fe+="i"),ae.multiline&&(fe+="m"),ae.unicode&&(fe+="u"),new RegExp(U,fe)}function t(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}function n(U){return U.split(/\r\n|\r|\n/)}function _(U){const X=[],ae=U.split(/(\r\n|\r|\n)/);for(let fe=0;fe<Math.ceil(ae.length/2);fe++)X.push(ae[2*fe]+(ae[2*fe+1]??""));return X}function O(U){for(let X=0,ae=U.length;X<ae;X++){const fe=U.charCodeAt(X);if(fe!==32&&fe!==9)return X}return-1}function m(U,X=0,ae=U.length){for(let fe=X;fe<ae;fe++){const ye=U.charCodeAt(fe);if(ye!==32&&ye!==9)return U.substring(X,fe)}return U.substring(X,ae)}function E(U,X=U.length-1){for(let ae=X;ae>=0;ae--){const fe=U.charCodeAt(ae);if(fe!==32&&fe!==9)return ae}return-1}function v(U,X,ae){const fe=[];let ye=0;for(const we of U.matchAll(X)){if(fe.push(U.slice(ye,we.index)),we.index===void 0)throw new Error("match.index should be defined");ye=we.index+we[0].length,fe.push(ae(we[0],...we.slice(1),we.index,U,we.groups))}return fe.push(U.slice(ye)),Promise.all(fe).then(we=>we.join(""))}function A(U,X){return U<X?-1:U>X?1:0}function W(U,X,ae=0,fe=U.length,ye=0,we=X.length){for(;ae<fe&&ye<we;ae++,ye++){const De=U.charCodeAt(ae),ke=X.charCodeAt(ye);if(De<ke)return-1;if(De>ke)return 1}const Se=fe-ae,Ie=we-ye;return Se<Ie?-1:Se>Ie?1:0}function Y(U,X){return N(U,X,0,U.length,0,X.length)}function N(U,X,ae=0,fe=U.length,ye=0,we=X.length){for(;ae<fe&&ye<we;ae++,ye++){let De=U.charCodeAt(ae),ke=X.charCodeAt(ye);if(De===ke)continue;if(De>=128||ke>=128)return W(U.toLowerCase(),X.toLowerCase(),ae,fe,ye,we);a(De)&&(De-=32),a(ke)&&(ke-=32);const Pe=De-ke;if(Pe!==0)return Pe}const Se=fe-ae,Ie=we-ye;return Se<Ie?-1:Se>Ie?1:0}function D(U){return U>=48&&U<=57}function a(U){return U>=97&&U<=122}function L(U){return U>=65&&U<=90}function P(U,X){return U.length===X.length&&N(U,X)===0}function T(U,X){const ae=X.length;return X.length>U.length?!1:N(U,X,0,ae)===0}function J(U,X){const ae=Math.min(U.length,X.length);let fe;for(fe=0;fe<ae;fe++)if(U.charCodeAt(fe)!==X.charCodeAt(fe))return fe;return ae}function re(U,X){const ae=Math.min(U.length,X.length);let fe;const ye=U.length-1,we=X.length-1;for(fe=0;fe<ae;fe++)if(U.charCodeAt(ye-fe)!==X.charCodeAt(we-fe))return fe;return ae}function x(U){return 55296<=U&&U<=56319}function te(U){return 56320<=U&&U<=57343}function ce(U,X){return(U-55296<<10)+(X-56320)+65536}function me(U,X,ae){const fe=U.charCodeAt(ae);if(x(fe)&&ae+1<X){const ye=U.charCodeAt(ae+1);if(te(ye))return ce(fe,ye)}return fe}function G(U,X){const ae=U.charCodeAt(X-1);if(te(ae)&&X>1){const fe=U.charCodeAt(X-2);if(x(fe))return ce(fe,ae)}return ae}class q{get offset(){return this._offset}constructor(X,ae=0){this._str=X,this._len=X.length,this._offset=ae}setOffset(X){this._offset=X}prevCodePoint(){const X=G(this._str,this._offset);return this._offset-=X>=65536?2:1,X}nextCodePoint(){const X=me(this._str,this._len,this._offset);return this._offset+=X>=65536?2:1,X}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class Q{get offset(){return this._iterator.offset}constructor(X,ae=0){this._iterator=new q(X,ae)}nextGraphemeLength(){const X=Le.getInstance(),ae=this._iterator,fe=ae.offset;let ye=X.getGraphemeBreakType(ae.nextCodePoint());for(;!ae.eol();){const we=ae.offset,Se=X.getGraphemeBreakType(ae.nextCodePoint());if(Te(ye,Se)){ae.setOffset(we);break}ye=Se}return ae.offset-fe}prevGraphemeLength(){const X=Le.getInstance(),ae=this._iterator,fe=ae.offset;let ye=X.getGraphemeBreakType(ae.prevCodePoint());for(;ae.offset>0;){const we=ae.offset,Se=X.getGraphemeBreakType(ae.prevCodePoint());if(Te(Se,ye)){ae.setOffset(we);break}ye=Se}return fe-ae.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function ie(U,X){return new Q(U,X).nextGraphemeLength()}function $(U,X){return new Q(U,X).prevGraphemeLength()}function ee(U,X){X>0&&te(U.charCodeAt(X))&&X--;const ae=X+ie(U,X);return[ae-$(U,ae),ae]}function ge(U){const X=new Q(U);let ae=0;for(;!X.eol();)ae++,X.nextGraphemeLength();return ae}let Z;function d(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(U){return Z||(Z=d()),Z.test(U)}const ne=/^[\t\n\r\x20-\x7E]*$/;function se(U){return ne.test(U)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(U){return e.UNUSUAL_LINE_TERMINATORS.test(U)}function j(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}function F(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}function R(U,X,ae=""){const fe=U.trimStart();if(fe.length<X)return fe;const ye=/\b/g;let we=0;for(;ye.test(fe)&&!(fe.length-ye.lastIndex<X);)we=ye.lastIndex,ye.lastIndex+=1;return we===0?fe:ae+fe.substring(we).trimStart()}const B=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*V(U){let X=0;for(const ae of U.matchAll(B))X!==ae.index&&(yield{isCode:!1,str:U.substring(X,ae.index)}),yield{isCode:!0,str:ae[0]},X=ae.index+ae[0].length;X!==U.length&&(yield{isCode:!1,str:U.substring(X)})}function K(U){return U&&(U=U.replace(B,"")),U}e.UTF8_BOM_CHARACTER="\uFEFF";function oe(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}function ue(U){return oe(U)?U.substr(1):U}function pe(U,X){if(!U||!X||U.length<X.length)return!1;const ae=X.length,fe=U.toLowerCase();let ye=0,we=-1;for(;ye<ae;){const Se=fe.indexOf(X[ye],we+1);if(Se<0)return!1;we=Se,ye++}return!0}function ve(U,X=!1){return U?(X&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}function Ce(U){return U.charAt(0).toUpperCase()+U.slice(1)}function be(U,X=1){if(X===0)return"";let ae=-1;do ae=U.indexOf(`
`,ae+1),X--;while(X>0&&ae>=0);return ae===-1?U:(U[ae-1]==="\r"&&ae--,U.substr(0,ae))}function Ee(U){return U=U%(2*26),U<26?String.fromCharCode(97+U):String.fromCharCode(65+U-26)}function Me(U){return Le.getInstance().getGraphemeBreakType(U)}function Te(U,X){return U===0?X!==5&&X!==7:U===2&&X===3?!1:U===4||U===2||U===3||X===4||X===2||X===3?!0:!(U===8&&(X===8||X===9||X===11||X===12)||(U===11||U===9)&&(X===9||X===10)||(U===12||U===10)&&X===10||X===5||X===13||X===7||U===1||U===13&&X===14||U===6&&X===6)}var Oe;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Le{static{this._INSTANCE=null}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const ae=this._data,fe=ae.length/3;let ye=1;for(;ye<=fe;)if(X<ae[3*ye])ye=2*ye;else if(X>ae[3*ye+1])ye=2*ye+1;else return ae[3*ye+2];return 0}}function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(U,X){if(U===0)return 0;const ae=$e(U,X);if(ae!==void 0)return ae;const fe=new q(X,U);return fe.prevCodePoint(),fe.offset}function $e(U,X){const ae=new q(X,U);let fe=ae.prevCodePoint();for(;He(fe)||fe===65039||fe===8419;){if(ae.offset===0)return;fe=ae.prevCodePoint()}if(!F(fe))return;let ye=ae.offset;return ye>0&&ae.prevCodePoint()===8205&&(ye=ae.offset),ye}function He(U){return 127995<=U&&U<=127999}var je;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class Fe{static{this.ambiguousCharacterData=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new y.LRUCachedFunction(X=>{function ae(Pe){const Re=new Map;for(let Ae=0;Ae<Pe.length;Ae+=2)Re.set(Pe[Ae],Pe[Ae+1]);return Re}function fe(Pe,Re){const Ae=new Map(Pe);for(const[qe,Be]of Re)Ae.set(qe,Be);return Ae}function ye(Pe,Re){if(!Pe)return Re;const Ae=new Map;for(const[qe,Be]of Pe)Re.has(qe)&&Ae.set(qe,Be);return Ae}const we=this.ambiguousCharacterData.value;let Se=X.filter(Pe=>!Pe.startsWith("_")&&Pe in we);Se.length===0&&(Se=["_default"]);let Ie;for(const Pe of Se){const Re=ae(we[Pe]);Ie=ye(Ie,Re)}const De=ae(we._common),ke=fe(De,Ie);return new Fe(ke)})}static getInstance(X){return Fe.cache.get(Array.from(X))}static{this._locales=new k.Lazy(()=>Object.keys(Fe.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")))}static getLocales(){return Fe._locales.value}constructor(X){this.confusableDictionary=X}isAmbiguous(X){return this.confusableDictionary.has(X)}getPrimaryConfusable(X){return this.confusableDictionary.get(X)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Fe;class ze{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(ze.getRawData())),this._data}static isInvisibleCharacter(X){return ze.getData().has(X)}static get codePoints(){return ze.getData()}}e.InvisibleCharacters=ze}),define(he[49],de([0,1,12]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=k,e.doHash=C,e.numberHash=I,e.stringHash=w,e.toHexString=g;function k(i){return C(i,0)}function C(i,o){switch(typeof i){case"object":return i===null?I(349,o):Array.isArray(i)?h(i,o):c(i,o);case"string":return w(i,o);case"boolean":return M(i,o);case"number":return I(i,o);case"undefined":return I(937,o);default:return I(617,o)}}function I(i,o){return(o<<5)-o+i|0}function M(i,o){return I(i?433:863,o)}function w(i,o){o=I(149417,o);for(let f=0,r=i.length;f<r;f++)o=I(i.charCodeAt(f),o);return o}function h(i,o){return o=I(104579,o),i.reduce((f,r)=>C(r,f),o)}function c(i,o){return o=I(181387,o),Object.keys(i).sort().reduce((f,r)=>(f=w(r,f),C(i[r],f)),o)}class S{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=C(o,this._value),this._value}}e.Hasher=S;var p;(function(i){i[i.BLOCK_SIZE=64]="BLOCK_SIZE",i[i.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function b(i,o,f=32){const r=f-o,t=~((1<<r)-1);return(i<<o|(t&i)>>>r)>>>0}function u(i,o=0,f=i.byteLength,r=0){for(let t=0;t<f;t++)i[o+t]=r}function l(i,o,f="0"){for(;i.length<o;)i=f+i;return i}function g(i,o=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(f=>f.toString(16).padStart(2,"0")).join(""):l((i>>>0).toString(16),o/4)}class s{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const f=o.length;if(f===0)return;const r=this._buff;let t=this._buffLen,n=this._leftoverHighSurrogate,_,O;for(n!==0?(_=n,O=-1,n=0):(_=o.charCodeAt(0),O=0);;){let m=_;if(y.isHighSurrogate(_))if(O+1<f){const E=o.charCodeAt(O+1);y.isLowSurrogate(E)?(O++,m=y.computeCodePoint(_,E)):m=65533}else{n=_;break}else y.isLowSurrogate(_)&&(m=65533);if(t=this._push(r,t,m),O++,O<f)_=o.charCodeAt(O);else break}this._buffLen=t,this._leftoverHighSurrogate=n}_push(o,f,r){return r<128?o[f++]=r:r<2048?(o[f++]=192|(r&1984)>>>6,o[f++]=128|(r&63)>>>0):r<65536?(o[f++]=224|(r&61440)>>>12,o[f++]=128|(r&4032)>>>6,o[f++]=128|(r&63)>>>0):(o[f++]=240|(r&1835008)>>>18,o[f++]=128|(r&258048)>>>12,o[f++]=128|(r&4032)>>>6,o[f++]=128|(r&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,o[0]=o[64],o[1]=o[65],o[2]=o[66]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,u(this._buff,this._buffLen),this._buffLen>56&&(this._step(),u(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=s._bigBlock32,f=this._buffDV;for(let A=0;A<64;A+=4)o.setUint32(A,f.getUint32(A,!1),!1);for(let A=64;A<320;A+=4)o.setUint32(A,b(o.getUint32(A-12,!1)^o.getUint32(A-32,!1)^o.getUint32(A-56,!1)^o.getUint32(A-64,!1),1),!1);let r=this._h0,t=this._h1,n=this._h2,_=this._h3,O=this._h4,m,E,v;for(let A=0;A<80;A++)A<20?(m=t&n|~t&_,E=1518500249):A<40?(m=t^n^_,E=1859775393):A<60?(m=t&n|t&_|n&_,E=2400959708):(m=t^n^_,E=3395469782),v=b(r,5)+m+O+E+o.getUint32(A*4,!1)&4294967295,O=_,_=n,n=b(t,30),t=r,r=v;this._h0=this._h0+r&4294967295,this._h1=this._h1+t&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+O&4294967295}}e.StringSHA1=s}),define(he[50],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(he[51],de([0,1,16,12]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this._value="",this._pos=0}reset(u){return this._value=u,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(u){const l=u.charCodeAt(0),g=this._value.charCodeAt(this._pos);return l-g}value(){return this._value[this._pos]}}e.StringIterator=C;class I{constructor(u=!0){this._caseSensitive=u}reset(u){return this._value=u,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let u=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(u)this._from++;else break;else u=!1;return this}cmp(u){return this._caseSensitive?(0,k.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class M{constructor(u=!0,l=!0){this._splitOnBackslash=u,this._caseSensitive=l}reset(u){this._from=0,this._to=0,this._value=u,this._valueLen=u.length;for(let l=u.length-1;l>=0;l--,this._valueLen--){const g=this._value.charCodeAt(l);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let u=!0;for(;this._to<this._valueLen;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(u)this._from++;else break;else u=!1}return this}cmp(u){return this._caseSensitive?(0,k.compareSubstring)(u,this._value,0,u.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(u,this._value,0,u.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=M;var w;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(w||(w={}));class h{constructor(u,l){this._ignorePathCasing=u,this._ignoreQueryAndFragment=l,this._states=[],this._stateIdx=0}reset(u){return this._value=u,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new M(!1,!this._ignorePathCasing(u)),this._pathIterator.reset(u.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(u)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(u){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(u,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(u,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(u);if(this._states[this._stateIdx]===4)return(0,k.compare)(u,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(u,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(S||(S={}));class p{static forUris(u=()=>!1,l=()=>!1){return new p(new h(u,l))}static forPaths(u=!1){return new p(new M(void 0,!u))}static forStrings(){return new p(new C)}static forConfigKeys(){return new p(new I)}constructor(u){this._iter=u}clear(){this._root=void 0}fill(u,l){if(l){const g=l.slice(0);(0,y.shuffle)(g);for(const s of g)this.set(s,u)}else{const g=u.slice(0);(0,y.shuffle)(g);for(const s of g)this.set(s[0],s[1])}}set(u,l){const g=this._iter.reset(u);let s;this._root||(this._root=new c,this._root.segment=g.value());const i=[];for(s=this._root;;){const f=g.cmp(s.segment);if(f>0)s.left||(s.left=new c,s.left.segment=g.value()),i.push([-1,s]),s=s.left;else if(f<0)s.right||(s.right=new c,s.right.segment=g.value()),i.push([1,s]),s=s.right;else if(g.hasNext())g.next(),s.mid||(s.mid=new c,s.mid.segment=g.value()),i.push([0,s]),s=s.mid;else break}const o=s.value;s.value=l,s.key=u;for(let f=i.length-1;f>=0;f--){const r=i[f][1];r.updateHeight();const t=r.balanceFactor();if(t<-1||t>1){const n=i[f][0],_=i[f+1][0];if(n===1&&_===1)i[f][1]=r.rotateLeft();else if(n===-1&&_===-1)i[f][1]=r.rotateRight();else if(n===1&&_===-1)r.right=i[f+1][1]=i[f+1][1].rotateRight(),i[f][1]=r.rotateLeft();else if(n===-1&&_===1)r.left=i[f+1][1]=i[f+1][1].rotateLeft(),i[f][1]=r.rotateRight();else throw new Error;if(f>0)switch(i[f-1][0]){case-1:i[f-1][1].left=i[f][1];break;case 1:i[f-1][1].right=i[f][1];break;case 0:i[f-1][1].mid=i[f][1];break}else this._root=i[0][1]}}return o}get(u){return this._getNode(u)?.value}_getNode(u){const l=this._iter.reset(u);let g=this._root;for(;g;){const s=l.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(l.hasNext())l.next(),g=g.mid;else break}return g}has(u){const l=this._getNode(u);return!(l?.value===void 0&&l?.mid===void 0)}delete(u){return this._delete(u,!1)}deleteSuperstr(u){return this._delete(u,!0)}_delete(u,l){const g=this._iter.reset(u),s=[];let i=this._root;for(;i;){const o=g.cmp(i.segment);if(o>0)s.push([-1,i]),i=i.left;else if(o<0)s.push([1,i]),i=i.right;else if(g.hasNext())g.next(),s.push([0,i]),i=i.mid;else break}if(i){if(l?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const o=this._min(i.right);if(o.key){const{key:f,value:r,segment:t}=o;this._delete(o.key,!1),i.key=f,i.value=r,i.segment=t}}else{const o=i.left??i.right;if(s.length>0){const[f,r]=s[s.length-1];switch(f){case-1:r.left=o;break;case 0:r.mid=o;break;case 1:r.right=o;break}}else this._root=o}for(let o=s.length-1;o>=0;o--){const f=s[o][1];f.updateHeight();const r=f.balanceFactor();if(r>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),s[o][1]=f.rotateLeft()):r<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),s[o][1]=f.rotateRight()),o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this._root=s[0][1]}}}_min(u){for(;u.left;)u=u.left;return u}findSubstr(u){const l=this._iter.reset(u);let g=this._root,s;for(;g;){const i=l.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(l.hasNext())l.next(),s=g.value||s,g=g.mid;else break}return g&&g.value||s}findSuperstr(u){return this._findSuperstrOrElement(u,!1)}_findSuperstrOrElement(u,l){const g=this._iter.reset(u);let s=this._root;for(;s;){const i=g.cmp(s.segment);if(i>0)s=s.left;else if(i<0)s=s.right;else if(g.hasNext())g.next(),s=s.mid;else return s.mid?this._entries(s.mid):l?s.value:void 0}}hasElementOrSubtree(u){return this._findSuperstrOrElement(u,!0)!==void 0}forEach(u){for(const[l,g]of this)u(g,l)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(u){const l=[];return this._dfsEntries(u,l),l[Symbol.iterator]()}_dfsEntries(u,l){u&&(u.left&&this._dfsEntries(u.left,l),u.value&&l.push([u.key,u.value]),u.mid&&this._dfsEntries(u.mid,l),u.right&&this._dfsEntries(u.right,l))}_isBalanced(){const u=l=>{if(!l)return!0;const g=l.balanceFactor();return g<-1||g>1?!1:u(l.left)&&u(l.right)};return u(this._root)}}e.TernarySearchTree=p}),define(he[8],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=y,e.isStringArray=k,e.isObject=C,e.isTypedArray=I,e.isNumber=M,e.isIterable=w,e.isBoolean=h,e.isUndefined=c,e.isDefined=S,e.isUndefinedOrNull=p,e.assertType=b,e.assertIsDefined=u,e.assertAllDefined=l,e.isEmptyObject=s,e.isFunction=i,e.areFunctions=o,e.validateConstraints=f,e.validateConstraint=r;function y(t){return typeof t=="string"}function k(t){return Array.isArray(t)&&t.every(n=>y(n))}function C(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function I(t){const n=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof n}function M(t){return typeof t=="number"&&!isNaN(t)}function w(t){return!!t&&typeof t[Symbol.iterator]=="function"}function h(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function S(t){return!p(t)}function p(t){return c(t)||t===null}function b(t,n){if(!t)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function u(t){if(p(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function l(...t){const n=[];for(let _=0;_<t.length;_++){const O=t[_];if(p(O))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);n.push(O)}return n}const g=Object.prototype.hasOwnProperty;function s(t){if(!C(t))return!1;for(const n in t)if(g.call(t,n))return!1;return!0}function i(t){return typeof t=="function"}function o(...t){return t.length>0&&t.every(i)}function f(t,n){const _=Math.min(t.length,n.length);for(let O=0;O<_;O++)r(t[O],n[O])}function r(t,n){if(y(n)){if(typeof t!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(i(n)){try{if(t instanceof n)return}catch{}if(!p(t)&&t.constructor===n||n.length===1&&n.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[30],de([0,1,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=k,e.deepFreeze=C,e.cloneAndChange=M,e.mixin=h,e.equals=c,e.safeStringify=S,e.distinct=p,e.getCaseInsensitive=b,e.filter=u,e.getAllPropertyNames=l,e.getAllMethodNames=g,e.createProxyObject=s;function k(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const o=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([f,r])=>{o[f]=r&&typeof r=="object"?k(r):r}),o}function C(i){if(!i||typeof i!="object")return i;const o=[i];for(;o.length>0;){const f=o.shift();Object.freeze(f);for(const r in f)if(I.call(f,r)){const t=f[r];typeof t=="object"&&!Object.isFrozen(t)&&!(0,y.isTypedArray)(t)&&o.push(t)}}return i}const I=Object.prototype.hasOwnProperty;function M(i,o){return w(i,o,new Set)}function w(i,o,f){if((0,y.isUndefinedOrNull)(i))return i;const r=o(i);if(typeof r<"u")return r;if(Array.isArray(i)){const t=[];for(const n of i)t.push(w(n,o,f));return t}if((0,y.isObject)(i)){if(f.has(i))throw new Error("Cannot clone recursive data-structure");f.add(i);const t={};for(const n in i)I.call(i,n)&&(t[n]=w(i[n],o,f));return f.delete(i),t}return i}function h(i,o,f=!0){return(0,y.isObject)(i)?((0,y.isObject)(o)&&Object.keys(o).forEach(r=>{r in i?f&&((0,y.isObject)(i[r])&&(0,y.isObject)(o[r])?h(i[r],o[r],f):i[r]=o[r]):i[r]=o[r]}),i):o}function c(i,o){if(i===o)return!0;if(i==null||o===null||o===void 0||typeof i!=typeof o||typeof i!="object"||Array.isArray(i)!==Array.isArray(o))return!1;let f,r;if(Array.isArray(i)){if(i.length!==o.length)return!1;for(f=0;f<i.length;f++)if(!c(i[f],o[f]))return!1}else{const t=[];for(r in i)t.push(r);t.sort();const n=[];for(r in o)n.push(r);if(n.sort(),!c(t,n))return!1;for(f=0;f<t.length;f++)if(!c(i[t[f]],o[t[f]]))return!1}return!0}function S(i){const o=new Set;return JSON.stringify(i,(f,r)=>{if((0,y.isObject)(r)||Array.isArray(r)){if(o.has(r))return"[Circular]";o.add(r)}return r})}function p(i,o){const f=Object.create(null);return!i||!o||Object.keys(o).forEach(t=>{const n=i[t],_=o[t];c(n,_)||(f[t]=_)}),f}function b(i,o){const f=o.toLowerCase(),r=Object.keys(i).find(t=>t.toLowerCase()===f);return r?i[r]:i[o]}function u(i,o){const f=Object.create(null);for(const[r,t]of Object.entries(i))o(r,t)&&(f[r]=t);return f}function l(i){let o=[];for(;Object.prototype!==i;)o=o.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return o}function g(i){const o=[];for(const f of l(i))typeof i[f]=="function"&&o.push(f);return o}function s(i,o){const f=t=>function(){const n=Array.prototype.slice.call(arguments,0);return o(t,n)},r={};for(const t of i)r[t]=f(t);return r}}),define(he[52],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=k;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(C){return y.test(C)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(w){for(let h=0;h<w.length;h++)w[h]=Math.floor(Math.random()*256);return w};const I=new Uint8Array(16),M=[];for(let w=0;w<256;w++)M.push(w.toString(16).padStart(2,"0"));return function(){C(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let h=0,c="";return c+=M[I[h++]],c+=M[I[h++]],c+=M[I[h++]],c+=M[I[h++]],c+="-",c+=M[I[h++]],c+=M[I[h++]],c+="-",c+=M[I[h++]],c+=M[I[h++]],c+="-",c+=M[I[h++]],c+=M[I[h++]],c+="-",c+=M[I[h++]],c+=M[I[h++]],c+=M[I[h++]],c+=M[I[h++]],c+=M[I[h++]],c+=M[I[h++]],c}}()}),define(he[31],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=y;function y(k){return!!k.parentPort}}),define(he[53],de([13,9]),function(le,e){return le.create("vs/base/common/date",e)}),define(he[54],de([0,1,53]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=c,e.getDurationString=S,e.toLocalISOString=p;const k=60,C=k*60,I=C*24,M=I*7,w=I*30,h=I*365;function c(b,u,l,g){typeof b!="number"&&(b=b.getTime());const s=Math.round((new Date().getTime()-b)/1e3);if(s<-30)return(0,y.localize)(0,null,c(new Date().getTime()+s*1e3,!1));if(!g&&s<30)return(0,y.localize)(1,null);let i;return s<k?(i=s,u?i===1?l?(0,y.localize)(2,null,i):(0,y.localize)(3,null,i):l?(0,y.localize)(4,null,i):(0,y.localize)(5,null,i):i===1?l?(0,y.localize)(6,null,i):(0,y.localize)(7,null,i):l?(0,y.localize)(8,null,i):(0,y.localize)(9,null,i)):s<C?(i=Math.floor(s/k),u?i===1?l?(0,y.localize)(10,null,i):(0,y.localize)(11,null,i):l?(0,y.localize)(12,null,i):(0,y.localize)(13,null,i):i===1?l?(0,y.localize)(14,null,i):(0,y.localize)(15,null,i):l?(0,y.localize)(16,null,i):(0,y.localize)(17,null,i)):s<I?(i=Math.floor(s/C),u?i===1?l?(0,y.localize)(18,null,i):(0,y.localize)(19,null,i):l?(0,y.localize)(20,null,i):(0,y.localize)(21,null,i):i===1?l?(0,y.localize)(22,null,i):(0,y.localize)(23,null,i):l?(0,y.localize)(24,null,i):(0,y.localize)(25,null,i)):s<M?(i=Math.floor(s/I),u?i===1?(0,y.localize)(26,null,i):(0,y.localize)(27,null,i):i===1?(0,y.localize)(28,null,i):(0,y.localize)(29,null,i)):s<w?(i=Math.floor(s/M),u?i===1?l?(0,y.localize)(30,null,i):(0,y.localize)(31,null,i):l?(0,y.localize)(32,null,i):(0,y.localize)(33,null,i):i===1?l?(0,y.localize)(34,null,i):(0,y.localize)(35,null,i):l?(0,y.localize)(36,null,i):(0,y.localize)(37,null,i)):s<h?(i=Math.floor(s/w),u?i===1?l?(0,y.localize)(38,null,i):(0,y.localize)(39,null,i):l?(0,y.localize)(40,null,i):(0,y.localize)(41,null,i):i===1?l?(0,y.localize)(42,null,i):(0,y.localize)(43,null,i):l?(0,y.localize)(44,null,i):(0,y.localize)(45,null,i)):(i=Math.floor(s/h),u?i===1?l?(0,y.localize)(46,null,i):(0,y.localize)(47,null,i):l?(0,y.localize)(48,null,i):(0,y.localize)(49,null,i):i===1?l?(0,y.localize)(50,null,i):(0,y.localize)(51,null,i):l?(0,y.localize)(52,null,i):(0,y.localize)(53,null,i))}function S(b,u){const l=Math.abs(b/1e3);return l<1?u?(0,y.localize)(54,null,b):(0,y.localize)(55,null,b):l<k?u?(0,y.localize)(56,null,Math.round(b)/1e3):(0,y.localize)(57,null,Math.round(b)/1e3):l<C?u?(0,y.localize)(58,null,Math.round(b/(1e3*k))):(0,y.localize)(59,null,Math.round(b/(1e3*k))):l<I?u?(0,y.localize)(60,null,Math.round(b/(1e3*C))):(0,y.localize)(61,null,Math.round(b/(1e3*C))):(0,y.localize)(62,null,Math.round(b/(1e3*I)))}function p(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[55],de([13,9]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(he[56],de([0,1,16,8,55]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=h,e.isErrorWithActions=c,e.createErrorWithActions=S;function I(p,b){return b&&(p.stack||p.stacktrace)?C.localize(0,null,w(p),M(p.stack)||M(p.stacktrace)):w(p)}function M(p){return Array.isArray(p)?p.join(`
`):p}function w(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?C.localize(1,null,p.message):p.message||C.localize(2,null)}function h(p=null,b=!1){if(!p)return C.localize(3,null);if(Array.isArray(p)){const u=y.coalesce(p),l=h(u[0],b);return u.length>1?C.localize(4,null,l,u.length):l}if(k.isString(p))return p;if(p.detail){const u=p.detail;if(u.error)return I(u.error,b);if(u.exception)return I(u.exception,b)}return p.stack?I(p,b):p.message?p.message:C.localize(5,null)}function c(p){const b=p;return b instanceof Error&&Array.isArray(b.actions)}function S(p,b){let u;return typeof p=="string"?u=new Error(p):u=p,u.actions=b,u}}),define(he[57],de([13,9]),function(le,e){return le.create("vs/base/common/platform",e)}),define(he[3],de([0,1,57]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=_,e.isLittleEndian=W,e.isBigSurOrNewer=Y,e.LANGUAGE_DEFAULT="en";let k=!1,C=!1,I=!1,M=!1,w=!1,h=!1,c=!1,S=!1,p=!1,b=!1,u,l=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT,s,i;const o=globalThis;let f;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?f=o.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const r=typeof f?.versions?.electron=="string",t=r&&f?.type==="renderer";if(typeof f=="object"){k=f.platform==="win32",C=f.platform==="darwin",I=f.platform==="linux",M=I&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,c=r,p=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,l=e.LANGUAGE_DEFAULT;const N=f.env.VSCODE_NLS_CONFIG;if(N)try{const D=JSON.parse(N),a=D.availableLanguages["*"];u=D.locale,g=D.osLocale,l=a||e.LANGUAGE_DEFAULT,s=D._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!t?(i=navigator.userAgent,k=i.indexOf("Windows")>=0,C=i.indexOf("Macintosh")>=0,S=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=i.indexOf("Linux")>=0,b=i?.indexOf("Mobi")>=0,h=!0,u=y.getConfiguredDefaultLocale(y.localize(0,null))||e.LANGUAGE_DEFAULT,l=u,g=navigator.language):console.error("Unable to resolve platform.");var n;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(n||(e.Platform=n={}));function _(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let O=0;C?O=1:k?O=3:I&&(O=2),e.isWindows=k,e.isMacintosh=C,e.isLinux=I,e.isLinuxSnap=M,e.isNative=w,e.isElectron=c,e.isWeb=h,e.isWebWorker=h&&typeof o.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?o.origin:void 0,e.isIOS=S,e.isMobile=b,e.isCI=p,e.platform=O,e.userAgent=i,e.language=l;var m;(function(N){function D(){return e.language}N.value=D;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}N.isDefaultVariant=a;function L(){return e.language==="en"}N.isDefault=L})(m||(e.Language=m={})),e.locale=u,e.platformLocale=g,e.translationsConfigFile=s,e.setTimeout0IsFaster=typeof o.postMessage=="function"&&!o.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const N=[];o.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let L=0,P=N.length;L<P;L++){const T=N[L];if(T.id===a.data.vscodeScheduleAsyncWork){N.splice(L,1),T.callback();return}}});let D=0;return a=>{const L=++D;N.push({id:L,callback:a}),o.postMessage({vscodeScheduleAsyncWork:L},"*")}}return N=>setTimeout(N)})();var E;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(E||(e.OperatingSystem=E={})),e.OS=C||S?2:k?1:3;let v=!0,A=!1;function W(){if(!A){A=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,v=new Uint16Array(N.buffer)[0]===513}return v}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function Y(N){return parseFloat(N)>=20}}),define(he[15],de([0,1,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let k;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const I=C.process;k={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.arch=k.arch}),define(he[5],de([0,1,15]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,C=97,I=90,M=122,w=46,h=47,c=92,S=58,p=63;class b extends Error{constructor(_,O,m){let E;typeof O=="string"&&O.indexOf("not ")===0?(E="must not be",O=O.replace(/^not /,"")):E="must be";const v=_.indexOf(".")!==-1?"property":"argument";let A=`The "${_}" ${v} ${E} of type ${O}`;A+=`. Received type ${typeof m}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function u(n,_){if(n===null||typeof n!="object")throw new b(_,"Object",n)}function l(n,_){if(typeof n!="string")throw new b(_,"string",n)}const g=y.platform==="win32";function s(n){return n===h||n===c}function i(n){return n===h}function o(n){return n>=k&&n<=I||n>=C&&n<=M}function f(n,_,O,m){let E="",v=0,A=-1,W=0,Y=0;for(let N=0;N<=n.length;++N){if(N<n.length)Y=n.charCodeAt(N);else{if(m(Y))break;Y=h}if(m(Y)){if(!(A===N-1||W===1))if(W===2){if(E.length<2||v!==2||E.charCodeAt(E.length-1)!==w||E.charCodeAt(E.length-2)!==w){if(E.length>2){const D=E.lastIndexOf(O);D===-1?(E="",v=0):(E=E.slice(0,D),v=E.length-1-E.lastIndexOf(O)),A=N,W=0;continue}else if(E.length!==0){E="",v=0,A=N,W=0;continue}}_&&(E+=E.length>0?`${O}..`:"..",v=2)}else E.length>0?E+=`${O}${n.slice(A+1,N)}`:E=n.slice(A+1,N),v=N-A-1;A=N,W=0}else Y===w&&W!==-1?++W:W=-1}return E}function r(n,_){u(_,"pathObject");const O=_.dir||_.root,m=_.base||`${_.name||""}${_.ext||""}`;return O?O===_.root?`${O}${m}`:`${O}${n}${m}`:m}e.win32={resolve(...n){let _="",O="",m=!1;for(let E=n.length-1;E>=-1;E--){let v;if(E>=0){if(v=n[E],l(v,"path"),v.length===0)continue}else _.length===0?v=y.cwd():(v=y.env[`=${_}`]||y.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==_.toLowerCase()&&v.charCodeAt(2)===c)&&(v=`${_}\\`));const A=v.length;let W=0,Y="",N=!1;const D=v.charCodeAt(0);if(A===1)s(D)&&(W=1,N=!0);else if(s(D))if(N=!0,s(v.charCodeAt(1))){let a=2,L=a;for(;a<A&&!s(v.charCodeAt(a));)a++;if(a<A&&a!==L){const P=v.slice(L,a);for(L=a;a<A&&s(v.charCodeAt(a));)a++;if(a<A&&a!==L){for(L=a;a<A&&!s(v.charCodeAt(a));)a++;(a===A||a!==L)&&(Y=`\\\\${P}\\${v.slice(L,a)}`,W=a)}}}else W=1;else o(D)&&v.charCodeAt(1)===S&&(Y=v.slice(0,2),W=2,A>2&&s(v.charCodeAt(2))&&(N=!0,W=3));if(Y.length>0)if(_.length>0){if(Y.toLowerCase()!==_.toLowerCase())continue}else _=Y;if(m){if(_.length>0)break}else if(O=`${v.slice(W)}\\${O}`,m=N,N&&_.length>0)break}return O=f(O,!m,"\\",s),m?`${_}\\${O}`:`${_}${O}`||"."},normalize(n){l(n,"path");const _=n.length;if(_===0)return".";let O=0,m,E=!1;const v=n.charCodeAt(0);if(_===1)return i(v)?"\\":n;if(s(v))if(E=!0,s(n.charCodeAt(1))){let W=2,Y=W;for(;W<_&&!s(n.charCodeAt(W));)W++;if(W<_&&W!==Y){const N=n.slice(Y,W);for(Y=W;W<_&&s(n.charCodeAt(W));)W++;if(W<_&&W!==Y){for(Y=W;W<_&&!s(n.charCodeAt(W));)W++;if(W===_)return`\\\\${N}\\${n.slice(Y)}\\`;W!==Y&&(m=`\\\\${N}\\${n.slice(Y,W)}`,O=W)}}}else O=1;else o(v)&&n.charCodeAt(1)===S&&(m=n.slice(0,2),O=2,_>2&&s(n.charCodeAt(2))&&(E=!0,O=3));let A=O<_?f(n.slice(O),!E,"\\",s):"";return A.length===0&&!E&&(A="."),A.length>0&&s(n.charCodeAt(_-1))&&(A+="\\"),m===void 0?E?`\\${A}`:A:E?`${m}\\${A}`:`${m}${A}`},isAbsolute(n){l(n,"path");const _=n.length;if(_===0)return!1;const O=n.charCodeAt(0);return s(O)||_>2&&o(O)&&n.charCodeAt(1)===S&&s(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let _,O;for(let v=0;v<n.length;++v){const A=n[v];l(A,"path"),A.length>0&&(_===void 0?_=O=A:_+=`\\${A}`)}if(_===void 0)return".";let m=!0,E=0;if(typeof O=="string"&&s(O.charCodeAt(0))){++E;const v=O.length;v>1&&s(O.charCodeAt(1))&&(++E,v>2&&(s(O.charCodeAt(2))?++E:m=!1))}if(m){for(;E<_.length&&s(_.charCodeAt(E));)E++;E>=2&&(_=`\\${_.slice(E)}`)}return e.win32.normalize(_)},relative(n,_){if(l(n,"from"),l(_,"to"),n===_)return"";const O=e.win32.resolve(n),m=e.win32.resolve(_);if(O===m||(n=O.toLowerCase(),_=m.toLowerCase(),n===_))return"";let E=0;for(;E<n.length&&n.charCodeAt(E)===c;)E++;let v=n.length;for(;v-1>E&&n.charCodeAt(v-1)===c;)v--;const A=v-E;let W=0;for(;W<_.length&&_.charCodeAt(W)===c;)W++;let Y=_.length;for(;Y-1>W&&_.charCodeAt(Y-1)===c;)Y--;const N=Y-W,D=A<N?A:N;let a=-1,L=0;for(;L<D;L++){const T=n.charCodeAt(E+L);if(T!==_.charCodeAt(W+L))break;T===c&&(a=L)}if(L!==D){if(a===-1)return m}else{if(N>D){if(_.charCodeAt(W+L)===c)return m.slice(W+L+1);if(L===2)return m.slice(W+L)}A>D&&(n.charCodeAt(E+L)===c?a=L:L===2&&(a=3)),a===-1&&(a=0)}let P="";for(L=E+a+1;L<=v;++L)(L===v||n.charCodeAt(L)===c)&&(P+=P.length===0?"..":"\\..");return W+=a,P.length>0?`${P}${m.slice(W,Y)}`:(m.charCodeAt(W)===c&&++W,m.slice(W,Y))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const _=e.win32.resolve(n);if(_.length<=2)return n;if(_.charCodeAt(0)===c){if(_.charCodeAt(1)===c){const O=_.charCodeAt(2);if(O!==p&&O!==w)return`\\\\?\\UNC\\${_.slice(2)}`}}else if(o(_.charCodeAt(0))&&_.charCodeAt(1)===S&&_.charCodeAt(2)===c)return`\\\\?\\${_}`;return n},dirname(n){l(n,"path");const _=n.length;if(_===0)return".";let O=-1,m=0;const E=n.charCodeAt(0);if(_===1)return s(E)?n:".";if(s(E)){if(O=m=1,s(n.charCodeAt(1))){let W=2,Y=W;for(;W<_&&!s(n.charCodeAt(W));)W++;if(W<_&&W!==Y){for(Y=W;W<_&&s(n.charCodeAt(W));)W++;if(W<_&&W!==Y){for(Y=W;W<_&&!s(n.charCodeAt(W));)W++;if(W===_)return n;W!==Y&&(O=m=W+1)}}}}else o(E)&&n.charCodeAt(1)===S&&(O=_>2&&s(n.charCodeAt(2))?3:2,m=O);let v=-1,A=!0;for(let W=_-1;W>=m;--W)if(s(n.charCodeAt(W))){if(!A){v=W;break}}else A=!1;if(v===-1){if(O===-1)return".";v=O}return n.slice(0,v)},basename(n,_){_!==void 0&&l(_,"ext"),l(n,"path");let O=0,m=-1,E=!0,v;if(n.length>=2&&o(n.charCodeAt(0))&&n.charCodeAt(1)===S&&(O=2),_!==void 0&&_.length>0&&_.length<=n.length){if(_===n)return"";let A=_.length-1,W=-1;for(v=n.length-1;v>=O;--v){const Y=n.charCodeAt(v);if(s(Y)){if(!E){O=v+1;break}}else W===-1&&(E=!1,W=v+1),A>=0&&(Y===_.charCodeAt(A)?--A===-1&&(m=v):(A=-1,m=W))}return O===m?m=W:m===-1&&(m=n.length),n.slice(O,m)}for(v=n.length-1;v>=O;--v)if(s(n.charCodeAt(v))){if(!E){O=v+1;break}}else m===-1&&(E=!1,m=v+1);return m===-1?"":n.slice(O,m)},extname(n){l(n,"path");let _=0,O=-1,m=0,E=-1,v=!0,A=0;n.length>=2&&n.charCodeAt(1)===S&&o(n.charCodeAt(0))&&(_=m=2);for(let W=n.length-1;W>=_;--W){const Y=n.charCodeAt(W);if(s(Y)){if(!v){m=W+1;break}continue}E===-1&&(v=!1,E=W+1),Y===w?O===-1?O=W:A!==1&&(A=1):O!==-1&&(A=-1)}return O===-1||E===-1||A===0||A===1&&O===E-1&&O===m+1?"":n.slice(O,E)},format:r.bind(null,"\\"),parse(n){l(n,"path");const _={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return _;const O=n.length;let m=0,E=n.charCodeAt(0);if(O===1)return s(E)?(_.root=_.dir=n,_):(_.base=_.name=n,_);if(s(E)){if(m=1,s(n.charCodeAt(1))){let a=2,L=a;for(;a<O&&!s(n.charCodeAt(a));)a++;if(a<O&&a!==L){for(L=a;a<O&&s(n.charCodeAt(a));)a++;if(a<O&&a!==L){for(L=a;a<O&&!s(n.charCodeAt(a));)a++;a===O?m=a:a!==L&&(m=a+1)}}}}else if(o(E)&&n.charCodeAt(1)===S){if(O<=2)return _.root=_.dir=n,_;if(m=2,s(n.charCodeAt(2))){if(O===3)return _.root=_.dir=n,_;m=3}}m>0&&(_.root=n.slice(0,m));let v=-1,A=m,W=-1,Y=!0,N=n.length-1,D=0;for(;N>=m;--N){if(E=n.charCodeAt(N),s(E)){if(!Y){A=N+1;break}continue}W===-1&&(Y=!1,W=N+1),E===w?v===-1?v=N:D!==1&&(D=1):v!==-1&&(D=-1)}return W!==-1&&(v===-1||D===0||D===1&&v===W-1&&v===A+1?_.base=_.name=n.slice(A,W):(_.name=n.slice(A,v),_.base=n.slice(A,W),_.ext=n.slice(v,W))),A>0&&A!==m?_.dir=n.slice(0,A-1):_.dir=_.root,_},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(g){const n=/\\/g;return()=>{const _=y.cwd().replace(n,"/");return _.slice(_.indexOf("/"))}}return()=>y.cwd()})();e.posix={resolve(...n){let _="",O=!1;for(let m=n.length-1;m>=-1&&!O;m--){const E=m>=0?n[m]:t();l(E,"path"),E.length!==0&&(_=`${E}/${_}`,O=E.charCodeAt(0)===h)}return _=f(_,!O,"/",i),O?`/${_}`:_.length>0?_:"."},normalize(n){if(l(n,"path"),n.length===0)return".";const _=n.charCodeAt(0)===h,O=n.charCodeAt(n.length-1)===h;return n=f(n,!_,"/",i),n.length===0?_?"/":O?"./":".":(O&&(n+="/"),_?`/${n}`:n)},isAbsolute(n){return l(n,"path"),n.length>0&&n.charCodeAt(0)===h},join(...n){if(n.length===0)return".";let _;for(let O=0;O<n.length;++O){const m=n[O];l(m,"path"),m.length>0&&(_===void 0?_=m:_+=`/${m}`)}return _===void 0?".":e.posix.normalize(_)},relative(n,_){if(l(n,"from"),l(_,"to"),n===_||(n=e.posix.resolve(n),_=e.posix.resolve(_),n===_))return"";const O=1,m=n.length,E=m-O,v=1,A=_.length-v,W=E<A?E:A;let Y=-1,N=0;for(;N<W;N++){const a=n.charCodeAt(O+N);if(a!==_.charCodeAt(v+N))break;a===h&&(Y=N)}if(N===W)if(A>W){if(_.charCodeAt(v+N)===h)return _.slice(v+N+1);if(N===0)return _.slice(v+N)}else E>W&&(n.charCodeAt(O+N)===h?Y=N:N===0&&(Y=0));let D="";for(N=O+Y+1;N<=m;++N)(N===m||n.charCodeAt(N)===h)&&(D+=D.length===0?"..":"/..");return`${D}${_.slice(v+Y)}`},toNamespacedPath(n){return n},dirname(n){if(l(n,"path"),n.length===0)return".";const _=n.charCodeAt(0)===h;let O=-1,m=!0;for(let E=n.length-1;E>=1;--E)if(n.charCodeAt(E)===h){if(!m){O=E;break}}else m=!1;return O===-1?_?"/":".":_&&O===1?"//":n.slice(0,O)},basename(n,_){_!==void 0&&l(_,"ext"),l(n,"path");let O=0,m=-1,E=!0,v;if(_!==void 0&&_.length>0&&_.length<=n.length){if(_===n)return"";let A=_.length-1,W=-1;for(v=n.length-1;v>=0;--v){const Y=n.charCodeAt(v);if(Y===h){if(!E){O=v+1;break}}else W===-1&&(E=!1,W=v+1),A>=0&&(Y===_.charCodeAt(A)?--A===-1&&(m=v):(A=-1,m=W))}return O===m?m=W:m===-1&&(m=n.length),n.slice(O,m)}for(v=n.length-1;v>=0;--v)if(n.charCodeAt(v)===h){if(!E){O=v+1;break}}else m===-1&&(E=!1,m=v+1);return m===-1?"":n.slice(O,m)},extname(n){l(n,"path");let _=-1,O=0,m=-1,E=!0,v=0;for(let A=n.length-1;A>=0;--A){const W=n.charCodeAt(A);if(W===h){if(!E){O=A+1;break}continue}m===-1&&(E=!1,m=A+1),W===w?_===-1?_=A:v!==1&&(v=1):_!==-1&&(v=-1)}return _===-1||m===-1||v===0||v===1&&_===m-1&&_===O+1?"":n.slice(_,m)},format:r.bind(null,"/"),parse(n){l(n,"path");const _={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return _;const O=n.charCodeAt(0)===h;let m;O?(_.root="/",m=1):m=0;let E=-1,v=0,A=-1,W=!0,Y=n.length-1,N=0;for(;Y>=m;--Y){const D=n.charCodeAt(Y);if(D===h){if(!W){v=Y+1;break}continue}A===-1&&(W=!1,A=Y+1),D===w?E===-1?E=Y:N!==1&&(N=1):E!==-1&&(N=-1)}if(A!==-1){const D=v===0&&O?1:v;E===-1||N===0||N===1&&E===A-1&&E===v+1?_.base=_.name=n.slice(D,A):(_.name=n.slice(D,E),_.base=n.slice(D,A),_.ext=n.slice(E,A))}return v>0?_.dir=n.slice(0,v-1):O&&(_.dir="/"),_},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g?e.win32.normalize:e.posix.normalize,e.isAbsolute=g?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g?e.win32.join:e.posix.join,e.resolve=g?e.win32.resolve:e.posix.resolve,e.relative=g?e.win32.relative:e.posix.relative,e.dirname=g?e.win32.dirname:e.posix.dirname,e.basename=g?e.win32.basename:e.posix.basename,e.extname=g?e.win32.extname:e.posix.extname,e.format=g?e.win32.format:e.posix.format,e.parse=g?e.win32.parse:e.posix.parse,e.toNamespacedPath=g?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g?e.win32.sep:e.posix.sep,e.delimiter=g?e.win32.delimiter:e.posix.delimiter}),define(he[32],de([0,1,5,3,12,8]),function(le,e,y,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=M,e.toSlashes=w,e.toPosixPath=h,e.getRoot=c,e.isUNC=S,e.isValidBasename=l,e.isEqual=g,e.isEqualOrParent=s,e.isWindowsDriveLetter=i,e.sanitizeFilePath=o,e.isRootOrDriveLetter=f,e.hasDriveLetter=r,e.getDriveLetter=t,e.indexOfPath=n,e.parseLineAndColumnAware=_,e.randomPath=E;function M(v){return v===47||v===92}function w(v){return v.replace(/[\\/]/g,y.posix.sep)}function h(v){return v.indexOf("/")===-1&&(v=w(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function c(v,A=y.posix.sep){if(!v)return"";const W=v.length,Y=v.charCodeAt(0);if(M(Y)){if(M(v.charCodeAt(1))&&!M(v.charCodeAt(2))){let D=3;const a=D;for(;D<W&&!M(v.charCodeAt(D));D++);if(a!==D&&!M(v.charCodeAt(D+1))){for(D+=1;D<W;D++)if(M(v.charCodeAt(D)))return v.slice(0,D+1).replace(/[\\/]/g,A)}}return A}else if(i(Y)&&v.charCodeAt(1)===58)return M(v.charCodeAt(2))?v.slice(0,2)+A:v.slice(0,2);let N=v.indexOf("://");if(N!==-1){for(N+=3;N<W;N++)if(M(v.charCodeAt(N)))return v.slice(0,N+1)}return""}function S(v){if(!k.isWindows||!v||v.length<5)return!1;let A=v.charCodeAt(0);if(A!==92||(A=v.charCodeAt(1),A!==92))return!1;let W=2;const Y=W;for(;W<v.length&&(A=v.charCodeAt(W),A!==92);W++);return!(Y===W||(A=v.charCodeAt(W+1),isNaN(A)||A===92))}const p=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(v,A=k.isWindows){const W=A?p:b;return!(!v||v.length===0||/^\s+$/.test(v)||(W.lastIndex=0,W.test(v))||A&&u.test(v)||v==="."||v===".."||A&&v[v.length-1]==="."||A&&v.length!==v.trim().length||v.length>255)}function g(v,A,W){const Y=v===A;return!W||Y?Y:!v||!A?!1:(0,C.equalsIgnoreCase)(v,A)}function s(v,A,W,Y=y.sep){if(v===A)return!0;if(!v||!A||A.length>v.length)return!1;if(W){if(!(0,C.startsWithIgnoreCase)(v,A))return!1;if(A.length===v.length)return!0;let D=A.length;return A.charAt(A.length-1)===Y&&D--,v.charAt(D)===Y}return A.charAt(A.length-1)!==Y&&(A+=Y),v.indexOf(A)===0}function i(v){return v>=65&&v<=90||v>=97&&v<=122}function o(v,A){return k.isWindows&&v.endsWith(":")&&(v+=y.sep),(0,y.isAbsolute)(v)||(v=(0,y.join)(A,v)),v=(0,y.normalize)(v),k.isWindows?(v=(0,C.rtrim)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,C.rtrim)(v,y.sep),v||(v=y.sep)),v}function f(v){const A=(0,y.normalize)(v);return k.isWindows?v.length>3?!1:r(A)&&(v.length===2||A.charCodeAt(2)===92):A===y.posix.sep}function r(v,A=k.isWindows){return A?i(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,A=k.isWindows){return r(v,A)?v[0]:void 0}function n(v,A,W){return A.length>v.length?-1:v===A?0:(W&&(v=v.toLowerCase(),A=A.toLowerCase()),v.indexOf(A))}function _(v){const A=v.split(":");let W,Y,N;for(const D of A){const a=Number(D);(0,I.isNumber)(a)?Y===void 0?Y=a:N===void 0&&(N=a):W=W?[W,D].join(":"):D}if(!W)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:W,line:Y!==void 0?Y:void 0,column:N!==void 0?N:Y!==void 0?1:void 0}}const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",m="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(v,A,W=8){let Y="";for(let D=0;D<W;D++){let a;D===0&&k.isWindows&&!A&&(W===3||W===4)?a=m:a=O,Y+=a.charAt(Math.floor(Math.random()*a.length))}let N;return A?N=`${A}-${Y}`:N=Y,v?(0,y.join)(v,N):N}}),define(he[33],de([0,1,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=I,e.removeDangerousEnvVariables=M;var k;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(k||(e.Source=k={}));var C;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function I(w,...h){const c=h.reduce((b,u)=>(b[u]=!0,b),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(b=>!c[b]).forEach(b=>{for(let u=0;u<S.length;u++)if(b.search(S[u])!==-1){delete w[b];break}})}function M(w){w&&(delete w.DEBUG,y.isMacintosh&&delete w.DYLD_LIBRARY_PATH,y.isLinux&&delete w.LD_PRELOAD)}}),define(he[6],de([0,1,5,3]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=l,e.uriToFsPath=r;const C=/^\w[\w\d+.-]*$/,I=/^\//,M=/^\/\//;function w(m,E){if(!m.scheme&&E)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${m.authority}", path: "${m.path}", query: "${m.query}", fragment: "${m.fragment}"}`);if(m.scheme&&!C.test(m.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(m.path){if(m.authority){if(!I.test(m.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(m.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(m,E){return!m&&!E?"file":m}function c(m,E){switch(m){case"https":case"http":case"file":E?E[0]!==p&&(E=p+E):E=p;break}return E}const S="",p="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(E){return E instanceof u?!0:E?typeof E.authority=="string"&&typeof E.fragment=="string"&&typeof E.path=="string"&&typeof E.query=="string"&&typeof E.scheme=="string"&&typeof E.fsPath=="string"&&typeof E.with=="function"&&typeof E.toString=="function":!1}constructor(E,v,A,W,Y,N=!1){typeof E=="object"?(this.scheme=E.scheme||S,this.authority=E.authority||S,this.path=E.path||S,this.query=E.query||S,this.fragment=E.fragment||S):(this.scheme=h(E,N),this.authority=v||S,this.path=c(this.scheme,A||S),this.query=W||S,this.fragment=Y||S,w(this,N))}get fsPath(){return r(this,!1)}with(E){if(!E)return this;let{scheme:v,authority:A,path:W,query:Y,fragment:N}=E;return v===void 0?v=this.scheme:v===null&&(v=S),A===void 0?A=this.authority:A===null&&(A=S),W===void 0?W=this.path:W===null&&(W=S),Y===void 0?Y=this.query:Y===null&&(Y=S),N===void 0?N=this.fragment:N===null&&(N=S),v===this.scheme&&A===this.authority&&W===this.path&&Y===this.query&&N===this.fragment?this:new s(v,A,W,Y,N)}static parse(E,v=!1){const A=b.exec(E);return A?new s(A[2]||S,O(A[4]||S),O(A[5]||S),O(A[7]||S),O(A[9]||S),v):new s(S,S,S,S,S)}static file(E){let v=S;if(k.isWindows&&(E=E.replace(/\\/g,p)),E[0]===p&&E[1]===p){const A=E.indexOf(p,2);A===-1?(v=E.substring(2),E=p):(v=E.substring(2,A),E=E.substring(A)||p)}return new s("file",v,E,S,S)}static from(E,v){return new s(E.scheme,E.authority,E.path,E.query,E.fragment,v)}static joinPath(E,...v){if(!E.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let A;return k.isWindows&&E.scheme==="file"?A=u.file(y.win32.join(r(E,!0),...v)).path:A=y.posix.join(E.path,...v),E.with({path:A})}toString(E=!1){return t(this,E)}toJSON(){return this}static revive(E){if(E){if(E instanceof u)return E;{const v=new s(E);return v._formatted=E.external??null,v._fsPath=E._sep===g?E.fsPath??null:null,v}}else return E}}e.URI=u;function l(m){return!m||typeof m!="object"?!1:typeof m.scheme=="string"&&(typeof m.authority=="string"||typeof m.authority>"u")&&(typeof m.path=="string"||typeof m.path>"u")&&(typeof m.query=="string"||typeof m.query>"u")&&(typeof m.fragment=="string"||typeof m.fragment>"u")}const g=k.isWindows?1:void 0;class s extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(E=!1){return E?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const E={$mid:1};return this._fsPath&&(E.fsPath=this._fsPath,E._sep=g),this._formatted&&(E.external=this._formatted),this.path&&(E.path=this.path),this.scheme&&(E.scheme=this.scheme),this.authority&&(E.authority=this.authority),this.query&&(E.query=this.query),this.fragment&&(E.fragment=this.fragment),E}}const i={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function o(m,E,v){let A,W=-1;for(let Y=0;Y<m.length;Y++){const N=m.charCodeAt(Y);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||E&&N===47||v&&N===91||v&&N===93||v&&N===58)W!==-1&&(A+=encodeURIComponent(m.substring(W,Y)),W=-1),A!==void 0&&(A+=m.charAt(Y));else{A===void 0&&(A=m.substr(0,Y));const D=i[N];D!==void 0?(W!==-1&&(A+=encodeURIComponent(m.substring(W,Y)),W=-1),A+=D):W===-1&&(W=Y)}}return W!==-1&&(A+=encodeURIComponent(m.substring(W))),A!==void 0?A:m}function f(m){let E;for(let v=0;v<m.length;v++){const A=m.charCodeAt(v);A===35||A===63?(E===void 0&&(E=m.substr(0,v)),E+=i[A]):E!==void 0&&(E+=m[v])}return E!==void 0?E:m}function r(m,E){let v;return m.authority&&m.path.length>1&&m.scheme==="file"?v=`//${m.authority}${m.path}`:m.path.charCodeAt(0)===47&&(m.path.charCodeAt(1)>=65&&m.path.charCodeAt(1)<=90||m.path.charCodeAt(1)>=97&&m.path.charCodeAt(1)<=122)&&m.path.charCodeAt(2)===58?E?v=m.path.substr(1):v=m.path[1].toLowerCase()+m.path.substr(2):v=m.path,k.isWindows&&(v=v.replace(/\//g,"\\")),v}function t(m,E){const v=E?f:o;let A="",{scheme:W,authority:Y,path:N,query:D,fragment:a}=m;if(W&&(A+=W,A+=":"),(Y||W==="file")&&(A+=p,A+=p),Y){let L=Y.indexOf("@");if(L!==-1){const P=Y.substr(0,L);Y=Y.substr(L+1),L=P.lastIndexOf(":"),L===-1?A+=v(P,!1,!1):(A+=v(P.substr(0,L),!1,!1),A+=":",A+=v(P.substr(L+1),!1,!0)),A+="@"}Y=Y.toLowerCase(),L=Y.lastIndexOf(":"),L===-1?A+=v(Y,!1,!0):(A+=v(Y.substr(0,L),!1,!0),A+=Y.substr(L))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const L=N.charCodeAt(1);L>=65&&L<=90&&(N=`/${String.fromCharCode(L+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const L=N.charCodeAt(0);L>=65&&L<=90&&(N=`${String.fromCharCode(L+32)}:${N.substr(2)}`)}A+=v(N,!0,!1)}return D&&(A+="?",A+=v(D,!1,!1)),a&&(A+="#",A+=E?a:o(a,!1,!1)),A}function n(m){try{return decodeURIComponent(m)}catch{return m.length>3?m.substr(0,3)+n(m.substr(3)):m}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(m){return m.match(_)?m.replace(_,E=>n(E)):m}}),define(he[58],de([0,1,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=k,e.parse=C,e.getFirstFrame=I,e.log=w;function k(c){const S=c;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function C(c){const S=[];let p;try{const b=JSON.parse(c.arguments),u=b[b.length-1];u&&u.__$stack&&(b.pop(),p=u.__$stack),S.push(...b)}catch{S.push("Unable to log remote console arguments",c.arguments)}return{args:S,stack:p}}function I(c){if(typeof c!="string")return I(C(c).stack);const S=c;if(S){const p=M(S),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(b&&b.length===4)return{uri:y.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function M(c){if(!c)return c;const S=c.indexOf(`
`);return S===-1?c:c.substring(0,S)}function w(c,S){const{args:p,stack:b}=C(c),u=typeof p[0]=="string"&&p.length===1;let l=M(b);l&&(l=`(${l.trim()})`);let g=[];if(typeof p[0]=="string"?l&&u?g=[`%c[${S}] %c${p[0]} %c${l}`,h("blue"),h(""),h("grey")]:g=[`%c[${S}] %c${p[0]}`,h("blue"),h(""),...p.slice(1)]:g=[`%c[${S}]%`,h("blue"),...p],l&&!u&&g.push(l),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}function h(c){return`color: ${c}`}}),define(he[59],de([0,1,18,6]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=C,e.parse=I,e.revive=w;function C(h){return JSON.stringify(h,M)}function I(h){let c=JSON.parse(h);return c=w(c),c}function M(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function w(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return k.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof y.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let S=0;S<h.length;++S)h[S]=w(h[S],c+1);else for(const S in h)Object.hasOwnProperty.call(h,S)&&(h[S]=w(h[S],c+1))}return h}}),define(he[19],de([0,1,7,3,12,6,5]),function(le,e,y,k,C,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=h,e.matchesSomeScheme=c,e.getServerRootPath=p;var w;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting"})(w||(e.Schemas=w={}));function h(l,g){return I.URI.isUri(l)?(0,C.equalsIgnoreCase)(l.scheme,g):(0,C.startsWithIgnoreCase)(l,g+":")}function c(l,...g){return g.some(s=>h(l,s))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g,s){this._serverRootPath=p(g,s)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return M.posix.join(this._serverRootPath,w.vscodeRemoteResource)}set(g,s,i){this._hosts[g]=s,this._ports[g]=i}setConnectionToken(g,s){this._connectionTokens[g]=s}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(t){return y.onUnexpectedError(t),g}const s=g.authority;let i=this._hosts[s];i&&i.indexOf(":")!==-1&&i.indexOf("[")===-1&&(i=`[${i}]`);const o=this._ports[s],f=this._connectionTokens[s];let r=`path=${encodeURIComponent(g.path)}`;return typeof f=="string"&&(r+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),I.URI.from({scheme:k.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${i}:${o}`,path:this._remoteResourcesPath,query:r})}}e.RemoteAuthorities=new S;function p(l,g){return M.posix.join(g??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class b{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const s=this.toUri(g,le);return this.uriToBrowserUri(s)}uriToBrowserUri(g){return g.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===w.file&&(k.isNative||k.webWorkerOrigin===`${w.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?g.with({scheme:w.vscodeFileResource,authority:g.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const s=this.toUri(g,le);return this.uriToFileUri(s)}uriToFileUri(g){return g.scheme===w.vscodeFileResource?g.with({scheme:w.file,authority:g.authority!==b.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,s){return I.URI.isUri(g)?g:I.URI.parse(s.toUrl(g))}}e.FileAccess=new b;var u;(function(l){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(g.get("3"));const s="vscode-coi";function i(f){let r;typeof f=="string"?r=new URL(f).searchParams:f instanceof URL?r=f.searchParams:I.URI.isUri(f)&&(r=new URL(f.toString(!0)).searchParams);const t=r?.get(s);if(t)return g.get(t)}l.getHeadersFromQuery=i;function o(f,r,t){if(!globalThis.crossOriginIsolated)return;const n=r&&t?"3":t?"2":"1";f instanceof URLSearchParams?f.set(s,n):f[s]=n}l.addSearchParam=o})(u||(e.COI=u={}))}),define(he[23],de([0,1,32,19,5,3,12,6]),function(le,e,y,k,C,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=h,e.distinctParents=S,e.toLocalResource=b;function h(u){return(0,w.uriToFsPath)(u,!0)}class c{constructor(l){this._ignorePathCasing=l}compare(l,g,s=!1){return l===g?0:(0,M.compare)(this.getComparisonKey(l,s),this.getComparisonKey(g,s))}isEqual(l,g,s=!1){return l===g?!0:!l||!g?!1:this.getComparisonKey(l,s)===this.getComparisonKey(g,s)}getComparisonKey(l,g=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,g,s=!1){if(l.scheme===g.scheme){if(l.scheme===k.Schemas.file)return y.isEqualOrParent(h(l),h(g),this._ignorePathCasing(l))&&l.query===g.query&&(s||l.fragment===g.fragment);if((0,e.isEqualAuthority)(l.authority,g.authority))return y.isEqualOrParent(l.path,g.path,this._ignorePathCasing(l),"/")&&l.query===g.query&&(s||l.fragment===g.fragment)}return!1}joinPath(l,...g){return w.URI.joinPath(l,...g)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return C.posix.basename(l.path)}extname(l){return C.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let g;return l.scheme===k.Schemas.file?g=w.URI.file(C.dirname(h(l))).path:(g=C.posix.dirname(l.path),l.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),g="/")),l.with({path:g})}normalizePath(l){if(!l.path.length)return l;let g;return l.scheme===k.Schemas.file?g=w.URI.file(C.normalize(h(l))).path:g=C.posix.normalize(l.path),l.with({path:g})}relativePath(l,g){if(l.scheme!==g.scheme||!(0,e.isEqualAuthority)(l.authority,g.authority))return;if(l.scheme===k.Schemas.file){const o=C.relative(h(l),h(g));return I.isWindows?y.toSlashes(o):o}let s=l.path||"/";const i=g.path||"/";if(this._ignorePathCasing(l)){let o=0;for(const f=Math.min(s.length,i.length);o<f&&!(s.charCodeAt(o)!==i.charCodeAt(o)&&s.charAt(o).toLowerCase()!==i.charAt(o).toLowerCase());o++);s=i.substr(0,o)+s.substr(o)}return C.posix.relative(s,i)}resolvePath(l,g){if(l.scheme===k.Schemas.file){const s=w.URI.file(C.resolve(h(l),g));return l.with({authority:s.authority,path:s.path})}return g=y.toPosixPath(g),l.with({path:C.posix.resolve(l.path,g)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,g){return l===g||l!==void 0&&g!==void 0&&(0,M.equalsIgnoreCase)(l,g)}hasTrailingPathSeparator(l,g=C.sep){if(l.scheme===k.Schemas.file){const s=h(l);return s.length>y.getRoot(s).length&&s[s.length-1]===g}else{const s=l.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,g=C.sep){return(0,e.hasTrailingPathSeparator)(l,g)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,g=C.sep){let s=!1;if(l.scheme===k.Schemas.file){const i=h(l);s=i!==void 0&&i.length===y.getRoot(i).length&&i[i.length-1]===g}else{g="/";const i=l.path;s=i.length===1&&i.charCodeAt(i.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(l,g)?l.with({path:l.path+"/"}):l}}e.ExtUri=c,e.extUri=new c(()=>!1),e.extUriBiasedIgnorePathCase=new c(u=>u.scheme===k.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new c(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(u,l){const g=[];for(let s=0;s<u.length;s++){const i=l(u[s]);u.some((o,f)=>f===s?!1:(0,e.isEqualOrParent)(i,l(o)))||g.push(u[s])}return g}var p;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function l(g){const s=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(f=>{const[r,t]=f.split(":");r&&t&&s.set(r,t)});const o=g.path.substring(0,g.path.indexOf(";"));return o&&s.set(u.META_DATA_MIME,o),s}u.parseMetaData=l})(p||(e.DataUri=p={}));function b(u,l,g){if(l){let s=u.path;return s&&s[0]!==C.posix.sep&&(s=C.posix.sep+s),u.with({scheme:g,authority:l,path:s})}return u.with({scheme:g})}}),define(he[10],de([0,1,17,7,4,2,23,3,50,22]),function(le,e,y,k,C,I,M,w,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=S,e.createCancelablePromise=p,e.raceCancellation=b,e.raceCancellationError=u,e.raceCancellablePromises=l,e.raceTimeout=g,e.asPromise=s,e.promiseWithResolvers=i,e.timeout=v,e.disposableTimeout=A,e.sequence=W,e.first=Y,e.firstParallel=N,e.retry=q,e.createCancelableAsyncIterable=H;function S(F){return!!F&&typeof F.then=="function"}function p(F){const R=new y.CancellationTokenSource,B=F(R.token),V=new Promise((K,oe)=>{const ue=R.token.onCancellationRequested(()=>{ue.dispose(),oe(new k.CancellationError)});Promise.resolve(B).then(pe=>{ue.dispose(),R.dispose(),K(pe)},pe=>{ue.dispose(),R.dispose(),oe(pe)})});return new class{cancel(){R.cancel(),R.dispose()}then(K,oe){return V.then(K,oe)}catch(K){return this.then(void 0,K)}finally(K){return V.finally(K)}}}function b(F,R,B){return new Promise((V,K)=>{const oe=R.onCancellationRequested(()=>{oe.dispose(),V(B)});F.then(V,K).finally(()=>oe.dispose())})}function u(F,R){return new Promise((B,V)=>{const K=R.onCancellationRequested(()=>{K.dispose(),V(new k.CancellationError)});F.then(B,V).finally(()=>K.dispose())})}async function l(F){let R=-1;const B=F.map((V,K)=>V.then(oe=>(R=K,oe)));try{return await Promise.race(B)}finally{F.forEach((V,K)=>{K!==R&&V.cancel()})}}function g(F,R,B){let V;const K=setTimeout(()=>{V?.(void 0),B?.()},R);return Promise.race([F.finally(()=>clearTimeout(K)),new Promise(oe=>V=oe)])}function s(F){return new Promise((R,B)=>{const V=F();S(V)?V.then(R,B):R(V)})}function i(){let F,R;return{promise:new Promise((V,K)=>{F=V,R=K}),resolve:F,reject:R}}class o{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const B=()=>{if(this.queuedPromise=null,this.isDisposed)return;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(B,B).then(V)})}return new Promise((B,V)=>{this.queuedPromise.then(B,V)})}return this.activePromise=R(),new Promise((B,V)=>{this.activePromise.then(K=>{this.activePromise=null,B(K)},K=>{this.activePromise=null,V(K)})})}dispose(){this.isDisposed=!0}}e.Throttler=o;class f{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}e.Sequencer=f;class r{constructor(){this.promiseMap=new Map}queue(R,B){const K=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(R)===K&&this.promiseMap.delete(R)});return this.promiseMap.set(R,K),K}}e.SequencerByKey=r;const t=(F,R)=>{let B=!0;const V=setTimeout(()=>{B=!1,R()},F);return{isTriggered:()=>B,dispose:()=>{clearTimeout(V),B=!1}}},n=F=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,F())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};class _{constructor(R){this.defaultDelay=R,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,B=this.defaultDelay){this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((K,oe)=>{this.doResolve=K,this.doReject=oe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const K=this.task;return this.task=null,K()}}));const V=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=B===h.MicrotaskDelay?n(V):t(B,V),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=_;class O{constructor(R){this.delayer=new _(R),this.throttler=new o}trigger(R,B){return this.delayer.trigger(()=>this.throttler.queue(R),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=O;class m{constructor(){this._isOpen=!1,this._promise=new Promise((R,B)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=m;class E extends m{constructor(R){super(),this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function v(F,R){return R?new Promise((B,V)=>{const K=setTimeout(()=>{oe.dispose(),B()},F),oe=R.onCancellationRequested(()=>{clearTimeout(K),oe.dispose(),V(new k.CancellationError)})}):p(B=>v(F,B))}function A(F,R=0,B){const V=setTimeout(()=>{F(),B&&K.dispose()},R),K=(0,I.toDisposable)(()=>{clearTimeout(V),B?.deleteAndLeak(K)});return B?.add(K),K}function W(F){const R=[];let B=0;const V=F.length;function K(){return B<V?F[B++]():null}function oe(ue){ue!=null&&R.push(ue);const pe=K();return pe?pe.then(oe):Promise.resolve(R)}return Promise.resolve(null).then(oe)}function Y(F,R=V=>!!V,B=null){let V=0;const K=F.length,oe=()=>{if(V>=K)return Promise.resolve(B);const ue=F[V++];return Promise.resolve(ue()).then(ve=>R(ve)?Promise.resolve(ve):oe())};return oe()}function N(F,R=V=>!!V,B=null){if(F.length===0)return Promise.resolve(B);let V=F.length;const K=()=>{V=-1;for(const oe of F)oe.cancel?.()};return new Promise((oe,ue)=>{for(const pe of F)pe.then(ve=>{--V>=0&&R(ve)?(K(),oe(ve)):V===0&&oe(B)}).catch(ve=>{--V>=0&&(K(),ue(ve))})})}class D{constructor(R){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(R){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((B,V)=>{this.outstandingPromises.push({factory:R,c:B,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const B=R.factory();B.then(R.c,R.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=D;class a extends D{constructor(){super(1)}}e.Queue=a;class L{constructor(){this.sequentializer=new Q,this.tasks=0}queue(R){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,R())):this.sequentializer.run(this.tasks++,R())}}e.LimitedQueue=L;class P{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const R=new ee;return this.drainers.add(R),R.p}isDrained(){for(const[,R]of this.queues)if(R.size>0)return!1;return!0}queueSize(R,B=M.extUri){const V=B.getComparisonKey(R);return this.queues.get(V)?.size??0}queueFor(R,B,V=M.extUri){const K=V.getComparisonKey(R);let oe=this.queues.get(K);if(!oe){oe=new a;const ue=this.drainListenerCount++,pe=C.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.queues.delete(K),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ue),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new I.DisposableMap),this.drainListeners.set(ue,pe),this.queues.set(K,oe)}return oe.queue(B)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const R of this.drainers)R.complete();this.drainers.clear()}dispose(){for(const[,R]of this.queues)R.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=P;class T{constructor(R,B){this._token=-1,typeof R=="function"&&typeof B=="number"&&this.setIfNotSet(R,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},B)}setIfNotSet(R,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},B))}}e.TimeoutTimer=T;class J{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(R,B,V=globalThis){this.cancel();const K=V.setInterval(()=>{R()},B);this.disposable=(0,I.toDisposable)(()=>{V.clearInterval(K),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=J;class re{constructor(R,B){this.timeoutToken=-1,this.runner=R,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=re;class x{constructor(R,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=R,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(R=this.timeout){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(R/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=x;class te extends re{constructor(R,B){super(R,B),this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner?.(R)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=te;class ce extends I.Disposable{constructor(R,B){super(),this.options=R,this.handler=B,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.options.maxBufferedWork)return!1}else if(this.pending+R.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const B of R)this.pendingWork.push(B);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new re(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(F,R)=>{(0,w.setTimeout0)(()=>{if(B)return;const V=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e._runWhenIdle=(F,R,B)=>{const V=F.requestIdleCallback(R,typeof B=="number"?{timeout:B}:void 0);let K=!1;return{dispose(){K||(K=!0,F.cancelIdleCallback(V))}}},e.runWhenGlobalIdle=F=>(0,e._runWhenIdle)(globalThis,F)}();class me{constructor(R,B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(R,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=me;class G extends me{constructor(R){super(globalThis,R)}}e.GlobalIdleValue=G;async function q(F,R,B){let V;for(let K=0;K<B;K++)try{return await F()}catch(oe){V=oe,await v(R)}throw V}class Q{isRunning(R){return typeof R=="number"?this._running?.taskId===R:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(R,B,V){return this._running={taskId:R,cancel:()=>V?.(),promise:B},B.then(()=>this.doneRunning(R),()=>this.doneRunning(R)),B}doneRunning(R){this._running&&R===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const R=this._queued;this._queued=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}queue(R){if(this._queued)this._queued.run=R;else{const{promise:B,resolve:V,reject:K}=i();this._queued={run:R,promise:B,promiseResolve:V,promiseReject:K}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Q;class ie{constructor(R,B=()=>Date.now()){this.interval=R,this.nowFn=B,this.lastIncrementTime=0,this.value=0}increment(){const R=this.nowFn();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}e.IntervalCounter=ie;var $;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})($||($={}));class ee{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((R,B)=>{this.completeCallback=R,this.errorCallback=B})}complete(R){return new Promise(B=>{this.completeCallback(R),this.outcome={outcome:0,value:R},B()})}error(R){return new Promise(B=>{this.errorCallback(R),this.outcome={outcome:1,value:R},B()})}cancel(){return this.error(new k.CancellationError)}}e.DeferredPromise=ee;var ge;(function(F){async function R(V){let K;const oe=await Promise.all(V.map(ue=>ue.then(pe=>pe,pe=>{K||(K=pe)})));if(typeof K<"u")throw K;return oe}F.settled=R;function B(V){return new Promise(async(K,oe)=>{try{await V(K,oe)}catch(ue){oe(ue)}})}F.withAsyncBody=B})(ge||(e.Promises=ge={}));class Z{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(R){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=R.then(B=>(this._value=B,this._isResolved=!0,B),B=>{throw this._error=B,this._isResolved=!0,B})}requireValue(){if(!this._isResolved)throw new k.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=Z;class d{constructor(R){this._compute=R,this._promise=new c.Lazy(()=>new Z(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=d;var z;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(z||(z={}));class ne{static fromArray(R){return new ne(B=>{B.emitMany(R)})}static fromPromise(R){return new ne(async B=>{B.emitMany(await R)})}static fromPromises(R){return new ne(async B=>{await Promise.all(R.map(async V=>B.emitOne(await V)))})}static merge(R){return new ne(async B=>{await Promise.all(R.map(async V=>{for await(const K of V)B.emitOne(K)}))})}static{this.EMPTY=ne.fromArray([])}constructor(R){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const B={emitOne:V=>this.emitOne(V),emitMany:V=>this.emitMany(V),reject:V=>this.reject(V)};try{await Promise.resolve(R(B)),this.resolve()}catch(V){this.reject(V)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(R<this._results.length)return{done:!1,value:this._results[R++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(R,B){return new ne(async V=>{for await(const K of R)V.emitOne(B(K))})}map(R){return ne.map(this,R)}static filter(R,B){return new ne(async V=>{for await(const K of R)B(K)&&V.emitOne(K)})}filter(R){return ne.filter(this,R)}static coalesce(R){return ne.filter(R,B=>!!B)}coalesce(){return ne.coalesce(this)}static async toPromise(R){const B=[];for await(const V of R)B.push(V);return B}toPromise(){return ne.toPromise(this)}emitOne(R){this._state===0&&(this._results.push(R),this._onStateChanged.fire())}emitMany(R){this._state===0&&(this._results=this._results.concat(R),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(R){this._state===0&&(this._state=2,this._error=R,this._onStateChanged.fire())}}e.AsyncIterableObject=ne;class se extends ne{constructor(R,B){super(B),this._source=R}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function H(F){const R=new y.CancellationTokenSource,B=F(R.token);return new se(R,async V=>{const K=R.token.onCancellationRequested(()=>{K.dispose(),R.dispose(),V.reject(new k.CancellationError)});try{for await(const oe of B){if(R.token.isCancellationRequested)return;V.emitOne(oe)}K.dispose(),R.dispose()}catch(oe){K.dispose(),R.dispose(),V.reject(oe)}})}class j{constructor(){this._deferred=new ee,this._asyncIterable=new ne(V=>{if(R){V.reject(R);return}return B&&V.emitMany(B),this._errorFn=K=>V.reject(K),this._emitFn=K=>V.emitOne(K),this._deferred.p});let R,B;this._emitFn=V=>{B||(B=[]),B.push(V)},this._errorFn=V=>{R||(R=V)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(R){this._errorFn(R),this._deferred.complete()}emitOne(R){this._emitFn(R)}}e.AsyncIterableSource=j}),define(he[60],de([0,1,18,6]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=w,e.transformIncomingURIs=c,e.transformAndReviveIncomingURIs=S;function C(p){return p.toJSON()}class I{constructor(b){this._uriTransformer=b}transformIncoming(b){const u=this._uriTransformer.transformIncoming(b);return u===b?b:C(k.URI.from(u))}transformOutgoing(b){const u=this._uriTransformer.transformOutgoing(b);return u===b?b:C(k.URI.from(u))}transformOutgoingURI(b){const u=this._uriTransformer.transformOutgoing(b);return u===b?b:k.URI.from(u)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function M(p,b,u){if(!p||u>200)return null;if(typeof p=="object"){if(p instanceof k.URI)return b.transformOutgoing(p);for(const l in p)if(Object.hasOwnProperty.call(p,l)){const g=M(p[l],b,u+1);g!==null&&(p[l]=g)}}return null}function w(p,b){const u=M(p,b,0);return u===null?p:u}function h(p,b,u,l){if(!p||l>200)return null;if(typeof p=="object"){if(p.$mid===1)return u?k.URI.revive(b.transformIncoming(p)):b.transformIncoming(p);if(p instanceof y.VSBuffer)return null;for(const g in p)if(Object.hasOwnProperty.call(p,g)){const s=h(p[g],b,u,l+1);s!==null&&(p[g]=s)}}return null}function c(p,b){const u=h(p,b,!1,0);return u===null?p:u}function S(p,b){const u=h(p,b,!0,0);return u===null?p:u}}),define(he[24],de([0,1,105,20,106,10,32,45,5,3,23,6]),function(le,e,y,k,C,I,M,w,h,c,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=s,e.readdirSync=f,e.whenDeleted=n,e.configureFlushOnWrite=v,e.writeFileSync=W;var b;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function u(x,te=b.UNLINK,ce){if((0,M.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");return te===b.UNLINK?g(x):l(x,ce)}async function l(x,te=(0,M.randomPath)((0,k.tmpdir)())){try{try{await y.promises.rename(x,te)}catch(ce){return ce.code==="ENOENT"?void 0:g(x)}g(te).catch(ce=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function g(x){return(0,C.promisify)(y.rm)(x,{recursive:!0,force:!0,maxRetries:3})}function s(x){if((0,M.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}async function i(x,te){return r(await(te?o(x):(0,C.promisify)(y.readdir)(x)))}async function o(x){try{return await(0,C.promisify)(y.readdir)(x,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const te=[],ce=await i(x);for(const me of ce){let G=!1,q=!1,Q=!1;try{const ie=await e.Promises.lstat((0,h.join)(x,me));G=ie.isFile(),q=ie.isDirectory(),Q=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}te.push({name:me,isFile:()=>G,isDirectory:()=>q,isSymbolicLink:()=>Q})}return te}function f(x){return r(y.readdirSync(x))}function r(x){return x.map(te=>typeof te=="string"?c.isMacintosh?(0,w.normalizeNFC)(te):te:(te.name=c.isMacintosh?(0,w.normalizeNFC)(te.name):te.name,te))}async function t(x){const te=await i(x),ce=[];for(const me of te)await _.existsDirectory((0,h.join)(x,me))&&ce.push(me);return ce}function n(x,te=1e3){return new Promise(ce=>{let me=!1;const G=setInterval(()=>{me||(me=!0,y.access(x,q=>{me=!1,q&&(clearInterval(G),ce(void 0))}))},te)})}var _;(function(x){async function te(G){let q;try{if(q=await e.Promises.lstat(G),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(c.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ie}throw Q}}x.stat=te;async function ce(G){try{const{stat:q,symbolicLink:Q}=await x.stat(G);return q.isFile()&&Q?.dangling!==!0}catch{}return!1}x.existsFile=ce;async function me(G){try{const{stat:q,symbolicLink:Q}=await x.stat(G);return q.isDirectory()&&Q?.dangling!==!0}catch{}return!1}x.existsDirectory=me})(_||(e.SymlinkSupport=_={}));const O=new I.ResourceQueue;function m(x,te,ce){return O.queueFor(p.URI.file(x),()=>{const me=Y(ce);return new Promise((G,q)=>A(x,te,me,Q=>Q?q(Q):G()))},S.extUriBiasedIgnorePathCase)}let E=!0;function v(x){E=x}function A(x,te,ce,me){if(!E)return y.writeFile(x,te,{mode:ce.mode,flag:ce.flag},me);y.open(x,ce.flag,ce.mode,(G,q)=>{if(G)return me(G);y.writeFile(q,te,Q=>{if(Q)return y.close(q,()=>me(Q));y.fdatasync(q,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),v(!1)),y.close(q,$=>me($))))})})}function W(x,te,ce){const me=Y(ce);if(!E)return y.writeFileSync(x,te,{mode:me.mode,flag:me.flag});const G=y.openSync(x,me.flag,me.mode);try{y.writeFileSync(G,te);try{y.fdatasyncSync(G)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),v(!1)}}finally{y.closeSync(G)}}function Y(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function N(x,te,ce=6e4){if(x!==te)try{c.isWindows&&typeof ce=="number"?await D(x,te,Date.now(),ce):await(0,C.promisify)(y.rename)(x,te)}catch(me){if(x.toLowerCase()!==te.toLowerCase()&&me.code==="EXDEV"||x.endsWith("."))await a(x,te,{preserveSymlinks:!1}),await u(x,b.MOVE);else throw me}}async function D(x,te,ce,me,G=0){try{return await(0,C.promisify)(y.rename)(x,te)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-ce>=me)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${q}`),q;if(G===0){let Q=!1;try{const{stat:ie}=await _.stat(te);ie.isFile()||(Q=!0)}catch{}if(Q)throw q}return await(0,I.timeout)(Math.min(100,G*10)),D(x,te,ce,me,G+1)}}async function a(x,te,ce){return P(x,te,{root:{source:x,target:te},options:ce,handledSourcePaths:new Set})}const L=511;async function P(x,te,ce){if(ce.handledSourcePaths.has(x))return;ce.handledSourcePaths.add(x);const{stat:me,symbolicLink:G}=await _.stat(x);if(G){if(ce.options.preserveSymlinks)try{return await re(x,te,ce)}catch{}if(G.dangling)return}return me.isDirectory()?T(x,te,me.mode&L,ce):J(x,te,me.mode&L)}async function T(x,te,ce,me){await e.Promises.mkdir(te,{recursive:!0,mode:ce});const G=await i(x);for(const q of G)await P((0,h.join)(x,q),(0,h.join)(te,q),me)}async function J(x,te,ce){await e.Promises.copyFile(x,te),await e.Promises.chmod(te,ce)}async function re(x,te,ce){let me=await e.Promises.readlink(x);(0,M.isEqualOrParent)(me,ce.root.source,!c.isLinux)&&(me=(0,h.join)(ce.root.target,me.substr(ce.root.source.length+1))),await e.Promises.symlink(me,te)}e.Promises=new class{get access(){return(0,C.promisify)(y.access)}get stat(){return(0,C.promisify)(y.stat)}get lstat(){return(0,C.promisify)(y.lstat)}get utimes(){return(0,C.promisify)(y.utimes)}get read(){return(x,te,ce,me,G)=>new Promise((q,Q)=>{y.read(x,te,ce,me,G,(ie,$,ee)=>ie?Q(ie):q({bytesRead:$,buffer:ee}))})}get readFile(){return(0,C.promisify)(y.readFile)}get write(){return(x,te,ce,me,G)=>new Promise((q,Q)=>{y.write(x,te,ce,me,G,(ie,$,ee)=>ie?Q(ie):q({bytesWritten:$,buffer:ee}))})}get appendFile(){return(0,C.promisify)(y.appendFile)}get fdatasync(){return(0,C.promisify)(y.fdatasync)}get truncate(){return(0,C.promisify)(y.truncate)}get copyFile(){return(0,C.promisify)(y.copyFile)}get open(){return(0,C.promisify)(y.open)}get close(){return(0,C.promisify)(y.close)}get symlink(){return(0,C.promisify)(y.symlink)}get readlink(){return(0,C.promisify)(y.readlink)}get chmod(){return(0,C.promisify)(y.chmod)}get mkdir(){return(0,C.promisify)(y.mkdir)}get unlink(){return(0,C.promisify)(y.unlink)}get rmdir(){return(0,C.promisify)(y.rmdir)}get realpath(){return(0,C.promisify)(y.realpath)}async exists(x){try{return await e.Promises.access(x),!0}catch{return!1}}get readdir(){return i}get readDirsInDir(){return t}get writeFile(){return m}get rm(){return u}get rename(){return N}get copy(){return a}}}),define(he[61],de([0,1,20,5,24]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=o,e.getFirstAvailablePowerShellInstallation=f;const I=/^\d+$/,M=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var h;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class p{constructor(t,n,_){this.exePath=t,this.displayName=n,this.knownToExist=_}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await C.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:r=!1}={}){return r?c===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:r=!1,findPreview:t=!1}={}){const n=b({useAlternateBitness:r});if(!n)return null;const _=k.join(n,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(_))return null;let O=-1,m=null;for(const A of await C.Promises.readdir(_)){let W=-1;if(t){const N=A.indexOf("-");if(N<0)continue;const D=A.substring(0,N);if(!I.test(D)||A.substring(N+1)!=="preview")continue;W=parseInt(D,10)}else{if(!I.test(A))continue;W=parseInt(A,10)}if(W<=O)continue;const Y=k.join(_,A,"pwsh.exe");await C.SymlinkSupport.existsFile(Y)&&(m=Y,O=W)}if(!m)return null;const E=n.includes("x86")?" (x86)":"",v=t?" Preview":"";return new p(m,`PowerShell${v}${E}`,!0)}async function l({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const t=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:n,pwshMsixName:_}=r?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const O of await C.Promises.readdir(t))if(n.test(O)){const m=k.join(t,O,"pwsh.exe");return new p(m,_)}return null}function g(){const r=k.join(y.homedir(),".dotnet","tools","pwsh.exe");return new p(r,".NET Core PowerShell Global Tool")}function s(){const r=k.join(process.env.windir,c===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(r,"Windows PowerShell",!0)}async function*i(){let r=await u();r&&(yield r),r=await u({useAlternateBitness:!0}),r&&(yield r),r=await l(),r&&(yield r),r=g(),r&&(yield r),r=await u({findPreview:!0}),r&&(yield r),r=await l({findPreview:!0}),r&&(yield r),r=await u({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=s(),r&&(yield r)}async function*o(){for await(const r of i())await r.exists()&&(yield r)}async function f(){for await(const r of o())return r;return null}}),define(he[34],de([0,1,5,3,15,33,8,24]),function(le,e,y,k,C,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=h,e.createQueuedSender=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(p=C.env){return p.comspec||"cmd.exe"}function c(p){let b=[],u=!1;const l=function(g){if(u){b.push(g);return}(!p.send(g,i=>{if(i&&console.error(i),u=!1,b.length>0){const o=b.slice(0);b=[],o.forEach(f=>l(f))}})||k.isWindows)&&(u=!0)};return{send:l}}var S;(function(p){async function b(u,l,g){if(y.isAbsolute(u))return u;if(l===void 0&&(l=C.cwd()),y.dirname(u)!=="."||(g===void 0&&M.isString(C.env.PATH)&&(g=C.env.PATH.split(y.delimiter)),g===void 0||g.length===0))return y.join(l,u);async function i(o){if(await w.Promises.exists(o)){let f;try{f=await w.Promises.stat(o)}catch(r){r.message.startsWith("EACCES")&&(f=await w.Promises.lstat(o))}return f?!f.isDirectory():!1}return!1}for(const o of g){let f;if(y.isAbsolute(o)?f=y.join(o,u):f=y.join(l,o,u),await i(f))return f;let r=f+".com";if(await i(r)||(r=f+".exe",await i(r)))return r}return y.join(l,u)}p.findExecutable=b})(S||(e.win32=S={}))}),define(he[62],de([0,1,26,19]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=C;function C(M){return new Promise((w,h)=>{let c;const S=new Map;function p(u,l,g,s,i){const o=S.get(l);if(u===M||o){const f={name:b(g),cmd:g,pid:u,ppid:l,load:s,mem:i};S.set(u,f),u===M&&(c=f),o&&(o.children||(o.children=[]),o.children.push(f),o.children.length>1&&(o.children=o.children.sort((r,t)=>r.pid-t.pid)))}}function b(u){const l=/--utility-sub-type=network/i,g=/--crashes-directory/i,s=/\\pipe\\winpty-control/i,i=/conhost\.exe.+--headless/i,o=/--type=([a-zA-Z-]+)/;if(g.exec(u))return"electron-crash-reporter";if(s.exec(u))return"winpty-agent";if(i.exec(u))return"conpty-agent";let f=o.exec(u);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?l.exec(u)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const r=/[a-zA-Z-]+\.js/g;let t="";do f=r.exec(u),f&&(t+=f+" ");while(f);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:u}if(process.platform==="win32"){const u=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,g)=>{le(["@vscode/windows-process-tree"],l,g)}).then(l=>{l.getProcessList(M,g=>{if(!g){h(new Error(`Root process ${M} not found`));return}l.getProcessCpuUsage(g,s=>{const i=new Map;s.forEach(o=>{const f=u(o.commandLine||"");i.set(o.pid,{name:b(f),cmd:f,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),c=i.get(M),c?(i.forEach(o=>{const f=i.get(o.ppid);f&&(f.children||(f.children=[]),f.children.push(o))}),i.forEach(o=>{o.children&&(o.children=o.children.sort((f,r)=>f.pid-r.pid))}),w(c)):h(new Error(`Root process ${M} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let u=function(){let l=[c];const g=[];for(;l.length;){const i=l.shift();i&&(g.push(i.pid),i.children&&(l=l.concat(i.children)))}let s=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+g.join(" "),(0,y.exec)(s,{},(i,o,f)=>{if(i||f)h(i||new Error(f.toString()));else{const r=o.toString().split(`
`);for(let t=0;t<g.length;t++){const n=S.get(g[t]);n.load=parseFloat(r[t])}if(!c){h(new Error(`Root process ${M} not found`));return}w(c)}})};(0,y.exec)("which ps",{},(l,g,s)=>{if(l||s)if(process.platform!=="linux")h(l||new Error(s.toString()));else{const i=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(i,{},(o,f,r)=>{o||r?h(o||new Error(r.toString())):(I(f,p),u())})}else{const i=g.toString().trim();(0,y.exec)(`${i} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,r,t)=>{f||t&&!t.includes("screen size is bogus")?h(f||new Error(t.toString())):(I(r,p),process.platform==="linux"?u():c?w(c):h(new Error(`Root process ${M} not found`)))})}})}})}function I(M,w){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=M.toString().split(`
`);for(const S of c){const p=h.exec(S.trim());p&&p.length===6&&w(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(he[63],de([0,1,20,3,61,34]),function(le,e,y,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=M;async function M(p,b){return p===1?k.isWindows?S():I.getWindowsShell(b):h(p,b)}let w=null;function h(p,b){if(k.isLinux&&p===2||k.isMacintosh&&p===3)return"/bin/bash";if(!w){let u;if(k.isWindows)u="/bin/bash";else{if(u=b.SHELL,!u)try{u=(0,y.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}w=u}return w}let c=null;async function S(){return c||(c=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),c}});var _e=this&&this.__decorate||function(le,e,y,k){var C=arguments.length,I=C<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,y):k,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(le,e,y,k);else for(var w=le.length-1;w>=0;w--)(M=le[w])&&(I=(C<3?M(I):C>3?M(e,y,I):M(e,y))||I);return C>3&&I&&Object.defineProperty(e,y,I),I};define(he[27],de([0,1,16,10,18,17,14,7,4,2,59,12,8]),function(le,e,y,k,C,I,M,w,h,c,S,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=v,e.deserialize=A,e.getDelayedChannel=L,e.getNextTickChannel=P;var u;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(u||(u={}));function l(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(g||(g={}));function s(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var i;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(i||(i={}));function o(G){let q=0;for(let Q=0;;Q+=7){const ie=G.read(1);if(q|=(ie.buffer[0]&127)<<Q,!(ie.buffer[0]&128))return q}}const f=O(0);function r(G,q){if(q===0){G.write(f);return}let Q=0;for(let $=q;$!==0;$=$>>>7)Q++;const ie=C.VSBuffer.alloc(Q);for(let $=0;q!==0;$++)ie.buffer[$]=q&127,q=q>>>7,q>0&&(ie.buffer[$]|=128);G.write(ie)}class t{constructor(q){this.buffer=q,this.pos=0}read(q){const Q=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Q.byteLength,Q}}e.BufferReader=t;class n{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=n;var _;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(_||(_={}));function O(G){const q=C.VSBuffer.alloc(1);return q.writeUInt8(G,0),q}const m={Undefined:O(_.Undefined),String:O(_.String),Buffer:O(_.Buffer),VSBuffer:O(_.VSBuffer),Array:O(_.Array),Object:O(_.Object),Uint:O(_.Int)},E=typeof Buffer<"u";function v(G,q){if(typeof q>"u")G.write(m.Undefined);else if(typeof q=="string"){const Q=C.VSBuffer.fromString(q);G.write(m.String),r(G,Q.byteLength),G.write(Q)}else if(E&&Buffer.isBuffer(q)){const Q=C.VSBuffer.wrap(q);G.write(m.Buffer),r(G,Q.byteLength),G.write(Q)}else if(q instanceof C.VSBuffer)G.write(m.VSBuffer),r(G,q.byteLength),G.write(q);else if(Array.isArray(q)){G.write(m.Array),r(G,q.length);for(const Q of q)v(G,Q)}else if(typeof q=="number"&&(q|0)===q)G.write(m.Uint),r(G,q);else{const Q=C.VSBuffer.fromString(JSON.stringify(q));G.write(m.Object),r(G,Q.byteLength),G.write(Q)}}function A(G){switch(G.read(1).readUInt8(0)){case _.Undefined:return;case _.String:return G.read(o(G)).toString();case _.Buffer:return G.read(o(G)).buffer;case _.VSBuffer:return G.read(o(G));case _.Array:{const Q=o(G),ie=[];for(let $=0;$<Q;$++)ie.push(A(G));return ie}case _.Object:return JSON.parse(G.read(o(G)).toString());case _.Int:return o(G)}}class W{constructor(q,Q,ie=null,$=1e3){this.protocol=q,this.ctx=Q,this.logger=ie,this.timeoutDelay=$,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(q,Q){this.channels.set(q,Q),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Q=this.send([q.type]);this.logger?.logOutgoing(Q,0,1,s(q.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Q,q.id,1,s(q.type),q.data);return}}}send(q,Q=void 0){const ie=new n;return v(ie,q),v(ie,Q),this.sendBuffer(ie.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Q=new t(q),ie=A(Q),$=A(Q),ee=ie[0];switch(ee){case 100:return this.logger?.logIncoming(q.byteLength,ie[1],1,`${l(ee)}: ${ie[2]}.${ie[3]}`,$),this.onPromise({type:ee,id:ie[1],channelName:ie[2],name:ie[3],arg:$});case 102:return this.logger?.logIncoming(q.byteLength,ie[1],1,`${l(ee)}: ${ie[2]}.${ie[3]}`,$),this.onEventListen({type:ee,id:ie[1],channelName:ie[2],name:ie[3],arg:$});case 101:return this.logger?.logIncoming(q.byteLength,ie[1],1,`${l(ee)}`),this.disposeActiveRequest({type:ee,id:ie[1]});case 103:return this.logger?.logIncoming(q.byteLength,ie[1],1,`${l(ee)}`),this.disposeActiveRequest({type:ee,id:ie[1]})}}onPromise(q){const Q=this.channels.get(q.channelName);if(!Q){this.collectPendingRequest(q);return}const ie=new I.CancellationTokenSource;let $;try{$=Q.call(this.ctx,q.name,q.arg,ie.token)}catch(Z){$=Promise.reject(Z)}const ee=q.id;$.then(Z=>{this.sendResponse({id:ee,data:Z,type:201})},Z=>{Z instanceof Error?this.sendResponse({id:ee,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:ee,data:Z,type:203})}).finally(()=>{ge.dispose(),this.activeRequests.delete(q.id)});const ge=(0,c.toDisposable)(()=>ie.cancel());this.activeRequests.set(q.id,ge)}onEventListen(q){const Q=this.channels.get(q.channelName);if(!Q){this.collectPendingRequest(q);return}const ie=q.id,ee=Q.listen(this.ctx,q.name,q.arg)(ge=>this.sendResponse({id:ie,data:ge,type:204}));this.activeRequests.set(q.id,ee)}disposeActiveRequest(q){const Q=this.activeRequests.get(q.id);Q&&(Q.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Q=this.pendingRequests.get(q.channelName);Q||(Q=[],this.pendingRequests.set(q.channelName,Q));const ie=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:q,timeoutTimer:ie})}flushPendingRequests(q){const Q=this.pendingRequests.get(q);if(Q){for(const ie of Q)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=W;var Y;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(Y||(e.RequestInitiator=Y={}));class N{constructor(q,Q=null){this.protocol=q,this.isDisposed=!1,this.state=i.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=Q}getChannel(q){const Q=this;return{call(ie,$,ee){return Q.isDisposed?Promise.reject(new w.CancellationError):Q.requestPromise(q,ie,$,ee)},listen(ie,$){return Q.isDisposed?h.Event.None:Q.requestEvent(q,ie,$)}}}requestPromise(q,Q,ie,$=I.CancellationToken.None){const ee=this.lastRequestId++,Z={id:ee,type:100,channelName:q,name:Q,arg:ie};if($.isCancellationRequested)return Promise.reject(new w.CancellationError);let d;return new Promise((ne,se)=>{if($.isCancellationRequested)return se(new w.CancellationError);const H=()=>{const B=V=>{switch(V.type){case 201:this.handlers.delete(ee),ne(V.data);break;case 202:{this.handlers.delete(ee);const K=new Error(V.data.message);K.stack=Array.isArray(V.data.stack)?V.data.stack.join(`
`):V.data.stack,K.name=V.data.name,se(K);break}case 203:this.handlers.delete(ee),se(V.data);break}};this.handlers.set(ee,B),this.sendRequest(Z)};let j=null;this.state===i.Idle?H():(j=(0,k.createCancelablePromise)(B=>this.whenInitialized()),j.then(()=>{j=null,H()}));const F=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ee,type:101}),se(new w.CancellationError)},R=$.onCancellationRequested(F);d=(0,c.combinedDisposable)((0,c.toDisposable)(F),R),this.activeRequests.add(d)}).finally(()=>{d.dispose(),this.activeRequests.delete(d)})}requestEvent(q,Q,ie){const $=this.lastRequestId++,ge={id:$,type:102,channelName:q,name:Q,arg:ie};let Z=null;const d=new h.Emitter({onWillAddFirstListener:()=>{Z=(0,k.createCancelablePromise)(ne=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(d),this.sendRequest(ge)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(d),this.sendRequest({id:$,type:103}))}}),z=ne=>d.fire(ne.data);return this.handlers.set($,z),d.event}sendRequest(q){switch(q.type){case 100:case 102:{const Q=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(Q,q.id,0,`${l(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Q=this.send([q.type,q.id]);this.logger?.logOutgoing(Q,q.id,0,l(q.type));return}}}send(q,Q=void 0){const ie=new n;return v(ie,q),v(ie,Q),this.sendBuffer(ie.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Q=new t(q),ie=A(Q),$=A(Q),ee=ie[0];switch(ee){case 200:return this.logger?.logIncoming(q.byteLength,0,0,s(ee)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,ie[1],0,s(ee),$),this.onResponse({type:ie[0],id:ie[1],data:$})}}onResponse(q){if(q.type===200){this.state=i.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===i.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=N,_e([M.memoize],N.prototype,"onDidInitializePromise",null);class D{get connections(){const q=[];return this._connections.forEach(Q=>q.push(Q)),q}constructor(q,Q,ie){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new c.DisposableStore,this.disposables.add(q(({protocol:$,onDidClientDisconnect:ee})=>{const ge=h.Event.once($.onMessage);this.disposables.add(ge(Z=>{const d=new t(Z),z=A(d),ne=new W($,z,Q,ie),se=new N($,Q);this.channels.forEach((j,F)=>ne.registerChannel(F,j));const H={channelServer:ne,channelClient:se,ctx:z};this._connections.add(H),this._onDidAddConnection.fire(H),this.disposables.add(ee(()=>{ne.dispose(),se.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)}))}))}))}getChannel(q,Q){const ie=this;return{call($,ee,ge){let Z;if((0,b.isFunction)(Q)){const z=(0,y.getRandomElement)(ie.connections.filter(Q));Z=z?Promise.resolve(z):h.Event.toPromise(h.Event.filter(ie.onDidAddConnection,Q))}else Z=Q.routeCall(ie,$,ee);const d=Z.then(z=>z.channelClient.getChannel(q));return L(d).call($,ee,ge)},listen($,ee){if((0,b.isFunction)(Q))return ie.getMulticastEvent(q,Q,$,ee);const ge=Q.routeEvent(ie,$,ee).then(Z=>Z.channelClient.getChannel(q));return L(ge).listen($,ee)}}}getMulticastEvent(q,Q,ie,$){const ee=this;let ge;const Z=new h.Emitter({onWillAddFirstListener:()=>{ge=new c.DisposableStore;const d=new h.EventMultiplexer,z=new Map,ne=H=>{const F=H.channelClient.getChannel(q).listen(ie,$),R=d.add(F);z.set(H,R)},se=H=>{const j=z.get(H);j&&(j.dispose(),z.delete(H))};ee.connections.filter(Q).forEach(ne),h.Event.filter(ee.onDidAddConnection,Q)(ne,void 0,ge),ee.onDidRemoveConnection(se,void 0,ge),d.event(Z.fire,Z,ge),ge.add(d)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return Z.event}registerChannel(q,Q){this.channels.set(q,Q);for(const ie of this._connections)ie.channelServer.registerChannel(q,Q)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class a{constructor(q,Q,ie=null){const $=new n;v($,Q),q.send($.buffer),this.channelClient=new N(q,ie),this.channelServer=new W(q,Q,ie)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Q){this.channelServer.registerChannel(q,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=a;function L(G){return{call(q,Q,ie){return G.then($=>$.call(q,Q,ie))},listen(q,Q){const ie=new h.Relay;return G.then($=>ie.input=$.listen(q,Q)),ie.event}}}function P(G){let q=!1;return{call(Q,ie,$){return q?G.call(Q,ie,$):(0,k.timeout)(0).then(()=>q=!0).then(()=>G.call(Q,ie,$))},listen(Q,ie){if(q)return G.listen(Q,ie);const $=new h.Relay;return(0,k.timeout)(0).then(()=>q=!0).then(()=>$.input=G.listen(Q,ie)),$.event}}}class T{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Q of q.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await h.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=T;var J;(function(G){function q(ee,ge,Z){const d=ee,z=Z&&Z.disableMarshalling,ne=new Map;for(const se in d)ie(se)&&ne.set(se,h.Event.buffer(d[se],!0,void 0,ge));return new class{listen(se,H,j){const F=ne.get(H);if(F)return F;const R=d[H];if(typeof R=="function"){if($(H))return R.call(d,j);if(ie(H))return ne.set(H,h.Event.buffer(d[H],!0,void 0,ge)),ne.get(H)}throw new w.ErrorNoTelemetry(`Event not found: ${H}`)}call(se,H,j){const F=d[H];if(typeof F=="function"){if(!z&&Array.isArray(j))for(let B=0;B<j.length;B++)j[B]=(0,S.revive)(j[B]);let R=F.apply(d,j);return R instanceof Promise||(R=Promise.resolve(R)),R}throw new w.ErrorNoTelemetry(`Method not found: ${H}`)}}}G.fromService=q;function Q(ee,ge){const Z=ge&&ge.disableMarshalling;return new Proxy({},{get(d,z){if(typeof z=="string")return ge?.properties?.has(z)?ge.properties.get(z):$(z)?function(ne){return ee.listen(z,ne)}:ie(z)?ee.listen(z):async function(...ne){let se;ge&&!(0,b.isUndefinedOrNull)(ge.context)?se=[ge.context,...ne]:se=ne;const H=await ee.call(z,se);return Z?H:(0,S.revive)(H)};throw new w.ErrorNoTelemetry(`Property not found: ${String(z)}`)}})}G.toService=Q;function ie(ee){return ee[0]==="o"&&ee[1]==="n"&&p.isUpperAsciiLetter(ee.charCodeAt(2))}function $(ee){return/^onDynamic/.test(ee)&&p.isUpperAsciiLetter(ee.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const q=G.toString();if(q!=="[object Object]")return q}return G}function te(G){return Array.isArray(G)?G.map(x):x(G)}function ce(G,q,Q,ie,$,ee,ge){ge=te(ge);const Z=re[$],d=Z[ie%Z.length];let z=[`%c[${G}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(ee)?(z=z.concat(ge),z.push(")")):z.push(ge),console.log.apply(console,z)}class me{constructor(q,Q){this._outgoingPrefix=q,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Q,ie,$,ee){this._totalOutgoing+=q,ce(this._outgoingPrefix,this._totalOutgoing,q,Q,ie,$,ee)}logIncoming(q,Q,ie,$,ee){this._totalIncoming+=q,ce(this._incomingPrefix,this._totalIncoming,q,Q,ie,$,ee)}}e.IPCLogger=me}),define(he[64],de([0,1,26,10,18,17,58,7,4,2,30,34,33,27]),function(le,e,y,k,C,I,M,w,h,c,S,p,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class l extends u.ChannelServer{constructor(i){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",o=>C.VSBuffer.wrap(Buffer.from(o,"base64")))},i),process.once("disconnect",()=>this.dispose())}}e.Server=l;class g{constructor(i,o){this.modulePath=i,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new k.Delayer(f),this.child=null,this._client=null}getChannel(i){const o=this;return{call(f,r,t){return o.requestPromise(i,f,r,t)},listen(f,r){return o.requestEvent(i,f,r)}}}requestPromise(i,o,f,r=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const t=this.getCachedChannel(i),n=(0,k.createCancelablePromise)(m=>t.call(o,f,m)),_=r.onCancellationRequested(()=>n.cancel()),O=(0,c.toDisposable)(()=>n.cancel());return this.activeRequests.add(O),n.finally(()=>{_.dispose(),this.activeRequests.delete(O),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(i,o,f){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let r;const t=new h.Emitter({onWillAddFirstListener:()=>{r=this.getCachedChannel(i).listen(o,f)(t.fire,t),this.activeRequests.add(r)},onDidRemoveLastListener:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return t.event}get client(){if(!this._client){const i=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(o.env={...o.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(o.env),this.child=(0,y.fork)(this.modulePath,i,o);const f=new h.Emitter,t=h.Event.fromNodeEventEmitter(this.child,"message",v=>v)(v=>{if((0,M.isRemoteConsoleLog)(v)){(0,M.log)(v,`IPC Library: ${this.options.serverName}`);return}f.fire(C.VSBuffer.wrap(Buffer.from(v,"base64")))}),n=this.options.useQueue?(0,p.createQueuedSender)(this.child):this.child,_=v=>this.child&&this.child.connected&&n.send(v.buffer.toString("base64")),O=f.event,m={send:_,onMessage:O};this._client=new u.ChannelClient(m);const E=()=>this.disposeClient();process.once("exit",E),this.child.on("error",v=>console.warn('IPC "'+this.options.serverName+'" errored with '+v)),this.child.on("exit",(v,A)=>{process.removeListener("exit",E),t.dispose(),this.activeRequests.forEach(W=>(0,c.dispose)(W)),this.activeRequests.clear(),v!==0&&A!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+v+" and signal "+A),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:v,signal:A})})}return this._client}getCachedChannel(i){let o=this.channels.get(i);return o||(o=this.client.getChannel(i),this.channels.set(i,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(he[65],de([0,1,31,18,27,4,8,16]),function(le,e,y,k,C,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=S;class h{constructor(b){this.port=b,this.onMessage=I.Event.fromNodeEventEmitter(this.port,"message",u=>u.data?k.VSBuffer.wrap(u.data):k.VSBuffer.alloc(0)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}class c extends C.IPCServer{static getOnDidClientConnect(b){(0,M.assertType)((0,y.isUtilityProcess)(process),"Electron Utility Process");const u=new I.Emitter;return process.parentPort.on("message",l=>{if(b?.handledClientConnection(l))return;const g=(0,w.firstOrDefault)(l.ports);g&&u.fire(g)}),I.Event.map(u.event,l=>({protocol:new h(l),onDidClientDisconnect:I.Event.fromNodeEventEmitter(l,"close")}))}constructor(b){super(c.getOnDidClientConnect(b))}}e.Server=c;function S(p,b,u){const l=g=>{g.data===b&&(p.removeListener("message",l),u())};p.on("message",l)}}),define(he[66],de([13,9]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(he[67],de([13,9]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(he[68],de([13,9]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(he[69],de([13,9]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(he[70],de([13,9]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(he[71],de([13,9]),function(le,e){return le.create("vs/platform/terminal/node/ptyService",e)}),define(he[72],de([13,9]),function(le,e){return le.create("vs/platform/terminal/node/terminalProcess",e)}),define(he[73],de([0,1,7,67]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var C;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(C||(e.TokenType=C={}));function I(...c){switch(c.length){case 1:return(0,k.localize)(0,null,c[0]);case 2:return(0,k.localize)(1,null,c[0],c[1]);case 3:return(0,k.localize)(2,null,c[0],c[1],c[2]);default:return}}const M=(0,k.localize)(3,null),w=(0,k.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return S.isTripleEq?"===":"==";case 4:return S.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,y.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(S){return this._input=S,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const p=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:p})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const p=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:p})}else this._match(126)?this._addToken(9):this._error(I("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(I("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(S){return this._isAtEnd()||this._input.charCodeAt(this._current)!==S?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(S){this._tokens.push({type:S,offset:this._start})}_error(S){const p=this._start,b=this._input.substring(this._start,this._current),u={type:19,offset:this._start,lexeme:b};this._errors.push({offset:p,lexeme:b,additionalInfo:S}),this._tokens.push(u)}_string(){this.stringRe.lastIndex=this._start;const S=this.stringRe.exec(this._input);if(S){this._current=this._start+S[0].length;const p=this._input.substring(this._start,this._current),b=h._keywords.get(p);b?this._addToken(b):this._tokens.push({type:17,lexeme:p,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(M);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let S=this._current,p=!1,b=!1;for(;;){if(S>=this._input.length){this._current=S,this._error(w);return}const l=this._input.charCodeAt(S);if(p)p=!1;else if(l===47&&!b){S++;break}else l===91?b=!0:l===92?p=!0:l===93&&(b=!1);S++}for(;S<this._input.length&&h._regexFlags.has(this._input.charCodeAt(S));)S++;this._current=S;const u=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:u,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(he[74],de([0,1,54,14,19,5,15,23,6]),function(le,e,y,k,C,I,M,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=S,e.parseDebugParams=p,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,I.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,w.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,w.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",u)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(h.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,w.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,w.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=M.env.VSCODE_PORTABLE;return u?h.URI.file((0,I.join)(u,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,I.resolve)(u):(0,I.normalize)((0,I.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?h.URI.file((0,I.resolve)(u)):h.URI.file((0,I.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,I.resolve)(u);const l=M.env.VSCODE_EXTENSIONS;if(l)return l;const g=M.env.VSCODE_PORTABLE;return g?(0,I.join)(g,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(l=>/^[^:/?#]+?:\/\//.test(l)?h.URI.parse(l):h.URI.file((0,I.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?h.URI.parse(u):h.URI.file((0,I.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const l of this.args.log||[]){const g=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(l);g&&g[1]&&g[2]&&u.push([g[1],g[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,w.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=M.env.VSCODE_PORTABLE;return u?h.URI.file((0,I.join)(u,"policy.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this._args}constructor(u,l,g){this._args=u,this.paths=l,this.productService=g,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=c,_e([k.memoize],c.prototype,"appRoot",null),_e([k.memoize],c.prototype,"userHome",null),_e([k.memoize],c.prototype,"userDataPath",null),_e([k.memoize],c.prototype,"appSettingsHome",null),_e([k.memoize],c.prototype,"tmpDir",null),_e([k.memoize],c.prototype,"cacheHome",null),_e([k.memoize],c.prototype,"stateResource",null),_e([k.memoize],c.prototype,"userRoamingDataHome",null),_e([k.memoize],c.prototype,"userDataSyncHome",null),_e([k.memoize],c.prototype,"sync",null),_e([k.memoize],c.prototype,"machineSettingsResource",null),_e([k.memoize],c.prototype,"workspaceStorageHome",null),_e([k.memoize],c.prototype,"localHistoryHome",null),_e([k.memoize],c.prototype,"keyboardLayoutResource",null),_e([k.memoize],c.prototype,"argvResource",null),_e([k.memoize],c.prototype,"isExtensionDevelopment",null),_e([k.memoize],c.prototype,"untitledWorkspacesHome",null),_e([k.memoize],c.prototype,"builtinExtensionsPath",null),_e([k.memoize],c.prototype,"extensionsPath",null),_e([k.memoize],c.prototype,"extensionDevelopmentLocationURI",null),_e([k.memoize],c.prototype,"extensionDevelopmentKind",null),_e([k.memoize],c.prototype,"extensionTestsLocationURI",null),_e([k.memoize],c.prototype,"debugExtensionHost",null),_e([k.memoize],c.prototype,"logLevel",null),_e([k.memoize],c.prototype,"extensionLogLevel",null),_e([k.memoize],c.prototype,"serviceMachineIdResource",null),_e([k.memoize],c.prototype,"disableTelemetry",null),_e([k.memoize],c.prototype,"disableWorkspaceTrust",null),_e([k.memoize],c.prototype,"useInMemorySecretStorage",null),_e([k.memoize],c.prototype,"policyFile",null);function S(b,u){return p(b["inspect-extensions"],b["inspect-brk-extensions"],5870,u,b.debugId,b.extensionEnvironment)}function p(b,u,l,g,s,i){const f=Number(u||b)||(g?null:l),r=f?!!u:!1;let t;if(i)try{t=JSON.parse(i)}catch{}return{port:f,break:r,debugId:s,env:t}}}),define(he[75],de([0,1,107,3,68]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=w,e.formatOptions=c,e.buildHelpMessage=u,e.buildVersionMessage=l;const I={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,C.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,C.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function w(g,s,i=M){const o=g.find(v=>v.length>0&&v[0]!=="-"),f={},r=["_"],t=[],n={};let _;for(const v in s){const A=s[v];A.type==="subcommand"?v===o&&(_=A):(A.alias&&(f[v]=A.alias),A.type==="string"||A.type==="string[]"?(r.push(v),A.deprecates&&r.push(...A.deprecates)):A.type==="boolean"&&(t.push(v),A.deprecates&&t.push(...A.deprecates)),A.global&&(n[v]=A))}if(_&&o){const v=n;for(const N in _.options)v[N]=_.options[N];const A=g.filter(N=>N!==o),W=i.getSubcommandReporter?i.getSubcommandReporter(o):void 0,Y=w(A,v,W);return{[o]:Y,_:[]}}const O=y(g,{string:r,boolean:t,alias:f}),m={},E=O;m._=O._.map(v=>String(v)).filter(v=>v.length>0),delete E._;for(const v in s){const A=s[v];if(A.type==="subcommand")continue;A.alias&&delete E[A.alias];let W=E[v];if(A.deprecates)for(const Y of A.deprecates)E.hasOwnProperty(Y)&&(W||(W=E[Y],W&&i.onDeprecatedOption(Y,A.deprecationMessage||(0,C.localize)(38,null,v))),delete E[Y]);if(typeof W<"u"){if(A.type==="string[]"){if(Array.isArray(W)||(W=[W]),!A.allowEmptyValue){const Y=W.filter(N=>N.length>0);Y.length!==W.length&&(i.onEmptyValue(v),W=Y.length>0?Y:void 0)}}else A.type==="string"&&(Array.isArray(W)?(W=W.pop(),i.onMultipleValues(v,W)):!W&&!A.allowEmptyValue&&(i.onEmptyValue(v),W=void 0));m[v]=W,A.deprecationMessage&&i.onDeprecatedOption(v,A.deprecationMessage)}delete E[v]}for(const v in E)i.onUnknownOption(v);return m}function h(g,s){let i="";return s.args&&(Array.isArray(s.args)?i=` <${s.args.join("> <")}>`:i=` <${s.args}>`),s.alias?`-${s.alias} --${g}${i}`:`--${g}${i}`}function c(g,s){const i=[];for(const o in g){const f=g[o],r=h(o,f);i.push([r,f.description])}return S(i,s)}function S(g,s){const o=g.reduce((t,n)=>Math.max(t,n[0].length),12)+2+1;if(s-o<25)return g.reduce((t,n)=>t.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const f=s-o-1,r=[];for(const t of g){const n=t[0],_=b(t[1],f),O=p(o-n.length-2);r.push("  "+n+O+_[0]);for(let m=1;m<_.length;m++)r.push(p(o)+_[m])}return r}function p(g){return" ".repeat(g)}function b(g,s){const i=[];for(;g.length;){const o=g.length<s?g.length:g.lastIndexOf(" ",s),f=g.slice(0,o).trim();g=g.slice(o),i.push(f)}return i}function u(g,s,i,o,f){const r=process.stdout.isTTY&&process.stdout.columns||80,t=f?.noInputFiles!==!0?`[${(0,C.localize)(39,null)}...]`:"",n=[`${g} ${i}`];n.push(""),n.push(`${(0,C.localize)(40,null)}: ${s} [${(0,C.localize)(41,null)}]${t}`),n.push(""),f?.noPipe!==!0&&(k.isWindows?n.push((0,C.localize)(42,null,s)):n.push((0,C.localize)(43,null,s)),n.push(""));const _={},O=[];for(const m in o){const E=o[m];if(E.type==="subcommand")E.description&&O.push({command:m,description:E.description});else if(E.description&&E.cat){let v=_[E.cat];v||(_[E.cat]=v={}),v[m]=E}}for(const m in _){const E=m,v=_[E];v&&(n.push(I[E]),n.push(...c(v,r)),n.push(""))}return O.length&&(n.push((0,C.localize)(44,null)),n.push(...S(O.map(m=>[m.command,m.description]),r)),n.push("")),n.join(`
`)}function l(g,s){return`${g||(0,C.localize)(45,null)}
${s||(0,C.localize)(46,null)}
${process.arch}`}}),function(){"use strict";function le(e,y,k){function C(M,w){const h=I(M,w),c=[h];return e.isAbsolute(h)||c.unshift(k),e.resolve(...c)}function I(M,w){process.env.VSCODE_DEV&&(w="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,w);const S=M["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(y.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,w)}return{getUserDataPath:C}}if(typeof define=="function")define(he[76],de([77,20,15]),function(e,y,k){return le(e,y,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=le(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[78],de([0,1,20,74,76]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=M,e.parseSharedProcessDebugPort=w;class I extends k.AbstractNativeEnvironmentService{constructor(c,S){super(c,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,C.getUserDataPath)(c,S.nameShort)},S)}}e.NativeEnvironmentService=I;function M(h,c){return(0,k.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}function w(h,c){return(0,k.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}}),define(he[21],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=C,e.refineServiceDecorator=I;var y;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function w(h){return h[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=w})(y||(e._util=y={})),e.IInstantiationService=C("instantiationService");function k(M,w,h){w[y.DI_TARGET]===w?w[y.DI_DEPENDENCIES].push({id:M,index:h}):(w[y.DI_DEPENDENCIES]=[{id:M,index:h}],w[y.DI_TARGET]=w)}function C(M){if(y.serviceIds.has(M))return y.serviceIds.get(M);const w=function(h,c,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(w,h,S)};return w.toString=()=>M,y.serviceIds.set(M,w),w}function I(M){return M}}),define(he[35],de([0,1,3,12,73,21,66,7]),function(le,e,y,k,C,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=c,e.validateWhenClauses=_,e.expressionsAreEqualWithConstantSubstitution=O,e.implies=$;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",y.isMacintosh),h.set("isLinux",y.isLinux),h.set("isWindows",y.isWindows),h.set("isWeb",y.isWeb),h.set("isMacNative",y.isMacintosh&&!y.isWeb),h.set("isEdge",y.isEdge),h.set("isFirefox",y.isFirefox),h.set("isChrome",y.isChrome),h.set("isSafari",y.isSafari);function c(Z,d){if(h.get(Z)!==void 0)throw(0,w.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Z,d)}const S=Object.prototype.hasOwnProperty;var p;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const b={regexParsingWithErrorRecovery:!0},u=(0,M.localize)(0,null),l=(0,M.localize)(1,null),g=(0,M.localize)(2,null),s=(0,M.localize)(3,null),i=(0,M.localize)(4,null),o=(0,M.localize)(5,null),f=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class t{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(d=b){this._config=d,this._scanner=new C.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(d){if(d===""){this._parsingErrors.push({message:u,offset:0,lexeme:"",additionalInfo:l});return}this._tokens=this._scanner.reset(d).scan(),this._current=0,this._parsingErrors=[];try{const z=this._expr();if(!this._isAtEnd()){const ne=this._peek(),se=ne.type===17?o:void 0;throw this._parsingErrors.push({message:i,offset:ne.offset,lexeme:C.Scanner.getLexeme(ne),additionalInfo:se}),t._parseError}return z}catch(z){if(z!==t._parseError)throw z;return}}_expr(){return this._or()}_or(){const d=[this._and()];for(;this._matchOne(16);){const z=this._and();d.push(z)}return d.length===1?d[0]:n.or(...d)}_and(){const d=[this._term()];for(;this._matchOne(15);){const z=this._term();d.push(z)}return d.length===1?d[0]:n.and(...d)}_term(){if(this._matchOne(2)){const d=this._peek();switch(d.type){case 11:return this._advance(),E.INSTANCE;case 12:return this._advance(),v.INSTANCE;case 0:{this._advance();const z=this._expr();return this._consume(1,s),z?.negate()}case 17:return this._advance(),a.create(d.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",d)}}return this._primary()}_primary(){const d=this._peek();switch(d.type){case 11:return this._advance(),n.true();case 12:return this._advance(),n.false();case 0:{this._advance();const z=this._expr();return this._consume(1,s),z}case 17:{const z=d.lexeme;if(this._advance(),this._matchOne(9)){const se=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),se.type!==10)throw this._errExpectedButGot("REGEX",se);const H=se.lexeme,j=H.lastIndexOf("/"),F=j===H.length-1?void 0:this._removeFlagsGY(H.substring(j+1));let R;try{R=new RegExp(H.substring(1,j),F)}catch{throw this._errExpectedButGot("REGEX",se)}return x.create(z,R)}switch(se.type){case 10:case 19:{const H=[se.lexeme];this._advance();let j=this._peek(),F=0;for(let oe=0;oe<se.lexeme.length;oe++)se.lexeme.charCodeAt(oe)===40?F++:se.lexeme.charCodeAt(oe)===41&&F--;for(;!this._isAtEnd()&&j.type!==15&&j.type!==16;){switch(j.type){case 0:F++;break;case 1:F--;break;case 10:case 18:for(let oe=0;oe<j.lexeme.length;oe++)j.lexeme.charCodeAt(oe)===40?F++:se.lexeme.charCodeAt(oe)===41&&F--}if(F<0)break;H.push(C.Scanner.getLexeme(j)),this._advance(),j=this._peek()}const R=H.join(""),B=R.lastIndexOf("/"),V=B===R.length-1?void 0:this._removeFlagsGY(R.substring(B+1));let K;try{K=new RegExp(R.substring(1,B),V)}catch{throw this._errExpectedButGot("REGEX",se)}return n.regex(z,K)}case 18:{const H=se.lexeme;this._advance();let j=null;if(!(0,k.isFalsyOrWhitespace)(H)){const F=H.indexOf("/"),R=H.lastIndexOf("/");if(F!==R&&F>=0){const B=H.slice(F+1,R),V=H[R+1]==="i"?"i":"";try{j=new RegExp(B,V)}catch{throw this._errExpectedButGot("REGEX",se)}}}if(j===null)throw this._errExpectedButGot("REGEX",se);return x.create(z,j)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,g);const se=this._value();return n.notIn(z,se)}switch(this._peek().type){case 3:{this._advance();const se=this._value();if(this._previous().type===18)return n.equals(z,se);switch(se){case"true":return n.has(z);case"false":return n.not(z);default:return n.equals(z,se)}}case 4:{this._advance();const se=this._value();if(this._previous().type===18)return n.notEquals(z,se);switch(se){case"true":return n.not(z);case"false":return n.has(z);default:return n.notEquals(z,se)}}case 5:return this._advance(),J.create(z,this._value());case 6:return this._advance(),re.create(z,this._value());case 7:return this._advance(),P.create(z,this._value());case 8:return this._advance(),T.create(z,this._value());case 13:return this._advance(),n.in(z,this._value());default:return n.has(z)}}case 20:throw this._parsingErrors.push({message:f,offset:d.offset,lexeme:"",additionalInfo:r}),t._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const d=this._peek();switch(d.type){case 17:case 18:return this._advance(),d.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(d){return d.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(d){return this._check(d)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(d,z){if(this._check(d))return this._advance();throw this._errExpectedButGot(z,this._peek())}_errExpectedButGot(d,z,ne){const se=(0,M.localize)(8,null,d,C.Scanner.getLexeme(z)),H=z.offset,j=C.Scanner.getLexeme(z);return this._parsingErrors.push({message:se,offset:H,lexeme:j,additionalInfo:ne}),t._parseError}_check(d){return this._peek().type===d}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=t;class n{static false(){return E.INSTANCE}static true(){return v.INSTANCE}static has(d){return A.create(d)}static equals(d,z){return W.create(d,z)}static notEquals(d,z){return D.create(d,z)}static regex(d,z){return x.create(d,z)}static in(d,z){return Y.create(d,z)}static notIn(d,z){return N.create(d,z)}static not(d){return a.create(d)}static and(...d){return me.create(d,null,!0)}static or(...d){return G.create(d,null,!0)}static greater(d,z){return P.create(d,z)}static greaterEquals(d,z){return T.create(d,z)}static smaller(d,z){return J.create(d,z)}static smallerEquals(d,z){return re.create(d,z)}static{this._parser=new t({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this._parser.parse(d)}}e.ContextKeyExpr=n;function _(Z){const d=new t({regexParsingWithErrorRecovery:!1});return Z.map(z=>(d.parse(z),d.lexingErrors.length>0?d.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,M.localize)(9,null,ne.additionalInfo):(0,M.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}function O(Z,d){const z=Z?Z.substituteConstants():void 0,ne=d?d.substituteConstants():void 0;return!z&&!ne?!0:!z||!ne?!1:z.equals(ne)}function m(Z,d){return Z.cmp(d)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=E;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=v;class A{static create(d,z=null){const ne=h.get(d);return typeof ne=="boolean"?ne?v.INSTANCE:E.INSTANCE:new A(d,z)}constructor(d,z){this.key=d,this.negated=z,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=h.get(this.key);return typeof d=="boolean"?d?v.INSTANCE:E.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=A;class W{static create(d,z,ne=null){if(typeof z=="boolean")return z?A.create(d,ne):a.create(d,ne);const se=h.get(d);return typeof se=="boolean"?z===(se?"true":"false")?v.INSTANCE:E.INSTANCE:new W(d,z,ne)}constructor(d,z,ne){this.key=d,this.value=z,this.negated=ne,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=h.get(this.key);if(typeof d=="boolean"){const z=d?"true":"false";return this.value===z?v.INSTANCE:E.INSTANCE}return this}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=W;class Y{static create(d,z){return new Y(d,z)}constructor(d,z){this.key=d,this.valueKey=z,this.type=10,this.negated=null}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}substituteConstants(){return this}evaluate(d){const z=d.getValue(this.valueKey),ne=d.getValue(this.key);return Array.isArray(z)?z.includes(ne):typeof ne=="string"&&typeof z=="object"&&z!==null?S.call(z,ne):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=N.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=Y;class N{static create(d,z){return new N(d,z)}constructor(d,z){this.key=d,this.valueKey=z,this.type=11,this._negated=Y.create(d,z)}cmp(d){return d.type!==this.type?this.type-d.type:this._negated.cmp(d._negated)}equals(d){return d.type===this.type?this._negated.equals(d._negated):!1}substituteConstants(){return this}evaluate(d){return!this._negated.evaluate(d)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(d){return d.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=N;class D{static create(d,z,ne=null){if(typeof z=="boolean")return z?a.create(d,ne):A.create(d,ne);const se=h.get(d);return typeof se=="boolean"?z===(se?"true":"false")?E.INSTANCE:v.INSTANCE:new D(d,z,ne)}constructor(d,z,ne){this.key=d,this.value=z,this.negated=ne,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){const d=h.get(this.key);if(typeof d=="boolean"){const z=d?"true":"false";return this.value===z?E.INSTANCE:v.INSTANCE}return this}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=W.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=D;class a{static create(d,z=null){const ne=h.get(d);return typeof ne=="boolean"?ne?E.INSTANCE:v.INSTANCE:new a(d,z)}constructor(d,z){this.key=d,this.negated=z,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=h.get(this.key);return typeof d=="boolean"?d?E.INSTANCE:v.INSTANCE:this}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return this.negated||(this.negated=A.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;function L(Z,d){if(typeof Z=="string"){const z=parseFloat(Z);isNaN(z)||(Z=z)}return typeof Z=="string"||typeof Z=="number"?d(Z):E.INSTANCE}class P{static create(d,z,ne=null){return L(z,se=>new P(d,se,ne))}constructor(d,z,ne){this.key=d,this.value=z,this.negated=ne,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=re.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=P;class T{static create(d,z,ne=null){return L(z,se=>new T(d,se,ne))}constructor(d,z,ne){this.key=d,this.value=z,this.negated=ne,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=J.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=T;class J{static create(d,z,ne=null){return L(z,se=>new J(d,se,ne))}constructor(d,z,ne){this.key=d,this.value=z,this.negated=ne,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=J;class re{static create(d,z,ne=null){return L(z,se=>new re(d,se,ne))}constructor(d,z,ne){this.key=d,this.value=z,this.negated=ne,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:ie(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}substituteConstants(){return this}evaluate(d){return typeof this.value=="string"?!1:parseFloat(d.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=re;class x{static create(d,z){return new x(d,z)}constructor(d,z){this.key=d,this.regexp=z,this.type=7,this.negated=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const z=this.regexp?this.regexp.source:"",ne=d.regexp?d.regexp.source:"";return z<ne?-1:z>ne?1:0}equals(d){if(d.type===this.type){const z=this.regexp?this.regexp.source:"",ne=d.regexp?d.regexp.source:"";return this.key===d.key&&z===ne}return!1}substituteConstants(){return this}evaluate(d){const z=d.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=te.create(this)),this.negated}}e.ContextKeyRegexExpr=x;class te{static create(d){return new te(d)}constructor(d){this._actual=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}substituteConstants(){return this}evaluate(d){return!this._actual.evaluate(d)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(d){return new te(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=te;function ce(Z){let d=null;for(let z=0,ne=Z.length;z<ne;z++){const se=Z[z].substituteConstants();if(Z[z]!==se&&d===null){d=[];for(let H=0;H<z;H++)d[H]=Z[H]}d!==null&&(d[z]=se)}return d===null?Z:d}class me{static create(d,z,ne){return me._normalizeArr(d,z,ne)}constructor(d,z){this.expr=d,this.negated=z,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const se=m(this.expr[z],d.expr[z]);if(se!==0)return se}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(d.expr[z]))return!1;return!0}return!1}substituteConstants(){const d=ce(this.expr);return d===this.expr?this:me.create(d,this.negated,!1)}evaluate(d){for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].evaluate(d))return!1;return!0}static _normalizeArr(d,z,ne){const se=[];let H=!1;for(const j of d)if(j){if(j.type===1){H=!0;continue}if(j.type===0)return E.INSTANCE;if(j.type===6){se.push(...j.expr);continue}se.push(j)}if(se.length===0&&H)return v.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(m);for(let j=1;j<se.length;j++)se[j-1].equals(se[j])&&(se.splice(j,1),j--);if(se.length===1)return se[0];for(;se.length>1;){const j=se[se.length-1];if(j.type!==9)break;se.pop();const F=se.pop(),R=se.length===0,B=G.create(j.expr.map(V=>me.create([V,F],null,ne)),null,R);B&&(se.push(B),se.sort(m))}if(se.length===1)return se[0];if(ne){for(let j=0;j<se.length;j++)for(let F=j+1;F<se.length;F++)if(se[j].negate().equals(se[F]))return E.INSTANCE;if(se.length===1)return se[0]}return new me(se,z)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const z of this.expr)d.push(...z.keys());return d}map(d){return new me(this.expr.map(z=>z.map(d)),null)}negate(){if(!this.negated){const d=[];for(const z of this.expr)d.push(z.negate());this.negated=G.create(d,this,!0)}return this.negated}}e.ContextKeyAndExpr=me;class G{static create(d,z,ne){return G._normalizeArr(d,z,ne)}constructor(d,z){this.expr=d,this.negated=z,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let z=0,ne=this.expr.length;z<ne;z++){const se=m(this.expr[z],d.expr[z]);if(se!==0)return se}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let z=0,ne=this.expr.length;z<ne;z++)if(!this.expr[z].equals(d.expr[z]))return!1;return!0}return!1}substituteConstants(){const d=ce(this.expr);return d===this.expr?this:G.create(d,this.negated,!1)}evaluate(d){for(let z=0,ne=this.expr.length;z<ne;z++)if(this.expr[z].evaluate(d))return!0;return!1}static _normalizeArr(d,z,ne){let se=[],H=!1;if(d){for(let j=0,F=d.length;j<F;j++){const R=d[j];if(R){if(R.type===0){H=!0;continue}if(R.type===1)return v.INSTANCE;if(R.type===9){se=se.concat(R.expr);continue}se.push(R)}}if(se.length===0&&H)return E.INSTANCE;se.sort(m)}if(se.length!==0){if(se.length===1)return se[0];for(let j=1;j<se.length;j++)se[j-1].equals(se[j])&&(se.splice(j,1),j--);if(se.length===1)return se[0];if(ne){for(let j=0;j<se.length;j++)for(let F=j+1;F<se.length;F++)if(se[j].negate().equals(se[F]))return v.INSTANCE;if(se.length===1)return se[0]}return new G(se,z)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const z of this.expr)d.push(...z.keys());return d}map(d){return new G(this.expr.map(z=>z.map(d)),null)}negate(){if(!this.negated){const d=[];for(const z of this.expr)d.push(z.negate());for(;d.length>1;){const z=d.shift(),ne=d.shift(),se=[];for(const H of ge(z))for(const j of ge(ne))se.push(me.create([H,j],null,!1));d.unshift(G.create(se,null,!1))}this.negated=G.create(d,this,!0)}return this.negated}}e.ContextKeyOrExpr=G;class q extends A{static{this._info=[]}static all(){return q._info.values()}constructor(d,z,ne){super(d,null),this._defaultValue=z,typeof ne=="object"?q._info.push({...ne,key:d}):ne!==!0&&q._info.push({key:d,description:ne,type:z!=null?typeof z:void 0})}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return W.create(this.key,d)}notEqualsTo(d){return D.create(this.key,d)}}e.RawContextKey=q,e.IContextKeyService=(0,I.createDecorator)("contextKeyService");function Q(Z,d){return Z<d?-1:Z>d?1:0}function ie(Z,d,z,ne){return Z<z?-1:Z>z?1:d<ne?-1:d>ne?1:0}function $(Z,d){if(Z.type===0||d.type===1)return!0;if(Z.type===9)return d.type===9?ee(Z.expr,d.expr):!1;if(d.type===9){for(const z of d.expr)if($(Z,z))return!0;return!1}if(Z.type===6){if(d.type===6)return ee(d.expr,Z.expr);for(const z of Z.expr)if($(z,d))return!0;return!1}return Z.equals(d)}function ee(Z,d){let z=0,ne=0;for(;z<Z.length&&ne<d.length;){const se=Z[z].cmp(d[ne]);if(se<0)return!1;se===0&&z++,ne++}return z===Z.length}function ge(Z){return Z.type===9?Z.expr:[Z]}}),define(he[79],de([0,1,51,5,12,8,6,69,21,3,19,22]),function(le,e,y,k,C,I,M,w,h,c,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=b,e.isFileSystemWatcher=g,e.hasReadWriteCapability=i,e.hasFileFolderCopyCapability=o,e.hasFileCloneCapability=f,e.hasOpenReadWriteCloseCapability=r,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=n,e.hasFileAtomicWriteCapability=_,e.hasFileAtomicDeleteCapability=O,e.hasReadonlyCapability=m,e.createFileSystemProviderError=A,e.ensureFileSystemProviderError=W,e.markAsFileSystemProviderError=Y,e.toFileSystemProviderErrorCode=N,e.toFileOperationResult=D,e.isParent=J,e.etag=G,e.whenProviderRegistered=q,e.getLargeFileConfirmationLimit=ie,e.IFileService=(0,h.createDecorator)("fileService");function b($){return $.create===!0}var u;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var l;(function($){$[$.Readonly=1]="Readonly",$[$.Locked=2]="Locked"})(l||(e.FilePermission=l={}));function g($){const ee=$;return!!ee&&typeof ee.onDidChange=="function"}var s;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileAtomicWrite=32768]="FileAtomicWrite",$[$.FileAtomicDelete=65536]="FileAtomicDelete",$[$.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function i($){return!!($.capabilities&2)}function o($){return!!($.capabilities&8)}function f($){return!!($.capabilities&131072)}function r($){return!!($.capabilities&4)}function t($){return!!($.capabilities&16)}function n($){return i($)?!!($.capabilities&16384):!1}function _($){return i($)?!!($.capabilities&32768):!1}function O($){return!!($.capabilities&65536)}function m($){return!!($.capabilities&2048)}var E;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class v extends Error{static create(ee,ge){const Z=new v(ee.toString(),ge);return Y(Z,ge),Z}constructor(ee,ge){super(ee),this.code=ge}}e.FileSystemProviderError=v;function A($,ee){return v.create($,ee)}function W($){return $||A((0,w.localize)(0,null),E.Unknown)}function Y($,ee){return $.name=ee?`${ee} (FileSystemError)`:"FileSystemError",$}function N($){if(!$)return E.Unknown;if($ instanceof v)return $.code;const ee=/^(.+) \(FileSystemError\)$/.exec($.name);if(!ee)return E.Unknown;switch(ee[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function D($){if($ instanceof re)return $.fileOperationResult;switch(N($)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}var a;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(a||(e.FileOperation=a={}));class L{constructor(ee,ge,Z){this.resource=ee,this.operation=ge,this.target=Z}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=L;var P;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class T{static{this.MIXED_CORRELATION=null}constructor(ee,ge){this.ignorePathCasing=ge,this.correlationId=void 0,this.added=new p.Lazy(()=>{const Z=y.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawAdded.map(d=>[d,!0])),Z}),this.updated=new p.Lazy(()=>{const Z=y.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawUpdated.map(d=>[d,!0])),Z}),this.deleted=new p.Lazy(()=>{const Z=y.TernarySearchTree.forUris(()=>this.ignorePathCasing);return Z.fill(this.rawDeleted.map(d=>[d,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of ee){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.correlationId!==T.MIXED_CORRELATION&&(typeof Z.cId=="number"?this.correlationId===void 0?this.correlationId=Z.cId:this.correlationId!==Z.cId&&(this.correlationId=T.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=T.MIXED_CORRELATION))}}contains(ee,...ge){return this.doContains(ee,{includeChildren:!1},...ge)}affects(ee,...ge){return this.doContains(ee,{includeChildren:!0},...ge)}doContains(ee,ge,...Z){if(!ee)return!1;const d=Z.length>0;return!!((!d||Z.includes(1))&&(this.added.value.get(ee)||ge.includeChildren&&this.added.value.findSuperstr(ee))||(!d||Z.includes(0))&&(this.updated.value.get(ee)||ge.includeChildren&&this.updated.value.findSuperstr(ee))||(!d||Z.includes(2))&&(this.deleted.value.findSubstr(ee)||ge.includeChildren&&this.deleted.value.findSuperstr(ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ee){return this.correlationId===ee}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=T;function J($,ee,ge){return!$||!ee||$===ee||ee.length>$.length?!1:(ee.charAt(ee.length-1)!==k.sep&&(ee+=k.sep),ge?(0,C.startsWithIgnoreCase)($,ee):$.indexOf(ee)===0)}class re extends Error{constructor(ee,ge,Z){super(ee),this.fileOperationResult=ge,this.options=Z}}e.FileOperationError=re;class x extends re{constructor(ee,ge,Z,d){super(ee,ge,d),this.fileOperationResult=ge,this.size=Z}}e.TooLargeFileOperationError=x;class te extends re{constructor(ee,ge,Z){super(ee,2,Z),this.stat=ge}}e.NotModifiedSinceFileOperationError=te;var ce;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var me;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.ETAG_DISABLED="";function G($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}async function q($,ee){if(!ee.hasProvider(M.URI.from({scheme:$.scheme})))return new Promise(ge=>{const Z=ee.onDidChangeFileSystemProviderRegistrations(d=>{d.scheme===$.scheme&&d.added&&(Z.dispose(),ge())})})}class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ee){return(0,I.isNumber)(ee)||(ee=0),ee<Q.KB?(0,w.localize)(1,null,ee.toFixed(0)):ee<Q.MB?(0,w.localize)(2,null,(ee/Q.KB).toFixed(2)):ee<Q.GB?(0,w.localize)(3,null,(ee/Q.MB).toFixed(2)):ee<Q.TB?(0,w.localize)(4,null,(ee/Q.GB).toFixed(2)):(0,w.localize)(5,null,(ee/Q.TB).toFixed(2))}}e.ByteSize=Q;function ie($){const ee=typeof $=="string"||$?.scheme===S.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===S.Schemas.file?1024*Q.MB:ee?10*Q.MB:c.isWeb?50*Q.MB:1024*Q.MB}}),define(he[11],de([0,1,70,56,4,49,2,25,3,23,8,6,35,21]),function(le,e,y,k,C,I,M,w,h,c,S,p,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=g,e.log=i,e.getLogLevel=A,e.LogLevelToString=W,e.LogLevelToLocalizedString=Y,e.parseLogLevel=N,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function l(){return new Date().toISOString()}function g(D){return(0,S.isNumber)(D)}var s;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(s||(e.LogLevel=s={})),e.DEFAULT_LOG_LEVEL=s.Info;function i(D,a,L){switch(a){case s.Trace:D.trace(L);break;case s.Debug:D.debug(L);break;case s.Info:D.info(L);break;case s.Warning:D.warn(L);break;case s.Error:D.error(L);break;case s.Off:break;default:throw new Error(`Invalid log level ${a}`)}}function o(D,a=!1){let L="";for(let P=0;P<D.length;P++){let T=D[P];if(T instanceof Error&&(T=(0,k.toErrorMessage)(T,a)),typeof T=="object")try{T=JSON.stringify(T)}catch{}L+=(P>0?" ":"")+T}return L}class f extends M.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(a){return this.level!==s.Off&&this.level<=a}}e.AbstractLogger=f;class r extends f{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||super.checkLogLevel(a)}trace(a,...L){this.checkLogLevel(s.Trace)&&this.log(s.Trace,o([a,...L],!0))}debug(a,...L){this.checkLogLevel(s.Debug)&&this.log(s.Debug,o([a,...L]))}info(a,...L){this.checkLogLevel(s.Info)&&this.log(s.Info,o([a,...L]))}warn(a,...L){this.checkLogLevel(s.Warning)&&this.log(s.Warning,o([a,...L]))}error(a,...L){if(this.checkLogLevel(s.Error))if(a instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=a.stack,this.log(s.Error,o(P))}else this.log(s.Error,o([a,...L]))}flush(){}}e.AbstractMessageLogger=r;class t extends f{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!h.isWindows}trace(a,...L){this.checkLogLevel(s.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...L):console.log(`[main ${l()}]`,a,...L))}debug(a,...L){this.checkLogLevel(s.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...L):console.log(`[main ${l()}]`,a,...L))}info(a,...L){this.checkLogLevel(s.Info)&&(this.useColors?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,a,...L):console.log(`[main ${l()}]`,a,...L))}warn(a,...L){this.checkLogLevel(s.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,a,...L):console.warn(`[main ${l()}]`,a,...L))}error(a,...L){this.checkLogLevel(s.Error)&&(this.useColors?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,a,...L):console.error(`[main ${l()}]`,a,...L))}flush(){}}e.ConsoleMainLogger=t;class n extends f{constructor(a=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(a)}trace(a,...L){this.checkLogLevel(s.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",a,...L):console.log(a,...L))}debug(a,...L){this.checkLogLevel(s.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",a,...L):console.log(a,...L))}info(a,...L){this.checkLogLevel(s.Info)&&(this.useColors?console.log("%c INFO","color: #33f",a,...L):console.log(a,...L))}warn(a,...L){this.checkLogLevel(s.Warning)&&(this.useColors?console.log("%c WARN","color: #993",a,...L):console.log(a,...L))}error(a,...L){this.checkLogLevel(s.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",a,...L):console.error(a,...L))}flush(){}}e.ConsoleLogger=n;class _ extends f{constructor(a,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(L)}trace(a,...L){this.checkLogLevel(s.Trace)&&this.adapter.log(s.Trace,[this.extractMessage(a),...L])}debug(a,...L){this.checkLogLevel(s.Debug)&&this.adapter.log(s.Debug,[this.extractMessage(a),...L])}info(a,...L){this.checkLogLevel(s.Info)&&this.adapter.log(s.Info,[this.extractMessage(a),...L])}warn(a,...L){this.checkLogLevel(s.Warning)&&this.adapter.log(s.Warning,[this.extractMessage(a),...L])}error(a,...L){this.checkLogLevel(s.Error)&&this.adapter.log(s.Error,[this.extractMessage(a),...L])}extractMessage(a){return typeof a=="string"?a:(0,k.toErrorMessage)(a,this.checkLogLevel(s.Trace))}flush(){}}e.AdapterLogger=_;class O extends f{constructor(a){super(),this.loggers=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const L of this.loggers)L.setLevel(a);super.setLevel(a)}trace(a,...L){for(const P of this.loggers)P.trace(a,...L)}debug(a,...L){for(const P of this.loggers)P.debug(a,...L)}info(a,...L){for(const P of this.loggers)P.info(a,...L)}warn(a,...L){for(const P of this.loggers)P.warn(a,...L)}error(a,...L){for(const P of this.loggers)P.error(a,...L)}flush(){for(const a of this.loggers)a.flush()}dispose(){for(const a of this.loggers)a.dispose();super.dispose()}}e.MultiplexLogger=O;class m extends M.Disposable{constructor(a,L,P){if(super(),this.logLevel=a,this.logsHome=L,this._loggers=new w.ResourceMap,this._onDidChangeLoggers=this._register(new C.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,P)for(const T of P)this._loggers.set(T.resource,{logger:void 0,info:T})}getLoggerEntry(a){return(0,S.isString)(a)?[...this._loggers.values()].find(L=>L.info.id===a):this._loggers.get(a)}getLogger(a){return this.getLoggerEntry(a)?.logger}createLogger(a,L){const P=this.toResource(a),T=(0,S.isString)(a)?a:L?.id??(0,I.hash)(P.toString()).toString(16);let J=this._loggers.get(P)?.logger;const re=L?.logLevel==="always"?s.Trace:L?.logLevel;J||(J=this.doCreateLogger(P,re??this.getLogLevel(P)??this.logLevel,{...L,id:T}));const x={logger:J,info:{resource:P,id:T,logLevel:re,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(x.info),this._loggers.set(P,x),J}toResource(a){return(0,S.isString)(a)?(0,c.joinPath)(this.logsHome,`${a}.log`):a}setLogLevel(a,L){if(p.URI.isUri(a)){const P=a,T=L,J=this._loggers.get(P);J&&T!==J.info.logLevel&&(J.info.logLevel=T===this.logLevel?void 0:T,J.logger?.setLevel(T),this._loggers.set(J.info.resource,J),this._onDidChangeLogLevel.fire([P,T]))}else{this.logLevel=a;for(const[P,T]of this._loggers.entries())this._loggers.get(P)?.info.logLevel===void 0&&T.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(a,L){const P=this.getLoggerEntry(a);P&&L!==!P.info.hidden&&(P.info.hidden=!L,this._loggers.set(P.info.resource,P),this._onDidChangeVisibility.fire([P.info.resource,L]))}getLogLevel(a){let L;return a&&(L=this._loggers.get(a)?.info.logLevel),L??this.logLevel}registerLogger(a){const L=this._loggers.get(a.resource);L?L.info.hidden!==a.hidden&&this.setVisibility(a.resource,!a.hidden):(this._loggers.set(a.resource,{info:a,logger:void 0}),this._onDidChangeLoggers.fire({added:[a],removed:[]}))}deregisterLogger(a){const L=this._loggers.get(a);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(a),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const a of this._loggers.values())yield a.info}getRegisteredLogger(a){return this._loggers.get(a)?.info}dispose(){this._loggers.forEach(a=>a.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=m;class E{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(a){}getLevel(){return s.Info}trace(a,...L){}debug(a,...L){}info(a,...L){}warn(a,...L){}error(a,...L){}critical(a,...L){}dispose(){}flush(){}}e.NullLogger=E;class v extends E{}e.NullLogService=v;function A(D){if(D.verbose)return s.Trace;if(typeof D.logLevel=="string"){const a=N(D.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}function W(D){switch(D){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function Y(D){switch(D){case s.Trace:return{original:"Trace",value:y.localize(0,null)};case s.Debug:return{original:"Debug",value:y.localize(1,null)};case s.Info:return{original:"Info",value:y.localize(2,null)};case s.Warning:return{original:"Warning",value:y.localize(3,null)};case s.Error:return{original:"Error",value:y.localize(4,null)};case s.Off:return{original:"Off",value:y.localize(5,null)}}}function N(D){switch(D){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",W(s.Info))}),define(he[80],de([0,1,6,4,11,2]),function(le,e,y,k,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class M extends C.AbstractLoggerService{constructor(p,b,u,l,g){super(b,u,l),this.windowId=p,this.channel=g,this._register(g.listen("onDidChangeLogLevel",p)(s=>{(0,C.isLogLevel)(s)?super.setLogLevel(s):super.setLogLevel(y.URI.revive(s[0]),s[1])})),this._register(g.listen("onDidChangeVisibility",p)(([s,i])=>super.setVisibility(y.URI.revive(s),i))),this._register(g.listen("onDidChangeLoggers",p)(({added:s,removed:i})=>{for(const o of s)super.registerLogger({...o,resource:y.URI.revive(o.resource)});for(const o of i)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new C.AdapterLogger({log:(p,b)=>{this.channel.call("consoleLog",[p,b])}})}registerLogger(p){super.registerLogger(p),this.channel.call("registerLogger",[p,this.windowId])}deregisterLogger(p){super.deregisterLogger(p),this.channel.call("deregisterLogger",[p,this.windowId])}setLogLevel(p,b){super.setLogLevel(p,b),this.channel.call("setLogLevel",[p,b])}setVisibility(p,b){super.setVisibility(p,b),this.channel.call("setVisibility",[this.toResource(p),b])}doCreateLogger(p,b,u){return new w(this.channel,p,b,u,this.windowId)}static setLogLevel(p,b,u){return p.call("setLogLevel",[b,u])}}e.LoggerChannelClient=M;class w extends C.AbstractMessageLogger{constructor(p,b,u,l,g){super(l?.logLevel==="always"),this.channel=p,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[b,l,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,b){const u=[[p,b]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(p){this.channel.call("log",[this.file,p])}}class h{constructor(p,b){this.loggerService=p,this.getUriTransformer=b}listen(p,b){const u=this.getUriTransformer(p);switch(b){case"onDidChangeLoggers":return k.Event.map(this.loggerService.onDidChangeLoggers,l=>({added:[...l.added].map(g=>this.transformLogger(g,u)),removed:[...l.removed].map(g=>this.transformLogger(g,u))}));case"onDidChangeVisibility":return k.Event.map(this.loggerService.onDidChangeVisibility,l=>[u.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return k.Event.map(this.loggerService.onDidChangeLogLevel,l=>(0,C.isLogLevel)(l)?l:[u.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${b}`)}async call(p,b,u){const l=this.getUriTransformer(p);switch(b){case"setLogLevel":return(0,C.isLogLevel)(u[0])?this.loggerService.setLogLevel(u[0]):this.loggerService.setLogLevel(y.URI.revive(l.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(g=>this.transformLogger(g,l)))}throw new Error(`Call not found: ${b}`)}transformLogger(p,b){return{...p,resource:b.transformOutgoingURI(p.resource)}}}e.LoggerChannel=h;class c extends I.Disposable{constructor(p,b){super(),b.call("setLogLevel",[p.getLogLevel()]),this._register(p.onDidChangeLogLevel(u=>b.call("setLogLevel",[u]))),b.call("getRegisteredLoggers").then(u=>{for(const l of u)p.registerLogger({...l,resource:y.URI.revive(l.resource)})}),this._register(b.listen("onDidChangeVisibility")(([u,l])=>p.setVisibility(y.URI.revive(u),l))),this._register(b.listen("onDidChangeLoggers")(({added:u,removed:l})=>{for(const g of u)p.registerLogger({...g,resource:y.URI.revive(g.resource)});for(const g of l)p.deregisterLogger(g.resource)}))}}e.RemoteLoggerChannelClient=c}),define(he[81],de([0,1,2,11]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class C extends y.Disposable{constructor(M,w=[]){super(),this.logger=new k.MultiplexLogger([M,...w]),this._register(M.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(M){this.logger.setLevel(M)}getLevel(){return this.logger.getLevel()}trace(M,...w){this.logger.trace(M,...w)}debug(M,...w){this.logger.debug(M,...w)}info(M,...w){this.logger.info(M,...w)}warn(M,...w){this.logger.warn(M,...w)}error(M,...w){this.logger.error(M,...w)}flush(){this.logger.flush()}}e.LogService=C}),define(he[82],de([0,1,79,11]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C||(C={}));async function I(c,S,p,b,u){try{const l=await new Promise((s,i)=>{le(["@vscode/spdlog"],s,i)});l.setFlushOn(C.Trace);const g=await l.createAsyncRotatingLogger(c,S,p,b);return u?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(l){console.error(l)}return null}function M(c,S,p){switch(S){case k.LogLevel.Trace:c.trace(p);break;case k.LogLevel.Debug:c.debug(p);break;case k.LogLevel.Info:c.info(p);break;case k.LogLevel.Warning:c.warn(p);break;case k.LogLevel.Error:c.error(p);break;case k.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function w(c,S){switch(S){case k.LogLevel.Trace:c.setLevel(C.Trace);break;case k.LogLevel.Debug:c.setLevel(C.Debug);break;case k.LogLevel.Info:c.setLevel(C.Info);break;case k.LogLevel.Warning:c.setLevel(C.Warning);break;case k.LogLevel.Error:c.setLevel(C.Error);break;case k.LogLevel.Off:c.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class h extends k.AbstractMessageLogger{constructor(S,p,b,u,l){super(),this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(S,p,b,u),this._register(this.onDidChangeLogLevel(g=>{this._logger&&w(this._logger,g)}))}async _createSpdLogLogger(S,p,b,u){const l=b?6:1,g=30/l*y.ByteSize.MB,s=await I(S,p,g,l,u);if(s){this._logger=s,w(this._logger,this.getLevel());for(const{level:i,message:o}of this.buffer)M(this._logger,i,o);this.buffer=[]}}log(S,p){this._logger?M(this._logger,S,p):this.getLevel()<=S&&this.buffer.push({level:S,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(he[83],de([0,1,52,11,82]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class I extends k.AbstractLoggerService{doCreateLogger(w,h,c){return new C.SpdLogLogger((0,y.generateUuid)(),w.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.LoggerService=I}),define(he[84],de([0,1,15]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const I=C.context.configuration();if(I)k=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){k=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:I,searchUrl:M,itemUrl:w,controlUrl:h}=k.extensionsGallery||{};Object.assign(k,{extensionsGallery:{serviceUrl:y.env.VSCODE_GALLERY_SERVICE_URL||I,searchUrl:y.env.VSCODE_GALLERY_SEARCH_URL||M,itemUrl:y.env.VSCODE_GALLERY_ITEM_URL||w,controlUrl:y.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const c=(...p)=>p.reduce((b,u)=>(Object.keys(u).forEach(l=>{Array.isArray(b[l])&&Array.isArray(u[l])?b[l]=u[l]:typeof b[l]=="object"&&typeof u[l]=="object"?b[l]=c(b[l],u[l]):b[l]=u[l]}),b),{}),S=globalThis._VSCODE_USER_PRODUCT_JSON||{};k=c(k,S)}catch{}if(y.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const c=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:c.version,release:c.release})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(he[85],de([0,1,21]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(he[86],de([0,1,42,8]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(M,w){y.ok(k.isString(M)),y.ok(k.isObject(w)),y.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,w)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new C}),define(he[87],de([0,1,4,2]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class C extends k.Disposable{constructor(M){super(),this._terminal=M,this.type=4,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new y.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const M of this._idToMarkerMap.values())yield M;for(const M of this._anonymousMarkers.values())yield M}addMark(M){const w=M?.marker||this._terminal.registerMarker(),h=M?.id;w&&(h?(this._idToMarkerMap.set(h,w),w.onDispose(()=>this._idToMarkerMap.delete(h))):(this._anonymousMarkers.set(w.id,w),w.onDispose(()=>this._anonymousMarkers.delete(w.id))),this._onMarkAdded.fire({marker:w,id:h,hidden:M?.hidden,hoverMessage:M?.hoverMessage}))}getMark(M){return this._idToMarkerMap.get(M)}}e.BufferMarkCapability=C}),define(he[88],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class y{get command(){return this._properties.command}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get duration(){return this._properties.duration}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(c){this._properties.endMarker=c}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(c,S){this._xterm=c,this._properties=S}static deserialize(c,S,p){const b=c.buffer.normal,u=S.startLine!==void 0?c.registerMarker(S.startLine-(b.baseY+b.cursorY)):void 0;if(!u)return;const l=S.promptStartLine!==void 0?c.registerMarker(S.promptStartLine-(b.baseY+b.cursorY)):void 0,g=S.endLine!==void 0?c.registerMarker(S.endLine-(b.baseY+b.cursorY)):void 0,s=S.executedLine!==void 0?c.registerMarker(S.executedLine-(b.baseY+b.cursorY)):void 0;return new y(c,{command:p?"":S.command,isTrusted:S.isTrusted,promptStartMarker:l,marker:u,startX:S.startX,endMarker:g,executedMarker:s,executedX:S.executedX,timestamp:S.timestamp,duration:S.duration,cwd:S.cwd,commandStartLineContent:S.commandStartLineContent,exitCode:S.exitCode,markProperties:S.markProperties,aliases:void 0,wasReplayed:!0})}serialize(c){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:c?"":this.command,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}getOutput(){if(!this.executedMarker||!this.endMarker)return;const c=this.executedMarker.line,S=this.endMarker.line;if(c===S)return;let p="",b;for(let u=c;u<S;u++)b=this._xterm.buffer.active.getLine(u),b&&(p+=b.translateToString(!b.isWrapped)+(b.isWrapped?"":`
`));return p===""?void 0:p}getOutputMatch(c){if(!this.executedMarker||!this.endMarker)return;const S=this.endMarker.line;if(S===-1)return;const p=this._xterm.buffer.active,b=Math.max(this.executedMarker.line,0),u=c.lineMatcher,l=typeof u=="string"?1:c.length||I(u),g=[];let s;if(c.anchor==="bottom")for(let i=S-(c.offset||0);i>=b;i--){let o=i;const f=i;for(;o>=b&&p.getLine(o)?.isWrapped;)o--;if(i=o,g.unshift(C(p,o,f,this._xterm.cols)),s||(s=g[0].match(u)),g.length>=l)break}else for(let i=b+(c.offset||0);i<S;i++){const o=i;let f=i;for(;f+1<S&&p.getLine(f+1)?.isWrapped;)f++;if(i=f,g.push(C(p,o,f,this._xterm.cols)),s||(s=g[g.length-1].match(u)),g.length>=l)break}return s?{regexMatch:s,outputLines:g}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return M(this,this._xterm.buffer.active)}getCommandRowCount(){return w(this)}}e.TerminalCommand=y;class k{constructor(c){this._xterm=c}serialize(c){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",isTrusted:!0,cwd:c,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(c,S,p,b){if(S===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||p)return new y(this._xterm,{command:p?"":this.command||"",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.commandDuration||0,cwd:c,exitCode:S,commandStartLineContent:this.commandStartLineContent,markProperties:b})}markExecutedTime(){this.commandExecutedTimestamp===void 0&&(this.commandExecutedTimestamp=Date.now())}markFinishedTime(){this.commandDuration===void 0&&this.commandExecutedTimestamp!==void 0&&(this.commandDuration=Date.now()-this.commandExecutedTimestamp)}getPromptRowCount(){return M(this,this._xterm.buffer.active)}getCommandRowCount(){return w(this)}}e.PartialTerminalCommand=k;function C(h,c,S,p){const b=Math.max(2048/p*2);S=Math.min(S,c+b);let u="";for(let l=c;l<=S;l++){const g=h.getLine(l);g&&(u+=g.translateToString(!0,0,p))}return u}function I(h){if(!h.multiline)return 1;const c=h.source;let S=1,p=c.indexOf("\\n");for(;p!==-1;)S++,p=c.indexOf("\\n",p+1);return S}function M(h,c){const S="hasOutput"in h?h.marker:h.commandStartMarker;if(!S||!h.promptStartMarker)return 1;let p=1,b=h.promptStartMarker.line;for(;b<S.line&&(c.getLine(b)?.translateToString(!0)??"").length===0;)b++;return p=S.line-b+1,p}function w(h){const c="hasOutput"in h?h.marker:h.commandStartMarker,S="hasOutput"in h?h.executedMarker:h.commandExecutedMarker;if(!c||!S)return 1;let b=Math.max(S.line,c.line)-c.line+1;return("hasOutput"in h?h.executedX:h.commandExecutedX)===0&&b--,b}});var Ue=this&&this.__param||function(le,e){return function(y,k){e(y,k,le)}};define(he[89],de([0,1,10,14,4,2,11,88]),function(le,e,y,k,C,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandDetectionCapability=void 0,e.getLinesForCommand=b;class h extends I.Disposable{get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get _isInputting(){return!!(this._currentCommand.commandStartMarker&&!this._currentCommand.commandExecutedMarker)}get hasInput(){if(!(!this._isInputting||!this._currentCommand?.commandStartMarker)){if(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY===this._currentCommand.commandStartMarker?.line){const s=this._terminal.buffer.active.getLine(this._terminal.buffer.active.cursorY)?.translateToString(!0,this._currentCommand.commandStartX);return s===void 0?void 0:s.length>0}return!0}}constructor(s,i){super(),this._terminal=s,this._logService=i,this.type=2,this._commands=[],this._currentCommand=new w.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new C.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new C.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new C.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new C.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new C.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new C.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event;const o=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return o._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return o._onCommandStarted}get onCommandExecutedEmitter(){return o._onCommandExecuted}get dimensions(){return o._dimensions}get isCommandStorageDisabled(){return o.__isCommandStorageDisabled}get commandMarkers(){return o._commandMarkers}set commandMarkers(f){o._commandMarkers=f}get clearCommandsInViewport(){return o._clearCommandsInViewport.bind(o)}commitCommandFinished(){o._commitCommandFinished?.flush(),o._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new I.MandatoryMutableDisposable(new c(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(f=>this._handleResize(f))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(s){this._ptyHeuristics.value.preHandleResize?.(s),this._dimensions.cols=s.cols,this._dimensions.rows=s.rows}_handleCursorMove(){this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:"windows"}))}_clearCommandsInViewport(){let s=0;for(let i=this._commands.length-1;i>=0;i--){const o=this._commands[i].marker?.line;if(o&&o<this._terminal.buffer.active.baseY)break;s++}s>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-s,s))}setCwd(s){this._cwd=s}setIsWindowsPty(s){if(s&&!(this._ptyHeuristics.value instanceof p)){const i=this;this._ptyHeuristics.value=new p(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return i._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return i._onCommandStarted}get onCommandExecutedEmitter(){return i._onCommandExecuted}get dimensions(){return i._dimensions}get isCommandStorageDisabled(){return i.__isCommandStorageDisabled}get commandMarkers(){return i._commandMarkers}set commandMarkers(o){i._commandMarkers=o}get clearCommandsInViewport(){return i._clearCommandsInViewport.bind(i)}commitCommandFinished(){i._commitCommandFinished?.flush(),i._commitCommandFinished=void 0}},this._logService)}else!s&&!(this._ptyHeuristics.value instanceof c)&&(this._ptyHeuristics.value=new c(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(s){if(this._currentCommand.promptStartMarker&&s>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>s)){for(let i=this.commands.length-1;i>=0;i--)if((this.commands[i].promptStartMarker??this.commands[i].marker).line<=s)return this.commands[i]}}getCwdForLine(s){if(this._currentCommand.promptStartMarker&&s>=this._currentCommand.promptStartMarker?.line)return this._cwd;const i=this.getCommandForLine(s);if(i&&"cwd"in i)return i.cwd}handlePromptStart(s){const i=this.commands.at(-1);i?.endMarker&&i?.executedMarker&&i.endMarker.line===i.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${i.endMarker.line} -> ${i.executedMarker.line+1}`),i.endMarker=l(this._terminal,i.executedMarker,1)),this._currentCommand.promptStartMarker=s?.marker||(i?.endMarker?l(this._terminal,i.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(s){if(this._handleCommandStartOptions=s,this._currentCommand.commandStartMarker=s?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this._ptyHeuristics.value.handleCommandExecuted(s),this._currentCommand.markExecutedTime()}handleCommandFinished(s,i){if(this._currentCommand.markFinishedTime(),this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,i?.marker?.line,this._currentCommand.command,this._currentCommand),s===void 0){const f=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&f?.command===this._currentCommand.command&&(s=f.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=i?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const o=this._currentCommand.promoteToFullCommand(this._cwd,s,this._handleCommandStartOptions?.ignoreCommandLine??!1,i?.markProperties);o&&(this._commands.push(o),this._commitCommandFinished=new y.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(o),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",o),this._onCommandFinished.fire(o))},50),this._commitCommandFinished.schedule()),this._currentCommand=new w.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(s,i){this._logService.debug("CommandDetectionCapability#setCommandLine",s,i),this._currentCommand.command=s,this._currentCommand.isTrusted=i}serialize(){const s=this.commands.map(o=>o.serialize(this.__isCommandStorageDisabled)),i=this._currentCommand.serialize(this._cwd);return i&&s.push(i),{isWindowsPty:this._ptyHeuristics.value instanceof p,commands:s}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const i=this._terminal.buffer.normal;for(const o of s.commands){if(!o.endLine){const r=o.startLine!==void 0?this._terminal.registerMarker(o.startLine-(i.baseY+i.cursorY)):void 0;if(!r)continue;this._currentCommand.commandStartMarker=o.startLine!==void 0?this._terminal.registerMarker(o.startLine-(i.baseY+i.cursorY)):void 0,this._currentCommand.commandStartX=o.startX,this._currentCommand.promptStartMarker=o.promptStartLine!==void 0?this._terminal.registerMarker(o.promptStartLine-(i.baseY+i.cursorY)):void 0,this._cwd=o.cwd,this._onCommandStarted.fire({marker:r});continue}const f=w.TerminalCommand.deserialize(this._terminal,o,this.__isCommandStorageDisabled);f&&(this._commands.push(f),this._logService.debug("CommandDetectionCapability#onCommandFinished",f),this._onCommandFinished.fire(f))}}}e.CommandDetectionCapability=h,_e([(0,k.debounce)(500)],h.prototype,"_handleCursorMove",null);class c extends I.Disposable{constructor(s,i,o,f){super(),this._terminal=s,this._capability=i,this._hooks=o,this._logService=f,this._register(s.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&o.clearCommandsInViewport(),!1)))}async handleCommandStart(s){this._hooks.commitCommandFinished();const i=this._capability.currentCommand;i.commandStartX=this._terminal.buffer.active.cursorX,i.commandStartMarker=s?.marker||this._terminal.registerMarker(0),i.commandExecutedMarker?.dispose(),i.commandExecutedMarker=void 0,i.commandExecutedX=void 0;for(const o of this._hooks.commandMarkers)o.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:s?.marker||i.commandStartMarker,markProperties:s?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",i.commandStartX,i.commandStartMarker?.line)}handleCommandExecuted(s){const i=this._capability.currentCommand;if(i.commandExecutedMarker=s?.marker||this._terminal.registerMarker(0),i.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",i.commandExecutedX,i.commandExecutedMarker?.line),!i.commandStartMarker||!i.commandExecutedMarker||i.commandStartX===void 0)return;i.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(i.commandStartMarker.line)?.translateToString(!0,i.commandStartX,i.commandRightPromptStartX).trim();let o=i.commandStartMarker.line+1;const f=i.commandExecutedMarker.line;for(;o<f;o++){const r=this._terminal.buffer.active.getLine(o);if(r){const t=i.continuations?.find(_=>_.marker.line===o);t&&(i.command+=`
`);const n=t?.end??0;i.command+=r.translateToString(!0,n)}}o===f&&(i.command+=this._terminal.buffer.active.getLine(f)?.translateToString(!0,void 0,i.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire(i)}}var S;(function(g){g[g.MaxCheckLineCount=5]="MaxCheckLineCount",g[g.Interval=20]="Interval",g[g.MaximumPollCount=50]="MaximumPollCount"})(S||(S={}));let p=class extends I.Disposable{constructor(s,i,o,f){super(),this._terminal=s,this._capability=i,this._hooks=o,this._logService=f,this._onCursorMoveListener=this._register(new I.MutableDisposable),this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(s.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&this._hooks.clearCommandsInViewport(),!1))),this._register(this._capability.onBeforeCommandFinished(r=>{(r.command.trim().toLowerCase()==="clear"||r.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(s){const i=this._terminal.buffer.active.baseY,o=s.rows-this._hooks.dimensions.rows;o>0&&this._waitForCursorMove().then(()=>{const f=Math.min(o,i);for(let r=this._capability.commands.length-1;r>=0;r--){const t=this._capability.commands[r];if(!t.marker||t.marker.line<i||t.commandStartLineContent===void 0)break;const n=this._terminal.buffer.active.getLine(t.marker.line);if(!n||n.translateToString(!0)===t.commandStartLineContent)continue;const _=t.marker.line-f;this._terminal.buffer.active.getLine(_)?.translateToString(!0)===t.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:f})}})}async handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const s=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?l(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new y.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(s),20),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(s){if(this._store.isDisposed)return;const i=this._terminal.buffer.active;let o=this._tryAdjustCommandStartMarkerScannedLineCount;for(;o<5&&s.line+o<i.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const f=this._getWindowsPrompt(s.line+o);if(f){const r=typeof f=="string"?f:f.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof f=="object"&&f.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=l(this._terminal,this._capability.currentCommand.commandStartMarker);const t=this._capability.commands.at(-1);t&&this._capability.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=l(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=r.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}o++}o<5?(this._tryAdjustCommandStartMarkerScannedLineCount=o,this._tryAdjustCommandStartMarkerPollCount<50?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=50,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const s=this._terminal.registerMarker(0);s&&this._hooks.commandMarkers.push(s)}})),this._capability.currentCommand.commandStartMarker){const s=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);s&&(this._capability.currentCommand.commandStartLineContent=s.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const s=this._capability.currentCommand,i=s.command,o=s.commandStartMarker?.line,f=s.commandExecutedMarker?.line;if(!i||i.length===0||o===void 0||o===-1||f===void 0||f===-1)return;let r=0,t=!1;for(let n=o;n<=f;n++){const _=this._terminal.buffer.active.getLine(n);if(!_)break;const O=_.translateToString(!0);for(let m=0;m<O.length;m++){for(;i.length<r&&i[r]===" ";)r++;if(O[m]===i[r]&&r++,r===i.length){const E=m>=this._terminal.cols-1;s.commandExecutedMarker=this._terminal.registerMarker(n-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(E?1:0)),s.commandExecutedX=E?0:m+1,t=!0;break}}if(t)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((s,i)=>s.line-i.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const s=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);s&&(this._capability.currentCommand.commandStartLineContent=s.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand)}}_cursorOnNextLine(){const s=this._capability.commands.at(-1);if(!s)return!0;const i=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,o=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return i>o}_waitForCursorMove(){const s=this._terminal.buffer.active.cursorX,i=this._terminal.buffer.active.cursorY;let o=0;return new Promise((f,r)=>{const t=setInterval(()=>{if(s!==this._terminal.buffer.active.cursorX||i!==this._terminal.buffer.active.cursorY){f(),clearInterval(t);return}o+=10,o>1e3&&(clearInterval(t),f())},10)})}_getWindowsPrompt(s=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const i=this._terminal.buffer.active.getLine(s);if(!i)return;const o=i.translateToString(!0);if(!o)return;const f=o.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(f){const _=this._adjustPrompt(f,o,">");if(_)return{prompt:_,likelySingleLine:!0}}const r=o.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(r){const _=this._adjustPrompt(r,o,"\u276F");if(_)return _}const t=o.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(t)return{prompt:t,likelySingleLine:!0};const n=o.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return n?.groups?.prompt?{prompt:n.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(s,i,o){if(s)return i===s&&s.endsWith(o)&&(s+=" "),s}};p=_e([Ue(3,M.ILogService)],p);function b(g,s,i,o){if(!o)return;const f=s.executedMarker,r=s.endMarker;if(!f||!r)return;const t=f.line,n=r.line,_=o.length,O=[];if(o.anchor==="bottom")for(let m=n-(o.offset||0);m>=t;m--){let E=m;const v=m;for(;E>=t&&g.getLine(E)?.isWrapped;)E--;m=E,O.unshift(u(g,E,v,i)),O.length>_&&O.pop()}else for(let m=t+(o.offset||0);m<n;m++){const E=m;let v=m;for(;v+1<n&&g.getLine(v+1)?.isWrapped;)v++;m=v,O.push(u(g,E,v,i)),O.length===_&&O.shift()}return O}function u(g,s,i,o){const f=Math.max(2048/o*2);i=Math.min(i,s+f);let r="";for(let t=s;t<=i;t++){const n=g.getLine(t);n&&(r+=n.translateToString(!0,0,o))}return r}function l(g,s,i=0){return g.registerMarker(s.line-(g.buffer.active.baseY+g.buffer.active.cursorY)+i)}}),define(he[90],de([0,1,4,2]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class C extends k.Disposable{constructor(){super(...arguments),this.type=0,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new y.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(M){const w=this._cwd!==M;this._cwd=M;const h=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,h+1),w&&this._onDidChangeCwd.fire(M)}}e.CwdDetectionCapability=C}),define(he[91],de([0,1,4,2]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var C;(function(M){M[M.MinimumPromptLength=2]="MinimumPromptLength"})(C||(C={}));class I extends k.DisposableStore{get commands(){return this._commands}constructor(w){super(),this._terminal=w,this.type=3,this._commands=[],this._onCommandFinished=this.add(new y.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(h=>this._onData(h))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(w){w==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=2){const w=this._terminal.registerMarker(0);w&&(this._commands.push(w),this._onCommandFinished.fire(w))}}_clearCommandsInViewport(){let w=0;for(let h=this._commands.length-1;h>=0&&!(this._commands[h].line<this._terminal.buffer.active.baseY);h--)w++;this._commands.splice(this._commands.length-w,w)}}e.PartialCommandDetectionCapability=I}),define(he[92],de([0,1,4,2]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class C extends k.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new y.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new y.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new y.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new y.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(w,h){this._map.set(w,h),this._onDidAddCapabilityType.fire(w),this._onDidAddCapability.fire({id:w,capability:h})}get(w){return this._map.get(w)}remove(w){const h=this._map.get(w);h&&(this._map.delete(w),this._onDidRemoveCapabilityType.fire(w),this._onDidAddCapability.fire({id:w,capability:h}))}has(w){return this._map.has(w)}}e.TerminalCapabilityStore=C;class I extends k.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new y.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new y.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new y.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new y.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const w of this._stores)for(const h of w.items)yield h}has(w){for(const h of this._stores)for(const c of h.items)if(c===w)return!0;return!1}get(w){for(const h of this._stores){const c=h.get(w);if(c)return c}}add(w){this._stores.push(w);for(const h of w.items)this._onDidAddCapabilityType.fire(h),this._onDidAddCapability.fire({id:h,capability:w.get(h)});this._register(w.onDidAddCapabilityType(h=>this._onDidAddCapabilityType.fire(h))),this._register(w.onDidAddCapability(h=>this._onDidAddCapability.fire(h))),this._register(w.onDidRemoveCapabilityType(h=>this._onDidRemoveCapabilityType.fire(h))),this._register(w.onDidRemoveCapability(h=>this._onDidRemoveCapability.fire(h)))}}e.TerminalCapabilityStoreMultiplexer=I}),define(he[36],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(k){k[k.Replace=1]="Replace",k[k.Append=2]="Append",k[k.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(he[93],de([0,1,3,36]),function(le,e,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const C=new Map([[k.EnvironmentVariableMutatorType.Append,"APPEND"],[k.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[k.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(S){this.collections=S,this.map=new Map,this.descriptionMap=new Map,S.forEach((p,b)=>{this.populateDescriptionMap(p,b);const u=p.map.entries();let l=u.next();for(;!l.done;){const g=l.value[1],s=l.value[0];let i=this.map.get(s);if(i||(i=[],this.map.set(s,i)),i.length>0&&i[0].type===k.EnvironmentVariableMutatorType.Replace){l=u.next();continue}const o={extensionIdentifier:b,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};o.scope||delete o.scope,i.unshift(o),l=u.next()}})}async applyToProcessEnvironment(S,p,b){let u;y.isWindows&&(u={},Object.keys(S).forEach(l=>u[l.toLowerCase()]=l));for(const[l,g]of this.getVariableMap(p)){const s=y.isWindows&&u[l.toLowerCase()]||l;for(const i of g){const o=b?await b(i.value):i.value;if(i.options?.applyAtProcessCreation??!0)switch(i.type){case k.EnvironmentVariableMutatorType.Append:S[s]=(S[s]||"")+o;break;case k.EnvironmentVariableMutatorType.Prepend:S[s]=o+(S[s]||"");break;case k.EnvironmentVariableMutatorType.Replace:S[s]=o;break}if(i.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${C.get(i.type)}`;S[f]=(S[f]?S[f]+":":"")+l+"="+this._encodeColons(o)}}}}_encodeColons(S){return S.replaceAll(":","\\x3a")}diff(S,p){const b=new Map,u=new Map,l=new Map;if(S.getVariableMap(p).forEach((g,s)=>{const i=this.getVariableMap(p).get(s),o=w(g,i);o&&b.set(s,o)}),this.getVariableMap(p).forEach((g,s)=>{const i=S.getVariableMap(p).get(s),o=w(g,i);o&&l.set(s,o)}),this.getVariableMap(p).forEach((g,s)=>{const i=S.getVariableMap(p).get(s),o=h(g,i);o&&u.set(s,o)}),!(b.size===0&&u.size===0&&l.size===0))return{added:b,changed:u,removed:l}}getVariableMap(S){const p=new Map;for(const b of this.map.values()){const u=b.filter(l=>M(l,S));u.length>0&&p.set(u[0].variable,u)}return p}getDescriptionMap(S){const p=new Map;for(const b of this.descriptionMap.values()){const u=b.filter(l=>M(l,S,!0));for(const l of u)p.set(l.extensionIdentifier,l.description)}return p}populateDescriptionMap(S,p){if(!S.descriptionMap)return;const b=S.descriptionMap.entries();let u=b.next();for(;!u.done;){const l=u.value[1],g=u.value[0];let s=this.descriptionMap.get(g);s||(s=[],this.descriptionMap.set(g,s));const i={extensionIdentifier:p,scope:l.scope,description:l.description};i.scope||delete i.scope,s.push(i),u=b.next()}}}e.MergedEnvironmentVariableCollection=I;function M(c,S,p=!1){return c.scope?!!(c.scope.workspaceFolder&&S?.workspaceFolder&&c.scope.workspaceFolder.index===S.workspaceFolder.index):p?S===c.scope:!0}function w(c,S){if(!S)return c;const p=new Set;S.forEach(u=>p.add(u.extensionIdentifier));const b=[];return c.forEach(u=>{p.has(u.extensionIdentifier)||b.push(u)}),b.length===0?void 0:b}function h(c,S){if(!S)return;const p=new Map;S.forEach(u=>p.set(u.extensionIdentifier,u));const b=[];return c.forEach(u=>{const l=p.get(u.extensionIdentifier);l&&(u.type!==l.type||u.value!==l.value||u.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index)&&b.push(l)}),b.length===0?void 0:b}}),define(he[94],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=y,e.serializeEnvironmentDescriptionMap=k,e.deserializeEnvironmentVariableCollection=C,e.deserializeEnvironmentDescriptionMap=I,e.serializeEnvironmentVariableCollections=M,e.deserializeEnvironmentVariableCollections=w;function y(h){return[...h.entries()]}function k(h){return h?[...h.entries()]:[]}function C(h){return new Map(h)}function I(h){return new Map(h??[])}function M(h){return Array.from(h.entries()).map(c=>[c[0],y(c[1].map),k(c[1].descriptionMap)])}function w(h){return new Map(h.map(c=>[c[0],{map:C(c[1]),descriptionMap:I(c[2])}]))}}),define(he[95],de([0,1,10,17,4,2,11]),function(le,e,y,k,C,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let w=class extends I.Disposable{constructor(c,S){super(),this._logService=S,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new C.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=c===void 0?15e3:c,this._register((0,I.toDisposable)(()=>{for(const p of this._pendingRequestDisposables.values())(0,I.dispose)(p)}))}createRequest(c){return new Promise((S,p)=>{const b=++this._lastRequestId;this._pendingRequests.set(b,S),this._onCreateRequest.fire({requestId:b,...c});const u=new k.CancellationTokenSource;(0,y.timeout)(this._timeout,u.token).then(()=>p(`Request ${b} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(b,[(0,I.toDisposable)(()=>u.cancel())])})}acceptReply(c,S){const p=this._pendingRequests.get(c);p?(this._pendingRequests.delete(c),(0,I.dispose)(this._pendingRequestDisposables.get(c)||[]),this._pendingRequestDisposables.delete(c),p(S)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.RequestStore=w,e.RequestStore=w=_e([Ue(1,M.ILogService)],w)}),define(he[28],de([0,1,21,35,86]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new k.RawContextKey("terminalTabFocusMode",!1,!0);var I;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var M;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",t.LocalEchoEnabled="terminal.integrated.localEchoEnabled",t.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",t.LocalEchoStyle="terminal.integrated.localEchoStyle",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",t.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",t.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",t.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",t.MouseWheelZoom="terminal.integrated.mouseWheelZoom",t.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(M||(e.TerminalSettingId=M={}));var w;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(w||(e.PosixShellType=w={}));var h;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(h||(e.WindowsShellType=h={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var S;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(S||(e.TerminalIpcChannels=S={}));var p;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.IPtyService=(0,y.createDecorator)("ptyService");var b;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var u;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var l;(function(t){t.TerminalView="view",t.Editor="editor"})(l||(e.TerminalLocationString=l={}));var g;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var i;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(i||(e.ProfileSource=i={}));var o;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(o||(e.ShellIntegrationStatus=o={}));var f;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(n){const _=this._sanitizeRemoteAuthority(n.remoteAuthority);if(this._backends.has(_))throw new Error(`A terminal backend with remote authority '${_}' was already registered.`);this._backends.set(_,n)}getTerminalBackend(n){return this._backends.get(this._sanitizeRemoteAuthority(n))}_sanitizeRemoteAuthority(n){return n?.toLowerCase()??""}}C.Registry.add(e.TerminalExtensions.Backend,new r),e.ILocalPtyService=(0,y.createDecorator)("localPtyService"),e.ITerminalLogService=(0,y.createDecorator)("terminalLogService")}),define(he[96],de([0,1,10,2,3]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class I extends k.Disposable{constructor(w,h,c,S){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(w.onProcessData(p=>{if(this._paused||this._throttled)return;const b=typeof p=="string"?p:p.data;for(let u=0;u<b.length;u++)b[u]===h[this._pointer]?this._pointer++:this._reset(),this._pointer===h.length&&(S.debug(`Auto reply match: "${h}", response: "${c}"`),w.input(c),this._throttled=!0,(0,y.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){C.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=I}),define(he[97],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class y{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,I,M=5){const w=I(h=>{const c=typeof h=="string"?h:h.data;let S=this._terminalBufferMap.get(C);if(S){S.data.push(c);return}const p=setTimeout(()=>this.flushBuffer(C),M);S={data:[c],timeoutId:p,dispose:()=>{clearTimeout(p),this.flushBuffer(C),w.dispose()}},this._terminalBufferMap.set(C,S)});return w}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const I=this._terminalBufferMap.get(C);I&&(this._terminalBufferMap.delete(C),this._callback(C,I.data.join("")))}}e.TerminalDataBufferer=y}),define(he[37],de([0,1,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeNonWindowsPath=k,e.collapseTildePath=C,e.sanitizeCwd=I,e.shouldUseEnvironmentVariableCollection=M;function k(w){let h=w;h.includes("\\")&&(h=h.replace(/\\/g,"\\\\"));const c=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return h=h.replace(c,""),`'${h}'`}function C(w,h,c){if(!w)return"";if(!h)return w;h.match(/[\/\\]$/)&&(h=h.slice(0,h.length-1));const S=w.replace(/\\/g,"/").toLowerCase(),p=h.replace(/\\/g,"/").toLowerCase();return S.includes(p)?`~${c}${w.slice(h.length+1)}`:w}function I(w){return w.match(/^['"].*['"]$/)&&(w=w.substring(1,w.length-1)),y.OS===1&&w&&w[1]===":"?w[0].toUpperCase()+w.substring(1):w}function M(w){return!w.strictEnv}}),define(he[98],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=k;var y;(function(C){C[C.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(y||(y={}));function k(C){const I=[];let M=0;for(let w=0;w<C.length-1;w++)(w-M+1>=50||C[w+1]==="\x1B")&&(I.push(C.substring(M,w+1)),M=w+1,w++);return M!==C.length&&I.push(C.substring(M)),I}}),define(he[99],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=y;function y(k,C={}){let I="";return C.excludeLeadingNewLine||(I+=`\r
`),I+="\x1B[0m\x1B[7m * ",C.loudFormatting?I+="\x1B[0;104m":I+="\x1B[0m",I+=` ${k} \x1B[0m
\r`,I}}),define(he[100],de([0,1,2,92,89,90,91,4,87,6,37]),function(le,e,y,k,C,I,M,w,h,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ShellIntegrationAddon=void 0,e.deserializeMessage=g,e.parseKeyValueAssignment=s,e.parseMarkSequence=i;var p;(function(o){o[o.FinalTerm=133]="FinalTerm",o[o.VSCode=633]="VSCode",o[o.ITerm=1337]="ITerm",o[o.SetCwd=7]="SetCwd",o[o.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(p||(p={}));var b;(function(o){o.PromptStart="A",o.CommandStart="B",o.CommandExecuted="C",o.CommandFinished="D",o.CommandLine="E",o.ContinuationStart="F",o.ContinuationEnd="G",o.RightPromptStart="H",o.RightPromptEnd="I",o.Property="P",o.SetMark="SetMark"})(b||(b={}));var u;(function(o){o.SetMark="SetMark",o.CurrentDir="CurrentDir"})(u||(u={}));class l extends y.Disposable{get status(){return this._status}constructor(f,r,t,n){super(),this._nonce=f,this._disableTelemetry=r,this._telemetryService=t,this._logService=n,this.capabilities=this._register(new k.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=0,this._onDidChangeStatus=new w.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,y.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,y.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(f){this._terminal=f,this.capabilities.add(3,this._register(new M.PartialCommandDetectionCapability(this._terminal))),this._register(f.parser.registerOscHandler(633,r=>this._handleVSCodeSequence(r))),this._register(f.parser.registerOscHandler(1337,r=>this._doHandleITermSequence(r))),this._commonProtocolDisposables.push(f.parser.registerOscHandler(133,r=>this._handleFinalTermSequence(r))),this._register(f.parser.registerOscHandler(7,r=>this._doHandleSetCwd(r))),this._register(f.parser.registerOscHandler(9,r=>this._doHandleSetWindowsFriendlyCwd(r))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(f,r){this._createOrGetBufferMarkDetection(f).getMark(r)}_handleFinalTermSequence(f){const r=this._doHandleFinalTermSequence(f);return this._status===0&&(this._status=1,this._onDidChangeStatus.fire(this._status)),r}_doHandleFinalTermSequence(f){if(!this._terminal)return!1;const[r,...t]=f.split(";");switch(r){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const n=t.length===1?parseInt(t[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(n),!0}}return!1}_handleVSCodeSequence(f){const r=this._doHandleVSCodeSequence(f);return!this._hasUpdatedTelemetry&&r&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==2&&(this._status=2,this._onDidChangeStatus.fire(this._status)),r}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(f){if(!this._terminal)return!1;const r=f.indexOf(";"),t=r===-1?f:f.substring(0,r),n=r===-1?[]:f.substring(r+1).split(";");switch(t){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const _=n[0],O=_!==void 0?parseInt(_):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(O),!0}case"E":{const _=n[0],O=n[1];let m;return _!==void 0?m=g(_):m="",this._createOrGetCommandDetection(this._terminal).setCommandLine(m,O===this._nonce),!0}case"F":return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case"G":return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case"H":return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case"I":return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case"P":{const _=n[0],O=_!==void 0?g(_):"",{key:m,value:E}=s(O);if(E===void 0)return!0;switch(m){case"Cwd":return this._updateCwd(E),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(E==="True"),!0;case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this._createOrGetBufferMarkDetection(this._terminal).addMark(i(n)),!0}return!1}_updateCwd(f){f=(0,S.sanitizeCwd)(f),this._createOrGetCwdDetection().updateCwd(f),this.capabilities.get(2)?.setCwd(f)}_doHandleITermSequence(f){if(!this._terminal)return!1;const[r]=f.split(";");switch(r){case"SetMark":this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:t,value:n}=s(r);if(n===void 0)return!0;switch(t){case"CurrentDir":return this._updateCwd(n),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(f){if(!this._terminal)return!1;const[r,...t]=f.split(";");switch(r){case"9":return t.length&&this._updateCwd(t[0]),!0}return!1}_doHandleSetCwd(f){if(!this._terminal)return!1;const[r]=f.split(";");if(r.match(/^file:\/\/.*\//)){const t=c.URI.parse(r);if(t.path&&t.path.length>0)return this._updateCwd(t.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(f){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(f)}_createOrGetCwdDetection(){let f=this.capabilities.get(0);return f||(f=this._register(new I.CwdDetectionCapability),this.capabilities.add(0,f)),f}_createOrGetCommandDetection(f){let r=this.capabilities.get(2);return r||(r=this._register(new C.CommandDetectionCapability(f,this._logService)),this.capabilities.add(2,r)),r}_createOrGetBufferMarkDetection(f){let r=this.capabilities.get(4);return r||(r=this._register(new h.BufferMarkCapability(f)),this.capabilities.add(4,r)),r}}e.ShellIntegrationAddon=l;function g(o){return o.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(f,r,t)=>t?String.fromCharCode(parseInt(t,16)):r)}function s(o){const f=o.indexOf("=");return f===-1?{key:o,value:void 0}:{key:o.substring(0,f),value:o.substring(1+f)}}function i(o){let f,r=!1;for(const t of o)t!==void 0&&(t==="Hidden"&&(r=!0),t.startsWith("Id=")&&(f=t.substring(3)));return{id:f,hidden:r}}}),define(he[38],de([0,1,5,14,4,2,62,11]),function(le,e,y,k,C,I,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var h;(function(S){S[S.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",S[S.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.ignoreProcessNames=[];let c=class extends I.Disposable{set hasChildProcesses(p){this._hasChildProcesses!==p&&(this._hasChildProcesses=p,this._logService.debug("ChildProcessMonitor: Has child processes changed",p),this._onDidChangeHasChildProcesses.fire(p))}get hasChildProcesses(){return this._hasChildProcesses}constructor(p,b){super(),this._pid=p,this._logService=b,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new C.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const p=await(0,M.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(p)}catch(p){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",p)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(p){if(!p.children)return!1;if(p.children.length===1){const b=p.children[0];let u;if(b.cmd.startsWith('"'))u=b.cmd.substring(1,b.cmd.indexOf('"',1));else{const l=b.cmd.indexOf(" ");l===-1?u=b.cmd:u=b.cmd.substring(0,l)}return e.ignoreProcessNames.indexOf((0,y.parse)(u).name)===-1}return p.children.length>0}};e.ChildProcessMonitor=c,_e([(0,k.debounce)(1e3)],c.prototype,"_refreshActive",null),_e([(0,k.throttle)(5e3)],c.prototype,"_refreshInactive",null),e.ChildProcessMonitor=c=_e([Ue(1,w.ILogService)],c)}),define(he[101],de([0,1,4,2,28]),function(le,e,y,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class I extends k.Disposable{constructor(){super(),this._onBeat=this._register(new y.Emitter),this.onBeat=this._onBeat.event;const w=setInterval(()=>{this._onBeat.fire()},C.HeartbeatConstants.BeatInterval);this._register((0,k.toDisposable)(()=>clearInterval(w)))}}e.HeartbeatService=I}),define(he[39],de([0,1,20,19,30,5,3,15,12,8,24,36,94,93]),function(le,e,y,k,C,I,M,w,h,c,S,p,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=l,e.findExecutable=g,e.getShellIntegrationInjection=s;function l(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let E=0;return m&&m.length===4&&(E=parseInt(m[3])),E}async function g(m,E,v,A=w.env,W=S.Promises.exists){if(I.isAbsolute(m))return await W(m)?m:void 0;if(E===void 0&&(E=w.cwd()),I.dirname(m)!=="."){const a=I.join(E,m);return await W(a)?a:void 0}const N=(0,C.getCaseInsensitive)(A,"PATH");if(v===void 0&&(0,c.isString)(N)&&(v=N.split(I.delimiter)),v===void 0||v.length===0){const a=I.join(E,m);return await W(a)?a:void 0}for(const a of v){let L;if(I.isAbsolute(a)?L=I.join(a,m):L=I.join(E,a,m),await W(L))return L;if(M.isWindows){let P=L+".com";if(await W(P)||(P=L+".exe",await W(P)))return P}}const D=I.join(E,m);return await W(D)?D:void 0}function s(m,E,v,A,W){const Y=M.isWindows&&(!E.windowsEnableConpty||l()<18309);if(!E.shellIntegration.enabled||!m.executable||m.isFeatureTerminal&&!m.forceShellIntegration||m.ignoreShellIntegration||Y)return;const N=m.args,D=w.platform==="win32"?I.basename(m.executable).toLowerCase():I.basename(m.executable),a=I.dirname(k.FileAccess.asFileUri("").fsPath);let L;const P={VSCODE_INJECTION:"1"};if(E.shellIntegration.nonce&&(P.VSCODE_NONCE=E.shellIntegration.nonce),M.isWindows){if(D==="pwsh.exe"||D==="powershell.exe")return!N||_(N)?L=f.get(o.WindowsPwsh):n(N)&&(L=f.get(o.WindowsPwshLogin)),L?(L=[...L],L[L.length-1]=(0,h.format)(L[L.length-1],a,""),E.shellIntegration.suggestEnabled&&(P.VSCODE_SUGGEST="1"),{newArgs:L,envMixin:P}):void 0;A.warn(`Shell integration cannot be enabled for executable "${m.executable}" and args`,m.args);return}switch(D){case"bash":return!N||N.length===0?L=f.get(o.Bash):O(N)&&(P.VSCODE_SHELL_LOGIN="1",i(E,P),L=f.get(o.Bash)),L?(L=[...L],L[L.length-1]=(0,h.format)(L[L.length-1],a),{newArgs:L,envMixin:P}):void 0;case"fish":{const T=v?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=I.join(a,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return P.XDG_DATA_DIRS=`${T}:${J}`,i(E,P),{newArgs:void 0,envMixin:P}}case"pwsh":return!N||_(N)?L=f.get(o.Pwsh):n(N)&&(L=f.get(o.PwshLogin)),L?(E.shellIntegration.suggestEnabled&&(P.VSCODE_SUGGEST="1"),L=[...L],L[L.length-1]=(0,h.format)(L[L.length-1],a,""),{newArgs:L,envMixin:P}):void 0;case"zsh":{if(!N||N.length===0?L=f.get(o.Zsh):O(N)?(L=f.get(o.ZshLogin),i(E,P)):(N===f.get(o.Zsh)||N===f.get(o.ZshLogin))&&(L=N),!L)return;L=[...L],L[L.length-1]=(0,h.format)(L[L.length-1],a);let T;try{T=y.userInfo().username}catch{T="unknown"}const J=I.join(y.tmpdir(),`${T}-${W.applicationName}-zsh`);P.ZDOTDIR=J;const re=v?.ZDOTDIR??y.homedir()??"~";P.USER_ZDOTDIR=re;const x=[];return x.push({source:I.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.join(J,".zshrc")}),x.push({source:I.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.join(J,".zprofile")}),x.push({source:I.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.join(J,".zshenv")}),x.push({source:I.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.join(J,".zlogin")}),{newArgs:L,envMixin:P,filesToCopy:x}}}A.warn(`Shell integration cannot be enabled for executable "${m.executable}" and args`,m.args)}function i(m,E){if(M.isMacintosh&&m.environmentVariableCollections){const v=(0,b.deserializeEnvironmentVariableCollections)(m.environmentVariableCollections),W=new u.MergedEnvironmentVariableCollection(v).getVariableMap({workspaceFolder:m.workspaceFolder}).get("PATH"),Y=[];if(W)for(const N of W)N.type===p.EnvironmentVariableMutatorType.Prepend&&Y.push(N.value);Y.length>0&&(E.VSCODE_PATH_PREFIX=Y.join(""))}}var o;(function(m){m.WindowsPwsh="windows-pwsh",m.WindowsPwshLogin="windows-pwsh-login",m.Pwsh="pwsh",m.PwshLogin="pwsh-login",m.Zsh="zsh",m.ZshLogin="zsh-login",m.Bash="bash"})(o||(o={}));const f=new Map;f.set(o.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(o.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(o.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(o.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(o.Zsh,["-i"]),f.set(o.ZshLogin,["-il"]),f.set(o.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const r=["-login","-l"],t=["-nol","-nologo"];function n(m){return typeof m=="string"?r.includes(m.toLowerCase()):m.length===1&&r.includes(m[0].toLowerCase())||m.length===2&&(r.includes(m[0].toLowerCase())||r.includes(m[1].toLowerCase()))&&(t.includes(m[0].toLowerCase())||t.includes(m[1].toLowerCase()))}function _(m){return typeof m=="string"?t.includes(m.toLowerCase()):m.length===0||m?.length===1&&t.includes(m[0].toLowerCase())}function O(m){return m==="string"&&r.includes(m.toLowerCase())||typeof m!="string"&&m.length===1&&r.includes(m[0].toLowerCase())}}),define(he[102],de([0,1,10,14,4,2,3]),function(le,e,y,k,C,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const w=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class c extends I.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(p){if(super(),this._rootProcessId=p,this._shellTitle="",this._onShellNameChanged=new C.Emitter,this._onShellTypeChanged=new C.Emitter,!M.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${M.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){M.isWindows&&(await(0,y.timeout)(300),this.getShellName().then(p=>{const b=this.getShellType(p);b!==this._shellType&&(this._onShellTypeChanged.fire(b),this._onShellNameChanged.fire(p),this._shellType=b,this._shellTitle=p)}))}traverseTree(p){if(!p)return"";if(w.indexOf(p.name)===-1||!p.children||p.children.length===0)return p.name;let b=0;for(;b<p.children.length;b++){const u=p.children[b];if(!u.children||u.children.length===0||u.children[0].name!=="conhost.exe")break}return b>=p.children.length?p.name:this.traverseTree(p.children[b])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(h||(h=await new Promise((p,b)=>{le(["@vscode/windows-process-tree"],p,b)})),this._currentRequest=new Promise(p=>{h.getProcessTree(this._rootProcessId,b=>{const u=this.traverseTree(b);this._currentRequest=void 0,p(u)})}),this._currentRequest)}getShellType(p){switch(p.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return p.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.WindowsShellHelper=c,_e([(0,k.debounce)(500)],c.prototype,"checkShell",null)}),define(he[103],de([0,1,26,10,4,2,5,3,6,24,72,11,85,38,39,102,108,98]),function(le,e,y,k,C,I,M,w,h,c,S,p,b,u,l,g,s,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;var f;(function(O){O[O.DataFlushTimeout=250]="DataFlushTimeout",O[O.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(f||(f={}));var r;(function(O){O[O.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",O[O.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",O[O.WriteInterval=5]="WriteInterval"})(r||(r={}));const t=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let n=class extends I.Disposable{static{o=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return w.isWindows?this._windowsShellHelper?.shellType:t.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(m,E,v,A,W,Y,N,D,a){super(),this.shellLaunchConfig=m,this._executableEnv=Y,this._options=N,this._logService=D,this._productService=a,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new C.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new C.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new C.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new C.Emitter),this.onProcessExit=this._onProcessExit.event;let L;w.isWindows?L=M.basename(this.shellLaunchConfig.executable||""):L="xterm-256color",this._initialCwd=E,this._properties.initialCwd=this._initialCwd,this._properties.cwd=this._initialCwd;const P=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,l.getWindowsBuildNumber)()>=18309;this._ptyOptions={name:L,cwd:E,env:W,cols:v,rows:A,useConpty:P,conptyInheritCursor:P&&!!m.initialText},w.isWindows&&(P&&v===0&&A===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new _,this._register(this._delayedResizer.onTrigger(T=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,T.cols&&T.rows&&this.resize(T.cols,T.rows)}))),this.onProcessReady(T=>{this._windowsShellHelper=this._register(new g.WindowsShellHelper(T.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(J=>this._onDidChangeProperty.fire({type:"shellType",value:J}))),this._register(this._windowsShellHelper.onShellNameChanged(J=>this._onDidChangeProperty.fire({type:"title",value:J})))})),this._register((0,I.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const E=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(A=>A!==void 0);if(E)return E;let v;if(this._options.shellIntegration.enabled)if(v=(0,l.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),v){if(this._onDidChangeProperty.fire({type:"usedShellIntegrationInjection",value:!0}),v.envMixin)for(const[A,W]of Object.entries(v.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[A]=W;if(v.filesToCopy)for(const A of v.filesToCopy){await c.Promises.mkdir(M.dirname(A.dest),{recursive:!0});try{await c.Promises.copyFile(A.source,A.dest)}catch{}}}else this._onDidChangeProperty.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,v),v?.newArgs?{injectedArgs:v.newArgs}:void 0}catch(A){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",A),{message:`A native exception occurred during launch (${A.message})`}}}async _validateCwd(){try{if(!(await c.Promises.stat(this._initialCwd)).isDirectory())return{message:(0,S.localize)(0,null,this._initialCwd.toString())}}catch(m){if(m?.code==="ENOENT")return{message:(0,S.localize)(1,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:"initialCwd",value:this._initialCwd})}async _validateExecutable(){const m=this.shellLaunchConfig;if(!m.executable)throw new Error("IShellLaunchConfig.executable not set");const E=m.cwd instanceof h.URI?m.cwd.path:m.cwd,v=m.env&&m.env.PATH?m.env.PATH.split(M.delimiter):void 0,A=await(0,l.findExecutable)(m.executable,E,v,this._executableEnv);if(!A)return{message:(0,S.localize)(2,null,m.executable)};try{const W=await c.Promises.stat(A);if(!W.isFile()&&!W.isSymbolicLink())return{message:(0,S.localize)(3,null,m.executable)};m.executable=A}catch(W){if(W?.code!=="EACCES")throw W}}async setupPtyProcess(m,E,v){const A=v?.newArgs||m.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",m.executable,A,E);const W=(0,s.spawn)(m.executable,A,E);this._ptyProcess=W,this._childProcessMonitor=this._register(new u.ChildProcessMonitor(W.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(Y=>this._onDidChangeProperty.fire({type:"hasChildProcesses",value:Y})),this._processStartupComplete=new Promise(Y=>{this.onProcessReady(()=>Y())}),W.onData(Y=>{this._unacknowledgedCharCount+=Y.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > 100000)`),this._isPtyPaused=!0,W.pause()),this._logService.trace("node-pty.IPty#onData",Y),this._onProcessData.fire(Y),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),W.onExit(Y=>{this._exitCode=Y.exitCode,this._queueProcessExit()}),this._sendProcessId(W.pid),this._setupTitlePolling(W)}_setupTitlePolling(m){setTimeout(()=>this._sendProcessTitle(m)),w.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==m.process&&this._sendProcessTitle(m)},200))}_queueProcessExit(){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},250)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!w.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-o._lastKillOrStart<250;)this._logService.trace("Throttling kill/spawn call"),await(0,k.timeout)(250-(Date.now()-o._lastKillOrStart)+50);o._lastKillOrStart=Date.now()}}_sendProcessId(m){this._onProcessReady.fire({pid:m,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(m){if(this._store.isDisposed)return;this._currentTitle=m.process,this._onDidChangeProperty.fire({type:"title",value:this._currentTitle});const E=this.currentTitle.replace(/ \(figterm\)$/g,"");E.toLowerCase().startsWith("python")?this._onDidChangeProperty.fire({type:"shellType",value:"python"}):this._onDidChangeProperty.fire({type:"shellType",value:t.get(E)})}shutdown(m){this._logService.getLevel()===p.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),m&&!w.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},5e3))}input(m,E=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,i.chunkInput)(m).map(v=>({isBinary:E,data:v}))),this._startWrite())}async processBinary(m){this.input(m,!0)}async refreshProperty(m){switch(m){case"cwd":{const E=await this.getCwd();return E!==this._properties.cwd&&(this._properties.cwd=E,this._onDidChangeProperty.fire({type:"cwd",value:this._properties.cwd})),E}case"initialCwd":{const E=await this.getInitialCwd();return E!==this._properties.initialCwd&&(this._properties.initialCwd=E,this._onDidChangeProperty.fire({type:"initialCwd",value:this._properties.initialCwd})),E}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(m,E){m==="fixedDimensions"&&(this._properties.fixedDimensions=E)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},5)}}_doWrite(){const m=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",m.data),m.isBinary?this._ptyProcess.write(Buffer.from(m.data,"binary")):this._ptyProcess.write(m.data),this._childProcessMonitor?.handleInput()}resize(m,E){if(!this._store.isDisposed&&!(typeof m!="number"||typeof E!="number"||isNaN(m)||isNaN(E))&&this._ptyProcess){if(m=Math.max(m,1),E=Math.max(E,1),this._delayedResizer){this._delayedResizer.cols=m,this._delayedResizer.rows=E;return}this._logService.trace("node-pty.IPty#resize",m,E);try{this._ptyProcess.resize(m,E)}catch(v){if(this._logService.trace("node-pty.IPty#resize exception "+v.message),this._exitCode!==void 0&&v.message!=="ioctl(2) failed, EBADF"&&v.message!=="Cannot resize a pty that has already exited")throw v}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(m){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-m,0),this._logService.trace(`Flow control: Ack ${m} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < 5000)`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(w.isMacintosh)return new Promise(m=>{if(!this._ptyProcess){m(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,y.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(E,v,A)=>{!E&&v!==""?m(v.substring(v.indexOf("/"),v.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",E,v,A),m(this._initialCwd))})});if(w.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await c.Promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return w.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,l.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=n,e.TerminalProcess=n=o=_e([Ue(7,p.ILogService),Ue(8,b.IProductService)],n);class _ extends I.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new C.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,I.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(he[104],de([0,1,26,10,4,2,3,63,11,95,28,97,37,109,39,103,71,38,96,7,100,99,77,14,110]),function(le,e,y,k,C,I,M,w,h,c,S,p,b,u,l,g,s,i,o,f,r,t,n,_,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=void 0,e.traceRpc=m;function m(L,P,T){if(typeof T.value!="function")throw new Error("not supported");const J="value",re=T.value;T[J]=async function(...x){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${re.name}(${x.map(ce=>JSON.stringify(ce)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,k.timeout)(this.traceRpcArgs.simulatedLatency);let te;try{te=await re.apply(this,x)}catch(ce){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${re.name}`,ce),ce}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${re.name}`,te),te}}let E,v;class A extends I.Disposable{_traceEvent(P,T){return T(J=>{this._logService.getLevel()===h.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${P}.fire(${JSON.stringify(J)})`)}),T}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(P,T,J,re){super(),this._logService=P,this._productService=T,this._reconnectConstants=J,this._simulatedLatency=re,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new C.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new C.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new C.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new C.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new C.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new C.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new C.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new C.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,I.toDisposable)(()=>{for(const x of this._ptys.values())x.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new c.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(P){i.ignoreProcessNames.length=0,i.ignoreProcessNames.push(...P)}async requestDetachInstance(P,T){return this._detachInstanceRequestStore.createRequest({workspaceId:P,instanceId:T})}async acceptDetachInstanceReply(P,T){let J;const re=this._ptys.get(T);re&&(J=await this._buildProcessDetails(T,re)),this._detachInstanceRequestStore.acceptReply(P,J)}async freePortKillProcess(P){const J=(await new Promise((re,x)=>{(0,y.exec)(M.isWindows?`netstat -ano | findstr "${P}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${P}`,{},(te,ce)=>{if(te)return x("Problem occurred when listing active processes");re(ce)})})).split(/\r?\n/).filter(re=>!!re.trim());if(J.length>=1){const re=/\s+(\d+)(?:\s+|$)/,x=J[0].match(re)?.[1];if(x)try{process.kill(Number.parseInt(x))}catch{}else throw new Error(`Processes for port ${P} were not found`);return{port:P,processId:x}}throw new Error(`Could not kill process with port ${P}`)}async serializeTerminalState(P){const T=[];for(const[re,x]of this._ptys.entries())x.hasWrittenData&&P.indexOf(re)!==-1&&T.push(k.Promises.withAsyncBody(async te=>{te({id:re,shellLaunchConfig:x.shellLaunchConfig,processDetails:await this._buildProcessDetails(re,x),processLaunchConfig:x.processLaunchOptions,unicodeVersion:x.unicodeVersion,replayEvent:await x.serializeNormalBuffer(),timestamp:Date.now()})}));const J={version:1,state:await Promise.all(T)};return JSON.stringify(J)}async reviveTerminalProcesses(P,T,J){const re=[];for(const x of T)re.push(this._reviveTerminalProcess(P,x));await Promise.all(re)}async _reviveTerminalProcess(P,T){const J=(0,s.localize)(0,null),re=await this.createProcess({...T.shellLaunchConfig,cwd:T.processDetails.cwd,color:T.processDetails.color,icon:T.processDetails.icon,name:T.processDetails.titleSource===S.TitleEventSource.Api?T.processDetails.title:void 0,initialText:T.replayEvent.events[0].data+(0,t.formatMessageForTerminal)(J,{loudFormatting:!0})},T.processDetails.cwd,T.replayEvent.events[0].cols,T.replayEvent.events[0].rows,T.unicodeVersion,T.processLaunchConfig.env,T.processLaunchConfig.executableEnv,T.processLaunchConfig.options,!0,T.processDetails.workspaceId,T.processDetails.workspaceName,!0,T.replayEvent.events[0].data),x=this._getRevivingProcessId(P,T.id);this._revivedPtyIdMap.set(x,{newId:re,state:T}),this._logService.info(`Revived process, old id ${x} -> new id ${re}`)}async shutdownAll(){this.dispose()}async createProcess(P,T,J,re,x,te,ce,me,G,q,Q,ie,$){if(P.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const ee=++this._lastPtyId,ge=new g.TerminalProcess(P,T,J,re,te,ce,me,this._logService,this._productService),Z={env:te,executableEnv:ce,options:me},d=new Y(ee,ge,q,Q,G,J,re,Z,x,this._reconnectConstants,this._logService,ie&&typeof P.initialText=="string"?P.initialText:void 0,$,P.icon,P.color,P.name,P.fixedDimensions);return ge.onProcessExit(z=>{d.dispose(),this._ptys.delete(ee),this._onProcessExit.fire({id:ee,event:z})}),d.onProcessData(z=>this._onProcessData.fire({id:ee,event:z})),d.onProcessReplay(z=>this._onProcessReplay.fire({id:ee,event:z})),d.onProcessReady(z=>this._onProcessReady.fire({id:ee,event:z})),d.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:ee})),d.onDidChangeProperty(z=>this._onDidChangeProperty.fire({id:ee,property:z})),d.onPersistentProcessReady(()=>{for(const z of this._autoReplies.entries())d.installAutoReply(z[0],z[1])}),this._ptys.set(ee,d),ee}async attachToProcess(P){try{await this._throwIfNoPty(P).attach(),this._logService.info(`Persistent process reconnection "${P}"`)}catch(T){throw this._logService.warn(`Persistent process reconnection "${P}" failed`,T.message),T}}async updateTitle(P,T,J){this._throwIfNoPty(P).setTitle(T,J)}async updateIcon(P,T,J,re){this._throwIfNoPty(P).setIcon(T,J,re)}async clearBuffer(P){this._throwIfNoPty(P).clearBuffer()}async refreshProperty(P,T){return this._throwIfNoPty(P).refreshProperty(T)}async updateProperty(P,T,J){return this._throwIfNoPty(P).updateProperty(T,J)}async detachFromProcess(P,T){return this._throwIfNoPty(P).detach(T)}async reduceConnectionGraceTime(){for(const P of this._ptys.values())P.reduceGraceTime()}async listProcesses(){const P=Array.from(this._ptys.entries()).filter(([re,x])=>x.shouldPersistTerminal);this._logService.info(`Listing ${P.length} persistent terminals, ${this._ptys.size} total terminals`);const T=P.map(async([re,x])=>this._buildProcessDetails(re,x));return(await Promise.all(T)).filter(re=>re.isOrphan)}async getPerformanceMarks(){return O.getMarks()}async start(P){const T=this._ptys.get(P);return T?T.start():{message:`Could not find pty with id "${P}"`}}async shutdown(P,T){return this._ptys.get(P)?.shutdown(T)}async input(P,T){return this._throwIfNoPty(P).input(T)}async processBinary(P,T){return this._throwIfNoPty(P).writeBinary(T)}async resize(P,T,J){return this._throwIfNoPty(P).resize(T,J)}async getInitialCwd(P){return this._throwIfNoPty(P).getInitialCwd()}async getCwd(P){return this._throwIfNoPty(P).getCwd()}async acknowledgeDataEvent(P,T){return this._throwIfNoPty(P).acknowledgeDataEvent(T)}async setUnicodeVersion(P,T){return this._throwIfNoPty(P).setUnicodeVersion(T)}async getLatency(){return[]}async orphanQuestionReply(P){return this._throwIfNoPty(P).orphanQuestionReply()}async installAutoReply(P,T){this._autoReplies.set(P,T);for(const J of this._ptys.values())J.installAutoReply(P,T)}async uninstallAllAutoReplies(){for(const P of this._autoReplies.keys())for(const T of this._ptys.values())T.uninstallAutoReply(P)}async uninstallAutoReply(P){for(const T of this._ptys.values())T.uninstallAutoReply(P)}async getDefaultSystemShell(P=M.OS){return(0,w.getSystemShell)(P,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(P,T){if(T==="win-to-unix"){if(!M.isWindows)return P;if((0,l.getWindowsBuildNumber)()<17063)return P.replace(/\\/g,"/");const J=this._getWSLExecutablePath();return J?new Promise(re=>{(0,y.execFile)(J,["-e","wslpath",P],{},(te,ce,me)=>{re(te?P:(0,b.escapeNonWindowsPath)(ce.trim()))}).stdin.end()}):P}if(T==="unix-to-win"&&M.isWindows){if((0,l.getWindowsBuildNumber)()<17063)return P;const J=this._getWSLExecutablePath();return J?new Promise(re=>{(0,y.execFile)(J,["-e","wslpath","-w",P],{},(te,ce,me)=>{re(te?P:ce.trim())}).stdin.end()}):P}return P}_getWSLExecutablePath(){const P=(0,l.getWindowsBuildNumber)()>=16299,T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=process.env.SystemRoot;if(J)return(0,n.join)(J,T?"Sysnative":"System32",P?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(P,T){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(P,T))?.newId}catch(J){this._logService.warn(`Couldn't find terminal ID ${P}-${T}`,J.message)}}async setTerminalLayoutInfo(P){this._workspaceLayoutInfos.set(P.workspaceId,P)}async getTerminalLayoutInfo(P){O.mark("code/willGetTerminalLayoutInfo");const T=this._workspaceLayoutInfos.get(P.workspaceId);if(T){const J=new Set,x=(await Promise.all(T.tabs.map(async te=>this._expandTerminalTab(P.workspaceId,te,J)))).filter(te=>te.terminals.length>0);return O.mark("code/didGetTerminalLayoutInfo"),{tabs:x}}O.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(P,T,J){const x=(await Promise.all(T.terminals.map(te=>this._expandTerminalInstance(P,te,J)))).filter(te=>te.terminal!==null);return{isActive:T.isActive,activePersistentProcessId:T.activePersistentProcessId,terminals:x}}async _expandTerminalInstance(P,T,J){try{const re=this._getRevivingProcessId(P,T.terminal),x=this._revivedPtyIdMap.get(re)?.newId;this._logService.info(`Expanding terminal instance, old id ${re} -> new id ${x}`),this._revivedPtyIdMap.delete(re);const te=x??T.terminal;if(J.has(te))throw new Error(`Terminal ${te} has already been expanded`);J.add(te);const ce=this._throwIfNoPty(te);return{terminal:{...ce&&await this._buildProcessDetails(T.terminal,ce,x!==void 0),id:te},relativeSize:T.relativeSize}}catch(re){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",re.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",T),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:T.relativeSize}}}_getRevivingProcessId(P,T){return`${P}-${T}`}async _buildProcessDetails(P,T,J=!1){O.mark(`code/willBuildProcessDetails/${P}`);const[re,x]=await Promise.all([T.getCwd(),J?!0:T.isOrphaned()]),te={id:P,title:T.title,titleSource:T.titleSource,pid:T.pid,workspaceId:T.workspaceId,workspaceName:T.workspaceName,cwd:re,isOrphan:x,icon:T.icon,color:T.color,fixedDimensions:T.fixedDimensions,environmentVariableCollections:T.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:T.shellLaunchConfig.reconnectionProperties,waitOnExit:T.shellLaunchConfig.waitOnExit,hideFromUser:T.shellLaunchConfig.hideFromUser,isFeatureTerminal:T.shellLaunchConfig.isFeatureTerminal,type:T.shellLaunchConfig.type,hasChildProcesses:T.hasChildProcesses,shellIntegrationNonce:T.processLaunchOptions.options.shellIntegration.nonce};return O.mark(`code/didBuildProcessDetails/${P}`),te}_throwIfNoPty(P){const T=this._ptys.get(P);if(!T)throw new f.ErrorNoTelemetry("Could not find pty on pty host");return T}}e.PtyService=A,_e([_.memoize],A.prototype,"traceRpcArgs",null),_e([m],A.prototype,"refreshIgnoreProcessNames",null),_e([m],A.prototype,"requestDetachInstance",null),_e([m],A.prototype,"acceptDetachInstanceReply",null),_e([m],A.prototype,"freePortKillProcess",null),_e([m],A.prototype,"serializeTerminalState",null),_e([m],A.prototype,"reviveTerminalProcesses",null),_e([m],A.prototype,"shutdownAll",null),_e([m],A.prototype,"createProcess",null),_e([m],A.prototype,"attachToProcess",null),_e([m],A.prototype,"updateTitle",null),_e([m],A.prototype,"updateIcon",null),_e([m],A.prototype,"clearBuffer",null),_e([m],A.prototype,"refreshProperty",null),_e([m],A.prototype,"updateProperty",null),_e([m],A.prototype,"detachFromProcess",null),_e([m],A.prototype,"reduceConnectionGraceTime",null),_e([m],A.prototype,"listProcesses",null),_e([m],A.prototype,"getPerformanceMarks",null),_e([m],A.prototype,"start",null),_e([m],A.prototype,"shutdown",null),_e([m],A.prototype,"input",null),_e([m],A.prototype,"processBinary",null),_e([m],A.prototype,"resize",null),_e([m],A.prototype,"getInitialCwd",null),_e([m],A.prototype,"getCwd",null),_e([m],A.prototype,"acknowledgeDataEvent",null),_e([m],A.prototype,"setUnicodeVersion",null),_e([m],A.prototype,"getLatency",null),_e([m],A.prototype,"orphanQuestionReply",null),_e([m],A.prototype,"installAutoReply",null),_e([m],A.prototype,"uninstallAllAutoReplies",null),_e([m],A.prototype,"uninstallAutoReply",null),_e([m],A.prototype,"getDefaultSystemShell",null),_e([m],A.prototype,"getEnvironment",null),_e([m],A.prototype,"getWslPath",null),_e([m],A.prototype,"getRevivedPtyNewId",null),_e([m],A.prototype,"setTerminalLayoutInfo",null),_e([m],A.prototype,"getTerminalLayoutInfo",null);var W;(function(L){L.None="None",L.ReplayOnly="ReplayOnly",L.Session="Session"})(W||(W={}));class Y extends I.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!=="None"}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(P,T){T===S.TitleEventSource.Api&&(this._interactionState.setValue("Session","setTitle"),this._serializer.freeRawReviveBuffer()),this._title=P,this._titleSource=T}setIcon(P,T,J){(!this._icon||"id"in T&&"id"in this._icon&&T.id!==this._icon.id||!this.color||J!==this._color)&&(this._serializer.freeRawReviveBuffer(),P&&this._interactionState.setValue("Session","setIcon")),this._icon=T,this._color=J}_setFixedDimensions(P){this._fixedDimensions=P}constructor(P,T,J,re,x,te,ce,me,G,q,Q,ie,$,ee,ge,Z,d){super(),this._persistentProcessId=P,this._terminalProcess=T,this.workspaceId=J,this.workspaceName=re,this.shouldPersistTerminal=x,this.processLaunchOptions=me,this.unicodeVersion=G,this._logService=Q,this._icon=ee,this._color=ge,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new k.Queue,this._onProcessReplay=this._register(new C.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new C.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new C.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new C.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new C.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new C.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=S.TitleEventSource.Process,this._interactionState=new N(`Persistent process "${this._persistentProcessId}" interaction state`,"None",this._logService),this._wasRevived=ie!==void 0,this._serializer=new D(te,ce,q.scrollback,G,ie,me.options.shellIntegration.nonce,x?$:void 0,this._logService),Z&&this.setTitle(Z,S.TitleEventSource.Api),this._fixedDimensions=d,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new k.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${a(q.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},q.graceTime)),this._disconnectRunner2=this._register(new k.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${a(q.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},q.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(z=>{this._pid=z.pid,this._cwd=z.cwd,this._onProcessReady.fire(z)})),this._register(this._terminalProcess.onDidChangeProperty(z=>{this._onDidChangeProperty.fire(z)})),this._bufferer=new p.TerminalDataBufferer((z,ne)=>this._onProcessData.fire(ne)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(z=>this._serializer.handleData(z))),this._register((0,I.toDisposable)(()=>{for(const z of this._autoReplies.values())z.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(P){this.shouldPersistTerminal&&(this._interactionState.value!=="None"||P)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!=="Session")}async refreshProperty(P){return this._terminalProcess.refreshProperty(P)}async updateProperty(P,T){if(P==="fixedDimensions")return this._setFixedDimensions(T)}async start(){if(!this._isStarted){const P=await this._terminalProcess.start();return P&&"message"in P||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),P}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:"title",value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:"shellType",value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(P){return this._terminalProcess.shutdown(P)}input(P){if(this._interactionState.setValue("Session","input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const T of this._autoReplies.values())T.handleInput();return this._terminalProcess.input(P)}}writeBinary(P){return this._terminalProcess.processBinary(P)}resize(P,T){if(!this._inReplay){this._serializer.handleResize(P,T),this._bufferer.flushBuffer(this._persistentProcessId);for(const J of this._autoReplies.values())J.handleResize();return this._terminalProcess.resize(P,T)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(P){this.unicodeVersion=P,this._serializer.setUnicodeVersion?.(P)}acknowledgeDataEvent(P){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(P)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value==="None"&&this._interactionState.setValue("ReplayOnly","triggerReplay");const P=await this._serializer.generateReplayEvent();let T=0;for(const J of P.events)T+=J.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${T} chars and ${P.events.length} size events`),this._onProcessReplay.fire(P),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(P,T){this._autoReplies.get(P)?.dispose(),this._autoReplies.set(P,new o.TerminalAutoResponder(this._terminalProcess,P,T,this._logService))}uninstallAutoReply(P){this._autoReplies.get(P)?.dispose(),this._autoReplies.delete(P)}sendCommandResult(P,T,J){this._pendingCommands.get(P)&&this._pendingCommands.delete(P)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const P=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,P.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new k.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class N{get value(){return this._value}setValue(P,T){this._value!==P&&(this._value=P,this._log(T))}constructor(P,T,J){this._name=P,this._value=T,this._logService=J,this._log("initialized")}_log(P){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${P}`)}}class D{constructor(P,T,J,re,x,te,ce,me){this._rawReviveBuffer=ce,this._xterm=new u.Terminal({cols:P,rows:T,scrollback:J,allowProposedApi:!0}),x&&this._xterm.writeln(x),this.setUnicodeVersion(re),this._shellIntegrationAddon=new r.ShellIntegrationAddon(te,!0,void 0,me),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(P){this._xterm.write(P)}handleResize(P,T){this._xterm.resize(P,T)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(P,T){const J=new(await this._getSerializeConstructor());this._xterm.loadAddon(J);const re={scrollback:this._xterm.options.scrollback};P&&(re.excludeAltBuffer=!0,re.excludeModes=!0);let x;return T&&this._rawReviveBuffer?x=this._rawReviveBuffer:x=J.serialize(re),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:x}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(P){this._xterm.unicode.activeVersion!==P&&(P==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=P)}async _getUnicode11Constructor(){return v||(v=(await new Promise((P,T)=>{le(["@xterm/addon-unicode11"],P,T)})).Unicode11Addon),v}async _getSerializeConstructor(){return E||(E=(await new Promise((P,T)=>{le(["@xterm/addon-serialize"],P,T)})).SerializeAddon),E}}function a(L){let P=0,T=0,J=0;L>=1e3&&(J=Math.floor(L/1e3),L-=J*1e3),J>=60&&(T=Math.floor(J/60),J-=T*60),T>=60&&(P=Math.floor(T/60),T-=P*60);const re=P?`${P}h`:"",x=T?`${T}m`:"",te=J?`${J}s`:"",ce=L?`${L}ms`:"";return`${re}${x}${te}${ce}`}}),define(he[111],de([0,1,60,27,64,65,9,75,78,11,80,81,83,84,28,101,104,31,10,2]),function(le,e,y,k,C,I,M,w,h,c,S,p,b,u,l,g,s,i,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r();async function r(){const t=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),n=parseInt(process.env.VSCODE_LATENCY??"0"),_={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,t&&await(0,o.timeout)(t);const O=(0,i.isUtilityProcess)(process);let m;O?m=new I.Server:m=new C.Server(l.TerminalIpcChannels.PtyHost);const E={_serviceBrand:void 0,...u.default},v=new h.NativeEnvironmentService((0,w.parseArgs)(process.argv,w.OPTIONS),E),A=new b.LoggerService((0,c.getLogLevel)(v),v.logsHome);m.registerChannel(l.TerminalIpcChannels.Logger,new S.LoggerChannel(A,()=>y.DefaultURITransformer));const W=A.createLogger("ptyhost",{name:(0,M.localize)(0,null)}),Y=new p.LogService(W);t&&Y.warn(`Pty Host startup is delayed ${t}ms`),n&&Y.warn(`Pty host is simulating ${n}ms latency`);const N=new f.DisposableStore,D=new g.HeartbeatService;m.registerChannel(l.TerminalIpcChannels.Heartbeat,k.ProxyChannel.fromService(D,N));const a=new s.PtyService(Y,E,_,n),L=k.ProxyChannel.fromService(a,N);m.registerChannel(l.TerminalIpcChannels.PtyHost,L),O&&m.registerChannel(l.TerminalIpcChannels.PtyHostWindow,L),process.once("exit",()=>{Y.trace("Pty host exiting"),Y.dispose(),D.dispose(),a.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/platform/terminal/node/ptyHostMain.js.map
