/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/platform","vs/base/common/errors","vs/base/common/path","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/cancellation","vs/base/common/types","vs/base/common/event","vs/base/common/buffer","vs/base/common/strings","vs/base/common/lazy","vs/base/common/objects","vs/base/common/process","vs/base/common/network","vs/base/common/async","vs/base/common/arrays","vs/base/common/functional","vs/base/common/map","vs/base/common/extpath","vs/base/common/processes","vs/base/common/resources","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uuid","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/amdX","vs/base/node/pfs","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/instantiation","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryUtils","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/nls","vs/nls!vs/workbench/contrib/debug/node/telemetryApp","fs","os","util","child_process","https","vs/workbench/contrib/debug/node/telemetryApp"],de=function(le){for(var e=[],E=0,z=le.length;E<z;E++)e[E]=he[le[E]];return e};define(he[23],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class E{static get(){const N=new Map,L=new Map,j=new Map,C=new Map;function u(U,c){U.has(c.detail)||U.set(c.detail,-c.timestamp)}function _(U,c){const h=U.get(c.detail);h&&(h>=0||U.set(c.detail,h+c.timestamp))}let T=[];typeof le=="function"&&typeof le.getStats=="function"&&(T=le.getStats().slice(0).sort((U,c)=>U.timestamp-c.timestamp));for(const U of T)switch(U.type){case 10:u(N,U);break;case 11:case 12:_(N,U);break;case 21:u(L,U);break;case 22:_(L,U);break;case 33:u(j,U);break;case 34:_(j,U);break;case 31:u(C,U);break;case 32:_(C,U);break}let B=0;j.forEach(U=>B+=U);function F(U){const c=[];return U.forEach((h,D)=>c.push([D,h])),c}return{amdLoad:F(N),amdInvoke:F(L),nodeRequire:F(j),nodeEval:F(C),nodeRequireTotal:B}}static toMarkdownTable(N,L){let j="";const C=[];return N.forEach((u,_)=>{C[_]=u.length}),L.forEach(u=>{u.forEach((_,T)=>{typeof _>"u"&&(_=u[T]="-");const B=_.toString().length;C[T]=Math.max(B,C[T])})}),N.forEach((u,_)=>{j+=`| ${u+" ".repeat(C[_]-u.toString().length)} `}),j+=`|
`,N.forEach((u,_)=>{j+=`| ${"-".repeat(C[_])} `}),j+=`|
`,L.forEach(u=>{u.forEach((_,T)=>{typeof _<"u"&&(j+=`| ${_+" ".repeat(C[T]-_.toString().length)} `)}),j+=`|
`}),j}}e.LoaderStats=E}),define(he[24],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=E,e.findLastIdx=z,e.findLastMonotonous=N,e.findLastIdxMonotonous=L,e.findFirstMonotonous=j,e.findFirstIdxMonotonousOrArrLen=C,e.findFirstIdxMonotonous=u,e.findFirstMaxBy=T,e.findLastMaxBy=B,e.findFirstMinBy=F,e.findMaxIdxBy=U,e.mapFindFirst=c;function E(h,D,m){const P=z(h,D);if(P!==-1)return h[P]}function z(h,D,m=h.length-1){for(let P=m;P>=0;P--){const R=h[P];if(D(R))return P}return-1}function N(h,D){const m=L(h,D);return m===-1?void 0:h[m]}function L(h,D,m=0,P=h.length){let R=m,r=P;for(;R<r;){const i=Math.floor((R+r)/2);D(h[i])?R=i+1:r=i}return R-1}function j(h,D){const m=C(h,D);return m===h.length?void 0:h[m]}function C(h,D,m=0,P=h.length){let R=m,r=P;for(;R<r;){const i=Math.floor((R+r)/2);D(h[i])?r=i:R=i+1}return R}function u(h,D,m=0,P=h.length){const R=C(h,D,m,P);return R===h.length?-1:R}class _{static{this.assertInvariants=!1}constructor(D){this._array=D,this._findLastMonotonousLastIdx=0}findLastMonotonous(D){if(_.assertInvariants){if(this._prevFindLastPredicate){for(const P of this._array)if(this._prevFindLastPredicate(P)&&!D(P))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=D}const m=L(this._array,D,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=m+1,m===-1?void 0:this._array[m]}}e.MonotonousArray=_;function T(h,D){if(h.length===0)return;let m=h[0];for(let P=1;P<h.length;P++){const R=h[P];D(R,m)>0&&(m=R)}return m}function B(h,D){if(h.length===0)return;let m=h[0];for(let P=1;P<h.length;P++){const R=h[P];D(R,m)>=0&&(m=R)}return m}function F(h,D){return T(h,(m,P)=>-D(m,P))}function U(h,D){if(h.length===0)return-1;let m=0;for(let P=1;P<h.length;P++){const R=h[P];D(R,h[m])>0&&(m=P)}return m}function c(h,D){for(const m of h){const P=D(m);if(P!==void 0)return P}}}),define(he[25],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=E,e.diffSets=z,e.diffMaps=N,e.intersection=L;function E(j,C){const u=Object.create(null);for(const _ of j){const T=C(_);let B=u[T];B||(B=u[T]=[]),B.push(_)}return u}function z(j,C){const u=[],_=[];for(const T of j)C.has(T)||u.push(T);for(const T of C)j.has(T)||_.push(T);return{removed:u,added:_}}function N(j,C){const u=[],_=[];for(const[T,B]of j)C.has(T)||u.push(B);for(const[T,B]of C)j.has(T)||_.push(B);return{removed:u,added:_}}function L(j,C){const u=new Set;for(const _ of C)j.has(_)&&u.add(_);return u}}),define(he[26],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=z,e.debounce=N,e.throttle=L;function E(j){return(C,u,_)=>{let T=null,B=null;if(typeof _.value=="function"?(T="value",B=_.value):typeof _.get=="function"&&(T="get",B=_.get),!B)throw new Error("not supported");_[T]=j(B,u)}}function z(j,C,u){let _=null,T=null;if(typeof u.value=="function"?(_="value",T=u.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(_="get",T=u.get),!T)throw new Error("not supported");const B=`$memoize$${C}`;u[_]=function(...F){return this.hasOwnProperty(B)||Object.defineProperty(this,B,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,F)}),this[B]}}function N(j,C,u){return E((_,T)=>{const B=`$debounce$${T}`,F=`$debounce$result$${T}`;return function(...U){this[F]||(this[F]=u?u():void 0),clearTimeout(this[B]),C&&(this[F]=C(this[F],...U),U=[this[F]]),this[B]=setTimeout(()=>{_.apply(this,U),this[F]=u?u():void 0},j)}})}function L(j,C,u){return E((_,T)=>{const B=`$throttle$timer$${T}`,F=`$throttle$result$${T}`,U=`$throttle$lastRun$${T}`,c=`$throttle$pending$${T}`;return function(...h){if(this[F]||(this[F]=u?u():void 0),(this[U]===null||this[U]===void 0)&&(this[U]=-Number.MAX_VALUE),C&&(this[F]=C(this[F],...h)),this[c])return;const D=this[U]+j;D<=Date.now()?(this[U]=Date.now(),_.apply(this,[this[F]]),this[F]=u?u():void 0):(this[c]=!0,this[B]=setTimeout(()=>{this[c]=!1,this[U]=Date.now(),_.apply(this,[this[F]]),this[F]=u?u():void 0},D-Date.now()))}})}}),define(he[3],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=z,e.isSigPipeError=N,e.onUnexpectedError=L,e.onUnexpectedExternalError=j,e.transformErrorForSerialization=C,e.isCancellationError=_,e.canceled=B,e.illegalArgument=F,e.illegalState=U,e.getErrorMessage=h;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?R.isErrorNoTelemetry(t)?new R(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function z(i){e.errorHandler.setUnexpectedErrorHandler(i)}function N(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function L(i){_(i)||e.errorHandler.onUnexpectedError(i)}function j(i){_(i)||e.errorHandler.onUnexpectedExternalError(i)}function C(i){if(i instanceof Error){const{name:t,message:n}=i,y=i.stacktrace||i.stack;return{$isError:!0,name:t,message:n,stack:y,noTelemetry:R.isErrorNoTelemetry(i)}}return i}const u="Canceled";function _(i){return i instanceof T?!0:i instanceof Error&&i.name===u&&i.message===u}class T extends Error{constructor(){super(u),this.name=this.message}}e.CancellationError=T;function B(){const i=new Error(u);return i.name=i.message,i}function F(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function U(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=c;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class D extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=D;class m extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=m;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=P;class R extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof R)return t;const n=new R;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=R;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.BugIndicatingError=r}),define(he[17],de([0,1,3,24]),function(le,e,E,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=N,e.tail2=L,e.equals=j,e.removeFastWithoutKeepingOrder=C,e.binarySearch=u,e.binarySearch2=_,e.quickSelect=T,e.groupBy=B,e.groupAdjacentBy=F,e.forEachAdjacent=U,e.forEachWithNeighbors=c,e.sortedDiff=h,e.delta=D,e.top=m,e.topAsync=P,e.coalesce=r,e.coalesceInPlace=i,e.move=t,e.isFalsyOrEmpty=n,e.isNonEmptyArray=y,e.distinct=v,e.uniqueFilter=g,e.firstOrDefault=o,e.lastOrDefault=b,e.commonPrefixLength=O,e.flatten=Q,e.range=p,e.index=l,e.insert=s,e.remove=M,e.arrayInsert=Z,e.shuffle=re,e.pushToStart=ue,e.pushToEnd=oe,e.pushMany=H,e.mapArrayOrNot=J,e.asArray=ie,e.getRandomElement=se,e.insertInto=q,e.splice=w,e.compareBy=ee,e.tieBreakComparators=te,e.reverseOrder=we;function N(I,$=0){return I[I.length-(1+$)]}function L(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}function j(I,$,d=(a,A)=>a===A){if(I===$)return!0;if(!I||!$||I.length!==$.length)return!1;for(let a=0,A=I.length;a<A;a++)if(!d(I[a],$[a]))return!1;return!0}function C(I,$){const d=I.length-1;$<d&&(I[$]=I[d]),I.pop()}function u(I,$,d){return _(I.length,a=>d(I[a],$))}function _(I,$){let d=0,a=I-1;for(;d<=a;){const A=(d+a)/2|0,S=$(A);if(S<0)d=A+1;else if(S>0)a=A-1;else return A}return-(d+1)}function T(I,$,d){if(I=I|0,I>=$.length)throw new TypeError("invalid index");const a=$[Math.floor($.length*Math.random())],A=[],S=[],k=[];for(const Y of $){const X=d(Y,a);X<0?A.push(Y):X>0?S.push(Y):k.push(Y)}return I<A.length?T(I,A,d):I<A.length+k.length?k[0]:T(I-(A.length+k.length),S,d)}function B(I,$){const d=[];let a;for(const A of I.slice(0).sort($))!a||$(a[0],A)!==0?(a=[A],d.push(a)):a.push(A);return d}function*F(I,$){let d,a;for(const A of I)a!==void 0&&$(a,A)?d.push(A):(d&&(yield d),d=[A]),a=A;d&&(yield d)}function U(I,$){for(let d=0;d<=I.length;d++)$(d===0?void 0:I[d-1],d===I.length?void 0:I[d])}function c(I,$){for(let d=0;d<I.length;d++)$(d===0?void 0:I[d-1],I[d],d+1===I.length?void 0:I[d+1])}function h(I,$,d){const a=[];function A(Y,X,ne){if(X===0&&ne.length===0)return;const ce=a[a.length-1];ce&&ce.start+ce.deleteCount===Y?(ce.deleteCount+=X,ce.toInsert.push(...ne)):a.push({start:Y,deleteCount:X,toInsert:ne})}let S=0,k=0;for(;;){if(S===I.length){A(S,0,$.slice(k));break}if(k===$.length){A(S,I.length-S,[]);break}const Y=I[S],X=$[k],ne=d(Y,X);ne===0?(S+=1,k+=1):ne<0?(A(S,1,[]),S+=1):ne>0&&(A(S,0,[X]),k+=1)}return a}function D(I,$,d){const a=h(I,$,d),A=[],S=[];for(const k of a)A.push(...I.slice(k.start,k.start+k.deleteCount)),S.push(...k.toInsert);return{removed:A,added:S}}function m(I,$,d){if(d===0)return[];const a=I.slice(0,d).sort($);return R(I,$,a,d,I.length),a}function P(I,$,d,a,A){return d===0?Promise.resolve([]):new Promise((S,k)=>{(async()=>{const Y=I.length,X=I.slice(0,d).sort($);for(let ne=d,ce=Math.min(d+a,Y);ne<Y;ne=ce,ce=Math.min(ce+a,Y)){if(ne>d&&await new Promise(_e=>setTimeout(_e)),A&&A.isCancellationRequested)throw new E.CancellationError;R(I,$,X,ne,ce)}return X})().then(S,k)})}function R(I,$,d,a,A){for(const S=d.length;a<A;a++){const k=I[a];if($(k,d[S-1])<0){d.pop();const Y=(0,z.findFirstIdxMonotonousOrArrLen)(d,X=>$(k,X)<0);d.splice(Y,0,k)}}}function r(I){return I.filter($=>!!$)}function i(I){let $=0;for(let d=0;d<I.length;d++)I[d]&&(I[$]=I[d],$+=1);I.length=$}function t(I,$,d){I.splice(d,0,I.splice($,1)[0])}function n(I){return!Array.isArray(I)||I.length===0}function y(I){return Array.isArray(I)&&I.length>0}function v(I,$=d=>d){const d=new Set;return I.filter(a=>{const A=$(a);return d.has(A)?!1:(d.add(A),!0)})}function g(I){const $=new Set;return d=>{const a=I(d);return $.has(a)?!1:($.add(a),!0)}}function o(I,$){return I.length>0?I[0]:$}function b(I,$){return I.length>0?I[I.length-1]:$}function O(I,$,d=(a,A)=>a===A){let a=0;for(let A=0,S=Math.min(I.length,$.length);A<S&&d(I[A],$[A]);A++)a++;return a}function Q(I){return[].concat(...I)}function p(I,$){let d=typeof $=="number"?I:0;typeof $=="number"?d=I:(d=0,$=I);const a=[];if(d<=$)for(let A=d;A<$;A++)a.push(A);else for(let A=d;A>$;A--)a.push(A);return a}function l(I,$,d){return I.reduce((a,A)=>(a[$(A)]=d?d(A):A,a),Object.create(null))}function s(I,$){return I.push($),()=>M(I,$)}function M(I,$){const d=I.indexOf($);if(d>-1)return I.splice(d,1),$}function Z(I,$,d){const a=I.slice(0,$),A=I.slice($);return a.concat(d,A)}function re(I,$){let d;if(typeof $=="number"){let a=$;d=()=>{const A=Math.sin(a++)*179426549;return A-Math.floor(A)}}else d=Math.random;for(let a=I.length-1;a>0;a-=1){const A=Math.floor(d()*(a+1)),S=I[a];I[a]=I[A],I[A]=S}}function ue(I,$){const d=I.indexOf($);d>-1&&(I.splice(d,1),I.unshift($))}function oe(I,$){const d=I.indexOf($);d>-1&&(I.splice(d,1),I.push($))}function H(I,$){for(const d of $)I.push(d)}function J(I,$){return Array.isArray(I)?I.map($):$(I)}function ie(I){return Array.isArray(I)?I:[I]}function se(I){return I[Math.floor(Math.random()*I.length)]}function q(I,$,d){const a=V(I,$),A=I.length,S=d.length;I.length=A+S;for(let k=A-1;k>=a;k--)I[k+S]=I[k];for(let k=0;k<S;k++)I[k+a]=d[k]}function w(I,$,d,a){const A=V(I,$);let S=I.splice(A,d);return S===void 0&&(S=[]),q(I,A,a),S}function V(I,$){return $<0?Math.max($+I.length,0):Math.min($,I.length)}var K;(function(I){function $(S){return S<0}I.isLessThan=$;function d(S){return S<=0}I.isLessThanOrEqual=d;function a(S){return S>0}I.isGreaterThan=a;function A(S){return S===0}I.isNeitherLessOrGreaterThan=A,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function ee(I,$){return(d,a)=>$(I(d),I(a))}function te(...I){return($,d)=>{for(const a of I){const A=a($,d);if(!K.isNeitherLessOrGreaterThan(A))return A}return K.neitherLessOrGreaterThan}}const me=(I,$)=>I-$;e.numberComparator=me;const fe=(I,$)=>(0,e.numberComparator)(I?1:0,$?1:0);e.booleanComparator=fe;function we(I){return($,d)=>-I($,d)}class ye{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let d=this.firstIdx;for(;d<this.items.length&&$(this.items[d]);)d++;const a=d===this.firstIdx?null:this.items.slice(this.firstIdx,d);return this.firstIdx=d,a}takeFromEndWhile($){let d=this.lastIdx;for(;d>=0&&$(this.items[d]);)d--;const a=d===this.lastIdx?null:this.items.slice(d+1,this.lastIdx+1);return this.lastIdx=d,a}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const $=this.items[this.firstIdx];return this.firstIdx++,$}removeLast(){const $=this.items[this.lastIdx];return this.lastIdx--,$}takeCount($){const d=this.items.slice(this.firstIdx,this.firstIdx+$);return this.firstIdx+=$,d}}e.ArrayQueue=ye;class ge{static{this.empty=new ge($=>{})}constructor($){this.iterate=$}forEach($){this.iterate(d=>($(d),!0))}toArray(){const $=[];return this.iterate(d=>($.push(d),!0)),$}filter($){return new ge(d=>this.iterate(a=>$(a)?d(a):!0))}map($){return new ge(d=>this.iterate(a=>d($(a))))}some($){let d=!1;return this.iterate(a=>(d=$(a),!d)),d}findFirst($){let d;return this.iterate(a=>$(a)?(d=a,!1):!0),d}findLast($){let d;return this.iterate(a=>($(a)&&(d=a),!0)),d}findLastMaxBy($){let d,a=!0;return this.iterate(A=>((a||K.isGreaterThan($(A,d)))&&(a=!1,d=A),!0)),d}}e.CallbackIterable=ge;class pe{constructor($){this._indexMap=$}static createSortPermutation($,d){const a=Array.from($.keys()).sort((A,S)=>d($[A],$[S]));return new pe(a)}apply($){return $.map((d,a)=>$[this._indexMap[a]])}inverse(){const $=this._indexMap.slice();for(let d=0;d<this._indexMap.length;d++)$[this._indexMap[d]]=d;return new pe($)}}e.Permutation=pe}),define(he[18],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=E;function E(z,N){const L=this;let j=!1,C;return function(){if(j)return C;if(j=!0,N)try{C=z.apply(L,arguments)}finally{N()}else C=z.apply(L,arguments);return C}}}),define(he[27],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(z){function N(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}z.is=N;const L=Object.freeze([]);function j(){return L}z.empty=j;function*C(t){yield t}z.single=C;function u(t){return N(t)?t:C(t)}z.wrap=u;function _(t){return t||L}z.from=_;function*T(t){for(let n=t.length-1;n>=0;n--)yield t[n]}z.reverse=T;function B(t){return!t||t[Symbol.iterator]().next().done===!0}z.isEmpty=B;function F(t){return t[Symbol.iterator]().next().value}z.first=F;function U(t,n){for(const y of t)if(n(y))return!0;return!1}z.some=U;function c(t,n){for(const y of t)if(n(y))return y}z.find=c;function*h(t,n){for(const y of t)n(y)&&(yield y)}z.filter=h;function*D(t,n){let y=0;for(const v of t)yield n(v,y++)}z.map=D;function*m(...t){for(const n of t)yield*n}z.concat=m;function P(t,n,y){let v=y;for(const g of t)v=n(v,g);return v}z.reduce=P;function*R(t,n,y=t.length){for(n<0&&(n+=t.length),y<0?y+=t.length:y>t.length&&(y=t.length);n<y;n++)yield t[n]}z.slice=R;function r(t,n=Number.POSITIVE_INFINITY){const y=[];if(n===0)return[y,t];const v=t[Symbol.iterator]();for(let g=0;g<n;g++){const o=v.next();if(o.done)return[y,z.empty()];y.push(o.value)}return[y,{[Symbol.iterator](){return v}}]}z.consume=r;async function i(t){const n=[];for await(const y of t)n.push(y);return Promise.resolve(n)}z.asyncToArray=i})(E||(e.Iterable=E={}))}),define(he[12],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(N){this.executor=N,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(N){this._error=N}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=E}),define(he[28],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{static{this.Undefined=new E(void 0)}constructor(L){this.element=L,this.next=E.Undefined,this.prev=E.Undefined}}class z{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let L=this._first;for(;L!==E.Undefined;){const j=L.next;L.prev=E.Undefined,L.next=E.Undefined,L=j}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,j){const C=new E(L);if(this._first===E.Undefined)this._first=C,this._last=C;else if(j){const _=this._last;this._last=C,C.prev=_,_.next=C}else{const _=this._first;this._first=C,C.next=_,_.prev=C}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(C))}}shift(){if(this._first!==E.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==E.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==E.Undefined&&L.next!==E.Undefined){const j=L.prev;j.next=L.next,L.next.prev=j}else L.prev===E.Undefined&&L.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):L.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):L.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==E.Undefined;)yield L.element,L=L.next}}e.LinkedList=z}),define(he[19],de([0,1]),function(le,e){"use strict";var E,z,N;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=L,e.mapToString=j,e.setToString=C,e.mapsStrictEqualIgnoreOrder=P;function L(R,r,i){let t=R.get(r);return t===void 0&&(t=i,R.set(r,t)),t}function j(R){const r=[];return R.forEach((i,t)=>{r.push(`${t} => ${i}`)}),`Map(${R.size}) {${r.join(", ")}}`}function C(R){const r=[];return R.forEach(i=>{r.push(i)}),`Set(${R.size}) {${r.join(", ")}}`}class u{constructor(r,i){this.uri=r,this.value=i}}function _(R){return Array.isArray(R)}class T{static{this.defaultToKey=r=>r.toString()}constructor(r,i){if(this[E]="ResourceMap",r instanceof T)this.map=new Map(r.map),this.toKey=i??T.defaultToKey;else if(_(r)){this.map=new Map,this.toKey=i??T.defaultToKey;for(const[t,n]of r)this.set(t,n)}else this.map=new Map,this.toKey=r??T.defaultToKey}set(r,i){return this.map.set(this.toKey(r),new u(r,i)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i<"u"&&(r=r.bind(i));for(const[t,n]of this.map)r(n.value,n.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=T;class B{constructor(r,i){this[z]="ResourceSet",!r||typeof r=="function"?this._map=new T(r):(this._map=new T(i),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,i){this._map.forEach((t,n)=>r.call(i,n,n,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=B;var F;(function(R){R[R.None=0]="None",R[R.AsOld=1]="AsOld",R[R.AsNew=2]="AsNew"})(F||(e.Touch=F={}));class U{constructor(){this[N]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const t=this._map.get(r);if(t)return i!==0&&this.touch(t,i),t.value}set(r,i,t=0){let n=this._map.get(r);if(n)n.value=i,t!==0&&this.touch(n,t);else{switch(n={key:r,value:i,next:void 0,previous:void 0},t){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:this.addItemLast(n);break;default:this.addItemLast(n);break}this._map.set(r,n),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const t=this._state;let n=this._head;for(;n;){if(i?r.bind(i)(n.value,n.key,this):r(n.value,n.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const r=this,i=this._state;let t=this._head;const n={[Symbol.iterator](){return n},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(t){const y={value:t.key,done:!1};return t=t.next,y}else return{value:void 0,done:!0}}};return n}values(){const r=this,i=this._state;let t=this._head;const n={[Symbol.iterator](){return n},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(t){const y={value:t.value,done:!1};return t=t.next,y}else return{value:void 0,done:!0}}};return n}entries(){const r=this,i=this._state;let t=this._head;const n={[Symbol.iterator](){return n},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(t){const y={value:[t.key,t.value],done:!1};return t=t.next,y}else return{value:void 0,done:!0}}};return n}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,t=this.size;for(;i&&t>r;)this._map.delete(i.key),i=i.next,t--;this._head=i,this._size=t,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,t=r.previous;if(!i||!t)throw new Error("Invalid list");i.previous=t,t.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const t=r.next,n=r.previous;r===this._tail?(n.next=void 0,this._tail=n):(t.previous=n,n.next=t),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const t=r.next,n=r.previous;r===this._head?(t.previous=void 0,this._head=t):(t.previous=n,n.next=t),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,t)=>{r.push([t,i])}),r}fromJSON(r){this.clear();for(const[i,t]of r)this.set(i,t)}}e.LinkedMap=U;class c extends U{constructor(r,i=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class h{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let i=this.map.get(r)||0;return i===0?!1:(i--,i===0?this.map.delete(r):this.map.set(r,i),!0)}has(r){return this.map.has(r)}}e.CounterSet=h;class D{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[i,t]of r)this.set(i,t)}clear(){this._m1.clear(),this._m2.clear()}set(r,i){this._m1.set(r,i),this._m2.set(i,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const i=this._m1.get(r);return i===void 0?!1:(this._m1.delete(r),this._m2.delete(i),!0)}forEach(r,i){this._m1.forEach((t,n)=>{r.call(i,t,n,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=D;class m{constructor(){this.map=new Map}add(r,i){let t=this.map.get(r);t||(t=new Set,this.map.set(r,t)),t.add(i)}delete(r,i){const t=this.map.get(r);t&&(t.delete(i),t.size===0&&this.map.delete(r))}forEach(r,i){const t=this.map.get(r);t&&t.forEach(i)}get(r){const i=this.map.get(r);return i||new Set}}e.SetMap=m;function P(R,r){if(R===r)return!0;if(R.size!==r.size)return!1;for(const[i,t]of R)if(!r.has(i)||r.get(i)!==t)return!1;for(const[i]of r)if(!R.has(i))return!1;return!0}}),define(he[6],de([0,1,17,25,19,18,27]),function(le,e,E,z,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=T,e.trackDisposable=B,e.markAsDisposed=F,e.markAsSingleton=h,e.isDisposable=D,e.dispose=m,e.disposeIfDisposable=P,e.combinedDisposable=R,e.toDisposable=r,e.disposeOnReturn=Q;const C=!1;let u=null;class _{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(s){let M=this.livingDisposables.get(s);return M||(M={parent:null,source:null,isSingleton:!1,value:s,idx:_.idx++},this.livingDisposables.set(s,M)),M}trackDisposable(s){const M=this.getDisposableData(s);M.source||(M.source=new Error().stack)}setParent(s,M){const Z=this.getDisposableData(s);Z.parent=M}markAsDisposed(s){this.livingDisposables.delete(s)}markAsSingleton(s){this.getDisposableData(s).isSingleton=!0}getRootParent(s,M){const Z=M.get(s);if(Z)return Z;const re=s.parent?this.getRootParent(this.getDisposableData(s.parent),M):s;return M.set(s,re),re}getTrackedDisposables(){const s=new Map;return[...this.livingDisposables.entries()].filter(([,Z])=>Z.source!==null&&!this.getRootParent(Z,s).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(s=10,M){let Z;if(M)Z=M;else{const J=new Map,ie=[...this.livingDisposables.values()].filter(q=>q.source!==null&&!this.getRootParent(q,J).isSingleton);if(ie.length===0)return;const se=new Set(ie.map(q=>q.value));if(Z=ie.filter(q=>!(q.parent&&se.has(q.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function re(J){function ie(q,w){for(;q.length>0&&w.some(V=>typeof V=="string"?V===q[0]:q[0].match(V));)q.shift()}const se=J.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return ie(se,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),se.reverse()}const ue=new N.SetMap;for(const J of Z){const ie=re(J);for(let se=0;se<=ie.length;se++)ue.add(ie.slice(0,se).join(`
`),J)}Z.sort((0,E.compareBy)(J=>J.idx,E.numberComparator));let oe="",H=0;for(const J of Z.slice(0,s)){H++;const ie=re(J),se=[];for(let q=0;q<ie.length;q++){let w=ie[q];w=`(shared with ${ue.get(ie.slice(0,q+1).join(`
`)).size}/${Z.length} leaks) at ${w}`;const K=ue.get(ie.slice(0,q).join(`
`)),ee=(0,z.groupBy)([...K].map(te=>re(te)[q]),te=>te);delete ee[ie[q]];for(const[te,me]of Object.entries(ee))se.unshift(`    - stacktraces of ${me.length} other leaks continue with ${te}`);se.unshift(w)}oe+=`


==================== Leaking disposable ${H}/${Z.length}: ${J.value.constructor.name} ====================
${se.join(`
`)}
============================================================

`}return Z.length>s&&(oe+=`


... and ${Z.length-s} more leaking disposables

`),{leaks:Z,details:oe}}}e.DisposableTracker=_;function T(l){u=l}if(C){const l="__is_disposable_tracked__";T(new class{trackDisposable(s){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(M)},3e3)}setParent(s,M){if(s&&s!==t.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==t.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function B(l){return u?.trackDisposable(l),l}function F(l){u?.markAsDisposed(l)}function U(l,s){u?.setParent(l,s)}function c(l,s){if(u)for(const M of l)u.setParent(M,s)}function h(l){return u?.markAsSingleton(l),l}function D(l){return typeof l.dispose=="function"&&l.dispose.length===0}function m(l){if(j.Iterable.is(l)){const s=[];for(const M of l)if(M)try{M.dispose()}catch(Z){s.push(Z)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}function P(l){for(const s of l)D(s)&&s.dispose();return[]}function R(...l){const s=r(()=>m(l));return c(l,s),s}function r(l){const s=B({dispose:(0,L.createSingleCallFunction)(()=>{F(s),l()})});return s}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,B(this)}dispose(){this._isDisposed||(F(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return U(s,this),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}delete(s){if(s){if(s===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(s),s.dispose()}}deleteAndLeak(s){s&&this._toDispose.has(s)&&(this._toDispose.delete(s),U(s,null))}}e.DisposableStore=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new i,B(this),U(this._store,this)}dispose(){F(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=t;class n{constructor(){this._isDisposed=!1,B(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&U(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,F(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&U(s,null),s}}e.MutableDisposable=n;class y{constructor(s){this._disposable=new n,this._isDisposed=!1,this._disposable.value=s}get value(){return this._disposable.value}set value(s){this._isDisposed||s===this._disposable.value||(this._disposable.value=s)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=y;class v{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=v;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(s){let M=s;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,F(this))},this}}e.SafeDisposable=g;class o{constructor(){this.references=new Map}acquire(s,...M){let Z=this.references.get(s);Z||(Z={counter:0,object:this.createReferencedObject(s,...M)},this.references.set(s,Z));const{object:re}=Z,ue=(0,L.createSingleCallFunction)(()=>{--Z.counter===0&&(this.destroyReferencedObject(s,Z.object),this.references.delete(s))});return Z.counter++,{object:re,dispose:ue}}}e.ReferenceCollection=o;class b{constructor(s){this.referenceCollection=s}async acquire(s,...M){const Z=this.referenceCollection.acquire(s,...M);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(re){throw Z.dispose(),re}}}e.AsyncReferenceCollection=b;class O{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=O;function Q(l){const s=new i;try{l(s)}finally{s.dispose()}}class p{constructor(){this._store=new Map,this._isDisposed=!1,B(this)}dispose(){F(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(s){return this._store.has(s)}get size(){return this._store.size}get(s){return this._store.get(s)}set(s,M,Z=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this._store.get(s)?.dispose(),this._store.set(s,M)}deleteAndDispose(s){this._store.get(s)?.dispose(),this._store.delete(s)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=p}),define(he[29],de([0,1,19]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=N,e.normalizeNFD=j;const z=new E.LRUCache(1e4);function N(_){return u(_,"NFC",z)}const L=new E.LRUCache(1e4);function j(_){return u(_,"NFD",L)}const C=/[^\u0000-\u0080]/;function u(_,T,B){if(!_)return _;const F=B.get(_);if(F)return F;let U;return C.test(_)?U=_.normalize(T):U=_,B.set(_,U),U}e.removeAccents=function(){const _=/[\u0300-\u036f]/g;return function(T){return j(T).replace(_,"")}}()}),define(he[30],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class z{static create(L){return new z(L)}constructor(L){this._now=E&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=z}),define(he[9],de([0,1,3,18,6,28,30]),function(le,e,E,z,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=U;const C=!1,u=!1,_=!1;var T;(function(l){l.None=()=>N.Disposable.None;function s(S){if(_){const{onDidAddListener:k}=S,Y=h.create();let X=0;S.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),k?.()}}}function M(S,k){return w(S,()=>{},0,void 0,!0,void 0,k)}l.defer=M;function Z(S){return(k,Y=null,X)=>{let ne=!1,ce;return ce=S(_e=>{if(!ne)return ce?ce.dispose():ne=!0,k.call(Y,_e)},null,X),ne&&ce.dispose(),ce}}l.once=Z;function re(S,k,Y){return se((X,ne=null,ce)=>S(_e=>X.call(ne,k(_e)),null,ce),Y)}l.map=re;function ue(S,k,Y){return se((X,ne=null,ce)=>S(_e=>{k(_e),X.call(ne,_e)},null,ce),Y)}l.forEach=ue;function oe(S,k,Y){return se((X,ne=null,ce)=>S(_e=>k(_e)&&X.call(ne,_e),null,ce),Y)}l.filter=oe;function H(S){return S}l.signal=H;function J(...S){return(k,Y=null,X)=>{const ne=(0,N.combinedDisposable)(...S.map(ce=>ce(_e=>k.call(Y,_e))));return q(ne,X)}}l.any=J;function ie(S,k,Y,X){let ne=Y;return re(S,ce=>(ne=k(ne,ce),ne),X)}l.reduce=ie;function se(S,k){let Y;const X={onWillAddFirstListener(){Y=S(ne.fire,ne)},onDidRemoveLastListener(){Y?.dispose()}};k||s(X);const ne=new i(X);return k?.add(ne),ne.event}function q(S,k){return k instanceof Array?k.push(S):k&&k.add(S),S}function w(S,k,Y=100,X=!1,ne=!1,ce,_e){let be,Ee,Te,ke=0,Oe;const Pe={leakWarningThreshold:ce,onWillAddFirstListener(){be=S(qe=>{ke++,Ee=k(Ee,qe),X&&!Te&&(Me.fire(Ee),Ee=void 0),Oe=()=>{const $e=Ee;Ee=void 0,Te=void 0,(!X||ke>1)&&Me.fire($e),ke=0},typeof Y=="number"?(clearTimeout(Te),Te=setTimeout(Oe,Y)):Te===void 0&&(Te=0,queueMicrotask(Oe))})},onWillRemoveListener(){ne&&ke>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};_e||s(Pe);const Me=new i(Pe);return _e?.add(Me),Me.event}l.debounce=w;function V(S,k=0,Y){return l.debounce(S,(X,ne)=>X?(X.push(ne),X):[ne],k,void 0,!0,void 0,Y)}l.accumulate=V;function K(S,k=(X,ne)=>X===ne,Y){let X=!0,ne;return oe(S,ce=>{const _e=X||!k(ce,ne);return X=!1,ne=ce,_e},Y)}l.latch=K;function ee(S,k,Y){return[l.filter(S,k,Y),l.filter(S,X=>!k(X),Y)]}l.split=ee;function te(S,k=!1,Y=[],X){let ne=Y.slice(),ce=S(Ee=>{ne?ne.push(Ee):be.fire(Ee)});X&&X.add(ce);const _e=()=>{ne?.forEach(Ee=>be.fire(Ee)),ne=null},be=new i({onWillAddFirstListener(){ce||(ce=S(Ee=>be.fire(Ee)),X&&X.add(ce))},onDidAddFirstListener(){ne&&(k?setTimeout(_e):_e())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return X&&X.add(be),be.event}l.buffer=te;function me(S,k){return(X,ne,ce)=>{const _e=k(new we);return S(function(be){const Ee=_e.evaluate(be);Ee!==fe&&X.call(ne,Ee)},void 0,ce)}}l.chain=me;const fe=Symbol("HaltChainable");class we{constructor(){this.steps=[]}map(k){return this.steps.push(k),this}forEach(k){return this.steps.push(Y=>(k(Y),Y)),this}filter(k){return this.steps.push(Y=>k(Y)?Y:fe),this}reduce(k,Y){let X=Y;return this.steps.push(ne=>(X=k(X,ne),X)),this}latch(k=(Y,X)=>Y===X){let Y=!0,X;return this.steps.push(ne=>{const ce=Y||!k(ne,X);return Y=!1,X=ne,ce?ne:fe}),this}evaluate(k){for(const Y of this.steps)if(k=Y(k),k===fe)break;return k}}function ye(S,k,Y=X=>X){const X=(...be)=>_e.fire(Y(...be)),ne=()=>S.on(k,X),ce=()=>S.removeListener(k,X),_e=new i({onWillAddFirstListener:ne,onDidRemoveLastListener:ce});return _e.event}l.fromNodeEventEmitter=ye;function ge(S,k,Y=X=>X){const X=(...be)=>_e.fire(Y(...be)),ne=()=>S.addEventListener(k,X),ce=()=>S.removeEventListener(k,X),_e=new i({onWillAddFirstListener:ne,onDidRemoveLastListener:ce});return _e.event}l.fromDOMEventEmitter=ge;function pe(S){return new Promise(k=>Z(S)(k))}l.toPromise=pe;function I(S){const k=new i;return S.then(Y=>{k.fire(Y)},()=>{k.fire(void 0)}).finally(()=>{k.dispose()}),k.event}l.fromPromise=I;function $(S,k,Y){return k(Y),S(X=>k(X))}l.runAndSubscribe=$;class d{constructor(k,Y){this._observable=k,this._counter=0,this._hasChanged=!1;const X={onWillAddFirstListener:()=>{k.addObserver(this)},onDidRemoveLastListener:()=>{k.removeObserver(this)}};Y||s(X),this.emitter=new i(X),Y&&Y.add(this.emitter)}beginUpdate(k){this._counter++}handlePossibleChange(k){}handleChange(k,Y){this._hasChanged=!0}endUpdate(k){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function a(S,k){return new d(S,k).emitter.event}l.fromObservable=a;function A(S){return(k,Y,X)=>{let ne=0,ce=!1;const _e={beginUpdate(){ne++},endUpdate(){ne--,ne===0&&(S.reportChanges(),ce&&(ce=!1,k.call(Y)))},handlePossibleChange(){},handleChange(){ce=!0}};S.addObserver(_e),S.reportChanges();const be={dispose(){S.removeObserver(_e)}};return X instanceof N.DisposableStore?X.add(be):Array.isArray(X)&&X.push(be),be}}l.fromObservableLight=A})(T||(e.Event=T={}));class B{static{this.all=new Set}static{this._idPool=0}constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${B._idPool++}`,B.all.add(this)}start(s){this._stopWatch=new j.StopWatch,this.listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=B;let F=-1;function U(l){const s=F;return F=l,{dispose(){F=s}}}class c{constructor(s,M=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=M,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(s,M){const Z=this.threshold;if(Z<=0||M<Z)return;this._stacks||(this._stacks=new Map);const re=this._stacks.get(s.value)||0;if(this._stacks.set(s.value,re+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=Z*.5;let ue,oe=0;for(const[H,J]of this._stacks)(!ue||oe<J)&&(ue=H,oe=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${oe}):`),console.warn(ue)}return()=>{const ue=this._stacks.get(s.value)||0;this._stacks.set(s.value,ue-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let D=0;class m{constructor(s){this.value=s,this.id=D++}}const P=2,R=(l,s)=>{if(l instanceof m)s(l);else for(let M=0;M<l.length;M++){const Z=l[M];Z&&s(Z)}},r=C?new FinalizationRegistry(l=>{typeof l=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(l))}):void 0;class i{constructor(s){this._size=0,this._options=s,this._leakageMon=F>0||this._options?.leakWarningThreshold?new c(this._options?.leakWarningThreshold??F):void 0,this._perfMon=this._options?._profName?new B(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(u){const s=this._listeners;queueMicrotask(()=>{R(s,M=>M.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(s,M,Z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),N.Disposable.None;if(this._disposed)return N.Disposable.None;M&&(s=s.bind(M));const re=new m(s);let ue,oe;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(re.stack=h.create(),ue=this._leakageMon.check(re.stack,this._size+1)),u&&(re.stack=oe??h.create()),this._listeners?this._listeners instanceof m?(this._deliveryQueue??=new n,this._listeners=[this._listeners,re]):this._listeners.push(re):(this._options?.onWillAddFirstListener?.(this),this._listeners=re,this._options?.onDidAddFirstListener?.(this)),this._size++;const H=(0,N.toDisposable)(()=>{r?.unregister(H),ue?.(),this._removeListener(re)});if(Z instanceof N.DisposableStore?Z.add(H):Array.isArray(Z)&&Z.push(H),r){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(H,J,H)}return H},this._event}_removeListener(s){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const M=this._listeners,Z=M.indexOf(s);if(Z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,M[Z]=void 0;const re=this._deliveryQueue.current===this;if(this._size*P<=M.length){let ue=0;for(let oe=0;oe<M.length;oe++)M[oe]?M[ue++]=M[oe]:re&&(this._deliveryQueue.end--,ue<this._deliveryQueue.i&&this._deliveryQueue.i--);M.length=ue}}_deliver(s,M){if(!s)return;const Z=this._options?.onListenerError||E.onUnexpectedError;if(!Z){s.value(M);return}try{s.value(M)}catch(re){Z(re)}}_deliverQueue(s){const M=s.current._listeners;for(;s.i<s.end;)this._deliver(M[s.i++],s.value);s.reset()}fire(s){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof m)this._deliver(this._listeners,s);else{const M=this._deliveryQueue;M.enqueue(this,s,this._listeners.length),this._deliverQueue(M)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const t=()=>new n;e.createEventDeliveryQueue=t;class n{constructor(){this.i=-1,this.end=0}enqueue(s,M,Z){this.i=0,this.end=Z,this.current=s,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class y extends i{async fireAsync(s,M,Z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList),R(this._listeners,re=>this._asyncDeliveryQueue.push([re.value,s]));this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[re,ue]=this._asyncDeliveryQueue.shift(),oe=[],H={...ue,token:M,waitUntil:J=>{if(Object.isFrozen(oe))throw new Error("waitUntil can NOT be called asynchronous");Z&&(J=Z(J,re)),oe.push(J)}};try{re(H)}catch(J){(0,E.onUnexpectedError)(J);continue}Object.freeze(oe),await Promise.allSettled(oe).then(J=>{for(const ie of J)ie.status==="rejected"&&(0,E.onUnexpectedError)(ie.reason)})}}}e.AsyncEmitter=y;class v extends i{get isPaused(){return this._isPaused!==0}constructor(s){super(s),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._size&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=v;class g extends v{constructor(s){super(s),this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=g;class o extends i{constructor(s){super(s),this._queuedEvents=[],this._mergeFn=s?.merge}fire(s){this.hasListeners()&&(this._queuedEvents.push(s),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(M=>super.fire(M)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const M={event:s,listener:null};this.events.push(M),this.hasListeners&&this.hook(M);const Z=()=>{this.hasListeners&&this.unhook(M);const re=this.events.indexOf(M);this.events.splice(re,1)};return(0,N.toDisposable)((0,z.createSingleCallFunction)(Z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(M=>this.emitter.fire(M))}unhook(s){s.listener?.dispose(),s.listener=null}dispose(){this.emitter.dispose();for(const s of this.events)s.listener?.dispose();this.events=[]}}e.EventMultiplexer=b;class O{constructor(s,M,Z,re){this._store=new N.DisposableStore;const ue=this._store.add(new b),oe=this._store.add(new N.DisposableMap);function H(J){oe.set(J,ue.add(re(J)))}for(const J of s)H(J);this._store.add(M(J=>{H(J)})),this._store.add(Z(J=>{oe.deleteAndDispose(J)})),this.event=ue.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=O;class Q{constructor(){this.buffers=[]}wrapEvent(s){return(M,Z,re)=>s(ue=>{const oe=this.buffers[this.buffers.length-1];oe?oe.push(()=>M.call(Z,ue)):M.call(Z,ue)},void 0,re)}bufferEvents(s){const M=[];this.buffers.push(M);const Z=s();return this.buffers.pop(),M.forEach(re=>re()),Z}}e.EventBufferer=Q;class p{constructor(){this.listening=!1,this.inputEvent=T.None,this.inputEventListener=N.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(he[7],de([0,1,9]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const z=Object.freeze(function(C,u){const _=setTimeout(C.bind(u),0);return{dispose(){clearTimeout(_)}}});var N;(function(C){function u(_){return _===C.None||_===C.Cancelled||_ instanceof L?!0:!_||typeof _!="object"?!1:typeof _.isCancellationRequested=="boolean"&&typeof _.onCancellationRequested=="function"}C.isCancellationToken=u,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:z})})(N||(e.CancellationToken=N={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?z:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class j{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=N.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=N.None}}e.CancellationTokenSource=j}),define(he[31],de([0,1,7]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class z{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new E.CancellationTokenSource,u=this.task(C.token);return this.result={promise:u,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=z;class N{constructor(C,u=JSON.stringify){this.fn=C,this._computeKey=u,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const u=this._computeKey(C);return this.lastArgKey!==u&&(this.lastArgKey=u,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=N;class L{get cachedValues(){return this._map}constructor(C){this.fn=C,this._map=new Map}get(C){if(this._map.has(C))return this._map.get(C);const u=this.fn(C);return this._map.set(C,u),u}}e.CachedFunction=L}),define(he[32],de([0,1,3,6]),function(le,e,E,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=N,e.isReadableStream=L,e.isReadableBufferedStream=j,e.newWriteableStream=C,e.consumeReadable=_,e.peekReadable=T,e.consumeStream=B,e.listenStream=F,e.peekStream=U,e.toStream=c,e.emptyStream=h,e.toReadable=D,e.transform=m,e.prefixedReadable=P,e.prefixedStream=R;function N(r){const i=r;return i?typeof i.read=="function":!1}function L(r){const i=r;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function j(r){const i=r;return i?L(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function C(r,i){return new u(r,i)}class u{constructor(i,t){this.reducer=i,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(i){if(!this.state.destroyed){if(this.state.flowing)this.emitData(i);else if(this.buffer.data.push(i),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(i){this.state.destroyed||(this.state.flowing?this.emitError(i):this.buffer.error.push(i))}end(i){this.state.destroyed||(typeof i<"u"&&this.write(i),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(i){this.listeners.data.slice(0).forEach(t=>t(i))}emitError(i){this.listeners.error.length===0?(0,E.onUnexpectedError)(i):this.listeners.error.slice(0).forEach(t=>t(i))}emitEnd(){this.listeners.end.slice(0).forEach(i=>i())}on(i,t){if(!this.state.destroyed)switch(i){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(i,t){if(this.state.destroyed)return;let n;switch(i){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const y=n.indexOf(t);y>=0&&n.splice(y,1)}}flowData(){if(this.buffer.data.length>0){const i=this.reducer(this.buffer.data);this.emitData(i),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const i of this.buffer.error)this.emitError(i);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(r,i){const t=[];let n;for(;(n=r.read())!==null;)t.push(n);return i(t)}function T(r,i,t){const n=[];let y;for(;(y=r.read())!==null&&n.length<t;)n.push(y);return y===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof y<"u"){const v=y;return y=void 0,v}return r.read()}}}function B(r,i){return new Promise((t,n)=>{const y=[];F(r,{onData:v=>{i&&y.push(v)},onError:v=>{i?n(v):t(void 0)},onEnd:()=>{t(i?i(y):void 0)}})})}function F(r,i,t){r.on("error",n=>{t?.isCancellationRequested||i.onError(n)}),r.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),r.on("data",n=>{t?.isCancellationRequested||i.onData(n)})}function U(r,i){return new Promise((t,n)=>{const y=new z.DisposableStore,v=[],g=O=>{if(v.push(O),v.length>i)return y.dispose(),r.pause(),t({stream:r,buffer:v,ended:!1})},o=O=>(y.dispose(),n(O)),b=()=>(y.dispose(),t({stream:r,buffer:v,ended:!0}));y.add((0,z.toDisposable)(()=>r.removeListener("error",o))),r.on("error",o),y.add((0,z.toDisposable)(()=>r.removeListener("end",b))),r.on("end",b),y.add((0,z.toDisposable)(()=>r.removeListener("data",g))),r.on("data",g)})}function c(r,i){const t=C(i);return t.end(r),t}function h(){const r=C(()=>{throw new Error("not supported")});return r.end(),r}function D(r){let i=!1;return{read:()=>i?null:(i=!0,r)}}function m(r,i,t){const n=C(t);return F(r,{onData:y=>n.write(i.data(y)),onError:y=>n.error(i.error?i.error(y):y),onEnd:()=>n.end()}),n}function P(r,i,t){let n=!1;return{read:()=>{const y=i.read();return n?y:(n=!0,y!==null?t([r,y]):r)}}}function R(r,i,t){let n=!1;const y=C(t);return F(i,{onData:v=>n?y.write(v):(n=!0,y.write(t([r,v]))),onError:v=>y.error(v),onEnd:()=>{n||(n=!0,y.write(r)),y.end()}}),y}}),define(he[10],de([0,1,12,32]),function(le,e,E,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=_,e.readUInt16LE=T,e.writeUInt16LE=B,e.readUInt32BE=F,e.writeUInt32BE=U,e.readUInt32LE=c,e.writeUInt32LE=h,e.readUInt8=D,e.writeUInt8=m,e.readableToBuffer=P,e.bufferToReadable=R,e.streamToBuffer=r,e.bufferedStreamToBuffer=i,e.bufferToStream=t,e.streamToBufferReadableStream=n,e.newWriteableBufferStream=y,e.prefixedBufferReadable=v,e.prefixedBufferStream=g,e.decodeBase64=o,e.encodeBase64=Q;const N=typeof Buffer<"u",L=new E.Lazy(()=>new Uint8Array(256));let j,C;class u{static alloc(l){return N?new u(Buffer.allocUnsafe(l)):new u(new Uint8Array(l))}static wrap(l){return N&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new u(l)}static fromString(l,s){return!(s?.dontUseNodeBuffer||!1)&&N?new u(Buffer.from(l)):(j||(j=new TextEncoder),new u(j.encode(l)))}static fromByteArray(l){const s=u.alloc(l.length);for(let M=0,Z=l.length;M<Z;M++)s.buffer[M]=l[M];return s}static concat(l,s){if(typeof s>"u"){s=0;for(let re=0,ue=l.length;re<ue;re++)s+=l[re].byteLength}const M=u.alloc(s);let Z=0;for(let re=0,ue=l.length;re<ue;re++){const oe=l[re];M.set(oe,Z),Z+=oe.byteLength}return M}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=u.alloc(this.byteLength);return l.set(this),l}toString(){return N?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(l,s){return new u(this.buffer.subarray(l,s))}set(l,s){if(l instanceof u)this.buffer.set(l.buffer,s);else if(l instanceof Uint8Array)this.buffer.set(l,s);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),s);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),s);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return F(this.buffer,l)}writeUInt32BE(l,s){U(this.buffer,l,s)}readUInt32LE(l){return c(this.buffer,l)}writeUInt32LE(l,s){h(this.buffer,l,s)}readUInt8(l){return D(this.buffer,l)}writeUInt8(l,s){m(this.buffer,l,s)}indexOf(l,s=0){return _(this.buffer,l instanceof u?l.buffer:l,s)}}e.VSBuffer=u;function _(p,l,s=0){const M=l.byteLength,Z=p.byteLength;if(M===0)return 0;if(M===1)return p.indexOf(l[0]);if(M>Z-s)return-1;const re=L.value;re.fill(l.length);for(let J=0;J<l.length;J++)re[l[J]]=l.length-J-1;let ue=s+l.length-1,oe=ue,H=-1;for(;ue<Z;)if(p[ue]===l[oe]){if(oe===0){H=ue;break}ue--,oe--}else ue+=Math.max(l.length-oe,re[p[ue]]),oe=l.length-1;return H}function T(p,l){return p[l+0]<<0>>>0|p[l+1]<<8>>>0}function B(p,l,s){p[s+0]=l&255,l=l>>>8,p[s+1]=l&255}function F(p,l){return p[l]*2**24+p[l+1]*2**16+p[l+2]*2**8+p[l+3]}function U(p,l,s){p[s+3]=l,l=l>>>8,p[s+2]=l,l=l>>>8,p[s+1]=l,l=l>>>8,p[s]=l}function c(p,l){return p[l+0]<<0>>>0|p[l+1]<<8>>>0|p[l+2]<<16>>>0|p[l+3]<<24>>>0}function h(p,l,s){p[s+0]=l&255,l=l>>>8,p[s+1]=l&255,l=l>>>8,p[s+2]=l&255,l=l>>>8,p[s+3]=l&255}function D(p,l){return p[l]}function m(p,l,s){p[s]=l}function P(p){return z.consumeReadable(p,l=>u.concat(l))}function R(p){return z.toReadable(p)}function r(p){return z.consumeStream(p,l=>u.concat(l))}async function i(p){return p.ended?u.concat(p.buffer):u.concat([...p.buffer,await r(p.stream)])}function t(p){return z.toStream(p,l=>u.concat(l))}function n(p){return z.transform(p,{data:l=>typeof l=="string"?u.fromString(l):u.wrap(l)},l=>u.concat(l))}function y(p){return z.newWriteableStream(l=>u.concat(l),p)}function v(p,l){return z.prefixedReadable(p,l,s=>u.concat(s))}function g(p,l){return z.prefixedStream(p,l,s=>u.concat(s))}function o(p){let l=0,s=0,M=0;const Z=new Uint8Array(Math.floor(p.length/4*3)),re=oe=>{switch(s){case 3:Z[M++]=l|oe,s=0;break;case 2:Z[M++]=l|oe>>>2,l=oe<<6,s=3;break;case 1:Z[M++]=l|oe>>>4,l=oe<<4,s=2;break;default:l=oe<<2,s=1}};for(let oe=0;oe<p.length;oe++){const H=p.charCodeAt(oe);if(H>=65&&H<=90)re(H-65);else if(H>=97&&H<=122)re(H-97+26);else if(H>=48&&H<=57)re(H-48+52);else if(H===43||H===45)re(62);else if(H===47||H===95)re(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${p[oe]}`)}}const ue=M;for(;s>0;)re(0);return u.wrap(Z).slice(0,ue)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Q({buffer:p},l=!0,s=!1){const M=s?O:b;let Z="";const re=p.byteLength%3;let ue=0;for(;ue<p.byteLength-re;ue+=3){const oe=p[ue+0],H=p[ue+1],J=p[ue+2];Z+=M[oe>>>2],Z+=M[(oe<<4|H>>>4)&63],Z+=M[(H<<2|J>>>6)&63],Z+=M[J&63]}if(re===1){const oe=p[ue+0];Z+=M[oe>>>2],Z+=M[oe<<4&63],l&&(Z+="==")}else if(re===2){const oe=p[ue+0],H=p[ue+1];Z+=M[oe>>>2],Z+=M[(oe<<4|H>>>4)&63],Z+=M[H<<2&63],l&&(Z+="=")}return Z}}),define(he[11],de([0,1,31,12]),function(le,e,E,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=N,e.format=j,e.format2=u,e.htmlAttributeEncodeValue=_,e.escape=T,e.escapeRegExpCharacters=B,e.count=F,e.truncate=U,e.truncateMiddle=c,e.trim=h,e.ltrim=D,e.rtrim=m,e.convertSimple2RegExpPattern=P,e.stripWildcards=R,e.createRegExp=r,e.regExpLeadsToEndlessLoop=i,e.splitLines=t,e.splitLinesIncludeSeparators=n,e.firstNonWhitespaceIndex=y,e.getLeadingWhitespace=v,e.lastNonWhitespaceIndex=g,e.replaceAsync=o,e.compare=b,e.compareSubstring=O,e.compareIgnoreCase=Q,e.compareSubstringIgnoreCase=p,e.isAsciiDigit=l,e.isLowerAsciiLetter=s,e.isUpperAsciiLetter=M,e.equalsIgnoreCase=Z,e.startsWithIgnoreCase=re,e.commonPrefixLength=ue,e.commonSuffixLength=oe,e.isHighSurrogate=H,e.isLowSurrogate=J,e.computeCodePoint=ie,e.getNextCodePoint=se,e.nextCharLength=K,e.prevCharLength=ee,e.getCharContainingOffset=te,e.charCount=me,e.containsRTL=ye,e.isBasicASCII=pe,e.containsUnusualLineTerminators=I,e.isFullWidthCharacter=$,e.isEmojiImprecise=d,e.lcut=a,e.forAnsiStringParts=S,e.removeAnsiEscapeCodes=k,e.startsWithUTF8BOM=Y,e.stripUTF8BOM=X,e.fuzzyContains=ne,e.containsUppercaseCharacter=ce,e.uppercaseFirstLetter=_e,e.getNLines=be,e.singleLetterHash=Ee,e.getGraphemeBreakType=Te,e.getLeftDeleteOffset=qe;function N(f){return!f||typeof f!="string"?!0:f.trim().length===0}const L=/{(\d+)}/g;function j(f,...W){return W.length===0?f:f.replace(L,function(G,x){const ae=parseInt(x,10);return isNaN(ae)||ae<0||ae>=W.length?G:W[ae]})}const C=/{([^}]+)}/g;function u(f,W){return Object.keys(W).length===0?f:f.replace(C,(G,x)=>W[x]??G)}function _(f){return f.replace(/[<>"'&]/g,W=>{switch(W){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return W})}function T(f){return f.replace(/[<>&]/g,function(W){switch(W){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return W}})}function B(f){return f.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function F(f,W){let G=0;const x=W.charCodeAt(0);for(let ae=f.length-1;ae>=0;ae--)f.charCodeAt(ae)===x&&G++;return G}function U(f,W,G="\u2026"){return f.length<=W?f:`${f.substr(0,W)}${G}`}function c(f,W,G="\u2026"){if(f.length<=W)return f;const x=Math.ceil(W/2)-G.length/2,ae=Math.floor(W/2)-G.length/2;return`${f.substr(0,x)}${G}${f.substr(f.length-ae)}`}function h(f,W=" "){const G=D(f,W);return m(G,W)}function D(f,W){if(!f||!W)return f;const G=W.length;if(G===0||f.length===0)return f;let x=0;for(;f.indexOf(W,x)===x;)x=x+G;return f.substring(x)}function m(f,W){if(!f||!W)return f;const G=W.length,x=f.length;if(G===0||x===0)return f;let ae=x,ve=-1;for(;ve=f.lastIndexOf(W,ae-1),!(ve===-1||ve+G!==ae);){if(ve===0)return"";ae=ve}return f.substring(0,ae)}function P(f){return f.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function R(f){return f.replace(/\*/g,"")}function r(f,W,G={}){if(!f)throw new Error("Cannot create regex from empty string");W||(f=B(f)),G.wholeWord&&(/\B/.test(f.charAt(0))||(f="\\b"+f),/\B/.test(f.charAt(f.length-1))||(f=f+"\\b"));let x="";return G.global&&(x+="g"),G.matchCase||(x+="i"),G.multiline&&(x+="m"),G.unicode&&(x+="u"),new RegExp(f,x)}function i(f){return f.source==="^"||f.source==="^$"||f.source==="$"||f.source==="^\\s*$"?!1:!!(f.exec("")&&f.lastIndex===0)}function t(f){return f.split(/\r\n|\r|\n/)}function n(f){const W=[],G=f.split(/(\r\n|\r|\n)/);for(let x=0;x<Math.ceil(G.length/2);x++)W.push(G[2*x]+(G[2*x+1]??""));return W}function y(f){for(let W=0,G=f.length;W<G;W++){const x=f.charCodeAt(W);if(x!==32&&x!==9)return W}return-1}function v(f,W=0,G=f.length){for(let x=W;x<G;x++){const ae=f.charCodeAt(x);if(ae!==32&&ae!==9)return f.substring(W,x)}return f.substring(W,G)}function g(f,W=f.length-1){for(let G=W;G>=0;G--){const x=f.charCodeAt(G);if(x!==32&&x!==9)return G}return-1}function o(f,W,G){const x=[];let ae=0;for(const ve of f.matchAll(W)){if(x.push(f.slice(ae,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");ae=ve.index+ve[0].length,x.push(G(ve[0],...ve.slice(1),ve.index,f,ve.groups))}return x.push(f.slice(ae)),Promise.all(x).then(ve=>ve.join(""))}function b(f,W){return f<W?-1:f>W?1:0}function O(f,W,G=0,x=f.length,ae=0,ve=W.length){for(;G<x&&ae<ve;G++,ae++){const Se=f.charCodeAt(G),De=W.charCodeAt(ae);if(Se<De)return-1;if(Se>De)return 1}const Ce=x-G,Ie=ve-ae;return Ce<Ie?-1:Ce>Ie?1:0}function Q(f,W){return p(f,W,0,f.length,0,W.length)}function p(f,W,G=0,x=f.length,ae=0,ve=W.length){for(;G<x&&ae<ve;G++,ae++){let Se=f.charCodeAt(G),De=W.charCodeAt(ae);if(Se===De)continue;if(Se>=128||De>=128)return O(f.toLowerCase(),W.toLowerCase(),G,x,ae,ve);s(Se)&&(Se-=32),s(De)&&(De-=32);const Ae=Se-De;if(Ae!==0)return Ae}const Ce=x-G,Ie=ve-ae;return Ce<Ie?-1:Ce>Ie?1:0}function l(f){return f>=48&&f<=57}function s(f){return f>=97&&f<=122}function M(f){return f>=65&&f<=90}function Z(f,W){return f.length===W.length&&p(f,W)===0}function re(f,W){const G=W.length;return W.length>f.length?!1:p(f,W,0,G)===0}function ue(f,W){const G=Math.min(f.length,W.length);let x;for(x=0;x<G;x++)if(f.charCodeAt(x)!==W.charCodeAt(x))return x;return G}function oe(f,W){const G=Math.min(f.length,W.length);let x;const ae=f.length-1,ve=W.length-1;for(x=0;x<G;x++)if(f.charCodeAt(ae-x)!==W.charCodeAt(ve-x))return x;return G}function H(f){return 55296<=f&&f<=56319}function J(f){return 56320<=f&&f<=57343}function ie(f,W){return(f-55296<<10)+(W-56320)+65536}function se(f,W,G){const x=f.charCodeAt(G);if(H(x)&&G+1<W){const ae=f.charCodeAt(G+1);if(J(ae))return ie(x,ae)}return x}function q(f,W){const G=f.charCodeAt(W-1);if(J(G)&&W>1){const x=f.charCodeAt(W-2);if(H(x))return ie(x,G)}return G}class w{get offset(){return this._offset}constructor(W,G=0){this._str=W,this._len=W.length,this._offset=G}setOffset(W){this._offset=W}prevCodePoint(){const W=q(this._str,this._offset);return this._offset-=W>=65536?2:1,W}nextCodePoint(){const W=se(this._str,this._len,this._offset);return this._offset+=W>=65536?2:1,W}eol(){return this._offset>=this._len}}e.CodePointIterator=w;class V{get offset(){return this._iterator.offset}constructor(W,G=0){this._iterator=new w(W,G)}nextGraphemeLength(){const W=Pe.getInstance(),G=this._iterator,x=G.offset;let ae=W.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const ve=G.offset,Ce=W.getGraphemeBreakType(G.nextCodePoint());if(ke(ae,Ce)){G.setOffset(ve);break}ae=Ce}return G.offset-x}prevGraphemeLength(){const W=Pe.getInstance(),G=this._iterator,x=G.offset;let ae=W.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const ve=G.offset,Ce=W.getGraphemeBreakType(G.prevCodePoint());if(ke(Ce,ae)){G.setOffset(ve);break}ae=Ce}return x-G.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function K(f,W){return new V(f,W).nextGraphemeLength()}function ee(f,W){return new V(f,W).prevGraphemeLength()}function te(f,W){W>0&&J(f.charCodeAt(W))&&W--;const G=W+K(f,W);return[G-ee(f,G),G]}function me(f){const W=new V(f);let G=0;for(;!W.eol();)G++,W.nextGraphemeLength();return G}let fe;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(f){return fe||(fe=we()),fe.test(f)}const ge=/^[\t\n\r\x20-\x7E]*$/;function pe(f){return ge.test(f)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function I(f){return e.UNUSUAL_LINE_TERMINATORS.test(f)}function $(f){return f>=11904&&f<=55215||f>=63744&&f<=64255||f>=65281&&f<=65374}function d(f){return f>=127462&&f<=127487||f===8986||f===8987||f===9200||f===9203||f>=9728&&f<=10175||f===11088||f===11093||f>=127744&&f<=128591||f>=128640&&f<=128764||f>=128992&&f<=129008||f>=129280&&f<=129535||f>=129648&&f<=129782}function a(f,W,G=""){const x=f.trimStart();if(x.length<W)return x;const ae=/\b/g;let ve=0;for(;ae.test(x)&&!(x.length-ae.lastIndex<W);)ve=ae.lastIndex,ae.lastIndex+=1;return ve===0?x:G+x.substring(ve).trimStart()}const A=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*S(f){let W=0;for(const G of f.matchAll(A))W!==G.index&&(yield{isCode:!1,str:f.substring(W,G.index)}),yield{isCode:!0,str:G[0]},W=G.index+G[0].length;W!==f.length&&(yield{isCode:!1,str:f.substring(W)})}function k(f){return f&&(f=f.replace(A,"")),f}e.UTF8_BOM_CHARACTER="\uFEFF";function Y(f){return!!(f&&f.length>0&&f.charCodeAt(0)===65279)}function X(f){return Y(f)?f.substr(1):f}function ne(f,W){if(!f||!W||f.length<W.length)return!1;const G=W.length,x=f.toLowerCase();let ae=0,ve=-1;for(;ae<G;){const Ce=x.indexOf(W[ae],ve+1);if(Ce<0)return!1;ve=Ce,ae++}return!0}function ce(f,W=!1){return f?(W&&(f=f.replace(/\\./g,"")),f.toLowerCase()!==f):!1}function _e(f){return f.charAt(0).toUpperCase()+f.slice(1)}function be(f,W=1){if(W===0)return"";let G=-1;do G=f.indexOf(`
`,G+1),W--;while(W>0&&G>=0);return G===-1?f:(f[G-1]==="\r"&&G--,f.substr(0,G))}function Ee(f){return f=f%(2*26),f<26?String.fromCharCode(97+f):String.fromCharCode(65+f-26)}function Te(f){return Pe.getInstance().getGraphemeBreakType(f)}function ke(f,W){return f===0?W!==5&&W!==7:f===2&&W===3?!1:f===4||f===2||f===3||W===4||W===2||W===3?!0:!(f===8&&(W===8||W===9||W===11||W===12)||(f===11||f===9)&&(W===9||W===10)||(f===12||f===10)&&W===10||W===5||W===13||W===7||f===1||f===13&&W===14||f===6&&W===6)}var Oe;(function(f){f[f.Other=0]="Other",f[f.Prepend=1]="Prepend",f[f.CR=2]="CR",f[f.LF=3]="LF",f[f.Control=4]="Control",f[f.Extend=5]="Extend",f[f.Regional_Indicator=6]="Regional_Indicator",f[f.SpacingMark=7]="SpacingMark",f[f.L=8]="L",f[f.V=9]="V",f[f.T=10]="T",f[f.LV=11]="LV",f[f.LVT=12]="LVT",f[f.ZWJ=13]="ZWJ",f[f.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Pe{static{this._INSTANCE=null}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(W){if(W<32)return W===10?3:W===13?2:4;if(W<127)return 0;const G=this._data,x=G.length/3;let ae=1;for(;ae<=x;)if(W<G[3*ae])ae=2*ae;else if(W>G[3*ae+1])ae=2*ae+1;else return G[3*ae+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(f,W){if(f===0)return 0;const G=$e(f,W);if(G!==void 0)return G;const x=new w(W,f);return x.prevCodePoint(),x.offset}function $e(f,W){const G=new w(W,f);let x=G.prevCodePoint();for(;Be(x)||x===65039||x===8419;){if(G.offset===0)return;x=G.prevCodePoint()}if(!d(x))return;let ae=G.offset;return ae>0&&G.prevCodePoint()===8205&&(ae=G.offset),ae}function Be(f){return 127995<=f&&f<=127999}var ze;(function(f){f[f.zwj=8205]="zwj",f[f.emojiVariantSelector=65039]="emojiVariantSelector",f[f.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Ue{static{this.ambiguousCharacterData=new z.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new E.LRUCachedFunction(W=>{function G(Ae){const Re=new Map;for(let Le=0;Le<Ae.length;Le+=2)Re.set(Ae[Le],Ae[Le+1]);return Re}function x(Ae,Re){const Le=new Map(Ae);for(const[Fe,We]of Re)Le.set(Fe,We);return Le}function ae(Ae,Re){if(!Ae)return Re;const Le=new Map;for(const[Fe,We]of Ae)Re.has(Fe)&&Le.set(Fe,We);return Le}const ve=this.ambiguousCharacterData.value;let Ce=W.filter(Ae=>!Ae.startsWith("_")&&Ae in ve);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Ae of Ce){const Re=G(ve[Ae]);Ie=ae(Ie,Re)}const Se=G(ve._common),De=x(Se,Ie);return new Ue(De)})}static getInstance(W){return Ue.cache.get(Array.from(W))}static{this._locales=new z.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(W=>!W.startsWith("_")))}static getLocales(){return Ue._locales.value}constructor(W){this.confusableDictionary=W}isAmbiguous(W){return this.confusableDictionary.has(W)}getPrimaryConfusable(W){return this.confusableDictionary.get(W)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ue;class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(W){return Ne.getData().has(W)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne}),define(he[33],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(he[8],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=E,e.isStringArray=z,e.isObject=N,e.isTypedArray=L,e.isNumber=j,e.isIterable=C,e.isBoolean=u,e.isUndefined=_,e.isDefined=T,e.isUndefinedOrNull=B,e.assertType=F,e.assertIsDefined=U,e.assertAllDefined=c,e.isEmptyObject=D,e.isFunction=m,e.areFunctions=P,e.validateConstraints=R,e.validateConstraint=r;function E(i){return typeof i=="string"}function z(i){return Array.isArray(i)&&i.every(t=>E(t))}function N(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function L(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function j(i){return typeof i=="number"&&!isNaN(i)}function C(i){return!!i&&typeof i[Symbol.iterator]=="function"}function u(i){return i===!0||i===!1}function _(i){return typeof i>"u"}function T(i){return!B(i)}function B(i){return _(i)||i===null}function F(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function U(i){if(B(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const t=[];for(let n=0;n<i.length;n++){const y=i[n];if(B(y))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(y)}return t}const h=Object.prototype.hasOwnProperty;function D(i){if(!N(i))return!1;for(const t in i)if(h.call(i,t))return!1;return!0}function m(i){return typeof i=="function"}function P(...i){return i.length>0&&i.every(m)}function R(i,t){const n=Math.min(i.length,t.length);for(let y=0;y<n;y++)r(i[y],t[y])}function r(i,t){if(E(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(i instanceof t)return}catch{}if(!B(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[13],de([0,1,8]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=z,e.deepFreeze=N,e.cloneAndChange=j,e.mixin=u,e.equals=_,e.safeStringify=T,e.distinct=B,e.getCaseInsensitive=F,e.filter=U,e.getAllPropertyNames=c,e.getAllMethodNames=h,e.createProxyObject=D;function z(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const P=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([R,r])=>{P[R]=r&&typeof r=="object"?z(r):r}),P}function N(m){if(!m||typeof m!="object")return m;const P=[m];for(;P.length>0;){const R=P.shift();Object.freeze(R);for(const r in R)if(L.call(R,r)){const i=R[r];typeof i=="object"&&!Object.isFrozen(i)&&!(0,E.isTypedArray)(i)&&P.push(i)}}return m}const L=Object.prototype.hasOwnProperty;function j(m,P){return C(m,P,new Set)}function C(m,P,R){if((0,E.isUndefinedOrNull)(m))return m;const r=P(m);if(typeof r<"u")return r;if(Array.isArray(m)){const i=[];for(const t of m)i.push(C(t,P,R));return i}if((0,E.isObject)(m)){if(R.has(m))throw new Error("Cannot clone recursive data-structure");R.add(m);const i={};for(const t in m)L.call(m,t)&&(i[t]=C(m[t],P,R));return R.delete(m),i}return m}function u(m,P,R=!0){return(0,E.isObject)(m)?((0,E.isObject)(P)&&Object.keys(P).forEach(r=>{r in m?R&&((0,E.isObject)(m[r])&&(0,E.isObject)(P[r])?u(m[r],P[r],R):m[r]=P[r]):m[r]=P[r]}),m):P}function _(m,P){if(m===P)return!0;if(m==null||P===null||P===void 0||typeof m!=typeof P||typeof m!="object"||Array.isArray(m)!==Array.isArray(P))return!1;let R,r;if(Array.isArray(m)){if(m.length!==P.length)return!1;for(R=0;R<m.length;R++)if(!_(m[R],P[R]))return!1}else{const i=[];for(r in m)i.push(r);i.sort();const t=[];for(r in P)t.push(r);if(t.sort(),!_(i,t))return!1;for(R=0;R<i.length;R++)if(!_(m[i[R]],P[i[R]]))return!1}return!0}function T(m){const P=new Set;return JSON.stringify(m,(R,r)=>{if((0,E.isObject)(r)||Array.isArray(r)){if(P.has(r))return"[Circular]";P.add(r)}return r})}function B(m,P){const R=Object.create(null);return!m||!P||Object.keys(P).forEach(i=>{const t=m[i],n=P[i];_(t,n)||(R[i]=n)}),R}function F(m,P){const R=P.toLowerCase(),r=Object.keys(m).find(i=>i.toLowerCase()===R);return r?m[r]:m[P]}function U(m,P){const R=Object.create(null);for(const[r,i]of Object.entries(m))P(r,i)&&(R[r]=i);return R}function c(m){let P=[];for(;Object.prototype!==m;)P=P.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return P}function h(m){const P=[];for(const R of c(m))typeof m[R]=="function"&&P.push(R);return P}function D(m,P){const R=i=>function(){const t=Array.prototype.slice.call(arguments,0);return P(i,t)},r={};for(const i of m)r[i]=R(i);return r}}),define(he[34],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=z;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function z(N){return E.test(N)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(C){for(let u=0;u<C.length;u++)C[u]=Math.floor(Math.random()*256);return C};const L=new Uint8Array(16),j=[];for(let C=0;C<256;C++)j.push(C.toString(16).padStart(2,"0"));return function(){N(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let u=0,_="";return _+=j[L[u++]],_+=j[L[u++]],_+=j[L[u++]],_+=j[L[u++]],_+="-",_+=j[L[u++]],_+=j[L[u++]],_+="-",_+=j[L[u++]],_+=j[L[u++]],_+="-",_+=j[L[u++]],_+=j[L[u++]],_+="-",_+=j[L[u++]],_+=j[L[u++]],_+=j[L[u++]],_+=j[L[u++]],_+=j[L[u++]],_+=j[L[u++]],_}}()}),define(he[35],de([51,52]),function(le,e){return le.create("vs/base/common/platform",e)}),define(he[2],de([0,1,35]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=n,e.isLittleEndian=O,e.isBigSurOrNewer=Q,e.LANGUAGE_DEFAULT="en";let z=!1,N=!1,L=!1,j=!1,C=!1,u=!1,_=!1,T=!1,B=!1,F=!1,U,c=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT,D,m;const P=globalThis;let R;typeof P.vscode<"u"&&typeof P.vscode.process<"u"?R=P.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(R=process);const r=typeof R?.versions?.electron=="string",i=r&&R?.type==="renderer";if(typeof R=="object"){z=R.platform==="win32",N=R.platform==="darwin",L=R.platform==="linux",j=L&&!!R.env.SNAP&&!!R.env.SNAP_REVISION,_=r,B=!!R.env.CI||!!R.env.BUILD_ARTIFACTSTAGINGDIRECTORY,U=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT;const p=R.env.VSCODE_NLS_CONFIG;if(p)try{const l=JSON.parse(p),s=l.availableLanguages["*"];U=l.locale,h=l.osLocale,c=s||e.LANGUAGE_DEFAULT,D=l._translationsConfigFile}catch{}C=!0}else typeof navigator=="object"&&!i?(m=navigator.userAgent,z=m.indexOf("Windows")>=0,N=m.indexOf("Macintosh")>=0,T=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=m.indexOf("Linux")>=0,F=m?.indexOf("Mobi")>=0,u=!0,U=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,c=U,h=navigator.language):console.error("Unable to resolve platform.");var t;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(t||(e.Platform=t={}));function n(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let y=0;N?y=1:z?y=3:L&&(y=2),e.isWindows=z,e.isMacintosh=N,e.isLinux=L,e.isLinuxSnap=j,e.isNative=C,e.isElectron=_,e.isWeb=u,e.isWebWorker=u&&typeof P.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?P.origin:void 0,e.isIOS=T,e.isMobile=F,e.isCI=B,e.platform=y,e.userAgent=m,e.language=c;var v;(function(p){function l(){return e.language}p.value=l;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}p.isDefaultVariant=s;function M(){return e.language==="en"}p.isDefault=M})(v||(e.Language=v={})),e.locale=U,e.platformLocale=h,e.translationsConfigFile=D,e.setTimeout0IsFaster=typeof P.postMessage=="function"&&!P.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const p=[];P.addEventListener("message",s=>{if(s.data&&s.data.vscodeScheduleAsyncWork)for(let M=0,Z=p.length;M<Z;M++){const re=p[M];if(re.id===s.data.vscodeScheduleAsyncWork){p.splice(M,1),re.callback();return}}});let l=0;return s=>{const M=++l;p.push({id:M,callback:s}),P.postMessage({vscodeScheduleAsyncWork:M},"*")}}return p=>setTimeout(p)})();var g;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(g||(e.OperatingSystem=g={})),e.OS=N||T?2:z?1:3;let o=!0,b=!1;function O(){if(!b){b=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,o=new Uint16Array(p.buffer)[0]===513}return o}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function Q(p){return parseFloat(p)>=20}}),define(he[14],de([0,1,2]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let z;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const L=N.process;z={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?z={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:z={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=z.cwd,e.env=z.env,e.platform=z.platform,e.arch=z.arch}),define(he[4],de([0,1,14]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const z=65,N=97,L=90,j=122,C=46,u=47,_=92,T=58,B=63;class F extends Error{constructor(n,y,v){let g;typeof y=="string"&&y.indexOf("not ")===0?(g="must not be",y=y.replace(/^not /,"")):g="must be";const o=n.indexOf(".")!==-1?"property":"argument";let b=`The "${n}" ${o} ${g} of type ${y}`;b+=`. Received type ${typeof v}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function U(t,n){if(t===null||typeof t!="object")throw new F(n,"Object",t)}function c(t,n){if(typeof t!="string")throw new F(n,"string",t)}const h=E.platform==="win32";function D(t){return t===u||t===_}function m(t){return t===u}function P(t){return t>=z&&t<=L||t>=N&&t<=j}function R(t,n,y,v){let g="",o=0,b=-1,O=0,Q=0;for(let p=0;p<=t.length;++p){if(p<t.length)Q=t.charCodeAt(p);else{if(v(Q))break;Q=u}if(v(Q)){if(!(b===p-1||O===1))if(O===2){if(g.length<2||o!==2||g.charCodeAt(g.length-1)!==C||g.charCodeAt(g.length-2)!==C){if(g.length>2){const l=g.lastIndexOf(y);l===-1?(g="",o=0):(g=g.slice(0,l),o=g.length-1-g.lastIndexOf(y)),b=p,O=0;continue}else if(g.length!==0){g="",o=0,b=p,O=0;continue}}n&&(g+=g.length>0?`${y}..`:"..",o=2)}else g.length>0?g+=`${y}${t.slice(b+1,p)}`:g=t.slice(b+1,p),o=p-b-1;b=p,O=0}else Q===C&&O!==-1?++O:O=-1}return g}function r(t,n){U(n,"pathObject");const y=n.dir||n.root,v=n.base||`${n.name||""}${n.ext||""}`;return y?y===n.root?`${y}${v}`:`${y}${t}${v}`:v}e.win32={resolve(...t){let n="",y="",v=!1;for(let g=t.length-1;g>=-1;g--){let o;if(g>=0){if(o=t[g],c(o,"path"),o.length===0)continue}else n.length===0?o=E.cwd():(o=E.env[`=${n}`]||E.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==n.toLowerCase()&&o.charCodeAt(2)===_)&&(o=`${n}\\`));const b=o.length;let O=0,Q="",p=!1;const l=o.charCodeAt(0);if(b===1)D(l)&&(O=1,p=!0);else if(D(l))if(p=!0,D(o.charCodeAt(1))){let s=2,M=s;for(;s<b&&!D(o.charCodeAt(s));)s++;if(s<b&&s!==M){const Z=o.slice(M,s);for(M=s;s<b&&D(o.charCodeAt(s));)s++;if(s<b&&s!==M){for(M=s;s<b&&!D(o.charCodeAt(s));)s++;(s===b||s!==M)&&(Q=`\\\\${Z}\\${o.slice(M,s)}`,O=s)}}}else O=1;else P(l)&&o.charCodeAt(1)===T&&(Q=o.slice(0,2),O=2,b>2&&D(o.charCodeAt(2))&&(p=!0,O=3));if(Q.length>0)if(n.length>0){if(Q.toLowerCase()!==n.toLowerCase())continue}else n=Q;if(v){if(n.length>0)break}else if(y=`${o.slice(O)}\\${y}`,v=p,p&&n.length>0)break}return y=R(y,!v,"\\",D),v?`${n}\\${y}`:`${n}${y}`||"."},normalize(t){c(t,"path");const n=t.length;if(n===0)return".";let y=0,v,g=!1;const o=t.charCodeAt(0);if(n===1)return m(o)?"\\":t;if(D(o))if(g=!0,D(t.charCodeAt(1))){let O=2,Q=O;for(;O<n&&!D(t.charCodeAt(O));)O++;if(O<n&&O!==Q){const p=t.slice(Q,O);for(Q=O;O<n&&D(t.charCodeAt(O));)O++;if(O<n&&O!==Q){for(Q=O;O<n&&!D(t.charCodeAt(O));)O++;if(O===n)return`\\\\${p}\\${t.slice(Q)}\\`;O!==Q&&(v=`\\\\${p}\\${t.slice(Q,O)}`,y=O)}}}else y=1;else P(o)&&t.charCodeAt(1)===T&&(v=t.slice(0,2),y=2,n>2&&D(t.charCodeAt(2))&&(g=!0,y=3));let b=y<n?R(t.slice(y),!g,"\\",D):"";return b.length===0&&!g&&(b="."),b.length>0&&D(t.charCodeAt(n-1))&&(b+="\\"),v===void 0?g?`\\${b}`:b:g?`${v}\\${b}`:`${v}${b}`},isAbsolute(t){c(t,"path");const n=t.length;if(n===0)return!1;const y=t.charCodeAt(0);return D(y)||n>2&&P(y)&&t.charCodeAt(1)===T&&D(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,y;for(let o=0;o<t.length;++o){const b=t[o];c(b,"path"),b.length>0&&(n===void 0?n=y=b:n+=`\\${b}`)}if(n===void 0)return".";let v=!0,g=0;if(typeof y=="string"&&D(y.charCodeAt(0))){++g;const o=y.length;o>1&&D(y.charCodeAt(1))&&(++g,o>2&&(D(y.charCodeAt(2))?++g:v=!1))}if(v){for(;g<n.length&&D(n.charCodeAt(g));)g++;g>=2&&(n=`\\${n.slice(g)}`)}return e.win32.normalize(n)},relative(t,n){if(c(t,"from"),c(n,"to"),t===n)return"";const y=e.win32.resolve(t),v=e.win32.resolve(n);if(y===v||(t=y.toLowerCase(),n=v.toLowerCase(),t===n))return"";let g=0;for(;g<t.length&&t.charCodeAt(g)===_;)g++;let o=t.length;for(;o-1>g&&t.charCodeAt(o-1)===_;)o--;const b=o-g;let O=0;for(;O<n.length&&n.charCodeAt(O)===_;)O++;let Q=n.length;for(;Q-1>O&&n.charCodeAt(Q-1)===_;)Q--;const p=Q-O,l=b<p?b:p;let s=-1,M=0;for(;M<l;M++){const re=t.charCodeAt(g+M);if(re!==n.charCodeAt(O+M))break;re===_&&(s=M)}if(M!==l){if(s===-1)return v}else{if(p>l){if(n.charCodeAt(O+M)===_)return v.slice(O+M+1);if(M===2)return v.slice(O+M)}b>l&&(t.charCodeAt(g+M)===_?s=M:M===2&&(s=3)),s===-1&&(s=0)}let Z="";for(M=g+s+1;M<=o;++M)(M===o||t.charCodeAt(M)===_)&&(Z+=Z.length===0?"..":"\\..");return O+=s,Z.length>0?`${Z}${v.slice(O,Q)}`:(v.charCodeAt(O)===_&&++O,v.slice(O,Q))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===_){if(n.charCodeAt(1)===_){const y=n.charCodeAt(2);if(y!==B&&y!==C)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(P(n.charCodeAt(0))&&n.charCodeAt(1)===T&&n.charCodeAt(2)===_)return`\\\\?\\${n}`;return t},dirname(t){c(t,"path");const n=t.length;if(n===0)return".";let y=-1,v=0;const g=t.charCodeAt(0);if(n===1)return D(g)?t:".";if(D(g)){if(y=v=1,D(t.charCodeAt(1))){let O=2,Q=O;for(;O<n&&!D(t.charCodeAt(O));)O++;if(O<n&&O!==Q){for(Q=O;O<n&&D(t.charCodeAt(O));)O++;if(O<n&&O!==Q){for(Q=O;O<n&&!D(t.charCodeAt(O));)O++;if(O===n)return t;O!==Q&&(y=v=O+1)}}}}else P(g)&&t.charCodeAt(1)===T&&(y=n>2&&D(t.charCodeAt(2))?3:2,v=y);let o=-1,b=!0;for(let O=n-1;O>=v;--O)if(D(t.charCodeAt(O))){if(!b){o=O;break}}else b=!1;if(o===-1){if(y===-1)return".";o=y}return t.slice(0,o)},basename(t,n){n!==void 0&&c(n,"ext"),c(t,"path");let y=0,v=-1,g=!0,o;if(t.length>=2&&P(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(y=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let b=n.length-1,O=-1;for(o=t.length-1;o>=y;--o){const Q=t.charCodeAt(o);if(D(Q)){if(!g){y=o+1;break}}else O===-1&&(g=!1,O=o+1),b>=0&&(Q===n.charCodeAt(b)?--b===-1&&(v=o):(b=-1,v=O))}return y===v?v=O:v===-1&&(v=t.length),t.slice(y,v)}for(o=t.length-1;o>=y;--o)if(D(t.charCodeAt(o))){if(!g){y=o+1;break}}else v===-1&&(g=!1,v=o+1);return v===-1?"":t.slice(y,v)},extname(t){c(t,"path");let n=0,y=-1,v=0,g=-1,o=!0,b=0;t.length>=2&&t.charCodeAt(1)===T&&P(t.charCodeAt(0))&&(n=v=2);for(let O=t.length-1;O>=n;--O){const Q=t.charCodeAt(O);if(D(Q)){if(!o){v=O+1;break}continue}g===-1&&(o=!1,g=O+1),Q===C?y===-1?y=O:b!==1&&(b=1):y!==-1&&(b=-1)}return y===-1||g===-1||b===0||b===1&&y===g-1&&y===v+1?"":t.slice(y,g)},format:r.bind(null,"\\"),parse(t){c(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const y=t.length;let v=0,g=t.charCodeAt(0);if(y===1)return D(g)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(D(g)){if(v=1,D(t.charCodeAt(1))){let s=2,M=s;for(;s<y&&!D(t.charCodeAt(s));)s++;if(s<y&&s!==M){for(M=s;s<y&&D(t.charCodeAt(s));)s++;if(s<y&&s!==M){for(M=s;s<y&&!D(t.charCodeAt(s));)s++;s===y?v=s:s!==M&&(v=s+1)}}}}else if(P(g)&&t.charCodeAt(1)===T){if(y<=2)return n.root=n.dir=t,n;if(v=2,D(t.charCodeAt(2))){if(y===3)return n.root=n.dir=t,n;v=3}}v>0&&(n.root=t.slice(0,v));let o=-1,b=v,O=-1,Q=!0,p=t.length-1,l=0;for(;p>=v;--p){if(g=t.charCodeAt(p),D(g)){if(!Q){b=p+1;break}continue}O===-1&&(Q=!1,O=p+1),g===C?o===-1?o=p:l!==1&&(l=1):o!==-1&&(l=-1)}return O!==-1&&(o===-1||l===0||l===1&&o===O-1&&o===b+1?n.base=n.name=t.slice(b,O):(n.name=t.slice(b,o),n.base=t.slice(b,O),n.ext=t.slice(o,O))),b>0&&b!==v?n.dir=t.slice(0,b-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(h){const t=/\\/g;return()=>{const n=E.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let n="",y=!1;for(let v=t.length-1;v>=-1&&!y;v--){const g=v>=0?t[v]:i();c(g,"path"),g.length!==0&&(n=`${g}/${n}`,y=g.charCodeAt(0)===u)}return n=R(n,!y,"/",m),y?`/${n}`:n.length>0?n:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===u,y=t.charCodeAt(t.length-1)===u;return t=R(t,!n,"/",m),t.length===0?n?"/":y?"./":".":(y&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let n;for(let y=0;y<t.length;++y){const v=t[y];c(v,"path"),v.length>0&&(n===void 0?n=v:n+=`/${v}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(c(t,"from"),c(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const y=1,v=t.length,g=v-y,o=1,b=n.length-o,O=g<b?g:b;let Q=-1,p=0;for(;p<O;p++){const s=t.charCodeAt(y+p);if(s!==n.charCodeAt(o+p))break;s===u&&(Q=p)}if(p===O)if(b>O){if(n.charCodeAt(o+p)===u)return n.slice(o+p+1);if(p===0)return n.slice(o+p)}else g>O&&(t.charCodeAt(y+p)===u?Q=p:p===0&&(Q=0));let l="";for(p=y+Q+1;p<=v;++p)(p===v||t.charCodeAt(p)===u)&&(l+=l.length===0?"..":"/..");return`${l}${n.slice(o+Q)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===u;let y=-1,v=!0;for(let g=t.length-1;g>=1;--g)if(t.charCodeAt(g)===u){if(!v){y=g;break}}else v=!1;return y===-1?n?"/":".":n&&y===1?"//":t.slice(0,y)},basename(t,n){n!==void 0&&c(n,"ext"),c(t,"path");let y=0,v=-1,g=!0,o;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let b=n.length-1,O=-1;for(o=t.length-1;o>=0;--o){const Q=t.charCodeAt(o);if(Q===u){if(!g){y=o+1;break}}else O===-1&&(g=!1,O=o+1),b>=0&&(Q===n.charCodeAt(b)?--b===-1&&(v=o):(b=-1,v=O))}return y===v?v=O:v===-1&&(v=t.length),t.slice(y,v)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===u){if(!g){y=o+1;break}}else v===-1&&(g=!1,v=o+1);return v===-1?"":t.slice(y,v)},extname(t){c(t,"path");let n=-1,y=0,v=-1,g=!0,o=0;for(let b=t.length-1;b>=0;--b){const O=t.charCodeAt(b);if(O===u){if(!g){y=b+1;break}continue}v===-1&&(g=!1,v=b+1),O===C?n===-1?n=b:o!==1&&(o=1):n!==-1&&(o=-1)}return n===-1||v===-1||o===0||o===1&&n===v-1&&n===y+1?"":t.slice(n,v)},format:r.bind(null,"/"),parse(t){c(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const y=t.charCodeAt(0)===u;let v;y?(n.root="/",v=1):v=0;let g=-1,o=0,b=-1,O=!0,Q=t.length-1,p=0;for(;Q>=v;--Q){const l=t.charCodeAt(Q);if(l===u){if(!O){o=Q+1;break}continue}b===-1&&(O=!1,b=Q+1),l===C?g===-1?g=Q:p!==1&&(p=1):g!==-1&&(p=-1)}if(b!==-1){const l=o===0&&y?1:o;g===-1||p===0||p===1&&g===b-1&&g===o+1?n.base=n.name=t.slice(l,b):(n.name=t.slice(l,g),n.base=t.slice(l,b),n.ext=t.slice(g,b))}return o>0?n.dir=t.slice(0,o-1):y&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h?e.win32.normalize:e.posix.normalize,e.isAbsolute=h?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h?e.win32.join:e.posix.join,e.resolve=h?e.win32.resolve:e.posix.resolve,e.relative=h?e.win32.relative:e.posix.relative,e.dirname=h?e.win32.dirname:e.posix.dirname,e.basename=h?e.win32.basename:e.posix.basename,e.extname=h?e.win32.extname:e.posix.extname,e.format=h?e.win32.format:e.posix.format,e.parse=h?e.win32.parse:e.posix.parse,e.toNamespacedPath=h?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h?e.win32.sep:e.posix.sep,e.delimiter=h?e.win32.delimiter:e.posix.delimiter}),define(he[20],de([0,1,4,2,11,8]),function(le,e,E,z,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=j,e.toSlashes=C,e.toPosixPath=u,e.getRoot=_,e.isUNC=T,e.isValidBasename=c,e.isEqual=h,e.isEqualOrParent=D,e.isWindowsDriveLetter=m,e.sanitizeFilePath=P,e.isRootOrDriveLetter=R,e.hasDriveLetter=r,e.getDriveLetter=i,e.indexOfPath=t,e.parseLineAndColumnAware=n,e.randomPath=g;function j(o){return o===47||o===92}function C(o){return o.replace(/[\\/]/g,E.posix.sep)}function u(o){return o.indexOf("/")===-1&&(o=C(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}function _(o,b=E.posix.sep){if(!o)return"";const O=o.length,Q=o.charCodeAt(0);if(j(Q)){if(j(o.charCodeAt(1))&&!j(o.charCodeAt(2))){let l=3;const s=l;for(;l<O&&!j(o.charCodeAt(l));l++);if(s!==l&&!j(o.charCodeAt(l+1))){for(l+=1;l<O;l++)if(j(o.charCodeAt(l)))return o.slice(0,l+1).replace(/[\\/]/g,b)}}return b}else if(m(Q)&&o.charCodeAt(1)===58)return j(o.charCodeAt(2))?o.slice(0,2)+b:o.slice(0,2);let p=o.indexOf("://");if(p!==-1){for(p+=3;p<O;p++)if(j(o.charCodeAt(p)))return o.slice(0,p+1)}return""}function T(o){if(!z.isWindows||!o||o.length<5)return!1;let b=o.charCodeAt(0);if(b!==92||(b=o.charCodeAt(1),b!==92))return!1;let O=2;const Q=O;for(;O<o.length&&(b=o.charCodeAt(O),b!==92);O++);return!(Q===O||(b=o.charCodeAt(O+1),isNaN(b)||b===92))}const B=/[\\/:\*\?"<>\|]/g,F=/[\\/]/g,U=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(o,b=z.isWindows){const O=b?B:F;return!(!o||o.length===0||/^\s+$/.test(o)||(O.lastIndex=0,O.test(o))||b&&U.test(o)||o==="."||o===".."||b&&o[o.length-1]==="."||b&&o.length!==o.trim().length||o.length>255)}function h(o,b,O){const Q=o===b;return!O||Q?Q:!o||!b?!1:(0,N.equalsIgnoreCase)(o,b)}function D(o,b,O,Q=E.sep){if(o===b)return!0;if(!o||!b||b.length>o.length)return!1;if(O){if(!(0,N.startsWithIgnoreCase)(o,b))return!1;if(b.length===o.length)return!0;let l=b.length;return b.charAt(b.length-1)===Q&&l--,o.charAt(l)===Q}return b.charAt(b.length-1)!==Q&&(b+=Q),o.indexOf(b)===0}function m(o){return o>=65&&o<=90||o>=97&&o<=122}function P(o,b){return z.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(b,o)),o=(0,E.normalize)(o),z.isWindows?(o=(0,N.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,N.rtrim)(o,E.sep),o||(o=E.sep)),o}function R(o){const b=(0,E.normalize)(o);return z.isWindows?o.length>3?!1:r(b)&&(o.length===2||b.charCodeAt(2)===92):b===E.posix.sep}function r(o,b=z.isWindows){return b?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}function i(o,b=z.isWindows){return r(o,b)?o[0]:void 0}function t(o,b,O){return b.length>o.length?-1:o===b?0:(O&&(o=o.toLowerCase(),b=b.toLowerCase()),o.indexOf(b))}function n(o){const b=o.split(":");let O,Q,p;for(const l of b){const s=Number(l);(0,L.isNumber)(s)?Q===void 0?Q=s:p===void 0&&(p=s):O=O?[O,l].join(":"):l}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:Q!==void 0?Q:void 0,column:p!==void 0?p:Q!==void 0?1:void 0}}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",v="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(o,b,O=8){let Q="";for(let l=0;l<O;l++){let s;l===0&&z.isWindows&&!b&&(O===3||O===4)?s=v:s=y,Q+=s.charAt(Math.floor(Math.random()*s.length))}let p;return b?p=`${b}-${Q}`:p=Q,o?(0,E.join)(o,p):p}}),define(he[21],de([0,1,2]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=L,e.removeDangerousEnvVariables=j;var z;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(z||(e.Source=z={}));var N;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function L(C,...u){const _=u.reduce((F,U)=>(F[U]=!0,F),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(F=>!_[F]).forEach(F=>{for(let U=0;U<T.length;U++)if(F.search(T[U])!==-1){delete C[F];break}})}function j(C){C&&(delete C.DEBUG,E.isMacintosh&&delete C.DYLD_LIBRARY_PATH,E.isLinux&&delete C.LD_PRELOAD)}}),define(he[5],de([0,1,4,2]),function(le,e,E,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=c,e.uriToFsPath=r;const N=/^\w[\w\d+.-]*$/,L=/^\//,j=/^\/\//;function C(v,g){if(!v.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${v.authority}", path: "${v.path}", query: "${v.query}", fragment: "${v.fragment}"}`);if(v.scheme&&!N.test(v.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(v.path){if(v.authority){if(!L.test(v.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(v.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(v,g){return!v&&!g?"file":v}function _(v,g){switch(v){case"https":case"http":case"file":g?g[0]!==B&&(g=B+g):g=B;break}return g}const T="",B="/",F=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class U{static isUri(g){return g instanceof U?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,o,b,O,Q,p=!1){typeof g=="object"?(this.scheme=g.scheme||T,this.authority=g.authority||T,this.path=g.path||T,this.query=g.query||T,this.fragment=g.fragment||T):(this.scheme=u(g,p),this.authority=o||T,this.path=_(this.scheme,b||T),this.query=O||T,this.fragment=Q||T,C(this,p))}get fsPath(){return r(this,!1)}with(g){if(!g)return this;let{scheme:o,authority:b,path:O,query:Q,fragment:p}=g;return o===void 0?o=this.scheme:o===null&&(o=T),b===void 0?b=this.authority:b===null&&(b=T),O===void 0?O=this.path:O===null&&(O=T),Q===void 0?Q=this.query:Q===null&&(Q=T),p===void 0?p=this.fragment:p===null&&(p=T),o===this.scheme&&b===this.authority&&O===this.path&&Q===this.query&&p===this.fragment?this:new D(o,b,O,Q,p)}static parse(g,o=!1){const b=F.exec(g);return b?new D(b[2]||T,y(b[4]||T),y(b[5]||T),y(b[7]||T),y(b[9]||T),o):new D(T,T,T,T,T)}static file(g){let o=T;if(z.isWindows&&(g=g.replace(/\\/g,B)),g[0]===B&&g[1]===B){const b=g.indexOf(B,2);b===-1?(o=g.substring(2),g=B):(o=g.substring(2,b),g=g.substring(b)||B)}return new D("file",o,g,T,T)}static from(g,o){return new D(g.scheme,g.authority,g.path,g.query,g.fragment,o)}static joinPath(g,...o){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return z.isWindows&&g.scheme==="file"?b=U.file(E.win32.join(r(g,!0),...o)).path:b=E.posix.join(g.path,...o),g.with({path:b})}toString(g=!1){return i(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof U)return g;{const o=new D(g);return o._formatted=g.external??null,o._fsPath=g._sep===h?g.fsPath??null:null,o}}else return g}}e.URI=U;function c(v){return!v||typeof v!="object"?!1:typeof v.scheme=="string"&&(typeof v.authority=="string"||typeof v.authority>"u")&&(typeof v.path=="string"||typeof v.path>"u")&&(typeof v.query=="string"||typeof v.query>"u")&&(typeof v.fragment=="string"||typeof v.fragment>"u")}const h=z.isWindows?1:void 0;class D extends U{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(g=!1){return g?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=h),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function P(v,g,o){let b,O=-1;for(let Q=0;Q<v.length;Q++){const p=v.charCodeAt(Q);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||g&&p===47||o&&p===91||o&&p===93||o&&p===58)O!==-1&&(b+=encodeURIComponent(v.substring(O,Q)),O=-1),b!==void 0&&(b+=v.charAt(Q));else{b===void 0&&(b=v.substr(0,Q));const l=m[p];l!==void 0?(O!==-1&&(b+=encodeURIComponent(v.substring(O,Q)),O=-1),b+=l):O===-1&&(O=Q)}}return O!==-1&&(b+=encodeURIComponent(v.substring(O))),b!==void 0?b:v}function R(v){let g;for(let o=0;o<v.length;o++){const b=v.charCodeAt(o);b===35||b===63?(g===void 0&&(g=v.substr(0,o)),g+=m[b]):g!==void 0&&(g+=v[o])}return g!==void 0?g:v}function r(v,g){let o;return v.authority&&v.path.length>1&&v.scheme==="file"?o=`//${v.authority}${v.path}`:v.path.charCodeAt(0)===47&&(v.path.charCodeAt(1)>=65&&v.path.charCodeAt(1)<=90||v.path.charCodeAt(1)>=97&&v.path.charCodeAt(1)<=122)&&v.path.charCodeAt(2)===58?g?o=v.path.substr(1):o=v.path[1].toLowerCase()+v.path.substr(2):o=v.path,z.isWindows&&(o=o.replace(/\//g,"\\")),o}function i(v,g){const o=g?R:P;let b="",{scheme:O,authority:Q,path:p,query:l,fragment:s}=v;if(O&&(b+=O,b+=":"),(Q||O==="file")&&(b+=B,b+=B),Q){let M=Q.indexOf("@");if(M!==-1){const Z=Q.substr(0,M);Q=Q.substr(M+1),M=Z.lastIndexOf(":"),M===-1?b+=o(Z,!1,!1):(b+=o(Z.substr(0,M),!1,!1),b+=":",b+=o(Z.substr(M+1),!1,!0)),b+="@"}Q=Q.toLowerCase(),M=Q.lastIndexOf(":"),M===-1?b+=o(Q,!1,!0):(b+=o(Q.substr(0,M),!1,!0),b+=Q.substr(M))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const M=p.charCodeAt(1);M>=65&&M<=90&&(p=`/${String.fromCharCode(M+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const M=p.charCodeAt(0);M>=65&&M<=90&&(p=`${String.fromCharCode(M+32)}:${p.substr(2)}`)}b+=o(p,!0,!1)}return l&&(b+="?",b+=o(l,!1,!1)),s&&(b+="#",b+=g?s:P(s,!1,!1)),b}function t(v){try{return decodeURIComponent(v)}catch{return v.length>3?v.substr(0,3)+t(v.substr(3)):v}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function y(v){return v.match(n)?v.replace(n,g=>t(g)):v}}),define(he[36],de([0,1,5]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=z,e.parse=N,e.getFirstFrame=L,e.log=C;function z(_){const T=_;return T&&typeof T.type=="string"&&typeof T.severity=="string"}function N(_){const T=[];let B;try{const F=JSON.parse(_.arguments),U=F[F.length-1];U&&U.__$stack&&(F.pop(),B=U.__$stack),T.push(...F)}catch{T.push("Unable to log remote console arguments",_.arguments)}return{args:T,stack:B}}function L(_){if(typeof _!="string")return L(N(_).stack);const T=_;if(T){const B=j(T),F=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(B||"");if(F&&F.length===4)return{uri:E.URI.file(F[1]),line:Number(F[2]),column:Number(F[3])}}}function j(_){if(!_)return _;const T=_.indexOf(`
`);return T===-1?_:_.substring(0,T)}function C(_,T){const{args:B,stack:F}=N(_),U=typeof B[0]=="string"&&B.length===1;let c=j(F);c&&(c=`(${c.trim()})`);let h=[];if(typeof B[0]=="string"?c&&U?h=[`%c[${T}] %c${B[0]} %c${c}`,u("blue"),u(""),u("grey")]:h=[`%c[${T}] %c${B[0]}`,u("blue"),u(""),...B.slice(1)]:h=[`%c[${T}]%`,u("blue"),...B],c&&!U&&h.push(c),typeof console[_.severity]!="function")throw new Error("Unknown console method");console[_.severity].apply(console,h)}function u(_){return`color: ${_}`}}),define(he[37],de([0,1,10,5]),function(le,e,E,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=N,e.parse=L,e.revive=C;function N(u){return JSON.stringify(u,j)}function L(u){let _=JSON.parse(u);return _=C(_),_}function j(u,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:_.flags}:_}function C(u,_=0){if(!u||_>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return z.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof E.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let T=0;T<u.length;++T)u[T]=C(u[T],_+1);else for(const T in u)Object.hasOwnProperty.call(u,T)&&(u[T]=C(u[T],_+1))}return u}}),define(he[15],de([0,1,3,2,11,5,4]),function(le,e,E,z,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=u,e.matchesSomeScheme=_,e.getServerRootPath=B;var C;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.codeSetting="code-setting"})(C||(e.Schemas=C={}));function u(c,h){return L.URI.isUri(c)?(0,N.equalsIgnoreCase)(c.scheme,h):(0,N.startsWithIgnoreCase)(c,h+":")}function _(c,...h){return h.some(D=>u(c,D))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}setServerRootPath(h,D){this._serverRootPath=B(h,D)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return j.posix.join(this._serverRootPath,C.vscodeRemoteResource)}set(h,D,m){this._hosts[h]=D,this._ports[h]=m}setConnectionToken(h,D){this._connectionTokens[h]=D}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(h){if(this._delegate)try{return this._delegate(h)}catch(i){return E.onUnexpectedError(i),h}const D=h.authority;let m=this._hosts[D];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const P=this._ports[D],R=this._connectionTokens[D];let r=`path=${encodeURIComponent(h.path)}`;return typeof R=="string"&&(r+=`&${e.connectionTokenQueryName}=${encodeURIComponent(R)}`),L.URI.from({scheme:z.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${m}:${P}`,path:this._remoteResourcesPath,query:r})}}e.RemoteAuthorities=new T;function B(c,h){return j.posix.join(h??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class F{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(h){const D=this.toUri(h,le);return this.uriToBrowserUri(D)}uriToBrowserUri(h){return h.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(h):h.scheme===C.file&&(z.isNative||z.webWorkerOrigin===`${C.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?h.with({scheme:C.vscodeFileResource,authority:h.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):h}asFileUri(h){const D=this.toUri(h,le);return this.uriToFileUri(D)}uriToFileUri(h){return h.scheme===C.vscodeFileResource?h.with({scheme:C.file,authority:h.authority!==F.FALLBACK_AUTHORITY?h.authority:null,query:null,fragment:null}):h}toUri(h,D){return L.URI.isUri(h)?h:L.URI.parse(D.toUrl(h))}}e.FileAccess=new F;var U;(function(c){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(h.get("3"));const D="vscode-coi";function m(R){let r;typeof R=="string"?r=new URL(R).searchParams:R instanceof URL?r=R.searchParams:L.URI.isUri(R)&&(r=new URL(R.toString(!0)).searchParams);const i=r?.get(D);if(i)return h.get(i)}c.getHeadersFromQuery=m;function P(R,r,i){if(!globalThis.crossOriginIsolated)return;const t=r&&i?"3":i?"2":"1";R instanceof URLSearchParams?R.set(D,t):R[D]=t}c.addSearchParam=P})(U||(e.COI=U={}))}),define(he[38],de([0,1,23,15,2,5]),function(le,e,E,z,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=T;class j{constructor(F,U,c){this.id=F,this.dependencies=U,this.callback=c}}class C{static{this.INSTANCE=new C}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(F,U,c)=>{typeof F!="string"&&(c=U,U=F,F=null),(typeof U!="object"||!Array.isArray(U))&&(c=U,U=null),this._defineCalls.push(new j(F,U,c))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(F){if(F.startsWith(window.location.origin)||F.startsWith("vscode-file://vscode-app"))return F;throw new Error(`[trusted_script_src] Invalid script url: ${F}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(F){return F}})))}async load(F){this._initialize();const U=await(this._isWebWorker?this._workerLoadScript(F):this._isRenderer?this._rendererLoadScript(F):this._nodeJSLoadScript(F));if(!U)throw new Error(`Did not receive a define call from script ${F}`);if(Array.isArray(U.dependencies)&&U.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${F}. The dependencies are: ${U.dependencies.join(", ")}`);return typeof U.callback=="function"?U.callback([]):U.callback}_rendererLoadScript(F){return new Promise((U,c)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const D=()=>{h.removeEventListener("load",m),h.removeEventListener("error",P)},m=R=>{D(),U(this._defineCalls.pop())},P=R=>{D(),c(R)};h.addEventListener("load",m),h.addEventListener("error",P),this._amdPolicy&&(F=this._amdPolicy.createScriptURL(F)),h.setAttribute("src",F),window.document.getElementsByTagName("head")[0].appendChild(h)})}_workerLoadScript(F){return new Promise((U,c)=>{try{this._amdPolicy&&(F=this._amdPolicy.createScriptURL(F)),importScripts(F),U(this._defineCalls.pop())}catch(h){c(h)}})}async _nodeJSLoadScript(F){try{const U=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,D=L.URI.parse(F).fsPath,m=U.readFileSync(D).toString(),P=h.wrap(m.replace(/^#!.*/,""));return new c.Script(P).runInThisContext().apply(),this._defineCalls.pop()}catch(U){throw U}}}const u=new Map;let _={};typeof globalThis.require=="object"&&(_=globalThis.require.paths??{});async function T(B,F,U){if(E.isESM){U===void 0&&(U=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),_[B]&&(B=_[B]);const c=`${B}/${F}`;if(u.has(c))return u.get(c);let h;if(/^\w[\w\d+.-]*:\/\//.test(c))h=c;else{const R=`${U&&!N.isWeb?z.nodeModulesAsarPath:z.nodeModulesPath}/${c}`;h=z.FileAccess.asBrowserUri(R).toString(!0)}const D=C.INSTANCE.load(h);return u.set(c,D),D}else return await new Promise((c,h)=>{le([B],c,h)})}}),define(he[22],de([0,1,20,15,4,2,11,5]),function(le,e,E,z,N,L,j,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=u,e.distinctParents=T,e.toLocalResource=F;function u(U){return(0,C.uriToFsPath)(U,!0)}class _{constructor(c){this._ignorePathCasing=c}compare(c,h,D=!1){return c===h?0:(0,j.compare)(this.getComparisonKey(c,D),this.getComparisonKey(h,D))}isEqual(c,h,D=!1){return c===h?!0:!c||!h?!1:this.getComparisonKey(c,D)===this.getComparisonKey(h,D)}getComparisonKey(c,h=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,h,D=!1){if(c.scheme===h.scheme){if(c.scheme===z.Schemas.file)return E.isEqualOrParent(u(c),u(h),this._ignorePathCasing(c))&&c.query===h.query&&(D||c.fragment===h.fragment);if((0,e.isEqualAuthority)(c.authority,h.authority))return E.isEqualOrParent(c.path,h.path,this._ignorePathCasing(c),"/")&&c.query===h.query&&(D||c.fragment===h.fragment)}return!1}joinPath(c,...h){return C.URI.joinPath(c,...h)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return N.posix.basename(c.path)}extname(c){return N.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let h;return c.scheme===z.Schemas.file?h=C.URI.file(N.dirname(u(c))).path:(h=N.posix.dirname(c.path),c.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),h="/")),c.with({path:h})}normalizePath(c){if(!c.path.length)return c;let h;return c.scheme===z.Schemas.file?h=C.URI.file(N.normalize(u(c))).path:h=N.posix.normalize(c.path),c.with({path:h})}relativePath(c,h){if(c.scheme!==h.scheme||!(0,e.isEqualAuthority)(c.authority,h.authority))return;if(c.scheme===z.Schemas.file){const P=N.relative(u(c),u(h));return L.isWindows?E.toSlashes(P):P}let D=c.path||"/";const m=h.path||"/";if(this._ignorePathCasing(c)){let P=0;for(const R=Math.min(D.length,m.length);P<R&&!(D.charCodeAt(P)!==m.charCodeAt(P)&&D.charAt(P).toLowerCase()!==m.charAt(P).toLowerCase());P++);D=m.substr(0,P)+D.substr(P)}return N.posix.relative(D,m)}resolvePath(c,h){if(c.scheme===z.Schemas.file){const D=C.URI.file(N.resolve(u(c),h));return c.with({authority:D.authority,path:D.path})}return h=E.toPosixPath(h),c.with({path:N.posix.resolve(c.path,h)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,h){return c===h||c!==void 0&&h!==void 0&&(0,j.equalsIgnoreCase)(c,h)}hasTrailingPathSeparator(c,h=N.sep){if(c.scheme===z.Schemas.file){const D=u(c);return D.length>E.getRoot(D).length&&D[D.length-1]===h}else{const D=c.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,h=N.sep){return(0,e.hasTrailingPathSeparator)(c,h)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,h=N.sep){let D=!1;if(c.scheme===z.Schemas.file){const m=u(c);D=m!==void 0&&m.length===E.getRoot(m).length&&m[m.length-1]===h}else{h="/";const m=c.path;D=m.length===1&&m.charCodeAt(m.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(c,h)?c.with({path:c.path+"/"}):c}}e.ExtUri=_,e.extUri=new _(()=>!1),e.extUriBiasedIgnorePathCase=new _(U=>U.scheme===z.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new _(U=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(U,c){const h=[];for(let D=0;D<U.length;D++){const m=c(U[D]);U.some((P,R)=>R===D?!1:(0,e.isEqualOrParent)(m,c(P)))||h.push(U[D])}return h}var B;(function(U){U.META_DATA_LABEL="label",U.META_DATA_DESCRIPTION="description",U.META_DATA_SIZE="size",U.META_DATA_MIME="mime";function c(h){const D=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(R=>{const[r,i]=R.split(":");r&&i&&D.set(r,i)});const P=h.path.substring(0,h.path.indexOf(";"));return P&&D.set(U.META_DATA_MIME,P),D}U.parseMetaData=c})(B||(e.DataUri=B={}));function F(U,c,h){if(c){let D=U.path;return D&&D[0]!==N.posix.sep&&(D=N.posix.sep+D),U.with({scheme:h,authority:c,path:D})}return U.with({scheme:h})}}),define(he[16],de([0,1,7,3,9,6,22,2,33,12]),function(le,e,E,z,N,L,j,C,u,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=T,e.createCancelablePromise=B,e.raceCancellation=F,e.raceCancellationError=U,e.raceCancellablePromises=c,e.raceTimeout=h,e.asPromise=D,e.promiseWithResolvers=m,e.timeout=o,e.disposableTimeout=b,e.sequence=O,e.first=Q,e.firstParallel=p,e.retry=w,e.createCancelableAsyncIterable=I;function T(d){return!!d&&typeof d.then=="function"}function B(d){const a=new E.CancellationTokenSource,A=d(a.token),S=new Promise((k,Y)=>{const X=a.token.onCancellationRequested(()=>{X.dispose(),Y(new z.CancellationError)});Promise.resolve(A).then(ne=>{X.dispose(),a.dispose(),k(ne)},ne=>{X.dispose(),a.dispose(),Y(ne)})});return new class{cancel(){a.cancel(),a.dispose()}then(k,Y){return S.then(k,Y)}catch(k){return this.then(void 0,k)}finally(k){return S.finally(k)}}}function F(d,a,A){return new Promise((S,k)=>{const Y=a.onCancellationRequested(()=>{Y.dispose(),S(A)});d.then(S,k).finally(()=>Y.dispose())})}function U(d,a){return new Promise((A,S)=>{const k=a.onCancellationRequested(()=>{k.dispose(),S(new z.CancellationError)});d.then(A,S).finally(()=>k.dispose())})}async function c(d){let a=-1;const A=d.map((S,k)=>S.then(Y=>(a=k,Y)));try{return await Promise.race(A)}finally{d.forEach((S,k)=>{k!==a&&S.cancel()})}}function h(d,a,A){let S;const k=setTimeout(()=>{S?.(void 0),A?.()},a);return Promise.race([d.finally(()=>clearTimeout(k)),new Promise(Y=>S=Y)])}function D(d){return new Promise((a,A)=>{const S=d();T(S)?S.then(a,A):a(S)})}function m(){let d,a;return{promise:new Promise((S,k)=>{d=S,a=k}),resolve:d,reject:a}}class P{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(a){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=a,!this.queuedPromise){const A=()=>{if(this.queuedPromise=null,this.isDisposed)return;const S=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,S};this.queuedPromise=new Promise(S=>{this.activePromise.then(A,A).then(S)})}return new Promise((A,S)=>{this.queuedPromise.then(A,S)})}return this.activePromise=a(),new Promise((A,S)=>{this.activePromise.then(k=>{this.activePromise=null,A(k)},k=>{this.activePromise=null,S(k)})})}dispose(){this.isDisposed=!0}}e.Throttler=P;class R{constructor(){this.current=Promise.resolve(null)}queue(a){return this.current=this.current.then(()=>a(),()=>a())}}e.Sequencer=R;class r{constructor(){this.promiseMap=new Map}queue(a,A){const k=(this.promiseMap.get(a)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(a)===k&&this.promiseMap.delete(a)});return this.promiseMap.set(a,k),k}}e.SequencerByKey=r;const i=(d,a)=>{let A=!0;const S=setTimeout(()=>{A=!1,a()},d);return{isTriggered:()=>A,dispose:()=>{clearTimeout(S),A=!1}}},t=d=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,d())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class n{constructor(a){this.defaultDelay=a,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(a,A=this.defaultDelay){this.task=a,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((k,Y)=>{this.doResolve=k,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const k=this.task;return this.task=null,k()}}));const S=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=A===u.MicrotaskDelay?t(S):i(A,S),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new z.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=n;class y{constructor(a){this.delayer=new n(a),this.throttler=new P}trigger(a,A){return this.delayer.trigger(()=>this.throttler.queue(a),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=y;class v{constructor(){this._isOpen=!1,this._promise=new Promise((a,A)=>{this._completePromise=a})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class g extends v{constructor(a){super(),this._timeout=setTimeout(()=>this.open(),a)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function o(d,a){return a?new Promise((A,S)=>{const k=setTimeout(()=>{Y.dispose(),A()},d),Y=a.onCancellationRequested(()=>{clearTimeout(k),Y.dispose(),S(new z.CancellationError)})}):B(A=>o(d,A))}function b(d,a=0,A){const S=setTimeout(()=>{d(),A&&k.dispose()},a),k=(0,L.toDisposable)(()=>{clearTimeout(S),A?.deleteAndLeak(k)});return A?.add(k),k}function O(d){const a=[];let A=0;const S=d.length;function k(){return A<S?d[A++]():null}function Y(X){X!=null&&a.push(X);const ne=k();return ne?ne.then(Y):Promise.resolve(a)}return Promise.resolve(null).then(Y)}function Q(d,a=S=>!!S,A=null){let S=0;const k=d.length,Y=()=>{if(S>=k)return Promise.resolve(A);const X=d[S++];return Promise.resolve(X()).then(ce=>a(ce)?Promise.resolve(ce):Y())};return Y()}function p(d,a=S=>!!S,A=null){if(d.length===0)return Promise.resolve(A);let S=d.length;const k=()=>{S=-1;for(const Y of d)Y.cancel?.()};return new Promise((Y,X)=>{for(const ne of d)ne.then(ce=>{--S>=0&&a(ce)?(k(),Y(ce)):S===0&&Y(A)}).catch(ce=>{--S>=0&&(k(),X(ce))})})}class l{constructor(a){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=a,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new N.Emitter}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(a){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((A,S)=>{this.outstandingPromises.push({factory:a,c:A,e:S}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const a=this.outstandingPromises.shift();this.runningPromises++;const A=a.factory();A.then(a.c,a.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=l;class s extends l{constructor(){super(1)}}e.Queue=s;class M{constructor(){this.sequentializer=new V,this.tasks=0}queue(a){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,a())):this.sequentializer.run(this.tasks++,a())}}e.LimitedQueue=M;class Z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const a=new te;return this.drainers.add(a),a.p}isDrained(){for(const[,a]of this.queues)if(a.size>0)return!1;return!0}queueSize(a,A=j.extUri){const S=A.getComparisonKey(a);return this.queues.get(S)?.size??0}queueFor(a,A,S=j.extUri){const k=S.getComparisonKey(a);let Y=this.queues.get(k);if(!Y){Y=new s;const X=this.drainListenerCount++,ne=N.Event.once(Y.onDrained)(()=>{Y?.dispose(),this.queues.delete(k),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(X),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new L.DisposableMap),this.drainListeners.set(X,ne),this.queues.set(k,Y)}return Y.queue(A)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const a of this.drainers)a.complete();this.drainers.clear()}dispose(){for(const[,a]of this.queues)a.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=Z;class re{constructor(a,A){this._token=-1,typeof a=="function"&&typeof A=="number"&&this.setIfNotSet(a,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(a,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,a()},A)}setIfNotSet(a,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,a()},A))}}e.TimeoutTimer=re;class ue{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(a,A,S=globalThis){this.cancel();const k=S.setInterval(()=>{a()},A);this.disposable=(0,L.toDisposable)(()=>{S.clearInterval(k),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=ue;class oe{constructor(a,A){this.timeoutToken=-1,this.runner=a,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(a=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,a)}get delay(){return this.timeout}set delay(a){this.timeout=a}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=oe;class H{constructor(a,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.runner=a,this.timeout=A,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(a=this.timeout){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(a/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=H;class J extends oe{constructor(a,A){super(a,A),this.units=[]}work(a){this.units.push(a),this.isScheduled()||this.schedule()}doRun(){const a=this.units;this.units=[],this.runner?.(a)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class ie extends L.Disposable{constructor(a,A){super(),this.options=a,this.handler=A,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(a){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+a.length>this.options.maxBufferedWork)return!1}else if(this.pending+a.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const A of a)this.pendingWork.push(A);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new oe(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(d,a)=>{(0,C.setTimeout0)(()=>{if(A)return;const S=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e._runWhenIdle=(d,a,A)=>{const S=d.requestIdleCallback(a,typeof A=="number"?{timeout:A}:void 0);let k=!1;return{dispose(){k||(k=!0,d.cancelIdleCallback(S))}}},e.runWhenGlobalIdle=d=>(0,e._runWhenIdle)(globalThis,d)}();class se{constructor(a,A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(S){this._error=S}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(a,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=se;class q extends se{constructor(a){super(globalThis,a)}}e.GlobalIdleValue=q;async function w(d,a,A){let S;for(let k=0;k<A;k++)try{return await d()}catch(Y){S=Y,await o(a)}throw S}class V{isRunning(a){return typeof a=="number"?this._running?.taskId===a:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(a,A,S){return this._running={taskId:a,cancel:()=>S?.(),promise:A},A.then(()=>this.doneRunning(a),()=>this.doneRunning(a)),A}doneRunning(a){this._running&&a===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const a=this._queued;this._queued=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this._queued)this._queued.run=a;else{const{promise:A,resolve:S,reject:k}=m();this._queued={run:a,promise:A,promiseResolve:S,promiseReject:k}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=V;class K{constructor(a,A=()=>Date.now()){this.interval=a,this.nowFn=A,this.lastIncrementTime=0,this.value=0}increment(){const a=this.nowFn();return a-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=a,this.value=0),this.value++,this.value}}e.IntervalCounter=K;var ee;(function(d){d[d.Resolved=0]="Resolved",d[d.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((a,A)=>{this.completeCallback=a,this.errorCallback=A})}complete(a){return new Promise(A=>{this.completeCallback(a),this.outcome={outcome:0,value:a},A()})}error(a){return new Promise(A=>{this.errorCallback(a),this.outcome={outcome:1,value:a},A()})}cancel(){return this.error(new z.CancellationError)}}e.DeferredPromise=te;var me;(function(d){async function a(S){let k;const Y=await Promise.all(S.map(X=>X.then(ne=>ne,ne=>{k||(k=ne)})));if(typeof k<"u")throw k;return Y}d.settled=a;function A(S){return new Promise(async(k,Y)=>{try{await S(k,Y)}catch(X){Y(X)}})}d.withAsyncBody=A})(me||(e.Promises=me={}));class fe{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(a){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=a.then(A=>(this._value=A,this._isResolved=!0,A),A=>{throw this._error=A,this._isResolved=!0,A})}requireValue(){if(!this._isResolved)throw new z.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=fe;class we{constructor(a){this._compute=a,this._promise=new _.Lazy(()=>new fe(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=we;var ye;(function(d){d[d.Initial=0]="Initial",d[d.DoneOK=1]="DoneOK",d[d.DoneError=2]="DoneError"})(ye||(ye={}));class ge{static fromArray(a){return new ge(A=>{A.emitMany(a)})}static fromPromise(a){return new ge(async A=>{A.emitMany(await a)})}static fromPromises(a){return new ge(async A=>{await Promise.all(a.map(async S=>A.emitOne(await S)))})}static merge(a){return new ge(async A=>{await Promise.all(a.map(async S=>{for await(const k of S)A.emitOne(k)}))})}static{this.EMPTY=ge.fromArray([])}constructor(a){this._state=0,this._results=[],this._error=null,this._onStateChanged=new N.Emitter,queueMicrotask(async()=>{const A={emitOne:S=>this.emitOne(S),emitMany:S=>this.emitMany(S),reject:S=>this.reject(S)};try{await Promise.resolve(a(A)),this.resolve()}catch(S){this.reject(S)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(a<this._results.length)return{done:!1,value:this._results[a++]};if(this._state===1)return{done:!0,value:void 0};await N.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(a,A){return new ge(async S=>{for await(const k of a)S.emitOne(A(k))})}map(a){return ge.map(this,a)}static filter(a,A){return new ge(async S=>{for await(const k of a)A(k)&&S.emitOne(k)})}filter(a){return ge.filter(this,a)}static coalesce(a){return ge.filter(a,A=>!!A)}coalesce(){return ge.coalesce(this)}static async toPromise(a){const A=[];for await(const S of a)A.push(S);return A}toPromise(){return ge.toPromise(this)}emitOne(a){this._state===0&&(this._results.push(a),this._onStateChanged.fire())}emitMany(a){this._state===0&&(this._results=this._results.concat(a),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(a){this._state===0&&(this._state=2,this._error=a,this._onStateChanged.fire())}}e.AsyncIterableObject=ge;class pe extends ge{constructor(a,A){super(A),this._source=a}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function I(d){const a=new E.CancellationTokenSource,A=d(a.token);return new pe(a,async S=>{const k=a.token.onCancellationRequested(()=>{k.dispose(),a.dispose(),S.reject(new z.CancellationError)});try{for await(const Y of A){if(a.token.isCancellationRequested)return;S.emitOne(Y)}k.dispose(),a.dispose()}catch(Y){k.dispose(),a.dispose(),S.reject(Y)}})}class ${constructor(){this._deferred=new te,this._asyncIterable=new ge(S=>{if(a){S.reject(a);return}return A&&S.emitMany(A),this._errorFn=k=>S.reject(k),this._emitFn=k=>S.emitOne(k),this._deferred.p});let a,A;this._emitFn=S=>{A||(A=[]),A.push(S)},this._errorFn=S=>{a||(a=S)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(a){this._errorFn(a),this._deferred.complete()}emitOne(a){this._emitFn(a)}}e.AsyncIterableSource=$}),define(he[39],de([0,1,53,54,55,16,20,29,4,2,22,5]),function(le,e,E,z,N,L,j,C,u,_,T,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=D,e.readdirSync=R,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=O;var F;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(F||(e.RimRafMode=F={}));async function U(H,J=F.UNLINK,ie){if((0,j.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return J===F.UNLINK?h(H):c(H,ie)}async function c(H,J=(0,j.randomPath)((0,z.tmpdir)())){try{try{await E.promises.rename(H,J)}catch(ie){return ie.code==="ENOENT"?void 0:h(H)}h(J).catch(ie=>{})}catch(ie){if(ie.code!=="ENOENT")throw ie}}async function h(H){return(0,N.promisify)(E.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function D(H){if((0,j.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function m(H,J){return r(await(J?P(H):(0,N.promisify)(E.readdir)(H)))}async function P(H){try{return await(0,N.promisify)(E.readdir)(H,{withFileTypes:!0})}catch(se){console.warn("[node.js fs] readdir with filetypes failed with error: ",se)}const J=[],ie=await m(H);for(const se of ie){let q=!1,w=!1,V=!1;try{const K=await e.Promises.lstat((0,u.join)(H,se));q=K.isFile(),w=K.isDirectory(),V=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}J.push({name:se,isFile:()=>q,isDirectory:()=>w,isSymbolicLink:()=>V})}return J}function R(H){return r(E.readdirSync(H))}function r(H){return H.map(J=>typeof J=="string"?_.isMacintosh?(0,C.normalizeNFC)(J):J:(J.name=_.isMacintosh?(0,C.normalizeNFC)(J.name):J.name,J))}async function i(H){const J=await m(H),ie=[];for(const se of J)await n.existsDirectory((0,u.join)(H,se))&&ie.push(se);return ie}function t(H,J=1e3){return new Promise(ie=>{let se=!1;const q=setInterval(()=>{se||(se=!0,E.access(H,w=>{se=!1,w&&(clearInterval(q),ie(void 0))}))},J)})}var n;(function(H){async function J(q){let w;try{if(w=await e.Promises.lstat(q),!w.isSymbolicLink())return{stat:w}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:w?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&w)return{stat:w,symbolicLink:{dangling:!0}};if(_.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&w)return{stat:w,symbolicLink:{dangling:!0}};throw K}throw V}}H.stat=J;async function ie(q){try{const{stat:w,symbolicLink:V}=await H.stat(q);return w.isFile()&&V?.dangling!==!0}catch{}return!1}H.existsFile=ie;async function se(q){try{const{stat:w,symbolicLink:V}=await H.stat(q);return w.isDirectory()&&V?.dangling!==!0}catch{}return!1}H.existsDirectory=se})(n||(e.SymlinkSupport=n={}));const y=new L.ResourceQueue;function v(H,J,ie){return y.queueFor(B.URI.file(H),()=>{const se=Q(ie);return new Promise((q,w)=>b(H,J,se,V=>V?w(V):q()))},T.extUriBiasedIgnorePathCase)}let g=!0;function o(H){g=H}function b(H,J,ie,se){if(!g)return E.writeFile(H,J,{mode:ie.mode,flag:ie.flag},se);E.open(H,ie.flag,ie.mode,(q,w)=>{if(q)return se(q);E.writeFile(w,J,V=>{if(V)return E.close(w,()=>se(V));E.fdatasync(w,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),o(!1)),E.close(w,ee=>se(ee))))})})}function O(H,J,ie){const se=Q(ie);if(!g)return E.writeFileSync(H,J,{mode:se.mode,flag:se.flag});const q=E.openSync(H,se.flag,se.mode);try{E.writeFileSync(q,J);try{E.fdatasyncSync(q)}catch(w){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",w),o(!1)}}finally{E.closeSync(q)}}function Q(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function p(H,J,ie=6e4){if(H!==J)try{_.isWindows&&typeof ie=="number"?await l(H,J,Date.now(),ie):await(0,N.promisify)(E.rename)(H,J)}catch(se){if(H.toLowerCase()!==J.toLowerCase()&&se.code==="EXDEV"||H.endsWith("."))await s(H,J,{preserveSymlinks:!1}),await U(H,F.MOVE);else throw se}}async function l(H,J,ie,se,q=0){try{return await(0,N.promisify)(E.rename)(H,J)}catch(w){if(w.code!=="EACCES"&&w.code!=="EPERM"&&w.code!=="EBUSY")throw w;if(Date.now()-ie>=se)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${w}`),w;if(q===0){let V=!1;try{const{stat:K}=await n.stat(J);K.isFile()||(V=!0)}catch{}if(V)throw w}return await(0,L.timeout)(Math.min(100,q*10)),l(H,J,ie,se,q+1)}}async function s(H,J,ie){return Z(H,J,{root:{source:H,target:J},options:ie,handledSourcePaths:new Set})}const M=511;async function Z(H,J,ie){if(ie.handledSourcePaths.has(H))return;ie.handledSourcePaths.add(H);const{stat:se,symbolicLink:q}=await n.stat(H);if(q){if(ie.options.preserveSymlinks)try{return await oe(H,J,ie)}catch{}if(q.dangling)return}return se.isDirectory()?re(H,J,se.mode&M,ie):ue(H,J,se.mode&M)}async function re(H,J,ie,se){await e.Promises.mkdir(J,{recursive:!0,mode:ie});const q=await m(H);for(const w of q)await Z((0,u.join)(H,w),(0,u.join)(J,w),se)}async function ue(H,J,ie){await e.Promises.copyFile(H,J),await e.Promises.chmod(J,ie)}async function oe(H,J,ie){let se=await e.Promises.readlink(H);(0,j.isEqualOrParent)(se,ie.root.source,!_.isLinux)&&(se=(0,u.join)(ie.root.target,se.substr(ie.root.source.length+1))),await e.Promises.symlink(se,J)}e.Promises=new class{get access(){return(0,N.promisify)(E.access)}get stat(){return(0,N.promisify)(E.stat)}get lstat(){return(0,N.promisify)(E.lstat)}get utimes(){return(0,N.promisify)(E.utimes)}get read(){return(H,J,ie,se,q)=>new Promise((w,V)=>{E.read(H,J,ie,se,q,(K,ee,te)=>K?V(K):w({bytesRead:ee,buffer:te}))})}get readFile(){return(0,N.promisify)(E.readFile)}get write(){return(H,J,ie,se,q)=>new Promise((w,V)=>{E.write(H,J,ie,se,q,(K,ee,te)=>K?V(K):w({bytesWritten:ee,buffer:te}))})}get appendFile(){return(0,N.promisify)(E.appendFile)}get fdatasync(){return(0,N.promisify)(E.fdatasync)}get truncate(){return(0,N.promisify)(E.truncate)}get copyFile(){return(0,N.promisify)(E.copyFile)}get open(){return(0,N.promisify)(E.open)}get close(){return(0,N.promisify)(E.close)}get symlink(){return(0,N.promisify)(E.symlink)}get readlink(){return(0,N.promisify)(E.readlink)}get chmod(){return(0,N.promisify)(E.chmod)}get mkdir(){return(0,N.promisify)(E.mkdir)}get unlink(){return(0,N.promisify)(E.unlink)}get rmdir(){return(0,N.promisify)(E.rmdir)}get realpath(){return(0,N.promisify)(E.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return i}get writeFile(){return v}get rm(){return U}get rename(){return p}get copy(){return s}}}),define(he[40],de([0,1,4,2,14,21,8,39]),function(le,e,E,z,N,L,j,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=u,e.createQueuedSender=_,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function u(B=N.env){return B.comspec||"cmd.exe"}function _(B){let F=[],U=!1;const c=function(h){if(U){F.push(h);return}(!B.send(h,m=>{if(m&&console.error(m),U=!1,F.length>0){const P=F.slice(0);F=[],P.forEach(R=>c(R))}})||z.isWindows)&&(U=!0)};return{send:c}}var T;(function(B){async function F(U,c,h){if(E.isAbsolute(U))return U;if(c===void 0&&(c=N.cwd()),E.dirname(U)!=="."||(h===void 0&&j.isString(N.env.PATH)&&(h=N.env.PATH.split(E.delimiter)),h===void 0||h.length===0))return E.join(c,U);async function m(P){if(await C.Promises.exists(P)){let R;try{R=await C.Promises.stat(P)}catch(r){r.message.startsWith("EACCES")&&(R=await C.Promises.lstat(P))}return R?!R.isDirectory():!1}return!1}for(const P of h){let R;if(E.isAbsolute(P)?R=E.join(P,U):R=E.join(c,P,U),await m(R))return R;let r=R+".com";if(await m(r)||(r=R+".exe",await m(r)))return r}return E.join(c,U)}B.findExecutable=F})(T||(e.win32=T={}))});var je=this&&this.__decorate||function(le,e,E,z){var N=arguments.length,L=N<3?e:z===null?z=Object.getOwnPropertyDescriptor(e,E):z,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(le,e,E,z);else for(var C=le.length-1;C>=0;C--)(j=le[C])&&(L=(N<3?j(L):N>3?j(e,E,L):j(e,E))||L);return N>3&&L&&Object.defineProperty(e,E,L),L};define(he[41],de([0,1,17,16,10,7,26,3,9,6,37,11,8]),function(le,e,E,z,N,L,j,C,u,_,T,B,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=b,e.getDelayedChannel=M,e.getNextTickChannel=Z;var U;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(U||(U={}));function c(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(h||(h={}));function D(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(m||(m={}));function P(q){let w=0;for(let V=0;;V+=7){const K=q.read(1);if(w|=(K.buffer[0]&127)<<V,!(K.buffer[0]&128))return w}}const R=y(0);function r(q,w){if(w===0){q.write(R);return}let V=0;for(let ee=w;ee!==0;ee=ee>>>7)V++;const K=N.VSBuffer.alloc(V);for(let ee=0;w!==0;ee++)K.buffer[ee]=w&127,w=w>>>7,w>0&&(K.buffer[ee]|=128);q.write(K)}class i{constructor(w){this.buffer=w,this.pos=0}read(w){const V=this.buffer.slice(this.pos,this.pos+w);return this.pos+=V.byteLength,V}}e.BufferReader=i;class t{constructor(){this.buffers=[]}get buffer(){return N.VSBuffer.concat(this.buffers)}write(w){this.buffers.push(w)}}e.BufferWriter=t;var n;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(n||(n={}));function y(q){const w=N.VSBuffer.alloc(1);return w.writeUInt8(q,0),w}const v={Undefined:y(n.Undefined),String:y(n.String),Buffer:y(n.Buffer),VSBuffer:y(n.VSBuffer),Array:y(n.Array),Object:y(n.Object),Uint:y(n.Int)},g=typeof Buffer<"u";function o(q,w){if(typeof w>"u")q.write(v.Undefined);else if(typeof w=="string"){const V=N.VSBuffer.fromString(w);q.write(v.String),r(q,V.byteLength),q.write(V)}else if(g&&Buffer.isBuffer(w)){const V=N.VSBuffer.wrap(w);q.write(v.Buffer),r(q,V.byteLength),q.write(V)}else if(w instanceof N.VSBuffer)q.write(v.VSBuffer),r(q,w.byteLength),q.write(w);else if(Array.isArray(w)){q.write(v.Array),r(q,w.length);for(const V of w)o(q,V)}else if(typeof w=="number"&&(w|0)===w)q.write(v.Uint),r(q,w);else{const V=N.VSBuffer.fromString(JSON.stringify(w));q.write(v.Object),r(q,V.byteLength),q.write(V)}}function b(q){switch(q.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return q.read(P(q)).toString();case n.Buffer:return q.read(P(q)).buffer;case n.VSBuffer:return q.read(P(q));case n.Array:{const V=P(q),K=[];for(let ee=0;ee<V;ee++)K.push(b(q));return K}case n.Object:return JSON.parse(q.read(P(q)).toString());case n.Int:return P(q)}}class O{constructor(w,V,K=null,ee=1e3){this.protocol=w,this.ctx=V,this.logger=K,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel(w,V){this.channels.set(w,V),setTimeout(()=>this.flushPendingRequests(w),0)}sendResponse(w){switch(w.type){case 200:{const V=this.send([w.type]);this.logger?.logOutgoing(V,0,1,D(w.type));return}case 201:case 202:case 204:case 203:{const V=this.send([w.type,w.id],w.data);this.logger?.logOutgoing(V,w.id,1,D(w.type),w.data);return}}}send(w,V=void 0){const K=new t;return o(K,w),o(K,V),this.sendBuffer(K.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch{return 0}}onRawMessage(w){const V=new i(w),K=b(V),ee=b(V),te=K[0];switch(te){case 100:return this.logger?.logIncoming(w.byteLength,K[1],1,`${c(te)}: ${K[2]}.${K[3]}`,ee),this.onPromise({type:te,id:K[1],channelName:K[2],name:K[3],arg:ee});case 102:return this.logger?.logIncoming(w.byteLength,K[1],1,`${c(te)}: ${K[2]}.${K[3]}`,ee),this.onEventListen({type:te,id:K[1],channelName:K[2],name:K[3],arg:ee});case 101:return this.logger?.logIncoming(w.byteLength,K[1],1,`${c(te)}`),this.disposeActiveRequest({type:te,id:K[1]});case 103:return this.logger?.logIncoming(w.byteLength,K[1],1,`${c(te)}`),this.disposeActiveRequest({type:te,id:K[1]})}}onPromise(w){const V=this.channels.get(w.channelName);if(!V){this.collectPendingRequest(w);return}const K=new L.CancellationTokenSource;let ee;try{ee=V.call(this.ctx,w.name,w.arg,K.token)}catch(fe){ee=Promise.reject(fe)}const te=w.id;ee.then(fe=>{this.sendResponse({id:te,data:fe,type:201})},fe=>{fe instanceof Error?this.sendResponse({id:te,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:te,data:fe,type:203})}).finally(()=>{me.dispose(),this.activeRequests.delete(w.id)});const me=(0,_.toDisposable)(()=>K.cancel());this.activeRequests.set(w.id,me)}onEventListen(w){const V=this.channels.get(w.channelName);if(!V){this.collectPendingRequest(w);return}const K=w.id,te=V.listen(this.ctx,w.name,w.arg)(me=>this.sendResponse({id:K,data:me,type:204}));this.activeRequests.set(w.id,te)}disposeActiveRequest(w){const V=this.activeRequests.get(w.id);V&&(V.dispose(),this.activeRequests.delete(w.id))}collectPendingRequest(w){let V=this.pendingRequests.get(w.channelName);V||(V=[],this.pendingRequests.set(w.channelName,V));const K=setTimeout(()=>{console.error(`Unknown channel: ${w.channelName}`),w.type===100&&this.sendResponse({id:w.id,data:{name:"Unknown channel",message:`Channel name '${w.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:w,timeoutTimer:K})}flushPendingRequests(w){const V=this.pendingRequests.get(w);if(V){for(const K of V)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(w)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,_.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=O;var Q;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(Q||(e.RequestInitiator=Q={}));class p{constructor(w,V=null){this.protocol=w,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=V}getChannel(w){const V=this;return{call(K,ee,te){return V.isDisposed?Promise.reject(new C.CancellationError):V.requestPromise(w,K,ee,te)},listen(K,ee){return V.isDisposed?u.Event.None:V.requestEvent(w,K,ee)}}}requestPromise(w,V,K,ee=L.CancellationToken.None){const te=this.lastRequestId++,fe={id:te,type:100,channelName:w,name:V,arg:K};if(ee.isCancellationRequested)return Promise.reject(new C.CancellationError);let we;return new Promise((ge,pe)=>{if(ee.isCancellationRequested)return pe(new C.CancellationError);const I=()=>{const A=S=>{switch(S.type){case 201:this.handlers.delete(te),ge(S.data);break;case 202:{this.handlers.delete(te);const k=new Error(S.data.message);k.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,k.name=S.data.name,pe(k);break}case 203:this.handlers.delete(te),pe(S.data);break}};this.handlers.set(te,A),this.sendRequest(fe)};let $=null;this.state===m.Idle?I():($=(0,z.createCancelablePromise)(A=>this.whenInitialized()),$.then(()=>{$=null,I()}));const d=()=>{$?($.cancel(),$=null):this.sendRequest({id:te,type:101}),pe(new C.CancellationError)},a=ee.onCancellationRequested(d);we=(0,_.combinedDisposable)((0,_.toDisposable)(d),a),this.activeRequests.add(we)}).finally(()=>{we.dispose(),this.activeRequests.delete(we)})}requestEvent(w,V,K){const ee=this.lastRequestId++,me={id:ee,type:102,channelName:w,name:V,arg:K};let fe=null;const we=new u.Emitter({onWillAddFirstListener:()=>{fe=(0,z.createCancelablePromise)(ge=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(we),this.sendRequest(me)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(we),this.sendRequest({id:ee,type:103}))}}),ye=ge=>we.fire(ge.data);return this.handlers.set(ee,ye),we.event}sendRequest(w){switch(w.type){case 100:case 102:{const V=this.send([w.type,w.id,w.channelName,w.name],w.arg);this.logger?.logOutgoing(V,w.id,0,`${c(w.type)}: ${w.channelName}.${w.name}`,w.arg);return}case 101:case 103:{const V=this.send([w.type,w.id]);this.logger?.logOutgoing(V,w.id,0,c(w.type));return}}}send(w,V=void 0){const K=new t;return o(K,w),o(K,V),this.sendBuffer(K.buffer)}sendBuffer(w){try{return this.protocol.send(w),w.byteLength}catch{return 0}}onBuffer(w){const V=new i(w),K=b(V),ee=b(V),te=K[0];switch(te){case 200:return this.logger?.logIncoming(w.byteLength,0,0,D(te)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(w.byteLength,K[1],0,D(te),ee),this.onResponse({type:K[0],id:K[1],data:ee})}}onResponse(w){if(w.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(w.id)?.(w)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,_.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=p,je([j.memoize],p.prototype,"onDidInitializePromise",null);class l{get connections(){const w=[];return this._connections.forEach(V=>w.push(V)),w}constructor(w,V,K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new _.DisposableStore,this.disposables.add(w(({protocol:ee,onDidClientDisconnect:te})=>{const me=u.Event.once(ee.onMessage);this.disposables.add(me(fe=>{const we=new i(fe),ye=b(we),ge=new O(ee,ye,V,K),pe=new p(ee,V);this.channels.forEach(($,d)=>ge.registerChannel(d,$));const I={channelServer:ge,channelClient:pe,ctx:ye};this._connections.add(I),this._onDidAddConnection.fire(I),this.disposables.add(te(()=>{ge.dispose(),pe.dispose(),this._connections.delete(I),this._onDidRemoveConnection.fire(I)}))}))}))}getChannel(w,V){const K=this;return{call(ee,te,me){let fe;if((0,F.isFunction)(V)){const ye=(0,E.getRandomElement)(K.connections.filter(V));fe=ye?Promise.resolve(ye):u.Event.toPromise(u.Event.filter(K.onDidAddConnection,V))}else fe=V.routeCall(K,ee,te);const we=fe.then(ye=>ye.channelClient.getChannel(w));return M(we).call(ee,te,me)},listen(ee,te){if((0,F.isFunction)(V))return K.getMulticastEvent(w,V,ee,te);const me=V.routeEvent(K,ee,te).then(fe=>fe.channelClient.getChannel(w));return M(me).listen(ee,te)}}}getMulticastEvent(w,V,K,ee){const te=this;let me;const fe=new u.Emitter({onWillAddFirstListener:()=>{me=new _.DisposableStore;const we=new u.EventMultiplexer,ye=new Map,ge=I=>{const d=I.channelClient.getChannel(w).listen(K,ee),a=we.add(d);ye.set(I,a)},pe=I=>{const $=ye.get(I);$&&($.dispose(),ye.delete(I))};te.connections.filter(V).forEach(ge),u.Event.filter(te.onDidAddConnection,V)(ge,void 0,me),te.onDidRemoveConnection(pe,void 0,me),we.event(fe.fire,fe,me),me.add(we)},onDidRemoveLastListener:()=>{me?.dispose(),me=void 0}});return fe.event}registerChannel(w,V){this.channels.set(w,V);for(const K of this._connections)K.channelServer.registerChannel(w,V)}dispose(){this.disposables.dispose();for(const w of this._connections)w.channelClient.dispose(),w.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class s{constructor(w,V,K=null){const ee=new t;o(ee,V),w.send(ee.buffer),this.channelClient=new p(w,K),this.channelServer=new O(w,V,K)}getChannel(w){return this.channelClient.getChannel(w)}registerChannel(w,V){this.channelServer.registerChannel(w,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=s;function M(q){return{call(w,V,K){return q.then(ee=>ee.call(w,V,K))},listen(w,V){const K=new u.Relay;return q.then(ee=>K.input=ee.listen(w,V)),K.event}}}function Z(q){let w=!1;return{call(V,K,ee){return w?q.call(V,K,ee):(0,z.timeout)(0).then(()=>w=!0).then(()=>q.call(V,K,ee))},listen(V,K){if(w)return q.listen(V,K);const ee=new u.Relay;return(0,z.timeout)(0).then(()=>w=!0).then(()=>ee.input=q.listen(V,K)),ee.event}}}class re{constructor(w){this.fn=w}routeCall(w){return this.route(w)}routeEvent(w){return this.route(w)}async route(w){for(const V of w.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await u.Event.toPromise(w.onDidAddConnection),await this.route(w)}}e.StaticRouter=re;var ue;(function(q){function w(te,me,fe){const we=te,ye=fe&&fe.disableMarshalling,ge=new Map;for(const pe in we)K(pe)&&ge.set(pe,u.Event.buffer(we[pe],!0,void 0,me));return new class{listen(pe,I,$){const d=ge.get(I);if(d)return d;const a=we[I];if(typeof a=="function"){if(ee(I))return a.call(we,$);if(K(I))return ge.set(I,u.Event.buffer(we[I],!0,void 0,me)),ge.get(I)}throw new C.ErrorNoTelemetry(`Event not found: ${I}`)}call(pe,I,$){const d=we[I];if(typeof d=="function"){if(!ye&&Array.isArray($))for(let A=0;A<$.length;A++)$[A]=(0,T.revive)($[A]);let a=d.apply(we,$);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new C.ErrorNoTelemetry(`Method not found: ${I}`)}}}q.fromService=w;function V(te,me){const fe=me&&me.disableMarshalling;return new Proxy({},{get(we,ye){if(typeof ye=="string")return me?.properties?.has(ye)?me.properties.get(ye):ee(ye)?function(ge){return te.listen(ye,ge)}:K(ye)?te.listen(ye):async function(...ge){let pe;me&&!(0,F.isUndefinedOrNull)(me.context)?pe=[me.context,...ge]:pe=ge;const I=await te.call(ye,pe);return fe?I:(0,T.revive)(I)};throw new C.ErrorNoTelemetry(`Property not found: ${String(ye)}`)}})}q.toService=V;function K(te){return te[0]==="o"&&te[1]==="n"&&B.isUpperAsciiLetter(te.charCodeAt(2))}function ee(te){return/^onDynamic/.test(te)&&B.isUpperAsciiLetter(te.charCodeAt(9))}})(ue||(e.ProxyChannel=ue={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const w=q.toString();if(w!=="[object Object]")return w}return q}function J(q){return Array.isArray(q)?q.map(H):H(q)}function ie(q,w,V,K,ee,te,me){me=J(me);const fe=oe[ee],we=fe[K%fe.length];let ye=[`%c[${q}]%c[${String(w).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(te)?(ye=ye.concat(me),ye.push(")")):ye.push(me),console.log.apply(console,ye)}class se{constructor(w,V){this._outgoingPrefix=w,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(w,V,K,ee,te){this._totalOutgoing+=w,ie(this._outgoingPrefix,this._totalOutgoing,w,V,K,ee,te)}logIncoming(w,V,K,ee,te){this._totalIncoming+=w,ie(this._incomingPrefix,this._totalIncoming,w,V,K,ee,te)}}e.IPCLogger=se}),define(he[42],de([0,1,56,16,10,7,36,3,9,6,13,40,21,41]),function(le,e,E,z,N,L,j,C,u,_,T,B,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends U.ChannelServer{constructor(m){super({send:P=>{try{process.send?.(P.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",P=>N.VSBuffer.wrap(Buffer.from(P,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=c;class h{constructor(m,P){this.modulePath=m,this.options=P,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const R=P&&P.timeout?P.timeout:6e4;this.disposeDelayer=new z.Delayer(R),this.child=null,this._client=null}getChannel(m){const P=this;return{call(R,r,i){return P.requestPromise(m,R,r,i)},listen(R,r){return P.requestEvent(m,R,r)}}}requestPromise(m,P,R,r=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(m),t=(0,z.createCancelablePromise)(v=>i.call(P,R,v)),n=r.onCancellationRequested(()=>t.cancel()),y=(0,_.toDisposable)(()=>t.cancel());return this.activeRequests.add(y),t.finally(()=>{n.dispose(),this.activeRequests.delete(y),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(m,P,R){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let r;const i=new u.Emitter({onWillAddFirstListener:()=>{r=this.getCachedChannel(m).listen(P,R)(i.fire,i),this.activeRequests.add(r)},onDidRemoveLastListener:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],P=Object.create(null);P.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(P.env={...P.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(P.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(P.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(P.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),P.execArgv===void 0&&(P.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,F.removeDangerousEnvVariables)(P.env),this.child=(0,E.fork)(this.modulePath,m,P);const R=new u.Emitter,i=u.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,j.isRemoteConsoleLog)(o)){(0,j.log)(o,`IPC Library: ${this.options.serverName}`);return}R.fire(N.VSBuffer.wrap(Buffer.from(o,"base64")))}),t=this.options.useQueue?(0,B.createQueuedSender)(this.child):this.child,n=o=>this.child&&this.child.connected&&t.send(o.buffer.toString("base64")),y=R.event,v={send:n,onMessage:y};this._client=new U.ChannelClient(v);const g=()=>this.disposeClient();process.once("exit",g),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,b)=>{process.removeListener("exit",g),i.dispose(),this.activeRequests.forEach(O=>(0,_.dispose)(O)),this.activeRequests.clear(),o!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+b),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:b})})}return this._client}getCachedChannel(m){let P=this.channels.get(m);return P||(P=this.client.getChannel(m),this.channels.set(m,P)),P}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(he[43],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=N,e.refineServiceDecorator=L;var E;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function C(u){return u[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=C})(E||(e._util=E={})),e.IInstantiationService=N("instantiationService");function z(j,C,u){C[E.DI_TARGET]===C?C[E.DI_DEPENDENCIES].push({id:j,index:u}):(C[E.DI_DEPENDENCIES]=[{id:j,index:u}],C[E.DI_TARGET]=C)}function N(j){if(E.serviceIds.has(j))return E.serviceIds.get(j);const C=function(u,_,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");z(C,u,T)};return C.toString=()=>j,E.serviceIds.set(j,C),C}function L(j){return j}}),define(he[44],de([0,1,15]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=z,e.getRemoteName=N,e.parseAuthorityWithPort=L,e.parseAuthorityWithOptionalPort=j;function z(u){return u.scheme===E.Schemas.vscodeRemote?u.authority:void 0}function N(u){if(!u)return;const _=u.indexOf("+");return _<0?u:u.substr(0,_)}function L(u){const{host:_,port:T}=C(u);if(typeof T>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:_,port:T}}function j(u,_){let{host:T,port:B}=C(u);return typeof B>"u"&&(B=_),{host:T,port:B}}function C(u){const _=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(_)return{host:_[1],port:parseInt(_[2],10)};const T=u.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const B=u.match(/(.*):(\d+)$/);return B?{host:B[1],port:parseInt(B[2],10)}:{host:u,port:void 0}}}),define(he[45],de([0,1,2,14,34]),function(le,e,E,z,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=j,e.verifyMicrosoftInternalDomain=C;function L(u){if(E.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,_,T,B,F,U,c,h,D){const m=Object.create(null);m["common.machineId"]=U,m["common.sqmId"]=c,m.sessionID=(0,N.generateUuid)()+Date.now(),m.commitHash=B,m.version=F,m["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,E.PlatformToString)(E.platform),m["common.nodePlatform"]=z.platform,m["common.nodeArch"]=T,m["common.product"]=D||"desktop",h&&(m["common.msftInternal"]=h);let P=0;const R=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),E.isLinuxSnap&&(m["common.snap"]="true");const r=L(_);return r&&(m["common.platformDetail"]=r),m}function C(u){const _=z.env.USERDNSDOMAIN;if(!_)return!1;const T=_.toLowerCase();return u.some(B=>T===B)}}),define(he[46],de([0,1,43]),function(le,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var z;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(z||(e.TelemetryLevel=z={}));var N;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(he[47],de([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(L){this.appenders=L}listen(L,j){throw new Error(`Event not found: ${j}`)}call(L,j,{eventName:C,data:u}){return this.appenders.forEach(_=>_.log(C,u)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class z{constructor(L){this.channel=L}log(L,j){return this.channel.call("log",{eventName:L,data:j}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=z}),define(he[48],de([0,1,13,8,44,45,46]),function(le,e,E,z,N,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=T,e.isLoggingOnly=B,e.getTelemetryLevel=F,e.validateTelemetryData=U,e.cleanRemoteAuthority=h,e.isInternalTelemetry=m,e.getPiiPathsFromEnvironment=P,e.cleanData=i;class C{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=C;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class _{async publicLog(n,y,v){}async publicLogError(n,y,v){}}e.NullEndpointTelemetryService=_,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}function B(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function F(t){const n=t.getValue(j.TELEMETRY_SETTING_ID),y=t.getValue(j.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(j.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function U(t){const n={},y={},v={};D(t,v);for(let g in v){g=g.length>150?g.substr(g.length-149):g;const o=v[g];typeof o=="number"?y[g]=o:typeof o=="boolean"?y[g]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${o.length}`),n[g]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[g]=o)}return{properties:n,measurements:y}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const n=(0,N.getRemoteName)(t);return c.has(n)?n:"other"}function D(t,n,y=0,v){if(t)for(const g of Object.getOwnPropertyNames(t)){const o=t[g],b=v?v+g:g;Array.isArray(o)?n[b]=(0,E.safeStringify)(o):o instanceof Date?n[b]=o.toISOString():(0,z.isObject)(o)?y<2?D(o,n,y+1,b+"."):n[b]=(0,E.safeStringify)(o):n[b]=o}}function m(t,n){const y=t.msftInternalDomains||[],v=n.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(y)||v}function P(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function R(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let y=t;const v=[];for(const O of n)for(;;){const Q=O.exec(t);if(!Q)break;v.push([Q.index,O.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(y="";;){const O=o.exec(t);if(!O)break;const Q=v.some(([p,l])=>O.index<l&&p<o.lastIndex);!g.test(O[0])&&!Q&&(y+=t.substring(b,O.index)+"<REDACTED: user-file-path>",b=o.lastIndex)}return b<t.length&&(y+=t.substr(b)),y}function r(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const y of n)if(y.regex.test(t))return`<REDACTED: ${y.label}>`;return t}function i(t,n){return(0,E.cloneAndChange)(t,y=>{if(y instanceof C||Object.hasOwnProperty.call(y,"isTrustedTelemetryValue"))return y.value;if(typeof y=="string"){let v=y.replaceAll("%20"," ");v=R(v,n);for(const g of n)v=v.replace(g,"");return v=r(v),v}})}}),define(he[49],de([0,1,38,3,13,48]),function(le,e,E,z,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const j="https://0.0.0.0/OneCollector/1.0",C="https://0.0.0.0/ping";async function u(T,B,F){const U=await(0,E.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,E.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),h=new U.AppInsightsCore,D=new c.PostChannel,m={instrumentationKey:T,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[D]]};if(F){m.extensionConfig={};const P={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:F};m.extensionConfig[D.identifier]=P}return h.initialize(m,[]),h.addTelemetryInitializer(P=>{P.ext=P.ext??{},P.ext.web=P.ext.web??{},P.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',B&&(P.ext.utc=P.ext.utc??{},P.ext.utc.flags=8462029)}),h}class _{constructor(B,F,U,c,h){this._isInternalTelemetry=B,this._eventPrefix=F,this._defaultData=U,this._xhrOverride=h,this.endPointUrl=j,this.endPointHealthUrl=C,this._defaultData||(this._defaultData={}),typeof c=="function"?this._aiCoreOrKey=c():this._aiCoreOrKey=c,this._asyncAiCore=null}_withAIClient(B){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){B(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=u(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(F=>{B(F)},F=>{(0,z.onUnexpectedError)(F),console.error(F)})}}log(B,F){if(!this._aiCoreOrKey)return;F=(0,N.mixin)(F,this._defaultData),F=(0,L.validateTelemetryData)(F);const U=this._eventPrefix+"/"+B;try{this._withAIClient(c=>{c.pluginVersionString=F?.properties.version??"Unknown",c.track({name:U,baseData:{name:U,properties:F?.properties,measurements:F?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(B=>{this._withAIClient(F=>{F.unload(!0,()=>{this._aiCoreOrKey=void 0,B(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=_}),define(he[50],de([0,1,10,7,57,49]),function(le,e,E,z,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function j(T,B){const F=await B.request(T,z.CancellationToken.None),U=(await(0,E.streamToBuffer)(F.stream)).toString(),c=F.res.statusCode??200;return{headers:F.res.headers,statusCode:c,responseData:U}}async function C(T){const B={method:T.type,headers:T.headers};return new Promise((U,c)=>{const h=N.request(T.url??"",B,D=>{D.on("data",function(m){U({headers:D.headers,statusCode:D.statusCode??200,responseData:m.toString()})}),D.on("error",function(m){c(m)})});h.write(T.data,D=>{D&&c(D)}),h.end()})}async function u(T,B,F){const U=typeof B.data=="string"?B.data:new TextDecoder().decode(B.data),c={type:"POST",headers:{...B.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(B.data).toString()},url:B.urlString,data:U};try{const h=T?await j(c,T):await C(c);F(h.statusCode,h.headers,h.responseData)}catch{F(0,{})}}class _ extends L.AbstractOneDataSystemAppender{constructor(B,F,U,c,h){const D={sendPOST:(m,P)=>{u(B,m,P)}};super(F,U,c,h,D)}}e.OneDataSystemAppender=_}),define(he[58],de([0,1,42,47,50]),function(le,e,E,z,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});const L=new N.OneDataSystemAppender(void 0,!1,process.argv[2],JSON.parse(process.argv[3]),process.argv[4]);process.once("exit",()=>L.flush());const j=new z.TelemetryAppenderChannel([L]);new E.Server("telemetry").registerChannel("telemetryAppender",j)})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/workbench/contrib/debug/node/telemetryApp.js.map
