/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var j=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(F){for(var e=[],P=0,E=F.length;P<E;P++)e[P]=j[F[P]];return e};define(j[24],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class P{static get(){const S=new Map,p=new Map,s=new Map,d=new Map;function i(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function l(u,n){const t=u.get(n.detail);t&&(t>=0||u.set(n.detail,t+n.timestamp))}let v=[];typeof F=="function"&&typeof F.getStats=="function"&&(v=F.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of v)switch(u.type){case 10:i(S,u);break;case 11:case 12:l(S,u);break;case 21:i(p,u);break;case 22:l(p,u);break;case 33:i(s,u);break;case 34:l(s,u);break;case 31:i(d,u);break;case 32:l(d,u);break}let h=0;s.forEach(u=>h+=u);function b(u){const n=[];return u.forEach((t,r)=>n.push([r,t])),n}return{amdLoad:b(S),amdInvoke:b(p),nodeRequire:b(s),nodeEval:b(d),nodeRequireTotal:h}}static toMarkdownTable(S,p){let s="";const d=[];return S.forEach((i,l)=>{d[l]=i.length}),p.forEach(i=>{i.forEach((l,v)=>{typeof l>"u"&&(l=i[v]="-");const h=l.toString().length;d[v]=Math.max(h,d[v])})}),S.forEach((i,l)=>{s+=`| ${i+" ".repeat(d[l]-i.toString().length)} `}),s+=`|
`,S.forEach((i,l)=>{s+=`| ${"-".repeat(d[l])} `}),s+=`|
`,p.forEach(i=>{i.forEach((l,v)=>{typeof l<"u"&&(s+=`| ${l+" ".repeat(d[v]-l.toString().length)} `)}),s+=`|
`}),s}}e.LoaderStats=P}),define(j[4],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugNameData=void 0,e.getDebugName=p,e.getFunctionName=b;class P{constructor(n,t,r){this.owner=n,this.debugNameSource=t,this.referenceFn=r}getDebugName(n){return p(n,this)}}e.DebugNameData=P;const E=new Map,S=new WeakMap;function p(u,n){const t=S.get(u);if(t)return t;const r=s(u,n);if(r){let c=E.get(r)??0;c++,E.set(r,c);const w=c===1?r:`${r}#${c}`;return S.set(u,w),w}}function s(u,n){const t=S.get(u);if(t)return t;const r=n.owner?v(n.owner)+".":"";let c;const w=n.debugNameSource;if(w!==void 0)if(typeof w=="function"){if(c=w(),c!==void 0)return r+c}else return r+w;const I=n.referenceFn;if(I!==void 0&&(c=b(I),c!==void 0))return r+c;if(n.owner!==void 0){const C=d(n.owner,u);if(C!==void 0)return r+C}}function d(u,n){for(const t in u)if(u[t]===n)return t}const i=new Map,l=new WeakMap;function v(u){const n=l.get(u);if(n)return n;const t=h(u);let r=i.get(t)??0;r++,i.set(t,r);const c=r===1?t:`${t}#${r}`;return l.set(u,c),c}function h(u){const n=u.constructor;return n?n.name:"Object"}function b(u){const n=u.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(r?r[1]:void 0)?.trim()}}),define(j[5],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=void 0,e.setLogger=E,e.getLogger=S;let P;function E(t){P=t}function S(){return P}class p{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return s([d(u("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[d(" "),l(v(r.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),l(v(r.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),l(v(r.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(r,c){console.log(...this.textToConsoleArgs([i("observable value changed"),l(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c)]))}formatChanges(r){if(r.size!==0)return l(" (changed deps: "+[...r].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const c=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(w,I)=>(this.changedObservablesSets.get(r).add(w),c.apply(r,[w,I]))}handleDerivedRecomputed(r,c){const w=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([i("derived recomputed"),l(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c),this.formatChanges(w),{data:[{fn:r._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(r,c){console.log(...this.textToConsoleArgs([i("observable from event triggered"),l(r.debugName,{color:"BlueViolet"}),...this.formatInfo(c),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const c=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(w,I)=>(this.changedObservablesSets.get(r).add(w),c.apply(r,[w,I]))}handleAutorunTriggered(r){const c=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([i("autorun"),l(r.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:r._runFn}]}])),c.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let c=r.getDebugName();c===void 0&&(c=""),console.log(...this.textToConsoleArgs([i("transaction"),l(c,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}e.ConsoleObservableLogger=p;function s(t){const r=new Array,c=[];let w="";function I(y){if("length"in y)for(const o of y)o&&I(o);else"text"in y?(w+=`%c${y.text}`,r.push(y.style),y.data&&c.push(...y.data)):"data"in y&&c.push(...y.data)}I(t);const C=[w,...r];return C.push(...c),C}function d(t){return l(t,{color:"black"})}function i(t){return l(n(`${t}: `,10),{color:"black",bold:!0})}function l(t,r={color:"black"}){function c(I){return Object.entries(I).reduce((C,[y,o])=>`${C}${y}:${o};`,"")}const w={color:r.color};return r.strikeThrough&&(w["text-decoration"]="line-through"),r.bold&&(w["font-weight"]="bold"),{text:t,style:c(w)}}function v(t,r){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=r?`"${t}"`:`"${t.substr(0,r-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?h(t,r):b(t,r);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function h(t,r){let c="[ ",w=!0;for(const I of t){if(w||(c+=", "),c.length-5>r){c+="...";break}w=!1,c+=`${v(I,r-c.length)}`}return c+=" ]",c}function b(t,r){let c="{ ",w=!0;for(const[I,C]of Object.entries(t)){if(w||(c+=", "),c.length-5>r){c+="...";break}w=!1,c+=`${I}: ${v(C,r-c.length)}`}return c+=" }",c}function u(t,r){let c="";for(let w=1;w<=r;w++)c+=t;return c}function n(t,r){for(;t.length<r;)t+=" ";return t}}),define(j[7],K([0,1,25,2,4,5]),function(F,e,P,E,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutorunObserver=void 0,e.autorun=s,e.autorunOpts=d,e.autorunHandleChanges=i,e.autorunWithStoreHandleChanges=l,e.autorunWithStore=v,e.autorunDelta=h;function s(n){return new u(new S.DebugNameData(void 0,void 0,n),n,void 0,void 0)}function d(n,t){return new u(new S.DebugNameData(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}function i(n,t){return new u(new S.DebugNameData(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}function l(n,t){const r=new E.DisposableStore,c=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(w,I)=>{r.clear(),t(w,I,r)});return(0,E.toDisposable)(()=>{c.dispose(),r.dispose()})}function v(n){const t=new E.DisposableStore,r=d({owner:void 0,debugName:void 0,debugReferenceFn:n},c=>{t.clear(),n(c,t)});return(0,E.toDisposable)(()=>{r.dispose(),t.dispose()})}function h(n,t){let r;return d({debugReferenceFn:t},c=>{const w=n.read(c),I=r;r=w,t({lastValue:I,newValue:w})})}var b;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(b||(b={}));class u{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(t,r,c,w){this._debugNameData=t,this._runFn=r,this.createChangeSummary=c,this._handleChange=w,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,p.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,E.trackDisposable)(this)}dispose(){this.disposed=!0;for(const t of this.dependencies)t.removeObserver(this);this.dependencies.clear(),(0,E.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const t=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=t,this.state=3;const r=this.disposed;try{if(!r){(0,p.getLogger)()?.handleAutorunTriggered(this);const c=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,c)}}finally{r||(0,p.getLogger)()?.handleAutorunFinished(this);for(const c of this.dependenciesToBeRemoved)c.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const t of this.dependencies)if(t.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,P.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(t){this.state===3&&this.dependencies.has(t)&&!this.dependenciesToBeRemoved.has(t)&&(this.state=1)}handleChange(t,r){this.dependencies.has(t)&&!this.dependenciesToBeRemoved.has(t)&&(!this._handleChange||this._handleChange({changedObservable:t,change:r,didChange:w=>w===t},this.changeSummary))&&(this.state=2)}readObservable(t){if(this.disposed)return t.get();t.addObserver(this);const r=t.get();return this.dependencies.add(t),this.dependenciesToBeRemoved.delete(t),r}}e.AutorunObserver=u,function(n){n.Observer=u}(s||(e.autorun=s={}))}),define(j[6],K([0,1,4,5]),function(F,e,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.ObservableValue=e.TransactionImpl=e.BaseObservable=e.ConvenientObservable=void 0,e._setRecomputeInitiallyAndOnChange=p,e._setKeepObserved=d,e._setDerivedOpts=l,e.transaction=b,e.globalTransaction=n,e.asyncTransaction=t,e.subtransaction=r,e.observableValue=w,e.disposableObservableValue=C;let S;function p(o){S=o}let s;function d(o){s=o}let i;function l(o){i=o}class v{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,_){const z=_===void 0?void 0:m,W=_===void 0?m:_;return i({owner:z,debugName:()=>{const f=(0,P.getFunctionName)(W);if(f!==void 0)return f;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(W.toString());if(R)return`${this.debugName}.${R[2]}`;if(!z)return`${this.debugName} (mapped)`}},f=>W(this.read(f),f))}recomputeInitiallyAndOnChange(m,_){return m.add(S(this,_)),this}keepObserved(m){return m.add(s(this)),this}}e.ConvenientObservable=v;class h extends v{constructor(){super(...arguments),this.observers=new Set}addObserver(m){const _=this.observers.size;this.observers.add(m),_===0&&this.onFirstObserverAdded()}removeObserver(m){this.observers.delete(m)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}e.BaseObservable=h;function b(o,m){const _=new c(o,m);try{o(_)}finally{_.finish()}}let u;function n(o){if(u)o(u);else{const m=new c(o,void 0);u=m;try{o(m)}finally{m.finish(),u=void 0}}}async function t(o,m){const _=new c(o,m);try{await o(_)}finally{_.finish()}}function r(o,m,_){o?m(o):b(m,_)}class c{constructor(m,_){this._fn=m,this._getDebugName=_,this.updatingObservers=[],(0,E.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,P.getFunctionName)(this._fn)}updateObserver(m,_){this.updatingObservers.push({observer:m,observable:_}),m.beginUpdate(_)}finish(){const m=this.updatingObservers;for(let _=0;_<m.length;_++){const{observer:z,observable:W}=m[_];z.endUpdate(W)}this.updatingObservers=null,(0,E.getLogger)()?.handleEndTransaction()}}e.TransactionImpl=c;function w(o,m){return typeof o=="string"?new I(void 0,o,m):new I(o,void 0,m)}class I extends h{get debugName(){return new P.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"ObservableValue"}constructor(m,_,z){super(),this._owner=m,this._debugName=_,this._value=z}get(){return this._value}set(m,_,z){if(this._value===m)return;let W;_||(_=W=new c(()=>{},()=>`Setting ${this.debugName}`));try{const f=this._value;this._setValue(m),(0,E.getLogger)()?.handleObservableChanged(this,{oldValue:f,newValue:m,change:z,didChange:!0,hadValue:!0});for(const k of this.observers)_.updateObserver(k,this),k.handleChange(this,z)}finally{W&&W.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(m){this._value=m}}e.ObservableValue=I;function C(o,m){return typeof o=="string"?new y(void 0,o,m):new y(o,void 0,m)}class y extends I{_setValue(m){this._value!==m&&(this._value&&this._value.dispose(),this._value=m)}dispose(){this._value?.dispose()}}e.DisposableObservableValue=y}),define(j[8],K([0,1,25,2,6,4,5]),function(F,e,P,E,S,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.defaultEqualityComparer=void 0,e.derived=i,e.derivedOpts=l,e.derivedHandleChanges=v,e.derivedWithStore=h,e.derivedDisposable=b;const d=(t,r)=>t===r;e.defaultEqualityComparer=d;function i(t,r){return r!==void 0?new n(new p.DebugNameData(t,void 0,r),r,void 0,void 0,void 0,e.defaultEqualityComparer):new n(new p.DebugNameData(void 0,void 0,t),t,void 0,void 0,void 0,e.defaultEqualityComparer)}function l(t,r){return new n(new p.DebugNameData(t.owner,t.debugName,t.debugReferenceFn),r,void 0,void 0,t.onLastObserverRemoved,t.equalityComparer??e.defaultEqualityComparer)}(0,S._setDerivedOpts)(l);function v(t,r){return new n(new p.DebugNameData(t.owner,t.debugName,void 0),r,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??e.defaultEqualityComparer)}function h(t,r){let c,w;r===void 0?(c=t,w=void 0):(w=t,c=r);const I=new E.DisposableStore;return new n(new p.DebugNameData(w,void 0,c),C=>(I.clear(),c(C,I)),void 0,void 0,()=>I.dispose(),e.defaultEqualityComparer)}function b(t,r){let c,w;r===void 0?(c=t,w=void 0):(w=t,c=r);const I=new E.DisposableStore;return new n(new p.DebugNameData(w,void 0,c),C=>{I.clear();const y=c(C);return y&&I.add(y),y},void 0,void 0,()=>I.dispose(),e.defaultEqualityComparer)}var u;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(u||(u={}));class n extends S.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(r,c,w,I,C=void 0,y){super(),this._debugNameData=r,this._computeFn=c,this.createChangeSummary=w,this._handleChange=I,this._handleLastObserverRemoved=C,this._equalityComparator=y,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,s.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const r of this.dependencies)r.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const r=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),r}else{do{if(this.state===1){for(const r of this.dependencies)if(r.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const r=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=r;const c=this.state!==0,w=this.value;this.state=3;const I=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,I)}finally{for(const y of this.dependenciesToBeRemoved)y.removeObserver(this);this.dependenciesToBeRemoved.clear()}const C=c&&!this._equalityComparator(w,this.value);if((0,s.getLogger)()?.handleDerivedRecomputed(this,{oldValue:w,newValue:this.value,change:void 0,didChange:C,hadValue:c}),C)for(const y of this.observers)y.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.updateCount++;const c=this.updateCount===1;if(this.state===3&&(this.state=1,!c))for(const w of this.observers)w.handlePossibleChange(this);if(c)for(const w of this.observers)w.beginUpdate(this)}endUpdate(r){if(this.updateCount--,this.updateCount===0){const c=[...this.observers];for(const w of c)w.endUpdate(this)}(0,P.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(r){if(this.state===3&&this.dependencies.has(r)&&!this.dependenciesToBeRemoved.has(r)){this.state=1;for(const c of this.observers)c.handlePossibleChange(this)}}handleChange(r,c){if(this.dependencies.has(r)&&!this.dependenciesToBeRemoved.has(r)){const w=this._handleChange?this._handleChange({changedObservable:r,change:c,didChange:C=>C===r},this.changeSummary):!0,I=this.state===3;if(w&&(this.state===1||I)&&(this.state=2,I))for(const C of this.observers)C.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const c=r.get();return this.dependencies.add(r),this.dependenciesToBeRemoved.delete(r),c}addObserver(r){const c=!this.observers.has(r)&&this.updateCount>0;super.addObserver(r),c&&r.beginUpdate(this)}removeObserver(r){const c=this.observers.has(r)&&this.updateCount>0;super.removeObserver(r),c&&r.endUpdate(this)}}e.Derived=n}),define(j[26],K([0,1,2,7,6,4,8,5]),function(F,e,P,E,S,p,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeepAliveObserver=e.FromEventObservable=void 0,e.constObservable=i,e.observableFromPromise=v,e.observableFromEvent=h,e.observableSignalFromEvent=u,e.observableSignal=t,e.debouncedObservable=c,e.debouncedObservable2=w,e.wasEventTriggeredRecently=I,e.keepObserved=C,e.recomputeInitiallyAndOnChange=y,e.derivedObservableWithCache=m,e.derivedObservableWithWritableCache=_,e.mapObservableArrayCached=z;function i(f){return new l(f)}class l extends S.ConvenientObservable{constructor(k){super(),this.value=k}get debugName(){return this.toString()}get(){return this.value}addObserver(k){}removeObserver(k){}toString(){return`Const: ${this.value}`}}function v(f){const k=(0,S.observableValue)("promiseValue",{});return f.then(R=>{k.set({value:R},void 0)}),k}function h(f,k){return new b(f,k)}class b extends S.BaseObservable{constructor(k,R){super(),this.event=k,this._getValue=R,this.hasValue=!1,this.handleEvent=M=>{const O=this._getValue(M),g=this.value,A=!this.hasValue||g!==O;let B=!1;A&&(this.value=O,this.hasValue&&(B=!0,(0,S.subtransaction)(b.globalTransaction,q=>{(0,d.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:A,hadValue:this.hasValue});for(const $ of this.observers)q.updateObserver($,this),$.handleChange(this,void 0)},()=>{const q=this.getDebugName();return"Event fired"+(q?`: ${q}`:"")})),this.hasValue=!0),B||(0,d.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:g,newValue:O,change:void 0,didChange:A,hadValue:this.hasValue})}}getDebugName(){return(0,p.getFunctionName)(this._getValue)}get debugName(){const k=this.getDebugName();return"From Event"+(k?`: ${k}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}e.FromEventObservable=b,function(f){f.Observer=b;function k(R,M){let O=!1;b.globalTransaction===void 0&&(b.globalTransaction=R,O=!0);try{M()}finally{O&&(b.globalTransaction=void 0)}}f.batchEventsGlobally=k}(h||(e.observableFromEvent=h={}));function u(f,k){return new n(f,k)}class n extends S.BaseObservable{constructor(k,R){super(),this.debugName=k,this.event=R,this.handleEvent=()=>{(0,S.transaction)(M=>{for(const O of this.observers)M.updateObserver(O,this),O.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function t(f){return typeof f=="string"?new r(f):new r(void 0,f)}class r extends S.BaseObservable{get debugName(){return new p.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}constructor(k,R){super(),this._debugName=k,this._owner=R}trigger(k,R){if(!k){(0,S.transaction)(M=>{this.trigger(M,R)},()=>`Trigger signal ${this.debugName}`);return}for(const M of this.observers)k.updateObserver(M,this),M.handleChange(this,R)}get(){}}function c(f,k,R){const M=(0,S.observableValue)("debounced",void 0);let O;return R.add((0,E.autorun)(g=>{const A=f.read(g);O&&clearTimeout(O),O=setTimeout(()=>{(0,S.transaction)(B=>{M.set(A,B)})},k)})),M}function w(f,k){let R=!1,M,O;return h(g=>{const A=(0,E.autorun)(B=>{const q=f.read(B);R?(O&&clearTimeout(O),O=setTimeout(()=>{M=q,g()},k)):(R=!0,M=q)});return{dispose(){A.dispose(),R=!1,M=void 0}}},()=>R?M:f.get())}function I(f,k,R){const M=(0,S.observableValue)("triggeredRecently",!1);let O;return R.add(f(()=>{M.set(!0,void 0),O&&clearTimeout(O),O=setTimeout(()=>{M.set(!1,void 0)},k)})),M}function C(f){const k=new o(!1,void 0);return f.addObserver(k),(0,P.toDisposable)(()=>{f.removeObserver(k)})}(0,S._setKeepObserved)(C);function y(f,k){const R=new o(!0,k);return f.addObserver(R),k?k(f.get()):f.reportChanges(),(0,P.toDisposable)(()=>{f.removeObserver(R)})}(0,S._setRecomputeInitiallyAndOnChange)(y);class o{constructor(k,R){this._forceRecompute=k,this._handleValue=R,this._counter=0}beginUpdate(k){this._counter++}endUpdate(k){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(k.get()):k.reportChanges())}handlePossibleChange(k){}handleChange(k,R){}}e.KeepAliveObserver=o;function m(f){let k;return(0,s.derived)(M=>(k=f(M,k),k))}function _(f,k){let R;const M=(0,S.observableValue)("derivedObservableWithWritableCache.counter",0),O=(0,s.derived)(f,g=>(M.read(g),R=k(g,R),R));return Object.assign(O,{clearCache:g=>{R=void 0,M.set(M.get()+1,g)}})}function z(f,k,R,M){let O=new W(R,M);return(0,s.derivedOpts)({debugReferenceFn:R,owner:f,onLastObserverRemoved:()=>{O.dispose(),O=new W(R)}},A=>(O.setItems(k.read(A)),O.getItems()))}class W{constructor(k,R){this._map=k,this._keySelector=R,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(k=>k.store.dispose()),this._cache.clear()}setItems(k){const R=[],M=new Set(this._cache.keys());for(const O of k){const g=this._keySelector?this._keySelector(O):O;let A=this._cache.get(g);if(A)M.delete(g);else{const B=new P.DisposableStore;A={out:this._map(O,B),store:B},this._cache.set(g,A)}R.push(A.out)}for(const O of M)this._cache.get(O).store.dispose(),this._cache.delete(O);this._items=R}getItems(){return this._items}}}),define(j[27],K([0,1,7,6,8,28,4]),function(F,e,P,E,S,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ObservableLazyPromise=e.PromiseResult=e.ObservablePromise=e.ObservableLazy=void 0,e.waitForState=h,e.derivedWithCancellationToken=b;class d{get cachedValue(){return this._value}constructor(n){this._computeValue=n,this._value=(0,E.observableValue)(this,void 0)}getValue(){let n=this._value.get();return n||(n=this._computeValue(),this._value.set(n,void 0)),n}}e.ObservableLazy=d;class i{constructor(n){this._value=(0,E.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=n.then(t=>((0,E.transaction)(r=>{this._value.set(new l(t,void 0),r)}),t),t=>{throw(0,E.transaction)(r=>{this._value.set(new l(void 0,t),r)}),t})}}e.ObservablePromise=i;class l{constructor(n,t){this.data=n,this.error=t}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.PromiseResult=l;class v{constructor(n){this._computePromise=n,this._lazyValue=new d(()=>new i(this._computePromise())),this.cachedPromiseResult=(0,S.derived)(this,t=>this._lazyValue.cachedValue.read(t)?.promiseResult.read(t))}getPromise(){return this._lazyValue.getValue().promise}}e.ObservableLazyPromise=v;function h(u,n,t){return new Promise((r,c)=>{let w=!0,I=!1;const C=u.map(o=>({isFinished:n(o),error:t?t(o):!1,state:o})),y=(0,P.autorun)(o=>{const{isFinished:m,error:_,state:z}=C.read(o);(m||_)&&(w?I=!0:y.dispose(),_?c(_===!0?z:_):r(z))});w=!1,I&&y.dispose()})}function b(u,n){let t,r;n===void 0?(t=u,r=void 0):(r=u,t=n);let c;return new S.Derived(new s.DebugNameData(r,void 0,t),w=>(c&&c.dispose(!0),c=new p.CancellationTokenSource,t(w,c.token)),void 0,void 0,()=>c?.dispose(),S.defaultEqualityComparer)}}),define(j[12],K([0,1,6,8,7,26,27,5]),function(F,e,P,E,S,p,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.observableValue}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.disposableObservableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.transaction}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.subtransaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return E.derived}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return E.derivedOpts}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return E.derivedHandleChanges}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return E.derivedWithStore}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return S.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return S.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return S.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return S.autorunWithStore}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return S.autorunOpts}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return S.autorunWithStoreHandleChanges}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return p.constObservable}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return p.debouncedObservable}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return p.derivedObservableWithCache}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return p.derivedObservableWithWritableCache}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return p.keepObserved}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return p.recomputeInitiallyAndOnChange}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return p.observableFromEvent}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return p.observableFromPromise}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return p.observableSignal}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return p.observableSignalFromEvent}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return p.wasEventTriggeredRecently}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return s.ObservableLazy}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return s.ObservableLazyPromise}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return s.ObservablePromise}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return s.PromiseResult}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return s.waitForState}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return s.derivedWithCancellationToken}}),!1&&(0,d.setLogger)(new d.ConsoleObservableLogger)}),define(j[29],K([0,1,9,2]),function(F,e,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=S,e.isReadableStream=p,e.isReadableBufferedStream=s,e.newWriteableStream=d,e.consumeReadable=l,e.peekReadable=v,e.consumeStream=h,e.listenStream=b,e.peekStream=u,e.toStream=n,e.emptyStream=t,e.toReadable=r,e.transform=c,e.prefixedReadable=w,e.prefixedStream=I;function S(C){const y=C;return y?typeof y.read=="function":!1}function p(C){const y=C;return y?[y.on,y.pause,y.resume,y.destroy].every(o=>typeof o=="function"):!1}function s(C){const y=C;return y?p(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}function d(C,y){return new i(C,y)}class i{constructor(y,o){this.reducer=y,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(y){if(!this.state.destroyed){if(this.state.flowing)this.emitData(y);else if(this.buffer.data.push(y),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(y){this.state.destroyed||(this.state.flowing?this.emitError(y):this.buffer.error.push(y))}end(y){this.state.destroyed||(typeof y<"u"&&this.write(y),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(y){this.listeners.data.slice(0).forEach(o=>o(y))}emitError(y){this.listeners.error.length===0?(0,P.onUnexpectedError)(y):this.listeners.error.slice(0).forEach(o=>o(y))}emitEnd(){this.listeners.end.slice(0).forEach(y=>y())}on(y,o){if(!this.state.destroyed)switch(y){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(y,o){if(this.state.destroyed)return;let m;switch(y){case"data":m=this.listeners.data;break;case"end":m=this.listeners.end;break;case"error":m=this.listeners.error;break}if(m){const _=m.indexOf(o);_>=0&&m.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const y=this.reducer(this.buffer.data);this.emitData(y),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(m=>m())}}flowErrors(){if(this.listeners.error.length>0){for(const y of this.buffer.error)this.emitError(y);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(C,y){const o=[];let m;for(;(m=C.read())!==null;)o.push(m);return y(o)}function v(C,y,o){const m=[];let _;for(;(_=C.read())!==null&&m.length<o;)m.push(_);return _===null&&m.length>0?y(m):{read:()=>{if(m.length>0)return m.shift();if(typeof _<"u"){const z=_;return _=void 0,z}return C.read()}}}function h(C,y){return new Promise((o,m)=>{const _=[];b(C,{onData:z=>{y&&_.push(z)},onError:z=>{y?m(z):o(void 0)},onEnd:()=>{o(y?y(_):void 0)}})})}function b(C,y,o){C.on("error",m=>{o?.isCancellationRequested||y.onError(m)}),C.on("end",()=>{o?.isCancellationRequested||y.onEnd()}),C.on("data",m=>{o?.isCancellationRequested||y.onData(m)})}function u(C,y){return new Promise((o,m)=>{const _=new E.DisposableStore,z=[],W=R=>{if(z.push(R),z.length>y)return _.dispose(),C.pause(),o({stream:C,buffer:z,ended:!1})},f=R=>(_.dispose(),m(R)),k=()=>(_.dispose(),o({stream:C,buffer:z,ended:!0}));_.add((0,E.toDisposable)(()=>C.removeListener("error",f))),C.on("error",f),_.add((0,E.toDisposable)(()=>C.removeListener("end",k))),C.on("end",k),_.add((0,E.toDisposable)(()=>C.removeListener("data",W))),C.on("data",W)})}function n(C,y){const o=d(y);return o.end(C),o}function t(){const C=d(()=>{throw new Error("not supported")});return C.end(),C}function r(C){let y=!1;return{read:()=>y?null:(y=!0,C)}}function c(C,y,o){const m=d(o);return b(C,{onData:_=>m.write(y.data(_)),onError:_=>m.error(y.error?y.error(_):_),onEnd:()=>m.end()}),m}function w(C,y,o){let m=!1;return{read:()=>{const _=y.read();return m?_:(m=!0,_!==null?o([C,_]):C)}}}function I(C,y,o){let m=!1;const _=d(o);return b(y,{onData:z=>m?_.write(z):(m=!0,_.write(o([C,z]))),onError:z=>_.error(z),onEnd:()=>{m||(m=!0,_.write(C)),_.end()}}),_}}),define(j[13],K([0,1,30,29]),function(F,e,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=l,e.readUInt16LE=v,e.writeUInt16LE=h,e.readUInt32BE=b,e.writeUInt32BE=u,e.readUInt32LE=n,e.writeUInt32LE=t,e.readUInt8=r,e.writeUInt8=c,e.readableToBuffer=w,e.bufferToReadable=I,e.streamToBuffer=C,e.bufferedStreamToBuffer=y,e.bufferToStream=o,e.streamToBufferReadableStream=m,e.newWriteableBufferStream=_,e.prefixedBufferReadable=z,e.prefixedBufferStream=W,e.decodeBase64=f,e.encodeBase64=M;const S=typeof Buffer<"u",p=new P.Lazy(()=>new Uint8Array(256));let s,d;class i{static alloc(g){return S?new i(Buffer.allocUnsafe(g)):new i(new Uint8Array(g))}static wrap(g){return S&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new i(g)}static fromString(g,A){return!(A?.dontUseNodeBuffer||!1)&&S?new i(Buffer.from(g)):(s||(s=new TextEncoder),new i(s.encode(g)))}static fromByteArray(g){const A=i.alloc(g.length);for(let B=0,q=g.length;B<q;B++)A.buffer[B]=g[B];return A}static concat(g,A){if(typeof A>"u"){A=0;for(let $=0,H=g.length;$<H;$++)A+=g[$].byteLength}const B=i.alloc(A);let q=0;for(let $=0,H=g.length;$<H;$++){const V=g[$];B.set(V,q),q+=V.byteLength}return B}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=i.alloc(this.byteLength);return g.set(this),g}toString(){return S?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(g,A){return new i(this.buffer.subarray(g,A))}set(g,A){if(g instanceof i)this.buffer.set(g.buffer,A);else if(g instanceof Uint8Array)this.buffer.set(g,A);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),A);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return b(this.buffer,g)}writeUInt32BE(g,A){u(this.buffer,g,A)}readUInt32LE(g){return n(this.buffer,g)}writeUInt32LE(g,A){t(this.buffer,g,A)}readUInt8(g){return r(this.buffer,g)}writeUInt8(g,A){c(this.buffer,g,A)}indexOf(g,A=0){return l(this.buffer,g instanceof i?g.buffer:g,A)}}e.VSBuffer=i;function l(O,g,A=0){const B=g.byteLength,q=O.byteLength;if(B===0)return 0;if(B===1)return O.indexOf(g[0]);if(B>q-A)return-1;const $=p.value;$.fill(g.length);for(let J=0;J<g.length;J++)$[g[J]]=g.length-J-1;let H=A+g.length-1,V=H,G=-1;for(;H<q;)if(O[H]===g[V]){if(V===0){G=H;break}H--,V--}else H+=Math.max(g.length-V,$[O[H]]),V=g.length-1;return G}function v(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0}function h(O,g,A){O[A+0]=g&255,g=g>>>8,O[A+1]=g&255}function b(O,g){return O[g]*2**24+O[g+1]*2**16+O[g+2]*2**8+O[g+3]}function u(O,g,A){O[A+3]=g,g=g>>>8,O[A+2]=g,g=g>>>8,O[A+1]=g,g=g>>>8,O[A]=g}function n(O,g){return O[g+0]<<0>>>0|O[g+1]<<8>>>0|O[g+2]<<16>>>0|O[g+3]<<24>>>0}function t(O,g,A){O[A+0]=g&255,g=g>>>8,O[A+1]=g&255,g=g>>>8,O[A+2]=g&255,g=g>>>8,O[A+3]=g&255}function r(O,g){return O[g]}function c(O,g,A){O[A]=g}function w(O){return E.consumeReadable(O,g=>i.concat(g))}function I(O){return E.toReadable(O)}function C(O){return E.consumeStream(O,g=>i.concat(g))}async function y(O){return O.ended?i.concat(O.buffer):i.concat([...O.buffer,await C(O.stream)])}function o(O){return E.toStream(O,g=>i.concat(g))}function m(O){return E.transform(O,{data:g=>typeof g=="string"?i.fromString(g):i.wrap(g)},g=>i.concat(g))}function _(O){return E.newWriteableStream(g=>i.concat(g),O)}function z(O,g){return E.prefixedReadable(O,g,A=>i.concat(A))}function W(O,g){return E.prefixedStream(O,g,A=>i.concat(A))}function f(O){let g=0,A=0,B=0;const q=new Uint8Array(Math.floor(O.length/4*3)),$=V=>{switch(A){case 3:q[B++]=g|V,A=0;break;case 2:q[B++]=g|V>>>2,g=V<<6,A=3;break;case 1:q[B++]=g|V>>>4,g=V<<4,A=2;break;default:g=V<<2,A=1}};for(let V=0;V<O.length;V++){const G=O.charCodeAt(V);if(G>=65&&G<=90)$(G-65);else if(G>=97&&G<=122)$(G-97+26);else if(G>=48&&G<=57)$(G-48+52);else if(G===43||G===45)$(62);else if(G===47||G===95)$(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${O[V]}`)}}const H=B;for(;A>0;)$(0);return i.wrap(q).slice(0,H)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:O},g=!0,A=!1){const B=A?R:k;let q="";const $=O.byteLength%3;let H=0;for(;H<O.byteLength-$;H+=3){const V=O[H+0],G=O[H+1],J=O[H+2];q+=B[V>>>2],q+=B[(V<<4|G>>>4)&63],q+=B[(G<<2|J>>>6)&63],q+=B[J&63]}if($===1){const V=O[H+0];q+=B[V>>>2],q+=B[V<<4&63],g&&(q+="==")}else if($===2){const V=O[H+0],G=O[H+1];q+=B[V>>>2],q+=B[(V<<4|G>>>4)&63],q+=B[G<<2&63],g&&(q+="=")}return q}}),define(j[31],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(j[14],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=E;var P;(function(S){S[S.Unknown=0]="Unknown",S[S.Invalid=3]="Invalid",S[S.LF=1]="LF",S[S.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function E(S){let p=0,s=0,d=0,i=0;for(let l=0,v=S.length;l<v;l++){const h=S.charCodeAt(l);h===13?(p===0&&(s=l),p++,l+1<v&&S.charCodeAt(l+1)===10?(i|=2,l++):i|=3,d=l+1):h===10&&(i|=1,p===0&&(s=l),p++,d=l+1)}return p===0&&(s=S.length),[p,s,S.length-d,i]}}),define(j[15],K([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var E;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(E||(e.FontStyle=E={}));var S;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(S||(e.ColorId=S={}));var p;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(p||(e.StandardTokenType=p={}));var s;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class d{static getLanguageId(l){return(l&255)>>>0}static getTokenType(l){return(l&768)>>>8}static containsBalancedBrackets(l){return(l&1024)!==0}static getFontStyle(l){return(l&30720)>>>11}static getForeground(l){return(l&16744448)>>>15}static getBackground(l){return(l&4278190080)>>>24}static getClassNameFromMetadata(l){let h="mtk"+this.getForeground(l);const b=this.getFontStyle(l);return b&1&&(h+=" mtki"),b&2&&(h+=" mtkb"),b&4&&(h+=" mtku"),b&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(l,v){const h=this.getForeground(l),b=this.getFontStyle(l);let u=`color: ${v[h]};`;b&1&&(u+="font-style: italic;"),b&2&&(u+="font-weight: bold;");let n="";return b&4&&(n+=" underline"),b&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(l){const v=this.getForeground(l),h=this.getFontStyle(l);return{foreground:v,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.TokenMetadata=d}),define(j[32],K([0,1,33]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class E{constructor(s){this._default=s,this._store=[]}get(s){return s<this._store.length?this._store[s]:this._default}set(s,d){for(;s>=this._store.length;)this._store[this._store.length]=this._default;this._store[s]=d}replace(s,d,i){if(s>=this._store.length)return;if(d===0){this.insert(s,i);return}else if(i===0){this.delete(s,d);return}const l=this._store.slice(0,s),v=this._store.slice(s+d),h=S(i,this._default);this._store=l.concat(h,v)}delete(s,d){d===0||s>=this._store.length||this._store.splice(s,d)}insert(s,d){if(d===0||s>=this._store.length)return;const i=[];for(let l=0;l<d;l++)i[l]=this._default;this._store=(0,P.arrayInsert)(this._store,s,i)}}e.FixedArray=E;function S(p,s){const d=[];for(let i=0;i<p;i++)d[i]=s;return d}}),define(j[10],K([0,1,15]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class E{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(s,d){const i=E.defaultTokenMetadata,l=new Uint32Array(2);return l[0]=s.length,l[1]=i,new E(l,s,d)}constructor(s,d,i){this._lineTokensBrand=void 0,this._tokens=s,this._tokensCount=this._tokens.length>>>1,this._text=d,this._languageIdCodec=i}equals(s){return s instanceof E?this.slicedEquals(s,0,this._tokensCount):!1}slicedEquals(s,d,i){if(this._text!==s._text||this._tokensCount!==s._tokensCount)return!1;const l=d<<1,v=l+(i<<1);for(let h=l;h<v;h++)if(this._tokens[h]!==s._tokens[h])return!1;return!0}getLineContent(){return this._text}getCount(){return this._tokensCount}getStartOffset(s){return s>0?this._tokens[s-1<<1]:0}getMetadata(s){return this._tokens[(s<<1)+1]}getLanguageId(s){const d=this._tokens[(s<<1)+1],i=P.TokenMetadata.getLanguageId(d);return this._languageIdCodec.decodeLanguageId(i)}getStandardTokenType(s){const d=this._tokens[(s<<1)+1];return P.TokenMetadata.getTokenType(d)}getForeground(s){const d=this._tokens[(s<<1)+1];return P.TokenMetadata.getForeground(d)}getClassName(s){const d=this._tokens[(s<<1)+1];return P.TokenMetadata.getClassNameFromMetadata(d)}getInlineStyle(s,d){const i=this._tokens[(s<<1)+1];return P.TokenMetadata.getInlineStyleFromMetadata(i,d)}getPresentation(s){const d=this._tokens[(s<<1)+1];return P.TokenMetadata.getPresentationFromMetadata(d)}getEndOffset(s){return this._tokens[s<<1]}findTokenIndexAtOffset(s){return E.findIndexInTokensArray(this._tokens,s)}inflate(){return this}sliceAndInflate(s,d,i){return new S(this,s,d,i)}static convertToEndOffset(s,d){const l=(s.length>>>1)-1;for(let v=0;v<l;v++)s[v<<1]=s[v+1<<1];s[l<<1]=d}static findIndexInTokensArray(s,d){if(s.length<=2)return 0;let i=0,l=(s.length>>>1)-1;for(;i<l;){const v=i+Math.floor((l-i)/2),h=s[v<<1];if(h===d)return v+1;h<d?i=v+1:h>d&&(l=v)}return i}withInserted(s){if(s.length===0)return this;let d=0,i=0,l="";const v=new Array;let h=0;for(;;){const b=d<this._tokensCount?this._tokens[d<<1]:-1,u=i<s.length?s[i]:null;if(b!==-1&&(u===null||b<=u.offset)){l+=this._text.substring(h,b);const n=this._tokens[(d<<1)+1];v.push(l.length,n),d++,h=b}else if(u){if(u.offset>h){l+=this._text.substring(h,u.offset);const n=this._tokens[(d<<1)+1];v.push(l.length,n),h=u.offset}l+=u.text,v.push(l.length,u.tokenMetadata),i++}else break}return new E(new Uint32Array(v),l,this._languageIdCodec)}}e.LineTokens=E;class S{constructor(s,d,i,l){this._source=s,this._startOffset=d,this._endOffset=i,this._deltaOffset=l,this._firstTokenIndex=s.findTokenIndexAtOffset(d),this._tokensCount=0;for(let v=this._firstTokenIndex,h=s.getCount();v<h&&!(s.getStartOffset(v)>=i);v++)this._tokensCount++}getMetadata(s){return this._source.getMetadata(this._firstTokenIndex+s)}getLanguageId(s){return this._source.getLanguageId(this._firstTokenIndex+s)}getLineContent(){return this._source.getLineContent().substring(this._startOffset,this._endOffset)}equals(s){return s instanceof S?this._startOffset===s._startOffset&&this._endOffset===s._endOffset&&this._deltaOffset===s._deltaOffset&&this._source.slicedEquals(s._source,this._firstTokenIndex,this._tokensCount):!1}getCount(){return this._tokensCount}getForeground(s){return this._source.getForeground(this._firstTokenIndex+s)}getEndOffset(s){const d=this._source.getEndOffset(this._firstTokenIndex+s);return Math.min(this._endOffset,d)-this._startOffset+this._deltaOffset}getClassName(s){return this._source.getClassName(this._firstTokenIndex+s)}getInlineStyle(s,d){return this._source.getInlineStyle(this._firstTokenIndex+s,d)}getPresentation(s){return this._source.getPresentation(this._firstTokenIndex+s)}findTokenIndexAtOffset(s){return this._source.findTokenIndexAtOffset(s+this._startOffset-this._deltaOffset)-this._firstTokenIndex}}}),define(j[34],K([0,1,10]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.toUint32Array=S,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class E{static deleteBeginning(s,d){return s===null||s===e.EMPTY_LINE_TOKENS?s:E.delete(s,0,d)}static deleteEnding(s,d){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const i=S(s),l=i[i.length-2];return E.delete(s,d,l)}static delete(s,d,i){if(s===null||s===e.EMPTY_LINE_TOKENS||d===i)return s;const l=S(s),v=l.length>>>1;if(d===0&&l[l.length-2]===i)return e.EMPTY_LINE_TOKENS;const h=P.LineTokens.findIndexInTokensArray(l,d),b=h>0?l[h-1<<1]:0,u=l[h<<1];if(i<u){const w=i-d;for(let I=h;I<v;I++)l[I<<1]-=w;return s}let n,t;b!==d?(l[h<<1]=d,n=h+1<<1,t=d):(n=h<<1,t=b);const r=i-d;for(let w=h+1;w<v;w++){const I=l[w<<1]-r;I>t&&(l[n++]=I,l[n++]=l[(w<<1)+1],t=I)}if(n===l.length)return s;const c=new Uint32Array(n);return c.set(l.subarray(0,n),0),c.buffer}static append(s,d){if(d===e.EMPTY_LINE_TOKENS)return s;if(s===e.EMPTY_LINE_TOKENS)return d;if(s===null)return s;if(d===null)return null;const i=S(s),l=S(d),v=l.length>>>1,h=new Uint32Array(i.length+l.length);h.set(i,0);let b=i.length;const u=i[i.length-2];for(let n=0;n<v;n++)h[b++]=l[n<<1]+u,h[b++]=l[(n<<1)+1];return h.buffer}static insert(s,d,i){if(s===null||s===e.EMPTY_LINE_TOKENS)return s;const l=S(s),v=l.length>>>1;let h=P.LineTokens.findIndexInTokensArray(l,d);h>0&&l[h-1<<1]===d&&h--;for(let b=h;b<v;b++)l[b<<1]+=i;return s}}e.ContiguousTokensEditing=E;function S(p){return p instanceof Uint32Array?p:new Uint32Array(p)}}),define(j[35],K([0,1,33,13,47,14,34,16]),function(F,e,P,E,S,p,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class i{static deserialize(v,h,b){const u=new Uint32Array(v.buffer),n=(0,E.readUInt32BE)(v,h);h+=4;const t=(0,E.readUInt32BE)(v,h);h+=4;const r=[];for(let c=0;c<t;c++){const w=(0,E.readUInt32BE)(v,h);h+=4,r.push(u.subarray(h/4,h/4+w/4)),h+=w}return b.push(new i(n,r)),h}get startLineNumber(){return this._startLineNumber}get endLineNumber(){return this._startLineNumber+this._tokens.length-1}constructor(v,h){this._startLineNumber=v,this._tokens=h}getLineRange(){return new d.LineRange(this._startLineNumber,this._startLineNumber+this._tokens.length)}getLineTokens(v){return this._tokens[v-this._startLineNumber]}appendLineTokens(v){this._tokens.push(v)}serializeSize(){let v=0;v+=4,v+=4;for(let h=0;h<this._tokens.length;h++){const b=this._tokens[h];if(!(b instanceof Uint32Array))throw new Error("Not supported!");v+=4,v+=b.byteLength}return v}serialize(v,h){(0,E.writeUInt32BE)(v,this._startLineNumber,h),h+=4,(0,E.writeUInt32BE)(v,this._tokens.length,h),h+=4;for(let b=0;b<this._tokens.length;b++){const u=this._tokens[b];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,E.writeUInt32BE)(v,u.byteLength,h),h+=4,v.set(new Uint8Array(u.buffer),h),h+=u.byteLength}return h}applyEdit(v,h){const[b,u]=(0,p.countEOL)(h);this._acceptDeleteRange(v),this._acceptInsertText(new S.Position(v.startLineNumber,v.startColumn),b,u)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber&&v.startColumn===v.endColumn)return;const h=v.startLineNumber-this._startLineNumber,b=v.endLineNumber-this._startLineNumber;if(b<0){const u=b-h;this._startLineNumber-=u;return}if(!(h>=this._tokens.length)){if(h<0&&b>=this._tokens.length){this._startLineNumber=0,this._tokens=[];return}if(h===b){this._tokens[h]=s.ContiguousTokensEditing.delete(this._tokens[h],v.startColumn-1,v.endColumn-1);return}if(h>=0)if(this._tokens[h]=s.ContiguousTokensEditing.deleteEnding(this._tokens[h],v.startColumn-1),b<this._tokens.length){const u=s.ContiguousTokensEditing.deleteBeginning(this._tokens[b],v.endColumn-1);this._tokens[h]=s.ContiguousTokensEditing.append(this._tokens[h],u),this._tokens.splice(h+1,b-h)}else this._tokens[h]=s.ContiguousTokensEditing.append(this._tokens[h],null),this._tokens=this._tokens.slice(0,h+1);else{const u=-h;this._startLineNumber-=u,this._tokens[b]=s.ContiguousTokensEditing.deleteBeginning(this._tokens[b],v.endColumn-1),this._tokens=this._tokens.slice(b)}}}_acceptInsertText(v,h,b){if(h===0&&b===0)return;const u=v.lineNumber-this._startLineNumber;if(u<0){this._startLineNumber+=h;return}if(!(u>=this._tokens.length)){if(h===0){this._tokens[u]=s.ContiguousTokensEditing.insert(this._tokens[u],v.column-1,b);return}this._tokens[u]=s.ContiguousTokensEditing.deleteEnding(this._tokens[u],v.column-1),this._tokens[u]=s.ContiguousTokensEditing.insert(this._tokens[u],v.column-1,b),this._insertLines(v.lineNumber,h)}}_insertLines(v,h){if(h===0)return;const b=[];for(let u=0;u<h;u++)b[u]=null;this._tokens=P.arrayInsert(this._tokens,v,b)}}e.ContiguousMultilineTokens=i}),define(j[17],K([0,1,13,35]),function(F,e,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class S{static deserialize(s){let d=0;const i=(0,P.readUInt32BE)(s,d);d+=4;const l=[];for(let v=0;v<i;v++)d=E.ContiguousMultilineTokens.deserialize(s,d,l);return l}constructor(){this._tokens=[]}add(s,d){if(this._tokens.length>0){const i=this._tokens[this._tokens.length-1];if(i.endLineNumber+1===s){i.appendLineTokens(d);return}}this._tokens.push(new E.ContiguousMultilineTokens(s,[d]))}finalize(){return this._tokens}serialize(){const s=this._serializeSize(),d=new Uint8Array(s);return this._serialize(d),d}_serializeSize(){let s=0;s+=4;for(let d=0;d<this._tokens.length;d++)s+=this._tokens[d].serializeSize();return s}_serialize(s){let d=0;(0,P.writeUInt32BE)(s,this._tokens.length,d),d+=4;for(let i=0;i<this._tokens.length;i++)d=this._tokens[i].serialize(s,d)}}e.ContiguousMultilineTokensBuilder=S}),define(j[36],K([0,1,18,3,19,48]),function(F,e,P,E,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=s,e.toSlashes=d,e.toPosixPath=i,e.getRoot=l,e.isUNC=v,e.isValidBasename=n,e.isEqual=t,e.isEqualOrParent=r,e.isWindowsDriveLetter=c,e.sanitizeFilePath=w,e.isRootOrDriveLetter=I,e.hasDriveLetter=C,e.getDriveLetter=y,e.indexOfPath=o,e.parseLineAndColumnAware=m,e.randomPath=W;function s(f){return f===47||f===92}function d(f){return f.replace(/[\\/]/g,P.posix.sep)}function i(f){return f.indexOf("/")===-1&&(f=d(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}function l(f,k=P.posix.sep){if(!f)return"";const R=f.length,M=f.charCodeAt(0);if(s(M)){if(s(f.charCodeAt(1))&&!s(f.charCodeAt(2))){let g=3;const A=g;for(;g<R&&!s(f.charCodeAt(g));g++);if(A!==g&&!s(f.charCodeAt(g+1))){for(g+=1;g<R;g++)if(s(f.charCodeAt(g)))return f.slice(0,g+1).replace(/[\\/]/g,k)}}return k}else if(c(M)&&f.charCodeAt(1)===58)return s(f.charCodeAt(2))?f.slice(0,2)+k:f.slice(0,2);let O=f.indexOf("://");if(O!==-1){for(O+=3;O<R;O++)if(s(f.charCodeAt(O)))return f.slice(0,O+1)}return""}function v(f){if(!E.isWindows||!f||f.length<5)return!1;let k=f.charCodeAt(0);if(k!==92||(k=f.charCodeAt(1),k!==92))return!1;let R=2;const M=R;for(;R<f.length&&(k=f.charCodeAt(R),k!==92);R++);return!(M===R||(k=f.charCodeAt(R+1),isNaN(k)||k===92))}const h=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,k=E.isWindows){const R=k?h:b;return!(!f||f.length===0||/^\s+$/.test(f)||(R.lastIndex=0,R.test(f))||k&&u.test(f)||f==="."||f===".."||k&&f[f.length-1]==="."||k&&f.length!==f.trim().length||f.length>255)}function t(f,k,R){const M=f===k;return!R||M?M:!f||!k?!1:(0,S.equalsIgnoreCase)(f,k)}function r(f,k,R,M=P.sep){if(f===k)return!0;if(!f||!k||k.length>f.length)return!1;if(R){if(!(0,S.startsWithIgnoreCase)(f,k))return!1;if(k.length===f.length)return!0;let g=k.length;return k.charAt(k.length-1)===M&&g--,f.charAt(g)===M}return k.charAt(k.length-1)!==M&&(k+=M),f.indexOf(k)===0}function c(f){return f>=65&&f<=90||f>=97&&f<=122}function w(f,k){return E.isWindows&&f.endsWith(":")&&(f+=P.sep),(0,P.isAbsolute)(f)||(f=(0,P.join)(k,f)),f=(0,P.normalize)(f),E.isWindows?(f=(0,S.rtrim)(f,P.sep),f.endsWith(":")&&(f+=P.sep)):(f=(0,S.rtrim)(f,P.sep),f||(f=P.sep)),f}function I(f){const k=(0,P.normalize)(f);return E.isWindows?f.length>3?!1:C(k)&&(f.length===2||k.charCodeAt(2)===92):k===P.posix.sep}function C(f,k=E.isWindows){return k?c(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}function y(f,k=E.isWindows){return C(f,k)?f[0]:void 0}function o(f,k,R){return k.length>f.length?-1:f===k?0:(R&&(f=f.toLowerCase(),k=k.toLowerCase()),f.indexOf(k))}function m(f){const k=f.split(":");let R,M,O;for(const g of k){const A=Number(g);(0,p.isNumber)(A)?M===void 0?M=A:O===void 0&&(O=A):R=R?[R,g].join(":"):g}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:M!==void 0?M:void 0,column:O!==void 0?O:M!==void 0?1:void 0}}const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",z="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function W(f,k,R=8){let M="";for(let g=0;g<R;g++){let A;g===0&&E.isWindows&&!k&&(R===3||R===4)?A=z:A=_,M+=A.charAt(Math.floor(Math.random()*A.length))}let O;return k?O=`${k}-${M}`:O=M,f?(0,P.join)(f,O):O}}),define(j[20],K([0,1,9,3,19,11,18]),function(F,e,P,E,S,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=i,e.matchesSomeScheme=l,e.getServerRootPath=h;var d;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.codeSetting="code-setting"})(d||(e.Schemas=d={}));function i(n,t){return p.URI.isUri(n)?(0,S.equalsIgnoreCase)(n.scheme,t):(0,S.startsWithIgnoreCase)(n,t+":")}function l(n,...t){return t.some(r=>i(n,r))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class v{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(t){this._preferredWebSchema=t}setDelegate(t){this._delegate=t}setServerRootPath(t,r){this._serverRootPath=h(t,r)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return s.posix.join(this._serverRootPath,d.vscodeRemoteResource)}set(t,r,c){this._hosts[t]=r,this._ports[t]=c}setConnectionToken(t,r){this._connectionTokens[t]=r}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(t){if(this._delegate)try{return this._delegate(t)}catch(y){return P.onUnexpectedError(y),t}const r=t.authority;let c=this._hosts[r];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const w=this._ports[r],I=this._connectionTokens[r];let C=`path=${encodeURIComponent(t.path)}`;return typeof I=="string"&&(C+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),p.URI.from({scheme:E.isWeb?this._preferredWebSchema:d.vscodeRemoteResource,authority:`${c}:${w}`,path:this._remoteResourcesPath,query:C})}}e.RemoteAuthorities=new v;function h(n,t){return s.posix.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class b{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(t){const r=this.toUri(t,F);return this.uriToBrowserUri(r)}uriToBrowserUri(t){return t.scheme===d.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===d.file&&(E.isNative||E.webWorkerOrigin===`${d.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?t.with({scheme:d.vscodeFileResource,authority:t.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(t){const r=this.toUri(t,F);return this.uriToFileUri(r)}uriToFileUri(t){return t.scheme===d.vscodeFileResource?t.with({scheme:d.file,authority:t.authority!==b.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(t,r){return p.URI.isUri(t)?t:p.URI.parse(r.toUrl(t))}}e.FileAccess=new b;var u;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const r="vscode-coi";function c(I){let C;typeof I=="string"?C=new URL(I).searchParams:I instanceof URL?C=I.searchParams:p.URI.isUri(I)&&(C=new URL(I.toString(!0)).searchParams);const y=C?.get(r);if(y)return t.get(y)}n.getHeadersFromQuery=c;function w(I,C,y){if(!globalThis.crossOriginIsolated)return;const o=C&&y?"3":y?"2":"1";I instanceof URLSearchParams?I.set(r,o):I[r]=o}n.addSearchParam=w})(u||(e.COI=u={}))}),define(j[37],K([0,1,24,20,3,11]),function(F,e,P,E,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=v;class s{constructor(b,u,n){this.id=b,this.dependencies=u,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(b,u,n)=>{typeof b!="string"&&(n=u,u=b,b=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this._defineCalls.push(new s(b,u,n))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this._initialize();const u=await(this._isWebWorker?this._workerLoadScript(b):this._isRenderer?this._rendererLoadScript(b):this._nodeJSLoadScript(b));if(!u)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}_rendererLoadScript(b){return new Promise((u,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const r=()=>{t.removeEventListener("load",c),t.removeEventListener("error",w)},c=I=>{r(),u(this._defineCalls.pop())},w=I=>{r(),n(I)};t.addEventListener("load",c),t.addEventListener("error",w),this._amdPolicy&&(b=this._amdPolicy.createScriptURL(b)),t.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(t)})}_workerLoadScript(b){return new Promise((u,n)=>{try{this._amdPolicy&&(b=this._amdPolicy.createScriptURL(b)),importScripts(b),u(this._defineCalls.pop())}catch(t){n(t)}})}async _nodeJSLoadScript(b){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,r=p.URI.parse(b).fsPath,c=u.readFileSync(r).toString(),w=t.wrap(c.replace(/^#!.*/,""));return new n.Script(w).runInThisContext().apply(),this._defineCalls.pop()}catch(u){throw u}}}const i=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function v(h,b,u){if(P.isESM){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[h]&&(h=l[h]);const n=`${h}/${b}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const I=`${u&&!S.isWeb?E.nodeModulesAsarPath:E.nodeModulesPath}/${n}`;t=E.FileAccess.asBrowserUri(I).toString(!0)}const r=d.INSTANCE.load(t);return i.set(n,r),r}else return await new Promise((n,t)=>{F([h],n,t)})}}),define(j[21],K([0,1,36,20,18,3,19,11]),function(F,e,P,E,S,p,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=i,e.distinctParents=v,e.toLocalResource=b;function i(u){return(0,d.uriToFsPath)(u,!0)}class l{constructor(n){this._ignorePathCasing=n}compare(n,t,r=!1){return n===t?0:(0,s.compare)(this.getComparisonKey(n,r),this.getComparisonKey(t,r))}isEqual(n,t,r=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,r)===this.getComparisonKey(t,r)}getComparisonKey(n,t=!1){return n.with({path:this._ignorePathCasing(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this._ignorePathCasing(n)}isEqualOrParent(n,t,r=!1){if(n.scheme===t.scheme){if(n.scheme===E.Schemas.file)return P.isEqualOrParent(i(n),i(t),this._ignorePathCasing(n))&&n.query===t.query&&(r||n.fragment===t.fragment);if((0,e.isEqualAuthority)(n.authority,t.authority))return P.isEqualOrParent(n.path,t.path,this._ignorePathCasing(n),"/")&&n.query===t.query&&(r||n.fragment===t.fragment)}return!1}joinPath(n,...t){return d.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.basename)(n)||n.authority}basename(n){return S.posix.basename(n.path)}extname(n){return S.posix.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===E.Schemas.file?t=d.URI.file(S.dirname(i(n))).path:(t=S.posix.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===E.Schemas.file?t=d.URI.file(S.normalize(i(n))).path:t=S.posix.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.isEqualAuthority)(n.authority,t.authority))return;if(n.scheme===E.Schemas.file){const w=S.relative(i(n),i(t));return p.isWindows?P.toSlashes(w):w}let r=n.path||"/";const c=t.path||"/";if(this._ignorePathCasing(n)){let w=0;for(const I=Math.min(r.length,c.length);w<I&&!(r.charCodeAt(w)!==c.charCodeAt(w)&&r.charAt(w).toLowerCase()!==c.charAt(w).toLowerCase());w++);r=c.substr(0,w)+r.substr(w)}return S.posix.relative(r,c)}resolvePath(n,t){if(n.scheme===E.Schemas.file){const r=d.URI.file(S.resolve(i(n),t));return n.with({authority:r.authority,path:r.path})}return t=P.toPosixPath(t),n.with({path:S.posix.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,s.equalsIgnoreCase)(n,t)}hasTrailingPathSeparator(n,t=S.sep){if(n.scheme===E.Schemas.file){const r=i(n);return r.length>P.getRoot(r).length&&r[r.length-1]===t}else{const r=n.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=S.sep){return(0,e.hasTrailingPathSeparator)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=S.sep){let r=!1;if(n.scheme===E.Schemas.file){const c=i(n);r=c!==void 0&&c.length===P.getRoot(c).length&&c[c.length-1]===t}else{t="/";const c=n.path;r=c.length===1&&c.charCodeAt(c.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(n,t)?n.with({path:n.path+"/"}):n}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(u=>u.scheme===E.Schemas.file?!p.isLinux:!0),e.extUriIgnorePathCase=new l(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function v(u,n){const t=[];for(let r=0;r<u.length;r++){const c=n(u[r]);u.some((w,I)=>I===r?!1:(0,e.isEqualOrParent)(c,n(w)))||t.push(u[r])}return t}var h;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(t){const r=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(I=>{const[C,y]=I.split(":");C&&y&&r.set(C,y)});const w=t.path.substring(0,t.path.indexOf(";"));return w&&r.set(u.META_DATA_MIME,w),r}u.parseMetaData=n})(h||(e.DataUri=h={}));function b(u,n,t){if(n){let r=u.path;return r&&r[0]!==S.posix.sep&&(r=S.posix.sep+r),u.with({scheme:t,authority:n,path:r})}return u.with({scheme:t})}}),define(j[22],K([0,1,28,9,38,2,21,3,31,30]),function(F,e,P,E,S,p,s,d,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=v,e.createCancelablePromise=h,e.raceCancellation=b,e.raceCancellationError=u,e.raceCancellablePromises=n,e.raceTimeout=t,e.asPromise=r,e.promiseWithResolvers=c,e.timeout=f,e.disposableTimeout=k,e.sequence=R,e.first=M,e.firstParallel=O,e.retry=le,e.createCancelableAsyncIterable=he;function v(N){return!!N&&typeof N.then=="function"}function h(N){const a=new P.CancellationTokenSource,T=N(a.token),L=new Promise((D,U)=>{const Y=a.token.onCancellationRequested(()=>{Y.dispose(),U(new E.CancellationError)});Promise.resolve(T).then(Z=>{Y.dispose(),a.dispose(),D(Z)},Z=>{Y.dispose(),a.dispose(),U(Z)})});return new class{cancel(){a.cancel(),a.dispose()}then(D,U){return L.then(D,U)}catch(D){return this.then(void 0,D)}finally(D){return L.finally(D)}}}function b(N,a,T){return new Promise((L,D)=>{const U=a.onCancellationRequested(()=>{U.dispose(),L(T)});N.then(L,D).finally(()=>U.dispose())})}function u(N,a){return new Promise((T,L)=>{const D=a.onCancellationRequested(()=>{D.dispose(),L(new E.CancellationError)});N.then(T,L).finally(()=>D.dispose())})}async function n(N){let a=-1;const T=N.map((L,D)=>L.then(U=>(a=D,U)));try{return await Promise.race(T)}finally{N.forEach((L,D)=>{D!==a&&L.cancel()})}}function t(N,a,T){let L;const D=setTimeout(()=>{L?.(void 0),T?.()},a);return Promise.race([N.finally(()=>clearTimeout(D)),new Promise(U=>L=U)])}function r(N){return new Promise((a,T)=>{const L=N();v(L)?L.then(a,T):a(L)})}function c(){let N,a;return{promise:new Promise((L,D)=>{N=L,a=D}),resolve:N,reject:a}}class w{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(a){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=a,!this.queuedPromise){const T=()=>{if(this.queuedPromise=null,this.isDisposed)return;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(T,T).then(L)})}return new Promise((T,L)=>{this.queuedPromise.then(T,L)})}return this.activePromise=a(),new Promise((T,L)=>{this.activePromise.then(D=>{this.activePromise=null,T(D)},D=>{this.activePromise=null,L(D)})})}dispose(){this.isDisposed=!0}}e.Throttler=w;class I{constructor(){this.current=Promise.resolve(null)}queue(a){return this.current=this.current.then(()=>a(),()=>a())}}e.Sequencer=I;class C{constructor(){this.promiseMap=new Map}queue(a,T){const D=(this.promiseMap.get(a)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(a)===D&&this.promiseMap.delete(a)});return this.promiseMap.set(a,D),D}}e.SequencerByKey=C;const y=(N,a)=>{let T=!0;const L=setTimeout(()=>{T=!1,a()},N);return{isTriggered:()=>T,dispose:()=>{clearTimeout(L),T=!1}}},o=N=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,N())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class m{constructor(a){this.defaultDelay=a,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(a,T=this.defaultDelay){this.task=a,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((D,U)=>{this.doResolve=D,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const D=this.task;return this.task=null,D()}}));const L=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=T===i.MicrotaskDelay?o(L):y(T,L),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new E.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class _{constructor(a){this.delayer=new m(a),this.throttler=new w}trigger(a,T){return this.delayer.trigger(()=>this.throttler.queue(a),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=_;class z{constructor(){this._isOpen=!1,this._promise=new Promise((a,T)=>{this._completePromise=a})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=z;class W extends z{constructor(a){super(),this._timeout=setTimeout(()=>this.open(),a)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=W;function f(N,a){return a?new Promise((T,L)=>{const D=setTimeout(()=>{U.dispose(),T()},N),U=a.onCancellationRequested(()=>{clearTimeout(D),U.dispose(),L(new E.CancellationError)})}):h(T=>f(N,T))}function k(N,a=0,T){const L=setTimeout(()=>{N(),T&&D.dispose()},a),D=(0,p.toDisposable)(()=>{clearTimeout(L),T?.deleteAndLeak(D)});return T?.add(D),D}function R(N){const a=[];let T=0;const L=N.length;function D(){return T<L?N[T++]():null}function U(Y){Y!=null&&a.push(Y);const Z=D();return Z?Z.then(U):Promise.resolve(a)}return Promise.resolve(null).then(U)}function M(N,a=L=>!!L,T=null){let L=0;const D=N.length,U=()=>{if(L>=D)return Promise.resolve(T);const Y=N[L++];return Promise.resolve(Y()).then(X=>a(X)?Promise.resolve(X):U())};return U()}function O(N,a=L=>!!L,T=null){if(N.length===0)return Promise.resolve(T);let L=N.length;const D=()=>{L=-1;for(const U of N)U.cancel?.()};return new Promise((U,Y)=>{for(const Z of N)Z.then(X=>{--L>=0&&a(X)?(D(),U(X)):L===0&&U(T)}).catch(X=>{--L>=0&&(D(),Y(X))})})}class g{constructor(a){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=a,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(a){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((T,L)=>{this.outstandingPromises.push({factory:a,c:T,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const a=this.outstandingPromises.shift();this.runningPromises++;const T=a.factory();T.then(a.c,a.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=g;class A extends g{constructor(){super(1)}}e.Queue=A;class B{constructor(){this.sequentializer=new te,this.tasks=0}queue(a){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,a())):this.sequentializer.run(this.tasks++,a())}}e.LimitedQueue=B;class q{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const a=new x;return this.drainers.add(a),a.p}isDrained(){for(const[,a]of this.queues)if(a.size>0)return!1;return!0}queueSize(a,T=s.extUri){const L=T.getComparisonKey(a);return this.queues.get(L)?.size??0}queueFor(a,T,L=s.extUri){const D=L.getComparisonKey(a);let U=this.queues.get(D);if(!U){U=new A;const Y=this.drainListenerCount++,Z=S.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(D),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(Y),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new p.DisposableMap),this.drainListeners.set(Y,Z),this.queues.set(D,U)}return U.queue(T)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const a of this.drainers)a.complete();this.drainers.clear()}dispose(){for(const[,a]of this.queues)a.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=q;class ${constructor(a,T){this._token=-1,typeof a=="function"&&typeof T=="number"&&this.setIfNotSet(a,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(a,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,a()},T)}setIfNotSet(a,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,a()},T))}}e.TimeoutTimer=$;class H{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(a,T,L=globalThis){this.cancel();const D=L.setInterval(()=>{a()},T);this.disposable=(0,p.toDisposable)(()=>{L.clearInterval(D),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=H;class V{constructor(a,T){this.timeoutToken=-1,this.runner=a,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(a=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,a)}get delay(){return this.timeout}set delay(a){this.timeout=a}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=V;class G{constructor(a,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.runner=a,this.timeout=T,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(a=this.timeout){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(a/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=G;class J extends V{constructor(a,T){super(a,T),this.units=[]}work(a){this.units.push(a),this.isScheduled()||this.schedule()}doRun(){const a=this.units;this.units=[],this.runner?.(a)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=J;class ae extends p.Disposable{constructor(a,T){super(),this.options=a,this.handler=T,this.pendingWork=[],this.throttler=this._register(new p.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(a){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+a.length>this.options.maxBufferedWork)return!1}else if(this.pending+a.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const T of a)this.pendingWork.push(T);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(N,a)=>{(0,d.setTimeout0)(()=>{if(T)return;const L=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,L-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e._runWhenIdle=(N,a,T)=>{const L=N.requestIdleCallback(a,typeof T=="number"?{timeout:T}:void 0);let D=!1;return{dispose(){D||(D=!0,N.cancelIdleCallback(L))}}},e.runWhenGlobalIdle=N=>(0,e._runWhenIdle)(globalThis,N)}();class ee{constructor(a,T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(L){this._error=L}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(a,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ee;class ue extends ee{constructor(a){super(globalThis,a)}}e.GlobalIdleValue=ue;async function le(N,a,T){let L;for(let D=0;D<T;D++)try{return await N()}catch(U){L=U,await f(a)}throw L}class te{isRunning(a){return typeof a=="number"?this._running?.taskId===a:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(a,T,L){return this._running={taskId:a,cancel:()=>L?.(),promise:T},T.then(()=>this.doneRunning(a),()=>this.doneRunning(a)),T}doneRunning(a){this._running&&a===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const a=this._queued;this._queued=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this._queued)this._queued.run=a;else{const{promise:T,resolve:L,reject:D}=c();this._queued={run:a,promise:T,promiseResolve:L,promiseReject:D}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=te;class de{constructor(a,T=()=>Date.now()){this.interval=a,this.nowFn=T,this.lastIncrementTime=0,this.value=0}increment(){const a=this.nowFn();return a-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=a,this.value=0),this.value++,this.value}}e.IntervalCounter=de;var ne;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((a,T)=>{this.completeCallback=a,this.errorCallback=T})}complete(a){return new Promise(T=>{this.completeCallback(a),this.outcome={outcome:0,value:a},T()})}error(a){return new Promise(T=>{this.errorCallback(a),this.outcome={outcome:1,value:a},T()})}cancel(){return this.error(new E.CancellationError)}}e.DeferredPromise=x;var ie;(function(N){async function a(L){let D;const U=await Promise.all(L.map(Y=>Y.then(Z=>Z,Z=>{D||(D=Z)})));if(typeof D<"u")throw D;return U}N.settled=a;function T(L){return new Promise(async(D,U)=>{try{await L(D,U)}catch(Y){U(Y)}})}N.withAsyncBody=T})(ie||(e.Promises=ie={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(a){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=a.then(T=>(this._value=T,this._isResolved=!0,T),T=>{throw this._error=T,this._isResolved=!0,T})}requireValue(){if(!this._isResolved)throw new E.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class ce{constructor(a){this._compute=a,this._promise=new l.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=ce;var se;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(se||(se={}));class Q{static fromArray(a){return new Q(T=>{T.emitMany(a)})}static fromPromise(a){return new Q(async T=>{T.emitMany(await a)})}static fromPromises(a){return new Q(async T=>{await Promise.all(a.map(async L=>T.emitOne(await L)))})}static merge(a){return new Q(async T=>{await Promise.all(a.map(async L=>{for await(const D of L)T.emitOne(D)}))})}static{this.EMPTY=Q.fromArray([])}constructor(a){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const T={emitOne:L=>this.emitOne(L),emitMany:L=>this.emitMany(L),reject:L=>this.reject(L)};try{await Promise.resolve(a(T)),this.resolve()}catch(L){this.reject(L)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(a<this._results.length)return{done:!1,value:this._results[a++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(a,T){return new Q(async L=>{for await(const D of a)L.emitOne(T(D))})}map(a){return Q.map(this,a)}static filter(a,T){return new Q(async L=>{for await(const D of a)T(D)&&L.emitOne(D)})}filter(a){return Q.filter(this,a)}static coalesce(a){return Q.filter(a,T=>!!T)}coalesce(){return Q.coalesce(this)}static async toPromise(a){const T=[];for await(const L of a)T.push(L);return T}toPromise(){return Q.toPromise(this)}emitOne(a){this._state===0&&(this._results.push(a),this._onStateChanged.fire())}emitMany(a){this._state===0&&(this._results=this._results.concat(a),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(a){this._state===0&&(this._state=2,this._error=a,this._onStateChanged.fire())}}e.AsyncIterableObject=Q;class oe extends Q{constructor(a,T){super(T),this._source=a}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function he(N){const a=new P.CancellationTokenSource,T=N(a.token);return new oe(a,async L=>{const D=a.token.onCancellationRequested(()=>{D.dispose(),a.dispose(),L.reject(new E.CancellationError)});try{for await(const U of T){if(a.token.isCancellationRequested)return;L.emitOne(U)}D.dispose(),a.dispose()}catch(U){D.dispose(),a.dispose(),L.reject(U)}})}class fe{constructor(){this._deferred=new x,this._asyncIterable=new Q(L=>{if(a){L.reject(a);return}return T&&L.emitMany(T),this._errorFn=D=>L.reject(D),this._emitFn=D=>L.emitOne(D),this._deferred.p});let a,T;this._emitFn=L=>{T||(T=[]),T.push(L)},this._errorFn=L=>{a||(a=L)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(a){this._errorFn(a),this._deferred.complete()}emitOne(a){this._emitFn(a)}}e.AsyncIterableSource=fe}),define(j[23],K([0,1,39]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullState=void 0,e.nullTokenize=E,e.nullTokenizeEncoded=S,e.NullState=new class{clone(){return this}equals(p){return this===p}};function E(p,s){return new P.TokenizationResult([new P.Token(0,"",p)],s)}function S(p,s){const d=new Uint32Array(2);return d[0]=0,d[1]=(p<<0|0|0|32768|2<<24)>>>0,new P.EncodedTokenizationResult(d,s===null?e.NullState:s)}}),define(j[40],K([0,1,22,9,3,41,14,16,49,23,32,17,10]),function(F,e,P,E,S,p,s,d,i,l,v,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var u;(function(y){y[y.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor(o,m){this.tokenizationSupport=m,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new r(o)}getStartState(o){return this.store.getStartState(o,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}e.TokenizerWithStateStore=n;class t extends n{constructor(o,m,_,z){super(o,m),this._textModel=_,this._languageIdCodec=z}updateTokensUntilLine(o,m){const _=this._textModel.getLanguageId();for(;;){const z=this.getFirstInvalidLine();if(!z||z.lineNumber>m)break;const W=this._textModel.getLineContent(z.lineNumber),f=I(this._languageIdCodec,_,this.tokenizationSupport,W,!0,z.startState);o.add(z.lineNumber,f.tokens),this.store.setEndState(z.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(o,m){const _=this.getStartState(o.lineNumber);if(!_)return 0;const z=this._textModel.getLanguageId(),W=this._textModel.getLineContent(o.lineNumber),f=W.substring(0,o.column-1)+m+W.substring(o.column-1),k=I(this._languageIdCodec,z,this.tokenizationSupport,f,!0,_),R=new b.LineTokens(k.tokens,f,this._languageIdCodec);if(R.getCount()===0)return 0;const M=R.findTokenIndexAtOffset(o.column-1);return R.getStandardTokenType(M)}tokenizeLineWithEdit(o,m,_){const z=o.lineNumber,W=o.column,f=this.getStartState(z);if(!f)return null;const k=this._textModel.getLineContent(z),R=k.substring(0,W-1)+_+k.substring(W-1+m),M=this._textModel.getLanguageIdAtPosition(z,0),O=I(this._languageIdCodec,M,this.tokenizationSupport,R,!0,f);return new b.LineTokens(O.tokens,R,this._languageIdCodec)}hasAccurateTokensForLine(o){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return o<m}isCheapToTokenize(o){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return o<m||o===m&&this._textModel.getLineLength(o)<2048}tokenizeHeuristically(o,m,_){if(_<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(o,_),{heuristicTokens:!1};let z=this.guessStartState(m);const W=this._textModel.getLanguageId();for(let f=m;f<=_;f++){const k=this._textModel.getLineContent(f),R=I(this._languageIdCodec,W,this.tokenizationSupport,k,!0,z);o.add(f,R.tokens),z=R.endState}return{heuristicTokens:!0}}guessStartState(o){let m=this._textModel.getLineFirstNonWhitespaceColumn(o);const _=[];let z=null;for(let k=o-1;m>1&&k>=1;k--){const R=this._textModel.getLineFirstNonWhitespaceColumn(k);if(R!==0&&R<m&&(_.push(this._textModel.getLineContent(k)),m=R,z=this.getStartState(k),z))break}z||(z=this.tokenizationSupport.getInitialState()),_.reverse();const W=this._textModel.getLanguageId();let f=z;for(const k of _)f=I(this._languageIdCodec,W,this.tokenizationSupport,k,!1,f).endState;return f}}e.TokenizerWithStateStoreAndTextModel=t;class r{constructor(o){this.lineCount=o,this._tokenizationStateStore=new c,this._invalidEndStatesLineNumbers=new w,this._invalidEndStatesLineNumbers.addRange(new i.OffsetRange(1,o+1))}getEndState(o){return this._tokenizationStateStore.getEndState(o)}setEndState(o,m){if(!m)throw new E.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(o);const _=this._tokenizationStateStore.setEndState(o,m);return _&&o<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new i.OffsetRange(o+1,o+2)),_}acceptChange(o,m){this.lineCount+=m-o.length,this._tokenizationStateStore.acceptChange(o,m),this._invalidEndStatesLineNumbers.addRangeAndResize(new i.OffsetRange(o.startLineNumber,o.endLineNumberExclusive),m)}acceptChanges(o){for(const m of o){const[_]=(0,s.countEOL)(m.text);this.acceptChange(new d.LineRange(m.range.startLineNumber,m.range.endLineNumber+1),_+1)}}invalidateEndStateRange(o){this._invalidEndStatesLineNumbers.addRange(new i.OffsetRange(o.startLineNumber,o.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this._invalidEndStatesLineNumbers.min===null}getStartState(o,m){return o===1?m:this.getEndState(o-1)}getFirstInvalidLine(o){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const _=this.getStartState(m,o);if(!_)throw new E.BugIndicatingError("Start state must be defined");return{lineNumber:m,startState:_}}}e.TrackingTokenizationStateStore=r;class c{constructor(){this._lineEndStates=new v.FixedArray(null)}getEndState(o){return this._lineEndStates.get(o)}setEndState(o,m){const _=this._lineEndStates.get(o);return _&&_.equals(m)?!1:(this._lineEndStates.set(o,m),!0)}acceptChange(o,m){let _=o.length;m>0&&_>0&&(_--,m--),this._lineEndStates.replace(o.startLineNumber,_,m)}acceptChanges(o){for(const m of o){const[_]=(0,s.countEOL)(m.text);this.acceptChange(new d.LineRange(m.range.startLineNumber,m.range.endLineNumber+1),_+1)}}}e.TokenizationStateStore=c;class w{constructor(){this._ranges=[]}getRanges(){return this._ranges}get min(){return this._ranges.length===0?null:this._ranges[0].start}removeMin(){if(this._ranges.length===0)return null;const o=this._ranges[0];return o.start+1===o.endExclusive?this._ranges.shift():this._ranges[0]=new i.OffsetRange(o.start+1,o.endExclusive),o.start}delete(o){const m=this._ranges.findIndex(_=>_.contains(o));if(m!==-1){const _=this._ranges[m];_.start===o?_.endExclusive===o+1?this._ranges.splice(m,1):this._ranges[m]=new i.OffsetRange(o+1,_.endExclusive):_.endExclusive===o+1?this._ranges[m]=new i.OffsetRange(_.start,o):this._ranges.splice(m,1,new i.OffsetRange(_.start,o),new i.OffsetRange(o+1,_.endExclusive))}}addRange(o){i.OffsetRange.addRange(o,this._ranges)}addRangeAndResize(o,m){let _=0;for(;!(_>=this._ranges.length||o.start<=this._ranges[_].endExclusive);)_++;let z=_;for(;!(z>=this._ranges.length||o.endExclusive<this._ranges[z].start);)z++;const W=m-o.length;for(let f=z;f<this._ranges.length;f++)this._ranges[f]=this._ranges[f].delta(W);if(_===z){const f=new i.OffsetRange(o.start,o.start+m);f.isEmpty||this._ranges.splice(_,0,f)}else{const f=Math.min(o.start,this._ranges[_].start),k=Math.max(o.endExclusive,this._ranges[z-1].endExclusive),R=new i.OffsetRange(f,k+W);R.isEmpty?this._ranges.splice(_,z-_):this._ranges.splice(_,z-_,R)}}toString(){return this._ranges.map(o=>o.toString()).join(" + ")}}e.RangePriorityQueueImpl=w;function I(y,o,m,_,z,W){let f=null;if(m)try{f=m.tokenizeEncoded(_,z,W.clone())}catch(k){(0,E.onUnexpectedError)(k)}return f||(f=(0,l.nullTokenizeEncoded)(y.encodeLanguageId(o),W)),b.LineTokens.convertToEndOffset(f.tokens,_.length),f}class C{constructor(o,m){this._tokenizerWithStateStore=o,this._backgroundTokenStore=m,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){this._isScheduled||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._isScheduled=!0,(0,P.runWhenGlobalIdle)(o=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(o)}))}_backgroundTokenizeWithDeadline(o){const m=Date.now()+o.timeRemaining(),_=()=>{this._isDisposed||!this._tokenizerWithStateStore._textModel.isAttachedToEditor()||!this._hasLinesToTokenize()||(this._backgroundTokenizeForAtLeast1ms(),Date.now()<m?(0,S.setTimeout0)(_):this._beginBackgroundTokenization())};_()}_backgroundTokenizeForAtLeast1ms(){const o=this._tokenizerWithStateStore._textModel.getLineCount(),m=new h.ContiguousMultilineTokensBuilder,_=p.StopWatch.create(!1);do if(_.elapsed()>1||this._tokenizeOneInvalidLine(m)>=o)break;while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(m.finalize()),this.checkFinished()}_hasLinesToTokenize(){return this._tokenizerWithStateStore?!this._tokenizerWithStateStore.store.allStatesValid():!1}_tokenizeOneInvalidLine(o){const m=this._tokenizerWithStateStore?.getFirstInvalidLine();return m?(this._tokenizerWithStateStore.updateTokensUntilLine(o,m.lineNumber),m.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(o,m){this._tokenizerWithStateStore.store.invalidateEndStateRange(new d.LineRange(o,m))}}e.DefaultBackgroundTokenizer=C}),define(j[42],K([0,1,38,2,41,15,39]),function(F,e,P,E,S,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class d extends E.Disposable{constructor(l,v,h,b,u,n,t){super(),this._grammar=l,this._initialState=v,this._containsEmbeddedLanguages=h,this._createBackgroundTokenizer=b,this._backgroundTokenizerShouldOnlyVerifyTokens=u,this._reportTokenizationTime=n,this._reportSlowTokenization=t,this._seenLanguages=[],this._onDidEncounterLanguage=this._register(new P.Emitter),this.onDidEncounterLanguage=this._onDidEncounterLanguage.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this._backgroundTokenizerShouldOnlyVerifyTokens()}getInitialState(){return this._initialState}tokenize(l,v,h){throw new Error("Not supported!")}createBackgroundTokenizer(l,v){if(this._createBackgroundTokenizer)return this._createBackgroundTokenizer(l,v)}tokenizeEncoded(l,v,h){const b=Math.random()*1e4<1,u=this._reportSlowTokenization||b,n=u?new S.StopWatch(!0):void 0,t=this._grammar.tokenizeLine2(l,h,500);if(u){const c=n.elapsed();(b||c>32)&&this._reportTokenizationTime(c,l.length,b)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${l.substring(0,100)}`),new s.EncodedTokenizationResult(t.tokens,h);if(this._containsEmbeddedLanguages){const c=this._seenLanguages,w=t.tokens;for(let I=0,C=w.length>>>1;I<C;I++){const y=w[(I<<1)+1],o=p.TokenMetadata.getLanguageId(y);c[o]||(c[o]=!0,this._onDidEncounterLanguage.fire(o))}}let r;return h.equals(t.ruleStack)?r=h:r=t.ruleStack,new s.EncodedTokenizationResult(t.tokens,r)}}e.TextMateTokenizationSupport=d}),define(j[43],K([0,1,23,2,12]),function(F,e,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class p extends E.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this._actual.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,i,l){super(),this._encodedLanguageId=d,this._actual=i,this._maxTokenizationLineLength=l,this._register((0,S.keepObserved)(this._maxTokenizationLineLength))}getInitialState(){return this._actual.getInitialState()}tokenize(d,i,l){throw new Error("Not supported!")}tokenizeEncoded(d,i,l){return d.length>=this._maxTokenizationLineLength.get()?(0,P.nullTokenizeEncoded)(this._encodedLanguageId,l):this._actual.tokenizeEncoded(d,i,l)}createBackgroundTokenizer(d,i){if(this._actual.createBackgroundTokenizer)return this._actual.createBackgroundTokenizer(d,i)}}e.TokenizationSupportWithLineLimit=p}),define(j[44],K([0,1,37,22,12,3,16,50,40,17,10,42,43]),function(F,e,P,E,S,p,s,d,i,l,v,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerTokenizer=void 0;class u extends d.MirrorTextModel{constructor(r,c,w,I,C,y,o,m){super(r,c,w,I),this._host=C,this._languageId=y,this._encodedLanguageId=o,this._tokenizerWithStateStore=null,this._isDisposed=!1,this._maxTokenizationLineLength=(0,S.observableValue)(this,-1),this._tokenizeDebouncer=new E.RunOnceScheduler(()=>this._tokenize(),10),this._maxTokenizationLineLength.set(m,void 0),this._resetTokenization()}dispose(){this._isDisposed=!0,super.dispose()}onLanguageId(r,c){this._languageId=r,this._encodedLanguageId=c,this._resetTokenization()}onEvents(r){super.onEvents(r),this._tokenizerWithStateStore?.store.acceptChanges(r.changes),this._tokenizeDebouncer.schedule()}acceptMaxTokenizationLineLength(r){this._maxTokenizationLineLength.set(r,void 0)}retokenize(r,c){this._tokenizerWithStateStore&&(this._tokenizerWithStateStore.store.invalidateEndStateRange(new s.LineRange(r,c)),this._tokenizeDebouncer.schedule())}async _resetTokenization(){this._tokenizerWithStateStore=null;const r=this._languageId,c=this._encodedLanguageId,w=await this._host.getOrCreateGrammar(r,c);if(!(this._isDisposed||r!==this._languageId||c!==this._encodedLanguageId||!w)){if(w.grammar){const I=new b.TokenizationSupportWithLineLimit(this._encodedLanguageId,new h.TextMateTokenizationSupport(w.grammar,w.initialState,!1,void 0,()=>!1,(C,y,o)=>{this._host.reportTokenizationTime(C,r,w.sourceExtensionId,y,o)},!1),this._maxTokenizationLineLength);this._tokenizerWithStateStore=new i.TokenizerWithStateStore(this._lines.length,I)}else this._tokenizerWithStateStore=null;this._tokenize()}}async _tokenize(){if(this._isDisposed||!this._tokenizerWithStateStore)return;if(!this._diffStateStacksRefEqFn){const{diffStateStacksRefEq:c}=await(0,P.importAMDNodeModule)("vscode-textmate","release/main.js");this._diffStateStacksRefEqFn=c}const r=new Date().getTime();for(;;){let c=0;const w=new l.ContiguousMultilineTokensBuilder,I=new n;for(;;){const o=this._tokenizerWithStateStore.getFirstInvalidLine();if(o===null||c>200)break;c++;const m=this._lines[o.lineNumber-1],_=this._tokenizerWithStateStore.tokenizationSupport.tokenizeEncoded(m,!0,o.startState);if(this._tokenizerWithStateStore.store.setEndState(o.lineNumber,_.endState)){const W=this._diffStateStacksRefEqFn(o.startState,_.endState);I.setState(o.lineNumber,W)}else I.setState(o.lineNumber,null);if(v.LineTokens.convertToEndOffset(_.tokens,m.length),w.add(o.lineNumber,_.tokens),new Date().getTime()-r>20)break}if(c===0)break;const C=I.getStateDeltas();if(this._host.setTokensAndStates(this._versionId,w.serialize(),C),new Date().getTime()-r>20){(0,p.setTimeout0)(()=>this._tokenize());return}}}}e.TextMateWorkerTokenizer=u;class n{constructor(){this._lastStartLineNumber=-1,this._stateDeltas=[]}setState(r,c){r===this._lastStartLineNumber+1?this._stateDeltas[this._stateDeltas.length-1].stateDeltas.push(c):this._stateDeltas.push({startLineNumber:r,stateDeltas:[c]}),this._lastStartLineNumber=r}getStateDeltas(){return this._stateDeltas}}}),define(j[45],K([0,1,21]),function(F,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class E{constructor(){this._scopeNameToLanguageRegistration=Object.create(null)}reset(){this._scopeNameToLanguageRegistration=Object.create(null)}register(p){if(this._scopeNameToLanguageRegistration[p.scopeName]){const s=this._scopeNameToLanguageRegistration[p.scopeName];P.isEqual(s.location,p.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${p.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${p.location.toString()}`)}this._scopeNameToLanguageRegistration[p.scopeName]=p}getGrammarDefinition(p){return this._scopeNameToLanguageRegistration[p]||null}}e.TMScopeRegistry=E}),define(j[46],K([0,1,2,45]),function(F,e,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class S extends P.Disposable{constructor(s,d,i,l){super(),this._host=s,this._initialState=i.INITIAL,this._scopeRegistry=new E.TMScopeRegistry,this._injections={},this._injectedEmbeddedLanguages={},this._languageToScope=new Map,this._grammarRegistry=this._register(new i.Registry({onigLib:l,loadGrammar:async v=>{const h=this._scopeRegistry.getGrammarDefinition(v);if(!h)return this._host.logTrace(`No grammar found for scope ${v}`),null;const b=h.location;try{const u=await this._host.readFile(b);return i.parseRawGrammar(u,b.path)}catch(u){return this._host.logError(`Unable to load and parse grammar for scope ${v} from ${b}`,u),null}},getInjections:v=>{const h=v.split(".");let b=[];for(let u=1;u<=h.length;u++){const n=h.slice(0,u).join(".");b=[...b,...this._injections[n]||[]]}return b}}));for(const v of d){if(this._scopeRegistry.register(v),v.injectTo){for(const h of v.injectTo){let b=this._injections[h];b||(this._injections[h]=b=[]),b.push(v.scopeName)}if(v.embeddedLanguages)for(const h of v.injectTo){let b=this._injectedEmbeddedLanguages[h];b||(this._injectedEmbeddedLanguages[h]=b=[]),b.push(v.embeddedLanguages)}}v.language&&this._languageToScope.set(v.language,v.scopeName)}}has(s){return this._languageToScope.has(s)}setTheme(s,d){this._grammarRegistry.setTheme(s,d)}getColorMap(){return this._grammarRegistry.getColorMap()}async createGrammar(s,d){const i=this._languageToScope.get(s);if(typeof i!="string")throw new Error(e.missingTMGrammarErrorMessage);const l=this._scopeRegistry.getGrammarDefinition(i);if(!l)throw new Error(e.missingTMGrammarErrorMessage);const v=l.embeddedLanguages;if(this._injectedEmbeddedLanguages[i]){const u=this._injectedEmbeddedLanguages[i];for(const n of u)for(const t of Object.keys(n))v[t]=n[t]}const h=Object.keys(v).length>0;let b;try{b=await this._grammarRegistry.loadGrammarWithConfiguration(i,d,{embeddedLanguages:v,tokenTypes:l.tokenTypes,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):u}return{languageId:s,grammar:b,initialState:this._initialState,containsEmbeddedLanguages:h,sourceExtensionId:l.sourceExtensionId}}}e.TMGrammarFactory=S}),define(j[51],K([0,1,11,46,44]),function(F,e,P,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=p;function p(d,i){return new s(d,i)}class s{constructor(i,l){this._createData=l,this._models=new Map,this._grammarCache=[],this._host=i.host;const v=l.grammarDefinitions.map(h=>({location:P.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this._grammarFactory=this._loadTMGrammarFactory(v)}async _loadTMGrammarFactory(i){const l=this._createData.textmateMainUri,v=await new Promise((t,r)=>{F([l],t,r)}),h=await new Promise((t,r)=>{F([this._createData.onigurumaMainUri],t,r)}),u=await(await fetch(this._createData.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(u);const n=Promise.resolve({createOnigScanner:t=>h.createOnigScanner(t),createOnigString:t=>h.createOnigString(t)});return new E.TMGrammarFactory({logTrace:t=>{},logError:(t,r)=>console.error(t,r),readFile:t=>this._host.readFile(t)},i,v,n)}acceptNewModel(i){const l=P.URI.revive(i.uri),v=this;this._models.set(i.controllerId,new S.TextMateWorkerTokenizer(l,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(h,b){const u=await v._grammarFactory;return u?(v._grammarCache[b]||(v._grammarCache[b]=u.createGrammar(h,b)),v._grammarCache[b]):Promise.resolve(null)},setTokensAndStates(h,b,u){v._host.setTokensAndStates(i.controllerId,h,b,u)},reportTokenizationTime(h,b,u,n,t){v._host.reportTokenizationTime(h,b,u,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,l){this._models.get(i).onEvents(l)}retokenize(i,l,v){this._models.get(i).retokenize(l,v)}acceptModelLanguageChanged(i,l,v){this._models.get(i).onLanguageId(l,v)}acceptRemovedModel(i){const l=this._models.get(i);l&&(l.dispose(),this._models.delete(i))}async acceptTheme(i,l){(await this._grammarFactory)?.setTheme(i,l)}acceptMaxTokenizationLineLength(i,l){this._models.get(i).acceptMaxTokenizationLineLength(l)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
